#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 3620
#define LARGE_STATE_COUNT 1004
#define SYMBOL_COUNT 343
#define ALIAS_COUNT 4
#define TOKEN_COUNT 153
#define EXTERNAL_TOKEN_COUNT 10
#define FIELD_COUNT 31
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 279

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_macro_rules_BANG = 3,
  anon_sym_LPAREN = 4,
  anon_sym_RPAREN = 5,
  anon_sym_LBRACK = 6,
  anon_sym_RBRACK = 7,
  anon_sym_LBRACE = 8,
  anon_sym_RBRACE = 9,
  anon_sym_EQ_GT = 10,
  anon_sym_COLON = 11,
  anon_sym_DOLLAR = 12,
  aux_sym_token_repetition_pattern_token1 = 13,
  anon_sym_PLUS = 14,
  anon_sym_STAR = 15,
  anon_sym_QMARK = 16,
  anon_sym_block = 17,
  anon_sym_expr = 18,
  anon_sym_ident = 19,
  anon_sym_item = 20,
  anon_sym_lifetime = 21,
  anon_sym_literal = 22,
  anon_sym_meta = 23,
  anon_sym_pat = 24,
  anon_sym_path = 25,
  anon_sym_stmt = 26,
  anon_sym_tt = 27,
  anon_sym_ty = 28,
  anon_sym_vis = 29,
  anon_sym_u8 = 30,
  anon_sym_i8 = 31,
  anon_sym_u16 = 32,
  anon_sym_i16 = 33,
  anon_sym_u32 = 34,
  anon_sym_i32 = 35,
  anon_sym_u64 = 36,
  anon_sym_i64 = 37,
  anon_sym_u128 = 38,
  anon_sym_i128 = 39,
  anon_sym_isize = 40,
  anon_sym_usize = 41,
  anon_sym_f32 = 42,
  anon_sym_f64 = 43,
  anon_sym_bool = 44,
  anon_sym_str = 45,
  anon_sym_char = 46,
  anon_sym_DASH = 47,
  anon_sym_SLASH = 48,
  anon_sym_PERCENT = 49,
  anon_sym_CARET = 50,
  anon_sym_BANG = 51,
  anon_sym_AMP = 52,
  anon_sym_PIPE = 53,
  anon_sym_AMP_AMP = 54,
  anon_sym_PIPE_PIPE = 55,
  anon_sym_LT_LT = 56,
  anon_sym_GT_GT = 57,
  anon_sym_PLUS_EQ = 58,
  anon_sym_DASH_EQ = 59,
  anon_sym_STAR_EQ = 60,
  anon_sym_SLASH_EQ = 61,
  anon_sym_PERCENT_EQ = 62,
  anon_sym_CARET_EQ = 63,
  anon_sym_AMP_EQ = 64,
  anon_sym_PIPE_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_GT_GT_EQ = 67,
  anon_sym_EQ = 68,
  anon_sym_EQ_EQ = 69,
  anon_sym_BANG_EQ = 70,
  anon_sym_GT = 71,
  anon_sym_LT = 72,
  anon_sym_GT_EQ = 73,
  anon_sym_LT_EQ = 74,
  anon_sym_AT = 75,
  anon_sym__ = 76,
  anon_sym_DOT = 77,
  anon_sym_DOT_DOT = 78,
  anon_sym_DOT_DOT_DOT = 79,
  anon_sym_DOT_DOT_EQ = 80,
  anon_sym_COMMA = 81,
  anon_sym_COLON_COLON = 82,
  anon_sym_DASH_GT = 83,
  anon_sym_POUND = 84,
  anon_sym_SQUOTE = 85,
  anon_sym_as = 86,
  anon_sym_async = 87,
  anon_sym_await = 88,
  anon_sym_break = 89,
  anon_sym_const = 90,
  anon_sym_continue = 91,
  anon_sym_default = 92,
  anon_sym_enum = 93,
  anon_sym_fn = 94,
  anon_sym_for = 95,
  anon_sym_if = 96,
  anon_sym_impl = 97,
  anon_sym_let = 98,
  anon_sym_loop = 99,
  anon_sym_match = 100,
  anon_sym_mod = 101,
  anon_sym_pub = 102,
  anon_sym_return = 103,
  anon_sym_static = 104,
  anon_sym_struct = 105,
  anon_sym_trait = 106,
  anon_sym_type = 107,
  anon_sym_union = 108,
  anon_sym_unsafe = 109,
  anon_sym_use = 110,
  anon_sym_where = 111,
  anon_sym_while = 112,
  anon_sym_extern = 113,
  anon_sym_ref = 114,
  anon_sym_else = 115,
  anon_sym_in = 116,
  anon_sym_LT2 = 117,
  anon_sym_dyn = 118,
  sym_mutable_specifier = 119,
  anon_sym_yield = 120,
  anon_sym_move = 121,
  anon_sym_try = 122,
  sym_integer_literal = 123,
  aux_sym_string_literal_token1 = 124,
  anon_sym_DQUOTE = 125,
  sym_char_literal = 126,
  sym_escape_sequence = 127,
  anon_sym_true = 128,
  anon_sym_false = 129,
  anon_sym_SLASH_SLASH = 130,
  aux_sym_line_comment_token1 = 131,
  aux_sym_line_comment_token2 = 132,
  aux_sym_line_comment_token3 = 133,
  anon_sym_BANG2 = 134,
  anon_sym_SLASH2 = 135,
  anon_sym_SLASH_STAR = 136,
  anon_sym_STAR_SLASH = 137,
  sym_shebang = 138,
  sym_self = 139,
  sym_super = 140,
  sym_crate = 141,
  sym_metavariable = 142,
  sym_string_content = 143,
  sym__raw_string_literal_start = 144,
  sym_raw_string_literal_content = 145,
  sym__raw_string_literal_end = 146,
  sym_float_literal = 147,
  sym__outer_block_doc_comment_marker = 148,
  sym__inner_block_doc_comment_marker = 149,
  sym__block_comment_content = 150,
  sym__line_doc_content = 151,
  sym__error_sentinel = 152,
  sym_source_file = 153,
  sym__statement = 154,
  sym_empty_statement = 155,
  sym_expression_statement = 156,
  sym_macro_definition = 157,
  sym_macro_rule = 158,
  sym__token_pattern = 159,
  sym_token_tree_pattern = 160,
  sym_token_binding_pattern = 161,
  sym_token_repetition_pattern = 162,
  sym_fragment_specifier = 163,
  sym_token_tree = 164,
  sym_token_repetition = 165,
  sym_attribute_item = 166,
  sym_inner_attribute_item = 167,
  sym_attribute = 168,
  sym_mod_item = 169,
  sym_foreign_mod_item = 170,
  sym_declaration_list = 171,
  sym_struct_item = 172,
  sym_union_item = 173,
  sym_enum_item = 174,
  sym_enum_variant_list = 175,
  sym_enum_variant = 176,
  sym_field_declaration_list = 177,
  sym_field_declaration = 178,
  sym_ordered_field_declaration_list = 179,
  sym_extern_crate_declaration = 180,
  sym_const_item = 181,
  sym_static_item = 182,
  sym_type_item = 183,
  sym_function_item = 184,
  sym_function_signature_item = 185,
  sym_function_modifiers = 186,
  sym_where_clause = 187,
  sym_where_predicate = 188,
  sym_impl_item = 189,
  sym_trait_item = 190,
  sym_associated_type = 191,
  sym_trait_bounds = 192,
  sym_higher_ranked_trait_bound = 193,
  sym_removed_trait_bound = 194,
  sym_type_parameters = 195,
  sym_const_parameter = 196,
  sym_constrained_type_parameter = 197,
  sym_optional_type_parameter = 198,
  sym_let_declaration = 199,
  sym_use_declaration = 200,
  sym__use_clause = 201,
  sym_scoped_use_list = 202,
  sym_use_list = 203,
  sym_use_as_clause = 204,
  sym_use_wildcard = 205,
  sym_parameters = 206,
  sym_self_parameter = 207,
  sym_variadic_parameter = 208,
  sym_parameter = 209,
  sym_extern_modifier = 210,
  sym_visibility_modifier = 211,
  sym__type = 212,
  sym_bracketed_type = 213,
  sym_qualified_type = 214,
  sym_lifetime = 215,
  sym_array_type = 216,
  sym_for_lifetimes = 217,
  sym_function_type = 218,
  sym_tuple_type = 219,
  sym_unit_type = 220,
  sym_generic_function = 221,
  sym_generic_type = 222,
  sym_generic_type_with_turbofish = 223,
  sym_bounded_type = 224,
  sym_type_arguments = 225,
  sym_type_binding = 226,
  sym_reference_type = 227,
  sym_pointer_type = 228,
  sym_never_type = 229,
  sym_abstract_type = 230,
  sym_dynamic_type = 231,
  sym__expression_except_range = 232,
  sym__expression = 233,
  sym_macro_invocation = 234,
  sym_delim_token_tree = 235,
  sym__delim_tokens = 236,
  sym__non_delim_token = 237,
  sym_scoped_identifier = 238,
  sym_scoped_type_identifier_in_expression_position = 239,
  sym_scoped_type_identifier = 240,
  sym_range_expression = 241,
  sym_unary_expression = 242,
  sym_try_expression = 243,
  sym_reference_expression = 244,
  sym_binary_expression = 245,
  sym_assignment_expression = 246,
  sym_compound_assignment_expr = 247,
  sym_type_cast_expression = 248,
  sym_return_expression = 249,
  sym_yield_expression = 250,
  sym_call_expression = 251,
  sym_arguments = 252,
  sym_array_expression = 253,
  sym_parenthesized_expression = 254,
  sym_tuple_expression = 255,
  sym_unit_expression = 256,
  sym_struct_expression = 257,
  sym_field_initializer_list = 258,
  sym_shorthand_field_initializer = 259,
  sym_field_initializer = 260,
  sym_base_field_initializer = 261,
  sym_if_expression = 262,
  sym_let_condition = 263,
  sym__let_chain = 264,
  sym__condition = 265,
  sym_else_clause = 266,
  sym_match_expression = 267,
  sym_match_block = 268,
  sym_match_arm = 269,
  sym_last_match_arm = 270,
  sym_match_pattern = 271,
  sym_while_expression = 272,
  sym_loop_expression = 273,
  sym_for_expression = 274,
  sym_const_block = 275,
  sym_closure_expression = 276,
  sym_closure_parameters = 277,
  sym_label = 278,
  sym_break_expression = 279,
  sym_continue_expression = 280,
  sym_index_expression = 281,
  sym_await_expression = 282,
  sym_field_expression = 283,
  sym_unsafe_block = 284,
  sym_async_block = 285,
  sym_try_block = 286,
  sym_block = 287,
  sym__pattern = 288,
  sym_tuple_pattern = 289,
  sym_slice_pattern = 290,
  sym_tuple_struct_pattern = 291,
  sym_struct_pattern = 292,
  sym_field_pattern = 293,
  sym_remaining_field_pattern = 294,
  sym_mut_pattern = 295,
  sym_range_pattern = 296,
  sym_ref_pattern = 297,
  sym_captured_pattern = 298,
  sym_reference_pattern = 299,
  sym_or_pattern = 300,
  sym__literal = 301,
  sym__literal_pattern = 302,
  sym_negative_literal = 303,
  sym_string_literal = 304,
  sym_raw_string_literal = 305,
  sym_boolean_literal = 306,
  sym_line_comment = 307,
  sym__line_doc_comment_marker = 308,
  sym__inner_line_doc_comment_marker = 309,
  sym__outer_line_doc_comment_marker = 310,
  sym_block_comment = 311,
  sym__block_doc_comment_marker = 312,
  aux_sym_source_file_repeat1 = 313,
  aux_sym_macro_definition_repeat1 = 314,
  aux_sym_token_tree_pattern_repeat1 = 315,
  aux_sym_token_tree_repeat1 = 316,
  aux_sym__non_special_token_repeat1 = 317,
  aux_sym_declaration_list_repeat1 = 318,
  aux_sym_enum_variant_list_repeat1 = 319,
  aux_sym_enum_variant_list_repeat2 = 320,
  aux_sym_field_declaration_list_repeat1 = 321,
  aux_sym_ordered_field_declaration_list_repeat1 = 322,
  aux_sym_function_modifiers_repeat1 = 323,
  aux_sym_where_clause_repeat1 = 324,
  aux_sym_trait_bounds_repeat1 = 325,
  aux_sym_type_parameters_repeat1 = 326,
  aux_sym_use_list_repeat1 = 327,
  aux_sym_parameters_repeat1 = 328,
  aux_sym_for_lifetimes_repeat1 = 329,
  aux_sym_tuple_type_repeat1 = 330,
  aux_sym_type_arguments_repeat1 = 331,
  aux_sym_delim_token_tree_repeat1 = 332,
  aux_sym_arguments_repeat1 = 333,
  aux_sym_tuple_expression_repeat1 = 334,
  aux_sym_field_initializer_list_repeat1 = 335,
  aux_sym_match_block_repeat1 = 336,
  aux_sym_match_arm_repeat1 = 337,
  aux_sym_closure_parameters_repeat1 = 338,
  aux_sym_tuple_pattern_repeat1 = 339,
  aux_sym_slice_pattern_repeat1 = 340,
  aux_sym_struct_pattern_repeat1 = 341,
  aux_sym_string_literal_repeat1 = 342,
  alias_sym_field_identifier = 343,
  alias_sym_let_chain = 344,
  alias_sym_shorthand_field_identifier = 345,
  alias_sym_type_identifier = 346,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_macro_rules_BANG] = "macro_rules!",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_token_repetition_pattern_token1] = "token_repetition_pattern_token1",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "\?",
  [anon_sym_block] = "block",
  [anon_sym_expr] = "expr",
  [anon_sym_ident] = "ident",
  [anon_sym_item] = "item",
  [anon_sym_lifetime] = "lifetime",
  [anon_sym_literal] = "literal",
  [anon_sym_meta] = "meta",
  [anon_sym_pat] = "pat",
  [anon_sym_path] = "path",
  [anon_sym_stmt] = "stmt",
  [anon_sym_tt] = "tt",
  [anon_sym_ty] = "ty",
  [anon_sym_vis] = "vis",
  [anon_sym_u8] = "primitive_type",
  [anon_sym_i8] = "primitive_type",
  [anon_sym_u16] = "primitive_type",
  [anon_sym_i16] = "primitive_type",
  [anon_sym_u32] = "primitive_type",
  [anon_sym_i32] = "primitive_type",
  [anon_sym_u64] = "primitive_type",
  [anon_sym_i64] = "primitive_type",
  [anon_sym_u128] = "primitive_type",
  [anon_sym_i128] = "primitive_type",
  [anon_sym_isize] = "primitive_type",
  [anon_sym_usize] = "primitive_type",
  [anon_sym_f32] = "primitive_type",
  [anon_sym_f64] = "primitive_type",
  [anon_sym_bool] = "primitive_type",
  [anon_sym_str] = "primitive_type",
  [anon_sym_char] = "primitive_type",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_BANG] = "!",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_EQ] = "=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_AT] = "@",
  [anon_sym__] = "_",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_POUND] = "#",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_as] = "as",
  [anon_sym_async] = "async",
  [anon_sym_await] = "await",
  [anon_sym_break] = "break",
  [anon_sym_const] = "const",
  [anon_sym_continue] = "continue",
  [anon_sym_default] = "default",
  [anon_sym_enum] = "enum",
  [anon_sym_fn] = "fn",
  [anon_sym_for] = "for",
  [anon_sym_if] = "if",
  [anon_sym_impl] = "impl",
  [anon_sym_let] = "let",
  [anon_sym_loop] = "loop",
  [anon_sym_match] = "match",
  [anon_sym_mod] = "mod",
  [anon_sym_pub] = "pub",
  [anon_sym_return] = "return",
  [anon_sym_static] = "static",
  [anon_sym_struct] = "struct",
  [anon_sym_trait] = "trait",
  [anon_sym_type] = "type",
  [anon_sym_union] = "union",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_use] = "use",
  [anon_sym_where] = "where",
  [anon_sym_while] = "while",
  [anon_sym_extern] = "extern",
  [anon_sym_ref] = "ref",
  [anon_sym_else] = "else",
  [anon_sym_in] = "in",
  [anon_sym_LT2] = "<",
  [anon_sym_dyn] = "dyn",
  [sym_mutable_specifier] = "mutable_specifier",
  [anon_sym_yield] = "yield",
  [anon_sym_move] = "move",
  [anon_sym_try] = "try",
  [sym_integer_literal] = "integer_literal",
  [aux_sym_string_literal_token1] = "\"",
  [anon_sym_DQUOTE] = "\"",
  [sym_char_literal] = "char_literal",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_SLASH_SLASH] = "//",
  [aux_sym_line_comment_token1] = "line_comment_token1",
  [aux_sym_line_comment_token2] = "line_comment_token2",
  [aux_sym_line_comment_token3] = "line_comment_token3",
  [anon_sym_BANG2] = "!",
  [anon_sym_SLASH2] = "/",
  [anon_sym_SLASH_STAR] = "/*",
  [anon_sym_STAR_SLASH] = "*/",
  [sym_shebang] = "shebang",
  [sym_self] = "self",
  [sym_super] = "super",
  [sym_crate] = "crate",
  [sym_metavariable] = "metavariable",
  [sym_string_content] = "string_content",
  [sym__raw_string_literal_start] = "_raw_string_literal_start",
  [sym_raw_string_literal_content] = "string_content",
  [sym__raw_string_literal_end] = "_raw_string_literal_end",
  [sym_float_literal] = "float_literal",
  [sym__outer_block_doc_comment_marker] = "outer_doc_comment_marker",
  [sym__inner_block_doc_comment_marker] = "inner_doc_comment_marker",
  [sym__block_comment_content] = "_block_comment_content",
  [sym__line_doc_content] = "doc_comment",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_source_file] = "source_file",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_macro_definition] = "macro_definition",
  [sym_macro_rule] = "macro_rule",
  [sym__token_pattern] = "_token_pattern",
  [sym_token_tree_pattern] = "token_tree_pattern",
  [sym_token_binding_pattern] = "token_binding_pattern",
  [sym_token_repetition_pattern] = "token_repetition_pattern",
  [sym_fragment_specifier] = "fragment_specifier",
  [sym_token_tree] = "token_tree",
  [sym_token_repetition] = "token_repetition",
  [sym_attribute_item] = "attribute_item",
  [sym_inner_attribute_item] = "inner_attribute_item",
  [sym_attribute] = "attribute",
  [sym_mod_item] = "mod_item",
  [sym_foreign_mod_item] = "foreign_mod_item",
  [sym_declaration_list] = "declaration_list",
  [sym_struct_item] = "struct_item",
  [sym_union_item] = "union_item",
  [sym_enum_item] = "enum_item",
  [sym_enum_variant_list] = "enum_variant_list",
  [sym_enum_variant] = "enum_variant",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_ordered_field_declaration_list] = "ordered_field_declaration_list",
  [sym_extern_crate_declaration] = "extern_crate_declaration",
  [sym_const_item] = "const_item",
  [sym_static_item] = "static_item",
  [sym_type_item] = "type_item",
  [sym_function_item] = "function_item",
  [sym_function_signature_item] = "function_signature_item",
  [sym_function_modifiers] = "function_modifiers",
  [sym_where_clause] = "where_clause",
  [sym_where_predicate] = "where_predicate",
  [sym_impl_item] = "impl_item",
  [sym_trait_item] = "trait_item",
  [sym_associated_type] = "associated_type",
  [sym_trait_bounds] = "trait_bounds",
  [sym_higher_ranked_trait_bound] = "higher_ranked_trait_bound",
  [sym_removed_trait_bound] = "removed_trait_bound",
  [sym_type_parameters] = "type_parameters",
  [sym_const_parameter] = "const_parameter",
  [sym_constrained_type_parameter] = "constrained_type_parameter",
  [sym_optional_type_parameter] = "optional_type_parameter",
  [sym_let_declaration] = "let_declaration",
  [sym_use_declaration] = "use_declaration",
  [sym__use_clause] = "_use_clause",
  [sym_scoped_use_list] = "scoped_use_list",
  [sym_use_list] = "use_list",
  [sym_use_as_clause] = "use_as_clause",
  [sym_use_wildcard] = "use_wildcard",
  [sym_parameters] = "parameters",
  [sym_self_parameter] = "self_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter] = "parameter",
  [sym_extern_modifier] = "extern_modifier",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym__type] = "_type",
  [sym_bracketed_type] = "bracketed_type",
  [sym_qualified_type] = "qualified_type",
  [sym_lifetime] = "lifetime",
  [sym_array_type] = "array_type",
  [sym_for_lifetimes] = "for_lifetimes",
  [sym_function_type] = "function_type",
  [sym_tuple_type] = "tuple_type",
  [sym_unit_type] = "unit_type",
  [sym_generic_function] = "generic_function",
  [sym_generic_type] = "generic_type",
  [sym_generic_type_with_turbofish] = "generic_type_with_turbofish",
  [sym_bounded_type] = "bounded_type",
  [sym_type_arguments] = "type_arguments",
  [sym_type_binding] = "type_binding",
  [sym_reference_type] = "reference_type",
  [sym_pointer_type] = "pointer_type",
  [sym_never_type] = "never_type",
  [sym_abstract_type] = "abstract_type",
  [sym_dynamic_type] = "dynamic_type",
  [sym__expression_except_range] = "_expression_except_range",
  [sym__expression] = "_expression",
  [sym_macro_invocation] = "macro_invocation",
  [sym_delim_token_tree] = "token_tree",
  [sym__delim_tokens] = "_delim_tokens",
  [sym__non_delim_token] = "_non_delim_token",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier_in_expression_position] = "scoped_type_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_range_expression] = "range_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_try_expression] = "try_expression",
  [sym_reference_expression] = "reference_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_compound_assignment_expr] = "compound_assignment_expr",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_return_expression] = "return_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_call_expression] = "call_expression",
  [sym_arguments] = "arguments",
  [sym_array_expression] = "array_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_unit_expression] = "unit_expression",
  [sym_struct_expression] = "struct_expression",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_shorthand_field_initializer] = "shorthand_field_initializer",
  [sym_field_initializer] = "field_initializer",
  [sym_base_field_initializer] = "base_field_initializer",
  [sym_if_expression] = "if_expression",
  [sym_let_condition] = "let_condition",
  [sym__let_chain] = "_let_chain",
  [sym__condition] = "_condition",
  [sym_else_clause] = "else_clause",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_arm] = "match_arm",
  [sym_last_match_arm] = "match_arm",
  [sym_match_pattern] = "match_pattern",
  [sym_while_expression] = "while_expression",
  [sym_loop_expression] = "loop_expression",
  [sym_for_expression] = "for_expression",
  [sym_const_block] = "const_block",
  [sym_closure_expression] = "closure_expression",
  [sym_closure_parameters] = "closure_parameters",
  [sym_label] = "label",
  [sym_break_expression] = "break_expression",
  [sym_continue_expression] = "continue_expression",
  [sym_index_expression] = "index_expression",
  [sym_await_expression] = "await_expression",
  [sym_field_expression] = "field_expression",
  [sym_unsafe_block] = "unsafe_block",
  [sym_async_block] = "async_block",
  [sym_try_block] = "try_block",
  [sym_block] = "block",
  [sym__pattern] = "_pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_slice_pattern] = "slice_pattern",
  [sym_tuple_struct_pattern] = "tuple_struct_pattern",
  [sym_struct_pattern] = "struct_pattern",
  [sym_field_pattern] = "field_pattern",
  [sym_remaining_field_pattern] = "remaining_field_pattern",
  [sym_mut_pattern] = "mut_pattern",
  [sym_range_pattern] = "range_pattern",
  [sym_ref_pattern] = "ref_pattern",
  [sym_captured_pattern] = "captured_pattern",
  [sym_reference_pattern] = "reference_pattern",
  [sym_or_pattern] = "or_pattern",
  [sym__literal] = "_literal",
  [sym__literal_pattern] = "_literal_pattern",
  [sym_negative_literal] = "negative_literal",
  [sym_string_literal] = "string_literal",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_boolean_literal] = "boolean_literal",
  [sym_line_comment] = "line_comment",
  [sym__line_doc_comment_marker] = "_line_doc_comment_marker",
  [sym__inner_line_doc_comment_marker] = "inner_doc_comment_marker",
  [sym__outer_line_doc_comment_marker] = "outer_doc_comment_marker",
  [sym_block_comment] = "block_comment",
  [sym__block_doc_comment_marker] = "_block_doc_comment_marker",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_macro_definition_repeat1] = "macro_definition_repeat1",
  [aux_sym_token_tree_pattern_repeat1] = "token_tree_pattern_repeat1",
  [aux_sym_token_tree_repeat1] = "token_tree_repeat1",
  [aux_sym__non_special_token_repeat1] = "_non_special_token_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_enum_variant_list_repeat1] = "enum_variant_list_repeat1",
  [aux_sym_enum_variant_list_repeat2] = "enum_variant_list_repeat2",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_ordered_field_declaration_list_repeat1] = "ordered_field_declaration_list_repeat1",
  [aux_sym_function_modifiers_repeat1] = "function_modifiers_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_trait_bounds_repeat1] = "trait_bounds_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_for_lifetimes_repeat1] = "for_lifetimes_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_delim_token_tree_repeat1] = "delim_token_tree_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_match_arm_repeat1] = "match_arm_repeat1",
  [aux_sym_closure_parameters_repeat1] = "closure_parameters_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_slice_pattern_repeat1] = "slice_pattern_repeat1",
  [aux_sym_struct_pattern_repeat1] = "struct_pattern_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_let_chain] = "let_chain",
  [alias_sym_shorthand_field_identifier] = "shorthand_field_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_macro_rules_BANG] = anon_sym_macro_rules_BANG,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_token_repetition_pattern_token1] = aux_sym_token_repetition_pattern_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_block] = anon_sym_block,
  [anon_sym_expr] = anon_sym_expr,
  [anon_sym_ident] = anon_sym_ident,
  [anon_sym_item] = anon_sym_item,
  [anon_sym_lifetime] = anon_sym_lifetime,
  [anon_sym_literal] = anon_sym_literal,
  [anon_sym_meta] = anon_sym_meta,
  [anon_sym_pat] = anon_sym_pat,
  [anon_sym_path] = anon_sym_path,
  [anon_sym_stmt] = anon_sym_stmt,
  [anon_sym_tt] = anon_sym_tt,
  [anon_sym_ty] = anon_sym_ty,
  [anon_sym_vis] = anon_sym_vis,
  [anon_sym_u8] = anon_sym_u8,
  [anon_sym_i8] = anon_sym_u8,
  [anon_sym_u16] = anon_sym_u8,
  [anon_sym_i16] = anon_sym_u8,
  [anon_sym_u32] = anon_sym_u8,
  [anon_sym_i32] = anon_sym_u8,
  [anon_sym_u64] = anon_sym_u8,
  [anon_sym_i64] = anon_sym_u8,
  [anon_sym_u128] = anon_sym_u8,
  [anon_sym_i128] = anon_sym_u8,
  [anon_sym_isize] = anon_sym_u8,
  [anon_sym_usize] = anon_sym_u8,
  [anon_sym_f32] = anon_sym_u8,
  [anon_sym_f64] = anon_sym_u8,
  [anon_sym_bool] = anon_sym_u8,
  [anon_sym_str] = anon_sym_u8,
  [anon_sym_char] = anon_sym_u8,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym__] = anon_sym__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_impl] = anon_sym_impl,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_pub] = anon_sym_pub,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_dyn] = anon_sym_dyn,
  [sym_mutable_specifier] = sym_mutable_specifier,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_move] = anon_sym_move,
  [anon_sym_try] = anon_sym_try,
  [sym_integer_literal] = sym_integer_literal,
  [aux_sym_string_literal_token1] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [sym_char_literal] = sym_char_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [aux_sym_line_comment_token1] = aux_sym_line_comment_token1,
  [aux_sym_line_comment_token2] = aux_sym_line_comment_token2,
  [aux_sym_line_comment_token3] = aux_sym_line_comment_token3,
  [anon_sym_BANG2] = anon_sym_BANG,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [anon_sym_SLASH_STAR] = anon_sym_SLASH_STAR,
  [anon_sym_STAR_SLASH] = anon_sym_STAR_SLASH,
  [sym_shebang] = sym_shebang,
  [sym_self] = sym_self,
  [sym_super] = sym_super,
  [sym_crate] = sym_crate,
  [sym_metavariable] = sym_metavariable,
  [sym_string_content] = sym_string_content,
  [sym__raw_string_literal_start] = sym__raw_string_literal_start,
  [sym_raw_string_literal_content] = sym_string_content,
  [sym__raw_string_literal_end] = sym__raw_string_literal_end,
  [sym_float_literal] = sym_float_literal,
  [sym__outer_block_doc_comment_marker] = sym__outer_block_doc_comment_marker,
  [sym__inner_block_doc_comment_marker] = sym__inner_block_doc_comment_marker,
  [sym__block_comment_content] = sym__block_comment_content,
  [sym__line_doc_content] = sym__line_doc_content,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_source_file] = sym_source_file,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_macro_definition] = sym_macro_definition,
  [sym_macro_rule] = sym_macro_rule,
  [sym__token_pattern] = sym__token_pattern,
  [sym_token_tree_pattern] = sym_token_tree_pattern,
  [sym_token_binding_pattern] = sym_token_binding_pattern,
  [sym_token_repetition_pattern] = sym_token_repetition_pattern,
  [sym_fragment_specifier] = sym_fragment_specifier,
  [sym_token_tree] = sym_token_tree,
  [sym_token_repetition] = sym_token_repetition,
  [sym_attribute_item] = sym_attribute_item,
  [sym_inner_attribute_item] = sym_inner_attribute_item,
  [sym_attribute] = sym_attribute,
  [sym_mod_item] = sym_mod_item,
  [sym_foreign_mod_item] = sym_foreign_mod_item,
  [sym_declaration_list] = sym_declaration_list,
  [sym_struct_item] = sym_struct_item,
  [sym_union_item] = sym_union_item,
  [sym_enum_item] = sym_enum_item,
  [sym_enum_variant_list] = sym_enum_variant_list,
  [sym_enum_variant] = sym_enum_variant,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_ordered_field_declaration_list] = sym_ordered_field_declaration_list,
  [sym_extern_crate_declaration] = sym_extern_crate_declaration,
  [sym_const_item] = sym_const_item,
  [sym_static_item] = sym_static_item,
  [sym_type_item] = sym_type_item,
  [sym_function_item] = sym_function_item,
  [sym_function_signature_item] = sym_function_signature_item,
  [sym_function_modifiers] = sym_function_modifiers,
  [sym_where_clause] = sym_where_clause,
  [sym_where_predicate] = sym_where_predicate,
  [sym_impl_item] = sym_impl_item,
  [sym_trait_item] = sym_trait_item,
  [sym_associated_type] = sym_associated_type,
  [sym_trait_bounds] = sym_trait_bounds,
  [sym_higher_ranked_trait_bound] = sym_higher_ranked_trait_bound,
  [sym_removed_trait_bound] = sym_removed_trait_bound,
  [sym_type_parameters] = sym_type_parameters,
  [sym_const_parameter] = sym_const_parameter,
  [sym_constrained_type_parameter] = sym_constrained_type_parameter,
  [sym_optional_type_parameter] = sym_optional_type_parameter,
  [sym_let_declaration] = sym_let_declaration,
  [sym_use_declaration] = sym_use_declaration,
  [sym__use_clause] = sym__use_clause,
  [sym_scoped_use_list] = sym_scoped_use_list,
  [sym_use_list] = sym_use_list,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_use_wildcard] = sym_use_wildcard,
  [sym_parameters] = sym_parameters,
  [sym_self_parameter] = sym_self_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter] = sym_parameter,
  [sym_extern_modifier] = sym_extern_modifier,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym__type] = sym__type,
  [sym_bracketed_type] = sym_bracketed_type,
  [sym_qualified_type] = sym_qualified_type,
  [sym_lifetime] = sym_lifetime,
  [sym_array_type] = sym_array_type,
  [sym_for_lifetimes] = sym_for_lifetimes,
  [sym_function_type] = sym_function_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_unit_type] = sym_unit_type,
  [sym_generic_function] = sym_generic_function,
  [sym_generic_type] = sym_generic_type,
  [sym_generic_type_with_turbofish] = sym_generic_type_with_turbofish,
  [sym_bounded_type] = sym_bounded_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_type_binding] = sym_type_binding,
  [sym_reference_type] = sym_reference_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_never_type] = sym_never_type,
  [sym_abstract_type] = sym_abstract_type,
  [sym_dynamic_type] = sym_dynamic_type,
  [sym__expression_except_range] = sym__expression_except_range,
  [sym__expression] = sym__expression,
  [sym_macro_invocation] = sym_macro_invocation,
  [sym_delim_token_tree] = sym_token_tree,
  [sym__delim_tokens] = sym__delim_tokens,
  [sym__non_delim_token] = sym__non_delim_token,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_scoped_type_identifier_in_expression_position] = sym_scoped_type_identifier,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_range_expression] = sym_range_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_try_expression] = sym_try_expression,
  [sym_reference_expression] = sym_reference_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_compound_assignment_expr] = sym_compound_assignment_expr,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_return_expression] = sym_return_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_arguments] = sym_arguments,
  [sym_array_expression] = sym_array_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_unit_expression] = sym_unit_expression,
  [sym_struct_expression] = sym_struct_expression,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_shorthand_field_initializer] = sym_shorthand_field_initializer,
  [sym_field_initializer] = sym_field_initializer,
  [sym_base_field_initializer] = sym_base_field_initializer,
  [sym_if_expression] = sym_if_expression,
  [sym_let_condition] = sym_let_condition,
  [sym__let_chain] = sym__let_chain,
  [sym__condition] = sym__condition,
  [sym_else_clause] = sym_else_clause,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_arm] = sym_match_arm,
  [sym_last_match_arm] = sym_match_arm,
  [sym_match_pattern] = sym_match_pattern,
  [sym_while_expression] = sym_while_expression,
  [sym_loop_expression] = sym_loop_expression,
  [sym_for_expression] = sym_for_expression,
  [sym_const_block] = sym_const_block,
  [sym_closure_expression] = sym_closure_expression,
  [sym_closure_parameters] = sym_closure_parameters,
  [sym_label] = sym_label,
  [sym_break_expression] = sym_break_expression,
  [sym_continue_expression] = sym_continue_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_field_expression] = sym_field_expression,
  [sym_unsafe_block] = sym_unsafe_block,
  [sym_async_block] = sym_async_block,
  [sym_try_block] = sym_try_block,
  [sym_block] = sym_block,
  [sym__pattern] = sym__pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_slice_pattern] = sym_slice_pattern,
  [sym_tuple_struct_pattern] = sym_tuple_struct_pattern,
  [sym_struct_pattern] = sym_struct_pattern,
  [sym_field_pattern] = sym_field_pattern,
  [sym_remaining_field_pattern] = sym_remaining_field_pattern,
  [sym_mut_pattern] = sym_mut_pattern,
  [sym_range_pattern] = sym_range_pattern,
  [sym_ref_pattern] = sym_ref_pattern,
  [sym_captured_pattern] = sym_captured_pattern,
  [sym_reference_pattern] = sym_reference_pattern,
  [sym_or_pattern] = sym_or_pattern,
  [sym__literal] = sym__literal,
  [sym__literal_pattern] = sym__literal_pattern,
  [sym_negative_literal] = sym_negative_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_line_comment] = sym_line_comment,
  [sym__line_doc_comment_marker] = sym__line_doc_comment_marker,
  [sym__inner_line_doc_comment_marker] = sym__inner_block_doc_comment_marker,
  [sym__outer_line_doc_comment_marker] = sym__outer_block_doc_comment_marker,
  [sym_block_comment] = sym_block_comment,
  [sym__block_doc_comment_marker] = sym__block_doc_comment_marker,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_macro_definition_repeat1] = aux_sym_macro_definition_repeat1,
  [aux_sym_token_tree_pattern_repeat1] = aux_sym_token_tree_pattern_repeat1,
  [aux_sym_token_tree_repeat1] = aux_sym_token_tree_repeat1,
  [aux_sym__non_special_token_repeat1] = aux_sym__non_special_token_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_enum_variant_list_repeat1] = aux_sym_enum_variant_list_repeat1,
  [aux_sym_enum_variant_list_repeat2] = aux_sym_enum_variant_list_repeat2,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_ordered_field_declaration_list_repeat1] = aux_sym_ordered_field_declaration_list_repeat1,
  [aux_sym_function_modifiers_repeat1] = aux_sym_function_modifiers_repeat1,
  [aux_sym_where_clause_repeat1] = aux_sym_where_clause_repeat1,
  [aux_sym_trait_bounds_repeat1] = aux_sym_trait_bounds_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_for_lifetimes_repeat1] = aux_sym_for_lifetimes_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_delim_token_tree_repeat1] = aux_sym_delim_token_tree_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_match_arm_repeat1] = aux_sym_match_arm_repeat1,
  [aux_sym_closure_parameters_repeat1] = aux_sym_closure_parameters_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym_slice_pattern_repeat1] = aux_sym_slice_pattern_repeat1,
  [aux_sym_struct_pattern_repeat1] = aux_sym_struct_pattern_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_let_chain] = alias_sym_let_chain,
  [alias_sym_shorthand_field_identifier] = alias_sym_shorthand_field_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro_rules_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_token_repetition_pattern_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_block] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_expr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ident] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_item] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lifetime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_literal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_meta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_path] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stmt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_isize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_usize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_str] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_impl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dyn] = {
    .visible = true,
    .named = false,
  },
  [sym_mutable_specifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_move] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_line_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BANG2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_shebang] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_crate] = {
    .visible = true,
    .named = true,
  },
  [sym_metavariable] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__raw_string_literal_start] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string_literal_content] = {
    .visible = true,
    .named = true,
  },
  [sym__raw_string_literal_end] = {
    .visible = false,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__outer_block_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__inner_block_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__block_comment_content] = {
    .visible = false,
    .named = true,
  },
  [sym__line_doc_content] = {
    .visible = true,
    .named = true,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_rule] = {
    .visible = true,
    .named = true,
  },
  [sym__token_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_token_tree_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_binding_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_fragment_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_inner_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_foreign_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_item] = {
    .visible = true,
    .named = true,
  },
  [sym_union_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ordered_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_crate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_item] = {
    .visible = true,
    .named = true,
  },
  [sym_static_item] = {
    .visible = true,
    .named = true,
  },
  [sym_type_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_where_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_impl_item] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_item] = {
    .visible = true,
    .named = true,
  },
  [sym_associated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_bounds] = {
    .visible = true,
    .named = true,
  },
  [sym_higher_ranked_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_removed_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_const_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_let_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__use_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_self_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_bracketed_type] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lifetime] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_for_lifetimes] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_with_turbofish] = {
    .visible = true,
    .named = true,
  },
  [sym_bounded_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_never_type] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_type] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic_type] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_except_range] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_macro_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_delim_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym__delim_tokens] = {
    .visible = false,
    .named = true,
  },
  [sym__non_delim_token] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier_in_expression_position] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_assignment_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_shorthand_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_base_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_let_condition] = {
    .visible = true,
    .named = true,
  },
  [sym__let_chain] = {
    .visible = false,
    .named = true,
  },
  [sym__condition] = {
    .visible = false,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_last_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_const_block] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_break_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_block] = {
    .visible = true,
    .named = true,
  },
  [sym_async_block] = {
    .visible = true,
    .named = true,
  },
  [sym_try_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_remaining_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_mut_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_range_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_captured_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_or_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__literal_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_negative_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__line_doc_comment_marker] = {
    .visible = false,
    .named = true,
  },
  [sym__inner_line_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__outer_line_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__block_doc_comment_marker] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__non_special_token_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ordered_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_trait_bounds_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_lifetimes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_delim_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_arm_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_closure_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slice_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_let_chain] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_bounds = 6,
  field_condition = 7,
  field_consequence = 8,
  field_default_type = 9,
  field_doc = 10,
  field_element = 11,
  field_field = 12,
  field_function = 13,
  field_inner = 14,
  field_left = 15,
  field_length = 16,
  field_list = 17,
  field_macro = 18,
  field_name = 19,
  field_operator = 20,
  field_outer = 21,
  field_parameters = 22,
  field_path = 23,
  field_pattern = 24,
  field_return_type = 25,
  field_right = 26,
  field_trait = 27,
  field_type = 28,
  field_type_arguments = 29,
  field_type_parameters = 30,
  field_value = 31,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_bounds] = "bounds",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_default_type] = "default_type",
  [field_doc] = "doc",
  [field_element] = "element",
  [field_field] = "field",
  [field_function] = "function",
  [field_inner] = "inner",
  [field_left] = "left",
  [field_length] = "length",
  [field_list] = "list",
  [field_macro] = "macro",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_outer] = "outer",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_trait] = "trait",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 1},
  [7] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 1},
  [10] = {.index = 5, .length = 2},
  [11] = {.index = 5, .length = 2},
  [12] = {.index = 7, .length = 2},
  [13] = {.index = 9, .length = 2},
  [14] = {.index = 11, .length = 3},
  [15] = {.index = 14, .length = 2},
  [16] = {.index = 16, .length = 2},
  [17] = {.index = 16, .length = 2},
  [18] = {.index = 18, .length = 1},
  [19] = {.index = 19, .length = 2},
  [20] = {.index = 19, .length = 2},
  [21] = {.index = 19, .length = 2},
  [22] = {.index = 21, .length = 1},
  [23] = {.index = 22, .length = 1},
  [24] = {.index = 23, .length = 1},
  [25] = {.index = 23, .length = 1},
  [26] = {.index = 24, .length = 2},
  [27] = {.index = 24, .length = 2},
  [28] = {.index = 26, .length = 1},
  [29] = {.index = 27, .length = 2},
  [30] = {.index = 29, .length = 2},
  [31] = {.index = 31, .length = 2},
  [32] = {.index = 33, .length = 1},
  [33] = {.index = 34, .length = 2},
  [34] = {.index = 27, .length = 2},
  [35] = {.index = 36, .length = 2},
  [36] = {.index = 38, .length = 1},
  [37] = {.index = 39, .length = 1},
  [38] = {.index = 40, .length = 2},
  [39] = {.index = 26, .length = 1},
  [40] = {.index = 16, .length = 2},
  [41] = {.index = 16, .length = 2},
  [42] = {.index = 42, .length = 2},
  [43] = {.index = 44, .length = 2},
  [44] = {.index = 46, .length = 1},
  [45] = {.index = 16, .length = 2},
  [46] = {.index = 16, .length = 2},
  [47] = {.index = 47, .length = 3},
  [48] = {.index = 50, .length = 2},
  [49] = {.index = 52, .length = 2},
  [50] = {.index = 52, .length = 2},
  [51] = {.index = 54, .length = 2},
  [52] = {.index = 44, .length = 2},
  [53] = {.index = 11, .length = 3},
  [54] = {.index = 3, .length = 1},
  [56] = {.index = 56, .length = 1},
  [57] = {.index = 56, .length = 1},
  [58] = {.index = 57, .length = 1},
  [60] = {.index = 58, .length = 2},
  [61] = {.index = 56, .length = 1},
  [62] = {.index = 60, .length = 1},
  [63] = {.index = 61, .length = 1},
  [64] = {.index = 62, .length = 1},
  [65] = {.index = 63, .length = 2},
  [66] = {.index = 65, .length = 2},
  [67] = {.index = 65, .length = 2},
  [68] = {.index = 67, .length = 1},
  [69] = {.index = 67, .length = 1},
  [70] = {.index = 57, .length = 1},
  [71] = {.index = 68, .length = 2},
  [72] = {.index = 70, .length = 3},
  [73] = {.index = 73, .length = 2},
  [74] = {.index = 75, .length = 3},
  [75] = {.index = 78, .length = 3},
  [77] = {.index = 81, .length = 2},
  [78] = {.index = 81, .length = 2},
  [79] = {.index = 83, .length = 2},
  [80] = {.index = 85, .length = 3},
  [81] = {.index = 88, .length = 2},
  [82] = {.index = 90, .length = 1},
  [83] = {.index = 91, .length = 2},
  [84] = {.index = 93, .length = 2},
  [85] = {.index = 95, .length = 3},
  [86] = {.index = 98, .length = 2},
  [87] = {.index = 100, .length = 2},
  [88] = {.index = 102, .length = 2},
  [89] = {.index = 104, .length = 2},
  [90] = {.index = 106, .length = 2},
  [91] = {.index = 104, .length = 2},
  [92] = {.index = 106, .length = 2},
  [93] = {.index = 108, .length = 1},
  [94] = {.index = 102, .length = 2},
  [95] = {.index = 108, .length = 1},
  [96] = {.index = 109, .length = 1},
  [97] = {.index = 110, .length = 3},
  [98] = {.index = 113, .length = 1},
  [99] = {.index = 114, .length = 1},
  [100] = {.index = 115, .length = 2},
  [101] = {.index = 3, .length = 1},
  [102] = {.index = 117, .length = 1},
  [103] = {.index = 118, .length = 2},
  [104] = {.index = 120, .length = 1},
  [105] = {.index = 120, .length = 1},
  [106] = {.index = 121, .length = 3},
  [107] = {.index = 124, .length = 1},
  [108] = {.index = 121, .length = 3},
  [109] = {.index = 18, .length = 1},
  [110] = {.index = 125, .length = 2},
  [111] = {.index = 127, .length = 3},
  [112] = {.index = 130, .length = 3},
  [113] = {.index = 133, .length = 4},
  [114] = {.index = 137, .length = 3},
  [115] = {.index = 140, .length = 3},
  [116] = {.index = 143, .length = 2},
  [117] = {.index = 145, .length = 2},
  [118] = {.index = 145, .length = 2},
  [120] = {.index = 147, .length = 2},
  [121] = {.index = 149, .length = 3},
  [122] = {.index = 152, .length = 3},
  [123] = {.index = 147, .length = 2},
  [124] = {.index = 149, .length = 3},
  [125] = {.index = 155, .length = 2},
  [127] = {.index = 157, .length = 3},
  [128] = {.index = 160, .length = 3},
  [129] = {.index = 163, .length = 4},
  [130] = {.index = 125, .length = 2},
  [131] = {.index = 167, .length = 3},
  [132] = {.index = 170, .length = 2},
  [133] = {.index = 172, .length = 3},
  [134] = {.index = 175, .length = 2},
  [135] = {.index = 177, .length = 2},
  [136] = {.index = 179, .length = 3},
  [137] = {.index = 182, .length = 3},
  [138] = {.index = 185, .length = 2},
  [139] = {.index = 185, .length = 2},
  [140] = {.index = 187, .length = 2},
  [141] = {.index = 189, .length = 3},
  [142] = {.index = 192, .length = 2},
  [143] = {.index = 194, .length = 2},
  [144] = {.index = 196, .length = 1},
  [145] = {.index = 197, .length = 2},
  [146] = {.index = 199, .length = 1},
  [147] = {.index = 200, .length = 2},
  [148] = {.index = 108, .length = 1},
  [149] = {.index = 202, .length = 2},
  [150] = {.index = 204, .length = 2},
  [151] = {.index = 206, .length = 1},
  [152] = {.index = 207, .length = 2},
  [153] = {.index = 209, .length = 3},
  [154] = {.index = 209, .length = 3},
  [155] = {.index = 212, .length = 2},
  [156] = {.index = 214, .length = 4},
  [157] = {.index = 218, .length = 3},
  [158] = {.index = 221, .length = 4},
  [159] = {.index = 225, .length = 2},
  [160] = {.index = 227, .length = 3},
  [161] = {.index = 225, .length = 2},
  [162] = {.index = 227, .length = 3},
  [163] = {.index = 230, .length = 3},
  [164] = {.index = 233, .length = 3},
  [165] = {.index = 236, .length = 4},
  [166] = {.index = 233, .length = 3},
  [167] = {.index = 236, .length = 4},
  [168] = {.index = 230, .length = 3},
  [169] = {.index = 240, .length = 2},
  [170] = {.index = 242, .length = 2},
  [171] = {.index = 244, .length = 2},
  [172] = {.index = 246, .length = 2},
  [173] = {.index = 248, .length = 1},
  [174] = {.index = 249, .length = 2},
  [175] = {.index = 251, .length = 3},
  [176] = {.index = 254, .length = 2},
  [177] = {.index = 256, .length = 2},
  [178] = {.index = 200, .length = 2},
  [179] = {.index = 258, .length = 4},
  [180] = {.index = 262, .length = 3},
  [181] = {.index = 265, .length = 3},
  [182] = {.index = 268, .length = 3},
  [183] = {.index = 271, .length = 3},
  [184] = {.index = 274, .length = 4},
  [185] = {.index = 278, .length = 2},
  [186] = {.index = 280, .length = 2},
  [187] = {.index = 280, .length = 2},
  [188] = {.index = 282, .length = 3},
  [189] = {.index = 285, .length = 4},
  [190] = {.index = 289, .length = 3},
  [191] = {.index = 249, .length = 2},
  [192] = {.index = 292, .length = 2},
  [193] = {.index = 294, .length = 3},
  [194] = {.index = 297, .length = 3},
  [195] = {.index = 300, .length = 2},
  [196] = {.index = 302, .length = 3},
  [197] = {.index = 200, .length = 2},
  [198] = {.index = 305, .length = 3},
  [199] = {.index = 308, .length = 2},
  [200] = {.index = 310, .length = 2},
  [201] = {.index = 312, .length = 3},
  [202] = {.index = 315, .length = 3},
  [203] = {.index = 318, .length = 2},
  [204] = {.index = 320, .length = 4},
  [205] = {.index = 324, .length = 5},
  [206] = {.index = 329, .length = 4},
  [207] = {.index = 333, .length = 3},
  [208] = {.index = 333, .length = 3},
  [209] = {.index = 336, .length = 3},
  [210] = {.index = 339, .length = 4},
  [211] = {.index = 336, .length = 3},
  [212] = {.index = 339, .length = 4},
  [213] = {.index = 343, .length = 4},
  [214] = {.index = 343, .length = 4},
  [215] = {.index = 347, .length = 3},
  [216] = {.index = 350, .length = 3},
  [217] = {.index = 353, .length = 3},
  [218] = {.index = 356, .length = 2},
  [219] = {.index = 358, .length = 2},
  [220] = {.index = 125, .length = 2},
  [221] = {.index = 360, .length = 2},
  [222] = {.index = 362, .length = 3},
  [223] = {.index = 360, .length = 2},
  [224] = {.index = 362, .length = 3},
  [225] = {.index = 365, .length = 3},
  [226] = {.index = 368, .length = 4},
  [227] = {.index = 365, .length = 3},
  [228] = {.index = 368, .length = 4},
  [229] = {.index = 372, .length = 4},
  [230] = {.index = 376, .length = 4},
  [231] = {.index = 380, .length = 3},
  [232] = {.index = 383, .length = 4},
  [233] = {.index = 387, .length = 3},
  [234] = {.index = 390, .length = 3},
  [235] = {.index = 393, .length = 3},
  [236] = {.index = 396, .length = 4},
  [237] = {.index = 400, .length = 2},
  [238] = {.index = 402, .length = 3},
  [239] = {.index = 405, .length = 4},
  [240] = {.index = 409, .length = 3},
  [241] = {.index = 412, .length = 3},
  [242] = {.index = 415, .length = 2},
  [243] = {.index = 417, .length = 3},
  [244] = {.index = 420, .length = 5},
  [245] = {.index = 425, .length = 4},
  [246] = {.index = 425, .length = 4},
  [247] = {.index = 429, .length = 3},
  [248] = {.index = 432, .length = 3},
  [249] = {.index = 435, .length = 3},
  [250] = {.index = 438, .length = 3},
  [251] = {.index = 441, .length = 2},
  [252] = {.index = 443, .length = 3},
  [253] = {.index = 443, .length = 3},
  [254] = {.index = 446, .length = 3},
  [255] = {.index = 449, .length = 4},
  [256] = {.index = 446, .length = 3},
  [257] = {.index = 449, .length = 4},
  [258] = {.index = 453, .length = 4},
  [259] = {.index = 453, .length = 4},
  [260] = {.index = 457, .length = 4},
  [261] = {.index = 461, .length = 5},
  [262] = {.index = 466, .length = 4},
  [263] = {.index = 470, .length = 2},
  [264] = {.index = 472, .length = 4},
  [265] = {.index = 476, .length = 4},
  [266] = {.index = 480, .length = 3},
  [267] = {.index = 483, .length = 4},
  [268] = {.index = 487, .length = 4},
  [269] = {.index = 491, .length = 3},
  [270] = {.index = 494, .length = 4},
  [271] = {.index = 494, .length = 4},
  [272] = {.index = 498, .length = 5},
  [273] = {.index = 503, .length = 4},
  [274] = {.index = 507, .length = 5},
  [275] = {.index = 512, .length = 4},
  [276] = {.index = 516, .length = 4},
  [277] = {.index = 520, .length = 3},
  [278] = {.index = 523, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_inner, 0},
  [1] =
    {field_outer, 0},
  [2] =
    {field_value, 1},
  [3] =
    {field_name, 1},
  [4] =
    {field_body, 1},
  [5] =
    {field_body, 1},
    {field_name, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_body, 1},
    {field_parameters, 0},
  [11] =
    {field_doc, 2},
    {field_inner, 1, .inherited = true},
    {field_outer, 1, .inherited = true},
  [14] =
    {field_inner, 1, .inherited = true},
    {field_outer, 1, .inherited = true},
  [16] =
    {field_name, 2},
    {field_path, 0},
  [18] =
    {field_value, 2},
  [19] =
    {field_type, 0},
    {field_type_arguments, 1},
  [21] =
    {field_type, 1},
  [22] =
    {field_parameters, 1},
  [23] =
    {field_trait, 1},
  [24] =
    {field_parameters, 1},
    {field_trait, 0},
  [26] =
    {field_macro, 0},
  [27] =
    {field_body, 2},
    {field_name, 1},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_body, 2},
    {field_type, 1},
  [33] =
    {field_pattern, 1},
  [34] =
    {field_body, 2},
    {field_value, 1},
  [36] =
    {field_body, 2},
    {field_parameters, 1},
  [38] =
    {field_list, 1},
  [39] =
    {field_argument, 1},
  [40] =
    {field_body, 2},
    {field_condition, 1},
  [42] =
    {field_function, 0},
    {field_type_arguments, 2},
  [44] =
    {field_type, 0},
    {field_type_arguments, 2},
  [46] =
    {field_body, 2},
  [47] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [50] =
    {field_left, 0},
    {field_right, 2},
  [52] =
    {field_field, 2},
    {field_value, 0},
  [54] =
    {field_type, 2},
    {field_value, 0},
  [56] =
    {field_type, 0},
  [57] =
    {field_name, 0},
  [58] =
    {field_pattern, 0},
    {field_type, 2},
  [60] =
    {field_element, 1},
  [61] =
    {field_type, 2},
  [62] =
    {field_parameters, 2},
  [63] =
    {field_alias, 2},
    {field_type, 0},
  [65] =
    {field_parameters, 2},
    {field_trait, 1},
  [67] =
    {field_arguments, 1},
  [68] =
    {field_body, 3},
    {field_name, 1},
  [70] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [73] =
    {field_name, 1},
    {field_parameters, 2},
  [75] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [78] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [81] =
    {field_bounds, 1},
    {field_left, 0},
  [83] =
    {field_type, 2},
    {field_type_parameters, 1},
  [85] =
    {field_body, 3},
    {field_type, 2},
    {field_type_parameters, 1},
  [88] =
    {field_body, 3},
    {field_type, 1},
  [90] =
    {field_pattern, 2},
  [91] =
    {field_body, 3},
    {field_parameters, 2},
  [93] =
    {field_name, 1},
    {field_type_parameters, 2},
  [95] =
    {field_body, 3},
    {field_bounds, 2},
    {field_name, 1},
  [98] =
    {field_bounds, 2},
    {field_name, 1},
  [100] =
    {field_body, 3},
    {field_type, 2},
  [102] =
    {field_body, 3},
    {field_name, 2},
  [104] =
    {field_list, 2},
    {field_path, 0},
  [106] =
    {field_alias, 2},
    {field_path, 0},
  [108] =
    {field_name, 2},
  [109] =
    {field_argument, 2},
  [110] =
    {field_body, 3},
    {field_parameters, 0},
    {field_return_type, 2},
  [113] =
    {field_body, 3},
  [114] =
    {field_length, 3},
  [115] =
    {field_pattern, 1},
    {field_type, 3},
  [117] =
    {field_type, 3},
  [118] =
    {field_parameters, 1},
    {field_return_type, 3},
  [120] =
    {field_trait, 3},
  [121] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_trait, 0},
  [124] =
    {field_parameters, 3},
  [125] =
    {field_name, 1},
    {field_type, 3},
  [127] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [130] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [133] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [137] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [140] =
    {field_body, 4},
    {field_pattern, 1},
    {field_value, 3},
  [143] =
    {field_pattern, 1},
    {field_value, 3},
  [145] =
    {field_default_type, 2},
    {field_name, 0},
  [147] =
    {field_trait, 1},
    {field_type, 3},
  [149] =
    {field_body, 4},
    {field_trait, 1},
    {field_type, 3},
  [152] =
    {field_body, 4},
    {field_type, 2},
    {field_type_parameters, 1},
  [155] =
    {field_alternative, 3},
    {field_pattern, 1},
  [157] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3},
  [160] =
    {field_body, 4},
    {field_bounds, 2},
    {field_name, 1},
  [163] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [167] =
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [170] =
    {field_type, 3},
    {field_type_parameters, 2},
  [172] =
    {field_body, 4},
    {field_type, 3},
    {field_type_parameters, 2},
  [175] =
    {field_body, 4},
    {field_type, 2},
  [177] =
    {field_body, 4},
    {field_name, 2},
  [179] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 2},
  [182] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [185] =
    {field_field, 0},
    {field_value, 2},
  [187] =
    {field_name, 2},
    {field_parameters, 3},
  [189] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [192] =
    {field_name, 2},
    {field_type_parameters, 3},
  [194] =
    {field_body, 4},
    {field_name, 3},
  [196] =
    {field_name, 3},
  [197] =
    {field_body, 4},
    {field_condition, 3},
  [199] =
    {field_length, 4},
  [200] =
    {field_name, 0},
    {field_type, 2},
  [202] =
    {field_name, 0},
    {field_pattern, 2},
  [204] =
    {field_element, 1},
    {field_length, 3},
  [206] =
    {field_pattern, 0},
  [207] =
    {field_parameters, 2},
    {field_return_type, 4},
  [209] =
    {field_parameters, 2},
    {field_return_type, 4},
    {field_trait, 1},
  [212] =
    {field_name, 0},
    {field_value, 2},
  [214] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [218] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [221] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [225] =
    {field_trait, 2},
    {field_type, 4},
  [227] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
  [230] =
    {field_body, 5},
    {field_trait, 1},
    {field_type, 3},
  [233] =
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [236] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [240] =
    {field_pattern, 2},
    {field_type, 4},
  [242] =
    {field_pattern, 2},
    {field_value, 4},
  [244] =
    {field_alternative, 4},
    {field_pattern, 2},
  [246] =
    {field_pattern, 0},
    {field_value, 2},
  [248] =
    {field_condition, 2},
  [249] =
    {field_name, 2},
    {field_type, 4},
  [251] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4},
  [254] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [256] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [258] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [262] =
    {field_name, 1},
    {field_type, 4},
    {field_type_parameters, 2},
  [265] =
    {field_body, 5},
    {field_type, 3},
    {field_type_parameters, 2},
  [268] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 2},
  [271] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [274] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [278] =
    {field_alias, 4},
    {field_name, 2},
  [280] =
    {field_field, 1},
    {field_value, 3},
  [282] =
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [285] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [289] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [292] =
    {field_body, 5},
    {field_name, 3},
  [294] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 3},
  [297] =
    {field_body, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [300] =
    {field_name, 3},
    {field_parameters, 4},
  [302] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [305] =
    {field_name, 0},
    {field_type, 3},
    {field_type_arguments, 1},
  [308] =
    {field_name, 1},
    {field_pattern, 3},
  [310] =
    {field_parameters, 3},
    {field_return_type, 5},
  [312] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 5},
  [315] =
    {field_body, 1},
    {field_name, 0},
    {field_value, 3},
  [318] =
    {field_name, 1},
    {field_value, 3},
  [320] =
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [324] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [329] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [333] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
  [336] =
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [339] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [343] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [347] =
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [350] =
    {field_alternative, 5},
    {field_pattern, 1},
    {field_type, 3},
  [353] =
    {field_alternative, 5},
    {field_pattern, 1},
    {field_value, 3},
  [356] =
    {field_name, 3},
    {field_type, 5},
  [358] =
    {field_type, 2},
    {field_type, 3, .inherited = true},
  [360] =
    {field_trait, 3},
    {field_type, 5},
  [362] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
  [365] =
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [368] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [372] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [376] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [380] =
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [383] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [387] =
    {field_name, 2},
    {field_type, 5},
    {field_type_parameters, 3},
  [390] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 3},
  [393] =
    {field_body, 6},
    {field_name, 3},
    {field_type_parameters, 4},
  [396] =
    {field_body, 6},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [400] =
    {field_alias, 5},
    {field_name, 3},
  [402] =
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [405] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [409] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
  [412] =
    {field_body, 6},
    {field_pattern, 3},
    {field_value, 5},
  [415] =
    {field_name, 2},
    {field_pattern, 4},
  [417] =
    {field_body, 2},
    {field_name, 1},
    {field_value, 4},
  [420] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [425] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [429] =
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [432] =
    {field_alternative, 6},
    {field_pattern, 2},
    {field_type, 4},
  [435] =
    {field_alternative, 6},
    {field_pattern, 2},
    {field_value, 4},
  [438] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 6},
  [441] =
    {field_type, 3},
    {field_type, 4, .inherited = true},
  [443] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
  [446] =
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [449] =
    {field_body, 7},
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [453] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [457] =
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [461] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [466] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [470] =
    {field_name, 4},
    {field_type, 6},
  [472] =
    {field_body, 7},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [476] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [480] =
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [483] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [487] =
    {field_alternative, 7},
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [491] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 7},
  [494] =
    {field_body, 8},
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [498] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [503] =
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [507] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [512] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [516] =
    {field_alternative, 8},
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [520] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 8},
  [523] =
    {field_body, 9},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [5] = {
    [0] = alias_sym_type_identifier,
  },
  [7] = {
    [1] = alias_sym_type_identifier,
  },
  [9] = {
    [0] = alias_sym_let_chain,
  },
  [10] = {
    [0] = alias_sym_type_identifier,
  },
  [16] = {
    [0] = sym_identifier,
  },
  [17] = {
    [0] = sym_identifier,
    [2] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = sym_identifier,
  },
  [20] = {
    [0] = alias_sym_type_identifier,
  },
  [24] = {
    [1] = alias_sym_type_identifier,
  },
  [26] = {
    [0] = alias_sym_type_identifier,
  },
  [28] = {
    [0] = sym_identifier,
  },
  [29] = {
    [1] = alias_sym_type_identifier,
  },
  [41] = {
    [2] = alias_sym_type_identifier,
  },
  [43] = {
    [0] = alias_sym_type_identifier,
  },
  [45] = {
    [0] = sym_generic_type,
  },
  [46] = {
    [0] = sym_generic_type,
    [2] = alias_sym_type_identifier,
  },
  [50] = {
    [2] = alias_sym_field_identifier,
  },
  [53] = {
    [2] = sym__line_doc_content,
  },
  [54] = {
    [1] = sym_identifier,
  },
  [55] = {
    [0] = sym_identifier,
    [2] = sym_identifier,
  },
  [57] = {
    [0] = alias_sym_type_identifier,
  },
  [58] = {
    [0] = alias_sym_shorthand_field_identifier,
  },
  [59] = {
    [2] = sym_identifier,
  },
  [61] = {
    [0] = sym_generic_type,
  },
  [66] = {
    [1] = alias_sym_type_identifier,
  },
  [68] = {
    [0] = sym_identifier,
  },
  [71] = {
    [1] = alias_sym_type_identifier,
  },
  [72] = {
    [1] = alias_sym_type_identifier,
  },
  [76] = {
    [1] = alias_sym_type_identifier,
  },
  [77] = {
    [0] = alias_sym_type_identifier,
  },
  [84] = {
    [1] = alias_sym_type_identifier,
  },
  [85] = {
    [1] = alias_sym_type_identifier,
  },
  [86] = {
    [1] = alias_sym_type_identifier,
  },
  [88] = {
    [2] = alias_sym_type_identifier,
  },
  [89] = {
    [0] = sym_identifier,
  },
  [90] = {
    [0] = sym_identifier,
  },
  [95] = {
    [2] = alias_sym_type_identifier,
  },
  [101] = {
    [1] = alias_sym_shorthand_field_identifier,
  },
  [104] = {
    [3] = alias_sym_type_identifier,
  },
  [106] = {
    [0] = alias_sym_type_identifier,
  },
  [109] = {
    [0] = sym_identifier,
  },
  [111] = {
    [1] = alias_sym_type_identifier,
  },
  [117] = {
    [0] = alias_sym_type_identifier,
  },
  [119] = {
    [2] = alias_sym_type_identifier,
  },
  [120] = {
    [1] = alias_sym_type_identifier,
  },
  [121] = {
    [1] = alias_sym_type_identifier,
  },
  [126] = {
    [3] = sym_identifier,
  },
  [128] = {
    [1] = alias_sym_type_identifier,
  },
  [129] = {
    [1] = alias_sym_type_identifier,
  },
  [130] = {
    [1] = alias_sym_type_identifier,
  },
  [131] = {
    [1] = alias_sym_type_identifier,
  },
  [135] = {
    [2] = alias_sym_type_identifier,
  },
  [136] = {
    [2] = alias_sym_type_identifier,
  },
  [137] = {
    [2] = alias_sym_type_identifier,
  },
  [139] = {
    [0] = alias_sym_field_identifier,
  },
  [142] = {
    [2] = alias_sym_type_identifier,
  },
  [143] = {
    [3] = alias_sym_type_identifier,
  },
  [147] = {
    [0] = alias_sym_type_identifier,
  },
  [148] = {
    [2] = alias_sym_shorthand_field_identifier,
  },
  [149] = {
    [0] = alias_sym_field_identifier,
  },
  [153] = {
    [1] = alias_sym_type_identifier,
  },
  [159] = {
    [2] = alias_sym_type_identifier,
  },
  [160] = {
    [2] = alias_sym_type_identifier,
  },
  [163] = {
    [1] = alias_sym_type_identifier,
  },
  [164] = {
    [2] = alias_sym_type_identifier,
  },
  [165] = {
    [2] = alias_sym_type_identifier,
  },
  [178] = {
    [0] = alias_sym_field_identifier,
  },
  [179] = {
    [1] = alias_sym_type_identifier,
  },
  [180] = {
    [1] = alias_sym_type_identifier,
  },
  [182] = {
    [2] = alias_sym_type_identifier,
  },
  [183] = {
    [2] = alias_sym_type_identifier,
  },
  [184] = {
    [2] = alias_sym_type_identifier,
  },
  [187] = {
    [1] = alias_sym_field_identifier,
  },
  [191] = {
    [2] = alias_sym_type_identifier,
  },
  [192] = {
    [3] = alias_sym_type_identifier,
  },
  [193] = {
    [3] = alias_sym_type_identifier,
  },
  [194] = {
    [3] = alias_sym_type_identifier,
  },
  [198] = {
    [0] = alias_sym_type_identifier,
  },
  [199] = {
    [1] = alias_sym_field_identifier,
  },
  [207] = {
    [2] = alias_sym_type_identifier,
  },
  [209] = {
    [3] = alias_sym_type_identifier,
  },
  [210] = {
    [3] = alias_sym_type_identifier,
  },
  [213] = {
    [2] = alias_sym_type_identifier,
  },
  [220] = {
    [1] = alias_sym_field_identifier,
  },
  [221] = {
    [3] = alias_sym_type_identifier,
  },
  [222] = {
    [3] = alias_sym_type_identifier,
  },
  [225] = {
    [3] = alias_sym_type_identifier,
  },
  [226] = {
    [3] = alias_sym_type_identifier,
  },
  [229] = {
    [2] = alias_sym_type_identifier,
  },
  [233] = {
    [2] = alias_sym_type_identifier,
  },
  [234] = {
    [3] = alias_sym_type_identifier,
  },
  [235] = {
    [3] = alias_sym_type_identifier,
  },
  [236] = {
    [3] = alias_sym_type_identifier,
  },
  [242] = {
    [2] = alias_sym_field_identifier,
  },
  [245] = {
    [3] = alias_sym_type_identifier,
  },
  [252] = {
    [3] = alias_sym_type_identifier,
  },
  [254] = {
    [4] = alias_sym_type_identifier,
  },
  [255] = {
    [4] = alias_sym_type_identifier,
  },
  [258] = {
    [3] = alias_sym_type_identifier,
  },
  [264] = {
    [3] = alias_sym_type_identifier,
  },
  [270] = {
    [4] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_generic_type_with_turbofish, 2,
    sym_generic_type_with_turbofish,
    sym_generic_type,
  sym__let_chain, 2,
    sym__let_chain,
    alias_sym_let_chain,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 2,
  [7] = 3,
  [8] = 8,
  [9] = 5,
  [10] = 3,
  [11] = 2,
  [12] = 2,
  [13] = 13,
  [14] = 2,
  [15] = 5,
  [16] = 3,
  [17] = 13,
  [18] = 2,
  [19] = 13,
  [20] = 3,
  [21] = 3,
  [22] = 13,
  [23] = 13,
  [24] = 3,
  [25] = 5,
  [26] = 5,
  [27] = 27,
  [28] = 5,
  [29] = 13,
  [30] = 2,
  [31] = 13,
  [32] = 5,
  [33] = 4,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 37,
  [40] = 40,
  [41] = 41,
  [42] = 40,
  [43] = 35,
  [44] = 41,
  [45] = 40,
  [46] = 38,
  [47] = 35,
  [48] = 37,
  [49] = 35,
  [50] = 36,
  [51] = 40,
  [52] = 37,
  [53] = 41,
  [54] = 38,
  [55] = 40,
  [56] = 40,
  [57] = 40,
  [58] = 36,
  [59] = 41,
  [60] = 40,
  [61] = 37,
  [62] = 37,
  [63] = 37,
  [64] = 37,
  [65] = 38,
  [66] = 36,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 68,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 71,
  [76] = 76,
  [77] = 73,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 79,
  [82] = 69,
  [83] = 80,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 85,
  [88] = 88,
  [89] = 88,
  [90] = 90,
  [91] = 85,
  [92] = 86,
  [93] = 93,
  [94] = 94,
  [95] = 84,
  [96] = 94,
  [97] = 88,
  [98] = 85,
  [99] = 86,
  [100] = 93,
  [101] = 94,
  [102] = 84,
  [103] = 103,
  [104] = 84,
  [105] = 94,
  [106] = 94,
  [107] = 84,
  [108] = 88,
  [109] = 109,
  [110] = 110,
  [111] = 93,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 90,
  [117] = 86,
  [118] = 110,
  [119] = 93,
  [120] = 93,
  [121] = 88,
  [122] = 114,
  [123] = 88,
  [124] = 86,
  [125] = 84,
  [126] = 115,
  [127] = 113,
  [128] = 112,
  [129] = 85,
  [130] = 94,
  [131] = 85,
  [132] = 93,
  [133] = 86,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 140,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 137,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 135,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 142,
  [164] = 164,
  [165] = 165,
  [166] = 143,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 171,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 158,
  [178] = 178,
  [179] = 171,
  [180] = 180,
  [181] = 181,
  [182] = 174,
  [183] = 172,
  [184] = 169,
  [185] = 185,
  [186] = 186,
  [187] = 175,
  [188] = 188,
  [189] = 178,
  [190] = 186,
  [191] = 188,
  [192] = 192,
  [193] = 169,
  [194] = 145,
  [195] = 185,
  [196] = 192,
  [197] = 176,
  [198] = 159,
  [199] = 161,
  [200] = 151,
  [201] = 174,
  [202] = 174,
  [203] = 169,
  [204] = 171,
  [205] = 205,
  [206] = 167,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 209,
  [211] = 211,
  [212] = 212,
  [213] = 212,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 217,
  [220] = 218,
  [221] = 218,
  [222] = 216,
  [223] = 216,
  [224] = 224,
  [225] = 217,
  [226] = 216,
  [227] = 227,
  [228] = 215,
  [229] = 224,
  [230] = 227,
  [231] = 231,
  [232] = 217,
  [233] = 217,
  [234] = 234,
  [235] = 218,
  [236] = 216,
  [237] = 237,
  [238] = 238,
  [239] = 231,
  [240] = 234,
  [241] = 238,
  [242] = 218,
  [243] = 243,
  [244] = 244,
  [245] = 243,
  [246] = 243,
  [247] = 243,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 250,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 252,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 251,
  [270] = 252,
  [271] = 250,
  [272] = 254,
  [273] = 255,
  [274] = 256,
  [275] = 261,
  [276] = 251,
  [277] = 258,
  [278] = 262,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 282,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 268,
  [288] = 288,
  [289] = 279,
  [290] = 290,
  [291] = 268,
  [292] = 267,
  [293] = 258,
  [294] = 266,
  [295] = 295,
  [296] = 261,
  [297] = 297,
  [298] = 281,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 281,
  [304] = 249,
  [305] = 305,
  [306] = 306,
  [307] = 265,
  [308] = 282,
  [309] = 254,
  [310] = 301,
  [311] = 311,
  [312] = 264,
  [313] = 313,
  [314] = 281,
  [315] = 258,
  [316] = 299,
  [317] = 258,
  [318] = 258,
  [319] = 319,
  [320] = 256,
  [321] = 264,
  [322] = 306,
  [323] = 265,
  [324] = 282,
  [325] = 288,
  [326] = 258,
  [327] = 248,
  [328] = 302,
  [329] = 329,
  [330] = 330,
  [331] = 255,
  [332] = 255,
  [333] = 259,
  [334] = 334,
  [335] = 302,
  [336] = 254,
  [337] = 290,
  [338] = 338,
  [339] = 256,
  [340] = 280,
  [341] = 267,
  [342] = 266,
  [343] = 266,
  [344] = 344,
  [345] = 302,
  [346] = 346,
  [347] = 284,
  [348] = 348,
  [349] = 313,
  [350] = 279,
  [351] = 351,
  [352] = 352,
  [353] = 258,
  [354] = 290,
  [355] = 250,
  [356] = 263,
  [357] = 267,
  [358] = 305,
  [359] = 359,
  [360] = 252,
  [361] = 361,
  [362] = 268,
  [363] = 290,
  [364] = 297,
  [365] = 261,
  [366] = 366,
  [367] = 264,
  [368] = 368,
  [369] = 251,
  [370] = 265,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 170,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 374,
  [383] = 374,
  [384] = 375,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 375,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 181,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 391,
  [404] = 400,
  [405] = 401,
  [406] = 402,
  [407] = 400,
  [408] = 402,
  [409] = 401,
  [410] = 410,
  [411] = 411,
  [412] = 411,
  [413] = 411,
  [414] = 414,
  [415] = 415,
  [416] = 415,
  [417] = 415,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 419,
  [422] = 422,
  [423] = 423,
  [424] = 420,
  [425] = 422,
  [426] = 419,
  [427] = 423,
  [428] = 423,
  [429] = 429,
  [430] = 429,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 434,
  [436] = 436,
  [437] = 433,
  [438] = 436,
  [439] = 436,
  [440] = 433,
  [441] = 434,
  [442] = 442,
  [443] = 442,
  [444] = 442,
  [445] = 445,
  [446] = 244,
  [447] = 368,
  [448] = 352,
  [449] = 257,
  [450] = 311,
  [451] = 361,
  [452] = 372,
  [453] = 399,
  [454] = 454,
  [455] = 395,
  [456] = 456,
  [457] = 454,
  [458] = 376,
  [459] = 397,
  [460] = 454,
  [461] = 394,
  [462] = 379,
  [463] = 386,
  [464] = 385,
  [465] = 381,
  [466] = 396,
  [467] = 390,
  [468] = 393,
  [469] = 380,
  [470] = 470,
  [471] = 454,
  [472] = 377,
  [473] = 373,
  [474] = 392,
  [475] = 475,
  [476] = 475,
  [477] = 475,
  [478] = 475,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 361,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 528,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 368,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 311,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 257,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 706,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 352,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 754,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 758,
  [760] = 760,
  [761] = 760,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 772,
  [775] = 775,
  [776] = 776,
  [777] = 776,
  [778] = 778,
  [779] = 775,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 780,
  [788] = 788,
  [789] = 789,
  [790] = 783,
  [791] = 782,
  [792] = 786,
  [793] = 793,
  [794] = 781,
  [795] = 789,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 800,
  [802] = 802,
  [803] = 802,
  [804] = 804,
  [805] = 805,
  [806] = 804,
  [807] = 807,
  [808] = 808,
  [809] = 799,
  [810] = 810,
  [811] = 797,
  [812] = 798,
  [813] = 799,
  [814] = 814,
  [815] = 800,
  [816] = 814,
  [817] = 808,
  [818] = 818,
  [819] = 819,
  [820] = 819,
  [821] = 818,
  [822] = 800,
  [823] = 823,
  [824] = 824,
  [825] = 810,
  [826] = 826,
  [827] = 805,
  [828] = 799,
  [829] = 829,
  [830] = 830,
  [831] = 829,
  [832] = 829,
  [833] = 829,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 837,
  [839] = 839,
  [840] = 840,
  [841] = 836,
  [842] = 842,
  [843] = 842,
  [844] = 844,
  [845] = 837,
  [846] = 846,
  [847] = 834,
  [848] = 834,
  [849] = 835,
  [850] = 850,
  [851] = 834,
  [852] = 844,
  [853] = 835,
  [854] = 842,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 878,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 875,
  [889] = 889,
  [890] = 859,
  [891] = 891,
  [892] = 869,
  [893] = 874,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 860,
  [899] = 891,
  [900] = 875,
  [901] = 901,
  [902] = 902,
  [903] = 886,
  [904] = 884,
  [905] = 905,
  [906] = 864,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 877,
  [911] = 911,
  [912] = 909,
  [913] = 883,
  [914] = 865,
  [915] = 877,
  [916] = 908,
  [917] = 874,
  [918] = 858,
  [919] = 919,
  [920] = 875,
  [921] = 873,
  [922] = 859,
  [923] = 923,
  [924] = 887,
  [925] = 925,
  [926] = 863,
  [927] = 862,
  [928] = 928,
  [929] = 895,
  [930] = 930,
  [931] = 874,
  [932] = 932,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 881,
  [937] = 880,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 901,
  [942] = 942,
  [943] = 943,
  [944] = 873,
  [945] = 861,
  [946] = 934,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 887,
  [951] = 902,
  [952] = 923,
  [953] = 939,
  [954] = 942,
  [955] = 948,
  [956] = 905,
  [957] = 957,
  [958] = 958,
  [959] = 947,
  [960] = 934,
  [961] = 868,
  [962] = 962,
  [963] = 879,
  [964] = 964,
  [965] = 965,
  [966] = 887,
  [967] = 967,
  [968] = 935,
  [969] = 871,
  [970] = 940,
  [971] = 925,
  [972] = 967,
  [973] = 973,
  [974] = 973,
  [975] = 975,
  [976] = 907,
  [977] = 889,
  [978] = 938,
  [979] = 930,
  [980] = 911,
  [981] = 877,
  [982] = 949,
  [983] = 909,
  [984] = 878,
  [985] = 985,
  [986] = 923,
  [987] = 985,
  [988] = 866,
  [989] = 935,
  [990] = 967,
  [991] = 867,
  [992] = 885,
  [993] = 858,
  [994] = 928,
  [995] = 870,
  [996] = 895,
  [997] = 708,
  [998] = 876,
  [999] = 908,
  [1000] = 1000,
  [1001] = 880,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 708,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 181,
  [1017] = 1017,
  [1018] = 170,
  [1019] = 1019,
  [1020] = 389,
  [1021] = 368,
  [1022] = 371,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 361,
  [1026] = 1026,
  [1027] = 311,
  [1028] = 1028,
  [1029] = 352,
  [1030] = 257,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 523,
  [1036] = 596,
  [1037] = 1037,
  [1038] = 735,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 715,
  [1043] = 491,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 244,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1008,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1054,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1002,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1077,
  [1084] = 429,
  [1085] = 1085,
  [1086] = 1077,
  [1087] = 1087,
  [1088] = 1054,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 480,
  [1092] = 721,
  [1093] = 1093,
  [1094] = 708,
  [1095] = 592,
  [1096] = 1096,
  [1097] = 552,
  [1098] = 650,
  [1099] = 551,
  [1100] = 588,
  [1101] = 647,
  [1102] = 151,
  [1103] = 586,
  [1104] = 550,
  [1105] = 606,
  [1106] = 395,
  [1107] = 578,
  [1108] = 1108,
  [1109] = 604,
  [1110] = 1110,
  [1111] = 576,
  [1112] = 603,
  [1113] = 602,
  [1114] = 575,
  [1115] = 600,
  [1116] = 607,
  [1117] = 396,
  [1118] = 361,
  [1119] = 634,
  [1120] = 626,
  [1121] = 572,
  [1122] = 625,
  [1123] = 624,
  [1124] = 622,
  [1125] = 1125,
  [1126] = 525,
  [1127] = 617,
  [1128] = 674,
  [1129] = 608,
  [1130] = 610,
  [1131] = 613,
  [1132] = 620,
  [1133] = 623,
  [1134] = 573,
  [1135] = 629,
  [1136] = 630,
  [1137] = 645,
  [1138] = 616,
  [1139] = 524,
  [1140] = 615,
  [1141] = 614,
  [1142] = 612,
  [1143] = 482,
  [1144] = 486,
  [1145] = 611,
  [1146] = 609,
  [1147] = 598,
  [1148] = 597,
  [1149] = 595,
  [1150] = 591,
  [1151] = 631,
  [1152] = 583,
  [1153] = 581,
  [1154] = 568,
  [1155] = 691,
  [1156] = 567,
  [1157] = 632,
  [1158] = 566,
  [1159] = 633,
  [1160] = 562,
  [1161] = 545,
  [1162] = 544,
  [1163] = 487,
  [1164] = 543,
  [1165] = 542,
  [1166] = 1166,
  [1167] = 490,
  [1168] = 493,
  [1169] = 534,
  [1170] = 635,
  [1171] = 637,
  [1172] = 494,
  [1173] = 483,
  [1174] = 484,
  [1175] = 495,
  [1176] = 489,
  [1177] = 638,
  [1178] = 642,
  [1179] = 644,
  [1180] = 714,
  [1181] = 651,
  [1182] = 662,
  [1183] = 497,
  [1184] = 669,
  [1185] = 675,
  [1186] = 479,
  [1187] = 505,
  [1188] = 716,
  [1189] = 498,
  [1190] = 1190,
  [1191] = 679,
  [1192] = 681,
  [1193] = 499,
  [1194] = 687,
  [1195] = 500,
  [1196] = 699,
  [1197] = 501,
  [1198] = 627,
  [1199] = 502,
  [1200] = 503,
  [1201] = 504,
  [1202] = 1202,
  [1203] = 705,
  [1204] = 509,
  [1205] = 709,
  [1206] = 717,
  [1207] = 711,
  [1208] = 713,
  [1209] = 392,
  [1210] = 508,
  [1211] = 510,
  [1212] = 1212,
  [1213] = 718,
  [1214] = 1214,
  [1215] = 513,
  [1216] = 1216,
  [1217] = 511,
  [1218] = 512,
  [1219] = 514,
  [1220] = 516,
  [1221] = 515,
  [1222] = 1222,
  [1223] = 520,
  [1224] = 526,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 527,
  [1228] = 518,
  [1229] = 720,
  [1230] = 519,
  [1231] = 731,
  [1232] = 522,
  [1233] = 529,
  [1234] = 530,
  [1235] = 746,
  [1236] = 546,
  [1237] = 549,
  [1238] = 751,
  [1239] = 553,
  [1240] = 719,
  [1241] = 554,
  [1242] = 394,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 722,
  [1246] = 381,
  [1247] = 556,
  [1248] = 558,
  [1249] = 1249,
  [1250] = 559,
  [1251] = 531,
  [1252] = 560,
  [1253] = 563,
  [1254] = 532,
  [1255] = 1255,
  [1256] = 533,
  [1257] = 537,
  [1258] = 564,
  [1259] = 539,
  [1260] = 565,
  [1261] = 555,
  [1262] = 724,
  [1263] = 181,
  [1264] = 1264,
  [1265] = 557,
  [1266] = 561,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 569,
  [1270] = 1270,
  [1271] = 571,
  [1272] = 574,
  [1273] = 1273,
  [1274] = 577,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 496,
  [1279] = 158,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 652,
  [1283] = 728,
  [1284] = 656,
  [1285] = 393,
  [1286] = 657,
  [1287] = 658,
  [1288] = 660,
  [1289] = 1289,
  [1290] = 579,
  [1291] = 580,
  [1292] = 661,
  [1293] = 1293,
  [1294] = 584,
  [1295] = 585,
  [1296] = 730,
  [1297] = 663,
  [1298] = 587,
  [1299] = 589,
  [1300] = 665,
  [1301] = 1301,
  [1302] = 666,
  [1303] = 593,
  [1304] = 670,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 732,
  [1308] = 733,
  [1309] = 671,
  [1310] = 677,
  [1311] = 594,
  [1312] = 1312,
  [1313] = 678,
  [1314] = 683,
  [1315] = 257,
  [1316] = 1316,
  [1317] = 684,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 685,
  [1321] = 686,
  [1322] = 689,
  [1323] = 1323,
  [1324] = 690,
  [1325] = 692,
  [1326] = 1326,
  [1327] = 693,
  [1328] = 700,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 702,
  [1332] = 703,
  [1333] = 704,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 710,
  [1337] = 145,
  [1338] = 570,
  [1339] = 736,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 379,
  [1343] = 740,
  [1344] = 743,
  [1345] = 744,
  [1346] = 1346,
  [1347] = 747,
  [1348] = 748,
  [1349] = 1349,
  [1350] = 618,
  [1351] = 1351,
  [1352] = 385,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 619,
  [1356] = 745,
  [1357] = 159,
  [1358] = 742,
  [1359] = 1359,
  [1360] = 377,
  [1361] = 739,
  [1362] = 368,
  [1363] = 738,
  [1364] = 161,
  [1365] = 1365,
  [1366] = 170,
  [1367] = 737,
  [1368] = 741,
  [1369] = 639,
  [1370] = 641,
  [1371] = 373,
  [1372] = 372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 643,
  [1376] = 646,
  [1377] = 648,
  [1378] = 649,
  [1379] = 653,
  [1380] = 654,
  [1381] = 380,
  [1382] = 390,
  [1383] = 752,
  [1384] = 1384,
  [1385] = 753,
  [1386] = 655,
  [1387] = 659,
  [1388] = 701,
  [1389] = 1389,
  [1390] = 664,
  [1391] = 1391,
  [1392] = 712,
  [1393] = 668,
  [1394] = 397,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 672,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 352,
  [1407] = 673,
  [1408] = 590,
  [1409] = 676,
  [1410] = 582,
  [1411] = 750,
  [1412] = 1412,
  [1413] = 311,
  [1414] = 1414,
  [1415] = 1009,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1010,
  [1424] = 729,
  [1425] = 1425,
  [1426] = 727,
  [1427] = 1427,
  [1428] = 680,
  [1429] = 1429,
  [1430] = 726,
  [1431] = 682,
  [1432] = 541,
  [1433] = 1433,
  [1434] = 694,
  [1435] = 540,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 517,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 725,
  [1444] = 389,
  [1445] = 376,
  [1446] = 507,
  [1447] = 492,
  [1448] = 488,
  [1449] = 485,
  [1450] = 481,
  [1451] = 521,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 535,
  [1456] = 536,
  [1457] = 386,
  [1458] = 538,
  [1459] = 547,
  [1460] = 695,
  [1461] = 548,
  [1462] = 1462,
  [1463] = 696,
  [1464] = 697,
  [1465] = 698,
  [1466] = 707,
  [1467] = 1467,
  [1468] = 399,
  [1469] = 601,
  [1470] = 371,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1003,
  [1478] = 708,
  [1479] = 1479,
  [1480] = 561,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1034,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1011,
  [1492] = 1484,
  [1493] = 1493,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1484,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1034,
  [1507] = 1034,
  [1508] = 1014,
  [1509] = 1013,
  [1510] = 1510,
  [1511] = 1510,
  [1512] = 1512,
  [1513] = 1012,
  [1514] = 1514,
  [1515] = 1512,
  [1516] = 1024,
  [1517] = 1404,
  [1518] = 1017,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1065,
  [1523] = 1071,
  [1524] = 1031,
  [1525] = 1071,
  [1526] = 1047,
  [1527] = 1065,
  [1528] = 1528,
  [1529] = 1081,
  [1530] = 1268,
  [1531] = 1531,
  [1532] = 1019,
  [1533] = 1081,
  [1534] = 1047,
  [1535] = 1535,
  [1536] = 1268,
  [1537] = 1028,
  [1538] = 1015,
  [1539] = 1026,
  [1540] = 1540,
  [1541] = 1023,
  [1542] = 1542,
  [1543] = 1033,
  [1544] = 1544,
  [1545] = 1542,
  [1546] = 1040,
  [1547] = 1056,
  [1548] = 1437,
  [1549] = 1549,
  [1550] = 1437,
  [1551] = 244,
  [1552] = 1549,
  [1553] = 1553,
  [1554] = 1039,
  [1555] = 1067,
  [1556] = 1542,
  [1557] = 1419,
  [1558] = 1419,
  [1559] = 1542,
  [1560] = 1544,
  [1561] = 1473,
  [1562] = 1553,
  [1563] = 1067,
  [1564] = 1068,
  [1565] = 1058,
  [1566] = 1549,
  [1567] = 1481,
  [1568] = 1268,
  [1569] = 1404,
  [1570] = 1041,
  [1571] = 1549,
  [1572] = 1076,
  [1573] = 1497,
  [1574] = 1061,
  [1575] = 1090,
  [1576] = 1069,
  [1577] = 1063,
  [1578] = 1486,
  [1579] = 352,
  [1580] = 1483,
  [1581] = 1502,
  [1582] = 1070,
  [1583] = 1055,
  [1584] = 1501,
  [1585] = 1500,
  [1586] = 1499,
  [1587] = 1587,
  [1588] = 311,
  [1589] = 1049,
  [1590] = 1060,
  [1591] = 1059,
  [1592] = 1473,
  [1593] = 1050,
  [1594] = 1079,
  [1595] = 1595,
  [1596] = 1482,
  [1597] = 1496,
  [1598] = 1075,
  [1599] = 1072,
  [1600] = 1503,
  [1601] = 1481,
  [1602] = 1505,
  [1603] = 1045,
  [1604] = 1082,
  [1605] = 1062,
  [1606] = 1485,
  [1607] = 1080,
  [1608] = 1053,
  [1609] = 1609,
  [1610] = 1073,
  [1611] = 1611,
  [1612] = 1495,
  [1613] = 1087,
  [1614] = 1587,
  [1615] = 1489,
  [1616] = 1494,
  [1617] = 1493,
  [1618] = 257,
  [1619] = 1487,
  [1620] = 1490,
  [1621] = 1052,
  [1622] = 1595,
  [1623] = 1587,
  [1624] = 1066,
  [1625] = 361,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1627,
  [1629] = 1609,
  [1630] = 1044,
  [1631] = 1057,
  [1632] = 1085,
  [1633] = 1504,
  [1634] = 368,
  [1635] = 1051,
  [1636] = 1636,
  [1637] = 1637,
  [1638] = 1493,
  [1639] = 1397,
  [1640] = 1226,
  [1641] = 1225,
  [1642] = 1222,
  [1643] = 1270,
  [1644] = 1644,
  [1645] = 1202,
  [1646] = 1646,
  [1647] = 1301,
  [1648] = 1648,
  [1649] = 1166,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1653,
  [1654] = 1654,
  [1655] = 1108,
  [1656] = 1637,
  [1657] = 1651,
  [1658] = 1658,
  [1659] = 1646,
  [1660] = 1273,
  [1661] = 1650,
  [1662] = 1495,
  [1663] = 1637,
  [1664] = 1658,
  [1665] = 1341,
  [1666] = 1275,
  [1667] = 1391,
  [1668] = 1668,
  [1669] = 1312,
  [1670] = 1395,
  [1671] = 376,
  [1672] = 1503,
  [1673] = 1277,
  [1674] = 1351,
  [1675] = 1675,
  [1676] = 1675,
  [1677] = 385,
  [1678] = 379,
  [1679] = 1503,
  [1680] = 393,
  [1681] = 1334,
  [1682] = 1504,
  [1683] = 1330,
  [1684] = 1280,
  [1685] = 1326,
  [1686] = 1190,
  [1687] = 1496,
  [1688] = 1281,
  [1689] = 1212,
  [1690] = 1214,
  [1691] = 1216,
  [1692] = 1494,
  [1693] = 1503,
  [1694] = 1694,
  [1695] = 1384,
  [1696] = 1696,
  [1697] = 1243,
  [1698] = 1244,
  [1699] = 1396,
  [1700] = 1249,
  [1701] = 1701,
  [1702] = 1403,
  [1703] = 1703,
  [1704] = 1637,
  [1705] = 1462,
  [1706] = 1467,
  [1707] = 1650,
  [1708] = 1452,
  [1709] = 1675,
  [1710] = 1442,
  [1711] = 1482,
  [1712] = 1264,
  [1713] = 1502,
  [1714] = 1501,
  [1715] = 1483,
  [1716] = 1505,
  [1717] = 1648,
  [1718] = 1429,
  [1719] = 1306,
  [1720] = 1701,
  [1721] = 1374,
  [1722] = 1636,
  [1723] = 1255,
  [1724] = 1637,
  [1725] = 1725,
  [1726] = 1398,
  [1727] = 1727,
  [1728] = 1650,
  [1729] = 1490,
  [1730] = 1454,
  [1731] = 1453,
  [1732] = 1425,
  [1733] = 170,
  [1734] = 1489,
  [1735] = 1675,
  [1736] = 1736,
  [1737] = 1405,
  [1738] = 181,
  [1739] = 429,
  [1740] = 1490,
  [1741] = 1373,
  [1742] = 1485,
  [1743] = 377,
  [1744] = 1636,
  [1745] = 1486,
  [1746] = 1637,
  [1747] = 1008,
  [1748] = 1354,
  [1749] = 1497,
  [1750] = 1489,
  [1751] = 1289,
  [1752] = 1340,
  [1753] = 1753,
  [1754] = 372,
  [1755] = 1335,
  [1756] = 380,
  [1757] = 1650,
  [1758] = 1725,
  [1759] = 390,
  [1760] = 1725,
  [1761] = 1436,
  [1762] = 1762,
  [1763] = 1499,
  [1764] = 1399,
  [1765] = 1485,
  [1766] = 1400,
  [1767] = 1329,
  [1768] = 1675,
  [1769] = 1323,
  [1770] = 1486,
  [1771] = 1276,
  [1772] = 386,
  [1773] = 1365,
  [1774] = 1353,
  [1775] = 381,
  [1776] = 394,
  [1777] = 1125,
  [1778] = 1675,
  [1779] = 1439,
  [1780] = 1440,
  [1781] = 1781,
  [1782] = 389,
  [1783] = 1703,
  [1784] = 1487,
  [1785] = 159,
  [1786] = 1504,
  [1787] = 1487,
  [1788] = 1788,
  [1789] = 392,
  [1790] = 1636,
  [1791] = 1637,
  [1792] = 1650,
  [1793] = 399,
  [1794] = 395,
  [1795] = 1505,
  [1796] = 1433,
  [1797] = 1483,
  [1798] = 397,
  [1799] = 1799,
  [1800] = 396,
  [1801] = 151,
  [1802] = 1652,
  [1803] = 1636,
  [1804] = 1804,
  [1805] = 145,
  [1806] = 373,
  [1807] = 161,
  [1808] = 1482,
  [1809] = 1809,
  [1810] = 1482,
  [1811] = 1500,
  [1812] = 158,
  [1813] = 1441,
  [1814] = 371,
  [1815] = 1502,
  [1816] = 1501,
  [1817] = 1427,
  [1818] = 1500,
  [1819] = 1650,
  [1820] = 1420,
  [1821] = 1504,
  [1822] = 1418,
  [1823] = 1417,
  [1824] = 1636,
  [1825] = 1825,
  [1826] = 1414,
  [1827] = 1401,
  [1828] = 1412,
  [1829] = 1636,
  [1830] = 1825,
  [1831] = 1293,
  [1832] = 1499,
  [1833] = 1305,
  [1834] = 1725,
  [1835] = 1497,
  [1836] = 1675,
  [1837] = 1496,
  [1838] = 1495,
  [1839] = 1494,
  [1840] = 1493,
  [1841] = 1359,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1845,
  [1854] = 1854,
  [1855] = 1843,
  [1856] = 1843,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1850,
  [1860] = 1851,
  [1861] = 1644,
  [1862] = 1857,
  [1863] = 1863,
  [1864] = 1842,
  [1865] = 1863,
  [1866] = 1866,
  [1867] = 1736,
  [1868] = 1868,
  [1869] = 1846,
  [1870] = 1870,
  [1871] = 1762,
  [1872] = 1844,
  [1873] = 1866,
  [1874] = 1874,
  [1875] = 1849,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1877,
  [1879] = 1876,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1883,
  [1886] = 1882,
  [1887] = 1881,
  [1888] = 1884,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1892,
  [1894] = 1894,
  [1895] = 1892,
  [1896] = 1892,
  [1897] = 1892,
  [1898] = 1894,
  [1899] = 1894,
  [1900] = 1900,
  [1901] = 1900,
  [1902] = 161,
  [1903] = 1011,
  [1904] = 159,
  [1905] = 1028,
  [1906] = 1906,
  [1907] = 1017,
  [1908] = 1014,
  [1909] = 1026,
  [1910] = 1013,
  [1911] = 1012,
  [1912] = 1023,
  [1913] = 1031,
  [1914] = 1028,
  [1915] = 1015,
  [1916] = 1019,
  [1917] = 1023,
  [1918] = 1024,
  [1919] = 1017,
  [1920] = 1026,
  [1921] = 1076,
  [1922] = 1041,
  [1923] = 1056,
  [1924] = 1061,
  [1925] = 1039,
  [1926] = 1058,
  [1927] = 1068,
  [1928] = 1033,
  [1929] = 1040,
  [1930] = 1930,
  [1931] = 1070,
  [1932] = 1932,
  [1933] = 1932,
  [1934] = 1934,
  [1935] = 1072,
  [1936] = 1075,
  [1937] = 1059,
  [1938] = 170,
  [1939] = 1066,
  [1940] = 1057,
  [1941] = 1085,
  [1942] = 1049,
  [1943] = 1052,
  [1944] = 1044,
  [1945] = 1945,
  [1946] = 1519,
  [1947] = 1050,
  [1948] = 1051,
  [1949] = 1087,
  [1950] = 1079,
  [1951] = 1053,
  [1952] = 1062,
  [1953] = 1945,
  [1954] = 1954,
  [1955] = 1073,
  [1956] = 1090,
  [1957] = 1045,
  [1958] = 1080,
  [1959] = 371,
  [1960] = 181,
  [1961] = 1934,
  [1962] = 1945,
  [1963] = 1082,
  [1964] = 389,
  [1965] = 1540,
  [1966] = 1190,
  [1967] = 1374,
  [1968] = 1391,
  [1969] = 1399,
  [1970] = 1395,
  [1971] = 1270,
  [1972] = 1528,
  [1973] = 1281,
  [1974] = 1280,
  [1975] = 1975,
  [1976] = 1351,
  [1977] = 1326,
  [1978] = 1535,
  [1979] = 1312,
  [1980] = 1425,
  [1981] = 1341,
  [1982] = 1982,
  [1983] = 1277,
  [1984] = 1429,
  [1985] = 1934,
  [1986] = 1440,
  [1987] = 1275,
  [1988] = 1330,
  [1989] = 1334,
  [1990] = 1400,
  [1991] = 1439,
  [1992] = 1433,
  [1993] = 1373,
  [1994] = 1273,
  [1995] = 1397,
  [1996] = 1398,
  [1997] = 1997,
  [1998] = 158,
  [1999] = 145,
  [2000] = 2000,
  [2001] = 2001,
  [2002] = 1906,
  [2003] = 1017,
  [2004] = 1023,
  [2005] = 1028,
  [2006] = 2006,
  [2007] = 1028,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 1026,
  [2011] = 1023,
  [2012] = 1017,
  [2013] = 1028,
  [2014] = 1017,
  [2015] = 1026,
  [2016] = 1023,
  [2017] = 1026,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 2023,
  [2024] = 2023,
  [2025] = 2018,
  [2026] = 2026,
  [2027] = 2020,
  [2028] = 2028,
  [2029] = 2026,
  [2030] = 2030,
  [2031] = 2021,
  [2032] = 2022,
  [2033] = 2019,
  [2034] = 2034,
  [2035] = 368,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2038,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 311,
  [2043] = 2043,
  [2044] = 2043,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 2047,
  [2048] = 1017,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2045,
  [2052] = 2034,
  [2053] = 2038,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 2055,
  [2060] = 361,
  [2061] = 2061,
  [2062] = 2062,
  [2063] = 2047,
  [2064] = 1026,
  [2065] = 2056,
  [2066] = 2066,
  [2067] = 2050,
  [2068] = 1028,
  [2069] = 2049,
  [2070] = 2070,
  [2071] = 352,
  [2072] = 1930,
  [2073] = 257,
  [2074] = 2074,
  [2075] = 1023,
  [2076] = 2076,
  [2077] = 2077,
  [2078] = 1930,
  [2079] = 2079,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 1954,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 2090,
  [2091] = 1930,
  [2092] = 2092,
  [2093] = 2093,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2098,
  [2099] = 2099,
  [2100] = 2100,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 2081,
  [2106] = 373,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2107,
  [2116] = 2108,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 2081,
  [2122] = 2122,
  [2123] = 2088,
  [2124] = 2090,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 1040,
  [2132] = 1039,
  [2133] = 2133,
  [2134] = 2134,
  [2135] = 2135,
  [2136] = 2136,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2129,
  [2140] = 2138,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2135,
  [2144] = 2144,
  [2145] = 2136,
  [2146] = 2146,
  [2147] = 1041,
  [2148] = 1954,
  [2149] = 2137,
  [2150] = 1930,
  [2151] = 2151,
  [2152] = 1954,
  [2153] = 2141,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2130,
  [2158] = 2158,
  [2159] = 2146,
  [2160] = 2160,
  [2161] = 2142,
  [2162] = 2154,
  [2163] = 2160,
  [2164] = 2155,
  [2165] = 2133,
  [2166] = 1033,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2130,
  [2170] = 2135,
  [2171] = 2171,
  [2172] = 2128,
  [2173] = 2134,
  [2174] = 2171,
  [2175] = 2175,
  [2176] = 2176,
  [2177] = 2177,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2181,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2177,
  [2193] = 2178,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2186,
  [2198] = 2195,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2180,
  [2202] = 2182,
  [2203] = 2203,
  [2204] = 2199,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2196,
  [2208] = 2208,
  [2209] = 2208,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 1954,
  [2213] = 2190,
  [2214] = 2214,
  [2215] = 2211,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2200,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 2185,
  [2224] = 2189,
  [2225] = 2194,
  [2226] = 2226,
  [2227] = 2226,
  [2228] = 2210,
  [2229] = 2229,
  [2230] = 2188,
  [2231] = 2203,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2233,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2001,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2246,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2254,
  [2256] = 2251,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2263,
  [2266] = 2262,
  [2267] = 2242,
  [2268] = 2268,
  [2269] = 2245,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2232,
  [2273] = 2235,
  [2274] = 2236,
  [2275] = 2237,
  [2276] = 2268,
  [2277] = 2270,
  [2278] = 2240,
  [2279] = 2257,
  [2280] = 2261,
  [2281] = 2264,
  [2282] = 2247,
  [2283] = 2271,
  [2284] = 2284,
  [2285] = 2260,
  [2286] = 2286,
  [2287] = 2261,
  [2288] = 2284,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 158,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2294,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2291,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2299,
  [2314] = 2314,
  [2315] = 2298,
  [2316] = 2297,
  [2317] = 2317,
  [2318] = 159,
  [2319] = 2292,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2317,
  [2329] = 2329,
  [2330] = 2322,
  [2331] = 2326,
  [2332] = 2332,
  [2333] = 2332,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2300,
  [2339] = 2336,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2337,
  [2343] = 2324,
  [2344] = 161,
  [2345] = 2300,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2329,
  [2350] = 2350,
  [2351] = 2314,
  [2352] = 2352,
  [2353] = 2305,
  [2354] = 2312,
  [2355] = 2009,
  [2356] = 145,
  [2357] = 2008,
  [2358] = 2320,
  [2359] = 2312,
  [2360] = 2360,
  [2361] = 2341,
  [2362] = 2340,
  [2363] = 2363,
  [2364] = 2340,
  [2365] = 2341,
  [2366] = 2006,
  [2367] = 2335,
  [2368] = 2334,
  [2369] = 2329,
  [2370] = 2370,
  [2371] = 2311,
  [2372] = 2329,
  [2373] = 2373,
  [2374] = 2302,
  [2375] = 2347,
  [2376] = 2363,
  [2377] = 2308,
  [2378] = 2360,
  [2379] = 2309,
  [2380] = 2310,
  [2381] = 2346,
  [2382] = 2327,
  [2383] = 2348,
  [2384] = 2350,
  [2385] = 2296,
  [2386] = 2352,
  [2387] = 2325,
  [2388] = 2323,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 1319,
  [2400] = 2400,
  [2401] = 2391,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2400,
  [2420] = 2420,
  [2421] = 2414,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2413,
  [2427] = 2427,
  [2428] = 2394,
  [2429] = 1316,
  [2430] = 1422,
  [2431] = 2413,
  [2432] = 2402,
  [2433] = 2397,
  [2434] = 2402,
  [2435] = 2435,
  [2436] = 2394,
  [2437] = 2437,
  [2438] = 2396,
  [2439] = 2413,
  [2440] = 2440,
  [2441] = 2441,
  [2442] = 2442,
  [2443] = 1318,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 2446,
  [2447] = 2414,
  [2448] = 2396,
  [2449] = 2449,
  [2450] = 2445,
  [2451] = 2407,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 2410,
  [2459] = 2457,
  [2460] = 2406,
  [2461] = 2461,
  [2462] = 2395,
  [2463] = 2405,
  [2464] = 2416,
  [2465] = 2465,
  [2466] = 1346,
  [2467] = 2423,
  [2468] = 2468,
  [2469] = 2469,
  [2470] = 1349,
  [2471] = 1093,
  [2472] = 2472,
  [2473] = 2417,
  [2474] = 1110,
  [2475] = 1096,
  [2476] = 2424,
  [2477] = 2415,
  [2478] = 2478,
  [2479] = 1008,
  [2480] = 2478,
  [2481] = 2441,
  [2482] = 1421,
  [2483] = 2483,
  [2484] = 2484,
  [2485] = 2417,
  [2486] = 2418,
  [2487] = 2484,
  [2488] = 2483,
  [2489] = 2405,
  [2490] = 2390,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2497,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 2498,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 2496,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 2523,
  [2524] = 2524,
  [2525] = 2057,
  [2526] = 2046,
  [2527] = 2058,
  [2528] = 2061,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2531,
  [2532] = 2532,
  [2533] = 2533,
  [2534] = 2041,
  [2535] = 2040,
  [2536] = 2037,
  [2537] = 2074,
  [2538] = 2538,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2518,
  [2549] = 2549,
  [2550] = 2519,
  [2551] = 2551,
  [2552] = 2552,
  [2553] = 2553,
  [2554] = 2510,
  [2555] = 2555,
  [2556] = 2553,
  [2557] = 2540,
  [2558] = 2558,
  [2559] = 2559,
  [2560] = 2560,
  [2561] = 2561,
  [2562] = 2562,
  [2563] = 2563,
  [2564] = 139,
  [2565] = 2565,
  [2566] = 2566,
  [2567] = 2508,
  [2568] = 2568,
  [2569] = 2563,
  [2570] = 2570,
  [2571] = 2563,
  [2572] = 2497,
  [2573] = 2540,
  [2574] = 149,
  [2575] = 2498,
  [2576] = 2496,
  [2577] = 2577,
  [2578] = 2533,
  [2579] = 2579,
  [2580] = 2580,
  [2581] = 2581,
  [2582] = 2582,
  [2583] = 2524,
  [2584] = 2584,
  [2585] = 2585,
  [2586] = 2586,
  [2587] = 2514,
  [2588] = 2516,
  [2589] = 2513,
  [2590] = 2590,
  [2591] = 2521,
  [2592] = 2592,
  [2593] = 2581,
  [2594] = 2594,
  [2595] = 2523,
  [2596] = 2506,
  [2597] = 2597,
  [2598] = 2586,
  [2599] = 2529,
  [2600] = 2497,
  [2601] = 2584,
  [2602] = 2498,
  [2603] = 2496,
  [2604] = 2530,
  [2605] = 2504,
  [2606] = 2606,
  [2607] = 2586,
  [2608] = 2505,
  [2609] = 2581,
  [2610] = 2503,
  [2611] = 2506,
  [2612] = 2512,
  [2613] = 2613,
  [2614] = 2562,
  [2615] = 2507,
  [2616] = 2579,
  [2617] = 2514,
  [2618] = 2516,
  [2619] = 2538,
  [2620] = 2620,
  [2621] = 2621,
  [2622] = 2622,
  [2623] = 2586,
  [2624] = 2539,
  [2625] = 2546,
  [2626] = 2626,
  [2627] = 2540,
  [2628] = 2521,
  [2629] = 2496,
  [2630] = 2630,
  [2631] = 2501,
  [2632] = 2512,
  [2633] = 2633,
  [2634] = 2634,
  [2635] = 2509,
  [2636] = 2514,
  [2637] = 2558,
  [2638] = 2516,
  [2639] = 2581,
  [2640] = 2640,
  [2641] = 2640,
  [2642] = 2521,
  [2643] = 2634,
  [2644] = 2644,
  [2645] = 2546,
  [2646] = 2516,
  [2647] = 2494,
  [2648] = 2523,
  [2649] = 2649,
  [2650] = 2620,
  [2651] = 2621,
  [2652] = 2529,
  [2653] = 2529,
  [2654] = 2523,
  [2655] = 2530,
  [2656] = 2529,
  [2657] = 2657,
  [2658] = 2530,
  [2659] = 2531,
  [2660] = 2530,
  [2661] = 2538,
  [2662] = 2531,
  [2663] = 2500,
  [2664] = 2518,
  [2665] = 2519,
  [2666] = 2539,
  [2667] = 2667,
  [2668] = 2532,
  [2669] = 2532,
  [2670] = 2553,
  [2671] = 2671,
  [2672] = 2496,
  [2673] = 2551,
  [2674] = 2529,
  [2675] = 2559,
  [2676] = 2584,
  [2677] = 2538,
  [2678] = 2539,
  [2679] = 2667,
  [2680] = 2613,
  [2681] = 2681,
  [2682] = 2511,
  [2683] = 2683,
  [2684] = 2681,
  [2685] = 2685,
  [2686] = 2686,
  [2687] = 2538,
  [2688] = 2683,
  [2689] = 2689,
  [2690] = 2538,
  [2691] = 2549,
  [2692] = 2539,
  [2693] = 2539,
  [2694] = 2541,
  [2695] = 2581,
  [2696] = 2538,
  [2697] = 2541,
  [2698] = 2539,
  [2699] = 2699,
  [2700] = 2538,
  [2701] = 2546,
  [2702] = 2702,
  [2703] = 2539,
  [2704] = 2538,
  [2705] = 2584,
  [2706] = 2544,
  [2707] = 2539,
  [2708] = 2545,
  [2709] = 2545,
  [2710] = 2630,
  [2711] = 2622,
  [2712] = 2538,
  [2713] = 2539,
  [2714] = 2538,
  [2715] = 2715,
  [2716] = 2715,
  [2717] = 2542,
  [2718] = 2539,
  [2719] = 2538,
  [2720] = 2720,
  [2721] = 2721,
  [2722] = 2539,
  [2723] = 2723,
  [2724] = 2586,
  [2725] = 2580,
  [2726] = 2686,
  [2727] = 2495,
  [2728] = 2720,
  [2729] = 2729,
  [2730] = 2699,
  [2731] = 2731,
  [2732] = 2732,
  [2733] = 2733,
  [2734] = 2734,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2738,
  [2739] = 2739,
  [2740] = 2737,
  [2741] = 2736,
  [2742] = 2733,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 2746,
  [2747] = 2747,
  [2748] = 2748,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 2752,
  [2753] = 2753,
  [2754] = 2752,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2734,
  [2759] = 2759,
  [2760] = 2760,
  [2761] = 2761,
  [2762] = 2762,
  [2763] = 2756,
  [2764] = 2764,
  [2765] = 2765,
  [2766] = 2766,
  [2767] = 2767,
  [2768] = 2768,
  [2769] = 2769,
  [2770] = 2770,
  [2771] = 2771,
  [2772] = 2772,
  [2773] = 2773,
  [2774] = 2774,
  [2775] = 2775,
  [2776] = 2776,
  [2777] = 2777,
  [2778] = 2778,
  [2779] = 2743,
  [2780] = 2778,
  [2781] = 2781,
  [2782] = 2782,
  [2783] = 2783,
  [2784] = 2783,
  [2785] = 2785,
  [2786] = 2786,
  [2787] = 2787,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2790,
  [2791] = 2791,
  [2792] = 2746,
  [2793] = 2793,
  [2794] = 2794,
  [2795] = 2795,
  [2796] = 2796,
  [2797] = 2797,
  [2798] = 2755,
  [2799] = 2799,
  [2800] = 2800,
  [2801] = 2801,
  [2802] = 2802,
  [2803] = 2803,
  [2804] = 2804,
  [2805] = 2805,
  [2806] = 2806,
  [2807] = 2807,
  [2808] = 2808,
  [2809] = 2809,
  [2810] = 2810,
  [2811] = 2811,
  [2812] = 2812,
  [2813] = 2813,
  [2814] = 2814,
  [2815] = 2815,
  [2816] = 2816,
  [2817] = 2817,
  [2818] = 2818,
  [2819] = 2819,
  [2820] = 2820,
  [2821] = 2821,
  [2822] = 2822,
  [2823] = 2823,
  [2824] = 2824,
  [2825] = 2825,
  [2826] = 2826,
  [2827] = 2827,
  [2828] = 2810,
  [2829] = 2829,
  [2830] = 2830,
  [2831] = 2831,
  [2832] = 2770,
  [2833] = 2773,
  [2834] = 2834,
  [2835] = 2835,
  [2836] = 2775,
  [2837] = 2837,
  [2838] = 2752,
  [2839] = 2839,
  [2840] = 2840,
  [2841] = 2841,
  [2842] = 2842,
  [2843] = 2812,
  [2844] = 2731,
  [2845] = 2744,
  [2846] = 2846,
  [2847] = 2847,
  [2848] = 2812,
  [2849] = 2849,
  [2850] = 2850,
  [2851] = 2851,
  [2852] = 2739,
  [2853] = 2853,
  [2854] = 2854,
  [2855] = 2855,
  [2856] = 2856,
  [2857] = 2735,
  [2858] = 2858,
  [2859] = 2859,
  [2860] = 2812,
  [2861] = 2861,
  [2862] = 2862,
  [2863] = 2732,
  [2864] = 2864,
  [2865] = 2865,
  [2866] = 2866,
  [2867] = 2867,
  [2868] = 2868,
  [2869] = 2731,
  [2870] = 2870,
  [2871] = 2871,
  [2872] = 2872,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 2782,
  [2876] = 2762,
  [2877] = 2745,
  [2878] = 2878,
  [2879] = 2879,
  [2880] = 2880,
  [2881] = 2881,
  [2882] = 2882,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2885,
  [2886] = 2886,
  [2887] = 2887,
  [2888] = 2888,
  [2889] = 2889,
  [2890] = 2890,
  [2891] = 2891,
  [2892] = 2892,
  [2893] = 2892,
  [2894] = 2891,
  [2895] = 2895,
  [2896] = 2889,
  [2897] = 2897,
  [2898] = 2890,
  [2899] = 2795,
  [2900] = 2888,
  [2901] = 2884,
  [2902] = 2887,
  [2903] = 2903,
  [2904] = 2880,
  [2905] = 2905,
  [2906] = 2906,
  [2907] = 2868,
  [2908] = 2866,
  [2909] = 2909,
  [2910] = 2910,
  [2911] = 2911,
  [2912] = 2880,
  [2913] = 2883,
  [2914] = 2914,
  [2915] = 2884,
  [2916] = 2825,
  [2917] = 2823,
  [2918] = 2822,
  [2919] = 2786,
  [2920] = 2888,
  [2921] = 2819,
  [2922] = 373,
  [2923] = 2887,
  [2924] = 2788,
  [2925] = 2925,
  [2926] = 2809,
  [2927] = 2793,
  [2928] = 2928,
  [2929] = 2804,
  [2930] = 2796,
  [2931] = 2931,
  [2932] = 2932,
  [2933] = 2933,
  [2934] = 2934,
  [2935] = 2793,
  [2936] = 2774,
  [2937] = 2788,
  [2938] = 151,
  [2939] = 2079,
  [2940] = 2080,
  [2941] = 2083,
  [2942] = 2084,
  [2943] = 2802,
  [2944] = 2759,
  [2945] = 2807,
  [2946] = 2946,
  [2947] = 2753,
  [2948] = 2752,
  [2949] = 2085,
  [2950] = 2086,
  [2951] = 2756,
  [2952] = 2087,
  [2953] = 2953,
  [2954] = 2089,
  [2955] = 2099,
  [2956] = 2738,
  [2957] = 2867,
  [2958] = 2092,
  [2959] = 2093,
  [2960] = 2960,
  [2961] = 2094,
  [2962] = 2095,
  [2963] = 2096,
  [2964] = 2097,
  [2965] = 2859,
  [2966] = 2745,
  [2967] = 2967,
  [2968] = 2098,
  [2969] = 2100,
  [2970] = 2101,
  [2971] = 2971,
  [2972] = 2102,
  [2973] = 2110,
  [2974] = 2762,
  [2975] = 2855,
  [2976] = 2111,
  [2977] = 2790,
  [2978] = 2978,
  [2979] = 2979,
  [2980] = 2794,
  [2981] = 2797,
  [2982] = 2906,
  [2983] = 2983,
  [2984] = 2984,
  [2985] = 2985,
  [2986] = 2803,
  [2987] = 2806,
  [2988] = 2988,
  [2989] = 2112,
  [2990] = 2990,
  [2991] = 2813,
  [2992] = 2992,
  [2993] = 2113,
  [2994] = 2830,
  [2995] = 2114,
  [2996] = 2816,
  [2997] = 2850,
  [2998] = 2946,
  [2999] = 2818,
  [3000] = 3000,
  [3001] = 2109,
  [3002] = 2820,
  [3003] = 2119,
  [3004] = 2122,
  [3005] = 2076,
  [3006] = 2118,
  [3007] = 2812,
  [3008] = 2127,
  [3009] = 2847,
  [3010] = 2117,
  [3011] = 2077,
  [3012] = 2839,
  [3013] = 2858,
  [3014] = 2861,
  [3015] = 2837,
  [3016] = 2871,
  [3017] = 2873,
  [3018] = 2126,
  [3019] = 2879,
  [3020] = 2881,
  [3021] = 2834,
  [3022] = 2897,
  [3023] = 2914,
  [3024] = 2925,
  [3025] = 3025,
  [3026] = 2125,
  [3027] = 2120,
  [3028] = 2824,
  [3029] = 3029,
  [3030] = 2776,
  [3031] = 2800,
  [3032] = 2862,
  [3033] = 3033,
  [3034] = 3034,
  [3035] = 1397,
  [3036] = 3036,
  [3037] = 3033,
  [3038] = 3038,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 3044,
  [3045] = 3045,
  [3046] = 1398,
  [3047] = 1433,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3049,
  [3052] = 3052,
  [3053] = 3050,
  [3054] = 3054,
  [3055] = 3055,
  [3056] = 3052,
  [3057] = 3038,
  [3058] = 1190,
  [3059] = 3059,
  [3060] = 3060,
  [3061] = 3061,
  [3062] = 3049,
  [3063] = 3063,
  [3064] = 3059,
  [3065] = 3065,
  [3066] = 3066,
  [3067] = 3067,
  [3068] = 3068,
  [3069] = 3069,
  [3070] = 3070,
  [3071] = 3052,
  [3072] = 3072,
  [3073] = 3073,
  [3074] = 3074,
  [3075] = 3075,
  [3076] = 3076,
  [3077] = 3074,
  [3078] = 3078,
  [3079] = 3039,
  [3080] = 3063,
  [3081] = 3081,
  [3082] = 3082,
  [3083] = 3083,
  [3084] = 3034,
  [3085] = 3085,
  [3086] = 3086,
  [3087] = 3050,
  [3088] = 3088,
  [3089] = 3089,
  [3090] = 3090,
  [3091] = 3042,
  [3092] = 3092,
  [3093] = 3038,
  [3094] = 3094,
  [3095] = 3095,
  [3096] = 3096,
  [3097] = 3097,
  [3098] = 3098,
  [3099] = 3052,
  [3100] = 3100,
  [3101] = 3101,
  [3102] = 3102,
  [3103] = 3103,
  [3104] = 3104,
  [3105] = 3049,
  [3106] = 3106,
  [3107] = 3107,
  [3108] = 3108,
  [3109] = 3109,
  [3110] = 3110,
  [3111] = 3111,
  [3112] = 3112,
  [3113] = 3113,
  [3114] = 3114,
  [3115] = 3100,
  [3116] = 3116,
  [3117] = 3117,
  [3118] = 3118,
  [3119] = 3119,
  [3120] = 3120,
  [3121] = 3033,
  [3122] = 3069,
  [3123] = 3123,
  [3124] = 3070,
  [3125] = 1280,
  [3126] = 3126,
  [3127] = 3127,
  [3128] = 3068,
  [3129] = 3129,
  [3130] = 3130,
  [3131] = 3131,
  [3132] = 3083,
  [3133] = 3133,
  [3134] = 3129,
  [3135] = 3072,
  [3136] = 3100,
  [3137] = 3137,
  [3138] = 3138,
  [3139] = 3066,
  [3140] = 3140,
  [3141] = 3076,
  [3142] = 3067,
  [3143] = 3143,
  [3144] = 3144,
  [3145] = 3145,
  [3146] = 3130,
  [3147] = 3147,
  [3148] = 3069,
  [3149] = 3075,
  [3150] = 3150,
  [3151] = 3151,
  [3152] = 3152,
  [3153] = 3123,
  [3154] = 3154,
  [3155] = 3155,
  [3156] = 3070,
  [3157] = 3059,
  [3158] = 3068,
  [3159] = 3154,
  [3160] = 3160,
  [3161] = 3050,
  [3162] = 3072,
  [3163] = 3163,
  [3164] = 3164,
  [3165] = 3147,
  [3166] = 3052,
  [3167] = 3167,
  [3168] = 3076,
  [3169] = 3048,
  [3170] = 3059,
  [3171] = 3171,
  [3172] = 3172,
  [3173] = 3088,
  [3174] = 3104,
  [3175] = 3172,
  [3176] = 2840,
  [3177] = 3177,
  [3178] = 3070,
  [3179] = 2831,
  [3180] = 3092,
  [3181] = 3090,
  [3182] = 3182,
  [3183] = 3152,
  [3184] = 3088,
  [3185] = 3078,
  [3186] = 3073,
  [3187] = 3151,
  [3188] = 3095,
  [3189] = 3144,
  [3190] = 3052,
  [3191] = 3044,
  [3192] = 3101,
  [3193] = 3103,
  [3194] = 3054,
  [3195] = 3055,
  [3196] = 3140,
  [3197] = 3088,
  [3198] = 3089,
  [3199] = 3094,
  [3200] = 3200,
  [3201] = 3036,
  [3202] = 3040,
  [3203] = 3041,
  [3204] = 3204,
  [3205] = 3205,
  [3206] = 3206,
  [3207] = 3095,
  [3208] = 3094,
  [3209] = 3209,
  [3210] = 3210,
  [3211] = 3043,
  [3212] = 3096,
  [3213] = 3085,
  [3214] = 3214,
  [3215] = 3215,
  [3216] = 3059,
  [3217] = 3095,
  [3218] = 3096,
  [3219] = 3100,
  [3220] = 3215,
  [3221] = 3205,
  [3222] = 3206,
  [3223] = 3070,
  [3224] = 3210,
  [3225] = 3088,
  [3226] = 3086,
  [3227] = 3214,
  [3228] = 3052,
  [3229] = 3052,
  [3230] = 3230,
  [3231] = 3101,
  [3232] = 3103,
  [3233] = 3101,
  [3234] = 3052,
  [3235] = 3081,
  [3236] = 3114,
  [3237] = 3237,
  [3238] = 3103,
  [3239] = 3129,
  [3240] = 3045,
  [3241] = 3101,
  [3242] = 3242,
  [3243] = 3243,
  [3244] = 3244,
  [3245] = 3245,
  [3246] = 3138,
  [3247] = 3103,
  [3248] = 3126,
  [3249] = 3249,
  [3250] = 3070,
  [3251] = 3251,
  [3252] = 3112,
  [3253] = 3052,
  [3254] = 3111,
  [3255] = 3101,
  [3256] = 3103,
  [3257] = 3061,
  [3258] = 3112,
  [3259] = 3126,
  [3260] = 3260,
  [3261] = 3061,
  [3262] = 3060,
  [3263] = 3263,
  [3264] = 3120,
  [3265] = 3265,
  [3266] = 3131,
  [3267] = 3265,
  [3268] = 3268,
  [3269] = 3130,
  [3270] = 3270,
  [3271] = 3070,
  [3272] = 3272,
  [3273] = 3052,
  [3274] = 3204,
  [3275] = 3101,
  [3276] = 3103,
  [3277] = 3072,
  [3278] = 3278,
  [3279] = 3209,
  [3280] = 3245,
  [3281] = 3119,
  [3282] = 3070,
  [3283] = 3052,
  [3284] = 3127,
  [3285] = 3101,
  [3286] = 3103,
  [3287] = 3270,
  [3288] = 3070,
  [3289] = 3100,
  [3290] = 3101,
  [3291] = 3103,
  [3292] = 3111,
  [3293] = 3070,
  [3294] = 3101,
  [3295] = 3103,
  [3296] = 3070,
  [3297] = 3110,
  [3298] = 3101,
  [3299] = 3103,
  [3300] = 3065,
  [3301] = 3070,
  [3302] = 3101,
  [3303] = 3103,
  [3304] = 3304,
  [3305] = 3305,
  [3306] = 3263,
  [3307] = 3120,
  [3308] = 3163,
  [3309] = 3278,
  [3310] = 3304,
  [3311] = 3305,
  [3312] = 3312,
  [3313] = 3313,
  [3314] = 3314,
  [3315] = 3315,
  [3316] = 3316,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3319,
  [3320] = 3320,
  [3321] = 3321,
  [3322] = 3322,
  [3323] = 3323,
  [3324] = 160,
  [3325] = 3325,
  [3326] = 3326,
  [3327] = 3327,
  [3328] = 3328,
  [3329] = 3329,
  [3330] = 3330,
  [3331] = 3331,
  [3332] = 3319,
  [3333] = 3333,
  [3334] = 3334,
  [3335] = 3335,
  [3336] = 3336,
  [3337] = 3337,
  [3338] = 3326,
  [3339] = 3339,
  [3340] = 3340,
  [3341] = 3341,
  [3342] = 3342,
  [3343] = 3343,
  [3344] = 3344,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3347,
  [3348] = 3320,
  [3349] = 3346,
  [3350] = 3350,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 3353,
  [3354] = 3354,
  [3355] = 3355,
  [3356] = 3356,
  [3357] = 3357,
  [3358] = 3358,
  [3359] = 3359,
  [3360] = 3360,
  [3361] = 3361,
  [3362] = 3362,
  [3363] = 3363,
  [3364] = 3364,
  [3365] = 3365,
  [3366] = 3366,
  [3367] = 3365,
  [3368] = 3368,
  [3369] = 3365,
  [3370] = 3370,
  [3371] = 3362,
  [3372] = 3334,
  [3373] = 3373,
  [3374] = 3345,
  [3375] = 3375,
  [3376] = 3376,
  [3377] = 3377,
  [3378] = 3378,
  [3379] = 3379,
  [3380] = 3380,
  [3381] = 3381,
  [3382] = 3330,
  [3383] = 3376,
  [3384] = 3346,
  [3385] = 3385,
  [3386] = 3386,
  [3387] = 3387,
  [3388] = 3388,
  [3389] = 3389,
  [3390] = 3385,
  [3391] = 3381,
  [3392] = 3366,
  [3393] = 3388,
  [3394] = 3394,
  [3395] = 3329,
  [3396] = 3396,
  [3397] = 3397,
  [3398] = 3398,
  [3399] = 3399,
  [3400] = 3400,
  [3401] = 3401,
  [3402] = 3402,
  [3403] = 3403,
  [3404] = 3404,
  [3405] = 3389,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 3377,
  [3409] = 3409,
  [3410] = 3356,
  [3411] = 3411,
  [3412] = 3355,
  [3413] = 3413,
  [3414] = 3354,
  [3415] = 3353,
  [3416] = 3337,
  [3417] = 3417,
  [3418] = 3401,
  [3419] = 3413,
  [3420] = 3340,
  [3421] = 3421,
  [3422] = 3422,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3352,
  [3426] = 3426,
  [3427] = 3427,
  [3428] = 3359,
  [3429] = 3346,
  [3430] = 3430,
  [3431] = 3394,
  [3432] = 3351,
  [3433] = 3433,
  [3434] = 3422,
  [3435] = 3435,
  [3436] = 3436,
  [3437] = 3350,
  [3438] = 3360,
  [3439] = 3439,
  [3440] = 3440,
  [3441] = 3441,
  [3442] = 3442,
  [3443] = 3377,
  [3444] = 3444,
  [3445] = 3445,
  [3446] = 3402,
  [3447] = 3439,
  [3448] = 3322,
  [3449] = 3449,
  [3450] = 3450,
  [3451] = 3451,
  [3452] = 3373,
  [3453] = 3453,
  [3454] = 3401,
  [3455] = 3361,
  [3456] = 3456,
  [3457] = 3457,
  [3458] = 3363,
  [3459] = 3459,
  [3460] = 3451,
  [3461] = 3341,
  [3462] = 3406,
  [3463] = 3444,
  [3464] = 3464,
  [3465] = 3465,
  [3466] = 3401,
  [3467] = 3321,
  [3468] = 3339,
  [3469] = 3469,
  [3470] = 3470,
  [3471] = 3323,
  [3472] = 3312,
  [3473] = 3378,
  [3474] = 3439,
  [3475] = 3413,
  [3476] = 3333,
  [3477] = 3380,
  [3478] = 3375,
  [3479] = 3377,
  [3480] = 3339,
  [3481] = 3386,
  [3482] = 3341,
  [3483] = 3368,
  [3484] = 3333,
  [3485] = 3351,
  [3486] = 3325,
  [3487] = 3487,
  [3488] = 3365,
  [3489] = 3378,
  [3490] = 3362,
  [3491] = 3334,
  [3492] = 3321,
  [3493] = 3345,
  [3494] = 3494,
  [3495] = 3402,
  [3496] = 3342,
  [3497] = 3497,
  [3498] = 3449,
  [3499] = 3469,
  [3500] = 3500,
  [3501] = 3501,
  [3502] = 3321,
  [3503] = 3503,
  [3504] = 3504,
  [3505] = 3386,
  [3506] = 3312,
  [3507] = 3397,
  [3508] = 3508,
  [3509] = 3333,
  [3510] = 3335,
  [3511] = 3377,
  [3512] = 3341,
  [3513] = 3346,
  [3514] = 3514,
  [3515] = 3362,
  [3516] = 3345,
  [3517] = 3327,
  [3518] = 3518,
  [3519] = 3519,
  [3520] = 164,
  [3521] = 3321,
  [3522] = 3333,
  [3523] = 3376,
  [3524] = 3341,
  [3525] = 3525,
  [3526] = 3345,
  [3527] = 3321,
  [3528] = 3333,
  [3529] = 3341,
  [3530] = 3345,
  [3531] = 3333,
  [3532] = 3341,
  [3533] = 3345,
  [3534] = 3333,
  [3535] = 3333,
  [3536] = 3333,
  [3537] = 3333,
  [3538] = 3333,
  [3539] = 3328,
  [3540] = 3404,
  [3541] = 3541,
  [3542] = 3542,
  [3543] = 3543,
  [3544] = 3504,
  [3545] = 3545,
  [3546] = 3459,
  [3547] = 3457,
  [3548] = 3456,
  [3549] = 3403,
  [3550] = 3550,
  [3551] = 3551,
  [3552] = 3552,
  [3553] = 3440,
  [3554] = 3554,
  [3555] = 3555,
  [3556] = 3543,
  [3557] = 3552,
  [3558] = 3373,
  [3559] = 3559,
  [3560] = 3423,
  [3561] = 3561,
  [3562] = 3312,
  [3563] = 3465,
  [3564] = 3564,
  [3565] = 3565,
  [3566] = 3323,
  [3567] = 3379,
  [3568] = 3426,
  [3569] = 3433,
  [3570] = 3398,
  [3571] = 3571,
  [3572] = 3444,
  [3573] = 3494,
  [3574] = 3400,
  [3575] = 3364,
  [3576] = 3576,
  [3577] = 3439,
  [3578] = 3501,
  [3579] = 3313,
  [3580] = 3541,
  [3581] = 3581,
  [3582] = 3377,
  [3583] = 3424,
  [3584] = 3584,
  [3585] = 3336,
  [3586] = 3430,
  [3587] = 3543,
  [3588] = 3504,
  [3589] = 3459,
  [3590] = 3457,
  [3591] = 3402,
  [3592] = 3421,
  [3593] = 3543,
  [3594] = 3457,
  [3595] = 3595,
  [3596] = 3407,
  [3597] = 3457,
  [3598] = 3457,
  [3599] = 3457,
  [3600] = 3318,
  [3601] = 3564,
  [3602] = 3317,
  [3603] = 3576,
  [3604] = 3442,
  [3605] = 3316,
  [3606] = 3413,
  [3607] = 3411,
  [3608] = 3409,
  [3609] = 3315,
  [3610] = 3314,
  [3611] = 3611,
  [3612] = 3559,
  [3613] = 3613,
  [3614] = 3614,
  [3615] = 3615,
  [3616] = 3616,
  [3617] = 3617,
  [3618] = 3618,
  [3619] = 3619,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d},
  {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333},
  {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af},
  {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8},
  {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916},
  {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00},
  {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e},
  {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68},
  {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399},
  {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a},
  {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3},
  {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb},
  {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2},
  {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514},
  {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0},
  {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8},
  {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_3[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xece},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071},
  {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113},
  {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096},
  {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf},
  {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c}, {0xa840, 0xa873},
  {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c}, {0xa980, 0xa9c0},
  {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2}, {0xaadb, 0xaadd},
  {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a},
  {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d},
  {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41},
  {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f},
  {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f},
  {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9},
  {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595},
  {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785},
  {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855},
  {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf},
  {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075}, {0x1107f, 0x110ba},
  {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173}, {0x11176, 0x11176},
  {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303}, {0x11305, 0x1130c},
  {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348}, {0x1134b, 0x1134d},
  {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459}, {0x1145e, 0x11461},
  {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640}, {0x11644, 0x11644},
  {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746}, {0x11800, 0x1183a},
  {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938}, {0x1193b, 0x11943},
  {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47}, {0x11a50, 0x11a99},
  {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7},
  {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47}, {0x11d50, 0x11d59},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10},
  {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0},
  {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9},
  {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f},
  {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d},
  {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c},
  {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006}, {0x1e008, 0x1e018},
  {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe},
  {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739},
  {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(72);
      ADVANCE_MAP(
        '!', 171,
        '"', 157,
        '#', 143,
        '$', 85,
        '%', 99,
        '&', 104,
        '\'', 145,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 90,
        ',', 139,
        '-', 96,
        '.', 133,
        '/', 172,
        '0', 151,
        ':', 83,
        ';', 73,
        '<', 146,
        '=', 123,
        '>', 127,
        '?', 93,
        '@', 132,
        '[', 77,
        '\\', 46,
        ']', 78,
        '^', 100,
        'b', 178,
        'c', 179,
        'm', 182,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(1);
      if (lookahead == '[') ADVANCE(193);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(192);
      if (lookahead != 0) ADVANCE(193);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 102,
        '"', 156,
        '#', 142,
        '$', 85,
        '%', 99,
        '&', 104,
        '\'', 145,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 90,
        ',', 139,
        '-', 96,
        '.', 133,
        '/', 98,
        '0', 151,
        ':', 83,
        ';', 73,
        '<', 129,
        '=', 123,
        '>', 127,
        '?', 93,
        '@', 132,
        '[', 77,
        ']', 78,
        '^', 100,
        'b', 178,
        'c', 179,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 102,
        '"', 156,
        '#', 142,
        '$', 65,
        '%', 99,
        '&', 104,
        '\'', 145,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 90,
        ',', 139,
        '-', 95,
        '.', 133,
        '/', 98,
        '0', 151,
        ':', 83,
        ';', 73,
        '<', 129,
        '=', 122,
        '>', 127,
        '?', 93,
        '[', 77,
        ']', 78,
        '^', 100,
        'b', 178,
        'c', 179,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 102,
        '"', 156,
        '#', 142,
        '$', 84,
        '%', 99,
        '&', 104,
        '\'', 145,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 90,
        ',', 139,
        '-', 96,
        '.', 133,
        '/', 98,
        '0', 151,
        ':', 83,
        ';', 73,
        '<', 129,
        '=', 123,
        '>', 127,
        '?', 93,
        '@', 132,
        '[', 77,
        ']', 78,
        '^', 100,
        'b', 178,
        'c', 179,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 102,
        '"', 156,
        '$', 65,
        '%', 99,
        '&', 104,
        '\'', 145,
        '(', 75,
        '*', 92,
        '+', 90,
        '-', 95,
        '.', 133,
        '/', 98,
        '0', 151,
        ':', 83,
        '<', 129,
        '=', 123,
        '>', 127,
        '?', 93,
        '[', 77,
        '^', 100,
        'b', 178,
        'c', 179,
        'r', 180,
        '{', 79,
        '|', 106,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 102,
        '%', 99,
        '&', 104,
        '\'', 144,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 90,
        ',', 139,
        '-', 95,
        '.', 133,
        '/', 98,
        ':', 83,
        ';', 73,
        '<', 146,
        '=', 122,
        '>', 127,
        '?', 93,
        '[', 77,
        ']', 78,
        '^', 100,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 102,
        '%', 99,
        '&', 104,
        '\'', 144,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 90,
        ',', 139,
        '-', 95,
        '.', 133,
        '/', 98,
        ':', 40,
        ';', 73,
        '<', 129,
        '=', 122,
        '>', 127,
        '?', 93,
        '[', 77,
        ']', 78,
        '^', 100,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 102,
        '%', 99,
        '&', 104,
        '\'', 144,
        '(', 75,
        '*', 92,
        '+', 90,
        '-', 95,
        '.', 133,
        '/', 98,
        ':', 40,
        '<', 129,
        '=', 123,
        '>', 127,
        '?', 93,
        '[', 77,
        '^', 100,
        'r', 180,
        '{', 79,
        '|', 106,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 102,
        '%', 99,
        '&', 104,
        '(', 75,
        '*', 92,
        '+', 90,
        '-', 95,
        '.', 133,
        '/', 98,
        ':', 40,
        '<', 146,
        '=', 123,
        '>', 127,
        '?', 93,
        '[', 77,
        '^', 100,
        'r', 180,
        '|', 106,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 101,
        '"', 157,
        '#', 142,
        '$', 65,
        '&', 24,
        '\'', 144,
        '(', 75,
        ')', 76,
        '*', 33,
        '+', 89,
        ',', 139,
        '.', 30,
        '/', 28,
        ':', 83,
        ';', 73,
        '<', 128,
        '=', 43,
        '>', 126,
        '\\', 46,
        ']', 78,
        'm', 182,
        'r', 180,
        '{', 79,
        '|', 105,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 101,
        '"', 156,
        '#', 142,
        '$', 65,
        '&', 103,
        '\'', 145,
        '(', 75,
        ')', 76,
        '*', 91,
        ',', 139,
        '-', 94,
        '.', 31,
        '/', 28,
        '0', 151,
        ':', 83,
        ';', 73,
        '<', 128,
        '=', 121,
        '>', 126,
        '?', 93,
        '[', 77,
        ']', 78,
        'b', 178,
        'c', 179,
        'r', 180,
        '{', 79,
        '|', 105,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 101,
        '"', 156,
        '#', 142,
        '$', 65,
        '&', 103,
        '\'', 145,
        '(', 75,
        ')', 76,
        '*', 91,
        ',', 139,
        '-', 94,
        '.', 32,
        '/', 28,
        '0', 151,
        ':', 40,
        '<', 128,
        '=', 43,
        '?', 93,
        '[', 77,
        'b', 178,
        'c', 179,
        'r', 180,
        '|', 105,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 101,
        '"', 156,
        '$', 65,
        '&', 103,
        '\'', 145,
        '(', 75,
        '*', 91,
        '+', 89,
        ',', 139,
        '-', 97,
        '.', 31,
        '/', 28,
        '0', 151,
        ':', 40,
        ';', 73,
        '<', 128,
        '[', 77,
        ']', 78,
        'b', 178,
        'c', 179,
        'r', 180,
        '{', 79,
        '|', 105,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 101,
        '#', 142,
        '$', 65,
        '&', 103,
        '\'', 144,
        '(', 75,
        ')', 76,
        '*', 91,
        '+', 89,
        ',', 139,
        '-', 42,
        '.', 30,
        '/', 28,
        '0', 151,
        ':', 83,
        ';', 73,
        '<', 128,
        '=', 121,
        '>', 126,
        '?', 93,
        '[', 77,
        ']', 78,
        'r', 180,
        '{', 79,
        '|', 105,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '!', 101,
        '#', 142,
        '$', 65,
        '&', 24,
        '\'', 144,
        '(', 75,
        ')', 76,
        '*', 33,
        '+', 89,
        ',', 139,
        '.', 30,
        '/', 28,
        ':', 83,
        ';', 73,
        '<', 128,
        '=', 43,
        '>', 126,
        ']', 78,
        'm', 182,
        'r', 180,
        '{', 79,
        '|', 105,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '!', 101,
        '\'', 144,
        '(', 75,
        ')', 76,
        '+', 89,
        ',', 139,
        '.', 30,
        '/', 28,
        ':', 83,
        ';', 73,
        '<', 146,
        '=', 121,
        '>', 126,
        '@', 132,
        ']', 78,
        'r', 180,
        '{', 79,
        '|', 105,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(16);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '!', 101,
        '(', 75,
        '.', 30,
        '/', 28,
        ':', 40,
        '<', 146,
        '=', 43,
        '@', 132,
        'r', 180,
        '{', 79,
        '|', 105,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(17);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '!', 41,
        '%', 99,
        '&', 104,
        '\'', 144,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 90,
        ',', 139,
        '-', 96,
        '.', 133,
        '/', 98,
        ':', 82,
        ';', 73,
        '<', 129,
        '=', 122,
        '>', 127,
        '?', 93,
        '[', 77,
        ']', 78,
        '^', 100,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '!', 41,
        '%', 99,
        '&', 104,
        '\'', 144,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 90,
        ',', 139,
        '-', 95,
        '.', 133,
        '/', 98,
        ':', 82,
        ';', 73,
        '<', 129,
        '=', 122,
        '>', 127,
        '?', 93,
        '[', 77,
        ']', 78,
        '^', 100,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '!', 41,
        '%', 99,
        '&', 104,
        '(', 75,
        '*', 92,
        '+', 90,
        '-', 96,
        '.', 133,
        '/', 98,
        '<', 129,
        '=', 123,
        '>', 127,
        '?', 93,
        '[', 77,
        '^', 100,
        'r', 180,
        '|', 106,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(20);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '/') ADVANCE(28);
      if (lookahead == ';') ADVANCE(73);
      if (lookahead == 'r') ADVANCE(180);
      if (lookahead == '{') ADVANCE(79);
      if (lookahead == 'b' ||
          lookahead == 'c') ADVANCE(179);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '#', 142,
        '$', 65,
        ',', 139,
        '/', 28,
        ':', 40,
        ';', 73,
        '<', 128,
        '=', 121,
        'm', 182,
        'r', 180,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '#', 142,
        ',', 139,
        '.', 31,
        '/', 28,
        '0', 151,
        ':', 82,
        ';', 73,
        '<', 128,
        '=', 121,
        'r', 180,
        '{', 79,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 24:
      if (lookahead == '&') ADVANCE(107);
      END_STATE();
    case 25:
      if (lookahead == '\'') ADVANCE(158);
      END_STATE();
    case 26:
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(47);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '\'', 144,
        '(', 75,
        ')', 76,
        '*', 91,
        '+', 89,
        ',', 139,
        '-', 42,
        '.', 30,
        '/', 28,
        ':', 82,
        ';', 73,
        '<', 146,
        '=', 121,
        '>', 126,
        ']', 78,
        'r', 180,
        '{', 79,
        '|', 105,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 28:
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(160);
      END_STATE();
    case 29:
      if (lookahead == '*') ADVANCE(91);
      if (lookahead == '+') ADVANCE(89);
      if (lookahead == '/') ADVANCE(86);
      if (lookahead == '?') ADVANCE(93);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(87);
      if (lookahead != 0) ADVANCE(88);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(136);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(134);
      END_STATE();
    case 32:
      if (lookahead == '.') ADVANCE(135);
      END_STATE();
    case 33:
      if (lookahead == '/') ADVANCE(176);
      END_STATE();
    case 34:
      if (lookahead == '1') ADVANCE(36);
      if (lookahead == '3') ADVANCE(35);
      if (lookahead == '6') ADVANCE(38);
      if (lookahead == '8') ADVANCE(147);
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 35:
      if (lookahead == '2') ADVANCE(147);
      END_STATE();
    case 36:
      if (lookahead == '2') ADVANCE(39);
      if (lookahead == '6') ADVANCE(147);
      END_STATE();
    case 37:
      if (lookahead == '3') ADVANCE(35);
      if (lookahead == '6') ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == '4') ADVANCE(147);
      END_STATE();
    case 39:
      if (lookahead == '8') ADVANCE(147);
      END_STATE();
    case 40:
      if (lookahead == ':') ADVANCE(140);
      END_STATE();
    case 41:
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 42:
      if (lookahead == '>') ADVANCE(141);
      END_STATE();
    case 43:
      if (lookahead == '>') ADVANCE(81);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 45:
      if (lookahead == 'i') ADVANCE(48);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(49);
      if (lookahead == 'x') ADVANCE(61);
      if (lookahead != 0) ADVANCE(159);
      END_STATE();
    case 47:
      if (lookahead == 'u') ADVANCE(50);
      if (lookahead == 'x') ADVANCE(62);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 48:
      if (lookahead == 'z') ADVANCE(44);
      END_STATE();
    case 49:
      if (lookahead == '{') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 50:
      if (lookahead == '{') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 51:
      if (lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 52:
      if (lookahead == '}') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 53:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(152);
      END_STATE();
    case 54:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(1);
      if (lookahead != 0 &&
          lookahead != '[') ADVANCE(67);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(153);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(25);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(159);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(155);
      END_STATE();
    case 65:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 66:
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 67:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(193);
      END_STATE();
    case 68:
      if (eof) ADVANCE(72);
      ADVANCE_MAP(
        '!', 102,
        '"', 156,
        '#', 143,
        '$', 85,
        '%', 99,
        '&', 104,
        '\'', 145,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 90,
        ',', 139,
        '-', 96,
        '.', 133,
        '/', 98,
        '0', 151,
        ':', 83,
        ';', 73,
        '<', 146,
        '=', 123,
        '>', 127,
        '?', 93,
        '@', 132,
        '[', 77,
        ']', 78,
        '^', 100,
        'b', 178,
        'c', 179,
        'm', 182,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 69:
      if (eof) ADVANCE(72);
      ADVANCE_MAP(
        '!', 102,
        '"', 156,
        '#', 142,
        '$', 65,
        '%', 99,
        '&', 104,
        '\'', 145,
        '(', 75,
        '*', 92,
        '+', 90,
        '-', 95,
        '.', 133,
        '/', 98,
        '0', 151,
        ':', 40,
        ';', 73,
        '<', 129,
        '=', 122,
        '>', 127,
        '?', 93,
        '[', 77,
        '^', 100,
        'b', 178,
        'c', 179,
        'm', 182,
        'r', 180,
        '{', 79,
        '|', 106,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 70:
      if (eof) ADVANCE(72);
      ADVANCE_MAP(
        '!', 101,
        '"', 156,
        '#', 143,
        '$', 65,
        '&', 103,
        '\'', 145,
        '(', 75,
        ')', 76,
        '*', 91,
        '+', 89,
        ',', 139,
        '-', 94,
        '.', 31,
        '/', 28,
        '0', 151,
        ':', 83,
        ';', 73,
        '<', 128,
        '=', 121,
        '>', 126,
        '?', 93,
        '[', 77,
        ']', 78,
        'b', 178,
        'c', 179,
        'm', 182,
        'r', 180,
        '{', 79,
        '|', 105,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 71:
      if (eof) ADVANCE(72);
      ADVANCE_MAP(
        '!', 101,
        '"', 156,
        '#', 142,
        '$', 65,
        '&', 103,
        '\'', 145,
        '(', 75,
        '*', 91,
        '-', 94,
        '.', 31,
        '/', 28,
        '0', 151,
        ':', 40,
        ';', 73,
        '<', 128,
        '=', 43,
        '[', 77,
        'b', 178,
        'c', 179,
        'm', 182,
        'r', 180,
        '{', 79,
        '|', 105,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(154);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(191);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_macro_rules_BANG);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(140);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(88);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '/') ADVANCE(86);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(112);
      if (lookahead == '>') ADVANCE(141);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(141);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(107);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(118);
      if (lookahead == '|') ADVANCE(108);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(124);
      if (lookahead == '>') ADVANCE(81);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(130);
      if (lookahead == '>') ADVANCE(110);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(131);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(136);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(137);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(137);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(54);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(47);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '2') ADVANCE(155);
      if (lookahead == 'f') ADVANCE(149);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(155);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '3') ADVANCE(148);
      if (lookahead == '6') ADVANCE(150);
      if (lookahead == 'f') ADVANCE(149);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(155);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '4') ADVANCE(155);
      if (lookahead == 'f') ADVANCE(149);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(155);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'b') ADVANCE(53);
      if (lookahead == 'f') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'o') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(154);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(34);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(154);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(149);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_char_literal);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(88);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(166);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead == '*') ADVANCE(175);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(166);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(165);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '!') ADVANCE(171);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(169);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(170);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '*') ADVANCE(170);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(169);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_BANG2);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '/') ADVANCE(163);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(166);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_STAR_SLASH);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(74);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '\'') ADVANCE(26);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(156);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '#') ADVANCE(66);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(188);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(183);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(187);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(189);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(184);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(181);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(186);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(190);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(177);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(185);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_3, 776, lookahead)) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_shebang);
      if (lookahead == '\n') ADVANCE(1);
      if (lookahead == '[') ADVANCE(193);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(192);
      if (lookahead != 0) ADVANCE(193);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_shebang);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_metavariable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(194);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        '_', 1,
        'a', 2,
        'b', 3,
        'c', 4,
        'd', 5,
        'e', 6,
        'f', 7,
        'i', 8,
        'l', 9,
        'm', 10,
        'p', 11,
        'r', 12,
        's', 13,
        't', 14,
        'u', 15,
        'v', 16,
        'w', 17,
        'y', 18,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(21);
      if (lookahead == 'o') ADVANCE(22);
      if (lookahead == 'r') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'h') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(25);
      if (lookahead == 'r') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(27);
      if (lookahead == 'y') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'n') ADVANCE(30);
      if (lookahead == 'x') ADVANCE(31);
      END_STATE();
    case 7:
      if (lookahead == '3') ADVANCE(32);
      if (lookahead == '6') ADVANCE(33);
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '1', 37,
        '3', 38,
        '6', 39,
        '8', 40,
        'd', 41,
        'f', 42,
        'm', 43,
        'n', 44,
        's', 45,
        't', 46,
      );
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      if (lookahead == 'i') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      if (lookahead == 'y') ADVANCE(62);
      END_STATE();
    case 15:
      if (lookahead == '1') ADVANCE(63);
      if (lookahead == '3') ADVANCE(64);
      if (lookahead == '6') ADVANCE(65);
      if (lookahead == '8') ADVANCE(66);
      if (lookahead == 'n') ADVANCE(67);
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 16:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(70);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(77);
      END_STATE();
    case 25:
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 27:
      if (lookahead == 'f') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 31:
      if (lookahead == 'p') ADVANCE(84);
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 32:
      if (lookahead == '2') ADVANCE(86);
      END_STATE();
    case 33:
      if (lookahead == '4') ADVANCE(87);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(89);
      END_STATE();
    case 37:
      if (lookahead == '2') ADVANCE(90);
      if (lookahead == '6') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == '2') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == '4') ADVANCE(93);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_i8);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(95);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 45:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 48:
      if (lookahead == 'f') ADVANCE(99);
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'v') ADVANCE(105);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(108);
      END_STATE();
    case 56:
      if (lookahead == 'f') ADVANCE(109);
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'm') ADVANCE(113);
      if (lookahead == 'r') ADVANCE(114);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'u') ADVANCE(117);
      if (lookahead == 'y') ADVANCE(118);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_tt);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_ty);
      if (lookahead == 'p') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == '2') ADVANCE(120);
      if (lookahead == '6') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == '2') ADVANCE(122);
      END_STATE();
    case 65:
      if (lookahead == '4') ADVANCE(123);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_u8);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(124);
      if (lookahead == 's') ADVANCE(125);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(126);
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(129);
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(134);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(136);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(138);
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_dyn);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 83:
      if (lookahead == 'm') ADVANCE(143);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_f64);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 90:
      if (lookahead == '8') ADVANCE(147);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_i16);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_i32);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_i64);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(149);
      END_STATE();
    case 96:
      if (lookahead == 'z') ADVANCE(150);
      END_STATE();
    case 97:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 101:
      if (lookahead == 'p') ADVANCE(154);
      END_STATE();
    case 102:
      if (lookahead == 'c') ADVANCE(155);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(156);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_mutable_specifier);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_pat);
      if (lookahead == 'h') ADVANCE(158);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_pub);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 110:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 111:
      if (lookahead == 'f') ADVANCE(160);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_str);
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(166);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 120:
      if (lookahead == '8') ADVANCE(168);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_u16);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_u32);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_u64);
      END_STATE();
    case 124:
      if (lookahead == 'o') ADVANCE(169);
      END_STATE();
    case 125:
      if (lookahead == 'a') ADVANCE(170);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 127:
      if (lookahead == 'z') ADVANCE(171);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_vis);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(173);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(175);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 134:
      if (lookahead == 'k') ADVANCE(177);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 136:
      if (lookahead == 'k') ADVANCE(178);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 138:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 139:
      if (lookahead == 'i') ADVANCE(180);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 141:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_expr);
      END_STATE();
    case 145:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_i128);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_impl);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_item);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 153:
      if (lookahead == 'r') ADVANCE(188);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 155:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_meta);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_move);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_path);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 161:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_stmt);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(192);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 165:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_u128);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(195);
      END_STATE();
    case 170:
      if (lookahead == 'f') ADVANCE(196);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 174:
      if (lookahead == 'd') ADVANCE(200);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_block);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(201);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_crate);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(202);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(203);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_ident);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_isize);
      END_STATE();
    case 187:
      if (lookahead == 'i') ADVANCE(204);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 190:
      if (lookahead == 'n') ADVANCE(206);
      END_STATE();
    case 191:
      if (lookahead == 'c') ADVANCE(207);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_usize);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 201:
      if (lookahead == 'u') ADVANCE(210);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 204:
      if (lookahead == 'm') ADVANCE(212);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_literal);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_lifetime);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 70, .external_lex_state = 2},
  [2] = {.lex_state = 71, .external_lex_state = 2},
  [3] = {.lex_state = 71, .external_lex_state = 2},
  [4] = {.lex_state = 71, .external_lex_state = 2},
  [5] = {.lex_state = 71, .external_lex_state = 2},
  [6] = {.lex_state = 71, .external_lex_state = 2},
  [7] = {.lex_state = 71, .external_lex_state = 2},
  [8] = {.lex_state = 71, .external_lex_state = 2},
  [9] = {.lex_state = 71, .external_lex_state = 2},
  [10] = {.lex_state = 71, .external_lex_state = 2},
  [11] = {.lex_state = 71, .external_lex_state = 2},
  [12] = {.lex_state = 71, .external_lex_state = 2},
  [13] = {.lex_state = 71, .external_lex_state = 2},
  [14] = {.lex_state = 71, .external_lex_state = 2},
  [15] = {.lex_state = 71, .external_lex_state = 2},
  [16] = {.lex_state = 71, .external_lex_state = 2},
  [17] = {.lex_state = 71, .external_lex_state = 2},
  [18] = {.lex_state = 71, .external_lex_state = 2},
  [19] = {.lex_state = 71, .external_lex_state = 2},
  [20] = {.lex_state = 71, .external_lex_state = 2},
  [21] = {.lex_state = 71, .external_lex_state = 2},
  [22] = {.lex_state = 71, .external_lex_state = 2},
  [23] = {.lex_state = 71, .external_lex_state = 2},
  [24] = {.lex_state = 71, .external_lex_state = 2},
  [25] = {.lex_state = 71, .external_lex_state = 2},
  [26] = {.lex_state = 71, .external_lex_state = 2},
  [27] = {.lex_state = 71, .external_lex_state = 2},
  [28] = {.lex_state = 71, .external_lex_state = 2},
  [29] = {.lex_state = 71, .external_lex_state = 2},
  [30] = {.lex_state = 71, .external_lex_state = 2},
  [31] = {.lex_state = 71, .external_lex_state = 2},
  [32] = {.lex_state = 71, .external_lex_state = 2},
  [33] = {.lex_state = 71, .external_lex_state = 2},
  [34] = {.lex_state = 71, .external_lex_state = 2},
  [35] = {.lex_state = 3, .external_lex_state = 2},
  [36] = {.lex_state = 3, .external_lex_state = 2},
  [37] = {.lex_state = 3, .external_lex_state = 2},
  [38] = {.lex_state = 3, .external_lex_state = 2},
  [39] = {.lex_state = 3, .external_lex_state = 2},
  [40] = {.lex_state = 3, .external_lex_state = 2},
  [41] = {.lex_state = 3, .external_lex_state = 2},
  [42] = {.lex_state = 3, .external_lex_state = 2},
  [43] = {.lex_state = 5, .external_lex_state = 2},
  [44] = {.lex_state = 5, .external_lex_state = 2},
  [45] = {.lex_state = 5, .external_lex_state = 2},
  [46] = {.lex_state = 5, .external_lex_state = 2},
  [47] = {.lex_state = 3, .external_lex_state = 2},
  [48] = {.lex_state = 5, .external_lex_state = 2},
  [49] = {.lex_state = 3, .external_lex_state = 2},
  [50] = {.lex_state = 5, .external_lex_state = 2},
  [51] = {.lex_state = 5, .external_lex_state = 2},
  [52] = {.lex_state = 5, .external_lex_state = 2},
  [53] = {.lex_state = 3, .external_lex_state = 2},
  [54] = {.lex_state = 3, .external_lex_state = 2},
  [55] = {.lex_state = 3, .external_lex_state = 2},
  [56] = {.lex_state = 3, .external_lex_state = 2},
  [57] = {.lex_state = 3, .external_lex_state = 2},
  [58] = {.lex_state = 3, .external_lex_state = 2},
  [59] = {.lex_state = 3, .external_lex_state = 2},
  [60] = {.lex_state = 3, .external_lex_state = 2},
  [61] = {.lex_state = 3, .external_lex_state = 2},
  [62] = {.lex_state = 3, .external_lex_state = 2},
  [63] = {.lex_state = 3, .external_lex_state = 2},
  [64] = {.lex_state = 3, .external_lex_state = 2},
  [65] = {.lex_state = 3, .external_lex_state = 2},
  [66] = {.lex_state = 3, .external_lex_state = 2},
  [67] = {.lex_state = 2, .external_lex_state = 2},
  [68] = {.lex_state = 2, .external_lex_state = 2},
  [69] = {.lex_state = 2, .external_lex_state = 2},
  [70] = {.lex_state = 2, .external_lex_state = 2},
  [71] = {.lex_state = 2, .external_lex_state = 2},
  [72] = {.lex_state = 2, .external_lex_state = 2},
  [73] = {.lex_state = 2, .external_lex_state = 2},
  [74] = {.lex_state = 4, .external_lex_state = 2},
  [75] = {.lex_state = 2, .external_lex_state = 2},
  [76] = {.lex_state = 2, .external_lex_state = 2},
  [77] = {.lex_state = 2, .external_lex_state = 2},
  [78] = {.lex_state = 2, .external_lex_state = 2},
  [79] = {.lex_state = 2, .external_lex_state = 2},
  [80] = {.lex_state = 2, .external_lex_state = 2},
  [81] = {.lex_state = 2, .external_lex_state = 2},
  [82] = {.lex_state = 2, .external_lex_state = 2},
  [83] = {.lex_state = 2, .external_lex_state = 2},
  [84] = {.lex_state = 4, .external_lex_state = 2},
  [85] = {.lex_state = 4, .external_lex_state = 2},
  [86] = {.lex_state = 4, .external_lex_state = 2},
  [87] = {.lex_state = 4, .external_lex_state = 2},
  [88] = {.lex_state = 4, .external_lex_state = 2},
  [89] = {.lex_state = 4, .external_lex_state = 2},
  [90] = {.lex_state = 2, .external_lex_state = 2},
  [91] = {.lex_state = 4, .external_lex_state = 2},
  [92] = {.lex_state = 4, .external_lex_state = 2},
  [93] = {.lex_state = 4, .external_lex_state = 2},
  [94] = {.lex_state = 4, .external_lex_state = 2},
  [95] = {.lex_state = 4, .external_lex_state = 2},
  [96] = {.lex_state = 4, .external_lex_state = 2},
  [97] = {.lex_state = 4, .external_lex_state = 2},
  [98] = {.lex_state = 4, .external_lex_state = 2},
  [99] = {.lex_state = 4, .external_lex_state = 2},
  [100] = {.lex_state = 4, .external_lex_state = 2},
  [101] = {.lex_state = 4, .external_lex_state = 2},
  [102] = {.lex_state = 4, .external_lex_state = 2},
  [103] = {.lex_state = 2, .external_lex_state = 2},
  [104] = {.lex_state = 4, .external_lex_state = 2},
  [105] = {.lex_state = 4, .external_lex_state = 2},
  [106] = {.lex_state = 4, .external_lex_state = 2},
  [107] = {.lex_state = 4, .external_lex_state = 2},
  [108] = {.lex_state = 4, .external_lex_state = 2},
  [109] = {.lex_state = 2, .external_lex_state = 2},
  [110] = {.lex_state = 2, .external_lex_state = 2},
  [111] = {.lex_state = 4, .external_lex_state = 2},
  [112] = {.lex_state = 2, .external_lex_state = 2},
  [113] = {.lex_state = 2, .external_lex_state = 2},
  [114] = {.lex_state = 2, .external_lex_state = 2},
  [115] = {.lex_state = 2, .external_lex_state = 2},
  [116] = {.lex_state = 2, .external_lex_state = 2},
  [117] = {.lex_state = 4, .external_lex_state = 2},
  [118] = {.lex_state = 2, .external_lex_state = 2},
  [119] = {.lex_state = 4, .external_lex_state = 2},
  [120] = {.lex_state = 4, .external_lex_state = 2},
  [121] = {.lex_state = 4, .external_lex_state = 2},
  [122] = {.lex_state = 2, .external_lex_state = 2},
  [123] = {.lex_state = 4, .external_lex_state = 2},
  [124] = {.lex_state = 4, .external_lex_state = 2},
  [125] = {.lex_state = 4, .external_lex_state = 2},
  [126] = {.lex_state = 2, .external_lex_state = 2},
  [127] = {.lex_state = 2, .external_lex_state = 2},
  [128] = {.lex_state = 2, .external_lex_state = 2},
  [129] = {.lex_state = 4, .external_lex_state = 2},
  [130] = {.lex_state = 4, .external_lex_state = 2},
  [131] = {.lex_state = 4, .external_lex_state = 2},
  [132] = {.lex_state = 4, .external_lex_state = 2},
  [133] = {.lex_state = 4, .external_lex_state = 2},
  [134] = {.lex_state = 2, .external_lex_state = 2},
  [135] = {.lex_state = 2, .external_lex_state = 2},
  [136] = {.lex_state = 2, .external_lex_state = 2},
  [137] = {.lex_state = 11, .external_lex_state = 2},
  [138] = {.lex_state = 2, .external_lex_state = 2},
  [139] = {.lex_state = 2, .external_lex_state = 2},
  [140] = {.lex_state = 11, .external_lex_state = 2},
  [141] = {.lex_state = 2, .external_lex_state = 2},
  [142] = {.lex_state = 11, .external_lex_state = 2},
  [143] = {.lex_state = 11, .external_lex_state = 2},
  [144] = {.lex_state = 11, .external_lex_state = 2},
  [145] = {.lex_state = 2, .external_lex_state = 2},
  [146] = {.lex_state = 2, .external_lex_state = 2},
  [147] = {.lex_state = 2, .external_lex_state = 2},
  [148] = {.lex_state = 2, .external_lex_state = 2},
  [149] = {.lex_state = 2, .external_lex_state = 2},
  [150] = {.lex_state = 11, .external_lex_state = 2},
  [151] = {.lex_state = 2, .external_lex_state = 2},
  [152] = {.lex_state = 2, .external_lex_state = 2},
  [153] = {.lex_state = 2, .external_lex_state = 2},
  [154] = {.lex_state = 4, .external_lex_state = 2},
  [155] = {.lex_state = 4, .external_lex_state = 2},
  [156] = {.lex_state = 2, .external_lex_state = 2},
  [157] = {.lex_state = 2, .external_lex_state = 2},
  [158] = {.lex_state = 2, .external_lex_state = 2},
  [159] = {.lex_state = 2, .external_lex_state = 2},
  [160] = {.lex_state = 2, .external_lex_state = 2},
  [161] = {.lex_state = 2, .external_lex_state = 2},
  [162] = {.lex_state = 2, .external_lex_state = 2},
  [163] = {.lex_state = 11, .external_lex_state = 2},
  [164] = {.lex_state = 2, .external_lex_state = 2},
  [165] = {.lex_state = 2, .external_lex_state = 2},
  [166] = {.lex_state = 11, .external_lex_state = 2},
  [167] = {.lex_state = 2, .external_lex_state = 2},
  [168] = {.lex_state = 2, .external_lex_state = 2},
  [169] = {.lex_state = 11, .external_lex_state = 2},
  [170] = {.lex_state = 4, .external_lex_state = 2},
  [171] = {.lex_state = 11, .external_lex_state = 2},
  [172] = {.lex_state = 11, .external_lex_state = 2},
  [173] = {.lex_state = 11, .external_lex_state = 2},
  [174] = {.lex_state = 11, .external_lex_state = 2},
  [175] = {.lex_state = 11, .external_lex_state = 2},
  [176] = {.lex_state = 11, .external_lex_state = 2},
  [177] = {.lex_state = 4, .external_lex_state = 2},
  [178] = {.lex_state = 11, .external_lex_state = 2},
  [179] = {.lex_state = 11, .external_lex_state = 2},
  [180] = {.lex_state = 11, .external_lex_state = 2},
  [181] = {.lex_state = 4, .external_lex_state = 2},
  [182] = {.lex_state = 11, .external_lex_state = 2},
  [183] = {.lex_state = 11, .external_lex_state = 2},
  [184] = {.lex_state = 11, .external_lex_state = 2},
  [185] = {.lex_state = 11, .external_lex_state = 2},
  [186] = {.lex_state = 11, .external_lex_state = 2},
  [187] = {.lex_state = 11, .external_lex_state = 2},
  [188] = {.lex_state = 11, .external_lex_state = 2},
  [189] = {.lex_state = 11, .external_lex_state = 2},
  [190] = {.lex_state = 11, .external_lex_state = 2},
  [191] = {.lex_state = 11, .external_lex_state = 2},
  [192] = {.lex_state = 11, .external_lex_state = 2},
  [193] = {.lex_state = 11, .external_lex_state = 2},
  [194] = {.lex_state = 4, .external_lex_state = 2},
  [195] = {.lex_state = 11, .external_lex_state = 2},
  [196] = {.lex_state = 11, .external_lex_state = 2},
  [197] = {.lex_state = 11, .external_lex_state = 2},
  [198] = {.lex_state = 4, .external_lex_state = 2},
  [199] = {.lex_state = 4, .external_lex_state = 2},
  [200] = {.lex_state = 4, .external_lex_state = 2},
  [201] = {.lex_state = 11, .external_lex_state = 2},
  [202] = {.lex_state = 11, .external_lex_state = 2},
  [203] = {.lex_state = 11, .external_lex_state = 2},
  [204] = {.lex_state = 11, .external_lex_state = 2},
  [205] = {.lex_state = 4, .external_lex_state = 2},
  [206] = {.lex_state = 4, .external_lex_state = 2},
  [207] = {.lex_state = 4, .external_lex_state = 2},
  [208] = {.lex_state = 4, .external_lex_state = 2},
  [209] = {.lex_state = 11, .external_lex_state = 2},
  [210] = {.lex_state = 11, .external_lex_state = 2},
  [211] = {.lex_state = 11, .external_lex_state = 2},
  [212] = {.lex_state = 11, .external_lex_state = 2},
  [213] = {.lex_state = 11, .external_lex_state = 2},
  [214] = {.lex_state = 11, .external_lex_state = 2},
  [215] = {.lex_state = 11, .external_lex_state = 2},
  [216] = {.lex_state = 13, .external_lex_state = 2},
  [217] = {.lex_state = 13, .external_lex_state = 2},
  [218] = {.lex_state = 13, .external_lex_state = 2},
  [219] = {.lex_state = 13, .external_lex_state = 2},
  [220] = {.lex_state = 13, .external_lex_state = 2},
  [221] = {.lex_state = 13, .external_lex_state = 2},
  [222] = {.lex_state = 13, .external_lex_state = 2},
  [223] = {.lex_state = 13, .external_lex_state = 2},
  [224] = {.lex_state = 11, .external_lex_state = 2},
  [225] = {.lex_state = 13, .external_lex_state = 2},
  [226] = {.lex_state = 13, .external_lex_state = 2},
  [227] = {.lex_state = 11, .external_lex_state = 2},
  [228] = {.lex_state = 11, .external_lex_state = 2},
  [229] = {.lex_state = 11, .external_lex_state = 2},
  [230] = {.lex_state = 11, .external_lex_state = 2},
  [231] = {.lex_state = 11, .external_lex_state = 2},
  [232] = {.lex_state = 13, .external_lex_state = 2},
  [233] = {.lex_state = 13, .external_lex_state = 2},
  [234] = {.lex_state = 11, .external_lex_state = 2},
  [235] = {.lex_state = 13, .external_lex_state = 2},
  [236] = {.lex_state = 13, .external_lex_state = 2},
  [237] = {.lex_state = 11, .external_lex_state = 2},
  [238] = {.lex_state = 11, .external_lex_state = 2},
  [239] = {.lex_state = 11, .external_lex_state = 2},
  [240] = {.lex_state = 11, .external_lex_state = 2},
  [241] = {.lex_state = 11, .external_lex_state = 2},
  [242] = {.lex_state = 13, .external_lex_state = 2},
  [243] = {.lex_state = 11, .external_lex_state = 2},
  [244] = {.lex_state = 69, .external_lex_state = 2},
  [245] = {.lex_state = 11, .external_lex_state = 2},
  [246] = {.lex_state = 11, .external_lex_state = 2},
  [247] = {.lex_state = 11, .external_lex_state = 2},
  [248] = {.lex_state = 11, .external_lex_state = 2},
  [249] = {.lex_state = 11, .external_lex_state = 2},
  [250] = {.lex_state = 11, .external_lex_state = 2},
  [251] = {.lex_state = 11, .external_lex_state = 2},
  [252] = {.lex_state = 11, .external_lex_state = 2},
  [253] = {.lex_state = 11, .external_lex_state = 2},
  [254] = {.lex_state = 11, .external_lex_state = 2},
  [255] = {.lex_state = 11, .external_lex_state = 2},
  [256] = {.lex_state = 11, .external_lex_state = 2},
  [257] = {.lex_state = 69, .external_lex_state = 2},
  [258] = {.lex_state = 11, .external_lex_state = 2},
  [259] = {.lex_state = 11, .external_lex_state = 2},
  [260] = {.lex_state = 11, .external_lex_state = 2},
  [261] = {.lex_state = 11, .external_lex_state = 2},
  [262] = {.lex_state = 11, .external_lex_state = 2},
  [263] = {.lex_state = 11, .external_lex_state = 2},
  [264] = {.lex_state = 11, .external_lex_state = 2},
  [265] = {.lex_state = 11, .external_lex_state = 2},
  [266] = {.lex_state = 11, .external_lex_state = 2},
  [267] = {.lex_state = 11, .external_lex_state = 2},
  [268] = {.lex_state = 11, .external_lex_state = 2},
  [269] = {.lex_state = 11, .external_lex_state = 2},
  [270] = {.lex_state = 11, .external_lex_state = 2},
  [271] = {.lex_state = 11, .external_lex_state = 2},
  [272] = {.lex_state = 11, .external_lex_state = 2},
  [273] = {.lex_state = 11, .external_lex_state = 2},
  [274] = {.lex_state = 11, .external_lex_state = 2},
  [275] = {.lex_state = 11, .external_lex_state = 2},
  [276] = {.lex_state = 11, .external_lex_state = 2},
  [277] = {.lex_state = 11, .external_lex_state = 2},
  [278] = {.lex_state = 11, .external_lex_state = 2},
  [279] = {.lex_state = 11, .external_lex_state = 2},
  [280] = {.lex_state = 11, .external_lex_state = 2},
  [281] = {.lex_state = 11, .external_lex_state = 2},
  [282] = {.lex_state = 11, .external_lex_state = 2},
  [283] = {.lex_state = 11, .external_lex_state = 2},
  [284] = {.lex_state = 11, .external_lex_state = 2},
  [285] = {.lex_state = 11, .external_lex_state = 2},
  [286] = {.lex_state = 11, .external_lex_state = 2},
  [287] = {.lex_state = 11, .external_lex_state = 2},
  [288] = {.lex_state = 11, .external_lex_state = 2},
  [289] = {.lex_state = 11, .external_lex_state = 2},
  [290] = {.lex_state = 11, .external_lex_state = 2},
  [291] = {.lex_state = 11, .external_lex_state = 2},
  [292] = {.lex_state = 11, .external_lex_state = 2},
  [293] = {.lex_state = 11, .external_lex_state = 2},
  [294] = {.lex_state = 11, .external_lex_state = 2},
  [295] = {.lex_state = 11, .external_lex_state = 2},
  [296] = {.lex_state = 11, .external_lex_state = 2},
  [297] = {.lex_state = 11, .external_lex_state = 2},
  [298] = {.lex_state = 11, .external_lex_state = 2},
  [299] = {.lex_state = 11, .external_lex_state = 2},
  [300] = {.lex_state = 11, .external_lex_state = 2},
  [301] = {.lex_state = 11, .external_lex_state = 2},
  [302] = {.lex_state = 11, .external_lex_state = 2},
  [303] = {.lex_state = 11, .external_lex_state = 2},
  [304] = {.lex_state = 11, .external_lex_state = 2},
  [305] = {.lex_state = 11, .external_lex_state = 2},
  [306] = {.lex_state = 11, .external_lex_state = 2},
  [307] = {.lex_state = 11, .external_lex_state = 2},
  [308] = {.lex_state = 11, .external_lex_state = 2},
  [309] = {.lex_state = 11, .external_lex_state = 2},
  [310] = {.lex_state = 11, .external_lex_state = 2},
  [311] = {.lex_state = 69, .external_lex_state = 2},
  [312] = {.lex_state = 11, .external_lex_state = 2},
  [313] = {.lex_state = 11, .external_lex_state = 2},
  [314] = {.lex_state = 11, .external_lex_state = 2},
  [315] = {.lex_state = 11, .external_lex_state = 2},
  [316] = {.lex_state = 11, .external_lex_state = 2},
  [317] = {.lex_state = 11, .external_lex_state = 2},
  [318] = {.lex_state = 11, .external_lex_state = 2},
  [319] = {.lex_state = 11, .external_lex_state = 2},
  [320] = {.lex_state = 11, .external_lex_state = 2},
  [321] = {.lex_state = 11, .external_lex_state = 2},
  [322] = {.lex_state = 11, .external_lex_state = 2},
  [323] = {.lex_state = 11, .external_lex_state = 2},
  [324] = {.lex_state = 11, .external_lex_state = 2},
  [325] = {.lex_state = 11, .external_lex_state = 2},
  [326] = {.lex_state = 11, .external_lex_state = 2},
  [327] = {.lex_state = 11, .external_lex_state = 2},
  [328] = {.lex_state = 11, .external_lex_state = 2},
  [329] = {.lex_state = 11, .external_lex_state = 2},
  [330] = {.lex_state = 11, .external_lex_state = 2},
  [331] = {.lex_state = 11, .external_lex_state = 2},
  [332] = {.lex_state = 11, .external_lex_state = 2},
  [333] = {.lex_state = 11, .external_lex_state = 2},
  [334] = {.lex_state = 11, .external_lex_state = 2},
  [335] = {.lex_state = 11, .external_lex_state = 2},
  [336] = {.lex_state = 11, .external_lex_state = 2},
  [337] = {.lex_state = 11, .external_lex_state = 2},
  [338] = {.lex_state = 11, .external_lex_state = 2},
  [339] = {.lex_state = 11, .external_lex_state = 2},
  [340] = {.lex_state = 11, .external_lex_state = 2},
  [341] = {.lex_state = 11, .external_lex_state = 2},
  [342] = {.lex_state = 11, .external_lex_state = 2},
  [343] = {.lex_state = 11, .external_lex_state = 2},
  [344] = {.lex_state = 11, .external_lex_state = 2},
  [345] = {.lex_state = 11, .external_lex_state = 2},
  [346] = {.lex_state = 11, .external_lex_state = 2},
  [347] = {.lex_state = 11, .external_lex_state = 2},
  [348] = {.lex_state = 11, .external_lex_state = 2},
  [349] = {.lex_state = 11, .external_lex_state = 2},
  [350] = {.lex_state = 11, .external_lex_state = 2},
  [351] = {.lex_state = 11, .external_lex_state = 2},
  [352] = {.lex_state = 69, .external_lex_state = 2},
  [353] = {.lex_state = 11, .external_lex_state = 2},
  [354] = {.lex_state = 11, .external_lex_state = 2},
  [355] = {.lex_state = 11, .external_lex_state = 2},
  [356] = {.lex_state = 11, .external_lex_state = 2},
  [357] = {.lex_state = 11, .external_lex_state = 2},
  [358] = {.lex_state = 11, .external_lex_state = 2},
  [359] = {.lex_state = 11, .external_lex_state = 2},
  [360] = {.lex_state = 11, .external_lex_state = 2},
  [361] = {.lex_state = 69, .external_lex_state = 2},
  [362] = {.lex_state = 11, .external_lex_state = 2},
  [363] = {.lex_state = 11, .external_lex_state = 2},
  [364] = {.lex_state = 11, .external_lex_state = 2},
  [365] = {.lex_state = 11, .external_lex_state = 2},
  [366] = {.lex_state = 11, .external_lex_state = 2},
  [367] = {.lex_state = 11, .external_lex_state = 2},
  [368] = {.lex_state = 69, .external_lex_state = 2},
  [369] = {.lex_state = 11, .external_lex_state = 2},
  [370] = {.lex_state = 11, .external_lex_state = 2},
  [371] = {.lex_state = 69, .external_lex_state = 2},
  [372] = {.lex_state = 69, .external_lex_state = 2},
  [373] = {.lex_state = 69, .external_lex_state = 2},
  [374] = {.lex_state = 12, .external_lex_state = 2},
  [375] = {.lex_state = 12, .external_lex_state = 2},
  [376] = {.lex_state = 69, .external_lex_state = 2},
  [377] = {.lex_state = 69, .external_lex_state = 2},
  [378] = {.lex_state = 69, .external_lex_state = 2},
  [379] = {.lex_state = 69, .external_lex_state = 2},
  [380] = {.lex_state = 69, .external_lex_state = 2},
  [381] = {.lex_state = 69, .external_lex_state = 2},
  [382] = {.lex_state = 12, .external_lex_state = 2},
  [383] = {.lex_state = 12, .external_lex_state = 2},
  [384] = {.lex_state = 12, .external_lex_state = 2},
  [385] = {.lex_state = 69, .external_lex_state = 2},
  [386] = {.lex_state = 69, .external_lex_state = 2},
  [387] = {.lex_state = 69, .external_lex_state = 2},
  [388] = {.lex_state = 12, .external_lex_state = 2},
  [389] = {.lex_state = 69, .external_lex_state = 2},
  [390] = {.lex_state = 69, .external_lex_state = 2},
  [391] = {.lex_state = 69, .external_lex_state = 2},
  [392] = {.lex_state = 69, .external_lex_state = 2},
  [393] = {.lex_state = 69, .external_lex_state = 2},
  [394] = {.lex_state = 69, .external_lex_state = 2},
  [395] = {.lex_state = 69, .external_lex_state = 2},
  [396] = {.lex_state = 69, .external_lex_state = 2},
  [397] = {.lex_state = 69, .external_lex_state = 2},
  [398] = {.lex_state = 69, .external_lex_state = 2},
  [399] = {.lex_state = 69, .external_lex_state = 2},
  [400] = {.lex_state = 12, .external_lex_state = 2},
  [401] = {.lex_state = 12, .external_lex_state = 2},
  [402] = {.lex_state = 12, .external_lex_state = 2},
  [403] = {.lex_state = 69, .external_lex_state = 2},
  [404] = {.lex_state = 12, .external_lex_state = 2},
  [405] = {.lex_state = 12, .external_lex_state = 2},
  [406] = {.lex_state = 12, .external_lex_state = 2},
  [407] = {.lex_state = 12, .external_lex_state = 2},
  [408] = {.lex_state = 12, .external_lex_state = 2},
  [409] = {.lex_state = 12, .external_lex_state = 2},
  [410] = {.lex_state = 12, .external_lex_state = 2},
  [411] = {.lex_state = 11, .external_lex_state = 2},
  [412] = {.lex_state = 11, .external_lex_state = 2},
  [413] = {.lex_state = 11, .external_lex_state = 2},
  [414] = {.lex_state = 12, .external_lex_state = 2},
  [415] = {.lex_state = 12, .external_lex_state = 2},
  [416] = {.lex_state = 12, .external_lex_state = 2},
  [417] = {.lex_state = 12, .external_lex_state = 2},
  [418] = {.lex_state = 11, .external_lex_state = 2},
  [419] = {.lex_state = 11, .external_lex_state = 2},
  [420] = {.lex_state = 11, .external_lex_state = 2},
  [421] = {.lex_state = 11, .external_lex_state = 2},
  [422] = {.lex_state = 11, .external_lex_state = 2},
  [423] = {.lex_state = 11, .external_lex_state = 2},
  [424] = {.lex_state = 11, .external_lex_state = 2},
  [425] = {.lex_state = 11, .external_lex_state = 2},
  [426] = {.lex_state = 11, .external_lex_state = 2},
  [427] = {.lex_state = 11, .external_lex_state = 2},
  [428] = {.lex_state = 11, .external_lex_state = 2},
  [429] = {.lex_state = 3, .external_lex_state = 2},
  [430] = {.lex_state = 5, .external_lex_state = 2},
  [431] = {.lex_state = 13, .external_lex_state = 2},
  [432] = {.lex_state = 13, .external_lex_state = 2},
  [433] = {.lex_state = 11, .external_lex_state = 2},
  [434] = {.lex_state = 11, .external_lex_state = 2},
  [435] = {.lex_state = 11, .external_lex_state = 2},
  [436] = {.lex_state = 11, .external_lex_state = 2},
  [437] = {.lex_state = 11, .external_lex_state = 2},
  [438] = {.lex_state = 11, .external_lex_state = 2},
  [439] = {.lex_state = 11, .external_lex_state = 2},
  [440] = {.lex_state = 11, .external_lex_state = 2},
  [441] = {.lex_state = 11, .external_lex_state = 2},
  [442] = {.lex_state = 11, .external_lex_state = 2},
  [443] = {.lex_state = 11, .external_lex_state = 2},
  [444] = {.lex_state = 11, .external_lex_state = 2},
  [445] = {.lex_state = 11, .external_lex_state = 2},
  [446] = {.lex_state = 3, .external_lex_state = 2},
  [447] = {.lex_state = 3, .external_lex_state = 2},
  [448] = {.lex_state = 3, .external_lex_state = 2},
  [449] = {.lex_state = 3, .external_lex_state = 2},
  [450] = {.lex_state = 3, .external_lex_state = 2},
  [451] = {.lex_state = 3, .external_lex_state = 2},
  [452] = {.lex_state = 3, .external_lex_state = 2},
  [453] = {.lex_state = 3, .external_lex_state = 2},
  [454] = {.lex_state = 11, .external_lex_state = 2},
  [455] = {.lex_state = 3, .external_lex_state = 2},
  [456] = {.lex_state = 3, .external_lex_state = 2},
  [457] = {.lex_state = 11, .external_lex_state = 2},
  [458] = {.lex_state = 3, .external_lex_state = 2},
  [459] = {.lex_state = 3, .external_lex_state = 2},
  [460] = {.lex_state = 11, .external_lex_state = 2},
  [461] = {.lex_state = 3, .external_lex_state = 2},
  [462] = {.lex_state = 3, .external_lex_state = 2},
  [463] = {.lex_state = 3, .external_lex_state = 2},
  [464] = {.lex_state = 3, .external_lex_state = 2},
  [465] = {.lex_state = 3, .external_lex_state = 2},
  [466] = {.lex_state = 3, .external_lex_state = 2},
  [467] = {.lex_state = 3, .external_lex_state = 2},
  [468] = {.lex_state = 3, .external_lex_state = 2},
  [469] = {.lex_state = 3, .external_lex_state = 2},
  [470] = {.lex_state = 3, .external_lex_state = 2},
  [471] = {.lex_state = 11, .external_lex_state = 2},
  [472] = {.lex_state = 3, .external_lex_state = 2},
  [473] = {.lex_state = 3, .external_lex_state = 2},
  [474] = {.lex_state = 3, .external_lex_state = 2},
  [475] = {.lex_state = 11, .external_lex_state = 2},
  [476] = {.lex_state = 11, .external_lex_state = 2},
  [477] = {.lex_state = 11, .external_lex_state = 2},
  [478] = {.lex_state = 11, .external_lex_state = 2},
  [479] = {.lex_state = 71, .external_lex_state = 2},
  [480] = {.lex_state = 71, .external_lex_state = 2},
  [481] = {.lex_state = 71, .external_lex_state = 2},
  [482] = {.lex_state = 71, .external_lex_state = 2},
  [483] = {.lex_state = 71, .external_lex_state = 2},
  [484] = {.lex_state = 71, .external_lex_state = 2},
  [485] = {.lex_state = 71, .external_lex_state = 2},
  [486] = {.lex_state = 71, .external_lex_state = 2},
  [487] = {.lex_state = 71, .external_lex_state = 2},
  [488] = {.lex_state = 71, .external_lex_state = 2},
  [489] = {.lex_state = 71, .external_lex_state = 2},
  [490] = {.lex_state = 71, .external_lex_state = 2},
  [491] = {.lex_state = 71, .external_lex_state = 2},
  [492] = {.lex_state = 71, .external_lex_state = 2},
  [493] = {.lex_state = 71, .external_lex_state = 2},
  [494] = {.lex_state = 71, .external_lex_state = 2},
  [495] = {.lex_state = 71, .external_lex_state = 2},
  [496] = {.lex_state = 71, .external_lex_state = 2},
  [497] = {.lex_state = 71, .external_lex_state = 2},
  [498] = {.lex_state = 71, .external_lex_state = 2},
  [499] = {.lex_state = 71, .external_lex_state = 2},
  [500] = {.lex_state = 71, .external_lex_state = 2},
  [501] = {.lex_state = 71, .external_lex_state = 2},
  [502] = {.lex_state = 71, .external_lex_state = 2},
  [503] = {.lex_state = 71, .external_lex_state = 2},
  [504] = {.lex_state = 71, .external_lex_state = 2},
  [505] = {.lex_state = 71, .external_lex_state = 2},
  [506] = {.lex_state = 11, .external_lex_state = 2},
  [507] = {.lex_state = 71, .external_lex_state = 2},
  [508] = {.lex_state = 71, .external_lex_state = 2},
  [509] = {.lex_state = 71, .external_lex_state = 2},
  [510] = {.lex_state = 71, .external_lex_state = 2},
  [511] = {.lex_state = 71, .external_lex_state = 2},
  [512] = {.lex_state = 71, .external_lex_state = 2},
  [513] = {.lex_state = 71, .external_lex_state = 2},
  [514] = {.lex_state = 71, .external_lex_state = 2},
  [515] = {.lex_state = 71, .external_lex_state = 2},
  [516] = {.lex_state = 71, .external_lex_state = 2},
  [517] = {.lex_state = 71, .external_lex_state = 2},
  [518] = {.lex_state = 71, .external_lex_state = 2},
  [519] = {.lex_state = 71, .external_lex_state = 2},
  [520] = {.lex_state = 71, .external_lex_state = 2},
  [521] = {.lex_state = 71, .external_lex_state = 2},
  [522] = {.lex_state = 71, .external_lex_state = 2},
  [523] = {.lex_state = 71, .external_lex_state = 2},
  [524] = {.lex_state = 71, .external_lex_state = 2},
  [525] = {.lex_state = 71, .external_lex_state = 2},
  [526] = {.lex_state = 71, .external_lex_state = 2},
  [527] = {.lex_state = 71, .external_lex_state = 2},
  [528] = {.lex_state = 10},
  [529] = {.lex_state = 71, .external_lex_state = 2},
  [530] = {.lex_state = 71, .external_lex_state = 2},
  [531] = {.lex_state = 71, .external_lex_state = 2},
  [532] = {.lex_state = 71, .external_lex_state = 2},
  [533] = {.lex_state = 71, .external_lex_state = 2},
  [534] = {.lex_state = 71, .external_lex_state = 2},
  [535] = {.lex_state = 71, .external_lex_state = 2},
  [536] = {.lex_state = 71, .external_lex_state = 2},
  [537] = {.lex_state = 71, .external_lex_state = 2},
  [538] = {.lex_state = 71, .external_lex_state = 2},
  [539] = {.lex_state = 71, .external_lex_state = 2},
  [540] = {.lex_state = 71, .external_lex_state = 2},
  [541] = {.lex_state = 71, .external_lex_state = 2},
  [542] = {.lex_state = 71, .external_lex_state = 2},
  [543] = {.lex_state = 71, .external_lex_state = 2},
  [544] = {.lex_state = 71, .external_lex_state = 2},
  [545] = {.lex_state = 71, .external_lex_state = 2},
  [546] = {.lex_state = 71, .external_lex_state = 2},
  [547] = {.lex_state = 71, .external_lex_state = 2},
  [548] = {.lex_state = 71, .external_lex_state = 2},
  [549] = {.lex_state = 71, .external_lex_state = 2},
  [550] = {.lex_state = 71, .external_lex_state = 2},
  [551] = {.lex_state = 71, .external_lex_state = 2},
  [552] = {.lex_state = 71, .external_lex_state = 2},
  [553] = {.lex_state = 71, .external_lex_state = 2},
  [554] = {.lex_state = 71, .external_lex_state = 2},
  [555] = {.lex_state = 71, .external_lex_state = 2},
  [556] = {.lex_state = 71, .external_lex_state = 2},
  [557] = {.lex_state = 71, .external_lex_state = 2},
  [558] = {.lex_state = 71, .external_lex_state = 2},
  [559] = {.lex_state = 71, .external_lex_state = 2},
  [560] = {.lex_state = 71, .external_lex_state = 2},
  [561] = {.lex_state = 71, .external_lex_state = 2},
  [562] = {.lex_state = 71, .external_lex_state = 2},
  [563] = {.lex_state = 71, .external_lex_state = 2},
  [564] = {.lex_state = 71, .external_lex_state = 2},
  [565] = {.lex_state = 71, .external_lex_state = 2},
  [566] = {.lex_state = 71, .external_lex_state = 2},
  [567] = {.lex_state = 71, .external_lex_state = 2},
  [568] = {.lex_state = 71, .external_lex_state = 2},
  [569] = {.lex_state = 71, .external_lex_state = 2},
  [570] = {.lex_state = 71, .external_lex_state = 2},
  [571] = {.lex_state = 71, .external_lex_state = 2},
  [572] = {.lex_state = 71, .external_lex_state = 2},
  [573] = {.lex_state = 71, .external_lex_state = 2},
  [574] = {.lex_state = 71, .external_lex_state = 2},
  [575] = {.lex_state = 71, .external_lex_state = 2},
  [576] = {.lex_state = 71, .external_lex_state = 2},
  [577] = {.lex_state = 71, .external_lex_state = 2},
  [578] = {.lex_state = 71, .external_lex_state = 2},
  [579] = {.lex_state = 71, .external_lex_state = 2},
  [580] = {.lex_state = 71, .external_lex_state = 2},
  [581] = {.lex_state = 71, .external_lex_state = 2},
  [582] = {.lex_state = 71, .external_lex_state = 2},
  [583] = {.lex_state = 71, .external_lex_state = 2},
  [584] = {.lex_state = 71, .external_lex_state = 2},
  [585] = {.lex_state = 71, .external_lex_state = 2},
  [586] = {.lex_state = 71, .external_lex_state = 2},
  [587] = {.lex_state = 71, .external_lex_state = 2},
  [588] = {.lex_state = 71, .external_lex_state = 2},
  [589] = {.lex_state = 71, .external_lex_state = 2},
  [590] = {.lex_state = 71, .external_lex_state = 2},
  [591] = {.lex_state = 71, .external_lex_state = 2},
  [592] = {.lex_state = 71, .external_lex_state = 2},
  [593] = {.lex_state = 71, .external_lex_state = 2},
  [594] = {.lex_state = 71, .external_lex_state = 2},
  [595] = {.lex_state = 71, .external_lex_state = 2},
  [596] = {.lex_state = 71, .external_lex_state = 2},
  [597] = {.lex_state = 71, .external_lex_state = 2},
  [598] = {.lex_state = 71, .external_lex_state = 2},
  [599] = {.lex_state = 71, .external_lex_state = 2},
  [600] = {.lex_state = 71, .external_lex_state = 2},
  [601] = {.lex_state = 71, .external_lex_state = 2},
  [602] = {.lex_state = 71, .external_lex_state = 2},
  [603] = {.lex_state = 71, .external_lex_state = 2},
  [604] = {.lex_state = 71, .external_lex_state = 2},
  [605] = {.lex_state = 71, .external_lex_state = 2},
  [606] = {.lex_state = 71, .external_lex_state = 2},
  [607] = {.lex_state = 71, .external_lex_state = 2},
  [608] = {.lex_state = 71, .external_lex_state = 2},
  [609] = {.lex_state = 71, .external_lex_state = 2},
  [610] = {.lex_state = 71, .external_lex_state = 2},
  [611] = {.lex_state = 71, .external_lex_state = 2},
  [612] = {.lex_state = 71, .external_lex_state = 2},
  [613] = {.lex_state = 71, .external_lex_state = 2},
  [614] = {.lex_state = 71, .external_lex_state = 2},
  [615] = {.lex_state = 71, .external_lex_state = 2},
  [616] = {.lex_state = 71, .external_lex_state = 2},
  [617] = {.lex_state = 71, .external_lex_state = 2},
  [618] = {.lex_state = 71, .external_lex_state = 2},
  [619] = {.lex_state = 71, .external_lex_state = 2},
  [620] = {.lex_state = 71, .external_lex_state = 2},
  [621] = {.lex_state = 71, .external_lex_state = 2},
  [622] = {.lex_state = 71, .external_lex_state = 2},
  [623] = {.lex_state = 71, .external_lex_state = 2},
  [624] = {.lex_state = 71, .external_lex_state = 2},
  [625] = {.lex_state = 71, .external_lex_state = 2},
  [626] = {.lex_state = 71, .external_lex_state = 2},
  [627] = {.lex_state = 71, .external_lex_state = 2},
  [628] = {.lex_state = 10},
  [629] = {.lex_state = 71, .external_lex_state = 2},
  [630] = {.lex_state = 71, .external_lex_state = 2},
  [631] = {.lex_state = 71, .external_lex_state = 2},
  [632] = {.lex_state = 71, .external_lex_state = 2},
  [633] = {.lex_state = 71, .external_lex_state = 2},
  [634] = {.lex_state = 71, .external_lex_state = 2},
  [635] = {.lex_state = 71, .external_lex_state = 2},
  [636] = {.lex_state = 71, .external_lex_state = 2},
  [637] = {.lex_state = 71, .external_lex_state = 2},
  [638] = {.lex_state = 71, .external_lex_state = 2},
  [639] = {.lex_state = 71, .external_lex_state = 2},
  [640] = {.lex_state = 71, .external_lex_state = 2},
  [641] = {.lex_state = 71, .external_lex_state = 2},
  [642] = {.lex_state = 71, .external_lex_state = 2},
  [643] = {.lex_state = 71, .external_lex_state = 2},
  [644] = {.lex_state = 71, .external_lex_state = 2},
  [645] = {.lex_state = 71, .external_lex_state = 2},
  [646] = {.lex_state = 71, .external_lex_state = 2},
  [647] = {.lex_state = 71, .external_lex_state = 2},
  [648] = {.lex_state = 71, .external_lex_state = 2},
  [649] = {.lex_state = 71, .external_lex_state = 2},
  [650] = {.lex_state = 71, .external_lex_state = 2},
  [651] = {.lex_state = 71, .external_lex_state = 2},
  [652] = {.lex_state = 71, .external_lex_state = 2},
  [653] = {.lex_state = 71, .external_lex_state = 2},
  [654] = {.lex_state = 71, .external_lex_state = 2},
  [655] = {.lex_state = 71, .external_lex_state = 2},
  [656] = {.lex_state = 71, .external_lex_state = 2},
  [657] = {.lex_state = 71, .external_lex_state = 2},
  [658] = {.lex_state = 71, .external_lex_state = 2},
  [659] = {.lex_state = 71, .external_lex_state = 2},
  [660] = {.lex_state = 71, .external_lex_state = 2},
  [661] = {.lex_state = 71, .external_lex_state = 2},
  [662] = {.lex_state = 71, .external_lex_state = 2},
  [663] = {.lex_state = 71, .external_lex_state = 2},
  [664] = {.lex_state = 71, .external_lex_state = 2},
  [665] = {.lex_state = 71, .external_lex_state = 2},
  [666] = {.lex_state = 71, .external_lex_state = 2},
  [667] = {.lex_state = 10},
  [668] = {.lex_state = 71, .external_lex_state = 2},
  [669] = {.lex_state = 71, .external_lex_state = 2},
  [670] = {.lex_state = 71, .external_lex_state = 2},
  [671] = {.lex_state = 71, .external_lex_state = 2},
  [672] = {.lex_state = 71, .external_lex_state = 2},
  [673] = {.lex_state = 71, .external_lex_state = 2},
  [674] = {.lex_state = 71, .external_lex_state = 2},
  [675] = {.lex_state = 71, .external_lex_state = 2},
  [676] = {.lex_state = 71, .external_lex_state = 2},
  [677] = {.lex_state = 71, .external_lex_state = 2},
  [678] = {.lex_state = 71, .external_lex_state = 2},
  [679] = {.lex_state = 71, .external_lex_state = 2},
  [680] = {.lex_state = 71, .external_lex_state = 2},
  [681] = {.lex_state = 71, .external_lex_state = 2},
  [682] = {.lex_state = 71, .external_lex_state = 2},
  [683] = {.lex_state = 71, .external_lex_state = 2},
  [684] = {.lex_state = 71, .external_lex_state = 2},
  [685] = {.lex_state = 71, .external_lex_state = 2},
  [686] = {.lex_state = 71, .external_lex_state = 2},
  [687] = {.lex_state = 71, .external_lex_state = 2},
  [688] = {.lex_state = 71, .external_lex_state = 2},
  [689] = {.lex_state = 71, .external_lex_state = 2},
  [690] = {.lex_state = 71, .external_lex_state = 2},
  [691] = {.lex_state = 71, .external_lex_state = 2},
  [692] = {.lex_state = 71, .external_lex_state = 2},
  [693] = {.lex_state = 71, .external_lex_state = 2},
  [694] = {.lex_state = 71, .external_lex_state = 2},
  [695] = {.lex_state = 71, .external_lex_state = 2},
  [696] = {.lex_state = 71, .external_lex_state = 2},
  [697] = {.lex_state = 71, .external_lex_state = 2},
  [698] = {.lex_state = 71, .external_lex_state = 2},
  [699] = {.lex_state = 71, .external_lex_state = 2},
  [700] = {.lex_state = 71, .external_lex_state = 2},
  [701] = {.lex_state = 71, .external_lex_state = 2},
  [702] = {.lex_state = 71, .external_lex_state = 2},
  [703] = {.lex_state = 71, .external_lex_state = 2},
  [704] = {.lex_state = 71, .external_lex_state = 2},
  [705] = {.lex_state = 71, .external_lex_state = 2},
  [706] = {.lex_state = 10},
  [707] = {.lex_state = 71, .external_lex_state = 2},
  [708] = {.lex_state = 71, .external_lex_state = 2},
  [709] = {.lex_state = 71, .external_lex_state = 2},
  [710] = {.lex_state = 71, .external_lex_state = 2},
  [711] = {.lex_state = 71, .external_lex_state = 2},
  [712] = {.lex_state = 71, .external_lex_state = 2},
  [713] = {.lex_state = 71, .external_lex_state = 2},
  [714] = {.lex_state = 71, .external_lex_state = 2},
  [715] = {.lex_state = 71, .external_lex_state = 2},
  [716] = {.lex_state = 71, .external_lex_state = 2},
  [717] = {.lex_state = 71, .external_lex_state = 2},
  [718] = {.lex_state = 71, .external_lex_state = 2},
  [719] = {.lex_state = 71, .external_lex_state = 2},
  [720] = {.lex_state = 71, .external_lex_state = 2},
  [721] = {.lex_state = 71, .external_lex_state = 2},
  [722] = {.lex_state = 71, .external_lex_state = 2},
  [723] = {.lex_state = 10},
  [724] = {.lex_state = 71, .external_lex_state = 2},
  [725] = {.lex_state = 71, .external_lex_state = 2},
  [726] = {.lex_state = 71, .external_lex_state = 2},
  [727] = {.lex_state = 71, .external_lex_state = 2},
  [728] = {.lex_state = 71, .external_lex_state = 2},
  [729] = {.lex_state = 71, .external_lex_state = 2},
  [730] = {.lex_state = 71, .external_lex_state = 2},
  [731] = {.lex_state = 71, .external_lex_state = 2},
  [732] = {.lex_state = 71, .external_lex_state = 2},
  [733] = {.lex_state = 71, .external_lex_state = 2},
  [734] = {.lex_state = 71, .external_lex_state = 2},
  [735] = {.lex_state = 71, .external_lex_state = 2},
  [736] = {.lex_state = 71, .external_lex_state = 2},
  [737] = {.lex_state = 71, .external_lex_state = 2},
  [738] = {.lex_state = 71, .external_lex_state = 2},
  [739] = {.lex_state = 71, .external_lex_state = 2},
  [740] = {.lex_state = 71, .external_lex_state = 2},
  [741] = {.lex_state = 71, .external_lex_state = 2},
  [742] = {.lex_state = 71, .external_lex_state = 2},
  [743] = {.lex_state = 71, .external_lex_state = 2},
  [744] = {.lex_state = 71, .external_lex_state = 2},
  [745] = {.lex_state = 71, .external_lex_state = 2},
  [746] = {.lex_state = 71, .external_lex_state = 2},
  [747] = {.lex_state = 71, .external_lex_state = 2},
  [748] = {.lex_state = 71, .external_lex_state = 2},
  [749] = {.lex_state = 71, .external_lex_state = 2},
  [750] = {.lex_state = 71, .external_lex_state = 2},
  [751] = {.lex_state = 71, .external_lex_state = 2},
  [752] = {.lex_state = 71, .external_lex_state = 2},
  [753] = {.lex_state = 71, .external_lex_state = 2},
  [754] = {.lex_state = 11, .external_lex_state = 2},
  [755] = {.lex_state = 11, .external_lex_state = 2},
  [756] = {.lex_state = 11, .external_lex_state = 2},
  [757] = {.lex_state = 11, .external_lex_state = 2},
  [758] = {.lex_state = 11, .external_lex_state = 2},
  [759] = {.lex_state = 11, .external_lex_state = 2},
  [760] = {.lex_state = 11, .external_lex_state = 2},
  [761] = {.lex_state = 11, .external_lex_state = 2},
  [762] = {.lex_state = 14},
  [763] = {.lex_state = 14},
  [764] = {.lex_state = 11, .external_lex_state = 2},
  [765] = {.lex_state = 14},
  [766] = {.lex_state = 14},
  [767] = {.lex_state = 14},
  [768] = {.lex_state = 14},
  [769] = {.lex_state = 14},
  [770] = {.lex_state = 14},
  [771] = {.lex_state = 14},
  [772] = {.lex_state = 11, .external_lex_state = 2},
  [773] = {.lex_state = 14},
  [774] = {.lex_state = 11, .external_lex_state = 2},
  [775] = {.lex_state = 11, .external_lex_state = 2},
  [776] = {.lex_state = 11, .external_lex_state = 2},
  [777] = {.lex_state = 11, .external_lex_state = 2},
  [778] = {.lex_state = 14},
  [779] = {.lex_state = 11, .external_lex_state = 2},
  [780] = {.lex_state = 11, .external_lex_state = 2},
  [781] = {.lex_state = 11, .external_lex_state = 2},
  [782] = {.lex_state = 11, .external_lex_state = 2},
  [783] = {.lex_state = 11, .external_lex_state = 2},
  [784] = {.lex_state = 11, .external_lex_state = 2},
  [785] = {.lex_state = 11, .external_lex_state = 2},
  [786] = {.lex_state = 11, .external_lex_state = 2},
  [787] = {.lex_state = 11, .external_lex_state = 2},
  [788] = {.lex_state = 12, .external_lex_state = 2},
  [789] = {.lex_state = 11, .external_lex_state = 2},
  [790] = {.lex_state = 11, .external_lex_state = 2},
  [791] = {.lex_state = 11, .external_lex_state = 2},
  [792] = {.lex_state = 11, .external_lex_state = 2},
  [793] = {.lex_state = 11, .external_lex_state = 2},
  [794] = {.lex_state = 11, .external_lex_state = 2},
  [795] = {.lex_state = 11, .external_lex_state = 2},
  [796] = {.lex_state = 11, .external_lex_state = 2},
  [797] = {.lex_state = 11, .external_lex_state = 2},
  [798] = {.lex_state = 11, .external_lex_state = 2},
  [799] = {.lex_state = 11, .external_lex_state = 2},
  [800] = {.lex_state = 11, .external_lex_state = 2},
  [801] = {.lex_state = 11, .external_lex_state = 2},
  [802] = {.lex_state = 11, .external_lex_state = 2},
  [803] = {.lex_state = 11, .external_lex_state = 2},
  [804] = {.lex_state = 11, .external_lex_state = 2},
  [805] = {.lex_state = 11, .external_lex_state = 2},
  [806] = {.lex_state = 11, .external_lex_state = 2},
  [807] = {.lex_state = 11, .external_lex_state = 2},
  [808] = {.lex_state = 11, .external_lex_state = 2},
  [809] = {.lex_state = 11, .external_lex_state = 2},
  [810] = {.lex_state = 11, .external_lex_state = 2},
  [811] = {.lex_state = 11, .external_lex_state = 2},
  [812] = {.lex_state = 11, .external_lex_state = 2},
  [813] = {.lex_state = 11, .external_lex_state = 2},
  [814] = {.lex_state = 11, .external_lex_state = 2},
  [815] = {.lex_state = 11, .external_lex_state = 2},
  [816] = {.lex_state = 11, .external_lex_state = 2},
  [817] = {.lex_state = 11, .external_lex_state = 2},
  [818] = {.lex_state = 11, .external_lex_state = 2},
  [819] = {.lex_state = 11, .external_lex_state = 2},
  [820] = {.lex_state = 11, .external_lex_state = 2},
  [821] = {.lex_state = 11, .external_lex_state = 2},
  [822] = {.lex_state = 11, .external_lex_state = 2},
  [823] = {.lex_state = 11, .external_lex_state = 2},
  [824] = {.lex_state = 11, .external_lex_state = 2},
  [825] = {.lex_state = 11, .external_lex_state = 2},
  [826] = {.lex_state = 11, .external_lex_state = 2},
  [827] = {.lex_state = 11, .external_lex_state = 2},
  [828] = {.lex_state = 11, .external_lex_state = 2},
  [829] = {.lex_state = 14},
  [830] = {.lex_state = 14},
  [831] = {.lex_state = 14},
  [832] = {.lex_state = 14},
  [833] = {.lex_state = 14},
  [834] = {.lex_state = 14},
  [835] = {.lex_state = 14},
  [836] = {.lex_state = 14},
  [837] = {.lex_state = 14},
  [838] = {.lex_state = 14},
  [839] = {.lex_state = 14},
  [840] = {.lex_state = 14},
  [841] = {.lex_state = 14},
  [842] = {.lex_state = 14},
  [843] = {.lex_state = 14},
  [844] = {.lex_state = 14},
  [845] = {.lex_state = 14},
  [846] = {.lex_state = 14},
  [847] = {.lex_state = 14},
  [848] = {.lex_state = 14},
  [849] = {.lex_state = 14},
  [850] = {.lex_state = 14},
  [851] = {.lex_state = 14},
  [852] = {.lex_state = 14},
  [853] = {.lex_state = 14},
  [854] = {.lex_state = 14},
  [855] = {.lex_state = 14},
  [856] = {.lex_state = 14},
  [857] = {.lex_state = 14},
  [858] = {.lex_state = 14},
  [859] = {.lex_state = 14},
  [860] = {.lex_state = 14},
  [861] = {.lex_state = 14},
  [862] = {.lex_state = 14},
  [863] = {.lex_state = 14},
  [864] = {.lex_state = 14},
  [865] = {.lex_state = 14},
  [866] = {.lex_state = 14},
  [867] = {.lex_state = 14},
  [868] = {.lex_state = 14},
  [869] = {.lex_state = 14},
  [870] = {.lex_state = 14},
  [871] = {.lex_state = 14},
  [872] = {.lex_state = 14},
  [873] = {.lex_state = 14},
  [874] = {.lex_state = 14},
  [875] = {.lex_state = 14},
  [876] = {.lex_state = 14},
  [877] = {.lex_state = 14},
  [878] = {.lex_state = 14},
  [879] = {.lex_state = 14},
  [880] = {.lex_state = 14},
  [881] = {.lex_state = 14},
  [882] = {.lex_state = 14},
  [883] = {.lex_state = 14},
  [884] = {.lex_state = 14},
  [885] = {.lex_state = 14},
  [886] = {.lex_state = 14},
  [887] = {.lex_state = 14},
  [888] = {.lex_state = 14},
  [889] = {.lex_state = 14},
  [890] = {.lex_state = 14},
  [891] = {.lex_state = 14},
  [892] = {.lex_state = 14},
  [893] = {.lex_state = 14},
  [894] = {.lex_state = 14},
  [895] = {.lex_state = 14},
  [896] = {.lex_state = 14},
  [897] = {.lex_state = 14},
  [898] = {.lex_state = 14},
  [899] = {.lex_state = 14},
  [900] = {.lex_state = 14},
  [901] = {.lex_state = 14},
  [902] = {.lex_state = 14},
  [903] = {.lex_state = 14},
  [904] = {.lex_state = 14},
  [905] = {.lex_state = 14},
  [906] = {.lex_state = 14},
  [907] = {.lex_state = 14},
  [908] = {.lex_state = 14},
  [909] = {.lex_state = 14},
  [910] = {.lex_state = 14},
  [911] = {.lex_state = 14},
  [912] = {.lex_state = 14},
  [913] = {.lex_state = 14},
  [914] = {.lex_state = 14},
  [915] = {.lex_state = 14},
  [916] = {.lex_state = 14},
  [917] = {.lex_state = 14},
  [918] = {.lex_state = 14},
  [919] = {.lex_state = 14},
  [920] = {.lex_state = 14},
  [921] = {.lex_state = 14},
  [922] = {.lex_state = 14},
  [923] = {.lex_state = 14},
  [924] = {.lex_state = 14},
  [925] = {.lex_state = 14},
  [926] = {.lex_state = 14},
  [927] = {.lex_state = 14},
  [928] = {.lex_state = 14},
  [929] = {.lex_state = 14},
  [930] = {.lex_state = 14},
  [931] = {.lex_state = 14},
  [932] = {.lex_state = 14},
  [933] = {.lex_state = 14},
  [934] = {.lex_state = 14},
  [935] = {.lex_state = 14},
  [936] = {.lex_state = 14},
  [937] = {.lex_state = 14},
  [938] = {.lex_state = 14},
  [939] = {.lex_state = 14},
  [940] = {.lex_state = 14},
  [941] = {.lex_state = 14},
  [942] = {.lex_state = 14},
  [943] = {.lex_state = 14},
  [944] = {.lex_state = 14},
  [945] = {.lex_state = 14},
  [946] = {.lex_state = 14},
  [947] = {.lex_state = 14},
  [948] = {.lex_state = 14},
  [949] = {.lex_state = 14},
  [950] = {.lex_state = 14},
  [951] = {.lex_state = 14},
  [952] = {.lex_state = 14},
  [953] = {.lex_state = 14},
  [954] = {.lex_state = 14},
  [955] = {.lex_state = 14},
  [956] = {.lex_state = 14},
  [957] = {.lex_state = 14},
  [958] = {.lex_state = 14},
  [959] = {.lex_state = 14},
  [960] = {.lex_state = 14},
  [961] = {.lex_state = 14},
  [962] = {.lex_state = 14},
  [963] = {.lex_state = 14},
  [964] = {.lex_state = 14},
  [965] = {.lex_state = 14},
  [966] = {.lex_state = 14},
  [967] = {.lex_state = 14},
  [968] = {.lex_state = 14},
  [969] = {.lex_state = 14},
  [970] = {.lex_state = 14},
  [971] = {.lex_state = 14},
  [972] = {.lex_state = 14},
  [973] = {.lex_state = 14},
  [974] = {.lex_state = 14},
  [975] = {.lex_state = 14},
  [976] = {.lex_state = 14},
  [977] = {.lex_state = 14},
  [978] = {.lex_state = 14},
  [979] = {.lex_state = 14},
  [980] = {.lex_state = 14},
  [981] = {.lex_state = 14},
  [982] = {.lex_state = 14},
  [983] = {.lex_state = 14},
  [984] = {.lex_state = 14},
  [985] = {.lex_state = 14},
  [986] = {.lex_state = 14},
  [987] = {.lex_state = 14},
  [988] = {.lex_state = 14},
  [989] = {.lex_state = 14},
  [990] = {.lex_state = 14},
  [991] = {.lex_state = 14},
  [992] = {.lex_state = 14},
  [993] = {.lex_state = 14},
  [994] = {.lex_state = 14},
  [995] = {.lex_state = 14},
  [996] = {.lex_state = 14},
  [997] = {.lex_state = 11, .external_lex_state = 2},
  [998] = {.lex_state = 14},
  [999] = {.lex_state = 14},
  [1000] = {.lex_state = 14},
  [1001] = {.lex_state = 14},
  [1002] = {.lex_state = 11, .external_lex_state = 2},
  [1003] = {.lex_state = 11, .external_lex_state = 2},
  [1004] = {.lex_state = 13, .external_lex_state = 2},
  [1005] = {.lex_state = 13, .external_lex_state = 2},
  [1006] = {.lex_state = 11, .external_lex_state = 2},
  [1007] = {.lex_state = 12, .external_lex_state = 2},
  [1008] = {.lex_state = 14},
  [1009] = {.lex_state = 11, .external_lex_state = 2},
  [1010] = {.lex_state = 11, .external_lex_state = 2},
  [1011] = {.lex_state = 6},
  [1012] = {.lex_state = 6},
  [1013] = {.lex_state = 6},
  [1014] = {.lex_state = 6},
  [1015] = {.lex_state = 6},
  [1016] = {.lex_state = 10},
  [1017] = {.lex_state = 6},
  [1018] = {.lex_state = 10},
  [1019] = {.lex_state = 6},
  [1020] = {.lex_state = 10},
  [1021] = {.lex_state = 10},
  [1022] = {.lex_state = 10},
  [1023] = {.lex_state = 6},
  [1024] = {.lex_state = 6},
  [1025] = {.lex_state = 10},
  [1026] = {.lex_state = 6},
  [1027] = {.lex_state = 10},
  [1028] = {.lex_state = 6},
  [1029] = {.lex_state = 10},
  [1030] = {.lex_state = 10},
  [1031] = {.lex_state = 6},
  [1032] = {.lex_state = 11, .external_lex_state = 2},
  [1033] = {.lex_state = 7},
  [1034] = {.lex_state = 7},
  [1035] = {.lex_state = 22},
  [1036] = {.lex_state = 22},
  [1037] = {.lex_state = 7},
  [1038] = {.lex_state = 22},
  [1039] = {.lex_state = 7},
  [1040] = {.lex_state = 7},
  [1041] = {.lex_state = 7},
  [1042] = {.lex_state = 22},
  [1043] = {.lex_state = 22},
  [1044] = {.lex_state = 18},
  [1045] = {.lex_state = 18},
  [1046] = {.lex_state = 14},
  [1047] = {.lex_state = 7},
  [1048] = {.lex_state = 7},
  [1049] = {.lex_state = 18},
  [1050] = {.lex_state = 18},
  [1051] = {.lex_state = 7},
  [1052] = {.lex_state = 18},
  [1053] = {.lex_state = 7},
  [1054] = {.lex_state = 14},
  [1055] = {.lex_state = 7},
  [1056] = {.lex_state = 7},
  [1057] = {.lex_state = 7},
  [1058] = {.lex_state = 7},
  [1059] = {.lex_state = 7},
  [1060] = {.lex_state = 7},
  [1061] = {.lex_state = 6},
  [1062] = {.lex_state = 7},
  [1063] = {.lex_state = 7},
  [1064] = {.lex_state = 19},
  [1065] = {.lex_state = 7},
  [1066] = {.lex_state = 18},
  [1067] = {.lex_state = 7},
  [1068] = {.lex_state = 7},
  [1069] = {.lex_state = 7},
  [1070] = {.lex_state = 7},
  [1071] = {.lex_state = 7},
  [1072] = {.lex_state = 7},
  [1073] = {.lex_state = 18},
  [1074] = {.lex_state = 14},
  [1075] = {.lex_state = 7},
  [1076] = {.lex_state = 7},
  [1077] = {.lex_state = 14},
  [1078] = {.lex_state = 14},
  [1079] = {.lex_state = 18},
  [1080] = {.lex_state = 18},
  [1081] = {.lex_state = 7},
  [1082] = {.lex_state = 18},
  [1083] = {.lex_state = 14},
  [1084] = {.lex_state = 19},
  [1085] = {.lex_state = 18},
  [1086] = {.lex_state = 14},
  [1087] = {.lex_state = 7},
  [1088] = {.lex_state = 14},
  [1089] = {.lex_state = 14},
  [1090] = {.lex_state = 18},
  [1091] = {.lex_state = 10},
  [1092] = {.lex_state = 10},
  [1093] = {.lex_state = 14},
  [1094] = {.lex_state = 10},
  [1095] = {.lex_state = 10},
  [1096] = {.lex_state = 14},
  [1097] = {.lex_state = 10},
  [1098] = {.lex_state = 10},
  [1099] = {.lex_state = 10},
  [1100] = {.lex_state = 10},
  [1101] = {.lex_state = 10},
  [1102] = {.lex_state = 7},
  [1103] = {.lex_state = 10},
  [1104] = {.lex_state = 10},
  [1105] = {.lex_state = 10},
  [1106] = {.lex_state = 7},
  [1107] = {.lex_state = 10},
  [1108] = {.lex_state = 7},
  [1109] = {.lex_state = 10},
  [1110] = {.lex_state = 14},
  [1111] = {.lex_state = 10},
  [1112] = {.lex_state = 10},
  [1113] = {.lex_state = 10},
  [1114] = {.lex_state = 10},
  [1115] = {.lex_state = 10},
  [1116] = {.lex_state = 10},
  [1117] = {.lex_state = 7},
  [1118] = {.lex_state = 7},
  [1119] = {.lex_state = 10},
  [1120] = {.lex_state = 10},
  [1121] = {.lex_state = 10},
  [1122] = {.lex_state = 10},
  [1123] = {.lex_state = 10},
  [1124] = {.lex_state = 10},
  [1125] = {.lex_state = 7},
  [1126] = {.lex_state = 10},
  [1127] = {.lex_state = 10},
  [1128] = {.lex_state = 10},
  [1129] = {.lex_state = 10},
  [1130] = {.lex_state = 10},
  [1131] = {.lex_state = 10},
  [1132] = {.lex_state = 10},
  [1133] = {.lex_state = 10},
  [1134] = {.lex_state = 10},
  [1135] = {.lex_state = 10},
  [1136] = {.lex_state = 10},
  [1137] = {.lex_state = 10},
  [1138] = {.lex_state = 10},
  [1139] = {.lex_state = 10},
  [1140] = {.lex_state = 10},
  [1141] = {.lex_state = 10},
  [1142] = {.lex_state = 10},
  [1143] = {.lex_state = 10},
  [1144] = {.lex_state = 10},
  [1145] = {.lex_state = 10},
  [1146] = {.lex_state = 10},
  [1147] = {.lex_state = 10},
  [1148] = {.lex_state = 10},
  [1149] = {.lex_state = 10},
  [1150] = {.lex_state = 10},
  [1151] = {.lex_state = 10},
  [1152] = {.lex_state = 10},
  [1153] = {.lex_state = 10},
  [1154] = {.lex_state = 10},
  [1155] = {.lex_state = 10},
  [1156] = {.lex_state = 10},
  [1157] = {.lex_state = 10},
  [1158] = {.lex_state = 10},
  [1159] = {.lex_state = 10},
  [1160] = {.lex_state = 10},
  [1161] = {.lex_state = 10},
  [1162] = {.lex_state = 10},
  [1163] = {.lex_state = 10},
  [1164] = {.lex_state = 10},
  [1165] = {.lex_state = 10},
  [1166] = {.lex_state = 7},
  [1167] = {.lex_state = 10},
  [1168] = {.lex_state = 10},
  [1169] = {.lex_state = 10},
  [1170] = {.lex_state = 10},
  [1171] = {.lex_state = 10},
  [1172] = {.lex_state = 10},
  [1173] = {.lex_state = 10},
  [1174] = {.lex_state = 10},
  [1175] = {.lex_state = 10},
  [1176] = {.lex_state = 10},
  [1177] = {.lex_state = 10},
  [1178] = {.lex_state = 10},
  [1179] = {.lex_state = 10},
  [1180] = {.lex_state = 10},
  [1181] = {.lex_state = 10},
  [1182] = {.lex_state = 10},
  [1183] = {.lex_state = 10},
  [1184] = {.lex_state = 10},
  [1185] = {.lex_state = 10},
  [1186] = {.lex_state = 10},
  [1187] = {.lex_state = 10},
  [1188] = {.lex_state = 10},
  [1189] = {.lex_state = 10},
  [1190] = {.lex_state = 7},
  [1191] = {.lex_state = 10},
  [1192] = {.lex_state = 10},
  [1193] = {.lex_state = 10},
  [1194] = {.lex_state = 10},
  [1195] = {.lex_state = 10},
  [1196] = {.lex_state = 10},
  [1197] = {.lex_state = 10},
  [1198] = {.lex_state = 10},
  [1199] = {.lex_state = 10},
  [1200] = {.lex_state = 10},
  [1201] = {.lex_state = 10},
  [1202] = {.lex_state = 7},
  [1203] = {.lex_state = 10},
  [1204] = {.lex_state = 10},
  [1205] = {.lex_state = 10},
  [1206] = {.lex_state = 10},
  [1207] = {.lex_state = 10},
  [1208] = {.lex_state = 10},
  [1209] = {.lex_state = 7},
  [1210] = {.lex_state = 10},
  [1211] = {.lex_state = 10},
  [1212] = {.lex_state = 7},
  [1213] = {.lex_state = 10},
  [1214] = {.lex_state = 7},
  [1215] = {.lex_state = 10},
  [1216] = {.lex_state = 7},
  [1217] = {.lex_state = 10},
  [1218] = {.lex_state = 10},
  [1219] = {.lex_state = 10},
  [1220] = {.lex_state = 10},
  [1221] = {.lex_state = 10},
  [1222] = {.lex_state = 7},
  [1223] = {.lex_state = 10},
  [1224] = {.lex_state = 10},
  [1225] = {.lex_state = 7},
  [1226] = {.lex_state = 7},
  [1227] = {.lex_state = 10},
  [1228] = {.lex_state = 10},
  [1229] = {.lex_state = 10},
  [1230] = {.lex_state = 10},
  [1231] = {.lex_state = 10},
  [1232] = {.lex_state = 10},
  [1233] = {.lex_state = 10},
  [1234] = {.lex_state = 10},
  [1235] = {.lex_state = 10},
  [1236] = {.lex_state = 10},
  [1237] = {.lex_state = 10},
  [1238] = {.lex_state = 10},
  [1239] = {.lex_state = 10},
  [1240] = {.lex_state = 10},
  [1241] = {.lex_state = 10},
  [1242] = {.lex_state = 7},
  [1243] = {.lex_state = 7},
  [1244] = {.lex_state = 7},
  [1245] = {.lex_state = 10},
  [1246] = {.lex_state = 7},
  [1247] = {.lex_state = 10},
  [1248] = {.lex_state = 10},
  [1249] = {.lex_state = 7},
  [1250] = {.lex_state = 10},
  [1251] = {.lex_state = 10},
  [1252] = {.lex_state = 10},
  [1253] = {.lex_state = 10},
  [1254] = {.lex_state = 10},
  [1255] = {.lex_state = 7},
  [1256] = {.lex_state = 10},
  [1257] = {.lex_state = 10},
  [1258] = {.lex_state = 10},
  [1259] = {.lex_state = 10},
  [1260] = {.lex_state = 10},
  [1261] = {.lex_state = 10},
  [1262] = {.lex_state = 10},
  [1263] = {.lex_state = 7},
  [1264] = {.lex_state = 7},
  [1265] = {.lex_state = 10},
  [1266] = {.lex_state = 10},
  [1267] = {.lex_state = 11, .external_lex_state = 2},
  [1268] = {.lex_state = 7},
  [1269] = {.lex_state = 10},
  [1270] = {.lex_state = 7},
  [1271] = {.lex_state = 10},
  [1272] = {.lex_state = 10},
  [1273] = {.lex_state = 7},
  [1274] = {.lex_state = 10},
  [1275] = {.lex_state = 7},
  [1276] = {.lex_state = 7},
  [1277] = {.lex_state = 7},
  [1278] = {.lex_state = 10},
  [1279] = {.lex_state = 7},
  [1280] = {.lex_state = 7},
  [1281] = {.lex_state = 7},
  [1282] = {.lex_state = 10},
  [1283] = {.lex_state = 10},
  [1284] = {.lex_state = 10},
  [1285] = {.lex_state = 7},
  [1286] = {.lex_state = 10},
  [1287] = {.lex_state = 10},
  [1288] = {.lex_state = 10},
  [1289] = {.lex_state = 7},
  [1290] = {.lex_state = 10},
  [1291] = {.lex_state = 10},
  [1292] = {.lex_state = 10},
  [1293] = {.lex_state = 7},
  [1294] = {.lex_state = 10},
  [1295] = {.lex_state = 10},
  [1296] = {.lex_state = 10},
  [1297] = {.lex_state = 10},
  [1298] = {.lex_state = 10},
  [1299] = {.lex_state = 10},
  [1300] = {.lex_state = 10},
  [1301] = {.lex_state = 7},
  [1302] = {.lex_state = 10},
  [1303] = {.lex_state = 10},
  [1304] = {.lex_state = 10},
  [1305] = {.lex_state = 7},
  [1306] = {.lex_state = 7},
  [1307] = {.lex_state = 10},
  [1308] = {.lex_state = 10},
  [1309] = {.lex_state = 10},
  [1310] = {.lex_state = 10},
  [1311] = {.lex_state = 10},
  [1312] = {.lex_state = 7},
  [1313] = {.lex_state = 10},
  [1314] = {.lex_state = 10},
  [1315] = {.lex_state = 7},
  [1316] = {.lex_state = 14},
  [1317] = {.lex_state = 10},
  [1318] = {.lex_state = 14},
  [1319] = {.lex_state = 14},
  [1320] = {.lex_state = 10},
  [1321] = {.lex_state = 10},
  [1322] = {.lex_state = 10},
  [1323] = {.lex_state = 7},
  [1324] = {.lex_state = 10},
  [1325] = {.lex_state = 10},
  [1326] = {.lex_state = 7},
  [1327] = {.lex_state = 10},
  [1328] = {.lex_state = 10},
  [1329] = {.lex_state = 7},
  [1330] = {.lex_state = 7},
  [1331] = {.lex_state = 10},
  [1332] = {.lex_state = 10},
  [1333] = {.lex_state = 10},
  [1334] = {.lex_state = 7},
  [1335] = {.lex_state = 7},
  [1336] = {.lex_state = 10},
  [1337] = {.lex_state = 7},
  [1338] = {.lex_state = 10},
  [1339] = {.lex_state = 10},
  [1340] = {.lex_state = 7},
  [1341] = {.lex_state = 7},
  [1342] = {.lex_state = 7},
  [1343] = {.lex_state = 10},
  [1344] = {.lex_state = 10},
  [1345] = {.lex_state = 10},
  [1346] = {.lex_state = 14},
  [1347] = {.lex_state = 10},
  [1348] = {.lex_state = 10},
  [1349] = {.lex_state = 14},
  [1350] = {.lex_state = 10},
  [1351] = {.lex_state = 7},
  [1352] = {.lex_state = 7},
  [1353] = {.lex_state = 7},
  [1354] = {.lex_state = 7},
  [1355] = {.lex_state = 10},
  [1356] = {.lex_state = 10},
  [1357] = {.lex_state = 7},
  [1358] = {.lex_state = 10},
  [1359] = {.lex_state = 7},
  [1360] = {.lex_state = 7},
  [1361] = {.lex_state = 10},
  [1362] = {.lex_state = 7},
  [1363] = {.lex_state = 10},
  [1364] = {.lex_state = 7},
  [1365] = {.lex_state = 7},
  [1366] = {.lex_state = 7},
  [1367] = {.lex_state = 10},
  [1368] = {.lex_state = 10},
  [1369] = {.lex_state = 10},
  [1370] = {.lex_state = 10},
  [1371] = {.lex_state = 7},
  [1372] = {.lex_state = 7},
  [1373] = {.lex_state = 7},
  [1374] = {.lex_state = 7},
  [1375] = {.lex_state = 10},
  [1376] = {.lex_state = 10},
  [1377] = {.lex_state = 10},
  [1378] = {.lex_state = 10},
  [1379] = {.lex_state = 10},
  [1380] = {.lex_state = 10},
  [1381] = {.lex_state = 7},
  [1382] = {.lex_state = 7},
  [1383] = {.lex_state = 10},
  [1384] = {.lex_state = 7},
  [1385] = {.lex_state = 10},
  [1386] = {.lex_state = 10},
  [1387] = {.lex_state = 10},
  [1388] = {.lex_state = 10},
  [1389] = {.lex_state = 10},
  [1390] = {.lex_state = 10},
  [1391] = {.lex_state = 7},
  [1392] = {.lex_state = 10},
  [1393] = {.lex_state = 10},
  [1394] = {.lex_state = 7},
  [1395] = {.lex_state = 7},
  [1396] = {.lex_state = 7},
  [1397] = {.lex_state = 7},
  [1398] = {.lex_state = 7},
  [1399] = {.lex_state = 7},
  [1400] = {.lex_state = 7},
  [1401] = {.lex_state = 7},
  [1402] = {.lex_state = 10},
  [1403] = {.lex_state = 7},
  [1404] = {.lex_state = 7},
  [1405] = {.lex_state = 7},
  [1406] = {.lex_state = 7},
  [1407] = {.lex_state = 10},
  [1408] = {.lex_state = 10},
  [1409] = {.lex_state = 10},
  [1410] = {.lex_state = 10},
  [1411] = {.lex_state = 10},
  [1412] = {.lex_state = 7},
  [1413] = {.lex_state = 7},
  [1414] = {.lex_state = 7},
  [1415] = {.lex_state = 12, .external_lex_state = 2},
  [1416] = {.lex_state = 11, .external_lex_state = 2},
  [1417] = {.lex_state = 7},
  [1418] = {.lex_state = 7},
  [1419] = {.lex_state = 7},
  [1420] = {.lex_state = 7},
  [1421] = {.lex_state = 14},
  [1422] = {.lex_state = 14},
  [1423] = {.lex_state = 12, .external_lex_state = 2},
  [1424] = {.lex_state = 10},
  [1425] = {.lex_state = 7},
  [1426] = {.lex_state = 10},
  [1427] = {.lex_state = 7},
  [1428] = {.lex_state = 10},
  [1429] = {.lex_state = 7},
  [1430] = {.lex_state = 10},
  [1431] = {.lex_state = 10},
  [1432] = {.lex_state = 10},
  [1433] = {.lex_state = 7},
  [1434] = {.lex_state = 10},
  [1435] = {.lex_state = 10},
  [1436] = {.lex_state = 7},
  [1437] = {.lex_state = 7},
  [1438] = {.lex_state = 10},
  [1439] = {.lex_state = 7},
  [1440] = {.lex_state = 7},
  [1441] = {.lex_state = 7},
  [1442] = {.lex_state = 7},
  [1443] = {.lex_state = 10},
  [1444] = {.lex_state = 7},
  [1445] = {.lex_state = 7},
  [1446] = {.lex_state = 10},
  [1447] = {.lex_state = 10},
  [1448] = {.lex_state = 10},
  [1449] = {.lex_state = 10},
  [1450] = {.lex_state = 10},
  [1451] = {.lex_state = 10},
  [1452] = {.lex_state = 7},
  [1453] = {.lex_state = 7},
  [1454] = {.lex_state = 7},
  [1455] = {.lex_state = 10},
  [1456] = {.lex_state = 10},
  [1457] = {.lex_state = 7},
  [1458] = {.lex_state = 10},
  [1459] = {.lex_state = 10},
  [1460] = {.lex_state = 10},
  [1461] = {.lex_state = 10},
  [1462] = {.lex_state = 7},
  [1463] = {.lex_state = 10},
  [1464] = {.lex_state = 10},
  [1465] = {.lex_state = 10},
  [1466] = {.lex_state = 10},
  [1467] = {.lex_state = 7},
  [1468] = {.lex_state = 7},
  [1469] = {.lex_state = 10},
  [1470] = {.lex_state = 7},
  [1471] = {.lex_state = 14},
  [1472] = {.lex_state = 11, .external_lex_state = 2},
  [1473] = {.lex_state = 7},
  [1474] = {.lex_state = 11, .external_lex_state = 2},
  [1475] = {.lex_state = 11, .external_lex_state = 2},
  [1476] = {.lex_state = 11, .external_lex_state = 2},
  [1477] = {.lex_state = 14},
  [1478] = {.lex_state = 14},
  [1479] = {.lex_state = 14},
  [1480] = {.lex_state = 11, .external_lex_state = 2},
  [1481] = {.lex_state = 7},
  [1482] = {.lex_state = 7},
  [1483] = {.lex_state = 7},
  [1484] = {.lex_state = 14},
  [1485] = {.lex_state = 7},
  [1486] = {.lex_state = 7},
  [1487] = {.lex_state = 7},
  [1488] = {.lex_state = 7},
  [1489] = {.lex_state = 7},
  [1490] = {.lex_state = 7},
  [1491] = {.lex_state = 9},
  [1492] = {.lex_state = 14},
  [1493] = {.lex_state = 7},
  [1494] = {.lex_state = 7},
  [1495] = {.lex_state = 7},
  [1496] = {.lex_state = 7},
  [1497] = {.lex_state = 7},
  [1498] = {.lex_state = 14},
  [1499] = {.lex_state = 7},
  [1500] = {.lex_state = 7},
  [1501] = {.lex_state = 7},
  [1502] = {.lex_state = 7},
  [1503] = {.lex_state = 7},
  [1504] = {.lex_state = 7},
  [1505] = {.lex_state = 7},
  [1506] = {.lex_state = 8},
  [1507] = {.lex_state = 7},
  [1508] = {.lex_state = 9},
  [1509] = {.lex_state = 9},
  [1510] = {.lex_state = 11, .external_lex_state = 2},
  [1511] = {.lex_state = 11, .external_lex_state = 2},
  [1512] = {.lex_state = 11, .external_lex_state = 2},
  [1513] = {.lex_state = 9},
  [1514] = {.lex_state = 7},
  [1515] = {.lex_state = 11, .external_lex_state = 2},
  [1516] = {.lex_state = 9},
  [1517] = {.lex_state = 7},
  [1518] = {.lex_state = 9},
  [1519] = {.lex_state = 14},
  [1520] = {.lex_state = 14},
  [1521] = {.lex_state = 14},
  [1522] = {.lex_state = 8},
  [1523] = {.lex_state = 8},
  [1524] = {.lex_state = 9},
  [1525] = {.lex_state = 7},
  [1526] = {.lex_state = 8},
  [1527] = {.lex_state = 7},
  [1528] = {.lex_state = 14},
  [1529] = {.lex_state = 8},
  [1530] = {.lex_state = 7},
  [1531] = {.lex_state = 14},
  [1532] = {.lex_state = 9},
  [1533] = {.lex_state = 7},
  [1534] = {.lex_state = 7},
  [1535] = {.lex_state = 14},
  [1536] = {.lex_state = 7},
  [1537] = {.lex_state = 9},
  [1538] = {.lex_state = 9},
  [1539] = {.lex_state = 9},
  [1540] = {.lex_state = 14},
  [1541] = {.lex_state = 9},
  [1542] = {.lex_state = 7},
  [1543] = {.lex_state = 8},
  [1544] = {.lex_state = 7},
  [1545] = {.lex_state = 7},
  [1546] = {.lex_state = 8},
  [1547] = {.lex_state = 8},
  [1548] = {.lex_state = 7},
  [1549] = {.lex_state = 7},
  [1550] = {.lex_state = 8},
  [1551] = {.lex_state = 8},
  [1552] = {.lex_state = 7},
  [1553] = {.lex_state = 7},
  [1554] = {.lex_state = 8},
  [1555] = {.lex_state = 8},
  [1556] = {.lex_state = 7},
  [1557] = {.lex_state = 7},
  [1558] = {.lex_state = 8},
  [1559] = {.lex_state = 7},
  [1560] = {.lex_state = 7},
  [1561] = {.lex_state = 7},
  [1562] = {.lex_state = 7},
  [1563] = {.lex_state = 7},
  [1564] = {.lex_state = 8},
  [1565] = {.lex_state = 8},
  [1566] = {.lex_state = 7},
  [1567] = {.lex_state = 7},
  [1568] = {.lex_state = 8},
  [1569] = {.lex_state = 8},
  [1570] = {.lex_state = 8},
  [1571] = {.lex_state = 7},
  [1572] = {.lex_state = 8},
  [1573] = {.lex_state = 7},
  [1574] = {.lex_state = 9},
  [1575] = {.lex_state = 20},
  [1576] = {.lex_state = 8},
  [1577] = {.lex_state = 8},
  [1578] = {.lex_state = 7},
  [1579] = {.lex_state = 8},
  [1580] = {.lex_state = 7},
  [1581] = {.lex_state = 7},
  [1582] = {.lex_state = 8},
  [1583] = {.lex_state = 8},
  [1584] = {.lex_state = 7},
  [1585] = {.lex_state = 7},
  [1586] = {.lex_state = 7},
  [1587] = {.lex_state = 14},
  [1588] = {.lex_state = 8},
  [1589] = {.lex_state = 20},
  [1590] = {.lex_state = 8},
  [1591] = {.lex_state = 8},
  [1592] = {.lex_state = 8},
  [1593] = {.lex_state = 20},
  [1594] = {.lex_state = 20},
  [1595] = {.lex_state = 7},
  [1596] = {.lex_state = 7},
  [1597] = {.lex_state = 7},
  [1598] = {.lex_state = 8},
  [1599] = {.lex_state = 8},
  [1600] = {.lex_state = 7},
  [1601] = {.lex_state = 8},
  [1602] = {.lex_state = 7},
  [1603] = {.lex_state = 20},
  [1604] = {.lex_state = 20},
  [1605] = {.lex_state = 8},
  [1606] = {.lex_state = 7},
  [1607] = {.lex_state = 20},
  [1608] = {.lex_state = 8},
  [1609] = {.lex_state = 7},
  [1610] = {.lex_state = 20},
  [1611] = {.lex_state = 7},
  [1612] = {.lex_state = 7},
  [1613] = {.lex_state = 8},
  [1614] = {.lex_state = 14},
  [1615] = {.lex_state = 7},
  [1616] = {.lex_state = 7},
  [1617] = {.lex_state = 7},
  [1618] = {.lex_state = 8},
  [1619] = {.lex_state = 7},
  [1620] = {.lex_state = 7},
  [1621] = {.lex_state = 20},
  [1622] = {.lex_state = 7},
  [1623] = {.lex_state = 14},
  [1624] = {.lex_state = 20},
  [1625] = {.lex_state = 8},
  [1626] = {.lex_state = 7},
  [1627] = {.lex_state = 7},
  [1628] = {.lex_state = 7},
  [1629] = {.lex_state = 7},
  [1630] = {.lex_state = 20},
  [1631] = {.lex_state = 8},
  [1632] = {.lex_state = 20},
  [1633] = {.lex_state = 7},
  [1634] = {.lex_state = 8},
  [1635] = {.lex_state = 8},
  [1636] = {.lex_state = 7},
  [1637] = {.lex_state = 7},
  [1638] = {.lex_state = 8},
  [1639] = {.lex_state = 8},
  [1640] = {.lex_state = 8},
  [1641] = {.lex_state = 8},
  [1642] = {.lex_state = 8},
  [1643] = {.lex_state = 8},
  [1644] = {.lex_state = 7},
  [1645] = {.lex_state = 8},
  [1646] = {.lex_state = 7},
  [1647] = {.lex_state = 8},
  [1648] = {.lex_state = 7},
  [1649] = {.lex_state = 8},
  [1650] = {.lex_state = 7},
  [1651] = {.lex_state = 7},
  [1652] = {.lex_state = 7},
  [1653] = {.lex_state = 7},
  [1654] = {.lex_state = 7},
  [1655] = {.lex_state = 8},
  [1656] = {.lex_state = 7},
  [1657] = {.lex_state = 7},
  [1658] = {.lex_state = 7},
  [1659] = {.lex_state = 7},
  [1660] = {.lex_state = 8},
  [1661] = {.lex_state = 7},
  [1662] = {.lex_state = 8},
  [1663] = {.lex_state = 7},
  [1664] = {.lex_state = 7},
  [1665] = {.lex_state = 8},
  [1666] = {.lex_state = 8},
  [1667] = {.lex_state = 8},
  [1668] = {.lex_state = 7},
  [1669] = {.lex_state = 8},
  [1670] = {.lex_state = 8},
  [1671] = {.lex_state = 8},
  [1672] = {.lex_state = 8},
  [1673] = {.lex_state = 8},
  [1674] = {.lex_state = 8},
  [1675] = {.lex_state = 7},
  [1676] = {.lex_state = 7},
  [1677] = {.lex_state = 8},
  [1678] = {.lex_state = 8},
  [1679] = {.lex_state = 7},
  [1680] = {.lex_state = 8},
  [1681] = {.lex_state = 8},
  [1682] = {.lex_state = 7},
  [1683] = {.lex_state = 8},
  [1684] = {.lex_state = 8},
  [1685] = {.lex_state = 8},
  [1686] = {.lex_state = 8},
  [1687] = {.lex_state = 8},
  [1688] = {.lex_state = 8},
  [1689] = {.lex_state = 8},
  [1690] = {.lex_state = 8},
  [1691] = {.lex_state = 8},
  [1692] = {.lex_state = 8},
  [1693] = {.lex_state = 7},
  [1694] = {.lex_state = 7},
  [1695] = {.lex_state = 8},
  [1696] = {.lex_state = 7},
  [1697] = {.lex_state = 8},
  [1698] = {.lex_state = 8},
  [1699] = {.lex_state = 8},
  [1700] = {.lex_state = 8},
  [1701] = {.lex_state = 7},
  [1702] = {.lex_state = 8},
  [1703] = {.lex_state = 7},
  [1704] = {.lex_state = 7},
  [1705] = {.lex_state = 8},
  [1706] = {.lex_state = 8},
  [1707] = {.lex_state = 7},
  [1708] = {.lex_state = 8},
  [1709] = {.lex_state = 7},
  [1710] = {.lex_state = 8},
  [1711] = {.lex_state = 7},
  [1712] = {.lex_state = 8},
  [1713] = {.lex_state = 8},
  [1714] = {.lex_state = 8},
  [1715] = {.lex_state = 8},
  [1716] = {.lex_state = 8},
  [1717] = {.lex_state = 7},
  [1718] = {.lex_state = 8},
  [1719] = {.lex_state = 8},
  [1720] = {.lex_state = 7},
  [1721] = {.lex_state = 8},
  [1722] = {.lex_state = 7},
  [1723] = {.lex_state = 8},
  [1724] = {.lex_state = 7},
  [1725] = {.lex_state = 7},
  [1726] = {.lex_state = 8},
  [1727] = {.lex_state = 7},
  [1728] = {.lex_state = 7},
  [1729] = {.lex_state = 8},
  [1730] = {.lex_state = 8},
  [1731] = {.lex_state = 8},
  [1732] = {.lex_state = 8},
  [1733] = {.lex_state = 8},
  [1734] = {.lex_state = 8},
  [1735] = {.lex_state = 7},
  [1736] = {.lex_state = 7},
  [1737] = {.lex_state = 8},
  [1738] = {.lex_state = 8},
  [1739] = {.lex_state = 8},
  [1740] = {.lex_state = 7},
  [1741] = {.lex_state = 8},
  [1742] = {.lex_state = 8},
  [1743] = {.lex_state = 8},
  [1744] = {.lex_state = 7},
  [1745] = {.lex_state = 8},
  [1746] = {.lex_state = 7},
  [1747] = {.lex_state = 8},
  [1748] = {.lex_state = 8},
  [1749] = {.lex_state = 8},
  [1750] = {.lex_state = 7},
  [1751] = {.lex_state = 8},
  [1752] = {.lex_state = 8},
  [1753] = {.lex_state = 14},
  [1754] = {.lex_state = 8},
  [1755] = {.lex_state = 8},
  [1756] = {.lex_state = 8},
  [1757] = {.lex_state = 7},
  [1758] = {.lex_state = 7},
  [1759] = {.lex_state = 8},
  [1760] = {.lex_state = 7},
  [1761] = {.lex_state = 8},
  [1762] = {.lex_state = 7},
  [1763] = {.lex_state = 8},
  [1764] = {.lex_state = 8},
  [1765] = {.lex_state = 7},
  [1766] = {.lex_state = 8},
  [1767] = {.lex_state = 8},
  [1768] = {.lex_state = 7},
  [1769] = {.lex_state = 8},
  [1770] = {.lex_state = 7},
  [1771] = {.lex_state = 8},
  [1772] = {.lex_state = 8},
  [1773] = {.lex_state = 8},
  [1774] = {.lex_state = 8},
  [1775] = {.lex_state = 8},
  [1776] = {.lex_state = 8},
  [1777] = {.lex_state = 8},
  [1778] = {.lex_state = 7},
  [1779] = {.lex_state = 8},
  [1780] = {.lex_state = 8},
  [1781] = {.lex_state = 7},
  [1782] = {.lex_state = 8},
  [1783] = {.lex_state = 7},
  [1784] = {.lex_state = 8},
  [1785] = {.lex_state = 8},
  [1786] = {.lex_state = 8},
  [1787] = {.lex_state = 7},
  [1788] = {.lex_state = 7},
  [1789] = {.lex_state = 8},
  [1790] = {.lex_state = 7},
  [1791] = {.lex_state = 7},
  [1792] = {.lex_state = 7},
  [1793] = {.lex_state = 8},
  [1794] = {.lex_state = 8},
  [1795] = {.lex_state = 7},
  [1796] = {.lex_state = 8},
  [1797] = {.lex_state = 7},
  [1798] = {.lex_state = 8},
  [1799] = {.lex_state = 7},
  [1800] = {.lex_state = 8},
  [1801] = {.lex_state = 8},
  [1802] = {.lex_state = 7},
  [1803] = {.lex_state = 7},
  [1804] = {.lex_state = 7},
  [1805] = {.lex_state = 8},
  [1806] = {.lex_state = 8},
  [1807] = {.lex_state = 8},
  [1808] = {.lex_state = 7},
  [1809] = {.lex_state = 7},
  [1810] = {.lex_state = 8},
  [1811] = {.lex_state = 7},
  [1812] = {.lex_state = 8},
  [1813] = {.lex_state = 8},
  [1814] = {.lex_state = 8},
  [1815] = {.lex_state = 7},
  [1816] = {.lex_state = 7},
  [1817] = {.lex_state = 8},
  [1818] = {.lex_state = 8},
  [1819] = {.lex_state = 7},
  [1820] = {.lex_state = 8},
  [1821] = {.lex_state = 7},
  [1822] = {.lex_state = 8},
  [1823] = {.lex_state = 8},
  [1824] = {.lex_state = 7},
  [1825] = {.lex_state = 7},
  [1826] = {.lex_state = 8},
  [1827] = {.lex_state = 8},
  [1828] = {.lex_state = 8},
  [1829] = {.lex_state = 7},
  [1830] = {.lex_state = 7},
  [1831] = {.lex_state = 8},
  [1832] = {.lex_state = 7},
  [1833] = {.lex_state = 8},
  [1834] = {.lex_state = 7},
  [1835] = {.lex_state = 7},
  [1836] = {.lex_state = 7},
  [1837] = {.lex_state = 7},
  [1838] = {.lex_state = 7},
  [1839] = {.lex_state = 7},
  [1840] = {.lex_state = 7},
  [1841] = {.lex_state = 8},
  [1842] = {.lex_state = 7},
  [1843] = {.lex_state = 7},
  [1844] = {.lex_state = 7},
  [1845] = {.lex_state = 7},
  [1846] = {.lex_state = 7},
  [1847] = {.lex_state = 7},
  [1848] = {.lex_state = 7},
  [1849] = {.lex_state = 7},
  [1850] = {.lex_state = 7},
  [1851] = {.lex_state = 7},
  [1852] = {.lex_state = 14},
  [1853] = {.lex_state = 7},
  [1854] = {.lex_state = 7},
  [1855] = {.lex_state = 7},
  [1856] = {.lex_state = 7},
  [1857] = {.lex_state = 7},
  [1858] = {.lex_state = 7},
  [1859] = {.lex_state = 7},
  [1860] = {.lex_state = 7},
  [1861] = {.lex_state = 8},
  [1862] = {.lex_state = 7},
  [1863] = {.lex_state = 7},
  [1864] = {.lex_state = 7},
  [1865] = {.lex_state = 7},
  [1866] = {.lex_state = 7},
  [1867] = {.lex_state = 8},
  [1868] = {.lex_state = 7},
  [1869] = {.lex_state = 7},
  [1870] = {.lex_state = 7},
  [1871] = {.lex_state = 8},
  [1872] = {.lex_state = 7},
  [1873] = {.lex_state = 7},
  [1874] = {.lex_state = 14},
  [1875] = {.lex_state = 7},
  [1876] = {.lex_state = 14},
  [1877] = {.lex_state = 14},
  [1878] = {.lex_state = 14},
  [1879] = {.lex_state = 14},
  [1880] = {.lex_state = 14},
  [1881] = {.lex_state = 14},
  [1882] = {.lex_state = 14},
  [1883] = {.lex_state = 14},
  [1884] = {.lex_state = 14},
  [1885] = {.lex_state = 14},
  [1886] = {.lex_state = 14},
  [1887] = {.lex_state = 14},
  [1888] = {.lex_state = 14},
  [1889] = {.lex_state = 14},
  [1890] = {.lex_state = 14},
  [1891] = {.lex_state = 14},
  [1892] = {.lex_state = 14},
  [1893] = {.lex_state = 14},
  [1894] = {.lex_state = 14},
  [1895] = {.lex_state = 14},
  [1896] = {.lex_state = 14},
  [1897] = {.lex_state = 14},
  [1898] = {.lex_state = 14},
  [1899] = {.lex_state = 14},
  [1900] = {.lex_state = 14},
  [1901] = {.lex_state = 14},
  [1902] = {.lex_state = 27},
  [1903] = {.lex_state = 16},
  [1904] = {.lex_state = 27},
  [1905] = {.lex_state = 16},
  [1906] = {.lex_state = 16},
  [1907] = {.lex_state = 16},
  [1908] = {.lex_state = 16},
  [1909] = {.lex_state = 16},
  [1910] = {.lex_state = 16},
  [1911] = {.lex_state = 16},
  [1912] = {.lex_state = 16},
  [1913] = {.lex_state = 27},
  [1914] = {.lex_state = 16},
  [1915] = {.lex_state = 27},
  [1916] = {.lex_state = 27},
  [1917] = {.lex_state = 16},
  [1918] = {.lex_state = 27},
  [1919] = {.lex_state = 16},
  [1920] = {.lex_state = 16},
  [1921] = {.lex_state = 14},
  [1922] = {.lex_state = 14},
  [1923] = {.lex_state = 14},
  [1924] = {.lex_state = 27},
  [1925] = {.lex_state = 14},
  [1926] = {.lex_state = 14},
  [1927] = {.lex_state = 14},
  [1928] = {.lex_state = 14},
  [1929] = {.lex_state = 14},
  [1930] = {.lex_state = 16},
  [1931] = {.lex_state = 14},
  [1932] = {.lex_state = 14},
  [1933] = {.lex_state = 14},
  [1934] = {.lex_state = 16},
  [1935] = {.lex_state = 14},
  [1936] = {.lex_state = 14},
  [1937] = {.lex_state = 14},
  [1938] = {.lex_state = 27},
  [1939] = {.lex_state = 27},
  [1940] = {.lex_state = 14},
  [1941] = {.lex_state = 27},
  [1942] = {.lex_state = 27},
  [1943] = {.lex_state = 27},
  [1944] = {.lex_state = 27},
  [1945] = {.lex_state = 16},
  [1946] = {.lex_state = 14},
  [1947] = {.lex_state = 27},
  [1948] = {.lex_state = 14},
  [1949] = {.lex_state = 14},
  [1950] = {.lex_state = 27},
  [1951] = {.lex_state = 14},
  [1952] = {.lex_state = 14},
  [1953] = {.lex_state = 16},
  [1954] = {.lex_state = 14},
  [1955] = {.lex_state = 27},
  [1956] = {.lex_state = 27},
  [1957] = {.lex_state = 27},
  [1958] = {.lex_state = 27},
  [1959] = {.lex_state = 27},
  [1960] = {.lex_state = 27},
  [1961] = {.lex_state = 16},
  [1962] = {.lex_state = 16},
  [1963] = {.lex_state = 27},
  [1964] = {.lex_state = 27},
  [1965] = {.lex_state = 14},
  [1966] = {.lex_state = 27},
  [1967] = {.lex_state = 27},
  [1968] = {.lex_state = 27},
  [1969] = {.lex_state = 27},
  [1970] = {.lex_state = 27},
  [1971] = {.lex_state = 27},
  [1972] = {.lex_state = 14},
  [1973] = {.lex_state = 27},
  [1974] = {.lex_state = 27},
  [1975] = {.lex_state = 14},
  [1976] = {.lex_state = 27},
  [1977] = {.lex_state = 27},
  [1978] = {.lex_state = 14},
  [1979] = {.lex_state = 27},
  [1980] = {.lex_state = 27},
  [1981] = {.lex_state = 27},
  [1982] = {.lex_state = 14},
  [1983] = {.lex_state = 27},
  [1984] = {.lex_state = 27},
  [1985] = {.lex_state = 16},
  [1986] = {.lex_state = 27},
  [1987] = {.lex_state = 27},
  [1988] = {.lex_state = 27},
  [1989] = {.lex_state = 27},
  [1990] = {.lex_state = 27},
  [1991] = {.lex_state = 27},
  [1992] = {.lex_state = 27},
  [1993] = {.lex_state = 27},
  [1994] = {.lex_state = 27},
  [1995] = {.lex_state = 27},
  [1996] = {.lex_state = 27},
  [1997] = {.lex_state = 16},
  [1998] = {.lex_state = 27},
  [1999] = {.lex_state = 27},
  [2000] = {.lex_state = 14},
  [2001] = {.lex_state = 14},
  [2002] = {.lex_state = 17},
  [2003] = {.lex_state = 16},
  [2004] = {.lex_state = 16},
  [2005] = {.lex_state = 16},
  [2006] = {.lex_state = 27},
  [2007] = {.lex_state = 16},
  [2008] = {.lex_state = 27},
  [2009] = {.lex_state = 27},
  [2010] = {.lex_state = 16},
  [2011] = {.lex_state = 16},
  [2012] = {.lex_state = 16},
  [2013] = {.lex_state = 16},
  [2014] = {.lex_state = 16},
  [2015] = {.lex_state = 16},
  [2016] = {.lex_state = 16},
  [2017] = {.lex_state = 16},
  [2018] = {.lex_state = 14},
  [2019] = {.lex_state = 14},
  [2020] = {.lex_state = 14},
  [2021] = {.lex_state = 14},
  [2022] = {.lex_state = 14},
  [2023] = {.lex_state = 14},
  [2024] = {.lex_state = 14},
  [2025] = {.lex_state = 14},
  [2026] = {.lex_state = 14},
  [2027] = {.lex_state = 14},
  [2028] = {.lex_state = 14},
  [2029] = {.lex_state = 14},
  [2030] = {.lex_state = 14},
  [2031] = {.lex_state = 14},
  [2032] = {.lex_state = 14},
  [2033] = {.lex_state = 14},
  [2034] = {.lex_state = 14},
  [2035] = {.lex_state = 27},
  [2036] = {.lex_state = 16},
  [2037] = {.lex_state = 14},
  [2038] = {.lex_state = 23},
  [2039] = {.lex_state = 14},
  [2040] = {.lex_state = 14},
  [2041] = {.lex_state = 14},
  [2042] = {.lex_state = 27},
  [2043] = {.lex_state = 16},
  [2044] = {.lex_state = 16},
  [2045] = {.lex_state = 14},
  [2046] = {.lex_state = 14},
  [2047] = {.lex_state = 21},
  [2048] = {.lex_state = 17},
  [2049] = {.lex_state = 21},
  [2050] = {.lex_state = 16},
  [2051] = {.lex_state = 14},
  [2052] = {.lex_state = 14},
  [2053] = {.lex_state = 23},
  [2054] = {.lex_state = 14},
  [2055] = {.lex_state = 16},
  [2056] = {.lex_state = 16},
  [2057] = {.lex_state = 14},
  [2058] = {.lex_state = 14},
  [2059] = {.lex_state = 16},
  [2060] = {.lex_state = 27},
  [2061] = {.lex_state = 14},
  [2062] = {.lex_state = 14},
  [2063] = {.lex_state = 21},
  [2064] = {.lex_state = 17},
  [2065] = {.lex_state = 16},
  [2066] = {.lex_state = 14},
  [2067] = {.lex_state = 16},
  [2068] = {.lex_state = 17},
  [2069] = {.lex_state = 21},
  [2070] = {.lex_state = 14},
  [2071] = {.lex_state = 27},
  [2072] = {.lex_state = 16},
  [2073] = {.lex_state = 27},
  [2074] = {.lex_state = 14},
  [2075] = {.lex_state = 17},
  [2076] = {.lex_state = 27},
  [2077] = {.lex_state = 27},
  [2078] = {.lex_state = 16},
  [2079] = {.lex_state = 27},
  [2080] = {.lex_state = 27},
  [2081] = {.lex_state = 16},
  [2082] = {.lex_state = 10},
  [2083] = {.lex_state = 27},
  [2084] = {.lex_state = 27},
  [2085] = {.lex_state = 27},
  [2086] = {.lex_state = 27},
  [2087] = {.lex_state = 27},
  [2088] = {.lex_state = 14},
  [2089] = {.lex_state = 27},
  [2090] = {.lex_state = 14},
  [2091] = {.lex_state = 17},
  [2092] = {.lex_state = 27},
  [2093] = {.lex_state = 27},
  [2094] = {.lex_state = 27},
  [2095] = {.lex_state = 27},
  [2096] = {.lex_state = 27},
  [2097] = {.lex_state = 27},
  [2098] = {.lex_state = 27},
  [2099] = {.lex_state = 27},
  [2100] = {.lex_state = 27},
  [2101] = {.lex_state = 27},
  [2102] = {.lex_state = 27},
  [2103] = {.lex_state = 14},
  [2104] = {.lex_state = 27},
  [2105] = {.lex_state = 16},
  [2106] = {.lex_state = 27},
  [2107] = {.lex_state = 23},
  [2108] = {.lex_state = 23},
  [2109] = {.lex_state = 27},
  [2110] = {.lex_state = 27},
  [2111] = {.lex_state = 27},
  [2112] = {.lex_state = 27},
  [2113] = {.lex_state = 27},
  [2114] = {.lex_state = 27},
  [2115] = {.lex_state = 23},
  [2116] = {.lex_state = 23},
  [2117] = {.lex_state = 27},
  [2118] = {.lex_state = 27},
  [2119] = {.lex_state = 27},
  [2120] = {.lex_state = 27},
  [2121] = {.lex_state = 16},
  [2122] = {.lex_state = 27},
  [2123] = {.lex_state = 14},
  [2124] = {.lex_state = 14},
  [2125] = {.lex_state = 27},
  [2126] = {.lex_state = 27},
  [2127] = {.lex_state = 27},
  [2128] = {.lex_state = 14},
  [2129] = {.lex_state = 14},
  [2130] = {.lex_state = 6},
  [2131] = {.lex_state = 17},
  [2132] = {.lex_state = 17},
  [2133] = {.lex_state = 27},
  [2134] = {.lex_state = 14},
  [2135] = {.lex_state = 10},
  [2136] = {.lex_state = 27},
  [2137] = {.lex_state = 27},
  [2138] = {.lex_state = 14},
  [2139] = {.lex_state = 14},
  [2140] = {.lex_state = 14},
  [2141] = {.lex_state = 14},
  [2142] = {.lex_state = 14},
  [2143] = {.lex_state = 10},
  [2144] = {.lex_state = 23},
  [2145] = {.lex_state = 27},
  [2146] = {.lex_state = 27},
  [2147] = {.lex_state = 17},
  [2148] = {.lex_state = 10},
  [2149] = {.lex_state = 27},
  [2150] = {.lex_state = 16},
  [2151] = {.lex_state = 14},
  [2152] = {.lex_state = 17},
  [2153] = {.lex_state = 14},
  [2154] = {.lex_state = 14},
  [2155] = {.lex_state = 14},
  [2156] = {.lex_state = 14},
  [2157] = {.lex_state = 6},
  [2158] = {.lex_state = 70},
  [2159] = {.lex_state = 27},
  [2160] = {.lex_state = 14},
  [2161] = {.lex_state = 14},
  [2162] = {.lex_state = 14},
  [2163] = {.lex_state = 14},
  [2164] = {.lex_state = 14},
  [2165] = {.lex_state = 27},
  [2166] = {.lex_state = 17},
  [2167] = {.lex_state = 14},
  [2168] = {.lex_state = 14},
  [2169] = {.lex_state = 6},
  [2170] = {.lex_state = 10},
  [2171] = {.lex_state = 14},
  [2172] = {.lex_state = 14},
  [2173] = {.lex_state = 14},
  [2174] = {.lex_state = 14},
  [2175] = {.lex_state = 14},
  [2176] = {.lex_state = 14},
  [2177] = {.lex_state = 23},
  [2178] = {.lex_state = 14},
  [2179] = {.lex_state = 14},
  [2180] = {.lex_state = 23},
  [2181] = {.lex_state = 14},
  [2182] = {.lex_state = 23},
  [2183] = {.lex_state = 14},
  [2184] = {.lex_state = 14},
  [2185] = {.lex_state = 14},
  [2186] = {.lex_state = 14},
  [2187] = {.lex_state = 14},
  [2188] = {.lex_state = 14},
  [2189] = {.lex_state = 14},
  [2190] = {.lex_state = 14},
  [2191] = {.lex_state = 14},
  [2192] = {.lex_state = 23},
  [2193] = {.lex_state = 14},
  [2194] = {.lex_state = 14},
  [2195] = {.lex_state = 14},
  [2196] = {.lex_state = 14},
  [2197] = {.lex_state = 14},
  [2198] = {.lex_state = 14},
  [2199] = {.lex_state = 23},
  [2200] = {.lex_state = 23},
  [2201] = {.lex_state = 23},
  [2202] = {.lex_state = 23},
  [2203] = {.lex_state = 14},
  [2204] = {.lex_state = 23},
  [2205] = {.lex_state = 21},
  [2206] = {.lex_state = 14},
  [2207] = {.lex_state = 14},
  [2208] = {.lex_state = 14},
  [2209] = {.lex_state = 14},
  [2210] = {.lex_state = 14},
  [2211] = {.lex_state = 14},
  [2212] = {.lex_state = 10},
  [2213] = {.lex_state = 14},
  [2214] = {.lex_state = 14},
  [2215] = {.lex_state = 14},
  [2216] = {.lex_state = 14},
  [2217] = {.lex_state = 14},
  [2218] = {.lex_state = 14},
  [2219] = {.lex_state = 23},
  [2220] = {.lex_state = 14},
  [2221] = {.lex_state = 14},
  [2222] = {.lex_state = 14},
  [2223] = {.lex_state = 14},
  [2224] = {.lex_state = 14},
  [2225] = {.lex_state = 14},
  [2226] = {.lex_state = 23},
  [2227] = {.lex_state = 23},
  [2228] = {.lex_state = 14},
  [2229] = {.lex_state = 14},
  [2230] = {.lex_state = 14},
  [2231] = {.lex_state = 14},
  [2232] = {.lex_state = 70},
  [2233] = {.lex_state = 70},
  [2234] = {.lex_state = 70},
  [2235] = {.lex_state = 70},
  [2236] = {.lex_state = 70},
  [2237] = {.lex_state = 70},
  [2238] = {.lex_state = 14},
  [2239] = {.lex_state = 70},
  [2240] = {.lex_state = 70},
  [2241] = {.lex_state = 70},
  [2242] = {.lex_state = 14},
  [2243] = {.lex_state = 17},
  [2244] = {.lex_state = 70},
  [2245] = {.lex_state = 14},
  [2246] = {.lex_state = 70},
  [2247] = {.lex_state = 70},
  [2248] = {.lex_state = 3},
  [2249] = {.lex_state = 14},
  [2250] = {.lex_state = 70},
  [2251] = {.lex_state = 23},
  [2252] = {.lex_state = 70},
  [2253] = {.lex_state = 27},
  [2254] = {.lex_state = 23},
  [2255] = {.lex_state = 23},
  [2256] = {.lex_state = 23},
  [2257] = {.lex_state = 3},
  [2258] = {.lex_state = 27},
  [2259] = {.lex_state = 70},
  [2260] = {.lex_state = 14},
  [2261] = {.lex_state = 10},
  [2262] = {.lex_state = 70},
  [2263] = {.lex_state = 70},
  [2264] = {.lex_state = 70},
  [2265] = {.lex_state = 70},
  [2266] = {.lex_state = 70},
  [2267] = {.lex_state = 14},
  [2268] = {.lex_state = 23},
  [2269] = {.lex_state = 14},
  [2270] = {.lex_state = 23},
  [2271] = {.lex_state = 70},
  [2272] = {.lex_state = 70},
  [2273] = {.lex_state = 70},
  [2274] = {.lex_state = 70},
  [2275] = {.lex_state = 70},
  [2276] = {.lex_state = 23},
  [2277] = {.lex_state = 23},
  [2278] = {.lex_state = 70},
  [2279] = {.lex_state = 3},
  [2280] = {.lex_state = 10},
  [2281] = {.lex_state = 70},
  [2282] = {.lex_state = 70},
  [2283] = {.lex_state = 70},
  [2284] = {.lex_state = 14},
  [2285] = {.lex_state = 14},
  [2286] = {.lex_state = 167},
  [2287] = {.lex_state = 10},
  [2288] = {.lex_state = 14},
  [2289] = {.lex_state = 70},
  [2290] = {.lex_state = 14},
  [2291] = {.lex_state = 14},
  [2292] = {.lex_state = 14},
  [2293] = {.lex_state = 14},
  [2294] = {.lex_state = 14},
  [2295] = {.lex_state = 17},
  [2296] = {.lex_state = 14},
  [2297] = {.lex_state = 14},
  [2298] = {.lex_state = 14},
  [2299] = {.lex_state = 14},
  [2300] = {.lex_state = 27},
  [2301] = {.lex_state = 70},
  [2302] = {.lex_state = 14},
  [2303] = {.lex_state = 14},
  [2304] = {.lex_state = 23},
  [2305] = {.lex_state = 18},
  [2306] = {.lex_state = 70},
  [2307] = {.lex_state = 14},
  [2308] = {.lex_state = 14},
  [2309] = {.lex_state = 14},
  [2310] = {.lex_state = 14},
  [2311] = {.lex_state = 14},
  [2312] = {.lex_state = 27},
  [2313] = {.lex_state = 14},
  [2314] = {.lex_state = 14},
  [2315] = {.lex_state = 14},
  [2316] = {.lex_state = 14},
  [2317] = {.lex_state = 14},
  [2318] = {.lex_state = 17},
  [2319] = {.lex_state = 14},
  [2320] = {.lex_state = 14},
  [2321] = {.lex_state = 14},
  [2322] = {.lex_state = 14},
  [2323] = {.lex_state = 14},
  [2324] = {.lex_state = 3},
  [2325] = {.lex_state = 14},
  [2326] = {.lex_state = 14},
  [2327] = {.lex_state = 27},
  [2328] = {.lex_state = 14},
  [2329] = {.lex_state = 14},
  [2330] = {.lex_state = 14},
  [2331] = {.lex_state = 14},
  [2332] = {.lex_state = 14},
  [2333] = {.lex_state = 14},
  [2334] = {.lex_state = 3},
  [2335] = {.lex_state = 27},
  [2336] = {.lex_state = 14},
  [2337] = {.lex_state = 14},
  [2338] = {.lex_state = 27},
  [2339] = {.lex_state = 14},
  [2340] = {.lex_state = 27},
  [2341] = {.lex_state = 27},
  [2342] = {.lex_state = 14},
  [2343] = {.lex_state = 3},
  [2344] = {.lex_state = 17},
  [2345] = {.lex_state = 13},
  [2346] = {.lex_state = 18},
  [2347] = {.lex_state = 14},
  [2348] = {.lex_state = 18},
  [2349] = {.lex_state = 14},
  [2350] = {.lex_state = 27},
  [2351] = {.lex_state = 14},
  [2352] = {.lex_state = 14},
  [2353] = {.lex_state = 18},
  [2354] = {.lex_state = 13},
  [2355] = {.lex_state = 17},
  [2356] = {.lex_state = 17},
  [2357] = {.lex_state = 17},
  [2358] = {.lex_state = 14},
  [2359] = {.lex_state = 27},
  [2360] = {.lex_state = 14},
  [2361] = {.lex_state = 27},
  [2362] = {.lex_state = 27},
  [2363] = {.lex_state = 14},
  [2364] = {.lex_state = 27},
  [2365] = {.lex_state = 27},
  [2366] = {.lex_state = 17},
  [2367] = {.lex_state = 27},
  [2368] = {.lex_state = 3},
  [2369] = {.lex_state = 14},
  [2370] = {.lex_state = 27},
  [2371] = {.lex_state = 14},
  [2372] = {.lex_state = 14},
  [2373] = {.lex_state = 27},
  [2374] = {.lex_state = 14},
  [2375] = {.lex_state = 14},
  [2376] = {.lex_state = 14},
  [2377] = {.lex_state = 14},
  [2378] = {.lex_state = 14},
  [2379] = {.lex_state = 14},
  [2380] = {.lex_state = 14},
  [2381] = {.lex_state = 18},
  [2382] = {.lex_state = 27},
  [2383] = {.lex_state = 18},
  [2384] = {.lex_state = 27},
  [2385] = {.lex_state = 14},
  [2386] = {.lex_state = 14},
  [2387] = {.lex_state = 14},
  [2388] = {.lex_state = 14},
  [2389] = {.lex_state = 27},
  [2390] = {.lex_state = 10},
  [2391] = {.lex_state = 10},
  [2392] = {.lex_state = 14},
  [2393] = {.lex_state = 14},
  [2394] = {.lex_state = 70},
  [2395] = {.lex_state = 27},
  [2396] = {.lex_state = 6},
  [2397] = {.lex_state = 27},
  [2398] = {.lex_state = 27},
  [2399] = {.lex_state = 27},
  [2400] = {.lex_state = 10},
  [2401] = {.lex_state = 10},
  [2402] = {.lex_state = 70},
  [2403] = {.lex_state = 14},
  [2404] = {.lex_state = 10},
  [2405] = {.lex_state = 27},
  [2406] = {.lex_state = 10},
  [2407] = {.lex_state = 27},
  [2408] = {.lex_state = 27},
  [2409] = {.lex_state = 14},
  [2410] = {.lex_state = 10},
  [2411] = {.lex_state = 14},
  [2412] = {.lex_state = 14},
  [2413] = {.lex_state = 27},
  [2414] = {.lex_state = 27},
  [2415] = {.lex_state = 10},
  [2416] = {.lex_state = 10},
  [2417] = {.lex_state = 14},
  [2418] = {.lex_state = 10},
  [2419] = {.lex_state = 10},
  [2420] = {.lex_state = 14},
  [2421] = {.lex_state = 27},
  [2422] = {.lex_state = 3},
  [2423] = {.lex_state = 10},
  [2424] = {.lex_state = 10},
  [2425] = {.lex_state = 14},
  [2426] = {.lex_state = 27},
  [2427] = {.lex_state = 14},
  [2428] = {.lex_state = 27},
  [2429] = {.lex_state = 27},
  [2430] = {.lex_state = 27},
  [2431] = {.lex_state = 27},
  [2432] = {.lex_state = 27},
  [2433] = {.lex_state = 27},
  [2434] = {.lex_state = 27},
  [2435] = {.lex_state = 27},
  [2436] = {.lex_state = 27},
  [2437] = {.lex_state = 27},
  [2438] = {.lex_state = 6},
  [2439] = {.lex_state = 27},
  [2440] = {.lex_state = 14},
  [2441] = {.lex_state = 10},
  [2442] = {.lex_state = 14},
  [2443] = {.lex_state = 27},
  [2444] = {.lex_state = 10},
  [2445] = {.lex_state = 10},
  [2446] = {.lex_state = 27},
  [2447] = {.lex_state = 27},
  [2448] = {.lex_state = 6},
  [2449] = {.lex_state = 14},
  [2450] = {.lex_state = 10},
  [2451] = {.lex_state = 27},
  [2452] = {.lex_state = 14},
  [2453] = {.lex_state = 14},
  [2454] = {.lex_state = 14},
  [2455] = {.lex_state = 6},
  [2456] = {.lex_state = 10},
  [2457] = {.lex_state = 27},
  [2458] = {.lex_state = 10},
  [2459] = {.lex_state = 27},
  [2460] = {.lex_state = 10},
  [2461] = {.lex_state = 14},
  [2462] = {.lex_state = 27},
  [2463] = {.lex_state = 27},
  [2464] = {.lex_state = 10},
  [2465] = {.lex_state = 14},
  [2466] = {.lex_state = 27},
  [2467] = {.lex_state = 10},
  [2468] = {.lex_state = 14},
  [2469] = {.lex_state = 3},
  [2470] = {.lex_state = 27},
  [2471] = {.lex_state = 27},
  [2472] = {.lex_state = 14},
  [2473] = {.lex_state = 14},
  [2474] = {.lex_state = 27},
  [2475] = {.lex_state = 27},
  [2476] = {.lex_state = 10},
  [2477] = {.lex_state = 10},
  [2478] = {.lex_state = 10},
  [2479] = {.lex_state = 27},
  [2480] = {.lex_state = 10},
  [2481] = {.lex_state = 10},
  [2482] = {.lex_state = 27},
  [2483] = {.lex_state = 10},
  [2484] = {.lex_state = 10},
  [2485] = {.lex_state = 14},
  [2486] = {.lex_state = 10},
  [2487] = {.lex_state = 10},
  [2488] = {.lex_state = 10},
  [2489] = {.lex_state = 27},
  [2490] = {.lex_state = 10},
  [2491] = {.lex_state = 14},
  [2492] = {.lex_state = 14},
  [2493] = {.lex_state = 10, .external_lex_state = 3},
  [2494] = {.lex_state = 70},
  [2495] = {.lex_state = 14},
  [2496] = {.lex_state = 10, .external_lex_state = 4},
  [2497] = {.lex_state = 10},
  [2498] = {.lex_state = 10},
  [2499] = {.lex_state = 10},
  [2500] = {.lex_state = 10},
  [2501] = {.lex_state = 14},
  [2502] = {.lex_state = 70},
  [2503] = {.lex_state = 14},
  [2504] = {.lex_state = 14},
  [2505] = {.lex_state = 14},
  [2506] = {.lex_state = 10},
  [2507] = {.lex_state = 14},
  [2508] = {.lex_state = 6},
  [2509] = {.lex_state = 70},
  [2510] = {.lex_state = 6},
  [2511] = {.lex_state = 6},
  [2512] = {.lex_state = 16},
  [2513] = {.lex_state = 14},
  [2514] = {.lex_state = 10},
  [2515] = {.lex_state = 10},
  [2516] = {.lex_state = 70},
  [2517] = {.lex_state = 10},
  [2518] = {.lex_state = 6},
  [2519] = {.lex_state = 6},
  [2520] = {.lex_state = 10, .external_lex_state = 4},
  [2521] = {.lex_state = 10},
  [2522] = {.lex_state = 27},
  [2523] = {.lex_state = 10},
  [2524] = {.lex_state = 14},
  [2525] = {.lex_state = 17},
  [2526] = {.lex_state = 17},
  [2527] = {.lex_state = 17},
  [2528] = {.lex_state = 17},
  [2529] = {.lex_state = 10, .external_lex_state = 4},
  [2530] = {.lex_state = 70},
  [2531] = {.lex_state = 6},
  [2532] = {.lex_state = 6},
  [2533] = {.lex_state = 14},
  [2534] = {.lex_state = 17},
  [2535] = {.lex_state = 17},
  [2536] = {.lex_state = 17},
  [2537] = {.lex_state = 17},
  [2538] = {.lex_state = 6},
  [2539] = {.lex_state = 6},
  [2540] = {.lex_state = 10},
  [2541] = {.lex_state = 70},
  [2542] = {.lex_state = 14},
  [2543] = {.lex_state = 70},
  [2544] = {.lex_state = 14},
  [2545] = {.lex_state = 6},
  [2546] = {.lex_state = 10},
  [2547] = {.lex_state = 70},
  [2548] = {.lex_state = 6},
  [2549] = {.lex_state = 14},
  [2550] = {.lex_state = 6},
  [2551] = {.lex_state = 14},
  [2552] = {.lex_state = 29},
  [2553] = {.lex_state = 70},
  [2554] = {.lex_state = 6},
  [2555] = {.lex_state = 29},
  [2556] = {.lex_state = 70},
  [2557] = {.lex_state = 10},
  [2558] = {.lex_state = 14},
  [2559] = {.lex_state = 70},
  [2560] = {.lex_state = 70},
  [2561] = {.lex_state = 70},
  [2562] = {.lex_state = 10},
  [2563] = {.lex_state = 70},
  [2564] = {.lex_state = 70},
  [2565] = {.lex_state = 29},
  [2566] = {.lex_state = 27},
  [2567] = {.lex_state = 6},
  [2568] = {.lex_state = 70},
  [2569] = {.lex_state = 70},
  [2570] = {.lex_state = 27},
  [2571] = {.lex_state = 70},
  [2572] = {.lex_state = 10},
  [2573] = {.lex_state = 10},
  [2574] = {.lex_state = 70},
  [2575] = {.lex_state = 10},
  [2576] = {.lex_state = 10, .external_lex_state = 4},
  [2577] = {.lex_state = 10},
  [2578] = {.lex_state = 14},
  [2579] = {.lex_state = 10},
  [2580] = {.lex_state = 6},
  [2581] = {.lex_state = 10},
  [2582] = {.lex_state = 10},
  [2583] = {.lex_state = 14},
  [2584] = {.lex_state = 14},
  [2585] = {.lex_state = 27},
  [2586] = {.lex_state = 3},
  [2587] = {.lex_state = 10},
  [2588] = {.lex_state = 70},
  [2589] = {.lex_state = 14},
  [2590] = {.lex_state = 27},
  [2591] = {.lex_state = 10},
  [2592] = {.lex_state = 27},
  [2593] = {.lex_state = 10},
  [2594] = {.lex_state = 27},
  [2595] = {.lex_state = 10},
  [2596] = {.lex_state = 10},
  [2597] = {.lex_state = 29},
  [2598] = {.lex_state = 3},
  [2599] = {.lex_state = 10, .external_lex_state = 4},
  [2600] = {.lex_state = 10},
  [2601] = {.lex_state = 14},
  [2602] = {.lex_state = 10},
  [2603] = {.lex_state = 10, .external_lex_state = 4},
  [2604] = {.lex_state = 70},
  [2605] = {.lex_state = 14},
  [2606] = {.lex_state = 27},
  [2607] = {.lex_state = 3},
  [2608] = {.lex_state = 14},
  [2609] = {.lex_state = 10},
  [2610] = {.lex_state = 14},
  [2611] = {.lex_state = 10},
  [2612] = {.lex_state = 16},
  [2613] = {.lex_state = 70},
  [2614] = {.lex_state = 10},
  [2615] = {.lex_state = 14},
  [2616] = {.lex_state = 10},
  [2617] = {.lex_state = 10},
  [2618] = {.lex_state = 70},
  [2619] = {.lex_state = 6},
  [2620] = {.lex_state = 10},
  [2621] = {.lex_state = 10},
  [2622] = {.lex_state = 70},
  [2623] = {.lex_state = 3},
  [2624] = {.lex_state = 6},
  [2625] = {.lex_state = 10},
  [2626] = {.lex_state = 70},
  [2627] = {.lex_state = 10},
  [2628] = {.lex_state = 10},
  [2629] = {.lex_state = 10, .external_lex_state = 4},
  [2630] = {.lex_state = 14},
  [2631] = {.lex_state = 14},
  [2632] = {.lex_state = 16},
  [2633] = {.lex_state = 70},
  [2634] = {.lex_state = 10},
  [2635] = {.lex_state = 70},
  [2636] = {.lex_state = 10},
  [2637] = {.lex_state = 14},
  [2638] = {.lex_state = 70},
  [2639] = {.lex_state = 10},
  [2640] = {.lex_state = 10},
  [2641] = {.lex_state = 10},
  [2642] = {.lex_state = 10},
  [2643] = {.lex_state = 10},
  [2644] = {.lex_state = 14},
  [2645] = {.lex_state = 10},
  [2646] = {.lex_state = 70},
  [2647] = {.lex_state = 70},
  [2648] = {.lex_state = 10},
  [2649] = {.lex_state = 70},
  [2650] = {.lex_state = 10},
  [2651] = {.lex_state = 10},
  [2652] = {.lex_state = 10, .external_lex_state = 4},
  [2653] = {.lex_state = 10, .external_lex_state = 4},
  [2654] = {.lex_state = 10},
  [2655] = {.lex_state = 70},
  [2656] = {.lex_state = 10, .external_lex_state = 4},
  [2657] = {.lex_state = 27},
  [2658] = {.lex_state = 70},
  [2659] = {.lex_state = 6},
  [2660] = {.lex_state = 70},
  [2661] = {.lex_state = 6},
  [2662] = {.lex_state = 6},
  [2663] = {.lex_state = 10},
  [2664] = {.lex_state = 6},
  [2665] = {.lex_state = 6},
  [2666] = {.lex_state = 6},
  [2667] = {.lex_state = 70},
  [2668] = {.lex_state = 6},
  [2669] = {.lex_state = 6},
  [2670] = {.lex_state = 70},
  [2671] = {.lex_state = 10},
  [2672] = {.lex_state = 10, .external_lex_state = 4},
  [2673] = {.lex_state = 14},
  [2674] = {.lex_state = 10, .external_lex_state = 4},
  [2675] = {.lex_state = 70},
  [2676] = {.lex_state = 14},
  [2677] = {.lex_state = 6},
  [2678] = {.lex_state = 6},
  [2679] = {.lex_state = 70},
  [2680] = {.lex_state = 70},
  [2681] = {.lex_state = 70},
  [2682] = {.lex_state = 6},
  [2683] = {.lex_state = 70},
  [2684] = {.lex_state = 70},
  [2685] = {.lex_state = 10, .external_lex_state = 4},
  [2686] = {.lex_state = 10},
  [2687] = {.lex_state = 6},
  [2688] = {.lex_state = 70},
  [2689] = {.lex_state = 27},
  [2690] = {.lex_state = 6},
  [2691] = {.lex_state = 14},
  [2692] = {.lex_state = 6},
  [2693] = {.lex_state = 6},
  [2694] = {.lex_state = 70},
  [2695] = {.lex_state = 10},
  [2696] = {.lex_state = 6},
  [2697] = {.lex_state = 70},
  [2698] = {.lex_state = 6},
  [2699] = {.lex_state = 14},
  [2700] = {.lex_state = 6},
  [2701] = {.lex_state = 10},
  [2702] = {.lex_state = 27},
  [2703] = {.lex_state = 6},
  [2704] = {.lex_state = 6},
  [2705] = {.lex_state = 14},
  [2706] = {.lex_state = 14},
  [2707] = {.lex_state = 6},
  [2708] = {.lex_state = 6},
  [2709] = {.lex_state = 6},
  [2710] = {.lex_state = 14},
  [2711] = {.lex_state = 70},
  [2712] = {.lex_state = 6},
  [2713] = {.lex_state = 6},
  [2714] = {.lex_state = 6},
  [2715] = {.lex_state = 14},
  [2716] = {.lex_state = 14},
  [2717] = {.lex_state = 14},
  [2718] = {.lex_state = 6},
  [2719] = {.lex_state = 6},
  [2720] = {.lex_state = 70},
  [2721] = {.lex_state = 27},
  [2722] = {.lex_state = 6},
  [2723] = {.lex_state = 27},
  [2724] = {.lex_state = 3},
  [2725] = {.lex_state = 6},
  [2726] = {.lex_state = 10},
  [2727] = {.lex_state = 14},
  [2728] = {.lex_state = 70},
  [2729] = {.lex_state = 70},
  [2730] = {.lex_state = 14},
  [2731] = {.lex_state = 70},
  [2732] = {.lex_state = 6},
  [2733] = {.lex_state = 70},
  [2734] = {.lex_state = 14},
  [2735] = {.lex_state = 70},
  [2736] = {.lex_state = 70},
  [2737] = {.lex_state = 14},
  [2738] = {.lex_state = 70},
  [2739] = {.lex_state = 70},
  [2740] = {.lex_state = 14},
  [2741] = {.lex_state = 70},
  [2742] = {.lex_state = 70},
  [2743] = {.lex_state = 70},
  [2744] = {.lex_state = 6},
  [2745] = {.lex_state = 70},
  [2746] = {.lex_state = 70},
  [2747] = {.lex_state = 70},
  [2748] = {.lex_state = 18},
  [2749] = {.lex_state = 70},
  [2750] = {.lex_state = 70},
  [2751] = {.lex_state = 70},
  [2752] = {.lex_state = 6},
  [2753] = {.lex_state = 14},
  [2754] = {.lex_state = 6},
  [2755] = {.lex_state = 14},
  [2756] = {.lex_state = 70},
  [2757] = {.lex_state = 70},
  [2758] = {.lex_state = 14},
  [2759] = {.lex_state = 70},
  [2760] = {.lex_state = 70},
  [2761] = {.lex_state = 70},
  [2762] = {.lex_state = 70},
  [2763] = {.lex_state = 70},
  [2764] = {.lex_state = 70},
  [2765] = {.lex_state = 70},
  [2766] = {.lex_state = 70},
  [2767] = {.lex_state = 70},
  [2768] = {.lex_state = 70},
  [2769] = {.lex_state = 70},
  [2770] = {.lex_state = 70},
  [2771] = {.lex_state = 70},
  [2772] = {.lex_state = 10},
  [2773] = {.lex_state = 70},
  [2774] = {.lex_state = 70},
  [2775] = {.lex_state = 70},
  [2776] = {.lex_state = 6},
  [2777] = {.lex_state = 18},
  [2778] = {.lex_state = 70},
  [2779] = {.lex_state = 70},
  [2780] = {.lex_state = 70},
  [2781] = {.lex_state = 70},
  [2782] = {.lex_state = 70},
  [2783] = {.lex_state = 70},
  [2784] = {.lex_state = 70},
  [2785] = {.lex_state = 70},
  [2786] = {.lex_state = 70},
  [2787] = {.lex_state = 14},
  [2788] = {.lex_state = 70},
  [2789] = {.lex_state = 70},
  [2790] = {.lex_state = 70},
  [2791] = {.lex_state = 14},
  [2792] = {.lex_state = 70},
  [2793] = {.lex_state = 70},
  [2794] = {.lex_state = 70},
  [2795] = {.lex_state = 70},
  [2796] = {.lex_state = 70},
  [2797] = {.lex_state = 70},
  [2798] = {.lex_state = 14},
  [2799] = {.lex_state = 70},
  [2800] = {.lex_state = 14},
  [2801] = {.lex_state = 70},
  [2802] = {.lex_state = 70},
  [2803] = {.lex_state = 70},
  [2804] = {.lex_state = 70},
  [2805] = {.lex_state = 70},
  [2806] = {.lex_state = 70},
  [2807] = {.lex_state = 70},
  [2808] = {.lex_state = 10, .external_lex_state = 4},
  [2809] = {.lex_state = 70},
  [2810] = {.lex_state = 70},
  [2811] = {.lex_state = 70},
  [2812] = {.lex_state = 14},
  [2813] = {.lex_state = 70},
  [2814] = {.lex_state = 70},
  [2815] = {.lex_state = 70},
  [2816] = {.lex_state = 70},
  [2817] = {.lex_state = 70},
  [2818] = {.lex_state = 70},
  [2819] = {.lex_state = 70},
  [2820] = {.lex_state = 70},
  [2821] = {.lex_state = 70},
  [2822] = {.lex_state = 70},
  [2823] = {.lex_state = 70},
  [2824] = {.lex_state = 70},
  [2825] = {.lex_state = 70},
  [2826] = {.lex_state = 70},
  [2827] = {.lex_state = 70},
  [2828] = {.lex_state = 70},
  [2829] = {.lex_state = 70},
  [2830] = {.lex_state = 70},
  [2831] = {.lex_state = 10},
  [2832] = {.lex_state = 70},
  [2833] = {.lex_state = 70},
  [2834] = {.lex_state = 70},
  [2835] = {.lex_state = 70},
  [2836] = {.lex_state = 70},
  [2837] = {.lex_state = 70},
  [2838] = {.lex_state = 6},
  [2839] = {.lex_state = 14},
  [2840] = {.lex_state = 10},
  [2841] = {.lex_state = 70},
  [2842] = {.lex_state = 14},
  [2843] = {.lex_state = 14},
  [2844] = {.lex_state = 70},
  [2845] = {.lex_state = 6},
  [2846] = {.lex_state = 70},
  [2847] = {.lex_state = 14},
  [2848] = {.lex_state = 14},
  [2849] = {.lex_state = 70},
  [2850] = {.lex_state = 70},
  [2851] = {.lex_state = 70},
  [2852] = {.lex_state = 70},
  [2853] = {.lex_state = 70},
  [2854] = {.lex_state = 70},
  [2855] = {.lex_state = 70},
  [2856] = {.lex_state = 70},
  [2857] = {.lex_state = 70},
  [2858] = {.lex_state = 70},
  [2859] = {.lex_state = 14},
  [2860] = {.lex_state = 14},
  [2861] = {.lex_state = 70},
  [2862] = {.lex_state = 14},
  [2863] = {.lex_state = 6},
  [2864] = {.lex_state = 70},
  [2865] = {.lex_state = 70},
  [2866] = {.lex_state = 70},
  [2867] = {.lex_state = 70},
  [2868] = {.lex_state = 70},
  [2869] = {.lex_state = 70},
  [2870] = {.lex_state = 70},
  [2871] = {.lex_state = 70},
  [2872] = {.lex_state = 10},
  [2873] = {.lex_state = 70},
  [2874] = {.lex_state = 18},
  [2875] = {.lex_state = 70},
  [2876] = {.lex_state = 70},
  [2877] = {.lex_state = 70},
  [2878] = {.lex_state = 27},
  [2879] = {.lex_state = 70},
  [2880] = {.lex_state = 70},
  [2881] = {.lex_state = 70},
  [2882] = {.lex_state = 70},
  [2883] = {.lex_state = 70},
  [2884] = {.lex_state = 70},
  [2885] = {.lex_state = 70},
  [2886] = {.lex_state = 70},
  [2887] = {.lex_state = 70},
  [2888] = {.lex_state = 70},
  [2889] = {.lex_state = 70},
  [2890] = {.lex_state = 70},
  [2891] = {.lex_state = 70},
  [2892] = {.lex_state = 70},
  [2893] = {.lex_state = 70},
  [2894] = {.lex_state = 70},
  [2895] = {.lex_state = 18},
  [2896] = {.lex_state = 70},
  [2897] = {.lex_state = 70},
  [2898] = {.lex_state = 70},
  [2899] = {.lex_state = 70},
  [2900] = {.lex_state = 70},
  [2901] = {.lex_state = 70},
  [2902] = {.lex_state = 70},
  [2903] = {.lex_state = 70},
  [2904] = {.lex_state = 70},
  [2905] = {.lex_state = 70},
  [2906] = {.lex_state = 6},
  [2907] = {.lex_state = 70},
  [2908] = {.lex_state = 70},
  [2909] = {.lex_state = 70},
  [2910] = {.lex_state = 70},
  [2911] = {.lex_state = 70},
  [2912] = {.lex_state = 70},
  [2913] = {.lex_state = 70},
  [2914] = {.lex_state = 70},
  [2915] = {.lex_state = 70},
  [2916] = {.lex_state = 70},
  [2917] = {.lex_state = 70},
  [2918] = {.lex_state = 70},
  [2919] = {.lex_state = 70},
  [2920] = {.lex_state = 70},
  [2921] = {.lex_state = 70},
  [2922] = {.lex_state = 17},
  [2923] = {.lex_state = 70},
  [2924] = {.lex_state = 70},
  [2925] = {.lex_state = 70},
  [2926] = {.lex_state = 70},
  [2927] = {.lex_state = 70},
  [2928] = {.lex_state = 70},
  [2929] = {.lex_state = 70},
  [2930] = {.lex_state = 70},
  [2931] = {.lex_state = 14},
  [2932] = {.lex_state = 70},
  [2933] = {.lex_state = 70},
  [2934] = {.lex_state = 70},
  [2935] = {.lex_state = 70},
  [2936] = {.lex_state = 70},
  [2937] = {.lex_state = 70},
  [2938] = {.lex_state = 27},
  [2939] = {.lex_state = 17},
  [2940] = {.lex_state = 17},
  [2941] = {.lex_state = 17},
  [2942] = {.lex_state = 17},
  [2943] = {.lex_state = 70},
  [2944] = {.lex_state = 70},
  [2945] = {.lex_state = 70},
  [2946] = {.lex_state = 6},
  [2947] = {.lex_state = 14},
  [2948] = {.lex_state = 6},
  [2949] = {.lex_state = 17},
  [2950] = {.lex_state = 17},
  [2951] = {.lex_state = 70},
  [2952] = {.lex_state = 17},
  [2953] = {.lex_state = 70},
  [2954] = {.lex_state = 17},
  [2955] = {.lex_state = 17},
  [2956] = {.lex_state = 70},
  [2957] = {.lex_state = 70},
  [2958] = {.lex_state = 17},
  [2959] = {.lex_state = 17},
  [2960] = {.lex_state = 70},
  [2961] = {.lex_state = 17},
  [2962] = {.lex_state = 17},
  [2963] = {.lex_state = 17},
  [2964] = {.lex_state = 17},
  [2965] = {.lex_state = 14},
  [2966] = {.lex_state = 70},
  [2967] = {.lex_state = 70},
  [2968] = {.lex_state = 17},
  [2969] = {.lex_state = 17},
  [2970] = {.lex_state = 17},
  [2971] = {.lex_state = 18},
  [2972] = {.lex_state = 17},
  [2973] = {.lex_state = 17},
  [2974] = {.lex_state = 70},
  [2975] = {.lex_state = 70},
  [2976] = {.lex_state = 17},
  [2977] = {.lex_state = 70},
  [2978] = {.lex_state = 70},
  [2979] = {.lex_state = 70},
  [2980] = {.lex_state = 70},
  [2981] = {.lex_state = 70},
  [2982] = {.lex_state = 6},
  [2983] = {.lex_state = 70},
  [2984] = {.lex_state = 70},
  [2985] = {.lex_state = 70},
  [2986] = {.lex_state = 70},
  [2987] = {.lex_state = 70},
  [2988] = {.lex_state = 70},
  [2989] = {.lex_state = 17},
  [2990] = {.lex_state = 70},
  [2991] = {.lex_state = 70},
  [2992] = {.lex_state = 70},
  [2993] = {.lex_state = 17},
  [2994] = {.lex_state = 70},
  [2995] = {.lex_state = 17},
  [2996] = {.lex_state = 70},
  [2997] = {.lex_state = 70},
  [2998] = {.lex_state = 6},
  [2999] = {.lex_state = 70},
  [3000] = {.lex_state = 70},
  [3001] = {.lex_state = 17},
  [3002] = {.lex_state = 70},
  [3003] = {.lex_state = 17},
  [3004] = {.lex_state = 17},
  [3005] = {.lex_state = 17},
  [3006] = {.lex_state = 17},
  [3007] = {.lex_state = 14},
  [3008] = {.lex_state = 17},
  [3009] = {.lex_state = 14},
  [3010] = {.lex_state = 17},
  [3011] = {.lex_state = 17},
  [3012] = {.lex_state = 14},
  [3013] = {.lex_state = 70},
  [3014] = {.lex_state = 70},
  [3015] = {.lex_state = 70},
  [3016] = {.lex_state = 70},
  [3017] = {.lex_state = 70},
  [3018] = {.lex_state = 17},
  [3019] = {.lex_state = 70},
  [3020] = {.lex_state = 70},
  [3021] = {.lex_state = 70},
  [3022] = {.lex_state = 70},
  [3023] = {.lex_state = 70},
  [3024] = {.lex_state = 70},
  [3025] = {.lex_state = 17},
  [3026] = {.lex_state = 17},
  [3027] = {.lex_state = 17},
  [3028] = {.lex_state = 70},
  [3029] = {.lex_state = 70},
  [3030] = {.lex_state = 6},
  [3031] = {.lex_state = 14},
  [3032] = {.lex_state = 14},
  [3033] = {.lex_state = 14},
  [3034] = {.lex_state = 14},
  [3035] = {.lex_state = 27},
  [3036] = {.lex_state = 70},
  [3037] = {.lex_state = 14},
  [3038] = {.lex_state = 70},
  [3039] = {.lex_state = 70},
  [3040] = {.lex_state = 70},
  [3041] = {.lex_state = 70},
  [3042] = {.lex_state = 14},
  [3043] = {.lex_state = 70},
  [3044] = {.lex_state = 70},
  [3045] = {.lex_state = 14},
  [3046] = {.lex_state = 27},
  [3047] = {.lex_state = 27},
  [3048] = {.lex_state = 14},
  [3049] = {.lex_state = 14},
  [3050] = {.lex_state = 14},
  [3051] = {.lex_state = 14},
  [3052] = {.lex_state = 14},
  [3053] = {.lex_state = 14},
  [3054] = {.lex_state = 70},
  [3055] = {.lex_state = 70},
  [3056] = {.lex_state = 14},
  [3057] = {.lex_state = 70},
  [3058] = {.lex_state = 27},
  [3059] = {.lex_state = 70},
  [3060] = {.lex_state = 14},
  [3061] = {.lex_state = 14},
  [3062] = {.lex_state = 14},
  [3063] = {.lex_state = 14},
  [3064] = {.lex_state = 70},
  [3065] = {.lex_state = 70},
  [3066] = {.lex_state = 70},
  [3067] = {.lex_state = 70},
  [3068] = {.lex_state = 14},
  [3069] = {.lex_state = 14},
  [3070] = {.lex_state = 14},
  [3071] = {.lex_state = 14},
  [3072] = {.lex_state = 14},
  [3073] = {.lex_state = 70},
  [3074] = {.lex_state = 14},
  [3075] = {.lex_state = 70},
  [3076] = {.lex_state = 70},
  [3077] = {.lex_state = 14},
  [3078] = {.lex_state = 70},
  [3079] = {.lex_state = 70},
  [3080] = {.lex_state = 14},
  [3081] = {.lex_state = 14},
  [3082] = {.lex_state = 70},
  [3083] = {.lex_state = 70},
  [3084] = {.lex_state = 14},
  [3085] = {.lex_state = 14},
  [3086] = {.lex_state = 70},
  [3087] = {.lex_state = 14},
  [3088] = {.lex_state = 70},
  [3089] = {.lex_state = 70},
  [3090] = {.lex_state = 70},
  [3091] = {.lex_state = 14},
  [3092] = {.lex_state = 70},
  [3093] = {.lex_state = 70},
  [3094] = {.lex_state = 14},
  [3095] = {.lex_state = 14},
  [3096] = {.lex_state = 14},
  [3097] = {.lex_state = 70},
  [3098] = {.lex_state = 18},
  [3099] = {.lex_state = 14},
  [3100] = {.lex_state = 70},
  [3101] = {.lex_state = 14},
  [3102] = {.lex_state = 10, .external_lex_state = 5},
  [3103] = {.lex_state = 14},
  [3104] = {.lex_state = 14},
  [3105] = {.lex_state = 14},
  [3106] = {.lex_state = 10, .external_lex_state = 5},
  [3107] = {.lex_state = 70},
  [3108] = {.lex_state = 70},
  [3109] = {.lex_state = 10},
  [3110] = {.lex_state = 70},
  [3111] = {.lex_state = 70},
  [3112] = {.lex_state = 70},
  [3113] = {.lex_state = 10, .external_lex_state = 5},
  [3114] = {.lex_state = 70},
  [3115] = {.lex_state = 70},
  [3116] = {.lex_state = 70},
  [3117] = {.lex_state = 70},
  [3118] = {.lex_state = 70},
  [3119] = {.lex_state = 70},
  [3120] = {.lex_state = 14},
  [3121] = {.lex_state = 14},
  [3122] = {.lex_state = 14},
  [3123] = {.lex_state = 70, .external_lex_state = 6},
  [3124] = {.lex_state = 14},
  [3125] = {.lex_state = 27},
  [3126] = {.lex_state = 70},
  [3127] = {.lex_state = 70},
  [3128] = {.lex_state = 14},
  [3129] = {.lex_state = 70},
  [3130] = {.lex_state = 70},
  [3131] = {.lex_state = 70},
  [3132] = {.lex_state = 70},
  [3133] = {.lex_state = 70},
  [3134] = {.lex_state = 70},
  [3135] = {.lex_state = 14},
  [3136] = {.lex_state = 70},
  [3137] = {.lex_state = 27},
  [3138] = {.lex_state = 70},
  [3139] = {.lex_state = 70},
  [3140] = {.lex_state = 70},
  [3141] = {.lex_state = 70},
  [3142] = {.lex_state = 70},
  [3143] = {.lex_state = 70},
  [3144] = {.lex_state = 70},
  [3145] = {.lex_state = 70},
  [3146] = {.lex_state = 70},
  [3147] = {.lex_state = 70},
  [3148] = {.lex_state = 14},
  [3149] = {.lex_state = 70},
  [3150] = {.lex_state = 70},
  [3151] = {.lex_state = 70},
  [3152] = {.lex_state = 70},
  [3153] = {.lex_state = 70, .external_lex_state = 6},
  [3154] = {.lex_state = 70},
  [3155] = {.lex_state = 70},
  [3156] = {.lex_state = 14},
  [3157] = {.lex_state = 70},
  [3158] = {.lex_state = 14},
  [3159] = {.lex_state = 70},
  [3160] = {.lex_state = 70},
  [3161] = {.lex_state = 14},
  [3162] = {.lex_state = 14},
  [3163] = {.lex_state = 70},
  [3164] = {.lex_state = 70},
  [3165] = {.lex_state = 70},
  [3166] = {.lex_state = 14},
  [3167] = {.lex_state = 70},
  [3168] = {.lex_state = 70},
  [3169] = {.lex_state = 14},
  [3170] = {.lex_state = 70},
  [3171] = {.lex_state = 70},
  [3172] = {.lex_state = 70},
  [3173] = {.lex_state = 70},
  [3174] = {.lex_state = 14},
  [3175] = {.lex_state = 70},
  [3176] = {.lex_state = 5},
  [3177] = {.lex_state = 14},
  [3178] = {.lex_state = 14},
  [3179] = {.lex_state = 5},
  [3180] = {.lex_state = 70},
  [3181] = {.lex_state = 70},
  [3182] = {.lex_state = 70},
  [3183] = {.lex_state = 70},
  [3184] = {.lex_state = 70},
  [3185] = {.lex_state = 70},
  [3186] = {.lex_state = 70},
  [3187] = {.lex_state = 70},
  [3188] = {.lex_state = 14},
  [3189] = {.lex_state = 70},
  [3190] = {.lex_state = 14},
  [3191] = {.lex_state = 70},
  [3192] = {.lex_state = 14},
  [3193] = {.lex_state = 14},
  [3194] = {.lex_state = 70},
  [3195] = {.lex_state = 70},
  [3196] = {.lex_state = 70},
  [3197] = {.lex_state = 70},
  [3198] = {.lex_state = 70},
  [3199] = {.lex_state = 14},
  [3200] = {.lex_state = 70},
  [3201] = {.lex_state = 70},
  [3202] = {.lex_state = 70},
  [3203] = {.lex_state = 70},
  [3204] = {.lex_state = 70},
  [3205] = {.lex_state = 70},
  [3206] = {.lex_state = 70},
  [3207] = {.lex_state = 14},
  [3208] = {.lex_state = 14},
  [3209] = {.lex_state = 70},
  [3210] = {.lex_state = 70},
  [3211] = {.lex_state = 70},
  [3212] = {.lex_state = 14},
  [3213] = {.lex_state = 14},
  [3214] = {.lex_state = 70},
  [3215] = {.lex_state = 6},
  [3216] = {.lex_state = 70},
  [3217] = {.lex_state = 14},
  [3218] = {.lex_state = 14},
  [3219] = {.lex_state = 70},
  [3220] = {.lex_state = 6},
  [3221] = {.lex_state = 70},
  [3222] = {.lex_state = 70},
  [3223] = {.lex_state = 14},
  [3224] = {.lex_state = 70},
  [3225] = {.lex_state = 70},
  [3226] = {.lex_state = 70},
  [3227] = {.lex_state = 70},
  [3228] = {.lex_state = 14},
  [3229] = {.lex_state = 14},
  [3230] = {.lex_state = 70},
  [3231] = {.lex_state = 14},
  [3232] = {.lex_state = 14},
  [3233] = {.lex_state = 14},
  [3234] = {.lex_state = 14},
  [3235] = {.lex_state = 14},
  [3236] = {.lex_state = 70},
  [3237] = {.lex_state = 70},
  [3238] = {.lex_state = 14},
  [3239] = {.lex_state = 70},
  [3240] = {.lex_state = 14},
  [3241] = {.lex_state = 14},
  [3242] = {.lex_state = 70},
  [3243] = {.lex_state = 70},
  [3244] = {.lex_state = 70},
  [3245] = {.lex_state = 70},
  [3246] = {.lex_state = 70},
  [3247] = {.lex_state = 14},
  [3248] = {.lex_state = 70},
  [3249] = {.lex_state = 70},
  [3250] = {.lex_state = 14},
  [3251] = {.lex_state = 10},
  [3252] = {.lex_state = 70},
  [3253] = {.lex_state = 14},
  [3254] = {.lex_state = 70},
  [3255] = {.lex_state = 14},
  [3256] = {.lex_state = 14},
  [3257] = {.lex_state = 14},
  [3258] = {.lex_state = 70},
  [3259] = {.lex_state = 70},
  [3260] = {.lex_state = 70},
  [3261] = {.lex_state = 14},
  [3262] = {.lex_state = 14},
  [3263] = {.lex_state = 14},
  [3264] = {.lex_state = 14},
  [3265] = {.lex_state = 70},
  [3266] = {.lex_state = 70},
  [3267] = {.lex_state = 70},
  [3268] = {.lex_state = 70},
  [3269] = {.lex_state = 70},
  [3270] = {.lex_state = 70},
  [3271] = {.lex_state = 14},
  [3272] = {.lex_state = 70},
  [3273] = {.lex_state = 14},
  [3274] = {.lex_state = 70},
  [3275] = {.lex_state = 14},
  [3276] = {.lex_state = 14},
  [3277] = {.lex_state = 14},
  [3278] = {.lex_state = 70},
  [3279] = {.lex_state = 70},
  [3280] = {.lex_state = 70},
  [3281] = {.lex_state = 70},
  [3282] = {.lex_state = 14},
  [3283] = {.lex_state = 14},
  [3284] = {.lex_state = 70},
  [3285] = {.lex_state = 14},
  [3286] = {.lex_state = 14},
  [3287] = {.lex_state = 70},
  [3288] = {.lex_state = 14},
  [3289] = {.lex_state = 70},
  [3290] = {.lex_state = 14},
  [3291] = {.lex_state = 14},
  [3292] = {.lex_state = 70},
  [3293] = {.lex_state = 14},
  [3294] = {.lex_state = 14},
  [3295] = {.lex_state = 14},
  [3296] = {.lex_state = 14},
  [3297] = {.lex_state = 70},
  [3298] = {.lex_state = 14},
  [3299] = {.lex_state = 14},
  [3300] = {.lex_state = 70},
  [3301] = {.lex_state = 14},
  [3302] = {.lex_state = 14},
  [3303] = {.lex_state = 14},
  [3304] = {.lex_state = 70},
  [3305] = {.lex_state = 70},
  [3306] = {.lex_state = 14},
  [3307] = {.lex_state = 14},
  [3308] = {.lex_state = 70},
  [3309] = {.lex_state = 70},
  [3310] = {.lex_state = 70},
  [3311] = {.lex_state = 70},
  [3312] = {.lex_state = 70},
  [3313] = {.lex_state = 70},
  [3314] = {.lex_state = 14},
  [3315] = {.lex_state = 14},
  [3316] = {.lex_state = 14},
  [3317] = {.lex_state = 14},
  [3318] = {.lex_state = 14},
  [3319] = {.lex_state = 70},
  [3320] = {.lex_state = 70},
  [3321] = {.lex_state = 70, .external_lex_state = 7},
  [3322] = {.lex_state = 14},
  [3323] = {.lex_state = 70},
  [3324] = {.lex_state = 71},
  [3325] = {.lex_state = 70},
  [3326] = {.lex_state = 70},
  [3327] = {.lex_state = 14},
  [3328] = {.lex_state = 70},
  [3329] = {.lex_state = 70},
  [3330] = {.lex_state = 70},
  [3331] = {.lex_state = 70},
  [3332] = {.lex_state = 70},
  [3333] = {.lex_state = 70},
  [3334] = {.lex_state = 14},
  [3335] = {.lex_state = 70},
  [3336] = {.lex_state = 18},
  [3337] = {.lex_state = 70},
  [3338] = {.lex_state = 70},
  [3339] = {.lex_state = 14},
  [3340] = {.lex_state = 70},
  [3341] = {.lex_state = 70},
  [3342] = {.lex_state = 70},
  [3343] = {.lex_state = 70},
  [3344] = {.lex_state = 14},
  [3345] = {.lex_state = 70},
  [3346] = {.lex_state = 70},
  [3347] = {.lex_state = 14},
  [3348] = {.lex_state = 70},
  [3349] = {.lex_state = 70},
  [3350] = {.lex_state = 14},
  [3351] = {.lex_state = 70},
  [3352] = {.lex_state = 14},
  [3353] = {.lex_state = 14},
  [3354] = {.lex_state = 14},
  [3355] = {.lex_state = 14},
  [3356] = {.lex_state = 14},
  [3357] = {.lex_state = 18},
  [3358] = {.lex_state = 70},
  [3359] = {.lex_state = 70},
  [3360] = {.lex_state = 70},
  [3361] = {.lex_state = 70},
  [3362] = {.lex_state = 70},
  [3363] = {.lex_state = 70},
  [3364] = {.lex_state = 70},
  [3365] = {.lex_state = 70},
  [3366] = {.lex_state = 14},
  [3367] = {.lex_state = 70},
  [3368] = {.lex_state = 70},
  [3369] = {.lex_state = 70},
  [3370] = {.lex_state = 70},
  [3371] = {.lex_state = 70},
  [3372] = {.lex_state = 14},
  [3373] = {.lex_state = 70},
  [3374] = {.lex_state = 70},
  [3375] = {.lex_state = 70},
  [3376] = {.lex_state = 14},
  [3377] = {.lex_state = 70, .external_lex_state = 8},
  [3378] = {.lex_state = 70},
  [3379] = {.lex_state = 18},
  [3380] = {.lex_state = 70},
  [3381] = {.lex_state = 14},
  [3382] = {.lex_state = 70},
  [3383] = {.lex_state = 14},
  [3384] = {.lex_state = 70},
  [3385] = {.lex_state = 70},
  [3386] = {.lex_state = 70},
  [3387] = {.lex_state = 18},
  [3388] = {.lex_state = 70},
  [3389] = {.lex_state = 70},
  [3390] = {.lex_state = 70},
  [3391] = {.lex_state = 14},
  [3392] = {.lex_state = 14},
  [3393] = {.lex_state = 70},
  [3394] = {.lex_state = 70},
  [3395] = {.lex_state = 70},
  [3396] = {.lex_state = 10},
  [3397] = {.lex_state = 70},
  [3398] = {.lex_state = 70},
  [3399] = {.lex_state = 71},
  [3400] = {.lex_state = 70},
  [3401] = {.lex_state = 70},
  [3402] = {.lex_state = 14},
  [3403] = {.lex_state = 14},
  [3404] = {.lex_state = 70},
  [3405] = {.lex_state = 70},
  [3406] = {.lex_state = 70},
  [3407] = {.lex_state = 70},
  [3408] = {.lex_state = 70, .external_lex_state = 8},
  [3409] = {.lex_state = 14},
  [3410] = {.lex_state = 14},
  [3411] = {.lex_state = 14},
  [3412] = {.lex_state = 14},
  [3413] = {.lex_state = 70},
  [3414] = {.lex_state = 14},
  [3415] = {.lex_state = 14},
  [3416] = {.lex_state = 70},
  [3417] = {.lex_state = 71},
  [3418] = {.lex_state = 70},
  [3419] = {.lex_state = 70},
  [3420] = {.lex_state = 70},
  [3421] = {.lex_state = 70},
  [3422] = {.lex_state = 70},
  [3423] = {.lex_state = 14},
  [3424] = {.lex_state = 70},
  [3425] = {.lex_state = 14},
  [3426] = {.lex_state = 70},
  [3427] = {.lex_state = 14},
  [3428] = {.lex_state = 70},
  [3429] = {.lex_state = 70},
  [3430] = {.lex_state = 70},
  [3431] = {.lex_state = 70},
  [3432] = {.lex_state = 70},
  [3433] = {.lex_state = 70},
  [3434] = {.lex_state = 70},
  [3435] = {.lex_state = 71},
  [3436] = {.lex_state = 71},
  [3437] = {.lex_state = 14},
  [3438] = {.lex_state = 70},
  [3439] = {.lex_state = 14},
  [3440] = {.lex_state = 18},
  [3441] = {.lex_state = 14},
  [3442] = {.lex_state = 14},
  [3443] = {.lex_state = 70, .external_lex_state = 8},
  [3444] = {.lex_state = 70},
  [3445] = {.lex_state = 14},
  [3446] = {.lex_state = 14},
  [3447] = {.lex_state = 14},
  [3448] = {.lex_state = 14},
  [3449] = {.lex_state = 70},
  [3450] = {.lex_state = 70},
  [3451] = {.lex_state = 70},
  [3452] = {.lex_state = 70},
  [3453] = {.lex_state = 14},
  [3454] = {.lex_state = 70},
  [3455] = {.lex_state = 70},
  [3456] = {.lex_state = 18},
  [3457] = {.lex_state = 18},
  [3458] = {.lex_state = 70},
  [3459] = {.lex_state = 70},
  [3460] = {.lex_state = 70},
  [3461] = {.lex_state = 70},
  [3462] = {.lex_state = 70},
  [3463] = {.lex_state = 70},
  [3464] = {.lex_state = 70},
  [3465] = {.lex_state = 18},
  [3466] = {.lex_state = 70},
  [3467] = {.lex_state = 70, .external_lex_state = 7},
  [3468] = {.lex_state = 14},
  [3469] = {.lex_state = 70},
  [3470] = {.lex_state = 70},
  [3471] = {.lex_state = 70},
  [3472] = {.lex_state = 70},
  [3473] = {.lex_state = 70},
  [3474] = {.lex_state = 14},
  [3475] = {.lex_state = 70},
  [3476] = {.lex_state = 70},
  [3477] = {.lex_state = 70},
  [3478] = {.lex_state = 70},
  [3479] = {.lex_state = 70, .external_lex_state = 8},
  [3480] = {.lex_state = 14},
  [3481] = {.lex_state = 70},
  [3482] = {.lex_state = 70},
  [3483] = {.lex_state = 70},
  [3484] = {.lex_state = 70},
  [3485] = {.lex_state = 70},
  [3486] = {.lex_state = 70},
  [3487] = {.lex_state = 70},
  [3488] = {.lex_state = 70},
  [3489] = {.lex_state = 70},
  [3490] = {.lex_state = 70},
  [3491] = {.lex_state = 14},
  [3492] = {.lex_state = 70, .external_lex_state = 7},
  [3493] = {.lex_state = 70},
  [3494] = {.lex_state = 18},
  [3495] = {.lex_state = 14},
  [3496] = {.lex_state = 70},
  [3497] = {.lex_state = 70},
  [3498] = {.lex_state = 70},
  [3499] = {.lex_state = 70},
  [3500] = {.lex_state = 70},
  [3501] = {.lex_state = 70},
  [3502] = {.lex_state = 70, .external_lex_state = 7},
  [3503] = {.lex_state = 70},
  [3504] = {.lex_state = 70},
  [3505] = {.lex_state = 70},
  [3506] = {.lex_state = 70},
  [3507] = {.lex_state = 70},
  [3508] = {.lex_state = 14},
  [3509] = {.lex_state = 70},
  [3510] = {.lex_state = 70},
  [3511] = {.lex_state = 70, .external_lex_state = 8},
  [3512] = {.lex_state = 70},
  [3513] = {.lex_state = 70},
  [3514] = {.lex_state = 14},
  [3515] = {.lex_state = 70},
  [3516] = {.lex_state = 70},
  [3517] = {.lex_state = 14},
  [3518] = {.lex_state = 10},
  [3519] = {.lex_state = 14},
  [3520] = {.lex_state = 71},
  [3521] = {.lex_state = 70, .external_lex_state = 7},
  [3522] = {.lex_state = 70},
  [3523] = {.lex_state = 14},
  [3524] = {.lex_state = 70},
  [3525] = {.lex_state = 70, .external_lex_state = 9},
  [3526] = {.lex_state = 70},
  [3527] = {.lex_state = 70, .external_lex_state = 7},
  [3528] = {.lex_state = 70},
  [3529] = {.lex_state = 70},
  [3530] = {.lex_state = 70},
  [3531] = {.lex_state = 70},
  [3532] = {.lex_state = 70},
  [3533] = {.lex_state = 70},
  [3534] = {.lex_state = 70},
  [3535] = {.lex_state = 70},
  [3536] = {.lex_state = 70},
  [3537] = {.lex_state = 70},
  [3538] = {.lex_state = 70},
  [3539] = {.lex_state = 70},
  [3540] = {.lex_state = 70},
  [3541] = {.lex_state = 70},
  [3542] = {.lex_state = 70, .external_lex_state = 9},
  [3543] = {.lex_state = 18},
  [3544] = {.lex_state = 70},
  [3545] = {.lex_state = 70, .external_lex_state = 9},
  [3546] = {.lex_state = 70},
  [3547] = {.lex_state = 18},
  [3548] = {.lex_state = 18},
  [3549] = {.lex_state = 14},
  [3550] = {.lex_state = 70, .external_lex_state = 9},
  [3551] = {.lex_state = 70, .external_lex_state = 9},
  [3552] = {.lex_state = 70},
  [3553] = {.lex_state = 18},
  [3554] = {.lex_state = 18},
  [3555] = {.lex_state = 165},
  [3556] = {.lex_state = 18},
  [3557] = {.lex_state = 70},
  [3558] = {.lex_state = 70},
  [3559] = {.lex_state = 70},
  [3560] = {.lex_state = 14},
  [3561] = {.lex_state = 71},
  [3562] = {.lex_state = 70},
  [3563] = {.lex_state = 18},
  [3564] = {.lex_state = 14},
  [3565] = {.lex_state = 70},
  [3566] = {.lex_state = 70},
  [3567] = {.lex_state = 18},
  [3568] = {.lex_state = 70},
  [3569] = {.lex_state = 70},
  [3570] = {.lex_state = 70},
  [3571] = {.lex_state = 18},
  [3572] = {.lex_state = 70},
  [3573] = {.lex_state = 18},
  [3574] = {.lex_state = 70},
  [3575] = {.lex_state = 70},
  [3576] = {.lex_state = 70},
  [3577] = {.lex_state = 14},
  [3578] = {.lex_state = 70},
  [3579] = {.lex_state = 70},
  [3580] = {.lex_state = 70},
  [3581] = {.lex_state = 14},
  [3582] = {.lex_state = 70, .external_lex_state = 8},
  [3583] = {.lex_state = 70},
  [3584] = {.lex_state = 70},
  [3585] = {.lex_state = 18},
  [3586] = {.lex_state = 70},
  [3587] = {.lex_state = 18},
  [3588] = {.lex_state = 70},
  [3589] = {.lex_state = 70},
  [3590] = {.lex_state = 18},
  [3591] = {.lex_state = 14},
  [3592] = {.lex_state = 70},
  [3593] = {.lex_state = 18},
  [3594] = {.lex_state = 18},
  [3595] = {.lex_state = 18},
  [3596] = {.lex_state = 70},
  [3597] = {.lex_state = 18},
  [3598] = {.lex_state = 18},
  [3599] = {.lex_state = 18},
  [3600] = {.lex_state = 14},
  [3601] = {.lex_state = 14},
  [3602] = {.lex_state = 14},
  [3603] = {.lex_state = 70},
  [3604] = {.lex_state = 14},
  [3605] = {.lex_state = 14},
  [3606] = {.lex_state = 70},
  [3607] = {.lex_state = 14},
  [3608] = {.lex_state = 14},
  [3609] = {.lex_state = 14},
  [3610] = {.lex_state = 14},
  [3611] = {.lex_state = 71},
  [3612] = {.lex_state = 70},
  [3613] = {(TSStateId)(-1)},
  [3614] = {(TSStateId)(-1)},
  [3615] = {(TSStateId)(-1)},
  [3616] = {(TSStateId)(-1)},
  [3617] = {(TSStateId)(-1)},
  [3618] = {(TSStateId)(-1)},
  [3619] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_line_comment] = STATE(0),
    [sym_block_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_macro_rules_BANG] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_block] = ACTIONS(1),
    [anon_sym_expr] = ACTIONS(1),
    [anon_sym_ident] = ACTIONS(1),
    [anon_sym_item] = ACTIONS(1),
    [anon_sym_lifetime] = ACTIONS(1),
    [anon_sym_literal] = ACTIONS(1),
    [anon_sym_meta] = ACTIONS(1),
    [anon_sym_pat] = ACTIONS(1),
    [anon_sym_path] = ACTIONS(1),
    [anon_sym_stmt] = ACTIONS(1),
    [anon_sym_tt] = ACTIONS(1),
    [anon_sym_ty] = ACTIONS(1),
    [anon_sym_vis] = ACTIONS(1),
    [anon_sym_u8] = ACTIONS(1),
    [anon_sym_i8] = ACTIONS(1),
    [anon_sym_u16] = ACTIONS(1),
    [anon_sym_i16] = ACTIONS(1),
    [anon_sym_u32] = ACTIONS(1),
    [anon_sym_i32] = ACTIONS(1),
    [anon_sym_u64] = ACTIONS(1),
    [anon_sym_i64] = ACTIONS(1),
    [anon_sym_u128] = ACTIONS(1),
    [anon_sym_i128] = ACTIONS(1),
    [anon_sym_isize] = ACTIONS(1),
    [anon_sym_usize] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f64] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_str] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_impl] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_pub] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_dyn] = ACTIONS(1),
    [sym_mutable_specifier] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_move] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [aux_sym_string_literal_token1] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_char_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_BANG2] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [sym_shebang] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_crate] = ACTIONS(1),
    [sym_metavariable] = ACTIONS(1),
    [sym_string_content] = ACTIONS(1),
    [sym__raw_string_literal_start] = ACTIONS(1),
    [sym_raw_string_literal_content] = ACTIONS(1),
    [sym__raw_string_literal_end] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym__outer_block_doc_comment_marker] = ACTIONS(1),
    [sym__inner_block_doc_comment_marker] = ACTIONS(1),
    [sym__block_comment_content] = ACTIONS(1),
    [sym__line_doc_content] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(3565),
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1858),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(1),
    [sym_block_comment] = STATE(1),
    [aux_sym_source_file_repeat1] = STATE(8),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(35),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_shebang] = ACTIONS(105),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [2] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1746),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(2),
    [sym_block_comment] = STATE(2),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [3] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1824),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(3),
    [sym_block_comment] = STATE(3),
    [aux_sym_source_file_repeat1] = STATE(23),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(121),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [4] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1858),
    [sym_macro_invocation] = STATE(403),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(4),
    [sym_block_comment] = STATE(4),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(123),
    [anon_sym_SEMI] = ACTIONS(126),
    [anon_sym_macro_rules_BANG] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(132),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(138),
    [anon_sym_RBRACE] = ACTIONS(141),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(146),
    [anon_sym_i8] = ACTIONS(146),
    [anon_sym_u16] = ACTIONS(146),
    [anon_sym_i16] = ACTIONS(146),
    [anon_sym_u32] = ACTIONS(146),
    [anon_sym_i32] = ACTIONS(146),
    [anon_sym_u64] = ACTIONS(146),
    [anon_sym_i64] = ACTIONS(146),
    [anon_sym_u128] = ACTIONS(146),
    [anon_sym_i128] = ACTIONS(146),
    [anon_sym_isize] = ACTIONS(146),
    [anon_sym_usize] = ACTIONS(146),
    [anon_sym_f32] = ACTIONS(146),
    [anon_sym_f64] = ACTIONS(146),
    [anon_sym_bool] = ACTIONS(146),
    [anon_sym_str] = ACTIONS(146),
    [anon_sym_char] = ACTIONS(146),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_DOT_DOT] = ACTIONS(158),
    [anon_sym_COLON_COLON] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_SQUOTE] = ACTIONS(167),
    [anon_sym_async] = ACTIONS(170),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(176),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_default] = ACTIONS(182),
    [anon_sym_enum] = ACTIONS(185),
    [anon_sym_fn] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_impl] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(200),
    [anon_sym_loop] = ACTIONS(203),
    [anon_sym_match] = ACTIONS(206),
    [anon_sym_mod] = ACTIONS(209),
    [anon_sym_pub] = ACTIONS(212),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_struct] = ACTIONS(221),
    [anon_sym_trait] = ACTIONS(224),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_union] = ACTIONS(230),
    [anon_sym_unsafe] = ACTIONS(233),
    [anon_sym_use] = ACTIONS(236),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_extern] = ACTIONS(242),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_move] = ACTIONS(248),
    [anon_sym_try] = ACTIONS(251),
    [sym_integer_literal] = ACTIONS(254),
    [aux_sym_string_literal_token1] = ACTIONS(257),
    [sym_char_literal] = ACTIONS(254),
    [anon_sym_true] = ACTIONS(260),
    [anon_sym_false] = ACTIONS(260),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(263),
    [sym_super] = ACTIONS(266),
    [sym_crate] = ACTIONS(269),
    [sym_metavariable] = ACTIONS(272),
    [sym__raw_string_literal_start] = ACTIONS(275),
    [sym_float_literal] = ACTIONS(254),
  },
  [5] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1707),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(5),
    [sym_block_comment] = STATE(5),
    [aux_sym_source_file_repeat1] = STATE(11),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(278),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [6] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1656),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(6),
    [sym_block_comment] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(280),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [7] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1722),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(7),
    [sym_block_comment] = STATE(7),
    [aux_sym_source_file_repeat1] = STATE(17),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(282),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [8] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1858),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(8),
    [sym_block_comment] = STATE(8),
    [aux_sym_source_file_repeat1] = STATE(33),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [ts_builtin_sym_end] = ACTIONS(284),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [9] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1650),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(9),
    [sym_block_comment] = STATE(9),
    [aux_sym_source_file_repeat1] = STATE(30),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(286),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [10] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1803),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(10),
    [sym_block_comment] = STATE(10),
    [aux_sym_source_file_repeat1] = STATE(31),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(288),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [11] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1704),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(11),
    [sym_block_comment] = STATE(11),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(290),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [12] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1791),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(12),
    [sym_block_comment] = STATE(12),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(292),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [13] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1778),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(13),
    [sym_block_comment] = STATE(13),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [14] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1637),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(14),
    [sym_block_comment] = STATE(14),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(296),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [15] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1728),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(15),
    [sym_block_comment] = STATE(15),
    [aux_sym_source_file_repeat1] = STATE(18),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(298),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [16] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1636),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(16),
    [sym_block_comment] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(13),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [17] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1709),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(17),
    [sym_block_comment] = STATE(17),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [18] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1724),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(18),
    [sym_block_comment] = STATE(18),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(304),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [19] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1735),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(19),
    [sym_block_comment] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(306),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [20] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1744),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(20),
    [sym_block_comment] = STATE(20),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [21] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1790),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(21),
    [sym_block_comment] = STATE(21),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(310),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [22] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1836),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(22),
    [sym_block_comment] = STATE(22),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(312),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [23] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1675),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(23),
    [sym_block_comment] = STATE(23),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [24] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1829),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(24),
    [sym_block_comment] = STATE(24),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(316),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [25] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1661),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(25),
    [sym_block_comment] = STATE(25),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(318),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [26] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1819),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(26),
    [sym_block_comment] = STATE(26),
    [aux_sym_source_file_repeat1] = STATE(14),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(320),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [27] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1858),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(27),
    [sym_block_comment] = STATE(27),
    [aux_sym_source_file_repeat1] = STATE(33),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [ts_builtin_sym_end] = ACTIONS(322),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [28] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1757),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(28),
    [sym_block_comment] = STATE(28),
    [aux_sym_source_file_repeat1] = STATE(2),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(324),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [29] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1768),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(29),
    [sym_block_comment] = STATE(29),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(326),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [30] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1663),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(30),
    [sym_block_comment] = STATE(30),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(328),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [31] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1676),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(31),
    [sym_block_comment] = STATE(31),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(330),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [32] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1792),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(32),
    [sym_block_comment] = STATE(32),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(332),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [33] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1858),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(33),
    [sym_block_comment] = STATE(33),
    [aux_sym_source_file_repeat1] = STATE(33),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym_identifier] = ACTIONS(123),
    [anon_sym_SEMI] = ACTIONS(126),
    [anon_sym_macro_rules_BANG] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(132),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(138),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(146),
    [anon_sym_i8] = ACTIONS(146),
    [anon_sym_u16] = ACTIONS(146),
    [anon_sym_i16] = ACTIONS(146),
    [anon_sym_u32] = ACTIONS(146),
    [anon_sym_i32] = ACTIONS(146),
    [anon_sym_u64] = ACTIONS(146),
    [anon_sym_i64] = ACTIONS(146),
    [anon_sym_u128] = ACTIONS(146),
    [anon_sym_i128] = ACTIONS(146),
    [anon_sym_isize] = ACTIONS(146),
    [anon_sym_usize] = ACTIONS(146),
    [anon_sym_f32] = ACTIONS(146),
    [anon_sym_f64] = ACTIONS(146),
    [anon_sym_bool] = ACTIONS(146),
    [anon_sym_str] = ACTIONS(146),
    [anon_sym_char] = ACTIONS(146),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_DOT_DOT] = ACTIONS(158),
    [anon_sym_COLON_COLON] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_SQUOTE] = ACTIONS(167),
    [anon_sym_async] = ACTIONS(170),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_const] = ACTIONS(176),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_default] = ACTIONS(182),
    [anon_sym_enum] = ACTIONS(185),
    [anon_sym_fn] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_impl] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(200),
    [anon_sym_loop] = ACTIONS(203),
    [anon_sym_match] = ACTIONS(206),
    [anon_sym_mod] = ACTIONS(209),
    [anon_sym_pub] = ACTIONS(212),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_struct] = ACTIONS(221),
    [anon_sym_trait] = ACTIONS(224),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_union] = ACTIONS(230),
    [anon_sym_unsafe] = ACTIONS(233),
    [anon_sym_use] = ACTIONS(236),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_extern] = ACTIONS(242),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_move] = ACTIONS(248),
    [anon_sym_try] = ACTIONS(251),
    [sym_integer_literal] = ACTIONS(254),
    [aux_sym_string_literal_token1] = ACTIONS(257),
    [sym_char_literal] = ACTIONS(254),
    [anon_sym_true] = ACTIONS(260),
    [anon_sym_false] = ACTIONS(260),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(263),
    [sym_super] = ACTIONS(266),
    [sym_crate] = ACTIONS(269),
    [sym_metavariable] = ACTIONS(272),
    [sym__raw_string_literal_start] = ACTIONS(275),
    [sym_float_literal] = ACTIONS(254),
  },
  [34] = {
    [sym__statement] = STATE(599),
    [sym_empty_statement] = STATE(605),
    [sym_expression_statement] = STATE(605),
    [sym_macro_definition] = STATE(605),
    [sym_attribute_item] = STATE(605),
    [sym_inner_attribute_item] = STATE(605),
    [sym_mod_item] = STATE(605),
    [sym_foreign_mod_item] = STATE(605),
    [sym_struct_item] = STATE(605),
    [sym_union_item] = STATE(605),
    [sym_enum_item] = STATE(605),
    [sym_extern_crate_declaration] = STATE(605),
    [sym_const_item] = STATE(605),
    [sym_static_item] = STATE(605),
    [sym_type_item] = STATE(605),
    [sym_function_item] = STATE(605),
    [sym_function_signature_item] = STATE(605),
    [sym_function_modifiers] = STATE(3564),
    [sym_impl_item] = STATE(605),
    [sym_trait_item] = STATE(605),
    [sym_associated_type] = STATE(605),
    [sym_let_declaration] = STATE(605),
    [sym_use_declaration] = STATE(605),
    [sym_extern_modifier] = STATE(2138),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1858),
    [sym_macro_invocation] = STATE(391),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(387),
    [sym_match_expression] = STATE(387),
    [sym_while_expression] = STATE(387),
    [sym_loop_expression] = STATE(387),
    [sym_for_expression] = STATE(387),
    [sym_const_block] = STATE(387),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3556),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(387),
    [sym_async_block] = STATE(387),
    [sym_try_block] = STATE(387),
    [sym_block] = STATE(387),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(34),
    [sym_block_comment] = STATE(34),
    [aux_sym_source_file_repeat1] = STATE(27),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [ts_builtin_sym_end] = ACTIONS(284),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [35] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1487),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(35),
    [sym_block_comment] = STATE(35),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(336),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_RPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_RBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COMMA] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(342),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [36] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1485),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(36),
    [sym_block_comment] = STATE(36),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(344),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(374),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(370),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [37] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1490),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(37),
    [sym_block_comment] = STATE(37),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(380),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_RPAREN] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_RBRACK] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(382),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PERCENT] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_PLUS_EQ] = ACTIONS(380),
    [anon_sym_DASH_EQ] = ACTIONS(380),
    [anon_sym_STAR_EQ] = ACTIONS(380),
    [anon_sym_SLASH_EQ] = ACTIONS(380),
    [anon_sym_PERCENT_EQ] = ACTIONS(380),
    [anon_sym_CARET_EQ] = ACTIONS(380),
    [anon_sym_AMP_EQ] = ACTIONS(380),
    [anon_sym_PIPE_EQ] = ACTIONS(380),
    [anon_sym_LT_LT_EQ] = ACTIONS(380),
    [anon_sym_GT_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(380),
    [anon_sym_COMMA] = ACTIONS(380),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(382),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [38] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1489),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(35),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(38),
    [sym_block_comment] = STATE(38),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(384),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_RPAREN] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(384),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_STAR] = ACTIONS(386),
    [anon_sym_QMARK] = ACTIONS(384),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_SLASH] = ACTIONS(386),
    [anon_sym_PERCENT] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(386),
    [anon_sym_PIPE] = ACTIONS(386),
    [anon_sym_AMP_AMP] = ACTIONS(384),
    [anon_sym_PIPE_PIPE] = ACTIONS(384),
    [anon_sym_LT_LT] = ACTIONS(386),
    [anon_sym_GT_GT] = ACTIONS(386),
    [anon_sym_PLUS_EQ] = ACTIONS(384),
    [anon_sym_DASH_EQ] = ACTIONS(384),
    [anon_sym_STAR_EQ] = ACTIONS(384),
    [anon_sym_SLASH_EQ] = ACTIONS(384),
    [anon_sym_PERCENT_EQ] = ACTIONS(384),
    [anon_sym_CARET_EQ] = ACTIONS(384),
    [anon_sym_AMP_EQ] = ACTIONS(384),
    [anon_sym_PIPE_EQ] = ACTIONS(384),
    [anon_sym_LT_LT_EQ] = ACTIONS(384),
    [anon_sym_GT_GT_EQ] = ACTIONS(384),
    [anon_sym_EQ] = ACTIONS(386),
    [anon_sym_EQ_EQ] = ACTIONS(384),
    [anon_sym_BANG_EQ] = ACTIONS(384),
    [anon_sym_GT] = ACTIONS(386),
    [anon_sym_LT] = ACTIONS(386),
    [anon_sym_GT_EQ] = ACTIONS(384),
    [anon_sym_LT_EQ] = ACTIONS(384),
    [anon_sym_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(384),
    [anon_sym_COMMA] = ACTIONS(384),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(388),
    [anon_sym_as] = ACTIONS(386),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(386),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [39] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1490),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(39),
    [sym_block_comment] = STATE(39),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(380),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_RBRACK] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(382),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PERCENT] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_PLUS_EQ] = ACTIONS(380),
    [anon_sym_DASH_EQ] = ACTIONS(380),
    [anon_sym_STAR_EQ] = ACTIONS(380),
    [anon_sym_SLASH_EQ] = ACTIONS(380),
    [anon_sym_PERCENT_EQ] = ACTIONS(380),
    [anon_sym_CARET_EQ] = ACTIONS(380),
    [anon_sym_AMP_EQ] = ACTIONS(380),
    [anon_sym_PIPE_EQ] = ACTIONS(380),
    [anon_sym_LT_LT_EQ] = ACTIONS(380),
    [anon_sym_GT_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(380),
    [anon_sym_COMMA] = ACTIONS(380),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(382),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [40] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1505),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(40),
    [sym_block_comment] = STATE(40),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(390),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(390),
    [anon_sym_RBRACK] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(392),
    [anon_sym_QMARK] = ACTIONS(390),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(392),
    [anon_sym_SLASH] = ACTIONS(392),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(390),
    [anon_sym_DASH_EQ] = ACTIONS(390),
    [anon_sym_STAR_EQ] = ACTIONS(390),
    [anon_sym_SLASH_EQ] = ACTIONS(390),
    [anon_sym_PERCENT_EQ] = ACTIONS(390),
    [anon_sym_CARET_EQ] = ACTIONS(390),
    [anon_sym_AMP_EQ] = ACTIONS(390),
    [anon_sym_PIPE_EQ] = ACTIONS(390),
    [anon_sym_LT_LT_EQ] = ACTIONS(390),
    [anon_sym_GT_GT_EQ] = ACTIONS(390),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(390),
    [anon_sym_BANG_EQ] = ACTIONS(390),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT_EQ] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(390),
    [anon_sym_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(390),
    [anon_sym_COMMA] = ACTIONS(390),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(392),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(392),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [41] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1486),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(41),
    [sym_block_comment] = STATE(41),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(344),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(374),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(396),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [42] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1505),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(42),
    [sym_block_comment] = STATE(42),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(390),
    [anon_sym_LPAREN] = ACTIONS(390),
    [anon_sym_RPAREN] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(390),
    [anon_sym_RBRACK] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(392),
    [anon_sym_QMARK] = ACTIONS(390),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(392),
    [anon_sym_SLASH] = ACTIONS(392),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(390),
    [anon_sym_DASH_EQ] = ACTIONS(390),
    [anon_sym_STAR_EQ] = ACTIONS(390),
    [anon_sym_SLASH_EQ] = ACTIONS(390),
    [anon_sym_PERCENT_EQ] = ACTIONS(390),
    [anon_sym_CARET_EQ] = ACTIONS(390),
    [anon_sym_AMP_EQ] = ACTIONS(390),
    [anon_sym_PIPE_EQ] = ACTIONS(390),
    [anon_sym_LT_LT_EQ] = ACTIONS(390),
    [anon_sym_GT_GT_EQ] = ACTIONS(390),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(390),
    [anon_sym_BANG_EQ] = ACTIONS(390),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT_EQ] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(390),
    [anon_sym_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(390),
    [anon_sym_COMMA] = ACTIONS(390),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(392),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(392),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [43] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1784),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(43),
    [sym_block_comment] = STATE(43),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [44] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1745),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(44),
    [sym_block_comment] = STATE(44),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(374),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [45] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1716),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(45),
    [sym_block_comment] = STATE(45),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(392),
    [anon_sym_QMARK] = ACTIONS(390),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(392),
    [anon_sym_SLASH] = ACTIONS(392),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(390),
    [anon_sym_DASH_EQ] = ACTIONS(390),
    [anon_sym_STAR_EQ] = ACTIONS(390),
    [anon_sym_SLASH_EQ] = ACTIONS(390),
    [anon_sym_PERCENT_EQ] = ACTIONS(390),
    [anon_sym_CARET_EQ] = ACTIONS(390),
    [anon_sym_AMP_EQ] = ACTIONS(390),
    [anon_sym_PIPE_EQ] = ACTIONS(390),
    [anon_sym_LT_LT_EQ] = ACTIONS(390),
    [anon_sym_GT_GT_EQ] = ACTIONS(390),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(390),
    [anon_sym_BANG_EQ] = ACTIONS(390),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT_EQ] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(390),
    [anon_sym_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(390),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(392),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [46] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1734),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(43),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(46),
    [sym_block_comment] = STATE(46),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_STAR] = ACTIONS(386),
    [anon_sym_QMARK] = ACTIONS(384),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_SLASH] = ACTIONS(386),
    [anon_sym_PERCENT] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(386),
    [anon_sym_PIPE] = ACTIONS(386),
    [anon_sym_AMP_AMP] = ACTIONS(384),
    [anon_sym_PIPE_PIPE] = ACTIONS(384),
    [anon_sym_LT_LT] = ACTIONS(386),
    [anon_sym_GT_GT] = ACTIONS(386),
    [anon_sym_PLUS_EQ] = ACTIONS(384),
    [anon_sym_DASH_EQ] = ACTIONS(384),
    [anon_sym_STAR_EQ] = ACTIONS(384),
    [anon_sym_SLASH_EQ] = ACTIONS(384),
    [anon_sym_PERCENT_EQ] = ACTIONS(384),
    [anon_sym_CARET_EQ] = ACTIONS(384),
    [anon_sym_AMP_EQ] = ACTIONS(384),
    [anon_sym_PIPE_EQ] = ACTIONS(384),
    [anon_sym_LT_LT_EQ] = ACTIONS(384),
    [anon_sym_GT_GT_EQ] = ACTIONS(384),
    [anon_sym_EQ] = ACTIONS(386),
    [anon_sym_EQ_EQ] = ACTIONS(384),
    [anon_sym_BANG_EQ] = ACTIONS(384),
    [anon_sym_GT] = ACTIONS(386),
    [anon_sym_LT] = ACTIONS(386),
    [anon_sym_GT_EQ] = ACTIONS(384),
    [anon_sym_LT_EQ] = ACTIONS(384),
    [anon_sym_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(384),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(464),
    [anon_sym_as] = ACTIONS(386),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [47] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1787),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(47),
    [sym_block_comment] = STATE(47),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [48] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1729),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(48),
    [sym_block_comment] = STATE(48),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(382),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PERCENT] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_PLUS_EQ] = ACTIONS(380),
    [anon_sym_DASH_EQ] = ACTIONS(380),
    [anon_sym_STAR_EQ] = ACTIONS(380),
    [anon_sym_SLASH_EQ] = ACTIONS(380),
    [anon_sym_PERCENT_EQ] = ACTIONS(380),
    [anon_sym_CARET_EQ] = ACTIONS(380),
    [anon_sym_AMP_EQ] = ACTIONS(380),
    [anon_sym_PIPE_EQ] = ACTIONS(380),
    [anon_sym_LT_LT_EQ] = ACTIONS(380),
    [anon_sym_GT_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(380),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [49] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1619),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(49),
    [sym_block_comment] = STATE(49),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(342),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [50] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1742),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(50),
    [sym_block_comment] = STATE(50),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(374),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [51] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1716),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(51),
    [sym_block_comment] = STATE(51),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(392),
    [anon_sym_QMARK] = ACTIONS(390),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(392),
    [anon_sym_SLASH] = ACTIONS(392),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(390),
    [anon_sym_DASH_EQ] = ACTIONS(390),
    [anon_sym_STAR_EQ] = ACTIONS(390),
    [anon_sym_SLASH_EQ] = ACTIONS(390),
    [anon_sym_PERCENT_EQ] = ACTIONS(390),
    [anon_sym_CARET_EQ] = ACTIONS(390),
    [anon_sym_AMP_EQ] = ACTIONS(390),
    [anon_sym_PIPE_EQ] = ACTIONS(390),
    [anon_sym_LT_LT_EQ] = ACTIONS(390),
    [anon_sym_GT_GT_EQ] = ACTIONS(390),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(390),
    [anon_sym_BANG_EQ] = ACTIONS(390),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT_EQ] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(390),
    [anon_sym_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(390),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(392),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [52] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1729),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(52),
    [sym_block_comment] = STATE(52),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(382),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PERCENT] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_PLUS_EQ] = ACTIONS(380),
    [anon_sym_DASH_EQ] = ACTIONS(380),
    [anon_sym_STAR_EQ] = ACTIONS(380),
    [anon_sym_SLASH_EQ] = ACTIONS(380),
    [anon_sym_PERCENT_EQ] = ACTIONS(380),
    [anon_sym_CARET_EQ] = ACTIONS(380),
    [anon_sym_AMP_EQ] = ACTIONS(380),
    [anon_sym_PIPE_EQ] = ACTIONS(380),
    [anon_sym_LT_LT_EQ] = ACTIONS(380),
    [anon_sym_GT_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(380),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [53] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1578),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(53),
    [sym_block_comment] = STATE(53),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(374),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [54] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1615),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(49),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(54),
    [sym_block_comment] = STATE(54),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_LBRACE] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_STAR] = ACTIONS(386),
    [anon_sym_QMARK] = ACTIONS(384),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_SLASH] = ACTIONS(386),
    [anon_sym_PERCENT] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(386),
    [anon_sym_PIPE] = ACTIONS(386),
    [anon_sym_AMP_AMP] = ACTIONS(384),
    [anon_sym_PIPE_PIPE] = ACTIONS(384),
    [anon_sym_LT_LT] = ACTIONS(386),
    [anon_sym_GT_GT] = ACTIONS(386),
    [anon_sym_PLUS_EQ] = ACTIONS(384),
    [anon_sym_DASH_EQ] = ACTIONS(384),
    [anon_sym_STAR_EQ] = ACTIONS(384),
    [anon_sym_SLASH_EQ] = ACTIONS(384),
    [anon_sym_PERCENT_EQ] = ACTIONS(384),
    [anon_sym_CARET_EQ] = ACTIONS(384),
    [anon_sym_AMP_EQ] = ACTIONS(384),
    [anon_sym_PIPE_EQ] = ACTIONS(384),
    [anon_sym_LT_LT_EQ] = ACTIONS(384),
    [anon_sym_GT_GT_EQ] = ACTIONS(384),
    [anon_sym_EQ] = ACTIONS(386),
    [anon_sym_EQ_EQ] = ACTIONS(384),
    [anon_sym_BANG_EQ] = ACTIONS(384),
    [anon_sym_GT] = ACTIONS(386),
    [anon_sym_LT] = ACTIONS(386),
    [anon_sym_GT_EQ] = ACTIONS(384),
    [anon_sym_LT_EQ] = ACTIONS(384),
    [anon_sym_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(384),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(386),
    [anon_sym_as] = ACTIONS(386),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [55] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1602),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(55),
    [sym_block_comment] = STATE(55),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(392),
    [anon_sym_QMARK] = ACTIONS(390),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(392),
    [anon_sym_SLASH] = ACTIONS(392),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(390),
    [anon_sym_DASH_EQ] = ACTIONS(390),
    [anon_sym_STAR_EQ] = ACTIONS(390),
    [anon_sym_SLASH_EQ] = ACTIONS(390),
    [anon_sym_PERCENT_EQ] = ACTIONS(390),
    [anon_sym_CARET_EQ] = ACTIONS(390),
    [anon_sym_AMP_EQ] = ACTIONS(390),
    [anon_sym_PIPE_EQ] = ACTIONS(390),
    [anon_sym_LT_LT_EQ] = ACTIONS(390),
    [anon_sym_GT_GT_EQ] = ACTIONS(390),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(390),
    [anon_sym_BANG_EQ] = ACTIONS(390),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT_EQ] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(390),
    [anon_sym_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(390),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(392),
    [anon_sym_as] = ACTIONS(392),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [56] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1795),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(56),
    [sym_block_comment] = STATE(56),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(392),
    [anon_sym_QMARK] = ACTIONS(390),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(392),
    [anon_sym_SLASH] = ACTIONS(392),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(390),
    [anon_sym_DASH_EQ] = ACTIONS(390),
    [anon_sym_STAR_EQ] = ACTIONS(390),
    [anon_sym_SLASH_EQ] = ACTIONS(390),
    [anon_sym_PERCENT_EQ] = ACTIONS(390),
    [anon_sym_CARET_EQ] = ACTIONS(390),
    [anon_sym_AMP_EQ] = ACTIONS(390),
    [anon_sym_PIPE_EQ] = ACTIONS(390),
    [anon_sym_LT_LT_EQ] = ACTIONS(390),
    [anon_sym_GT_GT_EQ] = ACTIONS(390),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(390),
    [anon_sym_BANG_EQ] = ACTIONS(390),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT_EQ] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(390),
    [anon_sym_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(390),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(392),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [57] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1602),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(57),
    [sym_block_comment] = STATE(57),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(392),
    [anon_sym_QMARK] = ACTIONS(390),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(392),
    [anon_sym_SLASH] = ACTIONS(392),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(390),
    [anon_sym_DASH_EQ] = ACTIONS(390),
    [anon_sym_STAR_EQ] = ACTIONS(390),
    [anon_sym_SLASH_EQ] = ACTIONS(390),
    [anon_sym_PERCENT_EQ] = ACTIONS(390),
    [anon_sym_CARET_EQ] = ACTIONS(390),
    [anon_sym_AMP_EQ] = ACTIONS(390),
    [anon_sym_PIPE_EQ] = ACTIONS(390),
    [anon_sym_LT_LT_EQ] = ACTIONS(390),
    [anon_sym_GT_GT_EQ] = ACTIONS(390),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(390),
    [anon_sym_BANG_EQ] = ACTIONS(390),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT_EQ] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(390),
    [anon_sym_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(390),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(392),
    [anon_sym_as] = ACTIONS(392),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [58] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1606),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(58),
    [sym_block_comment] = STATE(58),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(374),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [59] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1770),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(59),
    [sym_block_comment] = STATE(59),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(374),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [60] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1795),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(60),
    [sym_block_comment] = STATE(60),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(392),
    [anon_sym_QMARK] = ACTIONS(390),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(392),
    [anon_sym_SLASH] = ACTIONS(392),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(390),
    [anon_sym_PIPE_PIPE] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(390),
    [anon_sym_DASH_EQ] = ACTIONS(390),
    [anon_sym_STAR_EQ] = ACTIONS(390),
    [anon_sym_SLASH_EQ] = ACTIONS(390),
    [anon_sym_PERCENT_EQ] = ACTIONS(390),
    [anon_sym_CARET_EQ] = ACTIONS(390),
    [anon_sym_AMP_EQ] = ACTIONS(390),
    [anon_sym_PIPE_EQ] = ACTIONS(390),
    [anon_sym_LT_LT_EQ] = ACTIONS(390),
    [anon_sym_GT_GT_EQ] = ACTIONS(390),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(390),
    [anon_sym_BANG_EQ] = ACTIONS(390),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_GT_EQ] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(390),
    [anon_sym_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(390),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(392),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [61] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1620),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(61),
    [sym_block_comment] = STATE(61),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(382),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PERCENT] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_PLUS_EQ] = ACTIONS(380),
    [anon_sym_DASH_EQ] = ACTIONS(380),
    [anon_sym_STAR_EQ] = ACTIONS(380),
    [anon_sym_SLASH_EQ] = ACTIONS(380),
    [anon_sym_PERCENT_EQ] = ACTIONS(380),
    [anon_sym_CARET_EQ] = ACTIONS(380),
    [anon_sym_AMP_EQ] = ACTIONS(380),
    [anon_sym_PIPE_EQ] = ACTIONS(380),
    [anon_sym_LT_LT_EQ] = ACTIONS(380),
    [anon_sym_GT_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(380),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(382),
    [anon_sym_as] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [62] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1740),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(62),
    [sym_block_comment] = STATE(62),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(382),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PERCENT] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_PLUS_EQ] = ACTIONS(380),
    [anon_sym_DASH_EQ] = ACTIONS(380),
    [anon_sym_STAR_EQ] = ACTIONS(380),
    [anon_sym_SLASH_EQ] = ACTIONS(380),
    [anon_sym_PERCENT_EQ] = ACTIONS(380),
    [anon_sym_CARET_EQ] = ACTIONS(380),
    [anon_sym_AMP_EQ] = ACTIONS(380),
    [anon_sym_PIPE_EQ] = ACTIONS(380),
    [anon_sym_LT_LT_EQ] = ACTIONS(380),
    [anon_sym_GT_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(380),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [63] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1740),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(63),
    [sym_block_comment] = STATE(63),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(382),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PERCENT] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_PLUS_EQ] = ACTIONS(380),
    [anon_sym_DASH_EQ] = ACTIONS(380),
    [anon_sym_STAR_EQ] = ACTIONS(380),
    [anon_sym_SLASH_EQ] = ACTIONS(380),
    [anon_sym_PERCENT_EQ] = ACTIONS(380),
    [anon_sym_CARET_EQ] = ACTIONS(380),
    [anon_sym_AMP_EQ] = ACTIONS(380),
    [anon_sym_PIPE_EQ] = ACTIONS(380),
    [anon_sym_LT_LT_EQ] = ACTIONS(380),
    [anon_sym_GT_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(380),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [64] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1620),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(64),
    [sym_block_comment] = STATE(64),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_STAR] = ACTIONS(382),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PERCENT] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_PLUS_EQ] = ACTIONS(380),
    [anon_sym_DASH_EQ] = ACTIONS(380),
    [anon_sym_STAR_EQ] = ACTIONS(380),
    [anon_sym_SLASH_EQ] = ACTIONS(380),
    [anon_sym_PERCENT_EQ] = ACTIONS(380),
    [anon_sym_CARET_EQ] = ACTIONS(380),
    [anon_sym_AMP_EQ] = ACTIONS(380),
    [anon_sym_PIPE_EQ] = ACTIONS(380),
    [anon_sym_LT_LT_EQ] = ACTIONS(380),
    [anon_sym_GT_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(380),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(382),
    [anon_sym_as] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [65] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1750),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(47),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(65),
    [sym_block_comment] = STATE(65),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_LBRACE] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_STAR] = ACTIONS(386),
    [anon_sym_QMARK] = ACTIONS(384),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_SLASH] = ACTIONS(386),
    [anon_sym_PERCENT] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(386),
    [anon_sym_PIPE] = ACTIONS(386),
    [anon_sym_AMP_AMP] = ACTIONS(384),
    [anon_sym_PIPE_PIPE] = ACTIONS(384),
    [anon_sym_LT_LT] = ACTIONS(386),
    [anon_sym_GT_GT] = ACTIONS(386),
    [anon_sym_PLUS_EQ] = ACTIONS(384),
    [anon_sym_DASH_EQ] = ACTIONS(384),
    [anon_sym_STAR_EQ] = ACTIONS(384),
    [anon_sym_SLASH_EQ] = ACTIONS(384),
    [anon_sym_PERCENT_EQ] = ACTIONS(384),
    [anon_sym_CARET_EQ] = ACTIONS(384),
    [anon_sym_AMP_EQ] = ACTIONS(384),
    [anon_sym_PIPE_EQ] = ACTIONS(384),
    [anon_sym_LT_LT_EQ] = ACTIONS(384),
    [anon_sym_GT_GT_EQ] = ACTIONS(384),
    [anon_sym_EQ] = ACTIONS(386),
    [anon_sym_EQ_EQ] = ACTIONS(384),
    [anon_sym_BANG_EQ] = ACTIONS(384),
    [anon_sym_GT] = ACTIONS(386),
    [anon_sym_LT] = ACTIONS(386),
    [anon_sym_GT_EQ] = ACTIONS(384),
    [anon_sym_LT_EQ] = ACTIONS(384),
    [anon_sym_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(384),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(388),
    [anon_sym_as] = ACTIONS(386),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [66] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1765),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(66),
    [sym_block_comment] = STATE(66),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(374),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [67] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(67),
    [sym_block_comment] = STATE(67),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(514),
    [anon_sym_SEMI] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(520),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(531),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_u8] = ACTIONS(514),
    [anon_sym_i8] = ACTIONS(514),
    [anon_sym_u16] = ACTIONS(514),
    [anon_sym_i16] = ACTIONS(514),
    [anon_sym_u32] = ACTIONS(514),
    [anon_sym_i32] = ACTIONS(514),
    [anon_sym_u64] = ACTIONS(514),
    [anon_sym_i64] = ACTIONS(514),
    [anon_sym_u128] = ACTIONS(514),
    [anon_sym_i128] = ACTIONS(514),
    [anon_sym_isize] = ACTIONS(514),
    [anon_sym_usize] = ACTIONS(514),
    [anon_sym_f32] = ACTIONS(514),
    [anon_sym_f64] = ACTIONS(514),
    [anon_sym_bool] = ACTIONS(514),
    [anon_sym_str] = ACTIONS(514),
    [anon_sym_char] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(531),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_PERCENT] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_AMP] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_PIPE_PIPE] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(531),
    [anon_sym_GT_GT] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(517),
    [anon_sym_DASH_EQ] = ACTIONS(517),
    [anon_sym_STAR_EQ] = ACTIONS(517),
    [anon_sym_SLASH_EQ] = ACTIONS(517),
    [anon_sym_PERCENT_EQ] = ACTIONS(517),
    [anon_sym_CARET_EQ] = ACTIONS(517),
    [anon_sym_AMP_EQ] = ACTIONS(517),
    [anon_sym_PIPE_EQ] = ACTIONS(517),
    [anon_sym_LT_LT_EQ] = ACTIONS(517),
    [anon_sym_GT_GT_EQ] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(517),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym__] = ACTIONS(531),
    [anon_sym_DOT] = ACTIONS(531),
    [anon_sym_DOT_DOT] = ACTIONS(531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(517),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(517),
    [anon_sym_DASH_GT] = ACTIONS(517),
    [anon_sym_POUND] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(514),
    [anon_sym_as] = ACTIONS(514),
    [anon_sym_async] = ACTIONS(514),
    [anon_sym_await] = ACTIONS(514),
    [anon_sym_break] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_continue] = ACTIONS(514),
    [anon_sym_default] = ACTIONS(514),
    [anon_sym_enum] = ACTIONS(514),
    [anon_sym_fn] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(514),
    [anon_sym_impl] = ACTIONS(514),
    [anon_sym_let] = ACTIONS(514),
    [anon_sym_loop] = ACTIONS(514),
    [anon_sym_match] = ACTIONS(514),
    [anon_sym_mod] = ACTIONS(514),
    [anon_sym_pub] = ACTIONS(514),
    [anon_sym_return] = ACTIONS(514),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_struct] = ACTIONS(514),
    [anon_sym_trait] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(514),
    [anon_sym_union] = ACTIONS(514),
    [anon_sym_unsafe] = ACTIONS(514),
    [anon_sym_use] = ACTIONS(514),
    [anon_sym_where] = ACTIONS(514),
    [anon_sym_while] = ACTIONS(514),
    [sym_mutable_specifier] = ACTIONS(514),
    [sym_integer_literal] = ACTIONS(537),
    [aux_sym_string_literal_token1] = ACTIONS(540),
    [sym_char_literal] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(543),
    [anon_sym_false] = ACTIONS(543),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(514),
    [sym_super] = ACTIONS(514),
    [sym_crate] = ACTIONS(514),
    [sym_metavariable] = ACTIONS(546),
    [sym__raw_string_literal_start] = ACTIONS(549),
    [sym_float_literal] = ACTIONS(537),
  },
  [68] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(68),
    [sym_block_comment] = STATE(68),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [69] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(69),
    [sym_block_comment] = STATE(69),
    [aux_sym_token_tree_pattern_repeat1] = STATE(71),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [70] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(70),
    [sym_block_comment] = STATE(70),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [71] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(71),
    [sym_block_comment] = STATE(71),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(580),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [72] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(72),
    [sym_block_comment] = STATE(72),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [73] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(73),
    [sym_block_comment] = STATE(73),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_RBRACE] = ACTIONS(580),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [74] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(74),
    [sym_block_comment] = STATE(74),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_SEMI] = ACTIONS(587),
    [anon_sym_LPAREN] = ACTIONS(590),
    [anon_sym_RPAREN] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(593),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_RBRACE] = ACTIONS(593),
    [anon_sym_EQ_GT] = ACTIONS(587),
    [anon_sym_COLON] = ACTIONS(601),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_STAR] = ACTIONS(601),
    [anon_sym_QMARK] = ACTIONS(587),
    [anon_sym_u8] = ACTIONS(584),
    [anon_sym_i8] = ACTIONS(584),
    [anon_sym_u16] = ACTIONS(584),
    [anon_sym_i16] = ACTIONS(584),
    [anon_sym_u32] = ACTIONS(584),
    [anon_sym_i32] = ACTIONS(584),
    [anon_sym_u64] = ACTIONS(584),
    [anon_sym_i64] = ACTIONS(584),
    [anon_sym_u128] = ACTIONS(584),
    [anon_sym_i128] = ACTIONS(584),
    [anon_sym_isize] = ACTIONS(584),
    [anon_sym_usize] = ACTIONS(584),
    [anon_sym_f32] = ACTIONS(584),
    [anon_sym_f64] = ACTIONS(584),
    [anon_sym_bool] = ACTIONS(584),
    [anon_sym_str] = ACTIONS(584),
    [anon_sym_char] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_SLASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(601),
    [anon_sym_CARET] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(601),
    [anon_sym_AMP] = ACTIONS(601),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(587),
    [anon_sym_PIPE_PIPE] = ACTIONS(587),
    [anon_sym_LT_LT] = ACTIONS(601),
    [anon_sym_GT_GT] = ACTIONS(601),
    [anon_sym_PLUS_EQ] = ACTIONS(587),
    [anon_sym_DASH_EQ] = ACTIONS(587),
    [anon_sym_STAR_EQ] = ACTIONS(587),
    [anon_sym_SLASH_EQ] = ACTIONS(587),
    [anon_sym_PERCENT_EQ] = ACTIONS(587),
    [anon_sym_CARET_EQ] = ACTIONS(587),
    [anon_sym_AMP_EQ] = ACTIONS(587),
    [anon_sym_PIPE_EQ] = ACTIONS(587),
    [anon_sym_LT_LT_EQ] = ACTIONS(587),
    [anon_sym_GT_GT_EQ] = ACTIONS(587),
    [anon_sym_EQ] = ACTIONS(601),
    [anon_sym_EQ_EQ] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(587),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_GT_EQ] = ACTIONS(587),
    [anon_sym_LT_EQ] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym__] = ACTIONS(601),
    [anon_sym_DOT] = ACTIONS(601),
    [anon_sym_DOT_DOT] = ACTIONS(601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(587),
    [anon_sym_COLON_COLON] = ACTIONS(587),
    [anon_sym_DASH_GT] = ACTIONS(587),
    [anon_sym_POUND] = ACTIONS(587),
    [anon_sym_SQUOTE] = ACTIONS(584),
    [anon_sym_as] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(584),
    [anon_sym_await] = ACTIONS(584),
    [anon_sym_break] = ACTIONS(584),
    [anon_sym_const] = ACTIONS(584),
    [anon_sym_continue] = ACTIONS(584),
    [anon_sym_default] = ACTIONS(584),
    [anon_sym_enum] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(584),
    [anon_sym_for] = ACTIONS(584),
    [anon_sym_if] = ACTIONS(584),
    [anon_sym_impl] = ACTIONS(584),
    [anon_sym_let] = ACTIONS(584),
    [anon_sym_loop] = ACTIONS(584),
    [anon_sym_match] = ACTIONS(584),
    [anon_sym_mod] = ACTIONS(584),
    [anon_sym_pub] = ACTIONS(584),
    [anon_sym_return] = ACTIONS(584),
    [anon_sym_static] = ACTIONS(584),
    [anon_sym_struct] = ACTIONS(584),
    [anon_sym_trait] = ACTIONS(584),
    [anon_sym_type] = ACTIONS(584),
    [anon_sym_union] = ACTIONS(584),
    [anon_sym_unsafe] = ACTIONS(584),
    [anon_sym_use] = ACTIONS(584),
    [anon_sym_where] = ACTIONS(584),
    [anon_sym_while] = ACTIONS(584),
    [sym_mutable_specifier] = ACTIONS(584),
    [sym_integer_literal] = ACTIONS(607),
    [aux_sym_string_literal_token1] = ACTIONS(610),
    [sym_char_literal] = ACTIONS(607),
    [anon_sym_true] = ACTIONS(613),
    [anon_sym_false] = ACTIONS(613),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(584),
    [sym_super] = ACTIONS(584),
    [sym_crate] = ACTIONS(584),
    [sym__raw_string_literal_start] = ACTIONS(616),
    [sym_float_literal] = ACTIONS(607),
  },
  [75] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(75),
    [sym_block_comment] = STATE(75),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [76] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(76),
    [sym_block_comment] = STATE(76),
    [aux_sym_token_tree_pattern_repeat1] = STATE(72),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [77] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(77),
    [sym_block_comment] = STATE(77),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [78] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(78),
    [sym_block_comment] = STATE(78),
    [aux_sym_token_tree_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(632),
    [anon_sym_RBRACK] = ACTIONS(630),
    [anon_sym_LBRACE] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(630),
    [anon_sym_EQ_GT] = ACTIONS(624),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(624),
    [anon_sym_u8] = ACTIONS(621),
    [anon_sym_i8] = ACTIONS(621),
    [anon_sym_u16] = ACTIONS(621),
    [anon_sym_i16] = ACTIONS(621),
    [anon_sym_u32] = ACTIONS(621),
    [anon_sym_i32] = ACTIONS(621),
    [anon_sym_u64] = ACTIONS(621),
    [anon_sym_i64] = ACTIONS(621),
    [anon_sym_u128] = ACTIONS(621),
    [anon_sym_i128] = ACTIONS(621),
    [anon_sym_isize] = ACTIONS(621),
    [anon_sym_usize] = ACTIONS(621),
    [anon_sym_f32] = ACTIONS(621),
    [anon_sym_f64] = ACTIONS(621),
    [anon_sym_bool] = ACTIONS(621),
    [anon_sym_str] = ACTIONS(621),
    [anon_sym_char] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(638),
    [anon_sym_PERCENT] = ACTIONS(638),
    [anon_sym_CARET] = ACTIONS(638),
    [anon_sym_BANG] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_PIPE_PIPE] = ACTIONS(624),
    [anon_sym_LT_LT] = ACTIONS(638),
    [anon_sym_GT_GT] = ACTIONS(638),
    [anon_sym_PLUS_EQ] = ACTIONS(624),
    [anon_sym_DASH_EQ] = ACTIONS(624),
    [anon_sym_STAR_EQ] = ACTIONS(624),
    [anon_sym_SLASH_EQ] = ACTIONS(624),
    [anon_sym_PERCENT_EQ] = ACTIONS(624),
    [anon_sym_CARET_EQ] = ACTIONS(624),
    [anon_sym_AMP_EQ] = ACTIONS(624),
    [anon_sym_PIPE_EQ] = ACTIONS(624),
    [anon_sym_LT_LT_EQ] = ACTIONS(624),
    [anon_sym_GT_GT_EQ] = ACTIONS(624),
    [anon_sym_EQ] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(624),
    [anon_sym_BANG_EQ] = ACTIONS(624),
    [anon_sym_GT] = ACTIONS(638),
    [anon_sym_LT] = ACTIONS(638),
    [anon_sym_GT_EQ] = ACTIONS(624),
    [anon_sym_LT_EQ] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(624),
    [anon_sym__] = ACTIONS(638),
    [anon_sym_DOT] = ACTIONS(638),
    [anon_sym_DOT_DOT] = ACTIONS(638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(624),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(624),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_COLON_COLON] = ACTIONS(624),
    [anon_sym_DASH_GT] = ACTIONS(624),
    [anon_sym_POUND] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(621),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_await] = ACTIONS(621),
    [anon_sym_break] = ACTIONS(621),
    [anon_sym_const] = ACTIONS(621),
    [anon_sym_continue] = ACTIONS(621),
    [anon_sym_default] = ACTIONS(621),
    [anon_sym_enum] = ACTIONS(621),
    [anon_sym_fn] = ACTIONS(621),
    [anon_sym_for] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(621),
    [anon_sym_impl] = ACTIONS(621),
    [anon_sym_let] = ACTIONS(621),
    [anon_sym_loop] = ACTIONS(621),
    [anon_sym_match] = ACTIONS(621),
    [anon_sym_mod] = ACTIONS(621),
    [anon_sym_pub] = ACTIONS(621),
    [anon_sym_return] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(621),
    [anon_sym_struct] = ACTIONS(621),
    [anon_sym_trait] = ACTIONS(621),
    [anon_sym_type] = ACTIONS(621),
    [anon_sym_union] = ACTIONS(621),
    [anon_sym_unsafe] = ACTIONS(621),
    [anon_sym_use] = ACTIONS(621),
    [anon_sym_where] = ACTIONS(621),
    [anon_sym_while] = ACTIONS(621),
    [sym_mutable_specifier] = ACTIONS(621),
    [sym_integer_literal] = ACTIONS(644),
    [aux_sym_string_literal_token1] = ACTIONS(647),
    [sym_char_literal] = ACTIONS(644),
    [anon_sym_true] = ACTIONS(650),
    [anon_sym_false] = ACTIONS(650),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(621),
    [sym_super] = ACTIONS(621),
    [sym_crate] = ACTIONS(621),
    [sym_metavariable] = ACTIONS(653),
    [sym__raw_string_literal_start] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(644),
  },
  [79] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(79),
    [sym_block_comment] = STATE(79),
    [aux_sym_token_tree_pattern_repeat1] = STATE(68),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [80] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(80),
    [sym_block_comment] = STATE(80),
    [aux_sym_token_tree_pattern_repeat1] = STATE(77),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [81] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(81),
    [sym_block_comment] = STATE(81),
    [aux_sym_token_tree_pattern_repeat1] = STATE(70),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [82] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(82),
    [sym_block_comment] = STATE(82),
    [aux_sym_token_tree_pattern_repeat1] = STATE(75),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [83] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(141),
    [sym_token_binding_pattern] = STATE(141),
    [sym_token_repetition_pattern] = STATE(141),
    [sym__literal] = STATE(141),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(83),
    [sym_block_comment] = STATE(83),
    [aux_sym_token_tree_pattern_repeat1] = STATE(73),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_RBRACE] = ACTIONS(578),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [84] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(84),
    [sym_block_comment] = STATE(84),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(91),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [85] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(85),
    [sym_block_comment] = STATE(85),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [86] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(86),
    [sym_block_comment] = STATE(86),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [87] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(87),
    [sym_block_comment] = STATE(87),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [88] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(88),
    [sym_block_comment] = STATE(88),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(100),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [89] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(89),
    [sym_block_comment] = STATE(89),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(111),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(691),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [90] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(90),
    [sym_block_comment] = STATE(90),
    [aux_sym_token_tree_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [91] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(91),
    [sym_block_comment] = STATE(91),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(707),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [92] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(92),
    [sym_block_comment] = STATE(92),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(707),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [93] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(93),
    [sym_block_comment] = STATE(93),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [94] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(94),
    [sym_block_comment] = STATE(94),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(86),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(691),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [95] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(95),
    [sym_block_comment] = STATE(95),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(87),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(691),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [96] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(96),
    [sym_block_comment] = STATE(96),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(92),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [97] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(97),
    [sym_block_comment] = STATE(97),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(93),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [98] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(98),
    [sym_block_comment] = STATE(98),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [99] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(99),
    [sym_block_comment] = STATE(99),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [100] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(100),
    [sym_block_comment] = STATE(100),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [101] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(101),
    [sym_block_comment] = STATE(101),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [102] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(102),
    [sym_block_comment] = STATE(102),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [103] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(103),
    [sym_block_comment] = STATE(103),
    [aux_sym_token_tree_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [104] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(104),
    [sym_block_comment] = STATE(104),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(129),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [105] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(105),
    [sym_block_comment] = STATE(105),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(117),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [106] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(106),
    [sym_block_comment] = STATE(106),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(99),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [107] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(107),
    [sym_block_comment] = STATE(107),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(131),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [108] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(108),
    [sym_block_comment] = STATE(108),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(119),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [109] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(109),
    [sym_block_comment] = STATE(109),
    [aux_sym_token_tree_repeat1] = STATE(103),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [110] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(110),
    [sym_block_comment] = STATE(110),
    [aux_sym_token_tree_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [111] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(111),
    [sym_block_comment] = STATE(111),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(687),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [112] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(112),
    [sym_block_comment] = STATE(112),
    [aux_sym_token_tree_repeat1] = STATE(90),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [113] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(113),
    [sym_block_comment] = STATE(113),
    [aux_sym_token_tree_repeat1] = STATE(126),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(723),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [114] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(114),
    [sym_block_comment] = STATE(114),
    [aux_sym_token_tree_repeat1] = STATE(118),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [115] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(115),
    [sym_block_comment] = STATE(115),
    [aux_sym_token_tree_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [116] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(116),
    [sym_block_comment] = STATE(116),
    [aux_sym_token_tree_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [117] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(117),
    [sym_block_comment] = STATE(117),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [118] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(118),
    [sym_block_comment] = STATE(118),
    [aux_sym_token_tree_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [119] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(119),
    [sym_block_comment] = STATE(119),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [120] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(120),
    [sym_block_comment] = STATE(120),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [121] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(121),
    [sym_block_comment] = STATE(121),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(120),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [122] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(122),
    [sym_block_comment] = STATE(122),
    [aux_sym_token_tree_repeat1] = STATE(110),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [123] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(123),
    [sym_block_comment] = STATE(123),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [124] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(124),
    [sym_block_comment] = STATE(124),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [125] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(125),
    [sym_block_comment] = STATE(125),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [126] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(126),
    [sym_block_comment] = STATE(126),
    [aux_sym_token_tree_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(697),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [127] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(127),
    [sym_block_comment] = STATE(127),
    [aux_sym_token_tree_repeat1] = STATE(115),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [128] = {
    [sym_token_tree] = STATE(165),
    [sym_token_repetition] = STATE(165),
    [sym__literal] = STATE(165),
    [sym_string_literal] = STATE(151),
    [sym_raw_string_literal] = STATE(151),
    [sym_boolean_literal] = STATE(151),
    [sym_line_comment] = STATE(128),
    [sym_block_comment] = STATE(128),
    [aux_sym_token_tree_repeat1] = STATE(116),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [129] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(129),
    [sym_block_comment] = STATE(129),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [130] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(130),
    [sym_block_comment] = STATE(130),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(124),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [131] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(131),
    [sym_block_comment] = STATE(131),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [132] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(132),
    [sym_block_comment] = STATE(132),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [133] = {
    [sym_delim_token_tree] = STATE(208),
    [sym__delim_tokens] = STATE(205),
    [sym__non_delim_token] = STATE(208),
    [sym__literal] = STATE(207),
    [sym_string_literal] = STATE(200),
    [sym_raw_string_literal] = STATE(200),
    [sym_boolean_literal] = STATE(200),
    [sym_line_comment] = STATE(133),
    [sym_block_comment] = STATE(133),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(729),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [134] = {
    [sym_line_comment] = STATE(134),
    [sym_block_comment] = STATE(134),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(731),
    [anon_sym_i8] = ACTIONS(731),
    [anon_sym_u16] = ACTIONS(731),
    [anon_sym_i16] = ACTIONS(731),
    [anon_sym_u32] = ACTIONS(731),
    [anon_sym_i32] = ACTIONS(731),
    [anon_sym_u64] = ACTIONS(731),
    [anon_sym_i64] = ACTIONS(731),
    [anon_sym_u128] = ACTIONS(731),
    [anon_sym_i128] = ACTIONS(731),
    [anon_sym_isize] = ACTIONS(731),
    [anon_sym_usize] = ACTIONS(731),
    [anon_sym_f32] = ACTIONS(731),
    [anon_sym_f64] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_str] = ACTIONS(731),
    [anon_sym_char] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_await] = ACTIONS(731),
    [anon_sym_break] = ACTIONS(731),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_fn] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_impl] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_loop] = ACTIONS(731),
    [anon_sym_match] = ACTIONS(731),
    [anon_sym_mod] = ACTIONS(731),
    [anon_sym_pub] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_trait] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_union] = ACTIONS(731),
    [anon_sym_unsafe] = ACTIONS(731),
    [anon_sym_use] = ACTIONS(731),
    [anon_sym_where] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [sym_mutable_specifier] = ACTIONS(731),
    [sym_integer_literal] = ACTIONS(733),
    [aux_sym_string_literal_token1] = ACTIONS(733),
    [sym_char_literal] = ACTIONS(733),
    [anon_sym_true] = ACTIONS(731),
    [anon_sym_false] = ACTIONS(731),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(731),
    [sym_super] = ACTIONS(731),
    [sym_crate] = ACTIONS(731),
    [sym_metavariable] = ACTIONS(733),
    [sym__raw_string_literal_start] = ACTIONS(733),
    [sym_float_literal] = ACTIONS(733),
  },
  [135] = {
    [sym_line_comment] = STATE(135),
    [sym_block_comment] = STATE(135),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_RBRACK] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_EQ_GT] = ACTIONS(737),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_DOLLAR] = ACTIONS(735),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_u8] = ACTIONS(735),
    [anon_sym_i8] = ACTIONS(735),
    [anon_sym_u16] = ACTIONS(735),
    [anon_sym_i16] = ACTIONS(735),
    [anon_sym_u32] = ACTIONS(735),
    [anon_sym_i32] = ACTIONS(735),
    [anon_sym_u64] = ACTIONS(735),
    [anon_sym_i64] = ACTIONS(735),
    [anon_sym_u128] = ACTIONS(735),
    [anon_sym_i128] = ACTIONS(735),
    [anon_sym_isize] = ACTIONS(735),
    [anon_sym_usize] = ACTIONS(735),
    [anon_sym_f32] = ACTIONS(735),
    [anon_sym_f64] = ACTIONS(735),
    [anon_sym_bool] = ACTIONS(735),
    [anon_sym_str] = ACTIONS(735),
    [anon_sym_char] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(742),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_PLUS_EQ] = ACTIONS(737),
    [anon_sym_DASH_EQ] = ACTIONS(737),
    [anon_sym_STAR_EQ] = ACTIONS(737),
    [anon_sym_SLASH_EQ] = ACTIONS(737),
    [anon_sym_PERCENT_EQ] = ACTIONS(737),
    [anon_sym_CARET_EQ] = ACTIONS(737),
    [anon_sym_AMP_EQ] = ACTIONS(737),
    [anon_sym_PIPE_EQ] = ACTIONS(737),
    [anon_sym_LT_LT_EQ] = ACTIONS(737),
    [anon_sym_GT_GT_EQ] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_AT] = ACTIONS(737),
    [anon_sym__] = ACTIONS(742),
    [anon_sym_DOT] = ACTIONS(742),
    [anon_sym_DOT_DOT] = ACTIONS(742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(737),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_COLON_COLON] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(737),
    [anon_sym_POUND] = ACTIONS(737),
    [anon_sym_SQUOTE] = ACTIONS(735),
    [anon_sym_as] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(735),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_break] = ACTIONS(735),
    [anon_sym_const] = ACTIONS(735),
    [anon_sym_continue] = ACTIONS(735),
    [anon_sym_default] = ACTIONS(735),
    [anon_sym_enum] = ACTIONS(735),
    [anon_sym_fn] = ACTIONS(735),
    [anon_sym_for] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_impl] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(735),
    [anon_sym_loop] = ACTIONS(735),
    [anon_sym_match] = ACTIONS(735),
    [anon_sym_mod] = ACTIONS(735),
    [anon_sym_pub] = ACTIONS(735),
    [anon_sym_return] = ACTIONS(735),
    [anon_sym_static] = ACTIONS(735),
    [anon_sym_struct] = ACTIONS(735),
    [anon_sym_trait] = ACTIONS(735),
    [anon_sym_type] = ACTIONS(735),
    [anon_sym_union] = ACTIONS(735),
    [anon_sym_unsafe] = ACTIONS(735),
    [anon_sym_use] = ACTIONS(735),
    [anon_sym_where] = ACTIONS(735),
    [anon_sym_while] = ACTIONS(735),
    [sym_mutable_specifier] = ACTIONS(735),
    [sym_integer_literal] = ACTIONS(740),
    [aux_sym_string_literal_token1] = ACTIONS(740),
    [sym_char_literal] = ACTIONS(740),
    [anon_sym_true] = ACTIONS(735),
    [anon_sym_false] = ACTIONS(735),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(735),
    [sym_super] = ACTIONS(735),
    [sym_crate] = ACTIONS(735),
    [sym_metavariable] = ACTIONS(740),
    [sym__raw_string_literal_start] = ACTIONS(740),
    [sym_float_literal] = ACTIONS(740),
  },
  [136] = {
    [sym_line_comment] = STATE(136),
    [sym_block_comment] = STATE(136),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(747),
    [anon_sym_RBRACK] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(745),
    [anon_sym_i8] = ACTIONS(745),
    [anon_sym_u16] = ACTIONS(745),
    [anon_sym_i16] = ACTIONS(745),
    [anon_sym_u32] = ACTIONS(745),
    [anon_sym_i32] = ACTIONS(745),
    [anon_sym_u64] = ACTIONS(745),
    [anon_sym_i64] = ACTIONS(745),
    [anon_sym_u128] = ACTIONS(745),
    [anon_sym_i128] = ACTIONS(745),
    [anon_sym_isize] = ACTIONS(745),
    [anon_sym_usize] = ACTIONS(745),
    [anon_sym_f32] = ACTIONS(745),
    [anon_sym_f64] = ACTIONS(745),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_str] = ACTIONS(745),
    [anon_sym_char] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(745),
    [anon_sym_as] = ACTIONS(745),
    [anon_sym_async] = ACTIONS(745),
    [anon_sym_await] = ACTIONS(745),
    [anon_sym_break] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(745),
    [anon_sym_continue] = ACTIONS(745),
    [anon_sym_default] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_impl] = ACTIONS(745),
    [anon_sym_let] = ACTIONS(745),
    [anon_sym_loop] = ACTIONS(745),
    [anon_sym_match] = ACTIONS(745),
    [anon_sym_mod] = ACTIONS(745),
    [anon_sym_pub] = ACTIONS(745),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_trait] = ACTIONS(745),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_union] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(745),
    [anon_sym_use] = ACTIONS(745),
    [anon_sym_where] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [sym_mutable_specifier] = ACTIONS(745),
    [sym_integer_literal] = ACTIONS(747),
    [aux_sym_string_literal_token1] = ACTIONS(747),
    [sym_char_literal] = ACTIONS(747),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(745),
    [sym_super] = ACTIONS(745),
    [sym_crate] = ACTIONS(745),
    [sym_metavariable] = ACTIONS(747),
    [sym__raw_string_literal_start] = ACTIONS(747),
    [sym_float_literal] = ACTIONS(747),
  },
  [137] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1627),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(137),
    [sym_block_comment] = STATE(137),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(755),
    [anon_sym_RBRACK] = ACTIONS(758),
    [anon_sym_LBRACE] = ACTIONS(760),
    [anon_sym_STAR] = ACTIONS(763),
    [anon_sym_u8] = ACTIONS(766),
    [anon_sym_i8] = ACTIONS(766),
    [anon_sym_u16] = ACTIONS(766),
    [anon_sym_i16] = ACTIONS(766),
    [anon_sym_u32] = ACTIONS(766),
    [anon_sym_i32] = ACTIONS(766),
    [anon_sym_u64] = ACTIONS(766),
    [anon_sym_i64] = ACTIONS(766),
    [anon_sym_u128] = ACTIONS(766),
    [anon_sym_i128] = ACTIONS(766),
    [anon_sym_isize] = ACTIONS(766),
    [anon_sym_usize] = ACTIONS(766),
    [anon_sym_f32] = ACTIONS(766),
    [anon_sym_f64] = ACTIONS(766),
    [anon_sym_bool] = ACTIONS(766),
    [anon_sym_str] = ACTIONS(766),
    [anon_sym_char] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(763),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(778),
    [anon_sym_COMMA] = ACTIONS(758),
    [anon_sym_COLON_COLON] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(784),
    [anon_sym_SQUOTE] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_break] = ACTIONS(793),
    [anon_sym_const] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_default] = ACTIONS(802),
    [anon_sym_for] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(808),
    [anon_sym_loop] = ACTIONS(811),
    [anon_sym_match] = ACTIONS(814),
    [anon_sym_return] = ACTIONS(817),
    [anon_sym_static] = ACTIONS(820),
    [anon_sym_union] = ACTIONS(802),
    [anon_sym_unsafe] = ACTIONS(823),
    [anon_sym_while] = ACTIONS(826),
    [anon_sym_yield] = ACTIONS(829),
    [anon_sym_move] = ACTIONS(832),
    [anon_sym_try] = ACTIONS(835),
    [sym_integer_literal] = ACTIONS(838),
    [aux_sym_string_literal_token1] = ACTIONS(841),
    [sym_char_literal] = ACTIONS(838),
    [anon_sym_true] = ACTIONS(844),
    [anon_sym_false] = ACTIONS(844),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(847),
    [sym_super] = ACTIONS(850),
    [sym_crate] = ACTIONS(850),
    [sym_metavariable] = ACTIONS(853),
    [sym__raw_string_literal_start] = ACTIONS(856),
    [sym_float_literal] = ACTIONS(838),
  },
  [138] = {
    [sym_line_comment] = STATE(138),
    [sym_block_comment] = STATE(138),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(861),
    [anon_sym_EQ_GT] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(861),
    [anon_sym_u8] = ACTIONS(859),
    [anon_sym_i8] = ACTIONS(859),
    [anon_sym_u16] = ACTIONS(859),
    [anon_sym_i16] = ACTIONS(859),
    [anon_sym_u32] = ACTIONS(859),
    [anon_sym_i32] = ACTIONS(859),
    [anon_sym_u64] = ACTIONS(859),
    [anon_sym_i64] = ACTIONS(859),
    [anon_sym_u128] = ACTIONS(859),
    [anon_sym_i128] = ACTIONS(859),
    [anon_sym_isize] = ACTIONS(859),
    [anon_sym_usize] = ACTIONS(859),
    [anon_sym_f32] = ACTIONS(859),
    [anon_sym_f64] = ACTIONS(859),
    [anon_sym_bool] = ACTIONS(859),
    [anon_sym_str] = ACTIONS(859),
    [anon_sym_char] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_BANG] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_PLUS_EQ] = ACTIONS(861),
    [anon_sym_DASH_EQ] = ACTIONS(861),
    [anon_sym_STAR_EQ] = ACTIONS(861),
    [anon_sym_SLASH_EQ] = ACTIONS(861),
    [anon_sym_PERCENT_EQ] = ACTIONS(861),
    [anon_sym_CARET_EQ] = ACTIONS(861),
    [anon_sym_AMP_EQ] = ACTIONS(861),
    [anon_sym_PIPE_EQ] = ACTIONS(861),
    [anon_sym_LT_LT_EQ] = ACTIONS(861),
    [anon_sym_GT_GT_EQ] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_AT] = ACTIONS(861),
    [anon_sym__] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_DOT_DOT] = ACTIONS(859),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(861),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(861),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_COLON_COLON] = ACTIONS(861),
    [anon_sym_DASH_GT] = ACTIONS(861),
    [anon_sym_POUND] = ACTIONS(861),
    [anon_sym_SQUOTE] = ACTIONS(859),
    [anon_sym_as] = ACTIONS(859),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_default] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_impl] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(859),
    [anon_sym_loop] = ACTIONS(859),
    [anon_sym_match] = ACTIONS(859),
    [anon_sym_mod] = ACTIONS(859),
    [anon_sym_pub] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_trait] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_unsafe] = ACTIONS(859),
    [anon_sym_use] = ACTIONS(859),
    [anon_sym_where] = ACTIONS(859),
    [anon_sym_while] = ACTIONS(859),
    [sym_mutable_specifier] = ACTIONS(859),
    [sym_integer_literal] = ACTIONS(861),
    [aux_sym_string_literal_token1] = ACTIONS(861),
    [sym_char_literal] = ACTIONS(861),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(859),
    [sym_super] = ACTIONS(859),
    [sym_crate] = ACTIONS(859),
    [sym_metavariable] = ACTIONS(861),
    [sym__raw_string_literal_start] = ACTIONS(861),
    [sym_float_literal] = ACTIONS(861),
  },
  [139] = {
    [sym_line_comment] = STATE(139),
    [sym_block_comment] = STATE(139),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_RPAREN] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(865),
    [anon_sym_RBRACK] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_EQ_GT] = ACTIONS(865),
    [anon_sym_COLON] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_STAR] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_u8] = ACTIONS(863),
    [anon_sym_i8] = ACTIONS(863),
    [anon_sym_u16] = ACTIONS(863),
    [anon_sym_i16] = ACTIONS(863),
    [anon_sym_u32] = ACTIONS(863),
    [anon_sym_i32] = ACTIONS(863),
    [anon_sym_u64] = ACTIONS(863),
    [anon_sym_i64] = ACTIONS(863),
    [anon_sym_u128] = ACTIONS(863),
    [anon_sym_i128] = ACTIONS(863),
    [anon_sym_isize] = ACTIONS(863),
    [anon_sym_usize] = ACTIONS(863),
    [anon_sym_f32] = ACTIONS(863),
    [anon_sym_f64] = ACTIONS(863),
    [anon_sym_bool] = ACTIONS(863),
    [anon_sym_str] = ACTIONS(863),
    [anon_sym_char] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_SLASH] = ACTIONS(863),
    [anon_sym_PERCENT] = ACTIONS(863),
    [anon_sym_CARET] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(863),
    [anon_sym_AMP] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(863),
    [anon_sym_AMP_AMP] = ACTIONS(865),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_LT_LT] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(863),
    [anon_sym_PLUS_EQ] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(865),
    [anon_sym_STAR_EQ] = ACTIONS(865),
    [anon_sym_SLASH_EQ] = ACTIONS(865),
    [anon_sym_PERCENT_EQ] = ACTIONS(865),
    [anon_sym_CARET_EQ] = ACTIONS(865),
    [anon_sym_AMP_EQ] = ACTIONS(865),
    [anon_sym_PIPE_EQ] = ACTIONS(865),
    [anon_sym_LT_LT_EQ] = ACTIONS(865),
    [anon_sym_GT_GT_EQ] = ACTIONS(865),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_EQ_EQ] = ACTIONS(865),
    [anon_sym_BANG_EQ] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(865),
    [anon_sym_LT_EQ] = ACTIONS(865),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym__] = ACTIONS(863),
    [anon_sym_DOT] = ACTIONS(863),
    [anon_sym_DOT_DOT] = ACTIONS(863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(865),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_COLON_COLON] = ACTIONS(865),
    [anon_sym_DASH_GT] = ACTIONS(865),
    [anon_sym_POUND] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(863),
    [anon_sym_async] = ACTIONS(863),
    [anon_sym_await] = ACTIONS(863),
    [anon_sym_break] = ACTIONS(863),
    [anon_sym_const] = ACTIONS(863),
    [anon_sym_continue] = ACTIONS(863),
    [anon_sym_default] = ACTIONS(863),
    [anon_sym_enum] = ACTIONS(863),
    [anon_sym_fn] = ACTIONS(863),
    [anon_sym_for] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_impl] = ACTIONS(863),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_loop] = ACTIONS(863),
    [anon_sym_match] = ACTIONS(863),
    [anon_sym_mod] = ACTIONS(863),
    [anon_sym_pub] = ACTIONS(863),
    [anon_sym_return] = ACTIONS(863),
    [anon_sym_static] = ACTIONS(863),
    [anon_sym_struct] = ACTIONS(863),
    [anon_sym_trait] = ACTIONS(863),
    [anon_sym_type] = ACTIONS(863),
    [anon_sym_union] = ACTIONS(863),
    [anon_sym_unsafe] = ACTIONS(863),
    [anon_sym_use] = ACTIONS(863),
    [anon_sym_where] = ACTIONS(863),
    [anon_sym_while] = ACTIONS(863),
    [sym_mutable_specifier] = ACTIONS(863),
    [sym_integer_literal] = ACTIONS(865),
    [aux_sym_string_literal_token1] = ACTIONS(865),
    [sym_char_literal] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(863),
    [anon_sym_false] = ACTIONS(863),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(863),
    [sym_super] = ACTIONS(863),
    [sym_crate] = ACTIONS(863),
    [sym_metavariable] = ACTIONS(865),
    [sym__raw_string_literal_start] = ACTIONS(865),
    [sym_float_literal] = ACTIONS(865),
  },
  [140] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(140),
    [sym_block_comment] = STATE(140),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(869),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [141] = {
    [sym_line_comment] = STATE(141),
    [sym_block_comment] = STATE(141),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(731),
    [anon_sym_i8] = ACTIONS(731),
    [anon_sym_u16] = ACTIONS(731),
    [anon_sym_i16] = ACTIONS(731),
    [anon_sym_u32] = ACTIONS(731),
    [anon_sym_i32] = ACTIONS(731),
    [anon_sym_u64] = ACTIONS(731),
    [anon_sym_i64] = ACTIONS(731),
    [anon_sym_u128] = ACTIONS(731),
    [anon_sym_i128] = ACTIONS(731),
    [anon_sym_isize] = ACTIONS(731),
    [anon_sym_usize] = ACTIONS(731),
    [anon_sym_f32] = ACTIONS(731),
    [anon_sym_f64] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_str] = ACTIONS(731),
    [anon_sym_char] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(733),
    [anon_sym__] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_DASH_GT] = ACTIONS(733),
    [anon_sym_POUND] = ACTIONS(733),
    [anon_sym_SQUOTE] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_await] = ACTIONS(731),
    [anon_sym_break] = ACTIONS(731),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_fn] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_impl] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_loop] = ACTIONS(731),
    [anon_sym_match] = ACTIONS(731),
    [anon_sym_mod] = ACTIONS(731),
    [anon_sym_pub] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_trait] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_union] = ACTIONS(731),
    [anon_sym_unsafe] = ACTIONS(731),
    [anon_sym_use] = ACTIONS(731),
    [anon_sym_where] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [sym_mutable_specifier] = ACTIONS(731),
    [sym_integer_literal] = ACTIONS(733),
    [aux_sym_string_literal_token1] = ACTIONS(733),
    [sym_char_literal] = ACTIONS(733),
    [anon_sym_true] = ACTIONS(731),
    [anon_sym_false] = ACTIONS(731),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(731),
    [sym_super] = ACTIONS(731),
    [sym_crate] = ACTIONS(731),
    [sym_metavariable] = ACTIONS(733),
    [sym__raw_string_literal_start] = ACTIONS(733),
    [sym_float_literal] = ACTIONS(733),
  },
  [142] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1544),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(142),
    [sym_block_comment] = STATE(142),
    [aux_sym_enum_variant_list_repeat1] = STATE(150),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [143] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1553),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(143),
    [sym_block_comment] = STATE(143),
    [aux_sym_enum_variant_list_repeat1] = STATE(142),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(877),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [144] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1622),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(144),
    [sym_block_comment] = STATE(144),
    [aux_sym_enum_variant_list_repeat1] = STATE(212),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [145] = {
    [sym_line_comment] = STATE(145),
    [sym_block_comment] = STATE(145),
    [sym_identifier] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_RBRACK] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_COLON] = ACTIONS(885),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [anon_sym_PLUS] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(885),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_u8] = ACTIONS(885),
    [anon_sym_i8] = ACTIONS(885),
    [anon_sym_u16] = ACTIONS(885),
    [anon_sym_i16] = ACTIONS(885),
    [anon_sym_u32] = ACTIONS(885),
    [anon_sym_i32] = ACTIONS(885),
    [anon_sym_u64] = ACTIONS(885),
    [anon_sym_i64] = ACTIONS(885),
    [anon_sym_u128] = ACTIONS(885),
    [anon_sym_i128] = ACTIONS(885),
    [anon_sym_isize] = ACTIONS(885),
    [anon_sym_usize] = ACTIONS(885),
    [anon_sym_f32] = ACTIONS(885),
    [anon_sym_f64] = ACTIONS(885),
    [anon_sym_bool] = ACTIONS(885),
    [anon_sym_str] = ACTIONS(885),
    [anon_sym_char] = ACTIONS(885),
    [anon_sym_DASH] = ACTIONS(885),
    [anon_sym_SLASH] = ACTIONS(885),
    [anon_sym_PERCENT] = ACTIONS(885),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(885),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_EQ] = ACTIONS(885),
    [anon_sym_EQ_EQ] = ACTIONS(887),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(887),
    [anon_sym__] = ACTIONS(885),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_DOT_DOT] = ACTIONS(885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_DASH_GT] = ACTIONS(887),
    [anon_sym_POUND] = ACTIONS(887),
    [anon_sym_SQUOTE] = ACTIONS(885),
    [anon_sym_as] = ACTIONS(885),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(885),
    [anon_sym_break] = ACTIONS(885),
    [anon_sym_const] = ACTIONS(885),
    [anon_sym_continue] = ACTIONS(885),
    [anon_sym_default] = ACTIONS(885),
    [anon_sym_enum] = ACTIONS(885),
    [anon_sym_fn] = ACTIONS(885),
    [anon_sym_for] = ACTIONS(885),
    [anon_sym_if] = ACTIONS(885),
    [anon_sym_impl] = ACTIONS(885),
    [anon_sym_let] = ACTIONS(885),
    [anon_sym_loop] = ACTIONS(885),
    [anon_sym_match] = ACTIONS(885),
    [anon_sym_mod] = ACTIONS(885),
    [anon_sym_pub] = ACTIONS(885),
    [anon_sym_return] = ACTIONS(885),
    [anon_sym_static] = ACTIONS(885),
    [anon_sym_struct] = ACTIONS(885),
    [anon_sym_trait] = ACTIONS(885),
    [anon_sym_type] = ACTIONS(885),
    [anon_sym_union] = ACTIONS(885),
    [anon_sym_unsafe] = ACTIONS(885),
    [anon_sym_use] = ACTIONS(885),
    [anon_sym_where] = ACTIONS(885),
    [anon_sym_while] = ACTIONS(885),
    [sym_mutable_specifier] = ACTIONS(885),
    [sym_integer_literal] = ACTIONS(887),
    [aux_sym_string_literal_token1] = ACTIONS(887),
    [sym_char_literal] = ACTIONS(887),
    [anon_sym_true] = ACTIONS(885),
    [anon_sym_false] = ACTIONS(885),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(885),
    [sym_super] = ACTIONS(885),
    [sym_crate] = ACTIONS(885),
    [sym_metavariable] = ACTIONS(887),
    [sym__raw_string_literal_start] = ACTIONS(887),
    [sym_float_literal] = ACTIONS(887),
  },
  [146] = {
    [sym_line_comment] = STATE(146),
    [sym_block_comment] = STATE(146),
    [sym_identifier] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_EQ_GT] = ACTIONS(891),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_u8] = ACTIONS(889),
    [anon_sym_i8] = ACTIONS(889),
    [anon_sym_u16] = ACTIONS(889),
    [anon_sym_i16] = ACTIONS(889),
    [anon_sym_u32] = ACTIONS(889),
    [anon_sym_i32] = ACTIONS(889),
    [anon_sym_u64] = ACTIONS(889),
    [anon_sym_i64] = ACTIONS(889),
    [anon_sym_u128] = ACTIONS(889),
    [anon_sym_i128] = ACTIONS(889),
    [anon_sym_isize] = ACTIONS(889),
    [anon_sym_usize] = ACTIONS(889),
    [anon_sym_f32] = ACTIONS(889),
    [anon_sym_f64] = ACTIONS(889),
    [anon_sym_bool] = ACTIONS(889),
    [anon_sym_str] = ACTIONS(889),
    [anon_sym_char] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(891),
    [anon_sym__] = ACTIONS(889),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(891),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(889),
    [anon_sym_as] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(889),
    [anon_sym_await] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(889),
    [anon_sym_const] = ACTIONS(889),
    [anon_sym_continue] = ACTIONS(889),
    [anon_sym_default] = ACTIONS(889),
    [anon_sym_enum] = ACTIONS(889),
    [anon_sym_fn] = ACTIONS(889),
    [anon_sym_for] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(889),
    [anon_sym_impl] = ACTIONS(889),
    [anon_sym_let] = ACTIONS(889),
    [anon_sym_loop] = ACTIONS(889),
    [anon_sym_match] = ACTIONS(889),
    [anon_sym_mod] = ACTIONS(889),
    [anon_sym_pub] = ACTIONS(889),
    [anon_sym_return] = ACTIONS(889),
    [anon_sym_static] = ACTIONS(889),
    [anon_sym_struct] = ACTIONS(889),
    [anon_sym_trait] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_union] = ACTIONS(889),
    [anon_sym_unsafe] = ACTIONS(889),
    [anon_sym_use] = ACTIONS(889),
    [anon_sym_where] = ACTIONS(889),
    [anon_sym_while] = ACTIONS(889),
    [sym_mutable_specifier] = ACTIONS(889),
    [sym_integer_literal] = ACTIONS(891),
    [aux_sym_string_literal_token1] = ACTIONS(891),
    [sym_char_literal] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(889),
    [anon_sym_false] = ACTIONS(889),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(889),
    [sym_super] = ACTIONS(889),
    [sym_crate] = ACTIONS(889),
    [sym_metavariable] = ACTIONS(891),
    [sym__raw_string_literal_start] = ACTIONS(891),
    [sym_float_literal] = ACTIONS(891),
  },
  [147] = {
    [sym_line_comment] = STATE(147),
    [sym_block_comment] = STATE(147),
    [sym_identifier] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(895),
    [anon_sym_RBRACK] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_EQ_GT] = ACTIONS(895),
    [anon_sym_COLON] = ACTIONS(893),
    [anon_sym_DOLLAR] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(895),
    [anon_sym_u8] = ACTIONS(893),
    [anon_sym_i8] = ACTIONS(893),
    [anon_sym_u16] = ACTIONS(893),
    [anon_sym_i16] = ACTIONS(893),
    [anon_sym_u32] = ACTIONS(893),
    [anon_sym_i32] = ACTIONS(893),
    [anon_sym_u64] = ACTIONS(893),
    [anon_sym_i64] = ACTIONS(893),
    [anon_sym_u128] = ACTIONS(893),
    [anon_sym_i128] = ACTIONS(893),
    [anon_sym_isize] = ACTIONS(893),
    [anon_sym_usize] = ACTIONS(893),
    [anon_sym_f32] = ACTIONS(893),
    [anon_sym_f64] = ACTIONS(893),
    [anon_sym_bool] = ACTIONS(893),
    [anon_sym_str] = ACTIONS(893),
    [anon_sym_char] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(895),
    [anon_sym_DASH_EQ] = ACTIONS(895),
    [anon_sym_STAR_EQ] = ACTIONS(895),
    [anon_sym_SLASH_EQ] = ACTIONS(895),
    [anon_sym_PERCENT_EQ] = ACTIONS(895),
    [anon_sym_CARET_EQ] = ACTIONS(895),
    [anon_sym_AMP_EQ] = ACTIONS(895),
    [anon_sym_PIPE_EQ] = ACTIONS(895),
    [anon_sym_LT_LT_EQ] = ACTIONS(895),
    [anon_sym_GT_GT_EQ] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(895),
    [anon_sym__] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_COLON_COLON] = ACTIONS(895),
    [anon_sym_DASH_GT] = ACTIONS(895),
    [anon_sym_POUND] = ACTIONS(895),
    [anon_sym_SQUOTE] = ACTIONS(893),
    [anon_sym_as] = ACTIONS(893),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(893),
    [anon_sym_break] = ACTIONS(893),
    [anon_sym_const] = ACTIONS(893),
    [anon_sym_continue] = ACTIONS(893),
    [anon_sym_default] = ACTIONS(893),
    [anon_sym_enum] = ACTIONS(893),
    [anon_sym_fn] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_impl] = ACTIONS(893),
    [anon_sym_let] = ACTIONS(893),
    [anon_sym_loop] = ACTIONS(893),
    [anon_sym_match] = ACTIONS(893),
    [anon_sym_mod] = ACTIONS(893),
    [anon_sym_pub] = ACTIONS(893),
    [anon_sym_return] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(893),
    [anon_sym_struct] = ACTIONS(893),
    [anon_sym_trait] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(893),
    [anon_sym_union] = ACTIONS(893),
    [anon_sym_unsafe] = ACTIONS(893),
    [anon_sym_use] = ACTIONS(893),
    [anon_sym_where] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [sym_mutable_specifier] = ACTIONS(893),
    [sym_integer_literal] = ACTIONS(895),
    [aux_sym_string_literal_token1] = ACTIONS(895),
    [sym_char_literal] = ACTIONS(895),
    [anon_sym_true] = ACTIONS(893),
    [anon_sym_false] = ACTIONS(893),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(893),
    [sym_super] = ACTIONS(893),
    [sym_crate] = ACTIONS(893),
    [sym_metavariable] = ACTIONS(895),
    [sym__raw_string_literal_start] = ACTIONS(895),
    [sym_float_literal] = ACTIONS(895),
  },
  [148] = {
    [sym_line_comment] = STATE(148),
    [sym_block_comment] = STATE(148),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(897),
    [anon_sym_DOLLAR] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(731),
    [anon_sym_i8] = ACTIONS(731),
    [anon_sym_u16] = ACTIONS(731),
    [anon_sym_i16] = ACTIONS(731),
    [anon_sym_u32] = ACTIONS(731),
    [anon_sym_i32] = ACTIONS(731),
    [anon_sym_u64] = ACTIONS(731),
    [anon_sym_i64] = ACTIONS(731),
    [anon_sym_u128] = ACTIONS(731),
    [anon_sym_i128] = ACTIONS(731),
    [anon_sym_isize] = ACTIONS(731),
    [anon_sym_usize] = ACTIONS(731),
    [anon_sym_f32] = ACTIONS(731),
    [anon_sym_f64] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_str] = ACTIONS(731),
    [anon_sym_char] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(733),
    [anon_sym__] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_DASH_GT] = ACTIONS(733),
    [anon_sym_POUND] = ACTIONS(733),
    [anon_sym_SQUOTE] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_await] = ACTIONS(731),
    [anon_sym_break] = ACTIONS(731),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_fn] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_impl] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_loop] = ACTIONS(731),
    [anon_sym_match] = ACTIONS(731),
    [anon_sym_mod] = ACTIONS(731),
    [anon_sym_pub] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_trait] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_union] = ACTIONS(731),
    [anon_sym_unsafe] = ACTIONS(731),
    [anon_sym_use] = ACTIONS(731),
    [anon_sym_where] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [sym_mutable_specifier] = ACTIONS(731),
    [sym_integer_literal] = ACTIONS(733),
    [aux_sym_string_literal_token1] = ACTIONS(733),
    [sym_char_literal] = ACTIONS(733),
    [anon_sym_true] = ACTIONS(731),
    [anon_sym_false] = ACTIONS(731),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(731),
    [sym_super] = ACTIONS(731),
    [sym_crate] = ACTIONS(731),
    [sym_metavariable] = ACTIONS(733),
    [sym__raw_string_literal_start] = ACTIONS(733),
    [sym_float_literal] = ACTIONS(733),
  },
  [149] = {
    [sym_line_comment] = STATE(149),
    [sym_block_comment] = STATE(149),
    [sym_identifier] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(901),
    [anon_sym_RBRACK] = ACTIONS(901),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_EQ_GT] = ACTIONS(901),
    [anon_sym_COLON] = ACTIONS(899),
    [anon_sym_DOLLAR] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_STAR] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(901),
    [anon_sym_u8] = ACTIONS(899),
    [anon_sym_i8] = ACTIONS(899),
    [anon_sym_u16] = ACTIONS(899),
    [anon_sym_i16] = ACTIONS(899),
    [anon_sym_u32] = ACTIONS(899),
    [anon_sym_i32] = ACTIONS(899),
    [anon_sym_u64] = ACTIONS(899),
    [anon_sym_i64] = ACTIONS(899),
    [anon_sym_u128] = ACTIONS(899),
    [anon_sym_i128] = ACTIONS(899),
    [anon_sym_isize] = ACTIONS(899),
    [anon_sym_usize] = ACTIONS(899),
    [anon_sym_f32] = ACTIONS(899),
    [anon_sym_f64] = ACTIONS(899),
    [anon_sym_bool] = ACTIONS(899),
    [anon_sym_str] = ACTIONS(899),
    [anon_sym_char] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_PLUS_EQ] = ACTIONS(901),
    [anon_sym_DASH_EQ] = ACTIONS(901),
    [anon_sym_STAR_EQ] = ACTIONS(901),
    [anon_sym_SLASH_EQ] = ACTIONS(901),
    [anon_sym_PERCENT_EQ] = ACTIONS(901),
    [anon_sym_CARET_EQ] = ACTIONS(901),
    [anon_sym_AMP_EQ] = ACTIONS(901),
    [anon_sym_PIPE_EQ] = ACTIONS(901),
    [anon_sym_LT_LT_EQ] = ACTIONS(901),
    [anon_sym_GT_GT_EQ] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_GT_EQ] = ACTIONS(901),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym__] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_COLON_COLON] = ACTIONS(901),
    [anon_sym_DASH_GT] = ACTIONS(901),
    [anon_sym_POUND] = ACTIONS(901),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [anon_sym_as] = ACTIONS(899),
    [anon_sym_async] = ACTIONS(899),
    [anon_sym_await] = ACTIONS(899),
    [anon_sym_break] = ACTIONS(899),
    [anon_sym_const] = ACTIONS(899),
    [anon_sym_continue] = ACTIONS(899),
    [anon_sym_default] = ACTIONS(899),
    [anon_sym_enum] = ACTIONS(899),
    [anon_sym_fn] = ACTIONS(899),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_impl] = ACTIONS(899),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_loop] = ACTIONS(899),
    [anon_sym_match] = ACTIONS(899),
    [anon_sym_mod] = ACTIONS(899),
    [anon_sym_pub] = ACTIONS(899),
    [anon_sym_return] = ACTIONS(899),
    [anon_sym_static] = ACTIONS(899),
    [anon_sym_struct] = ACTIONS(899),
    [anon_sym_trait] = ACTIONS(899),
    [anon_sym_type] = ACTIONS(899),
    [anon_sym_union] = ACTIONS(899),
    [anon_sym_unsafe] = ACTIONS(899),
    [anon_sym_use] = ACTIONS(899),
    [anon_sym_where] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [sym_mutable_specifier] = ACTIONS(899),
    [sym_integer_literal] = ACTIONS(901),
    [aux_sym_string_literal_token1] = ACTIONS(901),
    [sym_char_literal] = ACTIONS(901),
    [anon_sym_true] = ACTIONS(899),
    [anon_sym_false] = ACTIONS(899),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(899),
    [sym_super] = ACTIONS(899),
    [sym_crate] = ACTIONS(899),
    [sym_metavariable] = ACTIONS(901),
    [sym__raw_string_literal_start] = ACTIONS(901),
    [sym_float_literal] = ACTIONS(901),
  },
  [150] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1628),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(150),
    [sym_block_comment] = STATE(150),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(755),
    [anon_sym_RBRACK] = ACTIONS(758),
    [anon_sym_LBRACE] = ACTIONS(760),
    [anon_sym_STAR] = ACTIONS(763),
    [anon_sym_u8] = ACTIONS(766),
    [anon_sym_i8] = ACTIONS(766),
    [anon_sym_u16] = ACTIONS(766),
    [anon_sym_i16] = ACTIONS(766),
    [anon_sym_u32] = ACTIONS(766),
    [anon_sym_i32] = ACTIONS(766),
    [anon_sym_u64] = ACTIONS(766),
    [anon_sym_i64] = ACTIONS(766),
    [anon_sym_u128] = ACTIONS(766),
    [anon_sym_i128] = ACTIONS(766),
    [anon_sym_isize] = ACTIONS(766),
    [anon_sym_usize] = ACTIONS(766),
    [anon_sym_f32] = ACTIONS(766),
    [anon_sym_f64] = ACTIONS(766),
    [anon_sym_bool] = ACTIONS(766),
    [anon_sym_str] = ACTIONS(766),
    [anon_sym_char] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(763),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(778),
    [anon_sym_COMMA] = ACTIONS(758),
    [anon_sym_COLON_COLON] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(784),
    [anon_sym_SQUOTE] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_break] = ACTIONS(793),
    [anon_sym_const] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_default] = ACTIONS(802),
    [anon_sym_for] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(808),
    [anon_sym_loop] = ACTIONS(811),
    [anon_sym_match] = ACTIONS(814),
    [anon_sym_return] = ACTIONS(817),
    [anon_sym_static] = ACTIONS(820),
    [anon_sym_union] = ACTIONS(802),
    [anon_sym_unsafe] = ACTIONS(823),
    [anon_sym_while] = ACTIONS(826),
    [anon_sym_yield] = ACTIONS(829),
    [anon_sym_move] = ACTIONS(832),
    [anon_sym_try] = ACTIONS(835),
    [sym_integer_literal] = ACTIONS(838),
    [aux_sym_string_literal_token1] = ACTIONS(841),
    [sym_char_literal] = ACTIONS(838),
    [anon_sym_true] = ACTIONS(844),
    [anon_sym_false] = ACTIONS(844),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(847),
    [sym_super] = ACTIONS(850),
    [sym_crate] = ACTIONS(850),
    [sym_metavariable] = ACTIONS(853),
    [sym__raw_string_literal_start] = ACTIONS(856),
    [sym_float_literal] = ACTIONS(838),
  },
  [151] = {
    [sym_line_comment] = STATE(151),
    [sym_block_comment] = STATE(151),
    [sym_identifier] = ACTIONS(903),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_COLON] = ACTIONS(903),
    [anon_sym_DOLLAR] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_STAR] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_u8] = ACTIONS(903),
    [anon_sym_i8] = ACTIONS(903),
    [anon_sym_u16] = ACTIONS(903),
    [anon_sym_i16] = ACTIONS(903),
    [anon_sym_u32] = ACTIONS(903),
    [anon_sym_i32] = ACTIONS(903),
    [anon_sym_u64] = ACTIONS(903),
    [anon_sym_i64] = ACTIONS(903),
    [anon_sym_u128] = ACTIONS(903),
    [anon_sym_i128] = ACTIONS(903),
    [anon_sym_isize] = ACTIONS(903),
    [anon_sym_usize] = ACTIONS(903),
    [anon_sym_f32] = ACTIONS(903),
    [anon_sym_f64] = ACTIONS(903),
    [anon_sym_bool] = ACTIONS(903),
    [anon_sym_str] = ACTIONS(903),
    [anon_sym_char] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_BANG] = ACTIONS(903),
    [anon_sym_AMP] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(903),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(905),
    [anon_sym__] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(903),
    [anon_sym_DOT_DOT] = ACTIONS(903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_COLON_COLON] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(905),
    [anon_sym_POUND] = ACTIONS(905),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_as] = ACTIONS(903),
    [anon_sym_async] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_break] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(903),
    [anon_sym_continue] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(903),
    [anon_sym_enum] = ACTIONS(903),
    [anon_sym_fn] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_impl] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(903),
    [anon_sym_loop] = ACTIONS(903),
    [anon_sym_match] = ACTIONS(903),
    [anon_sym_mod] = ACTIONS(903),
    [anon_sym_pub] = ACTIONS(903),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_static] = ACTIONS(903),
    [anon_sym_struct] = ACTIONS(903),
    [anon_sym_trait] = ACTIONS(903),
    [anon_sym_type] = ACTIONS(903),
    [anon_sym_union] = ACTIONS(903),
    [anon_sym_unsafe] = ACTIONS(903),
    [anon_sym_use] = ACTIONS(903),
    [anon_sym_where] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [sym_mutable_specifier] = ACTIONS(903),
    [sym_integer_literal] = ACTIONS(905),
    [aux_sym_string_literal_token1] = ACTIONS(905),
    [sym_char_literal] = ACTIONS(905),
    [anon_sym_true] = ACTIONS(903),
    [anon_sym_false] = ACTIONS(903),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(903),
    [sym_super] = ACTIONS(903),
    [sym_crate] = ACTIONS(903),
    [sym_metavariable] = ACTIONS(905),
    [sym__raw_string_literal_start] = ACTIONS(905),
    [sym_float_literal] = ACTIONS(905),
  },
  [152] = {
    [sym_line_comment] = STATE(152),
    [sym_block_comment] = STATE(152),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_DOLLAR] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_u8] = ACTIONS(907),
    [anon_sym_i8] = ACTIONS(907),
    [anon_sym_u16] = ACTIONS(907),
    [anon_sym_i16] = ACTIONS(907),
    [anon_sym_u32] = ACTIONS(907),
    [anon_sym_i32] = ACTIONS(907),
    [anon_sym_u64] = ACTIONS(907),
    [anon_sym_i64] = ACTIONS(907),
    [anon_sym_u128] = ACTIONS(907),
    [anon_sym_i128] = ACTIONS(907),
    [anon_sym_isize] = ACTIONS(907),
    [anon_sym_usize] = ACTIONS(907),
    [anon_sym_f32] = ACTIONS(907),
    [anon_sym_f64] = ACTIONS(907),
    [anon_sym_bool] = ACTIONS(907),
    [anon_sym_str] = ACTIONS(907),
    [anon_sym_char] = ACTIONS(907),
    [anon_sym_DASH] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym__] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(909),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(909),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [anon_sym_POUND] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(907),
    [anon_sym_as] = ACTIONS(907),
    [anon_sym_async] = ACTIONS(907),
    [anon_sym_await] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_const] = ACTIONS(907),
    [anon_sym_continue] = ACTIONS(907),
    [anon_sym_default] = ACTIONS(907),
    [anon_sym_enum] = ACTIONS(907),
    [anon_sym_fn] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_impl] = ACTIONS(907),
    [anon_sym_let] = ACTIONS(907),
    [anon_sym_loop] = ACTIONS(907),
    [anon_sym_match] = ACTIONS(907),
    [anon_sym_mod] = ACTIONS(907),
    [anon_sym_pub] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_static] = ACTIONS(907),
    [anon_sym_struct] = ACTIONS(907),
    [anon_sym_trait] = ACTIONS(907),
    [anon_sym_type] = ACTIONS(907),
    [anon_sym_union] = ACTIONS(907),
    [anon_sym_unsafe] = ACTIONS(907),
    [anon_sym_use] = ACTIONS(907),
    [anon_sym_where] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [sym_mutable_specifier] = ACTIONS(907),
    [sym_integer_literal] = ACTIONS(909),
    [aux_sym_string_literal_token1] = ACTIONS(909),
    [sym_char_literal] = ACTIONS(909),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(907),
    [sym_super] = ACTIONS(907),
    [sym_crate] = ACTIONS(907),
    [sym_metavariable] = ACTIONS(909),
    [sym__raw_string_literal_start] = ACTIONS(909),
    [sym_float_literal] = ACTIONS(909),
  },
  [153] = {
    [sym_line_comment] = STATE(153),
    [sym_block_comment] = STATE(153),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_RBRACK] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_EQ_GT] = ACTIONS(913),
    [anon_sym_COLON] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_u8] = ACTIONS(911),
    [anon_sym_i8] = ACTIONS(911),
    [anon_sym_u16] = ACTIONS(911),
    [anon_sym_i16] = ACTIONS(911),
    [anon_sym_u32] = ACTIONS(911),
    [anon_sym_i32] = ACTIONS(911),
    [anon_sym_u64] = ACTIONS(911),
    [anon_sym_i64] = ACTIONS(911),
    [anon_sym_u128] = ACTIONS(911),
    [anon_sym_i128] = ACTIONS(911),
    [anon_sym_isize] = ACTIONS(911),
    [anon_sym_usize] = ACTIONS(911),
    [anon_sym_f32] = ACTIONS(911),
    [anon_sym_f64] = ACTIONS(911),
    [anon_sym_bool] = ACTIONS(911),
    [anon_sym_str] = ACTIONS(911),
    [anon_sym_char] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(913),
    [anon_sym__] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_POUND] = ACTIONS(913),
    [anon_sym_SQUOTE] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_async] = ACTIONS(911),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(911),
    [anon_sym_const] = ACTIONS(911),
    [anon_sym_continue] = ACTIONS(911),
    [anon_sym_default] = ACTIONS(911),
    [anon_sym_enum] = ACTIONS(911),
    [anon_sym_fn] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(911),
    [anon_sym_impl] = ACTIONS(911),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_loop] = ACTIONS(911),
    [anon_sym_match] = ACTIONS(911),
    [anon_sym_mod] = ACTIONS(911),
    [anon_sym_pub] = ACTIONS(911),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_static] = ACTIONS(911),
    [anon_sym_struct] = ACTIONS(911),
    [anon_sym_trait] = ACTIONS(911),
    [anon_sym_type] = ACTIONS(911),
    [anon_sym_union] = ACTIONS(911),
    [anon_sym_unsafe] = ACTIONS(911),
    [anon_sym_use] = ACTIONS(911),
    [anon_sym_where] = ACTIONS(911),
    [anon_sym_while] = ACTIONS(911),
    [sym_mutable_specifier] = ACTIONS(911),
    [sym_integer_literal] = ACTIONS(913),
    [aux_sym_string_literal_token1] = ACTIONS(913),
    [sym_char_literal] = ACTIONS(913),
    [anon_sym_true] = ACTIONS(911),
    [anon_sym_false] = ACTIONS(911),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(911),
    [sym_super] = ACTIONS(911),
    [sym_crate] = ACTIONS(911),
    [sym_metavariable] = ACTIONS(913),
    [sym__raw_string_literal_start] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(913),
  },
  [154] = {
    [sym_line_comment] = STATE(154),
    [sym_block_comment] = STATE(154),
    [aux_sym__non_special_token_repeat1] = STATE(155),
    [sym_identifier] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_RBRACK] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(917),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(915),
    [anon_sym_i8] = ACTIONS(915),
    [anon_sym_u16] = ACTIONS(915),
    [anon_sym_i16] = ACTIONS(915),
    [anon_sym_u32] = ACTIONS(915),
    [anon_sym_i32] = ACTIONS(915),
    [anon_sym_u64] = ACTIONS(915),
    [anon_sym_i64] = ACTIONS(915),
    [anon_sym_u128] = ACTIONS(915),
    [anon_sym_i128] = ACTIONS(915),
    [anon_sym_isize] = ACTIONS(915),
    [anon_sym_usize] = ACTIONS(915),
    [anon_sym_f32] = ACTIONS(915),
    [anon_sym_f64] = ACTIONS(915),
    [anon_sym_bool] = ACTIONS(915),
    [anon_sym_str] = ACTIONS(915),
    [anon_sym_char] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(915),
    [anon_sym_as] = ACTIONS(915),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_await] = ACTIONS(915),
    [anon_sym_break] = ACTIONS(915),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_continue] = ACTIONS(915),
    [anon_sym_default] = ACTIONS(915),
    [anon_sym_enum] = ACTIONS(915),
    [anon_sym_fn] = ACTIONS(915),
    [anon_sym_for] = ACTIONS(915),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_impl] = ACTIONS(915),
    [anon_sym_let] = ACTIONS(915),
    [anon_sym_loop] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(915),
    [anon_sym_mod] = ACTIONS(915),
    [anon_sym_pub] = ACTIONS(915),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_static] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(915),
    [anon_sym_trait] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(915),
    [anon_sym_unsafe] = ACTIONS(915),
    [anon_sym_use] = ACTIONS(915),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_while] = ACTIONS(915),
    [sym_mutable_specifier] = ACTIONS(915),
    [sym_integer_literal] = ACTIONS(917),
    [aux_sym_string_literal_token1] = ACTIONS(917),
    [sym_char_literal] = ACTIONS(917),
    [anon_sym_true] = ACTIONS(915),
    [anon_sym_false] = ACTIONS(915),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(915),
    [sym_super] = ACTIONS(915),
    [sym_crate] = ACTIONS(915),
    [sym__raw_string_literal_start] = ACTIONS(917),
    [sym_float_literal] = ACTIONS(917),
  },
  [155] = {
    [sym_line_comment] = STATE(155),
    [sym_block_comment] = STATE(155),
    [aux_sym__non_special_token_repeat1] = STATE(155),
    [sym_identifier] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_RBRACK] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_COLON] = ACTIONS(922),
    [anon_sym_DOLLAR] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(922),
    [anon_sym_QMARK] = ACTIONS(919),
    [anon_sym_u8] = ACTIONS(735),
    [anon_sym_i8] = ACTIONS(735),
    [anon_sym_u16] = ACTIONS(735),
    [anon_sym_i16] = ACTIONS(735),
    [anon_sym_u32] = ACTIONS(735),
    [anon_sym_i32] = ACTIONS(735),
    [anon_sym_u64] = ACTIONS(735),
    [anon_sym_i64] = ACTIONS(735),
    [anon_sym_u128] = ACTIONS(735),
    [anon_sym_i128] = ACTIONS(735),
    [anon_sym_isize] = ACTIONS(735),
    [anon_sym_usize] = ACTIONS(735),
    [anon_sym_f32] = ACTIONS(735),
    [anon_sym_f64] = ACTIONS(735),
    [anon_sym_bool] = ACTIONS(735),
    [anon_sym_str] = ACTIONS(735),
    [anon_sym_char] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(922),
    [anon_sym_PERCENT] = ACTIONS(922),
    [anon_sym_CARET] = ACTIONS(922),
    [anon_sym_BANG] = ACTIONS(922),
    [anon_sym_AMP] = ACTIONS(922),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(922),
    [anon_sym_GT_GT] = ACTIONS(922),
    [anon_sym_PLUS_EQ] = ACTIONS(919),
    [anon_sym_DASH_EQ] = ACTIONS(919),
    [anon_sym_STAR_EQ] = ACTIONS(919),
    [anon_sym_SLASH_EQ] = ACTIONS(919),
    [anon_sym_PERCENT_EQ] = ACTIONS(919),
    [anon_sym_CARET_EQ] = ACTIONS(919),
    [anon_sym_AMP_EQ] = ACTIONS(919),
    [anon_sym_PIPE_EQ] = ACTIONS(919),
    [anon_sym_LT_LT_EQ] = ACTIONS(919),
    [anon_sym_GT_GT_EQ] = ACTIONS(919),
    [anon_sym_EQ] = ACTIONS(922),
    [anon_sym_EQ_EQ] = ACTIONS(919),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(922),
    [anon_sym_LT] = ACTIONS(922),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(919),
    [anon_sym__] = ACTIONS(922),
    [anon_sym_DOT] = ACTIONS(922),
    [anon_sym_DOT_DOT] = ACTIONS(922),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(919),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(919),
    [anon_sym_DASH_GT] = ACTIONS(919),
    [anon_sym_POUND] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(735),
    [anon_sym_as] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(735),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_break] = ACTIONS(735),
    [anon_sym_const] = ACTIONS(735),
    [anon_sym_continue] = ACTIONS(735),
    [anon_sym_default] = ACTIONS(735),
    [anon_sym_enum] = ACTIONS(735),
    [anon_sym_fn] = ACTIONS(735),
    [anon_sym_for] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_impl] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(735),
    [anon_sym_loop] = ACTIONS(735),
    [anon_sym_match] = ACTIONS(735),
    [anon_sym_mod] = ACTIONS(735),
    [anon_sym_pub] = ACTIONS(735),
    [anon_sym_return] = ACTIONS(735),
    [anon_sym_static] = ACTIONS(735),
    [anon_sym_struct] = ACTIONS(735),
    [anon_sym_trait] = ACTIONS(735),
    [anon_sym_type] = ACTIONS(735),
    [anon_sym_union] = ACTIONS(735),
    [anon_sym_unsafe] = ACTIONS(735),
    [anon_sym_use] = ACTIONS(735),
    [anon_sym_where] = ACTIONS(735),
    [anon_sym_while] = ACTIONS(735),
    [sym_mutable_specifier] = ACTIONS(735),
    [sym_integer_literal] = ACTIONS(740),
    [aux_sym_string_literal_token1] = ACTIONS(740),
    [sym_char_literal] = ACTIONS(740),
    [anon_sym_true] = ACTIONS(735),
    [anon_sym_false] = ACTIONS(735),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(735),
    [sym_super] = ACTIONS(735),
    [sym_crate] = ACTIONS(735),
    [sym__raw_string_literal_start] = ACTIONS(740),
    [sym_float_literal] = ACTIONS(740),
  },
  [156] = {
    [sym_line_comment] = STATE(156),
    [sym_block_comment] = STATE(156),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_LPAREN] = ACTIONS(927),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_EQ_GT] = ACTIONS(927),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(925),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_u8] = ACTIONS(925),
    [anon_sym_i8] = ACTIONS(925),
    [anon_sym_u16] = ACTIONS(925),
    [anon_sym_i16] = ACTIONS(925),
    [anon_sym_u32] = ACTIONS(925),
    [anon_sym_i32] = ACTIONS(925),
    [anon_sym_u64] = ACTIONS(925),
    [anon_sym_i64] = ACTIONS(925),
    [anon_sym_u128] = ACTIONS(925),
    [anon_sym_i128] = ACTIONS(925),
    [anon_sym_isize] = ACTIONS(925),
    [anon_sym_usize] = ACTIONS(925),
    [anon_sym_f32] = ACTIONS(925),
    [anon_sym_f64] = ACTIONS(925),
    [anon_sym_bool] = ACTIONS(925),
    [anon_sym_str] = ACTIONS(925),
    [anon_sym_char] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_PLUS_EQ] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(927),
    [anon_sym_STAR_EQ] = ACTIONS(927),
    [anon_sym_SLASH_EQ] = ACTIONS(927),
    [anon_sym_PERCENT_EQ] = ACTIONS(927),
    [anon_sym_CARET_EQ] = ACTIONS(927),
    [anon_sym_AMP_EQ] = ACTIONS(927),
    [anon_sym_PIPE_EQ] = ACTIONS(927),
    [anon_sym_LT_LT_EQ] = ACTIONS(927),
    [anon_sym_GT_GT_EQ] = ACTIONS(927),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_LT_EQ] = ACTIONS(927),
    [anon_sym_AT] = ACTIONS(927),
    [anon_sym__] = ACTIONS(925),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(927),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(927),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_COLON_COLON] = ACTIONS(927),
    [anon_sym_DASH_GT] = ACTIONS(927),
    [anon_sym_POUND] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(925),
    [anon_sym_as] = ACTIONS(925),
    [anon_sym_async] = ACTIONS(925),
    [anon_sym_await] = ACTIONS(925),
    [anon_sym_break] = ACTIONS(925),
    [anon_sym_const] = ACTIONS(925),
    [anon_sym_continue] = ACTIONS(925),
    [anon_sym_default] = ACTIONS(925),
    [anon_sym_enum] = ACTIONS(925),
    [anon_sym_fn] = ACTIONS(925),
    [anon_sym_for] = ACTIONS(925),
    [anon_sym_if] = ACTIONS(925),
    [anon_sym_impl] = ACTIONS(925),
    [anon_sym_let] = ACTIONS(925),
    [anon_sym_loop] = ACTIONS(925),
    [anon_sym_match] = ACTIONS(925),
    [anon_sym_mod] = ACTIONS(925),
    [anon_sym_pub] = ACTIONS(925),
    [anon_sym_return] = ACTIONS(925),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_struct] = ACTIONS(925),
    [anon_sym_trait] = ACTIONS(925),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_union] = ACTIONS(925),
    [anon_sym_unsafe] = ACTIONS(925),
    [anon_sym_use] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(925),
    [sym_mutable_specifier] = ACTIONS(925),
    [sym_integer_literal] = ACTIONS(927),
    [aux_sym_string_literal_token1] = ACTIONS(927),
    [sym_char_literal] = ACTIONS(927),
    [anon_sym_true] = ACTIONS(925),
    [anon_sym_false] = ACTIONS(925),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(925),
    [sym_super] = ACTIONS(925),
    [sym_crate] = ACTIONS(925),
    [sym_metavariable] = ACTIONS(927),
    [sym__raw_string_literal_start] = ACTIONS(927),
    [sym_float_literal] = ACTIONS(927),
  },
  [157] = {
    [sym_line_comment] = STATE(157),
    [sym_block_comment] = STATE(157),
    [sym_identifier] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_RBRACK] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(931),
    [anon_sym_EQ_GT] = ACTIONS(931),
    [anon_sym_COLON] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_QMARK] = ACTIONS(931),
    [anon_sym_u8] = ACTIONS(929),
    [anon_sym_i8] = ACTIONS(929),
    [anon_sym_u16] = ACTIONS(929),
    [anon_sym_i16] = ACTIONS(929),
    [anon_sym_u32] = ACTIONS(929),
    [anon_sym_i32] = ACTIONS(929),
    [anon_sym_u64] = ACTIONS(929),
    [anon_sym_i64] = ACTIONS(929),
    [anon_sym_u128] = ACTIONS(929),
    [anon_sym_i128] = ACTIONS(929),
    [anon_sym_isize] = ACTIONS(929),
    [anon_sym_usize] = ACTIONS(929),
    [anon_sym_f32] = ACTIONS(929),
    [anon_sym_f64] = ACTIONS(929),
    [anon_sym_bool] = ACTIONS(929),
    [anon_sym_str] = ACTIONS(929),
    [anon_sym_char] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(929),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(931),
    [anon_sym_DASH_EQ] = ACTIONS(931),
    [anon_sym_STAR_EQ] = ACTIONS(931),
    [anon_sym_SLASH_EQ] = ACTIONS(931),
    [anon_sym_PERCENT_EQ] = ACTIONS(931),
    [anon_sym_CARET_EQ] = ACTIONS(931),
    [anon_sym_AMP_EQ] = ACTIONS(931),
    [anon_sym_PIPE_EQ] = ACTIONS(931),
    [anon_sym_LT_LT_EQ] = ACTIONS(931),
    [anon_sym_GT_GT_EQ] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(931),
    [anon_sym__] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(931),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(931),
    [anon_sym_COMMA] = ACTIONS(931),
    [anon_sym_COLON_COLON] = ACTIONS(931),
    [anon_sym_DASH_GT] = ACTIONS(931),
    [anon_sym_POUND] = ACTIONS(931),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(929),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_await] = ACTIONS(929),
    [anon_sym_break] = ACTIONS(929),
    [anon_sym_const] = ACTIONS(929),
    [anon_sym_continue] = ACTIONS(929),
    [anon_sym_default] = ACTIONS(929),
    [anon_sym_enum] = ACTIONS(929),
    [anon_sym_fn] = ACTIONS(929),
    [anon_sym_for] = ACTIONS(929),
    [anon_sym_if] = ACTIONS(929),
    [anon_sym_impl] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_loop] = ACTIONS(929),
    [anon_sym_match] = ACTIONS(929),
    [anon_sym_mod] = ACTIONS(929),
    [anon_sym_pub] = ACTIONS(929),
    [anon_sym_return] = ACTIONS(929),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_struct] = ACTIONS(929),
    [anon_sym_trait] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_union] = ACTIONS(929),
    [anon_sym_unsafe] = ACTIONS(929),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_where] = ACTIONS(929),
    [anon_sym_while] = ACTIONS(929),
    [sym_mutable_specifier] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [aux_sym_string_literal_token1] = ACTIONS(931),
    [sym_char_literal] = ACTIONS(931),
    [anon_sym_true] = ACTIONS(929),
    [anon_sym_false] = ACTIONS(929),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(929),
    [sym_super] = ACTIONS(929),
    [sym_crate] = ACTIONS(929),
    [sym_metavariable] = ACTIONS(931),
    [sym__raw_string_literal_start] = ACTIONS(931),
    [sym_float_literal] = ACTIONS(931),
  },
  [158] = {
    [sym_line_comment] = STATE(158),
    [sym_block_comment] = STATE(158),
    [sym_identifier] = ACTIONS(933),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_COLON] = ACTIONS(933),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(933),
    [anon_sym_STAR] = ACTIONS(933),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_u8] = ACTIONS(933),
    [anon_sym_i8] = ACTIONS(933),
    [anon_sym_u16] = ACTIONS(933),
    [anon_sym_i16] = ACTIONS(933),
    [anon_sym_u32] = ACTIONS(933),
    [anon_sym_i32] = ACTIONS(933),
    [anon_sym_u64] = ACTIONS(933),
    [anon_sym_i64] = ACTIONS(933),
    [anon_sym_u128] = ACTIONS(933),
    [anon_sym_i128] = ACTIONS(933),
    [anon_sym_isize] = ACTIONS(933),
    [anon_sym_usize] = ACTIONS(933),
    [anon_sym_f32] = ACTIONS(933),
    [anon_sym_f64] = ACTIONS(933),
    [anon_sym_bool] = ACTIONS(933),
    [anon_sym_str] = ACTIONS(933),
    [anon_sym_char] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_SLASH] = ACTIONS(933),
    [anon_sym_PERCENT] = ACTIONS(933),
    [anon_sym_CARET] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
    [anon_sym_PIPE] = ACTIONS(933),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(933),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(935),
    [anon_sym__] = ACTIONS(933),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_COLON_COLON] = ACTIONS(935),
    [anon_sym_DASH_GT] = ACTIONS(935),
    [anon_sym_POUND] = ACTIONS(935),
    [anon_sym_SQUOTE] = ACTIONS(933),
    [anon_sym_as] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(933),
    [anon_sym_await] = ACTIONS(933),
    [anon_sym_break] = ACTIONS(933),
    [anon_sym_const] = ACTIONS(933),
    [anon_sym_continue] = ACTIONS(933),
    [anon_sym_default] = ACTIONS(933),
    [anon_sym_enum] = ACTIONS(933),
    [anon_sym_fn] = ACTIONS(933),
    [anon_sym_for] = ACTIONS(933),
    [anon_sym_if] = ACTIONS(933),
    [anon_sym_impl] = ACTIONS(933),
    [anon_sym_let] = ACTIONS(933),
    [anon_sym_loop] = ACTIONS(933),
    [anon_sym_match] = ACTIONS(933),
    [anon_sym_mod] = ACTIONS(933),
    [anon_sym_pub] = ACTIONS(933),
    [anon_sym_return] = ACTIONS(933),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_trait] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_union] = ACTIONS(933),
    [anon_sym_unsafe] = ACTIONS(933),
    [anon_sym_use] = ACTIONS(933),
    [anon_sym_where] = ACTIONS(933),
    [anon_sym_while] = ACTIONS(933),
    [sym_mutable_specifier] = ACTIONS(933),
    [sym_integer_literal] = ACTIONS(935),
    [aux_sym_string_literal_token1] = ACTIONS(935),
    [sym_char_literal] = ACTIONS(935),
    [anon_sym_true] = ACTIONS(933),
    [anon_sym_false] = ACTIONS(933),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(933),
    [sym_super] = ACTIONS(933),
    [sym_crate] = ACTIONS(933),
    [sym_metavariable] = ACTIONS(935),
    [sym__raw_string_literal_start] = ACTIONS(935),
    [sym_float_literal] = ACTIONS(935),
  },
  [159] = {
    [sym_line_comment] = STATE(159),
    [sym_block_comment] = STATE(159),
    [sym_identifier] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_DOLLAR] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_u8] = ACTIONS(937),
    [anon_sym_i8] = ACTIONS(937),
    [anon_sym_u16] = ACTIONS(937),
    [anon_sym_i16] = ACTIONS(937),
    [anon_sym_u32] = ACTIONS(937),
    [anon_sym_i32] = ACTIONS(937),
    [anon_sym_u64] = ACTIONS(937),
    [anon_sym_i64] = ACTIONS(937),
    [anon_sym_u128] = ACTIONS(937),
    [anon_sym_i128] = ACTIONS(937),
    [anon_sym_isize] = ACTIONS(937),
    [anon_sym_usize] = ACTIONS(937),
    [anon_sym_f32] = ACTIONS(937),
    [anon_sym_f64] = ACTIONS(937),
    [anon_sym_bool] = ACTIONS(937),
    [anon_sym_str] = ACTIONS(937),
    [anon_sym_char] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_BANG] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(939),
    [anon_sym_AT] = ACTIONS(939),
    [anon_sym__] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_COLON_COLON] = ACTIONS(939),
    [anon_sym_DASH_GT] = ACTIONS(939),
    [anon_sym_POUND] = ACTIONS(939),
    [anon_sym_SQUOTE] = ACTIONS(937),
    [anon_sym_as] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(937),
    [anon_sym_await] = ACTIONS(937),
    [anon_sym_break] = ACTIONS(937),
    [anon_sym_const] = ACTIONS(937),
    [anon_sym_continue] = ACTIONS(937),
    [anon_sym_default] = ACTIONS(937),
    [anon_sym_enum] = ACTIONS(937),
    [anon_sym_fn] = ACTIONS(937),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(937),
    [anon_sym_impl] = ACTIONS(937),
    [anon_sym_let] = ACTIONS(937),
    [anon_sym_loop] = ACTIONS(937),
    [anon_sym_match] = ACTIONS(937),
    [anon_sym_mod] = ACTIONS(937),
    [anon_sym_pub] = ACTIONS(937),
    [anon_sym_return] = ACTIONS(937),
    [anon_sym_static] = ACTIONS(937),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_trait] = ACTIONS(937),
    [anon_sym_type] = ACTIONS(937),
    [anon_sym_union] = ACTIONS(937),
    [anon_sym_unsafe] = ACTIONS(937),
    [anon_sym_use] = ACTIONS(937),
    [anon_sym_where] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(937),
    [sym_mutable_specifier] = ACTIONS(937),
    [sym_integer_literal] = ACTIONS(939),
    [aux_sym_string_literal_token1] = ACTIONS(939),
    [sym_char_literal] = ACTIONS(939),
    [anon_sym_true] = ACTIONS(937),
    [anon_sym_false] = ACTIONS(937),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(937),
    [sym_super] = ACTIONS(937),
    [sym_crate] = ACTIONS(937),
    [sym_metavariable] = ACTIONS(939),
    [sym__raw_string_literal_start] = ACTIONS(939),
    [sym_float_literal] = ACTIONS(939),
  },
  [160] = {
    [sym_line_comment] = STATE(160),
    [sym_block_comment] = STATE(160),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(943),
    [anon_sym_RPAREN] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(943),
    [anon_sym_RBRACK] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(943),
    [anon_sym_RBRACE] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(943),
    [anon_sym_COLON] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(943),
    [anon_sym_u8] = ACTIONS(941),
    [anon_sym_i8] = ACTIONS(941),
    [anon_sym_u16] = ACTIONS(941),
    [anon_sym_i16] = ACTIONS(941),
    [anon_sym_u32] = ACTIONS(941),
    [anon_sym_i32] = ACTIONS(941),
    [anon_sym_u64] = ACTIONS(941),
    [anon_sym_i64] = ACTIONS(941),
    [anon_sym_u128] = ACTIONS(941),
    [anon_sym_i128] = ACTIONS(941),
    [anon_sym_isize] = ACTIONS(941),
    [anon_sym_usize] = ACTIONS(941),
    [anon_sym_f32] = ACTIONS(941),
    [anon_sym_f64] = ACTIONS(941),
    [anon_sym_bool] = ACTIONS(941),
    [anon_sym_str] = ACTIONS(941),
    [anon_sym_char] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(943),
    [anon_sym_PIPE_PIPE] = ACTIONS(943),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(943),
    [anon_sym_DASH_EQ] = ACTIONS(943),
    [anon_sym_STAR_EQ] = ACTIONS(943),
    [anon_sym_SLASH_EQ] = ACTIONS(943),
    [anon_sym_PERCENT_EQ] = ACTIONS(943),
    [anon_sym_CARET_EQ] = ACTIONS(943),
    [anon_sym_AMP_EQ] = ACTIONS(943),
    [anon_sym_PIPE_EQ] = ACTIONS(943),
    [anon_sym_LT_LT_EQ] = ACTIONS(943),
    [anon_sym_GT_GT_EQ] = ACTIONS(943),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(943),
    [anon_sym_BANG_EQ] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(943),
    [anon_sym_LT_EQ] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(943),
    [anon_sym__] = ACTIONS(941),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(943),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(943),
    [anon_sym_COMMA] = ACTIONS(943),
    [anon_sym_COLON_COLON] = ACTIONS(943),
    [anon_sym_DASH_GT] = ACTIONS(943),
    [anon_sym_POUND] = ACTIONS(943),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [anon_sym_as] = ACTIONS(941),
    [anon_sym_async] = ACTIONS(941),
    [anon_sym_await] = ACTIONS(941),
    [anon_sym_break] = ACTIONS(941),
    [anon_sym_const] = ACTIONS(941),
    [anon_sym_continue] = ACTIONS(941),
    [anon_sym_default] = ACTIONS(941),
    [anon_sym_enum] = ACTIONS(941),
    [anon_sym_fn] = ACTIONS(941),
    [anon_sym_for] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(941),
    [anon_sym_impl] = ACTIONS(941),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_loop] = ACTIONS(941),
    [anon_sym_match] = ACTIONS(941),
    [anon_sym_mod] = ACTIONS(941),
    [anon_sym_pub] = ACTIONS(941),
    [anon_sym_return] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(941),
    [anon_sym_struct] = ACTIONS(941),
    [anon_sym_trait] = ACTIONS(941),
    [anon_sym_type] = ACTIONS(941),
    [anon_sym_union] = ACTIONS(941),
    [anon_sym_unsafe] = ACTIONS(941),
    [anon_sym_use] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(941),
    [anon_sym_while] = ACTIONS(941),
    [sym_mutable_specifier] = ACTIONS(941),
    [sym_integer_literal] = ACTIONS(943),
    [aux_sym_string_literal_token1] = ACTIONS(943),
    [sym_char_literal] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(941),
    [anon_sym_false] = ACTIONS(941),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(941),
    [sym_super] = ACTIONS(941),
    [sym_crate] = ACTIONS(941),
    [sym_metavariable] = ACTIONS(943),
    [sym__raw_string_literal_start] = ACTIONS(943),
    [sym_float_literal] = ACTIONS(943),
  },
  [161] = {
    [sym_line_comment] = STATE(161),
    [sym_block_comment] = STATE(161),
    [sym_identifier] = ACTIONS(945),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_COLON] = ACTIONS(945),
    [anon_sym_DOLLAR] = ACTIONS(945),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_u8] = ACTIONS(945),
    [anon_sym_i8] = ACTIONS(945),
    [anon_sym_u16] = ACTIONS(945),
    [anon_sym_i16] = ACTIONS(945),
    [anon_sym_u32] = ACTIONS(945),
    [anon_sym_i32] = ACTIONS(945),
    [anon_sym_u64] = ACTIONS(945),
    [anon_sym_i64] = ACTIONS(945),
    [anon_sym_u128] = ACTIONS(945),
    [anon_sym_i128] = ACTIONS(945),
    [anon_sym_isize] = ACTIONS(945),
    [anon_sym_usize] = ACTIONS(945),
    [anon_sym_f32] = ACTIONS(945),
    [anon_sym_f64] = ACTIONS(945),
    [anon_sym_bool] = ACTIONS(945),
    [anon_sym_str] = ACTIONS(945),
    [anon_sym_char] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_PERCENT] = ACTIONS(945),
    [anon_sym_CARET] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(945),
    [anon_sym_PIPE] = ACTIONS(945),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(945),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_PLUS_EQ] = ACTIONS(947),
    [anon_sym_DASH_EQ] = ACTIONS(947),
    [anon_sym_STAR_EQ] = ACTIONS(947),
    [anon_sym_SLASH_EQ] = ACTIONS(947),
    [anon_sym_PERCENT_EQ] = ACTIONS(947),
    [anon_sym_CARET_EQ] = ACTIONS(947),
    [anon_sym_AMP_EQ] = ACTIONS(947),
    [anon_sym_PIPE_EQ] = ACTIONS(947),
    [anon_sym_LT_LT_EQ] = ACTIONS(947),
    [anon_sym_GT_GT_EQ] = ACTIONS(947),
    [anon_sym_EQ] = ACTIONS(945),
    [anon_sym_EQ_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_LT] = ACTIONS(945),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(947),
    [anon_sym__] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_DOT_DOT] = ACTIONS(945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(947),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(947),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(947),
    [anon_sym_DASH_GT] = ACTIONS(947),
    [anon_sym_POUND] = ACTIONS(947),
    [anon_sym_SQUOTE] = ACTIONS(945),
    [anon_sym_as] = ACTIONS(945),
    [anon_sym_async] = ACTIONS(945),
    [anon_sym_await] = ACTIONS(945),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_const] = ACTIONS(945),
    [anon_sym_continue] = ACTIONS(945),
    [anon_sym_default] = ACTIONS(945),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_fn] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(945),
    [anon_sym_impl] = ACTIONS(945),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_loop] = ACTIONS(945),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_mod] = ACTIONS(945),
    [anon_sym_pub] = ACTIONS(945),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(945),
    [anon_sym_struct] = ACTIONS(945),
    [anon_sym_trait] = ACTIONS(945),
    [anon_sym_type] = ACTIONS(945),
    [anon_sym_union] = ACTIONS(945),
    [anon_sym_unsafe] = ACTIONS(945),
    [anon_sym_use] = ACTIONS(945),
    [anon_sym_where] = ACTIONS(945),
    [anon_sym_while] = ACTIONS(945),
    [sym_mutable_specifier] = ACTIONS(945),
    [sym_integer_literal] = ACTIONS(947),
    [aux_sym_string_literal_token1] = ACTIONS(947),
    [sym_char_literal] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(945),
    [anon_sym_false] = ACTIONS(945),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(945),
    [sym_super] = ACTIONS(945),
    [sym_crate] = ACTIONS(945),
    [sym_metavariable] = ACTIONS(947),
    [sym__raw_string_literal_start] = ACTIONS(947),
    [sym_float_literal] = ACTIONS(947),
  },
  [162] = {
    [sym_line_comment] = STATE(162),
    [sym_block_comment] = STATE(162),
    [sym_identifier] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_RBRACK] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(951),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_EQ_GT] = ACTIONS(951),
    [anon_sym_COLON] = ACTIONS(949),
    [anon_sym_DOLLAR] = ACTIONS(949),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_STAR] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(951),
    [anon_sym_u8] = ACTIONS(949),
    [anon_sym_i8] = ACTIONS(949),
    [anon_sym_u16] = ACTIONS(949),
    [anon_sym_i16] = ACTIONS(949),
    [anon_sym_u32] = ACTIONS(949),
    [anon_sym_i32] = ACTIONS(949),
    [anon_sym_u64] = ACTIONS(949),
    [anon_sym_i64] = ACTIONS(949),
    [anon_sym_u128] = ACTIONS(949),
    [anon_sym_i128] = ACTIONS(949),
    [anon_sym_isize] = ACTIONS(949),
    [anon_sym_usize] = ACTIONS(949),
    [anon_sym_f32] = ACTIONS(949),
    [anon_sym_f64] = ACTIONS(949),
    [anon_sym_bool] = ACTIONS(949),
    [anon_sym_str] = ACTIONS(949),
    [anon_sym_char] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(949),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_CARET] = ACTIONS(949),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(951),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(949),
    [anon_sym_EQ_EQ] = ACTIONS(951),
    [anon_sym_BANG_EQ] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(951),
    [anon_sym_LT_EQ] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(951),
    [anon_sym__] = ACTIONS(949),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_DOT_DOT] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(951),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(951),
    [anon_sym_COMMA] = ACTIONS(951),
    [anon_sym_COLON_COLON] = ACTIONS(951),
    [anon_sym_DASH_GT] = ACTIONS(951),
    [anon_sym_POUND] = ACTIONS(951),
    [anon_sym_SQUOTE] = ACTIONS(949),
    [anon_sym_as] = ACTIONS(949),
    [anon_sym_async] = ACTIONS(949),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_const] = ACTIONS(949),
    [anon_sym_continue] = ACTIONS(949),
    [anon_sym_default] = ACTIONS(949),
    [anon_sym_enum] = ACTIONS(949),
    [anon_sym_fn] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(949),
    [anon_sym_impl] = ACTIONS(949),
    [anon_sym_let] = ACTIONS(949),
    [anon_sym_loop] = ACTIONS(949),
    [anon_sym_match] = ACTIONS(949),
    [anon_sym_mod] = ACTIONS(949),
    [anon_sym_pub] = ACTIONS(949),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_static] = ACTIONS(949),
    [anon_sym_struct] = ACTIONS(949),
    [anon_sym_trait] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(949),
    [anon_sym_union] = ACTIONS(949),
    [anon_sym_unsafe] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(949),
    [anon_sym_where] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(949),
    [sym_mutable_specifier] = ACTIONS(949),
    [sym_integer_literal] = ACTIONS(951),
    [aux_sym_string_literal_token1] = ACTIONS(951),
    [sym_char_literal] = ACTIONS(951),
    [anon_sym_true] = ACTIONS(949),
    [anon_sym_false] = ACTIONS(949),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(949),
    [sym_super] = ACTIONS(949),
    [sym_crate] = ACTIONS(949),
    [sym_metavariable] = ACTIONS(951),
    [sym__raw_string_literal_start] = ACTIONS(951),
    [sym_float_literal] = ACTIONS(951),
  },
  [163] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1560),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(163),
    [sym_block_comment] = STATE(163),
    [aux_sym_enum_variant_list_repeat1] = STATE(137),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [164] = {
    [sym_line_comment] = STATE(164),
    [sym_block_comment] = STATE(164),
    [sym_identifier] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_RBRACK] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_EQ_GT] = ACTIONS(959),
    [anon_sym_COLON] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(959),
    [anon_sym_u8] = ACTIONS(957),
    [anon_sym_i8] = ACTIONS(957),
    [anon_sym_u16] = ACTIONS(957),
    [anon_sym_i16] = ACTIONS(957),
    [anon_sym_u32] = ACTIONS(957),
    [anon_sym_i32] = ACTIONS(957),
    [anon_sym_u64] = ACTIONS(957),
    [anon_sym_i64] = ACTIONS(957),
    [anon_sym_u128] = ACTIONS(957),
    [anon_sym_i128] = ACTIONS(957),
    [anon_sym_isize] = ACTIONS(957),
    [anon_sym_usize] = ACTIONS(957),
    [anon_sym_f32] = ACTIONS(957),
    [anon_sym_f64] = ACTIONS(957),
    [anon_sym_bool] = ACTIONS(957),
    [anon_sym_str] = ACTIONS(957),
    [anon_sym_char] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(957),
    [anon_sym_PIPE] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(959),
    [anon_sym_PIPE_PIPE] = ACTIONS(959),
    [anon_sym_LT_LT] = ACTIONS(957),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_PLUS_EQ] = ACTIONS(959),
    [anon_sym_DASH_EQ] = ACTIONS(959),
    [anon_sym_STAR_EQ] = ACTIONS(959),
    [anon_sym_SLASH_EQ] = ACTIONS(959),
    [anon_sym_PERCENT_EQ] = ACTIONS(959),
    [anon_sym_CARET_EQ] = ACTIONS(959),
    [anon_sym_AMP_EQ] = ACTIONS(959),
    [anon_sym_PIPE_EQ] = ACTIONS(959),
    [anon_sym_LT_LT_EQ] = ACTIONS(959),
    [anon_sym_GT_GT_EQ] = ACTIONS(959),
    [anon_sym_EQ] = ACTIONS(957),
    [anon_sym_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym__] = ACTIONS(957),
    [anon_sym_DOT] = ACTIONS(957),
    [anon_sym_DOT_DOT] = ACTIONS(957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(959),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(959),
    [anon_sym_COMMA] = ACTIONS(959),
    [anon_sym_COLON_COLON] = ACTIONS(959),
    [anon_sym_DASH_GT] = ACTIONS(959),
    [anon_sym_POUND] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(957),
    [anon_sym_as] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_await] = ACTIONS(957),
    [anon_sym_break] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(957),
    [anon_sym_continue] = ACTIONS(957),
    [anon_sym_default] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(957),
    [anon_sym_fn] = ACTIONS(957),
    [anon_sym_for] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(957),
    [anon_sym_impl] = ACTIONS(957),
    [anon_sym_let] = ACTIONS(957),
    [anon_sym_loop] = ACTIONS(957),
    [anon_sym_match] = ACTIONS(957),
    [anon_sym_mod] = ACTIONS(957),
    [anon_sym_pub] = ACTIONS(957),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_static] = ACTIONS(957),
    [anon_sym_struct] = ACTIONS(957),
    [anon_sym_trait] = ACTIONS(957),
    [anon_sym_type] = ACTIONS(957),
    [anon_sym_union] = ACTIONS(957),
    [anon_sym_unsafe] = ACTIONS(957),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_where] = ACTIONS(957),
    [anon_sym_while] = ACTIONS(957),
    [sym_mutable_specifier] = ACTIONS(957),
    [sym_integer_literal] = ACTIONS(959),
    [aux_sym_string_literal_token1] = ACTIONS(959),
    [sym_char_literal] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(957),
    [anon_sym_false] = ACTIONS(957),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(957),
    [sym_super] = ACTIONS(957),
    [sym_crate] = ACTIONS(957),
    [sym_metavariable] = ACTIONS(959),
    [sym__raw_string_literal_start] = ACTIONS(959),
    [sym_float_literal] = ACTIONS(959),
  },
  [165] = {
    [sym_line_comment] = STATE(165),
    [sym_block_comment] = STATE(165),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(747),
    [anon_sym_RBRACK] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_EQ_GT] = ACTIONS(747),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(747),
    [anon_sym_u8] = ACTIONS(745),
    [anon_sym_i8] = ACTIONS(745),
    [anon_sym_u16] = ACTIONS(745),
    [anon_sym_i16] = ACTIONS(745),
    [anon_sym_u32] = ACTIONS(745),
    [anon_sym_i32] = ACTIONS(745),
    [anon_sym_u64] = ACTIONS(745),
    [anon_sym_i64] = ACTIONS(745),
    [anon_sym_u128] = ACTIONS(745),
    [anon_sym_i128] = ACTIONS(745),
    [anon_sym_isize] = ACTIONS(745),
    [anon_sym_usize] = ACTIONS(745),
    [anon_sym_f32] = ACTIONS(745),
    [anon_sym_f64] = ACTIONS(745),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_str] = ACTIONS(745),
    [anon_sym_char] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(745),
    [anon_sym_SLASH] = ACTIONS(745),
    [anon_sym_PERCENT] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(745),
    [anon_sym_BANG] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(747),
    [anon_sym_PIPE_PIPE] = ACTIONS(747),
    [anon_sym_LT_LT] = ACTIONS(745),
    [anon_sym_GT_GT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(747),
    [anon_sym_DASH_EQ] = ACTIONS(747),
    [anon_sym_STAR_EQ] = ACTIONS(747),
    [anon_sym_SLASH_EQ] = ACTIONS(747),
    [anon_sym_PERCENT_EQ] = ACTIONS(747),
    [anon_sym_CARET_EQ] = ACTIONS(747),
    [anon_sym_AMP_EQ] = ACTIONS(747),
    [anon_sym_PIPE_EQ] = ACTIONS(747),
    [anon_sym_LT_LT_EQ] = ACTIONS(747),
    [anon_sym_GT_GT_EQ] = ACTIONS(747),
    [anon_sym_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ] = ACTIONS(747),
    [anon_sym_BANG_EQ] = ACTIONS(747),
    [anon_sym_GT] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(745),
    [anon_sym_GT_EQ] = ACTIONS(747),
    [anon_sym_LT_EQ] = ACTIONS(747),
    [anon_sym_AT] = ACTIONS(747),
    [anon_sym__] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(747),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(747),
    [anon_sym_COMMA] = ACTIONS(747),
    [anon_sym_COLON_COLON] = ACTIONS(747),
    [anon_sym_DASH_GT] = ACTIONS(747),
    [anon_sym_POUND] = ACTIONS(747),
    [anon_sym_SQUOTE] = ACTIONS(745),
    [anon_sym_as] = ACTIONS(745),
    [anon_sym_async] = ACTIONS(745),
    [anon_sym_await] = ACTIONS(745),
    [anon_sym_break] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(745),
    [anon_sym_continue] = ACTIONS(745),
    [anon_sym_default] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_impl] = ACTIONS(745),
    [anon_sym_let] = ACTIONS(745),
    [anon_sym_loop] = ACTIONS(745),
    [anon_sym_match] = ACTIONS(745),
    [anon_sym_mod] = ACTIONS(745),
    [anon_sym_pub] = ACTIONS(745),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_trait] = ACTIONS(745),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_union] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(745),
    [anon_sym_use] = ACTIONS(745),
    [anon_sym_where] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [sym_mutable_specifier] = ACTIONS(745),
    [sym_integer_literal] = ACTIONS(747),
    [aux_sym_string_literal_token1] = ACTIONS(747),
    [sym_char_literal] = ACTIONS(747),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(745),
    [sym_super] = ACTIONS(745),
    [sym_crate] = ACTIONS(745),
    [sym_metavariable] = ACTIONS(747),
    [sym__raw_string_literal_start] = ACTIONS(747),
    [sym_float_literal] = ACTIONS(747),
  },
  [166] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1562),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(166),
    [sym_block_comment] = STATE(166),
    [aux_sym_enum_variant_list_repeat1] = STATE(163),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(961),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(963),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [167] = {
    [sym_line_comment] = STATE(167),
    [sym_block_comment] = STATE(167),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_EQ_GT] = ACTIONS(967),
    [anon_sym_COLON] = ACTIONS(965),
    [anon_sym_DOLLAR] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(965),
    [anon_sym_STAR] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_u8] = ACTIONS(965),
    [anon_sym_i8] = ACTIONS(965),
    [anon_sym_u16] = ACTIONS(965),
    [anon_sym_i16] = ACTIONS(965),
    [anon_sym_u32] = ACTIONS(965),
    [anon_sym_i32] = ACTIONS(965),
    [anon_sym_u64] = ACTIONS(965),
    [anon_sym_i64] = ACTIONS(965),
    [anon_sym_u128] = ACTIONS(965),
    [anon_sym_i128] = ACTIONS(965),
    [anon_sym_isize] = ACTIONS(965),
    [anon_sym_usize] = ACTIONS(965),
    [anon_sym_f32] = ACTIONS(965),
    [anon_sym_f64] = ACTIONS(965),
    [anon_sym_bool] = ACTIONS(965),
    [anon_sym_str] = ACTIONS(965),
    [anon_sym_char] = ACTIONS(965),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_LT_LT] = ACTIONS(965),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_PLUS_EQ] = ACTIONS(967),
    [anon_sym_DASH_EQ] = ACTIONS(967),
    [anon_sym_STAR_EQ] = ACTIONS(967),
    [anon_sym_SLASH_EQ] = ACTIONS(967),
    [anon_sym_PERCENT_EQ] = ACTIONS(967),
    [anon_sym_CARET_EQ] = ACTIONS(967),
    [anon_sym_AMP_EQ] = ACTIONS(967),
    [anon_sym_PIPE_EQ] = ACTIONS(967),
    [anon_sym_LT_LT_EQ] = ACTIONS(967),
    [anon_sym_GT_GT_EQ] = ACTIONS(967),
    [anon_sym_EQ] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(967),
    [anon_sym_BANG_EQ] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_GT_EQ] = ACTIONS(967),
    [anon_sym_LT_EQ] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(967),
    [anon_sym__] = ACTIONS(965),
    [anon_sym_DOT] = ACTIONS(965),
    [anon_sym_DOT_DOT] = ACTIONS(965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(967),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(967),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_COLON_COLON] = ACTIONS(967),
    [anon_sym_DASH_GT] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(967),
    [anon_sym_SQUOTE] = ACTIONS(965),
    [anon_sym_as] = ACTIONS(965),
    [anon_sym_async] = ACTIONS(965),
    [anon_sym_await] = ACTIONS(965),
    [anon_sym_break] = ACTIONS(965),
    [anon_sym_const] = ACTIONS(965),
    [anon_sym_continue] = ACTIONS(965),
    [anon_sym_default] = ACTIONS(965),
    [anon_sym_enum] = ACTIONS(965),
    [anon_sym_fn] = ACTIONS(965),
    [anon_sym_for] = ACTIONS(965),
    [anon_sym_if] = ACTIONS(965),
    [anon_sym_impl] = ACTIONS(965),
    [anon_sym_let] = ACTIONS(965),
    [anon_sym_loop] = ACTIONS(965),
    [anon_sym_match] = ACTIONS(965),
    [anon_sym_mod] = ACTIONS(965),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_return] = ACTIONS(965),
    [anon_sym_static] = ACTIONS(965),
    [anon_sym_struct] = ACTIONS(965),
    [anon_sym_trait] = ACTIONS(965),
    [anon_sym_type] = ACTIONS(965),
    [anon_sym_union] = ACTIONS(965),
    [anon_sym_unsafe] = ACTIONS(965),
    [anon_sym_use] = ACTIONS(965),
    [anon_sym_where] = ACTIONS(965),
    [anon_sym_while] = ACTIONS(965),
    [sym_mutable_specifier] = ACTIONS(965),
    [sym_integer_literal] = ACTIONS(967),
    [aux_sym_string_literal_token1] = ACTIONS(967),
    [sym_char_literal] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(965),
    [anon_sym_false] = ACTIONS(965),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(965),
    [sym_super] = ACTIONS(965),
    [sym_crate] = ACTIONS(965),
    [sym_metavariable] = ACTIONS(967),
    [sym__raw_string_literal_start] = ACTIONS(967),
    [sym_float_literal] = ACTIONS(967),
  },
  [168] = {
    [sym_line_comment] = STATE(168),
    [sym_block_comment] = STATE(168),
    [sym_identifier] = ACTIONS(969),
    [anon_sym_SEMI] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_RBRACK] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_EQ_GT] = ACTIONS(971),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_DOLLAR] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_u8] = ACTIONS(969),
    [anon_sym_i8] = ACTIONS(969),
    [anon_sym_u16] = ACTIONS(969),
    [anon_sym_i16] = ACTIONS(969),
    [anon_sym_u32] = ACTIONS(969),
    [anon_sym_i32] = ACTIONS(969),
    [anon_sym_u64] = ACTIONS(969),
    [anon_sym_i64] = ACTIONS(969),
    [anon_sym_u128] = ACTIONS(969),
    [anon_sym_i128] = ACTIONS(969),
    [anon_sym_isize] = ACTIONS(969),
    [anon_sym_usize] = ACTIONS(969),
    [anon_sym_f32] = ACTIONS(969),
    [anon_sym_f64] = ACTIONS(969),
    [anon_sym_bool] = ACTIONS(969),
    [anon_sym_str] = ACTIONS(969),
    [anon_sym_char] = ACTIONS(969),
    [anon_sym_DASH] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(969),
    [anon_sym_PERCENT] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(969),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(969),
    [anon_sym_PLUS_EQ] = ACTIONS(971),
    [anon_sym_DASH_EQ] = ACTIONS(971),
    [anon_sym_STAR_EQ] = ACTIONS(971),
    [anon_sym_SLASH_EQ] = ACTIONS(971),
    [anon_sym_PERCENT_EQ] = ACTIONS(971),
    [anon_sym_CARET_EQ] = ACTIONS(971),
    [anon_sym_AMP_EQ] = ACTIONS(971),
    [anon_sym_PIPE_EQ] = ACTIONS(971),
    [anon_sym_LT_LT_EQ] = ACTIONS(971),
    [anon_sym_GT_GT_EQ] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(969),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_LT] = ACTIONS(969),
    [anon_sym_GT_EQ] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(971),
    [anon_sym__] = ACTIONS(969),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(971),
    [anon_sym_COLON_COLON] = ACTIONS(971),
    [anon_sym_DASH_GT] = ACTIONS(971),
    [anon_sym_POUND] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(969),
    [anon_sym_as] = ACTIONS(969),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_await] = ACTIONS(969),
    [anon_sym_break] = ACTIONS(969),
    [anon_sym_const] = ACTIONS(969),
    [anon_sym_continue] = ACTIONS(969),
    [anon_sym_default] = ACTIONS(969),
    [anon_sym_enum] = ACTIONS(969),
    [anon_sym_fn] = ACTIONS(969),
    [anon_sym_for] = ACTIONS(969),
    [anon_sym_if] = ACTIONS(969),
    [anon_sym_impl] = ACTIONS(969),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_loop] = ACTIONS(969),
    [anon_sym_match] = ACTIONS(969),
    [anon_sym_mod] = ACTIONS(969),
    [anon_sym_pub] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(969),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_struct] = ACTIONS(969),
    [anon_sym_trait] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_union] = ACTIONS(969),
    [anon_sym_unsafe] = ACTIONS(969),
    [anon_sym_use] = ACTIONS(969),
    [anon_sym_where] = ACTIONS(969),
    [anon_sym_while] = ACTIONS(969),
    [sym_mutable_specifier] = ACTIONS(969),
    [sym_integer_literal] = ACTIONS(971),
    [aux_sym_string_literal_token1] = ACTIONS(971),
    [sym_char_literal] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(969),
    [anon_sym_false] = ACTIONS(969),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(969),
    [sym_super] = ACTIONS(969),
    [sym_crate] = ACTIONS(969),
    [sym_metavariable] = ACTIONS(971),
    [sym__raw_string_literal_start] = ACTIONS(971),
    [sym_float_literal] = ACTIONS(971),
  },
  [169] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2591),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(169),
    [sym_block_comment] = STATE(169),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [170] = {
    [sym_line_comment] = STATE(170),
    [sym_block_comment] = STATE(170),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_RBRACK] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_EQ_GT] = ACTIONS(983),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_DOLLAR] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(983),
    [anon_sym_u8] = ACTIONS(981),
    [anon_sym_i8] = ACTIONS(981),
    [anon_sym_u16] = ACTIONS(981),
    [anon_sym_i16] = ACTIONS(981),
    [anon_sym_u32] = ACTIONS(981),
    [anon_sym_i32] = ACTIONS(981),
    [anon_sym_u64] = ACTIONS(981),
    [anon_sym_i64] = ACTIONS(981),
    [anon_sym_u128] = ACTIONS(981),
    [anon_sym_i128] = ACTIONS(981),
    [anon_sym_isize] = ACTIONS(981),
    [anon_sym_usize] = ACTIONS(981),
    [anon_sym_f32] = ACTIONS(981),
    [anon_sym_f64] = ACTIONS(981),
    [anon_sym_bool] = ACTIONS(981),
    [anon_sym_str] = ACTIONS(981),
    [anon_sym_char] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(983),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(983),
    [anon_sym__] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(983),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_COLON_COLON] = ACTIONS(983),
    [anon_sym_DASH_GT] = ACTIONS(983),
    [anon_sym_POUND] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(981),
    [anon_sym_as] = ACTIONS(981),
    [anon_sym_async] = ACTIONS(981),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_const] = ACTIONS(981),
    [anon_sym_continue] = ACTIONS(981),
    [anon_sym_default] = ACTIONS(981),
    [anon_sym_enum] = ACTIONS(981),
    [anon_sym_fn] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_impl] = ACTIONS(981),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(981),
    [anon_sym_match] = ACTIONS(981),
    [anon_sym_mod] = ACTIONS(981),
    [anon_sym_pub] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_static] = ACTIONS(981),
    [anon_sym_struct] = ACTIONS(981),
    [anon_sym_trait] = ACTIONS(981),
    [anon_sym_type] = ACTIONS(981),
    [anon_sym_union] = ACTIONS(981),
    [anon_sym_unsafe] = ACTIONS(981),
    [anon_sym_use] = ACTIONS(981),
    [anon_sym_where] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [sym_mutable_specifier] = ACTIONS(981),
    [sym_integer_literal] = ACTIONS(983),
    [aux_sym_string_literal_token1] = ACTIONS(983),
    [sym_char_literal] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(981),
    [sym_super] = ACTIONS(981),
    [sym_crate] = ACTIONS(981),
    [sym__raw_string_literal_start] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(983),
  },
  [171] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2557),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(171),
    [sym_block_comment] = STATE(171),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [172] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(172),
    [sym_block_comment] = STATE(172),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [173] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2540),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(173),
    [sym_block_comment] = STATE(173),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [174] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2648),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(174),
    [sym_block_comment] = STATE(174),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [175] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1830),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(175),
    [sym_block_comment] = STATE(175),
    [aux_sym_enum_variant_list_repeat1] = STATE(210),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [176] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(176),
    [sym_block_comment] = STATE(176),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [177] = {
    [sym_line_comment] = STATE(177),
    [sym_block_comment] = STATE(177),
    [sym_identifier] = ACTIONS(933),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_COLON] = ACTIONS(933),
    [anon_sym_DOLLAR] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(933),
    [anon_sym_STAR] = ACTIONS(933),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_u8] = ACTIONS(933),
    [anon_sym_i8] = ACTIONS(933),
    [anon_sym_u16] = ACTIONS(933),
    [anon_sym_i16] = ACTIONS(933),
    [anon_sym_u32] = ACTIONS(933),
    [anon_sym_i32] = ACTIONS(933),
    [anon_sym_u64] = ACTIONS(933),
    [anon_sym_i64] = ACTIONS(933),
    [anon_sym_u128] = ACTIONS(933),
    [anon_sym_i128] = ACTIONS(933),
    [anon_sym_isize] = ACTIONS(933),
    [anon_sym_usize] = ACTIONS(933),
    [anon_sym_f32] = ACTIONS(933),
    [anon_sym_f64] = ACTIONS(933),
    [anon_sym_bool] = ACTIONS(933),
    [anon_sym_str] = ACTIONS(933),
    [anon_sym_char] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_SLASH] = ACTIONS(933),
    [anon_sym_PERCENT] = ACTIONS(933),
    [anon_sym_CARET] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
    [anon_sym_PIPE] = ACTIONS(933),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(933),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(935),
    [anon_sym__] = ACTIONS(933),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_COLON_COLON] = ACTIONS(935),
    [anon_sym_DASH_GT] = ACTIONS(935),
    [anon_sym_POUND] = ACTIONS(935),
    [anon_sym_SQUOTE] = ACTIONS(933),
    [anon_sym_as] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(933),
    [anon_sym_await] = ACTIONS(933),
    [anon_sym_break] = ACTIONS(933),
    [anon_sym_const] = ACTIONS(933),
    [anon_sym_continue] = ACTIONS(933),
    [anon_sym_default] = ACTIONS(933),
    [anon_sym_enum] = ACTIONS(933),
    [anon_sym_fn] = ACTIONS(933),
    [anon_sym_for] = ACTIONS(933),
    [anon_sym_if] = ACTIONS(933),
    [anon_sym_impl] = ACTIONS(933),
    [anon_sym_let] = ACTIONS(933),
    [anon_sym_loop] = ACTIONS(933),
    [anon_sym_match] = ACTIONS(933),
    [anon_sym_mod] = ACTIONS(933),
    [anon_sym_pub] = ACTIONS(933),
    [anon_sym_return] = ACTIONS(933),
    [anon_sym_static] = ACTIONS(933),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_trait] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(933),
    [anon_sym_union] = ACTIONS(933),
    [anon_sym_unsafe] = ACTIONS(933),
    [anon_sym_use] = ACTIONS(933),
    [anon_sym_where] = ACTIONS(933),
    [anon_sym_while] = ACTIONS(933),
    [sym_mutable_specifier] = ACTIONS(933),
    [sym_integer_literal] = ACTIONS(935),
    [aux_sym_string_literal_token1] = ACTIONS(935),
    [sym_char_literal] = ACTIONS(935),
    [anon_sym_true] = ACTIONS(933),
    [anon_sym_false] = ACTIONS(933),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(933),
    [sym_super] = ACTIONS(933),
    [sym_crate] = ACTIONS(933),
    [sym__raw_string_literal_start] = ACTIONS(935),
    [sym_float_literal] = ACTIONS(935),
  },
  [178] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(178),
    [sym_block_comment] = STATE(178),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [179] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2573),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(179),
    [sym_block_comment] = STATE(179),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [180] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1871),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_let_condition] = STATE(3176),
    [sym__let_chain] = STATE(3179),
    [sym__condition] = STATE(3435),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(180),
    [sym_block_comment] = STATE(180),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_let] = ACTIONS(999),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [181] = {
    [sym_line_comment] = STATE(181),
    [sym_block_comment] = STATE(181),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACK] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym_EQ_GT] = ACTIONS(1003),
    [anon_sym_COLON] = ACTIONS(1001),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_u8] = ACTIONS(1001),
    [anon_sym_i8] = ACTIONS(1001),
    [anon_sym_u16] = ACTIONS(1001),
    [anon_sym_i16] = ACTIONS(1001),
    [anon_sym_u32] = ACTIONS(1001),
    [anon_sym_i32] = ACTIONS(1001),
    [anon_sym_u64] = ACTIONS(1001),
    [anon_sym_i64] = ACTIONS(1001),
    [anon_sym_u128] = ACTIONS(1001),
    [anon_sym_i128] = ACTIONS(1001),
    [anon_sym_isize] = ACTIONS(1001),
    [anon_sym_usize] = ACTIONS(1001),
    [anon_sym_f32] = ACTIONS(1001),
    [anon_sym_f64] = ACTIONS(1001),
    [anon_sym_bool] = ACTIONS(1001),
    [anon_sym_str] = ACTIONS(1001),
    [anon_sym_char] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1001),
    [anon_sym_CARET] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(1001),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS_EQ] = ACTIONS(1003),
    [anon_sym_DASH_EQ] = ACTIONS(1003),
    [anon_sym_STAR_EQ] = ACTIONS(1003),
    [anon_sym_SLASH_EQ] = ACTIONS(1003),
    [anon_sym_PERCENT_EQ] = ACTIONS(1003),
    [anon_sym_CARET_EQ] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(1003),
    [anon_sym_PIPE_EQ] = ACTIONS(1003),
    [anon_sym_LT_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT_GT_EQ] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1001),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym__] = ACTIONS(1001),
    [anon_sym_DOT] = ACTIONS(1001),
    [anon_sym_DOT_DOT] = ACTIONS(1001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_DASH_GT] = ACTIONS(1003),
    [anon_sym_POUND] = ACTIONS(1003),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_as] = ACTIONS(1001),
    [anon_sym_async] = ACTIONS(1001),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1001),
    [anon_sym_continue] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(1001),
    [anon_sym_enum] = ACTIONS(1001),
    [anon_sym_fn] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1001),
    [anon_sym_impl] = ACTIONS(1001),
    [anon_sym_let] = ACTIONS(1001),
    [anon_sym_loop] = ACTIONS(1001),
    [anon_sym_match] = ACTIONS(1001),
    [anon_sym_mod] = ACTIONS(1001),
    [anon_sym_pub] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_static] = ACTIONS(1001),
    [anon_sym_struct] = ACTIONS(1001),
    [anon_sym_trait] = ACTIONS(1001),
    [anon_sym_type] = ACTIONS(1001),
    [anon_sym_union] = ACTIONS(1001),
    [anon_sym_unsafe] = ACTIONS(1001),
    [anon_sym_use] = ACTIONS(1001),
    [anon_sym_where] = ACTIONS(1001),
    [anon_sym_while] = ACTIONS(1001),
    [sym_mutable_specifier] = ACTIONS(1001),
    [sym_integer_literal] = ACTIONS(1003),
    [aux_sym_string_literal_token1] = ACTIONS(1003),
    [sym_char_literal] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1001),
    [anon_sym_false] = ACTIONS(1001),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1001),
    [sym_super] = ACTIONS(1001),
    [sym_crate] = ACTIONS(1001),
    [sym__raw_string_literal_start] = ACTIONS(1003),
    [sym_float_literal] = ACTIONS(1003),
  },
  [182] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2523),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(182),
    [sym_block_comment] = STATE(182),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [183] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(183),
    [sym_block_comment] = STATE(183),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [184] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2642),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(184),
    [sym_block_comment] = STATE(184),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [185] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(185),
    [sym_block_comment] = STATE(185),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [186] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(186),
    [sym_block_comment] = STATE(186),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [187] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1825),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(187),
    [sym_block_comment] = STATE(187),
    [aux_sym_enum_variant_list_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [188] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(188),
    [sym_block_comment] = STATE(188),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [189] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(189),
    [sym_block_comment] = STATE(189),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1015),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [190] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(190),
    [sym_block_comment] = STATE(190),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [191] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(191),
    [sym_block_comment] = STATE(191),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [192] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(192),
    [sym_block_comment] = STATE(192),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [193] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2521),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(193),
    [sym_block_comment] = STATE(193),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [194] = {
    [sym_line_comment] = STATE(194),
    [sym_block_comment] = STATE(194),
    [sym_identifier] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_RBRACK] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_COLON] = ACTIONS(885),
    [anon_sym_DOLLAR] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(885),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_u8] = ACTIONS(885),
    [anon_sym_i8] = ACTIONS(885),
    [anon_sym_u16] = ACTIONS(885),
    [anon_sym_i16] = ACTIONS(885),
    [anon_sym_u32] = ACTIONS(885),
    [anon_sym_i32] = ACTIONS(885),
    [anon_sym_u64] = ACTIONS(885),
    [anon_sym_i64] = ACTIONS(885),
    [anon_sym_u128] = ACTIONS(885),
    [anon_sym_i128] = ACTIONS(885),
    [anon_sym_isize] = ACTIONS(885),
    [anon_sym_usize] = ACTIONS(885),
    [anon_sym_f32] = ACTIONS(885),
    [anon_sym_f64] = ACTIONS(885),
    [anon_sym_bool] = ACTIONS(885),
    [anon_sym_str] = ACTIONS(885),
    [anon_sym_char] = ACTIONS(885),
    [anon_sym_DASH] = ACTIONS(885),
    [anon_sym_SLASH] = ACTIONS(885),
    [anon_sym_PERCENT] = ACTIONS(885),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(885),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_EQ] = ACTIONS(885),
    [anon_sym_EQ_EQ] = ACTIONS(887),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(887),
    [anon_sym__] = ACTIONS(885),
    [anon_sym_DOT] = ACTIONS(885),
    [anon_sym_DOT_DOT] = ACTIONS(885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_DASH_GT] = ACTIONS(887),
    [anon_sym_POUND] = ACTIONS(887),
    [anon_sym_SQUOTE] = ACTIONS(885),
    [anon_sym_as] = ACTIONS(885),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(885),
    [anon_sym_break] = ACTIONS(885),
    [anon_sym_const] = ACTIONS(885),
    [anon_sym_continue] = ACTIONS(885),
    [anon_sym_default] = ACTIONS(885),
    [anon_sym_enum] = ACTIONS(885),
    [anon_sym_fn] = ACTIONS(885),
    [anon_sym_for] = ACTIONS(885),
    [anon_sym_if] = ACTIONS(885),
    [anon_sym_impl] = ACTIONS(885),
    [anon_sym_let] = ACTIONS(885),
    [anon_sym_loop] = ACTIONS(885),
    [anon_sym_match] = ACTIONS(885),
    [anon_sym_mod] = ACTIONS(885),
    [anon_sym_pub] = ACTIONS(885),
    [anon_sym_return] = ACTIONS(885),
    [anon_sym_static] = ACTIONS(885),
    [anon_sym_struct] = ACTIONS(885),
    [anon_sym_trait] = ACTIONS(885),
    [anon_sym_type] = ACTIONS(885),
    [anon_sym_union] = ACTIONS(885),
    [anon_sym_unsafe] = ACTIONS(885),
    [anon_sym_use] = ACTIONS(885),
    [anon_sym_where] = ACTIONS(885),
    [anon_sym_while] = ACTIONS(885),
    [sym_mutable_specifier] = ACTIONS(885),
    [sym_integer_literal] = ACTIONS(887),
    [aux_sym_string_literal_token1] = ACTIONS(887),
    [sym_char_literal] = ACTIONS(887),
    [anon_sym_true] = ACTIONS(885),
    [anon_sym_false] = ACTIONS(885),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(885),
    [sym_super] = ACTIONS(885),
    [sym_crate] = ACTIONS(885),
    [sym__raw_string_literal_start] = ACTIONS(887),
    [sym_float_literal] = ACTIONS(887),
  },
  [195] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(195),
    [sym_block_comment] = STATE(195),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [196] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(196),
    [sym_block_comment] = STATE(196),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [197] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(197),
    [sym_block_comment] = STATE(197),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [198] = {
    [sym_line_comment] = STATE(198),
    [sym_block_comment] = STATE(198),
    [sym_identifier] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_u8] = ACTIONS(937),
    [anon_sym_i8] = ACTIONS(937),
    [anon_sym_u16] = ACTIONS(937),
    [anon_sym_i16] = ACTIONS(937),
    [anon_sym_u32] = ACTIONS(937),
    [anon_sym_i32] = ACTIONS(937),
    [anon_sym_u64] = ACTIONS(937),
    [anon_sym_i64] = ACTIONS(937),
    [anon_sym_u128] = ACTIONS(937),
    [anon_sym_i128] = ACTIONS(937),
    [anon_sym_isize] = ACTIONS(937),
    [anon_sym_usize] = ACTIONS(937),
    [anon_sym_f32] = ACTIONS(937),
    [anon_sym_f64] = ACTIONS(937),
    [anon_sym_bool] = ACTIONS(937),
    [anon_sym_str] = ACTIONS(937),
    [anon_sym_char] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_BANG] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(939),
    [anon_sym_AT] = ACTIONS(939),
    [anon_sym__] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_COLON_COLON] = ACTIONS(939),
    [anon_sym_DASH_GT] = ACTIONS(939),
    [anon_sym_POUND] = ACTIONS(939),
    [anon_sym_SQUOTE] = ACTIONS(937),
    [anon_sym_as] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(937),
    [anon_sym_await] = ACTIONS(937),
    [anon_sym_break] = ACTIONS(937),
    [anon_sym_const] = ACTIONS(937),
    [anon_sym_continue] = ACTIONS(937),
    [anon_sym_default] = ACTIONS(937),
    [anon_sym_enum] = ACTIONS(937),
    [anon_sym_fn] = ACTIONS(937),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(937),
    [anon_sym_impl] = ACTIONS(937),
    [anon_sym_let] = ACTIONS(937),
    [anon_sym_loop] = ACTIONS(937),
    [anon_sym_match] = ACTIONS(937),
    [anon_sym_mod] = ACTIONS(937),
    [anon_sym_pub] = ACTIONS(937),
    [anon_sym_return] = ACTIONS(937),
    [anon_sym_static] = ACTIONS(937),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_trait] = ACTIONS(937),
    [anon_sym_type] = ACTIONS(937),
    [anon_sym_union] = ACTIONS(937),
    [anon_sym_unsafe] = ACTIONS(937),
    [anon_sym_use] = ACTIONS(937),
    [anon_sym_where] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(937),
    [sym_mutable_specifier] = ACTIONS(937),
    [sym_integer_literal] = ACTIONS(939),
    [aux_sym_string_literal_token1] = ACTIONS(939),
    [sym_char_literal] = ACTIONS(939),
    [anon_sym_true] = ACTIONS(937),
    [anon_sym_false] = ACTIONS(937),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(937),
    [sym_super] = ACTIONS(937),
    [sym_crate] = ACTIONS(937),
    [sym__raw_string_literal_start] = ACTIONS(939),
    [sym_float_literal] = ACTIONS(939),
  },
  [199] = {
    [sym_line_comment] = STATE(199),
    [sym_block_comment] = STATE(199),
    [sym_identifier] = ACTIONS(945),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_COLON] = ACTIONS(945),
    [anon_sym_DOLLAR] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_u8] = ACTIONS(945),
    [anon_sym_i8] = ACTIONS(945),
    [anon_sym_u16] = ACTIONS(945),
    [anon_sym_i16] = ACTIONS(945),
    [anon_sym_u32] = ACTIONS(945),
    [anon_sym_i32] = ACTIONS(945),
    [anon_sym_u64] = ACTIONS(945),
    [anon_sym_i64] = ACTIONS(945),
    [anon_sym_u128] = ACTIONS(945),
    [anon_sym_i128] = ACTIONS(945),
    [anon_sym_isize] = ACTIONS(945),
    [anon_sym_usize] = ACTIONS(945),
    [anon_sym_f32] = ACTIONS(945),
    [anon_sym_f64] = ACTIONS(945),
    [anon_sym_bool] = ACTIONS(945),
    [anon_sym_str] = ACTIONS(945),
    [anon_sym_char] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_PERCENT] = ACTIONS(945),
    [anon_sym_CARET] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(945),
    [anon_sym_PIPE] = ACTIONS(945),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(945),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_PLUS_EQ] = ACTIONS(947),
    [anon_sym_DASH_EQ] = ACTIONS(947),
    [anon_sym_STAR_EQ] = ACTIONS(947),
    [anon_sym_SLASH_EQ] = ACTIONS(947),
    [anon_sym_PERCENT_EQ] = ACTIONS(947),
    [anon_sym_CARET_EQ] = ACTIONS(947),
    [anon_sym_AMP_EQ] = ACTIONS(947),
    [anon_sym_PIPE_EQ] = ACTIONS(947),
    [anon_sym_LT_LT_EQ] = ACTIONS(947),
    [anon_sym_GT_GT_EQ] = ACTIONS(947),
    [anon_sym_EQ] = ACTIONS(945),
    [anon_sym_EQ_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_LT] = ACTIONS(945),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(947),
    [anon_sym__] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_DOT_DOT] = ACTIONS(945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(947),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(947),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(947),
    [anon_sym_DASH_GT] = ACTIONS(947),
    [anon_sym_POUND] = ACTIONS(947),
    [anon_sym_SQUOTE] = ACTIONS(945),
    [anon_sym_as] = ACTIONS(945),
    [anon_sym_async] = ACTIONS(945),
    [anon_sym_await] = ACTIONS(945),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_const] = ACTIONS(945),
    [anon_sym_continue] = ACTIONS(945),
    [anon_sym_default] = ACTIONS(945),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_fn] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(945),
    [anon_sym_impl] = ACTIONS(945),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_loop] = ACTIONS(945),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_mod] = ACTIONS(945),
    [anon_sym_pub] = ACTIONS(945),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(945),
    [anon_sym_struct] = ACTIONS(945),
    [anon_sym_trait] = ACTIONS(945),
    [anon_sym_type] = ACTIONS(945),
    [anon_sym_union] = ACTIONS(945),
    [anon_sym_unsafe] = ACTIONS(945),
    [anon_sym_use] = ACTIONS(945),
    [anon_sym_where] = ACTIONS(945),
    [anon_sym_while] = ACTIONS(945),
    [sym_mutable_specifier] = ACTIONS(945),
    [sym_integer_literal] = ACTIONS(947),
    [aux_sym_string_literal_token1] = ACTIONS(947),
    [sym_char_literal] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(945),
    [anon_sym_false] = ACTIONS(945),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(945),
    [sym_super] = ACTIONS(945),
    [sym_crate] = ACTIONS(945),
    [sym__raw_string_literal_start] = ACTIONS(947),
    [sym_float_literal] = ACTIONS(947),
  },
  [200] = {
    [sym_line_comment] = STATE(200),
    [sym_block_comment] = STATE(200),
    [sym_identifier] = ACTIONS(903),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_COLON] = ACTIONS(903),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_STAR] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_u8] = ACTIONS(903),
    [anon_sym_i8] = ACTIONS(903),
    [anon_sym_u16] = ACTIONS(903),
    [anon_sym_i16] = ACTIONS(903),
    [anon_sym_u32] = ACTIONS(903),
    [anon_sym_i32] = ACTIONS(903),
    [anon_sym_u64] = ACTIONS(903),
    [anon_sym_i64] = ACTIONS(903),
    [anon_sym_u128] = ACTIONS(903),
    [anon_sym_i128] = ACTIONS(903),
    [anon_sym_isize] = ACTIONS(903),
    [anon_sym_usize] = ACTIONS(903),
    [anon_sym_f32] = ACTIONS(903),
    [anon_sym_f64] = ACTIONS(903),
    [anon_sym_bool] = ACTIONS(903),
    [anon_sym_str] = ACTIONS(903),
    [anon_sym_char] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_BANG] = ACTIONS(903),
    [anon_sym_AMP] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(903),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(905),
    [anon_sym__] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(903),
    [anon_sym_DOT_DOT] = ACTIONS(903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_COLON_COLON] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(905),
    [anon_sym_POUND] = ACTIONS(905),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_as] = ACTIONS(903),
    [anon_sym_async] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_break] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(903),
    [anon_sym_continue] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(903),
    [anon_sym_enum] = ACTIONS(903),
    [anon_sym_fn] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_impl] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(903),
    [anon_sym_loop] = ACTIONS(903),
    [anon_sym_match] = ACTIONS(903),
    [anon_sym_mod] = ACTIONS(903),
    [anon_sym_pub] = ACTIONS(903),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_static] = ACTIONS(903),
    [anon_sym_struct] = ACTIONS(903),
    [anon_sym_trait] = ACTIONS(903),
    [anon_sym_type] = ACTIONS(903),
    [anon_sym_union] = ACTIONS(903),
    [anon_sym_unsafe] = ACTIONS(903),
    [anon_sym_use] = ACTIONS(903),
    [anon_sym_where] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [sym_mutable_specifier] = ACTIONS(903),
    [sym_integer_literal] = ACTIONS(905),
    [aux_sym_string_literal_token1] = ACTIONS(905),
    [sym_char_literal] = ACTIONS(905),
    [anon_sym_true] = ACTIONS(903),
    [anon_sym_false] = ACTIONS(903),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(903),
    [sym_super] = ACTIONS(903),
    [sym_crate] = ACTIONS(903),
    [sym__raw_string_literal_start] = ACTIONS(905),
    [sym_float_literal] = ACTIONS(905),
  },
  [201] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2654),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(201),
    [sym_block_comment] = STATE(201),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [202] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2595),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(202),
    [sym_block_comment] = STATE(202),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [203] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2628),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(203),
    [sym_block_comment] = STATE(203),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [204] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2840),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2627),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(204),
    [sym_block_comment] = STATE(204),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [205] = {
    [sym_line_comment] = STATE(205),
    [sym_block_comment] = STATE(205),
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [anon_sym_RBRACK] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_EQ_GT] = ACTIONS(1031),
    [anon_sym_COLON] = ACTIONS(1029),
    [anon_sym_DOLLAR] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1031),
    [anon_sym_u8] = ACTIONS(1029),
    [anon_sym_i8] = ACTIONS(1029),
    [anon_sym_u16] = ACTIONS(1029),
    [anon_sym_i16] = ACTIONS(1029),
    [anon_sym_u32] = ACTIONS(1029),
    [anon_sym_i32] = ACTIONS(1029),
    [anon_sym_u64] = ACTIONS(1029),
    [anon_sym_i64] = ACTIONS(1029),
    [anon_sym_u128] = ACTIONS(1029),
    [anon_sym_i128] = ACTIONS(1029),
    [anon_sym_isize] = ACTIONS(1029),
    [anon_sym_usize] = ACTIONS(1029),
    [anon_sym_f32] = ACTIONS(1029),
    [anon_sym_f64] = ACTIONS(1029),
    [anon_sym_bool] = ACTIONS(1029),
    [anon_sym_str] = ACTIONS(1029),
    [anon_sym_char] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_SLASH] = ACTIONS(1029),
    [anon_sym_PERCENT] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_AMP_AMP] = ACTIONS(1031),
    [anon_sym_PIPE_PIPE] = ACTIONS(1031),
    [anon_sym_LT_LT] = ACTIONS(1029),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1031),
    [anon_sym_DASH_EQ] = ACTIONS(1031),
    [anon_sym_STAR_EQ] = ACTIONS(1031),
    [anon_sym_SLASH_EQ] = ACTIONS(1031),
    [anon_sym_PERCENT_EQ] = ACTIONS(1031),
    [anon_sym_CARET_EQ] = ACTIONS(1031),
    [anon_sym_AMP_EQ] = ACTIONS(1031),
    [anon_sym_PIPE_EQ] = ACTIONS(1031),
    [anon_sym_LT_LT_EQ] = ACTIONS(1031),
    [anon_sym_GT_GT_EQ] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1029),
    [anon_sym_LT] = ACTIONS(1029),
    [anon_sym_GT_EQ] = ACTIONS(1031),
    [anon_sym_LT_EQ] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1031),
    [anon_sym__] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1029),
    [anon_sym_DOT_DOT] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1031),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1031),
    [anon_sym_COLON_COLON] = ACTIONS(1031),
    [anon_sym_DASH_GT] = ACTIONS(1031),
    [anon_sym_POUND] = ACTIONS(1031),
    [anon_sym_SQUOTE] = ACTIONS(1029),
    [anon_sym_as] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1029),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [anon_sym_default] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(1029),
    [anon_sym_fn] = ACTIONS(1029),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_impl] = ACTIONS(1029),
    [anon_sym_let] = ACTIONS(1029),
    [anon_sym_loop] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1029),
    [anon_sym_mod] = ACTIONS(1029),
    [anon_sym_pub] = ACTIONS(1029),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1029),
    [anon_sym_struct] = ACTIONS(1029),
    [anon_sym_trait] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1029),
    [anon_sym_union] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1029),
    [anon_sym_use] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(1029),
    [anon_sym_while] = ACTIONS(1029),
    [sym_mutable_specifier] = ACTIONS(1029),
    [sym_integer_literal] = ACTIONS(1031),
    [aux_sym_string_literal_token1] = ACTIONS(1031),
    [sym_char_literal] = ACTIONS(1031),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1029),
    [sym_super] = ACTIONS(1029),
    [sym_crate] = ACTIONS(1029),
    [sym__raw_string_literal_start] = ACTIONS(1031),
    [sym_float_literal] = ACTIONS(1031),
  },
  [206] = {
    [sym_line_comment] = STATE(206),
    [sym_block_comment] = STATE(206),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_EQ_GT] = ACTIONS(967),
    [anon_sym_COLON] = ACTIONS(965),
    [anon_sym_DOLLAR] = ACTIONS(967),
    [anon_sym_PLUS] = ACTIONS(965),
    [anon_sym_STAR] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_u8] = ACTIONS(965),
    [anon_sym_i8] = ACTIONS(965),
    [anon_sym_u16] = ACTIONS(965),
    [anon_sym_i16] = ACTIONS(965),
    [anon_sym_u32] = ACTIONS(965),
    [anon_sym_i32] = ACTIONS(965),
    [anon_sym_u64] = ACTIONS(965),
    [anon_sym_i64] = ACTIONS(965),
    [anon_sym_u128] = ACTIONS(965),
    [anon_sym_i128] = ACTIONS(965),
    [anon_sym_isize] = ACTIONS(965),
    [anon_sym_usize] = ACTIONS(965),
    [anon_sym_f32] = ACTIONS(965),
    [anon_sym_f64] = ACTIONS(965),
    [anon_sym_bool] = ACTIONS(965),
    [anon_sym_str] = ACTIONS(965),
    [anon_sym_char] = ACTIONS(965),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_LT_LT] = ACTIONS(965),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_PLUS_EQ] = ACTIONS(967),
    [anon_sym_DASH_EQ] = ACTIONS(967),
    [anon_sym_STAR_EQ] = ACTIONS(967),
    [anon_sym_SLASH_EQ] = ACTIONS(967),
    [anon_sym_PERCENT_EQ] = ACTIONS(967),
    [anon_sym_CARET_EQ] = ACTIONS(967),
    [anon_sym_AMP_EQ] = ACTIONS(967),
    [anon_sym_PIPE_EQ] = ACTIONS(967),
    [anon_sym_LT_LT_EQ] = ACTIONS(967),
    [anon_sym_GT_GT_EQ] = ACTIONS(967),
    [anon_sym_EQ] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(967),
    [anon_sym_BANG_EQ] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_GT_EQ] = ACTIONS(967),
    [anon_sym_LT_EQ] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(967),
    [anon_sym__] = ACTIONS(965),
    [anon_sym_DOT] = ACTIONS(965),
    [anon_sym_DOT_DOT] = ACTIONS(965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(967),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(967),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_COLON_COLON] = ACTIONS(967),
    [anon_sym_DASH_GT] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(967),
    [anon_sym_SQUOTE] = ACTIONS(965),
    [anon_sym_as] = ACTIONS(965),
    [anon_sym_async] = ACTIONS(965),
    [anon_sym_await] = ACTIONS(965),
    [anon_sym_break] = ACTIONS(965),
    [anon_sym_const] = ACTIONS(965),
    [anon_sym_continue] = ACTIONS(965),
    [anon_sym_default] = ACTIONS(965),
    [anon_sym_enum] = ACTIONS(965),
    [anon_sym_fn] = ACTIONS(965),
    [anon_sym_for] = ACTIONS(965),
    [anon_sym_if] = ACTIONS(965),
    [anon_sym_impl] = ACTIONS(965),
    [anon_sym_let] = ACTIONS(965),
    [anon_sym_loop] = ACTIONS(965),
    [anon_sym_match] = ACTIONS(965),
    [anon_sym_mod] = ACTIONS(965),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_return] = ACTIONS(965),
    [anon_sym_static] = ACTIONS(965),
    [anon_sym_struct] = ACTIONS(965),
    [anon_sym_trait] = ACTIONS(965),
    [anon_sym_type] = ACTIONS(965),
    [anon_sym_union] = ACTIONS(965),
    [anon_sym_unsafe] = ACTIONS(965),
    [anon_sym_use] = ACTIONS(965),
    [anon_sym_where] = ACTIONS(965),
    [anon_sym_while] = ACTIONS(965),
    [sym_mutable_specifier] = ACTIONS(965),
    [sym_integer_literal] = ACTIONS(967),
    [aux_sym_string_literal_token1] = ACTIONS(967),
    [sym_char_literal] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(965),
    [anon_sym_false] = ACTIONS(965),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(965),
    [sym_super] = ACTIONS(965),
    [sym_crate] = ACTIONS(965),
    [sym__raw_string_literal_start] = ACTIONS(967),
    [sym_float_literal] = ACTIONS(967),
  },
  [207] = {
    [sym_line_comment] = STATE(207),
    [sym_block_comment] = STATE(207),
    [sym_identifier] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_RBRACK] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_EQ_GT] = ACTIONS(917),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_DOLLAR] = ACTIONS(917),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(917),
    [anon_sym_u8] = ACTIONS(915),
    [anon_sym_i8] = ACTIONS(915),
    [anon_sym_u16] = ACTIONS(915),
    [anon_sym_i16] = ACTIONS(915),
    [anon_sym_u32] = ACTIONS(915),
    [anon_sym_i32] = ACTIONS(915),
    [anon_sym_u64] = ACTIONS(915),
    [anon_sym_i64] = ACTIONS(915),
    [anon_sym_u128] = ACTIONS(915),
    [anon_sym_i128] = ACTIONS(915),
    [anon_sym_isize] = ACTIONS(915),
    [anon_sym_usize] = ACTIONS(915),
    [anon_sym_f32] = ACTIONS(915),
    [anon_sym_f64] = ACTIONS(915),
    [anon_sym_bool] = ACTIONS(915),
    [anon_sym_str] = ACTIONS(915),
    [anon_sym_char] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(917),
    [anon_sym_PIPE_PIPE] = ACTIONS(917),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_PLUS_EQ] = ACTIONS(917),
    [anon_sym_DASH_EQ] = ACTIONS(917),
    [anon_sym_STAR_EQ] = ACTIONS(917),
    [anon_sym_SLASH_EQ] = ACTIONS(917),
    [anon_sym_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_CARET_EQ] = ACTIONS(917),
    [anon_sym_AMP_EQ] = ACTIONS(917),
    [anon_sym_PIPE_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_EQ] = ACTIONS(917),
    [anon_sym_GT_GT_EQ] = ACTIONS(917),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_AT] = ACTIONS(917),
    [anon_sym__] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(917),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(917),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_COLON_COLON] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(917),
    [anon_sym_POUND] = ACTIONS(917),
    [anon_sym_SQUOTE] = ACTIONS(915),
    [anon_sym_as] = ACTIONS(915),
    [anon_sym_async] = ACTIONS(915),
    [anon_sym_await] = ACTIONS(915),
    [anon_sym_break] = ACTIONS(915),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_continue] = ACTIONS(915),
    [anon_sym_default] = ACTIONS(915),
    [anon_sym_enum] = ACTIONS(915),
    [anon_sym_fn] = ACTIONS(915),
    [anon_sym_for] = ACTIONS(915),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_impl] = ACTIONS(915),
    [anon_sym_let] = ACTIONS(915),
    [anon_sym_loop] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(915),
    [anon_sym_mod] = ACTIONS(915),
    [anon_sym_pub] = ACTIONS(915),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_static] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(915),
    [anon_sym_trait] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(915),
    [anon_sym_unsafe] = ACTIONS(915),
    [anon_sym_use] = ACTIONS(915),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_while] = ACTIONS(915),
    [sym_mutable_specifier] = ACTIONS(915),
    [sym_integer_literal] = ACTIONS(917),
    [aux_sym_string_literal_token1] = ACTIONS(917),
    [sym_char_literal] = ACTIONS(917),
    [anon_sym_true] = ACTIONS(915),
    [anon_sym_false] = ACTIONS(915),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(915),
    [sym_super] = ACTIONS(915),
    [sym_crate] = ACTIONS(915),
    [sym__raw_string_literal_start] = ACTIONS(917),
    [sym_float_literal] = ACTIONS(917),
  },
  [208] = {
    [sym_line_comment] = STATE(208),
    [sym_block_comment] = STATE(208),
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(1035),
    [anon_sym_RPAREN] = ACTIONS(1035),
    [anon_sym_LBRACK] = ACTIONS(1035),
    [anon_sym_RBRACK] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1035),
    [anon_sym_RBRACE] = ACTIONS(1035),
    [anon_sym_EQ_GT] = ACTIONS(1035),
    [anon_sym_COLON] = ACTIONS(1033),
    [anon_sym_DOLLAR] = ACTIONS(1035),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_QMARK] = ACTIONS(1035),
    [anon_sym_u8] = ACTIONS(1033),
    [anon_sym_i8] = ACTIONS(1033),
    [anon_sym_u16] = ACTIONS(1033),
    [anon_sym_i16] = ACTIONS(1033),
    [anon_sym_u32] = ACTIONS(1033),
    [anon_sym_i32] = ACTIONS(1033),
    [anon_sym_u64] = ACTIONS(1033),
    [anon_sym_i64] = ACTIONS(1033),
    [anon_sym_u128] = ACTIONS(1033),
    [anon_sym_i128] = ACTIONS(1033),
    [anon_sym_isize] = ACTIONS(1033),
    [anon_sym_usize] = ACTIONS(1033),
    [anon_sym_f32] = ACTIONS(1033),
    [anon_sym_f64] = ACTIONS(1033),
    [anon_sym_bool] = ACTIONS(1033),
    [anon_sym_str] = ACTIONS(1033),
    [anon_sym_char] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_SLASH] = ACTIONS(1033),
    [anon_sym_PERCENT] = ACTIONS(1033),
    [anon_sym_CARET] = ACTIONS(1033),
    [anon_sym_BANG] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1033),
    [anon_sym_PIPE] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_LT_LT] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_PLUS_EQ] = ACTIONS(1035),
    [anon_sym_DASH_EQ] = ACTIONS(1035),
    [anon_sym_STAR_EQ] = ACTIONS(1035),
    [anon_sym_SLASH_EQ] = ACTIONS(1035),
    [anon_sym_PERCENT_EQ] = ACTIONS(1035),
    [anon_sym_CARET_EQ] = ACTIONS(1035),
    [anon_sym_AMP_EQ] = ACTIONS(1035),
    [anon_sym_PIPE_EQ] = ACTIONS(1035),
    [anon_sym_LT_LT_EQ] = ACTIONS(1035),
    [anon_sym_GT_GT_EQ] = ACTIONS(1035),
    [anon_sym_EQ] = ACTIONS(1033),
    [anon_sym_EQ_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(1035),
    [anon_sym_GT] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1033),
    [anon_sym_GT_EQ] = ACTIONS(1035),
    [anon_sym_LT_EQ] = ACTIONS(1035),
    [anon_sym_AT] = ACTIONS(1035),
    [anon_sym__] = ACTIONS(1033),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_DOT_DOT] = ACTIONS(1033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1035),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1035),
    [anon_sym_COMMA] = ACTIONS(1035),
    [anon_sym_COLON_COLON] = ACTIONS(1035),
    [anon_sym_DASH_GT] = ACTIONS(1035),
    [anon_sym_POUND] = ACTIONS(1035),
    [anon_sym_SQUOTE] = ACTIONS(1033),
    [anon_sym_as] = ACTIONS(1033),
    [anon_sym_async] = ACTIONS(1033),
    [anon_sym_await] = ACTIONS(1033),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_const] = ACTIONS(1033),
    [anon_sym_continue] = ACTIONS(1033),
    [anon_sym_default] = ACTIONS(1033),
    [anon_sym_enum] = ACTIONS(1033),
    [anon_sym_fn] = ACTIONS(1033),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1033),
    [anon_sym_impl] = ACTIONS(1033),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_loop] = ACTIONS(1033),
    [anon_sym_match] = ACTIONS(1033),
    [anon_sym_mod] = ACTIONS(1033),
    [anon_sym_pub] = ACTIONS(1033),
    [anon_sym_return] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(1033),
    [anon_sym_struct] = ACTIONS(1033),
    [anon_sym_trait] = ACTIONS(1033),
    [anon_sym_type] = ACTIONS(1033),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_use] = ACTIONS(1033),
    [anon_sym_where] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1033),
    [sym_mutable_specifier] = ACTIONS(1033),
    [sym_integer_literal] = ACTIONS(1035),
    [aux_sym_string_literal_token1] = ACTIONS(1035),
    [sym_char_literal] = ACTIONS(1035),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1033),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1033),
    [sym_super] = ACTIONS(1033),
    [sym_crate] = ACTIONS(1033),
    [sym__raw_string_literal_start] = ACTIONS(1035),
    [sym_float_literal] = ACTIONS(1035),
  },
  [209] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1846),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(209),
    [sym_block_comment] = STATE(209),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [210] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1869),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(210),
    [sym_block_comment] = STATE(210),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [211] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1626),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(211),
    [sym_block_comment] = STATE(211),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [212] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1629),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(212),
    [sym_block_comment] = STATE(212),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [213] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1609),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(213),
    [sym_block_comment] = STATE(213),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [214] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1611),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(214),
    [sym_block_comment] = STATE(214),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [215] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1657),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(215),
    [sym_block_comment] = STATE(215),
    [aux_sym_tuple_expression_repeat1] = STATE(241),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [216] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1808),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1323),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(216),
    [sym_block_comment] = STATE(216),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1041),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [217] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1821),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1305),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(217),
    [sym_block_comment] = STATE(217),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1047),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_DASH_GT] = ACTIONS(1051),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [218] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1503),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1306),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(218),
    [sym_block_comment] = STATE(218),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1053),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [219] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1633),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1305),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(219),
    [sym_block_comment] = STATE(219),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1047),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_DASH_GT] = ACTIONS(1051),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [220] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1693),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1306),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(220),
    [sym_block_comment] = STATE(220),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1053),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [221] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1672),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1719),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(221),
    [sym_block_comment] = STATE(221),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1061),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_DASH_GT] = ACTIONS(1065),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [222] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1810),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1769),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(222),
    [sym_block_comment] = STATE(222),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1067),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_DASH_GT] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [223] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1711),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1323),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(223),
    [sym_block_comment] = STATE(223),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_DASH_GT] = ACTIONS(1041),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [224] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1652),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(224),
    [sym_block_comment] = STATE(224),
    [aux_sym_tuple_expression_repeat1] = STATE(227),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [225] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1504),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1305),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(225),
    [sym_block_comment] = STATE(225),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1047),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1051),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [226] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1482),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1323),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(226),
    [sym_block_comment] = STATE(226),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1041),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [227] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1651),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(227),
    [sym_block_comment] = STATE(227),
    [aux_sym_tuple_expression_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [228] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1651),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(228),
    [sym_block_comment] = STATE(228),
    [aux_sym_tuple_expression_repeat1] = STATE(238),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [229] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1802),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(229),
    [sym_block_comment] = STATE(229),
    [aux_sym_tuple_expression_repeat1] = STATE(230),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [230] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1657),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(230),
    [sym_block_comment] = STATE(230),
    [aux_sym_tuple_expression_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [231] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1573),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2515),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(231),
    [sym_block_comment] = STATE(231),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [232] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1786),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1833),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(232),
    [sym_block_comment] = STATE(232),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1077),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_DASH_GT] = ACTIONS(1079),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [233] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1682),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1305),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(233),
    [sym_block_comment] = STATE(233),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1047),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1051),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [234] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_let_condition] = STATE(2515),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(234),
    [sym_block_comment] = STATE(234),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [235] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1600),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1306),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(235),
    [sym_block_comment] = STATE(235),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1053),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [236] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1596),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1323),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(236),
    [sym_block_comment] = STATE(236),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_DASH_GT] = ACTIONS(1041),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [237] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1868),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(237),
    [sym_block_comment] = STATE(237),
    [aux_sym_tuple_expression_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_u8] = ACTIONS(1098),
    [anon_sym_i8] = ACTIONS(1098),
    [anon_sym_u16] = ACTIONS(1098),
    [anon_sym_i16] = ACTIONS(1098),
    [anon_sym_u32] = ACTIONS(1098),
    [anon_sym_i32] = ACTIONS(1098),
    [anon_sym_u64] = ACTIONS(1098),
    [anon_sym_i64] = ACTIONS(1098),
    [anon_sym_u128] = ACTIONS(1098),
    [anon_sym_i128] = ACTIONS(1098),
    [anon_sym_isize] = ACTIONS(1098),
    [anon_sym_usize] = ACTIONS(1098),
    [anon_sym_f32] = ACTIONS(1098),
    [anon_sym_f64] = ACTIONS(1098),
    [anon_sym_bool] = ACTIONS(1098),
    [anon_sym_str] = ACTIONS(1098),
    [anon_sym_char] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_DOT_DOT] = ACTIONS(1110),
    [anon_sym_COLON_COLON] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1119),
    [anon_sym_break] = ACTIONS(1122),
    [anon_sym_const] = ACTIONS(1125),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_default] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_loop] = ACTIONS(1140),
    [anon_sym_match] = ACTIONS(1143),
    [anon_sym_return] = ACTIONS(1146),
    [anon_sym_static] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1131),
    [anon_sym_unsafe] = ACTIONS(1152),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_yield] = ACTIONS(1158),
    [anon_sym_move] = ACTIONS(1161),
    [anon_sym_try] = ACTIONS(1164),
    [sym_integer_literal] = ACTIONS(1167),
    [aux_sym_string_literal_token1] = ACTIONS(1170),
    [sym_char_literal] = ACTIONS(1167),
    [anon_sym_true] = ACTIONS(1173),
    [anon_sym_false] = ACTIONS(1173),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1176),
    [sym_super] = ACTIONS(1179),
    [sym_crate] = ACTIONS(1179),
    [sym_metavariable] = ACTIONS(1182),
    [sym__raw_string_literal_start] = ACTIONS(1185),
    [sym_float_literal] = ACTIONS(1167),
  },
  [238] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1664),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(238),
    [sym_block_comment] = STATE(238),
    [aux_sym_tuple_expression_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [239] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1749),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_let_condition] = STATE(2515),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(239),
    [sym_block_comment] = STATE(239),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_let] = ACTIONS(999),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [240] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1867),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_let_condition] = STATE(2515),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(240),
    [sym_block_comment] = STATE(240),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_let] = ACTIONS(999),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [241] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1658),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(241),
    [sym_block_comment] = STATE(241),
    [aux_sym_tuple_expression_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1190),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [242] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1679),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1306),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(242),
    [sym_block_comment] = STATE(242),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1053),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1057),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [243] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1710),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(243),
    [sym_block_comment] = STATE(243),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [sym_mutable_specifier] = ACTIONS(1192),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [244] = {
    [sym_else_clause] = STATE(385),
    [sym_line_comment] = STATE(244),
    [sym_block_comment] = STATE(244),
    [ts_builtin_sym_end] = ACTIONS(1194),
    [sym_identifier] = ACTIONS(1196),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym_macro_rules_BANG] = ACTIONS(1194),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [anon_sym_LBRACK] = ACTIONS(1194),
    [anon_sym_LBRACE] = ACTIONS(1194),
    [anon_sym_RBRACE] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_QMARK] = ACTIONS(1194),
    [anon_sym_u8] = ACTIONS(1196),
    [anon_sym_i8] = ACTIONS(1196),
    [anon_sym_u16] = ACTIONS(1196),
    [anon_sym_i16] = ACTIONS(1196),
    [anon_sym_u32] = ACTIONS(1196),
    [anon_sym_i32] = ACTIONS(1196),
    [anon_sym_u64] = ACTIONS(1196),
    [anon_sym_i64] = ACTIONS(1196),
    [anon_sym_u128] = ACTIONS(1196),
    [anon_sym_i128] = ACTIONS(1196),
    [anon_sym_isize] = ACTIONS(1196),
    [anon_sym_usize] = ACTIONS(1196),
    [anon_sym_f32] = ACTIONS(1196),
    [anon_sym_f64] = ACTIONS(1196),
    [anon_sym_bool] = ACTIONS(1196),
    [anon_sym_str] = ACTIONS(1196),
    [anon_sym_char] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_SLASH] = ACTIONS(1196),
    [anon_sym_PERCENT] = ACTIONS(1196),
    [anon_sym_CARET] = ACTIONS(1196),
    [anon_sym_BANG] = ACTIONS(1196),
    [anon_sym_AMP] = ACTIONS(1196),
    [anon_sym_PIPE] = ACTIONS(1196),
    [anon_sym_AMP_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1196),
    [anon_sym_GT_GT] = ACTIONS(1196),
    [anon_sym_PLUS_EQ] = ACTIONS(1194),
    [anon_sym_DASH_EQ] = ACTIONS(1194),
    [anon_sym_STAR_EQ] = ACTIONS(1194),
    [anon_sym_SLASH_EQ] = ACTIONS(1194),
    [anon_sym_PERCENT_EQ] = ACTIONS(1194),
    [anon_sym_CARET_EQ] = ACTIONS(1194),
    [anon_sym_AMP_EQ] = ACTIONS(1194),
    [anon_sym_PIPE_EQ] = ACTIONS(1194),
    [anon_sym_LT_LT_EQ] = ACTIONS(1194),
    [anon_sym_GT_GT_EQ] = ACTIONS(1194),
    [anon_sym_EQ] = ACTIONS(1196),
    [anon_sym_EQ_EQ] = ACTIONS(1194),
    [anon_sym_BANG_EQ] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1196),
    [anon_sym_LT] = ACTIONS(1196),
    [anon_sym_GT_EQ] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1194),
    [anon_sym_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1194),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1194),
    [anon_sym_COLON_COLON] = ACTIONS(1194),
    [anon_sym_POUND] = ACTIONS(1194),
    [anon_sym_SQUOTE] = ACTIONS(1196),
    [anon_sym_as] = ACTIONS(1196),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_break] = ACTIONS(1196),
    [anon_sym_const] = ACTIONS(1196),
    [anon_sym_continue] = ACTIONS(1196),
    [anon_sym_default] = ACTIONS(1196),
    [anon_sym_enum] = ACTIONS(1196),
    [anon_sym_fn] = ACTIONS(1196),
    [anon_sym_for] = ACTIONS(1196),
    [anon_sym_if] = ACTIONS(1196),
    [anon_sym_impl] = ACTIONS(1196),
    [anon_sym_let] = ACTIONS(1196),
    [anon_sym_loop] = ACTIONS(1196),
    [anon_sym_match] = ACTIONS(1196),
    [anon_sym_mod] = ACTIONS(1196),
    [anon_sym_pub] = ACTIONS(1196),
    [anon_sym_return] = ACTIONS(1196),
    [anon_sym_static] = ACTIONS(1196),
    [anon_sym_struct] = ACTIONS(1196),
    [anon_sym_trait] = ACTIONS(1196),
    [anon_sym_type] = ACTIONS(1196),
    [anon_sym_union] = ACTIONS(1196),
    [anon_sym_unsafe] = ACTIONS(1196),
    [anon_sym_use] = ACTIONS(1196),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_extern] = ACTIONS(1196),
    [anon_sym_else] = ACTIONS(1198),
    [anon_sym_yield] = ACTIONS(1196),
    [anon_sym_move] = ACTIONS(1196),
    [anon_sym_try] = ACTIONS(1196),
    [sym_integer_literal] = ACTIONS(1194),
    [aux_sym_string_literal_token1] = ACTIONS(1194),
    [sym_char_literal] = ACTIONS(1194),
    [anon_sym_true] = ACTIONS(1196),
    [anon_sym_false] = ACTIONS(1196),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1196),
    [sym_super] = ACTIONS(1196),
    [sym_crate] = ACTIONS(1196),
    [sym_metavariable] = ACTIONS(1194),
    [sym__raw_string_literal_start] = ACTIONS(1194),
    [sym_float_literal] = ACTIONS(1194),
  },
  [245] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1442),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(245),
    [sym_block_comment] = STATE(245),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [sym_mutable_specifier] = ACTIONS(1200),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [246] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1442),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(246),
    [sym_block_comment] = STATE(246),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [sym_mutable_specifier] = ACTIONS(1202),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [247] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1442),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(247),
    [sym_block_comment] = STATE(247),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [sym_mutable_specifier] = ACTIONS(1204),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [248] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1644),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(248),
    [sym_block_comment] = STATE(248),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [249] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1866),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(249),
    [sym_block_comment] = STATE(249),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [250] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1818),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(250),
    [sym_block_comment] = STATE(250),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [251] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1573),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(251),
    [sym_block_comment] = STATE(251),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [252] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1832),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(252),
    [sym_block_comment] = STATE(252),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [253] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1811),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(253),
    [sym_block_comment] = STATE(253),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [254] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1816),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(254),
    [sym_block_comment] = STATE(254),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [255] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1815),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(255),
    [sym_block_comment] = STATE(255),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [256] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1797),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(256),
    [sym_block_comment] = STATE(256),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [257] = {
    [sym_line_comment] = STATE(257),
    [sym_block_comment] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_SEMI] = ACTIONS(1206),
    [anon_sym_macro_rules_BANG] = ACTIONS(1206),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_QMARK] = ACTIONS(1206),
    [anon_sym_u8] = ACTIONS(1208),
    [anon_sym_i8] = ACTIONS(1208),
    [anon_sym_u16] = ACTIONS(1208),
    [anon_sym_i16] = ACTIONS(1208),
    [anon_sym_u32] = ACTIONS(1208),
    [anon_sym_i32] = ACTIONS(1208),
    [anon_sym_u64] = ACTIONS(1208),
    [anon_sym_i64] = ACTIONS(1208),
    [anon_sym_u128] = ACTIONS(1208),
    [anon_sym_i128] = ACTIONS(1208),
    [anon_sym_isize] = ACTIONS(1208),
    [anon_sym_usize] = ACTIONS(1208),
    [anon_sym_f32] = ACTIONS(1208),
    [anon_sym_f64] = ACTIONS(1208),
    [anon_sym_bool] = ACTIONS(1208),
    [anon_sym_str] = ACTIONS(1208),
    [anon_sym_char] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1208),
    [anon_sym_CARET] = ACTIONS(1208),
    [anon_sym_BANG] = ACTIONS(1208),
    [anon_sym_AMP] = ACTIONS(1208),
    [anon_sym_PIPE] = ACTIONS(1208),
    [anon_sym_AMP_AMP] = ACTIONS(1206),
    [anon_sym_PIPE_PIPE] = ACTIONS(1206),
    [anon_sym_LT_LT] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1208),
    [anon_sym_PLUS_EQ] = ACTIONS(1206),
    [anon_sym_DASH_EQ] = ACTIONS(1206),
    [anon_sym_STAR_EQ] = ACTIONS(1206),
    [anon_sym_SLASH_EQ] = ACTIONS(1206),
    [anon_sym_PERCENT_EQ] = ACTIONS(1206),
    [anon_sym_CARET_EQ] = ACTIONS(1206),
    [anon_sym_AMP_EQ] = ACTIONS(1206),
    [anon_sym_PIPE_EQ] = ACTIONS(1206),
    [anon_sym_LT_LT_EQ] = ACTIONS(1206),
    [anon_sym_GT_GT_EQ] = ACTIONS(1206),
    [anon_sym_EQ] = ACTIONS(1208),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1208),
    [anon_sym_LT] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym_DOT] = ACTIONS(1208),
    [anon_sym_DOT_DOT] = ACTIONS(1208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1206),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(1206),
    [anon_sym_POUND] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1208),
    [anon_sym_as] = ACTIONS(1208),
    [anon_sym_async] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_const] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_default] = ACTIONS(1208),
    [anon_sym_enum] = ACTIONS(1208),
    [anon_sym_fn] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1208),
    [anon_sym_impl] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_loop] = ACTIONS(1208),
    [anon_sym_match] = ACTIONS(1208),
    [anon_sym_mod] = ACTIONS(1208),
    [anon_sym_pub] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_static] = ACTIONS(1208),
    [anon_sym_struct] = ACTIONS(1208),
    [anon_sym_trait] = ACTIONS(1208),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_union] = ACTIONS(1208),
    [anon_sym_unsafe] = ACTIONS(1208),
    [anon_sym_use] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_extern] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1208),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_move] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [sym_integer_literal] = ACTIONS(1206),
    [aux_sym_string_literal_token1] = ACTIONS(1206),
    [sym_char_literal] = ACTIONS(1206),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1208),
    [sym_super] = ACTIONS(1208),
    [sym_crate] = ACTIONS(1208),
    [sym_metavariable] = ACTIONS(1206),
    [sym__raw_string_literal_start] = ACTIONS(1206),
    [sym_float_literal] = ACTIONS(1206),
  },
  [258] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1602),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(258),
    [sym_block_comment] = STATE(258),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [259] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1849),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(259),
    [sym_block_comment] = STATE(259),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [260] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1763),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(260),
    [sym_block_comment] = STATE(260),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [261] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1452),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(261),
    [sym_block_comment] = STATE(261),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [262] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1646),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(262),
    [sym_block_comment] = STATE(262),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [263] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1844),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(263),
    [sym_block_comment] = STATE(263),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [264] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1493),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(264),
    [sym_block_comment] = STATE(264),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [265] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1414),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(265),
    [sym_block_comment] = STATE(265),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [266] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1494),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(266),
    [sym_block_comment] = STATE(266),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [267] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1495),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(267),
    [sym_block_comment] = STATE(267),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [268] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1496),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(268),
    [sym_block_comment] = STATE(268),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [269] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1497),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(269),
    [sym_block_comment] = STATE(269),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [270] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1499),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(270),
    [sym_block_comment] = STATE(270),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [271] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1500),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(271),
    [sym_block_comment] = STATE(271),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [272] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1501),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(272),
    [sym_block_comment] = STATE(272),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [273] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1502),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(273),
    [sym_block_comment] = STATE(273),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [274] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1483),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(274),
    [sym_block_comment] = STATE(274),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [275] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1452),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(275),
    [sym_block_comment] = STATE(275),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [276] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1749),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(276),
    [sym_block_comment] = STATE(276),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [277] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1505),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(277),
    [sym_block_comment] = STATE(277),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [278] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1659),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(278),
    [sym_block_comment] = STATE(278),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [279] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1856),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(279),
    [sym_block_comment] = STATE(279),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [280] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1783),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(280),
    [sym_block_comment] = STATE(280),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [281] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1760),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(281),
    [sym_block_comment] = STATE(281),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [282] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1125),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(282),
    [sym_block_comment] = STATE(282),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [283] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1125),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(283),
    [sym_block_comment] = STATE(283),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [284] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1851),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(284),
    [sym_block_comment] = STATE(284),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [285] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1668),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(285),
    [sym_block_comment] = STATE(285),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [286] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1727),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(456),
    [sym_match_expression] = STATE(456),
    [sym_while_expression] = STATE(456),
    [sym_loop_expression] = STATE(456),
    [sym_for_expression] = STATE(456),
    [sym_const_block] = STATE(456),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3587),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(456),
    [sym_async_block] = STATE(456),
    [sym_try_block] = STATE(456),
    [sym_block] = STATE(456),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(286),
    [sym_block_comment] = STATE(286),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_loop] = ACTIONS(1222),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [287] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(287),
    [sym_block_comment] = STATE(287),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [288] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1720),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(288),
    [sym_block_comment] = STATE(288),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [289] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1843),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(289),
    [sym_block_comment] = STATE(289),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [290] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1552),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(290),
    [sym_block_comment] = STATE(290),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [291] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1837),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(291),
    [sym_block_comment] = STATE(291),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [292] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1838),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(292),
    [sym_block_comment] = STATE(292),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [293] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1795),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(293),
    [sym_block_comment] = STATE(293),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [294] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1839),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(294),
    [sym_block_comment] = STATE(294),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [295] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1696),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(295),
    [sym_block_comment] = STATE(295),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [296] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1708),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(296),
    [sym_block_comment] = STATE(296),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [297] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1857),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(297),
    [sym_block_comment] = STATE(297),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [298] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1725),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(298),
    [sym_block_comment] = STATE(298),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [299] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1845),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(299),
    [sym_block_comment] = STATE(299),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [300] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1781),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(470),
    [sym_match_expression] = STATE(470),
    [sym_while_expression] = STATE(470),
    [sym_loop_expression] = STATE(470),
    [sym_for_expression] = STATE(470),
    [sym_const_block] = STATE(470),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3587),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(470),
    [sym_async_block] = STATE(470),
    [sym_try_block] = STATE(470),
    [sym_block] = STATE(470),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(300),
    [sym_block_comment] = STATE(300),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_loop] = ACTIONS(1222),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [301] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1842),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(301),
    [sym_block_comment] = STATE(301),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [302] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1556),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(302),
    [sym_block_comment] = STATE(302),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [303] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1758),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(303),
    [sym_block_comment] = STATE(303),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [304] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1873),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(304),
    [sym_block_comment] = STATE(304),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [305] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1859),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(305),
    [sym_block_comment] = STATE(305),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [306] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1717),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(306),
    [sym_block_comment] = STATE(306),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [307] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1414),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(307),
    [sym_block_comment] = STATE(307),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [308] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1777),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(308),
    [sym_block_comment] = STATE(308),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [309] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1714),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(309),
    [sym_block_comment] = STATE(309),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [310] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1864),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(310),
    [sym_block_comment] = STATE(310),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [311] = {
    [sym_line_comment] = STATE(311),
    [sym_block_comment] = STATE(311),
    [ts_builtin_sym_end] = ACTIONS(1232),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_SEMI] = ACTIONS(1232),
    [anon_sym_macro_rules_BANG] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_QMARK] = ACTIONS(1232),
    [anon_sym_u8] = ACTIONS(1234),
    [anon_sym_i8] = ACTIONS(1234),
    [anon_sym_u16] = ACTIONS(1234),
    [anon_sym_i16] = ACTIONS(1234),
    [anon_sym_u32] = ACTIONS(1234),
    [anon_sym_i32] = ACTIONS(1234),
    [anon_sym_u64] = ACTIONS(1234),
    [anon_sym_i64] = ACTIONS(1234),
    [anon_sym_u128] = ACTIONS(1234),
    [anon_sym_i128] = ACTIONS(1234),
    [anon_sym_isize] = ACTIONS(1234),
    [anon_sym_usize] = ACTIONS(1234),
    [anon_sym_f32] = ACTIONS(1234),
    [anon_sym_f64] = ACTIONS(1234),
    [anon_sym_bool] = ACTIONS(1234),
    [anon_sym_str] = ACTIONS(1234),
    [anon_sym_char] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1234),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_CARET] = ACTIONS(1234),
    [anon_sym_BANG] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1232),
    [anon_sym_PIPE_PIPE] = ACTIONS(1232),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(1232),
    [anon_sym_DASH_EQ] = ACTIONS(1232),
    [anon_sym_STAR_EQ] = ACTIONS(1232),
    [anon_sym_SLASH_EQ] = ACTIONS(1232),
    [anon_sym_PERCENT_EQ] = ACTIONS(1232),
    [anon_sym_CARET_EQ] = ACTIONS(1232),
    [anon_sym_AMP_EQ] = ACTIONS(1232),
    [anon_sym_PIPE_EQ] = ACTIONS(1232),
    [anon_sym_LT_LT_EQ] = ACTIONS(1232),
    [anon_sym_GT_GT_EQ] = ACTIONS(1232),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_EQ_EQ] = ACTIONS(1232),
    [anon_sym_BANG_EQ] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1232),
    [anon_sym_LT_EQ] = ACTIONS(1232),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1232),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [anon_sym_as] = ACTIONS(1234),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_break] = ACTIONS(1234),
    [anon_sym_const] = ACTIONS(1234),
    [anon_sym_continue] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1234),
    [anon_sym_enum] = ACTIONS(1234),
    [anon_sym_fn] = ACTIONS(1234),
    [anon_sym_for] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_impl] = ACTIONS(1234),
    [anon_sym_let] = ACTIONS(1234),
    [anon_sym_loop] = ACTIONS(1234),
    [anon_sym_match] = ACTIONS(1234),
    [anon_sym_mod] = ACTIONS(1234),
    [anon_sym_pub] = ACTIONS(1234),
    [anon_sym_return] = ACTIONS(1234),
    [anon_sym_static] = ACTIONS(1234),
    [anon_sym_struct] = ACTIONS(1234),
    [anon_sym_trait] = ACTIONS(1234),
    [anon_sym_type] = ACTIONS(1234),
    [anon_sym_union] = ACTIONS(1234),
    [anon_sym_unsafe] = ACTIONS(1234),
    [anon_sym_use] = ACTIONS(1234),
    [anon_sym_while] = ACTIONS(1234),
    [anon_sym_extern] = ACTIONS(1234),
    [anon_sym_else] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1234),
    [anon_sym_move] = ACTIONS(1234),
    [anon_sym_try] = ACTIONS(1234),
    [sym_integer_literal] = ACTIONS(1232),
    [aux_sym_string_literal_token1] = ACTIONS(1232),
    [sym_char_literal] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1234),
    [anon_sym_false] = ACTIONS(1234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1234),
    [sym_super] = ACTIONS(1234),
    [sym_crate] = ACTIONS(1234),
    [sym_metavariable] = ACTIONS(1232),
    [sym__raw_string_literal_start] = ACTIONS(1232),
    [sym_float_literal] = ACTIONS(1232),
  },
  [312] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1840),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(312),
    [sym_block_comment] = STATE(312),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [313] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1865),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(313),
    [sym_block_comment] = STATE(313),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [314] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1834),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(314),
    [sym_block_comment] = STATE(314),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [315] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1505),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(315),
    [sym_block_comment] = STATE(315),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [316] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1853),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(316),
    [sym_block_comment] = STATE(316),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [317] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1602),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(317),
    [sym_block_comment] = STATE(317),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [318] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1716),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(318),
    [sym_block_comment] = STATE(318),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [319] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1870),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(456),
    [sym_match_expression] = STATE(456),
    [sym_while_expression] = STATE(456),
    [sym_loop_expression] = STATE(456),
    [sym_for_expression] = STATE(456),
    [sym_const_block] = STATE(456),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3587),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(456),
    [sym_async_block] = STATE(456),
    [sym_try_block] = STATE(456),
    [sym_block] = STATE(456),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(319),
    [sym_block_comment] = STATE(319),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_loop] = ACTIONS(1222),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [320] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1580),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(320),
    [sym_block_comment] = STATE(320),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [321] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1617),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(321),
    [sym_block_comment] = STATE(321),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [322] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1648),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(322),
    [sym_block_comment] = STATE(322),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [323] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1414),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(323),
    [sym_block_comment] = STATE(323),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [324] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1125),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(324),
    [sym_block_comment] = STATE(324),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [325] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1701),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(325),
    [sym_block_comment] = STATE(325),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [326] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1795),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(326),
    [sym_block_comment] = STATE(326),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [327] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1861),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(327),
    [sym_block_comment] = STATE(327),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [328] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1559),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(328),
    [sym_block_comment] = STATE(328),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [329] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1847),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(329),
    [sym_block_comment] = STATE(329),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [330] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1848),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(330),
    [sym_block_comment] = STATE(330),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [331] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1581),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(331),
    [sym_block_comment] = STATE(331),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [332] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1713),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(332),
    [sym_block_comment] = STATE(332),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [333] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1875),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(333),
    [sym_block_comment] = STATE(333),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [334] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1854),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(470),
    [sym_match_expression] = STATE(470),
    [sym_while_expression] = STATE(470),
    [sym_loop_expression] = STATE(470),
    [sym_for_expression] = STATE(470),
    [sym_const_block] = STATE(470),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3587),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(470),
    [sym_async_block] = STATE(470),
    [sym_try_block] = STATE(470),
    [sym_block] = STATE(470),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(334),
    [sym_block_comment] = STATE(334),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_loop] = ACTIONS(1222),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [335] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1542),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(335),
    [sym_block_comment] = STATE(335),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [336] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1584),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(336),
    [sym_block_comment] = STATE(336),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [337] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1566),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(337),
    [sym_block_comment] = STATE(337),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [338] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1694),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(338),
    [sym_block_comment] = STATE(338),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [339] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1715),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(339),
    [sym_block_comment] = STATE(339),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [340] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1703),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(340),
    [sym_block_comment] = STATE(340),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [341] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1662),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(341),
    [sym_block_comment] = STATE(341),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [342] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1692),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(342),
    [sym_block_comment] = STATE(342),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [343] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1616),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(343),
    [sym_block_comment] = STATE(343),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [344] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1654),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(344),
    [sym_block_comment] = STATE(344),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [345] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1545),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(345),
    [sym_block_comment] = STATE(345),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [346] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1653),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(346),
    [sym_block_comment] = STATE(346),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [347] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1860),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(347),
    [sym_block_comment] = STATE(347),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [348] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1788),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(348),
    [sym_block_comment] = STATE(348),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [349] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1863),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(349),
    [sym_block_comment] = STATE(349),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [350] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1855),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(350),
    [sym_block_comment] = STATE(350),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [351] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1809),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(351),
    [sym_block_comment] = STATE(351),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [352] = {
    [sym_line_comment] = STATE(352),
    [sym_block_comment] = STATE(352),
    [ts_builtin_sym_end] = ACTIONS(1236),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_macro_rules_BANG] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_QMARK] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1238),
    [anon_sym_i8] = ACTIONS(1238),
    [anon_sym_u16] = ACTIONS(1238),
    [anon_sym_i16] = ACTIONS(1238),
    [anon_sym_u32] = ACTIONS(1238),
    [anon_sym_i32] = ACTIONS(1238),
    [anon_sym_u64] = ACTIONS(1238),
    [anon_sym_i64] = ACTIONS(1238),
    [anon_sym_u128] = ACTIONS(1238),
    [anon_sym_i128] = ACTIONS(1238),
    [anon_sym_isize] = ACTIONS(1238),
    [anon_sym_usize] = ACTIONS(1238),
    [anon_sym_f32] = ACTIONS(1238),
    [anon_sym_f64] = ACTIONS(1238),
    [anon_sym_bool] = ACTIONS(1238),
    [anon_sym_str] = ACTIONS(1238),
    [anon_sym_char] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_CARET] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(1238),
    [anon_sym_AMP] = ACTIONS(1238),
    [anon_sym_PIPE] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(1236),
    [anon_sym_PIPE_PIPE] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1238),
    [anon_sym_PLUS_EQ] = ACTIONS(1236),
    [anon_sym_DASH_EQ] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(1236),
    [anon_sym_SLASH_EQ] = ACTIONS(1236),
    [anon_sym_PERCENT_EQ] = ACTIONS(1236),
    [anon_sym_CARET_EQ] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(1236),
    [anon_sym_LT_LT_EQ] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(1236),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(1236),
    [anon_sym_GT] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT_EQ] = ACTIONS(1236),
    [anon_sym_LT_EQ] = ACTIONS(1236),
    [anon_sym_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1236),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_as] = ACTIONS(1238),
    [anon_sym_async] = ACTIONS(1238),
    [anon_sym_break] = ACTIONS(1238),
    [anon_sym_const] = ACTIONS(1238),
    [anon_sym_continue] = ACTIONS(1238),
    [anon_sym_default] = ACTIONS(1238),
    [anon_sym_enum] = ACTIONS(1238),
    [anon_sym_fn] = ACTIONS(1238),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_if] = ACTIONS(1238),
    [anon_sym_impl] = ACTIONS(1238),
    [anon_sym_let] = ACTIONS(1238),
    [anon_sym_loop] = ACTIONS(1238),
    [anon_sym_match] = ACTIONS(1238),
    [anon_sym_mod] = ACTIONS(1238),
    [anon_sym_pub] = ACTIONS(1238),
    [anon_sym_return] = ACTIONS(1238),
    [anon_sym_static] = ACTIONS(1238),
    [anon_sym_struct] = ACTIONS(1238),
    [anon_sym_trait] = ACTIONS(1238),
    [anon_sym_type] = ACTIONS(1238),
    [anon_sym_union] = ACTIONS(1238),
    [anon_sym_unsafe] = ACTIONS(1238),
    [anon_sym_use] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(1238),
    [anon_sym_else] = ACTIONS(1238),
    [anon_sym_yield] = ACTIONS(1238),
    [anon_sym_move] = ACTIONS(1238),
    [anon_sym_try] = ACTIONS(1238),
    [sym_integer_literal] = ACTIONS(1236),
    [aux_sym_string_literal_token1] = ACTIONS(1236),
    [sym_char_literal] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1238),
    [anon_sym_false] = ACTIONS(1238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1238),
    [sym_super] = ACTIONS(1238),
    [sym_crate] = ACTIONS(1238),
    [sym_metavariable] = ACTIONS(1236),
    [sym__raw_string_literal_start] = ACTIONS(1236),
    [sym_float_literal] = ACTIONS(1236),
  },
  [353] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1716),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(353),
    [sym_block_comment] = STATE(353),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [354] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1571),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(354),
    [sym_block_comment] = STATE(354),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [355] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1585),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(355),
    [sym_block_comment] = STATE(355),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [356] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1872),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(356),
    [sym_block_comment] = STATE(356),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [357] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1612),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(357),
    [sym_block_comment] = STATE(357),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [358] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1850),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(358),
    [sym_block_comment] = STATE(358),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [359] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1804),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(359),
    [sym_block_comment] = STATE(359),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [360] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1586),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(360),
    [sym_block_comment] = STATE(360),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [361] = {
    [sym_line_comment] = STATE(361),
    [sym_block_comment] = STATE(361),
    [ts_builtin_sym_end] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1240),
    [anon_sym_macro_rules_BANG] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_QMARK] = ACTIONS(1240),
    [anon_sym_u8] = ACTIONS(1242),
    [anon_sym_i8] = ACTIONS(1242),
    [anon_sym_u16] = ACTIONS(1242),
    [anon_sym_i16] = ACTIONS(1242),
    [anon_sym_u32] = ACTIONS(1242),
    [anon_sym_i32] = ACTIONS(1242),
    [anon_sym_u64] = ACTIONS(1242),
    [anon_sym_i64] = ACTIONS(1242),
    [anon_sym_u128] = ACTIONS(1242),
    [anon_sym_i128] = ACTIONS(1242),
    [anon_sym_isize] = ACTIONS(1242),
    [anon_sym_usize] = ACTIONS(1242),
    [anon_sym_f32] = ACTIONS(1242),
    [anon_sym_f64] = ACTIONS(1242),
    [anon_sym_bool] = ACTIONS(1242),
    [anon_sym_str] = ACTIONS(1242),
    [anon_sym_char] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1240),
    [anon_sym_PIPE_PIPE] = ACTIONS(1240),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_PLUS_EQ] = ACTIONS(1240),
    [anon_sym_DASH_EQ] = ACTIONS(1240),
    [anon_sym_STAR_EQ] = ACTIONS(1240),
    [anon_sym_SLASH_EQ] = ACTIONS(1240),
    [anon_sym_PERCENT_EQ] = ACTIONS(1240),
    [anon_sym_CARET_EQ] = ACTIONS(1240),
    [anon_sym_AMP_EQ] = ACTIONS(1240),
    [anon_sym_PIPE_EQ] = ACTIONS(1240),
    [anon_sym_LT_LT_EQ] = ACTIONS(1240),
    [anon_sym_GT_GT_EQ] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1240),
    [anon_sym_BANG_EQ] = ACTIONS(1240),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1240),
    [anon_sym_LT_EQ] = ACTIONS(1240),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1240),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1240),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [anon_sym_as] = ACTIONS(1242),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_break] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_continue] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [anon_sym_fn] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_impl] = ACTIONS(1242),
    [anon_sym_let] = ACTIONS(1242),
    [anon_sym_loop] = ACTIONS(1242),
    [anon_sym_match] = ACTIONS(1242),
    [anon_sym_mod] = ACTIONS(1242),
    [anon_sym_pub] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_struct] = ACTIONS(1242),
    [anon_sym_trait] = ACTIONS(1242),
    [anon_sym_type] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_unsafe] = ACTIONS(1242),
    [anon_sym_use] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(1242),
    [anon_sym_extern] = ACTIONS(1242),
    [anon_sym_else] = ACTIONS(1242),
    [anon_sym_yield] = ACTIONS(1242),
    [anon_sym_move] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1242),
    [sym_integer_literal] = ACTIONS(1240),
    [aux_sym_string_literal_token1] = ACTIONS(1240),
    [sym_char_literal] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1242),
    [anon_sym_false] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_crate] = ACTIONS(1242),
    [sym_metavariable] = ACTIONS(1240),
    [sym__raw_string_literal_start] = ACTIONS(1240),
    [sym_float_literal] = ACTIONS(1240),
  },
  [362] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1597),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(362),
    [sym_block_comment] = STATE(362),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [363] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1549),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(363),
    [sym_block_comment] = STATE(363),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [364] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1862),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(364),
    [sym_block_comment] = STATE(364),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [365] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1452),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(236),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(365),
    [sym_block_comment] = STATE(365),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [366] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2869),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1799),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1268),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(366),
    [sym_block_comment] = STATE(366),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [367] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1638),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(367),
    [sym_block_comment] = STATE(367),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [368] = {
    [sym_line_comment] = STATE(368),
    [sym_block_comment] = STATE(368),
    [ts_builtin_sym_end] = ACTIONS(1244),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_macro_rules_BANG] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_u8] = ACTIONS(1246),
    [anon_sym_i8] = ACTIONS(1246),
    [anon_sym_u16] = ACTIONS(1246),
    [anon_sym_i16] = ACTIONS(1246),
    [anon_sym_u32] = ACTIONS(1246),
    [anon_sym_i32] = ACTIONS(1246),
    [anon_sym_u64] = ACTIONS(1246),
    [anon_sym_i64] = ACTIONS(1246),
    [anon_sym_u128] = ACTIONS(1246),
    [anon_sym_i128] = ACTIONS(1246),
    [anon_sym_isize] = ACTIONS(1246),
    [anon_sym_usize] = ACTIONS(1246),
    [anon_sym_f32] = ACTIONS(1246),
    [anon_sym_f64] = ACTIONS(1246),
    [anon_sym_bool] = ACTIONS(1246),
    [anon_sym_str] = ACTIONS(1246),
    [anon_sym_char] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_PLUS_EQ] = ACTIONS(1244),
    [anon_sym_DASH_EQ] = ACTIONS(1244),
    [anon_sym_STAR_EQ] = ACTIONS(1244),
    [anon_sym_SLASH_EQ] = ACTIONS(1244),
    [anon_sym_PERCENT_EQ] = ACTIONS(1244),
    [anon_sym_CARET_EQ] = ACTIONS(1244),
    [anon_sym_AMP_EQ] = ACTIONS(1244),
    [anon_sym_PIPE_EQ] = ACTIONS(1244),
    [anon_sym_LT_LT_EQ] = ACTIONS(1244),
    [anon_sym_GT_GT_EQ] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_EQ_EQ] = ACTIONS(1244),
    [anon_sym_BANG_EQ] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1244),
    [anon_sym_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1244),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1244),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_as] = ACTIONS(1246),
    [anon_sym_async] = ACTIONS(1246),
    [anon_sym_break] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [anon_sym_continue] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_enum] = ACTIONS(1246),
    [anon_sym_fn] = ACTIONS(1246),
    [anon_sym_for] = ACTIONS(1246),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_impl] = ACTIONS(1246),
    [anon_sym_let] = ACTIONS(1246),
    [anon_sym_loop] = ACTIONS(1246),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_mod] = ACTIONS(1246),
    [anon_sym_pub] = ACTIONS(1246),
    [anon_sym_return] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1246),
    [anon_sym_struct] = ACTIONS(1246),
    [anon_sym_trait] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1246),
    [anon_sym_union] = ACTIONS(1246),
    [anon_sym_unsafe] = ACTIONS(1246),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(1246),
    [anon_sym_extern] = ACTIONS(1246),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_yield] = ACTIONS(1246),
    [anon_sym_move] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(1246),
    [sym_integer_literal] = ACTIONS(1244),
    [aux_sym_string_literal_token1] = ACTIONS(1244),
    [sym_char_literal] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1246),
    [anon_sym_false] = ACTIONS(1246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [sym_crate] = ACTIONS(1246),
    [sym_metavariable] = ACTIONS(1244),
    [sym__raw_string_literal_start] = ACTIONS(1244),
    [sym_float_literal] = ACTIONS(1244),
  },
  [369] = {
    [sym_bracketed_type] = STATE(3562),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(2731),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1462),
    [sym_scoped_identifier] = STATE(1530),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_compound_assignment_expr] = STATE(1384),
    [sym_type_cast_expression] = STATE(1384),
    [sym_return_expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_const_block] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(223),
    [sym_label] = STATE(3543),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_field_expression] = STATE(1055),
    [sym_unsafe_block] = STATE(1384),
    [sym_async_block] = STATE(1384),
    [sym_try_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1384),
    [sym_string_literal] = STATE(1102),
    [sym_raw_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_line_comment] = STATE(369),
    [sym_block_comment] = STATE(369),
    [sym_identifier] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_u8] = ACTIONS(468),
    [anon_sym_i8] = ACTIONS(468),
    [anon_sym_u16] = ACTIONS(468),
    [anon_sym_i16] = ACTIONS(468),
    [anon_sym_u32] = ACTIONS(468),
    [anon_sym_i32] = ACTIONS(468),
    [anon_sym_u64] = ACTIONS(468),
    [anon_sym_i64] = ACTIONS(468),
    [anon_sym_u128] = ACTIONS(468),
    [anon_sym_i128] = ACTIONS(468),
    [anon_sym_isize] = ACTIONS(468),
    [anon_sym_usize] = ACTIONS(468),
    [anon_sym_f32] = ACTIONS(468),
    [anon_sym_f64] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_str] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(472),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_union] = ACTIONS(476),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_move] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(486),
    [sym_super] = ACTIONS(488),
    [sym_crate] = ACTIONS(488),
    [sym_metavariable] = ACTIONS(490),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [370] = {
    [sym_bracketed_type] = STATE(3506),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2844),
    [sym__expression_except_range] = STATE(1590),
    [sym__expression] = STATE(1826),
    [sym_macro_invocation] = STATE(1705),
    [sym_scoped_identifier] = STATE(1568),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3132),
    [sym_range_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(222),
    [sym_label] = STATE(3593),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1583),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1801),
    [sym_raw_string_literal] = STATE(1801),
    [sym_boolean_literal] = STATE(1801),
    [sym_line_comment] = STATE(370),
    [sym_block_comment] = STATE(370),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [371] = {
    [sym_line_comment] = STATE(371),
    [sym_block_comment] = STATE(371),
    [ts_builtin_sym_end] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1248),
    [anon_sym_macro_rules_BANG] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_u8] = ACTIONS(1250),
    [anon_sym_i8] = ACTIONS(1250),
    [anon_sym_u16] = ACTIONS(1250),
    [anon_sym_i16] = ACTIONS(1250),
    [anon_sym_u32] = ACTIONS(1250),
    [anon_sym_i32] = ACTIONS(1250),
    [anon_sym_u64] = ACTIONS(1250),
    [anon_sym_i64] = ACTIONS(1250),
    [anon_sym_u128] = ACTIONS(1250),
    [anon_sym_i128] = ACTIONS(1250),
    [anon_sym_isize] = ACTIONS(1250),
    [anon_sym_usize] = ACTIONS(1250),
    [anon_sym_f32] = ACTIONS(1250),
    [anon_sym_f64] = ACTIONS(1250),
    [anon_sym_bool] = ACTIONS(1250),
    [anon_sym_str] = ACTIONS(1250),
    [anon_sym_char] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_CARET] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_PLUS_EQ] = ACTIONS(1248),
    [anon_sym_DASH_EQ] = ACTIONS(1248),
    [anon_sym_STAR_EQ] = ACTIONS(1248),
    [anon_sym_SLASH_EQ] = ACTIONS(1248),
    [anon_sym_PERCENT_EQ] = ACTIONS(1248),
    [anon_sym_CARET_EQ] = ACTIONS(1248),
    [anon_sym_AMP_EQ] = ACTIONS(1248),
    [anon_sym_PIPE_EQ] = ACTIONS(1248),
    [anon_sym_LT_LT_EQ] = ACTIONS(1248),
    [anon_sym_GT_GT_EQ] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_EQ_EQ] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1248),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1248),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1248),
    [anon_sym_POUND] = ACTIONS(1248),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_async] = ACTIONS(1250),
    [anon_sym_break] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [anon_sym_continue] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_enum] = ACTIONS(1250),
    [anon_sym_fn] = ACTIONS(1250),
    [anon_sym_for] = ACTIONS(1250),
    [anon_sym_if] = ACTIONS(1250),
    [anon_sym_impl] = ACTIONS(1250),
    [anon_sym_let] = ACTIONS(1250),
    [anon_sym_loop] = ACTIONS(1250),
    [anon_sym_match] = ACTIONS(1250),
    [anon_sym_mod] = ACTIONS(1250),
    [anon_sym_pub] = ACTIONS(1250),
    [anon_sym_return] = ACTIONS(1250),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_struct] = ACTIONS(1250),
    [anon_sym_trait] = ACTIONS(1250),
    [anon_sym_type] = ACTIONS(1250),
    [anon_sym_union] = ACTIONS(1250),
    [anon_sym_unsafe] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1250),
    [anon_sym_while] = ACTIONS(1250),
    [anon_sym_extern] = ACTIONS(1250),
    [anon_sym_yield] = ACTIONS(1250),
    [anon_sym_move] = ACTIONS(1250),
    [anon_sym_try] = ACTIONS(1250),
    [sym_integer_literal] = ACTIONS(1248),
    [aux_sym_string_literal_token1] = ACTIONS(1248),
    [sym_char_literal] = ACTIONS(1248),
    [anon_sym_true] = ACTIONS(1250),
    [anon_sym_false] = ACTIONS(1250),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1250),
    [sym_super] = ACTIONS(1250),
    [sym_crate] = ACTIONS(1250),
    [sym_metavariable] = ACTIONS(1248),
    [sym__raw_string_literal_start] = ACTIONS(1248),
    [sym_float_literal] = ACTIONS(1248),
  },
  [372] = {
    [sym_line_comment] = STATE(372),
    [sym_block_comment] = STATE(372),
    [ts_builtin_sym_end] = ACTIONS(1252),
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_SEMI] = ACTIONS(1252),
    [anon_sym_macro_rules_BANG] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1252),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_QMARK] = ACTIONS(1252),
    [anon_sym_u8] = ACTIONS(1254),
    [anon_sym_i8] = ACTIONS(1254),
    [anon_sym_u16] = ACTIONS(1254),
    [anon_sym_i16] = ACTIONS(1254),
    [anon_sym_u32] = ACTIONS(1254),
    [anon_sym_i32] = ACTIONS(1254),
    [anon_sym_u64] = ACTIONS(1254),
    [anon_sym_i64] = ACTIONS(1254),
    [anon_sym_u128] = ACTIONS(1254),
    [anon_sym_i128] = ACTIONS(1254),
    [anon_sym_isize] = ACTIONS(1254),
    [anon_sym_usize] = ACTIONS(1254),
    [anon_sym_f32] = ACTIONS(1254),
    [anon_sym_f64] = ACTIONS(1254),
    [anon_sym_bool] = ACTIONS(1254),
    [anon_sym_str] = ACTIONS(1254),
    [anon_sym_char] = ACTIONS(1254),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_CARET] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1254),
    [anon_sym_AMP] = ACTIONS(1254),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_PIPE_PIPE] = ACTIONS(1252),
    [anon_sym_LT_LT] = ACTIONS(1254),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_PLUS_EQ] = ACTIONS(1252),
    [anon_sym_DASH_EQ] = ACTIONS(1252),
    [anon_sym_STAR_EQ] = ACTIONS(1252),
    [anon_sym_SLASH_EQ] = ACTIONS(1252),
    [anon_sym_PERCENT_EQ] = ACTIONS(1252),
    [anon_sym_CARET_EQ] = ACTIONS(1252),
    [anon_sym_AMP_EQ] = ACTIONS(1252),
    [anon_sym_PIPE_EQ] = ACTIONS(1252),
    [anon_sym_LT_LT_EQ] = ACTIONS(1252),
    [anon_sym_GT_GT_EQ] = ACTIONS(1252),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_EQ_EQ] = ACTIONS(1252),
    [anon_sym_BANG_EQ] = ACTIONS(1252),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_GT_EQ] = ACTIONS(1252),
    [anon_sym_LT_EQ] = ACTIONS(1252),
    [anon_sym_DOT] = ACTIONS(1254),
    [anon_sym_DOT_DOT] = ACTIONS(1254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1252),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1252),
    [anon_sym_COLON_COLON] = ACTIONS(1252),
    [anon_sym_POUND] = ACTIONS(1252),
    [anon_sym_SQUOTE] = ACTIONS(1254),
    [anon_sym_as] = ACTIONS(1254),
    [anon_sym_async] = ACTIONS(1254),
    [anon_sym_break] = ACTIONS(1254),
    [anon_sym_const] = ACTIONS(1254),
    [anon_sym_continue] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1254),
    [anon_sym_enum] = ACTIONS(1254),
    [anon_sym_fn] = ACTIONS(1254),
    [anon_sym_for] = ACTIONS(1254),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_impl] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(1254),
    [anon_sym_loop] = ACTIONS(1254),
    [anon_sym_match] = ACTIONS(1254),
    [anon_sym_mod] = ACTIONS(1254),
    [anon_sym_pub] = ACTIONS(1254),
    [anon_sym_return] = ACTIONS(1254),
    [anon_sym_static] = ACTIONS(1254),
    [anon_sym_struct] = ACTIONS(1254),
    [anon_sym_trait] = ACTIONS(1254),
    [anon_sym_type] = ACTIONS(1254),
    [anon_sym_union] = ACTIONS(1254),
    [anon_sym_unsafe] = ACTIONS(1254),
    [anon_sym_use] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(1254),
    [anon_sym_extern] = ACTIONS(1254),
    [anon_sym_yield] = ACTIONS(1254),
    [anon_sym_move] = ACTIONS(1254),
    [anon_sym_try] = ACTIONS(1254),
    [sym_integer_literal] = ACTIONS(1252),
    [aux_sym_string_literal_token1] = ACTIONS(1252),
    [sym_char_literal] = ACTIONS(1252),
    [anon_sym_true] = ACTIONS(1254),
    [anon_sym_false] = ACTIONS(1254),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1254),
    [sym_super] = ACTIONS(1254),
    [sym_crate] = ACTIONS(1254),
    [sym_metavariable] = ACTIONS(1252),
    [sym__raw_string_literal_start] = ACTIONS(1252),
    [sym_float_literal] = ACTIONS(1252),
  },
  [373] = {
    [sym_line_comment] = STATE(373),
    [sym_block_comment] = STATE(373),
    [ts_builtin_sym_end] = ACTIONS(1256),
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_SEMI] = ACTIONS(1256),
    [anon_sym_macro_rules_BANG] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_QMARK] = ACTIONS(1256),
    [anon_sym_u8] = ACTIONS(1258),
    [anon_sym_i8] = ACTIONS(1258),
    [anon_sym_u16] = ACTIONS(1258),
    [anon_sym_i16] = ACTIONS(1258),
    [anon_sym_u32] = ACTIONS(1258),
    [anon_sym_i32] = ACTIONS(1258),
    [anon_sym_u64] = ACTIONS(1258),
    [anon_sym_i64] = ACTIONS(1258),
    [anon_sym_u128] = ACTIONS(1258),
    [anon_sym_i128] = ACTIONS(1258),
    [anon_sym_isize] = ACTIONS(1258),
    [anon_sym_usize] = ACTIONS(1258),
    [anon_sym_f32] = ACTIONS(1258),
    [anon_sym_f64] = ACTIONS(1258),
    [anon_sym_bool] = ACTIONS(1258),
    [anon_sym_str] = ACTIONS(1258),
    [anon_sym_char] = ACTIONS(1258),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_CARET] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1258),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_PIPE] = ACTIONS(1258),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_PIPE_PIPE] = ACTIONS(1256),
    [anon_sym_LT_LT] = ACTIONS(1258),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_PLUS_EQ] = ACTIONS(1256),
    [anon_sym_DASH_EQ] = ACTIONS(1256),
    [anon_sym_STAR_EQ] = ACTIONS(1256),
    [anon_sym_SLASH_EQ] = ACTIONS(1256),
    [anon_sym_PERCENT_EQ] = ACTIONS(1256),
    [anon_sym_CARET_EQ] = ACTIONS(1256),
    [anon_sym_AMP_EQ] = ACTIONS(1256),
    [anon_sym_PIPE_EQ] = ACTIONS(1256),
    [anon_sym_LT_LT_EQ] = ACTIONS(1256),
    [anon_sym_GT_GT_EQ] = ACTIONS(1256),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_EQ_EQ] = ACTIONS(1256),
    [anon_sym_BANG_EQ] = ACTIONS(1256),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1256),
    [anon_sym_LT_EQ] = ACTIONS(1256),
    [anon_sym_DOT] = ACTIONS(1258),
    [anon_sym_DOT_DOT] = ACTIONS(1258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1256),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1256),
    [anon_sym_COLON_COLON] = ACTIONS(1256),
    [anon_sym_POUND] = ACTIONS(1256),
    [anon_sym_SQUOTE] = ACTIONS(1258),
    [anon_sym_as] = ACTIONS(1258),
    [anon_sym_async] = ACTIONS(1258),
    [anon_sym_break] = ACTIONS(1258),
    [anon_sym_const] = ACTIONS(1258),
    [anon_sym_continue] = ACTIONS(1258),
    [anon_sym_default] = ACTIONS(1258),
    [anon_sym_enum] = ACTIONS(1258),
    [anon_sym_fn] = ACTIONS(1258),
    [anon_sym_for] = ACTIONS(1258),
    [anon_sym_if] = ACTIONS(1258),
    [anon_sym_impl] = ACTIONS(1258),
    [anon_sym_let] = ACTIONS(1258),
    [anon_sym_loop] = ACTIONS(1258),
    [anon_sym_match] = ACTIONS(1258),
    [anon_sym_mod] = ACTIONS(1258),
    [anon_sym_pub] = ACTIONS(1258),
    [anon_sym_return] = ACTIONS(1258),
    [anon_sym_static] = ACTIONS(1258),
    [anon_sym_struct] = ACTIONS(1258),
    [anon_sym_trait] = ACTIONS(1258),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_union] = ACTIONS(1258),
    [anon_sym_unsafe] = ACTIONS(1258),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_while] = ACTIONS(1258),
    [anon_sym_extern] = ACTIONS(1258),
    [anon_sym_yield] = ACTIONS(1258),
    [anon_sym_move] = ACTIONS(1258),
    [anon_sym_try] = ACTIONS(1258),
    [sym_integer_literal] = ACTIONS(1256),
    [aux_sym_string_literal_token1] = ACTIONS(1256),
    [sym_char_literal] = ACTIONS(1256),
    [anon_sym_true] = ACTIONS(1258),
    [anon_sym_false] = ACTIONS(1258),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1258),
    [sym_super] = ACTIONS(1258),
    [sym_crate] = ACTIONS(1258),
    [sym_metavariable] = ACTIONS(1256),
    [sym__raw_string_literal_start] = ACTIONS(1256),
    [sym_float_literal] = ACTIONS(1256),
  },
  [374] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(2927),
    [sym_variadic_parameter] = STATE(2927),
    [sym_parameter] = STATE(2927),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2556),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(374),
    [sym_block_comment] = STATE(374),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1282),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COMMA] = ACTIONS(1288),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [375] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(2927),
    [sym_variadic_parameter] = STATE(2927),
    [sym_parameter] = STATE(2927),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2556),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2389),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(375),
    [sym_block_comment] = STATE(375),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1342),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [376] = {
    [sym_line_comment] = STATE(376),
    [sym_block_comment] = STATE(376),
    [ts_builtin_sym_end] = ACTIONS(1358),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1358),
    [anon_sym_macro_rules_BANG] = ACTIONS(1358),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_u8] = ACTIONS(1360),
    [anon_sym_i8] = ACTIONS(1360),
    [anon_sym_u16] = ACTIONS(1360),
    [anon_sym_i16] = ACTIONS(1360),
    [anon_sym_u32] = ACTIONS(1360),
    [anon_sym_i32] = ACTIONS(1360),
    [anon_sym_u64] = ACTIONS(1360),
    [anon_sym_i64] = ACTIONS(1360),
    [anon_sym_u128] = ACTIONS(1360),
    [anon_sym_i128] = ACTIONS(1360),
    [anon_sym_isize] = ACTIONS(1360),
    [anon_sym_usize] = ACTIONS(1360),
    [anon_sym_f32] = ACTIONS(1360),
    [anon_sym_f64] = ACTIONS(1360),
    [anon_sym_bool] = ACTIONS(1360),
    [anon_sym_str] = ACTIONS(1360),
    [anon_sym_char] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_SLASH] = ACTIONS(1360),
    [anon_sym_PERCENT] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1358),
    [anon_sym_LT_LT] = ACTIONS(1360),
    [anon_sym_GT_GT] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1358),
    [anon_sym_DASH_EQ] = ACTIONS(1358),
    [anon_sym_STAR_EQ] = ACTIONS(1358),
    [anon_sym_SLASH_EQ] = ACTIONS(1358),
    [anon_sym_PERCENT_EQ] = ACTIONS(1358),
    [anon_sym_CARET_EQ] = ACTIONS(1358),
    [anon_sym_AMP_EQ] = ACTIONS(1358),
    [anon_sym_PIPE_EQ] = ACTIONS(1358),
    [anon_sym_LT_LT_EQ] = ACTIONS(1358),
    [anon_sym_GT_GT_EQ] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1360),
    [anon_sym_EQ_EQ] = ACTIONS(1358),
    [anon_sym_BANG_EQ] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1358),
    [anon_sym_LT_EQ] = ACTIONS(1358),
    [anon_sym_DOT] = ACTIONS(1360),
    [anon_sym_DOT_DOT] = ACTIONS(1360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1358),
    [anon_sym_COLON_COLON] = ACTIONS(1358),
    [anon_sym_POUND] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [anon_sym_as] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_break] = ACTIONS(1360),
    [anon_sym_const] = ACTIONS(1360),
    [anon_sym_continue] = ACTIONS(1360),
    [anon_sym_default] = ACTIONS(1360),
    [anon_sym_enum] = ACTIONS(1360),
    [anon_sym_fn] = ACTIONS(1360),
    [anon_sym_for] = ACTIONS(1360),
    [anon_sym_if] = ACTIONS(1360),
    [anon_sym_impl] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1360),
    [anon_sym_loop] = ACTIONS(1360),
    [anon_sym_match] = ACTIONS(1360),
    [anon_sym_mod] = ACTIONS(1360),
    [anon_sym_pub] = ACTIONS(1360),
    [anon_sym_return] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_struct] = ACTIONS(1360),
    [anon_sym_trait] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_union] = ACTIONS(1360),
    [anon_sym_unsafe] = ACTIONS(1360),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_while] = ACTIONS(1360),
    [anon_sym_extern] = ACTIONS(1360),
    [anon_sym_yield] = ACTIONS(1360),
    [anon_sym_move] = ACTIONS(1360),
    [anon_sym_try] = ACTIONS(1360),
    [sym_integer_literal] = ACTIONS(1358),
    [aux_sym_string_literal_token1] = ACTIONS(1358),
    [sym_char_literal] = ACTIONS(1358),
    [anon_sym_true] = ACTIONS(1360),
    [anon_sym_false] = ACTIONS(1360),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1360),
    [sym_super] = ACTIONS(1360),
    [sym_crate] = ACTIONS(1360),
    [sym_metavariable] = ACTIONS(1358),
    [sym__raw_string_literal_start] = ACTIONS(1358),
    [sym_float_literal] = ACTIONS(1358),
  },
  [377] = {
    [sym_line_comment] = STATE(377),
    [sym_block_comment] = STATE(377),
    [ts_builtin_sym_end] = ACTIONS(1362),
    [sym_identifier] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1362),
    [anon_sym_macro_rules_BANG] = ACTIONS(1362),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1362),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1362),
    [anon_sym_u8] = ACTIONS(1364),
    [anon_sym_i8] = ACTIONS(1364),
    [anon_sym_u16] = ACTIONS(1364),
    [anon_sym_i16] = ACTIONS(1364),
    [anon_sym_u32] = ACTIONS(1364),
    [anon_sym_i32] = ACTIONS(1364),
    [anon_sym_u64] = ACTIONS(1364),
    [anon_sym_i64] = ACTIONS(1364),
    [anon_sym_u128] = ACTIONS(1364),
    [anon_sym_i128] = ACTIONS(1364),
    [anon_sym_isize] = ACTIONS(1364),
    [anon_sym_usize] = ACTIONS(1364),
    [anon_sym_f32] = ACTIONS(1364),
    [anon_sym_f64] = ACTIONS(1364),
    [anon_sym_bool] = ACTIONS(1364),
    [anon_sym_str] = ACTIONS(1364),
    [anon_sym_char] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_PERCENT] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1362),
    [anon_sym_LT_LT] = ACTIONS(1364),
    [anon_sym_GT_GT] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1362),
    [anon_sym_DASH_EQ] = ACTIONS(1362),
    [anon_sym_STAR_EQ] = ACTIONS(1362),
    [anon_sym_SLASH_EQ] = ACTIONS(1362),
    [anon_sym_PERCENT_EQ] = ACTIONS(1362),
    [anon_sym_CARET_EQ] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1362),
    [anon_sym_PIPE_EQ] = ACTIONS(1362),
    [anon_sym_LT_LT_EQ] = ACTIONS(1362),
    [anon_sym_GT_GT_EQ] = ACTIONS(1362),
    [anon_sym_EQ] = ACTIONS(1364),
    [anon_sym_EQ_EQ] = ACTIONS(1362),
    [anon_sym_BANG_EQ] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1362),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_DOT_DOT] = ACTIONS(1364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1362),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1362),
    [anon_sym_COLON_COLON] = ACTIONS(1362),
    [anon_sym_POUND] = ACTIONS(1362),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_as] = ACTIONS(1364),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_break] = ACTIONS(1364),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_continue] = ACTIONS(1364),
    [anon_sym_default] = ACTIONS(1364),
    [anon_sym_enum] = ACTIONS(1364),
    [anon_sym_fn] = ACTIONS(1364),
    [anon_sym_for] = ACTIONS(1364),
    [anon_sym_if] = ACTIONS(1364),
    [anon_sym_impl] = ACTIONS(1364),
    [anon_sym_let] = ACTIONS(1364),
    [anon_sym_loop] = ACTIONS(1364),
    [anon_sym_match] = ACTIONS(1364),
    [anon_sym_mod] = ACTIONS(1364),
    [anon_sym_pub] = ACTIONS(1364),
    [anon_sym_return] = ACTIONS(1364),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_struct] = ACTIONS(1364),
    [anon_sym_trait] = ACTIONS(1364),
    [anon_sym_type] = ACTIONS(1364),
    [anon_sym_union] = ACTIONS(1364),
    [anon_sym_unsafe] = ACTIONS(1364),
    [anon_sym_use] = ACTIONS(1364),
    [anon_sym_while] = ACTIONS(1364),
    [anon_sym_extern] = ACTIONS(1364),
    [anon_sym_yield] = ACTIONS(1364),
    [anon_sym_move] = ACTIONS(1364),
    [anon_sym_try] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1362),
    [aux_sym_string_literal_token1] = ACTIONS(1362),
    [sym_char_literal] = ACTIONS(1362),
    [anon_sym_true] = ACTIONS(1364),
    [anon_sym_false] = ACTIONS(1364),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1364),
    [sym_super] = ACTIONS(1364),
    [sym_crate] = ACTIONS(1364),
    [sym_metavariable] = ACTIONS(1362),
    [sym__raw_string_literal_start] = ACTIONS(1362),
    [sym_float_literal] = ACTIONS(1362),
  },
  [378] = {
    [sym_line_comment] = STATE(378),
    [sym_block_comment] = STATE(378),
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_macro_rules_BANG] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(983),
    [anon_sym_u8] = ACTIONS(981),
    [anon_sym_i8] = ACTIONS(981),
    [anon_sym_u16] = ACTIONS(981),
    [anon_sym_i16] = ACTIONS(981),
    [anon_sym_u32] = ACTIONS(981),
    [anon_sym_i32] = ACTIONS(981),
    [anon_sym_u64] = ACTIONS(981),
    [anon_sym_i64] = ACTIONS(981),
    [anon_sym_u128] = ACTIONS(981),
    [anon_sym_i128] = ACTIONS(981),
    [anon_sym_isize] = ACTIONS(981),
    [anon_sym_usize] = ACTIONS(981),
    [anon_sym_f32] = ACTIONS(981),
    [anon_sym_f64] = ACTIONS(981),
    [anon_sym_bool] = ACTIONS(981),
    [anon_sym_str] = ACTIONS(981),
    [anon_sym_char] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(981),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_PLUS_EQ] = ACTIONS(983),
    [anon_sym_DASH_EQ] = ACTIONS(983),
    [anon_sym_STAR_EQ] = ACTIONS(983),
    [anon_sym_SLASH_EQ] = ACTIONS(983),
    [anon_sym_PERCENT_EQ] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(983),
    [anon_sym_AMP_EQ] = ACTIONS(983),
    [anon_sym_PIPE_EQ] = ACTIONS(983),
    [anon_sym_LT_LT_EQ] = ACTIONS(983),
    [anon_sym_GT_GT_EQ] = ACTIONS(983),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(983),
    [anon_sym_BANG_EQ] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_LT_EQ] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(983),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(983),
    [anon_sym_COLON_COLON] = ACTIONS(983),
    [anon_sym_POUND] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(981),
    [anon_sym_as] = ACTIONS(981),
    [anon_sym_async] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_const] = ACTIONS(981),
    [anon_sym_continue] = ACTIONS(981),
    [anon_sym_default] = ACTIONS(981),
    [anon_sym_enum] = ACTIONS(981),
    [anon_sym_fn] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_impl] = ACTIONS(981),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(981),
    [anon_sym_match] = ACTIONS(981),
    [anon_sym_mod] = ACTIONS(981),
    [anon_sym_pub] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_static] = ACTIONS(981),
    [anon_sym_struct] = ACTIONS(981),
    [anon_sym_trait] = ACTIONS(981),
    [anon_sym_type] = ACTIONS(981),
    [anon_sym_union] = ACTIONS(981),
    [anon_sym_unsafe] = ACTIONS(981),
    [anon_sym_use] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_extern] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(981),
    [anon_sym_move] = ACTIONS(981),
    [anon_sym_try] = ACTIONS(981),
    [sym_integer_literal] = ACTIONS(983),
    [aux_sym_string_literal_token1] = ACTIONS(983),
    [sym_char_literal] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(981),
    [sym_super] = ACTIONS(981),
    [sym_crate] = ACTIONS(981),
    [sym_metavariable] = ACTIONS(983),
    [sym__raw_string_literal_start] = ACTIONS(983),
    [sym_float_literal] = ACTIONS(983),
  },
  [379] = {
    [sym_line_comment] = STATE(379),
    [sym_block_comment] = STATE(379),
    [ts_builtin_sym_end] = ACTIONS(1366),
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1366),
    [anon_sym_macro_rules_BANG] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_QMARK] = ACTIONS(1366),
    [anon_sym_u8] = ACTIONS(1368),
    [anon_sym_i8] = ACTIONS(1368),
    [anon_sym_u16] = ACTIONS(1368),
    [anon_sym_i16] = ACTIONS(1368),
    [anon_sym_u32] = ACTIONS(1368),
    [anon_sym_i32] = ACTIONS(1368),
    [anon_sym_u64] = ACTIONS(1368),
    [anon_sym_i64] = ACTIONS(1368),
    [anon_sym_u128] = ACTIONS(1368),
    [anon_sym_i128] = ACTIONS(1368),
    [anon_sym_isize] = ACTIONS(1368),
    [anon_sym_usize] = ACTIONS(1368),
    [anon_sym_f32] = ACTIONS(1368),
    [anon_sym_f64] = ACTIONS(1368),
    [anon_sym_bool] = ACTIONS(1368),
    [anon_sym_str] = ACTIONS(1368),
    [anon_sym_char] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_PERCENT] = ACTIONS(1368),
    [anon_sym_CARET] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_PIPE] = ACTIONS(1368),
    [anon_sym_AMP_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1366),
    [anon_sym_LT_LT] = ACTIONS(1368),
    [anon_sym_GT_GT] = ACTIONS(1368),
    [anon_sym_PLUS_EQ] = ACTIONS(1366),
    [anon_sym_DASH_EQ] = ACTIONS(1366),
    [anon_sym_STAR_EQ] = ACTIONS(1366),
    [anon_sym_SLASH_EQ] = ACTIONS(1366),
    [anon_sym_PERCENT_EQ] = ACTIONS(1366),
    [anon_sym_CARET_EQ] = ACTIONS(1366),
    [anon_sym_AMP_EQ] = ACTIONS(1366),
    [anon_sym_PIPE_EQ] = ACTIONS(1366),
    [anon_sym_LT_LT_EQ] = ACTIONS(1366),
    [anon_sym_GT_GT_EQ] = ACTIONS(1366),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_EQ_EQ] = ACTIONS(1366),
    [anon_sym_BANG_EQ] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1368),
    [anon_sym_LT] = ACTIONS(1368),
    [anon_sym_GT_EQ] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1366),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1366),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1366),
    [anon_sym_COLON_COLON] = ACTIONS(1366),
    [anon_sym_POUND] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(1368),
    [anon_sym_async] = ACTIONS(1368),
    [anon_sym_break] = ACTIONS(1368),
    [anon_sym_const] = ACTIONS(1368),
    [anon_sym_continue] = ACTIONS(1368),
    [anon_sym_default] = ACTIONS(1368),
    [anon_sym_enum] = ACTIONS(1368),
    [anon_sym_fn] = ACTIONS(1368),
    [anon_sym_for] = ACTIONS(1368),
    [anon_sym_if] = ACTIONS(1368),
    [anon_sym_impl] = ACTIONS(1368),
    [anon_sym_let] = ACTIONS(1368),
    [anon_sym_loop] = ACTIONS(1368),
    [anon_sym_match] = ACTIONS(1368),
    [anon_sym_mod] = ACTIONS(1368),
    [anon_sym_pub] = ACTIONS(1368),
    [anon_sym_return] = ACTIONS(1368),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_struct] = ACTIONS(1368),
    [anon_sym_trait] = ACTIONS(1368),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_union] = ACTIONS(1368),
    [anon_sym_unsafe] = ACTIONS(1368),
    [anon_sym_use] = ACTIONS(1368),
    [anon_sym_while] = ACTIONS(1368),
    [anon_sym_extern] = ACTIONS(1368),
    [anon_sym_yield] = ACTIONS(1368),
    [anon_sym_move] = ACTIONS(1368),
    [anon_sym_try] = ACTIONS(1368),
    [sym_integer_literal] = ACTIONS(1366),
    [aux_sym_string_literal_token1] = ACTIONS(1366),
    [sym_char_literal] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(1368),
    [anon_sym_false] = ACTIONS(1368),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1368),
    [sym_super] = ACTIONS(1368),
    [sym_crate] = ACTIONS(1368),
    [sym_metavariable] = ACTIONS(1366),
    [sym__raw_string_literal_start] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
  },
  [380] = {
    [sym_line_comment] = STATE(380),
    [sym_block_comment] = STATE(380),
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_identifier] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_macro_rules_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1370),
    [anon_sym_u8] = ACTIONS(1372),
    [anon_sym_i8] = ACTIONS(1372),
    [anon_sym_u16] = ACTIONS(1372),
    [anon_sym_i16] = ACTIONS(1372),
    [anon_sym_u32] = ACTIONS(1372),
    [anon_sym_i32] = ACTIONS(1372),
    [anon_sym_u64] = ACTIONS(1372),
    [anon_sym_i64] = ACTIONS(1372),
    [anon_sym_u128] = ACTIONS(1372),
    [anon_sym_i128] = ACTIONS(1372),
    [anon_sym_isize] = ACTIONS(1372),
    [anon_sym_usize] = ACTIONS(1372),
    [anon_sym_f32] = ACTIONS(1372),
    [anon_sym_f64] = ACTIONS(1372),
    [anon_sym_bool] = ACTIONS(1372),
    [anon_sym_str] = ACTIONS(1372),
    [anon_sym_char] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1372),
    [anon_sym_PLUS_EQ] = ACTIONS(1370),
    [anon_sym_DASH_EQ] = ACTIONS(1370),
    [anon_sym_STAR_EQ] = ACTIONS(1370),
    [anon_sym_SLASH_EQ] = ACTIONS(1370),
    [anon_sym_PERCENT_EQ] = ACTIONS(1370),
    [anon_sym_CARET_EQ] = ACTIONS(1370),
    [anon_sym_AMP_EQ] = ACTIONS(1370),
    [anon_sym_PIPE_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_GT_EQ] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_DOT_DOT] = ACTIONS(1372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1370),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1370),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_POUND] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_as] = ACTIONS(1372),
    [anon_sym_async] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_impl] = ACTIONS(1372),
    [anon_sym_let] = ACTIONS(1372),
    [anon_sym_loop] = ACTIONS(1372),
    [anon_sym_match] = ACTIONS(1372),
    [anon_sym_mod] = ACTIONS(1372),
    [anon_sym_pub] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1372),
    [anon_sym_trait] = ACTIONS(1372),
    [anon_sym_type] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_unsafe] = ACTIONS(1372),
    [anon_sym_use] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_move] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [sym_integer_literal] = ACTIONS(1370),
    [aux_sym_string_literal_token1] = ACTIONS(1370),
    [sym_char_literal] = ACTIONS(1370),
    [anon_sym_true] = ACTIONS(1372),
    [anon_sym_false] = ACTIONS(1372),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1372),
    [sym_super] = ACTIONS(1372),
    [sym_crate] = ACTIONS(1372),
    [sym_metavariable] = ACTIONS(1370),
    [sym__raw_string_literal_start] = ACTIONS(1370),
    [sym_float_literal] = ACTIONS(1370),
  },
  [381] = {
    [sym_line_comment] = STATE(381),
    [sym_block_comment] = STATE(381),
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1374),
    [anon_sym_macro_rules_BANG] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1374),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_QMARK] = ACTIONS(1374),
    [anon_sym_u8] = ACTIONS(1376),
    [anon_sym_i8] = ACTIONS(1376),
    [anon_sym_u16] = ACTIONS(1376),
    [anon_sym_i16] = ACTIONS(1376),
    [anon_sym_u32] = ACTIONS(1376),
    [anon_sym_i32] = ACTIONS(1376),
    [anon_sym_u64] = ACTIONS(1376),
    [anon_sym_i64] = ACTIONS(1376),
    [anon_sym_u128] = ACTIONS(1376),
    [anon_sym_i128] = ACTIONS(1376),
    [anon_sym_isize] = ACTIONS(1376),
    [anon_sym_usize] = ACTIONS(1376),
    [anon_sym_f32] = ACTIONS(1376),
    [anon_sym_f64] = ACTIONS(1376),
    [anon_sym_bool] = ACTIONS(1376),
    [anon_sym_str] = ACTIONS(1376),
    [anon_sym_char] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1376),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_PIPE] = ACTIONS(1376),
    [anon_sym_AMP_AMP] = ACTIONS(1374),
    [anon_sym_PIPE_PIPE] = ACTIONS(1374),
    [anon_sym_LT_LT] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1376),
    [anon_sym_PLUS_EQ] = ACTIONS(1374),
    [anon_sym_DASH_EQ] = ACTIONS(1374),
    [anon_sym_STAR_EQ] = ACTIONS(1374),
    [anon_sym_SLASH_EQ] = ACTIONS(1374),
    [anon_sym_PERCENT_EQ] = ACTIONS(1374),
    [anon_sym_CARET_EQ] = ACTIONS(1374),
    [anon_sym_AMP_EQ] = ACTIONS(1374),
    [anon_sym_PIPE_EQ] = ACTIONS(1374),
    [anon_sym_LT_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT_GT_EQ] = ACTIONS(1374),
    [anon_sym_EQ] = ACTIONS(1376),
    [anon_sym_EQ_EQ] = ACTIONS(1374),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym_DOT] = ACTIONS(1376),
    [anon_sym_DOT_DOT] = ACTIONS(1376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1374),
    [anon_sym_COLON_COLON] = ACTIONS(1374),
    [anon_sym_POUND] = ACTIONS(1374),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_as] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1376),
    [anon_sym_break] = ACTIONS(1376),
    [anon_sym_const] = ACTIONS(1376),
    [anon_sym_continue] = ACTIONS(1376),
    [anon_sym_default] = ACTIONS(1376),
    [anon_sym_enum] = ACTIONS(1376),
    [anon_sym_fn] = ACTIONS(1376),
    [anon_sym_for] = ACTIONS(1376),
    [anon_sym_if] = ACTIONS(1376),
    [anon_sym_impl] = ACTIONS(1376),
    [anon_sym_let] = ACTIONS(1376),
    [anon_sym_loop] = ACTIONS(1376),
    [anon_sym_match] = ACTIONS(1376),
    [anon_sym_mod] = ACTIONS(1376),
    [anon_sym_pub] = ACTIONS(1376),
    [anon_sym_return] = ACTIONS(1376),
    [anon_sym_static] = ACTIONS(1376),
    [anon_sym_struct] = ACTIONS(1376),
    [anon_sym_trait] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1376),
    [anon_sym_union] = ACTIONS(1376),
    [anon_sym_unsafe] = ACTIONS(1376),
    [anon_sym_use] = ACTIONS(1376),
    [anon_sym_while] = ACTIONS(1376),
    [anon_sym_extern] = ACTIONS(1376),
    [anon_sym_yield] = ACTIONS(1376),
    [anon_sym_move] = ACTIONS(1376),
    [anon_sym_try] = ACTIONS(1376),
    [sym_integer_literal] = ACTIONS(1374),
    [aux_sym_string_literal_token1] = ACTIONS(1374),
    [sym_char_literal] = ACTIONS(1374),
    [anon_sym_true] = ACTIONS(1376),
    [anon_sym_false] = ACTIONS(1376),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1376),
    [sym_super] = ACTIONS(1376),
    [sym_crate] = ACTIONS(1376),
    [sym_metavariable] = ACTIONS(1374),
    [sym__raw_string_literal_start] = ACTIONS(1374),
    [sym_float_literal] = ACTIONS(1374),
  },
  [382] = {
    [sym_attribute_item] = STATE(415),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(2935),
    [sym_variadic_parameter] = STATE(2935),
    [sym_parameter] = STATE(2935),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2553),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(382),
    [sym_block_comment] = STATE(382),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1380),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COMMA] = ACTIONS(1382),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [383] = {
    [sym_attribute_item] = STATE(417),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(2793),
    [sym_variadic_parameter] = STATE(2793),
    [sym_parameter] = STATE(2793),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2670),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(383),
    [sym_block_comment] = STATE(383),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1386),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [384] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(2927),
    [sym_variadic_parameter] = STATE(2927),
    [sym_parameter] = STATE(2927),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2556),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2389),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(384),
    [sym_block_comment] = STATE(384),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1342),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COMMA] = ACTIONS(1392),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [385] = {
    [sym_line_comment] = STATE(385),
    [sym_block_comment] = STATE(385),
    [ts_builtin_sym_end] = ACTIONS(1394),
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_SEMI] = ACTIONS(1394),
    [anon_sym_macro_rules_BANG] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1396),
    [anon_sym_STAR] = ACTIONS(1396),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_u8] = ACTIONS(1396),
    [anon_sym_i8] = ACTIONS(1396),
    [anon_sym_u16] = ACTIONS(1396),
    [anon_sym_i16] = ACTIONS(1396),
    [anon_sym_u32] = ACTIONS(1396),
    [anon_sym_i32] = ACTIONS(1396),
    [anon_sym_u64] = ACTIONS(1396),
    [anon_sym_i64] = ACTIONS(1396),
    [anon_sym_u128] = ACTIONS(1396),
    [anon_sym_i128] = ACTIONS(1396),
    [anon_sym_isize] = ACTIONS(1396),
    [anon_sym_usize] = ACTIONS(1396),
    [anon_sym_f32] = ACTIONS(1396),
    [anon_sym_f64] = ACTIONS(1396),
    [anon_sym_bool] = ACTIONS(1396),
    [anon_sym_str] = ACTIONS(1396),
    [anon_sym_char] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1396),
    [anon_sym_SLASH] = ACTIONS(1396),
    [anon_sym_PERCENT] = ACTIONS(1396),
    [anon_sym_CARET] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1396),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1396),
    [anon_sym_GT_GT] = ACTIONS(1396),
    [anon_sym_PLUS_EQ] = ACTIONS(1394),
    [anon_sym_DASH_EQ] = ACTIONS(1394),
    [anon_sym_STAR_EQ] = ACTIONS(1394),
    [anon_sym_SLASH_EQ] = ACTIONS(1394),
    [anon_sym_PERCENT_EQ] = ACTIONS(1394),
    [anon_sym_CARET_EQ] = ACTIONS(1394),
    [anon_sym_AMP_EQ] = ACTIONS(1394),
    [anon_sym_PIPE_EQ] = ACTIONS(1394),
    [anon_sym_LT_LT_EQ] = ACTIONS(1394),
    [anon_sym_GT_GT_EQ] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1396),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(1396),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym_DOT] = ACTIONS(1396),
    [anon_sym_DOT_DOT] = ACTIONS(1396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(1394),
    [anon_sym_POUND] = ACTIONS(1394),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [anon_sym_as] = ACTIONS(1396),
    [anon_sym_async] = ACTIONS(1396),
    [anon_sym_break] = ACTIONS(1396),
    [anon_sym_const] = ACTIONS(1396),
    [anon_sym_continue] = ACTIONS(1396),
    [anon_sym_default] = ACTIONS(1396),
    [anon_sym_enum] = ACTIONS(1396),
    [anon_sym_fn] = ACTIONS(1396),
    [anon_sym_for] = ACTIONS(1396),
    [anon_sym_if] = ACTIONS(1396),
    [anon_sym_impl] = ACTIONS(1396),
    [anon_sym_let] = ACTIONS(1396),
    [anon_sym_loop] = ACTIONS(1396),
    [anon_sym_match] = ACTIONS(1396),
    [anon_sym_mod] = ACTIONS(1396),
    [anon_sym_pub] = ACTIONS(1396),
    [anon_sym_return] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1396),
    [anon_sym_struct] = ACTIONS(1396),
    [anon_sym_trait] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(1396),
    [anon_sym_union] = ACTIONS(1396),
    [anon_sym_unsafe] = ACTIONS(1396),
    [anon_sym_use] = ACTIONS(1396),
    [anon_sym_while] = ACTIONS(1396),
    [anon_sym_extern] = ACTIONS(1396),
    [anon_sym_yield] = ACTIONS(1396),
    [anon_sym_move] = ACTIONS(1396),
    [anon_sym_try] = ACTIONS(1396),
    [sym_integer_literal] = ACTIONS(1394),
    [aux_sym_string_literal_token1] = ACTIONS(1394),
    [sym_char_literal] = ACTIONS(1394),
    [anon_sym_true] = ACTIONS(1396),
    [anon_sym_false] = ACTIONS(1396),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1396),
    [sym_super] = ACTIONS(1396),
    [sym_crate] = ACTIONS(1396),
    [sym_metavariable] = ACTIONS(1394),
    [sym__raw_string_literal_start] = ACTIONS(1394),
    [sym_float_literal] = ACTIONS(1394),
  },
  [386] = {
    [sym_line_comment] = STATE(386),
    [sym_block_comment] = STATE(386),
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_macro_rules_BANG] = ACTIONS(1398),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_QMARK] = ACTIONS(1398),
    [anon_sym_u8] = ACTIONS(1400),
    [anon_sym_i8] = ACTIONS(1400),
    [anon_sym_u16] = ACTIONS(1400),
    [anon_sym_i16] = ACTIONS(1400),
    [anon_sym_u32] = ACTIONS(1400),
    [anon_sym_i32] = ACTIONS(1400),
    [anon_sym_u64] = ACTIONS(1400),
    [anon_sym_i64] = ACTIONS(1400),
    [anon_sym_u128] = ACTIONS(1400),
    [anon_sym_i128] = ACTIONS(1400),
    [anon_sym_isize] = ACTIONS(1400),
    [anon_sym_usize] = ACTIONS(1400),
    [anon_sym_f32] = ACTIONS(1400),
    [anon_sym_f64] = ACTIONS(1400),
    [anon_sym_bool] = ACTIONS(1400),
    [anon_sym_str] = ACTIONS(1400),
    [anon_sym_char] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_PERCENT] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_PLUS_EQ] = ACTIONS(1398),
    [anon_sym_DASH_EQ] = ACTIONS(1398),
    [anon_sym_STAR_EQ] = ACTIONS(1398),
    [anon_sym_SLASH_EQ] = ACTIONS(1398),
    [anon_sym_PERCENT_EQ] = ACTIONS(1398),
    [anon_sym_CARET_EQ] = ACTIONS(1398),
    [anon_sym_AMP_EQ] = ACTIONS(1398),
    [anon_sym_PIPE_EQ] = ACTIONS(1398),
    [anon_sym_LT_LT_EQ] = ACTIONS(1398),
    [anon_sym_GT_GT_EQ] = ACTIONS(1398),
    [anon_sym_EQ] = ACTIONS(1400),
    [anon_sym_EQ_EQ] = ACTIONS(1398),
    [anon_sym_BANG_EQ] = ACTIONS(1398),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT_EQ] = ACTIONS(1398),
    [anon_sym_LT_EQ] = ACTIONS(1398),
    [anon_sym_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1398),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1398),
    [anon_sym_COLON_COLON] = ACTIONS(1398),
    [anon_sym_POUND] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_as] = ACTIONS(1400),
    [anon_sym_async] = ACTIONS(1400),
    [anon_sym_break] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_continue] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
    [anon_sym_fn] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1400),
    [anon_sym_impl] = ACTIONS(1400),
    [anon_sym_let] = ACTIONS(1400),
    [anon_sym_loop] = ACTIONS(1400),
    [anon_sym_match] = ACTIONS(1400),
    [anon_sym_mod] = ACTIONS(1400),
    [anon_sym_pub] = ACTIONS(1400),
    [anon_sym_return] = ACTIONS(1400),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_struct] = ACTIONS(1400),
    [anon_sym_trait] = ACTIONS(1400),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_unsafe] = ACTIONS(1400),
    [anon_sym_use] = ACTIONS(1400),
    [anon_sym_while] = ACTIONS(1400),
    [anon_sym_extern] = ACTIONS(1400),
    [anon_sym_yield] = ACTIONS(1400),
    [anon_sym_move] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1400),
    [sym_integer_literal] = ACTIONS(1398),
    [aux_sym_string_literal_token1] = ACTIONS(1398),
    [sym_char_literal] = ACTIONS(1398),
    [anon_sym_true] = ACTIONS(1400),
    [anon_sym_false] = ACTIONS(1400),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1400),
    [sym_super] = ACTIONS(1400),
    [sym_crate] = ACTIONS(1400),
    [sym_metavariable] = ACTIONS(1398),
    [sym__raw_string_literal_start] = ACTIONS(1398),
    [sym_float_literal] = ACTIONS(1398),
  },
  [387] = {
    [sym_line_comment] = STATE(387),
    [sym_block_comment] = STATE(387),
    [ts_builtin_sym_end] = ACTIONS(1402),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_macro_rules_BANG] = ACTIONS(1402),
    [anon_sym_LPAREN] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1402),
    [anon_sym_RBRACE] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_u8] = ACTIONS(1404),
    [anon_sym_i8] = ACTIONS(1404),
    [anon_sym_u16] = ACTIONS(1404),
    [anon_sym_i16] = ACTIONS(1404),
    [anon_sym_u32] = ACTIONS(1404),
    [anon_sym_i32] = ACTIONS(1404),
    [anon_sym_u64] = ACTIONS(1404),
    [anon_sym_i64] = ACTIONS(1404),
    [anon_sym_u128] = ACTIONS(1404),
    [anon_sym_i128] = ACTIONS(1404),
    [anon_sym_isize] = ACTIONS(1404),
    [anon_sym_usize] = ACTIONS(1404),
    [anon_sym_f32] = ACTIONS(1404),
    [anon_sym_f64] = ACTIONS(1404),
    [anon_sym_bool] = ACTIONS(1404),
    [anon_sym_str] = ACTIONS(1404),
    [anon_sym_char] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_SLASH] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1406),
    [anon_sym_CARET] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_PIPE] = ACTIONS(1404),
    [anon_sym_AMP_AMP] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(1406),
    [anon_sym_PLUS_EQ] = ACTIONS(1408),
    [anon_sym_DASH_EQ] = ACTIONS(1408),
    [anon_sym_STAR_EQ] = ACTIONS(1408),
    [anon_sym_SLASH_EQ] = ACTIONS(1408),
    [anon_sym_PERCENT_EQ] = ACTIONS(1408),
    [anon_sym_CARET_EQ] = ACTIONS(1408),
    [anon_sym_AMP_EQ] = ACTIONS(1408),
    [anon_sym_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_LT_LT_EQ] = ACTIONS(1408),
    [anon_sym_GT_GT_EQ] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1406),
    [anon_sym_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1406),
    [anon_sym_LT] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1408),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1408),
    [anon_sym_COLON_COLON] = ACTIONS(1402),
    [anon_sym_POUND] = ACTIONS(1402),
    [anon_sym_SQUOTE] = ACTIONS(1404),
    [anon_sym_as] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1404),
    [anon_sym_break] = ACTIONS(1404),
    [anon_sym_const] = ACTIONS(1404),
    [anon_sym_continue] = ACTIONS(1404),
    [anon_sym_default] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [anon_sym_fn] = ACTIONS(1404),
    [anon_sym_for] = ACTIONS(1404),
    [anon_sym_if] = ACTIONS(1404),
    [anon_sym_impl] = ACTIONS(1404),
    [anon_sym_let] = ACTIONS(1404),
    [anon_sym_loop] = ACTIONS(1404),
    [anon_sym_match] = ACTIONS(1404),
    [anon_sym_mod] = ACTIONS(1404),
    [anon_sym_pub] = ACTIONS(1404),
    [anon_sym_return] = ACTIONS(1404),
    [anon_sym_static] = ACTIONS(1404),
    [anon_sym_struct] = ACTIONS(1404),
    [anon_sym_trait] = ACTIONS(1404),
    [anon_sym_type] = ACTIONS(1404),
    [anon_sym_union] = ACTIONS(1404),
    [anon_sym_unsafe] = ACTIONS(1404),
    [anon_sym_use] = ACTIONS(1404),
    [anon_sym_while] = ACTIONS(1404),
    [anon_sym_extern] = ACTIONS(1404),
    [anon_sym_yield] = ACTIONS(1404),
    [anon_sym_move] = ACTIONS(1404),
    [anon_sym_try] = ACTIONS(1404),
    [sym_integer_literal] = ACTIONS(1402),
    [aux_sym_string_literal_token1] = ACTIONS(1402),
    [sym_char_literal] = ACTIONS(1402),
    [anon_sym_true] = ACTIONS(1404),
    [anon_sym_false] = ACTIONS(1404),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1404),
    [sym_super] = ACTIONS(1404),
    [sym_crate] = ACTIONS(1404),
    [sym_metavariable] = ACTIONS(1402),
    [sym__raw_string_literal_start] = ACTIONS(1402),
    [sym_float_literal] = ACTIONS(1402),
  },
  [388] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(2927),
    [sym_variadic_parameter] = STATE(2927),
    [sym_parameter] = STATE(2927),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2556),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2389),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(388),
    [sym_block_comment] = STATE(388),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1342),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [389] = {
    [sym_line_comment] = STATE(389),
    [sym_block_comment] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(1414),
    [sym_identifier] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1414),
    [anon_sym_macro_rules_BANG] = ACTIONS(1414),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1414),
    [anon_sym_RBRACE] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_QMARK] = ACTIONS(1414),
    [anon_sym_u8] = ACTIONS(1416),
    [anon_sym_i8] = ACTIONS(1416),
    [anon_sym_u16] = ACTIONS(1416),
    [anon_sym_i16] = ACTIONS(1416),
    [anon_sym_u32] = ACTIONS(1416),
    [anon_sym_i32] = ACTIONS(1416),
    [anon_sym_u64] = ACTIONS(1416),
    [anon_sym_i64] = ACTIONS(1416),
    [anon_sym_u128] = ACTIONS(1416),
    [anon_sym_i128] = ACTIONS(1416),
    [anon_sym_isize] = ACTIONS(1416),
    [anon_sym_usize] = ACTIONS(1416),
    [anon_sym_f32] = ACTIONS(1416),
    [anon_sym_f64] = ACTIONS(1416),
    [anon_sym_bool] = ACTIONS(1416),
    [anon_sym_str] = ACTIONS(1416),
    [anon_sym_char] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_SLASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(1416),
    [anon_sym_CARET] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_PIPE] = ACTIONS(1416),
    [anon_sym_AMP_AMP] = ACTIONS(1414),
    [anon_sym_PIPE_PIPE] = ACTIONS(1414),
    [anon_sym_LT_LT] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1416),
    [anon_sym_PLUS_EQ] = ACTIONS(1414),
    [anon_sym_DASH_EQ] = ACTIONS(1414),
    [anon_sym_STAR_EQ] = ACTIONS(1414),
    [anon_sym_SLASH_EQ] = ACTIONS(1414),
    [anon_sym_PERCENT_EQ] = ACTIONS(1414),
    [anon_sym_CARET_EQ] = ACTIONS(1414),
    [anon_sym_AMP_EQ] = ACTIONS(1414),
    [anon_sym_PIPE_EQ] = ACTIONS(1414),
    [anon_sym_LT_LT_EQ] = ACTIONS(1414),
    [anon_sym_GT_GT_EQ] = ACTIONS(1414),
    [anon_sym_EQ] = ACTIONS(1416),
    [anon_sym_EQ_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ] = ACTIONS(1414),
    [anon_sym_GT] = ACTIONS(1416),
    [anon_sym_LT] = ACTIONS(1416),
    [anon_sym_GT_EQ] = ACTIONS(1414),
    [anon_sym_LT_EQ] = ACTIONS(1414),
    [anon_sym_DOT] = ACTIONS(1416),
    [anon_sym_DOT_DOT] = ACTIONS(1416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1414),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1414),
    [anon_sym_COLON_COLON] = ACTIONS(1414),
    [anon_sym_POUND] = ACTIONS(1414),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_as] = ACTIONS(1416),
    [anon_sym_async] = ACTIONS(1416),
    [anon_sym_break] = ACTIONS(1416),
    [anon_sym_const] = ACTIONS(1416),
    [anon_sym_continue] = ACTIONS(1416),
    [anon_sym_default] = ACTIONS(1416),
    [anon_sym_enum] = ACTIONS(1416),
    [anon_sym_fn] = ACTIONS(1416),
    [anon_sym_for] = ACTIONS(1416),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_impl] = ACTIONS(1416),
    [anon_sym_let] = ACTIONS(1416),
    [anon_sym_loop] = ACTIONS(1416),
    [anon_sym_match] = ACTIONS(1416),
    [anon_sym_mod] = ACTIONS(1416),
    [anon_sym_pub] = ACTIONS(1416),
    [anon_sym_return] = ACTIONS(1416),
    [anon_sym_static] = ACTIONS(1416),
    [anon_sym_struct] = ACTIONS(1416),
    [anon_sym_trait] = ACTIONS(1416),
    [anon_sym_type] = ACTIONS(1416),
    [anon_sym_union] = ACTIONS(1416),
    [anon_sym_unsafe] = ACTIONS(1416),
    [anon_sym_use] = ACTIONS(1416),
    [anon_sym_while] = ACTIONS(1416),
    [anon_sym_extern] = ACTIONS(1416),
    [anon_sym_yield] = ACTIONS(1416),
    [anon_sym_move] = ACTIONS(1416),
    [anon_sym_try] = ACTIONS(1416),
    [sym_integer_literal] = ACTIONS(1414),
    [aux_sym_string_literal_token1] = ACTIONS(1414),
    [sym_char_literal] = ACTIONS(1414),
    [anon_sym_true] = ACTIONS(1416),
    [anon_sym_false] = ACTIONS(1416),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1416),
    [sym_super] = ACTIONS(1416),
    [sym_crate] = ACTIONS(1416),
    [sym_metavariable] = ACTIONS(1414),
    [sym__raw_string_literal_start] = ACTIONS(1414),
    [sym_float_literal] = ACTIONS(1414),
  },
  [390] = {
    [sym_line_comment] = STATE(390),
    [sym_block_comment] = STATE(390),
    [ts_builtin_sym_end] = ACTIONS(1418),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_macro_rules_BANG] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_QMARK] = ACTIONS(1418),
    [anon_sym_u8] = ACTIONS(1420),
    [anon_sym_i8] = ACTIONS(1420),
    [anon_sym_u16] = ACTIONS(1420),
    [anon_sym_i16] = ACTIONS(1420),
    [anon_sym_u32] = ACTIONS(1420),
    [anon_sym_i32] = ACTIONS(1420),
    [anon_sym_u64] = ACTIONS(1420),
    [anon_sym_i64] = ACTIONS(1420),
    [anon_sym_u128] = ACTIONS(1420),
    [anon_sym_i128] = ACTIONS(1420),
    [anon_sym_isize] = ACTIONS(1420),
    [anon_sym_usize] = ACTIONS(1420),
    [anon_sym_f32] = ACTIONS(1420),
    [anon_sym_f64] = ACTIONS(1420),
    [anon_sym_bool] = ACTIONS(1420),
    [anon_sym_str] = ACTIONS(1420),
    [anon_sym_char] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_SLASH] = ACTIONS(1420),
    [anon_sym_PERCENT] = ACTIONS(1420),
    [anon_sym_CARET] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_PIPE] = ACTIONS(1420),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_PIPE_PIPE] = ACTIONS(1418),
    [anon_sym_LT_LT] = ACTIONS(1420),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_EQ] = ACTIONS(1418),
    [anon_sym_DASH_EQ] = ACTIONS(1418),
    [anon_sym_STAR_EQ] = ACTIONS(1418),
    [anon_sym_SLASH_EQ] = ACTIONS(1418),
    [anon_sym_PERCENT_EQ] = ACTIONS(1418),
    [anon_sym_CARET_EQ] = ACTIONS(1418),
    [anon_sym_AMP_EQ] = ACTIONS(1418),
    [anon_sym_PIPE_EQ] = ACTIONS(1418),
    [anon_sym_LT_LT_EQ] = ACTIONS(1418),
    [anon_sym_GT_GT_EQ] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1420),
    [anon_sym_EQ_EQ] = ACTIONS(1418),
    [anon_sym_BANG_EQ] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1420),
    [anon_sym_LT] = ACTIONS(1420),
    [anon_sym_GT_EQ] = ACTIONS(1418),
    [anon_sym_LT_EQ] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1418),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1418),
    [anon_sym_COLON_COLON] = ACTIONS(1418),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_as] = ACTIONS(1420),
    [anon_sym_async] = ACTIONS(1420),
    [anon_sym_break] = ACTIONS(1420),
    [anon_sym_const] = ACTIONS(1420),
    [anon_sym_continue] = ACTIONS(1420),
    [anon_sym_default] = ACTIONS(1420),
    [anon_sym_enum] = ACTIONS(1420),
    [anon_sym_fn] = ACTIONS(1420),
    [anon_sym_for] = ACTIONS(1420),
    [anon_sym_if] = ACTIONS(1420),
    [anon_sym_impl] = ACTIONS(1420),
    [anon_sym_let] = ACTIONS(1420),
    [anon_sym_loop] = ACTIONS(1420),
    [anon_sym_match] = ACTIONS(1420),
    [anon_sym_mod] = ACTIONS(1420),
    [anon_sym_pub] = ACTIONS(1420),
    [anon_sym_return] = ACTIONS(1420),
    [anon_sym_static] = ACTIONS(1420),
    [anon_sym_struct] = ACTIONS(1420),
    [anon_sym_trait] = ACTIONS(1420),
    [anon_sym_type] = ACTIONS(1420),
    [anon_sym_union] = ACTIONS(1420),
    [anon_sym_unsafe] = ACTIONS(1420),
    [anon_sym_use] = ACTIONS(1420),
    [anon_sym_while] = ACTIONS(1420),
    [anon_sym_extern] = ACTIONS(1420),
    [anon_sym_yield] = ACTIONS(1420),
    [anon_sym_move] = ACTIONS(1420),
    [anon_sym_try] = ACTIONS(1420),
    [sym_integer_literal] = ACTIONS(1418),
    [aux_sym_string_literal_token1] = ACTIONS(1418),
    [sym_char_literal] = ACTIONS(1418),
    [anon_sym_true] = ACTIONS(1420),
    [anon_sym_false] = ACTIONS(1420),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1420),
    [sym_super] = ACTIONS(1420),
    [sym_crate] = ACTIONS(1420),
    [sym_metavariable] = ACTIONS(1418),
    [sym__raw_string_literal_start] = ACTIONS(1418),
    [sym_float_literal] = ACTIONS(1418),
  },
  [391] = {
    [sym_line_comment] = STATE(391),
    [sym_block_comment] = STATE(391),
    [ts_builtin_sym_end] = ACTIONS(1422),
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_macro_rules_BANG] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_u8] = ACTIONS(1424),
    [anon_sym_i8] = ACTIONS(1424),
    [anon_sym_u16] = ACTIONS(1424),
    [anon_sym_i16] = ACTIONS(1424),
    [anon_sym_u32] = ACTIONS(1424),
    [anon_sym_i32] = ACTIONS(1424),
    [anon_sym_u64] = ACTIONS(1424),
    [anon_sym_i64] = ACTIONS(1424),
    [anon_sym_u128] = ACTIONS(1424),
    [anon_sym_i128] = ACTIONS(1424),
    [anon_sym_isize] = ACTIONS(1424),
    [anon_sym_usize] = ACTIONS(1424),
    [anon_sym_f32] = ACTIONS(1424),
    [anon_sym_f64] = ACTIONS(1424),
    [anon_sym_bool] = ACTIONS(1424),
    [anon_sym_str] = ACTIONS(1424),
    [anon_sym_char] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1406),
    [anon_sym_SLASH] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1406),
    [anon_sym_CARET] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PIPE] = ACTIONS(1406),
    [anon_sym_AMP_AMP] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(1406),
    [anon_sym_PLUS_EQ] = ACTIONS(1408),
    [anon_sym_DASH_EQ] = ACTIONS(1408),
    [anon_sym_STAR_EQ] = ACTIONS(1408),
    [anon_sym_SLASH_EQ] = ACTIONS(1408),
    [anon_sym_PERCENT_EQ] = ACTIONS(1408),
    [anon_sym_CARET_EQ] = ACTIONS(1408),
    [anon_sym_AMP_EQ] = ACTIONS(1408),
    [anon_sym_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_LT_LT_EQ] = ACTIONS(1408),
    [anon_sym_GT_GT_EQ] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1406),
    [anon_sym_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1406),
    [anon_sym_LT] = ACTIONS(1406),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_DOT_DOT] = ACTIONS(1406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1408),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1408),
    [anon_sym_COLON_COLON] = ACTIONS(1422),
    [anon_sym_POUND] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_break] = ACTIONS(1424),
    [anon_sym_const] = ACTIONS(1424),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_default] = ACTIONS(1424),
    [anon_sym_enum] = ACTIONS(1424),
    [anon_sym_fn] = ACTIONS(1424),
    [anon_sym_for] = ACTIONS(1424),
    [anon_sym_if] = ACTIONS(1424),
    [anon_sym_impl] = ACTIONS(1424),
    [anon_sym_let] = ACTIONS(1424),
    [anon_sym_loop] = ACTIONS(1424),
    [anon_sym_match] = ACTIONS(1424),
    [anon_sym_mod] = ACTIONS(1424),
    [anon_sym_pub] = ACTIONS(1424),
    [anon_sym_return] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_struct] = ACTIONS(1424),
    [anon_sym_trait] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1424),
    [anon_sym_union] = ACTIONS(1424),
    [anon_sym_unsafe] = ACTIONS(1424),
    [anon_sym_use] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(1424),
    [anon_sym_extern] = ACTIONS(1424),
    [anon_sym_yield] = ACTIONS(1424),
    [anon_sym_move] = ACTIONS(1424),
    [anon_sym_try] = ACTIONS(1424),
    [sym_integer_literal] = ACTIONS(1422),
    [aux_sym_string_literal_token1] = ACTIONS(1422),
    [sym_char_literal] = ACTIONS(1422),
    [anon_sym_true] = ACTIONS(1424),
    [anon_sym_false] = ACTIONS(1424),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_crate] = ACTIONS(1424),
    [sym_metavariable] = ACTIONS(1422),
    [sym__raw_string_literal_start] = ACTIONS(1422),
    [sym_float_literal] = ACTIONS(1422),
  },
  [392] = {
    [sym_line_comment] = STATE(392),
    [sym_block_comment] = STATE(392),
    [ts_builtin_sym_end] = ACTIONS(1426),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1426),
    [anon_sym_macro_rules_BANG] = ACTIONS(1426),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1426),
    [anon_sym_u8] = ACTIONS(1428),
    [anon_sym_i8] = ACTIONS(1428),
    [anon_sym_u16] = ACTIONS(1428),
    [anon_sym_i16] = ACTIONS(1428),
    [anon_sym_u32] = ACTIONS(1428),
    [anon_sym_i32] = ACTIONS(1428),
    [anon_sym_u64] = ACTIONS(1428),
    [anon_sym_i64] = ACTIONS(1428),
    [anon_sym_u128] = ACTIONS(1428),
    [anon_sym_i128] = ACTIONS(1428),
    [anon_sym_isize] = ACTIONS(1428),
    [anon_sym_usize] = ACTIONS(1428),
    [anon_sym_f32] = ACTIONS(1428),
    [anon_sym_f64] = ACTIONS(1428),
    [anon_sym_bool] = ACTIONS(1428),
    [anon_sym_str] = ACTIONS(1428),
    [anon_sym_char] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1426),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_LT_LT] = ACTIONS(1428),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_PLUS_EQ] = ACTIONS(1426),
    [anon_sym_DASH_EQ] = ACTIONS(1426),
    [anon_sym_STAR_EQ] = ACTIONS(1426),
    [anon_sym_SLASH_EQ] = ACTIONS(1426),
    [anon_sym_PERCENT_EQ] = ACTIONS(1426),
    [anon_sym_CARET_EQ] = ACTIONS(1426),
    [anon_sym_AMP_EQ] = ACTIONS(1426),
    [anon_sym_PIPE_EQ] = ACTIONS(1426),
    [anon_sym_LT_LT_EQ] = ACTIONS(1426),
    [anon_sym_GT_GT_EQ] = ACTIONS(1426),
    [anon_sym_EQ] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1426),
    [anon_sym_BANG_EQ] = ACTIONS(1426),
    [anon_sym_GT] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_GT_EQ] = ACTIONS(1426),
    [anon_sym_LT_EQ] = ACTIONS(1426),
    [anon_sym_DOT] = ACTIONS(1428),
    [anon_sym_DOT_DOT] = ACTIONS(1428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1426),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(1426),
    [anon_sym_POUND] = ACTIONS(1426),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_break] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_continue] = ACTIONS(1428),
    [anon_sym_default] = ACTIONS(1428),
    [anon_sym_enum] = ACTIONS(1428),
    [anon_sym_fn] = ACTIONS(1428),
    [anon_sym_for] = ACTIONS(1428),
    [anon_sym_if] = ACTIONS(1428),
    [anon_sym_impl] = ACTIONS(1428),
    [anon_sym_let] = ACTIONS(1428),
    [anon_sym_loop] = ACTIONS(1428),
    [anon_sym_match] = ACTIONS(1428),
    [anon_sym_mod] = ACTIONS(1428),
    [anon_sym_pub] = ACTIONS(1428),
    [anon_sym_return] = ACTIONS(1428),
    [anon_sym_static] = ACTIONS(1428),
    [anon_sym_struct] = ACTIONS(1428),
    [anon_sym_trait] = ACTIONS(1428),
    [anon_sym_type] = ACTIONS(1428),
    [anon_sym_union] = ACTIONS(1428),
    [anon_sym_unsafe] = ACTIONS(1428),
    [anon_sym_use] = ACTIONS(1428),
    [anon_sym_while] = ACTIONS(1428),
    [anon_sym_extern] = ACTIONS(1428),
    [anon_sym_yield] = ACTIONS(1428),
    [anon_sym_move] = ACTIONS(1428),
    [anon_sym_try] = ACTIONS(1428),
    [sym_integer_literal] = ACTIONS(1426),
    [aux_sym_string_literal_token1] = ACTIONS(1426),
    [sym_char_literal] = ACTIONS(1426),
    [anon_sym_true] = ACTIONS(1428),
    [anon_sym_false] = ACTIONS(1428),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1428),
    [sym_super] = ACTIONS(1428),
    [sym_crate] = ACTIONS(1428),
    [sym_metavariable] = ACTIONS(1426),
    [sym__raw_string_literal_start] = ACTIONS(1426),
    [sym_float_literal] = ACTIONS(1426),
  },
  [393] = {
    [sym_line_comment] = STATE(393),
    [sym_block_comment] = STATE(393),
    [ts_builtin_sym_end] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_macro_rules_BANG] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1432),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_QMARK] = ACTIONS(1430),
    [anon_sym_u8] = ACTIONS(1432),
    [anon_sym_i8] = ACTIONS(1432),
    [anon_sym_u16] = ACTIONS(1432),
    [anon_sym_i16] = ACTIONS(1432),
    [anon_sym_u32] = ACTIONS(1432),
    [anon_sym_i32] = ACTIONS(1432),
    [anon_sym_u64] = ACTIONS(1432),
    [anon_sym_i64] = ACTIONS(1432),
    [anon_sym_u128] = ACTIONS(1432),
    [anon_sym_i128] = ACTIONS(1432),
    [anon_sym_isize] = ACTIONS(1432),
    [anon_sym_usize] = ACTIONS(1432),
    [anon_sym_f32] = ACTIONS(1432),
    [anon_sym_f64] = ACTIONS(1432),
    [anon_sym_bool] = ACTIONS(1432),
    [anon_sym_str] = ACTIONS(1432),
    [anon_sym_char] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1432),
    [anon_sym_PERCENT] = ACTIONS(1432),
    [anon_sym_CARET] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_PIPE] = ACTIONS(1432),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT_LT] = ACTIONS(1432),
    [anon_sym_GT_GT] = ACTIONS(1432),
    [anon_sym_PLUS_EQ] = ACTIONS(1430),
    [anon_sym_DASH_EQ] = ACTIONS(1430),
    [anon_sym_STAR_EQ] = ACTIONS(1430),
    [anon_sym_SLASH_EQ] = ACTIONS(1430),
    [anon_sym_PERCENT_EQ] = ACTIONS(1430),
    [anon_sym_CARET_EQ] = ACTIONS(1430),
    [anon_sym_AMP_EQ] = ACTIONS(1430),
    [anon_sym_PIPE_EQ] = ACTIONS(1430),
    [anon_sym_LT_LT_EQ] = ACTIONS(1430),
    [anon_sym_GT_GT_EQ] = ACTIONS(1430),
    [anon_sym_EQ] = ACTIONS(1432),
    [anon_sym_EQ_EQ] = ACTIONS(1430),
    [anon_sym_BANG_EQ] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_GT_EQ] = ACTIONS(1430),
    [anon_sym_LT_EQ] = ACTIONS(1430),
    [anon_sym_DOT] = ACTIONS(1432),
    [anon_sym_DOT_DOT] = ACTIONS(1432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1430),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1430),
    [anon_sym_COLON_COLON] = ACTIONS(1430),
    [anon_sym_POUND] = ACTIONS(1430),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_as] = ACTIONS(1432),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_break] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_continue] = ACTIONS(1432),
    [anon_sym_default] = ACTIONS(1432),
    [anon_sym_enum] = ACTIONS(1432),
    [anon_sym_fn] = ACTIONS(1432),
    [anon_sym_for] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_impl] = ACTIONS(1432),
    [anon_sym_let] = ACTIONS(1432),
    [anon_sym_loop] = ACTIONS(1432),
    [anon_sym_match] = ACTIONS(1432),
    [anon_sym_mod] = ACTIONS(1432),
    [anon_sym_pub] = ACTIONS(1432),
    [anon_sym_return] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_struct] = ACTIONS(1432),
    [anon_sym_trait] = ACTIONS(1432),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_union] = ACTIONS(1432),
    [anon_sym_unsafe] = ACTIONS(1432),
    [anon_sym_use] = ACTIONS(1432),
    [anon_sym_while] = ACTIONS(1432),
    [anon_sym_extern] = ACTIONS(1432),
    [anon_sym_yield] = ACTIONS(1432),
    [anon_sym_move] = ACTIONS(1432),
    [anon_sym_try] = ACTIONS(1432),
    [sym_integer_literal] = ACTIONS(1430),
    [aux_sym_string_literal_token1] = ACTIONS(1430),
    [sym_char_literal] = ACTIONS(1430),
    [anon_sym_true] = ACTIONS(1432),
    [anon_sym_false] = ACTIONS(1432),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1432),
    [sym_super] = ACTIONS(1432),
    [sym_crate] = ACTIONS(1432),
    [sym_metavariable] = ACTIONS(1430),
    [sym__raw_string_literal_start] = ACTIONS(1430),
    [sym_float_literal] = ACTIONS(1430),
  },
  [394] = {
    [sym_line_comment] = STATE(394),
    [sym_block_comment] = STATE(394),
    [ts_builtin_sym_end] = ACTIONS(1434),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_macro_rules_BANG] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_u8] = ACTIONS(1436),
    [anon_sym_i8] = ACTIONS(1436),
    [anon_sym_u16] = ACTIONS(1436),
    [anon_sym_i16] = ACTIONS(1436),
    [anon_sym_u32] = ACTIONS(1436),
    [anon_sym_i32] = ACTIONS(1436),
    [anon_sym_u64] = ACTIONS(1436),
    [anon_sym_i64] = ACTIONS(1436),
    [anon_sym_u128] = ACTIONS(1436),
    [anon_sym_i128] = ACTIONS(1436),
    [anon_sym_isize] = ACTIONS(1436),
    [anon_sym_usize] = ACTIONS(1436),
    [anon_sym_f32] = ACTIONS(1436),
    [anon_sym_f64] = ACTIONS(1436),
    [anon_sym_bool] = ACTIONS(1436),
    [anon_sym_str] = ACTIONS(1436),
    [anon_sym_char] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS_EQ] = ACTIONS(1434),
    [anon_sym_DASH_EQ] = ACTIONS(1434),
    [anon_sym_STAR_EQ] = ACTIONS(1434),
    [anon_sym_SLASH_EQ] = ACTIONS(1434),
    [anon_sym_PERCENT_EQ] = ACTIONS(1434),
    [anon_sym_CARET_EQ] = ACTIONS(1434),
    [anon_sym_AMP_EQ] = ACTIONS(1434),
    [anon_sym_PIPE_EQ] = ACTIONS(1434),
    [anon_sym_LT_LT_EQ] = ACTIONS(1434),
    [anon_sym_GT_GT_EQ] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_BANG_EQ] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT_EQ] = ACTIONS(1434),
    [anon_sym_LT_EQ] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1436),
    [anon_sym_DOT_DOT] = ACTIONS(1436),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1434),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1434),
    [anon_sym_COLON_COLON] = ACTIONS(1434),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_as] = ACTIONS(1436),
    [anon_sym_async] = ACTIONS(1436),
    [anon_sym_break] = ACTIONS(1436),
    [anon_sym_const] = ACTIONS(1436),
    [anon_sym_continue] = ACTIONS(1436),
    [anon_sym_default] = ACTIONS(1436),
    [anon_sym_enum] = ACTIONS(1436),
    [anon_sym_fn] = ACTIONS(1436),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_if] = ACTIONS(1436),
    [anon_sym_impl] = ACTIONS(1436),
    [anon_sym_let] = ACTIONS(1436),
    [anon_sym_loop] = ACTIONS(1436),
    [anon_sym_match] = ACTIONS(1436),
    [anon_sym_mod] = ACTIONS(1436),
    [anon_sym_pub] = ACTIONS(1436),
    [anon_sym_return] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1436),
    [anon_sym_struct] = ACTIONS(1436),
    [anon_sym_trait] = ACTIONS(1436),
    [anon_sym_type] = ACTIONS(1436),
    [anon_sym_union] = ACTIONS(1436),
    [anon_sym_unsafe] = ACTIONS(1436),
    [anon_sym_use] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1436),
    [anon_sym_extern] = ACTIONS(1436),
    [anon_sym_yield] = ACTIONS(1436),
    [anon_sym_move] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1436),
    [sym_integer_literal] = ACTIONS(1434),
    [aux_sym_string_literal_token1] = ACTIONS(1434),
    [sym_char_literal] = ACTIONS(1434),
    [anon_sym_true] = ACTIONS(1436),
    [anon_sym_false] = ACTIONS(1436),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1436),
    [sym_super] = ACTIONS(1436),
    [sym_crate] = ACTIONS(1436),
    [sym_metavariable] = ACTIONS(1434),
    [sym__raw_string_literal_start] = ACTIONS(1434),
    [sym_float_literal] = ACTIONS(1434),
  },
  [395] = {
    [sym_line_comment] = STATE(395),
    [sym_block_comment] = STATE(395),
    [ts_builtin_sym_end] = ACTIONS(1438),
    [sym_identifier] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_macro_rules_BANG] = ACTIONS(1438),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1438),
    [anon_sym_u8] = ACTIONS(1440),
    [anon_sym_i8] = ACTIONS(1440),
    [anon_sym_u16] = ACTIONS(1440),
    [anon_sym_i16] = ACTIONS(1440),
    [anon_sym_u32] = ACTIONS(1440),
    [anon_sym_i32] = ACTIONS(1440),
    [anon_sym_u64] = ACTIONS(1440),
    [anon_sym_i64] = ACTIONS(1440),
    [anon_sym_u128] = ACTIONS(1440),
    [anon_sym_i128] = ACTIONS(1440),
    [anon_sym_isize] = ACTIONS(1440),
    [anon_sym_usize] = ACTIONS(1440),
    [anon_sym_f32] = ACTIONS(1440),
    [anon_sym_f64] = ACTIONS(1440),
    [anon_sym_bool] = ACTIONS(1440),
    [anon_sym_str] = ACTIONS(1440),
    [anon_sym_char] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_PLUS_EQ] = ACTIONS(1438),
    [anon_sym_DASH_EQ] = ACTIONS(1438),
    [anon_sym_STAR_EQ] = ACTIONS(1438),
    [anon_sym_SLASH_EQ] = ACTIONS(1438),
    [anon_sym_PERCENT_EQ] = ACTIONS(1438),
    [anon_sym_CARET_EQ] = ACTIONS(1438),
    [anon_sym_AMP_EQ] = ACTIONS(1438),
    [anon_sym_PIPE_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_GT_EQ] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1438),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_DOT_DOT] = ACTIONS(1440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1438),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(1438),
    [anon_sym_POUND] = ACTIONS(1438),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_as] = ACTIONS(1440),
    [anon_sym_async] = ACTIONS(1440),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_fn] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_impl] = ACTIONS(1440),
    [anon_sym_let] = ACTIONS(1440),
    [anon_sym_loop] = ACTIONS(1440),
    [anon_sym_match] = ACTIONS(1440),
    [anon_sym_mod] = ACTIONS(1440),
    [anon_sym_pub] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_trait] = ACTIONS(1440),
    [anon_sym_type] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [anon_sym_unsafe] = ACTIONS(1440),
    [anon_sym_use] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym_yield] = ACTIONS(1440),
    [anon_sym_move] = ACTIONS(1440),
    [anon_sym_try] = ACTIONS(1440),
    [sym_integer_literal] = ACTIONS(1438),
    [aux_sym_string_literal_token1] = ACTIONS(1438),
    [sym_char_literal] = ACTIONS(1438),
    [anon_sym_true] = ACTIONS(1440),
    [anon_sym_false] = ACTIONS(1440),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1440),
    [sym_super] = ACTIONS(1440),
    [sym_crate] = ACTIONS(1440),
    [sym_metavariable] = ACTIONS(1438),
    [sym__raw_string_literal_start] = ACTIONS(1438),
    [sym_float_literal] = ACTIONS(1438),
  },
  [396] = {
    [sym_line_comment] = STATE(396),
    [sym_block_comment] = STATE(396),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_macro_rules_BANG] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_u8] = ACTIONS(1444),
    [anon_sym_i8] = ACTIONS(1444),
    [anon_sym_u16] = ACTIONS(1444),
    [anon_sym_i16] = ACTIONS(1444),
    [anon_sym_u32] = ACTIONS(1444),
    [anon_sym_i32] = ACTIONS(1444),
    [anon_sym_u64] = ACTIONS(1444),
    [anon_sym_i64] = ACTIONS(1444),
    [anon_sym_u128] = ACTIONS(1444),
    [anon_sym_i128] = ACTIONS(1444),
    [anon_sym_isize] = ACTIONS(1444),
    [anon_sym_usize] = ACTIONS(1444),
    [anon_sym_f32] = ACTIONS(1444),
    [anon_sym_f64] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_str] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1444),
    [anon_sym_DOT_DOT] = ACTIONS(1444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1442),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [anon_sym_POUND] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(1444),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_fn] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_impl] = ACTIONS(1444),
    [anon_sym_let] = ACTIONS(1444),
    [anon_sym_loop] = ACTIONS(1444),
    [anon_sym_match] = ACTIONS(1444),
    [anon_sym_mod] = ACTIONS(1444),
    [anon_sym_pub] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_struct] = ACTIONS(1444),
    [anon_sym_trait] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [anon_sym_unsafe] = ACTIONS(1444),
    [anon_sym_use] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [anon_sym_move] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [sym_integer_literal] = ACTIONS(1442),
    [aux_sym_string_literal_token1] = ACTIONS(1442),
    [sym_char_literal] = ACTIONS(1442),
    [anon_sym_true] = ACTIONS(1444),
    [anon_sym_false] = ACTIONS(1444),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [sym_crate] = ACTIONS(1444),
    [sym_metavariable] = ACTIONS(1442),
    [sym__raw_string_literal_start] = ACTIONS(1442),
    [sym_float_literal] = ACTIONS(1442),
  },
  [397] = {
    [sym_line_comment] = STATE(397),
    [sym_block_comment] = STATE(397),
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_macro_rules_BANG] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1446),
    [anon_sym_u8] = ACTIONS(1448),
    [anon_sym_i8] = ACTIONS(1448),
    [anon_sym_u16] = ACTIONS(1448),
    [anon_sym_i16] = ACTIONS(1448),
    [anon_sym_u32] = ACTIONS(1448),
    [anon_sym_i32] = ACTIONS(1448),
    [anon_sym_u64] = ACTIONS(1448),
    [anon_sym_i64] = ACTIONS(1448),
    [anon_sym_u128] = ACTIONS(1448),
    [anon_sym_i128] = ACTIONS(1448),
    [anon_sym_isize] = ACTIONS(1448),
    [anon_sym_usize] = ACTIONS(1448),
    [anon_sym_f32] = ACTIONS(1448),
    [anon_sym_f64] = ACTIONS(1448),
    [anon_sym_bool] = ACTIONS(1448),
    [anon_sym_str] = ACTIONS(1448),
    [anon_sym_char] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_PLUS_EQ] = ACTIONS(1446),
    [anon_sym_DASH_EQ] = ACTIONS(1446),
    [anon_sym_STAR_EQ] = ACTIONS(1446),
    [anon_sym_SLASH_EQ] = ACTIONS(1446),
    [anon_sym_PERCENT_EQ] = ACTIONS(1446),
    [anon_sym_CARET_EQ] = ACTIONS(1446),
    [anon_sym_AMP_EQ] = ACTIONS(1446),
    [anon_sym_PIPE_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_GT_EQ] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1446),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1446),
    [anon_sym_COLON_COLON] = ACTIONS(1446),
    [anon_sym_POUND] = ACTIONS(1446),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_as] = ACTIONS(1448),
    [anon_sym_async] = ACTIONS(1448),
    [anon_sym_break] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_continue] = ACTIONS(1448),
    [anon_sym_default] = ACTIONS(1448),
    [anon_sym_enum] = ACTIONS(1448),
    [anon_sym_fn] = ACTIONS(1448),
    [anon_sym_for] = ACTIONS(1448),
    [anon_sym_if] = ACTIONS(1448),
    [anon_sym_impl] = ACTIONS(1448),
    [anon_sym_let] = ACTIONS(1448),
    [anon_sym_loop] = ACTIONS(1448),
    [anon_sym_match] = ACTIONS(1448),
    [anon_sym_mod] = ACTIONS(1448),
    [anon_sym_pub] = ACTIONS(1448),
    [anon_sym_return] = ACTIONS(1448),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_struct] = ACTIONS(1448),
    [anon_sym_trait] = ACTIONS(1448),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_union] = ACTIONS(1448),
    [anon_sym_unsafe] = ACTIONS(1448),
    [anon_sym_use] = ACTIONS(1448),
    [anon_sym_while] = ACTIONS(1448),
    [anon_sym_extern] = ACTIONS(1448),
    [anon_sym_yield] = ACTIONS(1448),
    [anon_sym_move] = ACTIONS(1448),
    [anon_sym_try] = ACTIONS(1448),
    [sym_integer_literal] = ACTIONS(1446),
    [aux_sym_string_literal_token1] = ACTIONS(1446),
    [sym_char_literal] = ACTIONS(1446),
    [anon_sym_true] = ACTIONS(1448),
    [anon_sym_false] = ACTIONS(1448),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1448),
    [sym_super] = ACTIONS(1448),
    [sym_crate] = ACTIONS(1448),
    [sym_metavariable] = ACTIONS(1446),
    [sym__raw_string_literal_start] = ACTIONS(1446),
    [sym_float_literal] = ACTIONS(1446),
  },
  [398] = {
    [sym_line_comment] = STATE(398),
    [sym_block_comment] = STATE(398),
    [ts_builtin_sym_end] = ACTIONS(1003),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_macro_rules_BANG] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_STAR] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_u8] = ACTIONS(1001),
    [anon_sym_i8] = ACTIONS(1001),
    [anon_sym_u16] = ACTIONS(1001),
    [anon_sym_i16] = ACTIONS(1001),
    [anon_sym_u32] = ACTIONS(1001),
    [anon_sym_i32] = ACTIONS(1001),
    [anon_sym_u64] = ACTIONS(1001),
    [anon_sym_i64] = ACTIONS(1001),
    [anon_sym_u128] = ACTIONS(1001),
    [anon_sym_i128] = ACTIONS(1001),
    [anon_sym_isize] = ACTIONS(1001),
    [anon_sym_usize] = ACTIONS(1001),
    [anon_sym_f32] = ACTIONS(1001),
    [anon_sym_f64] = ACTIONS(1001),
    [anon_sym_bool] = ACTIONS(1001),
    [anon_sym_str] = ACTIONS(1001),
    [anon_sym_char] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1001),
    [anon_sym_CARET] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(1001),
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1001),
    [anon_sym_GT_GT] = ACTIONS(1001),
    [anon_sym_PLUS_EQ] = ACTIONS(1003),
    [anon_sym_DASH_EQ] = ACTIONS(1003),
    [anon_sym_STAR_EQ] = ACTIONS(1003),
    [anon_sym_SLASH_EQ] = ACTIONS(1003),
    [anon_sym_PERCENT_EQ] = ACTIONS(1003),
    [anon_sym_CARET_EQ] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(1003),
    [anon_sym_PIPE_EQ] = ACTIONS(1003),
    [anon_sym_LT_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT_GT_EQ] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1001),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_DOT] = ACTIONS(1001),
    [anon_sym_DOT_DOT] = ACTIONS(1001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1003),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_POUND] = ACTIONS(1003),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_as] = ACTIONS(1001),
    [anon_sym_async] = ACTIONS(1001),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1001),
    [anon_sym_continue] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(1001),
    [anon_sym_enum] = ACTIONS(1001),
    [anon_sym_fn] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1001),
    [anon_sym_impl] = ACTIONS(1001),
    [anon_sym_let] = ACTIONS(1001),
    [anon_sym_loop] = ACTIONS(1001),
    [anon_sym_match] = ACTIONS(1001),
    [anon_sym_mod] = ACTIONS(1001),
    [anon_sym_pub] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_static] = ACTIONS(1001),
    [anon_sym_struct] = ACTIONS(1001),
    [anon_sym_trait] = ACTIONS(1001),
    [anon_sym_type] = ACTIONS(1001),
    [anon_sym_union] = ACTIONS(1001),
    [anon_sym_unsafe] = ACTIONS(1001),
    [anon_sym_use] = ACTIONS(1001),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_extern] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_move] = ACTIONS(1001),
    [anon_sym_try] = ACTIONS(1001),
    [sym_integer_literal] = ACTIONS(1003),
    [aux_sym_string_literal_token1] = ACTIONS(1003),
    [sym_char_literal] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1001),
    [anon_sym_false] = ACTIONS(1001),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1001),
    [sym_super] = ACTIONS(1001),
    [sym_crate] = ACTIONS(1001),
    [sym_metavariable] = ACTIONS(1003),
    [sym__raw_string_literal_start] = ACTIONS(1003),
    [sym_float_literal] = ACTIONS(1003),
  },
  [399] = {
    [sym_line_comment] = STATE(399),
    [sym_block_comment] = STATE(399),
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1450),
    [anon_sym_macro_rules_BANG] = ACTIONS(1450),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_QMARK] = ACTIONS(1450),
    [anon_sym_u8] = ACTIONS(1452),
    [anon_sym_i8] = ACTIONS(1452),
    [anon_sym_u16] = ACTIONS(1452),
    [anon_sym_i16] = ACTIONS(1452),
    [anon_sym_u32] = ACTIONS(1452),
    [anon_sym_i32] = ACTIONS(1452),
    [anon_sym_u64] = ACTIONS(1452),
    [anon_sym_i64] = ACTIONS(1452),
    [anon_sym_u128] = ACTIONS(1452),
    [anon_sym_i128] = ACTIONS(1452),
    [anon_sym_isize] = ACTIONS(1452),
    [anon_sym_usize] = ACTIONS(1452),
    [anon_sym_f32] = ACTIONS(1452),
    [anon_sym_f64] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_str] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_AMP_AMP] = ACTIONS(1450),
    [anon_sym_PIPE_PIPE] = ACTIONS(1450),
    [anon_sym_LT_LT] = ACTIONS(1452),
    [anon_sym_GT_GT] = ACTIONS(1452),
    [anon_sym_PLUS_EQ] = ACTIONS(1450),
    [anon_sym_DASH_EQ] = ACTIONS(1450),
    [anon_sym_STAR_EQ] = ACTIONS(1450),
    [anon_sym_SLASH_EQ] = ACTIONS(1450),
    [anon_sym_PERCENT_EQ] = ACTIONS(1450),
    [anon_sym_CARET_EQ] = ACTIONS(1450),
    [anon_sym_AMP_EQ] = ACTIONS(1450),
    [anon_sym_PIPE_EQ] = ACTIONS(1450),
    [anon_sym_LT_LT_EQ] = ACTIONS(1450),
    [anon_sym_GT_GT_EQ] = ACTIONS(1450),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_EQ_EQ] = ACTIONS(1450),
    [anon_sym_BANG_EQ] = ACTIONS(1450),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT_EQ] = ACTIONS(1450),
    [anon_sym_LT_EQ] = ACTIONS(1450),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1450),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1450),
    [anon_sym_COLON_COLON] = ACTIONS(1450),
    [anon_sym_POUND] = ACTIONS(1450),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_as] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_fn] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_impl] = ACTIONS(1452),
    [anon_sym_let] = ACTIONS(1452),
    [anon_sym_loop] = ACTIONS(1452),
    [anon_sym_match] = ACTIONS(1452),
    [anon_sym_mod] = ACTIONS(1452),
    [anon_sym_pub] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_struct] = ACTIONS(1452),
    [anon_sym_trait] = ACTIONS(1452),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [anon_sym_unsafe] = ACTIONS(1452),
    [anon_sym_use] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [anon_sym_extern] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(1452),
    [anon_sym_move] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [sym_integer_literal] = ACTIONS(1450),
    [aux_sym_string_literal_token1] = ACTIONS(1450),
    [sym_char_literal] = ACTIONS(1450),
    [anon_sym_true] = ACTIONS(1452),
    [anon_sym_false] = ACTIONS(1452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_crate] = ACTIONS(1452),
    [sym_metavariable] = ACTIONS(1450),
    [sym__raw_string_literal_start] = ACTIONS(1450),
    [sym_float_literal] = ACTIONS(1450),
  },
  [400] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(400),
    [sym_block_comment] = STATE(400),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [401] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(401),
    [sym_block_comment] = STATE(401),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [402] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(402),
    [sym_block_comment] = STATE(402),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [403] = {
    [sym_line_comment] = STATE(403),
    [sym_block_comment] = STATE(403),
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_macro_rules_BANG] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_u8] = ACTIONS(1424),
    [anon_sym_i8] = ACTIONS(1424),
    [anon_sym_u16] = ACTIONS(1424),
    [anon_sym_i16] = ACTIONS(1424),
    [anon_sym_u32] = ACTIONS(1424),
    [anon_sym_i32] = ACTIONS(1424),
    [anon_sym_u64] = ACTIONS(1424),
    [anon_sym_i64] = ACTIONS(1424),
    [anon_sym_u128] = ACTIONS(1424),
    [anon_sym_i128] = ACTIONS(1424),
    [anon_sym_isize] = ACTIONS(1424),
    [anon_sym_usize] = ACTIONS(1424),
    [anon_sym_f32] = ACTIONS(1424),
    [anon_sym_f64] = ACTIONS(1424),
    [anon_sym_bool] = ACTIONS(1424),
    [anon_sym_str] = ACTIONS(1424),
    [anon_sym_char] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1406),
    [anon_sym_SLASH] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1406),
    [anon_sym_CARET] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PIPE] = ACTIONS(1406),
    [anon_sym_AMP_AMP] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(1406),
    [anon_sym_PLUS_EQ] = ACTIONS(1408),
    [anon_sym_DASH_EQ] = ACTIONS(1408),
    [anon_sym_STAR_EQ] = ACTIONS(1408),
    [anon_sym_SLASH_EQ] = ACTIONS(1408),
    [anon_sym_PERCENT_EQ] = ACTIONS(1408),
    [anon_sym_CARET_EQ] = ACTIONS(1408),
    [anon_sym_AMP_EQ] = ACTIONS(1408),
    [anon_sym_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_LT_LT_EQ] = ACTIONS(1408),
    [anon_sym_GT_GT_EQ] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1406),
    [anon_sym_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1406),
    [anon_sym_LT] = ACTIONS(1406),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_DOT_DOT] = ACTIONS(1406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1408),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1408),
    [anon_sym_COLON_COLON] = ACTIONS(1422),
    [anon_sym_POUND] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_break] = ACTIONS(1424),
    [anon_sym_const] = ACTIONS(1424),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_default] = ACTIONS(1424),
    [anon_sym_enum] = ACTIONS(1424),
    [anon_sym_fn] = ACTIONS(1424),
    [anon_sym_for] = ACTIONS(1424),
    [anon_sym_if] = ACTIONS(1424),
    [anon_sym_impl] = ACTIONS(1424),
    [anon_sym_let] = ACTIONS(1424),
    [anon_sym_loop] = ACTIONS(1424),
    [anon_sym_match] = ACTIONS(1424),
    [anon_sym_mod] = ACTIONS(1424),
    [anon_sym_pub] = ACTIONS(1424),
    [anon_sym_return] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_struct] = ACTIONS(1424),
    [anon_sym_trait] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1424),
    [anon_sym_union] = ACTIONS(1424),
    [anon_sym_unsafe] = ACTIONS(1424),
    [anon_sym_use] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(1424),
    [anon_sym_extern] = ACTIONS(1424),
    [anon_sym_yield] = ACTIONS(1424),
    [anon_sym_move] = ACTIONS(1424),
    [anon_sym_try] = ACTIONS(1424),
    [sym_integer_literal] = ACTIONS(1422),
    [aux_sym_string_literal_token1] = ACTIONS(1422),
    [sym_char_literal] = ACTIONS(1422),
    [anon_sym_true] = ACTIONS(1424),
    [anon_sym_false] = ACTIONS(1424),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_crate] = ACTIONS(1424),
    [sym_metavariable] = ACTIONS(1422),
    [sym__raw_string_literal_start] = ACTIONS(1422),
    [sym_float_literal] = ACTIONS(1422),
  },
  [404] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(404),
    [sym_block_comment] = STATE(404),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [405] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(405),
    [sym_block_comment] = STATE(405),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [406] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(406),
    [sym_block_comment] = STATE(406),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1466),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [407] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(407),
    [sym_block_comment] = STATE(407),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [408] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(408),
    [sym_block_comment] = STATE(408),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [409] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(409),
    [sym_block_comment] = STATE(409),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [410] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3249),
    [sym_variadic_parameter] = STATE(3249),
    [sym_parameter] = STATE(3249),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2757),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(410),
    [sym_block_comment] = STATE(410),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_POUND] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [411] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2697),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(2778),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2684),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(411),
    [sym_block_comment] = STATE(411),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1354),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [412] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2697),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(2778),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2684),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(412),
    [sym_block_comment] = STATE(412),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1354),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [413] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2697),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(2778),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2684),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(413),
    [sym_block_comment] = STATE(413),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1494),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1354),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [414] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(3117),
    [sym_variadic_parameter] = STATE(3117),
    [sym_parameter] = STATE(3117),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2854),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(414),
    [sym_block_comment] = STATE(414),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1496),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [415] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(2912),
    [sym_variadic_parameter] = STATE(2912),
    [sym_parameter] = STATE(2912),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2569),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(415),
    [sym_block_comment] = STATE(415),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1498),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [416] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(2880),
    [sym_variadic_parameter] = STATE(2880),
    [sym_parameter] = STATE(2880),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2571),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(416),
    [sym_block_comment] = STATE(416),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1500),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [417] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_self_parameter] = STATE(2904),
    [sym_variadic_parameter] = STATE(2904),
    [sym_parameter] = STATE(2904),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2563),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(2931),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(417),
    [sym_block_comment] = STATE(417),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1502),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1316),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1324),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [418] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2756),
    [sym_bracketed_type] = STATE(3536),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3100),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2394),
    [sym_scoped_identifier] = STATE(2148),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2688),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(418),
    [sym_block_comment] = STATE(418),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1520),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [419] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1992),
    [sym_bracketed_type] = STATE(3536),
    [sym_lifetime] = STATE(833),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3100),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2394),
    [sym_scoped_identifier] = STATE(2148),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2085),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(419),
    [sym_block_comment] = STATE(419),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1520),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1526),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [420] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1992),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(830),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2085),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(420),
    [sym_block_comment] = STATE(420),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1530),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1532),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [421] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1992),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(833),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2085),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(421),
    [sym_block_comment] = STATE(421),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1534),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1354),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [422] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1995),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2094),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(422),
    [sym_block_comment] = STATE(422),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1536),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [423] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1995),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2094),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(423),
    [sym_block_comment] = STATE(423),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1326),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [424] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1992),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(830),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2085),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(424),
    [sym_block_comment] = STATE(424),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1538),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1540),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [425] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1995),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2094),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(425),
    [sym_block_comment] = STATE(425),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1542),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [426] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1992),
    [sym_bracketed_type] = STATE(3528),
    [sym_lifetime] = STATE(833),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3289),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2436),
    [sym_scoped_identifier] = STATE(2212),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2085),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(426),
    [sym_block_comment] = STATE(426),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1272),
    [anon_sym_i8] = ACTIONS(1272),
    [anon_sym_u16] = ACTIONS(1272),
    [anon_sym_i16] = ACTIONS(1272),
    [anon_sym_u32] = ACTIONS(1272),
    [anon_sym_i32] = ACTIONS(1272),
    [anon_sym_u64] = ACTIONS(1272),
    [anon_sym_i64] = ACTIONS(1272),
    [anon_sym_u128] = ACTIONS(1272),
    [anon_sym_i128] = ACTIONS(1272),
    [anon_sym_isize] = ACTIONS(1272),
    [anon_sym_usize] = ACTIONS(1272),
    [anon_sym_f32] = ACTIONS(1272),
    [anon_sym_f64] = ACTIONS(1272),
    [anon_sym_bool] = ACTIONS(1272),
    [anon_sym_str] = ACTIONS(1272),
    [anon_sym_char] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1308),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1544),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1326),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [427] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1995),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2428),
    [sym_scoped_identifier] = STATE(2082),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2094),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(427),
    [sym_block_comment] = STATE(427),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1354),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [428] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1995),
    [sym_bracketed_type] = STATE(3536),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3100),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(2394),
    [sym_scoped_identifier] = STATE(2148),
    [sym_scoped_type_identifier] = STATE(2104),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2094),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(428),
    [sym_block_comment] = STATE(428),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1520),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_ref] = ACTIONS(1312),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [429] = {
    [sym_line_comment] = STATE(429),
    [sym_block_comment] = STATE(429),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_SEMI] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1546),
    [anon_sym_i8] = ACTIONS(1546),
    [anon_sym_u16] = ACTIONS(1546),
    [anon_sym_i16] = ACTIONS(1546),
    [anon_sym_u32] = ACTIONS(1546),
    [anon_sym_i32] = ACTIONS(1546),
    [anon_sym_u64] = ACTIONS(1546),
    [anon_sym_i64] = ACTIONS(1546),
    [anon_sym_u128] = ACTIONS(1546),
    [anon_sym_i128] = ACTIONS(1546),
    [anon_sym_isize] = ACTIONS(1546),
    [anon_sym_usize] = ACTIONS(1546),
    [anon_sym_f32] = ACTIONS(1546),
    [anon_sym_f64] = ACTIONS(1546),
    [anon_sym_bool] = ACTIONS(1546),
    [anon_sym_str] = ACTIONS(1546),
    [anon_sym_char] = ACTIONS(1546),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_PLUS_EQ] = ACTIONS(1548),
    [anon_sym_DASH_EQ] = ACTIONS(1548),
    [anon_sym_STAR_EQ] = ACTIONS(1548),
    [anon_sym_SLASH_EQ] = ACTIONS(1548),
    [anon_sym_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_CARET_EQ] = ACTIONS(1548),
    [anon_sym_AMP_EQ] = ACTIONS(1548),
    [anon_sym_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_LT_LT_EQ] = ACTIONS(1548),
    [anon_sym_GT_GT_EQ] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1548),
    [anon_sym_BANG_EQ] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1548),
    [anon_sym_LT_EQ] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1548),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1548),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [anon_sym_as] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1546),
    [anon_sym_const] = ACTIONS(1546),
    [anon_sym_continue] = ACTIONS(1546),
    [anon_sym_default] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1546),
    [anon_sym_loop] = ACTIONS(1546),
    [anon_sym_match] = ACTIONS(1546),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1546),
    [anon_sym_union] = ACTIONS(1546),
    [anon_sym_unsafe] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1546),
    [anon_sym_else] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(1546),
    [anon_sym_move] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1546),
    [sym_integer_literal] = ACTIONS(1548),
    [aux_sym_string_literal_token1] = ACTIONS(1548),
    [sym_char_literal] = ACTIONS(1548),
    [anon_sym_true] = ACTIONS(1546),
    [anon_sym_false] = ACTIONS(1546),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1546),
    [sym_super] = ACTIONS(1546),
    [sym_crate] = ACTIONS(1546),
    [sym_metavariable] = ACTIONS(1548),
    [sym__raw_string_literal_start] = ACTIONS(1548),
    [sym_float_literal] = ACTIONS(1548),
  },
  [430] = {
    [sym_line_comment] = STATE(430),
    [sym_block_comment] = STATE(430),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_EQ_GT] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1546),
    [anon_sym_i8] = ACTIONS(1546),
    [anon_sym_u16] = ACTIONS(1546),
    [anon_sym_i16] = ACTIONS(1546),
    [anon_sym_u32] = ACTIONS(1546),
    [anon_sym_i32] = ACTIONS(1546),
    [anon_sym_u64] = ACTIONS(1546),
    [anon_sym_i64] = ACTIONS(1546),
    [anon_sym_u128] = ACTIONS(1546),
    [anon_sym_i128] = ACTIONS(1546),
    [anon_sym_isize] = ACTIONS(1546),
    [anon_sym_usize] = ACTIONS(1546),
    [anon_sym_f32] = ACTIONS(1546),
    [anon_sym_f64] = ACTIONS(1546),
    [anon_sym_bool] = ACTIONS(1546),
    [anon_sym_str] = ACTIONS(1546),
    [anon_sym_char] = ACTIONS(1546),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_PLUS_EQ] = ACTIONS(1548),
    [anon_sym_DASH_EQ] = ACTIONS(1548),
    [anon_sym_STAR_EQ] = ACTIONS(1548),
    [anon_sym_SLASH_EQ] = ACTIONS(1548),
    [anon_sym_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_CARET_EQ] = ACTIONS(1548),
    [anon_sym_AMP_EQ] = ACTIONS(1548),
    [anon_sym_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_LT_LT_EQ] = ACTIONS(1548),
    [anon_sym_GT_GT_EQ] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1548),
    [anon_sym_BANG_EQ] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1548),
    [anon_sym_LT_EQ] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1548),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1548),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [anon_sym_as] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1546),
    [anon_sym_const] = ACTIONS(1546),
    [anon_sym_continue] = ACTIONS(1546),
    [anon_sym_default] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1546),
    [anon_sym_loop] = ACTIONS(1546),
    [anon_sym_match] = ACTIONS(1546),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1546),
    [anon_sym_union] = ACTIONS(1546),
    [anon_sym_unsafe] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(1546),
    [anon_sym_move] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1546),
    [sym_integer_literal] = ACTIONS(1548),
    [aux_sym_string_literal_token1] = ACTIONS(1548),
    [sym_char_literal] = ACTIONS(1548),
    [anon_sym_true] = ACTIONS(1546),
    [anon_sym_false] = ACTIONS(1546),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1546),
    [sym_super] = ACTIONS(1546),
    [sym_crate] = ACTIONS(1546),
    [sym_metavariable] = ACTIONS(1548),
    [sym__raw_string_literal_start] = ACTIONS(1548),
    [sym_float_literal] = ACTIONS(1548),
  },
  [431] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2086),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(431),
    [sym_block_comment] = STATE(431),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [anon_sym_STAR] = ACTIONS(1552),
    [anon_sym_u8] = ACTIONS(1550),
    [anon_sym_i8] = ACTIONS(1550),
    [anon_sym_u16] = ACTIONS(1550),
    [anon_sym_i16] = ACTIONS(1550),
    [anon_sym_u32] = ACTIONS(1550),
    [anon_sym_i32] = ACTIONS(1550),
    [anon_sym_u64] = ACTIONS(1550),
    [anon_sym_i64] = ACTIONS(1550),
    [anon_sym_u128] = ACTIONS(1550),
    [anon_sym_i128] = ACTIONS(1550),
    [anon_sym_isize] = ACTIONS(1550),
    [anon_sym_usize] = ACTIONS(1550),
    [anon_sym_f32] = ACTIONS(1550),
    [anon_sym_f64] = ACTIONS(1550),
    [anon_sym_bool] = ACTIONS(1550),
    [anon_sym_str] = ACTIONS(1550),
    [anon_sym_char] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1550),
    [anon_sym_DOT_DOT] = ACTIONS(1552),
    [anon_sym_COLON_COLON] = ACTIONS(1552),
    [anon_sym_DASH_GT] = ACTIONS(1552),
    [anon_sym_SQUOTE] = ACTIONS(1550),
    [anon_sym_async] = ACTIONS(1550),
    [anon_sym_break] = ACTIONS(1550),
    [anon_sym_const] = ACTIONS(1550),
    [anon_sym_continue] = ACTIONS(1550),
    [anon_sym_default] = ACTIONS(1550),
    [anon_sym_for] = ACTIONS(1550),
    [anon_sym_if] = ACTIONS(1550),
    [anon_sym_loop] = ACTIONS(1550),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_return] = ACTIONS(1550),
    [anon_sym_static] = ACTIONS(1550),
    [anon_sym_union] = ACTIONS(1550),
    [anon_sym_unsafe] = ACTIONS(1550),
    [anon_sym_while] = ACTIONS(1550),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1550),
    [anon_sym_move] = ACTIONS(1550),
    [anon_sym_try] = ACTIONS(1550),
    [sym_integer_literal] = ACTIONS(1552),
    [aux_sym_string_literal_token1] = ACTIONS(1552),
    [sym_char_literal] = ACTIONS(1552),
    [anon_sym_true] = ACTIONS(1550),
    [anon_sym_false] = ACTIONS(1550),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1550),
    [sym_super] = ACTIONS(1550),
    [sym_crate] = ACTIONS(1550),
    [sym_metavariable] = ACTIONS(1552),
    [sym__raw_string_literal_start] = ACTIONS(1552),
    [sym_float_literal] = ACTIONS(1552),
  },
  [432] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2102),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(432),
    [sym_block_comment] = STATE(432),
    [sym_identifier] = ACTIONS(1554),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_u8] = ACTIONS(1554),
    [anon_sym_i8] = ACTIONS(1554),
    [anon_sym_u16] = ACTIONS(1554),
    [anon_sym_i16] = ACTIONS(1554),
    [anon_sym_u32] = ACTIONS(1554),
    [anon_sym_i32] = ACTIONS(1554),
    [anon_sym_u64] = ACTIONS(1554),
    [anon_sym_i64] = ACTIONS(1554),
    [anon_sym_u128] = ACTIONS(1554),
    [anon_sym_i128] = ACTIONS(1554),
    [anon_sym_isize] = ACTIONS(1554),
    [anon_sym_usize] = ACTIONS(1554),
    [anon_sym_f32] = ACTIONS(1554),
    [anon_sym_f64] = ACTIONS(1554),
    [anon_sym_bool] = ACTIONS(1554),
    [anon_sym_str] = ACTIONS(1554),
    [anon_sym_char] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1554),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1556),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DOT_DOT] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1554),
    [anon_sym_async] = ACTIONS(1554),
    [anon_sym_break] = ACTIONS(1554),
    [anon_sym_const] = ACTIONS(1554),
    [anon_sym_continue] = ACTIONS(1554),
    [anon_sym_default] = ACTIONS(1554),
    [anon_sym_for] = ACTIONS(1554),
    [anon_sym_if] = ACTIONS(1554),
    [anon_sym_loop] = ACTIONS(1554),
    [anon_sym_match] = ACTIONS(1554),
    [anon_sym_return] = ACTIONS(1554),
    [anon_sym_static] = ACTIONS(1554),
    [anon_sym_union] = ACTIONS(1554),
    [anon_sym_unsafe] = ACTIONS(1554),
    [anon_sym_while] = ACTIONS(1554),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1554),
    [anon_sym_move] = ACTIONS(1554),
    [anon_sym_try] = ACTIONS(1554),
    [sym_integer_literal] = ACTIONS(1556),
    [aux_sym_string_literal_token1] = ACTIONS(1556),
    [sym_char_literal] = ACTIONS(1556),
    [anon_sym_true] = ACTIONS(1554),
    [anon_sym_false] = ACTIONS(1554),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1554),
    [sym_super] = ACTIONS(1554),
    [sym_crate] = ACTIONS(1554),
    [sym_metavariable] = ACTIONS(1556),
    [sym__raw_string_literal_start] = ACTIONS(1556),
    [sym_float_literal] = ACTIONS(1556),
  },
  [433] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(433),
    [sym_block_comment] = STATE(433),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [434] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(434),
    [sym_block_comment] = STATE(434),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1586),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [435] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(435),
    [sym_block_comment] = STATE(435),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [436] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(436),
    [sym_block_comment] = STATE(436),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [437] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(437),
    [sym_block_comment] = STATE(437),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [438] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(438),
    [sym_block_comment] = STATE(438),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [439] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(439),
    [sym_block_comment] = STATE(439),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1596),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [440] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(440),
    [sym_block_comment] = STATE(440),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [441] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(441),
    [sym_block_comment] = STATE(441),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [442] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2340),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2341),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2447),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2447),
    [sym__literal] = STATE(2447),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(442),
    [sym_block_comment] = STATE(442),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [443] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2364),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2365),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2414),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2414),
    [sym__literal] = STATE(2414),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(443),
    [sym_block_comment] = STATE(443),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [444] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2362),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2361),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2421),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2421),
    [sym__literal] = STATE(2421),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(444),
    [sym_block_comment] = STATE(444),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [445] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2435),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2437),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_type_binding] = STATE(2721),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_label] = STATE(3590),
    [sym_block] = STATE(2721),
    [sym__literal] = STATE(2721),
    [sym_string_literal] = STATE(2938),
    [sym_raw_string_literal] = STATE(2938),
    [sym_boolean_literal] = STATE(2938),
    [sym_line_comment] = STATE(445),
    [sym_block_comment] = STATE(445),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1580),
  },
  [446] = {
    [sym_else_clause] = STATE(464),
    [sym_line_comment] = STATE(446),
    [sym_block_comment] = STATE(446),
    [sym_identifier] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [anon_sym_LBRACK] = ACTIONS(1194),
    [anon_sym_RBRACE] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_QMARK] = ACTIONS(1194),
    [anon_sym_u8] = ACTIONS(1196),
    [anon_sym_i8] = ACTIONS(1196),
    [anon_sym_u16] = ACTIONS(1196),
    [anon_sym_i16] = ACTIONS(1196),
    [anon_sym_u32] = ACTIONS(1196),
    [anon_sym_i32] = ACTIONS(1196),
    [anon_sym_u64] = ACTIONS(1196),
    [anon_sym_i64] = ACTIONS(1196),
    [anon_sym_u128] = ACTIONS(1196),
    [anon_sym_i128] = ACTIONS(1196),
    [anon_sym_isize] = ACTIONS(1196),
    [anon_sym_usize] = ACTIONS(1196),
    [anon_sym_f32] = ACTIONS(1196),
    [anon_sym_f64] = ACTIONS(1196),
    [anon_sym_bool] = ACTIONS(1196),
    [anon_sym_str] = ACTIONS(1196),
    [anon_sym_char] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_SLASH] = ACTIONS(1196),
    [anon_sym_PERCENT] = ACTIONS(1196),
    [anon_sym_CARET] = ACTIONS(1196),
    [anon_sym_AMP] = ACTIONS(1196),
    [anon_sym_PIPE] = ACTIONS(1196),
    [anon_sym_AMP_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1196),
    [anon_sym_GT_GT] = ACTIONS(1196),
    [anon_sym_PLUS_EQ] = ACTIONS(1194),
    [anon_sym_DASH_EQ] = ACTIONS(1194),
    [anon_sym_STAR_EQ] = ACTIONS(1194),
    [anon_sym_SLASH_EQ] = ACTIONS(1194),
    [anon_sym_PERCENT_EQ] = ACTIONS(1194),
    [anon_sym_CARET_EQ] = ACTIONS(1194),
    [anon_sym_AMP_EQ] = ACTIONS(1194),
    [anon_sym_PIPE_EQ] = ACTIONS(1194),
    [anon_sym_LT_LT_EQ] = ACTIONS(1194),
    [anon_sym_GT_GT_EQ] = ACTIONS(1194),
    [anon_sym_EQ] = ACTIONS(1196),
    [anon_sym_EQ_EQ] = ACTIONS(1194),
    [anon_sym_BANG_EQ] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1196),
    [anon_sym_LT] = ACTIONS(1196),
    [anon_sym_GT_EQ] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1194),
    [anon_sym__] = ACTIONS(1196),
    [anon_sym_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1194),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1194),
    [anon_sym_COMMA] = ACTIONS(1194),
    [anon_sym_COLON_COLON] = ACTIONS(1194),
    [anon_sym_POUND] = ACTIONS(1194),
    [anon_sym_as] = ACTIONS(1196),
    [anon_sym_const] = ACTIONS(1196),
    [anon_sym_default] = ACTIONS(1196),
    [anon_sym_union] = ACTIONS(1196),
    [anon_sym_ref] = ACTIONS(1196),
    [anon_sym_else] = ACTIONS(1602),
    [sym_mutable_specifier] = ACTIONS(1196),
    [sym_integer_literal] = ACTIONS(1194),
    [aux_sym_string_literal_token1] = ACTIONS(1194),
    [sym_char_literal] = ACTIONS(1194),
    [anon_sym_true] = ACTIONS(1196),
    [anon_sym_false] = ACTIONS(1196),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1196),
    [sym_super] = ACTIONS(1196),
    [sym_crate] = ACTIONS(1196),
    [sym_metavariable] = ACTIONS(1194),
    [sym__raw_string_literal_start] = ACTIONS(1194),
    [sym_float_literal] = ACTIONS(1194),
  },
  [447] = {
    [sym_line_comment] = STATE(447),
    [sym_block_comment] = STATE(447),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_u8] = ACTIONS(1246),
    [anon_sym_i8] = ACTIONS(1246),
    [anon_sym_u16] = ACTIONS(1246),
    [anon_sym_i16] = ACTIONS(1246),
    [anon_sym_u32] = ACTIONS(1246),
    [anon_sym_i32] = ACTIONS(1246),
    [anon_sym_u64] = ACTIONS(1246),
    [anon_sym_i64] = ACTIONS(1246),
    [anon_sym_u128] = ACTIONS(1246),
    [anon_sym_i128] = ACTIONS(1246),
    [anon_sym_isize] = ACTIONS(1246),
    [anon_sym_usize] = ACTIONS(1246),
    [anon_sym_f32] = ACTIONS(1246),
    [anon_sym_f64] = ACTIONS(1246),
    [anon_sym_bool] = ACTIONS(1246),
    [anon_sym_str] = ACTIONS(1246),
    [anon_sym_char] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_PLUS_EQ] = ACTIONS(1244),
    [anon_sym_DASH_EQ] = ACTIONS(1244),
    [anon_sym_STAR_EQ] = ACTIONS(1244),
    [anon_sym_SLASH_EQ] = ACTIONS(1244),
    [anon_sym_PERCENT_EQ] = ACTIONS(1244),
    [anon_sym_CARET_EQ] = ACTIONS(1244),
    [anon_sym_AMP_EQ] = ACTIONS(1244),
    [anon_sym_PIPE_EQ] = ACTIONS(1244),
    [anon_sym_LT_LT_EQ] = ACTIONS(1244),
    [anon_sym_GT_GT_EQ] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_EQ_EQ] = ACTIONS(1244),
    [anon_sym_BANG_EQ] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1244),
    [anon_sym__] = ACTIONS(1246),
    [anon_sym_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1244),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1244),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1244),
    [anon_sym_as] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_union] = ACTIONS(1246),
    [anon_sym_ref] = ACTIONS(1246),
    [anon_sym_else] = ACTIONS(1246),
    [sym_mutable_specifier] = ACTIONS(1246),
    [sym_integer_literal] = ACTIONS(1244),
    [aux_sym_string_literal_token1] = ACTIONS(1244),
    [sym_char_literal] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1246),
    [anon_sym_false] = ACTIONS(1246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [sym_crate] = ACTIONS(1246),
    [sym_metavariable] = ACTIONS(1244),
    [sym__raw_string_literal_start] = ACTIONS(1244),
    [sym_float_literal] = ACTIONS(1244),
  },
  [448] = {
    [sym_line_comment] = STATE(448),
    [sym_block_comment] = STATE(448),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_QMARK] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1238),
    [anon_sym_i8] = ACTIONS(1238),
    [anon_sym_u16] = ACTIONS(1238),
    [anon_sym_i16] = ACTIONS(1238),
    [anon_sym_u32] = ACTIONS(1238),
    [anon_sym_i32] = ACTIONS(1238),
    [anon_sym_u64] = ACTIONS(1238),
    [anon_sym_i64] = ACTIONS(1238),
    [anon_sym_u128] = ACTIONS(1238),
    [anon_sym_i128] = ACTIONS(1238),
    [anon_sym_isize] = ACTIONS(1238),
    [anon_sym_usize] = ACTIONS(1238),
    [anon_sym_f32] = ACTIONS(1238),
    [anon_sym_f64] = ACTIONS(1238),
    [anon_sym_bool] = ACTIONS(1238),
    [anon_sym_str] = ACTIONS(1238),
    [anon_sym_char] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_CARET] = ACTIONS(1238),
    [anon_sym_AMP] = ACTIONS(1238),
    [anon_sym_PIPE] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(1236),
    [anon_sym_PIPE_PIPE] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1238),
    [anon_sym_PLUS_EQ] = ACTIONS(1236),
    [anon_sym_DASH_EQ] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(1236),
    [anon_sym_SLASH_EQ] = ACTIONS(1236),
    [anon_sym_PERCENT_EQ] = ACTIONS(1236),
    [anon_sym_CARET_EQ] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(1236),
    [anon_sym_LT_LT_EQ] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(1236),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(1236),
    [anon_sym_GT] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT_EQ] = ACTIONS(1236),
    [anon_sym_LT_EQ] = ACTIONS(1236),
    [anon_sym__] = ACTIONS(1238),
    [anon_sym_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1236),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_as] = ACTIONS(1238),
    [anon_sym_const] = ACTIONS(1238),
    [anon_sym_default] = ACTIONS(1238),
    [anon_sym_union] = ACTIONS(1238),
    [anon_sym_ref] = ACTIONS(1238),
    [anon_sym_else] = ACTIONS(1238),
    [sym_mutable_specifier] = ACTIONS(1238),
    [sym_integer_literal] = ACTIONS(1236),
    [aux_sym_string_literal_token1] = ACTIONS(1236),
    [sym_char_literal] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1238),
    [anon_sym_false] = ACTIONS(1238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1238),
    [sym_super] = ACTIONS(1238),
    [sym_crate] = ACTIONS(1238),
    [sym_metavariable] = ACTIONS(1236),
    [sym__raw_string_literal_start] = ACTIONS(1236),
    [sym_float_literal] = ACTIONS(1236),
  },
  [449] = {
    [sym_line_comment] = STATE(449),
    [sym_block_comment] = STATE(449),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_QMARK] = ACTIONS(1206),
    [anon_sym_u8] = ACTIONS(1208),
    [anon_sym_i8] = ACTIONS(1208),
    [anon_sym_u16] = ACTIONS(1208),
    [anon_sym_i16] = ACTIONS(1208),
    [anon_sym_u32] = ACTIONS(1208),
    [anon_sym_i32] = ACTIONS(1208),
    [anon_sym_u64] = ACTIONS(1208),
    [anon_sym_i64] = ACTIONS(1208),
    [anon_sym_u128] = ACTIONS(1208),
    [anon_sym_i128] = ACTIONS(1208),
    [anon_sym_isize] = ACTIONS(1208),
    [anon_sym_usize] = ACTIONS(1208),
    [anon_sym_f32] = ACTIONS(1208),
    [anon_sym_f64] = ACTIONS(1208),
    [anon_sym_bool] = ACTIONS(1208),
    [anon_sym_str] = ACTIONS(1208),
    [anon_sym_char] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1208),
    [anon_sym_CARET] = ACTIONS(1208),
    [anon_sym_AMP] = ACTIONS(1208),
    [anon_sym_PIPE] = ACTIONS(1208),
    [anon_sym_AMP_AMP] = ACTIONS(1206),
    [anon_sym_PIPE_PIPE] = ACTIONS(1206),
    [anon_sym_LT_LT] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1208),
    [anon_sym_PLUS_EQ] = ACTIONS(1206),
    [anon_sym_DASH_EQ] = ACTIONS(1206),
    [anon_sym_STAR_EQ] = ACTIONS(1206),
    [anon_sym_SLASH_EQ] = ACTIONS(1206),
    [anon_sym_PERCENT_EQ] = ACTIONS(1206),
    [anon_sym_CARET_EQ] = ACTIONS(1206),
    [anon_sym_AMP_EQ] = ACTIONS(1206),
    [anon_sym_PIPE_EQ] = ACTIONS(1206),
    [anon_sym_LT_LT_EQ] = ACTIONS(1206),
    [anon_sym_GT_GT_EQ] = ACTIONS(1206),
    [anon_sym_EQ] = ACTIONS(1208),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1208),
    [anon_sym_LT] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym__] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1208),
    [anon_sym_DOT_DOT] = ACTIONS(1208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1206),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(1206),
    [anon_sym_POUND] = ACTIONS(1206),
    [anon_sym_as] = ACTIONS(1208),
    [anon_sym_const] = ACTIONS(1208),
    [anon_sym_default] = ACTIONS(1208),
    [anon_sym_union] = ACTIONS(1208),
    [anon_sym_ref] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1208),
    [sym_mutable_specifier] = ACTIONS(1208),
    [sym_integer_literal] = ACTIONS(1206),
    [aux_sym_string_literal_token1] = ACTIONS(1206),
    [sym_char_literal] = ACTIONS(1206),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1208),
    [sym_super] = ACTIONS(1208),
    [sym_crate] = ACTIONS(1208),
    [sym_metavariable] = ACTIONS(1206),
    [sym__raw_string_literal_start] = ACTIONS(1206),
    [sym_float_literal] = ACTIONS(1206),
  },
  [450] = {
    [sym_line_comment] = STATE(450),
    [sym_block_comment] = STATE(450),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_LPAREN] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_QMARK] = ACTIONS(1232),
    [anon_sym_u8] = ACTIONS(1234),
    [anon_sym_i8] = ACTIONS(1234),
    [anon_sym_u16] = ACTIONS(1234),
    [anon_sym_i16] = ACTIONS(1234),
    [anon_sym_u32] = ACTIONS(1234),
    [anon_sym_i32] = ACTIONS(1234),
    [anon_sym_u64] = ACTIONS(1234),
    [anon_sym_i64] = ACTIONS(1234),
    [anon_sym_u128] = ACTIONS(1234),
    [anon_sym_i128] = ACTIONS(1234),
    [anon_sym_isize] = ACTIONS(1234),
    [anon_sym_usize] = ACTIONS(1234),
    [anon_sym_f32] = ACTIONS(1234),
    [anon_sym_f64] = ACTIONS(1234),
    [anon_sym_bool] = ACTIONS(1234),
    [anon_sym_str] = ACTIONS(1234),
    [anon_sym_char] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1234),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_CARET] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1232),
    [anon_sym_PIPE_PIPE] = ACTIONS(1232),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(1232),
    [anon_sym_DASH_EQ] = ACTIONS(1232),
    [anon_sym_STAR_EQ] = ACTIONS(1232),
    [anon_sym_SLASH_EQ] = ACTIONS(1232),
    [anon_sym_PERCENT_EQ] = ACTIONS(1232),
    [anon_sym_CARET_EQ] = ACTIONS(1232),
    [anon_sym_AMP_EQ] = ACTIONS(1232),
    [anon_sym_PIPE_EQ] = ACTIONS(1232),
    [anon_sym_LT_LT_EQ] = ACTIONS(1232),
    [anon_sym_GT_GT_EQ] = ACTIONS(1232),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_EQ_EQ] = ACTIONS(1232),
    [anon_sym_BANG_EQ] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1232),
    [anon_sym_LT_EQ] = ACTIONS(1232),
    [anon_sym__] = ACTIONS(1234),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1232),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1232),
    [anon_sym_COMMA] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(1234),
    [anon_sym_const] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1234),
    [anon_sym_union] = ACTIONS(1234),
    [anon_sym_ref] = ACTIONS(1234),
    [anon_sym_else] = ACTIONS(1234),
    [sym_mutable_specifier] = ACTIONS(1234),
    [sym_integer_literal] = ACTIONS(1232),
    [aux_sym_string_literal_token1] = ACTIONS(1232),
    [sym_char_literal] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1234),
    [anon_sym_false] = ACTIONS(1234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1234),
    [sym_super] = ACTIONS(1234),
    [sym_crate] = ACTIONS(1234),
    [sym_metavariable] = ACTIONS(1232),
    [sym__raw_string_literal_start] = ACTIONS(1232),
    [sym_float_literal] = ACTIONS(1232),
  },
  [451] = {
    [sym_line_comment] = STATE(451),
    [sym_block_comment] = STATE(451),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_QMARK] = ACTIONS(1240),
    [anon_sym_u8] = ACTIONS(1242),
    [anon_sym_i8] = ACTIONS(1242),
    [anon_sym_u16] = ACTIONS(1242),
    [anon_sym_i16] = ACTIONS(1242),
    [anon_sym_u32] = ACTIONS(1242),
    [anon_sym_i32] = ACTIONS(1242),
    [anon_sym_u64] = ACTIONS(1242),
    [anon_sym_i64] = ACTIONS(1242),
    [anon_sym_u128] = ACTIONS(1242),
    [anon_sym_i128] = ACTIONS(1242),
    [anon_sym_isize] = ACTIONS(1242),
    [anon_sym_usize] = ACTIONS(1242),
    [anon_sym_f32] = ACTIONS(1242),
    [anon_sym_f64] = ACTIONS(1242),
    [anon_sym_bool] = ACTIONS(1242),
    [anon_sym_str] = ACTIONS(1242),
    [anon_sym_char] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1240),
    [anon_sym_PIPE_PIPE] = ACTIONS(1240),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_PLUS_EQ] = ACTIONS(1240),
    [anon_sym_DASH_EQ] = ACTIONS(1240),
    [anon_sym_STAR_EQ] = ACTIONS(1240),
    [anon_sym_SLASH_EQ] = ACTIONS(1240),
    [anon_sym_PERCENT_EQ] = ACTIONS(1240),
    [anon_sym_CARET_EQ] = ACTIONS(1240),
    [anon_sym_AMP_EQ] = ACTIONS(1240),
    [anon_sym_PIPE_EQ] = ACTIONS(1240),
    [anon_sym_LT_LT_EQ] = ACTIONS(1240),
    [anon_sym_GT_GT_EQ] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1240),
    [anon_sym_BANG_EQ] = ACTIONS(1240),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1240),
    [anon_sym_LT_EQ] = ACTIONS(1240),
    [anon_sym__] = ACTIONS(1242),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1240),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1240),
    [anon_sym_COMMA] = ACTIONS(1240),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_ref] = ACTIONS(1242),
    [anon_sym_else] = ACTIONS(1242),
    [sym_mutable_specifier] = ACTIONS(1242),
    [sym_integer_literal] = ACTIONS(1240),
    [aux_sym_string_literal_token1] = ACTIONS(1240),
    [sym_char_literal] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1242),
    [anon_sym_false] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_crate] = ACTIONS(1242),
    [sym_metavariable] = ACTIONS(1240),
    [sym__raw_string_literal_start] = ACTIONS(1240),
    [sym_float_literal] = ACTIONS(1240),
  },
  [452] = {
    [sym_line_comment] = STATE(452),
    [sym_block_comment] = STATE(452),
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_LPAREN] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_QMARK] = ACTIONS(1252),
    [anon_sym_u8] = ACTIONS(1254),
    [anon_sym_i8] = ACTIONS(1254),
    [anon_sym_u16] = ACTIONS(1254),
    [anon_sym_i16] = ACTIONS(1254),
    [anon_sym_u32] = ACTIONS(1254),
    [anon_sym_i32] = ACTIONS(1254),
    [anon_sym_u64] = ACTIONS(1254),
    [anon_sym_i64] = ACTIONS(1254),
    [anon_sym_u128] = ACTIONS(1254),
    [anon_sym_i128] = ACTIONS(1254),
    [anon_sym_isize] = ACTIONS(1254),
    [anon_sym_usize] = ACTIONS(1254),
    [anon_sym_f32] = ACTIONS(1254),
    [anon_sym_f64] = ACTIONS(1254),
    [anon_sym_bool] = ACTIONS(1254),
    [anon_sym_str] = ACTIONS(1254),
    [anon_sym_char] = ACTIONS(1254),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_CARET] = ACTIONS(1254),
    [anon_sym_AMP] = ACTIONS(1254),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_PIPE_PIPE] = ACTIONS(1252),
    [anon_sym_LT_LT] = ACTIONS(1254),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_PLUS_EQ] = ACTIONS(1252),
    [anon_sym_DASH_EQ] = ACTIONS(1252),
    [anon_sym_STAR_EQ] = ACTIONS(1252),
    [anon_sym_SLASH_EQ] = ACTIONS(1252),
    [anon_sym_PERCENT_EQ] = ACTIONS(1252),
    [anon_sym_CARET_EQ] = ACTIONS(1252),
    [anon_sym_AMP_EQ] = ACTIONS(1252),
    [anon_sym_PIPE_EQ] = ACTIONS(1252),
    [anon_sym_LT_LT_EQ] = ACTIONS(1252),
    [anon_sym_GT_GT_EQ] = ACTIONS(1252),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_EQ_EQ] = ACTIONS(1252),
    [anon_sym_BANG_EQ] = ACTIONS(1252),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_GT_EQ] = ACTIONS(1252),
    [anon_sym_LT_EQ] = ACTIONS(1252),
    [anon_sym__] = ACTIONS(1254),
    [anon_sym_DOT] = ACTIONS(1254),
    [anon_sym_DOT_DOT] = ACTIONS(1254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1252),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_COLON_COLON] = ACTIONS(1252),
    [anon_sym_POUND] = ACTIONS(1252),
    [anon_sym_as] = ACTIONS(1254),
    [anon_sym_const] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1254),
    [anon_sym_union] = ACTIONS(1254),
    [anon_sym_ref] = ACTIONS(1254),
    [sym_mutable_specifier] = ACTIONS(1254),
    [sym_integer_literal] = ACTIONS(1252),
    [aux_sym_string_literal_token1] = ACTIONS(1252),
    [sym_char_literal] = ACTIONS(1252),
    [anon_sym_true] = ACTIONS(1254),
    [anon_sym_false] = ACTIONS(1254),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1254),
    [sym_super] = ACTIONS(1254),
    [sym_crate] = ACTIONS(1254),
    [sym_metavariable] = ACTIONS(1252),
    [sym__raw_string_literal_start] = ACTIONS(1252),
    [sym_float_literal] = ACTIONS(1252),
  },
  [453] = {
    [sym_line_comment] = STATE(453),
    [sym_block_comment] = STATE(453),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_QMARK] = ACTIONS(1450),
    [anon_sym_u8] = ACTIONS(1452),
    [anon_sym_i8] = ACTIONS(1452),
    [anon_sym_u16] = ACTIONS(1452),
    [anon_sym_i16] = ACTIONS(1452),
    [anon_sym_u32] = ACTIONS(1452),
    [anon_sym_i32] = ACTIONS(1452),
    [anon_sym_u64] = ACTIONS(1452),
    [anon_sym_i64] = ACTIONS(1452),
    [anon_sym_u128] = ACTIONS(1452),
    [anon_sym_i128] = ACTIONS(1452),
    [anon_sym_isize] = ACTIONS(1452),
    [anon_sym_usize] = ACTIONS(1452),
    [anon_sym_f32] = ACTIONS(1452),
    [anon_sym_f64] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_str] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_AMP_AMP] = ACTIONS(1450),
    [anon_sym_PIPE_PIPE] = ACTIONS(1450),
    [anon_sym_LT_LT] = ACTIONS(1452),
    [anon_sym_GT_GT] = ACTIONS(1452),
    [anon_sym_PLUS_EQ] = ACTIONS(1450),
    [anon_sym_DASH_EQ] = ACTIONS(1450),
    [anon_sym_STAR_EQ] = ACTIONS(1450),
    [anon_sym_SLASH_EQ] = ACTIONS(1450),
    [anon_sym_PERCENT_EQ] = ACTIONS(1450),
    [anon_sym_CARET_EQ] = ACTIONS(1450),
    [anon_sym_AMP_EQ] = ACTIONS(1450),
    [anon_sym_PIPE_EQ] = ACTIONS(1450),
    [anon_sym_LT_LT_EQ] = ACTIONS(1450),
    [anon_sym_GT_GT_EQ] = ACTIONS(1450),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_EQ_EQ] = ACTIONS(1450),
    [anon_sym_BANG_EQ] = ACTIONS(1450),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT_EQ] = ACTIONS(1450),
    [anon_sym_LT_EQ] = ACTIONS(1450),
    [anon_sym__] = ACTIONS(1452),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1450),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1450),
    [anon_sym_COMMA] = ACTIONS(1450),
    [anon_sym_COLON_COLON] = ACTIONS(1450),
    [anon_sym_POUND] = ACTIONS(1450),
    [anon_sym_as] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [anon_sym_ref] = ACTIONS(1452),
    [sym_mutable_specifier] = ACTIONS(1452),
    [sym_integer_literal] = ACTIONS(1450),
    [aux_sym_string_literal_token1] = ACTIONS(1450),
    [sym_char_literal] = ACTIONS(1450),
    [anon_sym_true] = ACTIONS(1452),
    [anon_sym_false] = ACTIONS(1452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_crate] = ACTIONS(1452),
    [sym_metavariable] = ACTIONS(1450),
    [sym__raw_string_literal_start] = ACTIONS(1450),
    [sym_float_literal] = ACTIONS(1450),
  },
  [454] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3413),
    [sym_match_pattern] = STATE(3611),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(454),
    [sym_block_comment] = STATE(454),
    [aux_sym_match_block_repeat1] = STATE(478),
    [aux_sym_match_arm_repeat1] = STATE(756),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1610),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [455] = {
    [sym_line_comment] = STATE(455),
    [sym_block_comment] = STATE(455),
    [sym_identifier] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1438),
    [anon_sym_u8] = ACTIONS(1440),
    [anon_sym_i8] = ACTIONS(1440),
    [anon_sym_u16] = ACTIONS(1440),
    [anon_sym_i16] = ACTIONS(1440),
    [anon_sym_u32] = ACTIONS(1440),
    [anon_sym_i32] = ACTIONS(1440),
    [anon_sym_u64] = ACTIONS(1440),
    [anon_sym_i64] = ACTIONS(1440),
    [anon_sym_u128] = ACTIONS(1440),
    [anon_sym_i128] = ACTIONS(1440),
    [anon_sym_isize] = ACTIONS(1440),
    [anon_sym_usize] = ACTIONS(1440),
    [anon_sym_f32] = ACTIONS(1440),
    [anon_sym_f64] = ACTIONS(1440),
    [anon_sym_bool] = ACTIONS(1440),
    [anon_sym_str] = ACTIONS(1440),
    [anon_sym_char] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_PLUS_EQ] = ACTIONS(1438),
    [anon_sym_DASH_EQ] = ACTIONS(1438),
    [anon_sym_STAR_EQ] = ACTIONS(1438),
    [anon_sym_SLASH_EQ] = ACTIONS(1438),
    [anon_sym_PERCENT_EQ] = ACTIONS(1438),
    [anon_sym_CARET_EQ] = ACTIONS(1438),
    [anon_sym_AMP_EQ] = ACTIONS(1438),
    [anon_sym_PIPE_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_GT_EQ] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1438),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym__] = ACTIONS(1440),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_DOT_DOT] = ACTIONS(1440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1438),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1438),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(1438),
    [anon_sym_POUND] = ACTIONS(1438),
    [anon_sym_as] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [anon_sym_ref] = ACTIONS(1440),
    [sym_mutable_specifier] = ACTIONS(1440),
    [sym_integer_literal] = ACTIONS(1438),
    [aux_sym_string_literal_token1] = ACTIONS(1438),
    [sym_char_literal] = ACTIONS(1438),
    [anon_sym_true] = ACTIONS(1440),
    [anon_sym_false] = ACTIONS(1440),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1440),
    [sym_super] = ACTIONS(1440),
    [sym_crate] = ACTIONS(1440),
    [sym_metavariable] = ACTIONS(1438),
    [sym__raw_string_literal_start] = ACTIONS(1438),
    [sym_float_literal] = ACTIONS(1438),
  },
  [456] = {
    [sym_line_comment] = STATE(456),
    [sym_block_comment] = STATE(456),
    [sym_identifier] = ACTIONS(1648),
    [anon_sym_LPAREN] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(1650),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_u8] = ACTIONS(1648),
    [anon_sym_i8] = ACTIONS(1648),
    [anon_sym_u16] = ACTIONS(1648),
    [anon_sym_i16] = ACTIONS(1648),
    [anon_sym_u32] = ACTIONS(1648),
    [anon_sym_i32] = ACTIONS(1648),
    [anon_sym_u64] = ACTIONS(1648),
    [anon_sym_i64] = ACTIONS(1648),
    [anon_sym_u128] = ACTIONS(1648),
    [anon_sym_i128] = ACTIONS(1648),
    [anon_sym_isize] = ACTIONS(1648),
    [anon_sym_usize] = ACTIONS(1648),
    [anon_sym_f32] = ACTIONS(1648),
    [anon_sym_f64] = ACTIONS(1648),
    [anon_sym_bool] = ACTIONS(1648),
    [anon_sym_str] = ACTIONS(1648),
    [anon_sym_char] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_SLASH] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1406),
    [anon_sym_CARET] = ACTIONS(1406),
    [anon_sym_AMP] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(1406),
    [anon_sym_PLUS_EQ] = ACTIONS(1408),
    [anon_sym_DASH_EQ] = ACTIONS(1408),
    [anon_sym_STAR_EQ] = ACTIONS(1408),
    [anon_sym_SLASH_EQ] = ACTIONS(1408),
    [anon_sym_PERCENT_EQ] = ACTIONS(1408),
    [anon_sym_CARET_EQ] = ACTIONS(1408),
    [anon_sym_AMP_EQ] = ACTIONS(1408),
    [anon_sym_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_LT_LT_EQ] = ACTIONS(1408),
    [anon_sym_GT_GT_EQ] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1406),
    [anon_sym_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1406),
    [anon_sym_LT] = ACTIONS(1648),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym__] = ACTIONS(1648),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_DOT_DOT] = ACTIONS(1648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1408),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1408),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_COLON_COLON] = ACTIONS(1650),
    [anon_sym_POUND] = ACTIONS(1650),
    [anon_sym_as] = ACTIONS(1406),
    [anon_sym_const] = ACTIONS(1648),
    [anon_sym_default] = ACTIONS(1648),
    [anon_sym_union] = ACTIONS(1648),
    [anon_sym_ref] = ACTIONS(1648),
    [sym_mutable_specifier] = ACTIONS(1648),
    [sym_integer_literal] = ACTIONS(1650),
    [aux_sym_string_literal_token1] = ACTIONS(1650),
    [sym_char_literal] = ACTIONS(1650),
    [anon_sym_true] = ACTIONS(1648),
    [anon_sym_false] = ACTIONS(1648),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1648),
    [sym_super] = ACTIONS(1648),
    [sym_crate] = ACTIONS(1648),
    [sym_metavariable] = ACTIONS(1650),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1650),
  },
  [457] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3606),
    [sym_match_pattern] = STATE(3611),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(457),
    [sym_block_comment] = STATE(457),
    [aux_sym_match_block_repeat1] = STATE(475),
    [aux_sym_match_arm_repeat1] = STATE(756),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [458] = {
    [sym_line_comment] = STATE(458),
    [sym_block_comment] = STATE(458),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_u8] = ACTIONS(1360),
    [anon_sym_i8] = ACTIONS(1360),
    [anon_sym_u16] = ACTIONS(1360),
    [anon_sym_i16] = ACTIONS(1360),
    [anon_sym_u32] = ACTIONS(1360),
    [anon_sym_i32] = ACTIONS(1360),
    [anon_sym_u64] = ACTIONS(1360),
    [anon_sym_i64] = ACTIONS(1360),
    [anon_sym_u128] = ACTIONS(1360),
    [anon_sym_i128] = ACTIONS(1360),
    [anon_sym_isize] = ACTIONS(1360),
    [anon_sym_usize] = ACTIONS(1360),
    [anon_sym_f32] = ACTIONS(1360),
    [anon_sym_f64] = ACTIONS(1360),
    [anon_sym_bool] = ACTIONS(1360),
    [anon_sym_str] = ACTIONS(1360),
    [anon_sym_char] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_SLASH] = ACTIONS(1360),
    [anon_sym_PERCENT] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1358),
    [anon_sym_LT_LT] = ACTIONS(1360),
    [anon_sym_GT_GT] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1358),
    [anon_sym_DASH_EQ] = ACTIONS(1358),
    [anon_sym_STAR_EQ] = ACTIONS(1358),
    [anon_sym_SLASH_EQ] = ACTIONS(1358),
    [anon_sym_PERCENT_EQ] = ACTIONS(1358),
    [anon_sym_CARET_EQ] = ACTIONS(1358),
    [anon_sym_AMP_EQ] = ACTIONS(1358),
    [anon_sym_PIPE_EQ] = ACTIONS(1358),
    [anon_sym_LT_LT_EQ] = ACTIONS(1358),
    [anon_sym_GT_GT_EQ] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1360),
    [anon_sym_EQ_EQ] = ACTIONS(1358),
    [anon_sym_BANG_EQ] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1358),
    [anon_sym_LT_EQ] = ACTIONS(1358),
    [anon_sym__] = ACTIONS(1360),
    [anon_sym_DOT] = ACTIONS(1360),
    [anon_sym_DOT_DOT] = ACTIONS(1360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1358),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_COLON_COLON] = ACTIONS(1358),
    [anon_sym_POUND] = ACTIONS(1358),
    [anon_sym_as] = ACTIONS(1360),
    [anon_sym_const] = ACTIONS(1360),
    [anon_sym_default] = ACTIONS(1360),
    [anon_sym_union] = ACTIONS(1360),
    [anon_sym_ref] = ACTIONS(1360),
    [sym_mutable_specifier] = ACTIONS(1360),
    [sym_integer_literal] = ACTIONS(1358),
    [aux_sym_string_literal_token1] = ACTIONS(1358),
    [sym_char_literal] = ACTIONS(1358),
    [anon_sym_true] = ACTIONS(1360),
    [anon_sym_false] = ACTIONS(1360),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1360),
    [sym_super] = ACTIONS(1360),
    [sym_crate] = ACTIONS(1360),
    [sym_metavariable] = ACTIONS(1358),
    [sym__raw_string_literal_start] = ACTIONS(1358),
    [sym_float_literal] = ACTIONS(1358),
  },
  [459] = {
    [sym_line_comment] = STATE(459),
    [sym_block_comment] = STATE(459),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1446),
    [anon_sym_u8] = ACTIONS(1448),
    [anon_sym_i8] = ACTIONS(1448),
    [anon_sym_u16] = ACTIONS(1448),
    [anon_sym_i16] = ACTIONS(1448),
    [anon_sym_u32] = ACTIONS(1448),
    [anon_sym_i32] = ACTIONS(1448),
    [anon_sym_u64] = ACTIONS(1448),
    [anon_sym_i64] = ACTIONS(1448),
    [anon_sym_u128] = ACTIONS(1448),
    [anon_sym_i128] = ACTIONS(1448),
    [anon_sym_isize] = ACTIONS(1448),
    [anon_sym_usize] = ACTIONS(1448),
    [anon_sym_f32] = ACTIONS(1448),
    [anon_sym_f64] = ACTIONS(1448),
    [anon_sym_bool] = ACTIONS(1448),
    [anon_sym_str] = ACTIONS(1448),
    [anon_sym_char] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_PLUS_EQ] = ACTIONS(1446),
    [anon_sym_DASH_EQ] = ACTIONS(1446),
    [anon_sym_STAR_EQ] = ACTIONS(1446),
    [anon_sym_SLASH_EQ] = ACTIONS(1446),
    [anon_sym_PERCENT_EQ] = ACTIONS(1446),
    [anon_sym_CARET_EQ] = ACTIONS(1446),
    [anon_sym_AMP_EQ] = ACTIONS(1446),
    [anon_sym_PIPE_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_GT_EQ] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym__] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1446),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1446),
    [anon_sym_COMMA] = ACTIONS(1446),
    [anon_sym_COLON_COLON] = ACTIONS(1446),
    [anon_sym_POUND] = ACTIONS(1446),
    [anon_sym_as] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_default] = ACTIONS(1448),
    [anon_sym_union] = ACTIONS(1448),
    [anon_sym_ref] = ACTIONS(1448),
    [sym_mutable_specifier] = ACTIONS(1448),
    [sym_integer_literal] = ACTIONS(1446),
    [aux_sym_string_literal_token1] = ACTIONS(1446),
    [sym_char_literal] = ACTIONS(1446),
    [anon_sym_true] = ACTIONS(1448),
    [anon_sym_false] = ACTIONS(1448),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1448),
    [sym_super] = ACTIONS(1448),
    [sym_crate] = ACTIONS(1448),
    [sym_metavariable] = ACTIONS(1446),
    [sym__raw_string_literal_start] = ACTIONS(1446),
    [sym_float_literal] = ACTIONS(1446),
  },
  [460] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3475),
    [sym_match_pattern] = STATE(3611),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(460),
    [sym_block_comment] = STATE(460),
    [aux_sym_match_block_repeat1] = STATE(477),
    [aux_sym_match_arm_repeat1] = STATE(756),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1654),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [461] = {
    [sym_line_comment] = STATE(461),
    [sym_block_comment] = STATE(461),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_u8] = ACTIONS(1436),
    [anon_sym_i8] = ACTIONS(1436),
    [anon_sym_u16] = ACTIONS(1436),
    [anon_sym_i16] = ACTIONS(1436),
    [anon_sym_u32] = ACTIONS(1436),
    [anon_sym_i32] = ACTIONS(1436),
    [anon_sym_u64] = ACTIONS(1436),
    [anon_sym_i64] = ACTIONS(1436),
    [anon_sym_u128] = ACTIONS(1436),
    [anon_sym_i128] = ACTIONS(1436),
    [anon_sym_isize] = ACTIONS(1436),
    [anon_sym_usize] = ACTIONS(1436),
    [anon_sym_f32] = ACTIONS(1436),
    [anon_sym_f64] = ACTIONS(1436),
    [anon_sym_bool] = ACTIONS(1436),
    [anon_sym_str] = ACTIONS(1436),
    [anon_sym_char] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS_EQ] = ACTIONS(1434),
    [anon_sym_DASH_EQ] = ACTIONS(1434),
    [anon_sym_STAR_EQ] = ACTIONS(1434),
    [anon_sym_SLASH_EQ] = ACTIONS(1434),
    [anon_sym_PERCENT_EQ] = ACTIONS(1434),
    [anon_sym_CARET_EQ] = ACTIONS(1434),
    [anon_sym_AMP_EQ] = ACTIONS(1434),
    [anon_sym_PIPE_EQ] = ACTIONS(1434),
    [anon_sym_LT_LT_EQ] = ACTIONS(1434),
    [anon_sym_GT_GT_EQ] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_BANG_EQ] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT_EQ] = ACTIONS(1434),
    [anon_sym_LT_EQ] = ACTIONS(1434),
    [anon_sym__] = ACTIONS(1436),
    [anon_sym_DOT] = ACTIONS(1436),
    [anon_sym_DOT_DOT] = ACTIONS(1436),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1434),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1434),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_COLON_COLON] = ACTIONS(1434),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_as] = ACTIONS(1436),
    [anon_sym_const] = ACTIONS(1436),
    [anon_sym_default] = ACTIONS(1436),
    [anon_sym_union] = ACTIONS(1436),
    [anon_sym_ref] = ACTIONS(1436),
    [sym_mutable_specifier] = ACTIONS(1436),
    [sym_integer_literal] = ACTIONS(1434),
    [aux_sym_string_literal_token1] = ACTIONS(1434),
    [sym_char_literal] = ACTIONS(1434),
    [anon_sym_true] = ACTIONS(1436),
    [anon_sym_false] = ACTIONS(1436),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1436),
    [sym_super] = ACTIONS(1436),
    [sym_crate] = ACTIONS(1436),
    [sym_metavariable] = ACTIONS(1434),
    [sym__raw_string_literal_start] = ACTIONS(1434),
    [sym_float_literal] = ACTIONS(1434),
  },
  [462] = {
    [sym_line_comment] = STATE(462),
    [sym_block_comment] = STATE(462),
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_QMARK] = ACTIONS(1366),
    [anon_sym_u8] = ACTIONS(1368),
    [anon_sym_i8] = ACTIONS(1368),
    [anon_sym_u16] = ACTIONS(1368),
    [anon_sym_i16] = ACTIONS(1368),
    [anon_sym_u32] = ACTIONS(1368),
    [anon_sym_i32] = ACTIONS(1368),
    [anon_sym_u64] = ACTIONS(1368),
    [anon_sym_i64] = ACTIONS(1368),
    [anon_sym_u128] = ACTIONS(1368),
    [anon_sym_i128] = ACTIONS(1368),
    [anon_sym_isize] = ACTIONS(1368),
    [anon_sym_usize] = ACTIONS(1368),
    [anon_sym_f32] = ACTIONS(1368),
    [anon_sym_f64] = ACTIONS(1368),
    [anon_sym_bool] = ACTIONS(1368),
    [anon_sym_str] = ACTIONS(1368),
    [anon_sym_char] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_PERCENT] = ACTIONS(1368),
    [anon_sym_CARET] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_PIPE] = ACTIONS(1368),
    [anon_sym_AMP_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1366),
    [anon_sym_LT_LT] = ACTIONS(1368),
    [anon_sym_GT_GT] = ACTIONS(1368),
    [anon_sym_PLUS_EQ] = ACTIONS(1366),
    [anon_sym_DASH_EQ] = ACTIONS(1366),
    [anon_sym_STAR_EQ] = ACTIONS(1366),
    [anon_sym_SLASH_EQ] = ACTIONS(1366),
    [anon_sym_PERCENT_EQ] = ACTIONS(1366),
    [anon_sym_CARET_EQ] = ACTIONS(1366),
    [anon_sym_AMP_EQ] = ACTIONS(1366),
    [anon_sym_PIPE_EQ] = ACTIONS(1366),
    [anon_sym_LT_LT_EQ] = ACTIONS(1366),
    [anon_sym_GT_GT_EQ] = ACTIONS(1366),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_EQ_EQ] = ACTIONS(1366),
    [anon_sym_BANG_EQ] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1368),
    [anon_sym_LT] = ACTIONS(1368),
    [anon_sym_GT_EQ] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1366),
    [anon_sym__] = ACTIONS(1368),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1366),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1366),
    [anon_sym_COMMA] = ACTIONS(1366),
    [anon_sym_COLON_COLON] = ACTIONS(1366),
    [anon_sym_POUND] = ACTIONS(1366),
    [anon_sym_as] = ACTIONS(1368),
    [anon_sym_const] = ACTIONS(1368),
    [anon_sym_default] = ACTIONS(1368),
    [anon_sym_union] = ACTIONS(1368),
    [anon_sym_ref] = ACTIONS(1368),
    [sym_mutable_specifier] = ACTIONS(1368),
    [sym_integer_literal] = ACTIONS(1366),
    [aux_sym_string_literal_token1] = ACTIONS(1366),
    [sym_char_literal] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(1368),
    [anon_sym_false] = ACTIONS(1368),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1368),
    [sym_super] = ACTIONS(1368),
    [sym_crate] = ACTIONS(1368),
    [sym_metavariable] = ACTIONS(1366),
    [sym__raw_string_literal_start] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
  },
  [463] = {
    [sym_line_comment] = STATE(463),
    [sym_block_comment] = STATE(463),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_QMARK] = ACTIONS(1398),
    [anon_sym_u8] = ACTIONS(1400),
    [anon_sym_i8] = ACTIONS(1400),
    [anon_sym_u16] = ACTIONS(1400),
    [anon_sym_i16] = ACTIONS(1400),
    [anon_sym_u32] = ACTIONS(1400),
    [anon_sym_i32] = ACTIONS(1400),
    [anon_sym_u64] = ACTIONS(1400),
    [anon_sym_i64] = ACTIONS(1400),
    [anon_sym_u128] = ACTIONS(1400),
    [anon_sym_i128] = ACTIONS(1400),
    [anon_sym_isize] = ACTIONS(1400),
    [anon_sym_usize] = ACTIONS(1400),
    [anon_sym_f32] = ACTIONS(1400),
    [anon_sym_f64] = ACTIONS(1400),
    [anon_sym_bool] = ACTIONS(1400),
    [anon_sym_str] = ACTIONS(1400),
    [anon_sym_char] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_PERCENT] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_PLUS_EQ] = ACTIONS(1398),
    [anon_sym_DASH_EQ] = ACTIONS(1398),
    [anon_sym_STAR_EQ] = ACTIONS(1398),
    [anon_sym_SLASH_EQ] = ACTIONS(1398),
    [anon_sym_PERCENT_EQ] = ACTIONS(1398),
    [anon_sym_CARET_EQ] = ACTIONS(1398),
    [anon_sym_AMP_EQ] = ACTIONS(1398),
    [anon_sym_PIPE_EQ] = ACTIONS(1398),
    [anon_sym_LT_LT_EQ] = ACTIONS(1398),
    [anon_sym_GT_GT_EQ] = ACTIONS(1398),
    [anon_sym_EQ] = ACTIONS(1400),
    [anon_sym_EQ_EQ] = ACTIONS(1398),
    [anon_sym_BANG_EQ] = ACTIONS(1398),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT_EQ] = ACTIONS(1398),
    [anon_sym_LT_EQ] = ACTIONS(1398),
    [anon_sym__] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1398),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1398),
    [anon_sym_COMMA] = ACTIONS(1398),
    [anon_sym_COLON_COLON] = ACTIONS(1398),
    [anon_sym_POUND] = ACTIONS(1398),
    [anon_sym_as] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_ref] = ACTIONS(1400),
    [sym_mutable_specifier] = ACTIONS(1400),
    [sym_integer_literal] = ACTIONS(1398),
    [aux_sym_string_literal_token1] = ACTIONS(1398),
    [sym_char_literal] = ACTIONS(1398),
    [anon_sym_true] = ACTIONS(1400),
    [anon_sym_false] = ACTIONS(1400),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1400),
    [sym_super] = ACTIONS(1400),
    [sym_crate] = ACTIONS(1400),
    [sym_metavariable] = ACTIONS(1398),
    [sym__raw_string_literal_start] = ACTIONS(1398),
    [sym_float_literal] = ACTIONS(1398),
  },
  [464] = {
    [sym_line_comment] = STATE(464),
    [sym_block_comment] = STATE(464),
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1396),
    [anon_sym_STAR] = ACTIONS(1396),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_u8] = ACTIONS(1396),
    [anon_sym_i8] = ACTIONS(1396),
    [anon_sym_u16] = ACTIONS(1396),
    [anon_sym_i16] = ACTIONS(1396),
    [anon_sym_u32] = ACTIONS(1396),
    [anon_sym_i32] = ACTIONS(1396),
    [anon_sym_u64] = ACTIONS(1396),
    [anon_sym_i64] = ACTIONS(1396),
    [anon_sym_u128] = ACTIONS(1396),
    [anon_sym_i128] = ACTIONS(1396),
    [anon_sym_isize] = ACTIONS(1396),
    [anon_sym_usize] = ACTIONS(1396),
    [anon_sym_f32] = ACTIONS(1396),
    [anon_sym_f64] = ACTIONS(1396),
    [anon_sym_bool] = ACTIONS(1396),
    [anon_sym_str] = ACTIONS(1396),
    [anon_sym_char] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1396),
    [anon_sym_SLASH] = ACTIONS(1396),
    [anon_sym_PERCENT] = ACTIONS(1396),
    [anon_sym_CARET] = ACTIONS(1396),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1396),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1396),
    [anon_sym_GT_GT] = ACTIONS(1396),
    [anon_sym_PLUS_EQ] = ACTIONS(1394),
    [anon_sym_DASH_EQ] = ACTIONS(1394),
    [anon_sym_STAR_EQ] = ACTIONS(1394),
    [anon_sym_SLASH_EQ] = ACTIONS(1394),
    [anon_sym_PERCENT_EQ] = ACTIONS(1394),
    [anon_sym_CARET_EQ] = ACTIONS(1394),
    [anon_sym_AMP_EQ] = ACTIONS(1394),
    [anon_sym_PIPE_EQ] = ACTIONS(1394),
    [anon_sym_LT_LT_EQ] = ACTIONS(1394),
    [anon_sym_GT_GT_EQ] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1396),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(1396),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym__] = ACTIONS(1396),
    [anon_sym_DOT] = ACTIONS(1396),
    [anon_sym_DOT_DOT] = ACTIONS(1396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(1394),
    [anon_sym_POUND] = ACTIONS(1394),
    [anon_sym_as] = ACTIONS(1396),
    [anon_sym_const] = ACTIONS(1396),
    [anon_sym_default] = ACTIONS(1396),
    [anon_sym_union] = ACTIONS(1396),
    [anon_sym_ref] = ACTIONS(1396),
    [sym_mutable_specifier] = ACTIONS(1396),
    [sym_integer_literal] = ACTIONS(1394),
    [aux_sym_string_literal_token1] = ACTIONS(1394),
    [sym_char_literal] = ACTIONS(1394),
    [anon_sym_true] = ACTIONS(1396),
    [anon_sym_false] = ACTIONS(1396),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1396),
    [sym_super] = ACTIONS(1396),
    [sym_crate] = ACTIONS(1396),
    [sym_metavariable] = ACTIONS(1394),
    [sym__raw_string_literal_start] = ACTIONS(1394),
    [sym_float_literal] = ACTIONS(1394),
  },
  [465] = {
    [sym_line_comment] = STATE(465),
    [sym_block_comment] = STATE(465),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_QMARK] = ACTIONS(1374),
    [anon_sym_u8] = ACTIONS(1376),
    [anon_sym_i8] = ACTIONS(1376),
    [anon_sym_u16] = ACTIONS(1376),
    [anon_sym_i16] = ACTIONS(1376),
    [anon_sym_u32] = ACTIONS(1376),
    [anon_sym_i32] = ACTIONS(1376),
    [anon_sym_u64] = ACTIONS(1376),
    [anon_sym_i64] = ACTIONS(1376),
    [anon_sym_u128] = ACTIONS(1376),
    [anon_sym_i128] = ACTIONS(1376),
    [anon_sym_isize] = ACTIONS(1376),
    [anon_sym_usize] = ACTIONS(1376),
    [anon_sym_f32] = ACTIONS(1376),
    [anon_sym_f64] = ACTIONS(1376),
    [anon_sym_bool] = ACTIONS(1376),
    [anon_sym_str] = ACTIONS(1376),
    [anon_sym_char] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1376),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_PIPE] = ACTIONS(1376),
    [anon_sym_AMP_AMP] = ACTIONS(1374),
    [anon_sym_PIPE_PIPE] = ACTIONS(1374),
    [anon_sym_LT_LT] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1376),
    [anon_sym_PLUS_EQ] = ACTIONS(1374),
    [anon_sym_DASH_EQ] = ACTIONS(1374),
    [anon_sym_STAR_EQ] = ACTIONS(1374),
    [anon_sym_SLASH_EQ] = ACTIONS(1374),
    [anon_sym_PERCENT_EQ] = ACTIONS(1374),
    [anon_sym_CARET_EQ] = ACTIONS(1374),
    [anon_sym_AMP_EQ] = ACTIONS(1374),
    [anon_sym_PIPE_EQ] = ACTIONS(1374),
    [anon_sym_LT_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT_GT_EQ] = ACTIONS(1374),
    [anon_sym_EQ] = ACTIONS(1376),
    [anon_sym_EQ_EQ] = ACTIONS(1374),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym__] = ACTIONS(1376),
    [anon_sym_DOT] = ACTIONS(1376),
    [anon_sym_DOT_DOT] = ACTIONS(1376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [anon_sym_COLON_COLON] = ACTIONS(1374),
    [anon_sym_POUND] = ACTIONS(1374),
    [anon_sym_as] = ACTIONS(1376),
    [anon_sym_const] = ACTIONS(1376),
    [anon_sym_default] = ACTIONS(1376),
    [anon_sym_union] = ACTIONS(1376),
    [anon_sym_ref] = ACTIONS(1376),
    [sym_mutable_specifier] = ACTIONS(1376),
    [sym_integer_literal] = ACTIONS(1374),
    [aux_sym_string_literal_token1] = ACTIONS(1374),
    [sym_char_literal] = ACTIONS(1374),
    [anon_sym_true] = ACTIONS(1376),
    [anon_sym_false] = ACTIONS(1376),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1376),
    [sym_super] = ACTIONS(1376),
    [sym_crate] = ACTIONS(1376),
    [sym_metavariable] = ACTIONS(1374),
    [sym__raw_string_literal_start] = ACTIONS(1374),
    [sym_float_literal] = ACTIONS(1374),
  },
  [466] = {
    [sym_line_comment] = STATE(466),
    [sym_block_comment] = STATE(466),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_u8] = ACTIONS(1444),
    [anon_sym_i8] = ACTIONS(1444),
    [anon_sym_u16] = ACTIONS(1444),
    [anon_sym_i16] = ACTIONS(1444),
    [anon_sym_u32] = ACTIONS(1444),
    [anon_sym_i32] = ACTIONS(1444),
    [anon_sym_u64] = ACTIONS(1444),
    [anon_sym_i64] = ACTIONS(1444),
    [anon_sym_u128] = ACTIONS(1444),
    [anon_sym_i128] = ACTIONS(1444),
    [anon_sym_isize] = ACTIONS(1444),
    [anon_sym_usize] = ACTIONS(1444),
    [anon_sym_f32] = ACTIONS(1444),
    [anon_sym_f64] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_str] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym__] = ACTIONS(1444),
    [anon_sym_DOT] = ACTIONS(1444),
    [anon_sym_DOT_DOT] = ACTIONS(1444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1442),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1442),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [anon_sym_POUND] = ACTIONS(1442),
    [anon_sym_as] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [anon_sym_ref] = ACTIONS(1444),
    [sym_mutable_specifier] = ACTIONS(1444),
    [sym_integer_literal] = ACTIONS(1442),
    [aux_sym_string_literal_token1] = ACTIONS(1442),
    [sym_char_literal] = ACTIONS(1442),
    [anon_sym_true] = ACTIONS(1444),
    [anon_sym_false] = ACTIONS(1444),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [sym_crate] = ACTIONS(1444),
    [sym_metavariable] = ACTIONS(1442),
    [sym__raw_string_literal_start] = ACTIONS(1442),
    [sym_float_literal] = ACTIONS(1442),
  },
  [467] = {
    [sym_line_comment] = STATE(467),
    [sym_block_comment] = STATE(467),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_QMARK] = ACTIONS(1418),
    [anon_sym_u8] = ACTIONS(1420),
    [anon_sym_i8] = ACTIONS(1420),
    [anon_sym_u16] = ACTIONS(1420),
    [anon_sym_i16] = ACTIONS(1420),
    [anon_sym_u32] = ACTIONS(1420),
    [anon_sym_i32] = ACTIONS(1420),
    [anon_sym_u64] = ACTIONS(1420),
    [anon_sym_i64] = ACTIONS(1420),
    [anon_sym_u128] = ACTIONS(1420),
    [anon_sym_i128] = ACTIONS(1420),
    [anon_sym_isize] = ACTIONS(1420),
    [anon_sym_usize] = ACTIONS(1420),
    [anon_sym_f32] = ACTIONS(1420),
    [anon_sym_f64] = ACTIONS(1420),
    [anon_sym_bool] = ACTIONS(1420),
    [anon_sym_str] = ACTIONS(1420),
    [anon_sym_char] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_SLASH] = ACTIONS(1420),
    [anon_sym_PERCENT] = ACTIONS(1420),
    [anon_sym_CARET] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_PIPE] = ACTIONS(1420),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_PIPE_PIPE] = ACTIONS(1418),
    [anon_sym_LT_LT] = ACTIONS(1420),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_EQ] = ACTIONS(1418),
    [anon_sym_DASH_EQ] = ACTIONS(1418),
    [anon_sym_STAR_EQ] = ACTIONS(1418),
    [anon_sym_SLASH_EQ] = ACTIONS(1418),
    [anon_sym_PERCENT_EQ] = ACTIONS(1418),
    [anon_sym_CARET_EQ] = ACTIONS(1418),
    [anon_sym_AMP_EQ] = ACTIONS(1418),
    [anon_sym_PIPE_EQ] = ACTIONS(1418),
    [anon_sym_LT_LT_EQ] = ACTIONS(1418),
    [anon_sym_GT_GT_EQ] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1420),
    [anon_sym_EQ_EQ] = ACTIONS(1418),
    [anon_sym_BANG_EQ] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1420),
    [anon_sym_LT] = ACTIONS(1420),
    [anon_sym_GT_EQ] = ACTIONS(1418),
    [anon_sym_LT_EQ] = ACTIONS(1418),
    [anon_sym__] = ACTIONS(1420),
    [anon_sym_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1418),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(1418),
    [anon_sym_COLON_COLON] = ACTIONS(1418),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_as] = ACTIONS(1420),
    [anon_sym_const] = ACTIONS(1420),
    [anon_sym_default] = ACTIONS(1420),
    [anon_sym_union] = ACTIONS(1420),
    [anon_sym_ref] = ACTIONS(1420),
    [sym_mutable_specifier] = ACTIONS(1420),
    [sym_integer_literal] = ACTIONS(1418),
    [aux_sym_string_literal_token1] = ACTIONS(1418),
    [sym_char_literal] = ACTIONS(1418),
    [anon_sym_true] = ACTIONS(1420),
    [anon_sym_false] = ACTIONS(1420),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1420),
    [sym_super] = ACTIONS(1420),
    [sym_crate] = ACTIONS(1420),
    [sym_metavariable] = ACTIONS(1418),
    [sym__raw_string_literal_start] = ACTIONS(1418),
    [sym_float_literal] = ACTIONS(1418),
  },
  [468] = {
    [sym_line_comment] = STATE(468),
    [sym_block_comment] = STATE(468),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1432),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_QMARK] = ACTIONS(1430),
    [anon_sym_u8] = ACTIONS(1432),
    [anon_sym_i8] = ACTIONS(1432),
    [anon_sym_u16] = ACTIONS(1432),
    [anon_sym_i16] = ACTIONS(1432),
    [anon_sym_u32] = ACTIONS(1432),
    [anon_sym_i32] = ACTIONS(1432),
    [anon_sym_u64] = ACTIONS(1432),
    [anon_sym_i64] = ACTIONS(1432),
    [anon_sym_u128] = ACTIONS(1432),
    [anon_sym_i128] = ACTIONS(1432),
    [anon_sym_isize] = ACTIONS(1432),
    [anon_sym_usize] = ACTIONS(1432),
    [anon_sym_f32] = ACTIONS(1432),
    [anon_sym_f64] = ACTIONS(1432),
    [anon_sym_bool] = ACTIONS(1432),
    [anon_sym_str] = ACTIONS(1432),
    [anon_sym_char] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1432),
    [anon_sym_PERCENT] = ACTIONS(1432),
    [anon_sym_CARET] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_PIPE] = ACTIONS(1432),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT_LT] = ACTIONS(1432),
    [anon_sym_GT_GT] = ACTIONS(1432),
    [anon_sym_PLUS_EQ] = ACTIONS(1430),
    [anon_sym_DASH_EQ] = ACTIONS(1430),
    [anon_sym_STAR_EQ] = ACTIONS(1430),
    [anon_sym_SLASH_EQ] = ACTIONS(1430),
    [anon_sym_PERCENT_EQ] = ACTIONS(1430),
    [anon_sym_CARET_EQ] = ACTIONS(1430),
    [anon_sym_AMP_EQ] = ACTIONS(1430),
    [anon_sym_PIPE_EQ] = ACTIONS(1430),
    [anon_sym_LT_LT_EQ] = ACTIONS(1430),
    [anon_sym_GT_GT_EQ] = ACTIONS(1430),
    [anon_sym_EQ] = ACTIONS(1432),
    [anon_sym_EQ_EQ] = ACTIONS(1430),
    [anon_sym_BANG_EQ] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_GT_EQ] = ACTIONS(1430),
    [anon_sym_LT_EQ] = ACTIONS(1430),
    [anon_sym__] = ACTIONS(1432),
    [anon_sym_DOT] = ACTIONS(1432),
    [anon_sym_DOT_DOT] = ACTIONS(1432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1430),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1430),
    [anon_sym_COMMA] = ACTIONS(1430),
    [anon_sym_COLON_COLON] = ACTIONS(1430),
    [anon_sym_POUND] = ACTIONS(1430),
    [anon_sym_as] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_default] = ACTIONS(1432),
    [anon_sym_union] = ACTIONS(1432),
    [anon_sym_ref] = ACTIONS(1432),
    [sym_mutable_specifier] = ACTIONS(1432),
    [sym_integer_literal] = ACTIONS(1430),
    [aux_sym_string_literal_token1] = ACTIONS(1430),
    [sym_char_literal] = ACTIONS(1430),
    [anon_sym_true] = ACTIONS(1432),
    [anon_sym_false] = ACTIONS(1432),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1432),
    [sym_super] = ACTIONS(1432),
    [sym_crate] = ACTIONS(1432),
    [sym_metavariable] = ACTIONS(1430),
    [sym__raw_string_literal_start] = ACTIONS(1430),
    [sym_float_literal] = ACTIONS(1430),
  },
  [469] = {
    [sym_line_comment] = STATE(469),
    [sym_block_comment] = STATE(469),
    [sym_identifier] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1370),
    [anon_sym_u8] = ACTIONS(1372),
    [anon_sym_i8] = ACTIONS(1372),
    [anon_sym_u16] = ACTIONS(1372),
    [anon_sym_i16] = ACTIONS(1372),
    [anon_sym_u32] = ACTIONS(1372),
    [anon_sym_i32] = ACTIONS(1372),
    [anon_sym_u64] = ACTIONS(1372),
    [anon_sym_i64] = ACTIONS(1372),
    [anon_sym_u128] = ACTIONS(1372),
    [anon_sym_i128] = ACTIONS(1372),
    [anon_sym_isize] = ACTIONS(1372),
    [anon_sym_usize] = ACTIONS(1372),
    [anon_sym_f32] = ACTIONS(1372),
    [anon_sym_f64] = ACTIONS(1372),
    [anon_sym_bool] = ACTIONS(1372),
    [anon_sym_str] = ACTIONS(1372),
    [anon_sym_char] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1372),
    [anon_sym_PLUS_EQ] = ACTIONS(1370),
    [anon_sym_DASH_EQ] = ACTIONS(1370),
    [anon_sym_STAR_EQ] = ACTIONS(1370),
    [anon_sym_SLASH_EQ] = ACTIONS(1370),
    [anon_sym_PERCENT_EQ] = ACTIONS(1370),
    [anon_sym_CARET_EQ] = ACTIONS(1370),
    [anon_sym_AMP_EQ] = ACTIONS(1370),
    [anon_sym_PIPE_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_GT_EQ] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym__] = ACTIONS(1372),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_DOT_DOT] = ACTIONS(1372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1370),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1370),
    [anon_sym_COMMA] = ACTIONS(1370),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_POUND] = ACTIONS(1370),
    [anon_sym_as] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_ref] = ACTIONS(1372),
    [sym_mutable_specifier] = ACTIONS(1372),
    [sym_integer_literal] = ACTIONS(1370),
    [aux_sym_string_literal_token1] = ACTIONS(1370),
    [sym_char_literal] = ACTIONS(1370),
    [anon_sym_true] = ACTIONS(1372),
    [anon_sym_false] = ACTIONS(1372),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1372),
    [sym_super] = ACTIONS(1372),
    [sym_crate] = ACTIONS(1372),
    [sym_metavariable] = ACTIONS(1370),
    [sym__raw_string_literal_start] = ACTIONS(1370),
    [sym_float_literal] = ACTIONS(1370),
  },
  [470] = {
    [sym_line_comment] = STATE(470),
    [sym_block_comment] = STATE(470),
    [sym_identifier] = ACTIONS(1656),
    [anon_sym_LPAREN] = ACTIONS(1658),
    [anon_sym_LBRACK] = ACTIONS(1658),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_u8] = ACTIONS(1656),
    [anon_sym_i8] = ACTIONS(1656),
    [anon_sym_u16] = ACTIONS(1656),
    [anon_sym_i16] = ACTIONS(1656),
    [anon_sym_u32] = ACTIONS(1656),
    [anon_sym_i32] = ACTIONS(1656),
    [anon_sym_u64] = ACTIONS(1656),
    [anon_sym_i64] = ACTIONS(1656),
    [anon_sym_u128] = ACTIONS(1656),
    [anon_sym_i128] = ACTIONS(1656),
    [anon_sym_isize] = ACTIONS(1656),
    [anon_sym_usize] = ACTIONS(1656),
    [anon_sym_f32] = ACTIONS(1656),
    [anon_sym_f64] = ACTIONS(1656),
    [anon_sym_bool] = ACTIONS(1656),
    [anon_sym_str] = ACTIONS(1656),
    [anon_sym_char] = ACTIONS(1656),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_SLASH] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1406),
    [anon_sym_CARET] = ACTIONS(1406),
    [anon_sym_AMP] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(1406),
    [anon_sym_PLUS_EQ] = ACTIONS(1408),
    [anon_sym_DASH_EQ] = ACTIONS(1408),
    [anon_sym_STAR_EQ] = ACTIONS(1408),
    [anon_sym_SLASH_EQ] = ACTIONS(1408),
    [anon_sym_PERCENT_EQ] = ACTIONS(1408),
    [anon_sym_CARET_EQ] = ACTIONS(1408),
    [anon_sym_AMP_EQ] = ACTIONS(1408),
    [anon_sym_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_LT_LT_EQ] = ACTIONS(1408),
    [anon_sym_GT_GT_EQ] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1406),
    [anon_sym_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1406),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym__] = ACTIONS(1656),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_DOT_DOT] = ACTIONS(1656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1408),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1408),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_COLON_COLON] = ACTIONS(1658),
    [anon_sym_POUND] = ACTIONS(1658),
    [anon_sym_as] = ACTIONS(1406),
    [anon_sym_const] = ACTIONS(1656),
    [anon_sym_default] = ACTIONS(1656),
    [anon_sym_union] = ACTIONS(1656),
    [anon_sym_ref] = ACTIONS(1656),
    [sym_mutable_specifier] = ACTIONS(1656),
    [sym_integer_literal] = ACTIONS(1658),
    [aux_sym_string_literal_token1] = ACTIONS(1658),
    [sym_char_literal] = ACTIONS(1658),
    [anon_sym_true] = ACTIONS(1656),
    [anon_sym_false] = ACTIONS(1656),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1656),
    [sym_super] = ACTIONS(1656),
    [sym_crate] = ACTIONS(1656),
    [sym_metavariable] = ACTIONS(1658),
    [sym__raw_string_literal_start] = ACTIONS(1658),
    [sym_float_literal] = ACTIONS(1658),
  },
  [471] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3419),
    [sym_match_pattern] = STATE(3611),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(471),
    [sym_block_comment] = STATE(471),
    [aux_sym_match_block_repeat1] = STATE(476),
    [aux_sym_match_arm_repeat1] = STATE(756),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [472] = {
    [sym_line_comment] = STATE(472),
    [sym_block_comment] = STATE(472),
    [sym_identifier] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1362),
    [anon_sym_u8] = ACTIONS(1364),
    [anon_sym_i8] = ACTIONS(1364),
    [anon_sym_u16] = ACTIONS(1364),
    [anon_sym_i16] = ACTIONS(1364),
    [anon_sym_u32] = ACTIONS(1364),
    [anon_sym_i32] = ACTIONS(1364),
    [anon_sym_u64] = ACTIONS(1364),
    [anon_sym_i64] = ACTIONS(1364),
    [anon_sym_u128] = ACTIONS(1364),
    [anon_sym_i128] = ACTIONS(1364),
    [anon_sym_isize] = ACTIONS(1364),
    [anon_sym_usize] = ACTIONS(1364),
    [anon_sym_f32] = ACTIONS(1364),
    [anon_sym_f64] = ACTIONS(1364),
    [anon_sym_bool] = ACTIONS(1364),
    [anon_sym_str] = ACTIONS(1364),
    [anon_sym_char] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_PERCENT] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1362),
    [anon_sym_LT_LT] = ACTIONS(1364),
    [anon_sym_GT_GT] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1362),
    [anon_sym_DASH_EQ] = ACTIONS(1362),
    [anon_sym_STAR_EQ] = ACTIONS(1362),
    [anon_sym_SLASH_EQ] = ACTIONS(1362),
    [anon_sym_PERCENT_EQ] = ACTIONS(1362),
    [anon_sym_CARET_EQ] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1362),
    [anon_sym_PIPE_EQ] = ACTIONS(1362),
    [anon_sym_LT_LT_EQ] = ACTIONS(1362),
    [anon_sym_GT_GT_EQ] = ACTIONS(1362),
    [anon_sym_EQ] = ACTIONS(1364),
    [anon_sym_EQ_EQ] = ACTIONS(1362),
    [anon_sym_BANG_EQ] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1362),
    [anon_sym__] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_DOT_DOT] = ACTIONS(1364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1362),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1362),
    [anon_sym_COMMA] = ACTIONS(1362),
    [anon_sym_COLON_COLON] = ACTIONS(1362),
    [anon_sym_POUND] = ACTIONS(1362),
    [anon_sym_as] = ACTIONS(1364),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_default] = ACTIONS(1364),
    [anon_sym_union] = ACTIONS(1364),
    [anon_sym_ref] = ACTIONS(1364),
    [sym_mutable_specifier] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1362),
    [aux_sym_string_literal_token1] = ACTIONS(1362),
    [sym_char_literal] = ACTIONS(1362),
    [anon_sym_true] = ACTIONS(1364),
    [anon_sym_false] = ACTIONS(1364),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1364),
    [sym_super] = ACTIONS(1364),
    [sym_crate] = ACTIONS(1364),
    [sym_metavariable] = ACTIONS(1362),
    [sym__raw_string_literal_start] = ACTIONS(1362),
    [sym_float_literal] = ACTIONS(1362),
  },
  [473] = {
    [sym_line_comment] = STATE(473),
    [sym_block_comment] = STATE(473),
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_QMARK] = ACTIONS(1256),
    [anon_sym_u8] = ACTIONS(1258),
    [anon_sym_i8] = ACTIONS(1258),
    [anon_sym_u16] = ACTIONS(1258),
    [anon_sym_i16] = ACTIONS(1258),
    [anon_sym_u32] = ACTIONS(1258),
    [anon_sym_i32] = ACTIONS(1258),
    [anon_sym_u64] = ACTIONS(1258),
    [anon_sym_i64] = ACTIONS(1258),
    [anon_sym_u128] = ACTIONS(1258),
    [anon_sym_i128] = ACTIONS(1258),
    [anon_sym_isize] = ACTIONS(1258),
    [anon_sym_usize] = ACTIONS(1258),
    [anon_sym_f32] = ACTIONS(1258),
    [anon_sym_f64] = ACTIONS(1258),
    [anon_sym_bool] = ACTIONS(1258),
    [anon_sym_str] = ACTIONS(1258),
    [anon_sym_char] = ACTIONS(1258),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_CARET] = ACTIONS(1258),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_PIPE] = ACTIONS(1258),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_PIPE_PIPE] = ACTIONS(1256),
    [anon_sym_LT_LT] = ACTIONS(1258),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_PLUS_EQ] = ACTIONS(1256),
    [anon_sym_DASH_EQ] = ACTIONS(1256),
    [anon_sym_STAR_EQ] = ACTIONS(1256),
    [anon_sym_SLASH_EQ] = ACTIONS(1256),
    [anon_sym_PERCENT_EQ] = ACTIONS(1256),
    [anon_sym_CARET_EQ] = ACTIONS(1256),
    [anon_sym_AMP_EQ] = ACTIONS(1256),
    [anon_sym_PIPE_EQ] = ACTIONS(1256),
    [anon_sym_LT_LT_EQ] = ACTIONS(1256),
    [anon_sym_GT_GT_EQ] = ACTIONS(1256),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_EQ_EQ] = ACTIONS(1256),
    [anon_sym_BANG_EQ] = ACTIONS(1256),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1256),
    [anon_sym_LT_EQ] = ACTIONS(1256),
    [anon_sym__] = ACTIONS(1258),
    [anon_sym_DOT] = ACTIONS(1258),
    [anon_sym_DOT_DOT] = ACTIONS(1258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1256),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1256),
    [anon_sym_COMMA] = ACTIONS(1256),
    [anon_sym_COLON_COLON] = ACTIONS(1256),
    [anon_sym_POUND] = ACTIONS(1256),
    [anon_sym_as] = ACTIONS(1258),
    [anon_sym_const] = ACTIONS(1258),
    [anon_sym_default] = ACTIONS(1258),
    [anon_sym_union] = ACTIONS(1258),
    [anon_sym_ref] = ACTIONS(1258),
    [sym_mutable_specifier] = ACTIONS(1258),
    [sym_integer_literal] = ACTIONS(1256),
    [aux_sym_string_literal_token1] = ACTIONS(1256),
    [sym_char_literal] = ACTIONS(1256),
    [anon_sym_true] = ACTIONS(1258),
    [anon_sym_false] = ACTIONS(1258),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1258),
    [sym_super] = ACTIONS(1258),
    [sym_crate] = ACTIONS(1258),
    [sym_metavariable] = ACTIONS(1256),
    [sym__raw_string_literal_start] = ACTIONS(1256),
    [sym_float_literal] = ACTIONS(1256),
  },
  [474] = {
    [sym_line_comment] = STATE(474),
    [sym_block_comment] = STATE(474),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1426),
    [anon_sym_u8] = ACTIONS(1428),
    [anon_sym_i8] = ACTIONS(1428),
    [anon_sym_u16] = ACTIONS(1428),
    [anon_sym_i16] = ACTIONS(1428),
    [anon_sym_u32] = ACTIONS(1428),
    [anon_sym_i32] = ACTIONS(1428),
    [anon_sym_u64] = ACTIONS(1428),
    [anon_sym_i64] = ACTIONS(1428),
    [anon_sym_u128] = ACTIONS(1428),
    [anon_sym_i128] = ACTIONS(1428),
    [anon_sym_isize] = ACTIONS(1428),
    [anon_sym_usize] = ACTIONS(1428),
    [anon_sym_f32] = ACTIONS(1428),
    [anon_sym_f64] = ACTIONS(1428),
    [anon_sym_bool] = ACTIONS(1428),
    [anon_sym_str] = ACTIONS(1428),
    [anon_sym_char] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1426),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_LT_LT] = ACTIONS(1428),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_PLUS_EQ] = ACTIONS(1426),
    [anon_sym_DASH_EQ] = ACTIONS(1426),
    [anon_sym_STAR_EQ] = ACTIONS(1426),
    [anon_sym_SLASH_EQ] = ACTIONS(1426),
    [anon_sym_PERCENT_EQ] = ACTIONS(1426),
    [anon_sym_CARET_EQ] = ACTIONS(1426),
    [anon_sym_AMP_EQ] = ACTIONS(1426),
    [anon_sym_PIPE_EQ] = ACTIONS(1426),
    [anon_sym_LT_LT_EQ] = ACTIONS(1426),
    [anon_sym_GT_GT_EQ] = ACTIONS(1426),
    [anon_sym_EQ] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1426),
    [anon_sym_BANG_EQ] = ACTIONS(1426),
    [anon_sym_GT] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_GT_EQ] = ACTIONS(1426),
    [anon_sym_LT_EQ] = ACTIONS(1426),
    [anon_sym__] = ACTIONS(1428),
    [anon_sym_DOT] = ACTIONS(1428),
    [anon_sym_DOT_DOT] = ACTIONS(1428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1426),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1426),
    [anon_sym_COMMA] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(1426),
    [anon_sym_POUND] = ACTIONS(1426),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_default] = ACTIONS(1428),
    [anon_sym_union] = ACTIONS(1428),
    [anon_sym_ref] = ACTIONS(1428),
    [sym_mutable_specifier] = ACTIONS(1428),
    [sym_integer_literal] = ACTIONS(1426),
    [aux_sym_string_literal_token1] = ACTIONS(1426),
    [sym_char_literal] = ACTIONS(1426),
    [anon_sym_true] = ACTIONS(1428),
    [anon_sym_false] = ACTIONS(1428),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1428),
    [sym_super] = ACTIONS(1428),
    [sym_crate] = ACTIONS(1428),
    [sym_metavariable] = ACTIONS(1426),
    [sym__raw_string_literal_start] = ACTIONS(1426),
    [sym_float_literal] = ACTIONS(1426),
  },
  [475] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3401),
    [sym_match_pattern] = STATE(3611),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(475),
    [sym_block_comment] = STATE(475),
    [aux_sym_match_block_repeat1] = STATE(506),
    [aux_sym_match_arm_repeat1] = STATE(756),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [476] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3418),
    [sym_match_pattern] = STATE(3611),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(476),
    [sym_block_comment] = STATE(476),
    [aux_sym_match_block_repeat1] = STATE(506),
    [aux_sym_match_arm_repeat1] = STATE(756),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [477] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3454),
    [sym_match_pattern] = STATE(3611),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(477),
    [sym_block_comment] = STATE(477),
    [aux_sym_match_block_repeat1] = STATE(506),
    [aux_sym_match_arm_repeat1] = STATE(756),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [478] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3466),
    [sym_match_pattern] = STATE(3611),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(478),
    [sym_block_comment] = STATE(478),
    [aux_sym_match_block_repeat1] = STATE(506),
    [aux_sym_match_arm_repeat1] = STATE(756),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [479] = {
    [sym_line_comment] = STATE(479),
    [sym_block_comment] = STATE(479),
    [ts_builtin_sym_end] = ACTIONS(1662),
    [sym_identifier] = ACTIONS(1664),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_macro_rules_BANG] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_LBRACK] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_RBRACE] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_u8] = ACTIONS(1664),
    [anon_sym_i8] = ACTIONS(1664),
    [anon_sym_u16] = ACTIONS(1664),
    [anon_sym_i16] = ACTIONS(1664),
    [anon_sym_u32] = ACTIONS(1664),
    [anon_sym_i32] = ACTIONS(1664),
    [anon_sym_u64] = ACTIONS(1664),
    [anon_sym_i64] = ACTIONS(1664),
    [anon_sym_u128] = ACTIONS(1664),
    [anon_sym_i128] = ACTIONS(1664),
    [anon_sym_isize] = ACTIONS(1664),
    [anon_sym_usize] = ACTIONS(1664),
    [anon_sym_f32] = ACTIONS(1664),
    [anon_sym_f64] = ACTIONS(1664),
    [anon_sym_bool] = ACTIONS(1664),
    [anon_sym_str] = ACTIONS(1664),
    [anon_sym_char] = ACTIONS(1664),
    [anon_sym_DASH] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_DOT_DOT] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1662),
    [anon_sym_POUND] = ACTIONS(1662),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_break] = ACTIONS(1664),
    [anon_sym_const] = ACTIONS(1664),
    [anon_sym_continue] = ACTIONS(1664),
    [anon_sym_default] = ACTIONS(1664),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_fn] = ACTIONS(1664),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1664),
    [anon_sym_impl] = ACTIONS(1664),
    [anon_sym_let] = ACTIONS(1664),
    [anon_sym_loop] = ACTIONS(1664),
    [anon_sym_match] = ACTIONS(1664),
    [anon_sym_mod] = ACTIONS(1664),
    [anon_sym_pub] = ACTIONS(1664),
    [anon_sym_return] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_struct] = ACTIONS(1664),
    [anon_sym_trait] = ACTIONS(1664),
    [anon_sym_type] = ACTIONS(1664),
    [anon_sym_union] = ACTIONS(1664),
    [anon_sym_unsafe] = ACTIONS(1664),
    [anon_sym_use] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1664),
    [anon_sym_extern] = ACTIONS(1664),
    [anon_sym_yield] = ACTIONS(1664),
    [anon_sym_move] = ACTIONS(1664),
    [anon_sym_try] = ACTIONS(1664),
    [sym_integer_literal] = ACTIONS(1662),
    [aux_sym_string_literal_token1] = ACTIONS(1662),
    [sym_char_literal] = ACTIONS(1662),
    [anon_sym_true] = ACTIONS(1664),
    [anon_sym_false] = ACTIONS(1664),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1664),
    [sym_super] = ACTIONS(1664),
    [sym_crate] = ACTIONS(1664),
    [sym_metavariable] = ACTIONS(1662),
    [sym__raw_string_literal_start] = ACTIONS(1662),
    [sym_float_literal] = ACTIONS(1662),
  },
  [480] = {
    [sym_line_comment] = STATE(480),
    [sym_block_comment] = STATE(480),
    [ts_builtin_sym_end] = ACTIONS(1666),
    [sym_identifier] = ACTIONS(1668),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_macro_rules_BANG] = ACTIONS(1666),
    [anon_sym_LPAREN] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_STAR] = ACTIONS(1666),
    [anon_sym_u8] = ACTIONS(1668),
    [anon_sym_i8] = ACTIONS(1668),
    [anon_sym_u16] = ACTIONS(1668),
    [anon_sym_i16] = ACTIONS(1668),
    [anon_sym_u32] = ACTIONS(1668),
    [anon_sym_i32] = ACTIONS(1668),
    [anon_sym_u64] = ACTIONS(1668),
    [anon_sym_i64] = ACTIONS(1668),
    [anon_sym_u128] = ACTIONS(1668),
    [anon_sym_i128] = ACTIONS(1668),
    [anon_sym_isize] = ACTIONS(1668),
    [anon_sym_usize] = ACTIONS(1668),
    [anon_sym_f32] = ACTIONS(1668),
    [anon_sym_f64] = ACTIONS(1668),
    [anon_sym_bool] = ACTIONS(1668),
    [anon_sym_str] = ACTIONS(1668),
    [anon_sym_char] = ACTIONS(1668),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_DOT_DOT] = ACTIONS(1666),
    [anon_sym_COLON_COLON] = ACTIONS(1666),
    [anon_sym_POUND] = ACTIONS(1666),
    [anon_sym_SQUOTE] = ACTIONS(1668),
    [anon_sym_async] = ACTIONS(1668),
    [anon_sym_break] = ACTIONS(1668),
    [anon_sym_const] = ACTIONS(1668),
    [anon_sym_continue] = ACTIONS(1668),
    [anon_sym_default] = ACTIONS(1668),
    [anon_sym_enum] = ACTIONS(1668),
    [anon_sym_fn] = ACTIONS(1668),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_if] = ACTIONS(1668),
    [anon_sym_impl] = ACTIONS(1668),
    [anon_sym_let] = ACTIONS(1668),
    [anon_sym_loop] = ACTIONS(1668),
    [anon_sym_match] = ACTIONS(1668),
    [anon_sym_mod] = ACTIONS(1668),
    [anon_sym_pub] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1668),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_struct] = ACTIONS(1668),
    [anon_sym_trait] = ACTIONS(1668),
    [anon_sym_type] = ACTIONS(1668),
    [anon_sym_union] = ACTIONS(1668),
    [anon_sym_unsafe] = ACTIONS(1668),
    [anon_sym_use] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1668),
    [anon_sym_extern] = ACTIONS(1668),
    [anon_sym_yield] = ACTIONS(1668),
    [anon_sym_move] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1668),
    [sym_integer_literal] = ACTIONS(1666),
    [aux_sym_string_literal_token1] = ACTIONS(1666),
    [sym_char_literal] = ACTIONS(1666),
    [anon_sym_true] = ACTIONS(1668),
    [anon_sym_false] = ACTIONS(1668),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1668),
    [sym_super] = ACTIONS(1668),
    [sym_crate] = ACTIONS(1668),
    [sym_metavariable] = ACTIONS(1666),
    [sym__raw_string_literal_start] = ACTIONS(1666),
    [sym_float_literal] = ACTIONS(1666),
  },
  [481] = {
    [sym_line_comment] = STATE(481),
    [sym_block_comment] = STATE(481),
    [ts_builtin_sym_end] = ACTIONS(1670),
    [sym_identifier] = ACTIONS(1672),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym_macro_rules_BANG] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_u8] = ACTIONS(1672),
    [anon_sym_i8] = ACTIONS(1672),
    [anon_sym_u16] = ACTIONS(1672),
    [anon_sym_i16] = ACTIONS(1672),
    [anon_sym_u32] = ACTIONS(1672),
    [anon_sym_i32] = ACTIONS(1672),
    [anon_sym_u64] = ACTIONS(1672),
    [anon_sym_i64] = ACTIONS(1672),
    [anon_sym_u128] = ACTIONS(1672),
    [anon_sym_i128] = ACTIONS(1672),
    [anon_sym_isize] = ACTIONS(1672),
    [anon_sym_usize] = ACTIONS(1672),
    [anon_sym_f32] = ACTIONS(1672),
    [anon_sym_f64] = ACTIONS(1672),
    [anon_sym_bool] = ACTIONS(1672),
    [anon_sym_str] = ACTIONS(1672),
    [anon_sym_char] = ACTIONS(1672),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1670),
    [anon_sym_PIPE] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(1670),
    [anon_sym_DOT_DOT] = ACTIONS(1670),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_POUND] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [anon_sym_async] = ACTIONS(1672),
    [anon_sym_break] = ACTIONS(1672),
    [anon_sym_const] = ACTIONS(1672),
    [anon_sym_continue] = ACTIONS(1672),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_enum] = ACTIONS(1672),
    [anon_sym_fn] = ACTIONS(1672),
    [anon_sym_for] = ACTIONS(1672),
    [anon_sym_if] = ACTIONS(1672),
    [anon_sym_impl] = ACTIONS(1672),
    [anon_sym_let] = ACTIONS(1672),
    [anon_sym_loop] = ACTIONS(1672),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_mod] = ACTIONS(1672),
    [anon_sym_pub] = ACTIONS(1672),
    [anon_sym_return] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1672),
    [anon_sym_struct] = ACTIONS(1672),
    [anon_sym_trait] = ACTIONS(1672),
    [anon_sym_type] = ACTIONS(1672),
    [anon_sym_union] = ACTIONS(1672),
    [anon_sym_unsafe] = ACTIONS(1672),
    [anon_sym_use] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1672),
    [anon_sym_extern] = ACTIONS(1672),
    [anon_sym_yield] = ACTIONS(1672),
    [anon_sym_move] = ACTIONS(1672),
    [anon_sym_try] = ACTIONS(1672),
    [sym_integer_literal] = ACTIONS(1670),
    [aux_sym_string_literal_token1] = ACTIONS(1670),
    [sym_char_literal] = ACTIONS(1670),
    [anon_sym_true] = ACTIONS(1672),
    [anon_sym_false] = ACTIONS(1672),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1672),
    [sym_super] = ACTIONS(1672),
    [sym_crate] = ACTIONS(1672),
    [sym_metavariable] = ACTIONS(1670),
    [sym__raw_string_literal_start] = ACTIONS(1670),
    [sym_float_literal] = ACTIONS(1670),
  },
  [482] = {
    [sym_line_comment] = STATE(482),
    [sym_block_comment] = STATE(482),
    [ts_builtin_sym_end] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1676),
    [anon_sym_SEMI] = ACTIONS(1674),
    [anon_sym_macro_rules_BANG] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1674),
    [anon_sym_LBRACK] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1674),
    [anon_sym_RBRACE] = ACTIONS(1674),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_u8] = ACTIONS(1676),
    [anon_sym_i8] = ACTIONS(1676),
    [anon_sym_u16] = ACTIONS(1676),
    [anon_sym_i16] = ACTIONS(1676),
    [anon_sym_u32] = ACTIONS(1676),
    [anon_sym_i32] = ACTIONS(1676),
    [anon_sym_u64] = ACTIONS(1676),
    [anon_sym_i64] = ACTIONS(1676),
    [anon_sym_u128] = ACTIONS(1676),
    [anon_sym_i128] = ACTIONS(1676),
    [anon_sym_isize] = ACTIONS(1676),
    [anon_sym_usize] = ACTIONS(1676),
    [anon_sym_f32] = ACTIONS(1676),
    [anon_sym_f64] = ACTIONS(1676),
    [anon_sym_bool] = ACTIONS(1676),
    [anon_sym_str] = ACTIONS(1676),
    [anon_sym_char] = ACTIONS(1676),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_PIPE] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1674),
    [anon_sym_DOT_DOT] = ACTIONS(1674),
    [anon_sym_COLON_COLON] = ACTIONS(1674),
    [anon_sym_POUND] = ACTIONS(1674),
    [anon_sym_SQUOTE] = ACTIONS(1676),
    [anon_sym_async] = ACTIONS(1676),
    [anon_sym_break] = ACTIONS(1676),
    [anon_sym_const] = ACTIONS(1676),
    [anon_sym_continue] = ACTIONS(1676),
    [anon_sym_default] = ACTIONS(1676),
    [anon_sym_enum] = ACTIONS(1676),
    [anon_sym_fn] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1676),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_impl] = ACTIONS(1676),
    [anon_sym_let] = ACTIONS(1676),
    [anon_sym_loop] = ACTIONS(1676),
    [anon_sym_match] = ACTIONS(1676),
    [anon_sym_mod] = ACTIONS(1676),
    [anon_sym_pub] = ACTIONS(1676),
    [anon_sym_return] = ACTIONS(1676),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_struct] = ACTIONS(1676),
    [anon_sym_trait] = ACTIONS(1676),
    [anon_sym_type] = ACTIONS(1676),
    [anon_sym_union] = ACTIONS(1676),
    [anon_sym_unsafe] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1676),
    [anon_sym_while] = ACTIONS(1676),
    [anon_sym_extern] = ACTIONS(1676),
    [anon_sym_yield] = ACTIONS(1676),
    [anon_sym_move] = ACTIONS(1676),
    [anon_sym_try] = ACTIONS(1676),
    [sym_integer_literal] = ACTIONS(1674),
    [aux_sym_string_literal_token1] = ACTIONS(1674),
    [sym_char_literal] = ACTIONS(1674),
    [anon_sym_true] = ACTIONS(1676),
    [anon_sym_false] = ACTIONS(1676),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1676),
    [sym_super] = ACTIONS(1676),
    [sym_crate] = ACTIONS(1676),
    [sym_metavariable] = ACTIONS(1674),
    [sym__raw_string_literal_start] = ACTIONS(1674),
    [sym_float_literal] = ACTIONS(1674),
  },
  [483] = {
    [sym_line_comment] = STATE(483),
    [sym_block_comment] = STATE(483),
    [ts_builtin_sym_end] = ACTIONS(1678),
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_SEMI] = ACTIONS(1678),
    [anon_sym_macro_rules_BANG] = ACTIONS(1678),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_LBRACK] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_RBRACE] = ACTIONS(1678),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_u8] = ACTIONS(1680),
    [anon_sym_i8] = ACTIONS(1680),
    [anon_sym_u16] = ACTIONS(1680),
    [anon_sym_i16] = ACTIONS(1680),
    [anon_sym_u32] = ACTIONS(1680),
    [anon_sym_i32] = ACTIONS(1680),
    [anon_sym_u64] = ACTIONS(1680),
    [anon_sym_i64] = ACTIONS(1680),
    [anon_sym_u128] = ACTIONS(1680),
    [anon_sym_i128] = ACTIONS(1680),
    [anon_sym_isize] = ACTIONS(1680),
    [anon_sym_usize] = ACTIONS(1680),
    [anon_sym_f32] = ACTIONS(1680),
    [anon_sym_f64] = ACTIONS(1680),
    [anon_sym_bool] = ACTIONS(1680),
    [anon_sym_str] = ACTIONS(1680),
    [anon_sym_char] = ACTIONS(1680),
    [anon_sym_DASH] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_PIPE] = ACTIONS(1678),
    [anon_sym_LT] = ACTIONS(1678),
    [anon_sym_DOT_DOT] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1678),
    [anon_sym_POUND] = ACTIONS(1678),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [anon_sym_async] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1680),
    [anon_sym_const] = ACTIONS(1680),
    [anon_sym_continue] = ACTIONS(1680),
    [anon_sym_default] = ACTIONS(1680),
    [anon_sym_enum] = ACTIONS(1680),
    [anon_sym_fn] = ACTIONS(1680),
    [anon_sym_for] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_impl] = ACTIONS(1680),
    [anon_sym_let] = ACTIONS(1680),
    [anon_sym_loop] = ACTIONS(1680),
    [anon_sym_match] = ACTIONS(1680),
    [anon_sym_mod] = ACTIONS(1680),
    [anon_sym_pub] = ACTIONS(1680),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_struct] = ACTIONS(1680),
    [anon_sym_trait] = ACTIONS(1680),
    [anon_sym_type] = ACTIONS(1680),
    [anon_sym_union] = ACTIONS(1680),
    [anon_sym_unsafe] = ACTIONS(1680),
    [anon_sym_use] = ACTIONS(1680),
    [anon_sym_while] = ACTIONS(1680),
    [anon_sym_extern] = ACTIONS(1680),
    [anon_sym_yield] = ACTIONS(1680),
    [anon_sym_move] = ACTIONS(1680),
    [anon_sym_try] = ACTIONS(1680),
    [sym_integer_literal] = ACTIONS(1678),
    [aux_sym_string_literal_token1] = ACTIONS(1678),
    [sym_char_literal] = ACTIONS(1678),
    [anon_sym_true] = ACTIONS(1680),
    [anon_sym_false] = ACTIONS(1680),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1680),
    [sym_super] = ACTIONS(1680),
    [sym_crate] = ACTIONS(1680),
    [sym_metavariable] = ACTIONS(1678),
    [sym__raw_string_literal_start] = ACTIONS(1678),
    [sym_float_literal] = ACTIONS(1678),
  },
  [484] = {
    [sym_line_comment] = STATE(484),
    [sym_block_comment] = STATE(484),
    [ts_builtin_sym_end] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_macro_rules_BANG] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_u8] = ACTIONS(1684),
    [anon_sym_i8] = ACTIONS(1684),
    [anon_sym_u16] = ACTIONS(1684),
    [anon_sym_i16] = ACTIONS(1684),
    [anon_sym_u32] = ACTIONS(1684),
    [anon_sym_i32] = ACTIONS(1684),
    [anon_sym_u64] = ACTIONS(1684),
    [anon_sym_i64] = ACTIONS(1684),
    [anon_sym_u128] = ACTIONS(1684),
    [anon_sym_i128] = ACTIONS(1684),
    [anon_sym_isize] = ACTIONS(1684),
    [anon_sym_usize] = ACTIONS(1684),
    [anon_sym_f32] = ACTIONS(1684),
    [anon_sym_f64] = ACTIONS(1684),
    [anon_sym_bool] = ACTIONS(1684),
    [anon_sym_str] = ACTIONS(1684),
    [anon_sym_char] = ACTIONS(1684),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_DOT_DOT] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1682),
    [anon_sym_POUND] = ACTIONS(1682),
    [anon_sym_SQUOTE] = ACTIONS(1684),
    [anon_sym_async] = ACTIONS(1684),
    [anon_sym_break] = ACTIONS(1684),
    [anon_sym_const] = ACTIONS(1684),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_default] = ACTIONS(1684),
    [anon_sym_enum] = ACTIONS(1684),
    [anon_sym_fn] = ACTIONS(1684),
    [anon_sym_for] = ACTIONS(1684),
    [anon_sym_if] = ACTIONS(1684),
    [anon_sym_impl] = ACTIONS(1684),
    [anon_sym_let] = ACTIONS(1684),
    [anon_sym_loop] = ACTIONS(1684),
    [anon_sym_match] = ACTIONS(1684),
    [anon_sym_mod] = ACTIONS(1684),
    [anon_sym_pub] = ACTIONS(1684),
    [anon_sym_return] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1684),
    [anon_sym_struct] = ACTIONS(1684),
    [anon_sym_trait] = ACTIONS(1684),
    [anon_sym_type] = ACTIONS(1684),
    [anon_sym_union] = ACTIONS(1684),
    [anon_sym_unsafe] = ACTIONS(1684),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_while] = ACTIONS(1684),
    [anon_sym_extern] = ACTIONS(1684),
    [anon_sym_yield] = ACTIONS(1684),
    [anon_sym_move] = ACTIONS(1684),
    [anon_sym_try] = ACTIONS(1684),
    [sym_integer_literal] = ACTIONS(1682),
    [aux_sym_string_literal_token1] = ACTIONS(1682),
    [sym_char_literal] = ACTIONS(1682),
    [anon_sym_true] = ACTIONS(1684),
    [anon_sym_false] = ACTIONS(1684),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1684),
    [sym_super] = ACTIONS(1684),
    [sym_crate] = ACTIONS(1684),
    [sym_metavariable] = ACTIONS(1682),
    [sym__raw_string_literal_start] = ACTIONS(1682),
    [sym_float_literal] = ACTIONS(1682),
  },
  [485] = {
    [sym_line_comment] = STATE(485),
    [sym_block_comment] = STATE(485),
    [ts_builtin_sym_end] = ACTIONS(1686),
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_macro_rules_BANG] = ACTIONS(1686),
    [anon_sym_LPAREN] = ACTIONS(1686),
    [anon_sym_LBRACK] = ACTIONS(1686),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [anon_sym_STAR] = ACTIONS(1686),
    [anon_sym_u8] = ACTIONS(1688),
    [anon_sym_i8] = ACTIONS(1688),
    [anon_sym_u16] = ACTIONS(1688),
    [anon_sym_i16] = ACTIONS(1688),
    [anon_sym_u32] = ACTIONS(1688),
    [anon_sym_i32] = ACTIONS(1688),
    [anon_sym_u64] = ACTIONS(1688),
    [anon_sym_i64] = ACTIONS(1688),
    [anon_sym_u128] = ACTIONS(1688),
    [anon_sym_i128] = ACTIONS(1688),
    [anon_sym_isize] = ACTIONS(1688),
    [anon_sym_usize] = ACTIONS(1688),
    [anon_sym_f32] = ACTIONS(1688),
    [anon_sym_f64] = ACTIONS(1688),
    [anon_sym_bool] = ACTIONS(1688),
    [anon_sym_str] = ACTIONS(1688),
    [anon_sym_char] = ACTIONS(1688),
    [anon_sym_DASH] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(1686),
    [anon_sym_DOT_DOT] = ACTIONS(1686),
    [anon_sym_COLON_COLON] = ACTIONS(1686),
    [anon_sym_POUND] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1688),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1688),
    [anon_sym_const] = ACTIONS(1688),
    [anon_sym_continue] = ACTIONS(1688),
    [anon_sym_default] = ACTIONS(1688),
    [anon_sym_enum] = ACTIONS(1688),
    [anon_sym_fn] = ACTIONS(1688),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1688),
    [anon_sym_impl] = ACTIONS(1688),
    [anon_sym_let] = ACTIONS(1688),
    [anon_sym_loop] = ACTIONS(1688),
    [anon_sym_match] = ACTIONS(1688),
    [anon_sym_mod] = ACTIONS(1688),
    [anon_sym_pub] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_struct] = ACTIONS(1688),
    [anon_sym_trait] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_union] = ACTIONS(1688),
    [anon_sym_unsafe] = ACTIONS(1688),
    [anon_sym_use] = ACTIONS(1688),
    [anon_sym_while] = ACTIONS(1688),
    [anon_sym_extern] = ACTIONS(1688),
    [anon_sym_yield] = ACTIONS(1688),
    [anon_sym_move] = ACTIONS(1688),
    [anon_sym_try] = ACTIONS(1688),
    [sym_integer_literal] = ACTIONS(1686),
    [aux_sym_string_literal_token1] = ACTIONS(1686),
    [sym_char_literal] = ACTIONS(1686),
    [anon_sym_true] = ACTIONS(1688),
    [anon_sym_false] = ACTIONS(1688),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1688),
    [sym_super] = ACTIONS(1688),
    [sym_crate] = ACTIONS(1688),
    [sym_metavariable] = ACTIONS(1686),
    [sym__raw_string_literal_start] = ACTIONS(1686),
    [sym_float_literal] = ACTIONS(1686),
  },
  [486] = {
    [sym_line_comment] = STATE(486),
    [sym_block_comment] = STATE(486),
    [ts_builtin_sym_end] = ACTIONS(1690),
    [sym_identifier] = ACTIONS(1692),
    [anon_sym_SEMI] = ACTIONS(1690),
    [anon_sym_macro_rules_BANG] = ACTIONS(1690),
    [anon_sym_LPAREN] = ACTIONS(1690),
    [anon_sym_LBRACK] = ACTIONS(1690),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_u8] = ACTIONS(1692),
    [anon_sym_i8] = ACTIONS(1692),
    [anon_sym_u16] = ACTIONS(1692),
    [anon_sym_i16] = ACTIONS(1692),
    [anon_sym_u32] = ACTIONS(1692),
    [anon_sym_i32] = ACTIONS(1692),
    [anon_sym_u64] = ACTIONS(1692),
    [anon_sym_i64] = ACTIONS(1692),
    [anon_sym_u128] = ACTIONS(1692),
    [anon_sym_i128] = ACTIONS(1692),
    [anon_sym_isize] = ACTIONS(1692),
    [anon_sym_usize] = ACTIONS(1692),
    [anon_sym_f32] = ACTIONS(1692),
    [anon_sym_f64] = ACTIONS(1692),
    [anon_sym_bool] = ACTIONS(1692),
    [anon_sym_str] = ACTIONS(1692),
    [anon_sym_char] = ACTIONS(1692),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_BANG] = ACTIONS(1690),
    [anon_sym_AMP] = ACTIONS(1690),
    [anon_sym_PIPE] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(1690),
    [anon_sym_DOT_DOT] = ACTIONS(1690),
    [anon_sym_COLON_COLON] = ACTIONS(1690),
    [anon_sym_POUND] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1692),
    [anon_sym_async] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_fn] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_impl] = ACTIONS(1692),
    [anon_sym_let] = ACTIONS(1692),
    [anon_sym_loop] = ACTIONS(1692),
    [anon_sym_match] = ACTIONS(1692),
    [anon_sym_mod] = ACTIONS(1692),
    [anon_sym_pub] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_struct] = ACTIONS(1692),
    [anon_sym_trait] = ACTIONS(1692),
    [anon_sym_type] = ACTIONS(1692),
    [anon_sym_union] = ACTIONS(1692),
    [anon_sym_unsafe] = ACTIONS(1692),
    [anon_sym_use] = ACTIONS(1692),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_extern] = ACTIONS(1692),
    [anon_sym_yield] = ACTIONS(1692),
    [anon_sym_move] = ACTIONS(1692),
    [anon_sym_try] = ACTIONS(1692),
    [sym_integer_literal] = ACTIONS(1690),
    [aux_sym_string_literal_token1] = ACTIONS(1690),
    [sym_char_literal] = ACTIONS(1690),
    [anon_sym_true] = ACTIONS(1692),
    [anon_sym_false] = ACTIONS(1692),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1692),
    [sym_super] = ACTIONS(1692),
    [sym_crate] = ACTIONS(1692),
    [sym_metavariable] = ACTIONS(1690),
    [sym__raw_string_literal_start] = ACTIONS(1690),
    [sym_float_literal] = ACTIONS(1690),
  },
  [487] = {
    [sym_line_comment] = STATE(487),
    [sym_block_comment] = STATE(487),
    [ts_builtin_sym_end] = ACTIONS(1694),
    [sym_identifier] = ACTIONS(1696),
    [anon_sym_SEMI] = ACTIONS(1694),
    [anon_sym_macro_rules_BANG] = ACTIONS(1694),
    [anon_sym_LPAREN] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1694),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_RBRACE] = ACTIONS(1694),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_u8] = ACTIONS(1696),
    [anon_sym_i8] = ACTIONS(1696),
    [anon_sym_u16] = ACTIONS(1696),
    [anon_sym_i16] = ACTIONS(1696),
    [anon_sym_u32] = ACTIONS(1696),
    [anon_sym_i32] = ACTIONS(1696),
    [anon_sym_u64] = ACTIONS(1696),
    [anon_sym_i64] = ACTIONS(1696),
    [anon_sym_u128] = ACTIONS(1696),
    [anon_sym_i128] = ACTIONS(1696),
    [anon_sym_isize] = ACTIONS(1696),
    [anon_sym_usize] = ACTIONS(1696),
    [anon_sym_f32] = ACTIONS(1696),
    [anon_sym_f64] = ACTIONS(1696),
    [anon_sym_bool] = ACTIONS(1696),
    [anon_sym_str] = ACTIONS(1696),
    [anon_sym_char] = ACTIONS(1696),
    [anon_sym_DASH] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(1694),
    [anon_sym_DOT_DOT] = ACTIONS(1694),
    [anon_sym_COLON_COLON] = ACTIONS(1694),
    [anon_sym_POUND] = ACTIONS(1694),
    [anon_sym_SQUOTE] = ACTIONS(1696),
    [anon_sym_async] = ACTIONS(1696),
    [anon_sym_break] = ACTIONS(1696),
    [anon_sym_const] = ACTIONS(1696),
    [anon_sym_continue] = ACTIONS(1696),
    [anon_sym_default] = ACTIONS(1696),
    [anon_sym_enum] = ACTIONS(1696),
    [anon_sym_fn] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1696),
    [anon_sym_if] = ACTIONS(1696),
    [anon_sym_impl] = ACTIONS(1696),
    [anon_sym_let] = ACTIONS(1696),
    [anon_sym_loop] = ACTIONS(1696),
    [anon_sym_match] = ACTIONS(1696),
    [anon_sym_mod] = ACTIONS(1696),
    [anon_sym_pub] = ACTIONS(1696),
    [anon_sym_return] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_struct] = ACTIONS(1696),
    [anon_sym_trait] = ACTIONS(1696),
    [anon_sym_type] = ACTIONS(1696),
    [anon_sym_union] = ACTIONS(1696),
    [anon_sym_unsafe] = ACTIONS(1696),
    [anon_sym_use] = ACTIONS(1696),
    [anon_sym_while] = ACTIONS(1696),
    [anon_sym_extern] = ACTIONS(1696),
    [anon_sym_yield] = ACTIONS(1696),
    [anon_sym_move] = ACTIONS(1696),
    [anon_sym_try] = ACTIONS(1696),
    [sym_integer_literal] = ACTIONS(1694),
    [aux_sym_string_literal_token1] = ACTIONS(1694),
    [sym_char_literal] = ACTIONS(1694),
    [anon_sym_true] = ACTIONS(1696),
    [anon_sym_false] = ACTIONS(1696),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1696),
    [sym_super] = ACTIONS(1696),
    [sym_crate] = ACTIONS(1696),
    [sym_metavariable] = ACTIONS(1694),
    [sym__raw_string_literal_start] = ACTIONS(1694),
    [sym_float_literal] = ACTIONS(1694),
  },
  [488] = {
    [sym_line_comment] = STATE(488),
    [sym_block_comment] = STATE(488),
    [ts_builtin_sym_end] = ACTIONS(1698),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_macro_rules_BANG] = ACTIONS(1698),
    [anon_sym_LPAREN] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1698),
    [anon_sym_LBRACE] = ACTIONS(1698),
    [anon_sym_RBRACE] = ACTIONS(1698),
    [anon_sym_STAR] = ACTIONS(1698),
    [anon_sym_u8] = ACTIONS(1700),
    [anon_sym_i8] = ACTIONS(1700),
    [anon_sym_u16] = ACTIONS(1700),
    [anon_sym_i16] = ACTIONS(1700),
    [anon_sym_u32] = ACTIONS(1700),
    [anon_sym_i32] = ACTIONS(1700),
    [anon_sym_u64] = ACTIONS(1700),
    [anon_sym_i64] = ACTIONS(1700),
    [anon_sym_u128] = ACTIONS(1700),
    [anon_sym_i128] = ACTIONS(1700),
    [anon_sym_isize] = ACTIONS(1700),
    [anon_sym_usize] = ACTIONS(1700),
    [anon_sym_f32] = ACTIONS(1700),
    [anon_sym_f64] = ACTIONS(1700),
    [anon_sym_bool] = ACTIONS(1700),
    [anon_sym_str] = ACTIONS(1700),
    [anon_sym_char] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1698),
    [anon_sym_BANG] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
    [anon_sym_PIPE] = ACTIONS(1698),
    [anon_sym_LT] = ACTIONS(1698),
    [anon_sym_DOT_DOT] = ACTIONS(1698),
    [anon_sym_COLON_COLON] = ACTIONS(1698),
    [anon_sym_POUND] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1700),
    [anon_sym_break] = ACTIONS(1700),
    [anon_sym_const] = ACTIONS(1700),
    [anon_sym_continue] = ACTIONS(1700),
    [anon_sym_default] = ACTIONS(1700),
    [anon_sym_enum] = ACTIONS(1700),
    [anon_sym_fn] = ACTIONS(1700),
    [anon_sym_for] = ACTIONS(1700),
    [anon_sym_if] = ACTIONS(1700),
    [anon_sym_impl] = ACTIONS(1700),
    [anon_sym_let] = ACTIONS(1700),
    [anon_sym_loop] = ACTIONS(1700),
    [anon_sym_match] = ACTIONS(1700),
    [anon_sym_mod] = ACTIONS(1700),
    [anon_sym_pub] = ACTIONS(1700),
    [anon_sym_return] = ACTIONS(1700),
    [anon_sym_static] = ACTIONS(1700),
    [anon_sym_struct] = ACTIONS(1700),
    [anon_sym_trait] = ACTIONS(1700),
    [anon_sym_type] = ACTIONS(1700),
    [anon_sym_union] = ACTIONS(1700),
    [anon_sym_unsafe] = ACTIONS(1700),
    [anon_sym_use] = ACTIONS(1700),
    [anon_sym_while] = ACTIONS(1700),
    [anon_sym_extern] = ACTIONS(1700),
    [anon_sym_yield] = ACTIONS(1700),
    [anon_sym_move] = ACTIONS(1700),
    [anon_sym_try] = ACTIONS(1700),
    [sym_integer_literal] = ACTIONS(1698),
    [aux_sym_string_literal_token1] = ACTIONS(1698),
    [sym_char_literal] = ACTIONS(1698),
    [anon_sym_true] = ACTIONS(1700),
    [anon_sym_false] = ACTIONS(1700),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1700),
    [sym_super] = ACTIONS(1700),
    [sym_crate] = ACTIONS(1700),
    [sym_metavariable] = ACTIONS(1698),
    [sym__raw_string_literal_start] = ACTIONS(1698),
    [sym_float_literal] = ACTIONS(1698),
  },
  [489] = {
    [sym_line_comment] = STATE(489),
    [sym_block_comment] = STATE(489),
    [ts_builtin_sym_end] = ACTIONS(1702),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_SEMI] = ACTIONS(1702),
    [anon_sym_macro_rules_BANG] = ACTIONS(1702),
    [anon_sym_LPAREN] = ACTIONS(1702),
    [anon_sym_LBRACK] = ACTIONS(1702),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_RBRACE] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(1702),
    [anon_sym_u8] = ACTIONS(1704),
    [anon_sym_i8] = ACTIONS(1704),
    [anon_sym_u16] = ACTIONS(1704),
    [anon_sym_i16] = ACTIONS(1704),
    [anon_sym_u32] = ACTIONS(1704),
    [anon_sym_i32] = ACTIONS(1704),
    [anon_sym_u64] = ACTIONS(1704),
    [anon_sym_i64] = ACTIONS(1704),
    [anon_sym_u128] = ACTIONS(1704),
    [anon_sym_i128] = ACTIONS(1704),
    [anon_sym_isize] = ACTIONS(1704),
    [anon_sym_usize] = ACTIONS(1704),
    [anon_sym_f32] = ACTIONS(1704),
    [anon_sym_f64] = ACTIONS(1704),
    [anon_sym_bool] = ACTIONS(1704),
    [anon_sym_str] = ACTIONS(1704),
    [anon_sym_char] = ACTIONS(1704),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1702),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_LT] = ACTIONS(1702),
    [anon_sym_DOT_DOT] = ACTIONS(1702),
    [anon_sym_COLON_COLON] = ACTIONS(1702),
    [anon_sym_POUND] = ACTIONS(1702),
    [anon_sym_SQUOTE] = ACTIONS(1704),
    [anon_sym_async] = ACTIONS(1704),
    [anon_sym_break] = ACTIONS(1704),
    [anon_sym_const] = ACTIONS(1704),
    [anon_sym_continue] = ACTIONS(1704),
    [anon_sym_default] = ACTIONS(1704),
    [anon_sym_enum] = ACTIONS(1704),
    [anon_sym_fn] = ACTIONS(1704),
    [anon_sym_for] = ACTIONS(1704),
    [anon_sym_if] = ACTIONS(1704),
    [anon_sym_impl] = ACTIONS(1704),
    [anon_sym_let] = ACTIONS(1704),
    [anon_sym_loop] = ACTIONS(1704),
    [anon_sym_match] = ACTIONS(1704),
    [anon_sym_mod] = ACTIONS(1704),
    [anon_sym_pub] = ACTIONS(1704),
    [anon_sym_return] = ACTIONS(1704),
    [anon_sym_static] = ACTIONS(1704),
    [anon_sym_struct] = ACTIONS(1704),
    [anon_sym_trait] = ACTIONS(1704),
    [anon_sym_type] = ACTIONS(1704),
    [anon_sym_union] = ACTIONS(1704),
    [anon_sym_unsafe] = ACTIONS(1704),
    [anon_sym_use] = ACTIONS(1704),
    [anon_sym_while] = ACTIONS(1704),
    [anon_sym_extern] = ACTIONS(1704),
    [anon_sym_yield] = ACTIONS(1704),
    [anon_sym_move] = ACTIONS(1704),
    [anon_sym_try] = ACTIONS(1704),
    [sym_integer_literal] = ACTIONS(1702),
    [aux_sym_string_literal_token1] = ACTIONS(1702),
    [sym_char_literal] = ACTIONS(1702),
    [anon_sym_true] = ACTIONS(1704),
    [anon_sym_false] = ACTIONS(1704),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1704),
    [sym_super] = ACTIONS(1704),
    [sym_crate] = ACTIONS(1704),
    [sym_metavariable] = ACTIONS(1702),
    [sym__raw_string_literal_start] = ACTIONS(1702),
    [sym_float_literal] = ACTIONS(1702),
  },
  [490] = {
    [sym_line_comment] = STATE(490),
    [sym_block_comment] = STATE(490),
    [ts_builtin_sym_end] = ACTIONS(1706),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_SEMI] = ACTIONS(1706),
    [anon_sym_macro_rules_BANG] = ACTIONS(1706),
    [anon_sym_LPAREN] = ACTIONS(1706),
    [anon_sym_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(1706),
    [anon_sym_RBRACE] = ACTIONS(1706),
    [anon_sym_STAR] = ACTIONS(1706),
    [anon_sym_u8] = ACTIONS(1708),
    [anon_sym_i8] = ACTIONS(1708),
    [anon_sym_u16] = ACTIONS(1708),
    [anon_sym_i16] = ACTIONS(1708),
    [anon_sym_u32] = ACTIONS(1708),
    [anon_sym_i32] = ACTIONS(1708),
    [anon_sym_u64] = ACTIONS(1708),
    [anon_sym_i64] = ACTIONS(1708),
    [anon_sym_u128] = ACTIONS(1708),
    [anon_sym_i128] = ACTIONS(1708),
    [anon_sym_isize] = ACTIONS(1708),
    [anon_sym_usize] = ACTIONS(1708),
    [anon_sym_f32] = ACTIONS(1708),
    [anon_sym_f64] = ACTIONS(1708),
    [anon_sym_bool] = ACTIONS(1708),
    [anon_sym_str] = ACTIONS(1708),
    [anon_sym_char] = ACTIONS(1708),
    [anon_sym_DASH] = ACTIONS(1706),
    [anon_sym_BANG] = ACTIONS(1706),
    [anon_sym_AMP] = ACTIONS(1706),
    [anon_sym_PIPE] = ACTIONS(1706),
    [anon_sym_LT] = ACTIONS(1706),
    [anon_sym_DOT_DOT] = ACTIONS(1706),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_POUND] = ACTIONS(1706),
    [anon_sym_SQUOTE] = ACTIONS(1708),
    [anon_sym_async] = ACTIONS(1708),
    [anon_sym_break] = ACTIONS(1708),
    [anon_sym_const] = ACTIONS(1708),
    [anon_sym_continue] = ACTIONS(1708),
    [anon_sym_default] = ACTIONS(1708),
    [anon_sym_enum] = ACTIONS(1708),
    [anon_sym_fn] = ACTIONS(1708),
    [anon_sym_for] = ACTIONS(1708),
    [anon_sym_if] = ACTIONS(1708),
    [anon_sym_impl] = ACTIONS(1708),
    [anon_sym_let] = ACTIONS(1708),
    [anon_sym_loop] = ACTIONS(1708),
    [anon_sym_match] = ACTIONS(1708),
    [anon_sym_mod] = ACTIONS(1708),
    [anon_sym_pub] = ACTIONS(1708),
    [anon_sym_return] = ACTIONS(1708),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_struct] = ACTIONS(1708),
    [anon_sym_trait] = ACTIONS(1708),
    [anon_sym_type] = ACTIONS(1708),
    [anon_sym_union] = ACTIONS(1708),
    [anon_sym_unsafe] = ACTIONS(1708),
    [anon_sym_use] = ACTIONS(1708),
    [anon_sym_while] = ACTIONS(1708),
    [anon_sym_extern] = ACTIONS(1708),
    [anon_sym_yield] = ACTIONS(1708),
    [anon_sym_move] = ACTIONS(1708),
    [anon_sym_try] = ACTIONS(1708),
    [sym_integer_literal] = ACTIONS(1706),
    [aux_sym_string_literal_token1] = ACTIONS(1706),
    [sym_char_literal] = ACTIONS(1706),
    [anon_sym_true] = ACTIONS(1708),
    [anon_sym_false] = ACTIONS(1708),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1708),
    [sym_super] = ACTIONS(1708),
    [sym_crate] = ACTIONS(1708),
    [sym_metavariable] = ACTIONS(1706),
    [sym__raw_string_literal_start] = ACTIONS(1706),
    [sym_float_literal] = ACTIONS(1706),
  },
  [491] = {
    [sym_line_comment] = STATE(491),
    [sym_block_comment] = STATE(491),
    [ts_builtin_sym_end] = ACTIONS(1710),
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_macro_rules_BANG] = ACTIONS(1710),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_LBRACK] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1710),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_STAR] = ACTIONS(1710),
    [anon_sym_u8] = ACTIONS(1712),
    [anon_sym_i8] = ACTIONS(1712),
    [anon_sym_u16] = ACTIONS(1712),
    [anon_sym_i16] = ACTIONS(1712),
    [anon_sym_u32] = ACTIONS(1712),
    [anon_sym_i32] = ACTIONS(1712),
    [anon_sym_u64] = ACTIONS(1712),
    [anon_sym_i64] = ACTIONS(1712),
    [anon_sym_u128] = ACTIONS(1712),
    [anon_sym_i128] = ACTIONS(1712),
    [anon_sym_isize] = ACTIONS(1712),
    [anon_sym_usize] = ACTIONS(1712),
    [anon_sym_f32] = ACTIONS(1712),
    [anon_sym_f64] = ACTIONS(1712),
    [anon_sym_bool] = ACTIONS(1712),
    [anon_sym_str] = ACTIONS(1712),
    [anon_sym_char] = ACTIONS(1712),
    [anon_sym_DASH] = ACTIONS(1710),
    [anon_sym_BANG] = ACTIONS(1710),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_LT] = ACTIONS(1710),
    [anon_sym_DOT_DOT] = ACTIONS(1710),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_POUND] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1712),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_break] = ACTIONS(1712),
    [anon_sym_const] = ACTIONS(1712),
    [anon_sym_continue] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1712),
    [anon_sym_enum] = ACTIONS(1712),
    [anon_sym_fn] = ACTIONS(1712),
    [anon_sym_for] = ACTIONS(1712),
    [anon_sym_if] = ACTIONS(1712),
    [anon_sym_impl] = ACTIONS(1712),
    [anon_sym_let] = ACTIONS(1712),
    [anon_sym_loop] = ACTIONS(1712),
    [anon_sym_match] = ACTIONS(1712),
    [anon_sym_mod] = ACTIONS(1712),
    [anon_sym_pub] = ACTIONS(1712),
    [anon_sym_return] = ACTIONS(1712),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_struct] = ACTIONS(1712),
    [anon_sym_trait] = ACTIONS(1712),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_union] = ACTIONS(1712),
    [anon_sym_unsafe] = ACTIONS(1712),
    [anon_sym_use] = ACTIONS(1712),
    [anon_sym_while] = ACTIONS(1712),
    [anon_sym_extern] = ACTIONS(1712),
    [anon_sym_yield] = ACTIONS(1712),
    [anon_sym_move] = ACTIONS(1712),
    [anon_sym_try] = ACTIONS(1712),
    [sym_integer_literal] = ACTIONS(1710),
    [aux_sym_string_literal_token1] = ACTIONS(1710),
    [sym_char_literal] = ACTIONS(1710),
    [anon_sym_true] = ACTIONS(1712),
    [anon_sym_false] = ACTIONS(1712),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1712),
    [sym_super] = ACTIONS(1712),
    [sym_crate] = ACTIONS(1712),
    [sym_metavariable] = ACTIONS(1710),
    [sym__raw_string_literal_start] = ACTIONS(1710),
    [sym_float_literal] = ACTIONS(1710),
  },
  [492] = {
    [sym_line_comment] = STATE(492),
    [sym_block_comment] = STATE(492),
    [ts_builtin_sym_end] = ACTIONS(1714),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_SEMI] = ACTIONS(1714),
    [anon_sym_macro_rules_BANG] = ACTIONS(1714),
    [anon_sym_LPAREN] = ACTIONS(1714),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LBRACE] = ACTIONS(1714),
    [anon_sym_RBRACE] = ACTIONS(1714),
    [anon_sym_STAR] = ACTIONS(1714),
    [anon_sym_u8] = ACTIONS(1716),
    [anon_sym_i8] = ACTIONS(1716),
    [anon_sym_u16] = ACTIONS(1716),
    [anon_sym_i16] = ACTIONS(1716),
    [anon_sym_u32] = ACTIONS(1716),
    [anon_sym_i32] = ACTIONS(1716),
    [anon_sym_u64] = ACTIONS(1716),
    [anon_sym_i64] = ACTIONS(1716),
    [anon_sym_u128] = ACTIONS(1716),
    [anon_sym_i128] = ACTIONS(1716),
    [anon_sym_isize] = ACTIONS(1716),
    [anon_sym_usize] = ACTIONS(1716),
    [anon_sym_f32] = ACTIONS(1716),
    [anon_sym_f64] = ACTIONS(1716),
    [anon_sym_bool] = ACTIONS(1716),
    [anon_sym_str] = ACTIONS(1716),
    [anon_sym_char] = ACTIONS(1716),
    [anon_sym_DASH] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1714),
    [anon_sym_AMP] = ACTIONS(1714),
    [anon_sym_PIPE] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1714),
    [anon_sym_COLON_COLON] = ACTIONS(1714),
    [anon_sym_POUND] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1716),
    [anon_sym_async] = ACTIONS(1716),
    [anon_sym_break] = ACTIONS(1716),
    [anon_sym_const] = ACTIONS(1716),
    [anon_sym_continue] = ACTIONS(1716),
    [anon_sym_default] = ACTIONS(1716),
    [anon_sym_enum] = ACTIONS(1716),
    [anon_sym_fn] = ACTIONS(1716),
    [anon_sym_for] = ACTIONS(1716),
    [anon_sym_if] = ACTIONS(1716),
    [anon_sym_impl] = ACTIONS(1716),
    [anon_sym_let] = ACTIONS(1716),
    [anon_sym_loop] = ACTIONS(1716),
    [anon_sym_match] = ACTIONS(1716),
    [anon_sym_mod] = ACTIONS(1716),
    [anon_sym_pub] = ACTIONS(1716),
    [anon_sym_return] = ACTIONS(1716),
    [anon_sym_static] = ACTIONS(1716),
    [anon_sym_struct] = ACTIONS(1716),
    [anon_sym_trait] = ACTIONS(1716),
    [anon_sym_type] = ACTIONS(1716),
    [anon_sym_union] = ACTIONS(1716),
    [anon_sym_unsafe] = ACTIONS(1716),
    [anon_sym_use] = ACTIONS(1716),
    [anon_sym_while] = ACTIONS(1716),
    [anon_sym_extern] = ACTIONS(1716),
    [anon_sym_yield] = ACTIONS(1716),
    [anon_sym_move] = ACTIONS(1716),
    [anon_sym_try] = ACTIONS(1716),
    [sym_integer_literal] = ACTIONS(1714),
    [aux_sym_string_literal_token1] = ACTIONS(1714),
    [sym_char_literal] = ACTIONS(1714),
    [anon_sym_true] = ACTIONS(1716),
    [anon_sym_false] = ACTIONS(1716),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1716),
    [sym_super] = ACTIONS(1716),
    [sym_crate] = ACTIONS(1716),
    [sym_metavariable] = ACTIONS(1714),
    [sym__raw_string_literal_start] = ACTIONS(1714),
    [sym_float_literal] = ACTIONS(1714),
  },
  [493] = {
    [sym_line_comment] = STATE(493),
    [sym_block_comment] = STATE(493),
    [ts_builtin_sym_end] = ACTIONS(1718),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_SEMI] = ACTIONS(1718),
    [anon_sym_macro_rules_BANG] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(1718),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(1718),
    [anon_sym_STAR] = ACTIONS(1718),
    [anon_sym_u8] = ACTIONS(1720),
    [anon_sym_i8] = ACTIONS(1720),
    [anon_sym_u16] = ACTIONS(1720),
    [anon_sym_i16] = ACTIONS(1720),
    [anon_sym_u32] = ACTIONS(1720),
    [anon_sym_i32] = ACTIONS(1720),
    [anon_sym_u64] = ACTIONS(1720),
    [anon_sym_i64] = ACTIONS(1720),
    [anon_sym_u128] = ACTIONS(1720),
    [anon_sym_i128] = ACTIONS(1720),
    [anon_sym_isize] = ACTIONS(1720),
    [anon_sym_usize] = ACTIONS(1720),
    [anon_sym_f32] = ACTIONS(1720),
    [anon_sym_f64] = ACTIONS(1720),
    [anon_sym_bool] = ACTIONS(1720),
    [anon_sym_str] = ACTIONS(1720),
    [anon_sym_char] = ACTIONS(1720),
    [anon_sym_DASH] = ACTIONS(1718),
    [anon_sym_BANG] = ACTIONS(1718),
    [anon_sym_AMP] = ACTIONS(1718),
    [anon_sym_PIPE] = ACTIONS(1718),
    [anon_sym_LT] = ACTIONS(1718),
    [anon_sym_DOT_DOT] = ACTIONS(1718),
    [anon_sym_COLON_COLON] = ACTIONS(1718),
    [anon_sym_POUND] = ACTIONS(1718),
    [anon_sym_SQUOTE] = ACTIONS(1720),
    [anon_sym_async] = ACTIONS(1720),
    [anon_sym_break] = ACTIONS(1720),
    [anon_sym_const] = ACTIONS(1720),
    [anon_sym_continue] = ACTIONS(1720),
    [anon_sym_default] = ACTIONS(1720),
    [anon_sym_enum] = ACTIONS(1720),
    [anon_sym_fn] = ACTIONS(1720),
    [anon_sym_for] = ACTIONS(1720),
    [anon_sym_if] = ACTIONS(1720),
    [anon_sym_impl] = ACTIONS(1720),
    [anon_sym_let] = ACTIONS(1720),
    [anon_sym_loop] = ACTIONS(1720),
    [anon_sym_match] = ACTIONS(1720),
    [anon_sym_mod] = ACTIONS(1720),
    [anon_sym_pub] = ACTIONS(1720),
    [anon_sym_return] = ACTIONS(1720),
    [anon_sym_static] = ACTIONS(1720),
    [anon_sym_struct] = ACTIONS(1720),
    [anon_sym_trait] = ACTIONS(1720),
    [anon_sym_type] = ACTIONS(1720),
    [anon_sym_union] = ACTIONS(1720),
    [anon_sym_unsafe] = ACTIONS(1720),
    [anon_sym_use] = ACTIONS(1720),
    [anon_sym_while] = ACTIONS(1720),
    [anon_sym_extern] = ACTIONS(1720),
    [anon_sym_yield] = ACTIONS(1720),
    [anon_sym_move] = ACTIONS(1720),
    [anon_sym_try] = ACTIONS(1720),
    [sym_integer_literal] = ACTIONS(1718),
    [aux_sym_string_literal_token1] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [anon_sym_true] = ACTIONS(1720),
    [anon_sym_false] = ACTIONS(1720),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1720),
    [sym_super] = ACTIONS(1720),
    [sym_crate] = ACTIONS(1720),
    [sym_metavariable] = ACTIONS(1718),
    [sym__raw_string_literal_start] = ACTIONS(1718),
    [sym_float_literal] = ACTIONS(1718),
  },
  [494] = {
    [sym_line_comment] = STATE(494),
    [sym_block_comment] = STATE(494),
    [ts_builtin_sym_end] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_macro_rules_BANG] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(1722),
    [anon_sym_u8] = ACTIONS(1724),
    [anon_sym_i8] = ACTIONS(1724),
    [anon_sym_u16] = ACTIONS(1724),
    [anon_sym_i16] = ACTIONS(1724),
    [anon_sym_u32] = ACTIONS(1724),
    [anon_sym_i32] = ACTIONS(1724),
    [anon_sym_u64] = ACTIONS(1724),
    [anon_sym_i64] = ACTIONS(1724),
    [anon_sym_u128] = ACTIONS(1724),
    [anon_sym_i128] = ACTIONS(1724),
    [anon_sym_isize] = ACTIONS(1724),
    [anon_sym_usize] = ACTIONS(1724),
    [anon_sym_f32] = ACTIONS(1724),
    [anon_sym_f64] = ACTIONS(1724),
    [anon_sym_bool] = ACTIONS(1724),
    [anon_sym_str] = ACTIONS(1724),
    [anon_sym_char] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1722),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1722),
    [anon_sym_PIPE] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_DOT_DOT] = ACTIONS(1722),
    [anon_sym_COLON_COLON] = ACTIONS(1722),
    [anon_sym_POUND] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1724),
    [anon_sym_async] = ACTIONS(1724),
    [anon_sym_break] = ACTIONS(1724),
    [anon_sym_const] = ACTIONS(1724),
    [anon_sym_continue] = ACTIONS(1724),
    [anon_sym_default] = ACTIONS(1724),
    [anon_sym_enum] = ACTIONS(1724),
    [anon_sym_fn] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1724),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_impl] = ACTIONS(1724),
    [anon_sym_let] = ACTIONS(1724),
    [anon_sym_loop] = ACTIONS(1724),
    [anon_sym_match] = ACTIONS(1724),
    [anon_sym_mod] = ACTIONS(1724),
    [anon_sym_pub] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1724),
    [anon_sym_static] = ACTIONS(1724),
    [anon_sym_struct] = ACTIONS(1724),
    [anon_sym_trait] = ACTIONS(1724),
    [anon_sym_type] = ACTIONS(1724),
    [anon_sym_union] = ACTIONS(1724),
    [anon_sym_unsafe] = ACTIONS(1724),
    [anon_sym_use] = ACTIONS(1724),
    [anon_sym_while] = ACTIONS(1724),
    [anon_sym_extern] = ACTIONS(1724),
    [anon_sym_yield] = ACTIONS(1724),
    [anon_sym_move] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(1724),
    [sym_integer_literal] = ACTIONS(1722),
    [aux_sym_string_literal_token1] = ACTIONS(1722),
    [sym_char_literal] = ACTIONS(1722),
    [anon_sym_true] = ACTIONS(1724),
    [anon_sym_false] = ACTIONS(1724),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1724),
    [sym_super] = ACTIONS(1724),
    [sym_crate] = ACTIONS(1724),
    [sym_metavariable] = ACTIONS(1722),
    [sym__raw_string_literal_start] = ACTIONS(1722),
    [sym_float_literal] = ACTIONS(1722),
  },
  [495] = {
    [sym_line_comment] = STATE(495),
    [sym_block_comment] = STATE(495),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [sym_identifier] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_macro_rules_BANG] = ACTIONS(1726),
    [anon_sym_LPAREN] = ACTIONS(1726),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_LBRACE] = ACTIONS(1726),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_STAR] = ACTIONS(1726),
    [anon_sym_u8] = ACTIONS(1728),
    [anon_sym_i8] = ACTIONS(1728),
    [anon_sym_u16] = ACTIONS(1728),
    [anon_sym_i16] = ACTIONS(1728),
    [anon_sym_u32] = ACTIONS(1728),
    [anon_sym_i32] = ACTIONS(1728),
    [anon_sym_u64] = ACTIONS(1728),
    [anon_sym_i64] = ACTIONS(1728),
    [anon_sym_u128] = ACTIONS(1728),
    [anon_sym_i128] = ACTIONS(1728),
    [anon_sym_isize] = ACTIONS(1728),
    [anon_sym_usize] = ACTIONS(1728),
    [anon_sym_f32] = ACTIONS(1728),
    [anon_sym_f64] = ACTIONS(1728),
    [anon_sym_bool] = ACTIONS(1728),
    [anon_sym_str] = ACTIONS(1728),
    [anon_sym_char] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1726),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_COLON_COLON] = ACTIONS(1726),
    [anon_sym_POUND] = ACTIONS(1726),
    [anon_sym_SQUOTE] = ACTIONS(1728),
    [anon_sym_async] = ACTIONS(1728),
    [anon_sym_break] = ACTIONS(1728),
    [anon_sym_const] = ACTIONS(1728),
    [anon_sym_continue] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1728),
    [anon_sym_enum] = ACTIONS(1728),
    [anon_sym_fn] = ACTIONS(1728),
    [anon_sym_for] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(1728),
    [anon_sym_impl] = ACTIONS(1728),
    [anon_sym_let] = ACTIONS(1728),
    [anon_sym_loop] = ACTIONS(1728),
    [anon_sym_match] = ACTIONS(1728),
    [anon_sym_mod] = ACTIONS(1728),
    [anon_sym_pub] = ACTIONS(1728),
    [anon_sym_return] = ACTIONS(1728),
    [anon_sym_static] = ACTIONS(1728),
    [anon_sym_struct] = ACTIONS(1728),
    [anon_sym_trait] = ACTIONS(1728),
    [anon_sym_type] = ACTIONS(1728),
    [anon_sym_union] = ACTIONS(1728),
    [anon_sym_unsafe] = ACTIONS(1728),
    [anon_sym_use] = ACTIONS(1728),
    [anon_sym_while] = ACTIONS(1728),
    [anon_sym_extern] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1728),
    [anon_sym_move] = ACTIONS(1728),
    [anon_sym_try] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1726),
    [aux_sym_string_literal_token1] = ACTIONS(1726),
    [sym_char_literal] = ACTIONS(1726),
    [anon_sym_true] = ACTIONS(1728),
    [anon_sym_false] = ACTIONS(1728),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1728),
    [sym_super] = ACTIONS(1728),
    [sym_crate] = ACTIONS(1728),
    [sym_metavariable] = ACTIONS(1726),
    [sym__raw_string_literal_start] = ACTIONS(1726),
    [sym_float_literal] = ACTIONS(1726),
  },
  [496] = {
    [sym_line_comment] = STATE(496),
    [sym_block_comment] = STATE(496),
    [ts_builtin_sym_end] = ACTIONS(1730),
    [sym_identifier] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(1730),
    [anon_sym_macro_rules_BANG] = ACTIONS(1730),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_LBRACK] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(1730),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_STAR] = ACTIONS(1730),
    [anon_sym_u8] = ACTIONS(1732),
    [anon_sym_i8] = ACTIONS(1732),
    [anon_sym_u16] = ACTIONS(1732),
    [anon_sym_i16] = ACTIONS(1732),
    [anon_sym_u32] = ACTIONS(1732),
    [anon_sym_i32] = ACTIONS(1732),
    [anon_sym_u64] = ACTIONS(1732),
    [anon_sym_i64] = ACTIONS(1732),
    [anon_sym_u128] = ACTIONS(1732),
    [anon_sym_i128] = ACTIONS(1732),
    [anon_sym_isize] = ACTIONS(1732),
    [anon_sym_usize] = ACTIONS(1732),
    [anon_sym_f32] = ACTIONS(1732),
    [anon_sym_f64] = ACTIONS(1732),
    [anon_sym_bool] = ACTIONS(1732),
    [anon_sym_str] = ACTIONS(1732),
    [anon_sym_char] = ACTIONS(1732),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(1730),
    [anon_sym_LT] = ACTIONS(1730),
    [anon_sym_DOT_DOT] = ACTIONS(1730),
    [anon_sym_COLON_COLON] = ACTIONS(1730),
    [anon_sym_POUND] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_async] = ACTIONS(1732),
    [anon_sym_break] = ACTIONS(1732),
    [anon_sym_const] = ACTIONS(1732),
    [anon_sym_continue] = ACTIONS(1732),
    [anon_sym_default] = ACTIONS(1732),
    [anon_sym_enum] = ACTIONS(1732),
    [anon_sym_fn] = ACTIONS(1732),
    [anon_sym_for] = ACTIONS(1732),
    [anon_sym_if] = ACTIONS(1732),
    [anon_sym_impl] = ACTIONS(1732),
    [anon_sym_let] = ACTIONS(1732),
    [anon_sym_loop] = ACTIONS(1732),
    [anon_sym_match] = ACTIONS(1732),
    [anon_sym_mod] = ACTIONS(1732),
    [anon_sym_pub] = ACTIONS(1732),
    [anon_sym_return] = ACTIONS(1732),
    [anon_sym_static] = ACTIONS(1732),
    [anon_sym_struct] = ACTIONS(1732),
    [anon_sym_trait] = ACTIONS(1732),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_union] = ACTIONS(1732),
    [anon_sym_unsafe] = ACTIONS(1732),
    [anon_sym_use] = ACTIONS(1732),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_extern] = ACTIONS(1732),
    [anon_sym_yield] = ACTIONS(1732),
    [anon_sym_move] = ACTIONS(1732),
    [anon_sym_try] = ACTIONS(1732),
    [sym_integer_literal] = ACTIONS(1730),
    [aux_sym_string_literal_token1] = ACTIONS(1730),
    [sym_char_literal] = ACTIONS(1730),
    [anon_sym_true] = ACTIONS(1732),
    [anon_sym_false] = ACTIONS(1732),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1732),
    [sym_super] = ACTIONS(1732),
    [sym_crate] = ACTIONS(1732),
    [sym_metavariable] = ACTIONS(1730),
    [sym__raw_string_literal_start] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
  },
  [497] = {
    [sym_line_comment] = STATE(497),
    [sym_block_comment] = STATE(497),
    [ts_builtin_sym_end] = ACTIONS(1734),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_macro_rules_BANG] = ACTIONS(1734),
    [anon_sym_LPAREN] = ACTIONS(1734),
    [anon_sym_LBRACK] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_STAR] = ACTIONS(1734),
    [anon_sym_u8] = ACTIONS(1736),
    [anon_sym_i8] = ACTIONS(1736),
    [anon_sym_u16] = ACTIONS(1736),
    [anon_sym_i16] = ACTIONS(1736),
    [anon_sym_u32] = ACTIONS(1736),
    [anon_sym_i32] = ACTIONS(1736),
    [anon_sym_u64] = ACTIONS(1736),
    [anon_sym_i64] = ACTIONS(1736),
    [anon_sym_u128] = ACTIONS(1736),
    [anon_sym_i128] = ACTIONS(1736),
    [anon_sym_isize] = ACTIONS(1736),
    [anon_sym_usize] = ACTIONS(1736),
    [anon_sym_f32] = ACTIONS(1736),
    [anon_sym_f64] = ACTIONS(1736),
    [anon_sym_bool] = ACTIONS(1736),
    [anon_sym_str] = ACTIONS(1736),
    [anon_sym_char] = ACTIONS(1736),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_DOT_DOT] = ACTIONS(1734),
    [anon_sym_COLON_COLON] = ACTIONS(1734),
    [anon_sym_POUND] = ACTIONS(1734),
    [anon_sym_SQUOTE] = ACTIONS(1736),
    [anon_sym_async] = ACTIONS(1736),
    [anon_sym_break] = ACTIONS(1736),
    [anon_sym_const] = ACTIONS(1736),
    [anon_sym_continue] = ACTIONS(1736),
    [anon_sym_default] = ACTIONS(1736),
    [anon_sym_enum] = ACTIONS(1736),
    [anon_sym_fn] = ACTIONS(1736),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_if] = ACTIONS(1736),
    [anon_sym_impl] = ACTIONS(1736),
    [anon_sym_let] = ACTIONS(1736),
    [anon_sym_loop] = ACTIONS(1736),
    [anon_sym_match] = ACTIONS(1736),
    [anon_sym_mod] = ACTIONS(1736),
    [anon_sym_pub] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1736),
    [anon_sym_static] = ACTIONS(1736),
    [anon_sym_struct] = ACTIONS(1736),
    [anon_sym_trait] = ACTIONS(1736),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_union] = ACTIONS(1736),
    [anon_sym_unsafe] = ACTIONS(1736),
    [anon_sym_use] = ACTIONS(1736),
    [anon_sym_while] = ACTIONS(1736),
    [anon_sym_extern] = ACTIONS(1736),
    [anon_sym_yield] = ACTIONS(1736),
    [anon_sym_move] = ACTIONS(1736),
    [anon_sym_try] = ACTIONS(1736),
    [sym_integer_literal] = ACTIONS(1734),
    [aux_sym_string_literal_token1] = ACTIONS(1734),
    [sym_char_literal] = ACTIONS(1734),
    [anon_sym_true] = ACTIONS(1736),
    [anon_sym_false] = ACTIONS(1736),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1736),
    [sym_super] = ACTIONS(1736),
    [sym_crate] = ACTIONS(1736),
    [sym_metavariable] = ACTIONS(1734),
    [sym__raw_string_literal_start] = ACTIONS(1734),
    [sym_float_literal] = ACTIONS(1734),
  },
  [498] = {
    [sym_line_comment] = STATE(498),
    [sym_block_comment] = STATE(498),
    [ts_builtin_sym_end] = ACTIONS(1738),
    [sym_identifier] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_macro_rules_BANG] = ACTIONS(1738),
    [anon_sym_LPAREN] = ACTIONS(1738),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_RBRACE] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1738),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1738),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1738),
    [anon_sym_PIPE] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1738),
    [anon_sym_DOT_DOT] = ACTIONS(1738),
    [anon_sym_COLON_COLON] = ACTIONS(1738),
    [anon_sym_POUND] = ACTIONS(1738),
    [anon_sym_SQUOTE] = ACTIONS(1740),
    [anon_sym_async] = ACTIONS(1740),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_const] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1740),
    [anon_sym_default] = ACTIONS(1740),
    [anon_sym_enum] = ACTIONS(1740),
    [anon_sym_fn] = ACTIONS(1740),
    [anon_sym_for] = ACTIONS(1740),
    [anon_sym_if] = ACTIONS(1740),
    [anon_sym_impl] = ACTIONS(1740),
    [anon_sym_let] = ACTIONS(1740),
    [anon_sym_loop] = ACTIONS(1740),
    [anon_sym_match] = ACTIONS(1740),
    [anon_sym_mod] = ACTIONS(1740),
    [anon_sym_pub] = ACTIONS(1740),
    [anon_sym_return] = ACTIONS(1740),
    [anon_sym_static] = ACTIONS(1740),
    [anon_sym_struct] = ACTIONS(1740),
    [anon_sym_trait] = ACTIONS(1740),
    [anon_sym_type] = ACTIONS(1740),
    [anon_sym_union] = ACTIONS(1740),
    [anon_sym_unsafe] = ACTIONS(1740),
    [anon_sym_use] = ACTIONS(1740),
    [anon_sym_while] = ACTIONS(1740),
    [anon_sym_extern] = ACTIONS(1740),
    [anon_sym_yield] = ACTIONS(1740),
    [anon_sym_move] = ACTIONS(1740),
    [anon_sym_try] = ACTIONS(1740),
    [sym_integer_literal] = ACTIONS(1738),
    [aux_sym_string_literal_token1] = ACTIONS(1738),
    [sym_char_literal] = ACTIONS(1738),
    [anon_sym_true] = ACTIONS(1740),
    [anon_sym_false] = ACTIONS(1740),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1740),
    [sym_super] = ACTIONS(1740),
    [sym_crate] = ACTIONS(1740),
    [sym_metavariable] = ACTIONS(1738),
    [sym__raw_string_literal_start] = ACTIONS(1738),
    [sym_float_literal] = ACTIONS(1738),
  },
  [499] = {
    [sym_line_comment] = STATE(499),
    [sym_block_comment] = STATE(499),
    [ts_builtin_sym_end] = ACTIONS(1742),
    [sym_identifier] = ACTIONS(1744),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_macro_rules_BANG] = ACTIONS(1742),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [anon_sym_LBRACK] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(1742),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_STAR] = ACTIONS(1742),
    [anon_sym_u8] = ACTIONS(1744),
    [anon_sym_i8] = ACTIONS(1744),
    [anon_sym_u16] = ACTIONS(1744),
    [anon_sym_i16] = ACTIONS(1744),
    [anon_sym_u32] = ACTIONS(1744),
    [anon_sym_i32] = ACTIONS(1744),
    [anon_sym_u64] = ACTIONS(1744),
    [anon_sym_i64] = ACTIONS(1744),
    [anon_sym_u128] = ACTIONS(1744),
    [anon_sym_i128] = ACTIONS(1744),
    [anon_sym_isize] = ACTIONS(1744),
    [anon_sym_usize] = ACTIONS(1744),
    [anon_sym_f32] = ACTIONS(1744),
    [anon_sym_f64] = ACTIONS(1744),
    [anon_sym_bool] = ACTIONS(1744),
    [anon_sym_str] = ACTIONS(1744),
    [anon_sym_char] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1742),
    [anon_sym_BANG] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1742),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_LT] = ACTIONS(1742),
    [anon_sym_DOT_DOT] = ACTIONS(1742),
    [anon_sym_COLON_COLON] = ACTIONS(1742),
    [anon_sym_POUND] = ACTIONS(1742),
    [anon_sym_SQUOTE] = ACTIONS(1744),
    [anon_sym_async] = ACTIONS(1744),
    [anon_sym_break] = ACTIONS(1744),
    [anon_sym_const] = ACTIONS(1744),
    [anon_sym_continue] = ACTIONS(1744),
    [anon_sym_default] = ACTIONS(1744),
    [anon_sym_enum] = ACTIONS(1744),
    [anon_sym_fn] = ACTIONS(1744),
    [anon_sym_for] = ACTIONS(1744),
    [anon_sym_if] = ACTIONS(1744),
    [anon_sym_impl] = ACTIONS(1744),
    [anon_sym_let] = ACTIONS(1744),
    [anon_sym_loop] = ACTIONS(1744),
    [anon_sym_match] = ACTIONS(1744),
    [anon_sym_mod] = ACTIONS(1744),
    [anon_sym_pub] = ACTIONS(1744),
    [anon_sym_return] = ACTIONS(1744),
    [anon_sym_static] = ACTIONS(1744),
    [anon_sym_struct] = ACTIONS(1744),
    [anon_sym_trait] = ACTIONS(1744),
    [anon_sym_type] = ACTIONS(1744),
    [anon_sym_union] = ACTIONS(1744),
    [anon_sym_unsafe] = ACTIONS(1744),
    [anon_sym_use] = ACTIONS(1744),
    [anon_sym_while] = ACTIONS(1744),
    [anon_sym_extern] = ACTIONS(1744),
    [anon_sym_yield] = ACTIONS(1744),
    [anon_sym_move] = ACTIONS(1744),
    [anon_sym_try] = ACTIONS(1744),
    [sym_integer_literal] = ACTIONS(1742),
    [aux_sym_string_literal_token1] = ACTIONS(1742),
    [sym_char_literal] = ACTIONS(1742),
    [anon_sym_true] = ACTIONS(1744),
    [anon_sym_false] = ACTIONS(1744),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1744),
    [sym_super] = ACTIONS(1744),
    [sym_crate] = ACTIONS(1744),
    [sym_metavariable] = ACTIONS(1742),
    [sym__raw_string_literal_start] = ACTIONS(1742),
    [sym_float_literal] = ACTIONS(1742),
  },
  [500] = {
    [sym_line_comment] = STATE(500),
    [sym_block_comment] = STATE(500),
    [ts_builtin_sym_end] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_macro_rules_BANG] = ACTIONS(1746),
    [anon_sym_LPAREN] = ACTIONS(1746),
    [anon_sym_LBRACK] = ACTIONS(1746),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_RBRACE] = ACTIONS(1746),
    [anon_sym_STAR] = ACTIONS(1746),
    [anon_sym_u8] = ACTIONS(1748),
    [anon_sym_i8] = ACTIONS(1748),
    [anon_sym_u16] = ACTIONS(1748),
    [anon_sym_i16] = ACTIONS(1748),
    [anon_sym_u32] = ACTIONS(1748),
    [anon_sym_i32] = ACTIONS(1748),
    [anon_sym_u64] = ACTIONS(1748),
    [anon_sym_i64] = ACTIONS(1748),
    [anon_sym_u128] = ACTIONS(1748),
    [anon_sym_i128] = ACTIONS(1748),
    [anon_sym_isize] = ACTIONS(1748),
    [anon_sym_usize] = ACTIONS(1748),
    [anon_sym_f32] = ACTIONS(1748),
    [anon_sym_f64] = ACTIONS(1748),
    [anon_sym_bool] = ACTIONS(1748),
    [anon_sym_str] = ACTIONS(1748),
    [anon_sym_char] = ACTIONS(1748),
    [anon_sym_DASH] = ACTIONS(1746),
    [anon_sym_BANG] = ACTIONS(1746),
    [anon_sym_AMP] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_DOT_DOT] = ACTIONS(1746),
    [anon_sym_COLON_COLON] = ACTIONS(1746),
    [anon_sym_POUND] = ACTIONS(1746),
    [anon_sym_SQUOTE] = ACTIONS(1748),
    [anon_sym_async] = ACTIONS(1748),
    [anon_sym_break] = ACTIONS(1748),
    [anon_sym_const] = ACTIONS(1748),
    [anon_sym_continue] = ACTIONS(1748),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_enum] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(1748),
    [anon_sym_for] = ACTIONS(1748),
    [anon_sym_if] = ACTIONS(1748),
    [anon_sym_impl] = ACTIONS(1748),
    [anon_sym_let] = ACTIONS(1748),
    [anon_sym_loop] = ACTIONS(1748),
    [anon_sym_match] = ACTIONS(1748),
    [anon_sym_mod] = ACTIONS(1748),
    [anon_sym_pub] = ACTIONS(1748),
    [anon_sym_return] = ACTIONS(1748),
    [anon_sym_static] = ACTIONS(1748),
    [anon_sym_struct] = ACTIONS(1748),
    [anon_sym_trait] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(1748),
    [anon_sym_union] = ACTIONS(1748),
    [anon_sym_unsafe] = ACTIONS(1748),
    [anon_sym_use] = ACTIONS(1748),
    [anon_sym_while] = ACTIONS(1748),
    [anon_sym_extern] = ACTIONS(1748),
    [anon_sym_yield] = ACTIONS(1748),
    [anon_sym_move] = ACTIONS(1748),
    [anon_sym_try] = ACTIONS(1748),
    [sym_integer_literal] = ACTIONS(1746),
    [aux_sym_string_literal_token1] = ACTIONS(1746),
    [sym_char_literal] = ACTIONS(1746),
    [anon_sym_true] = ACTIONS(1748),
    [anon_sym_false] = ACTIONS(1748),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1748),
    [sym_super] = ACTIONS(1748),
    [sym_crate] = ACTIONS(1748),
    [sym_metavariable] = ACTIONS(1746),
    [sym__raw_string_literal_start] = ACTIONS(1746),
    [sym_float_literal] = ACTIONS(1746),
  },
  [501] = {
    [sym_line_comment] = STATE(501),
    [sym_block_comment] = STATE(501),
    [ts_builtin_sym_end] = ACTIONS(1750),
    [sym_identifier] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1750),
    [anon_sym_macro_rules_BANG] = ACTIONS(1750),
    [anon_sym_LPAREN] = ACTIONS(1750),
    [anon_sym_LBRACK] = ACTIONS(1750),
    [anon_sym_LBRACE] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1750),
    [anon_sym_STAR] = ACTIONS(1750),
    [anon_sym_u8] = ACTIONS(1752),
    [anon_sym_i8] = ACTIONS(1752),
    [anon_sym_u16] = ACTIONS(1752),
    [anon_sym_i16] = ACTIONS(1752),
    [anon_sym_u32] = ACTIONS(1752),
    [anon_sym_i32] = ACTIONS(1752),
    [anon_sym_u64] = ACTIONS(1752),
    [anon_sym_i64] = ACTIONS(1752),
    [anon_sym_u128] = ACTIONS(1752),
    [anon_sym_i128] = ACTIONS(1752),
    [anon_sym_isize] = ACTIONS(1752),
    [anon_sym_usize] = ACTIONS(1752),
    [anon_sym_f32] = ACTIONS(1752),
    [anon_sym_f64] = ACTIONS(1752),
    [anon_sym_bool] = ACTIONS(1752),
    [anon_sym_str] = ACTIONS(1752),
    [anon_sym_char] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1750),
    [anon_sym_BANG] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1750),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_DOT_DOT] = ACTIONS(1750),
    [anon_sym_COLON_COLON] = ACTIONS(1750),
    [anon_sym_POUND] = ACTIONS(1750),
    [anon_sym_SQUOTE] = ACTIONS(1752),
    [anon_sym_async] = ACTIONS(1752),
    [anon_sym_break] = ACTIONS(1752),
    [anon_sym_const] = ACTIONS(1752),
    [anon_sym_continue] = ACTIONS(1752),
    [anon_sym_default] = ACTIONS(1752),
    [anon_sym_enum] = ACTIONS(1752),
    [anon_sym_fn] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1752),
    [anon_sym_if] = ACTIONS(1752),
    [anon_sym_impl] = ACTIONS(1752),
    [anon_sym_let] = ACTIONS(1752),
    [anon_sym_loop] = ACTIONS(1752),
    [anon_sym_match] = ACTIONS(1752),
    [anon_sym_mod] = ACTIONS(1752),
    [anon_sym_pub] = ACTIONS(1752),
    [anon_sym_return] = ACTIONS(1752),
    [anon_sym_static] = ACTIONS(1752),
    [anon_sym_struct] = ACTIONS(1752),
    [anon_sym_trait] = ACTIONS(1752),
    [anon_sym_type] = ACTIONS(1752),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(1752),
    [anon_sym_use] = ACTIONS(1752),
    [anon_sym_while] = ACTIONS(1752),
    [anon_sym_extern] = ACTIONS(1752),
    [anon_sym_yield] = ACTIONS(1752),
    [anon_sym_move] = ACTIONS(1752),
    [anon_sym_try] = ACTIONS(1752),
    [sym_integer_literal] = ACTIONS(1750),
    [aux_sym_string_literal_token1] = ACTIONS(1750),
    [sym_char_literal] = ACTIONS(1750),
    [anon_sym_true] = ACTIONS(1752),
    [anon_sym_false] = ACTIONS(1752),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1752),
    [sym_super] = ACTIONS(1752),
    [sym_crate] = ACTIONS(1752),
    [sym_metavariable] = ACTIONS(1750),
    [sym__raw_string_literal_start] = ACTIONS(1750),
    [sym_float_literal] = ACTIONS(1750),
  },
  [502] = {
    [sym_line_comment] = STATE(502),
    [sym_block_comment] = STATE(502),
    [ts_builtin_sym_end] = ACTIONS(1754),
    [sym_identifier] = ACTIONS(1756),
    [anon_sym_SEMI] = ACTIONS(1754),
    [anon_sym_macro_rules_BANG] = ACTIONS(1754),
    [anon_sym_LPAREN] = ACTIONS(1754),
    [anon_sym_LBRACK] = ACTIONS(1754),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_RBRACE] = ACTIONS(1754),
    [anon_sym_STAR] = ACTIONS(1754),
    [anon_sym_u8] = ACTIONS(1756),
    [anon_sym_i8] = ACTIONS(1756),
    [anon_sym_u16] = ACTIONS(1756),
    [anon_sym_i16] = ACTIONS(1756),
    [anon_sym_u32] = ACTIONS(1756),
    [anon_sym_i32] = ACTIONS(1756),
    [anon_sym_u64] = ACTIONS(1756),
    [anon_sym_i64] = ACTIONS(1756),
    [anon_sym_u128] = ACTIONS(1756),
    [anon_sym_i128] = ACTIONS(1756),
    [anon_sym_isize] = ACTIONS(1756),
    [anon_sym_usize] = ACTIONS(1756),
    [anon_sym_f32] = ACTIONS(1756),
    [anon_sym_f64] = ACTIONS(1756),
    [anon_sym_bool] = ACTIONS(1756),
    [anon_sym_str] = ACTIONS(1756),
    [anon_sym_char] = ACTIONS(1756),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_BANG] = ACTIONS(1754),
    [anon_sym_AMP] = ACTIONS(1754),
    [anon_sym_PIPE] = ACTIONS(1754),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_DOT_DOT] = ACTIONS(1754),
    [anon_sym_COLON_COLON] = ACTIONS(1754),
    [anon_sym_POUND] = ACTIONS(1754),
    [anon_sym_SQUOTE] = ACTIONS(1756),
    [anon_sym_async] = ACTIONS(1756),
    [anon_sym_break] = ACTIONS(1756),
    [anon_sym_const] = ACTIONS(1756),
    [anon_sym_continue] = ACTIONS(1756),
    [anon_sym_default] = ACTIONS(1756),
    [anon_sym_enum] = ACTIONS(1756),
    [anon_sym_fn] = ACTIONS(1756),
    [anon_sym_for] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(1756),
    [anon_sym_impl] = ACTIONS(1756),
    [anon_sym_let] = ACTIONS(1756),
    [anon_sym_loop] = ACTIONS(1756),
    [anon_sym_match] = ACTIONS(1756),
    [anon_sym_mod] = ACTIONS(1756),
    [anon_sym_pub] = ACTIONS(1756),
    [anon_sym_return] = ACTIONS(1756),
    [anon_sym_static] = ACTIONS(1756),
    [anon_sym_struct] = ACTIONS(1756),
    [anon_sym_trait] = ACTIONS(1756),
    [anon_sym_type] = ACTIONS(1756),
    [anon_sym_union] = ACTIONS(1756),
    [anon_sym_unsafe] = ACTIONS(1756),
    [anon_sym_use] = ACTIONS(1756),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_extern] = ACTIONS(1756),
    [anon_sym_yield] = ACTIONS(1756),
    [anon_sym_move] = ACTIONS(1756),
    [anon_sym_try] = ACTIONS(1756),
    [sym_integer_literal] = ACTIONS(1754),
    [aux_sym_string_literal_token1] = ACTIONS(1754),
    [sym_char_literal] = ACTIONS(1754),
    [anon_sym_true] = ACTIONS(1756),
    [anon_sym_false] = ACTIONS(1756),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1756),
    [sym_super] = ACTIONS(1756),
    [sym_crate] = ACTIONS(1756),
    [sym_metavariable] = ACTIONS(1754),
    [sym__raw_string_literal_start] = ACTIONS(1754),
    [sym_float_literal] = ACTIONS(1754),
  },
  [503] = {
    [sym_line_comment] = STATE(503),
    [sym_block_comment] = STATE(503),
    [ts_builtin_sym_end] = ACTIONS(1758),
    [sym_identifier] = ACTIONS(1760),
    [anon_sym_SEMI] = ACTIONS(1758),
    [anon_sym_macro_rules_BANG] = ACTIONS(1758),
    [anon_sym_LPAREN] = ACTIONS(1758),
    [anon_sym_LBRACK] = ACTIONS(1758),
    [anon_sym_LBRACE] = ACTIONS(1758),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [anon_sym_STAR] = ACTIONS(1758),
    [anon_sym_u8] = ACTIONS(1760),
    [anon_sym_i8] = ACTIONS(1760),
    [anon_sym_u16] = ACTIONS(1760),
    [anon_sym_i16] = ACTIONS(1760),
    [anon_sym_u32] = ACTIONS(1760),
    [anon_sym_i32] = ACTIONS(1760),
    [anon_sym_u64] = ACTIONS(1760),
    [anon_sym_i64] = ACTIONS(1760),
    [anon_sym_u128] = ACTIONS(1760),
    [anon_sym_i128] = ACTIONS(1760),
    [anon_sym_isize] = ACTIONS(1760),
    [anon_sym_usize] = ACTIONS(1760),
    [anon_sym_f32] = ACTIONS(1760),
    [anon_sym_f64] = ACTIONS(1760),
    [anon_sym_bool] = ACTIONS(1760),
    [anon_sym_str] = ACTIONS(1760),
    [anon_sym_char] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_AMP] = ACTIONS(1758),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_LT] = ACTIONS(1758),
    [anon_sym_DOT_DOT] = ACTIONS(1758),
    [anon_sym_COLON_COLON] = ACTIONS(1758),
    [anon_sym_POUND] = ACTIONS(1758),
    [anon_sym_SQUOTE] = ACTIONS(1760),
    [anon_sym_async] = ACTIONS(1760),
    [anon_sym_break] = ACTIONS(1760),
    [anon_sym_const] = ACTIONS(1760),
    [anon_sym_continue] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1760),
    [anon_sym_enum] = ACTIONS(1760),
    [anon_sym_fn] = ACTIONS(1760),
    [anon_sym_for] = ACTIONS(1760),
    [anon_sym_if] = ACTIONS(1760),
    [anon_sym_impl] = ACTIONS(1760),
    [anon_sym_let] = ACTIONS(1760),
    [anon_sym_loop] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1760),
    [anon_sym_mod] = ACTIONS(1760),
    [anon_sym_pub] = ACTIONS(1760),
    [anon_sym_return] = ACTIONS(1760),
    [anon_sym_static] = ACTIONS(1760),
    [anon_sym_struct] = ACTIONS(1760),
    [anon_sym_trait] = ACTIONS(1760),
    [anon_sym_type] = ACTIONS(1760),
    [anon_sym_union] = ACTIONS(1760),
    [anon_sym_unsafe] = ACTIONS(1760),
    [anon_sym_use] = ACTIONS(1760),
    [anon_sym_while] = ACTIONS(1760),
    [anon_sym_extern] = ACTIONS(1760),
    [anon_sym_yield] = ACTIONS(1760),
    [anon_sym_move] = ACTIONS(1760),
    [anon_sym_try] = ACTIONS(1760),
    [sym_integer_literal] = ACTIONS(1758),
    [aux_sym_string_literal_token1] = ACTIONS(1758),
    [sym_char_literal] = ACTIONS(1758),
    [anon_sym_true] = ACTIONS(1760),
    [anon_sym_false] = ACTIONS(1760),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1760),
    [sym_super] = ACTIONS(1760),
    [sym_crate] = ACTIONS(1760),
    [sym_metavariable] = ACTIONS(1758),
    [sym__raw_string_literal_start] = ACTIONS(1758),
    [sym_float_literal] = ACTIONS(1758),
  },
  [504] = {
    [sym_line_comment] = STATE(504),
    [sym_block_comment] = STATE(504),
    [ts_builtin_sym_end] = ACTIONS(1762),
    [sym_identifier] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1762),
    [anon_sym_macro_rules_BANG] = ACTIONS(1762),
    [anon_sym_LPAREN] = ACTIONS(1762),
    [anon_sym_LBRACK] = ACTIONS(1762),
    [anon_sym_LBRACE] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_u8] = ACTIONS(1764),
    [anon_sym_i8] = ACTIONS(1764),
    [anon_sym_u16] = ACTIONS(1764),
    [anon_sym_i16] = ACTIONS(1764),
    [anon_sym_u32] = ACTIONS(1764),
    [anon_sym_i32] = ACTIONS(1764),
    [anon_sym_u64] = ACTIONS(1764),
    [anon_sym_i64] = ACTIONS(1764),
    [anon_sym_u128] = ACTIONS(1764),
    [anon_sym_i128] = ACTIONS(1764),
    [anon_sym_isize] = ACTIONS(1764),
    [anon_sym_usize] = ACTIONS(1764),
    [anon_sym_f32] = ACTIONS(1764),
    [anon_sym_f64] = ACTIONS(1764),
    [anon_sym_bool] = ACTIONS(1764),
    [anon_sym_str] = ACTIONS(1764),
    [anon_sym_char] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1762),
    [anon_sym_DOT_DOT] = ACTIONS(1762),
    [anon_sym_COLON_COLON] = ACTIONS(1762),
    [anon_sym_POUND] = ACTIONS(1762),
    [anon_sym_SQUOTE] = ACTIONS(1764),
    [anon_sym_async] = ACTIONS(1764),
    [anon_sym_break] = ACTIONS(1764),
    [anon_sym_const] = ACTIONS(1764),
    [anon_sym_continue] = ACTIONS(1764),
    [anon_sym_default] = ACTIONS(1764),
    [anon_sym_enum] = ACTIONS(1764),
    [anon_sym_fn] = ACTIONS(1764),
    [anon_sym_for] = ACTIONS(1764),
    [anon_sym_if] = ACTIONS(1764),
    [anon_sym_impl] = ACTIONS(1764),
    [anon_sym_let] = ACTIONS(1764),
    [anon_sym_loop] = ACTIONS(1764),
    [anon_sym_match] = ACTIONS(1764),
    [anon_sym_mod] = ACTIONS(1764),
    [anon_sym_pub] = ACTIONS(1764),
    [anon_sym_return] = ACTIONS(1764),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_struct] = ACTIONS(1764),
    [anon_sym_trait] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_union] = ACTIONS(1764),
    [anon_sym_unsafe] = ACTIONS(1764),
    [anon_sym_use] = ACTIONS(1764),
    [anon_sym_while] = ACTIONS(1764),
    [anon_sym_extern] = ACTIONS(1764),
    [anon_sym_yield] = ACTIONS(1764),
    [anon_sym_move] = ACTIONS(1764),
    [anon_sym_try] = ACTIONS(1764),
    [sym_integer_literal] = ACTIONS(1762),
    [aux_sym_string_literal_token1] = ACTIONS(1762),
    [sym_char_literal] = ACTIONS(1762),
    [anon_sym_true] = ACTIONS(1764),
    [anon_sym_false] = ACTIONS(1764),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1764),
    [sym_super] = ACTIONS(1764),
    [sym_crate] = ACTIONS(1764),
    [sym_metavariable] = ACTIONS(1762),
    [sym__raw_string_literal_start] = ACTIONS(1762),
    [sym_float_literal] = ACTIONS(1762),
  },
  [505] = {
    [sym_line_comment] = STATE(505),
    [sym_block_comment] = STATE(505),
    [ts_builtin_sym_end] = ACTIONS(1766),
    [sym_identifier] = ACTIONS(1768),
    [anon_sym_SEMI] = ACTIONS(1766),
    [anon_sym_macro_rules_BANG] = ACTIONS(1766),
    [anon_sym_LPAREN] = ACTIONS(1766),
    [anon_sym_LBRACK] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1766),
    [anon_sym_RBRACE] = ACTIONS(1766),
    [anon_sym_STAR] = ACTIONS(1766),
    [anon_sym_u8] = ACTIONS(1768),
    [anon_sym_i8] = ACTIONS(1768),
    [anon_sym_u16] = ACTIONS(1768),
    [anon_sym_i16] = ACTIONS(1768),
    [anon_sym_u32] = ACTIONS(1768),
    [anon_sym_i32] = ACTIONS(1768),
    [anon_sym_u64] = ACTIONS(1768),
    [anon_sym_i64] = ACTIONS(1768),
    [anon_sym_u128] = ACTIONS(1768),
    [anon_sym_i128] = ACTIONS(1768),
    [anon_sym_isize] = ACTIONS(1768),
    [anon_sym_usize] = ACTIONS(1768),
    [anon_sym_f32] = ACTIONS(1768),
    [anon_sym_f64] = ACTIONS(1768),
    [anon_sym_bool] = ACTIONS(1768),
    [anon_sym_str] = ACTIONS(1768),
    [anon_sym_char] = ACTIONS(1768),
    [anon_sym_DASH] = ACTIONS(1766),
    [anon_sym_BANG] = ACTIONS(1766),
    [anon_sym_AMP] = ACTIONS(1766),
    [anon_sym_PIPE] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1766),
    [anon_sym_DOT_DOT] = ACTIONS(1766),
    [anon_sym_COLON_COLON] = ACTIONS(1766),
    [anon_sym_POUND] = ACTIONS(1766),
    [anon_sym_SQUOTE] = ACTIONS(1768),
    [anon_sym_async] = ACTIONS(1768),
    [anon_sym_break] = ACTIONS(1768),
    [anon_sym_const] = ACTIONS(1768),
    [anon_sym_continue] = ACTIONS(1768),
    [anon_sym_default] = ACTIONS(1768),
    [anon_sym_enum] = ACTIONS(1768),
    [anon_sym_fn] = ACTIONS(1768),
    [anon_sym_for] = ACTIONS(1768),
    [anon_sym_if] = ACTIONS(1768),
    [anon_sym_impl] = ACTIONS(1768),
    [anon_sym_let] = ACTIONS(1768),
    [anon_sym_loop] = ACTIONS(1768),
    [anon_sym_match] = ACTIONS(1768),
    [anon_sym_mod] = ACTIONS(1768),
    [anon_sym_pub] = ACTIONS(1768),
    [anon_sym_return] = ACTIONS(1768),
    [anon_sym_static] = ACTIONS(1768),
    [anon_sym_struct] = ACTIONS(1768),
    [anon_sym_trait] = ACTIONS(1768),
    [anon_sym_type] = ACTIONS(1768),
    [anon_sym_union] = ACTIONS(1768),
    [anon_sym_unsafe] = ACTIONS(1768),
    [anon_sym_use] = ACTIONS(1768),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_extern] = ACTIONS(1768),
    [anon_sym_yield] = ACTIONS(1768),
    [anon_sym_move] = ACTIONS(1768),
    [anon_sym_try] = ACTIONS(1768),
    [sym_integer_literal] = ACTIONS(1766),
    [aux_sym_string_literal_token1] = ACTIONS(1766),
    [sym_char_literal] = ACTIONS(1766),
    [anon_sym_true] = ACTIONS(1768),
    [anon_sym_false] = ACTIONS(1768),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1768),
    [sym_super] = ACTIONS(1768),
    [sym_crate] = ACTIONS(1768),
    [sym_metavariable] = ACTIONS(1766),
    [sym__raw_string_literal_start] = ACTIONS(1766),
    [sym_float_literal] = ACTIONS(1766),
  },
  [506] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_arm] = STATE(1476),
    [sym_match_pattern] = STATE(3436),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(506),
    [sym_block_comment] = STATE(506),
    [aux_sym_match_block_repeat1] = STATE(506),
    [aux_sym_match_arm_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(1773),
    [anon_sym_LBRACK] = ACTIONS(1776),
    [anon_sym_u8] = ACTIONS(1779),
    [anon_sym_i8] = ACTIONS(1779),
    [anon_sym_u16] = ACTIONS(1779),
    [anon_sym_i16] = ACTIONS(1779),
    [anon_sym_u32] = ACTIONS(1779),
    [anon_sym_i32] = ACTIONS(1779),
    [anon_sym_u64] = ACTIONS(1779),
    [anon_sym_i64] = ACTIONS(1779),
    [anon_sym_u128] = ACTIONS(1779),
    [anon_sym_i128] = ACTIONS(1779),
    [anon_sym_isize] = ACTIONS(1779),
    [anon_sym_usize] = ACTIONS(1779),
    [anon_sym_f32] = ACTIONS(1779),
    [anon_sym_f64] = ACTIONS(1779),
    [anon_sym_bool] = ACTIONS(1779),
    [anon_sym_str] = ACTIONS(1779),
    [anon_sym_char] = ACTIONS(1779),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_AMP] = ACTIONS(1785),
    [anon_sym_PIPE] = ACTIONS(1788),
    [anon_sym_LT] = ACTIONS(1791),
    [anon_sym__] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_COLON_COLON] = ACTIONS(1800),
    [anon_sym_POUND] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1806),
    [anon_sym_default] = ACTIONS(1809),
    [anon_sym_union] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1812),
    [sym_mutable_specifier] = ACTIONS(1815),
    [sym_integer_literal] = ACTIONS(1818),
    [aux_sym_string_literal_token1] = ACTIONS(1821),
    [sym_char_literal] = ACTIONS(1818),
    [anon_sym_true] = ACTIONS(1824),
    [anon_sym_false] = ACTIONS(1824),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1827),
    [sym_super] = ACTIONS(1827),
    [sym_crate] = ACTIONS(1827),
    [sym_metavariable] = ACTIONS(1830),
    [sym__raw_string_literal_start] = ACTIONS(1833),
    [sym_float_literal] = ACTIONS(1818),
  },
  [507] = {
    [sym_line_comment] = STATE(507),
    [sym_block_comment] = STATE(507),
    [ts_builtin_sym_end] = ACTIONS(1836),
    [sym_identifier] = ACTIONS(1838),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_macro_rules_BANG] = ACTIONS(1836),
    [anon_sym_LPAREN] = ACTIONS(1836),
    [anon_sym_LBRACK] = ACTIONS(1836),
    [anon_sym_LBRACE] = ACTIONS(1836),
    [anon_sym_RBRACE] = ACTIONS(1836),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_u8] = ACTIONS(1838),
    [anon_sym_i8] = ACTIONS(1838),
    [anon_sym_u16] = ACTIONS(1838),
    [anon_sym_i16] = ACTIONS(1838),
    [anon_sym_u32] = ACTIONS(1838),
    [anon_sym_i32] = ACTIONS(1838),
    [anon_sym_u64] = ACTIONS(1838),
    [anon_sym_i64] = ACTIONS(1838),
    [anon_sym_u128] = ACTIONS(1838),
    [anon_sym_i128] = ACTIONS(1838),
    [anon_sym_isize] = ACTIONS(1838),
    [anon_sym_usize] = ACTIONS(1838),
    [anon_sym_f32] = ACTIONS(1838),
    [anon_sym_f64] = ACTIONS(1838),
    [anon_sym_bool] = ACTIONS(1838),
    [anon_sym_str] = ACTIONS(1838),
    [anon_sym_char] = ACTIONS(1838),
    [anon_sym_DASH] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1836),
    [anon_sym_AMP] = ACTIONS(1836),
    [anon_sym_PIPE] = ACTIONS(1836),
    [anon_sym_LT] = ACTIONS(1836),
    [anon_sym_DOT_DOT] = ACTIONS(1836),
    [anon_sym_COLON_COLON] = ACTIONS(1836),
    [anon_sym_POUND] = ACTIONS(1836),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_async] = ACTIONS(1838),
    [anon_sym_break] = ACTIONS(1838),
    [anon_sym_const] = ACTIONS(1838),
    [anon_sym_continue] = ACTIONS(1838),
    [anon_sym_default] = ACTIONS(1838),
    [anon_sym_enum] = ACTIONS(1838),
    [anon_sym_fn] = ACTIONS(1838),
    [anon_sym_for] = ACTIONS(1838),
    [anon_sym_if] = ACTIONS(1838),
    [anon_sym_impl] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1838),
    [anon_sym_loop] = ACTIONS(1838),
    [anon_sym_match] = ACTIONS(1838),
    [anon_sym_mod] = ACTIONS(1838),
    [anon_sym_pub] = ACTIONS(1838),
    [anon_sym_return] = ACTIONS(1838),
    [anon_sym_static] = ACTIONS(1838),
    [anon_sym_struct] = ACTIONS(1838),
    [anon_sym_trait] = ACTIONS(1838),
    [anon_sym_type] = ACTIONS(1838),
    [anon_sym_union] = ACTIONS(1838),
    [anon_sym_unsafe] = ACTIONS(1838),
    [anon_sym_use] = ACTIONS(1838),
    [anon_sym_while] = ACTIONS(1838),
    [anon_sym_extern] = ACTIONS(1838),
    [anon_sym_yield] = ACTIONS(1838),
    [anon_sym_move] = ACTIONS(1838),
    [anon_sym_try] = ACTIONS(1838),
    [sym_integer_literal] = ACTIONS(1836),
    [aux_sym_string_literal_token1] = ACTIONS(1836),
    [sym_char_literal] = ACTIONS(1836),
    [anon_sym_true] = ACTIONS(1838),
    [anon_sym_false] = ACTIONS(1838),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1838),
    [sym_super] = ACTIONS(1838),
    [sym_crate] = ACTIONS(1838),
    [sym_metavariable] = ACTIONS(1836),
    [sym__raw_string_literal_start] = ACTIONS(1836),
    [sym_float_literal] = ACTIONS(1836),
  },
  [508] = {
    [sym_line_comment] = STATE(508),
    [sym_block_comment] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(1840),
    [sym_identifier] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1840),
    [anon_sym_macro_rules_BANG] = ACTIONS(1840),
    [anon_sym_LPAREN] = ACTIONS(1840),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(1840),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_u8] = ACTIONS(1842),
    [anon_sym_i8] = ACTIONS(1842),
    [anon_sym_u16] = ACTIONS(1842),
    [anon_sym_i16] = ACTIONS(1842),
    [anon_sym_u32] = ACTIONS(1842),
    [anon_sym_i32] = ACTIONS(1842),
    [anon_sym_u64] = ACTIONS(1842),
    [anon_sym_i64] = ACTIONS(1842),
    [anon_sym_u128] = ACTIONS(1842),
    [anon_sym_i128] = ACTIONS(1842),
    [anon_sym_isize] = ACTIONS(1842),
    [anon_sym_usize] = ACTIONS(1842),
    [anon_sym_f32] = ACTIONS(1842),
    [anon_sym_f64] = ACTIONS(1842),
    [anon_sym_bool] = ACTIONS(1842),
    [anon_sym_str] = ACTIONS(1842),
    [anon_sym_char] = ACTIONS(1842),
    [anon_sym_DASH] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1840),
    [anon_sym_LT] = ACTIONS(1840),
    [anon_sym_DOT_DOT] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(1840),
    [anon_sym_POUND] = ACTIONS(1840),
    [anon_sym_SQUOTE] = ACTIONS(1842),
    [anon_sym_async] = ACTIONS(1842),
    [anon_sym_break] = ACTIONS(1842),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_continue] = ACTIONS(1842),
    [anon_sym_default] = ACTIONS(1842),
    [anon_sym_enum] = ACTIONS(1842),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_for] = ACTIONS(1842),
    [anon_sym_if] = ACTIONS(1842),
    [anon_sym_impl] = ACTIONS(1842),
    [anon_sym_let] = ACTIONS(1842),
    [anon_sym_loop] = ACTIONS(1842),
    [anon_sym_match] = ACTIONS(1842),
    [anon_sym_mod] = ACTIONS(1842),
    [anon_sym_pub] = ACTIONS(1842),
    [anon_sym_return] = ACTIONS(1842),
    [anon_sym_static] = ACTIONS(1842),
    [anon_sym_struct] = ACTIONS(1842),
    [anon_sym_trait] = ACTIONS(1842),
    [anon_sym_type] = ACTIONS(1842),
    [anon_sym_union] = ACTIONS(1842),
    [anon_sym_unsafe] = ACTIONS(1842),
    [anon_sym_use] = ACTIONS(1842),
    [anon_sym_while] = ACTIONS(1842),
    [anon_sym_extern] = ACTIONS(1842),
    [anon_sym_yield] = ACTIONS(1842),
    [anon_sym_move] = ACTIONS(1842),
    [anon_sym_try] = ACTIONS(1842),
    [sym_integer_literal] = ACTIONS(1840),
    [aux_sym_string_literal_token1] = ACTIONS(1840),
    [sym_char_literal] = ACTIONS(1840),
    [anon_sym_true] = ACTIONS(1842),
    [anon_sym_false] = ACTIONS(1842),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1842),
    [sym_super] = ACTIONS(1842),
    [sym_crate] = ACTIONS(1842),
    [sym_metavariable] = ACTIONS(1840),
    [sym__raw_string_literal_start] = ACTIONS(1840),
    [sym_float_literal] = ACTIONS(1840),
  },
  [509] = {
    [sym_line_comment] = STATE(509),
    [sym_block_comment] = STATE(509),
    [ts_builtin_sym_end] = ACTIONS(1844),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(1844),
    [anon_sym_macro_rules_BANG] = ACTIONS(1844),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_LBRACK] = ACTIONS(1844),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_RBRACE] = ACTIONS(1844),
    [anon_sym_STAR] = ACTIONS(1844),
    [anon_sym_u8] = ACTIONS(1846),
    [anon_sym_i8] = ACTIONS(1846),
    [anon_sym_u16] = ACTIONS(1846),
    [anon_sym_i16] = ACTIONS(1846),
    [anon_sym_u32] = ACTIONS(1846),
    [anon_sym_i32] = ACTIONS(1846),
    [anon_sym_u64] = ACTIONS(1846),
    [anon_sym_i64] = ACTIONS(1846),
    [anon_sym_u128] = ACTIONS(1846),
    [anon_sym_i128] = ACTIONS(1846),
    [anon_sym_isize] = ACTIONS(1846),
    [anon_sym_usize] = ACTIONS(1846),
    [anon_sym_f32] = ACTIONS(1846),
    [anon_sym_f64] = ACTIONS(1846),
    [anon_sym_bool] = ACTIONS(1846),
    [anon_sym_str] = ACTIONS(1846),
    [anon_sym_char] = ACTIONS(1846),
    [anon_sym_DASH] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_AMP] = ACTIONS(1844),
    [anon_sym_PIPE] = ACTIONS(1844),
    [anon_sym_LT] = ACTIONS(1844),
    [anon_sym_DOT_DOT] = ACTIONS(1844),
    [anon_sym_COLON_COLON] = ACTIONS(1844),
    [anon_sym_POUND] = ACTIONS(1844),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [anon_sym_async] = ACTIONS(1846),
    [anon_sym_break] = ACTIONS(1846),
    [anon_sym_const] = ACTIONS(1846),
    [anon_sym_continue] = ACTIONS(1846),
    [anon_sym_default] = ACTIONS(1846),
    [anon_sym_enum] = ACTIONS(1846),
    [anon_sym_fn] = ACTIONS(1846),
    [anon_sym_for] = ACTIONS(1846),
    [anon_sym_if] = ACTIONS(1846),
    [anon_sym_impl] = ACTIONS(1846),
    [anon_sym_let] = ACTIONS(1846),
    [anon_sym_loop] = ACTIONS(1846),
    [anon_sym_match] = ACTIONS(1846),
    [anon_sym_mod] = ACTIONS(1846),
    [anon_sym_pub] = ACTIONS(1846),
    [anon_sym_return] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1846),
    [anon_sym_struct] = ACTIONS(1846),
    [anon_sym_trait] = ACTIONS(1846),
    [anon_sym_type] = ACTIONS(1846),
    [anon_sym_union] = ACTIONS(1846),
    [anon_sym_unsafe] = ACTIONS(1846),
    [anon_sym_use] = ACTIONS(1846),
    [anon_sym_while] = ACTIONS(1846),
    [anon_sym_extern] = ACTIONS(1846),
    [anon_sym_yield] = ACTIONS(1846),
    [anon_sym_move] = ACTIONS(1846),
    [anon_sym_try] = ACTIONS(1846),
    [sym_integer_literal] = ACTIONS(1844),
    [aux_sym_string_literal_token1] = ACTIONS(1844),
    [sym_char_literal] = ACTIONS(1844),
    [anon_sym_true] = ACTIONS(1846),
    [anon_sym_false] = ACTIONS(1846),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1846),
    [sym_super] = ACTIONS(1846),
    [sym_crate] = ACTIONS(1846),
    [sym_metavariable] = ACTIONS(1844),
    [sym__raw_string_literal_start] = ACTIONS(1844),
    [sym_float_literal] = ACTIONS(1844),
  },
  [510] = {
    [sym_line_comment] = STATE(510),
    [sym_block_comment] = STATE(510),
    [ts_builtin_sym_end] = ACTIONS(1848),
    [sym_identifier] = ACTIONS(1850),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_macro_rules_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [anon_sym_LBRACK] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_u8] = ACTIONS(1850),
    [anon_sym_i8] = ACTIONS(1850),
    [anon_sym_u16] = ACTIONS(1850),
    [anon_sym_i16] = ACTIONS(1850),
    [anon_sym_u32] = ACTIONS(1850),
    [anon_sym_i32] = ACTIONS(1850),
    [anon_sym_u64] = ACTIONS(1850),
    [anon_sym_i64] = ACTIONS(1850),
    [anon_sym_u128] = ACTIONS(1850),
    [anon_sym_i128] = ACTIONS(1850),
    [anon_sym_isize] = ACTIONS(1850),
    [anon_sym_usize] = ACTIONS(1850),
    [anon_sym_f32] = ACTIONS(1850),
    [anon_sym_f64] = ACTIONS(1850),
    [anon_sym_bool] = ACTIONS(1850),
    [anon_sym_str] = ACTIONS(1850),
    [anon_sym_char] = ACTIONS(1850),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_DOT_DOT] = ACTIONS(1848),
    [anon_sym_COLON_COLON] = ACTIONS(1848),
    [anon_sym_POUND] = ACTIONS(1848),
    [anon_sym_SQUOTE] = ACTIONS(1850),
    [anon_sym_async] = ACTIONS(1850),
    [anon_sym_break] = ACTIONS(1850),
    [anon_sym_const] = ACTIONS(1850),
    [anon_sym_continue] = ACTIONS(1850),
    [anon_sym_default] = ACTIONS(1850),
    [anon_sym_enum] = ACTIONS(1850),
    [anon_sym_fn] = ACTIONS(1850),
    [anon_sym_for] = ACTIONS(1850),
    [anon_sym_if] = ACTIONS(1850),
    [anon_sym_impl] = ACTIONS(1850),
    [anon_sym_let] = ACTIONS(1850),
    [anon_sym_loop] = ACTIONS(1850),
    [anon_sym_match] = ACTIONS(1850),
    [anon_sym_mod] = ACTIONS(1850),
    [anon_sym_pub] = ACTIONS(1850),
    [anon_sym_return] = ACTIONS(1850),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_struct] = ACTIONS(1850),
    [anon_sym_trait] = ACTIONS(1850),
    [anon_sym_type] = ACTIONS(1850),
    [anon_sym_union] = ACTIONS(1850),
    [anon_sym_unsafe] = ACTIONS(1850),
    [anon_sym_use] = ACTIONS(1850),
    [anon_sym_while] = ACTIONS(1850),
    [anon_sym_extern] = ACTIONS(1850),
    [anon_sym_yield] = ACTIONS(1850),
    [anon_sym_move] = ACTIONS(1850),
    [anon_sym_try] = ACTIONS(1850),
    [sym_integer_literal] = ACTIONS(1848),
    [aux_sym_string_literal_token1] = ACTIONS(1848),
    [sym_char_literal] = ACTIONS(1848),
    [anon_sym_true] = ACTIONS(1850),
    [anon_sym_false] = ACTIONS(1850),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1850),
    [sym_super] = ACTIONS(1850),
    [sym_crate] = ACTIONS(1850),
    [sym_metavariable] = ACTIONS(1848),
    [sym__raw_string_literal_start] = ACTIONS(1848),
    [sym_float_literal] = ACTIONS(1848),
  },
  [511] = {
    [sym_line_comment] = STATE(511),
    [sym_block_comment] = STATE(511),
    [ts_builtin_sym_end] = ACTIONS(1852),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_macro_rules_BANG] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_u8] = ACTIONS(1854),
    [anon_sym_i8] = ACTIONS(1854),
    [anon_sym_u16] = ACTIONS(1854),
    [anon_sym_i16] = ACTIONS(1854),
    [anon_sym_u32] = ACTIONS(1854),
    [anon_sym_i32] = ACTIONS(1854),
    [anon_sym_u64] = ACTIONS(1854),
    [anon_sym_i64] = ACTIONS(1854),
    [anon_sym_u128] = ACTIONS(1854),
    [anon_sym_i128] = ACTIONS(1854),
    [anon_sym_isize] = ACTIONS(1854),
    [anon_sym_usize] = ACTIONS(1854),
    [anon_sym_f32] = ACTIONS(1854),
    [anon_sym_f64] = ACTIONS(1854),
    [anon_sym_bool] = ACTIONS(1854),
    [anon_sym_str] = ACTIONS(1854),
    [anon_sym_char] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1852),
    [anon_sym_PIPE] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1852),
    [anon_sym_DOT_DOT] = ACTIONS(1852),
    [anon_sym_COLON_COLON] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1854),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_break] = ACTIONS(1854),
    [anon_sym_const] = ACTIONS(1854),
    [anon_sym_continue] = ACTIONS(1854),
    [anon_sym_default] = ACTIONS(1854),
    [anon_sym_enum] = ACTIONS(1854),
    [anon_sym_fn] = ACTIONS(1854),
    [anon_sym_for] = ACTIONS(1854),
    [anon_sym_if] = ACTIONS(1854),
    [anon_sym_impl] = ACTIONS(1854),
    [anon_sym_let] = ACTIONS(1854),
    [anon_sym_loop] = ACTIONS(1854),
    [anon_sym_match] = ACTIONS(1854),
    [anon_sym_mod] = ACTIONS(1854),
    [anon_sym_pub] = ACTIONS(1854),
    [anon_sym_return] = ACTIONS(1854),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_struct] = ACTIONS(1854),
    [anon_sym_trait] = ACTIONS(1854),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_union] = ACTIONS(1854),
    [anon_sym_unsafe] = ACTIONS(1854),
    [anon_sym_use] = ACTIONS(1854),
    [anon_sym_while] = ACTIONS(1854),
    [anon_sym_extern] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1854),
    [anon_sym_move] = ACTIONS(1854),
    [anon_sym_try] = ACTIONS(1854),
    [sym_integer_literal] = ACTIONS(1852),
    [aux_sym_string_literal_token1] = ACTIONS(1852),
    [sym_char_literal] = ACTIONS(1852),
    [anon_sym_true] = ACTIONS(1854),
    [anon_sym_false] = ACTIONS(1854),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1854),
    [sym_super] = ACTIONS(1854),
    [sym_crate] = ACTIONS(1854),
    [sym_metavariable] = ACTIONS(1852),
    [sym__raw_string_literal_start] = ACTIONS(1852),
    [sym_float_literal] = ACTIONS(1852),
  },
  [512] = {
    [sym_line_comment] = STATE(512),
    [sym_block_comment] = STATE(512),
    [ts_builtin_sym_end] = ACTIONS(1856),
    [sym_identifier] = ACTIONS(1858),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_macro_rules_BANG] = ACTIONS(1856),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_u8] = ACTIONS(1858),
    [anon_sym_i8] = ACTIONS(1858),
    [anon_sym_u16] = ACTIONS(1858),
    [anon_sym_i16] = ACTIONS(1858),
    [anon_sym_u32] = ACTIONS(1858),
    [anon_sym_i32] = ACTIONS(1858),
    [anon_sym_u64] = ACTIONS(1858),
    [anon_sym_i64] = ACTIONS(1858),
    [anon_sym_u128] = ACTIONS(1858),
    [anon_sym_i128] = ACTIONS(1858),
    [anon_sym_isize] = ACTIONS(1858),
    [anon_sym_usize] = ACTIONS(1858),
    [anon_sym_f32] = ACTIONS(1858),
    [anon_sym_f64] = ACTIONS(1858),
    [anon_sym_bool] = ACTIONS(1858),
    [anon_sym_str] = ACTIONS(1858),
    [anon_sym_char] = ACTIONS(1858),
    [anon_sym_DASH] = ACTIONS(1856),
    [anon_sym_BANG] = ACTIONS(1856),
    [anon_sym_AMP] = ACTIONS(1856),
    [anon_sym_PIPE] = ACTIONS(1856),
    [anon_sym_LT] = ACTIONS(1856),
    [anon_sym_DOT_DOT] = ACTIONS(1856),
    [anon_sym_COLON_COLON] = ACTIONS(1856),
    [anon_sym_POUND] = ACTIONS(1856),
    [anon_sym_SQUOTE] = ACTIONS(1858),
    [anon_sym_async] = ACTIONS(1858),
    [anon_sym_break] = ACTIONS(1858),
    [anon_sym_const] = ACTIONS(1858),
    [anon_sym_continue] = ACTIONS(1858),
    [anon_sym_default] = ACTIONS(1858),
    [anon_sym_enum] = ACTIONS(1858),
    [anon_sym_fn] = ACTIONS(1858),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_if] = ACTIONS(1858),
    [anon_sym_impl] = ACTIONS(1858),
    [anon_sym_let] = ACTIONS(1858),
    [anon_sym_loop] = ACTIONS(1858),
    [anon_sym_match] = ACTIONS(1858),
    [anon_sym_mod] = ACTIONS(1858),
    [anon_sym_pub] = ACTIONS(1858),
    [anon_sym_return] = ACTIONS(1858),
    [anon_sym_static] = ACTIONS(1858),
    [anon_sym_struct] = ACTIONS(1858),
    [anon_sym_trait] = ACTIONS(1858),
    [anon_sym_type] = ACTIONS(1858),
    [anon_sym_union] = ACTIONS(1858),
    [anon_sym_unsafe] = ACTIONS(1858),
    [anon_sym_use] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1858),
    [anon_sym_extern] = ACTIONS(1858),
    [anon_sym_yield] = ACTIONS(1858),
    [anon_sym_move] = ACTIONS(1858),
    [anon_sym_try] = ACTIONS(1858),
    [sym_integer_literal] = ACTIONS(1856),
    [aux_sym_string_literal_token1] = ACTIONS(1856),
    [sym_char_literal] = ACTIONS(1856),
    [anon_sym_true] = ACTIONS(1858),
    [anon_sym_false] = ACTIONS(1858),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1858),
    [sym_super] = ACTIONS(1858),
    [sym_crate] = ACTIONS(1858),
    [sym_metavariable] = ACTIONS(1856),
    [sym__raw_string_literal_start] = ACTIONS(1856),
    [sym_float_literal] = ACTIONS(1856),
  },
  [513] = {
    [sym_line_comment] = STATE(513),
    [sym_block_comment] = STATE(513),
    [ts_builtin_sym_end] = ACTIONS(1860),
    [sym_identifier] = ACTIONS(1862),
    [anon_sym_SEMI] = ACTIONS(1860),
    [anon_sym_macro_rules_BANG] = ACTIONS(1860),
    [anon_sym_LPAREN] = ACTIONS(1860),
    [anon_sym_LBRACK] = ACTIONS(1860),
    [anon_sym_LBRACE] = ACTIONS(1860),
    [anon_sym_RBRACE] = ACTIONS(1860),
    [anon_sym_STAR] = ACTIONS(1860),
    [anon_sym_u8] = ACTIONS(1862),
    [anon_sym_i8] = ACTIONS(1862),
    [anon_sym_u16] = ACTIONS(1862),
    [anon_sym_i16] = ACTIONS(1862),
    [anon_sym_u32] = ACTIONS(1862),
    [anon_sym_i32] = ACTIONS(1862),
    [anon_sym_u64] = ACTIONS(1862),
    [anon_sym_i64] = ACTIONS(1862),
    [anon_sym_u128] = ACTIONS(1862),
    [anon_sym_i128] = ACTIONS(1862),
    [anon_sym_isize] = ACTIONS(1862),
    [anon_sym_usize] = ACTIONS(1862),
    [anon_sym_f32] = ACTIONS(1862),
    [anon_sym_f64] = ACTIONS(1862),
    [anon_sym_bool] = ACTIONS(1862),
    [anon_sym_str] = ACTIONS(1862),
    [anon_sym_char] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(1860),
    [anon_sym_PIPE] = ACTIONS(1860),
    [anon_sym_LT] = ACTIONS(1860),
    [anon_sym_DOT_DOT] = ACTIONS(1860),
    [anon_sym_COLON_COLON] = ACTIONS(1860),
    [anon_sym_POUND] = ACTIONS(1860),
    [anon_sym_SQUOTE] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_break] = ACTIONS(1862),
    [anon_sym_const] = ACTIONS(1862),
    [anon_sym_continue] = ACTIONS(1862),
    [anon_sym_default] = ACTIONS(1862),
    [anon_sym_enum] = ACTIONS(1862),
    [anon_sym_fn] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_impl] = ACTIONS(1862),
    [anon_sym_let] = ACTIONS(1862),
    [anon_sym_loop] = ACTIONS(1862),
    [anon_sym_match] = ACTIONS(1862),
    [anon_sym_mod] = ACTIONS(1862),
    [anon_sym_pub] = ACTIONS(1862),
    [anon_sym_return] = ACTIONS(1862),
    [anon_sym_static] = ACTIONS(1862),
    [anon_sym_struct] = ACTIONS(1862),
    [anon_sym_trait] = ACTIONS(1862),
    [anon_sym_type] = ACTIONS(1862),
    [anon_sym_union] = ACTIONS(1862),
    [anon_sym_unsafe] = ACTIONS(1862),
    [anon_sym_use] = ACTIONS(1862),
    [anon_sym_while] = ACTIONS(1862),
    [anon_sym_extern] = ACTIONS(1862),
    [anon_sym_yield] = ACTIONS(1862),
    [anon_sym_move] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1862),
    [sym_integer_literal] = ACTIONS(1860),
    [aux_sym_string_literal_token1] = ACTIONS(1860),
    [sym_char_literal] = ACTIONS(1860),
    [anon_sym_true] = ACTIONS(1862),
    [anon_sym_false] = ACTIONS(1862),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1862),
    [sym_super] = ACTIONS(1862),
    [sym_crate] = ACTIONS(1862),
    [sym_metavariable] = ACTIONS(1860),
    [sym__raw_string_literal_start] = ACTIONS(1860),
    [sym_float_literal] = ACTIONS(1860),
  },
  [514] = {
    [sym_line_comment] = STATE(514),
    [sym_block_comment] = STATE(514),
    [ts_builtin_sym_end] = ACTIONS(1864),
    [sym_identifier] = ACTIONS(1866),
    [anon_sym_SEMI] = ACTIONS(1864),
    [anon_sym_macro_rules_BANG] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(1864),
    [anon_sym_LBRACK] = ACTIONS(1864),
    [anon_sym_LBRACE] = ACTIONS(1864),
    [anon_sym_RBRACE] = ACTIONS(1864),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_u8] = ACTIONS(1866),
    [anon_sym_i8] = ACTIONS(1866),
    [anon_sym_u16] = ACTIONS(1866),
    [anon_sym_i16] = ACTIONS(1866),
    [anon_sym_u32] = ACTIONS(1866),
    [anon_sym_i32] = ACTIONS(1866),
    [anon_sym_u64] = ACTIONS(1866),
    [anon_sym_i64] = ACTIONS(1866),
    [anon_sym_u128] = ACTIONS(1866),
    [anon_sym_i128] = ACTIONS(1866),
    [anon_sym_isize] = ACTIONS(1866),
    [anon_sym_usize] = ACTIONS(1866),
    [anon_sym_f32] = ACTIONS(1866),
    [anon_sym_f64] = ACTIONS(1866),
    [anon_sym_bool] = ACTIONS(1866),
    [anon_sym_str] = ACTIONS(1866),
    [anon_sym_char] = ACTIONS(1866),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_BANG] = ACTIONS(1864),
    [anon_sym_AMP] = ACTIONS(1864),
    [anon_sym_PIPE] = ACTIONS(1864),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_DOT_DOT] = ACTIONS(1864),
    [anon_sym_COLON_COLON] = ACTIONS(1864),
    [anon_sym_POUND] = ACTIONS(1864),
    [anon_sym_SQUOTE] = ACTIONS(1866),
    [anon_sym_async] = ACTIONS(1866),
    [anon_sym_break] = ACTIONS(1866),
    [anon_sym_const] = ACTIONS(1866),
    [anon_sym_continue] = ACTIONS(1866),
    [anon_sym_default] = ACTIONS(1866),
    [anon_sym_enum] = ACTIONS(1866),
    [anon_sym_fn] = ACTIONS(1866),
    [anon_sym_for] = ACTIONS(1866),
    [anon_sym_if] = ACTIONS(1866),
    [anon_sym_impl] = ACTIONS(1866),
    [anon_sym_let] = ACTIONS(1866),
    [anon_sym_loop] = ACTIONS(1866),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_mod] = ACTIONS(1866),
    [anon_sym_pub] = ACTIONS(1866),
    [anon_sym_return] = ACTIONS(1866),
    [anon_sym_static] = ACTIONS(1866),
    [anon_sym_struct] = ACTIONS(1866),
    [anon_sym_trait] = ACTIONS(1866),
    [anon_sym_type] = ACTIONS(1866),
    [anon_sym_union] = ACTIONS(1866),
    [anon_sym_unsafe] = ACTIONS(1866),
    [anon_sym_use] = ACTIONS(1866),
    [anon_sym_while] = ACTIONS(1866),
    [anon_sym_extern] = ACTIONS(1866),
    [anon_sym_yield] = ACTIONS(1866),
    [anon_sym_move] = ACTIONS(1866),
    [anon_sym_try] = ACTIONS(1866),
    [sym_integer_literal] = ACTIONS(1864),
    [aux_sym_string_literal_token1] = ACTIONS(1864),
    [sym_char_literal] = ACTIONS(1864),
    [anon_sym_true] = ACTIONS(1866),
    [anon_sym_false] = ACTIONS(1866),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1866),
    [sym_super] = ACTIONS(1866),
    [sym_crate] = ACTIONS(1866),
    [sym_metavariable] = ACTIONS(1864),
    [sym__raw_string_literal_start] = ACTIONS(1864),
    [sym_float_literal] = ACTIONS(1864),
  },
  [515] = {
    [sym_line_comment] = STATE(515),
    [sym_block_comment] = STATE(515),
    [ts_builtin_sym_end] = ACTIONS(1868),
    [sym_identifier] = ACTIONS(1870),
    [anon_sym_SEMI] = ACTIONS(1868),
    [anon_sym_macro_rules_BANG] = ACTIONS(1868),
    [anon_sym_LPAREN] = ACTIONS(1868),
    [anon_sym_LBRACK] = ACTIONS(1868),
    [anon_sym_LBRACE] = ACTIONS(1868),
    [anon_sym_RBRACE] = ACTIONS(1868),
    [anon_sym_STAR] = ACTIONS(1868),
    [anon_sym_u8] = ACTIONS(1870),
    [anon_sym_i8] = ACTIONS(1870),
    [anon_sym_u16] = ACTIONS(1870),
    [anon_sym_i16] = ACTIONS(1870),
    [anon_sym_u32] = ACTIONS(1870),
    [anon_sym_i32] = ACTIONS(1870),
    [anon_sym_u64] = ACTIONS(1870),
    [anon_sym_i64] = ACTIONS(1870),
    [anon_sym_u128] = ACTIONS(1870),
    [anon_sym_i128] = ACTIONS(1870),
    [anon_sym_isize] = ACTIONS(1870),
    [anon_sym_usize] = ACTIONS(1870),
    [anon_sym_f32] = ACTIONS(1870),
    [anon_sym_f64] = ACTIONS(1870),
    [anon_sym_bool] = ACTIONS(1870),
    [anon_sym_str] = ACTIONS(1870),
    [anon_sym_char] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1868),
    [anon_sym_AMP] = ACTIONS(1868),
    [anon_sym_PIPE] = ACTIONS(1868),
    [anon_sym_LT] = ACTIONS(1868),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_COLON_COLON] = ACTIONS(1868),
    [anon_sym_POUND] = ACTIONS(1868),
    [anon_sym_SQUOTE] = ACTIONS(1870),
    [anon_sym_async] = ACTIONS(1870),
    [anon_sym_break] = ACTIONS(1870),
    [anon_sym_const] = ACTIONS(1870),
    [anon_sym_continue] = ACTIONS(1870),
    [anon_sym_default] = ACTIONS(1870),
    [anon_sym_enum] = ACTIONS(1870),
    [anon_sym_fn] = ACTIONS(1870),
    [anon_sym_for] = ACTIONS(1870),
    [anon_sym_if] = ACTIONS(1870),
    [anon_sym_impl] = ACTIONS(1870),
    [anon_sym_let] = ACTIONS(1870),
    [anon_sym_loop] = ACTIONS(1870),
    [anon_sym_match] = ACTIONS(1870),
    [anon_sym_mod] = ACTIONS(1870),
    [anon_sym_pub] = ACTIONS(1870),
    [anon_sym_return] = ACTIONS(1870),
    [anon_sym_static] = ACTIONS(1870),
    [anon_sym_struct] = ACTIONS(1870),
    [anon_sym_trait] = ACTIONS(1870),
    [anon_sym_type] = ACTIONS(1870),
    [anon_sym_union] = ACTIONS(1870),
    [anon_sym_unsafe] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1870),
    [anon_sym_while] = ACTIONS(1870),
    [anon_sym_extern] = ACTIONS(1870),
    [anon_sym_yield] = ACTIONS(1870),
    [anon_sym_move] = ACTIONS(1870),
    [anon_sym_try] = ACTIONS(1870),
    [sym_integer_literal] = ACTIONS(1868),
    [aux_sym_string_literal_token1] = ACTIONS(1868),
    [sym_char_literal] = ACTIONS(1868),
    [anon_sym_true] = ACTIONS(1870),
    [anon_sym_false] = ACTIONS(1870),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1870),
    [sym_super] = ACTIONS(1870),
    [sym_crate] = ACTIONS(1870),
    [sym_metavariable] = ACTIONS(1868),
    [sym__raw_string_literal_start] = ACTIONS(1868),
    [sym_float_literal] = ACTIONS(1868),
  },
  [516] = {
    [sym_line_comment] = STATE(516),
    [sym_block_comment] = STATE(516),
    [ts_builtin_sym_end] = ACTIONS(1872),
    [sym_identifier] = ACTIONS(1874),
    [anon_sym_SEMI] = ACTIONS(1872),
    [anon_sym_macro_rules_BANG] = ACTIONS(1872),
    [anon_sym_LPAREN] = ACTIONS(1872),
    [anon_sym_LBRACK] = ACTIONS(1872),
    [anon_sym_LBRACE] = ACTIONS(1872),
    [anon_sym_RBRACE] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1872),
    [anon_sym_u8] = ACTIONS(1874),
    [anon_sym_i8] = ACTIONS(1874),
    [anon_sym_u16] = ACTIONS(1874),
    [anon_sym_i16] = ACTIONS(1874),
    [anon_sym_u32] = ACTIONS(1874),
    [anon_sym_i32] = ACTIONS(1874),
    [anon_sym_u64] = ACTIONS(1874),
    [anon_sym_i64] = ACTIONS(1874),
    [anon_sym_u128] = ACTIONS(1874),
    [anon_sym_i128] = ACTIONS(1874),
    [anon_sym_isize] = ACTIONS(1874),
    [anon_sym_usize] = ACTIONS(1874),
    [anon_sym_f32] = ACTIONS(1874),
    [anon_sym_f64] = ACTIONS(1874),
    [anon_sym_bool] = ACTIONS(1874),
    [anon_sym_str] = ACTIONS(1874),
    [anon_sym_char] = ACTIONS(1874),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_BANG] = ACTIONS(1872),
    [anon_sym_AMP] = ACTIONS(1872),
    [anon_sym_PIPE] = ACTIONS(1872),
    [anon_sym_LT] = ACTIONS(1872),
    [anon_sym_DOT_DOT] = ACTIONS(1872),
    [anon_sym_COLON_COLON] = ACTIONS(1872),
    [anon_sym_POUND] = ACTIONS(1872),
    [anon_sym_SQUOTE] = ACTIONS(1874),
    [anon_sym_async] = ACTIONS(1874),
    [anon_sym_break] = ACTIONS(1874),
    [anon_sym_const] = ACTIONS(1874),
    [anon_sym_continue] = ACTIONS(1874),
    [anon_sym_default] = ACTIONS(1874),
    [anon_sym_enum] = ACTIONS(1874),
    [anon_sym_fn] = ACTIONS(1874),
    [anon_sym_for] = ACTIONS(1874),
    [anon_sym_if] = ACTIONS(1874),
    [anon_sym_impl] = ACTIONS(1874),
    [anon_sym_let] = ACTIONS(1874),
    [anon_sym_loop] = ACTIONS(1874),
    [anon_sym_match] = ACTIONS(1874),
    [anon_sym_mod] = ACTIONS(1874),
    [anon_sym_pub] = ACTIONS(1874),
    [anon_sym_return] = ACTIONS(1874),
    [anon_sym_static] = ACTIONS(1874),
    [anon_sym_struct] = ACTIONS(1874),
    [anon_sym_trait] = ACTIONS(1874),
    [anon_sym_type] = ACTIONS(1874),
    [anon_sym_union] = ACTIONS(1874),
    [anon_sym_unsafe] = ACTIONS(1874),
    [anon_sym_use] = ACTIONS(1874),
    [anon_sym_while] = ACTIONS(1874),
    [anon_sym_extern] = ACTIONS(1874),
    [anon_sym_yield] = ACTIONS(1874),
    [anon_sym_move] = ACTIONS(1874),
    [anon_sym_try] = ACTIONS(1874),
    [sym_integer_literal] = ACTIONS(1872),
    [aux_sym_string_literal_token1] = ACTIONS(1872),
    [sym_char_literal] = ACTIONS(1872),
    [anon_sym_true] = ACTIONS(1874),
    [anon_sym_false] = ACTIONS(1874),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1874),
    [sym_super] = ACTIONS(1874),
    [sym_crate] = ACTIONS(1874),
    [sym_metavariable] = ACTIONS(1872),
    [sym__raw_string_literal_start] = ACTIONS(1872),
    [sym_float_literal] = ACTIONS(1872),
  },
  [517] = {
    [sym_line_comment] = STATE(517),
    [sym_block_comment] = STATE(517),
    [ts_builtin_sym_end] = ACTIONS(1876),
    [sym_identifier] = ACTIONS(1878),
    [anon_sym_SEMI] = ACTIONS(1876),
    [anon_sym_macro_rules_BANG] = ACTIONS(1876),
    [anon_sym_LPAREN] = ACTIONS(1876),
    [anon_sym_LBRACK] = ACTIONS(1876),
    [anon_sym_LBRACE] = ACTIONS(1876),
    [anon_sym_RBRACE] = ACTIONS(1876),
    [anon_sym_STAR] = ACTIONS(1876),
    [anon_sym_u8] = ACTIONS(1878),
    [anon_sym_i8] = ACTIONS(1878),
    [anon_sym_u16] = ACTIONS(1878),
    [anon_sym_i16] = ACTIONS(1878),
    [anon_sym_u32] = ACTIONS(1878),
    [anon_sym_i32] = ACTIONS(1878),
    [anon_sym_u64] = ACTIONS(1878),
    [anon_sym_i64] = ACTIONS(1878),
    [anon_sym_u128] = ACTIONS(1878),
    [anon_sym_i128] = ACTIONS(1878),
    [anon_sym_isize] = ACTIONS(1878),
    [anon_sym_usize] = ACTIONS(1878),
    [anon_sym_f32] = ACTIONS(1878),
    [anon_sym_f64] = ACTIONS(1878),
    [anon_sym_bool] = ACTIONS(1878),
    [anon_sym_str] = ACTIONS(1878),
    [anon_sym_char] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1876),
    [anon_sym_PIPE] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_DOT_DOT] = ACTIONS(1876),
    [anon_sym_COLON_COLON] = ACTIONS(1876),
    [anon_sym_POUND] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(1878),
    [anon_sym_async] = ACTIONS(1878),
    [anon_sym_break] = ACTIONS(1878),
    [anon_sym_const] = ACTIONS(1878),
    [anon_sym_continue] = ACTIONS(1878),
    [anon_sym_default] = ACTIONS(1878),
    [anon_sym_enum] = ACTIONS(1878),
    [anon_sym_fn] = ACTIONS(1878),
    [anon_sym_for] = ACTIONS(1878),
    [anon_sym_if] = ACTIONS(1878),
    [anon_sym_impl] = ACTIONS(1878),
    [anon_sym_let] = ACTIONS(1878),
    [anon_sym_loop] = ACTIONS(1878),
    [anon_sym_match] = ACTIONS(1878),
    [anon_sym_mod] = ACTIONS(1878),
    [anon_sym_pub] = ACTIONS(1878),
    [anon_sym_return] = ACTIONS(1878),
    [anon_sym_static] = ACTIONS(1878),
    [anon_sym_struct] = ACTIONS(1878),
    [anon_sym_trait] = ACTIONS(1878),
    [anon_sym_type] = ACTIONS(1878),
    [anon_sym_union] = ACTIONS(1878),
    [anon_sym_unsafe] = ACTIONS(1878),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_while] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(1878),
    [anon_sym_yield] = ACTIONS(1878),
    [anon_sym_move] = ACTIONS(1878),
    [anon_sym_try] = ACTIONS(1878),
    [sym_integer_literal] = ACTIONS(1876),
    [aux_sym_string_literal_token1] = ACTIONS(1876),
    [sym_char_literal] = ACTIONS(1876),
    [anon_sym_true] = ACTIONS(1878),
    [anon_sym_false] = ACTIONS(1878),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1878),
    [sym_super] = ACTIONS(1878),
    [sym_crate] = ACTIONS(1878),
    [sym_metavariable] = ACTIONS(1876),
    [sym__raw_string_literal_start] = ACTIONS(1876),
    [sym_float_literal] = ACTIONS(1876),
  },
  [518] = {
    [sym_line_comment] = STATE(518),
    [sym_block_comment] = STATE(518),
    [ts_builtin_sym_end] = ACTIONS(1880),
    [sym_identifier] = ACTIONS(1882),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_macro_rules_BANG] = ACTIONS(1880),
    [anon_sym_LPAREN] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(1880),
    [anon_sym_LBRACE] = ACTIONS(1880),
    [anon_sym_RBRACE] = ACTIONS(1880),
    [anon_sym_STAR] = ACTIONS(1880),
    [anon_sym_u8] = ACTIONS(1882),
    [anon_sym_i8] = ACTIONS(1882),
    [anon_sym_u16] = ACTIONS(1882),
    [anon_sym_i16] = ACTIONS(1882),
    [anon_sym_u32] = ACTIONS(1882),
    [anon_sym_i32] = ACTIONS(1882),
    [anon_sym_u64] = ACTIONS(1882),
    [anon_sym_i64] = ACTIONS(1882),
    [anon_sym_u128] = ACTIONS(1882),
    [anon_sym_i128] = ACTIONS(1882),
    [anon_sym_isize] = ACTIONS(1882),
    [anon_sym_usize] = ACTIONS(1882),
    [anon_sym_f32] = ACTIONS(1882),
    [anon_sym_f64] = ACTIONS(1882),
    [anon_sym_bool] = ACTIONS(1882),
    [anon_sym_str] = ACTIONS(1882),
    [anon_sym_char] = ACTIONS(1882),
    [anon_sym_DASH] = ACTIONS(1880),
    [anon_sym_BANG] = ACTIONS(1880),
    [anon_sym_AMP] = ACTIONS(1880),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1880),
    [anon_sym_DOT_DOT] = ACTIONS(1880),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_SQUOTE] = ACTIONS(1882),
    [anon_sym_async] = ACTIONS(1882),
    [anon_sym_break] = ACTIONS(1882),
    [anon_sym_const] = ACTIONS(1882),
    [anon_sym_continue] = ACTIONS(1882),
    [anon_sym_default] = ACTIONS(1882),
    [anon_sym_enum] = ACTIONS(1882),
    [anon_sym_fn] = ACTIONS(1882),
    [anon_sym_for] = ACTIONS(1882),
    [anon_sym_if] = ACTIONS(1882),
    [anon_sym_impl] = ACTIONS(1882),
    [anon_sym_let] = ACTIONS(1882),
    [anon_sym_loop] = ACTIONS(1882),
    [anon_sym_match] = ACTIONS(1882),
    [anon_sym_mod] = ACTIONS(1882),
    [anon_sym_pub] = ACTIONS(1882),
    [anon_sym_return] = ACTIONS(1882),
    [anon_sym_static] = ACTIONS(1882),
    [anon_sym_struct] = ACTIONS(1882),
    [anon_sym_trait] = ACTIONS(1882),
    [anon_sym_type] = ACTIONS(1882),
    [anon_sym_union] = ACTIONS(1882),
    [anon_sym_unsafe] = ACTIONS(1882),
    [anon_sym_use] = ACTIONS(1882),
    [anon_sym_while] = ACTIONS(1882),
    [anon_sym_extern] = ACTIONS(1882),
    [anon_sym_yield] = ACTIONS(1882),
    [anon_sym_move] = ACTIONS(1882),
    [anon_sym_try] = ACTIONS(1882),
    [sym_integer_literal] = ACTIONS(1880),
    [aux_sym_string_literal_token1] = ACTIONS(1880),
    [sym_char_literal] = ACTIONS(1880),
    [anon_sym_true] = ACTIONS(1882),
    [anon_sym_false] = ACTIONS(1882),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1882),
    [sym_super] = ACTIONS(1882),
    [sym_crate] = ACTIONS(1882),
    [sym_metavariable] = ACTIONS(1880),
    [sym__raw_string_literal_start] = ACTIONS(1880),
    [sym_float_literal] = ACTIONS(1880),
  },
  [519] = {
    [sym_line_comment] = STATE(519),
    [sym_block_comment] = STATE(519),
    [ts_builtin_sym_end] = ACTIONS(1884),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_macro_rules_BANG] = ACTIONS(1884),
    [anon_sym_LPAREN] = ACTIONS(1884),
    [anon_sym_LBRACK] = ACTIONS(1884),
    [anon_sym_LBRACE] = ACTIONS(1884),
    [anon_sym_RBRACE] = ACTIONS(1884),
    [anon_sym_STAR] = ACTIONS(1884),
    [anon_sym_u8] = ACTIONS(1886),
    [anon_sym_i8] = ACTIONS(1886),
    [anon_sym_u16] = ACTIONS(1886),
    [anon_sym_i16] = ACTIONS(1886),
    [anon_sym_u32] = ACTIONS(1886),
    [anon_sym_i32] = ACTIONS(1886),
    [anon_sym_u64] = ACTIONS(1886),
    [anon_sym_i64] = ACTIONS(1886),
    [anon_sym_u128] = ACTIONS(1886),
    [anon_sym_i128] = ACTIONS(1886),
    [anon_sym_isize] = ACTIONS(1886),
    [anon_sym_usize] = ACTIONS(1886),
    [anon_sym_f32] = ACTIONS(1886),
    [anon_sym_f64] = ACTIONS(1886),
    [anon_sym_bool] = ACTIONS(1886),
    [anon_sym_str] = ACTIONS(1886),
    [anon_sym_char] = ACTIONS(1886),
    [anon_sym_DASH] = ACTIONS(1884),
    [anon_sym_BANG] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_DOT_DOT] = ACTIONS(1884),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_POUND] = ACTIONS(1884),
    [anon_sym_SQUOTE] = ACTIONS(1886),
    [anon_sym_async] = ACTIONS(1886),
    [anon_sym_break] = ACTIONS(1886),
    [anon_sym_const] = ACTIONS(1886),
    [anon_sym_continue] = ACTIONS(1886),
    [anon_sym_default] = ACTIONS(1886),
    [anon_sym_enum] = ACTIONS(1886),
    [anon_sym_fn] = ACTIONS(1886),
    [anon_sym_for] = ACTIONS(1886),
    [anon_sym_if] = ACTIONS(1886),
    [anon_sym_impl] = ACTIONS(1886),
    [anon_sym_let] = ACTIONS(1886),
    [anon_sym_loop] = ACTIONS(1886),
    [anon_sym_match] = ACTIONS(1886),
    [anon_sym_mod] = ACTIONS(1886),
    [anon_sym_pub] = ACTIONS(1886),
    [anon_sym_return] = ACTIONS(1886),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1886),
    [anon_sym_trait] = ACTIONS(1886),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_union] = ACTIONS(1886),
    [anon_sym_unsafe] = ACTIONS(1886),
    [anon_sym_use] = ACTIONS(1886),
    [anon_sym_while] = ACTIONS(1886),
    [anon_sym_extern] = ACTIONS(1886),
    [anon_sym_yield] = ACTIONS(1886),
    [anon_sym_move] = ACTIONS(1886),
    [anon_sym_try] = ACTIONS(1886),
    [sym_integer_literal] = ACTIONS(1884),
    [aux_sym_string_literal_token1] = ACTIONS(1884),
    [sym_char_literal] = ACTIONS(1884),
    [anon_sym_true] = ACTIONS(1886),
    [anon_sym_false] = ACTIONS(1886),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1886),
    [sym_super] = ACTIONS(1886),
    [sym_crate] = ACTIONS(1886),
    [sym_metavariable] = ACTIONS(1884),
    [sym__raw_string_literal_start] = ACTIONS(1884),
    [sym_float_literal] = ACTIONS(1884),
  },
  [520] = {
    [sym_line_comment] = STATE(520),
    [sym_block_comment] = STATE(520),
    [ts_builtin_sym_end] = ACTIONS(1888),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1888),
    [anon_sym_macro_rules_BANG] = ACTIONS(1888),
    [anon_sym_LPAREN] = ACTIONS(1888),
    [anon_sym_LBRACK] = ACTIONS(1888),
    [anon_sym_LBRACE] = ACTIONS(1888),
    [anon_sym_RBRACE] = ACTIONS(1888),
    [anon_sym_STAR] = ACTIONS(1888),
    [anon_sym_u8] = ACTIONS(1890),
    [anon_sym_i8] = ACTIONS(1890),
    [anon_sym_u16] = ACTIONS(1890),
    [anon_sym_i16] = ACTIONS(1890),
    [anon_sym_u32] = ACTIONS(1890),
    [anon_sym_i32] = ACTIONS(1890),
    [anon_sym_u64] = ACTIONS(1890),
    [anon_sym_i64] = ACTIONS(1890),
    [anon_sym_u128] = ACTIONS(1890),
    [anon_sym_i128] = ACTIONS(1890),
    [anon_sym_isize] = ACTIONS(1890),
    [anon_sym_usize] = ACTIONS(1890),
    [anon_sym_f32] = ACTIONS(1890),
    [anon_sym_f64] = ACTIONS(1890),
    [anon_sym_bool] = ACTIONS(1890),
    [anon_sym_str] = ACTIONS(1890),
    [anon_sym_char] = ACTIONS(1890),
    [anon_sym_DASH] = ACTIONS(1888),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_AMP] = ACTIONS(1888),
    [anon_sym_PIPE] = ACTIONS(1888),
    [anon_sym_LT] = ACTIONS(1888),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_COLON_COLON] = ACTIONS(1888),
    [anon_sym_POUND] = ACTIONS(1888),
    [anon_sym_SQUOTE] = ACTIONS(1890),
    [anon_sym_async] = ACTIONS(1890),
    [anon_sym_break] = ACTIONS(1890),
    [anon_sym_const] = ACTIONS(1890),
    [anon_sym_continue] = ACTIONS(1890),
    [anon_sym_default] = ACTIONS(1890),
    [anon_sym_enum] = ACTIONS(1890),
    [anon_sym_fn] = ACTIONS(1890),
    [anon_sym_for] = ACTIONS(1890),
    [anon_sym_if] = ACTIONS(1890),
    [anon_sym_impl] = ACTIONS(1890),
    [anon_sym_let] = ACTIONS(1890),
    [anon_sym_loop] = ACTIONS(1890),
    [anon_sym_match] = ACTIONS(1890),
    [anon_sym_mod] = ACTIONS(1890),
    [anon_sym_pub] = ACTIONS(1890),
    [anon_sym_return] = ACTIONS(1890),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_struct] = ACTIONS(1890),
    [anon_sym_trait] = ACTIONS(1890),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_union] = ACTIONS(1890),
    [anon_sym_unsafe] = ACTIONS(1890),
    [anon_sym_use] = ACTIONS(1890),
    [anon_sym_while] = ACTIONS(1890),
    [anon_sym_extern] = ACTIONS(1890),
    [anon_sym_yield] = ACTIONS(1890),
    [anon_sym_move] = ACTIONS(1890),
    [anon_sym_try] = ACTIONS(1890),
    [sym_integer_literal] = ACTIONS(1888),
    [aux_sym_string_literal_token1] = ACTIONS(1888),
    [sym_char_literal] = ACTIONS(1888),
    [anon_sym_true] = ACTIONS(1890),
    [anon_sym_false] = ACTIONS(1890),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1890),
    [sym_super] = ACTIONS(1890),
    [sym_crate] = ACTIONS(1890),
    [sym_metavariable] = ACTIONS(1888),
    [sym__raw_string_literal_start] = ACTIONS(1888),
    [sym_float_literal] = ACTIONS(1888),
  },
  [521] = {
    [sym_line_comment] = STATE(521),
    [sym_block_comment] = STATE(521),
    [ts_builtin_sym_end] = ACTIONS(1892),
    [sym_identifier] = ACTIONS(1894),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_macro_rules_BANG] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1892),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_RBRACE] = ACTIONS(1892),
    [anon_sym_STAR] = ACTIONS(1892),
    [anon_sym_u8] = ACTIONS(1894),
    [anon_sym_i8] = ACTIONS(1894),
    [anon_sym_u16] = ACTIONS(1894),
    [anon_sym_i16] = ACTIONS(1894),
    [anon_sym_u32] = ACTIONS(1894),
    [anon_sym_i32] = ACTIONS(1894),
    [anon_sym_u64] = ACTIONS(1894),
    [anon_sym_i64] = ACTIONS(1894),
    [anon_sym_u128] = ACTIONS(1894),
    [anon_sym_i128] = ACTIONS(1894),
    [anon_sym_isize] = ACTIONS(1894),
    [anon_sym_usize] = ACTIONS(1894),
    [anon_sym_f32] = ACTIONS(1894),
    [anon_sym_f64] = ACTIONS(1894),
    [anon_sym_bool] = ACTIONS(1894),
    [anon_sym_str] = ACTIONS(1894),
    [anon_sym_char] = ACTIONS(1894),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_BANG] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_DOT_DOT] = ACTIONS(1892),
    [anon_sym_COLON_COLON] = ACTIONS(1892),
    [anon_sym_POUND] = ACTIONS(1892),
    [anon_sym_SQUOTE] = ACTIONS(1894),
    [anon_sym_async] = ACTIONS(1894),
    [anon_sym_break] = ACTIONS(1894),
    [anon_sym_const] = ACTIONS(1894),
    [anon_sym_continue] = ACTIONS(1894),
    [anon_sym_default] = ACTIONS(1894),
    [anon_sym_enum] = ACTIONS(1894),
    [anon_sym_fn] = ACTIONS(1894),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_if] = ACTIONS(1894),
    [anon_sym_impl] = ACTIONS(1894),
    [anon_sym_let] = ACTIONS(1894),
    [anon_sym_loop] = ACTIONS(1894),
    [anon_sym_match] = ACTIONS(1894),
    [anon_sym_mod] = ACTIONS(1894),
    [anon_sym_pub] = ACTIONS(1894),
    [anon_sym_return] = ACTIONS(1894),
    [anon_sym_static] = ACTIONS(1894),
    [anon_sym_struct] = ACTIONS(1894),
    [anon_sym_trait] = ACTIONS(1894),
    [anon_sym_type] = ACTIONS(1894),
    [anon_sym_union] = ACTIONS(1894),
    [anon_sym_unsafe] = ACTIONS(1894),
    [anon_sym_use] = ACTIONS(1894),
    [anon_sym_while] = ACTIONS(1894),
    [anon_sym_extern] = ACTIONS(1894),
    [anon_sym_yield] = ACTIONS(1894),
    [anon_sym_move] = ACTIONS(1894),
    [anon_sym_try] = ACTIONS(1894),
    [sym_integer_literal] = ACTIONS(1892),
    [aux_sym_string_literal_token1] = ACTIONS(1892),
    [sym_char_literal] = ACTIONS(1892),
    [anon_sym_true] = ACTIONS(1894),
    [anon_sym_false] = ACTIONS(1894),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1894),
    [sym_super] = ACTIONS(1894),
    [sym_crate] = ACTIONS(1894),
    [sym_metavariable] = ACTIONS(1892),
    [sym__raw_string_literal_start] = ACTIONS(1892),
    [sym_float_literal] = ACTIONS(1892),
  },
  [522] = {
    [sym_line_comment] = STATE(522),
    [sym_block_comment] = STATE(522),
    [ts_builtin_sym_end] = ACTIONS(1896),
    [sym_identifier] = ACTIONS(1898),
    [anon_sym_SEMI] = ACTIONS(1896),
    [anon_sym_macro_rules_BANG] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1896),
    [anon_sym_LBRACE] = ACTIONS(1896),
    [anon_sym_RBRACE] = ACTIONS(1896),
    [anon_sym_STAR] = ACTIONS(1896),
    [anon_sym_u8] = ACTIONS(1898),
    [anon_sym_i8] = ACTIONS(1898),
    [anon_sym_u16] = ACTIONS(1898),
    [anon_sym_i16] = ACTIONS(1898),
    [anon_sym_u32] = ACTIONS(1898),
    [anon_sym_i32] = ACTIONS(1898),
    [anon_sym_u64] = ACTIONS(1898),
    [anon_sym_i64] = ACTIONS(1898),
    [anon_sym_u128] = ACTIONS(1898),
    [anon_sym_i128] = ACTIONS(1898),
    [anon_sym_isize] = ACTIONS(1898),
    [anon_sym_usize] = ACTIONS(1898),
    [anon_sym_f32] = ACTIONS(1898),
    [anon_sym_f64] = ACTIONS(1898),
    [anon_sym_bool] = ACTIONS(1898),
    [anon_sym_str] = ACTIONS(1898),
    [anon_sym_char] = ACTIONS(1898),
    [anon_sym_DASH] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1896),
    [anon_sym_AMP] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1896),
    [anon_sym_LT] = ACTIONS(1896),
    [anon_sym_DOT_DOT] = ACTIONS(1896),
    [anon_sym_COLON_COLON] = ACTIONS(1896),
    [anon_sym_POUND] = ACTIONS(1896),
    [anon_sym_SQUOTE] = ACTIONS(1898),
    [anon_sym_async] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(1898),
    [anon_sym_const] = ACTIONS(1898),
    [anon_sym_continue] = ACTIONS(1898),
    [anon_sym_default] = ACTIONS(1898),
    [anon_sym_enum] = ACTIONS(1898),
    [anon_sym_fn] = ACTIONS(1898),
    [anon_sym_for] = ACTIONS(1898),
    [anon_sym_if] = ACTIONS(1898),
    [anon_sym_impl] = ACTIONS(1898),
    [anon_sym_let] = ACTIONS(1898),
    [anon_sym_loop] = ACTIONS(1898),
    [anon_sym_match] = ACTIONS(1898),
    [anon_sym_mod] = ACTIONS(1898),
    [anon_sym_pub] = ACTIONS(1898),
    [anon_sym_return] = ACTIONS(1898),
    [anon_sym_static] = ACTIONS(1898),
    [anon_sym_struct] = ACTIONS(1898),
    [anon_sym_trait] = ACTIONS(1898),
    [anon_sym_type] = ACTIONS(1898),
    [anon_sym_union] = ACTIONS(1898),
    [anon_sym_unsafe] = ACTIONS(1898),
    [anon_sym_use] = ACTIONS(1898),
    [anon_sym_while] = ACTIONS(1898),
    [anon_sym_extern] = ACTIONS(1898),
    [anon_sym_yield] = ACTIONS(1898),
    [anon_sym_move] = ACTIONS(1898),
    [anon_sym_try] = ACTIONS(1898),
    [sym_integer_literal] = ACTIONS(1896),
    [aux_sym_string_literal_token1] = ACTIONS(1896),
    [sym_char_literal] = ACTIONS(1896),
    [anon_sym_true] = ACTIONS(1898),
    [anon_sym_false] = ACTIONS(1898),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1898),
    [sym_super] = ACTIONS(1898),
    [sym_crate] = ACTIONS(1898),
    [sym_metavariable] = ACTIONS(1896),
    [sym__raw_string_literal_start] = ACTIONS(1896),
    [sym_float_literal] = ACTIONS(1896),
  },
  [523] = {
    [sym_line_comment] = STATE(523),
    [sym_block_comment] = STATE(523),
    [ts_builtin_sym_end] = ACTIONS(1900),
    [sym_identifier] = ACTIONS(1902),
    [anon_sym_SEMI] = ACTIONS(1900),
    [anon_sym_macro_rules_BANG] = ACTIONS(1900),
    [anon_sym_LPAREN] = ACTIONS(1900),
    [anon_sym_LBRACK] = ACTIONS(1900),
    [anon_sym_LBRACE] = ACTIONS(1900),
    [anon_sym_RBRACE] = ACTIONS(1900),
    [anon_sym_STAR] = ACTIONS(1900),
    [anon_sym_u8] = ACTIONS(1902),
    [anon_sym_i8] = ACTIONS(1902),
    [anon_sym_u16] = ACTIONS(1902),
    [anon_sym_i16] = ACTIONS(1902),
    [anon_sym_u32] = ACTIONS(1902),
    [anon_sym_i32] = ACTIONS(1902),
    [anon_sym_u64] = ACTIONS(1902),
    [anon_sym_i64] = ACTIONS(1902),
    [anon_sym_u128] = ACTIONS(1902),
    [anon_sym_i128] = ACTIONS(1902),
    [anon_sym_isize] = ACTIONS(1902),
    [anon_sym_usize] = ACTIONS(1902),
    [anon_sym_f32] = ACTIONS(1902),
    [anon_sym_f64] = ACTIONS(1902),
    [anon_sym_bool] = ACTIONS(1902),
    [anon_sym_str] = ACTIONS(1902),
    [anon_sym_char] = ACTIONS(1902),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_BANG] = ACTIONS(1900),
    [anon_sym_AMP] = ACTIONS(1900),
    [anon_sym_PIPE] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1900),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_COLON_COLON] = ACTIONS(1900),
    [anon_sym_POUND] = ACTIONS(1900),
    [anon_sym_SQUOTE] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1902),
    [anon_sym_break] = ACTIONS(1902),
    [anon_sym_const] = ACTIONS(1902),
    [anon_sym_continue] = ACTIONS(1902),
    [anon_sym_default] = ACTIONS(1902),
    [anon_sym_enum] = ACTIONS(1902),
    [anon_sym_fn] = ACTIONS(1902),
    [anon_sym_for] = ACTIONS(1902),
    [anon_sym_if] = ACTIONS(1902),
    [anon_sym_impl] = ACTIONS(1902),
    [anon_sym_let] = ACTIONS(1902),
    [anon_sym_loop] = ACTIONS(1902),
    [anon_sym_match] = ACTIONS(1902),
    [anon_sym_mod] = ACTIONS(1902),
    [anon_sym_pub] = ACTIONS(1902),
    [anon_sym_return] = ACTIONS(1902),
    [anon_sym_static] = ACTIONS(1902),
    [anon_sym_struct] = ACTIONS(1902),
    [anon_sym_trait] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1902),
    [anon_sym_union] = ACTIONS(1902),
    [anon_sym_unsafe] = ACTIONS(1902),
    [anon_sym_use] = ACTIONS(1902),
    [anon_sym_while] = ACTIONS(1902),
    [anon_sym_extern] = ACTIONS(1902),
    [anon_sym_yield] = ACTIONS(1902),
    [anon_sym_move] = ACTIONS(1902),
    [anon_sym_try] = ACTIONS(1902),
    [sym_integer_literal] = ACTIONS(1900),
    [aux_sym_string_literal_token1] = ACTIONS(1900),
    [sym_char_literal] = ACTIONS(1900),
    [anon_sym_true] = ACTIONS(1902),
    [anon_sym_false] = ACTIONS(1902),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1902),
    [sym_super] = ACTIONS(1902),
    [sym_crate] = ACTIONS(1902),
    [sym_metavariable] = ACTIONS(1900),
    [sym__raw_string_literal_start] = ACTIONS(1900),
    [sym_float_literal] = ACTIONS(1900),
  },
  [524] = {
    [sym_line_comment] = STATE(524),
    [sym_block_comment] = STATE(524),
    [ts_builtin_sym_end] = ACTIONS(1904),
    [sym_identifier] = ACTIONS(1906),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_macro_rules_BANG] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1904),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [anon_sym_LBRACE] = ACTIONS(1904),
    [anon_sym_RBRACE] = ACTIONS(1904),
    [anon_sym_STAR] = ACTIONS(1904),
    [anon_sym_u8] = ACTIONS(1906),
    [anon_sym_i8] = ACTIONS(1906),
    [anon_sym_u16] = ACTIONS(1906),
    [anon_sym_i16] = ACTIONS(1906),
    [anon_sym_u32] = ACTIONS(1906),
    [anon_sym_i32] = ACTIONS(1906),
    [anon_sym_u64] = ACTIONS(1906),
    [anon_sym_i64] = ACTIONS(1906),
    [anon_sym_u128] = ACTIONS(1906),
    [anon_sym_i128] = ACTIONS(1906),
    [anon_sym_isize] = ACTIONS(1906),
    [anon_sym_usize] = ACTIONS(1906),
    [anon_sym_f32] = ACTIONS(1906),
    [anon_sym_f64] = ACTIONS(1906),
    [anon_sym_bool] = ACTIONS(1906),
    [anon_sym_str] = ACTIONS(1906),
    [anon_sym_char] = ACTIONS(1906),
    [anon_sym_DASH] = ACTIONS(1904),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1904),
    [anon_sym_DOT_DOT] = ACTIONS(1904),
    [anon_sym_COLON_COLON] = ACTIONS(1904),
    [anon_sym_POUND] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_async] = ACTIONS(1906),
    [anon_sym_break] = ACTIONS(1906),
    [anon_sym_const] = ACTIONS(1906),
    [anon_sym_continue] = ACTIONS(1906),
    [anon_sym_default] = ACTIONS(1906),
    [anon_sym_enum] = ACTIONS(1906),
    [anon_sym_fn] = ACTIONS(1906),
    [anon_sym_for] = ACTIONS(1906),
    [anon_sym_if] = ACTIONS(1906),
    [anon_sym_impl] = ACTIONS(1906),
    [anon_sym_let] = ACTIONS(1906),
    [anon_sym_loop] = ACTIONS(1906),
    [anon_sym_match] = ACTIONS(1906),
    [anon_sym_mod] = ACTIONS(1906),
    [anon_sym_pub] = ACTIONS(1906),
    [anon_sym_return] = ACTIONS(1906),
    [anon_sym_static] = ACTIONS(1906),
    [anon_sym_struct] = ACTIONS(1906),
    [anon_sym_trait] = ACTIONS(1906),
    [anon_sym_type] = ACTIONS(1906),
    [anon_sym_union] = ACTIONS(1906),
    [anon_sym_unsafe] = ACTIONS(1906),
    [anon_sym_use] = ACTIONS(1906),
    [anon_sym_while] = ACTIONS(1906),
    [anon_sym_extern] = ACTIONS(1906),
    [anon_sym_yield] = ACTIONS(1906),
    [anon_sym_move] = ACTIONS(1906),
    [anon_sym_try] = ACTIONS(1906),
    [sym_integer_literal] = ACTIONS(1904),
    [aux_sym_string_literal_token1] = ACTIONS(1904),
    [sym_char_literal] = ACTIONS(1904),
    [anon_sym_true] = ACTIONS(1906),
    [anon_sym_false] = ACTIONS(1906),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1906),
    [sym_super] = ACTIONS(1906),
    [sym_crate] = ACTIONS(1906),
    [sym_metavariable] = ACTIONS(1904),
    [sym__raw_string_literal_start] = ACTIONS(1904),
    [sym_float_literal] = ACTIONS(1904),
  },
  [525] = {
    [sym_line_comment] = STATE(525),
    [sym_block_comment] = STATE(525),
    [ts_builtin_sym_end] = ACTIONS(1908),
    [sym_identifier] = ACTIONS(1910),
    [anon_sym_SEMI] = ACTIONS(1908),
    [anon_sym_macro_rules_BANG] = ACTIONS(1908),
    [anon_sym_LPAREN] = ACTIONS(1908),
    [anon_sym_LBRACK] = ACTIONS(1908),
    [anon_sym_LBRACE] = ACTIONS(1908),
    [anon_sym_RBRACE] = ACTIONS(1908),
    [anon_sym_STAR] = ACTIONS(1908),
    [anon_sym_u8] = ACTIONS(1910),
    [anon_sym_i8] = ACTIONS(1910),
    [anon_sym_u16] = ACTIONS(1910),
    [anon_sym_i16] = ACTIONS(1910),
    [anon_sym_u32] = ACTIONS(1910),
    [anon_sym_i32] = ACTIONS(1910),
    [anon_sym_u64] = ACTIONS(1910),
    [anon_sym_i64] = ACTIONS(1910),
    [anon_sym_u128] = ACTIONS(1910),
    [anon_sym_i128] = ACTIONS(1910),
    [anon_sym_isize] = ACTIONS(1910),
    [anon_sym_usize] = ACTIONS(1910),
    [anon_sym_f32] = ACTIONS(1910),
    [anon_sym_f64] = ACTIONS(1910),
    [anon_sym_bool] = ACTIONS(1910),
    [anon_sym_str] = ACTIONS(1910),
    [anon_sym_char] = ACTIONS(1910),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_BANG] = ACTIONS(1908),
    [anon_sym_AMP] = ACTIONS(1908),
    [anon_sym_PIPE] = ACTIONS(1908),
    [anon_sym_LT] = ACTIONS(1908),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_COLON_COLON] = ACTIONS(1908),
    [anon_sym_POUND] = ACTIONS(1908),
    [anon_sym_SQUOTE] = ACTIONS(1910),
    [anon_sym_async] = ACTIONS(1910),
    [anon_sym_break] = ACTIONS(1910),
    [anon_sym_const] = ACTIONS(1910),
    [anon_sym_continue] = ACTIONS(1910),
    [anon_sym_default] = ACTIONS(1910),
    [anon_sym_enum] = ACTIONS(1910),
    [anon_sym_fn] = ACTIONS(1910),
    [anon_sym_for] = ACTIONS(1910),
    [anon_sym_if] = ACTIONS(1910),
    [anon_sym_impl] = ACTIONS(1910),
    [anon_sym_let] = ACTIONS(1910),
    [anon_sym_loop] = ACTIONS(1910),
    [anon_sym_match] = ACTIONS(1910),
    [anon_sym_mod] = ACTIONS(1910),
    [anon_sym_pub] = ACTIONS(1910),
    [anon_sym_return] = ACTIONS(1910),
    [anon_sym_static] = ACTIONS(1910),
    [anon_sym_struct] = ACTIONS(1910),
    [anon_sym_trait] = ACTIONS(1910),
    [anon_sym_type] = ACTIONS(1910),
    [anon_sym_union] = ACTIONS(1910),
    [anon_sym_unsafe] = ACTIONS(1910),
    [anon_sym_use] = ACTIONS(1910),
    [anon_sym_while] = ACTIONS(1910),
    [anon_sym_extern] = ACTIONS(1910),
    [anon_sym_yield] = ACTIONS(1910),
    [anon_sym_move] = ACTIONS(1910),
    [anon_sym_try] = ACTIONS(1910),
    [sym_integer_literal] = ACTIONS(1908),
    [aux_sym_string_literal_token1] = ACTIONS(1908),
    [sym_char_literal] = ACTIONS(1908),
    [anon_sym_true] = ACTIONS(1910),
    [anon_sym_false] = ACTIONS(1910),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1910),
    [sym_super] = ACTIONS(1910),
    [sym_crate] = ACTIONS(1910),
    [sym_metavariable] = ACTIONS(1908),
    [sym__raw_string_literal_start] = ACTIONS(1908),
    [sym_float_literal] = ACTIONS(1908),
  },
  [526] = {
    [sym_line_comment] = STATE(526),
    [sym_block_comment] = STATE(526),
    [ts_builtin_sym_end] = ACTIONS(1912),
    [sym_identifier] = ACTIONS(1914),
    [anon_sym_SEMI] = ACTIONS(1912),
    [anon_sym_macro_rules_BANG] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1912),
    [anon_sym_LBRACK] = ACTIONS(1912),
    [anon_sym_LBRACE] = ACTIONS(1912),
    [anon_sym_RBRACE] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1912),
    [anon_sym_u8] = ACTIONS(1914),
    [anon_sym_i8] = ACTIONS(1914),
    [anon_sym_u16] = ACTIONS(1914),
    [anon_sym_i16] = ACTIONS(1914),
    [anon_sym_u32] = ACTIONS(1914),
    [anon_sym_i32] = ACTIONS(1914),
    [anon_sym_u64] = ACTIONS(1914),
    [anon_sym_i64] = ACTIONS(1914),
    [anon_sym_u128] = ACTIONS(1914),
    [anon_sym_i128] = ACTIONS(1914),
    [anon_sym_isize] = ACTIONS(1914),
    [anon_sym_usize] = ACTIONS(1914),
    [anon_sym_f32] = ACTIONS(1914),
    [anon_sym_f64] = ACTIONS(1914),
    [anon_sym_bool] = ACTIONS(1914),
    [anon_sym_str] = ACTIONS(1914),
    [anon_sym_char] = ACTIONS(1914),
    [anon_sym_DASH] = ACTIONS(1912),
    [anon_sym_BANG] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(1912),
    [anon_sym_PIPE] = ACTIONS(1912),
    [anon_sym_LT] = ACTIONS(1912),
    [anon_sym_DOT_DOT] = ACTIONS(1912),
    [anon_sym_COLON_COLON] = ACTIONS(1912),
    [anon_sym_POUND] = ACTIONS(1912),
    [anon_sym_SQUOTE] = ACTIONS(1914),
    [anon_sym_async] = ACTIONS(1914),
    [anon_sym_break] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1914),
    [anon_sym_continue] = ACTIONS(1914),
    [anon_sym_default] = ACTIONS(1914),
    [anon_sym_enum] = ACTIONS(1914),
    [anon_sym_fn] = ACTIONS(1914),
    [anon_sym_for] = ACTIONS(1914),
    [anon_sym_if] = ACTIONS(1914),
    [anon_sym_impl] = ACTIONS(1914),
    [anon_sym_let] = ACTIONS(1914),
    [anon_sym_loop] = ACTIONS(1914),
    [anon_sym_match] = ACTIONS(1914),
    [anon_sym_mod] = ACTIONS(1914),
    [anon_sym_pub] = ACTIONS(1914),
    [anon_sym_return] = ACTIONS(1914),
    [anon_sym_static] = ACTIONS(1914),
    [anon_sym_struct] = ACTIONS(1914),
    [anon_sym_trait] = ACTIONS(1914),
    [anon_sym_type] = ACTIONS(1914),
    [anon_sym_union] = ACTIONS(1914),
    [anon_sym_unsafe] = ACTIONS(1914),
    [anon_sym_use] = ACTIONS(1914),
    [anon_sym_while] = ACTIONS(1914),
    [anon_sym_extern] = ACTIONS(1914),
    [anon_sym_yield] = ACTIONS(1914),
    [anon_sym_move] = ACTIONS(1914),
    [anon_sym_try] = ACTIONS(1914),
    [sym_integer_literal] = ACTIONS(1912),
    [aux_sym_string_literal_token1] = ACTIONS(1912),
    [sym_char_literal] = ACTIONS(1912),
    [anon_sym_true] = ACTIONS(1914),
    [anon_sym_false] = ACTIONS(1914),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1914),
    [sym_super] = ACTIONS(1914),
    [sym_crate] = ACTIONS(1914),
    [sym_metavariable] = ACTIONS(1912),
    [sym__raw_string_literal_start] = ACTIONS(1912),
    [sym_float_literal] = ACTIONS(1912),
  },
  [527] = {
    [sym_line_comment] = STATE(527),
    [sym_block_comment] = STATE(527),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [sym_identifier] = ACTIONS(1918),
    [anon_sym_SEMI] = ACTIONS(1916),
    [anon_sym_macro_rules_BANG] = ACTIONS(1916),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1916),
    [anon_sym_RBRACE] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_u8] = ACTIONS(1918),
    [anon_sym_i8] = ACTIONS(1918),
    [anon_sym_u16] = ACTIONS(1918),
    [anon_sym_i16] = ACTIONS(1918),
    [anon_sym_u32] = ACTIONS(1918),
    [anon_sym_i32] = ACTIONS(1918),
    [anon_sym_u64] = ACTIONS(1918),
    [anon_sym_i64] = ACTIONS(1918),
    [anon_sym_u128] = ACTIONS(1918),
    [anon_sym_i128] = ACTIONS(1918),
    [anon_sym_isize] = ACTIONS(1918),
    [anon_sym_usize] = ACTIONS(1918),
    [anon_sym_f32] = ACTIONS(1918),
    [anon_sym_f64] = ACTIONS(1918),
    [anon_sym_bool] = ACTIONS(1918),
    [anon_sym_str] = ACTIONS(1918),
    [anon_sym_char] = ACTIONS(1918),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_BANG] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1916),
    [anon_sym_POUND] = ACTIONS(1916),
    [anon_sym_SQUOTE] = ACTIONS(1918),
    [anon_sym_async] = ACTIONS(1918),
    [anon_sym_break] = ACTIONS(1918),
    [anon_sym_const] = ACTIONS(1918),
    [anon_sym_continue] = ACTIONS(1918),
    [anon_sym_default] = ACTIONS(1918),
    [anon_sym_enum] = ACTIONS(1918),
    [anon_sym_fn] = ACTIONS(1918),
    [anon_sym_for] = ACTIONS(1918),
    [anon_sym_if] = ACTIONS(1918),
    [anon_sym_impl] = ACTIONS(1918),
    [anon_sym_let] = ACTIONS(1918),
    [anon_sym_loop] = ACTIONS(1918),
    [anon_sym_match] = ACTIONS(1918),
    [anon_sym_mod] = ACTIONS(1918),
    [anon_sym_pub] = ACTIONS(1918),
    [anon_sym_return] = ACTIONS(1918),
    [anon_sym_static] = ACTIONS(1918),
    [anon_sym_struct] = ACTIONS(1918),
    [anon_sym_trait] = ACTIONS(1918),
    [anon_sym_type] = ACTIONS(1918),
    [anon_sym_union] = ACTIONS(1918),
    [anon_sym_unsafe] = ACTIONS(1918),
    [anon_sym_use] = ACTIONS(1918),
    [anon_sym_while] = ACTIONS(1918),
    [anon_sym_extern] = ACTIONS(1918),
    [anon_sym_yield] = ACTIONS(1918),
    [anon_sym_move] = ACTIONS(1918),
    [anon_sym_try] = ACTIONS(1918),
    [sym_integer_literal] = ACTIONS(1916),
    [aux_sym_string_literal_token1] = ACTIONS(1916),
    [sym_char_literal] = ACTIONS(1916),
    [anon_sym_true] = ACTIONS(1918),
    [anon_sym_false] = ACTIONS(1918),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1918),
    [sym_super] = ACTIONS(1918),
    [sym_crate] = ACTIONS(1918),
    [sym_metavariable] = ACTIONS(1916),
    [sym__raw_string_literal_start] = ACTIONS(1916),
    [sym_float_literal] = ACTIONS(1916),
  },
  [528] = {
    [sym_empty_statement] = STATE(1389),
    [sym_macro_definition] = STATE(1389),
    [sym_attribute_item] = STATE(1389),
    [sym_inner_attribute_item] = STATE(1389),
    [sym_mod_item] = STATE(1389),
    [sym_foreign_mod_item] = STATE(1389),
    [sym_struct_item] = STATE(1389),
    [sym_union_item] = STATE(1389),
    [sym_enum_item] = STATE(1389),
    [sym_extern_crate_declaration] = STATE(1389),
    [sym_const_item] = STATE(1389),
    [sym_static_item] = STATE(1389),
    [sym_type_item] = STATE(1389),
    [sym_function_item] = STATE(1389),
    [sym_function_signature_item] = STATE(1389),
    [sym_function_modifiers] = STATE(3601),
    [sym_impl_item] = STATE(1389),
    [sym_trait_item] = STATE(1389),
    [sym_associated_type] = STATE(1389),
    [sym_let_declaration] = STATE(1389),
    [sym_use_declaration] = STATE(1389),
    [sym_extern_modifier] = STATE(2140),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3312),
    [sym_generic_type_with_turbofish] = STATE(3351),
    [sym_macro_invocation] = STATE(1389),
    [sym_scoped_identifier] = STATE(3243),
    [sym_line_comment] = STATE(528),
    [sym_block_comment] = STATE(528),
    [aux_sym_declaration_list_repeat1] = STATE(667),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_macro_rules_BANG] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_u8] = ACTIONS(1928),
    [anon_sym_i8] = ACTIONS(1928),
    [anon_sym_u16] = ACTIONS(1928),
    [anon_sym_i16] = ACTIONS(1928),
    [anon_sym_u32] = ACTIONS(1928),
    [anon_sym_i32] = ACTIONS(1928),
    [anon_sym_u64] = ACTIONS(1928),
    [anon_sym_i64] = ACTIONS(1928),
    [anon_sym_u128] = ACTIONS(1928),
    [anon_sym_i128] = ACTIONS(1928),
    [anon_sym_isize] = ACTIONS(1928),
    [anon_sym_usize] = ACTIONS(1928),
    [anon_sym_f32] = ACTIONS(1928),
    [anon_sym_f64] = ACTIONS(1928),
    [anon_sym_bool] = ACTIONS(1928),
    [anon_sym_str] = ACTIONS(1928),
    [anon_sym_char] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1930),
    [anon_sym_POUND] = ACTIONS(1932),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_fn] = ACTIONS(1940),
    [anon_sym_impl] = ACTIONS(1942),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_mod] = ACTIONS(1946),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_trait] = ACTIONS(1952),
    [anon_sym_type] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1956),
    [anon_sym_unsafe] = ACTIONS(1958),
    [anon_sym_use] = ACTIONS(1960),
    [anon_sym_extern] = ACTIONS(1962),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1964),
    [sym_super] = ACTIONS(1964),
    [sym_crate] = ACTIONS(1966),
    [sym_metavariable] = ACTIONS(1968),
  },
  [529] = {
    [sym_line_comment] = STATE(529),
    [sym_block_comment] = STATE(529),
    [ts_builtin_sym_end] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_macro_rules_BANG] = ACTIONS(1970),
    [anon_sym_LPAREN] = ACTIONS(1970),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_u8] = ACTIONS(1972),
    [anon_sym_i8] = ACTIONS(1972),
    [anon_sym_u16] = ACTIONS(1972),
    [anon_sym_i16] = ACTIONS(1972),
    [anon_sym_u32] = ACTIONS(1972),
    [anon_sym_i32] = ACTIONS(1972),
    [anon_sym_u64] = ACTIONS(1972),
    [anon_sym_i64] = ACTIONS(1972),
    [anon_sym_u128] = ACTIONS(1972),
    [anon_sym_i128] = ACTIONS(1972),
    [anon_sym_isize] = ACTIONS(1972),
    [anon_sym_usize] = ACTIONS(1972),
    [anon_sym_f32] = ACTIONS(1972),
    [anon_sym_f64] = ACTIONS(1972),
    [anon_sym_bool] = ACTIONS(1972),
    [anon_sym_str] = ACTIONS(1972),
    [anon_sym_char] = ACTIONS(1972),
    [anon_sym_DASH] = ACTIONS(1970),
    [anon_sym_BANG] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(1970),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_DOT_DOT] = ACTIONS(1970),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [anon_sym_POUND] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1972),
    [anon_sym_async] = ACTIONS(1972),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1972),
    [anon_sym_default] = ACTIONS(1972),
    [anon_sym_enum] = ACTIONS(1972),
    [anon_sym_fn] = ACTIONS(1972),
    [anon_sym_for] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1972),
    [anon_sym_impl] = ACTIONS(1972),
    [anon_sym_let] = ACTIONS(1972),
    [anon_sym_loop] = ACTIONS(1972),
    [anon_sym_match] = ACTIONS(1972),
    [anon_sym_mod] = ACTIONS(1972),
    [anon_sym_pub] = ACTIONS(1972),
    [anon_sym_return] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_struct] = ACTIONS(1972),
    [anon_sym_trait] = ACTIONS(1972),
    [anon_sym_type] = ACTIONS(1972),
    [anon_sym_union] = ACTIONS(1972),
    [anon_sym_unsafe] = ACTIONS(1972),
    [anon_sym_use] = ACTIONS(1972),
    [anon_sym_while] = ACTIONS(1972),
    [anon_sym_extern] = ACTIONS(1972),
    [anon_sym_yield] = ACTIONS(1972),
    [anon_sym_move] = ACTIONS(1972),
    [anon_sym_try] = ACTIONS(1972),
    [sym_integer_literal] = ACTIONS(1970),
    [aux_sym_string_literal_token1] = ACTIONS(1970),
    [sym_char_literal] = ACTIONS(1970),
    [anon_sym_true] = ACTIONS(1972),
    [anon_sym_false] = ACTIONS(1972),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1972),
    [sym_super] = ACTIONS(1972),
    [sym_crate] = ACTIONS(1972),
    [sym_metavariable] = ACTIONS(1970),
    [sym__raw_string_literal_start] = ACTIONS(1970),
    [sym_float_literal] = ACTIONS(1970),
  },
  [530] = {
    [sym_line_comment] = STATE(530),
    [sym_block_comment] = STATE(530),
    [ts_builtin_sym_end] = ACTIONS(1974),
    [sym_identifier] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_macro_rules_BANG] = ACTIONS(1974),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_LBRACK] = ACTIONS(1974),
    [anon_sym_LBRACE] = ACTIONS(1974),
    [anon_sym_RBRACE] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(1974),
    [anon_sym_u8] = ACTIONS(1976),
    [anon_sym_i8] = ACTIONS(1976),
    [anon_sym_u16] = ACTIONS(1976),
    [anon_sym_i16] = ACTIONS(1976),
    [anon_sym_u32] = ACTIONS(1976),
    [anon_sym_i32] = ACTIONS(1976),
    [anon_sym_u64] = ACTIONS(1976),
    [anon_sym_i64] = ACTIONS(1976),
    [anon_sym_u128] = ACTIONS(1976),
    [anon_sym_i128] = ACTIONS(1976),
    [anon_sym_isize] = ACTIONS(1976),
    [anon_sym_usize] = ACTIONS(1976),
    [anon_sym_f32] = ACTIONS(1976),
    [anon_sym_f64] = ACTIONS(1976),
    [anon_sym_bool] = ACTIONS(1976),
    [anon_sym_str] = ACTIONS(1976),
    [anon_sym_char] = ACTIONS(1976),
    [anon_sym_DASH] = ACTIONS(1974),
    [anon_sym_BANG] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1974),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_DOT_DOT] = ACTIONS(1974),
    [anon_sym_COLON_COLON] = ACTIONS(1974),
    [anon_sym_POUND] = ACTIONS(1974),
    [anon_sym_SQUOTE] = ACTIONS(1976),
    [anon_sym_async] = ACTIONS(1976),
    [anon_sym_break] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_continue] = ACTIONS(1976),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_fn] = ACTIONS(1976),
    [anon_sym_for] = ACTIONS(1976),
    [anon_sym_if] = ACTIONS(1976),
    [anon_sym_impl] = ACTIONS(1976),
    [anon_sym_let] = ACTIONS(1976),
    [anon_sym_loop] = ACTIONS(1976),
    [anon_sym_match] = ACTIONS(1976),
    [anon_sym_mod] = ACTIONS(1976),
    [anon_sym_pub] = ACTIONS(1976),
    [anon_sym_return] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_struct] = ACTIONS(1976),
    [anon_sym_trait] = ACTIONS(1976),
    [anon_sym_type] = ACTIONS(1976),
    [anon_sym_union] = ACTIONS(1976),
    [anon_sym_unsafe] = ACTIONS(1976),
    [anon_sym_use] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1976),
    [anon_sym_extern] = ACTIONS(1976),
    [anon_sym_yield] = ACTIONS(1976),
    [anon_sym_move] = ACTIONS(1976),
    [anon_sym_try] = ACTIONS(1976),
    [sym_integer_literal] = ACTIONS(1974),
    [aux_sym_string_literal_token1] = ACTIONS(1974),
    [sym_char_literal] = ACTIONS(1974),
    [anon_sym_true] = ACTIONS(1976),
    [anon_sym_false] = ACTIONS(1976),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1976),
    [sym_super] = ACTIONS(1976),
    [sym_crate] = ACTIONS(1976),
    [sym_metavariable] = ACTIONS(1974),
    [sym__raw_string_literal_start] = ACTIONS(1974),
    [sym_float_literal] = ACTIONS(1974),
  },
  [531] = {
    [sym_line_comment] = STATE(531),
    [sym_block_comment] = STATE(531),
    [ts_builtin_sym_end] = ACTIONS(1978),
    [sym_identifier] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_macro_rules_BANG] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1978),
    [anon_sym_LBRACK] = ACTIONS(1978),
    [anon_sym_LBRACE] = ACTIONS(1978),
    [anon_sym_RBRACE] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_u8] = ACTIONS(1980),
    [anon_sym_i8] = ACTIONS(1980),
    [anon_sym_u16] = ACTIONS(1980),
    [anon_sym_i16] = ACTIONS(1980),
    [anon_sym_u32] = ACTIONS(1980),
    [anon_sym_i32] = ACTIONS(1980),
    [anon_sym_u64] = ACTIONS(1980),
    [anon_sym_i64] = ACTIONS(1980),
    [anon_sym_u128] = ACTIONS(1980),
    [anon_sym_i128] = ACTIONS(1980),
    [anon_sym_isize] = ACTIONS(1980),
    [anon_sym_usize] = ACTIONS(1980),
    [anon_sym_f32] = ACTIONS(1980),
    [anon_sym_f64] = ACTIONS(1980),
    [anon_sym_bool] = ACTIONS(1980),
    [anon_sym_str] = ACTIONS(1980),
    [anon_sym_char] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_DOT_DOT] = ACTIONS(1978),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_POUND] = ACTIONS(1978),
    [anon_sym_SQUOTE] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_break] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_continue] = ACTIONS(1980),
    [anon_sym_default] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_fn] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_impl] = ACTIONS(1980),
    [anon_sym_let] = ACTIONS(1980),
    [anon_sym_loop] = ACTIONS(1980),
    [anon_sym_match] = ACTIONS(1980),
    [anon_sym_mod] = ACTIONS(1980),
    [anon_sym_pub] = ACTIONS(1980),
    [anon_sym_return] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_struct] = ACTIONS(1980),
    [anon_sym_trait] = ACTIONS(1980),
    [anon_sym_type] = ACTIONS(1980),
    [anon_sym_union] = ACTIONS(1980),
    [anon_sym_unsafe] = ACTIONS(1980),
    [anon_sym_use] = ACTIONS(1980),
    [anon_sym_while] = ACTIONS(1980),
    [anon_sym_extern] = ACTIONS(1980),
    [anon_sym_yield] = ACTIONS(1980),
    [anon_sym_move] = ACTIONS(1980),
    [anon_sym_try] = ACTIONS(1980),
    [sym_integer_literal] = ACTIONS(1978),
    [aux_sym_string_literal_token1] = ACTIONS(1978),
    [sym_char_literal] = ACTIONS(1978),
    [anon_sym_true] = ACTIONS(1980),
    [anon_sym_false] = ACTIONS(1980),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1980),
    [sym_super] = ACTIONS(1980),
    [sym_crate] = ACTIONS(1980),
    [sym_metavariable] = ACTIONS(1978),
    [sym__raw_string_literal_start] = ACTIONS(1978),
    [sym_float_literal] = ACTIONS(1978),
  },
  [532] = {
    [sym_line_comment] = STATE(532),
    [sym_block_comment] = STATE(532),
    [ts_builtin_sym_end] = ACTIONS(1982),
    [sym_identifier] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_macro_rules_BANG] = ACTIONS(1982),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1982),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_RBRACE] = ACTIONS(1982),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_u8] = ACTIONS(1984),
    [anon_sym_i8] = ACTIONS(1984),
    [anon_sym_u16] = ACTIONS(1984),
    [anon_sym_i16] = ACTIONS(1984),
    [anon_sym_u32] = ACTIONS(1984),
    [anon_sym_i32] = ACTIONS(1984),
    [anon_sym_u64] = ACTIONS(1984),
    [anon_sym_i64] = ACTIONS(1984),
    [anon_sym_u128] = ACTIONS(1984),
    [anon_sym_i128] = ACTIONS(1984),
    [anon_sym_isize] = ACTIONS(1984),
    [anon_sym_usize] = ACTIONS(1984),
    [anon_sym_f32] = ACTIONS(1984),
    [anon_sym_f64] = ACTIONS(1984),
    [anon_sym_bool] = ACTIONS(1984),
    [anon_sym_str] = ACTIONS(1984),
    [anon_sym_char] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_DOT_DOT] = ACTIONS(1982),
    [anon_sym_COLON_COLON] = ACTIONS(1982),
    [anon_sym_POUND] = ACTIONS(1982),
    [anon_sym_SQUOTE] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_break] = ACTIONS(1984),
    [anon_sym_const] = ACTIONS(1984),
    [anon_sym_continue] = ACTIONS(1984),
    [anon_sym_default] = ACTIONS(1984),
    [anon_sym_enum] = ACTIONS(1984),
    [anon_sym_fn] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_impl] = ACTIONS(1984),
    [anon_sym_let] = ACTIONS(1984),
    [anon_sym_loop] = ACTIONS(1984),
    [anon_sym_match] = ACTIONS(1984),
    [anon_sym_mod] = ACTIONS(1984),
    [anon_sym_pub] = ACTIONS(1984),
    [anon_sym_return] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1984),
    [anon_sym_struct] = ACTIONS(1984),
    [anon_sym_trait] = ACTIONS(1984),
    [anon_sym_type] = ACTIONS(1984),
    [anon_sym_union] = ACTIONS(1984),
    [anon_sym_unsafe] = ACTIONS(1984),
    [anon_sym_use] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1984),
    [anon_sym_extern] = ACTIONS(1984),
    [anon_sym_yield] = ACTIONS(1984),
    [anon_sym_move] = ACTIONS(1984),
    [anon_sym_try] = ACTIONS(1984),
    [sym_integer_literal] = ACTIONS(1982),
    [aux_sym_string_literal_token1] = ACTIONS(1982),
    [sym_char_literal] = ACTIONS(1982),
    [anon_sym_true] = ACTIONS(1984),
    [anon_sym_false] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1984),
    [sym_super] = ACTIONS(1984),
    [sym_crate] = ACTIONS(1984),
    [sym_metavariable] = ACTIONS(1982),
    [sym__raw_string_literal_start] = ACTIONS(1982),
    [sym_float_literal] = ACTIONS(1982),
  },
  [533] = {
    [sym_line_comment] = STATE(533),
    [sym_block_comment] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(1986),
    [sym_identifier] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym_macro_rules_BANG] = ACTIONS(1986),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_LBRACK] = ACTIONS(1986),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_u8] = ACTIONS(1988),
    [anon_sym_i8] = ACTIONS(1988),
    [anon_sym_u16] = ACTIONS(1988),
    [anon_sym_i16] = ACTIONS(1988),
    [anon_sym_u32] = ACTIONS(1988),
    [anon_sym_i32] = ACTIONS(1988),
    [anon_sym_u64] = ACTIONS(1988),
    [anon_sym_i64] = ACTIONS(1988),
    [anon_sym_u128] = ACTIONS(1988),
    [anon_sym_i128] = ACTIONS(1988),
    [anon_sym_isize] = ACTIONS(1988),
    [anon_sym_usize] = ACTIONS(1988),
    [anon_sym_f32] = ACTIONS(1988),
    [anon_sym_f64] = ACTIONS(1988),
    [anon_sym_bool] = ACTIONS(1988),
    [anon_sym_str] = ACTIONS(1988),
    [anon_sym_char] = ACTIONS(1988),
    [anon_sym_DASH] = ACTIONS(1986),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_COLON_COLON] = ACTIONS(1986),
    [anon_sym_POUND] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_break] = ACTIONS(1988),
    [anon_sym_const] = ACTIONS(1988),
    [anon_sym_continue] = ACTIONS(1988),
    [anon_sym_default] = ACTIONS(1988),
    [anon_sym_enum] = ACTIONS(1988),
    [anon_sym_fn] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_impl] = ACTIONS(1988),
    [anon_sym_let] = ACTIONS(1988),
    [anon_sym_loop] = ACTIONS(1988),
    [anon_sym_match] = ACTIONS(1988),
    [anon_sym_mod] = ACTIONS(1988),
    [anon_sym_pub] = ACTIONS(1988),
    [anon_sym_return] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_struct] = ACTIONS(1988),
    [anon_sym_trait] = ACTIONS(1988),
    [anon_sym_type] = ACTIONS(1988),
    [anon_sym_union] = ACTIONS(1988),
    [anon_sym_unsafe] = ACTIONS(1988),
    [anon_sym_use] = ACTIONS(1988),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_extern] = ACTIONS(1988),
    [anon_sym_yield] = ACTIONS(1988),
    [anon_sym_move] = ACTIONS(1988),
    [anon_sym_try] = ACTIONS(1988),
    [sym_integer_literal] = ACTIONS(1986),
    [aux_sym_string_literal_token1] = ACTIONS(1986),
    [sym_char_literal] = ACTIONS(1986),
    [anon_sym_true] = ACTIONS(1988),
    [anon_sym_false] = ACTIONS(1988),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1988),
    [sym_super] = ACTIONS(1988),
    [sym_crate] = ACTIONS(1988),
    [sym_metavariable] = ACTIONS(1986),
    [sym__raw_string_literal_start] = ACTIONS(1986),
    [sym_float_literal] = ACTIONS(1986),
  },
  [534] = {
    [sym_line_comment] = STATE(534),
    [sym_block_comment] = STATE(534),
    [ts_builtin_sym_end] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym_macro_rules_BANG] = ACTIONS(1990),
    [anon_sym_LPAREN] = ACTIONS(1990),
    [anon_sym_LBRACK] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1990),
    [anon_sym_RBRACE] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(1990),
    [anon_sym_u8] = ACTIONS(1992),
    [anon_sym_i8] = ACTIONS(1992),
    [anon_sym_u16] = ACTIONS(1992),
    [anon_sym_i16] = ACTIONS(1992),
    [anon_sym_u32] = ACTIONS(1992),
    [anon_sym_i32] = ACTIONS(1992),
    [anon_sym_u64] = ACTIONS(1992),
    [anon_sym_i64] = ACTIONS(1992),
    [anon_sym_u128] = ACTIONS(1992),
    [anon_sym_i128] = ACTIONS(1992),
    [anon_sym_isize] = ACTIONS(1992),
    [anon_sym_usize] = ACTIONS(1992),
    [anon_sym_f32] = ACTIONS(1992),
    [anon_sym_f64] = ACTIONS(1992),
    [anon_sym_bool] = ACTIONS(1992),
    [anon_sym_str] = ACTIONS(1992),
    [anon_sym_char] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1990),
    [anon_sym_BANG] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_PIPE] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_DOT_DOT] = ACTIONS(1990),
    [anon_sym_COLON_COLON] = ACTIONS(1990),
    [anon_sym_POUND] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(1992),
    [anon_sym_async] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
    [anon_sym_fn] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_impl] = ACTIONS(1992),
    [anon_sym_let] = ACTIONS(1992),
    [anon_sym_loop] = ACTIONS(1992),
    [anon_sym_match] = ACTIONS(1992),
    [anon_sym_mod] = ACTIONS(1992),
    [anon_sym_pub] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_struct] = ACTIONS(1992),
    [anon_sym_trait] = ACTIONS(1992),
    [anon_sym_type] = ACTIONS(1992),
    [anon_sym_union] = ACTIONS(1992),
    [anon_sym_unsafe] = ACTIONS(1992),
    [anon_sym_use] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_extern] = ACTIONS(1992),
    [anon_sym_yield] = ACTIONS(1992),
    [anon_sym_move] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [sym_integer_literal] = ACTIONS(1990),
    [aux_sym_string_literal_token1] = ACTIONS(1990),
    [sym_char_literal] = ACTIONS(1990),
    [anon_sym_true] = ACTIONS(1992),
    [anon_sym_false] = ACTIONS(1992),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1992),
    [sym_super] = ACTIONS(1992),
    [sym_crate] = ACTIONS(1992),
    [sym_metavariable] = ACTIONS(1990),
    [sym__raw_string_literal_start] = ACTIONS(1990),
    [sym_float_literal] = ACTIONS(1990),
  },
  [535] = {
    [sym_line_comment] = STATE(535),
    [sym_block_comment] = STATE(535),
    [ts_builtin_sym_end] = ACTIONS(1994),
    [sym_identifier] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_macro_rules_BANG] = ACTIONS(1994),
    [anon_sym_LPAREN] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_RBRACE] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_u8] = ACTIONS(1996),
    [anon_sym_i8] = ACTIONS(1996),
    [anon_sym_u16] = ACTIONS(1996),
    [anon_sym_i16] = ACTIONS(1996),
    [anon_sym_u32] = ACTIONS(1996),
    [anon_sym_i32] = ACTIONS(1996),
    [anon_sym_u64] = ACTIONS(1996),
    [anon_sym_i64] = ACTIONS(1996),
    [anon_sym_u128] = ACTIONS(1996),
    [anon_sym_i128] = ACTIONS(1996),
    [anon_sym_isize] = ACTIONS(1996),
    [anon_sym_usize] = ACTIONS(1996),
    [anon_sym_f32] = ACTIONS(1996),
    [anon_sym_f64] = ACTIONS(1996),
    [anon_sym_bool] = ACTIONS(1996),
    [anon_sym_str] = ACTIONS(1996),
    [anon_sym_char] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_PIPE] = ACTIONS(1994),
    [anon_sym_LT] = ACTIONS(1994),
    [anon_sym_DOT_DOT] = ACTIONS(1994),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [anon_sym_POUND] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1996),
    [anon_sym_async] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_fn] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_impl] = ACTIONS(1996),
    [anon_sym_let] = ACTIONS(1996),
    [anon_sym_loop] = ACTIONS(1996),
    [anon_sym_match] = ACTIONS(1996),
    [anon_sym_mod] = ACTIONS(1996),
    [anon_sym_pub] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_trait] = ACTIONS(1996),
    [anon_sym_type] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_unsafe] = ACTIONS(1996),
    [anon_sym_use] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym_yield] = ACTIONS(1996),
    [anon_sym_move] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [sym_integer_literal] = ACTIONS(1994),
    [aux_sym_string_literal_token1] = ACTIONS(1994),
    [sym_char_literal] = ACTIONS(1994),
    [anon_sym_true] = ACTIONS(1996),
    [anon_sym_false] = ACTIONS(1996),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1996),
    [sym_super] = ACTIONS(1996),
    [sym_crate] = ACTIONS(1996),
    [sym_metavariable] = ACTIONS(1994),
    [sym__raw_string_literal_start] = ACTIONS(1994),
    [sym_float_literal] = ACTIONS(1994),
  },
  [536] = {
    [sym_line_comment] = STATE(536),
    [sym_block_comment] = STATE(536),
    [ts_builtin_sym_end] = ACTIONS(1998),
    [sym_identifier] = ACTIONS(2000),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym_macro_rules_BANG] = ACTIONS(1998),
    [anon_sym_LPAREN] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(1998),
    [anon_sym_LBRACE] = ACTIONS(1998),
    [anon_sym_RBRACE] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(1998),
    [anon_sym_u8] = ACTIONS(2000),
    [anon_sym_i8] = ACTIONS(2000),
    [anon_sym_u16] = ACTIONS(2000),
    [anon_sym_i16] = ACTIONS(2000),
    [anon_sym_u32] = ACTIONS(2000),
    [anon_sym_i32] = ACTIONS(2000),
    [anon_sym_u64] = ACTIONS(2000),
    [anon_sym_i64] = ACTIONS(2000),
    [anon_sym_u128] = ACTIONS(2000),
    [anon_sym_i128] = ACTIONS(2000),
    [anon_sym_isize] = ACTIONS(2000),
    [anon_sym_usize] = ACTIONS(2000),
    [anon_sym_f32] = ACTIONS(2000),
    [anon_sym_f64] = ACTIONS(2000),
    [anon_sym_bool] = ACTIONS(2000),
    [anon_sym_str] = ACTIONS(2000),
    [anon_sym_char] = ACTIONS(2000),
    [anon_sym_DASH] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(1998),
    [anon_sym_AMP] = ACTIONS(1998),
    [anon_sym_PIPE] = ACTIONS(1998),
    [anon_sym_LT] = ACTIONS(1998),
    [anon_sym_DOT_DOT] = ACTIONS(1998),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_POUND] = ACTIONS(1998),
    [anon_sym_SQUOTE] = ACTIONS(2000),
    [anon_sym_async] = ACTIONS(2000),
    [anon_sym_break] = ACTIONS(2000),
    [anon_sym_const] = ACTIONS(2000),
    [anon_sym_continue] = ACTIONS(2000),
    [anon_sym_default] = ACTIONS(2000),
    [anon_sym_enum] = ACTIONS(2000),
    [anon_sym_fn] = ACTIONS(2000),
    [anon_sym_for] = ACTIONS(2000),
    [anon_sym_if] = ACTIONS(2000),
    [anon_sym_impl] = ACTIONS(2000),
    [anon_sym_let] = ACTIONS(2000),
    [anon_sym_loop] = ACTIONS(2000),
    [anon_sym_match] = ACTIONS(2000),
    [anon_sym_mod] = ACTIONS(2000),
    [anon_sym_pub] = ACTIONS(2000),
    [anon_sym_return] = ACTIONS(2000),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_struct] = ACTIONS(2000),
    [anon_sym_trait] = ACTIONS(2000),
    [anon_sym_type] = ACTIONS(2000),
    [anon_sym_union] = ACTIONS(2000),
    [anon_sym_unsafe] = ACTIONS(2000),
    [anon_sym_use] = ACTIONS(2000),
    [anon_sym_while] = ACTIONS(2000),
    [anon_sym_extern] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(2000),
    [anon_sym_move] = ACTIONS(2000),
    [anon_sym_try] = ACTIONS(2000),
    [sym_integer_literal] = ACTIONS(1998),
    [aux_sym_string_literal_token1] = ACTIONS(1998),
    [sym_char_literal] = ACTIONS(1998),
    [anon_sym_true] = ACTIONS(2000),
    [anon_sym_false] = ACTIONS(2000),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2000),
    [sym_super] = ACTIONS(2000),
    [sym_crate] = ACTIONS(2000),
    [sym_metavariable] = ACTIONS(1998),
    [sym__raw_string_literal_start] = ACTIONS(1998),
    [sym_float_literal] = ACTIONS(1998),
  },
  [537] = {
    [sym_line_comment] = STATE(537),
    [sym_block_comment] = STATE(537),
    [ts_builtin_sym_end] = ACTIONS(2002),
    [sym_identifier] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2002),
    [anon_sym_macro_rules_BANG] = ACTIONS(2002),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2002),
    [anon_sym_LBRACE] = ACTIONS(2002),
    [anon_sym_RBRACE] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(2002),
    [anon_sym_u8] = ACTIONS(2004),
    [anon_sym_i8] = ACTIONS(2004),
    [anon_sym_u16] = ACTIONS(2004),
    [anon_sym_i16] = ACTIONS(2004),
    [anon_sym_u32] = ACTIONS(2004),
    [anon_sym_i32] = ACTIONS(2004),
    [anon_sym_u64] = ACTIONS(2004),
    [anon_sym_i64] = ACTIONS(2004),
    [anon_sym_u128] = ACTIONS(2004),
    [anon_sym_i128] = ACTIONS(2004),
    [anon_sym_isize] = ACTIONS(2004),
    [anon_sym_usize] = ACTIONS(2004),
    [anon_sym_f32] = ACTIONS(2004),
    [anon_sym_f64] = ACTIONS(2004),
    [anon_sym_bool] = ACTIONS(2004),
    [anon_sym_str] = ACTIONS(2004),
    [anon_sym_char] = ACTIONS(2004),
    [anon_sym_DASH] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_AMP] = ACTIONS(2002),
    [anon_sym_PIPE] = ACTIONS(2002),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_DOT_DOT] = ACTIONS(2002),
    [anon_sym_COLON_COLON] = ACTIONS(2002),
    [anon_sym_POUND] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_async] = ACTIONS(2004),
    [anon_sym_break] = ACTIONS(2004),
    [anon_sym_const] = ACTIONS(2004),
    [anon_sym_continue] = ACTIONS(2004),
    [anon_sym_default] = ACTIONS(2004),
    [anon_sym_enum] = ACTIONS(2004),
    [anon_sym_fn] = ACTIONS(2004),
    [anon_sym_for] = ACTIONS(2004),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_impl] = ACTIONS(2004),
    [anon_sym_let] = ACTIONS(2004),
    [anon_sym_loop] = ACTIONS(2004),
    [anon_sym_match] = ACTIONS(2004),
    [anon_sym_mod] = ACTIONS(2004),
    [anon_sym_pub] = ACTIONS(2004),
    [anon_sym_return] = ACTIONS(2004),
    [anon_sym_static] = ACTIONS(2004),
    [anon_sym_struct] = ACTIONS(2004),
    [anon_sym_trait] = ACTIONS(2004),
    [anon_sym_type] = ACTIONS(2004),
    [anon_sym_union] = ACTIONS(2004),
    [anon_sym_unsafe] = ACTIONS(2004),
    [anon_sym_use] = ACTIONS(2004),
    [anon_sym_while] = ACTIONS(2004),
    [anon_sym_extern] = ACTIONS(2004),
    [anon_sym_yield] = ACTIONS(2004),
    [anon_sym_move] = ACTIONS(2004),
    [anon_sym_try] = ACTIONS(2004),
    [sym_integer_literal] = ACTIONS(2002),
    [aux_sym_string_literal_token1] = ACTIONS(2002),
    [sym_char_literal] = ACTIONS(2002),
    [anon_sym_true] = ACTIONS(2004),
    [anon_sym_false] = ACTIONS(2004),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2004),
    [sym_super] = ACTIONS(2004),
    [sym_crate] = ACTIONS(2004),
    [sym_metavariable] = ACTIONS(2002),
    [sym__raw_string_literal_start] = ACTIONS(2002),
    [sym_float_literal] = ACTIONS(2002),
  },
  [538] = {
    [sym_line_comment] = STATE(538),
    [sym_block_comment] = STATE(538),
    [ts_builtin_sym_end] = ACTIONS(2006),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym_macro_rules_BANG] = ACTIONS(2006),
    [anon_sym_LPAREN] = ACTIONS(2006),
    [anon_sym_LBRACK] = ACTIONS(2006),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_RBRACE] = ACTIONS(2006),
    [anon_sym_STAR] = ACTIONS(2006),
    [anon_sym_u8] = ACTIONS(2008),
    [anon_sym_i8] = ACTIONS(2008),
    [anon_sym_u16] = ACTIONS(2008),
    [anon_sym_i16] = ACTIONS(2008),
    [anon_sym_u32] = ACTIONS(2008),
    [anon_sym_i32] = ACTIONS(2008),
    [anon_sym_u64] = ACTIONS(2008),
    [anon_sym_i64] = ACTIONS(2008),
    [anon_sym_u128] = ACTIONS(2008),
    [anon_sym_i128] = ACTIONS(2008),
    [anon_sym_isize] = ACTIONS(2008),
    [anon_sym_usize] = ACTIONS(2008),
    [anon_sym_f32] = ACTIONS(2008),
    [anon_sym_f64] = ACTIONS(2008),
    [anon_sym_bool] = ACTIONS(2008),
    [anon_sym_str] = ACTIONS(2008),
    [anon_sym_char] = ACTIONS(2008),
    [anon_sym_DASH] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2006),
    [anon_sym_LT] = ACTIONS(2006),
    [anon_sym_DOT_DOT] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(2006),
    [anon_sym_POUND] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(2008),
    [anon_sym_async] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(2008),
    [anon_sym_continue] = ACTIONS(2008),
    [anon_sym_default] = ACTIONS(2008),
    [anon_sym_enum] = ACTIONS(2008),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_for] = ACTIONS(2008),
    [anon_sym_if] = ACTIONS(2008),
    [anon_sym_impl] = ACTIONS(2008),
    [anon_sym_let] = ACTIONS(2008),
    [anon_sym_loop] = ACTIONS(2008),
    [anon_sym_match] = ACTIONS(2008),
    [anon_sym_mod] = ACTIONS(2008),
    [anon_sym_pub] = ACTIONS(2008),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_struct] = ACTIONS(2008),
    [anon_sym_trait] = ACTIONS(2008),
    [anon_sym_type] = ACTIONS(2008),
    [anon_sym_union] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(2008),
    [anon_sym_use] = ACTIONS(2008),
    [anon_sym_while] = ACTIONS(2008),
    [anon_sym_extern] = ACTIONS(2008),
    [anon_sym_yield] = ACTIONS(2008),
    [anon_sym_move] = ACTIONS(2008),
    [anon_sym_try] = ACTIONS(2008),
    [sym_integer_literal] = ACTIONS(2006),
    [aux_sym_string_literal_token1] = ACTIONS(2006),
    [sym_char_literal] = ACTIONS(2006),
    [anon_sym_true] = ACTIONS(2008),
    [anon_sym_false] = ACTIONS(2008),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2008),
    [sym_super] = ACTIONS(2008),
    [sym_crate] = ACTIONS(2008),
    [sym_metavariable] = ACTIONS(2006),
    [sym__raw_string_literal_start] = ACTIONS(2006),
    [sym_float_literal] = ACTIONS(2006),
  },
  [539] = {
    [sym_line_comment] = STATE(539),
    [sym_block_comment] = STATE(539),
    [ts_builtin_sym_end] = ACTIONS(2010),
    [sym_identifier] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_macro_rules_BANG] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_u8] = ACTIONS(2012),
    [anon_sym_i8] = ACTIONS(2012),
    [anon_sym_u16] = ACTIONS(2012),
    [anon_sym_i16] = ACTIONS(2012),
    [anon_sym_u32] = ACTIONS(2012),
    [anon_sym_i32] = ACTIONS(2012),
    [anon_sym_u64] = ACTIONS(2012),
    [anon_sym_i64] = ACTIONS(2012),
    [anon_sym_u128] = ACTIONS(2012),
    [anon_sym_i128] = ACTIONS(2012),
    [anon_sym_isize] = ACTIONS(2012),
    [anon_sym_usize] = ACTIONS(2012),
    [anon_sym_f32] = ACTIONS(2012),
    [anon_sym_f64] = ACTIONS(2012),
    [anon_sym_bool] = ACTIONS(2012),
    [anon_sym_str] = ACTIONS(2012),
    [anon_sym_char] = ACTIONS(2012),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_POUND] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2012),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_break] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_continue] = ACTIONS(2012),
    [anon_sym_default] = ACTIONS(2012),
    [anon_sym_enum] = ACTIONS(2012),
    [anon_sym_fn] = ACTIONS(2012),
    [anon_sym_for] = ACTIONS(2012),
    [anon_sym_if] = ACTIONS(2012),
    [anon_sym_impl] = ACTIONS(2012),
    [anon_sym_let] = ACTIONS(2012),
    [anon_sym_loop] = ACTIONS(2012),
    [anon_sym_match] = ACTIONS(2012),
    [anon_sym_mod] = ACTIONS(2012),
    [anon_sym_pub] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2012),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_struct] = ACTIONS(2012),
    [anon_sym_trait] = ACTIONS(2012),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_union] = ACTIONS(2012),
    [anon_sym_unsafe] = ACTIONS(2012),
    [anon_sym_use] = ACTIONS(2012),
    [anon_sym_while] = ACTIONS(2012),
    [anon_sym_extern] = ACTIONS(2012),
    [anon_sym_yield] = ACTIONS(2012),
    [anon_sym_move] = ACTIONS(2012),
    [anon_sym_try] = ACTIONS(2012),
    [sym_integer_literal] = ACTIONS(2010),
    [aux_sym_string_literal_token1] = ACTIONS(2010),
    [sym_char_literal] = ACTIONS(2010),
    [anon_sym_true] = ACTIONS(2012),
    [anon_sym_false] = ACTIONS(2012),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2012),
    [sym_super] = ACTIONS(2012),
    [sym_crate] = ACTIONS(2012),
    [sym_metavariable] = ACTIONS(2010),
    [sym__raw_string_literal_start] = ACTIONS(2010),
    [sym_float_literal] = ACTIONS(2010),
  },
  [540] = {
    [sym_line_comment] = STATE(540),
    [sym_block_comment] = STATE(540),
    [ts_builtin_sym_end] = ACTIONS(2014),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_macro_rules_BANG] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(2014),
    [anon_sym_LBRACK] = ACTIONS(2014),
    [anon_sym_LBRACE] = ACTIONS(2014),
    [anon_sym_RBRACE] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_u8] = ACTIONS(2016),
    [anon_sym_i8] = ACTIONS(2016),
    [anon_sym_u16] = ACTIONS(2016),
    [anon_sym_i16] = ACTIONS(2016),
    [anon_sym_u32] = ACTIONS(2016),
    [anon_sym_i32] = ACTIONS(2016),
    [anon_sym_u64] = ACTIONS(2016),
    [anon_sym_i64] = ACTIONS(2016),
    [anon_sym_u128] = ACTIONS(2016),
    [anon_sym_i128] = ACTIONS(2016),
    [anon_sym_isize] = ACTIONS(2016),
    [anon_sym_usize] = ACTIONS(2016),
    [anon_sym_f32] = ACTIONS(2016),
    [anon_sym_f64] = ACTIONS(2016),
    [anon_sym_bool] = ACTIONS(2016),
    [anon_sym_str] = ACTIONS(2016),
    [anon_sym_char] = ACTIONS(2016),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_COLON_COLON] = ACTIONS(2014),
    [anon_sym_POUND] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(2016),
    [anon_sym_break] = ACTIONS(2016),
    [anon_sym_const] = ACTIONS(2016),
    [anon_sym_continue] = ACTIONS(2016),
    [anon_sym_default] = ACTIONS(2016),
    [anon_sym_enum] = ACTIONS(2016),
    [anon_sym_fn] = ACTIONS(2016),
    [anon_sym_for] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(2016),
    [anon_sym_impl] = ACTIONS(2016),
    [anon_sym_let] = ACTIONS(2016),
    [anon_sym_loop] = ACTIONS(2016),
    [anon_sym_match] = ACTIONS(2016),
    [anon_sym_mod] = ACTIONS(2016),
    [anon_sym_pub] = ACTIONS(2016),
    [anon_sym_return] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2016),
    [anon_sym_struct] = ACTIONS(2016),
    [anon_sym_trait] = ACTIONS(2016),
    [anon_sym_type] = ACTIONS(2016),
    [anon_sym_union] = ACTIONS(2016),
    [anon_sym_unsafe] = ACTIONS(2016),
    [anon_sym_use] = ACTIONS(2016),
    [anon_sym_while] = ACTIONS(2016),
    [anon_sym_extern] = ACTIONS(2016),
    [anon_sym_yield] = ACTIONS(2016),
    [anon_sym_move] = ACTIONS(2016),
    [anon_sym_try] = ACTIONS(2016),
    [sym_integer_literal] = ACTIONS(2014),
    [aux_sym_string_literal_token1] = ACTIONS(2014),
    [sym_char_literal] = ACTIONS(2014),
    [anon_sym_true] = ACTIONS(2016),
    [anon_sym_false] = ACTIONS(2016),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2016),
    [sym_super] = ACTIONS(2016),
    [sym_crate] = ACTIONS(2016),
    [sym_metavariable] = ACTIONS(2014),
    [sym__raw_string_literal_start] = ACTIONS(2014),
    [sym_float_literal] = ACTIONS(2014),
  },
  [541] = {
    [sym_line_comment] = STATE(541),
    [sym_block_comment] = STATE(541),
    [ts_builtin_sym_end] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym_macro_rules_BANG] = ACTIONS(2018),
    [anon_sym_LPAREN] = ACTIONS(2018),
    [anon_sym_LBRACK] = ACTIONS(2018),
    [anon_sym_LBRACE] = ACTIONS(2018),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_u8] = ACTIONS(2020),
    [anon_sym_i8] = ACTIONS(2020),
    [anon_sym_u16] = ACTIONS(2020),
    [anon_sym_i16] = ACTIONS(2020),
    [anon_sym_u32] = ACTIONS(2020),
    [anon_sym_i32] = ACTIONS(2020),
    [anon_sym_u64] = ACTIONS(2020),
    [anon_sym_i64] = ACTIONS(2020),
    [anon_sym_u128] = ACTIONS(2020),
    [anon_sym_i128] = ACTIONS(2020),
    [anon_sym_isize] = ACTIONS(2020),
    [anon_sym_usize] = ACTIONS(2020),
    [anon_sym_f32] = ACTIONS(2020),
    [anon_sym_f64] = ACTIONS(2020),
    [anon_sym_bool] = ACTIONS(2020),
    [anon_sym_str] = ACTIONS(2020),
    [anon_sym_char] = ACTIONS(2020),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2018),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [anon_sym_POUND] = ACTIONS(2018),
    [anon_sym_SQUOTE] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2020),
    [anon_sym_break] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_continue] = ACTIONS(2020),
    [anon_sym_default] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_fn] = ACTIONS(2020),
    [anon_sym_for] = ACTIONS(2020),
    [anon_sym_if] = ACTIONS(2020),
    [anon_sym_impl] = ACTIONS(2020),
    [anon_sym_let] = ACTIONS(2020),
    [anon_sym_loop] = ACTIONS(2020),
    [anon_sym_match] = ACTIONS(2020),
    [anon_sym_mod] = ACTIONS(2020),
    [anon_sym_pub] = ACTIONS(2020),
    [anon_sym_return] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_trait] = ACTIONS(2020),
    [anon_sym_type] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_unsafe] = ACTIONS(2020),
    [anon_sym_use] = ACTIONS(2020),
    [anon_sym_while] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym_yield] = ACTIONS(2020),
    [anon_sym_move] = ACTIONS(2020),
    [anon_sym_try] = ACTIONS(2020),
    [sym_integer_literal] = ACTIONS(2018),
    [aux_sym_string_literal_token1] = ACTIONS(2018),
    [sym_char_literal] = ACTIONS(2018),
    [anon_sym_true] = ACTIONS(2020),
    [anon_sym_false] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2020),
    [sym_super] = ACTIONS(2020),
    [sym_crate] = ACTIONS(2020),
    [sym_metavariable] = ACTIONS(2018),
    [sym__raw_string_literal_start] = ACTIONS(2018),
    [sym_float_literal] = ACTIONS(2018),
  },
  [542] = {
    [sym_line_comment] = STATE(542),
    [sym_block_comment] = STATE(542),
    [ts_builtin_sym_end] = ACTIONS(2022),
    [sym_identifier] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym_macro_rules_BANG] = ACTIONS(2022),
    [anon_sym_LPAREN] = ACTIONS(2022),
    [anon_sym_LBRACK] = ACTIONS(2022),
    [anon_sym_LBRACE] = ACTIONS(2022),
    [anon_sym_RBRACE] = ACTIONS(2022),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_u8] = ACTIONS(2024),
    [anon_sym_i8] = ACTIONS(2024),
    [anon_sym_u16] = ACTIONS(2024),
    [anon_sym_i16] = ACTIONS(2024),
    [anon_sym_u32] = ACTIONS(2024),
    [anon_sym_i32] = ACTIONS(2024),
    [anon_sym_u64] = ACTIONS(2024),
    [anon_sym_i64] = ACTIONS(2024),
    [anon_sym_u128] = ACTIONS(2024),
    [anon_sym_i128] = ACTIONS(2024),
    [anon_sym_isize] = ACTIONS(2024),
    [anon_sym_usize] = ACTIONS(2024),
    [anon_sym_f32] = ACTIONS(2024),
    [anon_sym_f64] = ACTIONS(2024),
    [anon_sym_bool] = ACTIONS(2024),
    [anon_sym_str] = ACTIONS(2024),
    [anon_sym_char] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_AMP] = ACTIONS(2022),
    [anon_sym_PIPE] = ACTIONS(2022),
    [anon_sym_LT] = ACTIONS(2022),
    [anon_sym_DOT_DOT] = ACTIONS(2022),
    [anon_sym_COLON_COLON] = ACTIONS(2022),
    [anon_sym_POUND] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(2024),
    [anon_sym_async] = ACTIONS(2024),
    [anon_sym_break] = ACTIONS(2024),
    [anon_sym_const] = ACTIONS(2024),
    [anon_sym_continue] = ACTIONS(2024),
    [anon_sym_default] = ACTIONS(2024),
    [anon_sym_enum] = ACTIONS(2024),
    [anon_sym_fn] = ACTIONS(2024),
    [anon_sym_for] = ACTIONS(2024),
    [anon_sym_if] = ACTIONS(2024),
    [anon_sym_impl] = ACTIONS(2024),
    [anon_sym_let] = ACTIONS(2024),
    [anon_sym_loop] = ACTIONS(2024),
    [anon_sym_match] = ACTIONS(2024),
    [anon_sym_mod] = ACTIONS(2024),
    [anon_sym_pub] = ACTIONS(2024),
    [anon_sym_return] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2024),
    [anon_sym_struct] = ACTIONS(2024),
    [anon_sym_trait] = ACTIONS(2024),
    [anon_sym_type] = ACTIONS(2024),
    [anon_sym_union] = ACTIONS(2024),
    [anon_sym_unsafe] = ACTIONS(2024),
    [anon_sym_use] = ACTIONS(2024),
    [anon_sym_while] = ACTIONS(2024),
    [anon_sym_extern] = ACTIONS(2024),
    [anon_sym_yield] = ACTIONS(2024),
    [anon_sym_move] = ACTIONS(2024),
    [anon_sym_try] = ACTIONS(2024),
    [sym_integer_literal] = ACTIONS(2022),
    [aux_sym_string_literal_token1] = ACTIONS(2022),
    [sym_char_literal] = ACTIONS(2022),
    [anon_sym_true] = ACTIONS(2024),
    [anon_sym_false] = ACTIONS(2024),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2024),
    [sym_super] = ACTIONS(2024),
    [sym_crate] = ACTIONS(2024),
    [sym_metavariable] = ACTIONS(2022),
    [sym__raw_string_literal_start] = ACTIONS(2022),
    [sym_float_literal] = ACTIONS(2022),
  },
  [543] = {
    [sym_line_comment] = STATE(543),
    [sym_block_comment] = STATE(543),
    [ts_builtin_sym_end] = ACTIONS(2026),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym_macro_rules_BANG] = ACTIONS(2026),
    [anon_sym_LPAREN] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2026),
    [anon_sym_LBRACE] = ACTIONS(2026),
    [anon_sym_RBRACE] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_u8] = ACTIONS(2028),
    [anon_sym_i8] = ACTIONS(2028),
    [anon_sym_u16] = ACTIONS(2028),
    [anon_sym_i16] = ACTIONS(2028),
    [anon_sym_u32] = ACTIONS(2028),
    [anon_sym_i32] = ACTIONS(2028),
    [anon_sym_u64] = ACTIONS(2028),
    [anon_sym_i64] = ACTIONS(2028),
    [anon_sym_u128] = ACTIONS(2028),
    [anon_sym_i128] = ACTIONS(2028),
    [anon_sym_isize] = ACTIONS(2028),
    [anon_sym_usize] = ACTIONS(2028),
    [anon_sym_f32] = ACTIONS(2028),
    [anon_sym_f64] = ACTIONS(2028),
    [anon_sym_bool] = ACTIONS(2028),
    [anon_sym_str] = ACTIONS(2028),
    [anon_sym_char] = ACTIONS(2028),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(2026),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_POUND] = ACTIONS(2026),
    [anon_sym_SQUOTE] = ACTIONS(2028),
    [anon_sym_async] = ACTIONS(2028),
    [anon_sym_break] = ACTIONS(2028),
    [anon_sym_const] = ACTIONS(2028),
    [anon_sym_continue] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_enum] = ACTIONS(2028),
    [anon_sym_fn] = ACTIONS(2028),
    [anon_sym_for] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(2028),
    [anon_sym_impl] = ACTIONS(2028),
    [anon_sym_let] = ACTIONS(2028),
    [anon_sym_loop] = ACTIONS(2028),
    [anon_sym_match] = ACTIONS(2028),
    [anon_sym_mod] = ACTIONS(2028),
    [anon_sym_pub] = ACTIONS(2028),
    [anon_sym_return] = ACTIONS(2028),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_struct] = ACTIONS(2028),
    [anon_sym_trait] = ACTIONS(2028),
    [anon_sym_type] = ACTIONS(2028),
    [anon_sym_union] = ACTIONS(2028),
    [anon_sym_unsafe] = ACTIONS(2028),
    [anon_sym_use] = ACTIONS(2028),
    [anon_sym_while] = ACTIONS(2028),
    [anon_sym_extern] = ACTIONS(2028),
    [anon_sym_yield] = ACTIONS(2028),
    [anon_sym_move] = ACTIONS(2028),
    [anon_sym_try] = ACTIONS(2028),
    [sym_integer_literal] = ACTIONS(2026),
    [aux_sym_string_literal_token1] = ACTIONS(2026),
    [sym_char_literal] = ACTIONS(2026),
    [anon_sym_true] = ACTIONS(2028),
    [anon_sym_false] = ACTIONS(2028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2028),
    [sym_super] = ACTIONS(2028),
    [sym_crate] = ACTIONS(2028),
    [sym_metavariable] = ACTIONS(2026),
    [sym__raw_string_literal_start] = ACTIONS(2026),
    [sym_float_literal] = ACTIONS(2026),
  },
  [544] = {
    [sym_line_comment] = STATE(544),
    [sym_block_comment] = STATE(544),
    [ts_builtin_sym_end] = ACTIONS(2030),
    [sym_identifier] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_macro_rules_BANG] = ACTIONS(2030),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [anon_sym_LBRACK] = ACTIONS(2030),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_RBRACE] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_u8] = ACTIONS(2032),
    [anon_sym_i8] = ACTIONS(2032),
    [anon_sym_u16] = ACTIONS(2032),
    [anon_sym_i16] = ACTIONS(2032),
    [anon_sym_u32] = ACTIONS(2032),
    [anon_sym_i32] = ACTIONS(2032),
    [anon_sym_u64] = ACTIONS(2032),
    [anon_sym_i64] = ACTIONS(2032),
    [anon_sym_u128] = ACTIONS(2032),
    [anon_sym_i128] = ACTIONS(2032),
    [anon_sym_isize] = ACTIONS(2032),
    [anon_sym_usize] = ACTIONS(2032),
    [anon_sym_f32] = ACTIONS(2032),
    [anon_sym_f64] = ACTIONS(2032),
    [anon_sym_bool] = ACTIONS(2032),
    [anon_sym_str] = ACTIONS(2032),
    [anon_sym_char] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_DOT_DOT] = ACTIONS(2030),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_POUND] = ACTIONS(2030),
    [anon_sym_SQUOTE] = ACTIONS(2032),
    [anon_sym_async] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_fn] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_impl] = ACTIONS(2032),
    [anon_sym_let] = ACTIONS(2032),
    [anon_sym_loop] = ACTIONS(2032),
    [anon_sym_match] = ACTIONS(2032),
    [anon_sym_mod] = ACTIONS(2032),
    [anon_sym_pub] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_trait] = ACTIONS(2032),
    [anon_sym_type] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_unsafe] = ACTIONS(2032),
    [anon_sym_use] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym_yield] = ACTIONS(2032),
    [anon_sym_move] = ACTIONS(2032),
    [anon_sym_try] = ACTIONS(2032),
    [sym_integer_literal] = ACTIONS(2030),
    [aux_sym_string_literal_token1] = ACTIONS(2030),
    [sym_char_literal] = ACTIONS(2030),
    [anon_sym_true] = ACTIONS(2032),
    [anon_sym_false] = ACTIONS(2032),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2032),
    [sym_super] = ACTIONS(2032),
    [sym_crate] = ACTIONS(2032),
    [sym_metavariable] = ACTIONS(2030),
    [sym__raw_string_literal_start] = ACTIONS(2030),
    [sym_float_literal] = ACTIONS(2030),
  },
  [545] = {
    [sym_line_comment] = STATE(545),
    [sym_block_comment] = STATE(545),
    [ts_builtin_sym_end] = ACTIONS(2034),
    [sym_identifier] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_macro_rules_BANG] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(2034),
    [anon_sym_LBRACK] = ACTIONS(2034),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(2036),
    [anon_sym_i8] = ACTIONS(2036),
    [anon_sym_u16] = ACTIONS(2036),
    [anon_sym_i16] = ACTIONS(2036),
    [anon_sym_u32] = ACTIONS(2036),
    [anon_sym_i32] = ACTIONS(2036),
    [anon_sym_u64] = ACTIONS(2036),
    [anon_sym_i64] = ACTIONS(2036),
    [anon_sym_u128] = ACTIONS(2036),
    [anon_sym_i128] = ACTIONS(2036),
    [anon_sym_isize] = ACTIONS(2036),
    [anon_sym_usize] = ACTIONS(2036),
    [anon_sym_f32] = ACTIONS(2036),
    [anon_sym_f64] = ACTIONS(2036),
    [anon_sym_bool] = ACTIONS(2036),
    [anon_sym_str] = ACTIONS(2036),
    [anon_sym_char] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_AMP] = ACTIONS(2034),
    [anon_sym_PIPE] = ACTIONS(2034),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_DOT_DOT] = ACTIONS(2034),
    [anon_sym_COLON_COLON] = ACTIONS(2034),
    [anon_sym_POUND] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2036),
    [anon_sym_async] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_default] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [anon_sym_fn] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_impl] = ACTIONS(2036),
    [anon_sym_let] = ACTIONS(2036),
    [anon_sym_loop] = ACTIONS(2036),
    [anon_sym_match] = ACTIONS(2036),
    [anon_sym_mod] = ACTIONS(2036),
    [anon_sym_pub] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_struct] = ACTIONS(2036),
    [anon_sym_trait] = ACTIONS(2036),
    [anon_sym_type] = ACTIONS(2036),
    [anon_sym_union] = ACTIONS(2036),
    [anon_sym_unsafe] = ACTIONS(2036),
    [anon_sym_use] = ACTIONS(2036),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_extern] = ACTIONS(2036),
    [anon_sym_yield] = ACTIONS(2036),
    [anon_sym_move] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [sym_integer_literal] = ACTIONS(2034),
    [aux_sym_string_literal_token1] = ACTIONS(2034),
    [sym_char_literal] = ACTIONS(2034),
    [anon_sym_true] = ACTIONS(2036),
    [anon_sym_false] = ACTIONS(2036),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2036),
    [sym_super] = ACTIONS(2036),
    [sym_crate] = ACTIONS(2036),
    [sym_metavariable] = ACTIONS(2034),
    [sym__raw_string_literal_start] = ACTIONS(2034),
    [sym_float_literal] = ACTIONS(2034),
  },
  [546] = {
    [sym_line_comment] = STATE(546),
    [sym_block_comment] = STATE(546),
    [ts_builtin_sym_end] = ACTIONS(2038),
    [sym_identifier] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_macro_rules_BANG] = ACTIONS(2038),
    [anon_sym_LPAREN] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2038),
    [anon_sym_RBRACE] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_u8] = ACTIONS(2040),
    [anon_sym_i8] = ACTIONS(2040),
    [anon_sym_u16] = ACTIONS(2040),
    [anon_sym_i16] = ACTIONS(2040),
    [anon_sym_u32] = ACTIONS(2040),
    [anon_sym_i32] = ACTIONS(2040),
    [anon_sym_u64] = ACTIONS(2040),
    [anon_sym_i64] = ACTIONS(2040),
    [anon_sym_u128] = ACTIONS(2040),
    [anon_sym_i128] = ACTIONS(2040),
    [anon_sym_isize] = ACTIONS(2040),
    [anon_sym_usize] = ACTIONS(2040),
    [anon_sym_f32] = ACTIONS(2040),
    [anon_sym_f64] = ACTIONS(2040),
    [anon_sym_bool] = ACTIONS(2040),
    [anon_sym_str] = ACTIONS(2040),
    [anon_sym_char] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(2038),
    [anon_sym_LT] = ACTIONS(2038),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_POUND] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2040),
    [anon_sym_async] = ACTIONS(2040),
    [anon_sym_break] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_continue] = ACTIONS(2040),
    [anon_sym_default] = ACTIONS(2040),
    [anon_sym_enum] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2040),
    [anon_sym_for] = ACTIONS(2040),
    [anon_sym_if] = ACTIONS(2040),
    [anon_sym_impl] = ACTIONS(2040),
    [anon_sym_let] = ACTIONS(2040),
    [anon_sym_loop] = ACTIONS(2040),
    [anon_sym_match] = ACTIONS(2040),
    [anon_sym_mod] = ACTIONS(2040),
    [anon_sym_pub] = ACTIONS(2040),
    [anon_sym_return] = ACTIONS(2040),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_struct] = ACTIONS(2040),
    [anon_sym_trait] = ACTIONS(2040),
    [anon_sym_type] = ACTIONS(2040),
    [anon_sym_union] = ACTIONS(2040),
    [anon_sym_unsafe] = ACTIONS(2040),
    [anon_sym_use] = ACTIONS(2040),
    [anon_sym_while] = ACTIONS(2040),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym_yield] = ACTIONS(2040),
    [anon_sym_move] = ACTIONS(2040),
    [anon_sym_try] = ACTIONS(2040),
    [sym_integer_literal] = ACTIONS(2038),
    [aux_sym_string_literal_token1] = ACTIONS(2038),
    [sym_char_literal] = ACTIONS(2038),
    [anon_sym_true] = ACTIONS(2040),
    [anon_sym_false] = ACTIONS(2040),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2040),
    [sym_super] = ACTIONS(2040),
    [sym_crate] = ACTIONS(2040),
    [sym_metavariable] = ACTIONS(2038),
    [sym__raw_string_literal_start] = ACTIONS(2038),
    [sym_float_literal] = ACTIONS(2038),
  },
  [547] = {
    [sym_line_comment] = STATE(547),
    [sym_block_comment] = STATE(547),
    [ts_builtin_sym_end] = ACTIONS(2042),
    [sym_identifier] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym_macro_rules_BANG] = ACTIONS(2042),
    [anon_sym_LPAREN] = ACTIONS(2042),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_u8] = ACTIONS(2044),
    [anon_sym_i8] = ACTIONS(2044),
    [anon_sym_u16] = ACTIONS(2044),
    [anon_sym_i16] = ACTIONS(2044),
    [anon_sym_u32] = ACTIONS(2044),
    [anon_sym_i32] = ACTIONS(2044),
    [anon_sym_u64] = ACTIONS(2044),
    [anon_sym_i64] = ACTIONS(2044),
    [anon_sym_u128] = ACTIONS(2044),
    [anon_sym_i128] = ACTIONS(2044),
    [anon_sym_isize] = ACTIONS(2044),
    [anon_sym_usize] = ACTIONS(2044),
    [anon_sym_f32] = ACTIONS(2044),
    [anon_sym_f64] = ACTIONS(2044),
    [anon_sym_bool] = ACTIONS(2044),
    [anon_sym_str] = ACTIONS(2044),
    [anon_sym_char] = ACTIONS(2044),
    [anon_sym_DASH] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_PIPE] = ACTIONS(2042),
    [anon_sym_LT] = ACTIONS(2042),
    [anon_sym_DOT_DOT] = ACTIONS(2042),
    [anon_sym_COLON_COLON] = ACTIONS(2042),
    [anon_sym_POUND] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2044),
    [anon_sym_async] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_fn] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_impl] = ACTIONS(2044),
    [anon_sym_let] = ACTIONS(2044),
    [anon_sym_loop] = ACTIONS(2044),
    [anon_sym_match] = ACTIONS(2044),
    [anon_sym_mod] = ACTIONS(2044),
    [anon_sym_pub] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2044),
    [anon_sym_trait] = ACTIONS(2044),
    [anon_sym_type] = ACTIONS(2044),
    [anon_sym_union] = ACTIONS(2044),
    [anon_sym_unsafe] = ACTIONS(2044),
    [anon_sym_use] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_extern] = ACTIONS(2044),
    [anon_sym_yield] = ACTIONS(2044),
    [anon_sym_move] = ACTIONS(2044),
    [anon_sym_try] = ACTIONS(2044),
    [sym_integer_literal] = ACTIONS(2042),
    [aux_sym_string_literal_token1] = ACTIONS(2042),
    [sym_char_literal] = ACTIONS(2042),
    [anon_sym_true] = ACTIONS(2044),
    [anon_sym_false] = ACTIONS(2044),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2044),
    [sym_super] = ACTIONS(2044),
    [sym_crate] = ACTIONS(2044),
    [sym_metavariable] = ACTIONS(2042),
    [sym__raw_string_literal_start] = ACTIONS(2042),
    [sym_float_literal] = ACTIONS(2042),
  },
  [548] = {
    [sym_line_comment] = STATE(548),
    [sym_block_comment] = STATE(548),
    [ts_builtin_sym_end] = ACTIONS(2046),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym_macro_rules_BANG] = ACTIONS(2046),
    [anon_sym_LPAREN] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(2046),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(2046),
    [anon_sym_u8] = ACTIONS(2048),
    [anon_sym_i8] = ACTIONS(2048),
    [anon_sym_u16] = ACTIONS(2048),
    [anon_sym_i16] = ACTIONS(2048),
    [anon_sym_u32] = ACTIONS(2048),
    [anon_sym_i32] = ACTIONS(2048),
    [anon_sym_u64] = ACTIONS(2048),
    [anon_sym_i64] = ACTIONS(2048),
    [anon_sym_u128] = ACTIONS(2048),
    [anon_sym_i128] = ACTIONS(2048),
    [anon_sym_isize] = ACTIONS(2048),
    [anon_sym_usize] = ACTIONS(2048),
    [anon_sym_f32] = ACTIONS(2048),
    [anon_sym_f64] = ACTIONS(2048),
    [anon_sym_bool] = ACTIONS(2048),
    [anon_sym_str] = ACTIONS(2048),
    [anon_sym_char] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2046),
    [anon_sym_PIPE] = ACTIONS(2046),
    [anon_sym_LT] = ACTIONS(2046),
    [anon_sym_DOT_DOT] = ACTIONS(2046),
    [anon_sym_COLON_COLON] = ACTIONS(2046),
    [anon_sym_POUND] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2048),
    [anon_sym_async] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_fn] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_impl] = ACTIONS(2048),
    [anon_sym_let] = ACTIONS(2048),
    [anon_sym_loop] = ACTIONS(2048),
    [anon_sym_match] = ACTIONS(2048),
    [anon_sym_mod] = ACTIONS(2048),
    [anon_sym_pub] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_trait] = ACTIONS(2048),
    [anon_sym_type] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_unsafe] = ACTIONS(2048),
    [anon_sym_use] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym_yield] = ACTIONS(2048),
    [anon_sym_move] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [sym_integer_literal] = ACTIONS(2046),
    [aux_sym_string_literal_token1] = ACTIONS(2046),
    [sym_char_literal] = ACTIONS(2046),
    [anon_sym_true] = ACTIONS(2048),
    [anon_sym_false] = ACTIONS(2048),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2048),
    [sym_super] = ACTIONS(2048),
    [sym_crate] = ACTIONS(2048),
    [sym_metavariable] = ACTIONS(2046),
    [sym__raw_string_literal_start] = ACTIONS(2046),
    [sym_float_literal] = ACTIONS(2046),
  },
  [549] = {
    [sym_line_comment] = STATE(549),
    [sym_block_comment] = STATE(549),
    [ts_builtin_sym_end] = ACTIONS(2050),
    [sym_identifier] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym_macro_rules_BANG] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2050),
    [anon_sym_u8] = ACTIONS(2052),
    [anon_sym_i8] = ACTIONS(2052),
    [anon_sym_u16] = ACTIONS(2052),
    [anon_sym_i16] = ACTIONS(2052),
    [anon_sym_u32] = ACTIONS(2052),
    [anon_sym_i32] = ACTIONS(2052),
    [anon_sym_u64] = ACTIONS(2052),
    [anon_sym_i64] = ACTIONS(2052),
    [anon_sym_u128] = ACTIONS(2052),
    [anon_sym_i128] = ACTIONS(2052),
    [anon_sym_isize] = ACTIONS(2052),
    [anon_sym_usize] = ACTIONS(2052),
    [anon_sym_f32] = ACTIONS(2052),
    [anon_sym_f64] = ACTIONS(2052),
    [anon_sym_bool] = ACTIONS(2052),
    [anon_sym_str] = ACTIONS(2052),
    [anon_sym_char] = ACTIONS(2052),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2050),
    [anon_sym_DOT_DOT] = ACTIONS(2050),
    [anon_sym_COLON_COLON] = ACTIONS(2050),
    [anon_sym_POUND] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2052),
    [anon_sym_async] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
    [anon_sym_fn] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_impl] = ACTIONS(2052),
    [anon_sym_let] = ACTIONS(2052),
    [anon_sym_loop] = ACTIONS(2052),
    [anon_sym_match] = ACTIONS(2052),
    [anon_sym_mod] = ACTIONS(2052),
    [anon_sym_pub] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_struct] = ACTIONS(2052),
    [anon_sym_trait] = ACTIONS(2052),
    [anon_sym_type] = ACTIONS(2052),
    [anon_sym_union] = ACTIONS(2052),
    [anon_sym_unsafe] = ACTIONS(2052),
    [anon_sym_use] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_extern] = ACTIONS(2052),
    [anon_sym_yield] = ACTIONS(2052),
    [anon_sym_move] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [sym_integer_literal] = ACTIONS(2050),
    [aux_sym_string_literal_token1] = ACTIONS(2050),
    [sym_char_literal] = ACTIONS(2050),
    [anon_sym_true] = ACTIONS(2052),
    [anon_sym_false] = ACTIONS(2052),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2052),
    [sym_super] = ACTIONS(2052),
    [sym_crate] = ACTIONS(2052),
    [sym_metavariable] = ACTIONS(2050),
    [sym__raw_string_literal_start] = ACTIONS(2050),
    [sym_float_literal] = ACTIONS(2050),
  },
  [550] = {
    [sym_line_comment] = STATE(550),
    [sym_block_comment] = STATE(550),
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_macro_rules_BANG] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2054),
    [anon_sym_LBRACK] = ACTIONS(2054),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_u8] = ACTIONS(2056),
    [anon_sym_i8] = ACTIONS(2056),
    [anon_sym_u16] = ACTIONS(2056),
    [anon_sym_i16] = ACTIONS(2056),
    [anon_sym_u32] = ACTIONS(2056),
    [anon_sym_i32] = ACTIONS(2056),
    [anon_sym_u64] = ACTIONS(2056),
    [anon_sym_i64] = ACTIONS(2056),
    [anon_sym_u128] = ACTIONS(2056),
    [anon_sym_i128] = ACTIONS(2056),
    [anon_sym_isize] = ACTIONS(2056),
    [anon_sym_usize] = ACTIONS(2056),
    [anon_sym_f32] = ACTIONS(2056),
    [anon_sym_f64] = ACTIONS(2056),
    [anon_sym_bool] = ACTIONS(2056),
    [anon_sym_str] = ACTIONS(2056),
    [anon_sym_char] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2054),
    [anon_sym_POUND] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2056),
    [anon_sym_async] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_fn] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_impl] = ACTIONS(2056),
    [anon_sym_let] = ACTIONS(2056),
    [anon_sym_loop] = ACTIONS(2056),
    [anon_sym_match] = ACTIONS(2056),
    [anon_sym_mod] = ACTIONS(2056),
    [anon_sym_pub] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_trait] = ACTIONS(2056),
    [anon_sym_type] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [anon_sym_unsafe] = ACTIONS(2056),
    [anon_sym_use] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym_yield] = ACTIONS(2056),
    [anon_sym_move] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [sym_integer_literal] = ACTIONS(2054),
    [aux_sym_string_literal_token1] = ACTIONS(2054),
    [sym_char_literal] = ACTIONS(2054),
    [anon_sym_true] = ACTIONS(2056),
    [anon_sym_false] = ACTIONS(2056),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2056),
    [sym_super] = ACTIONS(2056),
    [sym_crate] = ACTIONS(2056),
    [sym_metavariable] = ACTIONS(2054),
    [sym__raw_string_literal_start] = ACTIONS(2054),
    [sym_float_literal] = ACTIONS(2054),
  },
  [551] = {
    [sym_line_comment] = STATE(551),
    [sym_block_comment] = STATE(551),
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_macro_rules_BANG] = ACTIONS(2058),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_u8] = ACTIONS(2060),
    [anon_sym_i8] = ACTIONS(2060),
    [anon_sym_u16] = ACTIONS(2060),
    [anon_sym_i16] = ACTIONS(2060),
    [anon_sym_u32] = ACTIONS(2060),
    [anon_sym_i32] = ACTIONS(2060),
    [anon_sym_u64] = ACTIONS(2060),
    [anon_sym_i64] = ACTIONS(2060),
    [anon_sym_u128] = ACTIONS(2060),
    [anon_sym_i128] = ACTIONS(2060),
    [anon_sym_isize] = ACTIONS(2060),
    [anon_sym_usize] = ACTIONS(2060),
    [anon_sym_f32] = ACTIONS(2060),
    [anon_sym_f64] = ACTIONS(2060),
    [anon_sym_bool] = ACTIONS(2060),
    [anon_sym_str] = ACTIONS(2060),
    [anon_sym_char] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2058),
    [anon_sym_PIPE] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_DOT_DOT] = ACTIONS(2058),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_POUND] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_fn] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_impl] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_loop] = ACTIONS(2060),
    [anon_sym_match] = ACTIONS(2060),
    [anon_sym_mod] = ACTIONS(2060),
    [anon_sym_pub] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_trait] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [anon_sym_unsafe] = ACTIONS(2060),
    [anon_sym_use] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_move] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [sym_integer_literal] = ACTIONS(2058),
    [aux_sym_string_literal_token1] = ACTIONS(2058),
    [sym_char_literal] = ACTIONS(2058),
    [anon_sym_true] = ACTIONS(2060),
    [anon_sym_false] = ACTIONS(2060),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_crate] = ACTIONS(2060),
    [sym_metavariable] = ACTIONS(2058),
    [sym__raw_string_literal_start] = ACTIONS(2058),
    [sym_float_literal] = ACTIONS(2058),
  },
  [552] = {
    [sym_line_comment] = STATE(552),
    [sym_block_comment] = STATE(552),
    [ts_builtin_sym_end] = ACTIONS(2062),
    [sym_identifier] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym_macro_rules_BANG] = ACTIONS(2062),
    [anon_sym_LPAREN] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_RBRACE] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_u8] = ACTIONS(2064),
    [anon_sym_i8] = ACTIONS(2064),
    [anon_sym_u16] = ACTIONS(2064),
    [anon_sym_i16] = ACTIONS(2064),
    [anon_sym_u32] = ACTIONS(2064),
    [anon_sym_i32] = ACTIONS(2064),
    [anon_sym_u64] = ACTIONS(2064),
    [anon_sym_i64] = ACTIONS(2064),
    [anon_sym_u128] = ACTIONS(2064),
    [anon_sym_i128] = ACTIONS(2064),
    [anon_sym_isize] = ACTIONS(2064),
    [anon_sym_usize] = ACTIONS(2064),
    [anon_sym_f32] = ACTIONS(2064),
    [anon_sym_f64] = ACTIONS(2064),
    [anon_sym_bool] = ACTIONS(2064),
    [anon_sym_str] = ACTIONS(2064),
    [anon_sym_char] = ACTIONS(2064),
    [anon_sym_DASH] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2062),
    [anon_sym_DOT_DOT] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_POUND] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2064),
    [anon_sym_async] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_impl] = ACTIONS(2064),
    [anon_sym_let] = ACTIONS(2064),
    [anon_sym_loop] = ACTIONS(2064),
    [anon_sym_match] = ACTIONS(2064),
    [anon_sym_mod] = ACTIONS(2064),
    [anon_sym_pub] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_struct] = ACTIONS(2064),
    [anon_sym_trait] = ACTIONS(2064),
    [anon_sym_type] = ACTIONS(2064),
    [anon_sym_union] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(2064),
    [anon_sym_use] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2064),
    [anon_sym_yield] = ACTIONS(2064),
    [anon_sym_move] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [sym_integer_literal] = ACTIONS(2062),
    [aux_sym_string_literal_token1] = ACTIONS(2062),
    [sym_char_literal] = ACTIONS(2062),
    [anon_sym_true] = ACTIONS(2064),
    [anon_sym_false] = ACTIONS(2064),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2064),
    [sym_super] = ACTIONS(2064),
    [sym_crate] = ACTIONS(2064),
    [sym_metavariable] = ACTIONS(2062),
    [sym__raw_string_literal_start] = ACTIONS(2062),
    [sym_float_literal] = ACTIONS(2062),
  },
  [553] = {
    [sym_line_comment] = STATE(553),
    [sym_block_comment] = STATE(553),
    [ts_builtin_sym_end] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(2068),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_macro_rules_BANG] = ACTIONS(2066),
    [anon_sym_LPAREN] = ACTIONS(2066),
    [anon_sym_LBRACK] = ACTIONS(2066),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_RBRACE] = ACTIONS(2066),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_u8] = ACTIONS(2068),
    [anon_sym_i8] = ACTIONS(2068),
    [anon_sym_u16] = ACTIONS(2068),
    [anon_sym_i16] = ACTIONS(2068),
    [anon_sym_u32] = ACTIONS(2068),
    [anon_sym_i32] = ACTIONS(2068),
    [anon_sym_u64] = ACTIONS(2068),
    [anon_sym_i64] = ACTIONS(2068),
    [anon_sym_u128] = ACTIONS(2068),
    [anon_sym_i128] = ACTIONS(2068),
    [anon_sym_isize] = ACTIONS(2068),
    [anon_sym_usize] = ACTIONS(2068),
    [anon_sym_f32] = ACTIONS(2068),
    [anon_sym_f64] = ACTIONS(2068),
    [anon_sym_bool] = ACTIONS(2068),
    [anon_sym_str] = ACTIONS(2068),
    [anon_sym_char] = ACTIONS(2068),
    [anon_sym_DASH] = ACTIONS(2066),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2066),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_COLON_COLON] = ACTIONS(2066),
    [anon_sym_POUND] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2068),
    [anon_sym_async] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_default] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_fn] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_impl] = ACTIONS(2068),
    [anon_sym_let] = ACTIONS(2068),
    [anon_sym_loop] = ACTIONS(2068),
    [anon_sym_match] = ACTIONS(2068),
    [anon_sym_mod] = ACTIONS(2068),
    [anon_sym_pub] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_struct] = ACTIONS(2068),
    [anon_sym_trait] = ACTIONS(2068),
    [anon_sym_type] = ACTIONS(2068),
    [anon_sym_union] = ACTIONS(2068),
    [anon_sym_unsafe] = ACTIONS(2068),
    [anon_sym_use] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_extern] = ACTIONS(2068),
    [anon_sym_yield] = ACTIONS(2068),
    [anon_sym_move] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [sym_integer_literal] = ACTIONS(2066),
    [aux_sym_string_literal_token1] = ACTIONS(2066),
    [sym_char_literal] = ACTIONS(2066),
    [anon_sym_true] = ACTIONS(2068),
    [anon_sym_false] = ACTIONS(2068),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2068),
    [sym_super] = ACTIONS(2068),
    [sym_crate] = ACTIONS(2068),
    [sym_metavariable] = ACTIONS(2066),
    [sym__raw_string_literal_start] = ACTIONS(2066),
    [sym_float_literal] = ACTIONS(2066),
  },
  [554] = {
    [sym_line_comment] = STATE(554),
    [sym_block_comment] = STATE(554),
    [ts_builtin_sym_end] = ACTIONS(2070),
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym_macro_rules_BANG] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(2070),
    [anon_sym_LBRACK] = ACTIONS(2070),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_RBRACE] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(2070),
    [anon_sym_u8] = ACTIONS(2072),
    [anon_sym_i8] = ACTIONS(2072),
    [anon_sym_u16] = ACTIONS(2072),
    [anon_sym_i16] = ACTIONS(2072),
    [anon_sym_u32] = ACTIONS(2072),
    [anon_sym_i32] = ACTIONS(2072),
    [anon_sym_u64] = ACTIONS(2072),
    [anon_sym_i64] = ACTIONS(2072),
    [anon_sym_u128] = ACTIONS(2072),
    [anon_sym_i128] = ACTIONS(2072),
    [anon_sym_isize] = ACTIONS(2072),
    [anon_sym_usize] = ACTIONS(2072),
    [anon_sym_f32] = ACTIONS(2072),
    [anon_sym_f64] = ACTIONS(2072),
    [anon_sym_bool] = ACTIONS(2072),
    [anon_sym_str] = ACTIONS(2072),
    [anon_sym_char] = ACTIONS(2072),
    [anon_sym_DASH] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2070),
    [anon_sym_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_DOT_DOT] = ACTIONS(2070),
    [anon_sym_COLON_COLON] = ACTIONS(2070),
    [anon_sym_POUND] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2072),
    [anon_sym_async] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
    [anon_sym_fn] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_impl] = ACTIONS(2072),
    [anon_sym_let] = ACTIONS(2072),
    [anon_sym_loop] = ACTIONS(2072),
    [anon_sym_match] = ACTIONS(2072),
    [anon_sym_mod] = ACTIONS(2072),
    [anon_sym_pub] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_trait] = ACTIONS(2072),
    [anon_sym_type] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2072),
    [anon_sym_unsafe] = ACTIONS(2072),
    [anon_sym_use] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_extern] = ACTIONS(2072),
    [anon_sym_yield] = ACTIONS(2072),
    [anon_sym_move] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_string_literal_token1] = ACTIONS(2070),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2072),
    [anon_sym_false] = ACTIONS(2072),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2072),
    [sym_super] = ACTIONS(2072),
    [sym_crate] = ACTIONS(2072),
    [sym_metavariable] = ACTIONS(2070),
    [sym__raw_string_literal_start] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
  },
  [555] = {
    [sym_line_comment] = STATE(555),
    [sym_block_comment] = STATE(555),
    [ts_builtin_sym_end] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_macro_rules_BANG] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym_DASH] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2074),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [anon_sym_POUND] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2076),
    [anon_sym_async] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
    [anon_sym_fn] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_impl] = ACTIONS(2076),
    [anon_sym_let] = ACTIONS(2076),
    [anon_sym_loop] = ACTIONS(2076),
    [anon_sym_match] = ACTIONS(2076),
    [anon_sym_mod] = ACTIONS(2076),
    [anon_sym_pub] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_struct] = ACTIONS(2076),
    [anon_sym_trait] = ACTIONS(2076),
    [anon_sym_type] = ACTIONS(2076),
    [anon_sym_union] = ACTIONS(2076),
    [anon_sym_unsafe] = ACTIONS(2076),
    [anon_sym_use] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym_yield] = ACTIONS(2076),
    [anon_sym_move] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [sym_integer_literal] = ACTIONS(2074),
    [aux_sym_string_literal_token1] = ACTIONS(2074),
    [sym_char_literal] = ACTIONS(2074),
    [anon_sym_true] = ACTIONS(2076),
    [anon_sym_false] = ACTIONS(2076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2076),
    [sym_super] = ACTIONS(2076),
    [sym_crate] = ACTIONS(2076),
    [sym_metavariable] = ACTIONS(2074),
    [sym__raw_string_literal_start] = ACTIONS(2074),
    [sym_float_literal] = ACTIONS(2074),
  },
  [556] = {
    [sym_line_comment] = STATE(556),
    [sym_block_comment] = STATE(556),
    [ts_builtin_sym_end] = ACTIONS(2078),
    [sym_identifier] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_macro_rules_BANG] = ACTIONS(2078),
    [anon_sym_LPAREN] = ACTIONS(2078),
    [anon_sym_LBRACK] = ACTIONS(2078),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_RBRACE] = ACTIONS(2078),
    [anon_sym_STAR] = ACTIONS(2078),
    [anon_sym_u8] = ACTIONS(2080),
    [anon_sym_i8] = ACTIONS(2080),
    [anon_sym_u16] = ACTIONS(2080),
    [anon_sym_i16] = ACTIONS(2080),
    [anon_sym_u32] = ACTIONS(2080),
    [anon_sym_i32] = ACTIONS(2080),
    [anon_sym_u64] = ACTIONS(2080),
    [anon_sym_i64] = ACTIONS(2080),
    [anon_sym_u128] = ACTIONS(2080),
    [anon_sym_i128] = ACTIONS(2080),
    [anon_sym_isize] = ACTIONS(2080),
    [anon_sym_usize] = ACTIONS(2080),
    [anon_sym_f32] = ACTIONS(2080),
    [anon_sym_f64] = ACTIONS(2080),
    [anon_sym_bool] = ACTIONS(2080),
    [anon_sym_str] = ACTIONS(2080),
    [anon_sym_char] = ACTIONS(2080),
    [anon_sym_DASH] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
    [anon_sym_POUND] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2080),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_fn] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_impl] = ACTIONS(2080),
    [anon_sym_let] = ACTIONS(2080),
    [anon_sym_loop] = ACTIONS(2080),
    [anon_sym_match] = ACTIONS(2080),
    [anon_sym_mod] = ACTIONS(2080),
    [anon_sym_pub] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_trait] = ACTIONS(2080),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [anon_sym_unsafe] = ACTIONS(2080),
    [anon_sym_use] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym_yield] = ACTIONS(2080),
    [anon_sym_move] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [sym_integer_literal] = ACTIONS(2078),
    [aux_sym_string_literal_token1] = ACTIONS(2078),
    [sym_char_literal] = ACTIONS(2078),
    [anon_sym_true] = ACTIONS(2080),
    [anon_sym_false] = ACTIONS(2080),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2080),
    [sym_super] = ACTIONS(2080),
    [sym_crate] = ACTIONS(2080),
    [sym_metavariable] = ACTIONS(2078),
    [sym__raw_string_literal_start] = ACTIONS(2078),
    [sym_float_literal] = ACTIONS(2078),
  },
  [557] = {
    [sym_line_comment] = STATE(557),
    [sym_block_comment] = STATE(557),
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_macro_rules_BANG] = ACTIONS(2082),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_u8] = ACTIONS(2084),
    [anon_sym_i8] = ACTIONS(2084),
    [anon_sym_u16] = ACTIONS(2084),
    [anon_sym_i16] = ACTIONS(2084),
    [anon_sym_u32] = ACTIONS(2084),
    [anon_sym_i32] = ACTIONS(2084),
    [anon_sym_u64] = ACTIONS(2084),
    [anon_sym_i64] = ACTIONS(2084),
    [anon_sym_u128] = ACTIONS(2084),
    [anon_sym_i128] = ACTIONS(2084),
    [anon_sym_isize] = ACTIONS(2084),
    [anon_sym_usize] = ACTIONS(2084),
    [anon_sym_f32] = ACTIONS(2084),
    [anon_sym_f64] = ACTIONS(2084),
    [anon_sym_bool] = ACTIONS(2084),
    [anon_sym_str] = ACTIONS(2084),
    [anon_sym_char] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2082),
    [anon_sym_PIPE] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_DOT_DOT] = ACTIONS(2082),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
    [anon_sym_fn] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_impl] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_loop] = ACTIONS(2084),
    [anon_sym_match] = ACTIONS(2084),
    [anon_sym_mod] = ACTIONS(2084),
    [anon_sym_pub] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_struct] = ACTIONS(2084),
    [anon_sym_trait] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_union] = ACTIONS(2084),
    [anon_sym_unsafe] = ACTIONS(2084),
    [anon_sym_use] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_extern] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_move] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [sym_integer_literal] = ACTIONS(2082),
    [aux_sym_string_literal_token1] = ACTIONS(2082),
    [sym_char_literal] = ACTIONS(2082),
    [anon_sym_true] = ACTIONS(2084),
    [anon_sym_false] = ACTIONS(2084),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_crate] = ACTIONS(2084),
    [sym_metavariable] = ACTIONS(2082),
    [sym__raw_string_literal_start] = ACTIONS(2082),
    [sym_float_literal] = ACTIONS(2082),
  },
  [558] = {
    [sym_line_comment] = STATE(558),
    [sym_block_comment] = STATE(558),
    [ts_builtin_sym_end] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2088),
    [anon_sym_SEMI] = ACTIONS(2086),
    [anon_sym_macro_rules_BANG] = ACTIONS(2086),
    [anon_sym_LPAREN] = ACTIONS(2086),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_LBRACE] = ACTIONS(2086),
    [anon_sym_RBRACE] = ACTIONS(2086),
    [anon_sym_STAR] = ACTIONS(2086),
    [anon_sym_u8] = ACTIONS(2088),
    [anon_sym_i8] = ACTIONS(2088),
    [anon_sym_u16] = ACTIONS(2088),
    [anon_sym_i16] = ACTIONS(2088),
    [anon_sym_u32] = ACTIONS(2088),
    [anon_sym_i32] = ACTIONS(2088),
    [anon_sym_u64] = ACTIONS(2088),
    [anon_sym_i64] = ACTIONS(2088),
    [anon_sym_u128] = ACTIONS(2088),
    [anon_sym_i128] = ACTIONS(2088),
    [anon_sym_isize] = ACTIONS(2088),
    [anon_sym_usize] = ACTIONS(2088),
    [anon_sym_f32] = ACTIONS(2088),
    [anon_sym_f64] = ACTIONS(2088),
    [anon_sym_bool] = ACTIONS(2088),
    [anon_sym_str] = ACTIONS(2088),
    [anon_sym_char] = ACTIONS(2088),
    [anon_sym_DASH] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(2086),
    [anon_sym_AMP] = ACTIONS(2086),
    [anon_sym_PIPE] = ACTIONS(2086),
    [anon_sym_LT] = ACTIONS(2086),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [anon_sym_COLON_COLON] = ACTIONS(2086),
    [anon_sym_POUND] = ACTIONS(2086),
    [anon_sym_SQUOTE] = ACTIONS(2088),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_break] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(2088),
    [anon_sym_continue] = ACTIONS(2088),
    [anon_sym_default] = ACTIONS(2088),
    [anon_sym_enum] = ACTIONS(2088),
    [anon_sym_fn] = ACTIONS(2088),
    [anon_sym_for] = ACTIONS(2088),
    [anon_sym_if] = ACTIONS(2088),
    [anon_sym_impl] = ACTIONS(2088),
    [anon_sym_let] = ACTIONS(2088),
    [anon_sym_loop] = ACTIONS(2088),
    [anon_sym_match] = ACTIONS(2088),
    [anon_sym_mod] = ACTIONS(2088),
    [anon_sym_pub] = ACTIONS(2088),
    [anon_sym_return] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_struct] = ACTIONS(2088),
    [anon_sym_trait] = ACTIONS(2088),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_union] = ACTIONS(2088),
    [anon_sym_unsafe] = ACTIONS(2088),
    [anon_sym_use] = ACTIONS(2088),
    [anon_sym_while] = ACTIONS(2088),
    [anon_sym_extern] = ACTIONS(2088),
    [anon_sym_yield] = ACTIONS(2088),
    [anon_sym_move] = ACTIONS(2088),
    [anon_sym_try] = ACTIONS(2088),
    [sym_integer_literal] = ACTIONS(2086),
    [aux_sym_string_literal_token1] = ACTIONS(2086),
    [sym_char_literal] = ACTIONS(2086),
    [anon_sym_true] = ACTIONS(2088),
    [anon_sym_false] = ACTIONS(2088),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2088),
    [sym_super] = ACTIONS(2088),
    [sym_crate] = ACTIONS(2088),
    [sym_metavariable] = ACTIONS(2086),
    [sym__raw_string_literal_start] = ACTIONS(2086),
    [sym_float_literal] = ACTIONS(2086),
  },
  [559] = {
    [sym_line_comment] = STATE(559),
    [sym_block_comment] = STATE(559),
    [ts_builtin_sym_end] = ACTIONS(2090),
    [sym_identifier] = ACTIONS(2092),
    [anon_sym_SEMI] = ACTIONS(2090),
    [anon_sym_macro_rules_BANG] = ACTIONS(2090),
    [anon_sym_LPAREN] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(2090),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [anon_sym_STAR] = ACTIONS(2090),
    [anon_sym_u8] = ACTIONS(2092),
    [anon_sym_i8] = ACTIONS(2092),
    [anon_sym_u16] = ACTIONS(2092),
    [anon_sym_i16] = ACTIONS(2092),
    [anon_sym_u32] = ACTIONS(2092),
    [anon_sym_i32] = ACTIONS(2092),
    [anon_sym_u64] = ACTIONS(2092),
    [anon_sym_i64] = ACTIONS(2092),
    [anon_sym_u128] = ACTIONS(2092),
    [anon_sym_i128] = ACTIONS(2092),
    [anon_sym_isize] = ACTIONS(2092),
    [anon_sym_usize] = ACTIONS(2092),
    [anon_sym_f32] = ACTIONS(2092),
    [anon_sym_f64] = ACTIONS(2092),
    [anon_sym_bool] = ACTIONS(2092),
    [anon_sym_str] = ACTIONS(2092),
    [anon_sym_char] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2090),
    [anon_sym_BANG] = ACTIONS(2090),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym_PIPE] = ACTIONS(2090),
    [anon_sym_LT] = ACTIONS(2090),
    [anon_sym_DOT_DOT] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2090),
    [anon_sym_POUND] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2092),
    [anon_sym_async] = ACTIONS(2092),
    [anon_sym_break] = ACTIONS(2092),
    [anon_sym_const] = ACTIONS(2092),
    [anon_sym_continue] = ACTIONS(2092),
    [anon_sym_default] = ACTIONS(2092),
    [anon_sym_enum] = ACTIONS(2092),
    [anon_sym_fn] = ACTIONS(2092),
    [anon_sym_for] = ACTIONS(2092),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_impl] = ACTIONS(2092),
    [anon_sym_let] = ACTIONS(2092),
    [anon_sym_loop] = ACTIONS(2092),
    [anon_sym_match] = ACTIONS(2092),
    [anon_sym_mod] = ACTIONS(2092),
    [anon_sym_pub] = ACTIONS(2092),
    [anon_sym_return] = ACTIONS(2092),
    [anon_sym_static] = ACTIONS(2092),
    [anon_sym_struct] = ACTIONS(2092),
    [anon_sym_trait] = ACTIONS(2092),
    [anon_sym_type] = ACTIONS(2092),
    [anon_sym_union] = ACTIONS(2092),
    [anon_sym_unsafe] = ACTIONS(2092),
    [anon_sym_use] = ACTIONS(2092),
    [anon_sym_while] = ACTIONS(2092),
    [anon_sym_extern] = ACTIONS(2092),
    [anon_sym_yield] = ACTIONS(2092),
    [anon_sym_move] = ACTIONS(2092),
    [anon_sym_try] = ACTIONS(2092),
    [sym_integer_literal] = ACTIONS(2090),
    [aux_sym_string_literal_token1] = ACTIONS(2090),
    [sym_char_literal] = ACTIONS(2090),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2092),
    [sym_super] = ACTIONS(2092),
    [sym_crate] = ACTIONS(2092),
    [sym_metavariable] = ACTIONS(2090),
    [sym__raw_string_literal_start] = ACTIONS(2090),
    [sym_float_literal] = ACTIONS(2090),
  },
  [560] = {
    [sym_line_comment] = STATE(560),
    [sym_block_comment] = STATE(560),
    [ts_builtin_sym_end] = ACTIONS(2094),
    [sym_identifier] = ACTIONS(2096),
    [anon_sym_SEMI] = ACTIONS(2094),
    [anon_sym_macro_rules_BANG] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(2094),
    [anon_sym_RBRACE] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(2094),
    [anon_sym_u8] = ACTIONS(2096),
    [anon_sym_i8] = ACTIONS(2096),
    [anon_sym_u16] = ACTIONS(2096),
    [anon_sym_i16] = ACTIONS(2096),
    [anon_sym_u32] = ACTIONS(2096),
    [anon_sym_i32] = ACTIONS(2096),
    [anon_sym_u64] = ACTIONS(2096),
    [anon_sym_i64] = ACTIONS(2096),
    [anon_sym_u128] = ACTIONS(2096),
    [anon_sym_i128] = ACTIONS(2096),
    [anon_sym_isize] = ACTIONS(2096),
    [anon_sym_usize] = ACTIONS(2096),
    [anon_sym_f32] = ACTIONS(2096),
    [anon_sym_f64] = ACTIONS(2096),
    [anon_sym_bool] = ACTIONS(2096),
    [anon_sym_str] = ACTIONS(2096),
    [anon_sym_char] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2094),
    [anon_sym_BANG] = ACTIONS(2094),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym_PIPE] = ACTIONS(2094),
    [anon_sym_LT] = ACTIONS(2094),
    [anon_sym_DOT_DOT] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2094),
    [anon_sym_POUND] = ACTIONS(2094),
    [anon_sym_SQUOTE] = ACTIONS(2096),
    [anon_sym_async] = ACTIONS(2096),
    [anon_sym_break] = ACTIONS(2096),
    [anon_sym_const] = ACTIONS(2096),
    [anon_sym_continue] = ACTIONS(2096),
    [anon_sym_default] = ACTIONS(2096),
    [anon_sym_enum] = ACTIONS(2096),
    [anon_sym_fn] = ACTIONS(2096),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_if] = ACTIONS(2096),
    [anon_sym_impl] = ACTIONS(2096),
    [anon_sym_let] = ACTIONS(2096),
    [anon_sym_loop] = ACTIONS(2096),
    [anon_sym_match] = ACTIONS(2096),
    [anon_sym_mod] = ACTIONS(2096),
    [anon_sym_pub] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(2096),
    [anon_sym_static] = ACTIONS(2096),
    [anon_sym_struct] = ACTIONS(2096),
    [anon_sym_trait] = ACTIONS(2096),
    [anon_sym_type] = ACTIONS(2096),
    [anon_sym_union] = ACTIONS(2096),
    [anon_sym_unsafe] = ACTIONS(2096),
    [anon_sym_use] = ACTIONS(2096),
    [anon_sym_while] = ACTIONS(2096),
    [anon_sym_extern] = ACTIONS(2096),
    [anon_sym_yield] = ACTIONS(2096),
    [anon_sym_move] = ACTIONS(2096),
    [anon_sym_try] = ACTIONS(2096),
    [sym_integer_literal] = ACTIONS(2094),
    [aux_sym_string_literal_token1] = ACTIONS(2094),
    [sym_char_literal] = ACTIONS(2094),
    [anon_sym_true] = ACTIONS(2096),
    [anon_sym_false] = ACTIONS(2096),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2094),
    [sym__raw_string_literal_start] = ACTIONS(2094),
    [sym_float_literal] = ACTIONS(2094),
  },
  [561] = {
    [sym_line_comment] = STATE(561),
    [sym_block_comment] = STATE(561),
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_macro_rules_BANG] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(2098),
    [anon_sym_u8] = ACTIONS(2100),
    [anon_sym_i8] = ACTIONS(2100),
    [anon_sym_u16] = ACTIONS(2100),
    [anon_sym_i16] = ACTIONS(2100),
    [anon_sym_u32] = ACTIONS(2100),
    [anon_sym_i32] = ACTIONS(2100),
    [anon_sym_u64] = ACTIONS(2100),
    [anon_sym_i64] = ACTIONS(2100),
    [anon_sym_u128] = ACTIONS(2100),
    [anon_sym_i128] = ACTIONS(2100),
    [anon_sym_isize] = ACTIONS(2100),
    [anon_sym_usize] = ACTIONS(2100),
    [anon_sym_f32] = ACTIONS(2100),
    [anon_sym_f64] = ACTIONS(2100),
    [anon_sym_bool] = ACTIONS(2100),
    [anon_sym_str] = ACTIONS(2100),
    [anon_sym_char] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_AMP] = ACTIONS(2098),
    [anon_sym_PIPE] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_COLON_COLON] = ACTIONS(2098),
    [anon_sym_POUND] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
    [anon_sym_fn] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_impl] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_loop] = ACTIONS(2100),
    [anon_sym_match] = ACTIONS(2100),
    [anon_sym_mod] = ACTIONS(2100),
    [anon_sym_pub] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_struct] = ACTIONS(2100),
    [anon_sym_trait] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_union] = ACTIONS(2100),
    [anon_sym_unsafe] = ACTIONS(2100),
    [anon_sym_use] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_extern] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_move] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [sym_integer_literal] = ACTIONS(2098),
    [aux_sym_string_literal_token1] = ACTIONS(2098),
    [sym_char_literal] = ACTIONS(2098),
    [anon_sym_true] = ACTIONS(2100),
    [anon_sym_false] = ACTIONS(2100),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_crate] = ACTIONS(2100),
    [sym_metavariable] = ACTIONS(2098),
    [sym__raw_string_literal_start] = ACTIONS(2098),
    [sym_float_literal] = ACTIONS(2098),
  },
  [562] = {
    [sym_line_comment] = STATE(562),
    [sym_block_comment] = STATE(562),
    [ts_builtin_sym_end] = ACTIONS(2102),
    [sym_identifier] = ACTIONS(2104),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_macro_rules_BANG] = ACTIONS(2102),
    [anon_sym_LPAREN] = ACTIONS(2102),
    [anon_sym_LBRACK] = ACTIONS(2102),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_STAR] = ACTIONS(2102),
    [anon_sym_u8] = ACTIONS(2104),
    [anon_sym_i8] = ACTIONS(2104),
    [anon_sym_u16] = ACTIONS(2104),
    [anon_sym_i16] = ACTIONS(2104),
    [anon_sym_u32] = ACTIONS(2104),
    [anon_sym_i32] = ACTIONS(2104),
    [anon_sym_u64] = ACTIONS(2104),
    [anon_sym_i64] = ACTIONS(2104),
    [anon_sym_u128] = ACTIONS(2104),
    [anon_sym_i128] = ACTIONS(2104),
    [anon_sym_isize] = ACTIONS(2104),
    [anon_sym_usize] = ACTIONS(2104),
    [anon_sym_f32] = ACTIONS(2104),
    [anon_sym_f64] = ACTIONS(2104),
    [anon_sym_bool] = ACTIONS(2104),
    [anon_sym_str] = ACTIONS(2104),
    [anon_sym_char] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_AMP] = ACTIONS(2102),
    [anon_sym_PIPE] = ACTIONS(2102),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_COLON_COLON] = ACTIONS(2102),
    [anon_sym_POUND] = ACTIONS(2102),
    [anon_sym_SQUOTE] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2104),
    [anon_sym_break] = ACTIONS(2104),
    [anon_sym_const] = ACTIONS(2104),
    [anon_sym_continue] = ACTIONS(2104),
    [anon_sym_default] = ACTIONS(2104),
    [anon_sym_enum] = ACTIONS(2104),
    [anon_sym_fn] = ACTIONS(2104),
    [anon_sym_for] = ACTIONS(2104),
    [anon_sym_if] = ACTIONS(2104),
    [anon_sym_impl] = ACTIONS(2104),
    [anon_sym_let] = ACTIONS(2104),
    [anon_sym_loop] = ACTIONS(2104),
    [anon_sym_match] = ACTIONS(2104),
    [anon_sym_mod] = ACTIONS(2104),
    [anon_sym_pub] = ACTIONS(2104),
    [anon_sym_return] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2104),
    [anon_sym_struct] = ACTIONS(2104),
    [anon_sym_trait] = ACTIONS(2104),
    [anon_sym_type] = ACTIONS(2104),
    [anon_sym_union] = ACTIONS(2104),
    [anon_sym_unsafe] = ACTIONS(2104),
    [anon_sym_use] = ACTIONS(2104),
    [anon_sym_while] = ACTIONS(2104),
    [anon_sym_extern] = ACTIONS(2104),
    [anon_sym_yield] = ACTIONS(2104),
    [anon_sym_move] = ACTIONS(2104),
    [anon_sym_try] = ACTIONS(2104),
    [sym_integer_literal] = ACTIONS(2102),
    [aux_sym_string_literal_token1] = ACTIONS(2102),
    [sym_char_literal] = ACTIONS(2102),
    [anon_sym_true] = ACTIONS(2104),
    [anon_sym_false] = ACTIONS(2104),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2104),
    [sym_super] = ACTIONS(2104),
    [sym_crate] = ACTIONS(2104),
    [sym_metavariable] = ACTIONS(2102),
    [sym__raw_string_literal_start] = ACTIONS(2102),
    [sym_float_literal] = ACTIONS(2102),
  },
  [563] = {
    [sym_line_comment] = STATE(563),
    [sym_block_comment] = STATE(563),
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_macro_rules_BANG] = ACTIONS(2106),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_STAR] = ACTIONS(2106),
    [anon_sym_u8] = ACTIONS(2108),
    [anon_sym_i8] = ACTIONS(2108),
    [anon_sym_u16] = ACTIONS(2108),
    [anon_sym_i16] = ACTIONS(2108),
    [anon_sym_u32] = ACTIONS(2108),
    [anon_sym_i32] = ACTIONS(2108),
    [anon_sym_u64] = ACTIONS(2108),
    [anon_sym_i64] = ACTIONS(2108),
    [anon_sym_u128] = ACTIONS(2108),
    [anon_sym_i128] = ACTIONS(2108),
    [anon_sym_isize] = ACTIONS(2108),
    [anon_sym_usize] = ACTIONS(2108),
    [anon_sym_f32] = ACTIONS(2108),
    [anon_sym_f64] = ACTIONS(2108),
    [anon_sym_bool] = ACTIONS(2108),
    [anon_sym_str] = ACTIONS(2108),
    [anon_sym_char] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2106),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_AMP] = ACTIONS(2106),
    [anon_sym_PIPE] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_DOT_DOT] = ACTIONS(2106),
    [anon_sym_COLON_COLON] = ACTIONS(2106),
    [anon_sym_POUND] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
    [anon_sym_fn] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_impl] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_loop] = ACTIONS(2108),
    [anon_sym_match] = ACTIONS(2108),
    [anon_sym_mod] = ACTIONS(2108),
    [anon_sym_pub] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_struct] = ACTIONS(2108),
    [anon_sym_trait] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_union] = ACTIONS(2108),
    [anon_sym_unsafe] = ACTIONS(2108),
    [anon_sym_use] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_extern] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_move] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [sym_integer_literal] = ACTIONS(2106),
    [aux_sym_string_literal_token1] = ACTIONS(2106),
    [sym_char_literal] = ACTIONS(2106),
    [anon_sym_true] = ACTIONS(2108),
    [anon_sym_false] = ACTIONS(2108),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_crate] = ACTIONS(2108),
    [sym_metavariable] = ACTIONS(2106),
    [sym__raw_string_literal_start] = ACTIONS(2106),
    [sym_float_literal] = ACTIONS(2106),
  },
  [564] = {
    [sym_line_comment] = STATE(564),
    [sym_block_comment] = STATE(564),
    [ts_builtin_sym_end] = ACTIONS(2110),
    [sym_identifier] = ACTIONS(2112),
    [anon_sym_SEMI] = ACTIONS(2110),
    [anon_sym_macro_rules_BANG] = ACTIONS(2110),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [anon_sym_LBRACE] = ACTIONS(2110),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_STAR] = ACTIONS(2110),
    [anon_sym_u8] = ACTIONS(2112),
    [anon_sym_i8] = ACTIONS(2112),
    [anon_sym_u16] = ACTIONS(2112),
    [anon_sym_i16] = ACTIONS(2112),
    [anon_sym_u32] = ACTIONS(2112),
    [anon_sym_i32] = ACTIONS(2112),
    [anon_sym_u64] = ACTIONS(2112),
    [anon_sym_i64] = ACTIONS(2112),
    [anon_sym_u128] = ACTIONS(2112),
    [anon_sym_i128] = ACTIONS(2112),
    [anon_sym_isize] = ACTIONS(2112),
    [anon_sym_usize] = ACTIONS(2112),
    [anon_sym_f32] = ACTIONS(2112),
    [anon_sym_f64] = ACTIONS(2112),
    [anon_sym_bool] = ACTIONS(2112),
    [anon_sym_str] = ACTIONS(2112),
    [anon_sym_char] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2110),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_AMP] = ACTIONS(2110),
    [anon_sym_PIPE] = ACTIONS(2110),
    [anon_sym_LT] = ACTIONS(2110),
    [anon_sym_DOT_DOT] = ACTIONS(2110),
    [anon_sym_COLON_COLON] = ACTIONS(2110),
    [anon_sym_POUND] = ACTIONS(2110),
    [anon_sym_SQUOTE] = ACTIONS(2112),
    [anon_sym_async] = ACTIONS(2112),
    [anon_sym_break] = ACTIONS(2112),
    [anon_sym_const] = ACTIONS(2112),
    [anon_sym_continue] = ACTIONS(2112),
    [anon_sym_default] = ACTIONS(2112),
    [anon_sym_enum] = ACTIONS(2112),
    [anon_sym_fn] = ACTIONS(2112),
    [anon_sym_for] = ACTIONS(2112),
    [anon_sym_if] = ACTIONS(2112),
    [anon_sym_impl] = ACTIONS(2112),
    [anon_sym_let] = ACTIONS(2112),
    [anon_sym_loop] = ACTIONS(2112),
    [anon_sym_match] = ACTIONS(2112),
    [anon_sym_mod] = ACTIONS(2112),
    [anon_sym_pub] = ACTIONS(2112),
    [anon_sym_return] = ACTIONS(2112),
    [anon_sym_static] = ACTIONS(2112),
    [anon_sym_struct] = ACTIONS(2112),
    [anon_sym_trait] = ACTIONS(2112),
    [anon_sym_type] = ACTIONS(2112),
    [anon_sym_union] = ACTIONS(2112),
    [anon_sym_unsafe] = ACTIONS(2112),
    [anon_sym_use] = ACTIONS(2112),
    [anon_sym_while] = ACTIONS(2112),
    [anon_sym_extern] = ACTIONS(2112),
    [anon_sym_yield] = ACTIONS(2112),
    [anon_sym_move] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2112),
    [sym_integer_literal] = ACTIONS(2110),
    [aux_sym_string_literal_token1] = ACTIONS(2110),
    [sym_char_literal] = ACTIONS(2110),
    [anon_sym_true] = ACTIONS(2112),
    [anon_sym_false] = ACTIONS(2112),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2112),
    [sym_super] = ACTIONS(2112),
    [sym_crate] = ACTIONS(2112),
    [sym_metavariable] = ACTIONS(2110),
    [sym__raw_string_literal_start] = ACTIONS(2110),
    [sym_float_literal] = ACTIONS(2110),
  },
  [565] = {
    [sym_line_comment] = STATE(565),
    [sym_block_comment] = STATE(565),
    [ts_builtin_sym_end] = ACTIONS(2114),
    [sym_identifier] = ACTIONS(2116),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_macro_rules_BANG] = ACTIONS(2114),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_RBRACE] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(2114),
    [anon_sym_u8] = ACTIONS(2116),
    [anon_sym_i8] = ACTIONS(2116),
    [anon_sym_u16] = ACTIONS(2116),
    [anon_sym_i16] = ACTIONS(2116),
    [anon_sym_u32] = ACTIONS(2116),
    [anon_sym_i32] = ACTIONS(2116),
    [anon_sym_u64] = ACTIONS(2116),
    [anon_sym_i64] = ACTIONS(2116),
    [anon_sym_u128] = ACTIONS(2116),
    [anon_sym_i128] = ACTIONS(2116),
    [anon_sym_isize] = ACTIONS(2116),
    [anon_sym_usize] = ACTIONS(2116),
    [anon_sym_f32] = ACTIONS(2116),
    [anon_sym_f64] = ACTIONS(2116),
    [anon_sym_bool] = ACTIONS(2116),
    [anon_sym_str] = ACTIONS(2116),
    [anon_sym_char] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2114),
    [anon_sym_BANG] = ACTIONS(2114),
    [anon_sym_AMP] = ACTIONS(2114),
    [anon_sym_PIPE] = ACTIONS(2114),
    [anon_sym_LT] = ACTIONS(2114),
    [anon_sym_DOT_DOT] = ACTIONS(2114),
    [anon_sym_COLON_COLON] = ACTIONS(2114),
    [anon_sym_POUND] = ACTIONS(2114),
    [anon_sym_SQUOTE] = ACTIONS(2116),
    [anon_sym_async] = ACTIONS(2116),
    [anon_sym_break] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_continue] = ACTIONS(2116),
    [anon_sym_default] = ACTIONS(2116),
    [anon_sym_enum] = ACTIONS(2116),
    [anon_sym_fn] = ACTIONS(2116),
    [anon_sym_for] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(2116),
    [anon_sym_impl] = ACTIONS(2116),
    [anon_sym_let] = ACTIONS(2116),
    [anon_sym_loop] = ACTIONS(2116),
    [anon_sym_match] = ACTIONS(2116),
    [anon_sym_mod] = ACTIONS(2116),
    [anon_sym_pub] = ACTIONS(2116),
    [anon_sym_return] = ACTIONS(2116),
    [anon_sym_static] = ACTIONS(2116),
    [anon_sym_struct] = ACTIONS(2116),
    [anon_sym_trait] = ACTIONS(2116),
    [anon_sym_type] = ACTIONS(2116),
    [anon_sym_union] = ACTIONS(2116),
    [anon_sym_unsafe] = ACTIONS(2116),
    [anon_sym_use] = ACTIONS(2116),
    [anon_sym_while] = ACTIONS(2116),
    [anon_sym_extern] = ACTIONS(2116),
    [anon_sym_yield] = ACTIONS(2116),
    [anon_sym_move] = ACTIONS(2116),
    [anon_sym_try] = ACTIONS(2116),
    [sym_integer_literal] = ACTIONS(2114),
    [aux_sym_string_literal_token1] = ACTIONS(2114),
    [sym_char_literal] = ACTIONS(2114),
    [anon_sym_true] = ACTIONS(2116),
    [anon_sym_false] = ACTIONS(2116),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2116),
    [sym_super] = ACTIONS(2116),
    [sym_crate] = ACTIONS(2116),
    [sym_metavariable] = ACTIONS(2114),
    [sym__raw_string_literal_start] = ACTIONS(2114),
    [sym_float_literal] = ACTIONS(2114),
  },
  [566] = {
    [sym_line_comment] = STATE(566),
    [sym_block_comment] = STATE(566),
    [ts_builtin_sym_end] = ACTIONS(2118),
    [sym_identifier] = ACTIONS(2120),
    [anon_sym_SEMI] = ACTIONS(2118),
    [anon_sym_macro_rules_BANG] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [anon_sym_LBRACK] = ACTIONS(2118),
    [anon_sym_LBRACE] = ACTIONS(2118),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2118),
    [anon_sym_u8] = ACTIONS(2120),
    [anon_sym_i8] = ACTIONS(2120),
    [anon_sym_u16] = ACTIONS(2120),
    [anon_sym_i16] = ACTIONS(2120),
    [anon_sym_u32] = ACTIONS(2120),
    [anon_sym_i32] = ACTIONS(2120),
    [anon_sym_u64] = ACTIONS(2120),
    [anon_sym_i64] = ACTIONS(2120),
    [anon_sym_u128] = ACTIONS(2120),
    [anon_sym_i128] = ACTIONS(2120),
    [anon_sym_isize] = ACTIONS(2120),
    [anon_sym_usize] = ACTIONS(2120),
    [anon_sym_f32] = ACTIONS(2120),
    [anon_sym_f64] = ACTIONS(2120),
    [anon_sym_bool] = ACTIONS(2120),
    [anon_sym_str] = ACTIONS(2120),
    [anon_sym_char] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2118),
    [anon_sym_BANG] = ACTIONS(2118),
    [anon_sym_AMP] = ACTIONS(2118),
    [anon_sym_PIPE] = ACTIONS(2118),
    [anon_sym_LT] = ACTIONS(2118),
    [anon_sym_DOT_DOT] = ACTIONS(2118),
    [anon_sym_COLON_COLON] = ACTIONS(2118),
    [anon_sym_POUND] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_async] = ACTIONS(2120),
    [anon_sym_break] = ACTIONS(2120),
    [anon_sym_const] = ACTIONS(2120),
    [anon_sym_continue] = ACTIONS(2120),
    [anon_sym_default] = ACTIONS(2120),
    [anon_sym_enum] = ACTIONS(2120),
    [anon_sym_fn] = ACTIONS(2120),
    [anon_sym_for] = ACTIONS(2120),
    [anon_sym_if] = ACTIONS(2120),
    [anon_sym_impl] = ACTIONS(2120),
    [anon_sym_let] = ACTIONS(2120),
    [anon_sym_loop] = ACTIONS(2120),
    [anon_sym_match] = ACTIONS(2120),
    [anon_sym_mod] = ACTIONS(2120),
    [anon_sym_pub] = ACTIONS(2120),
    [anon_sym_return] = ACTIONS(2120),
    [anon_sym_static] = ACTIONS(2120),
    [anon_sym_struct] = ACTIONS(2120),
    [anon_sym_trait] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(2120),
    [anon_sym_union] = ACTIONS(2120),
    [anon_sym_unsafe] = ACTIONS(2120),
    [anon_sym_use] = ACTIONS(2120),
    [anon_sym_while] = ACTIONS(2120),
    [anon_sym_extern] = ACTIONS(2120),
    [anon_sym_yield] = ACTIONS(2120),
    [anon_sym_move] = ACTIONS(2120),
    [anon_sym_try] = ACTIONS(2120),
    [sym_integer_literal] = ACTIONS(2118),
    [aux_sym_string_literal_token1] = ACTIONS(2118),
    [sym_char_literal] = ACTIONS(2118),
    [anon_sym_true] = ACTIONS(2120),
    [anon_sym_false] = ACTIONS(2120),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2120),
    [sym_super] = ACTIONS(2120),
    [sym_crate] = ACTIONS(2120),
    [sym_metavariable] = ACTIONS(2118),
    [sym__raw_string_literal_start] = ACTIONS(2118),
    [sym_float_literal] = ACTIONS(2118),
  },
  [567] = {
    [sym_line_comment] = STATE(567),
    [sym_block_comment] = STATE(567),
    [ts_builtin_sym_end] = ACTIONS(2122),
    [sym_identifier] = ACTIONS(2124),
    [anon_sym_SEMI] = ACTIONS(2122),
    [anon_sym_macro_rules_BANG] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LBRACE] = ACTIONS(2122),
    [anon_sym_RBRACE] = ACTIONS(2122),
    [anon_sym_STAR] = ACTIONS(2122),
    [anon_sym_u8] = ACTIONS(2124),
    [anon_sym_i8] = ACTIONS(2124),
    [anon_sym_u16] = ACTIONS(2124),
    [anon_sym_i16] = ACTIONS(2124),
    [anon_sym_u32] = ACTIONS(2124),
    [anon_sym_i32] = ACTIONS(2124),
    [anon_sym_u64] = ACTIONS(2124),
    [anon_sym_i64] = ACTIONS(2124),
    [anon_sym_u128] = ACTIONS(2124),
    [anon_sym_i128] = ACTIONS(2124),
    [anon_sym_isize] = ACTIONS(2124),
    [anon_sym_usize] = ACTIONS(2124),
    [anon_sym_f32] = ACTIONS(2124),
    [anon_sym_f64] = ACTIONS(2124),
    [anon_sym_bool] = ACTIONS(2124),
    [anon_sym_str] = ACTIONS(2124),
    [anon_sym_char] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2122),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_PIPE] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(2122),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2122),
    [anon_sym_POUND] = ACTIONS(2122),
    [anon_sym_SQUOTE] = ACTIONS(2124),
    [anon_sym_async] = ACTIONS(2124),
    [anon_sym_break] = ACTIONS(2124),
    [anon_sym_const] = ACTIONS(2124),
    [anon_sym_continue] = ACTIONS(2124),
    [anon_sym_default] = ACTIONS(2124),
    [anon_sym_enum] = ACTIONS(2124),
    [anon_sym_fn] = ACTIONS(2124),
    [anon_sym_for] = ACTIONS(2124),
    [anon_sym_if] = ACTIONS(2124),
    [anon_sym_impl] = ACTIONS(2124),
    [anon_sym_let] = ACTIONS(2124),
    [anon_sym_loop] = ACTIONS(2124),
    [anon_sym_match] = ACTIONS(2124),
    [anon_sym_mod] = ACTIONS(2124),
    [anon_sym_pub] = ACTIONS(2124),
    [anon_sym_return] = ACTIONS(2124),
    [anon_sym_static] = ACTIONS(2124),
    [anon_sym_struct] = ACTIONS(2124),
    [anon_sym_trait] = ACTIONS(2124),
    [anon_sym_type] = ACTIONS(2124),
    [anon_sym_union] = ACTIONS(2124),
    [anon_sym_unsafe] = ACTIONS(2124),
    [anon_sym_use] = ACTIONS(2124),
    [anon_sym_while] = ACTIONS(2124),
    [anon_sym_extern] = ACTIONS(2124),
    [anon_sym_yield] = ACTIONS(2124),
    [anon_sym_move] = ACTIONS(2124),
    [anon_sym_try] = ACTIONS(2124),
    [sym_integer_literal] = ACTIONS(2122),
    [aux_sym_string_literal_token1] = ACTIONS(2122),
    [sym_char_literal] = ACTIONS(2122),
    [anon_sym_true] = ACTIONS(2124),
    [anon_sym_false] = ACTIONS(2124),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2124),
    [sym_super] = ACTIONS(2124),
    [sym_crate] = ACTIONS(2124),
    [sym_metavariable] = ACTIONS(2122),
    [sym__raw_string_literal_start] = ACTIONS(2122),
    [sym_float_literal] = ACTIONS(2122),
  },
  [568] = {
    [sym_line_comment] = STATE(568),
    [sym_block_comment] = STATE(568),
    [ts_builtin_sym_end] = ACTIONS(2126),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_macro_rules_BANG] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_u8] = ACTIONS(2128),
    [anon_sym_i8] = ACTIONS(2128),
    [anon_sym_u16] = ACTIONS(2128),
    [anon_sym_i16] = ACTIONS(2128),
    [anon_sym_u32] = ACTIONS(2128),
    [anon_sym_i32] = ACTIONS(2128),
    [anon_sym_u64] = ACTIONS(2128),
    [anon_sym_i64] = ACTIONS(2128),
    [anon_sym_u128] = ACTIONS(2128),
    [anon_sym_i128] = ACTIONS(2128),
    [anon_sym_isize] = ACTIONS(2128),
    [anon_sym_usize] = ACTIONS(2128),
    [anon_sym_f32] = ACTIONS(2128),
    [anon_sym_f64] = ACTIONS(2128),
    [anon_sym_bool] = ACTIONS(2128),
    [anon_sym_str] = ACTIONS(2128),
    [anon_sym_char] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2126),
    [anon_sym_POUND] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_async] = ACTIONS(2128),
    [anon_sym_break] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2128),
    [anon_sym_continue] = ACTIONS(2128),
    [anon_sym_default] = ACTIONS(2128),
    [anon_sym_enum] = ACTIONS(2128),
    [anon_sym_fn] = ACTIONS(2128),
    [anon_sym_for] = ACTIONS(2128),
    [anon_sym_if] = ACTIONS(2128),
    [anon_sym_impl] = ACTIONS(2128),
    [anon_sym_let] = ACTIONS(2128),
    [anon_sym_loop] = ACTIONS(2128),
    [anon_sym_match] = ACTIONS(2128),
    [anon_sym_mod] = ACTIONS(2128),
    [anon_sym_pub] = ACTIONS(2128),
    [anon_sym_return] = ACTIONS(2128),
    [anon_sym_static] = ACTIONS(2128),
    [anon_sym_struct] = ACTIONS(2128),
    [anon_sym_trait] = ACTIONS(2128),
    [anon_sym_type] = ACTIONS(2128),
    [anon_sym_union] = ACTIONS(2128),
    [anon_sym_unsafe] = ACTIONS(2128),
    [anon_sym_use] = ACTIONS(2128),
    [anon_sym_while] = ACTIONS(2128),
    [anon_sym_extern] = ACTIONS(2128),
    [anon_sym_yield] = ACTIONS(2128),
    [anon_sym_move] = ACTIONS(2128),
    [anon_sym_try] = ACTIONS(2128),
    [sym_integer_literal] = ACTIONS(2126),
    [aux_sym_string_literal_token1] = ACTIONS(2126),
    [sym_char_literal] = ACTIONS(2126),
    [anon_sym_true] = ACTIONS(2128),
    [anon_sym_false] = ACTIONS(2128),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2128),
    [sym_super] = ACTIONS(2128),
    [sym_crate] = ACTIONS(2128),
    [sym_metavariable] = ACTIONS(2126),
    [sym__raw_string_literal_start] = ACTIONS(2126),
    [sym_float_literal] = ACTIONS(2126),
  },
  [569] = {
    [sym_line_comment] = STATE(569),
    [sym_block_comment] = STATE(569),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2132),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym_macro_rules_BANG] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_LBRACE] = ACTIONS(2130),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [anon_sym_STAR] = ACTIONS(2130),
    [anon_sym_u8] = ACTIONS(2132),
    [anon_sym_i8] = ACTIONS(2132),
    [anon_sym_u16] = ACTIONS(2132),
    [anon_sym_i16] = ACTIONS(2132),
    [anon_sym_u32] = ACTIONS(2132),
    [anon_sym_i32] = ACTIONS(2132),
    [anon_sym_u64] = ACTIONS(2132),
    [anon_sym_i64] = ACTIONS(2132),
    [anon_sym_u128] = ACTIONS(2132),
    [anon_sym_i128] = ACTIONS(2132),
    [anon_sym_isize] = ACTIONS(2132),
    [anon_sym_usize] = ACTIONS(2132),
    [anon_sym_f32] = ACTIONS(2132),
    [anon_sym_f64] = ACTIONS(2132),
    [anon_sym_bool] = ACTIONS(2132),
    [anon_sym_str] = ACTIONS(2132),
    [anon_sym_char] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2130),
    [anon_sym_BANG] = ACTIONS(2130),
    [anon_sym_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2130),
    [anon_sym_LT] = ACTIONS(2130),
    [anon_sym_DOT_DOT] = ACTIONS(2130),
    [anon_sym_COLON_COLON] = ACTIONS(2130),
    [anon_sym_POUND] = ACTIONS(2130),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym_async] = ACTIONS(2132),
    [anon_sym_break] = ACTIONS(2132),
    [anon_sym_const] = ACTIONS(2132),
    [anon_sym_continue] = ACTIONS(2132),
    [anon_sym_default] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2132),
    [anon_sym_fn] = ACTIONS(2132),
    [anon_sym_for] = ACTIONS(2132),
    [anon_sym_if] = ACTIONS(2132),
    [anon_sym_impl] = ACTIONS(2132),
    [anon_sym_let] = ACTIONS(2132),
    [anon_sym_loop] = ACTIONS(2132),
    [anon_sym_match] = ACTIONS(2132),
    [anon_sym_mod] = ACTIONS(2132),
    [anon_sym_pub] = ACTIONS(2132),
    [anon_sym_return] = ACTIONS(2132),
    [anon_sym_static] = ACTIONS(2132),
    [anon_sym_struct] = ACTIONS(2132),
    [anon_sym_trait] = ACTIONS(2132),
    [anon_sym_type] = ACTIONS(2132),
    [anon_sym_union] = ACTIONS(2132),
    [anon_sym_unsafe] = ACTIONS(2132),
    [anon_sym_use] = ACTIONS(2132),
    [anon_sym_while] = ACTIONS(2132),
    [anon_sym_extern] = ACTIONS(2132),
    [anon_sym_yield] = ACTIONS(2132),
    [anon_sym_move] = ACTIONS(2132),
    [anon_sym_try] = ACTIONS(2132),
    [sym_integer_literal] = ACTIONS(2130),
    [aux_sym_string_literal_token1] = ACTIONS(2130),
    [sym_char_literal] = ACTIONS(2130),
    [anon_sym_true] = ACTIONS(2132),
    [anon_sym_false] = ACTIONS(2132),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2132),
    [sym_super] = ACTIONS(2132),
    [sym_crate] = ACTIONS(2132),
    [sym_metavariable] = ACTIONS(2130),
    [sym__raw_string_literal_start] = ACTIONS(2130),
    [sym_float_literal] = ACTIONS(2130),
  },
  [570] = {
    [sym_line_comment] = STATE(570),
    [sym_block_comment] = STATE(570),
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_identifier] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2134),
    [anon_sym_macro_rules_BANG] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_u8] = ACTIONS(2136),
    [anon_sym_i8] = ACTIONS(2136),
    [anon_sym_u16] = ACTIONS(2136),
    [anon_sym_i16] = ACTIONS(2136),
    [anon_sym_u32] = ACTIONS(2136),
    [anon_sym_i32] = ACTIONS(2136),
    [anon_sym_u64] = ACTIONS(2136),
    [anon_sym_i64] = ACTIONS(2136),
    [anon_sym_u128] = ACTIONS(2136),
    [anon_sym_i128] = ACTIONS(2136),
    [anon_sym_isize] = ACTIONS(2136),
    [anon_sym_usize] = ACTIONS(2136),
    [anon_sym_f32] = ACTIONS(2136),
    [anon_sym_f64] = ACTIONS(2136),
    [anon_sym_bool] = ACTIONS(2136),
    [anon_sym_str] = ACTIONS(2136),
    [anon_sym_char] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_BANG] = ACTIONS(2134),
    [anon_sym_AMP] = ACTIONS(2134),
    [anon_sym_PIPE] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2134),
    [anon_sym_DOT_DOT] = ACTIONS(2134),
    [anon_sym_COLON_COLON] = ACTIONS(2134),
    [anon_sym_POUND] = ACTIONS(2134),
    [anon_sym_SQUOTE] = ACTIONS(2136),
    [anon_sym_async] = ACTIONS(2136),
    [anon_sym_break] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(2136),
    [anon_sym_continue] = ACTIONS(2136),
    [anon_sym_default] = ACTIONS(2136),
    [anon_sym_enum] = ACTIONS(2136),
    [anon_sym_fn] = ACTIONS(2136),
    [anon_sym_for] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_impl] = ACTIONS(2136),
    [anon_sym_let] = ACTIONS(2136),
    [anon_sym_loop] = ACTIONS(2136),
    [anon_sym_match] = ACTIONS(2136),
    [anon_sym_mod] = ACTIONS(2136),
    [anon_sym_pub] = ACTIONS(2136),
    [anon_sym_return] = ACTIONS(2136),
    [anon_sym_static] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2136),
    [anon_sym_trait] = ACTIONS(2136),
    [anon_sym_type] = ACTIONS(2136),
    [anon_sym_union] = ACTIONS(2136),
    [anon_sym_unsafe] = ACTIONS(2136),
    [anon_sym_use] = ACTIONS(2136),
    [anon_sym_while] = ACTIONS(2136),
    [anon_sym_extern] = ACTIONS(2136),
    [anon_sym_yield] = ACTIONS(2136),
    [anon_sym_move] = ACTIONS(2136),
    [anon_sym_try] = ACTIONS(2136),
    [sym_integer_literal] = ACTIONS(2134),
    [aux_sym_string_literal_token1] = ACTIONS(2134),
    [sym_char_literal] = ACTIONS(2134),
    [anon_sym_true] = ACTIONS(2136),
    [anon_sym_false] = ACTIONS(2136),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2136),
    [sym_super] = ACTIONS(2136),
    [sym_crate] = ACTIONS(2136),
    [sym_metavariable] = ACTIONS(2134),
    [sym__raw_string_literal_start] = ACTIONS(2134),
    [sym_float_literal] = ACTIONS(2134),
  },
  [571] = {
    [sym_line_comment] = STATE(571),
    [sym_block_comment] = STATE(571),
    [ts_builtin_sym_end] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2140),
    [anon_sym_SEMI] = ACTIONS(2138),
    [anon_sym_macro_rules_BANG] = ACTIONS(2138),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_LBRACK] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2138),
    [anon_sym_RBRACE] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(2138),
    [anon_sym_u8] = ACTIONS(2140),
    [anon_sym_i8] = ACTIONS(2140),
    [anon_sym_u16] = ACTIONS(2140),
    [anon_sym_i16] = ACTIONS(2140),
    [anon_sym_u32] = ACTIONS(2140),
    [anon_sym_i32] = ACTIONS(2140),
    [anon_sym_u64] = ACTIONS(2140),
    [anon_sym_i64] = ACTIONS(2140),
    [anon_sym_u128] = ACTIONS(2140),
    [anon_sym_i128] = ACTIONS(2140),
    [anon_sym_isize] = ACTIONS(2140),
    [anon_sym_usize] = ACTIONS(2140),
    [anon_sym_f32] = ACTIONS(2140),
    [anon_sym_f64] = ACTIONS(2140),
    [anon_sym_bool] = ACTIONS(2140),
    [anon_sym_str] = ACTIONS(2140),
    [anon_sym_char] = ACTIONS(2140),
    [anon_sym_DASH] = ACTIONS(2138),
    [anon_sym_BANG] = ACTIONS(2138),
    [anon_sym_AMP] = ACTIONS(2138),
    [anon_sym_PIPE] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(2138),
    [anon_sym_DOT_DOT] = ACTIONS(2138),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_POUND] = ACTIONS(2138),
    [anon_sym_SQUOTE] = ACTIONS(2140),
    [anon_sym_async] = ACTIONS(2140),
    [anon_sym_break] = ACTIONS(2140),
    [anon_sym_const] = ACTIONS(2140),
    [anon_sym_continue] = ACTIONS(2140),
    [anon_sym_default] = ACTIONS(2140),
    [anon_sym_enum] = ACTIONS(2140),
    [anon_sym_fn] = ACTIONS(2140),
    [anon_sym_for] = ACTIONS(2140),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_impl] = ACTIONS(2140),
    [anon_sym_let] = ACTIONS(2140),
    [anon_sym_loop] = ACTIONS(2140),
    [anon_sym_match] = ACTIONS(2140),
    [anon_sym_mod] = ACTIONS(2140),
    [anon_sym_pub] = ACTIONS(2140),
    [anon_sym_return] = ACTIONS(2140),
    [anon_sym_static] = ACTIONS(2140),
    [anon_sym_struct] = ACTIONS(2140),
    [anon_sym_trait] = ACTIONS(2140),
    [anon_sym_type] = ACTIONS(2140),
    [anon_sym_union] = ACTIONS(2140),
    [anon_sym_unsafe] = ACTIONS(2140),
    [anon_sym_use] = ACTIONS(2140),
    [anon_sym_while] = ACTIONS(2140),
    [anon_sym_extern] = ACTIONS(2140),
    [anon_sym_yield] = ACTIONS(2140),
    [anon_sym_move] = ACTIONS(2140),
    [anon_sym_try] = ACTIONS(2140),
    [sym_integer_literal] = ACTIONS(2138),
    [aux_sym_string_literal_token1] = ACTIONS(2138),
    [sym_char_literal] = ACTIONS(2138),
    [anon_sym_true] = ACTIONS(2140),
    [anon_sym_false] = ACTIONS(2140),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2140),
    [sym_super] = ACTIONS(2140),
    [sym_crate] = ACTIONS(2140),
    [sym_metavariable] = ACTIONS(2138),
    [sym__raw_string_literal_start] = ACTIONS(2138),
    [sym_float_literal] = ACTIONS(2138),
  },
  [572] = {
    [sym_line_comment] = STATE(572),
    [sym_block_comment] = STATE(572),
    [ts_builtin_sym_end] = ACTIONS(2142),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_macro_rules_BANG] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2142),
    [anon_sym_u8] = ACTIONS(2144),
    [anon_sym_i8] = ACTIONS(2144),
    [anon_sym_u16] = ACTIONS(2144),
    [anon_sym_i16] = ACTIONS(2144),
    [anon_sym_u32] = ACTIONS(2144),
    [anon_sym_i32] = ACTIONS(2144),
    [anon_sym_u64] = ACTIONS(2144),
    [anon_sym_i64] = ACTIONS(2144),
    [anon_sym_u128] = ACTIONS(2144),
    [anon_sym_i128] = ACTIONS(2144),
    [anon_sym_isize] = ACTIONS(2144),
    [anon_sym_usize] = ACTIONS(2144),
    [anon_sym_f32] = ACTIONS(2144),
    [anon_sym_f64] = ACTIONS(2144),
    [anon_sym_bool] = ACTIONS(2144),
    [anon_sym_str] = ACTIONS(2144),
    [anon_sym_char] = ACTIONS(2144),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_AMP] = ACTIONS(2142),
    [anon_sym_PIPE] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_DOT_DOT] = ACTIONS(2142),
    [anon_sym_COLON_COLON] = ACTIONS(2142),
    [anon_sym_POUND] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym_async] = ACTIONS(2144),
    [anon_sym_break] = ACTIONS(2144),
    [anon_sym_const] = ACTIONS(2144),
    [anon_sym_continue] = ACTIONS(2144),
    [anon_sym_default] = ACTIONS(2144),
    [anon_sym_enum] = ACTIONS(2144),
    [anon_sym_fn] = ACTIONS(2144),
    [anon_sym_for] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(2144),
    [anon_sym_impl] = ACTIONS(2144),
    [anon_sym_let] = ACTIONS(2144),
    [anon_sym_loop] = ACTIONS(2144),
    [anon_sym_match] = ACTIONS(2144),
    [anon_sym_mod] = ACTIONS(2144),
    [anon_sym_pub] = ACTIONS(2144),
    [anon_sym_return] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2144),
    [anon_sym_struct] = ACTIONS(2144),
    [anon_sym_trait] = ACTIONS(2144),
    [anon_sym_type] = ACTIONS(2144),
    [anon_sym_union] = ACTIONS(2144),
    [anon_sym_unsafe] = ACTIONS(2144),
    [anon_sym_use] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2144),
    [anon_sym_extern] = ACTIONS(2144),
    [anon_sym_yield] = ACTIONS(2144),
    [anon_sym_move] = ACTIONS(2144),
    [anon_sym_try] = ACTIONS(2144),
    [sym_integer_literal] = ACTIONS(2142),
    [aux_sym_string_literal_token1] = ACTIONS(2142),
    [sym_char_literal] = ACTIONS(2142),
    [anon_sym_true] = ACTIONS(2144),
    [anon_sym_false] = ACTIONS(2144),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2144),
    [sym_super] = ACTIONS(2144),
    [sym_crate] = ACTIONS(2144),
    [sym_metavariable] = ACTIONS(2142),
    [sym__raw_string_literal_start] = ACTIONS(2142),
    [sym_float_literal] = ACTIONS(2142),
  },
  [573] = {
    [sym_line_comment] = STATE(573),
    [sym_block_comment] = STATE(573),
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(2146),
    [anon_sym_macro_rules_BANG] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_u8] = ACTIONS(2148),
    [anon_sym_i8] = ACTIONS(2148),
    [anon_sym_u16] = ACTIONS(2148),
    [anon_sym_i16] = ACTIONS(2148),
    [anon_sym_u32] = ACTIONS(2148),
    [anon_sym_i32] = ACTIONS(2148),
    [anon_sym_u64] = ACTIONS(2148),
    [anon_sym_i64] = ACTIONS(2148),
    [anon_sym_u128] = ACTIONS(2148),
    [anon_sym_i128] = ACTIONS(2148),
    [anon_sym_isize] = ACTIONS(2148),
    [anon_sym_usize] = ACTIONS(2148),
    [anon_sym_f32] = ACTIONS(2148),
    [anon_sym_f64] = ACTIONS(2148),
    [anon_sym_bool] = ACTIONS(2148),
    [anon_sym_str] = ACTIONS(2148),
    [anon_sym_char] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_AMP] = ACTIONS(2146),
    [anon_sym_PIPE] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2146),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_COLON_COLON] = ACTIONS(2146),
    [anon_sym_POUND] = ACTIONS(2146),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_async] = ACTIONS(2148),
    [anon_sym_break] = ACTIONS(2148),
    [anon_sym_const] = ACTIONS(2148),
    [anon_sym_continue] = ACTIONS(2148),
    [anon_sym_default] = ACTIONS(2148),
    [anon_sym_enum] = ACTIONS(2148),
    [anon_sym_fn] = ACTIONS(2148),
    [anon_sym_for] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_impl] = ACTIONS(2148),
    [anon_sym_let] = ACTIONS(2148),
    [anon_sym_loop] = ACTIONS(2148),
    [anon_sym_match] = ACTIONS(2148),
    [anon_sym_mod] = ACTIONS(2148),
    [anon_sym_pub] = ACTIONS(2148),
    [anon_sym_return] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2148),
    [anon_sym_struct] = ACTIONS(2148),
    [anon_sym_trait] = ACTIONS(2148),
    [anon_sym_type] = ACTIONS(2148),
    [anon_sym_union] = ACTIONS(2148),
    [anon_sym_unsafe] = ACTIONS(2148),
    [anon_sym_use] = ACTIONS(2148),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_extern] = ACTIONS(2148),
    [anon_sym_yield] = ACTIONS(2148),
    [anon_sym_move] = ACTIONS(2148),
    [anon_sym_try] = ACTIONS(2148),
    [sym_integer_literal] = ACTIONS(2146),
    [aux_sym_string_literal_token1] = ACTIONS(2146),
    [sym_char_literal] = ACTIONS(2146),
    [anon_sym_true] = ACTIONS(2148),
    [anon_sym_false] = ACTIONS(2148),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2148),
    [sym_super] = ACTIONS(2148),
    [sym_crate] = ACTIONS(2148),
    [sym_metavariable] = ACTIONS(2146),
    [sym__raw_string_literal_start] = ACTIONS(2146),
    [sym_float_literal] = ACTIONS(2146),
  },
  [574] = {
    [sym_line_comment] = STATE(574),
    [sym_block_comment] = STATE(574),
    [ts_builtin_sym_end] = ACTIONS(2150),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_macro_rules_BANG] = ACTIONS(2150),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2150),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_u8] = ACTIONS(2152),
    [anon_sym_i8] = ACTIONS(2152),
    [anon_sym_u16] = ACTIONS(2152),
    [anon_sym_i16] = ACTIONS(2152),
    [anon_sym_u32] = ACTIONS(2152),
    [anon_sym_i32] = ACTIONS(2152),
    [anon_sym_u64] = ACTIONS(2152),
    [anon_sym_i64] = ACTIONS(2152),
    [anon_sym_u128] = ACTIONS(2152),
    [anon_sym_i128] = ACTIONS(2152),
    [anon_sym_isize] = ACTIONS(2152),
    [anon_sym_usize] = ACTIONS(2152),
    [anon_sym_f32] = ACTIONS(2152),
    [anon_sym_f64] = ACTIONS(2152),
    [anon_sym_bool] = ACTIONS(2152),
    [anon_sym_str] = ACTIONS(2152),
    [anon_sym_char] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_BANG] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
    [anon_sym_PIPE] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_DOT_DOT] = ACTIONS(2150),
    [anon_sym_COLON_COLON] = ACTIONS(2150),
    [anon_sym_POUND] = ACTIONS(2150),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [anon_sym_fn] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_impl] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_loop] = ACTIONS(2152),
    [anon_sym_match] = ACTIONS(2152),
    [anon_sym_mod] = ACTIONS(2152),
    [anon_sym_pub] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_struct] = ACTIONS(2152),
    [anon_sym_trait] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_union] = ACTIONS(2152),
    [anon_sym_unsafe] = ACTIONS(2152),
    [anon_sym_use] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_extern] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_move] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [sym_integer_literal] = ACTIONS(2150),
    [aux_sym_string_literal_token1] = ACTIONS(2150),
    [sym_char_literal] = ACTIONS(2150),
    [anon_sym_true] = ACTIONS(2152),
    [anon_sym_false] = ACTIONS(2152),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_crate] = ACTIONS(2152),
    [sym_metavariable] = ACTIONS(2150),
    [sym__raw_string_literal_start] = ACTIONS(2150),
    [sym_float_literal] = ACTIONS(2150),
  },
  [575] = {
    [sym_line_comment] = STATE(575),
    [sym_block_comment] = STATE(575),
    [ts_builtin_sym_end] = ACTIONS(2154),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_macro_rules_BANG] = ACTIONS(2154),
    [anon_sym_LPAREN] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2154),
    [anon_sym_STAR] = ACTIONS(2154),
    [anon_sym_u8] = ACTIONS(2156),
    [anon_sym_i8] = ACTIONS(2156),
    [anon_sym_u16] = ACTIONS(2156),
    [anon_sym_i16] = ACTIONS(2156),
    [anon_sym_u32] = ACTIONS(2156),
    [anon_sym_i32] = ACTIONS(2156),
    [anon_sym_u64] = ACTIONS(2156),
    [anon_sym_i64] = ACTIONS(2156),
    [anon_sym_u128] = ACTIONS(2156),
    [anon_sym_i128] = ACTIONS(2156),
    [anon_sym_isize] = ACTIONS(2156),
    [anon_sym_usize] = ACTIONS(2156),
    [anon_sym_f32] = ACTIONS(2156),
    [anon_sym_f64] = ACTIONS(2156),
    [anon_sym_bool] = ACTIONS(2156),
    [anon_sym_str] = ACTIONS(2156),
    [anon_sym_char] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_BANG] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2154),
    [anon_sym_DOT_DOT] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2154),
    [anon_sym_POUND] = ACTIONS(2154),
    [anon_sym_SQUOTE] = ACTIONS(2156),
    [anon_sym_async] = ACTIONS(2156),
    [anon_sym_break] = ACTIONS(2156),
    [anon_sym_const] = ACTIONS(2156),
    [anon_sym_continue] = ACTIONS(2156),
    [anon_sym_default] = ACTIONS(2156),
    [anon_sym_enum] = ACTIONS(2156),
    [anon_sym_fn] = ACTIONS(2156),
    [anon_sym_for] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(2156),
    [anon_sym_impl] = ACTIONS(2156),
    [anon_sym_let] = ACTIONS(2156),
    [anon_sym_loop] = ACTIONS(2156),
    [anon_sym_match] = ACTIONS(2156),
    [anon_sym_mod] = ACTIONS(2156),
    [anon_sym_pub] = ACTIONS(2156),
    [anon_sym_return] = ACTIONS(2156),
    [anon_sym_static] = ACTIONS(2156),
    [anon_sym_struct] = ACTIONS(2156),
    [anon_sym_trait] = ACTIONS(2156),
    [anon_sym_type] = ACTIONS(2156),
    [anon_sym_union] = ACTIONS(2156),
    [anon_sym_unsafe] = ACTIONS(2156),
    [anon_sym_use] = ACTIONS(2156),
    [anon_sym_while] = ACTIONS(2156),
    [anon_sym_extern] = ACTIONS(2156),
    [anon_sym_yield] = ACTIONS(2156),
    [anon_sym_move] = ACTIONS(2156),
    [anon_sym_try] = ACTIONS(2156),
    [sym_integer_literal] = ACTIONS(2154),
    [aux_sym_string_literal_token1] = ACTIONS(2154),
    [sym_char_literal] = ACTIONS(2154),
    [anon_sym_true] = ACTIONS(2156),
    [anon_sym_false] = ACTIONS(2156),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2156),
    [sym_super] = ACTIONS(2156),
    [sym_crate] = ACTIONS(2156),
    [sym_metavariable] = ACTIONS(2154),
    [sym__raw_string_literal_start] = ACTIONS(2154),
    [sym_float_literal] = ACTIONS(2154),
  },
  [576] = {
    [sym_line_comment] = STATE(576),
    [sym_block_comment] = STATE(576),
    [ts_builtin_sym_end] = ACTIONS(2158),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2158),
    [anon_sym_macro_rules_BANG] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2158),
    [anon_sym_STAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_PIPE] = ACTIONS(2158),
    [anon_sym_LT] = ACTIONS(2158),
    [anon_sym_DOT_DOT] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2158),
    [anon_sym_POUND] = ACTIONS(2158),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [anon_sym_fn] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_impl] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_loop] = ACTIONS(2160),
    [anon_sym_match] = ACTIONS(2160),
    [anon_sym_mod] = ACTIONS(2160),
    [anon_sym_pub] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_struct] = ACTIONS(2160),
    [anon_sym_trait] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_union] = ACTIONS(2160),
    [anon_sym_unsafe] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_extern] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_move] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [sym_integer_literal] = ACTIONS(2158),
    [aux_sym_string_literal_token1] = ACTIONS(2158),
    [sym_char_literal] = ACTIONS(2158),
    [anon_sym_true] = ACTIONS(2160),
    [anon_sym_false] = ACTIONS(2160),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_crate] = ACTIONS(2160),
    [sym_metavariable] = ACTIONS(2158),
    [sym__raw_string_literal_start] = ACTIONS(2158),
    [sym_float_literal] = ACTIONS(2158),
  },
  [577] = {
    [sym_line_comment] = STATE(577),
    [sym_block_comment] = STATE(577),
    [ts_builtin_sym_end] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_SEMI] = ACTIONS(2162),
    [anon_sym_macro_rules_BANG] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(2162),
    [anon_sym_u8] = ACTIONS(2164),
    [anon_sym_i8] = ACTIONS(2164),
    [anon_sym_u16] = ACTIONS(2164),
    [anon_sym_i16] = ACTIONS(2164),
    [anon_sym_u32] = ACTIONS(2164),
    [anon_sym_i32] = ACTIONS(2164),
    [anon_sym_u64] = ACTIONS(2164),
    [anon_sym_i64] = ACTIONS(2164),
    [anon_sym_u128] = ACTIONS(2164),
    [anon_sym_i128] = ACTIONS(2164),
    [anon_sym_isize] = ACTIONS(2164),
    [anon_sym_usize] = ACTIONS(2164),
    [anon_sym_f32] = ACTIONS(2164),
    [anon_sym_f64] = ACTIONS(2164),
    [anon_sym_bool] = ACTIONS(2164),
    [anon_sym_str] = ACTIONS(2164),
    [anon_sym_char] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2162),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2162),
    [anon_sym_DOT_DOT] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2162),
    [anon_sym_POUND] = ACTIONS(2162),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_extern] = ACTIONS(2164),
    [anon_sym_yield] = ACTIONS(2164),
    [anon_sym_move] = ACTIONS(2164),
    [anon_sym_try] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2162),
    [aux_sym_string_literal_token1] = ACTIONS(2162),
    [sym_char_literal] = ACTIONS(2162),
    [anon_sym_true] = ACTIONS(2164),
    [anon_sym_false] = ACTIONS(2164),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2162),
    [sym__raw_string_literal_start] = ACTIONS(2162),
    [sym_float_literal] = ACTIONS(2162),
  },
  [578] = {
    [sym_line_comment] = STATE(578),
    [sym_block_comment] = STATE(578),
    [ts_builtin_sym_end] = ACTIONS(2166),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_macro_rules_BANG] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2166),
    [anon_sym_u8] = ACTIONS(2168),
    [anon_sym_i8] = ACTIONS(2168),
    [anon_sym_u16] = ACTIONS(2168),
    [anon_sym_i16] = ACTIONS(2168),
    [anon_sym_u32] = ACTIONS(2168),
    [anon_sym_i32] = ACTIONS(2168),
    [anon_sym_u64] = ACTIONS(2168),
    [anon_sym_i64] = ACTIONS(2168),
    [anon_sym_u128] = ACTIONS(2168),
    [anon_sym_i128] = ACTIONS(2168),
    [anon_sym_isize] = ACTIONS(2168),
    [anon_sym_usize] = ACTIONS(2168),
    [anon_sym_f32] = ACTIONS(2168),
    [anon_sym_f64] = ACTIONS(2168),
    [anon_sym_bool] = ACTIONS(2168),
    [anon_sym_str] = ACTIONS(2168),
    [anon_sym_char] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_PIPE] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_COLON_COLON] = ACTIONS(2166),
    [anon_sym_POUND] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2168),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
    [anon_sym_fn] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_impl] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_loop] = ACTIONS(2168),
    [anon_sym_match] = ACTIONS(2168),
    [anon_sym_mod] = ACTIONS(2168),
    [anon_sym_pub] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_struct] = ACTIONS(2168),
    [anon_sym_trait] = ACTIONS(2168),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_union] = ACTIONS(2168),
    [anon_sym_unsafe] = ACTIONS(2168),
    [anon_sym_use] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2168),
    [anon_sym_move] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [sym_integer_literal] = ACTIONS(2166),
    [aux_sym_string_literal_token1] = ACTIONS(2166),
    [sym_char_literal] = ACTIONS(2166),
    [anon_sym_true] = ACTIONS(2168),
    [anon_sym_false] = ACTIONS(2168),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2168),
    [sym_super] = ACTIONS(2168),
    [sym_crate] = ACTIONS(2168),
    [sym_metavariable] = ACTIONS(2166),
    [sym__raw_string_literal_start] = ACTIONS(2166),
    [sym_float_literal] = ACTIONS(2166),
  },
  [579] = {
    [sym_line_comment] = STATE(579),
    [sym_block_comment] = STATE(579),
    [ts_builtin_sym_end] = ACTIONS(2170),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_macro_rules_BANG] = ACTIONS(2170),
    [anon_sym_LPAREN] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_LBRACE] = ACTIONS(2170),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_STAR] = ACTIONS(2170),
    [anon_sym_u8] = ACTIONS(2172),
    [anon_sym_i8] = ACTIONS(2172),
    [anon_sym_u16] = ACTIONS(2172),
    [anon_sym_i16] = ACTIONS(2172),
    [anon_sym_u32] = ACTIONS(2172),
    [anon_sym_i32] = ACTIONS(2172),
    [anon_sym_u64] = ACTIONS(2172),
    [anon_sym_i64] = ACTIONS(2172),
    [anon_sym_u128] = ACTIONS(2172),
    [anon_sym_i128] = ACTIONS(2172),
    [anon_sym_isize] = ACTIONS(2172),
    [anon_sym_usize] = ACTIONS(2172),
    [anon_sym_f32] = ACTIONS(2172),
    [anon_sym_f64] = ACTIONS(2172),
    [anon_sym_bool] = ACTIONS(2172),
    [anon_sym_str] = ACTIONS(2172),
    [anon_sym_char] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2170),
    [anon_sym_POUND] = ACTIONS(2170),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_fn] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_impl] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_loop] = ACTIONS(2172),
    [anon_sym_match] = ACTIONS(2172),
    [anon_sym_mod] = ACTIONS(2172),
    [anon_sym_pub] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_trait] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [anon_sym_unsafe] = ACTIONS(2172),
    [anon_sym_use] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_move] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [sym_integer_literal] = ACTIONS(2170),
    [aux_sym_string_literal_token1] = ACTIONS(2170),
    [sym_char_literal] = ACTIONS(2170),
    [anon_sym_true] = ACTIONS(2172),
    [anon_sym_false] = ACTIONS(2172),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_crate] = ACTIONS(2172),
    [sym_metavariable] = ACTIONS(2170),
    [sym__raw_string_literal_start] = ACTIONS(2170),
    [sym_float_literal] = ACTIONS(2170),
  },
  [580] = {
    [sym_line_comment] = STATE(580),
    [sym_block_comment] = STATE(580),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2176),
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym_macro_rules_BANG] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_u8] = ACTIONS(2176),
    [anon_sym_i8] = ACTIONS(2176),
    [anon_sym_u16] = ACTIONS(2176),
    [anon_sym_i16] = ACTIONS(2176),
    [anon_sym_u32] = ACTIONS(2176),
    [anon_sym_i32] = ACTIONS(2176),
    [anon_sym_u64] = ACTIONS(2176),
    [anon_sym_i64] = ACTIONS(2176),
    [anon_sym_u128] = ACTIONS(2176),
    [anon_sym_i128] = ACTIONS(2176),
    [anon_sym_isize] = ACTIONS(2176),
    [anon_sym_usize] = ACTIONS(2176),
    [anon_sym_f32] = ACTIONS(2176),
    [anon_sym_f64] = ACTIONS(2176),
    [anon_sym_bool] = ACTIONS(2176),
    [anon_sym_str] = ACTIONS(2176),
    [anon_sym_char] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2174),
    [anon_sym_PIPE] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2174),
    [anon_sym_DOT_DOT] = ACTIONS(2174),
    [anon_sym_COLON_COLON] = ACTIONS(2174),
    [anon_sym_POUND] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_async] = ACTIONS(2176),
    [anon_sym_break] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_continue] = ACTIONS(2176),
    [anon_sym_default] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
    [anon_sym_fn] = ACTIONS(2176),
    [anon_sym_for] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2176),
    [anon_sym_impl] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_loop] = ACTIONS(2176),
    [anon_sym_match] = ACTIONS(2176),
    [anon_sym_mod] = ACTIONS(2176),
    [anon_sym_pub] = ACTIONS(2176),
    [anon_sym_return] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_struct] = ACTIONS(2176),
    [anon_sym_trait] = ACTIONS(2176),
    [anon_sym_type] = ACTIONS(2176),
    [anon_sym_union] = ACTIONS(2176),
    [anon_sym_unsafe] = ACTIONS(2176),
    [anon_sym_use] = ACTIONS(2176),
    [anon_sym_while] = ACTIONS(2176),
    [anon_sym_extern] = ACTIONS(2176),
    [anon_sym_yield] = ACTIONS(2176),
    [anon_sym_move] = ACTIONS(2176),
    [anon_sym_try] = ACTIONS(2176),
    [sym_integer_literal] = ACTIONS(2174),
    [aux_sym_string_literal_token1] = ACTIONS(2174),
    [sym_char_literal] = ACTIONS(2174),
    [anon_sym_true] = ACTIONS(2176),
    [anon_sym_false] = ACTIONS(2176),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2176),
    [sym_super] = ACTIONS(2176),
    [sym_crate] = ACTIONS(2176),
    [sym_metavariable] = ACTIONS(2174),
    [sym__raw_string_literal_start] = ACTIONS(2174),
    [sym_float_literal] = ACTIONS(2174),
  },
  [581] = {
    [sym_line_comment] = STATE(581),
    [sym_block_comment] = STATE(581),
    [ts_builtin_sym_end] = ACTIONS(2178),
    [sym_identifier] = ACTIONS(2180),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_macro_rules_BANG] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_u8] = ACTIONS(2180),
    [anon_sym_i8] = ACTIONS(2180),
    [anon_sym_u16] = ACTIONS(2180),
    [anon_sym_i16] = ACTIONS(2180),
    [anon_sym_u32] = ACTIONS(2180),
    [anon_sym_i32] = ACTIONS(2180),
    [anon_sym_u64] = ACTIONS(2180),
    [anon_sym_i64] = ACTIONS(2180),
    [anon_sym_u128] = ACTIONS(2180),
    [anon_sym_i128] = ACTIONS(2180),
    [anon_sym_isize] = ACTIONS(2180),
    [anon_sym_usize] = ACTIONS(2180),
    [anon_sym_f32] = ACTIONS(2180),
    [anon_sym_f64] = ACTIONS(2180),
    [anon_sym_bool] = ACTIONS(2180),
    [anon_sym_str] = ACTIONS(2180),
    [anon_sym_char] = ACTIONS(2180),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_PIPE] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_DOT_DOT] = ACTIONS(2178),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_POUND] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2180),
    [anon_sym_async] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_fn] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_impl] = ACTIONS(2180),
    [anon_sym_let] = ACTIONS(2180),
    [anon_sym_loop] = ACTIONS(2180),
    [anon_sym_match] = ACTIONS(2180),
    [anon_sym_mod] = ACTIONS(2180),
    [anon_sym_pub] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_trait] = ACTIONS(2180),
    [anon_sym_type] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [anon_sym_unsafe] = ACTIONS(2180),
    [anon_sym_use] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym_yield] = ACTIONS(2180),
    [anon_sym_move] = ACTIONS(2180),
    [anon_sym_try] = ACTIONS(2180),
    [sym_integer_literal] = ACTIONS(2178),
    [aux_sym_string_literal_token1] = ACTIONS(2178),
    [sym_char_literal] = ACTIONS(2178),
    [anon_sym_true] = ACTIONS(2180),
    [anon_sym_false] = ACTIONS(2180),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2180),
    [sym_super] = ACTIONS(2180),
    [sym_crate] = ACTIONS(2180),
    [sym_metavariable] = ACTIONS(2178),
    [sym__raw_string_literal_start] = ACTIONS(2178),
    [sym_float_literal] = ACTIONS(2178),
  },
  [582] = {
    [sym_line_comment] = STATE(582),
    [sym_block_comment] = STATE(582),
    [ts_builtin_sym_end] = ACTIONS(2182),
    [sym_identifier] = ACTIONS(2184),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_macro_rules_BANG] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2182),
    [anon_sym_u8] = ACTIONS(2184),
    [anon_sym_i8] = ACTIONS(2184),
    [anon_sym_u16] = ACTIONS(2184),
    [anon_sym_i16] = ACTIONS(2184),
    [anon_sym_u32] = ACTIONS(2184),
    [anon_sym_i32] = ACTIONS(2184),
    [anon_sym_u64] = ACTIONS(2184),
    [anon_sym_i64] = ACTIONS(2184),
    [anon_sym_u128] = ACTIONS(2184),
    [anon_sym_i128] = ACTIONS(2184),
    [anon_sym_isize] = ACTIONS(2184),
    [anon_sym_usize] = ACTIONS(2184),
    [anon_sym_f32] = ACTIONS(2184),
    [anon_sym_f64] = ACTIONS(2184),
    [anon_sym_bool] = ACTIONS(2184),
    [anon_sym_str] = ACTIONS(2184),
    [anon_sym_char] = ACTIONS(2184),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2182),
    [anon_sym_PIPE] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_POUND] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2184),
    [anon_sym_async] = ACTIONS(2184),
    [anon_sym_break] = ACTIONS(2184),
    [anon_sym_const] = ACTIONS(2184),
    [anon_sym_continue] = ACTIONS(2184),
    [anon_sym_default] = ACTIONS(2184),
    [anon_sym_enum] = ACTIONS(2184),
    [anon_sym_fn] = ACTIONS(2184),
    [anon_sym_for] = ACTIONS(2184),
    [anon_sym_if] = ACTIONS(2184),
    [anon_sym_impl] = ACTIONS(2184),
    [anon_sym_let] = ACTIONS(2184),
    [anon_sym_loop] = ACTIONS(2184),
    [anon_sym_match] = ACTIONS(2184),
    [anon_sym_mod] = ACTIONS(2184),
    [anon_sym_pub] = ACTIONS(2184),
    [anon_sym_return] = ACTIONS(2184),
    [anon_sym_static] = ACTIONS(2184),
    [anon_sym_struct] = ACTIONS(2184),
    [anon_sym_trait] = ACTIONS(2184),
    [anon_sym_type] = ACTIONS(2184),
    [anon_sym_union] = ACTIONS(2184),
    [anon_sym_unsafe] = ACTIONS(2184),
    [anon_sym_use] = ACTIONS(2184),
    [anon_sym_while] = ACTIONS(2184),
    [anon_sym_extern] = ACTIONS(2184),
    [anon_sym_yield] = ACTIONS(2184),
    [anon_sym_move] = ACTIONS(2184),
    [anon_sym_try] = ACTIONS(2184),
    [sym_integer_literal] = ACTIONS(2182),
    [aux_sym_string_literal_token1] = ACTIONS(2182),
    [sym_char_literal] = ACTIONS(2182),
    [anon_sym_true] = ACTIONS(2184),
    [anon_sym_false] = ACTIONS(2184),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2184),
    [sym_super] = ACTIONS(2184),
    [sym_crate] = ACTIONS(2184),
    [sym_metavariable] = ACTIONS(2182),
    [sym__raw_string_literal_start] = ACTIONS(2182),
    [sym_float_literal] = ACTIONS(2182),
  },
  [583] = {
    [sym_line_comment] = STATE(583),
    [sym_block_comment] = STATE(583),
    [ts_builtin_sym_end] = ACTIONS(2186),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_macro_rules_BANG] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_RBRACE] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_u8] = ACTIONS(2188),
    [anon_sym_i8] = ACTIONS(2188),
    [anon_sym_u16] = ACTIONS(2188),
    [anon_sym_i16] = ACTIONS(2188),
    [anon_sym_u32] = ACTIONS(2188),
    [anon_sym_i32] = ACTIONS(2188),
    [anon_sym_u64] = ACTIONS(2188),
    [anon_sym_i64] = ACTIONS(2188),
    [anon_sym_u128] = ACTIONS(2188),
    [anon_sym_i128] = ACTIONS(2188),
    [anon_sym_isize] = ACTIONS(2188),
    [anon_sym_usize] = ACTIONS(2188),
    [anon_sym_f32] = ACTIONS(2188),
    [anon_sym_f64] = ACTIONS(2188),
    [anon_sym_bool] = ACTIONS(2188),
    [anon_sym_str] = ACTIONS(2188),
    [anon_sym_char] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_DOT_DOT] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_POUND] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [anon_sym_fn] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_impl] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_loop] = ACTIONS(2188),
    [anon_sym_match] = ACTIONS(2188),
    [anon_sym_mod] = ACTIONS(2188),
    [anon_sym_pub] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_struct] = ACTIONS(2188),
    [anon_sym_trait] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_union] = ACTIONS(2188),
    [anon_sym_unsafe] = ACTIONS(2188),
    [anon_sym_use] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_extern] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_move] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [sym_integer_literal] = ACTIONS(2186),
    [aux_sym_string_literal_token1] = ACTIONS(2186),
    [sym_char_literal] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2188),
    [anon_sym_false] = ACTIONS(2188),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_crate] = ACTIONS(2188),
    [sym_metavariable] = ACTIONS(2186),
    [sym__raw_string_literal_start] = ACTIONS(2186),
    [sym_float_literal] = ACTIONS(2186),
  },
  [584] = {
    [sym_line_comment] = STATE(584),
    [sym_block_comment] = STATE(584),
    [ts_builtin_sym_end] = ACTIONS(2190),
    [sym_identifier] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_macro_rules_BANG] = ACTIONS(2190),
    [anon_sym_LPAREN] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_u8] = ACTIONS(2192),
    [anon_sym_i8] = ACTIONS(2192),
    [anon_sym_u16] = ACTIONS(2192),
    [anon_sym_i16] = ACTIONS(2192),
    [anon_sym_u32] = ACTIONS(2192),
    [anon_sym_i32] = ACTIONS(2192),
    [anon_sym_u64] = ACTIONS(2192),
    [anon_sym_i64] = ACTIONS(2192),
    [anon_sym_u128] = ACTIONS(2192),
    [anon_sym_i128] = ACTIONS(2192),
    [anon_sym_isize] = ACTIONS(2192),
    [anon_sym_usize] = ACTIONS(2192),
    [anon_sym_f32] = ACTIONS(2192),
    [anon_sym_f64] = ACTIONS(2192),
    [anon_sym_bool] = ACTIONS(2192),
    [anon_sym_str] = ACTIONS(2192),
    [anon_sym_char] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_DOT_DOT] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2190),
    [anon_sym_POUND] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_async] = ACTIONS(2192),
    [anon_sym_break] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2192),
    [anon_sym_continue] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2192),
    [anon_sym_enum] = ACTIONS(2192),
    [anon_sym_fn] = ACTIONS(2192),
    [anon_sym_for] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2192),
    [anon_sym_impl] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_loop] = ACTIONS(2192),
    [anon_sym_match] = ACTIONS(2192),
    [anon_sym_mod] = ACTIONS(2192),
    [anon_sym_pub] = ACTIONS(2192),
    [anon_sym_return] = ACTIONS(2192),
    [anon_sym_static] = ACTIONS(2192),
    [anon_sym_struct] = ACTIONS(2192),
    [anon_sym_trait] = ACTIONS(2192),
    [anon_sym_type] = ACTIONS(2192),
    [anon_sym_union] = ACTIONS(2192),
    [anon_sym_unsafe] = ACTIONS(2192),
    [anon_sym_use] = ACTIONS(2192),
    [anon_sym_while] = ACTIONS(2192),
    [anon_sym_extern] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2192),
    [anon_sym_move] = ACTIONS(2192),
    [anon_sym_try] = ACTIONS(2192),
    [sym_integer_literal] = ACTIONS(2190),
    [aux_sym_string_literal_token1] = ACTIONS(2190),
    [sym_char_literal] = ACTIONS(2190),
    [anon_sym_true] = ACTIONS(2192),
    [anon_sym_false] = ACTIONS(2192),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2192),
    [sym_super] = ACTIONS(2192),
    [sym_crate] = ACTIONS(2192),
    [sym_metavariable] = ACTIONS(2190),
    [sym__raw_string_literal_start] = ACTIONS(2190),
    [sym_float_literal] = ACTIONS(2190),
  },
  [585] = {
    [sym_line_comment] = STATE(585),
    [sym_block_comment] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(2194),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2194),
    [anon_sym_macro_rules_BANG] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2194),
    [anon_sym_RBRACE] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_u8] = ACTIONS(2196),
    [anon_sym_i8] = ACTIONS(2196),
    [anon_sym_u16] = ACTIONS(2196),
    [anon_sym_i16] = ACTIONS(2196),
    [anon_sym_u32] = ACTIONS(2196),
    [anon_sym_i32] = ACTIONS(2196),
    [anon_sym_u64] = ACTIONS(2196),
    [anon_sym_i64] = ACTIONS(2196),
    [anon_sym_u128] = ACTIONS(2196),
    [anon_sym_i128] = ACTIONS(2196),
    [anon_sym_isize] = ACTIONS(2196),
    [anon_sym_usize] = ACTIONS(2196),
    [anon_sym_f32] = ACTIONS(2196),
    [anon_sym_f64] = ACTIONS(2196),
    [anon_sym_bool] = ACTIONS(2196),
    [anon_sym_str] = ACTIONS(2196),
    [anon_sym_char] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_DOT_DOT] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2194),
    [anon_sym_POUND] = ACTIONS(2194),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [anon_sym_fn] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_impl] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_loop] = ACTIONS(2196),
    [anon_sym_match] = ACTIONS(2196),
    [anon_sym_mod] = ACTIONS(2196),
    [anon_sym_pub] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_struct] = ACTIONS(2196),
    [anon_sym_trait] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_union] = ACTIONS(2196),
    [anon_sym_unsafe] = ACTIONS(2196),
    [anon_sym_use] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_extern] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_move] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [sym_integer_literal] = ACTIONS(2194),
    [aux_sym_string_literal_token1] = ACTIONS(2194),
    [sym_char_literal] = ACTIONS(2194),
    [anon_sym_true] = ACTIONS(2196),
    [anon_sym_false] = ACTIONS(2196),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_crate] = ACTIONS(2196),
    [sym_metavariable] = ACTIONS(2194),
    [sym__raw_string_literal_start] = ACTIONS(2194),
    [sym_float_literal] = ACTIONS(2194),
  },
  [586] = {
    [sym_line_comment] = STATE(586),
    [sym_block_comment] = STATE(586),
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(2198),
    [anon_sym_macro_rules_BANG] = ACTIONS(2198),
    [anon_sym_LPAREN] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_u8] = ACTIONS(2200),
    [anon_sym_i8] = ACTIONS(2200),
    [anon_sym_u16] = ACTIONS(2200),
    [anon_sym_i16] = ACTIONS(2200),
    [anon_sym_u32] = ACTIONS(2200),
    [anon_sym_i32] = ACTIONS(2200),
    [anon_sym_u64] = ACTIONS(2200),
    [anon_sym_i64] = ACTIONS(2200),
    [anon_sym_u128] = ACTIONS(2200),
    [anon_sym_i128] = ACTIONS(2200),
    [anon_sym_isize] = ACTIONS(2200),
    [anon_sym_usize] = ACTIONS(2200),
    [anon_sym_f32] = ACTIONS(2200),
    [anon_sym_f64] = ACTIONS(2200),
    [anon_sym_bool] = ACTIONS(2200),
    [anon_sym_str] = ACTIONS(2200),
    [anon_sym_char] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_DOT_DOT] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2198),
    [anon_sym_POUND] = ACTIONS(2198),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_async] = ACTIONS(2200),
    [anon_sym_break] = ACTIONS(2200),
    [anon_sym_const] = ACTIONS(2200),
    [anon_sym_continue] = ACTIONS(2200),
    [anon_sym_default] = ACTIONS(2200),
    [anon_sym_enum] = ACTIONS(2200),
    [anon_sym_fn] = ACTIONS(2200),
    [anon_sym_for] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2200),
    [anon_sym_impl] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_loop] = ACTIONS(2200),
    [anon_sym_match] = ACTIONS(2200),
    [anon_sym_mod] = ACTIONS(2200),
    [anon_sym_pub] = ACTIONS(2200),
    [anon_sym_return] = ACTIONS(2200),
    [anon_sym_static] = ACTIONS(2200),
    [anon_sym_struct] = ACTIONS(2200),
    [anon_sym_trait] = ACTIONS(2200),
    [anon_sym_type] = ACTIONS(2200),
    [anon_sym_union] = ACTIONS(2200),
    [anon_sym_unsafe] = ACTIONS(2200),
    [anon_sym_use] = ACTIONS(2200),
    [anon_sym_while] = ACTIONS(2200),
    [anon_sym_extern] = ACTIONS(2200),
    [anon_sym_yield] = ACTIONS(2200),
    [anon_sym_move] = ACTIONS(2200),
    [anon_sym_try] = ACTIONS(2200),
    [sym_integer_literal] = ACTIONS(2198),
    [aux_sym_string_literal_token1] = ACTIONS(2198),
    [sym_char_literal] = ACTIONS(2198),
    [anon_sym_true] = ACTIONS(2200),
    [anon_sym_false] = ACTIONS(2200),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2200),
    [sym_super] = ACTIONS(2200),
    [sym_crate] = ACTIONS(2200),
    [sym_metavariable] = ACTIONS(2198),
    [sym__raw_string_literal_start] = ACTIONS(2198),
    [sym_float_literal] = ACTIONS(2198),
  },
  [587] = {
    [sym_line_comment] = STATE(587),
    [sym_block_comment] = STATE(587),
    [ts_builtin_sym_end] = ACTIONS(2202),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2202),
    [anon_sym_macro_rules_BANG] = ACTIONS(2202),
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2202),
    [anon_sym_RBRACE] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_u8] = ACTIONS(2204),
    [anon_sym_i8] = ACTIONS(2204),
    [anon_sym_u16] = ACTIONS(2204),
    [anon_sym_i16] = ACTIONS(2204),
    [anon_sym_u32] = ACTIONS(2204),
    [anon_sym_i32] = ACTIONS(2204),
    [anon_sym_u64] = ACTIONS(2204),
    [anon_sym_i64] = ACTIONS(2204),
    [anon_sym_u128] = ACTIONS(2204),
    [anon_sym_i128] = ACTIONS(2204),
    [anon_sym_isize] = ACTIONS(2204),
    [anon_sym_usize] = ACTIONS(2204),
    [anon_sym_f32] = ACTIONS(2204),
    [anon_sym_f64] = ACTIONS(2204),
    [anon_sym_bool] = ACTIONS(2204),
    [anon_sym_str] = ACTIONS(2204),
    [anon_sym_char] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2202),
    [anon_sym_POUND] = ACTIONS(2202),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [anon_sym_fn] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_impl] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_loop] = ACTIONS(2204),
    [anon_sym_match] = ACTIONS(2204),
    [anon_sym_mod] = ACTIONS(2204),
    [anon_sym_pub] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_struct] = ACTIONS(2204),
    [anon_sym_trait] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_union] = ACTIONS(2204),
    [anon_sym_unsafe] = ACTIONS(2204),
    [anon_sym_use] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_extern] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_move] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [sym_integer_literal] = ACTIONS(2202),
    [aux_sym_string_literal_token1] = ACTIONS(2202),
    [sym_char_literal] = ACTIONS(2202),
    [anon_sym_true] = ACTIONS(2204),
    [anon_sym_false] = ACTIONS(2204),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_crate] = ACTIONS(2204),
    [sym_metavariable] = ACTIONS(2202),
    [sym__raw_string_literal_start] = ACTIONS(2202),
    [sym_float_literal] = ACTIONS(2202),
  },
  [588] = {
    [sym_line_comment] = STATE(588),
    [sym_block_comment] = STATE(588),
    [ts_builtin_sym_end] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2208),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_macro_rules_BANG] = ACTIONS(2206),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_u8] = ACTIONS(2208),
    [anon_sym_i8] = ACTIONS(2208),
    [anon_sym_u16] = ACTIONS(2208),
    [anon_sym_i16] = ACTIONS(2208),
    [anon_sym_u32] = ACTIONS(2208),
    [anon_sym_i32] = ACTIONS(2208),
    [anon_sym_u64] = ACTIONS(2208),
    [anon_sym_i64] = ACTIONS(2208),
    [anon_sym_u128] = ACTIONS(2208),
    [anon_sym_i128] = ACTIONS(2208),
    [anon_sym_isize] = ACTIONS(2208),
    [anon_sym_usize] = ACTIONS(2208),
    [anon_sym_f32] = ACTIONS(2208),
    [anon_sym_f64] = ACTIONS(2208),
    [anon_sym_bool] = ACTIONS(2208),
    [anon_sym_str] = ACTIONS(2208),
    [anon_sym_char] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_DOT_DOT] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2206),
    [anon_sym_POUND] = ACTIONS(2206),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_async] = ACTIONS(2208),
    [anon_sym_break] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_continue] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_enum] = ACTIONS(2208),
    [anon_sym_fn] = ACTIONS(2208),
    [anon_sym_for] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(2208),
    [anon_sym_impl] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_loop] = ACTIONS(2208),
    [anon_sym_match] = ACTIONS(2208),
    [anon_sym_mod] = ACTIONS(2208),
    [anon_sym_pub] = ACTIONS(2208),
    [anon_sym_return] = ACTIONS(2208),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_struct] = ACTIONS(2208),
    [anon_sym_trait] = ACTIONS(2208),
    [anon_sym_type] = ACTIONS(2208),
    [anon_sym_union] = ACTIONS(2208),
    [anon_sym_unsafe] = ACTIONS(2208),
    [anon_sym_use] = ACTIONS(2208),
    [anon_sym_while] = ACTIONS(2208),
    [anon_sym_extern] = ACTIONS(2208),
    [anon_sym_yield] = ACTIONS(2208),
    [anon_sym_move] = ACTIONS(2208),
    [anon_sym_try] = ACTIONS(2208),
    [sym_integer_literal] = ACTIONS(2206),
    [aux_sym_string_literal_token1] = ACTIONS(2206),
    [sym_char_literal] = ACTIONS(2206),
    [anon_sym_true] = ACTIONS(2208),
    [anon_sym_false] = ACTIONS(2208),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2208),
    [sym_super] = ACTIONS(2208),
    [sym_crate] = ACTIONS(2208),
    [sym_metavariable] = ACTIONS(2206),
    [sym__raw_string_literal_start] = ACTIONS(2206),
    [sym_float_literal] = ACTIONS(2206),
  },
  [589] = {
    [sym_line_comment] = STATE(589),
    [sym_block_comment] = STATE(589),
    [ts_builtin_sym_end] = ACTIONS(2210),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2210),
    [anon_sym_macro_rules_BANG] = ACTIONS(2210),
    [anon_sym_LPAREN] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2210),
    [anon_sym_RBRACE] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(2210),
    [anon_sym_u8] = ACTIONS(2212),
    [anon_sym_i8] = ACTIONS(2212),
    [anon_sym_u16] = ACTIONS(2212),
    [anon_sym_i16] = ACTIONS(2212),
    [anon_sym_u32] = ACTIONS(2212),
    [anon_sym_i32] = ACTIONS(2212),
    [anon_sym_u64] = ACTIONS(2212),
    [anon_sym_i64] = ACTIONS(2212),
    [anon_sym_u128] = ACTIONS(2212),
    [anon_sym_i128] = ACTIONS(2212),
    [anon_sym_isize] = ACTIONS(2212),
    [anon_sym_usize] = ACTIONS(2212),
    [anon_sym_f32] = ACTIONS(2212),
    [anon_sym_f64] = ACTIONS(2212),
    [anon_sym_bool] = ACTIONS(2212),
    [anon_sym_str] = ACTIONS(2212),
    [anon_sym_char] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_PIPE] = ACTIONS(2210),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_DOT_DOT] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2210),
    [anon_sym_POUND] = ACTIONS(2210),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [anon_sym_fn] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_impl] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_loop] = ACTIONS(2212),
    [anon_sym_match] = ACTIONS(2212),
    [anon_sym_mod] = ACTIONS(2212),
    [anon_sym_pub] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_struct] = ACTIONS(2212),
    [anon_sym_trait] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_union] = ACTIONS(2212),
    [anon_sym_unsafe] = ACTIONS(2212),
    [anon_sym_use] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_move] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [sym_integer_literal] = ACTIONS(2210),
    [aux_sym_string_literal_token1] = ACTIONS(2210),
    [sym_char_literal] = ACTIONS(2210),
    [anon_sym_true] = ACTIONS(2212),
    [anon_sym_false] = ACTIONS(2212),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_crate] = ACTIONS(2212),
    [sym_metavariable] = ACTIONS(2210),
    [sym__raw_string_literal_start] = ACTIONS(2210),
    [sym_float_literal] = ACTIONS(2210),
  },
  [590] = {
    [sym_line_comment] = STATE(590),
    [sym_block_comment] = STATE(590),
    [ts_builtin_sym_end] = ACTIONS(2214),
    [sym_identifier] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_macro_rules_BANG] = ACTIONS(2214),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_u8] = ACTIONS(2216),
    [anon_sym_i8] = ACTIONS(2216),
    [anon_sym_u16] = ACTIONS(2216),
    [anon_sym_i16] = ACTIONS(2216),
    [anon_sym_u32] = ACTIONS(2216),
    [anon_sym_i32] = ACTIONS(2216),
    [anon_sym_u64] = ACTIONS(2216),
    [anon_sym_i64] = ACTIONS(2216),
    [anon_sym_u128] = ACTIONS(2216),
    [anon_sym_i128] = ACTIONS(2216),
    [anon_sym_isize] = ACTIONS(2216),
    [anon_sym_usize] = ACTIONS(2216),
    [anon_sym_f32] = ACTIONS(2216),
    [anon_sym_f64] = ACTIONS(2216),
    [anon_sym_bool] = ACTIONS(2216),
    [anon_sym_str] = ACTIONS(2216),
    [anon_sym_char] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym_COLON_COLON] = ACTIONS(2214),
    [anon_sym_POUND] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_break] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_default] = ACTIONS(2216),
    [anon_sym_enum] = ACTIONS(2216),
    [anon_sym_fn] = ACTIONS(2216),
    [anon_sym_for] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(2216),
    [anon_sym_impl] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_loop] = ACTIONS(2216),
    [anon_sym_match] = ACTIONS(2216),
    [anon_sym_mod] = ACTIONS(2216),
    [anon_sym_pub] = ACTIONS(2216),
    [anon_sym_return] = ACTIONS(2216),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_struct] = ACTIONS(2216),
    [anon_sym_trait] = ACTIONS(2216),
    [anon_sym_type] = ACTIONS(2216),
    [anon_sym_union] = ACTIONS(2216),
    [anon_sym_unsafe] = ACTIONS(2216),
    [anon_sym_use] = ACTIONS(2216),
    [anon_sym_while] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_move] = ACTIONS(2216),
    [anon_sym_try] = ACTIONS(2216),
    [sym_integer_literal] = ACTIONS(2214),
    [aux_sym_string_literal_token1] = ACTIONS(2214),
    [sym_char_literal] = ACTIONS(2214),
    [anon_sym_true] = ACTIONS(2216),
    [anon_sym_false] = ACTIONS(2216),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2216),
    [sym_super] = ACTIONS(2216),
    [sym_crate] = ACTIONS(2216),
    [sym_metavariable] = ACTIONS(2214),
    [sym__raw_string_literal_start] = ACTIONS(2214),
    [sym_float_literal] = ACTIONS(2214),
  },
  [591] = {
    [sym_line_comment] = STATE(591),
    [sym_block_comment] = STATE(591),
    [ts_builtin_sym_end] = ACTIONS(2218),
    [sym_identifier] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_macro_rules_BANG] = ACTIONS(2218),
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_RBRACE] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2218),
    [anon_sym_u8] = ACTIONS(2220),
    [anon_sym_i8] = ACTIONS(2220),
    [anon_sym_u16] = ACTIONS(2220),
    [anon_sym_i16] = ACTIONS(2220),
    [anon_sym_u32] = ACTIONS(2220),
    [anon_sym_i32] = ACTIONS(2220),
    [anon_sym_u64] = ACTIONS(2220),
    [anon_sym_i64] = ACTIONS(2220),
    [anon_sym_u128] = ACTIONS(2220),
    [anon_sym_i128] = ACTIONS(2220),
    [anon_sym_isize] = ACTIONS(2220),
    [anon_sym_usize] = ACTIONS(2220),
    [anon_sym_f32] = ACTIONS(2220),
    [anon_sym_f64] = ACTIONS(2220),
    [anon_sym_bool] = ACTIONS(2220),
    [anon_sym_str] = ACTIONS(2220),
    [anon_sym_char] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_PIPE] = ACTIONS(2218),
    [anon_sym_LT] = ACTIONS(2218),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
    [anon_sym_POUND] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_async] = ACTIONS(2220),
    [anon_sym_break] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_continue] = ACTIONS(2220),
    [anon_sym_default] = ACTIONS(2220),
    [anon_sym_enum] = ACTIONS(2220),
    [anon_sym_fn] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_impl] = ACTIONS(2220),
    [anon_sym_let] = ACTIONS(2220),
    [anon_sym_loop] = ACTIONS(2220),
    [anon_sym_match] = ACTIONS(2220),
    [anon_sym_mod] = ACTIONS(2220),
    [anon_sym_pub] = ACTIONS(2220),
    [anon_sym_return] = ACTIONS(2220),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_struct] = ACTIONS(2220),
    [anon_sym_trait] = ACTIONS(2220),
    [anon_sym_type] = ACTIONS(2220),
    [anon_sym_union] = ACTIONS(2220),
    [anon_sym_unsafe] = ACTIONS(2220),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_while] = ACTIONS(2220),
    [anon_sym_extern] = ACTIONS(2220),
    [anon_sym_yield] = ACTIONS(2220),
    [anon_sym_move] = ACTIONS(2220),
    [anon_sym_try] = ACTIONS(2220),
    [sym_integer_literal] = ACTIONS(2218),
    [aux_sym_string_literal_token1] = ACTIONS(2218),
    [sym_char_literal] = ACTIONS(2218),
    [anon_sym_true] = ACTIONS(2220),
    [anon_sym_false] = ACTIONS(2220),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2220),
    [sym_super] = ACTIONS(2220),
    [sym_crate] = ACTIONS(2220),
    [sym_metavariable] = ACTIONS(2218),
    [sym__raw_string_literal_start] = ACTIONS(2218),
    [sym_float_literal] = ACTIONS(2218),
  },
  [592] = {
    [sym_line_comment] = STATE(592),
    [sym_block_comment] = STATE(592),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_macro_rules_BANG] = ACTIONS(2222),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_u8] = ACTIONS(2224),
    [anon_sym_i8] = ACTIONS(2224),
    [anon_sym_u16] = ACTIONS(2224),
    [anon_sym_i16] = ACTIONS(2224),
    [anon_sym_u32] = ACTIONS(2224),
    [anon_sym_i32] = ACTIONS(2224),
    [anon_sym_u64] = ACTIONS(2224),
    [anon_sym_i64] = ACTIONS(2224),
    [anon_sym_u128] = ACTIONS(2224),
    [anon_sym_i128] = ACTIONS(2224),
    [anon_sym_isize] = ACTIONS(2224),
    [anon_sym_usize] = ACTIONS(2224),
    [anon_sym_f32] = ACTIONS(2224),
    [anon_sym_f64] = ACTIONS(2224),
    [anon_sym_bool] = ACTIONS(2224),
    [anon_sym_str] = ACTIONS(2224),
    [anon_sym_char] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_DOT_DOT] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2222),
    [anon_sym_POUND] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_fn] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_impl] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_loop] = ACTIONS(2224),
    [anon_sym_match] = ACTIONS(2224),
    [anon_sym_mod] = ACTIONS(2224),
    [anon_sym_pub] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_trait] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_unsafe] = ACTIONS(2224),
    [anon_sym_use] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym_yield] = ACTIONS(2224),
    [anon_sym_move] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [sym_integer_literal] = ACTIONS(2222),
    [aux_sym_string_literal_token1] = ACTIONS(2222),
    [sym_char_literal] = ACTIONS(2222),
    [anon_sym_true] = ACTIONS(2224),
    [anon_sym_false] = ACTIONS(2224),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2224),
    [sym_super] = ACTIONS(2224),
    [sym_crate] = ACTIONS(2224),
    [sym_metavariable] = ACTIONS(2222),
    [sym__raw_string_literal_start] = ACTIONS(2222),
    [sym_float_literal] = ACTIONS(2222),
  },
  [593] = {
    [sym_line_comment] = STATE(593),
    [sym_block_comment] = STATE(593),
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_macro_rules_BANG] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_u8] = ACTIONS(2228),
    [anon_sym_i8] = ACTIONS(2228),
    [anon_sym_u16] = ACTIONS(2228),
    [anon_sym_i16] = ACTIONS(2228),
    [anon_sym_u32] = ACTIONS(2228),
    [anon_sym_i32] = ACTIONS(2228),
    [anon_sym_u64] = ACTIONS(2228),
    [anon_sym_i64] = ACTIONS(2228),
    [anon_sym_u128] = ACTIONS(2228),
    [anon_sym_i128] = ACTIONS(2228),
    [anon_sym_isize] = ACTIONS(2228),
    [anon_sym_usize] = ACTIONS(2228),
    [anon_sym_f32] = ACTIONS(2228),
    [anon_sym_f64] = ACTIONS(2228),
    [anon_sym_bool] = ACTIONS(2228),
    [anon_sym_str] = ACTIONS(2228),
    [anon_sym_char] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_POUND] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2228),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_fn] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_impl] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_loop] = ACTIONS(2228),
    [anon_sym_match] = ACTIONS(2228),
    [anon_sym_mod] = ACTIONS(2228),
    [anon_sym_pub] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_trait] = ACTIONS(2228),
    [anon_sym_type] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_unsafe] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2228),
    [anon_sym_move] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [sym_integer_literal] = ACTIONS(2226),
    [aux_sym_string_literal_token1] = ACTIONS(2226),
    [sym_char_literal] = ACTIONS(2226),
    [anon_sym_true] = ACTIONS(2228),
    [anon_sym_false] = ACTIONS(2228),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2228),
    [sym_super] = ACTIONS(2228),
    [sym_crate] = ACTIONS(2228),
    [sym_metavariable] = ACTIONS(2226),
    [sym__raw_string_literal_start] = ACTIONS(2226),
    [sym_float_literal] = ACTIONS(2226),
  },
  [594] = {
    [sym_line_comment] = STATE(594),
    [sym_block_comment] = STATE(594),
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym_macro_rules_BANG] = ACTIONS(2230),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_u8] = ACTIONS(2232),
    [anon_sym_i8] = ACTIONS(2232),
    [anon_sym_u16] = ACTIONS(2232),
    [anon_sym_i16] = ACTIONS(2232),
    [anon_sym_u32] = ACTIONS(2232),
    [anon_sym_i32] = ACTIONS(2232),
    [anon_sym_u64] = ACTIONS(2232),
    [anon_sym_i64] = ACTIONS(2232),
    [anon_sym_u128] = ACTIONS(2232),
    [anon_sym_i128] = ACTIONS(2232),
    [anon_sym_isize] = ACTIONS(2232),
    [anon_sym_usize] = ACTIONS(2232),
    [anon_sym_f32] = ACTIONS(2232),
    [anon_sym_f64] = ACTIONS(2232),
    [anon_sym_bool] = ACTIONS(2232),
    [anon_sym_str] = ACTIONS(2232),
    [anon_sym_char] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2230),
    [anon_sym_LT] = ACTIONS(2230),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_POUND] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym_async] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_fn] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_impl] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_loop] = ACTIONS(2232),
    [anon_sym_match] = ACTIONS(2232),
    [anon_sym_mod] = ACTIONS(2232),
    [anon_sym_pub] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_trait] = ACTIONS(2232),
    [anon_sym_type] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_unsafe] = ACTIONS(2232),
    [anon_sym_use] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym_yield] = ACTIONS(2232),
    [anon_sym_move] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [sym_integer_literal] = ACTIONS(2230),
    [aux_sym_string_literal_token1] = ACTIONS(2230),
    [sym_char_literal] = ACTIONS(2230),
    [anon_sym_true] = ACTIONS(2232),
    [anon_sym_false] = ACTIONS(2232),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2232),
    [sym_super] = ACTIONS(2232),
    [sym_crate] = ACTIONS(2232),
    [sym_metavariable] = ACTIONS(2230),
    [sym__raw_string_literal_start] = ACTIONS(2230),
    [sym_float_literal] = ACTIONS(2230),
  },
  [595] = {
    [sym_line_comment] = STATE(595),
    [sym_block_comment] = STATE(595),
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_macro_rules_BANG] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_u8] = ACTIONS(2236),
    [anon_sym_i8] = ACTIONS(2236),
    [anon_sym_u16] = ACTIONS(2236),
    [anon_sym_i16] = ACTIONS(2236),
    [anon_sym_u32] = ACTIONS(2236),
    [anon_sym_i32] = ACTIONS(2236),
    [anon_sym_u64] = ACTIONS(2236),
    [anon_sym_i64] = ACTIONS(2236),
    [anon_sym_u128] = ACTIONS(2236),
    [anon_sym_i128] = ACTIONS(2236),
    [anon_sym_isize] = ACTIONS(2236),
    [anon_sym_usize] = ACTIONS(2236),
    [anon_sym_f32] = ACTIONS(2236),
    [anon_sym_f64] = ACTIONS(2236),
    [anon_sym_bool] = ACTIONS(2236),
    [anon_sym_str] = ACTIONS(2236),
    [anon_sym_char] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_POUND] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_fn] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_impl] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_loop] = ACTIONS(2236),
    [anon_sym_match] = ACTIONS(2236),
    [anon_sym_mod] = ACTIONS(2236),
    [anon_sym_pub] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_trait] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_unsafe] = ACTIONS(2236),
    [anon_sym_use] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym_yield] = ACTIONS(2236),
    [anon_sym_move] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [sym_integer_literal] = ACTIONS(2234),
    [aux_sym_string_literal_token1] = ACTIONS(2234),
    [sym_char_literal] = ACTIONS(2234),
    [anon_sym_true] = ACTIONS(2236),
    [anon_sym_false] = ACTIONS(2236),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2236),
    [sym_super] = ACTIONS(2236),
    [sym_crate] = ACTIONS(2236),
    [sym_metavariable] = ACTIONS(2234),
    [sym__raw_string_literal_start] = ACTIONS(2234),
    [sym_float_literal] = ACTIONS(2234),
  },
  [596] = {
    [sym_line_comment] = STATE(596),
    [sym_block_comment] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(2238),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_macro_rules_BANG] = ACTIONS(2238),
    [anon_sym_LPAREN] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_u8] = ACTIONS(2240),
    [anon_sym_i8] = ACTIONS(2240),
    [anon_sym_u16] = ACTIONS(2240),
    [anon_sym_i16] = ACTIONS(2240),
    [anon_sym_u32] = ACTIONS(2240),
    [anon_sym_i32] = ACTIONS(2240),
    [anon_sym_u64] = ACTIONS(2240),
    [anon_sym_i64] = ACTIONS(2240),
    [anon_sym_u128] = ACTIONS(2240),
    [anon_sym_i128] = ACTIONS(2240),
    [anon_sym_isize] = ACTIONS(2240),
    [anon_sym_usize] = ACTIONS(2240),
    [anon_sym_f32] = ACTIONS(2240),
    [anon_sym_f64] = ACTIONS(2240),
    [anon_sym_bool] = ACTIONS(2240),
    [anon_sym_str] = ACTIONS(2240),
    [anon_sym_char] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_POUND] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2240),
    [anon_sym_async] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_fn] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_impl] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_loop] = ACTIONS(2240),
    [anon_sym_match] = ACTIONS(2240),
    [anon_sym_mod] = ACTIONS(2240),
    [anon_sym_pub] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_trait] = ACTIONS(2240),
    [anon_sym_type] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_unsafe] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2240),
    [anon_sym_move] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [sym_integer_literal] = ACTIONS(2238),
    [aux_sym_string_literal_token1] = ACTIONS(2238),
    [sym_char_literal] = ACTIONS(2238),
    [anon_sym_true] = ACTIONS(2240),
    [anon_sym_false] = ACTIONS(2240),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2240),
    [sym_super] = ACTIONS(2240),
    [sym_crate] = ACTIONS(2240),
    [sym_metavariable] = ACTIONS(2238),
    [sym__raw_string_literal_start] = ACTIONS(2238),
    [sym_float_literal] = ACTIONS(2238),
  },
  [597] = {
    [sym_line_comment] = STATE(597),
    [sym_block_comment] = STATE(597),
    [ts_builtin_sym_end] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_macro_rules_BANG] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_u8] = ACTIONS(2244),
    [anon_sym_i8] = ACTIONS(2244),
    [anon_sym_u16] = ACTIONS(2244),
    [anon_sym_i16] = ACTIONS(2244),
    [anon_sym_u32] = ACTIONS(2244),
    [anon_sym_i32] = ACTIONS(2244),
    [anon_sym_u64] = ACTIONS(2244),
    [anon_sym_i64] = ACTIONS(2244),
    [anon_sym_u128] = ACTIONS(2244),
    [anon_sym_i128] = ACTIONS(2244),
    [anon_sym_isize] = ACTIONS(2244),
    [anon_sym_usize] = ACTIONS(2244),
    [anon_sym_f32] = ACTIONS(2244),
    [anon_sym_f64] = ACTIONS(2244),
    [anon_sym_bool] = ACTIONS(2244),
    [anon_sym_str] = ACTIONS(2244),
    [anon_sym_char] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_POUND] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2244),
    [anon_sym_async] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_fn] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_impl] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_loop] = ACTIONS(2244),
    [anon_sym_match] = ACTIONS(2244),
    [anon_sym_mod] = ACTIONS(2244),
    [anon_sym_pub] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_trait] = ACTIONS(2244),
    [anon_sym_type] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_unsafe] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2244),
    [anon_sym_move] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [sym_integer_literal] = ACTIONS(2242),
    [aux_sym_string_literal_token1] = ACTIONS(2242),
    [sym_char_literal] = ACTIONS(2242),
    [anon_sym_true] = ACTIONS(2244),
    [anon_sym_false] = ACTIONS(2244),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2244),
    [sym_super] = ACTIONS(2244),
    [sym_crate] = ACTIONS(2244),
    [sym_metavariable] = ACTIONS(2242),
    [sym__raw_string_literal_start] = ACTIONS(2242),
    [sym_float_literal] = ACTIONS(2242),
  },
  [598] = {
    [sym_line_comment] = STATE(598),
    [sym_block_comment] = STATE(598),
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_macro_rules_BANG] = ACTIONS(2246),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_u8] = ACTIONS(2248),
    [anon_sym_i8] = ACTIONS(2248),
    [anon_sym_u16] = ACTIONS(2248),
    [anon_sym_i16] = ACTIONS(2248),
    [anon_sym_u32] = ACTIONS(2248),
    [anon_sym_i32] = ACTIONS(2248),
    [anon_sym_u64] = ACTIONS(2248),
    [anon_sym_i64] = ACTIONS(2248),
    [anon_sym_u128] = ACTIONS(2248),
    [anon_sym_i128] = ACTIONS(2248),
    [anon_sym_isize] = ACTIONS(2248),
    [anon_sym_usize] = ACTIONS(2248),
    [anon_sym_f32] = ACTIONS(2248),
    [anon_sym_f64] = ACTIONS(2248),
    [anon_sym_bool] = ACTIONS(2248),
    [anon_sym_str] = ACTIONS(2248),
    [anon_sym_char] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_POUND] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_fn] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_impl] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_loop] = ACTIONS(2248),
    [anon_sym_match] = ACTIONS(2248),
    [anon_sym_mod] = ACTIONS(2248),
    [anon_sym_pub] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_trait] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_unsafe] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2248),
    [anon_sym_move] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [sym_integer_literal] = ACTIONS(2246),
    [aux_sym_string_literal_token1] = ACTIONS(2246),
    [sym_char_literal] = ACTIONS(2246),
    [anon_sym_true] = ACTIONS(2248),
    [anon_sym_false] = ACTIONS(2248),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [sym_crate] = ACTIONS(2248),
    [sym_metavariable] = ACTIONS(2246),
    [sym__raw_string_literal_start] = ACTIONS(2246),
    [sym_float_literal] = ACTIONS(2246),
  },
  [599] = {
    [sym_line_comment] = STATE(599),
    [sym_block_comment] = STATE(599),
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_macro_rules_BANG] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_u8] = ACTIONS(2252),
    [anon_sym_i8] = ACTIONS(2252),
    [anon_sym_u16] = ACTIONS(2252),
    [anon_sym_i16] = ACTIONS(2252),
    [anon_sym_u32] = ACTIONS(2252),
    [anon_sym_i32] = ACTIONS(2252),
    [anon_sym_u64] = ACTIONS(2252),
    [anon_sym_i64] = ACTIONS(2252),
    [anon_sym_u128] = ACTIONS(2252),
    [anon_sym_i128] = ACTIONS(2252),
    [anon_sym_isize] = ACTIONS(2252),
    [anon_sym_usize] = ACTIONS(2252),
    [anon_sym_f32] = ACTIONS(2252),
    [anon_sym_f64] = ACTIONS(2252),
    [anon_sym_bool] = ACTIONS(2252),
    [anon_sym_str] = ACTIONS(2252),
    [anon_sym_char] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_POUND] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_fn] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_impl] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_loop] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_mod] = ACTIONS(2252),
    [anon_sym_pub] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_trait] = ACTIONS(2252),
    [anon_sym_type] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_unsafe] = ACTIONS(2252),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_move] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [sym_integer_literal] = ACTIONS(2250),
    [aux_sym_string_literal_token1] = ACTIONS(2250),
    [sym_char_literal] = ACTIONS(2250),
    [anon_sym_true] = ACTIONS(2252),
    [anon_sym_false] = ACTIONS(2252),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2252),
    [sym_super] = ACTIONS(2252),
    [sym_crate] = ACTIONS(2252),
    [sym_metavariable] = ACTIONS(2250),
    [sym__raw_string_literal_start] = ACTIONS(2250),
    [sym_float_literal] = ACTIONS(2250),
  },
  [600] = {
    [sym_line_comment] = STATE(600),
    [sym_block_comment] = STATE(600),
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_macro_rules_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_u8] = ACTIONS(2256),
    [anon_sym_i8] = ACTIONS(2256),
    [anon_sym_u16] = ACTIONS(2256),
    [anon_sym_i16] = ACTIONS(2256),
    [anon_sym_u32] = ACTIONS(2256),
    [anon_sym_i32] = ACTIONS(2256),
    [anon_sym_u64] = ACTIONS(2256),
    [anon_sym_i64] = ACTIONS(2256),
    [anon_sym_u128] = ACTIONS(2256),
    [anon_sym_i128] = ACTIONS(2256),
    [anon_sym_isize] = ACTIONS(2256),
    [anon_sym_usize] = ACTIONS(2256),
    [anon_sym_f32] = ACTIONS(2256),
    [anon_sym_f64] = ACTIONS(2256),
    [anon_sym_bool] = ACTIONS(2256),
    [anon_sym_str] = ACTIONS(2256),
    [anon_sym_char] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_POUND] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_fn] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_impl] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_loop] = ACTIONS(2256),
    [anon_sym_match] = ACTIONS(2256),
    [anon_sym_mod] = ACTIONS(2256),
    [anon_sym_pub] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_trait] = ACTIONS(2256),
    [anon_sym_type] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_unsafe] = ACTIONS(2256),
    [anon_sym_use] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_move] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [sym_integer_literal] = ACTIONS(2254),
    [aux_sym_string_literal_token1] = ACTIONS(2254),
    [sym_char_literal] = ACTIONS(2254),
    [anon_sym_true] = ACTIONS(2256),
    [anon_sym_false] = ACTIONS(2256),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2256),
    [sym_super] = ACTIONS(2256),
    [sym_crate] = ACTIONS(2256),
    [sym_metavariable] = ACTIONS(2254),
    [sym__raw_string_literal_start] = ACTIONS(2254),
    [sym_float_literal] = ACTIONS(2254),
  },
  [601] = {
    [sym_line_comment] = STATE(601),
    [sym_block_comment] = STATE(601),
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_macro_rules_BANG] = ACTIONS(2258),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_u8] = ACTIONS(2260),
    [anon_sym_i8] = ACTIONS(2260),
    [anon_sym_u16] = ACTIONS(2260),
    [anon_sym_i16] = ACTIONS(2260),
    [anon_sym_u32] = ACTIONS(2260),
    [anon_sym_i32] = ACTIONS(2260),
    [anon_sym_u64] = ACTIONS(2260),
    [anon_sym_i64] = ACTIONS(2260),
    [anon_sym_u128] = ACTIONS(2260),
    [anon_sym_i128] = ACTIONS(2260),
    [anon_sym_isize] = ACTIONS(2260),
    [anon_sym_usize] = ACTIONS(2260),
    [anon_sym_f32] = ACTIONS(2260),
    [anon_sym_f64] = ACTIONS(2260),
    [anon_sym_bool] = ACTIONS(2260),
    [anon_sym_str] = ACTIONS(2260),
    [anon_sym_char] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_fn] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_impl] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_loop] = ACTIONS(2260),
    [anon_sym_match] = ACTIONS(2260),
    [anon_sym_mod] = ACTIONS(2260),
    [anon_sym_pub] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_trait] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_unsafe] = ACTIONS(2260),
    [anon_sym_use] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_move] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [sym_integer_literal] = ACTIONS(2258),
    [aux_sym_string_literal_token1] = ACTIONS(2258),
    [sym_char_literal] = ACTIONS(2258),
    [anon_sym_true] = ACTIONS(2260),
    [anon_sym_false] = ACTIONS(2260),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_crate] = ACTIONS(2260),
    [sym_metavariable] = ACTIONS(2258),
    [sym__raw_string_literal_start] = ACTIONS(2258),
    [sym_float_literal] = ACTIONS(2258),
  },
  [602] = {
    [sym_line_comment] = STATE(602),
    [sym_block_comment] = STATE(602),
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_macro_rules_BANG] = ACTIONS(2262),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_u8] = ACTIONS(2264),
    [anon_sym_i8] = ACTIONS(2264),
    [anon_sym_u16] = ACTIONS(2264),
    [anon_sym_i16] = ACTIONS(2264),
    [anon_sym_u32] = ACTIONS(2264),
    [anon_sym_i32] = ACTIONS(2264),
    [anon_sym_u64] = ACTIONS(2264),
    [anon_sym_i64] = ACTIONS(2264),
    [anon_sym_u128] = ACTIONS(2264),
    [anon_sym_i128] = ACTIONS(2264),
    [anon_sym_isize] = ACTIONS(2264),
    [anon_sym_usize] = ACTIONS(2264),
    [anon_sym_f32] = ACTIONS(2264),
    [anon_sym_f64] = ACTIONS(2264),
    [anon_sym_bool] = ACTIONS(2264),
    [anon_sym_str] = ACTIONS(2264),
    [anon_sym_char] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_POUND] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_fn] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_impl] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_loop] = ACTIONS(2264),
    [anon_sym_match] = ACTIONS(2264),
    [anon_sym_mod] = ACTIONS(2264),
    [anon_sym_pub] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_trait] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_unsafe] = ACTIONS(2264),
    [anon_sym_use] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_move] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [sym_integer_literal] = ACTIONS(2262),
    [aux_sym_string_literal_token1] = ACTIONS(2262),
    [sym_char_literal] = ACTIONS(2262),
    [anon_sym_true] = ACTIONS(2264),
    [anon_sym_false] = ACTIONS(2264),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_crate] = ACTIONS(2264),
    [sym_metavariable] = ACTIONS(2262),
    [sym__raw_string_literal_start] = ACTIONS(2262),
    [sym_float_literal] = ACTIONS(2262),
  },
  [603] = {
    [sym_line_comment] = STATE(603),
    [sym_block_comment] = STATE(603),
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym_macro_rules_BANG] = ACTIONS(2266),
    [anon_sym_LPAREN] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_u8] = ACTIONS(2268),
    [anon_sym_i8] = ACTIONS(2268),
    [anon_sym_u16] = ACTIONS(2268),
    [anon_sym_i16] = ACTIONS(2268),
    [anon_sym_u32] = ACTIONS(2268),
    [anon_sym_i32] = ACTIONS(2268),
    [anon_sym_u64] = ACTIONS(2268),
    [anon_sym_i64] = ACTIONS(2268),
    [anon_sym_u128] = ACTIONS(2268),
    [anon_sym_i128] = ACTIONS(2268),
    [anon_sym_isize] = ACTIONS(2268),
    [anon_sym_usize] = ACTIONS(2268),
    [anon_sym_f32] = ACTIONS(2268),
    [anon_sym_f64] = ACTIONS(2268),
    [anon_sym_bool] = ACTIONS(2268),
    [anon_sym_str] = ACTIONS(2268),
    [anon_sym_char] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_POUND] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2268),
    [anon_sym_async] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_fn] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_impl] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_loop] = ACTIONS(2268),
    [anon_sym_match] = ACTIONS(2268),
    [anon_sym_mod] = ACTIONS(2268),
    [anon_sym_pub] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_trait] = ACTIONS(2268),
    [anon_sym_type] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_unsafe] = ACTIONS(2268),
    [anon_sym_use] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym_yield] = ACTIONS(2268),
    [anon_sym_move] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [sym_integer_literal] = ACTIONS(2266),
    [aux_sym_string_literal_token1] = ACTIONS(2266),
    [sym_char_literal] = ACTIONS(2266),
    [anon_sym_true] = ACTIONS(2268),
    [anon_sym_false] = ACTIONS(2268),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2268),
    [sym_super] = ACTIONS(2268),
    [sym_crate] = ACTIONS(2268),
    [sym_metavariable] = ACTIONS(2266),
    [sym__raw_string_literal_start] = ACTIONS(2266),
    [sym_float_literal] = ACTIONS(2266),
  },
  [604] = {
    [sym_line_comment] = STATE(604),
    [sym_block_comment] = STATE(604),
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_macro_rules_BANG] = ACTIONS(2270),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_u8] = ACTIONS(2272),
    [anon_sym_i8] = ACTIONS(2272),
    [anon_sym_u16] = ACTIONS(2272),
    [anon_sym_i16] = ACTIONS(2272),
    [anon_sym_u32] = ACTIONS(2272),
    [anon_sym_i32] = ACTIONS(2272),
    [anon_sym_u64] = ACTIONS(2272),
    [anon_sym_i64] = ACTIONS(2272),
    [anon_sym_u128] = ACTIONS(2272),
    [anon_sym_i128] = ACTIONS(2272),
    [anon_sym_isize] = ACTIONS(2272),
    [anon_sym_usize] = ACTIONS(2272),
    [anon_sym_f32] = ACTIONS(2272),
    [anon_sym_f64] = ACTIONS(2272),
    [anon_sym_bool] = ACTIONS(2272),
    [anon_sym_str] = ACTIONS(2272),
    [anon_sym_char] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_POUND] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_fn] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_impl] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_loop] = ACTIONS(2272),
    [anon_sym_match] = ACTIONS(2272),
    [anon_sym_mod] = ACTIONS(2272),
    [anon_sym_pub] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_trait] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_unsafe] = ACTIONS(2272),
    [anon_sym_use] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_move] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [sym_integer_literal] = ACTIONS(2270),
    [aux_sym_string_literal_token1] = ACTIONS(2270),
    [sym_char_literal] = ACTIONS(2270),
    [anon_sym_true] = ACTIONS(2272),
    [anon_sym_false] = ACTIONS(2272),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_crate] = ACTIONS(2272),
    [sym_metavariable] = ACTIONS(2270),
    [sym__raw_string_literal_start] = ACTIONS(2270),
    [sym_float_literal] = ACTIONS(2270),
  },
  [605] = {
    [sym_line_comment] = STATE(605),
    [sym_block_comment] = STATE(605),
    [ts_builtin_sym_end] = ACTIONS(1422),
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1422),
    [anon_sym_macro_rules_BANG] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_u8] = ACTIONS(1424),
    [anon_sym_i8] = ACTIONS(1424),
    [anon_sym_u16] = ACTIONS(1424),
    [anon_sym_i16] = ACTIONS(1424),
    [anon_sym_u32] = ACTIONS(1424),
    [anon_sym_i32] = ACTIONS(1424),
    [anon_sym_u64] = ACTIONS(1424),
    [anon_sym_i64] = ACTIONS(1424),
    [anon_sym_u128] = ACTIONS(1424),
    [anon_sym_i128] = ACTIONS(1424),
    [anon_sym_isize] = ACTIONS(1424),
    [anon_sym_usize] = ACTIONS(1424),
    [anon_sym_f32] = ACTIONS(1424),
    [anon_sym_f64] = ACTIONS(1424),
    [anon_sym_bool] = ACTIONS(1424),
    [anon_sym_str] = ACTIONS(1424),
    [anon_sym_char] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_DOT_DOT] = ACTIONS(1422),
    [anon_sym_COLON_COLON] = ACTIONS(1422),
    [anon_sym_POUND] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_break] = ACTIONS(1424),
    [anon_sym_const] = ACTIONS(1424),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_default] = ACTIONS(1424),
    [anon_sym_enum] = ACTIONS(1424),
    [anon_sym_fn] = ACTIONS(1424),
    [anon_sym_for] = ACTIONS(1424),
    [anon_sym_if] = ACTIONS(1424),
    [anon_sym_impl] = ACTIONS(1424),
    [anon_sym_let] = ACTIONS(1424),
    [anon_sym_loop] = ACTIONS(1424),
    [anon_sym_match] = ACTIONS(1424),
    [anon_sym_mod] = ACTIONS(1424),
    [anon_sym_pub] = ACTIONS(1424),
    [anon_sym_return] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_struct] = ACTIONS(1424),
    [anon_sym_trait] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1424),
    [anon_sym_union] = ACTIONS(1424),
    [anon_sym_unsafe] = ACTIONS(1424),
    [anon_sym_use] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(1424),
    [anon_sym_extern] = ACTIONS(1424),
    [anon_sym_yield] = ACTIONS(1424),
    [anon_sym_move] = ACTIONS(1424),
    [anon_sym_try] = ACTIONS(1424),
    [sym_integer_literal] = ACTIONS(1422),
    [aux_sym_string_literal_token1] = ACTIONS(1422),
    [sym_char_literal] = ACTIONS(1422),
    [anon_sym_true] = ACTIONS(1424),
    [anon_sym_false] = ACTIONS(1424),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_crate] = ACTIONS(1424),
    [sym_metavariable] = ACTIONS(1422),
    [sym__raw_string_literal_start] = ACTIONS(1422),
    [sym_float_literal] = ACTIONS(1422),
  },
  [606] = {
    [sym_line_comment] = STATE(606),
    [sym_block_comment] = STATE(606),
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_macro_rules_BANG] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_u8] = ACTIONS(2276),
    [anon_sym_i8] = ACTIONS(2276),
    [anon_sym_u16] = ACTIONS(2276),
    [anon_sym_i16] = ACTIONS(2276),
    [anon_sym_u32] = ACTIONS(2276),
    [anon_sym_i32] = ACTIONS(2276),
    [anon_sym_u64] = ACTIONS(2276),
    [anon_sym_i64] = ACTIONS(2276),
    [anon_sym_u128] = ACTIONS(2276),
    [anon_sym_i128] = ACTIONS(2276),
    [anon_sym_isize] = ACTIONS(2276),
    [anon_sym_usize] = ACTIONS(2276),
    [anon_sym_f32] = ACTIONS(2276),
    [anon_sym_f64] = ACTIONS(2276),
    [anon_sym_bool] = ACTIONS(2276),
    [anon_sym_str] = ACTIONS(2276),
    [anon_sym_char] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2274),
    [anon_sym_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_POUND] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2276),
    [anon_sym_async] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_fn] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_impl] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_loop] = ACTIONS(2276),
    [anon_sym_match] = ACTIONS(2276),
    [anon_sym_mod] = ACTIONS(2276),
    [anon_sym_pub] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_trait] = ACTIONS(2276),
    [anon_sym_type] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_unsafe] = ACTIONS(2276),
    [anon_sym_use] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym_yield] = ACTIONS(2276),
    [anon_sym_move] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [sym_integer_literal] = ACTIONS(2274),
    [aux_sym_string_literal_token1] = ACTIONS(2274),
    [sym_char_literal] = ACTIONS(2274),
    [anon_sym_true] = ACTIONS(2276),
    [anon_sym_false] = ACTIONS(2276),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2276),
    [sym_super] = ACTIONS(2276),
    [sym_crate] = ACTIONS(2276),
    [sym_metavariable] = ACTIONS(2274),
    [sym__raw_string_literal_start] = ACTIONS(2274),
    [sym_float_literal] = ACTIONS(2274),
  },
  [607] = {
    [sym_line_comment] = STATE(607),
    [sym_block_comment] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_macro_rules_BANG] = ACTIONS(2278),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_u8] = ACTIONS(2280),
    [anon_sym_i8] = ACTIONS(2280),
    [anon_sym_u16] = ACTIONS(2280),
    [anon_sym_i16] = ACTIONS(2280),
    [anon_sym_u32] = ACTIONS(2280),
    [anon_sym_i32] = ACTIONS(2280),
    [anon_sym_u64] = ACTIONS(2280),
    [anon_sym_i64] = ACTIONS(2280),
    [anon_sym_u128] = ACTIONS(2280),
    [anon_sym_i128] = ACTIONS(2280),
    [anon_sym_isize] = ACTIONS(2280),
    [anon_sym_usize] = ACTIONS(2280),
    [anon_sym_f32] = ACTIONS(2280),
    [anon_sym_f64] = ACTIONS(2280),
    [anon_sym_bool] = ACTIONS(2280),
    [anon_sym_str] = ACTIONS(2280),
    [anon_sym_char] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_POUND] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_fn] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_impl] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_loop] = ACTIONS(2280),
    [anon_sym_match] = ACTIONS(2280),
    [anon_sym_mod] = ACTIONS(2280),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_trait] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(2280),
    [anon_sym_use] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_move] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [sym_integer_literal] = ACTIONS(2278),
    [aux_sym_string_literal_token1] = ACTIONS(2278),
    [sym_char_literal] = ACTIONS(2278),
    [anon_sym_true] = ACTIONS(2280),
    [anon_sym_false] = ACTIONS(2280),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_crate] = ACTIONS(2280),
    [sym_metavariable] = ACTIONS(2278),
    [sym__raw_string_literal_start] = ACTIONS(2278),
    [sym_float_literal] = ACTIONS(2278),
  },
  [608] = {
    [sym_line_comment] = STATE(608),
    [sym_block_comment] = STATE(608),
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_macro_rules_BANG] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_u8] = ACTIONS(2284),
    [anon_sym_i8] = ACTIONS(2284),
    [anon_sym_u16] = ACTIONS(2284),
    [anon_sym_i16] = ACTIONS(2284),
    [anon_sym_u32] = ACTIONS(2284),
    [anon_sym_i32] = ACTIONS(2284),
    [anon_sym_u64] = ACTIONS(2284),
    [anon_sym_i64] = ACTIONS(2284),
    [anon_sym_u128] = ACTIONS(2284),
    [anon_sym_i128] = ACTIONS(2284),
    [anon_sym_isize] = ACTIONS(2284),
    [anon_sym_usize] = ACTIONS(2284),
    [anon_sym_f32] = ACTIONS(2284),
    [anon_sym_f64] = ACTIONS(2284),
    [anon_sym_bool] = ACTIONS(2284),
    [anon_sym_str] = ACTIONS(2284),
    [anon_sym_char] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2282),
    [anon_sym_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2284),
    [anon_sym_async] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_fn] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_impl] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_loop] = ACTIONS(2284),
    [anon_sym_match] = ACTIONS(2284),
    [anon_sym_mod] = ACTIONS(2284),
    [anon_sym_pub] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_trait] = ACTIONS(2284),
    [anon_sym_type] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_unsafe] = ACTIONS(2284),
    [anon_sym_use] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym_yield] = ACTIONS(2284),
    [anon_sym_move] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [sym_integer_literal] = ACTIONS(2282),
    [aux_sym_string_literal_token1] = ACTIONS(2282),
    [sym_char_literal] = ACTIONS(2282),
    [anon_sym_true] = ACTIONS(2284),
    [anon_sym_false] = ACTIONS(2284),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2284),
    [sym_super] = ACTIONS(2284),
    [sym_crate] = ACTIONS(2284),
    [sym_metavariable] = ACTIONS(2282),
    [sym__raw_string_literal_start] = ACTIONS(2282),
    [sym_float_literal] = ACTIONS(2282),
  },
  [609] = {
    [sym_line_comment] = STATE(609),
    [sym_block_comment] = STATE(609),
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_macro_rules_BANG] = ACTIONS(2286),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_u8] = ACTIONS(2288),
    [anon_sym_i8] = ACTIONS(2288),
    [anon_sym_u16] = ACTIONS(2288),
    [anon_sym_i16] = ACTIONS(2288),
    [anon_sym_u32] = ACTIONS(2288),
    [anon_sym_i32] = ACTIONS(2288),
    [anon_sym_u64] = ACTIONS(2288),
    [anon_sym_i64] = ACTIONS(2288),
    [anon_sym_u128] = ACTIONS(2288),
    [anon_sym_i128] = ACTIONS(2288),
    [anon_sym_isize] = ACTIONS(2288),
    [anon_sym_usize] = ACTIONS(2288),
    [anon_sym_f32] = ACTIONS(2288),
    [anon_sym_f64] = ACTIONS(2288),
    [anon_sym_bool] = ACTIONS(2288),
    [anon_sym_str] = ACTIONS(2288),
    [anon_sym_char] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_POUND] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_fn] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_impl] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_loop] = ACTIONS(2288),
    [anon_sym_match] = ACTIONS(2288),
    [anon_sym_mod] = ACTIONS(2288),
    [anon_sym_pub] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_trait] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_unsafe] = ACTIONS(2288),
    [anon_sym_use] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_move] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [sym_integer_literal] = ACTIONS(2286),
    [aux_sym_string_literal_token1] = ACTIONS(2286),
    [sym_char_literal] = ACTIONS(2286),
    [anon_sym_true] = ACTIONS(2288),
    [anon_sym_false] = ACTIONS(2288),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_crate] = ACTIONS(2288),
    [sym_metavariable] = ACTIONS(2286),
    [sym__raw_string_literal_start] = ACTIONS(2286),
    [sym_float_literal] = ACTIONS(2286),
  },
  [610] = {
    [sym_line_comment] = STATE(610),
    [sym_block_comment] = STATE(610),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_macro_rules_BANG] = ACTIONS(2290),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_u8] = ACTIONS(2292),
    [anon_sym_i8] = ACTIONS(2292),
    [anon_sym_u16] = ACTIONS(2292),
    [anon_sym_i16] = ACTIONS(2292),
    [anon_sym_u32] = ACTIONS(2292),
    [anon_sym_i32] = ACTIONS(2292),
    [anon_sym_u64] = ACTIONS(2292),
    [anon_sym_i64] = ACTIONS(2292),
    [anon_sym_u128] = ACTIONS(2292),
    [anon_sym_i128] = ACTIONS(2292),
    [anon_sym_isize] = ACTIONS(2292),
    [anon_sym_usize] = ACTIONS(2292),
    [anon_sym_f32] = ACTIONS(2292),
    [anon_sym_f64] = ACTIONS(2292),
    [anon_sym_bool] = ACTIONS(2292),
    [anon_sym_str] = ACTIONS(2292),
    [anon_sym_char] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_POUND] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_fn] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_impl] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_loop] = ACTIONS(2292),
    [anon_sym_match] = ACTIONS(2292),
    [anon_sym_mod] = ACTIONS(2292),
    [anon_sym_pub] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_trait] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_unsafe] = ACTIONS(2292),
    [anon_sym_use] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_move] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [sym_integer_literal] = ACTIONS(2290),
    [aux_sym_string_literal_token1] = ACTIONS(2290),
    [sym_char_literal] = ACTIONS(2290),
    [anon_sym_true] = ACTIONS(2292),
    [anon_sym_false] = ACTIONS(2292),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_crate] = ACTIONS(2292),
    [sym_metavariable] = ACTIONS(2290),
    [sym__raw_string_literal_start] = ACTIONS(2290),
    [sym_float_literal] = ACTIONS(2290),
  },
  [611] = {
    [sym_line_comment] = STATE(611),
    [sym_block_comment] = STATE(611),
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_macro_rules_BANG] = ACTIONS(2294),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_u8] = ACTIONS(2296),
    [anon_sym_i8] = ACTIONS(2296),
    [anon_sym_u16] = ACTIONS(2296),
    [anon_sym_i16] = ACTIONS(2296),
    [anon_sym_u32] = ACTIONS(2296),
    [anon_sym_i32] = ACTIONS(2296),
    [anon_sym_u64] = ACTIONS(2296),
    [anon_sym_i64] = ACTIONS(2296),
    [anon_sym_u128] = ACTIONS(2296),
    [anon_sym_i128] = ACTIONS(2296),
    [anon_sym_isize] = ACTIONS(2296),
    [anon_sym_usize] = ACTIONS(2296),
    [anon_sym_f32] = ACTIONS(2296),
    [anon_sym_f64] = ACTIONS(2296),
    [anon_sym_bool] = ACTIONS(2296),
    [anon_sym_str] = ACTIONS(2296),
    [anon_sym_char] = ACTIONS(2296),
    [anon_sym_DASH] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2294),
    [anon_sym_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_POUND] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2296),
    [anon_sym_async] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_fn] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_impl] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_loop] = ACTIONS(2296),
    [anon_sym_match] = ACTIONS(2296),
    [anon_sym_mod] = ACTIONS(2296),
    [anon_sym_pub] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_trait] = ACTIONS(2296),
    [anon_sym_type] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_unsafe] = ACTIONS(2296),
    [anon_sym_use] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym_yield] = ACTIONS(2296),
    [anon_sym_move] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [sym_integer_literal] = ACTIONS(2294),
    [aux_sym_string_literal_token1] = ACTIONS(2294),
    [sym_char_literal] = ACTIONS(2294),
    [anon_sym_true] = ACTIONS(2296),
    [anon_sym_false] = ACTIONS(2296),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2296),
    [sym_super] = ACTIONS(2296),
    [sym_crate] = ACTIONS(2296),
    [sym_metavariable] = ACTIONS(2294),
    [sym__raw_string_literal_start] = ACTIONS(2294),
    [sym_float_literal] = ACTIONS(2294),
  },
  [612] = {
    [sym_line_comment] = STATE(612),
    [sym_block_comment] = STATE(612),
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym_macro_rules_BANG] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_u8] = ACTIONS(2300),
    [anon_sym_i8] = ACTIONS(2300),
    [anon_sym_u16] = ACTIONS(2300),
    [anon_sym_i16] = ACTIONS(2300),
    [anon_sym_u32] = ACTIONS(2300),
    [anon_sym_i32] = ACTIONS(2300),
    [anon_sym_u64] = ACTIONS(2300),
    [anon_sym_i64] = ACTIONS(2300),
    [anon_sym_u128] = ACTIONS(2300),
    [anon_sym_i128] = ACTIONS(2300),
    [anon_sym_isize] = ACTIONS(2300),
    [anon_sym_usize] = ACTIONS(2300),
    [anon_sym_f32] = ACTIONS(2300),
    [anon_sym_f64] = ACTIONS(2300),
    [anon_sym_bool] = ACTIONS(2300),
    [anon_sym_str] = ACTIONS(2300),
    [anon_sym_char] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2298),
    [anon_sym_LT] = ACTIONS(2298),
    [anon_sym_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_POUND] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_fn] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_impl] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_loop] = ACTIONS(2300),
    [anon_sym_match] = ACTIONS(2300),
    [anon_sym_mod] = ACTIONS(2300),
    [anon_sym_pub] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_trait] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_unsafe] = ACTIONS(2300),
    [anon_sym_use] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_move] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [sym_integer_literal] = ACTIONS(2298),
    [aux_sym_string_literal_token1] = ACTIONS(2298),
    [sym_char_literal] = ACTIONS(2298),
    [anon_sym_true] = ACTIONS(2300),
    [anon_sym_false] = ACTIONS(2300),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_crate] = ACTIONS(2300),
    [sym_metavariable] = ACTIONS(2298),
    [sym__raw_string_literal_start] = ACTIONS(2298),
    [sym_float_literal] = ACTIONS(2298),
  },
  [613] = {
    [sym_line_comment] = STATE(613),
    [sym_block_comment] = STATE(613),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym_macro_rules_BANG] = ACTIONS(2302),
    [anon_sym_LPAREN] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_u8] = ACTIONS(2304),
    [anon_sym_i8] = ACTIONS(2304),
    [anon_sym_u16] = ACTIONS(2304),
    [anon_sym_i16] = ACTIONS(2304),
    [anon_sym_u32] = ACTIONS(2304),
    [anon_sym_i32] = ACTIONS(2304),
    [anon_sym_u64] = ACTIONS(2304),
    [anon_sym_i64] = ACTIONS(2304),
    [anon_sym_u128] = ACTIONS(2304),
    [anon_sym_i128] = ACTIONS(2304),
    [anon_sym_isize] = ACTIONS(2304),
    [anon_sym_usize] = ACTIONS(2304),
    [anon_sym_f32] = ACTIONS(2304),
    [anon_sym_f64] = ACTIONS(2304),
    [anon_sym_bool] = ACTIONS(2304),
    [anon_sym_str] = ACTIONS(2304),
    [anon_sym_char] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2302),
    [anon_sym_LT] = ACTIONS(2302),
    [anon_sym_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_POUND] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_fn] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_impl] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_loop] = ACTIONS(2304),
    [anon_sym_match] = ACTIONS(2304),
    [anon_sym_mod] = ACTIONS(2304),
    [anon_sym_pub] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_trait] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_unsafe] = ACTIONS(2304),
    [anon_sym_use] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_move] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [sym_integer_literal] = ACTIONS(2302),
    [aux_sym_string_literal_token1] = ACTIONS(2302),
    [sym_char_literal] = ACTIONS(2302),
    [anon_sym_true] = ACTIONS(2304),
    [anon_sym_false] = ACTIONS(2304),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_crate] = ACTIONS(2304),
    [sym_metavariable] = ACTIONS(2302),
    [sym__raw_string_literal_start] = ACTIONS(2302),
    [sym_float_literal] = ACTIONS(2302),
  },
  [614] = {
    [sym_line_comment] = STATE(614),
    [sym_block_comment] = STATE(614),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym_macro_rules_BANG] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_u8] = ACTIONS(2308),
    [anon_sym_i8] = ACTIONS(2308),
    [anon_sym_u16] = ACTIONS(2308),
    [anon_sym_i16] = ACTIONS(2308),
    [anon_sym_u32] = ACTIONS(2308),
    [anon_sym_i32] = ACTIONS(2308),
    [anon_sym_u64] = ACTIONS(2308),
    [anon_sym_i64] = ACTIONS(2308),
    [anon_sym_u128] = ACTIONS(2308),
    [anon_sym_i128] = ACTIONS(2308),
    [anon_sym_isize] = ACTIONS(2308),
    [anon_sym_usize] = ACTIONS(2308),
    [anon_sym_f32] = ACTIONS(2308),
    [anon_sym_f64] = ACTIONS(2308),
    [anon_sym_bool] = ACTIONS(2308),
    [anon_sym_str] = ACTIONS(2308),
    [anon_sym_char] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2306),
    [anon_sym_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_POUND] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_fn] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_impl] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_loop] = ACTIONS(2308),
    [anon_sym_match] = ACTIONS(2308),
    [anon_sym_mod] = ACTIONS(2308),
    [anon_sym_pub] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_trait] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_unsafe] = ACTIONS(2308),
    [anon_sym_use] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_move] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [sym_integer_literal] = ACTIONS(2306),
    [aux_sym_string_literal_token1] = ACTIONS(2306),
    [sym_char_literal] = ACTIONS(2306),
    [anon_sym_true] = ACTIONS(2308),
    [anon_sym_false] = ACTIONS(2308),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_crate] = ACTIONS(2308),
    [sym_metavariable] = ACTIONS(2306),
    [sym__raw_string_literal_start] = ACTIONS(2306),
    [sym_float_literal] = ACTIONS(2306),
  },
  [615] = {
    [sym_line_comment] = STATE(615),
    [sym_block_comment] = STATE(615),
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_macro_rules_BANG] = ACTIONS(2310),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_u8] = ACTIONS(2312),
    [anon_sym_i8] = ACTIONS(2312),
    [anon_sym_u16] = ACTIONS(2312),
    [anon_sym_i16] = ACTIONS(2312),
    [anon_sym_u32] = ACTIONS(2312),
    [anon_sym_i32] = ACTIONS(2312),
    [anon_sym_u64] = ACTIONS(2312),
    [anon_sym_i64] = ACTIONS(2312),
    [anon_sym_u128] = ACTIONS(2312),
    [anon_sym_i128] = ACTIONS(2312),
    [anon_sym_isize] = ACTIONS(2312),
    [anon_sym_usize] = ACTIONS(2312),
    [anon_sym_f32] = ACTIONS(2312),
    [anon_sym_f64] = ACTIONS(2312),
    [anon_sym_bool] = ACTIONS(2312),
    [anon_sym_str] = ACTIONS(2312),
    [anon_sym_char] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2310),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_POUND] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_fn] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_impl] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_loop] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_mod] = ACTIONS(2312),
    [anon_sym_pub] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_trait] = ACTIONS(2312),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_unsafe] = ACTIONS(2312),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_move] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [sym_integer_literal] = ACTIONS(2310),
    [aux_sym_string_literal_token1] = ACTIONS(2310),
    [sym_char_literal] = ACTIONS(2310),
    [anon_sym_true] = ACTIONS(2312),
    [anon_sym_false] = ACTIONS(2312),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2312),
    [sym_super] = ACTIONS(2312),
    [sym_crate] = ACTIONS(2312),
    [sym_metavariable] = ACTIONS(2310),
    [sym__raw_string_literal_start] = ACTIONS(2310),
    [sym_float_literal] = ACTIONS(2310),
  },
  [616] = {
    [sym_line_comment] = STATE(616),
    [sym_block_comment] = STATE(616),
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_macro_rules_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_u8] = ACTIONS(2316),
    [anon_sym_i8] = ACTIONS(2316),
    [anon_sym_u16] = ACTIONS(2316),
    [anon_sym_i16] = ACTIONS(2316),
    [anon_sym_u32] = ACTIONS(2316),
    [anon_sym_i32] = ACTIONS(2316),
    [anon_sym_u64] = ACTIONS(2316),
    [anon_sym_i64] = ACTIONS(2316),
    [anon_sym_u128] = ACTIONS(2316),
    [anon_sym_i128] = ACTIONS(2316),
    [anon_sym_isize] = ACTIONS(2316),
    [anon_sym_usize] = ACTIONS(2316),
    [anon_sym_f32] = ACTIONS(2316),
    [anon_sym_f64] = ACTIONS(2316),
    [anon_sym_bool] = ACTIONS(2316),
    [anon_sym_str] = ACTIONS(2316),
    [anon_sym_char] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_POUND] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_async] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
    [anon_sym_fn] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_impl] = ACTIONS(2316),
    [anon_sym_let] = ACTIONS(2316),
    [anon_sym_loop] = ACTIONS(2316),
    [anon_sym_match] = ACTIONS(2316),
    [anon_sym_mod] = ACTIONS(2316),
    [anon_sym_pub] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_struct] = ACTIONS(2316),
    [anon_sym_trait] = ACTIONS(2316),
    [anon_sym_type] = ACTIONS(2316),
    [anon_sym_union] = ACTIONS(2316),
    [anon_sym_unsafe] = ACTIONS(2316),
    [anon_sym_use] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_extern] = ACTIONS(2316),
    [anon_sym_yield] = ACTIONS(2316),
    [anon_sym_move] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [sym_integer_literal] = ACTIONS(2314),
    [aux_sym_string_literal_token1] = ACTIONS(2314),
    [sym_char_literal] = ACTIONS(2314),
    [anon_sym_true] = ACTIONS(2316),
    [anon_sym_false] = ACTIONS(2316),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2316),
    [sym_super] = ACTIONS(2316),
    [sym_crate] = ACTIONS(2316),
    [sym_metavariable] = ACTIONS(2314),
    [sym__raw_string_literal_start] = ACTIONS(2314),
    [sym_float_literal] = ACTIONS(2314),
  },
  [617] = {
    [sym_line_comment] = STATE(617),
    [sym_block_comment] = STATE(617),
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_macro_rules_BANG] = ACTIONS(2318),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_u8] = ACTIONS(2320),
    [anon_sym_i8] = ACTIONS(2320),
    [anon_sym_u16] = ACTIONS(2320),
    [anon_sym_i16] = ACTIONS(2320),
    [anon_sym_u32] = ACTIONS(2320),
    [anon_sym_i32] = ACTIONS(2320),
    [anon_sym_u64] = ACTIONS(2320),
    [anon_sym_i64] = ACTIONS(2320),
    [anon_sym_u128] = ACTIONS(2320),
    [anon_sym_i128] = ACTIONS(2320),
    [anon_sym_isize] = ACTIONS(2320),
    [anon_sym_usize] = ACTIONS(2320),
    [anon_sym_f32] = ACTIONS(2320),
    [anon_sym_f64] = ACTIONS(2320),
    [anon_sym_bool] = ACTIONS(2320),
    [anon_sym_str] = ACTIONS(2320),
    [anon_sym_char] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2318),
    [anon_sym_PIPE] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_DOT_DOT] = ACTIONS(2318),
    [anon_sym_COLON_COLON] = ACTIONS(2318),
    [anon_sym_POUND] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
    [anon_sym_fn] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_impl] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_loop] = ACTIONS(2320),
    [anon_sym_match] = ACTIONS(2320),
    [anon_sym_mod] = ACTIONS(2320),
    [anon_sym_pub] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_struct] = ACTIONS(2320),
    [anon_sym_trait] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_union] = ACTIONS(2320),
    [anon_sym_unsafe] = ACTIONS(2320),
    [anon_sym_use] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_extern] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_move] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [sym_integer_literal] = ACTIONS(2318),
    [aux_sym_string_literal_token1] = ACTIONS(2318),
    [sym_char_literal] = ACTIONS(2318),
    [anon_sym_true] = ACTIONS(2320),
    [anon_sym_false] = ACTIONS(2320),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_crate] = ACTIONS(2320),
    [sym_metavariable] = ACTIONS(2318),
    [sym__raw_string_literal_start] = ACTIONS(2318),
    [sym_float_literal] = ACTIONS(2318),
  },
  [618] = {
    [sym_line_comment] = STATE(618),
    [sym_block_comment] = STATE(618),
    [ts_builtin_sym_end] = ACTIONS(2322),
    [sym_identifier] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_macro_rules_BANG] = ACTIONS(2322),
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2322),
    [anon_sym_u8] = ACTIONS(2324),
    [anon_sym_i8] = ACTIONS(2324),
    [anon_sym_u16] = ACTIONS(2324),
    [anon_sym_i16] = ACTIONS(2324),
    [anon_sym_u32] = ACTIONS(2324),
    [anon_sym_i32] = ACTIONS(2324),
    [anon_sym_u64] = ACTIONS(2324),
    [anon_sym_i64] = ACTIONS(2324),
    [anon_sym_u128] = ACTIONS(2324),
    [anon_sym_i128] = ACTIONS(2324),
    [anon_sym_isize] = ACTIONS(2324),
    [anon_sym_usize] = ACTIONS(2324),
    [anon_sym_f32] = ACTIONS(2324),
    [anon_sym_f64] = ACTIONS(2324),
    [anon_sym_bool] = ACTIONS(2324),
    [anon_sym_str] = ACTIONS(2324),
    [anon_sym_char] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_PIPE] = ACTIONS(2322),
    [anon_sym_LT] = ACTIONS(2322),
    [anon_sym_DOT_DOT] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2322),
    [anon_sym_POUND] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_async] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
    [anon_sym_fn] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_impl] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(2324),
    [anon_sym_loop] = ACTIONS(2324),
    [anon_sym_match] = ACTIONS(2324),
    [anon_sym_mod] = ACTIONS(2324),
    [anon_sym_pub] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_struct] = ACTIONS(2324),
    [anon_sym_trait] = ACTIONS(2324),
    [anon_sym_type] = ACTIONS(2324),
    [anon_sym_union] = ACTIONS(2324),
    [anon_sym_unsafe] = ACTIONS(2324),
    [anon_sym_use] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_extern] = ACTIONS(2324),
    [anon_sym_yield] = ACTIONS(2324),
    [anon_sym_move] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2324),
    [sym_integer_literal] = ACTIONS(2322),
    [aux_sym_string_literal_token1] = ACTIONS(2322),
    [sym_char_literal] = ACTIONS(2322),
    [anon_sym_true] = ACTIONS(2324),
    [anon_sym_false] = ACTIONS(2324),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2324),
    [sym_super] = ACTIONS(2324),
    [sym_crate] = ACTIONS(2324),
    [sym_metavariable] = ACTIONS(2322),
    [sym__raw_string_literal_start] = ACTIONS(2322),
    [sym_float_literal] = ACTIONS(2322),
  },
  [619] = {
    [sym_line_comment] = STATE(619),
    [sym_block_comment] = STATE(619),
    [ts_builtin_sym_end] = ACTIONS(2326),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(2326),
    [anon_sym_macro_rules_BANG] = ACTIONS(2326),
    [anon_sym_LPAREN] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_RBRACE] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2326),
    [anon_sym_u8] = ACTIONS(2328),
    [anon_sym_i8] = ACTIONS(2328),
    [anon_sym_u16] = ACTIONS(2328),
    [anon_sym_i16] = ACTIONS(2328),
    [anon_sym_u32] = ACTIONS(2328),
    [anon_sym_i32] = ACTIONS(2328),
    [anon_sym_u64] = ACTIONS(2328),
    [anon_sym_i64] = ACTIONS(2328),
    [anon_sym_u128] = ACTIONS(2328),
    [anon_sym_i128] = ACTIONS(2328),
    [anon_sym_isize] = ACTIONS(2328),
    [anon_sym_usize] = ACTIONS(2328),
    [anon_sym_f32] = ACTIONS(2328),
    [anon_sym_f64] = ACTIONS(2328),
    [anon_sym_bool] = ACTIONS(2328),
    [anon_sym_str] = ACTIONS(2328),
    [anon_sym_char] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_BANG] = ACTIONS(2326),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_PIPE] = ACTIONS(2326),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2326),
    [anon_sym_POUND] = ACTIONS(2326),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_async] = ACTIONS(2328),
    [anon_sym_break] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(2328),
    [anon_sym_continue] = ACTIONS(2328),
    [anon_sym_default] = ACTIONS(2328),
    [anon_sym_enum] = ACTIONS(2328),
    [anon_sym_fn] = ACTIONS(2328),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_impl] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_loop] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_mod] = ACTIONS(2328),
    [anon_sym_pub] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(2328),
    [anon_sym_struct] = ACTIONS(2328),
    [anon_sym_trait] = ACTIONS(2328),
    [anon_sym_type] = ACTIONS(2328),
    [anon_sym_union] = ACTIONS(2328),
    [anon_sym_unsafe] = ACTIONS(2328),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_extern] = ACTIONS(2328),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_move] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [sym_integer_literal] = ACTIONS(2326),
    [aux_sym_string_literal_token1] = ACTIONS(2326),
    [sym_char_literal] = ACTIONS(2326),
    [anon_sym_true] = ACTIONS(2328),
    [anon_sym_false] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2328),
    [sym_super] = ACTIONS(2328),
    [sym_crate] = ACTIONS(2328),
    [sym_metavariable] = ACTIONS(2326),
    [sym__raw_string_literal_start] = ACTIONS(2326),
    [sym_float_literal] = ACTIONS(2326),
  },
  [620] = {
    [sym_line_comment] = STATE(620),
    [sym_block_comment] = STATE(620),
    [ts_builtin_sym_end] = ACTIONS(2330),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_SEMI] = ACTIONS(2330),
    [anon_sym_macro_rules_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2330),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2330),
    [anon_sym_u8] = ACTIONS(2332),
    [anon_sym_i8] = ACTIONS(2332),
    [anon_sym_u16] = ACTIONS(2332),
    [anon_sym_i16] = ACTIONS(2332),
    [anon_sym_u32] = ACTIONS(2332),
    [anon_sym_i32] = ACTIONS(2332),
    [anon_sym_u64] = ACTIONS(2332),
    [anon_sym_i64] = ACTIONS(2332),
    [anon_sym_u128] = ACTIONS(2332),
    [anon_sym_i128] = ACTIONS(2332),
    [anon_sym_isize] = ACTIONS(2332),
    [anon_sym_usize] = ACTIONS(2332),
    [anon_sym_f32] = ACTIONS(2332),
    [anon_sym_f64] = ACTIONS(2332),
    [anon_sym_bool] = ACTIONS(2332),
    [anon_sym_str] = ACTIONS(2332),
    [anon_sym_char] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_BANG] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_PIPE] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_DOT_DOT] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(2330),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_async] = ACTIONS(2332),
    [anon_sym_break] = ACTIONS(2332),
    [anon_sym_const] = ACTIONS(2332),
    [anon_sym_continue] = ACTIONS(2332),
    [anon_sym_default] = ACTIONS(2332),
    [anon_sym_enum] = ACTIONS(2332),
    [anon_sym_fn] = ACTIONS(2332),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_impl] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_loop] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_mod] = ACTIONS(2332),
    [anon_sym_pub] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_static] = ACTIONS(2332),
    [anon_sym_struct] = ACTIONS(2332),
    [anon_sym_trait] = ACTIONS(2332),
    [anon_sym_type] = ACTIONS(2332),
    [anon_sym_union] = ACTIONS(2332),
    [anon_sym_unsafe] = ACTIONS(2332),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_extern] = ACTIONS(2332),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_move] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [sym_integer_literal] = ACTIONS(2330),
    [aux_sym_string_literal_token1] = ACTIONS(2330),
    [sym_char_literal] = ACTIONS(2330),
    [anon_sym_true] = ACTIONS(2332),
    [anon_sym_false] = ACTIONS(2332),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2332),
    [sym_super] = ACTIONS(2332),
    [sym_crate] = ACTIONS(2332),
    [sym_metavariable] = ACTIONS(2330),
    [sym__raw_string_literal_start] = ACTIONS(2330),
    [sym_float_literal] = ACTIONS(2330),
  },
  [621] = {
    [sym_line_comment] = STATE(621),
    [sym_block_comment] = STATE(621),
    [ts_builtin_sym_end] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1240),
    [anon_sym_macro_rules_BANG] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_STAR] = ACTIONS(1240),
    [anon_sym_u8] = ACTIONS(1242),
    [anon_sym_i8] = ACTIONS(1242),
    [anon_sym_u16] = ACTIONS(1242),
    [anon_sym_i16] = ACTIONS(1242),
    [anon_sym_u32] = ACTIONS(1242),
    [anon_sym_i32] = ACTIONS(1242),
    [anon_sym_u64] = ACTIONS(1242),
    [anon_sym_i64] = ACTIONS(1242),
    [anon_sym_u128] = ACTIONS(1242),
    [anon_sym_i128] = ACTIONS(1242),
    [anon_sym_isize] = ACTIONS(1242),
    [anon_sym_usize] = ACTIONS(1242),
    [anon_sym_f32] = ACTIONS(1242),
    [anon_sym_f64] = ACTIONS(1242),
    [anon_sym_bool] = ACTIONS(1242),
    [anon_sym_str] = ACTIONS(1242),
    [anon_sym_char] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1240),
    [anon_sym_BANG] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(1240),
    [anon_sym_PIPE] = ACTIONS(1240),
    [anon_sym_LT] = ACTIONS(1240),
    [anon_sym_DOT_DOT] = ACTIONS(1240),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_break] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_continue] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [anon_sym_fn] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_impl] = ACTIONS(1242),
    [anon_sym_let] = ACTIONS(1242),
    [anon_sym_loop] = ACTIONS(1242),
    [anon_sym_match] = ACTIONS(1242),
    [anon_sym_mod] = ACTIONS(1242),
    [anon_sym_pub] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_struct] = ACTIONS(1242),
    [anon_sym_trait] = ACTIONS(1242),
    [anon_sym_type] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_unsafe] = ACTIONS(1242),
    [anon_sym_use] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(1242),
    [anon_sym_extern] = ACTIONS(1242),
    [anon_sym_yield] = ACTIONS(1242),
    [anon_sym_move] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1242),
    [sym_integer_literal] = ACTIONS(1240),
    [aux_sym_string_literal_token1] = ACTIONS(1240),
    [sym_char_literal] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1242),
    [anon_sym_false] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_crate] = ACTIONS(1242),
    [sym_metavariable] = ACTIONS(1240),
    [sym__raw_string_literal_start] = ACTIONS(1240),
    [sym_float_literal] = ACTIONS(1240),
  },
  [622] = {
    [sym_line_comment] = STATE(622),
    [sym_block_comment] = STATE(622),
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_macro_rules_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_u8] = ACTIONS(2336),
    [anon_sym_i8] = ACTIONS(2336),
    [anon_sym_u16] = ACTIONS(2336),
    [anon_sym_i16] = ACTIONS(2336),
    [anon_sym_u32] = ACTIONS(2336),
    [anon_sym_i32] = ACTIONS(2336),
    [anon_sym_u64] = ACTIONS(2336),
    [anon_sym_i64] = ACTIONS(2336),
    [anon_sym_u128] = ACTIONS(2336),
    [anon_sym_i128] = ACTIONS(2336),
    [anon_sym_isize] = ACTIONS(2336),
    [anon_sym_usize] = ACTIONS(2336),
    [anon_sym_f32] = ACTIONS(2336),
    [anon_sym_f64] = ACTIONS(2336),
    [anon_sym_bool] = ACTIONS(2336),
    [anon_sym_str] = ACTIONS(2336),
    [anon_sym_char] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_POUND] = ACTIONS(2334),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_break] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_continue] = ACTIONS(2336),
    [anon_sym_default] = ACTIONS(2336),
    [anon_sym_enum] = ACTIONS(2336),
    [anon_sym_fn] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_impl] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_loop] = ACTIONS(2336),
    [anon_sym_match] = ACTIONS(2336),
    [anon_sym_mod] = ACTIONS(2336),
    [anon_sym_pub] = ACTIONS(2336),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_struct] = ACTIONS(2336),
    [anon_sym_trait] = ACTIONS(2336),
    [anon_sym_type] = ACTIONS(2336),
    [anon_sym_union] = ACTIONS(2336),
    [anon_sym_unsafe] = ACTIONS(2336),
    [anon_sym_use] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_extern] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_move] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [sym_integer_literal] = ACTIONS(2334),
    [aux_sym_string_literal_token1] = ACTIONS(2334),
    [sym_char_literal] = ACTIONS(2334),
    [anon_sym_true] = ACTIONS(2336),
    [anon_sym_false] = ACTIONS(2336),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2336),
    [sym_super] = ACTIONS(2336),
    [sym_crate] = ACTIONS(2336),
    [sym_metavariable] = ACTIONS(2334),
    [sym__raw_string_literal_start] = ACTIONS(2334),
    [sym_float_literal] = ACTIONS(2334),
  },
  [623] = {
    [sym_line_comment] = STATE(623),
    [sym_block_comment] = STATE(623),
    [ts_builtin_sym_end] = ACTIONS(2338),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_macro_rules_BANG] = ACTIONS(2338),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2338),
    [anon_sym_u8] = ACTIONS(2340),
    [anon_sym_i8] = ACTIONS(2340),
    [anon_sym_u16] = ACTIONS(2340),
    [anon_sym_i16] = ACTIONS(2340),
    [anon_sym_u32] = ACTIONS(2340),
    [anon_sym_i32] = ACTIONS(2340),
    [anon_sym_u64] = ACTIONS(2340),
    [anon_sym_i64] = ACTIONS(2340),
    [anon_sym_u128] = ACTIONS(2340),
    [anon_sym_i128] = ACTIONS(2340),
    [anon_sym_isize] = ACTIONS(2340),
    [anon_sym_usize] = ACTIONS(2340),
    [anon_sym_f32] = ACTIONS(2340),
    [anon_sym_f64] = ACTIONS(2340),
    [anon_sym_bool] = ACTIONS(2340),
    [anon_sym_str] = ACTIONS(2340),
    [anon_sym_char] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2338),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_PIPE] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2338),
    [anon_sym_DOT_DOT] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2338),
    [anon_sym_POUND] = ACTIONS(2338),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
    [anon_sym_fn] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_impl] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_loop] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_mod] = ACTIONS(2340),
    [anon_sym_pub] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_struct] = ACTIONS(2340),
    [anon_sym_trait] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(2340),
    [anon_sym_union] = ACTIONS(2340),
    [anon_sym_unsafe] = ACTIONS(2340),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_extern] = ACTIONS(2340),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_move] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [sym_integer_literal] = ACTIONS(2338),
    [aux_sym_string_literal_token1] = ACTIONS(2338),
    [sym_char_literal] = ACTIONS(2338),
    [anon_sym_true] = ACTIONS(2340),
    [anon_sym_false] = ACTIONS(2340),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2340),
    [sym_super] = ACTIONS(2340),
    [sym_crate] = ACTIONS(2340),
    [sym_metavariable] = ACTIONS(2338),
    [sym__raw_string_literal_start] = ACTIONS(2338),
    [sym_float_literal] = ACTIONS(2338),
  },
  [624] = {
    [sym_line_comment] = STATE(624),
    [sym_block_comment] = STATE(624),
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_macro_rules_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_u8] = ACTIONS(2344),
    [anon_sym_i8] = ACTIONS(2344),
    [anon_sym_u16] = ACTIONS(2344),
    [anon_sym_i16] = ACTIONS(2344),
    [anon_sym_u32] = ACTIONS(2344),
    [anon_sym_i32] = ACTIONS(2344),
    [anon_sym_u64] = ACTIONS(2344),
    [anon_sym_i64] = ACTIONS(2344),
    [anon_sym_u128] = ACTIONS(2344),
    [anon_sym_i128] = ACTIONS(2344),
    [anon_sym_isize] = ACTIONS(2344),
    [anon_sym_usize] = ACTIONS(2344),
    [anon_sym_f32] = ACTIONS(2344),
    [anon_sym_f64] = ACTIONS(2344),
    [anon_sym_bool] = ACTIONS(2344),
    [anon_sym_str] = ACTIONS(2344),
    [anon_sym_char] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_PIPE] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_POUND] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
    [anon_sym_fn] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_impl] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_loop] = ACTIONS(2344),
    [anon_sym_match] = ACTIONS(2344),
    [anon_sym_mod] = ACTIONS(2344),
    [anon_sym_pub] = ACTIONS(2344),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_struct] = ACTIONS(2344),
    [anon_sym_trait] = ACTIONS(2344),
    [anon_sym_type] = ACTIONS(2344),
    [anon_sym_union] = ACTIONS(2344),
    [anon_sym_unsafe] = ACTIONS(2344),
    [anon_sym_use] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_extern] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_move] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [sym_integer_literal] = ACTIONS(2342),
    [aux_sym_string_literal_token1] = ACTIONS(2342),
    [sym_char_literal] = ACTIONS(2342),
    [anon_sym_true] = ACTIONS(2344),
    [anon_sym_false] = ACTIONS(2344),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2344),
    [sym_super] = ACTIONS(2344),
    [sym_crate] = ACTIONS(2344),
    [sym_metavariable] = ACTIONS(2342),
    [sym__raw_string_literal_start] = ACTIONS(2342),
    [sym_float_literal] = ACTIONS(2342),
  },
  [625] = {
    [sym_line_comment] = STATE(625),
    [sym_block_comment] = STATE(625),
    [ts_builtin_sym_end] = ACTIONS(2346),
    [sym_identifier] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_macro_rules_BANG] = ACTIONS(2346),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_STAR] = ACTIONS(2346),
    [anon_sym_u8] = ACTIONS(2348),
    [anon_sym_i8] = ACTIONS(2348),
    [anon_sym_u16] = ACTIONS(2348),
    [anon_sym_i16] = ACTIONS(2348),
    [anon_sym_u32] = ACTIONS(2348),
    [anon_sym_i32] = ACTIONS(2348),
    [anon_sym_u64] = ACTIONS(2348),
    [anon_sym_i64] = ACTIONS(2348),
    [anon_sym_u128] = ACTIONS(2348),
    [anon_sym_i128] = ACTIONS(2348),
    [anon_sym_isize] = ACTIONS(2348),
    [anon_sym_usize] = ACTIONS(2348),
    [anon_sym_f32] = ACTIONS(2348),
    [anon_sym_f64] = ACTIONS(2348),
    [anon_sym_bool] = ACTIONS(2348),
    [anon_sym_str] = ACTIONS(2348),
    [anon_sym_char] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_DOT_DOT] = ACTIONS(2346),
    [anon_sym_COLON_COLON] = ACTIONS(2346),
    [anon_sym_POUND] = ACTIONS(2346),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_fn] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_impl] = ACTIONS(2348),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_loop] = ACTIONS(2348),
    [anon_sym_match] = ACTIONS(2348),
    [anon_sym_mod] = ACTIONS(2348),
    [anon_sym_pub] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_struct] = ACTIONS(2348),
    [anon_sym_trait] = ACTIONS(2348),
    [anon_sym_type] = ACTIONS(2348),
    [anon_sym_union] = ACTIONS(2348),
    [anon_sym_unsafe] = ACTIONS(2348),
    [anon_sym_use] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(2348),
    [anon_sym_yield] = ACTIONS(2348),
    [anon_sym_move] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [sym_integer_literal] = ACTIONS(2346),
    [aux_sym_string_literal_token1] = ACTIONS(2346),
    [sym_char_literal] = ACTIONS(2346),
    [anon_sym_true] = ACTIONS(2348),
    [anon_sym_false] = ACTIONS(2348),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2348),
    [sym_super] = ACTIONS(2348),
    [sym_crate] = ACTIONS(2348),
    [sym_metavariable] = ACTIONS(2346),
    [sym__raw_string_literal_start] = ACTIONS(2346),
    [sym_float_literal] = ACTIONS(2346),
  },
  [626] = {
    [sym_line_comment] = STATE(626),
    [sym_block_comment] = STATE(626),
    [ts_builtin_sym_end] = ACTIONS(2350),
    [sym_identifier] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_macro_rules_BANG] = ACTIONS(2350),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_RBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_u8] = ACTIONS(2352),
    [anon_sym_i8] = ACTIONS(2352),
    [anon_sym_u16] = ACTIONS(2352),
    [anon_sym_i16] = ACTIONS(2352),
    [anon_sym_u32] = ACTIONS(2352),
    [anon_sym_i32] = ACTIONS(2352),
    [anon_sym_u64] = ACTIONS(2352),
    [anon_sym_i64] = ACTIONS(2352),
    [anon_sym_u128] = ACTIONS(2352),
    [anon_sym_i128] = ACTIONS(2352),
    [anon_sym_isize] = ACTIONS(2352),
    [anon_sym_usize] = ACTIONS(2352),
    [anon_sym_f32] = ACTIONS(2352),
    [anon_sym_f64] = ACTIONS(2352),
    [anon_sym_bool] = ACTIONS(2352),
    [anon_sym_str] = ACTIONS(2352),
    [anon_sym_char] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_PIPE] = ACTIONS(2350),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_DOT_DOT] = ACTIONS(2350),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_POUND] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2352),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
    [anon_sym_fn] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_impl] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2352),
    [anon_sym_loop] = ACTIONS(2352),
    [anon_sym_match] = ACTIONS(2352),
    [anon_sym_mod] = ACTIONS(2352),
    [anon_sym_pub] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_struct] = ACTIONS(2352),
    [anon_sym_trait] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2352),
    [anon_sym_union] = ACTIONS(2352),
    [anon_sym_unsafe] = ACTIONS(2352),
    [anon_sym_use] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_extern] = ACTIONS(2352),
    [anon_sym_yield] = ACTIONS(2352),
    [anon_sym_move] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [sym_integer_literal] = ACTIONS(2350),
    [aux_sym_string_literal_token1] = ACTIONS(2350),
    [sym_char_literal] = ACTIONS(2350),
    [anon_sym_true] = ACTIONS(2352),
    [anon_sym_false] = ACTIONS(2352),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2352),
    [sym_super] = ACTIONS(2352),
    [sym_crate] = ACTIONS(2352),
    [sym_metavariable] = ACTIONS(2350),
    [sym__raw_string_literal_start] = ACTIONS(2350),
    [sym_float_literal] = ACTIONS(2350),
  },
  [627] = {
    [sym_line_comment] = STATE(627),
    [sym_block_comment] = STATE(627),
    [ts_builtin_sym_end] = ACTIONS(2354),
    [sym_identifier] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_macro_rules_BANG] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_u8] = ACTIONS(2356),
    [anon_sym_i8] = ACTIONS(2356),
    [anon_sym_u16] = ACTIONS(2356),
    [anon_sym_i16] = ACTIONS(2356),
    [anon_sym_u32] = ACTIONS(2356),
    [anon_sym_i32] = ACTIONS(2356),
    [anon_sym_u64] = ACTIONS(2356),
    [anon_sym_i64] = ACTIONS(2356),
    [anon_sym_u128] = ACTIONS(2356),
    [anon_sym_i128] = ACTIONS(2356),
    [anon_sym_isize] = ACTIONS(2356),
    [anon_sym_usize] = ACTIONS(2356),
    [anon_sym_f32] = ACTIONS(2356),
    [anon_sym_f64] = ACTIONS(2356),
    [anon_sym_bool] = ACTIONS(2356),
    [anon_sym_str] = ACTIONS(2356),
    [anon_sym_char] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_DOT_DOT] = ACTIONS(2354),
    [anon_sym_COLON_COLON] = ACTIONS(2354),
    [anon_sym_POUND] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_fn] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_impl] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_loop] = ACTIONS(2356),
    [anon_sym_match] = ACTIONS(2356),
    [anon_sym_mod] = ACTIONS(2356),
    [anon_sym_pub] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_trait] = ACTIONS(2356),
    [anon_sym_type] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [anon_sym_unsafe] = ACTIONS(2356),
    [anon_sym_use] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_move] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [sym_integer_literal] = ACTIONS(2354),
    [aux_sym_string_literal_token1] = ACTIONS(2354),
    [sym_char_literal] = ACTIONS(2354),
    [anon_sym_true] = ACTIONS(2356),
    [anon_sym_false] = ACTIONS(2356),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2356),
    [sym_super] = ACTIONS(2356),
    [sym_crate] = ACTIONS(2356),
    [sym_metavariable] = ACTIONS(2354),
    [sym__raw_string_literal_start] = ACTIONS(2354),
    [sym_float_literal] = ACTIONS(2354),
  },
  [628] = {
    [sym_empty_statement] = STATE(1389),
    [sym_macro_definition] = STATE(1389),
    [sym_attribute_item] = STATE(1389),
    [sym_inner_attribute_item] = STATE(1389),
    [sym_mod_item] = STATE(1389),
    [sym_foreign_mod_item] = STATE(1389),
    [sym_struct_item] = STATE(1389),
    [sym_union_item] = STATE(1389),
    [sym_enum_item] = STATE(1389),
    [sym_extern_crate_declaration] = STATE(1389),
    [sym_const_item] = STATE(1389),
    [sym_static_item] = STATE(1389),
    [sym_type_item] = STATE(1389),
    [sym_function_item] = STATE(1389),
    [sym_function_signature_item] = STATE(1389),
    [sym_function_modifiers] = STATE(3601),
    [sym_impl_item] = STATE(1389),
    [sym_trait_item] = STATE(1389),
    [sym_associated_type] = STATE(1389),
    [sym_let_declaration] = STATE(1389),
    [sym_use_declaration] = STATE(1389),
    [sym_extern_modifier] = STATE(2140),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3312),
    [sym_generic_type_with_turbofish] = STATE(3351),
    [sym_macro_invocation] = STATE(1389),
    [sym_scoped_identifier] = STATE(3243),
    [sym_line_comment] = STATE(628),
    [sym_block_comment] = STATE(628),
    [aux_sym_declaration_list_repeat1] = STATE(667),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_macro_rules_BANG] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_u8] = ACTIONS(1928),
    [anon_sym_i8] = ACTIONS(1928),
    [anon_sym_u16] = ACTIONS(1928),
    [anon_sym_i16] = ACTIONS(1928),
    [anon_sym_u32] = ACTIONS(1928),
    [anon_sym_i32] = ACTIONS(1928),
    [anon_sym_u64] = ACTIONS(1928),
    [anon_sym_i64] = ACTIONS(1928),
    [anon_sym_u128] = ACTIONS(1928),
    [anon_sym_i128] = ACTIONS(1928),
    [anon_sym_isize] = ACTIONS(1928),
    [anon_sym_usize] = ACTIONS(1928),
    [anon_sym_f32] = ACTIONS(1928),
    [anon_sym_f64] = ACTIONS(1928),
    [anon_sym_bool] = ACTIONS(1928),
    [anon_sym_str] = ACTIONS(1928),
    [anon_sym_char] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1930),
    [anon_sym_POUND] = ACTIONS(1932),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_fn] = ACTIONS(1940),
    [anon_sym_impl] = ACTIONS(1942),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_mod] = ACTIONS(1946),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_trait] = ACTIONS(1952),
    [anon_sym_type] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1956),
    [anon_sym_unsafe] = ACTIONS(1958),
    [anon_sym_use] = ACTIONS(1960),
    [anon_sym_extern] = ACTIONS(1962),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1964),
    [sym_super] = ACTIONS(1964),
    [sym_crate] = ACTIONS(1966),
    [sym_metavariable] = ACTIONS(1968),
  },
  [629] = {
    [sym_line_comment] = STATE(629),
    [sym_block_comment] = STATE(629),
    [ts_builtin_sym_end] = ACTIONS(2360),
    [sym_identifier] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym_macro_rules_BANG] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(2360),
    [anon_sym_LBRACK] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2360),
    [anon_sym_RBRACE] = ACTIONS(2360),
    [anon_sym_STAR] = ACTIONS(2360),
    [anon_sym_u8] = ACTIONS(2362),
    [anon_sym_i8] = ACTIONS(2362),
    [anon_sym_u16] = ACTIONS(2362),
    [anon_sym_i16] = ACTIONS(2362),
    [anon_sym_u32] = ACTIONS(2362),
    [anon_sym_i32] = ACTIONS(2362),
    [anon_sym_u64] = ACTIONS(2362),
    [anon_sym_i64] = ACTIONS(2362),
    [anon_sym_u128] = ACTIONS(2362),
    [anon_sym_i128] = ACTIONS(2362),
    [anon_sym_isize] = ACTIONS(2362),
    [anon_sym_usize] = ACTIONS(2362),
    [anon_sym_f32] = ACTIONS(2362),
    [anon_sym_f64] = ACTIONS(2362),
    [anon_sym_bool] = ACTIONS(2362),
    [anon_sym_str] = ACTIONS(2362),
    [anon_sym_char] = ACTIONS(2362),
    [anon_sym_DASH] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_AMP] = ACTIONS(2360),
    [anon_sym_PIPE] = ACTIONS(2360),
    [anon_sym_LT] = ACTIONS(2360),
    [anon_sym_DOT_DOT] = ACTIONS(2360),
    [anon_sym_COLON_COLON] = ACTIONS(2360),
    [anon_sym_POUND] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2362),
    [anon_sym_async] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_fn] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_impl] = ACTIONS(2362),
    [anon_sym_let] = ACTIONS(2362),
    [anon_sym_loop] = ACTIONS(2362),
    [anon_sym_match] = ACTIONS(2362),
    [anon_sym_mod] = ACTIONS(2362),
    [anon_sym_pub] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_trait] = ACTIONS(2362),
    [anon_sym_type] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_unsafe] = ACTIONS(2362),
    [anon_sym_use] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym_yield] = ACTIONS(2362),
    [anon_sym_move] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [sym_integer_literal] = ACTIONS(2360),
    [aux_sym_string_literal_token1] = ACTIONS(2360),
    [sym_char_literal] = ACTIONS(2360),
    [anon_sym_true] = ACTIONS(2362),
    [anon_sym_false] = ACTIONS(2362),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2362),
    [sym_super] = ACTIONS(2362),
    [sym_crate] = ACTIONS(2362),
    [sym_metavariable] = ACTIONS(2360),
    [sym__raw_string_literal_start] = ACTIONS(2360),
    [sym_float_literal] = ACTIONS(2360),
  },
  [630] = {
    [sym_line_comment] = STATE(630),
    [sym_block_comment] = STATE(630),
    [ts_builtin_sym_end] = ACTIONS(2364),
    [sym_identifier] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_macro_rules_BANG] = ACTIONS(2364),
    [anon_sym_LPAREN] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_RBRACE] = ACTIONS(2364),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_u8] = ACTIONS(2366),
    [anon_sym_i8] = ACTIONS(2366),
    [anon_sym_u16] = ACTIONS(2366),
    [anon_sym_i16] = ACTIONS(2366),
    [anon_sym_u32] = ACTIONS(2366),
    [anon_sym_i32] = ACTIONS(2366),
    [anon_sym_u64] = ACTIONS(2366),
    [anon_sym_i64] = ACTIONS(2366),
    [anon_sym_u128] = ACTIONS(2366),
    [anon_sym_i128] = ACTIONS(2366),
    [anon_sym_isize] = ACTIONS(2366),
    [anon_sym_usize] = ACTIONS(2366),
    [anon_sym_f32] = ACTIONS(2366),
    [anon_sym_f64] = ACTIONS(2366),
    [anon_sym_bool] = ACTIONS(2366),
    [anon_sym_str] = ACTIONS(2366),
    [anon_sym_char] = ACTIONS(2366),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_DOT_DOT] = ACTIONS(2364),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_POUND] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2366),
    [anon_sym_async] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_fn] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_impl] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2366),
    [anon_sym_loop] = ACTIONS(2366),
    [anon_sym_match] = ACTIONS(2366),
    [anon_sym_mod] = ACTIONS(2366),
    [anon_sym_pub] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_trait] = ACTIONS(2366),
    [anon_sym_type] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_unsafe] = ACTIONS(2366),
    [anon_sym_use] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym_yield] = ACTIONS(2366),
    [anon_sym_move] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [sym_integer_literal] = ACTIONS(2364),
    [aux_sym_string_literal_token1] = ACTIONS(2364),
    [sym_char_literal] = ACTIONS(2364),
    [anon_sym_true] = ACTIONS(2366),
    [anon_sym_false] = ACTIONS(2366),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2366),
    [sym_super] = ACTIONS(2366),
    [sym_crate] = ACTIONS(2366),
    [sym_metavariable] = ACTIONS(2364),
    [sym__raw_string_literal_start] = ACTIONS(2364),
    [sym_float_literal] = ACTIONS(2364),
  },
  [631] = {
    [sym_line_comment] = STATE(631),
    [sym_block_comment] = STATE(631),
    [ts_builtin_sym_end] = ACTIONS(2368),
    [sym_identifier] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym_macro_rules_BANG] = ACTIONS(2368),
    [anon_sym_LPAREN] = ACTIONS(2368),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_RBRACE] = ACTIONS(2368),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_u8] = ACTIONS(2370),
    [anon_sym_i8] = ACTIONS(2370),
    [anon_sym_u16] = ACTIONS(2370),
    [anon_sym_i16] = ACTIONS(2370),
    [anon_sym_u32] = ACTIONS(2370),
    [anon_sym_i32] = ACTIONS(2370),
    [anon_sym_u64] = ACTIONS(2370),
    [anon_sym_i64] = ACTIONS(2370),
    [anon_sym_u128] = ACTIONS(2370),
    [anon_sym_i128] = ACTIONS(2370),
    [anon_sym_isize] = ACTIONS(2370),
    [anon_sym_usize] = ACTIONS(2370),
    [anon_sym_f32] = ACTIONS(2370),
    [anon_sym_f64] = ACTIONS(2370),
    [anon_sym_bool] = ACTIONS(2370),
    [anon_sym_str] = ACTIONS(2370),
    [anon_sym_char] = ACTIONS(2370),
    [anon_sym_DASH] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2368),
    [anon_sym_PIPE] = ACTIONS(2368),
    [anon_sym_LT] = ACTIONS(2368),
    [anon_sym_DOT_DOT] = ACTIONS(2368),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_POUND] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_async] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_fn] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_impl] = ACTIONS(2370),
    [anon_sym_let] = ACTIONS(2370),
    [anon_sym_loop] = ACTIONS(2370),
    [anon_sym_match] = ACTIONS(2370),
    [anon_sym_mod] = ACTIONS(2370),
    [anon_sym_pub] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_trait] = ACTIONS(2370),
    [anon_sym_type] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_unsafe] = ACTIONS(2370),
    [anon_sym_use] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym_yield] = ACTIONS(2370),
    [anon_sym_move] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [sym_integer_literal] = ACTIONS(2368),
    [aux_sym_string_literal_token1] = ACTIONS(2368),
    [sym_char_literal] = ACTIONS(2368),
    [anon_sym_true] = ACTIONS(2370),
    [anon_sym_false] = ACTIONS(2370),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2370),
    [sym_super] = ACTIONS(2370),
    [sym_crate] = ACTIONS(2370),
    [sym_metavariable] = ACTIONS(2368),
    [sym__raw_string_literal_start] = ACTIONS(2368),
    [sym_float_literal] = ACTIONS(2368),
  },
  [632] = {
    [sym_line_comment] = STATE(632),
    [sym_block_comment] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(2372),
    [sym_identifier] = ACTIONS(2374),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym_macro_rules_BANG] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(2372),
    [anon_sym_LBRACK] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_u8] = ACTIONS(2374),
    [anon_sym_i8] = ACTIONS(2374),
    [anon_sym_u16] = ACTIONS(2374),
    [anon_sym_i16] = ACTIONS(2374),
    [anon_sym_u32] = ACTIONS(2374),
    [anon_sym_i32] = ACTIONS(2374),
    [anon_sym_u64] = ACTIONS(2374),
    [anon_sym_i64] = ACTIONS(2374),
    [anon_sym_u128] = ACTIONS(2374),
    [anon_sym_i128] = ACTIONS(2374),
    [anon_sym_isize] = ACTIONS(2374),
    [anon_sym_usize] = ACTIONS(2374),
    [anon_sym_f32] = ACTIONS(2374),
    [anon_sym_f64] = ACTIONS(2374),
    [anon_sym_bool] = ACTIONS(2374),
    [anon_sym_str] = ACTIONS(2374),
    [anon_sym_char] = ACTIONS(2374),
    [anon_sym_DASH] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2372),
    [anon_sym_PIPE] = ACTIONS(2372),
    [anon_sym_LT] = ACTIONS(2372),
    [anon_sym_DOT_DOT] = ACTIONS(2372),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_fn] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_impl] = ACTIONS(2374),
    [anon_sym_let] = ACTIONS(2374),
    [anon_sym_loop] = ACTIONS(2374),
    [anon_sym_match] = ACTIONS(2374),
    [anon_sym_mod] = ACTIONS(2374),
    [anon_sym_pub] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_trait] = ACTIONS(2374),
    [anon_sym_type] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_unsafe] = ACTIONS(2374),
    [anon_sym_use] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym_yield] = ACTIONS(2374),
    [anon_sym_move] = ACTIONS(2374),
    [anon_sym_try] = ACTIONS(2374),
    [sym_integer_literal] = ACTIONS(2372),
    [aux_sym_string_literal_token1] = ACTIONS(2372),
    [sym_char_literal] = ACTIONS(2372),
    [anon_sym_true] = ACTIONS(2374),
    [anon_sym_false] = ACTIONS(2374),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2374),
    [sym_super] = ACTIONS(2374),
    [sym_crate] = ACTIONS(2374),
    [sym_metavariable] = ACTIONS(2372),
    [sym__raw_string_literal_start] = ACTIONS(2372),
    [sym_float_literal] = ACTIONS(2372),
  },
  [633] = {
    [sym_line_comment] = STATE(633),
    [sym_block_comment] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_macro_rules_BANG] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_RBRACE] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_u8] = ACTIONS(2378),
    [anon_sym_i8] = ACTIONS(2378),
    [anon_sym_u16] = ACTIONS(2378),
    [anon_sym_i16] = ACTIONS(2378),
    [anon_sym_u32] = ACTIONS(2378),
    [anon_sym_i32] = ACTIONS(2378),
    [anon_sym_u64] = ACTIONS(2378),
    [anon_sym_i64] = ACTIONS(2378),
    [anon_sym_u128] = ACTIONS(2378),
    [anon_sym_i128] = ACTIONS(2378),
    [anon_sym_isize] = ACTIONS(2378),
    [anon_sym_usize] = ACTIONS(2378),
    [anon_sym_f32] = ACTIONS(2378),
    [anon_sym_f64] = ACTIONS(2378),
    [anon_sym_bool] = ACTIONS(2378),
    [anon_sym_str] = ACTIONS(2378),
    [anon_sym_char] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym_PIPE] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2376),
    [anon_sym_DOT_DOT] = ACTIONS(2376),
    [anon_sym_COLON_COLON] = ACTIONS(2376),
    [anon_sym_POUND] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [anon_sym_async] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_fn] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_impl] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(2378),
    [anon_sym_loop] = ACTIONS(2378),
    [anon_sym_match] = ACTIONS(2378),
    [anon_sym_mod] = ACTIONS(2378),
    [anon_sym_pub] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_trait] = ACTIONS(2378),
    [anon_sym_type] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_unsafe] = ACTIONS(2378),
    [anon_sym_use] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym_yield] = ACTIONS(2378),
    [anon_sym_move] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [sym_integer_literal] = ACTIONS(2376),
    [aux_sym_string_literal_token1] = ACTIONS(2376),
    [sym_char_literal] = ACTIONS(2376),
    [anon_sym_true] = ACTIONS(2378),
    [anon_sym_false] = ACTIONS(2378),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2378),
    [sym_super] = ACTIONS(2378),
    [sym_crate] = ACTIONS(2378),
    [sym_metavariable] = ACTIONS(2376),
    [sym__raw_string_literal_start] = ACTIONS(2376),
    [sym_float_literal] = ACTIONS(2376),
  },
  [634] = {
    [sym_line_comment] = STATE(634),
    [sym_block_comment] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(2380),
    [sym_identifier] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_macro_rules_BANG] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_u8] = ACTIONS(2382),
    [anon_sym_i8] = ACTIONS(2382),
    [anon_sym_u16] = ACTIONS(2382),
    [anon_sym_i16] = ACTIONS(2382),
    [anon_sym_u32] = ACTIONS(2382),
    [anon_sym_i32] = ACTIONS(2382),
    [anon_sym_u64] = ACTIONS(2382),
    [anon_sym_i64] = ACTIONS(2382),
    [anon_sym_u128] = ACTIONS(2382),
    [anon_sym_i128] = ACTIONS(2382),
    [anon_sym_isize] = ACTIONS(2382),
    [anon_sym_usize] = ACTIONS(2382),
    [anon_sym_f32] = ACTIONS(2382),
    [anon_sym_f64] = ACTIONS(2382),
    [anon_sym_bool] = ACTIONS(2382),
    [anon_sym_str] = ACTIONS(2382),
    [anon_sym_char] = ACTIONS(2382),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2380),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(2380),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_POUND] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2382),
    [anon_sym_async] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_default] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_fn] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_impl] = ACTIONS(2382),
    [anon_sym_let] = ACTIONS(2382),
    [anon_sym_loop] = ACTIONS(2382),
    [anon_sym_match] = ACTIONS(2382),
    [anon_sym_mod] = ACTIONS(2382),
    [anon_sym_pub] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_trait] = ACTIONS(2382),
    [anon_sym_type] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [anon_sym_unsafe] = ACTIONS(2382),
    [anon_sym_use] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym_yield] = ACTIONS(2382),
    [anon_sym_move] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [sym_integer_literal] = ACTIONS(2380),
    [aux_sym_string_literal_token1] = ACTIONS(2380),
    [sym_char_literal] = ACTIONS(2380),
    [anon_sym_true] = ACTIONS(2382),
    [anon_sym_false] = ACTIONS(2382),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2382),
    [sym_super] = ACTIONS(2382),
    [sym_crate] = ACTIONS(2382),
    [sym_metavariable] = ACTIONS(2380),
    [sym__raw_string_literal_start] = ACTIONS(2380),
    [sym_float_literal] = ACTIONS(2380),
  },
  [635] = {
    [sym_line_comment] = STATE(635),
    [sym_block_comment] = STATE(635),
    [ts_builtin_sym_end] = ACTIONS(2384),
    [sym_identifier] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym_macro_rules_BANG] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_u8] = ACTIONS(2386),
    [anon_sym_i8] = ACTIONS(2386),
    [anon_sym_u16] = ACTIONS(2386),
    [anon_sym_i16] = ACTIONS(2386),
    [anon_sym_u32] = ACTIONS(2386),
    [anon_sym_i32] = ACTIONS(2386),
    [anon_sym_u64] = ACTIONS(2386),
    [anon_sym_i64] = ACTIONS(2386),
    [anon_sym_u128] = ACTIONS(2386),
    [anon_sym_i128] = ACTIONS(2386),
    [anon_sym_isize] = ACTIONS(2386),
    [anon_sym_usize] = ACTIONS(2386),
    [anon_sym_f32] = ACTIONS(2386),
    [anon_sym_f64] = ACTIONS(2386),
    [anon_sym_bool] = ACTIONS(2386),
    [anon_sym_str] = ACTIONS(2386),
    [anon_sym_char] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_PIPE] = ACTIONS(2384),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_DOT_DOT] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_POUND] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_async] = ACTIONS(2386),
    [anon_sym_break] = ACTIONS(2386),
    [anon_sym_const] = ACTIONS(2386),
    [anon_sym_continue] = ACTIONS(2386),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_enum] = ACTIONS(2386),
    [anon_sym_fn] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_impl] = ACTIONS(2386),
    [anon_sym_let] = ACTIONS(2386),
    [anon_sym_loop] = ACTIONS(2386),
    [anon_sym_match] = ACTIONS(2386),
    [anon_sym_mod] = ACTIONS(2386),
    [anon_sym_pub] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2386),
    [anon_sym_struct] = ACTIONS(2386),
    [anon_sym_trait] = ACTIONS(2386),
    [anon_sym_type] = ACTIONS(2386),
    [anon_sym_union] = ACTIONS(2386),
    [anon_sym_unsafe] = ACTIONS(2386),
    [anon_sym_use] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_extern] = ACTIONS(2386),
    [anon_sym_yield] = ACTIONS(2386),
    [anon_sym_move] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [sym_integer_literal] = ACTIONS(2384),
    [aux_sym_string_literal_token1] = ACTIONS(2384),
    [sym_char_literal] = ACTIONS(2384),
    [anon_sym_true] = ACTIONS(2386),
    [anon_sym_false] = ACTIONS(2386),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2386),
    [sym_super] = ACTIONS(2386),
    [sym_crate] = ACTIONS(2386),
    [sym_metavariable] = ACTIONS(2384),
    [sym__raw_string_literal_start] = ACTIONS(2384),
    [sym_float_literal] = ACTIONS(2384),
  },
  [636] = {
    [sym_line_comment] = STATE(636),
    [sym_block_comment] = STATE(636),
    [ts_builtin_sym_end] = ACTIONS(1244),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_macro_rules_BANG] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_u8] = ACTIONS(1246),
    [anon_sym_i8] = ACTIONS(1246),
    [anon_sym_u16] = ACTIONS(1246),
    [anon_sym_i16] = ACTIONS(1246),
    [anon_sym_u32] = ACTIONS(1246),
    [anon_sym_i32] = ACTIONS(1246),
    [anon_sym_u64] = ACTIONS(1246),
    [anon_sym_i64] = ACTIONS(1246),
    [anon_sym_u128] = ACTIONS(1246),
    [anon_sym_i128] = ACTIONS(1246),
    [anon_sym_isize] = ACTIONS(1246),
    [anon_sym_usize] = ACTIONS(1246),
    [anon_sym_f32] = ACTIONS(1246),
    [anon_sym_f64] = ACTIONS(1246),
    [anon_sym_bool] = ACTIONS(1246),
    [anon_sym_str] = ACTIONS(1246),
    [anon_sym_char] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_LT] = ACTIONS(1244),
    [anon_sym_DOT_DOT] = ACTIONS(1244),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_async] = ACTIONS(1246),
    [anon_sym_break] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [anon_sym_continue] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_enum] = ACTIONS(1246),
    [anon_sym_fn] = ACTIONS(1246),
    [anon_sym_for] = ACTIONS(1246),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_impl] = ACTIONS(1246),
    [anon_sym_let] = ACTIONS(1246),
    [anon_sym_loop] = ACTIONS(1246),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_mod] = ACTIONS(1246),
    [anon_sym_pub] = ACTIONS(1246),
    [anon_sym_return] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1246),
    [anon_sym_struct] = ACTIONS(1246),
    [anon_sym_trait] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1246),
    [anon_sym_union] = ACTIONS(1246),
    [anon_sym_unsafe] = ACTIONS(1246),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(1246),
    [anon_sym_extern] = ACTIONS(1246),
    [anon_sym_yield] = ACTIONS(1246),
    [anon_sym_move] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(1246),
    [sym_integer_literal] = ACTIONS(1244),
    [aux_sym_string_literal_token1] = ACTIONS(1244),
    [sym_char_literal] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1246),
    [anon_sym_false] = ACTIONS(1246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [sym_crate] = ACTIONS(1246),
    [sym_metavariable] = ACTIONS(1244),
    [sym__raw_string_literal_start] = ACTIONS(1244),
    [sym_float_literal] = ACTIONS(1244),
  },
  [637] = {
    [sym_line_comment] = STATE(637),
    [sym_block_comment] = STATE(637),
    [ts_builtin_sym_end] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_macro_rules_BANG] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_STAR] = ACTIONS(2388),
    [anon_sym_u8] = ACTIONS(2390),
    [anon_sym_i8] = ACTIONS(2390),
    [anon_sym_u16] = ACTIONS(2390),
    [anon_sym_i16] = ACTIONS(2390),
    [anon_sym_u32] = ACTIONS(2390),
    [anon_sym_i32] = ACTIONS(2390),
    [anon_sym_u64] = ACTIONS(2390),
    [anon_sym_i64] = ACTIONS(2390),
    [anon_sym_u128] = ACTIONS(2390),
    [anon_sym_i128] = ACTIONS(2390),
    [anon_sym_isize] = ACTIONS(2390),
    [anon_sym_usize] = ACTIONS(2390),
    [anon_sym_f32] = ACTIONS(2390),
    [anon_sym_f64] = ACTIONS(2390),
    [anon_sym_bool] = ACTIONS(2390),
    [anon_sym_str] = ACTIONS(2390),
    [anon_sym_char] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_DOT_DOT] = ACTIONS(2388),
    [anon_sym_COLON_COLON] = ACTIONS(2388),
    [anon_sym_POUND] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
    [anon_sym_fn] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_impl] = ACTIONS(2390),
    [anon_sym_let] = ACTIONS(2390),
    [anon_sym_loop] = ACTIONS(2390),
    [anon_sym_match] = ACTIONS(2390),
    [anon_sym_mod] = ACTIONS(2390),
    [anon_sym_pub] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_struct] = ACTIONS(2390),
    [anon_sym_trait] = ACTIONS(2390),
    [anon_sym_type] = ACTIONS(2390),
    [anon_sym_union] = ACTIONS(2390),
    [anon_sym_unsafe] = ACTIONS(2390),
    [anon_sym_use] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_extern] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_move] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [sym_integer_literal] = ACTIONS(2388),
    [aux_sym_string_literal_token1] = ACTIONS(2388),
    [sym_char_literal] = ACTIONS(2388),
    [anon_sym_true] = ACTIONS(2390),
    [anon_sym_false] = ACTIONS(2390),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2390),
    [sym_super] = ACTIONS(2390),
    [sym_crate] = ACTIONS(2390),
    [sym_metavariable] = ACTIONS(2388),
    [sym__raw_string_literal_start] = ACTIONS(2388),
    [sym_float_literal] = ACTIONS(2388),
  },
  [638] = {
    [sym_line_comment] = STATE(638),
    [sym_block_comment] = STATE(638),
    [ts_builtin_sym_end] = ACTIONS(2392),
    [sym_identifier] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_macro_rules_BANG] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2392),
    [anon_sym_u8] = ACTIONS(2394),
    [anon_sym_i8] = ACTIONS(2394),
    [anon_sym_u16] = ACTIONS(2394),
    [anon_sym_i16] = ACTIONS(2394),
    [anon_sym_u32] = ACTIONS(2394),
    [anon_sym_i32] = ACTIONS(2394),
    [anon_sym_u64] = ACTIONS(2394),
    [anon_sym_i64] = ACTIONS(2394),
    [anon_sym_u128] = ACTIONS(2394),
    [anon_sym_i128] = ACTIONS(2394),
    [anon_sym_isize] = ACTIONS(2394),
    [anon_sym_usize] = ACTIONS(2394),
    [anon_sym_f32] = ACTIONS(2394),
    [anon_sym_f64] = ACTIONS(2394),
    [anon_sym_bool] = ACTIONS(2394),
    [anon_sym_str] = ACTIONS(2394),
    [anon_sym_char] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2392),
    [anon_sym_DOT_DOT] = ACTIONS(2392),
    [anon_sym_COLON_COLON] = ACTIONS(2392),
    [anon_sym_POUND] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [anon_sym_async] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
    [anon_sym_fn] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_impl] = ACTIONS(2394),
    [anon_sym_let] = ACTIONS(2394),
    [anon_sym_loop] = ACTIONS(2394),
    [anon_sym_match] = ACTIONS(2394),
    [anon_sym_mod] = ACTIONS(2394),
    [anon_sym_pub] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_struct] = ACTIONS(2394),
    [anon_sym_trait] = ACTIONS(2394),
    [anon_sym_type] = ACTIONS(2394),
    [anon_sym_union] = ACTIONS(2394),
    [anon_sym_unsafe] = ACTIONS(2394),
    [anon_sym_use] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_extern] = ACTIONS(2394),
    [anon_sym_yield] = ACTIONS(2394),
    [anon_sym_move] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [sym_integer_literal] = ACTIONS(2392),
    [aux_sym_string_literal_token1] = ACTIONS(2392),
    [sym_char_literal] = ACTIONS(2392),
    [anon_sym_true] = ACTIONS(2394),
    [anon_sym_false] = ACTIONS(2394),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2394),
    [sym_super] = ACTIONS(2394),
    [sym_crate] = ACTIONS(2394),
    [sym_metavariable] = ACTIONS(2392),
    [sym__raw_string_literal_start] = ACTIONS(2392),
    [sym_float_literal] = ACTIONS(2392),
  },
  [639] = {
    [sym_line_comment] = STATE(639),
    [sym_block_comment] = STATE(639),
    [ts_builtin_sym_end] = ACTIONS(2396),
    [sym_identifier] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym_macro_rules_BANG] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_u8] = ACTIONS(2398),
    [anon_sym_i8] = ACTIONS(2398),
    [anon_sym_u16] = ACTIONS(2398),
    [anon_sym_i16] = ACTIONS(2398),
    [anon_sym_u32] = ACTIONS(2398),
    [anon_sym_i32] = ACTIONS(2398),
    [anon_sym_u64] = ACTIONS(2398),
    [anon_sym_i64] = ACTIONS(2398),
    [anon_sym_u128] = ACTIONS(2398),
    [anon_sym_i128] = ACTIONS(2398),
    [anon_sym_isize] = ACTIONS(2398),
    [anon_sym_usize] = ACTIONS(2398),
    [anon_sym_f32] = ACTIONS(2398),
    [anon_sym_f64] = ACTIONS(2398),
    [anon_sym_bool] = ACTIONS(2398),
    [anon_sym_str] = ACTIONS(2398),
    [anon_sym_char] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_PIPE] = ACTIONS(2396),
    [anon_sym_LT] = ACTIONS(2396),
    [anon_sym_DOT_DOT] = ACTIONS(2396),
    [anon_sym_COLON_COLON] = ACTIONS(2396),
    [anon_sym_POUND] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [anon_sym_async] = ACTIONS(2398),
    [anon_sym_break] = ACTIONS(2398),
    [anon_sym_const] = ACTIONS(2398),
    [anon_sym_continue] = ACTIONS(2398),
    [anon_sym_default] = ACTIONS(2398),
    [anon_sym_enum] = ACTIONS(2398),
    [anon_sym_fn] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2398),
    [anon_sym_if] = ACTIONS(2398),
    [anon_sym_impl] = ACTIONS(2398),
    [anon_sym_let] = ACTIONS(2398),
    [anon_sym_loop] = ACTIONS(2398),
    [anon_sym_match] = ACTIONS(2398),
    [anon_sym_mod] = ACTIONS(2398),
    [anon_sym_pub] = ACTIONS(2398),
    [anon_sym_return] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2398),
    [anon_sym_struct] = ACTIONS(2398),
    [anon_sym_trait] = ACTIONS(2398),
    [anon_sym_type] = ACTIONS(2398),
    [anon_sym_union] = ACTIONS(2398),
    [anon_sym_unsafe] = ACTIONS(2398),
    [anon_sym_use] = ACTIONS(2398),
    [anon_sym_while] = ACTIONS(2398),
    [anon_sym_extern] = ACTIONS(2398),
    [anon_sym_yield] = ACTIONS(2398),
    [anon_sym_move] = ACTIONS(2398),
    [anon_sym_try] = ACTIONS(2398),
    [sym_integer_literal] = ACTIONS(2396),
    [aux_sym_string_literal_token1] = ACTIONS(2396),
    [sym_char_literal] = ACTIONS(2396),
    [anon_sym_true] = ACTIONS(2398),
    [anon_sym_false] = ACTIONS(2398),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2398),
    [sym_super] = ACTIONS(2398),
    [sym_crate] = ACTIONS(2398),
    [sym_metavariable] = ACTIONS(2396),
    [sym__raw_string_literal_start] = ACTIONS(2396),
    [sym_float_literal] = ACTIONS(2396),
  },
  [640] = {
    [sym_line_comment] = STATE(640),
    [sym_block_comment] = STATE(640),
    [ts_builtin_sym_end] = ACTIONS(1232),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_SEMI] = ACTIONS(1232),
    [anon_sym_macro_rules_BANG] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_u8] = ACTIONS(1234),
    [anon_sym_i8] = ACTIONS(1234),
    [anon_sym_u16] = ACTIONS(1234),
    [anon_sym_i16] = ACTIONS(1234),
    [anon_sym_u32] = ACTIONS(1234),
    [anon_sym_i32] = ACTIONS(1234),
    [anon_sym_u64] = ACTIONS(1234),
    [anon_sym_i64] = ACTIONS(1234),
    [anon_sym_u128] = ACTIONS(1234),
    [anon_sym_i128] = ACTIONS(1234),
    [anon_sym_isize] = ACTIONS(1234),
    [anon_sym_usize] = ACTIONS(1234),
    [anon_sym_f32] = ACTIONS(1234),
    [anon_sym_f64] = ACTIONS(1234),
    [anon_sym_bool] = ACTIONS(1234),
    [anon_sym_str] = ACTIONS(1234),
    [anon_sym_char] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(1232),
    [anon_sym_LT] = ACTIONS(1232),
    [anon_sym_DOT_DOT] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_break] = ACTIONS(1234),
    [anon_sym_const] = ACTIONS(1234),
    [anon_sym_continue] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1234),
    [anon_sym_enum] = ACTIONS(1234),
    [anon_sym_fn] = ACTIONS(1234),
    [anon_sym_for] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_impl] = ACTIONS(1234),
    [anon_sym_let] = ACTIONS(1234),
    [anon_sym_loop] = ACTIONS(1234),
    [anon_sym_match] = ACTIONS(1234),
    [anon_sym_mod] = ACTIONS(1234),
    [anon_sym_pub] = ACTIONS(1234),
    [anon_sym_return] = ACTIONS(1234),
    [anon_sym_static] = ACTIONS(1234),
    [anon_sym_struct] = ACTIONS(1234),
    [anon_sym_trait] = ACTIONS(1234),
    [anon_sym_type] = ACTIONS(1234),
    [anon_sym_union] = ACTIONS(1234),
    [anon_sym_unsafe] = ACTIONS(1234),
    [anon_sym_use] = ACTIONS(1234),
    [anon_sym_while] = ACTIONS(1234),
    [anon_sym_extern] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1234),
    [anon_sym_move] = ACTIONS(1234),
    [anon_sym_try] = ACTIONS(1234),
    [sym_integer_literal] = ACTIONS(1232),
    [aux_sym_string_literal_token1] = ACTIONS(1232),
    [sym_char_literal] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1234),
    [anon_sym_false] = ACTIONS(1234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1234),
    [sym_super] = ACTIONS(1234),
    [sym_crate] = ACTIONS(1234),
    [sym_metavariable] = ACTIONS(1232),
    [sym__raw_string_literal_start] = ACTIONS(1232),
    [sym_float_literal] = ACTIONS(1232),
  },
  [641] = {
    [sym_line_comment] = STATE(641),
    [sym_block_comment] = STATE(641),
    [ts_builtin_sym_end] = ACTIONS(2400),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_macro_rules_BANG] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_u8] = ACTIONS(2402),
    [anon_sym_i8] = ACTIONS(2402),
    [anon_sym_u16] = ACTIONS(2402),
    [anon_sym_i16] = ACTIONS(2402),
    [anon_sym_u32] = ACTIONS(2402),
    [anon_sym_i32] = ACTIONS(2402),
    [anon_sym_u64] = ACTIONS(2402),
    [anon_sym_i64] = ACTIONS(2402),
    [anon_sym_u128] = ACTIONS(2402),
    [anon_sym_i128] = ACTIONS(2402),
    [anon_sym_isize] = ACTIONS(2402),
    [anon_sym_usize] = ACTIONS(2402),
    [anon_sym_f32] = ACTIONS(2402),
    [anon_sym_f64] = ACTIONS(2402),
    [anon_sym_bool] = ACTIONS(2402),
    [anon_sym_str] = ACTIONS(2402),
    [anon_sym_char] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_DOT_DOT] = ACTIONS(2400),
    [anon_sym_COLON_COLON] = ACTIONS(2400),
    [anon_sym_POUND] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_async] = ACTIONS(2402),
    [anon_sym_break] = ACTIONS(2402),
    [anon_sym_const] = ACTIONS(2402),
    [anon_sym_continue] = ACTIONS(2402),
    [anon_sym_default] = ACTIONS(2402),
    [anon_sym_enum] = ACTIONS(2402),
    [anon_sym_fn] = ACTIONS(2402),
    [anon_sym_for] = ACTIONS(2402),
    [anon_sym_if] = ACTIONS(2402),
    [anon_sym_impl] = ACTIONS(2402),
    [anon_sym_let] = ACTIONS(2402),
    [anon_sym_loop] = ACTIONS(2402),
    [anon_sym_match] = ACTIONS(2402),
    [anon_sym_mod] = ACTIONS(2402),
    [anon_sym_pub] = ACTIONS(2402),
    [anon_sym_return] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2402),
    [anon_sym_struct] = ACTIONS(2402),
    [anon_sym_trait] = ACTIONS(2402),
    [anon_sym_type] = ACTIONS(2402),
    [anon_sym_union] = ACTIONS(2402),
    [anon_sym_unsafe] = ACTIONS(2402),
    [anon_sym_use] = ACTIONS(2402),
    [anon_sym_while] = ACTIONS(2402),
    [anon_sym_extern] = ACTIONS(2402),
    [anon_sym_yield] = ACTIONS(2402),
    [anon_sym_move] = ACTIONS(2402),
    [anon_sym_try] = ACTIONS(2402),
    [sym_integer_literal] = ACTIONS(2400),
    [aux_sym_string_literal_token1] = ACTIONS(2400),
    [sym_char_literal] = ACTIONS(2400),
    [anon_sym_true] = ACTIONS(2402),
    [anon_sym_false] = ACTIONS(2402),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2402),
    [sym_super] = ACTIONS(2402),
    [sym_crate] = ACTIONS(2402),
    [sym_metavariable] = ACTIONS(2400),
    [sym__raw_string_literal_start] = ACTIONS(2400),
    [sym_float_literal] = ACTIONS(2400),
  },
  [642] = {
    [sym_line_comment] = STATE(642),
    [sym_block_comment] = STATE(642),
    [ts_builtin_sym_end] = ACTIONS(2404),
    [sym_identifier] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_macro_rules_BANG] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_u8] = ACTIONS(2406),
    [anon_sym_i8] = ACTIONS(2406),
    [anon_sym_u16] = ACTIONS(2406),
    [anon_sym_i16] = ACTIONS(2406),
    [anon_sym_u32] = ACTIONS(2406),
    [anon_sym_i32] = ACTIONS(2406),
    [anon_sym_u64] = ACTIONS(2406),
    [anon_sym_i64] = ACTIONS(2406),
    [anon_sym_u128] = ACTIONS(2406),
    [anon_sym_i128] = ACTIONS(2406),
    [anon_sym_isize] = ACTIONS(2406),
    [anon_sym_usize] = ACTIONS(2406),
    [anon_sym_f32] = ACTIONS(2406),
    [anon_sym_f64] = ACTIONS(2406),
    [anon_sym_bool] = ACTIONS(2406),
    [anon_sym_str] = ACTIONS(2406),
    [anon_sym_char] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_DOT_DOT] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2404),
    [anon_sym_POUND] = ACTIONS(2404),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [anon_sym_async] = ACTIONS(2406),
    [anon_sym_break] = ACTIONS(2406),
    [anon_sym_const] = ACTIONS(2406),
    [anon_sym_continue] = ACTIONS(2406),
    [anon_sym_default] = ACTIONS(2406),
    [anon_sym_enum] = ACTIONS(2406),
    [anon_sym_fn] = ACTIONS(2406),
    [anon_sym_for] = ACTIONS(2406),
    [anon_sym_if] = ACTIONS(2406),
    [anon_sym_impl] = ACTIONS(2406),
    [anon_sym_let] = ACTIONS(2406),
    [anon_sym_loop] = ACTIONS(2406),
    [anon_sym_match] = ACTIONS(2406),
    [anon_sym_mod] = ACTIONS(2406),
    [anon_sym_pub] = ACTIONS(2406),
    [anon_sym_return] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2406),
    [anon_sym_struct] = ACTIONS(2406),
    [anon_sym_trait] = ACTIONS(2406),
    [anon_sym_type] = ACTIONS(2406),
    [anon_sym_union] = ACTIONS(2406),
    [anon_sym_unsafe] = ACTIONS(2406),
    [anon_sym_use] = ACTIONS(2406),
    [anon_sym_while] = ACTIONS(2406),
    [anon_sym_extern] = ACTIONS(2406),
    [anon_sym_yield] = ACTIONS(2406),
    [anon_sym_move] = ACTIONS(2406),
    [anon_sym_try] = ACTIONS(2406),
    [sym_integer_literal] = ACTIONS(2404),
    [aux_sym_string_literal_token1] = ACTIONS(2404),
    [sym_char_literal] = ACTIONS(2404),
    [anon_sym_true] = ACTIONS(2406),
    [anon_sym_false] = ACTIONS(2406),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2406),
    [sym_super] = ACTIONS(2406),
    [sym_crate] = ACTIONS(2406),
    [sym_metavariable] = ACTIONS(2404),
    [sym__raw_string_literal_start] = ACTIONS(2404),
    [sym_float_literal] = ACTIONS(2404),
  },
  [643] = {
    [sym_line_comment] = STATE(643),
    [sym_block_comment] = STATE(643),
    [ts_builtin_sym_end] = ACTIONS(2408),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_macro_rules_BANG] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_u8] = ACTIONS(2410),
    [anon_sym_i8] = ACTIONS(2410),
    [anon_sym_u16] = ACTIONS(2410),
    [anon_sym_i16] = ACTIONS(2410),
    [anon_sym_u32] = ACTIONS(2410),
    [anon_sym_i32] = ACTIONS(2410),
    [anon_sym_u64] = ACTIONS(2410),
    [anon_sym_i64] = ACTIONS(2410),
    [anon_sym_u128] = ACTIONS(2410),
    [anon_sym_i128] = ACTIONS(2410),
    [anon_sym_isize] = ACTIONS(2410),
    [anon_sym_usize] = ACTIONS(2410),
    [anon_sym_f32] = ACTIONS(2410),
    [anon_sym_f64] = ACTIONS(2410),
    [anon_sym_bool] = ACTIONS(2410),
    [anon_sym_str] = ACTIONS(2410),
    [anon_sym_char] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_DOT_DOT] = ACTIONS(2408),
    [anon_sym_COLON_COLON] = ACTIONS(2408),
    [anon_sym_POUND] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2410),
    [anon_sym_async] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_fn] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_impl] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_loop] = ACTIONS(2410),
    [anon_sym_match] = ACTIONS(2410),
    [anon_sym_mod] = ACTIONS(2410),
    [anon_sym_pub] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_trait] = ACTIONS(2410),
    [anon_sym_type] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_unsafe] = ACTIONS(2410),
    [anon_sym_use] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym_yield] = ACTIONS(2410),
    [anon_sym_move] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [sym_integer_literal] = ACTIONS(2408),
    [aux_sym_string_literal_token1] = ACTIONS(2408),
    [sym_char_literal] = ACTIONS(2408),
    [anon_sym_true] = ACTIONS(2410),
    [anon_sym_false] = ACTIONS(2410),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2410),
    [sym_super] = ACTIONS(2410),
    [sym_crate] = ACTIONS(2410),
    [sym_metavariable] = ACTIONS(2408),
    [sym__raw_string_literal_start] = ACTIONS(2408),
    [sym_float_literal] = ACTIONS(2408),
  },
  [644] = {
    [sym_line_comment] = STATE(644),
    [sym_block_comment] = STATE(644),
    [ts_builtin_sym_end] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_macro_rules_BANG] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_u8] = ACTIONS(2414),
    [anon_sym_i8] = ACTIONS(2414),
    [anon_sym_u16] = ACTIONS(2414),
    [anon_sym_i16] = ACTIONS(2414),
    [anon_sym_u32] = ACTIONS(2414),
    [anon_sym_i32] = ACTIONS(2414),
    [anon_sym_u64] = ACTIONS(2414),
    [anon_sym_i64] = ACTIONS(2414),
    [anon_sym_u128] = ACTIONS(2414),
    [anon_sym_i128] = ACTIONS(2414),
    [anon_sym_isize] = ACTIONS(2414),
    [anon_sym_usize] = ACTIONS(2414),
    [anon_sym_f32] = ACTIONS(2414),
    [anon_sym_f64] = ACTIONS(2414),
    [anon_sym_bool] = ACTIONS(2414),
    [anon_sym_str] = ACTIONS(2414),
    [anon_sym_char] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2412),
    [anon_sym_DOT_DOT] = ACTIONS(2412),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_POUND] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2414),
    [anon_sym_async] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_fn] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_impl] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_loop] = ACTIONS(2414),
    [anon_sym_match] = ACTIONS(2414),
    [anon_sym_mod] = ACTIONS(2414),
    [anon_sym_pub] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_trait] = ACTIONS(2414),
    [anon_sym_type] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_unsafe] = ACTIONS(2414),
    [anon_sym_use] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym_yield] = ACTIONS(2414),
    [anon_sym_move] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [sym_integer_literal] = ACTIONS(2412),
    [aux_sym_string_literal_token1] = ACTIONS(2412),
    [sym_char_literal] = ACTIONS(2412),
    [anon_sym_true] = ACTIONS(2414),
    [anon_sym_false] = ACTIONS(2414),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2414),
    [sym_super] = ACTIONS(2414),
    [sym_crate] = ACTIONS(2414),
    [sym_metavariable] = ACTIONS(2412),
    [sym__raw_string_literal_start] = ACTIONS(2412),
    [sym_float_literal] = ACTIONS(2412),
  },
  [645] = {
    [sym_line_comment] = STATE(645),
    [sym_block_comment] = STATE(645),
    [ts_builtin_sym_end] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_macro_rules_BANG] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_u8] = ACTIONS(2418),
    [anon_sym_i8] = ACTIONS(2418),
    [anon_sym_u16] = ACTIONS(2418),
    [anon_sym_i16] = ACTIONS(2418),
    [anon_sym_u32] = ACTIONS(2418),
    [anon_sym_i32] = ACTIONS(2418),
    [anon_sym_u64] = ACTIONS(2418),
    [anon_sym_i64] = ACTIONS(2418),
    [anon_sym_u128] = ACTIONS(2418),
    [anon_sym_i128] = ACTIONS(2418),
    [anon_sym_isize] = ACTIONS(2418),
    [anon_sym_usize] = ACTIONS(2418),
    [anon_sym_f32] = ACTIONS(2418),
    [anon_sym_f64] = ACTIONS(2418),
    [anon_sym_bool] = ACTIONS(2418),
    [anon_sym_str] = ACTIONS(2418),
    [anon_sym_char] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_DOT_DOT] = ACTIONS(2416),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_POUND] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2418),
    [anon_sym_async] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_fn] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_impl] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_loop] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_mod] = ACTIONS(2418),
    [anon_sym_pub] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_trait] = ACTIONS(2418),
    [anon_sym_type] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_unsafe] = ACTIONS(2418),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_move] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [sym_integer_literal] = ACTIONS(2416),
    [aux_sym_string_literal_token1] = ACTIONS(2416),
    [sym_char_literal] = ACTIONS(2416),
    [anon_sym_true] = ACTIONS(2418),
    [anon_sym_false] = ACTIONS(2418),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2418),
    [sym_super] = ACTIONS(2418),
    [sym_crate] = ACTIONS(2418),
    [sym_metavariable] = ACTIONS(2416),
    [sym__raw_string_literal_start] = ACTIONS(2416),
    [sym_float_literal] = ACTIONS(2416),
  },
  [646] = {
    [sym_line_comment] = STATE(646),
    [sym_block_comment] = STATE(646),
    [ts_builtin_sym_end] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_macro_rules_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_u8] = ACTIONS(2422),
    [anon_sym_i8] = ACTIONS(2422),
    [anon_sym_u16] = ACTIONS(2422),
    [anon_sym_i16] = ACTIONS(2422),
    [anon_sym_u32] = ACTIONS(2422),
    [anon_sym_i32] = ACTIONS(2422),
    [anon_sym_u64] = ACTIONS(2422),
    [anon_sym_i64] = ACTIONS(2422),
    [anon_sym_u128] = ACTIONS(2422),
    [anon_sym_i128] = ACTIONS(2422),
    [anon_sym_isize] = ACTIONS(2422),
    [anon_sym_usize] = ACTIONS(2422),
    [anon_sym_f32] = ACTIONS(2422),
    [anon_sym_f64] = ACTIONS(2422),
    [anon_sym_bool] = ACTIONS(2422),
    [anon_sym_str] = ACTIONS(2422),
    [anon_sym_char] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_POUND] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2422),
    [anon_sym_async] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_fn] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_impl] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_loop] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_mod] = ACTIONS(2422),
    [anon_sym_pub] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_trait] = ACTIONS(2422),
    [anon_sym_type] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_unsafe] = ACTIONS(2422),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_move] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [sym_integer_literal] = ACTIONS(2420),
    [aux_sym_string_literal_token1] = ACTIONS(2420),
    [sym_char_literal] = ACTIONS(2420),
    [anon_sym_true] = ACTIONS(2422),
    [anon_sym_false] = ACTIONS(2422),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2422),
    [sym_super] = ACTIONS(2422),
    [sym_crate] = ACTIONS(2422),
    [sym_metavariable] = ACTIONS(2420),
    [sym__raw_string_literal_start] = ACTIONS(2420),
    [sym_float_literal] = ACTIONS(2420),
  },
  [647] = {
    [sym_line_comment] = STATE(647),
    [sym_block_comment] = STATE(647),
    [ts_builtin_sym_end] = ACTIONS(2424),
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_macro_rules_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_STAR] = ACTIONS(2424),
    [anon_sym_u8] = ACTIONS(2426),
    [anon_sym_i8] = ACTIONS(2426),
    [anon_sym_u16] = ACTIONS(2426),
    [anon_sym_i16] = ACTIONS(2426),
    [anon_sym_u32] = ACTIONS(2426),
    [anon_sym_i32] = ACTIONS(2426),
    [anon_sym_u64] = ACTIONS(2426),
    [anon_sym_i64] = ACTIONS(2426),
    [anon_sym_u128] = ACTIONS(2426),
    [anon_sym_i128] = ACTIONS(2426),
    [anon_sym_isize] = ACTIONS(2426),
    [anon_sym_usize] = ACTIONS(2426),
    [anon_sym_f32] = ACTIONS(2426),
    [anon_sym_f64] = ACTIONS(2426),
    [anon_sym_bool] = ACTIONS(2426),
    [anon_sym_str] = ACTIONS(2426),
    [anon_sym_char] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(2424),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_POUND] = ACTIONS(2424),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2426),
    [anon_sym_default] = ACTIONS(2426),
    [anon_sym_enum] = ACTIONS(2426),
    [anon_sym_fn] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_impl] = ACTIONS(2426),
    [anon_sym_let] = ACTIONS(2426),
    [anon_sym_loop] = ACTIONS(2426),
    [anon_sym_match] = ACTIONS(2426),
    [anon_sym_mod] = ACTIONS(2426),
    [anon_sym_pub] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2426),
    [anon_sym_struct] = ACTIONS(2426),
    [anon_sym_trait] = ACTIONS(2426),
    [anon_sym_type] = ACTIONS(2426),
    [anon_sym_union] = ACTIONS(2426),
    [anon_sym_unsafe] = ACTIONS(2426),
    [anon_sym_use] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_extern] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_move] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [sym_integer_literal] = ACTIONS(2424),
    [aux_sym_string_literal_token1] = ACTIONS(2424),
    [sym_char_literal] = ACTIONS(2424),
    [anon_sym_true] = ACTIONS(2426),
    [anon_sym_false] = ACTIONS(2426),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2426),
    [sym_super] = ACTIONS(2426),
    [sym_crate] = ACTIONS(2426),
    [sym_metavariable] = ACTIONS(2424),
    [sym__raw_string_literal_start] = ACTIONS(2424),
    [sym_float_literal] = ACTIONS(2424),
  },
  [648] = {
    [sym_line_comment] = STATE(648),
    [sym_block_comment] = STATE(648),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym_identifier] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_macro_rules_BANG] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_u8] = ACTIONS(2430),
    [anon_sym_i8] = ACTIONS(2430),
    [anon_sym_u16] = ACTIONS(2430),
    [anon_sym_i16] = ACTIONS(2430),
    [anon_sym_u32] = ACTIONS(2430),
    [anon_sym_i32] = ACTIONS(2430),
    [anon_sym_u64] = ACTIONS(2430),
    [anon_sym_i64] = ACTIONS(2430),
    [anon_sym_u128] = ACTIONS(2430),
    [anon_sym_i128] = ACTIONS(2430),
    [anon_sym_isize] = ACTIONS(2430),
    [anon_sym_usize] = ACTIONS(2430),
    [anon_sym_f32] = ACTIONS(2430),
    [anon_sym_f64] = ACTIONS(2430),
    [anon_sym_bool] = ACTIONS(2430),
    [anon_sym_str] = ACTIONS(2430),
    [anon_sym_char] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2428),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2428),
    [anon_sym_DOT_DOT] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2428),
    [anon_sym_POUND] = ACTIONS(2428),
    [anon_sym_SQUOTE] = ACTIONS(2430),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_break] = ACTIONS(2430),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_continue] = ACTIONS(2430),
    [anon_sym_default] = ACTIONS(2430),
    [anon_sym_enum] = ACTIONS(2430),
    [anon_sym_fn] = ACTIONS(2430),
    [anon_sym_for] = ACTIONS(2430),
    [anon_sym_if] = ACTIONS(2430),
    [anon_sym_impl] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_loop] = ACTIONS(2430),
    [anon_sym_match] = ACTIONS(2430),
    [anon_sym_mod] = ACTIONS(2430),
    [anon_sym_pub] = ACTIONS(2430),
    [anon_sym_return] = ACTIONS(2430),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_struct] = ACTIONS(2430),
    [anon_sym_trait] = ACTIONS(2430),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_union] = ACTIONS(2430),
    [anon_sym_unsafe] = ACTIONS(2430),
    [anon_sym_use] = ACTIONS(2430),
    [anon_sym_while] = ACTIONS(2430),
    [anon_sym_extern] = ACTIONS(2430),
    [anon_sym_yield] = ACTIONS(2430),
    [anon_sym_move] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2430),
    [sym_integer_literal] = ACTIONS(2428),
    [aux_sym_string_literal_token1] = ACTIONS(2428),
    [sym_char_literal] = ACTIONS(2428),
    [anon_sym_true] = ACTIONS(2430),
    [anon_sym_false] = ACTIONS(2430),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2430),
    [sym_super] = ACTIONS(2430),
    [sym_crate] = ACTIONS(2430),
    [sym_metavariable] = ACTIONS(2428),
    [sym__raw_string_literal_start] = ACTIONS(2428),
    [sym_float_literal] = ACTIONS(2428),
  },
  [649] = {
    [sym_line_comment] = STATE(649),
    [sym_block_comment] = STATE(649),
    [ts_builtin_sym_end] = ACTIONS(2432),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_macro_rules_BANG] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_u8] = ACTIONS(2434),
    [anon_sym_i8] = ACTIONS(2434),
    [anon_sym_u16] = ACTIONS(2434),
    [anon_sym_i16] = ACTIONS(2434),
    [anon_sym_u32] = ACTIONS(2434),
    [anon_sym_i32] = ACTIONS(2434),
    [anon_sym_u64] = ACTIONS(2434),
    [anon_sym_i64] = ACTIONS(2434),
    [anon_sym_u128] = ACTIONS(2434),
    [anon_sym_i128] = ACTIONS(2434),
    [anon_sym_isize] = ACTIONS(2434),
    [anon_sym_usize] = ACTIONS(2434),
    [anon_sym_f32] = ACTIONS(2434),
    [anon_sym_f64] = ACTIONS(2434),
    [anon_sym_bool] = ACTIONS(2434),
    [anon_sym_str] = ACTIONS(2434),
    [anon_sym_char] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2432),
    [anon_sym_DOT_DOT] = ACTIONS(2432),
    [anon_sym_COLON_COLON] = ACTIONS(2432),
    [anon_sym_POUND] = ACTIONS(2432),
    [anon_sym_SQUOTE] = ACTIONS(2434),
    [anon_sym_async] = ACTIONS(2434),
    [anon_sym_break] = ACTIONS(2434),
    [anon_sym_const] = ACTIONS(2434),
    [anon_sym_continue] = ACTIONS(2434),
    [anon_sym_default] = ACTIONS(2434),
    [anon_sym_enum] = ACTIONS(2434),
    [anon_sym_fn] = ACTIONS(2434),
    [anon_sym_for] = ACTIONS(2434),
    [anon_sym_if] = ACTIONS(2434),
    [anon_sym_impl] = ACTIONS(2434),
    [anon_sym_let] = ACTIONS(2434),
    [anon_sym_loop] = ACTIONS(2434),
    [anon_sym_match] = ACTIONS(2434),
    [anon_sym_mod] = ACTIONS(2434),
    [anon_sym_pub] = ACTIONS(2434),
    [anon_sym_return] = ACTIONS(2434),
    [anon_sym_static] = ACTIONS(2434),
    [anon_sym_struct] = ACTIONS(2434),
    [anon_sym_trait] = ACTIONS(2434),
    [anon_sym_type] = ACTIONS(2434),
    [anon_sym_union] = ACTIONS(2434),
    [anon_sym_unsafe] = ACTIONS(2434),
    [anon_sym_use] = ACTIONS(2434),
    [anon_sym_while] = ACTIONS(2434),
    [anon_sym_extern] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(2434),
    [anon_sym_move] = ACTIONS(2434),
    [anon_sym_try] = ACTIONS(2434),
    [sym_integer_literal] = ACTIONS(2432),
    [aux_sym_string_literal_token1] = ACTIONS(2432),
    [sym_char_literal] = ACTIONS(2432),
    [anon_sym_true] = ACTIONS(2434),
    [anon_sym_false] = ACTIONS(2434),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2434),
    [sym_super] = ACTIONS(2434),
    [sym_crate] = ACTIONS(2434),
    [sym_metavariable] = ACTIONS(2432),
    [sym__raw_string_literal_start] = ACTIONS(2432),
    [sym_float_literal] = ACTIONS(2432),
  },
  [650] = {
    [sym_line_comment] = STATE(650),
    [sym_block_comment] = STATE(650),
    [ts_builtin_sym_end] = ACTIONS(2436),
    [sym_identifier] = ACTIONS(2438),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_macro_rules_BANG] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_u8] = ACTIONS(2438),
    [anon_sym_i8] = ACTIONS(2438),
    [anon_sym_u16] = ACTIONS(2438),
    [anon_sym_i16] = ACTIONS(2438),
    [anon_sym_u32] = ACTIONS(2438),
    [anon_sym_i32] = ACTIONS(2438),
    [anon_sym_u64] = ACTIONS(2438),
    [anon_sym_i64] = ACTIONS(2438),
    [anon_sym_u128] = ACTIONS(2438),
    [anon_sym_i128] = ACTIONS(2438),
    [anon_sym_isize] = ACTIONS(2438),
    [anon_sym_usize] = ACTIONS(2438),
    [anon_sym_f32] = ACTIONS(2438),
    [anon_sym_f64] = ACTIONS(2438),
    [anon_sym_bool] = ACTIONS(2438),
    [anon_sym_str] = ACTIONS(2438),
    [anon_sym_char] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_DOT_DOT] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(2436),
    [anon_sym_POUND] = ACTIONS(2436),
    [anon_sym_SQUOTE] = ACTIONS(2438),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_break] = ACTIONS(2438),
    [anon_sym_const] = ACTIONS(2438),
    [anon_sym_continue] = ACTIONS(2438),
    [anon_sym_default] = ACTIONS(2438),
    [anon_sym_enum] = ACTIONS(2438),
    [anon_sym_fn] = ACTIONS(2438),
    [anon_sym_for] = ACTIONS(2438),
    [anon_sym_if] = ACTIONS(2438),
    [anon_sym_impl] = ACTIONS(2438),
    [anon_sym_let] = ACTIONS(2438),
    [anon_sym_loop] = ACTIONS(2438),
    [anon_sym_match] = ACTIONS(2438),
    [anon_sym_mod] = ACTIONS(2438),
    [anon_sym_pub] = ACTIONS(2438),
    [anon_sym_return] = ACTIONS(2438),
    [anon_sym_static] = ACTIONS(2438),
    [anon_sym_struct] = ACTIONS(2438),
    [anon_sym_trait] = ACTIONS(2438),
    [anon_sym_type] = ACTIONS(2438),
    [anon_sym_union] = ACTIONS(2438),
    [anon_sym_unsafe] = ACTIONS(2438),
    [anon_sym_use] = ACTIONS(2438),
    [anon_sym_while] = ACTIONS(2438),
    [anon_sym_extern] = ACTIONS(2438),
    [anon_sym_yield] = ACTIONS(2438),
    [anon_sym_move] = ACTIONS(2438),
    [anon_sym_try] = ACTIONS(2438),
    [sym_integer_literal] = ACTIONS(2436),
    [aux_sym_string_literal_token1] = ACTIONS(2436),
    [sym_char_literal] = ACTIONS(2436),
    [anon_sym_true] = ACTIONS(2438),
    [anon_sym_false] = ACTIONS(2438),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2438),
    [sym_super] = ACTIONS(2438),
    [sym_crate] = ACTIONS(2438),
    [sym_metavariable] = ACTIONS(2436),
    [sym__raw_string_literal_start] = ACTIONS(2436),
    [sym_float_literal] = ACTIONS(2436),
  },
  [651] = {
    [sym_line_comment] = STATE(651),
    [sym_block_comment] = STATE(651),
    [ts_builtin_sym_end] = ACTIONS(2440),
    [sym_identifier] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_macro_rules_BANG] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_u8] = ACTIONS(2442),
    [anon_sym_i8] = ACTIONS(2442),
    [anon_sym_u16] = ACTIONS(2442),
    [anon_sym_i16] = ACTIONS(2442),
    [anon_sym_u32] = ACTIONS(2442),
    [anon_sym_i32] = ACTIONS(2442),
    [anon_sym_u64] = ACTIONS(2442),
    [anon_sym_i64] = ACTIONS(2442),
    [anon_sym_u128] = ACTIONS(2442),
    [anon_sym_i128] = ACTIONS(2442),
    [anon_sym_isize] = ACTIONS(2442),
    [anon_sym_usize] = ACTIONS(2442),
    [anon_sym_f32] = ACTIONS(2442),
    [anon_sym_f64] = ACTIONS(2442),
    [anon_sym_bool] = ACTIONS(2442),
    [anon_sym_str] = ACTIONS(2442),
    [anon_sym_char] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_DOT_DOT] = ACTIONS(2440),
    [anon_sym_COLON_COLON] = ACTIONS(2440),
    [anon_sym_POUND] = ACTIONS(2440),
    [anon_sym_SQUOTE] = ACTIONS(2442),
    [anon_sym_async] = ACTIONS(2442),
    [anon_sym_break] = ACTIONS(2442),
    [anon_sym_const] = ACTIONS(2442),
    [anon_sym_continue] = ACTIONS(2442),
    [anon_sym_default] = ACTIONS(2442),
    [anon_sym_enum] = ACTIONS(2442),
    [anon_sym_fn] = ACTIONS(2442),
    [anon_sym_for] = ACTIONS(2442),
    [anon_sym_if] = ACTIONS(2442),
    [anon_sym_impl] = ACTIONS(2442),
    [anon_sym_let] = ACTIONS(2442),
    [anon_sym_loop] = ACTIONS(2442),
    [anon_sym_match] = ACTIONS(2442),
    [anon_sym_mod] = ACTIONS(2442),
    [anon_sym_pub] = ACTIONS(2442),
    [anon_sym_return] = ACTIONS(2442),
    [anon_sym_static] = ACTIONS(2442),
    [anon_sym_struct] = ACTIONS(2442),
    [anon_sym_trait] = ACTIONS(2442),
    [anon_sym_type] = ACTIONS(2442),
    [anon_sym_union] = ACTIONS(2442),
    [anon_sym_unsafe] = ACTIONS(2442),
    [anon_sym_use] = ACTIONS(2442),
    [anon_sym_while] = ACTIONS(2442),
    [anon_sym_extern] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2442),
    [anon_sym_move] = ACTIONS(2442),
    [anon_sym_try] = ACTIONS(2442),
    [sym_integer_literal] = ACTIONS(2440),
    [aux_sym_string_literal_token1] = ACTIONS(2440),
    [sym_char_literal] = ACTIONS(2440),
    [anon_sym_true] = ACTIONS(2442),
    [anon_sym_false] = ACTIONS(2442),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2442),
    [sym_super] = ACTIONS(2442),
    [sym_crate] = ACTIONS(2442),
    [sym_metavariable] = ACTIONS(2440),
    [sym__raw_string_literal_start] = ACTIONS(2440),
    [sym_float_literal] = ACTIONS(2440),
  },
  [652] = {
    [sym_line_comment] = STATE(652),
    [sym_block_comment] = STATE(652),
    [ts_builtin_sym_end] = ACTIONS(2444),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_macro_rules_BANG] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_u8] = ACTIONS(2446),
    [anon_sym_i8] = ACTIONS(2446),
    [anon_sym_u16] = ACTIONS(2446),
    [anon_sym_i16] = ACTIONS(2446),
    [anon_sym_u32] = ACTIONS(2446),
    [anon_sym_i32] = ACTIONS(2446),
    [anon_sym_u64] = ACTIONS(2446),
    [anon_sym_i64] = ACTIONS(2446),
    [anon_sym_u128] = ACTIONS(2446),
    [anon_sym_i128] = ACTIONS(2446),
    [anon_sym_isize] = ACTIONS(2446),
    [anon_sym_usize] = ACTIONS(2446),
    [anon_sym_f32] = ACTIONS(2446),
    [anon_sym_f64] = ACTIONS(2446),
    [anon_sym_bool] = ACTIONS(2446),
    [anon_sym_str] = ACTIONS(2446),
    [anon_sym_char] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_DOT_DOT] = ACTIONS(2444),
    [anon_sym_COLON_COLON] = ACTIONS(2444),
    [anon_sym_POUND] = ACTIONS(2444),
    [anon_sym_SQUOTE] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_const] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_default] = ACTIONS(2446),
    [anon_sym_enum] = ACTIONS(2446),
    [anon_sym_fn] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_impl] = ACTIONS(2446),
    [anon_sym_let] = ACTIONS(2446),
    [anon_sym_loop] = ACTIONS(2446),
    [anon_sym_match] = ACTIONS(2446),
    [anon_sym_mod] = ACTIONS(2446),
    [anon_sym_pub] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_static] = ACTIONS(2446),
    [anon_sym_struct] = ACTIONS(2446),
    [anon_sym_trait] = ACTIONS(2446),
    [anon_sym_type] = ACTIONS(2446),
    [anon_sym_union] = ACTIONS(2446),
    [anon_sym_unsafe] = ACTIONS(2446),
    [anon_sym_use] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_extern] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_move] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [sym_integer_literal] = ACTIONS(2444),
    [aux_sym_string_literal_token1] = ACTIONS(2444),
    [sym_char_literal] = ACTIONS(2444),
    [anon_sym_true] = ACTIONS(2446),
    [anon_sym_false] = ACTIONS(2446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2446),
    [sym_super] = ACTIONS(2446),
    [sym_crate] = ACTIONS(2446),
    [sym_metavariable] = ACTIONS(2444),
    [sym__raw_string_literal_start] = ACTIONS(2444),
    [sym_float_literal] = ACTIONS(2444),
  },
  [653] = {
    [sym_line_comment] = STATE(653),
    [sym_block_comment] = STATE(653),
    [ts_builtin_sym_end] = ACTIONS(2448),
    [sym_identifier] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_macro_rules_BANG] = ACTIONS(2448),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_u8] = ACTIONS(2450),
    [anon_sym_i8] = ACTIONS(2450),
    [anon_sym_u16] = ACTIONS(2450),
    [anon_sym_i16] = ACTIONS(2450),
    [anon_sym_u32] = ACTIONS(2450),
    [anon_sym_i32] = ACTIONS(2450),
    [anon_sym_u64] = ACTIONS(2450),
    [anon_sym_i64] = ACTIONS(2450),
    [anon_sym_u128] = ACTIONS(2450),
    [anon_sym_i128] = ACTIONS(2450),
    [anon_sym_isize] = ACTIONS(2450),
    [anon_sym_usize] = ACTIONS(2450),
    [anon_sym_f32] = ACTIONS(2450),
    [anon_sym_f64] = ACTIONS(2450),
    [anon_sym_bool] = ACTIONS(2450),
    [anon_sym_str] = ACTIONS(2450),
    [anon_sym_char] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_DOT_DOT] = ACTIONS(2448),
    [anon_sym_COLON_COLON] = ACTIONS(2448),
    [anon_sym_POUND] = ACTIONS(2448),
    [anon_sym_SQUOTE] = ACTIONS(2450),
    [anon_sym_async] = ACTIONS(2450),
    [anon_sym_break] = ACTIONS(2450),
    [anon_sym_const] = ACTIONS(2450),
    [anon_sym_continue] = ACTIONS(2450),
    [anon_sym_default] = ACTIONS(2450),
    [anon_sym_enum] = ACTIONS(2450),
    [anon_sym_fn] = ACTIONS(2450),
    [anon_sym_for] = ACTIONS(2450),
    [anon_sym_if] = ACTIONS(2450),
    [anon_sym_impl] = ACTIONS(2450),
    [anon_sym_let] = ACTIONS(2450),
    [anon_sym_loop] = ACTIONS(2450),
    [anon_sym_match] = ACTIONS(2450),
    [anon_sym_mod] = ACTIONS(2450),
    [anon_sym_pub] = ACTIONS(2450),
    [anon_sym_return] = ACTIONS(2450),
    [anon_sym_static] = ACTIONS(2450),
    [anon_sym_struct] = ACTIONS(2450),
    [anon_sym_trait] = ACTIONS(2450),
    [anon_sym_type] = ACTIONS(2450),
    [anon_sym_union] = ACTIONS(2450),
    [anon_sym_unsafe] = ACTIONS(2450),
    [anon_sym_use] = ACTIONS(2450),
    [anon_sym_while] = ACTIONS(2450),
    [anon_sym_extern] = ACTIONS(2450),
    [anon_sym_yield] = ACTIONS(2450),
    [anon_sym_move] = ACTIONS(2450),
    [anon_sym_try] = ACTIONS(2450),
    [sym_integer_literal] = ACTIONS(2448),
    [aux_sym_string_literal_token1] = ACTIONS(2448),
    [sym_char_literal] = ACTIONS(2448),
    [anon_sym_true] = ACTIONS(2450),
    [anon_sym_false] = ACTIONS(2450),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2450),
    [sym_super] = ACTIONS(2450),
    [sym_crate] = ACTIONS(2450),
    [sym_metavariable] = ACTIONS(2448),
    [sym__raw_string_literal_start] = ACTIONS(2448),
    [sym_float_literal] = ACTIONS(2448),
  },
  [654] = {
    [sym_line_comment] = STATE(654),
    [sym_block_comment] = STATE(654),
    [ts_builtin_sym_end] = ACTIONS(2452),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_macro_rules_BANG] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_u8] = ACTIONS(2454),
    [anon_sym_i8] = ACTIONS(2454),
    [anon_sym_u16] = ACTIONS(2454),
    [anon_sym_i16] = ACTIONS(2454),
    [anon_sym_u32] = ACTIONS(2454),
    [anon_sym_i32] = ACTIONS(2454),
    [anon_sym_u64] = ACTIONS(2454),
    [anon_sym_i64] = ACTIONS(2454),
    [anon_sym_u128] = ACTIONS(2454),
    [anon_sym_i128] = ACTIONS(2454),
    [anon_sym_isize] = ACTIONS(2454),
    [anon_sym_usize] = ACTIONS(2454),
    [anon_sym_f32] = ACTIONS(2454),
    [anon_sym_f64] = ACTIONS(2454),
    [anon_sym_bool] = ACTIONS(2454),
    [anon_sym_str] = ACTIONS(2454),
    [anon_sym_char] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_DOT_DOT] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2452),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_break] = ACTIONS(2454),
    [anon_sym_const] = ACTIONS(2454),
    [anon_sym_continue] = ACTIONS(2454),
    [anon_sym_default] = ACTIONS(2454),
    [anon_sym_enum] = ACTIONS(2454),
    [anon_sym_fn] = ACTIONS(2454),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_impl] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_loop] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_mod] = ACTIONS(2454),
    [anon_sym_pub] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_struct] = ACTIONS(2454),
    [anon_sym_trait] = ACTIONS(2454),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_union] = ACTIONS(2454),
    [anon_sym_unsafe] = ACTIONS(2454),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_extern] = ACTIONS(2454),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_move] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [sym_integer_literal] = ACTIONS(2452),
    [aux_sym_string_literal_token1] = ACTIONS(2452),
    [sym_char_literal] = ACTIONS(2452),
    [anon_sym_true] = ACTIONS(2454),
    [anon_sym_false] = ACTIONS(2454),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2454),
    [sym_super] = ACTIONS(2454),
    [sym_crate] = ACTIONS(2454),
    [sym_metavariable] = ACTIONS(2452),
    [sym__raw_string_literal_start] = ACTIONS(2452),
    [sym_float_literal] = ACTIONS(2452),
  },
  [655] = {
    [sym_line_comment] = STATE(655),
    [sym_block_comment] = STATE(655),
    [ts_builtin_sym_end] = ACTIONS(2456),
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_macro_rules_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_u8] = ACTIONS(2458),
    [anon_sym_i8] = ACTIONS(2458),
    [anon_sym_u16] = ACTIONS(2458),
    [anon_sym_i16] = ACTIONS(2458),
    [anon_sym_u32] = ACTIONS(2458),
    [anon_sym_i32] = ACTIONS(2458),
    [anon_sym_u64] = ACTIONS(2458),
    [anon_sym_i64] = ACTIONS(2458),
    [anon_sym_u128] = ACTIONS(2458),
    [anon_sym_i128] = ACTIONS(2458),
    [anon_sym_isize] = ACTIONS(2458),
    [anon_sym_usize] = ACTIONS(2458),
    [anon_sym_f32] = ACTIONS(2458),
    [anon_sym_f64] = ACTIONS(2458),
    [anon_sym_bool] = ACTIONS(2458),
    [anon_sym_str] = ACTIONS(2458),
    [anon_sym_char] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_DOT_DOT] = ACTIONS(2456),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_POUND] = ACTIONS(2456),
    [anon_sym_SQUOTE] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_default] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
    [anon_sym_fn] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_impl] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_loop] = ACTIONS(2458),
    [anon_sym_match] = ACTIONS(2458),
    [anon_sym_mod] = ACTIONS(2458),
    [anon_sym_pub] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_struct] = ACTIONS(2458),
    [anon_sym_trait] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_union] = ACTIONS(2458),
    [anon_sym_unsafe] = ACTIONS(2458),
    [anon_sym_use] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_extern] = ACTIONS(2458),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_move] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [sym_integer_literal] = ACTIONS(2456),
    [aux_sym_string_literal_token1] = ACTIONS(2456),
    [sym_char_literal] = ACTIONS(2456),
    [anon_sym_true] = ACTIONS(2458),
    [anon_sym_false] = ACTIONS(2458),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_crate] = ACTIONS(2458),
    [sym_metavariable] = ACTIONS(2456),
    [sym__raw_string_literal_start] = ACTIONS(2456),
    [sym_float_literal] = ACTIONS(2456),
  },
  [656] = {
    [sym_line_comment] = STATE(656),
    [sym_block_comment] = STATE(656),
    [ts_builtin_sym_end] = ACTIONS(2460),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_macro_rules_BANG] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_u8] = ACTIONS(2462),
    [anon_sym_i8] = ACTIONS(2462),
    [anon_sym_u16] = ACTIONS(2462),
    [anon_sym_i16] = ACTIONS(2462),
    [anon_sym_u32] = ACTIONS(2462),
    [anon_sym_i32] = ACTIONS(2462),
    [anon_sym_u64] = ACTIONS(2462),
    [anon_sym_i64] = ACTIONS(2462),
    [anon_sym_u128] = ACTIONS(2462),
    [anon_sym_i128] = ACTIONS(2462),
    [anon_sym_isize] = ACTIONS(2462),
    [anon_sym_usize] = ACTIONS(2462),
    [anon_sym_f32] = ACTIONS(2462),
    [anon_sym_f64] = ACTIONS(2462),
    [anon_sym_bool] = ACTIONS(2462),
    [anon_sym_str] = ACTIONS(2462),
    [anon_sym_char] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_COLON_COLON] = ACTIONS(2460),
    [anon_sym_POUND] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2462),
    [anon_sym_async] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_fn] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_impl] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_loop] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_mod] = ACTIONS(2462),
    [anon_sym_pub] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_trait] = ACTIONS(2462),
    [anon_sym_type] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_unsafe] = ACTIONS(2462),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_move] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [sym_integer_literal] = ACTIONS(2460),
    [aux_sym_string_literal_token1] = ACTIONS(2460),
    [sym_char_literal] = ACTIONS(2460),
    [anon_sym_true] = ACTIONS(2462),
    [anon_sym_false] = ACTIONS(2462),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2462),
    [sym_super] = ACTIONS(2462),
    [sym_crate] = ACTIONS(2462),
    [sym_metavariable] = ACTIONS(2460),
    [sym__raw_string_literal_start] = ACTIONS(2460),
    [sym_float_literal] = ACTIONS(2460),
  },
  [657] = {
    [sym_line_comment] = STATE(657),
    [sym_block_comment] = STATE(657),
    [ts_builtin_sym_end] = ACTIONS(2464),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_macro_rules_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_u8] = ACTIONS(2466),
    [anon_sym_i8] = ACTIONS(2466),
    [anon_sym_u16] = ACTIONS(2466),
    [anon_sym_i16] = ACTIONS(2466),
    [anon_sym_u32] = ACTIONS(2466),
    [anon_sym_i32] = ACTIONS(2466),
    [anon_sym_u64] = ACTIONS(2466),
    [anon_sym_i64] = ACTIONS(2466),
    [anon_sym_u128] = ACTIONS(2466),
    [anon_sym_i128] = ACTIONS(2466),
    [anon_sym_isize] = ACTIONS(2466),
    [anon_sym_usize] = ACTIONS(2466),
    [anon_sym_f32] = ACTIONS(2466),
    [anon_sym_f64] = ACTIONS(2466),
    [anon_sym_bool] = ACTIONS(2466),
    [anon_sym_str] = ACTIONS(2466),
    [anon_sym_char] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_DOT_DOT] = ACTIONS(2464),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_POUND] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2466),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_fn] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_impl] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_loop] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_mod] = ACTIONS(2466),
    [anon_sym_pub] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_trait] = ACTIONS(2466),
    [anon_sym_type] = ACTIONS(2466),
    [anon_sym_union] = ACTIONS(2466),
    [anon_sym_unsafe] = ACTIONS(2466),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_move] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [sym_integer_literal] = ACTIONS(2464),
    [aux_sym_string_literal_token1] = ACTIONS(2464),
    [sym_char_literal] = ACTIONS(2464),
    [anon_sym_true] = ACTIONS(2466),
    [anon_sym_false] = ACTIONS(2466),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2466),
    [sym_super] = ACTIONS(2466),
    [sym_crate] = ACTIONS(2466),
    [sym_metavariable] = ACTIONS(2464),
    [sym__raw_string_literal_start] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
  },
  [658] = {
    [sym_line_comment] = STATE(658),
    [sym_block_comment] = STATE(658),
    [ts_builtin_sym_end] = ACTIONS(2468),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_macro_rules_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_u8] = ACTIONS(2470),
    [anon_sym_i8] = ACTIONS(2470),
    [anon_sym_u16] = ACTIONS(2470),
    [anon_sym_i16] = ACTIONS(2470),
    [anon_sym_u32] = ACTIONS(2470),
    [anon_sym_i32] = ACTIONS(2470),
    [anon_sym_u64] = ACTIONS(2470),
    [anon_sym_i64] = ACTIONS(2470),
    [anon_sym_u128] = ACTIONS(2470),
    [anon_sym_i128] = ACTIONS(2470),
    [anon_sym_isize] = ACTIONS(2470),
    [anon_sym_usize] = ACTIONS(2470),
    [anon_sym_f32] = ACTIONS(2470),
    [anon_sym_f64] = ACTIONS(2470),
    [anon_sym_bool] = ACTIONS(2470),
    [anon_sym_str] = ACTIONS(2470),
    [anon_sym_char] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_DOT_DOT] = ACTIONS(2468),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_POUND] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_fn] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_impl] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_loop] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_mod] = ACTIONS(2470),
    [anon_sym_pub] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_trait] = ACTIONS(2470),
    [anon_sym_type] = ACTIONS(2470),
    [anon_sym_union] = ACTIONS(2470),
    [anon_sym_unsafe] = ACTIONS(2470),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_move] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [sym_integer_literal] = ACTIONS(2468),
    [aux_sym_string_literal_token1] = ACTIONS(2468),
    [sym_char_literal] = ACTIONS(2468),
    [anon_sym_true] = ACTIONS(2470),
    [anon_sym_false] = ACTIONS(2470),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2470),
    [sym_super] = ACTIONS(2470),
    [sym_crate] = ACTIONS(2470),
    [sym_metavariable] = ACTIONS(2468),
    [sym__raw_string_literal_start] = ACTIONS(2468),
    [sym_float_literal] = ACTIONS(2468),
  },
  [659] = {
    [sym_line_comment] = STATE(659),
    [sym_block_comment] = STATE(659),
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_macro_rules_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_u8] = ACTIONS(2474),
    [anon_sym_i8] = ACTIONS(2474),
    [anon_sym_u16] = ACTIONS(2474),
    [anon_sym_i16] = ACTIONS(2474),
    [anon_sym_u32] = ACTIONS(2474),
    [anon_sym_i32] = ACTIONS(2474),
    [anon_sym_u64] = ACTIONS(2474),
    [anon_sym_i64] = ACTIONS(2474),
    [anon_sym_u128] = ACTIONS(2474),
    [anon_sym_i128] = ACTIONS(2474),
    [anon_sym_isize] = ACTIONS(2474),
    [anon_sym_usize] = ACTIONS(2474),
    [anon_sym_f32] = ACTIONS(2474),
    [anon_sym_f64] = ACTIONS(2474),
    [anon_sym_bool] = ACTIONS(2474),
    [anon_sym_str] = ACTIONS(2474),
    [anon_sym_char] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_POUND] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [anon_sym_fn] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_impl] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_loop] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_mod] = ACTIONS(2474),
    [anon_sym_pub] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2474),
    [anon_sym_trait] = ACTIONS(2474),
    [anon_sym_type] = ACTIONS(2474),
    [anon_sym_union] = ACTIONS(2474),
    [anon_sym_unsafe] = ACTIONS(2474),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_extern] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_move] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [sym_integer_literal] = ACTIONS(2472),
    [aux_sym_string_literal_token1] = ACTIONS(2472),
    [sym_char_literal] = ACTIONS(2472),
    [anon_sym_true] = ACTIONS(2474),
    [anon_sym_false] = ACTIONS(2474),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2474),
    [sym_super] = ACTIONS(2474),
    [sym_crate] = ACTIONS(2474),
    [sym_metavariable] = ACTIONS(2472),
    [sym__raw_string_literal_start] = ACTIONS(2472),
    [sym_float_literal] = ACTIONS(2472),
  },
  [660] = {
    [sym_line_comment] = STATE(660),
    [sym_block_comment] = STATE(660),
    [ts_builtin_sym_end] = ACTIONS(2476),
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_macro_rules_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2476),
    [anon_sym_u8] = ACTIONS(2478),
    [anon_sym_i8] = ACTIONS(2478),
    [anon_sym_u16] = ACTIONS(2478),
    [anon_sym_i16] = ACTIONS(2478),
    [anon_sym_u32] = ACTIONS(2478),
    [anon_sym_i32] = ACTIONS(2478),
    [anon_sym_u64] = ACTIONS(2478),
    [anon_sym_i64] = ACTIONS(2478),
    [anon_sym_u128] = ACTIONS(2478),
    [anon_sym_i128] = ACTIONS(2478),
    [anon_sym_isize] = ACTIONS(2478),
    [anon_sym_usize] = ACTIONS(2478),
    [anon_sym_f32] = ACTIONS(2478),
    [anon_sym_f64] = ACTIONS(2478),
    [anon_sym_bool] = ACTIONS(2478),
    [anon_sym_str] = ACTIONS(2478),
    [anon_sym_char] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_DOT_DOT] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_POUND] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
    [anon_sym_fn] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_impl] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_loop] = ACTIONS(2478),
    [anon_sym_match] = ACTIONS(2478),
    [anon_sym_mod] = ACTIONS(2478),
    [anon_sym_pub] = ACTIONS(2478),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_struct] = ACTIONS(2478),
    [anon_sym_trait] = ACTIONS(2478),
    [anon_sym_type] = ACTIONS(2478),
    [anon_sym_union] = ACTIONS(2478),
    [anon_sym_unsafe] = ACTIONS(2478),
    [anon_sym_use] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_extern] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_move] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [sym_integer_literal] = ACTIONS(2476),
    [aux_sym_string_literal_token1] = ACTIONS(2476),
    [sym_char_literal] = ACTIONS(2476),
    [anon_sym_true] = ACTIONS(2478),
    [anon_sym_false] = ACTIONS(2478),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2478),
    [sym_super] = ACTIONS(2478),
    [sym_crate] = ACTIONS(2478),
    [sym_metavariable] = ACTIONS(2476),
    [sym__raw_string_literal_start] = ACTIONS(2476),
    [sym_float_literal] = ACTIONS(2476),
  },
  [661] = {
    [sym_line_comment] = STATE(661),
    [sym_block_comment] = STATE(661),
    [ts_builtin_sym_end] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_macro_rules_BANG] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_STAR] = ACTIONS(2480),
    [anon_sym_u8] = ACTIONS(2482),
    [anon_sym_i8] = ACTIONS(2482),
    [anon_sym_u16] = ACTIONS(2482),
    [anon_sym_i16] = ACTIONS(2482),
    [anon_sym_u32] = ACTIONS(2482),
    [anon_sym_i32] = ACTIONS(2482),
    [anon_sym_u64] = ACTIONS(2482),
    [anon_sym_i64] = ACTIONS(2482),
    [anon_sym_u128] = ACTIONS(2482),
    [anon_sym_i128] = ACTIONS(2482),
    [anon_sym_isize] = ACTIONS(2482),
    [anon_sym_usize] = ACTIONS(2482),
    [anon_sym_f32] = ACTIONS(2482),
    [anon_sym_f64] = ACTIONS(2482),
    [anon_sym_bool] = ACTIONS(2482),
    [anon_sym_str] = ACTIONS(2482),
    [anon_sym_char] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2480),
    [anon_sym_DOT_DOT] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2480),
    [anon_sym_POUND] = ACTIONS(2480),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_fn] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_impl] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_loop] = ACTIONS(2482),
    [anon_sym_match] = ACTIONS(2482),
    [anon_sym_mod] = ACTIONS(2482),
    [anon_sym_pub] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_trait] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [anon_sym_unsafe] = ACTIONS(2482),
    [anon_sym_use] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_move] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [sym_integer_literal] = ACTIONS(2480),
    [aux_sym_string_literal_token1] = ACTIONS(2480),
    [sym_char_literal] = ACTIONS(2480),
    [anon_sym_true] = ACTIONS(2482),
    [anon_sym_false] = ACTIONS(2482),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_crate] = ACTIONS(2482),
    [sym_metavariable] = ACTIONS(2480),
    [sym__raw_string_literal_start] = ACTIONS(2480),
    [sym_float_literal] = ACTIONS(2480),
  },
  [662] = {
    [sym_line_comment] = STATE(662),
    [sym_block_comment] = STATE(662),
    [ts_builtin_sym_end] = ACTIONS(2484),
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_macro_rules_BANG] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_u8] = ACTIONS(2486),
    [anon_sym_i8] = ACTIONS(2486),
    [anon_sym_u16] = ACTIONS(2486),
    [anon_sym_i16] = ACTIONS(2486),
    [anon_sym_u32] = ACTIONS(2486),
    [anon_sym_i32] = ACTIONS(2486),
    [anon_sym_u64] = ACTIONS(2486),
    [anon_sym_i64] = ACTIONS(2486),
    [anon_sym_u128] = ACTIONS(2486),
    [anon_sym_i128] = ACTIONS(2486),
    [anon_sym_isize] = ACTIONS(2486),
    [anon_sym_usize] = ACTIONS(2486),
    [anon_sym_f32] = ACTIONS(2486),
    [anon_sym_f64] = ACTIONS(2486),
    [anon_sym_bool] = ACTIONS(2486),
    [anon_sym_str] = ACTIONS(2486),
    [anon_sym_char] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_DOT_DOT] = ACTIONS(2484),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_POUND] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2486),
    [anon_sym_break] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_continue] = ACTIONS(2486),
    [anon_sym_default] = ACTIONS(2486),
    [anon_sym_enum] = ACTIONS(2486),
    [anon_sym_fn] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_impl] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_loop] = ACTIONS(2486),
    [anon_sym_match] = ACTIONS(2486),
    [anon_sym_mod] = ACTIONS(2486),
    [anon_sym_pub] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_static] = ACTIONS(2486),
    [anon_sym_struct] = ACTIONS(2486),
    [anon_sym_trait] = ACTIONS(2486),
    [anon_sym_type] = ACTIONS(2486),
    [anon_sym_union] = ACTIONS(2486),
    [anon_sym_unsafe] = ACTIONS(2486),
    [anon_sym_use] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [anon_sym_extern] = ACTIONS(2486),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_move] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [sym_integer_literal] = ACTIONS(2484),
    [aux_sym_string_literal_token1] = ACTIONS(2484),
    [sym_char_literal] = ACTIONS(2484),
    [anon_sym_true] = ACTIONS(2486),
    [anon_sym_false] = ACTIONS(2486),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2486),
    [sym_super] = ACTIONS(2486),
    [sym_crate] = ACTIONS(2486),
    [sym_metavariable] = ACTIONS(2484),
    [sym__raw_string_literal_start] = ACTIONS(2484),
    [sym_float_literal] = ACTIONS(2484),
  },
  [663] = {
    [sym_line_comment] = STATE(663),
    [sym_block_comment] = STATE(663),
    [ts_builtin_sym_end] = ACTIONS(2488),
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_macro_rules_BANG] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_u8] = ACTIONS(2490),
    [anon_sym_i8] = ACTIONS(2490),
    [anon_sym_u16] = ACTIONS(2490),
    [anon_sym_i16] = ACTIONS(2490),
    [anon_sym_u32] = ACTIONS(2490),
    [anon_sym_i32] = ACTIONS(2490),
    [anon_sym_u64] = ACTIONS(2490),
    [anon_sym_i64] = ACTIONS(2490),
    [anon_sym_u128] = ACTIONS(2490),
    [anon_sym_i128] = ACTIONS(2490),
    [anon_sym_isize] = ACTIONS(2490),
    [anon_sym_usize] = ACTIONS(2490),
    [anon_sym_f32] = ACTIONS(2490),
    [anon_sym_f64] = ACTIONS(2490),
    [anon_sym_bool] = ACTIONS(2490),
    [anon_sym_str] = ACTIONS(2490),
    [anon_sym_char] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_PIPE] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2488),
    [anon_sym_DOT_DOT] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2488),
    [anon_sym_POUND] = ACTIONS(2488),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_default] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_fn] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_impl] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_loop] = ACTIONS(2490),
    [anon_sym_match] = ACTIONS(2490),
    [anon_sym_mod] = ACTIONS(2490),
    [anon_sym_pub] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_trait] = ACTIONS(2490),
    [anon_sym_type] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [anon_sym_unsafe] = ACTIONS(2490),
    [anon_sym_use] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym_yield] = ACTIONS(2490),
    [anon_sym_move] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [sym_integer_literal] = ACTIONS(2488),
    [aux_sym_string_literal_token1] = ACTIONS(2488),
    [sym_char_literal] = ACTIONS(2488),
    [anon_sym_true] = ACTIONS(2490),
    [anon_sym_false] = ACTIONS(2490),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2490),
    [sym_super] = ACTIONS(2490),
    [sym_crate] = ACTIONS(2490),
    [sym_metavariable] = ACTIONS(2488),
    [sym__raw_string_literal_start] = ACTIONS(2488),
    [sym_float_literal] = ACTIONS(2488),
  },
  [664] = {
    [sym_line_comment] = STATE(664),
    [sym_block_comment] = STATE(664),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_macro_rules_BANG] = ACTIONS(2492),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_u8] = ACTIONS(2494),
    [anon_sym_i8] = ACTIONS(2494),
    [anon_sym_u16] = ACTIONS(2494),
    [anon_sym_i16] = ACTIONS(2494),
    [anon_sym_u32] = ACTIONS(2494),
    [anon_sym_i32] = ACTIONS(2494),
    [anon_sym_u64] = ACTIONS(2494),
    [anon_sym_i64] = ACTIONS(2494),
    [anon_sym_u128] = ACTIONS(2494),
    [anon_sym_i128] = ACTIONS(2494),
    [anon_sym_isize] = ACTIONS(2494),
    [anon_sym_usize] = ACTIONS(2494),
    [anon_sym_f32] = ACTIONS(2494),
    [anon_sym_f64] = ACTIONS(2494),
    [anon_sym_bool] = ACTIONS(2494),
    [anon_sym_str] = ACTIONS(2494),
    [anon_sym_char] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_DOT_DOT] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_POUND] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_async] = ACTIONS(2494),
    [anon_sym_break] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_continue] = ACTIONS(2494),
    [anon_sym_default] = ACTIONS(2494),
    [anon_sym_enum] = ACTIONS(2494),
    [anon_sym_fn] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_impl] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_loop] = ACTIONS(2494),
    [anon_sym_match] = ACTIONS(2494),
    [anon_sym_mod] = ACTIONS(2494),
    [anon_sym_pub] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_static] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_trait] = ACTIONS(2494),
    [anon_sym_type] = ACTIONS(2494),
    [anon_sym_union] = ACTIONS(2494),
    [anon_sym_unsafe] = ACTIONS(2494),
    [anon_sym_use] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [anon_sym_extern] = ACTIONS(2494),
    [anon_sym_yield] = ACTIONS(2494),
    [anon_sym_move] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [sym_integer_literal] = ACTIONS(2492),
    [aux_sym_string_literal_token1] = ACTIONS(2492),
    [sym_char_literal] = ACTIONS(2492),
    [anon_sym_true] = ACTIONS(2494),
    [anon_sym_false] = ACTIONS(2494),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2494),
    [sym_super] = ACTIONS(2494),
    [sym_crate] = ACTIONS(2494),
    [sym_metavariable] = ACTIONS(2492),
    [sym__raw_string_literal_start] = ACTIONS(2492),
    [sym_float_literal] = ACTIONS(2492),
  },
  [665] = {
    [sym_line_comment] = STATE(665),
    [sym_block_comment] = STATE(665),
    [ts_builtin_sym_end] = ACTIONS(2496),
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_macro_rules_BANG] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2496),
    [anon_sym_u8] = ACTIONS(2498),
    [anon_sym_i8] = ACTIONS(2498),
    [anon_sym_u16] = ACTIONS(2498),
    [anon_sym_i16] = ACTIONS(2498),
    [anon_sym_u32] = ACTIONS(2498),
    [anon_sym_i32] = ACTIONS(2498),
    [anon_sym_u64] = ACTIONS(2498),
    [anon_sym_i64] = ACTIONS(2498),
    [anon_sym_u128] = ACTIONS(2498),
    [anon_sym_i128] = ACTIONS(2498),
    [anon_sym_isize] = ACTIONS(2498),
    [anon_sym_usize] = ACTIONS(2498),
    [anon_sym_f32] = ACTIONS(2498),
    [anon_sym_f64] = ACTIONS(2498),
    [anon_sym_bool] = ACTIONS(2498),
    [anon_sym_str] = ACTIONS(2498),
    [anon_sym_char] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(2496),
    [anon_sym_DOT_DOT] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2496),
    [anon_sym_POUND] = ACTIONS(2496),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_async] = ACTIONS(2498),
    [anon_sym_break] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_continue] = ACTIONS(2498),
    [anon_sym_default] = ACTIONS(2498),
    [anon_sym_enum] = ACTIONS(2498),
    [anon_sym_fn] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_impl] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_loop] = ACTIONS(2498),
    [anon_sym_match] = ACTIONS(2498),
    [anon_sym_mod] = ACTIONS(2498),
    [anon_sym_pub] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_static] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_trait] = ACTIONS(2498),
    [anon_sym_type] = ACTIONS(2498),
    [anon_sym_union] = ACTIONS(2498),
    [anon_sym_unsafe] = ACTIONS(2498),
    [anon_sym_use] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [anon_sym_extern] = ACTIONS(2498),
    [anon_sym_yield] = ACTIONS(2498),
    [anon_sym_move] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [sym_integer_literal] = ACTIONS(2496),
    [aux_sym_string_literal_token1] = ACTIONS(2496),
    [sym_char_literal] = ACTIONS(2496),
    [anon_sym_true] = ACTIONS(2498),
    [anon_sym_false] = ACTIONS(2498),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2498),
    [sym_super] = ACTIONS(2498),
    [sym_crate] = ACTIONS(2498),
    [sym_metavariable] = ACTIONS(2496),
    [sym__raw_string_literal_start] = ACTIONS(2496),
    [sym_float_literal] = ACTIONS(2496),
  },
  [666] = {
    [sym_line_comment] = STATE(666),
    [sym_block_comment] = STATE(666),
    [ts_builtin_sym_end] = ACTIONS(2500),
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2500),
    [anon_sym_macro_rules_BANG] = ACTIONS(2500),
    [anon_sym_LPAREN] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_u8] = ACTIONS(2502),
    [anon_sym_i8] = ACTIONS(2502),
    [anon_sym_u16] = ACTIONS(2502),
    [anon_sym_i16] = ACTIONS(2502),
    [anon_sym_u32] = ACTIONS(2502),
    [anon_sym_i32] = ACTIONS(2502),
    [anon_sym_u64] = ACTIONS(2502),
    [anon_sym_i64] = ACTIONS(2502),
    [anon_sym_u128] = ACTIONS(2502),
    [anon_sym_i128] = ACTIONS(2502),
    [anon_sym_isize] = ACTIONS(2502),
    [anon_sym_usize] = ACTIONS(2502),
    [anon_sym_f32] = ACTIONS(2502),
    [anon_sym_f64] = ACTIONS(2502),
    [anon_sym_bool] = ACTIONS(2502),
    [anon_sym_str] = ACTIONS(2502),
    [anon_sym_char] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2500),
    [anon_sym_DOT_DOT] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2500),
    [anon_sym_POUND] = ACTIONS(2500),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_async] = ACTIONS(2502),
    [anon_sym_break] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_continue] = ACTIONS(2502),
    [anon_sym_default] = ACTIONS(2502),
    [anon_sym_enum] = ACTIONS(2502),
    [anon_sym_fn] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_impl] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_loop] = ACTIONS(2502),
    [anon_sym_match] = ACTIONS(2502),
    [anon_sym_mod] = ACTIONS(2502),
    [anon_sym_pub] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_static] = ACTIONS(2502),
    [anon_sym_struct] = ACTIONS(2502),
    [anon_sym_trait] = ACTIONS(2502),
    [anon_sym_type] = ACTIONS(2502),
    [anon_sym_union] = ACTIONS(2502),
    [anon_sym_unsafe] = ACTIONS(2502),
    [anon_sym_use] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [anon_sym_extern] = ACTIONS(2502),
    [anon_sym_yield] = ACTIONS(2502),
    [anon_sym_move] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [sym_integer_literal] = ACTIONS(2500),
    [aux_sym_string_literal_token1] = ACTIONS(2500),
    [sym_char_literal] = ACTIONS(2500),
    [anon_sym_true] = ACTIONS(2502),
    [anon_sym_false] = ACTIONS(2502),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2502),
    [sym_super] = ACTIONS(2502),
    [sym_crate] = ACTIONS(2502),
    [sym_metavariable] = ACTIONS(2500),
    [sym__raw_string_literal_start] = ACTIONS(2500),
    [sym_float_literal] = ACTIONS(2500),
  },
  [667] = {
    [sym_empty_statement] = STATE(1389),
    [sym_macro_definition] = STATE(1389),
    [sym_attribute_item] = STATE(1389),
    [sym_inner_attribute_item] = STATE(1389),
    [sym_mod_item] = STATE(1389),
    [sym_foreign_mod_item] = STATE(1389),
    [sym_struct_item] = STATE(1389),
    [sym_union_item] = STATE(1389),
    [sym_enum_item] = STATE(1389),
    [sym_extern_crate_declaration] = STATE(1389),
    [sym_const_item] = STATE(1389),
    [sym_static_item] = STATE(1389),
    [sym_type_item] = STATE(1389),
    [sym_function_item] = STATE(1389),
    [sym_function_signature_item] = STATE(1389),
    [sym_function_modifiers] = STATE(3601),
    [sym_impl_item] = STATE(1389),
    [sym_trait_item] = STATE(1389),
    [sym_associated_type] = STATE(1389),
    [sym_let_declaration] = STATE(1389),
    [sym_use_declaration] = STATE(1389),
    [sym_extern_modifier] = STATE(2140),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3312),
    [sym_generic_type_with_turbofish] = STATE(3351),
    [sym_macro_invocation] = STATE(1389),
    [sym_scoped_identifier] = STATE(3243),
    [sym_line_comment] = STATE(667),
    [sym_block_comment] = STATE(667),
    [aux_sym_declaration_list_repeat1] = STATE(667),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_macro_rules_BANG] = ACTIONS(2510),
    [anon_sym_RBRACE] = ACTIONS(2513),
    [anon_sym_u8] = ACTIONS(2515),
    [anon_sym_i8] = ACTIONS(2515),
    [anon_sym_u16] = ACTIONS(2515),
    [anon_sym_i16] = ACTIONS(2515),
    [anon_sym_u32] = ACTIONS(2515),
    [anon_sym_i32] = ACTIONS(2515),
    [anon_sym_u64] = ACTIONS(2515),
    [anon_sym_i64] = ACTIONS(2515),
    [anon_sym_u128] = ACTIONS(2515),
    [anon_sym_i128] = ACTIONS(2515),
    [anon_sym_isize] = ACTIONS(2515),
    [anon_sym_usize] = ACTIONS(2515),
    [anon_sym_f32] = ACTIONS(2515),
    [anon_sym_f64] = ACTIONS(2515),
    [anon_sym_bool] = ACTIONS(2515),
    [anon_sym_str] = ACTIONS(2515),
    [anon_sym_char] = ACTIONS(2515),
    [anon_sym_LT] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2521),
    [anon_sym_POUND] = ACTIONS(2524),
    [anon_sym_async] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_default] = ACTIONS(2533),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_fn] = ACTIONS(2539),
    [anon_sym_impl] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2545),
    [anon_sym_mod] = ACTIONS(2548),
    [anon_sym_pub] = ACTIONS(2551),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2557),
    [anon_sym_trait] = ACTIONS(2560),
    [anon_sym_type] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2566),
    [anon_sym_unsafe] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2575),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_crate] = ACTIONS(2581),
    [sym_metavariable] = ACTIONS(2584),
  },
  [668] = {
    [sym_line_comment] = STATE(668),
    [sym_block_comment] = STATE(668),
    [ts_builtin_sym_end] = ACTIONS(2587),
    [sym_identifier] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym_macro_rules_BANG] = ACTIONS(2587),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [anon_sym_LBRACK] = ACTIONS(2587),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_RBRACE] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_u8] = ACTIONS(2589),
    [anon_sym_i8] = ACTIONS(2589),
    [anon_sym_u16] = ACTIONS(2589),
    [anon_sym_i16] = ACTIONS(2589),
    [anon_sym_u32] = ACTIONS(2589),
    [anon_sym_i32] = ACTIONS(2589),
    [anon_sym_u64] = ACTIONS(2589),
    [anon_sym_i64] = ACTIONS(2589),
    [anon_sym_u128] = ACTIONS(2589),
    [anon_sym_i128] = ACTIONS(2589),
    [anon_sym_isize] = ACTIONS(2589),
    [anon_sym_usize] = ACTIONS(2589),
    [anon_sym_f32] = ACTIONS(2589),
    [anon_sym_f64] = ACTIONS(2589),
    [anon_sym_bool] = ACTIONS(2589),
    [anon_sym_str] = ACTIONS(2589),
    [anon_sym_char] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2587),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_DOT_DOT] = ACTIONS(2587),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_POUND] = ACTIONS(2587),
    [anon_sym_SQUOTE] = ACTIONS(2589),
    [anon_sym_async] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_default] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_fn] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_impl] = ACTIONS(2589),
    [anon_sym_let] = ACTIONS(2589),
    [anon_sym_loop] = ACTIONS(2589),
    [anon_sym_match] = ACTIONS(2589),
    [anon_sym_mod] = ACTIONS(2589),
    [anon_sym_pub] = ACTIONS(2589),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_trait] = ACTIONS(2589),
    [anon_sym_type] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_unsafe] = ACTIONS(2589),
    [anon_sym_use] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym_yield] = ACTIONS(2589),
    [anon_sym_move] = ACTIONS(2589),
    [anon_sym_try] = ACTIONS(2589),
    [sym_integer_literal] = ACTIONS(2587),
    [aux_sym_string_literal_token1] = ACTIONS(2587),
    [sym_char_literal] = ACTIONS(2587),
    [anon_sym_true] = ACTIONS(2589),
    [anon_sym_false] = ACTIONS(2589),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2589),
    [sym_super] = ACTIONS(2589),
    [sym_crate] = ACTIONS(2589),
    [sym_metavariable] = ACTIONS(2587),
    [sym__raw_string_literal_start] = ACTIONS(2587),
    [sym_float_literal] = ACTIONS(2587),
  },
  [669] = {
    [sym_line_comment] = STATE(669),
    [sym_block_comment] = STATE(669),
    [ts_builtin_sym_end] = ACTIONS(2591),
    [sym_identifier] = ACTIONS(2593),
    [anon_sym_SEMI] = ACTIONS(2591),
    [anon_sym_macro_rules_BANG] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2591),
    [anon_sym_LBRACK] = ACTIONS(2591),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_RBRACE] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_u8] = ACTIONS(2593),
    [anon_sym_i8] = ACTIONS(2593),
    [anon_sym_u16] = ACTIONS(2593),
    [anon_sym_i16] = ACTIONS(2593),
    [anon_sym_u32] = ACTIONS(2593),
    [anon_sym_i32] = ACTIONS(2593),
    [anon_sym_u64] = ACTIONS(2593),
    [anon_sym_i64] = ACTIONS(2593),
    [anon_sym_u128] = ACTIONS(2593),
    [anon_sym_i128] = ACTIONS(2593),
    [anon_sym_isize] = ACTIONS(2593),
    [anon_sym_usize] = ACTIONS(2593),
    [anon_sym_f32] = ACTIONS(2593),
    [anon_sym_f64] = ACTIONS(2593),
    [anon_sym_bool] = ACTIONS(2593),
    [anon_sym_str] = ACTIONS(2593),
    [anon_sym_char] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_COLON_COLON] = ACTIONS(2591),
    [anon_sym_POUND] = ACTIONS(2591),
    [anon_sym_SQUOTE] = ACTIONS(2593),
    [anon_sym_async] = ACTIONS(2593),
    [anon_sym_break] = ACTIONS(2593),
    [anon_sym_const] = ACTIONS(2593),
    [anon_sym_continue] = ACTIONS(2593),
    [anon_sym_default] = ACTIONS(2593),
    [anon_sym_enum] = ACTIONS(2593),
    [anon_sym_fn] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2593),
    [anon_sym_impl] = ACTIONS(2593),
    [anon_sym_let] = ACTIONS(2593),
    [anon_sym_loop] = ACTIONS(2593),
    [anon_sym_match] = ACTIONS(2593),
    [anon_sym_mod] = ACTIONS(2593),
    [anon_sym_pub] = ACTIONS(2593),
    [anon_sym_return] = ACTIONS(2593),
    [anon_sym_static] = ACTIONS(2593),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_trait] = ACTIONS(2593),
    [anon_sym_type] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2593),
    [anon_sym_unsafe] = ACTIONS(2593),
    [anon_sym_use] = ACTIONS(2593),
    [anon_sym_while] = ACTIONS(2593),
    [anon_sym_extern] = ACTIONS(2593),
    [anon_sym_yield] = ACTIONS(2593),
    [anon_sym_move] = ACTIONS(2593),
    [anon_sym_try] = ACTIONS(2593),
    [sym_integer_literal] = ACTIONS(2591),
    [aux_sym_string_literal_token1] = ACTIONS(2591),
    [sym_char_literal] = ACTIONS(2591),
    [anon_sym_true] = ACTIONS(2593),
    [anon_sym_false] = ACTIONS(2593),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2593),
    [sym_super] = ACTIONS(2593),
    [sym_crate] = ACTIONS(2593),
    [sym_metavariable] = ACTIONS(2591),
    [sym__raw_string_literal_start] = ACTIONS(2591),
    [sym_float_literal] = ACTIONS(2591),
  },
  [670] = {
    [sym_line_comment] = STATE(670),
    [sym_block_comment] = STATE(670),
    [ts_builtin_sym_end] = ACTIONS(2595),
    [sym_identifier] = ACTIONS(2597),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_macro_rules_BANG] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2595),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_RBRACE] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_u8] = ACTIONS(2597),
    [anon_sym_i8] = ACTIONS(2597),
    [anon_sym_u16] = ACTIONS(2597),
    [anon_sym_i16] = ACTIONS(2597),
    [anon_sym_u32] = ACTIONS(2597),
    [anon_sym_i32] = ACTIONS(2597),
    [anon_sym_u64] = ACTIONS(2597),
    [anon_sym_i64] = ACTIONS(2597),
    [anon_sym_u128] = ACTIONS(2597),
    [anon_sym_i128] = ACTIONS(2597),
    [anon_sym_isize] = ACTIONS(2597),
    [anon_sym_usize] = ACTIONS(2597),
    [anon_sym_f32] = ACTIONS(2597),
    [anon_sym_f64] = ACTIONS(2597),
    [anon_sym_bool] = ACTIONS(2597),
    [anon_sym_str] = ACTIONS(2597),
    [anon_sym_char] = ACTIONS(2597),
    [anon_sym_DASH] = ACTIONS(2595),
    [anon_sym_BANG] = ACTIONS(2595),
    [anon_sym_AMP] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_LT] = ACTIONS(2595),
    [anon_sym_DOT_DOT] = ACTIONS(2595),
    [anon_sym_COLON_COLON] = ACTIONS(2595),
    [anon_sym_POUND] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2597),
    [anon_sym_async] = ACTIONS(2597),
    [anon_sym_break] = ACTIONS(2597),
    [anon_sym_const] = ACTIONS(2597),
    [anon_sym_continue] = ACTIONS(2597),
    [anon_sym_default] = ACTIONS(2597),
    [anon_sym_enum] = ACTIONS(2597),
    [anon_sym_fn] = ACTIONS(2597),
    [anon_sym_for] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(2597),
    [anon_sym_impl] = ACTIONS(2597),
    [anon_sym_let] = ACTIONS(2597),
    [anon_sym_loop] = ACTIONS(2597),
    [anon_sym_match] = ACTIONS(2597),
    [anon_sym_mod] = ACTIONS(2597),
    [anon_sym_pub] = ACTIONS(2597),
    [anon_sym_return] = ACTIONS(2597),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_struct] = ACTIONS(2597),
    [anon_sym_trait] = ACTIONS(2597),
    [anon_sym_type] = ACTIONS(2597),
    [anon_sym_union] = ACTIONS(2597),
    [anon_sym_unsafe] = ACTIONS(2597),
    [anon_sym_use] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2597),
    [anon_sym_extern] = ACTIONS(2597),
    [anon_sym_yield] = ACTIONS(2597),
    [anon_sym_move] = ACTIONS(2597),
    [anon_sym_try] = ACTIONS(2597),
    [sym_integer_literal] = ACTIONS(2595),
    [aux_sym_string_literal_token1] = ACTIONS(2595),
    [sym_char_literal] = ACTIONS(2595),
    [anon_sym_true] = ACTIONS(2597),
    [anon_sym_false] = ACTIONS(2597),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2597),
    [sym_super] = ACTIONS(2597),
    [sym_crate] = ACTIONS(2597),
    [sym_metavariable] = ACTIONS(2595),
    [sym__raw_string_literal_start] = ACTIONS(2595),
    [sym_float_literal] = ACTIONS(2595),
  },
  [671] = {
    [sym_line_comment] = STATE(671),
    [sym_block_comment] = STATE(671),
    [ts_builtin_sym_end] = ACTIONS(2599),
    [sym_identifier] = ACTIONS(2601),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym_macro_rules_BANG] = ACTIONS(2599),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACE] = ACTIONS(2599),
    [anon_sym_RBRACE] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(2599),
    [anon_sym_u8] = ACTIONS(2601),
    [anon_sym_i8] = ACTIONS(2601),
    [anon_sym_u16] = ACTIONS(2601),
    [anon_sym_i16] = ACTIONS(2601),
    [anon_sym_u32] = ACTIONS(2601),
    [anon_sym_i32] = ACTIONS(2601),
    [anon_sym_u64] = ACTIONS(2601),
    [anon_sym_i64] = ACTIONS(2601),
    [anon_sym_u128] = ACTIONS(2601),
    [anon_sym_i128] = ACTIONS(2601),
    [anon_sym_isize] = ACTIONS(2601),
    [anon_sym_usize] = ACTIONS(2601),
    [anon_sym_f32] = ACTIONS(2601),
    [anon_sym_f64] = ACTIONS(2601),
    [anon_sym_bool] = ACTIONS(2601),
    [anon_sym_str] = ACTIONS(2601),
    [anon_sym_char] = ACTIONS(2601),
    [anon_sym_DASH] = ACTIONS(2599),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_DOT_DOT] = ACTIONS(2599),
    [anon_sym_COLON_COLON] = ACTIONS(2599),
    [anon_sym_POUND] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2601),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_break] = ACTIONS(2601),
    [anon_sym_const] = ACTIONS(2601),
    [anon_sym_continue] = ACTIONS(2601),
    [anon_sym_default] = ACTIONS(2601),
    [anon_sym_enum] = ACTIONS(2601),
    [anon_sym_fn] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2601),
    [anon_sym_if] = ACTIONS(2601),
    [anon_sym_impl] = ACTIONS(2601),
    [anon_sym_let] = ACTIONS(2601),
    [anon_sym_loop] = ACTIONS(2601),
    [anon_sym_match] = ACTIONS(2601),
    [anon_sym_mod] = ACTIONS(2601),
    [anon_sym_pub] = ACTIONS(2601),
    [anon_sym_return] = ACTIONS(2601),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_struct] = ACTIONS(2601),
    [anon_sym_trait] = ACTIONS(2601),
    [anon_sym_type] = ACTIONS(2601),
    [anon_sym_union] = ACTIONS(2601),
    [anon_sym_unsafe] = ACTIONS(2601),
    [anon_sym_use] = ACTIONS(2601),
    [anon_sym_while] = ACTIONS(2601),
    [anon_sym_extern] = ACTIONS(2601),
    [anon_sym_yield] = ACTIONS(2601),
    [anon_sym_move] = ACTIONS(2601),
    [anon_sym_try] = ACTIONS(2601),
    [sym_integer_literal] = ACTIONS(2599),
    [aux_sym_string_literal_token1] = ACTIONS(2599),
    [sym_char_literal] = ACTIONS(2599),
    [anon_sym_true] = ACTIONS(2601),
    [anon_sym_false] = ACTIONS(2601),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2601),
    [sym_super] = ACTIONS(2601),
    [sym_crate] = ACTIONS(2601),
    [sym_metavariable] = ACTIONS(2599),
    [sym__raw_string_literal_start] = ACTIONS(2599),
    [sym_float_literal] = ACTIONS(2599),
  },
  [672] = {
    [sym_line_comment] = STATE(672),
    [sym_block_comment] = STATE(672),
    [ts_builtin_sym_end] = ACTIONS(2603),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym_macro_rules_BANG] = ACTIONS(2603),
    [anon_sym_LPAREN] = ACTIONS(2603),
    [anon_sym_LBRACK] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_RBRACE] = ACTIONS(2603),
    [anon_sym_STAR] = ACTIONS(2603),
    [anon_sym_u8] = ACTIONS(2605),
    [anon_sym_i8] = ACTIONS(2605),
    [anon_sym_u16] = ACTIONS(2605),
    [anon_sym_i16] = ACTIONS(2605),
    [anon_sym_u32] = ACTIONS(2605),
    [anon_sym_i32] = ACTIONS(2605),
    [anon_sym_u64] = ACTIONS(2605),
    [anon_sym_i64] = ACTIONS(2605),
    [anon_sym_u128] = ACTIONS(2605),
    [anon_sym_i128] = ACTIONS(2605),
    [anon_sym_isize] = ACTIONS(2605),
    [anon_sym_usize] = ACTIONS(2605),
    [anon_sym_f32] = ACTIONS(2605),
    [anon_sym_f64] = ACTIONS(2605),
    [anon_sym_bool] = ACTIONS(2605),
    [anon_sym_str] = ACTIONS(2605),
    [anon_sym_char] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2603),
    [anon_sym_BANG] = ACTIONS(2603),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(2603),
    [anon_sym_DOT_DOT] = ACTIONS(2603),
    [anon_sym_COLON_COLON] = ACTIONS(2603),
    [anon_sym_POUND] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(2605),
    [anon_sym_async] = ACTIONS(2605),
    [anon_sym_break] = ACTIONS(2605),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_continue] = ACTIONS(2605),
    [anon_sym_default] = ACTIONS(2605),
    [anon_sym_enum] = ACTIONS(2605),
    [anon_sym_fn] = ACTIONS(2605),
    [anon_sym_for] = ACTIONS(2605),
    [anon_sym_if] = ACTIONS(2605),
    [anon_sym_impl] = ACTIONS(2605),
    [anon_sym_let] = ACTIONS(2605),
    [anon_sym_loop] = ACTIONS(2605),
    [anon_sym_match] = ACTIONS(2605),
    [anon_sym_mod] = ACTIONS(2605),
    [anon_sym_pub] = ACTIONS(2605),
    [anon_sym_return] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2605),
    [anon_sym_struct] = ACTIONS(2605),
    [anon_sym_trait] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(2605),
    [anon_sym_union] = ACTIONS(2605),
    [anon_sym_unsafe] = ACTIONS(2605),
    [anon_sym_use] = ACTIONS(2605),
    [anon_sym_while] = ACTIONS(2605),
    [anon_sym_extern] = ACTIONS(2605),
    [anon_sym_yield] = ACTIONS(2605),
    [anon_sym_move] = ACTIONS(2605),
    [anon_sym_try] = ACTIONS(2605),
    [sym_integer_literal] = ACTIONS(2603),
    [aux_sym_string_literal_token1] = ACTIONS(2603),
    [sym_char_literal] = ACTIONS(2603),
    [anon_sym_true] = ACTIONS(2605),
    [anon_sym_false] = ACTIONS(2605),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2605),
    [sym_super] = ACTIONS(2605),
    [sym_crate] = ACTIONS(2605),
    [sym_metavariable] = ACTIONS(2603),
    [sym__raw_string_literal_start] = ACTIONS(2603),
    [sym_float_literal] = ACTIONS(2603),
  },
  [673] = {
    [sym_line_comment] = STATE(673),
    [sym_block_comment] = STATE(673),
    [ts_builtin_sym_end] = ACTIONS(2607),
    [sym_identifier] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2607),
    [anon_sym_macro_rules_BANG] = ACTIONS(2607),
    [anon_sym_LPAREN] = ACTIONS(2607),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [anon_sym_LBRACE] = ACTIONS(2607),
    [anon_sym_RBRACE] = ACTIONS(2607),
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_u8] = ACTIONS(2609),
    [anon_sym_i8] = ACTIONS(2609),
    [anon_sym_u16] = ACTIONS(2609),
    [anon_sym_i16] = ACTIONS(2609),
    [anon_sym_u32] = ACTIONS(2609),
    [anon_sym_i32] = ACTIONS(2609),
    [anon_sym_u64] = ACTIONS(2609),
    [anon_sym_i64] = ACTIONS(2609),
    [anon_sym_u128] = ACTIONS(2609),
    [anon_sym_i128] = ACTIONS(2609),
    [anon_sym_isize] = ACTIONS(2609),
    [anon_sym_usize] = ACTIONS(2609),
    [anon_sym_f32] = ACTIONS(2609),
    [anon_sym_f64] = ACTIONS(2609),
    [anon_sym_bool] = ACTIONS(2609),
    [anon_sym_str] = ACTIONS(2609),
    [anon_sym_char] = ACTIONS(2609),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_LT] = ACTIONS(2607),
    [anon_sym_DOT_DOT] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(2607),
    [anon_sym_POUND] = ACTIONS(2607),
    [anon_sym_SQUOTE] = ACTIONS(2609),
    [anon_sym_async] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_fn] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_impl] = ACTIONS(2609),
    [anon_sym_let] = ACTIONS(2609),
    [anon_sym_loop] = ACTIONS(2609),
    [anon_sym_match] = ACTIONS(2609),
    [anon_sym_mod] = ACTIONS(2609),
    [anon_sym_pub] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_trait] = ACTIONS(2609),
    [anon_sym_type] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_unsafe] = ACTIONS(2609),
    [anon_sym_use] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym_yield] = ACTIONS(2609),
    [anon_sym_move] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [sym_integer_literal] = ACTIONS(2607),
    [aux_sym_string_literal_token1] = ACTIONS(2607),
    [sym_char_literal] = ACTIONS(2607),
    [anon_sym_true] = ACTIONS(2609),
    [anon_sym_false] = ACTIONS(2609),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2609),
    [sym_super] = ACTIONS(2609),
    [sym_crate] = ACTIONS(2609),
    [sym_metavariable] = ACTIONS(2607),
    [sym__raw_string_literal_start] = ACTIONS(2607),
    [sym_float_literal] = ACTIONS(2607),
  },
  [674] = {
    [sym_line_comment] = STATE(674),
    [sym_block_comment] = STATE(674),
    [ts_builtin_sym_end] = ACTIONS(2611),
    [sym_identifier] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym_macro_rules_BANG] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_u8] = ACTIONS(2613),
    [anon_sym_i8] = ACTIONS(2613),
    [anon_sym_u16] = ACTIONS(2613),
    [anon_sym_i16] = ACTIONS(2613),
    [anon_sym_u32] = ACTIONS(2613),
    [anon_sym_i32] = ACTIONS(2613),
    [anon_sym_u64] = ACTIONS(2613),
    [anon_sym_i64] = ACTIONS(2613),
    [anon_sym_u128] = ACTIONS(2613),
    [anon_sym_i128] = ACTIONS(2613),
    [anon_sym_isize] = ACTIONS(2613),
    [anon_sym_usize] = ACTIONS(2613),
    [anon_sym_f32] = ACTIONS(2613),
    [anon_sym_f64] = ACTIONS(2613),
    [anon_sym_bool] = ACTIONS(2613),
    [anon_sym_str] = ACTIONS(2613),
    [anon_sym_char] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(2611),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_POUND] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_async] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_fn] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_impl] = ACTIONS(2613),
    [anon_sym_let] = ACTIONS(2613),
    [anon_sym_loop] = ACTIONS(2613),
    [anon_sym_match] = ACTIONS(2613),
    [anon_sym_mod] = ACTIONS(2613),
    [anon_sym_pub] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_trait] = ACTIONS(2613),
    [anon_sym_type] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_unsafe] = ACTIONS(2613),
    [anon_sym_use] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym_yield] = ACTIONS(2613),
    [anon_sym_move] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [sym_integer_literal] = ACTIONS(2611),
    [aux_sym_string_literal_token1] = ACTIONS(2611),
    [sym_char_literal] = ACTIONS(2611),
    [anon_sym_true] = ACTIONS(2613),
    [anon_sym_false] = ACTIONS(2613),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2613),
    [sym_super] = ACTIONS(2613),
    [sym_crate] = ACTIONS(2613),
    [sym_metavariable] = ACTIONS(2611),
    [sym__raw_string_literal_start] = ACTIONS(2611),
    [sym_float_literal] = ACTIONS(2611),
  },
  [675] = {
    [sym_line_comment] = STATE(675),
    [sym_block_comment] = STATE(675),
    [ts_builtin_sym_end] = ACTIONS(2615),
    [sym_identifier] = ACTIONS(2617),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_macro_rules_BANG] = ACTIONS(2615),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(2615),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_RBRACE] = ACTIONS(2615),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u8] = ACTIONS(2617),
    [anon_sym_i8] = ACTIONS(2617),
    [anon_sym_u16] = ACTIONS(2617),
    [anon_sym_i16] = ACTIONS(2617),
    [anon_sym_u32] = ACTIONS(2617),
    [anon_sym_i32] = ACTIONS(2617),
    [anon_sym_u64] = ACTIONS(2617),
    [anon_sym_i64] = ACTIONS(2617),
    [anon_sym_u128] = ACTIONS(2617),
    [anon_sym_i128] = ACTIONS(2617),
    [anon_sym_isize] = ACTIONS(2617),
    [anon_sym_usize] = ACTIONS(2617),
    [anon_sym_f32] = ACTIONS(2617),
    [anon_sym_f64] = ACTIONS(2617),
    [anon_sym_bool] = ACTIONS(2617),
    [anon_sym_str] = ACTIONS(2617),
    [anon_sym_char] = ACTIONS(2617),
    [anon_sym_DASH] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2615),
    [anon_sym_DOT_DOT] = ACTIONS(2615),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_POUND] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2617),
    [anon_sym_async] = ACTIONS(2617),
    [anon_sym_break] = ACTIONS(2617),
    [anon_sym_const] = ACTIONS(2617),
    [anon_sym_continue] = ACTIONS(2617),
    [anon_sym_default] = ACTIONS(2617),
    [anon_sym_enum] = ACTIONS(2617),
    [anon_sym_fn] = ACTIONS(2617),
    [anon_sym_for] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(2617),
    [anon_sym_impl] = ACTIONS(2617),
    [anon_sym_let] = ACTIONS(2617),
    [anon_sym_loop] = ACTIONS(2617),
    [anon_sym_match] = ACTIONS(2617),
    [anon_sym_mod] = ACTIONS(2617),
    [anon_sym_pub] = ACTIONS(2617),
    [anon_sym_return] = ACTIONS(2617),
    [anon_sym_static] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2617),
    [anon_sym_trait] = ACTIONS(2617),
    [anon_sym_type] = ACTIONS(2617),
    [anon_sym_union] = ACTIONS(2617),
    [anon_sym_unsafe] = ACTIONS(2617),
    [anon_sym_use] = ACTIONS(2617),
    [anon_sym_while] = ACTIONS(2617),
    [anon_sym_extern] = ACTIONS(2617),
    [anon_sym_yield] = ACTIONS(2617),
    [anon_sym_move] = ACTIONS(2617),
    [anon_sym_try] = ACTIONS(2617),
    [sym_integer_literal] = ACTIONS(2615),
    [aux_sym_string_literal_token1] = ACTIONS(2615),
    [sym_char_literal] = ACTIONS(2615),
    [anon_sym_true] = ACTIONS(2617),
    [anon_sym_false] = ACTIONS(2617),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2617),
    [sym_super] = ACTIONS(2617),
    [sym_crate] = ACTIONS(2617),
    [sym_metavariable] = ACTIONS(2615),
    [sym__raw_string_literal_start] = ACTIONS(2615),
    [sym_float_literal] = ACTIONS(2615),
  },
  [676] = {
    [sym_line_comment] = STATE(676),
    [sym_block_comment] = STATE(676),
    [ts_builtin_sym_end] = ACTIONS(2619),
    [sym_identifier] = ACTIONS(2621),
    [anon_sym_SEMI] = ACTIONS(2619),
    [anon_sym_macro_rules_BANG] = ACTIONS(2619),
    [anon_sym_LPAREN] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_RBRACE] = ACTIONS(2619),
    [anon_sym_STAR] = ACTIONS(2619),
    [anon_sym_u8] = ACTIONS(2621),
    [anon_sym_i8] = ACTIONS(2621),
    [anon_sym_u16] = ACTIONS(2621),
    [anon_sym_i16] = ACTIONS(2621),
    [anon_sym_u32] = ACTIONS(2621),
    [anon_sym_i32] = ACTIONS(2621),
    [anon_sym_u64] = ACTIONS(2621),
    [anon_sym_i64] = ACTIONS(2621),
    [anon_sym_u128] = ACTIONS(2621),
    [anon_sym_i128] = ACTIONS(2621),
    [anon_sym_isize] = ACTIONS(2621),
    [anon_sym_usize] = ACTIONS(2621),
    [anon_sym_f32] = ACTIONS(2621),
    [anon_sym_f64] = ACTIONS(2621),
    [anon_sym_bool] = ACTIONS(2621),
    [anon_sym_str] = ACTIONS(2621),
    [anon_sym_char] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2619),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_LT] = ACTIONS(2619),
    [anon_sym_DOT_DOT] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2619),
    [anon_sym_POUND] = ACTIONS(2619),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_async] = ACTIONS(2621),
    [anon_sym_break] = ACTIONS(2621),
    [anon_sym_const] = ACTIONS(2621),
    [anon_sym_continue] = ACTIONS(2621),
    [anon_sym_default] = ACTIONS(2621),
    [anon_sym_enum] = ACTIONS(2621),
    [anon_sym_fn] = ACTIONS(2621),
    [anon_sym_for] = ACTIONS(2621),
    [anon_sym_if] = ACTIONS(2621),
    [anon_sym_impl] = ACTIONS(2621),
    [anon_sym_let] = ACTIONS(2621),
    [anon_sym_loop] = ACTIONS(2621),
    [anon_sym_match] = ACTIONS(2621),
    [anon_sym_mod] = ACTIONS(2621),
    [anon_sym_pub] = ACTIONS(2621),
    [anon_sym_return] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2621),
    [anon_sym_struct] = ACTIONS(2621),
    [anon_sym_trait] = ACTIONS(2621),
    [anon_sym_type] = ACTIONS(2621),
    [anon_sym_union] = ACTIONS(2621),
    [anon_sym_unsafe] = ACTIONS(2621),
    [anon_sym_use] = ACTIONS(2621),
    [anon_sym_while] = ACTIONS(2621),
    [anon_sym_extern] = ACTIONS(2621),
    [anon_sym_yield] = ACTIONS(2621),
    [anon_sym_move] = ACTIONS(2621),
    [anon_sym_try] = ACTIONS(2621),
    [sym_integer_literal] = ACTIONS(2619),
    [aux_sym_string_literal_token1] = ACTIONS(2619),
    [sym_char_literal] = ACTIONS(2619),
    [anon_sym_true] = ACTIONS(2621),
    [anon_sym_false] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2621),
    [sym_super] = ACTIONS(2621),
    [sym_crate] = ACTIONS(2621),
    [sym_metavariable] = ACTIONS(2619),
    [sym__raw_string_literal_start] = ACTIONS(2619),
    [sym_float_literal] = ACTIONS(2619),
  },
  [677] = {
    [sym_line_comment] = STATE(677),
    [sym_block_comment] = STATE(677),
    [ts_builtin_sym_end] = ACTIONS(2623),
    [sym_identifier] = ACTIONS(2625),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym_macro_rules_BANG] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_RBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_u8] = ACTIONS(2625),
    [anon_sym_i8] = ACTIONS(2625),
    [anon_sym_u16] = ACTIONS(2625),
    [anon_sym_i16] = ACTIONS(2625),
    [anon_sym_u32] = ACTIONS(2625),
    [anon_sym_i32] = ACTIONS(2625),
    [anon_sym_u64] = ACTIONS(2625),
    [anon_sym_i64] = ACTIONS(2625),
    [anon_sym_u128] = ACTIONS(2625),
    [anon_sym_i128] = ACTIONS(2625),
    [anon_sym_isize] = ACTIONS(2625),
    [anon_sym_usize] = ACTIONS(2625),
    [anon_sym_f32] = ACTIONS(2625),
    [anon_sym_f64] = ACTIONS(2625),
    [anon_sym_bool] = ACTIONS(2625),
    [anon_sym_str] = ACTIONS(2625),
    [anon_sym_char] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2623),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_LT] = ACTIONS(2623),
    [anon_sym_DOT_DOT] = ACTIONS(2623),
    [anon_sym_COLON_COLON] = ACTIONS(2623),
    [anon_sym_POUND] = ACTIONS(2623),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [anon_sym_async] = ACTIONS(2625),
    [anon_sym_break] = ACTIONS(2625),
    [anon_sym_const] = ACTIONS(2625),
    [anon_sym_continue] = ACTIONS(2625),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_enum] = ACTIONS(2625),
    [anon_sym_fn] = ACTIONS(2625),
    [anon_sym_for] = ACTIONS(2625),
    [anon_sym_if] = ACTIONS(2625),
    [anon_sym_impl] = ACTIONS(2625),
    [anon_sym_let] = ACTIONS(2625),
    [anon_sym_loop] = ACTIONS(2625),
    [anon_sym_match] = ACTIONS(2625),
    [anon_sym_mod] = ACTIONS(2625),
    [anon_sym_pub] = ACTIONS(2625),
    [anon_sym_return] = ACTIONS(2625),
    [anon_sym_static] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2625),
    [anon_sym_trait] = ACTIONS(2625),
    [anon_sym_type] = ACTIONS(2625),
    [anon_sym_union] = ACTIONS(2625),
    [anon_sym_unsafe] = ACTIONS(2625),
    [anon_sym_use] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2625),
    [anon_sym_extern] = ACTIONS(2625),
    [anon_sym_yield] = ACTIONS(2625),
    [anon_sym_move] = ACTIONS(2625),
    [anon_sym_try] = ACTIONS(2625),
    [sym_integer_literal] = ACTIONS(2623),
    [aux_sym_string_literal_token1] = ACTIONS(2623),
    [sym_char_literal] = ACTIONS(2623),
    [anon_sym_true] = ACTIONS(2625),
    [anon_sym_false] = ACTIONS(2625),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2625),
    [sym_super] = ACTIONS(2625),
    [sym_crate] = ACTIONS(2625),
    [sym_metavariable] = ACTIONS(2623),
    [sym__raw_string_literal_start] = ACTIONS(2623),
    [sym_float_literal] = ACTIONS(2623),
  },
  [678] = {
    [sym_line_comment] = STATE(678),
    [sym_block_comment] = STATE(678),
    [ts_builtin_sym_end] = ACTIONS(2627),
    [sym_identifier] = ACTIONS(2629),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym_macro_rules_BANG] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_u8] = ACTIONS(2629),
    [anon_sym_i8] = ACTIONS(2629),
    [anon_sym_u16] = ACTIONS(2629),
    [anon_sym_i16] = ACTIONS(2629),
    [anon_sym_u32] = ACTIONS(2629),
    [anon_sym_i32] = ACTIONS(2629),
    [anon_sym_u64] = ACTIONS(2629),
    [anon_sym_i64] = ACTIONS(2629),
    [anon_sym_u128] = ACTIONS(2629),
    [anon_sym_i128] = ACTIONS(2629),
    [anon_sym_isize] = ACTIONS(2629),
    [anon_sym_usize] = ACTIONS(2629),
    [anon_sym_f32] = ACTIONS(2629),
    [anon_sym_f64] = ACTIONS(2629),
    [anon_sym_bool] = ACTIONS(2629),
    [anon_sym_str] = ACTIONS(2629),
    [anon_sym_char] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2627),
    [anon_sym_DOT_DOT] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2627),
    [anon_sym_POUND] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [anon_sym_async] = ACTIONS(2629),
    [anon_sym_break] = ACTIONS(2629),
    [anon_sym_const] = ACTIONS(2629),
    [anon_sym_continue] = ACTIONS(2629),
    [anon_sym_default] = ACTIONS(2629),
    [anon_sym_enum] = ACTIONS(2629),
    [anon_sym_fn] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_if] = ACTIONS(2629),
    [anon_sym_impl] = ACTIONS(2629),
    [anon_sym_let] = ACTIONS(2629),
    [anon_sym_loop] = ACTIONS(2629),
    [anon_sym_match] = ACTIONS(2629),
    [anon_sym_mod] = ACTIONS(2629),
    [anon_sym_pub] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2629),
    [anon_sym_static] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2629),
    [anon_sym_trait] = ACTIONS(2629),
    [anon_sym_type] = ACTIONS(2629),
    [anon_sym_union] = ACTIONS(2629),
    [anon_sym_unsafe] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2629),
    [anon_sym_while] = ACTIONS(2629),
    [anon_sym_extern] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2629),
    [anon_sym_move] = ACTIONS(2629),
    [anon_sym_try] = ACTIONS(2629),
    [sym_integer_literal] = ACTIONS(2627),
    [aux_sym_string_literal_token1] = ACTIONS(2627),
    [sym_char_literal] = ACTIONS(2627),
    [anon_sym_true] = ACTIONS(2629),
    [anon_sym_false] = ACTIONS(2629),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2629),
    [sym_super] = ACTIONS(2629),
    [sym_crate] = ACTIONS(2629),
    [sym_metavariable] = ACTIONS(2627),
    [sym__raw_string_literal_start] = ACTIONS(2627),
    [sym_float_literal] = ACTIONS(2627),
  },
  [679] = {
    [sym_line_comment] = STATE(679),
    [sym_block_comment] = STATE(679),
    [ts_builtin_sym_end] = ACTIONS(2631),
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym_macro_rules_BANG] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_RBRACE] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_u8] = ACTIONS(2633),
    [anon_sym_i8] = ACTIONS(2633),
    [anon_sym_u16] = ACTIONS(2633),
    [anon_sym_i16] = ACTIONS(2633),
    [anon_sym_u32] = ACTIONS(2633),
    [anon_sym_i32] = ACTIONS(2633),
    [anon_sym_u64] = ACTIONS(2633),
    [anon_sym_i64] = ACTIONS(2633),
    [anon_sym_u128] = ACTIONS(2633),
    [anon_sym_i128] = ACTIONS(2633),
    [anon_sym_isize] = ACTIONS(2633),
    [anon_sym_usize] = ACTIONS(2633),
    [anon_sym_f32] = ACTIONS(2633),
    [anon_sym_f64] = ACTIONS(2633),
    [anon_sym_bool] = ACTIONS(2633),
    [anon_sym_str] = ACTIONS(2633),
    [anon_sym_char] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_DOT_DOT] = ACTIONS(2631),
    [anon_sym_COLON_COLON] = ACTIONS(2631),
    [anon_sym_POUND] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2633),
    [anon_sym_async] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_continue] = ACTIONS(2633),
    [anon_sym_default] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_fn] = ACTIONS(2633),
    [anon_sym_for] = ACTIONS(2633),
    [anon_sym_if] = ACTIONS(2633),
    [anon_sym_impl] = ACTIONS(2633),
    [anon_sym_let] = ACTIONS(2633),
    [anon_sym_loop] = ACTIONS(2633),
    [anon_sym_match] = ACTIONS(2633),
    [anon_sym_mod] = ACTIONS(2633),
    [anon_sym_pub] = ACTIONS(2633),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_trait] = ACTIONS(2633),
    [anon_sym_type] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [anon_sym_unsafe] = ACTIONS(2633),
    [anon_sym_use] = ACTIONS(2633),
    [anon_sym_while] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_move] = ACTIONS(2633),
    [anon_sym_try] = ACTIONS(2633),
    [sym_integer_literal] = ACTIONS(2631),
    [aux_sym_string_literal_token1] = ACTIONS(2631),
    [sym_char_literal] = ACTIONS(2631),
    [anon_sym_true] = ACTIONS(2633),
    [anon_sym_false] = ACTIONS(2633),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2633),
    [sym_super] = ACTIONS(2633),
    [sym_crate] = ACTIONS(2633),
    [sym_metavariable] = ACTIONS(2631),
    [sym__raw_string_literal_start] = ACTIONS(2631),
    [sym_float_literal] = ACTIONS(2631),
  },
  [680] = {
    [sym_line_comment] = STATE(680),
    [sym_block_comment] = STATE(680),
    [ts_builtin_sym_end] = ACTIONS(2635),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym_macro_rules_BANG] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_RBRACE] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u8] = ACTIONS(2637),
    [anon_sym_i8] = ACTIONS(2637),
    [anon_sym_u16] = ACTIONS(2637),
    [anon_sym_i16] = ACTIONS(2637),
    [anon_sym_u32] = ACTIONS(2637),
    [anon_sym_i32] = ACTIONS(2637),
    [anon_sym_u64] = ACTIONS(2637),
    [anon_sym_i64] = ACTIONS(2637),
    [anon_sym_u128] = ACTIONS(2637),
    [anon_sym_i128] = ACTIONS(2637),
    [anon_sym_isize] = ACTIONS(2637),
    [anon_sym_usize] = ACTIONS(2637),
    [anon_sym_f32] = ACTIONS(2637),
    [anon_sym_f64] = ACTIONS(2637),
    [anon_sym_bool] = ACTIONS(2637),
    [anon_sym_str] = ACTIONS(2637),
    [anon_sym_char] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_PIPE] = ACTIONS(2635),
    [anon_sym_LT] = ACTIONS(2635),
    [anon_sym_DOT_DOT] = ACTIONS(2635),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_POUND] = ACTIONS(2635),
    [anon_sym_SQUOTE] = ACTIONS(2637),
    [anon_sym_async] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_fn] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_impl] = ACTIONS(2637),
    [anon_sym_let] = ACTIONS(2637),
    [anon_sym_loop] = ACTIONS(2637),
    [anon_sym_match] = ACTIONS(2637),
    [anon_sym_mod] = ACTIONS(2637),
    [anon_sym_pub] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_trait] = ACTIONS(2637),
    [anon_sym_type] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_unsafe] = ACTIONS(2637),
    [anon_sym_use] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym_yield] = ACTIONS(2637),
    [anon_sym_move] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [sym_integer_literal] = ACTIONS(2635),
    [aux_sym_string_literal_token1] = ACTIONS(2635),
    [sym_char_literal] = ACTIONS(2635),
    [anon_sym_true] = ACTIONS(2637),
    [anon_sym_false] = ACTIONS(2637),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2637),
    [sym_super] = ACTIONS(2637),
    [sym_crate] = ACTIONS(2637),
    [sym_metavariable] = ACTIONS(2635),
    [sym__raw_string_literal_start] = ACTIONS(2635),
    [sym_float_literal] = ACTIONS(2635),
  },
  [681] = {
    [sym_line_comment] = STATE(681),
    [sym_block_comment] = STATE(681),
    [ts_builtin_sym_end] = ACTIONS(2639),
    [sym_identifier] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym_macro_rules_BANG] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_u8] = ACTIONS(2641),
    [anon_sym_i8] = ACTIONS(2641),
    [anon_sym_u16] = ACTIONS(2641),
    [anon_sym_i16] = ACTIONS(2641),
    [anon_sym_u32] = ACTIONS(2641),
    [anon_sym_i32] = ACTIONS(2641),
    [anon_sym_u64] = ACTIONS(2641),
    [anon_sym_i64] = ACTIONS(2641),
    [anon_sym_u128] = ACTIONS(2641),
    [anon_sym_i128] = ACTIONS(2641),
    [anon_sym_isize] = ACTIONS(2641),
    [anon_sym_usize] = ACTIONS(2641),
    [anon_sym_f32] = ACTIONS(2641),
    [anon_sym_f64] = ACTIONS(2641),
    [anon_sym_bool] = ACTIONS(2641),
    [anon_sym_str] = ACTIONS(2641),
    [anon_sym_char] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_LT] = ACTIONS(2639),
    [anon_sym_DOT_DOT] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_POUND] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_async] = ACTIONS(2641),
    [anon_sym_break] = ACTIONS(2641),
    [anon_sym_const] = ACTIONS(2641),
    [anon_sym_continue] = ACTIONS(2641),
    [anon_sym_default] = ACTIONS(2641),
    [anon_sym_enum] = ACTIONS(2641),
    [anon_sym_fn] = ACTIONS(2641),
    [anon_sym_for] = ACTIONS(2641),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_impl] = ACTIONS(2641),
    [anon_sym_let] = ACTIONS(2641),
    [anon_sym_loop] = ACTIONS(2641),
    [anon_sym_match] = ACTIONS(2641),
    [anon_sym_mod] = ACTIONS(2641),
    [anon_sym_pub] = ACTIONS(2641),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_struct] = ACTIONS(2641),
    [anon_sym_trait] = ACTIONS(2641),
    [anon_sym_type] = ACTIONS(2641),
    [anon_sym_union] = ACTIONS(2641),
    [anon_sym_unsafe] = ACTIONS(2641),
    [anon_sym_use] = ACTIONS(2641),
    [anon_sym_while] = ACTIONS(2641),
    [anon_sym_extern] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2641),
    [anon_sym_move] = ACTIONS(2641),
    [anon_sym_try] = ACTIONS(2641),
    [sym_integer_literal] = ACTIONS(2639),
    [aux_sym_string_literal_token1] = ACTIONS(2639),
    [sym_char_literal] = ACTIONS(2639),
    [anon_sym_true] = ACTIONS(2641),
    [anon_sym_false] = ACTIONS(2641),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2641),
    [sym_super] = ACTIONS(2641),
    [sym_crate] = ACTIONS(2641),
    [sym_metavariable] = ACTIONS(2639),
    [sym__raw_string_literal_start] = ACTIONS(2639),
    [sym_float_literal] = ACTIONS(2639),
  },
  [682] = {
    [sym_line_comment] = STATE(682),
    [sym_block_comment] = STATE(682),
    [ts_builtin_sym_end] = ACTIONS(2643),
    [sym_identifier] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2643),
    [anon_sym_macro_rules_BANG] = ACTIONS(2643),
    [anon_sym_LPAREN] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_RBRACE] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2643),
    [anon_sym_u8] = ACTIONS(2645),
    [anon_sym_i8] = ACTIONS(2645),
    [anon_sym_u16] = ACTIONS(2645),
    [anon_sym_i16] = ACTIONS(2645),
    [anon_sym_u32] = ACTIONS(2645),
    [anon_sym_i32] = ACTIONS(2645),
    [anon_sym_u64] = ACTIONS(2645),
    [anon_sym_i64] = ACTIONS(2645),
    [anon_sym_u128] = ACTIONS(2645),
    [anon_sym_i128] = ACTIONS(2645),
    [anon_sym_isize] = ACTIONS(2645),
    [anon_sym_usize] = ACTIONS(2645),
    [anon_sym_f32] = ACTIONS(2645),
    [anon_sym_f64] = ACTIONS(2645),
    [anon_sym_bool] = ACTIONS(2645),
    [anon_sym_str] = ACTIONS(2645),
    [anon_sym_char] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_BANG] = ACTIONS(2643),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_PIPE] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2643),
    [anon_sym_DOT_DOT] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2643),
    [anon_sym_POUND] = ACTIONS(2643),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_async] = ACTIONS(2645),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_continue] = ACTIONS(2645),
    [anon_sym_default] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_fn] = ACTIONS(2645),
    [anon_sym_for] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(2645),
    [anon_sym_impl] = ACTIONS(2645),
    [anon_sym_let] = ACTIONS(2645),
    [anon_sym_loop] = ACTIONS(2645),
    [anon_sym_match] = ACTIONS(2645),
    [anon_sym_mod] = ACTIONS(2645),
    [anon_sym_pub] = ACTIONS(2645),
    [anon_sym_return] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_trait] = ACTIONS(2645),
    [anon_sym_type] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [anon_sym_unsafe] = ACTIONS(2645),
    [anon_sym_use] = ACTIONS(2645),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym_yield] = ACTIONS(2645),
    [anon_sym_move] = ACTIONS(2645),
    [anon_sym_try] = ACTIONS(2645),
    [sym_integer_literal] = ACTIONS(2643),
    [aux_sym_string_literal_token1] = ACTIONS(2643),
    [sym_char_literal] = ACTIONS(2643),
    [anon_sym_true] = ACTIONS(2645),
    [anon_sym_false] = ACTIONS(2645),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2645),
    [sym_super] = ACTIONS(2645),
    [sym_crate] = ACTIONS(2645),
    [sym_metavariable] = ACTIONS(2643),
    [sym__raw_string_literal_start] = ACTIONS(2643),
    [sym_float_literal] = ACTIONS(2643),
  },
  [683] = {
    [sym_line_comment] = STATE(683),
    [sym_block_comment] = STATE(683),
    [ts_builtin_sym_end] = ACTIONS(2647),
    [sym_identifier] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym_macro_rules_BANG] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_u8] = ACTIONS(2649),
    [anon_sym_i8] = ACTIONS(2649),
    [anon_sym_u16] = ACTIONS(2649),
    [anon_sym_i16] = ACTIONS(2649),
    [anon_sym_u32] = ACTIONS(2649),
    [anon_sym_i32] = ACTIONS(2649),
    [anon_sym_u64] = ACTIONS(2649),
    [anon_sym_i64] = ACTIONS(2649),
    [anon_sym_u128] = ACTIONS(2649),
    [anon_sym_i128] = ACTIONS(2649),
    [anon_sym_isize] = ACTIONS(2649),
    [anon_sym_usize] = ACTIONS(2649),
    [anon_sym_f32] = ACTIONS(2649),
    [anon_sym_f64] = ACTIONS(2649),
    [anon_sym_bool] = ACTIONS(2649),
    [anon_sym_str] = ACTIONS(2649),
    [anon_sym_char] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_DOT_DOT] = ACTIONS(2647),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_POUND] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_async] = ACTIONS(2649),
    [anon_sym_break] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_continue] = ACTIONS(2649),
    [anon_sym_default] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_fn] = ACTIONS(2649),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_impl] = ACTIONS(2649),
    [anon_sym_let] = ACTIONS(2649),
    [anon_sym_loop] = ACTIONS(2649),
    [anon_sym_match] = ACTIONS(2649),
    [anon_sym_mod] = ACTIONS(2649),
    [anon_sym_pub] = ACTIONS(2649),
    [anon_sym_return] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_trait] = ACTIONS(2649),
    [anon_sym_type] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [anon_sym_unsafe] = ACTIONS(2649),
    [anon_sym_use] = ACTIONS(2649),
    [anon_sym_while] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym_yield] = ACTIONS(2649),
    [anon_sym_move] = ACTIONS(2649),
    [anon_sym_try] = ACTIONS(2649),
    [sym_integer_literal] = ACTIONS(2647),
    [aux_sym_string_literal_token1] = ACTIONS(2647),
    [sym_char_literal] = ACTIONS(2647),
    [anon_sym_true] = ACTIONS(2649),
    [anon_sym_false] = ACTIONS(2649),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2649),
    [sym_super] = ACTIONS(2649),
    [sym_crate] = ACTIONS(2649),
    [sym_metavariable] = ACTIONS(2647),
    [sym__raw_string_literal_start] = ACTIONS(2647),
    [sym_float_literal] = ACTIONS(2647),
  },
  [684] = {
    [sym_line_comment] = STATE(684),
    [sym_block_comment] = STATE(684),
    [ts_builtin_sym_end] = ACTIONS(2651),
    [sym_identifier] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym_macro_rules_BANG] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_u8] = ACTIONS(2653),
    [anon_sym_i8] = ACTIONS(2653),
    [anon_sym_u16] = ACTIONS(2653),
    [anon_sym_i16] = ACTIONS(2653),
    [anon_sym_u32] = ACTIONS(2653),
    [anon_sym_i32] = ACTIONS(2653),
    [anon_sym_u64] = ACTIONS(2653),
    [anon_sym_i64] = ACTIONS(2653),
    [anon_sym_u128] = ACTIONS(2653),
    [anon_sym_i128] = ACTIONS(2653),
    [anon_sym_isize] = ACTIONS(2653),
    [anon_sym_usize] = ACTIONS(2653),
    [anon_sym_f32] = ACTIONS(2653),
    [anon_sym_f64] = ACTIONS(2653),
    [anon_sym_bool] = ACTIONS(2653),
    [anon_sym_str] = ACTIONS(2653),
    [anon_sym_char] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_LT] = ACTIONS(2651),
    [anon_sym_DOT_DOT] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_POUND] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2653),
    [anon_sym_async] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_fn] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_impl] = ACTIONS(2653),
    [anon_sym_let] = ACTIONS(2653),
    [anon_sym_loop] = ACTIONS(2653),
    [anon_sym_match] = ACTIONS(2653),
    [anon_sym_mod] = ACTIONS(2653),
    [anon_sym_pub] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_trait] = ACTIONS(2653),
    [anon_sym_type] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_unsafe] = ACTIONS(2653),
    [anon_sym_use] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym_yield] = ACTIONS(2653),
    [anon_sym_move] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [sym_integer_literal] = ACTIONS(2651),
    [aux_sym_string_literal_token1] = ACTIONS(2651),
    [sym_char_literal] = ACTIONS(2651),
    [anon_sym_true] = ACTIONS(2653),
    [anon_sym_false] = ACTIONS(2653),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2653),
    [sym_super] = ACTIONS(2653),
    [sym_crate] = ACTIONS(2653),
    [sym_metavariable] = ACTIONS(2651),
    [sym__raw_string_literal_start] = ACTIONS(2651),
    [sym_float_literal] = ACTIONS(2651),
  },
  [685] = {
    [sym_line_comment] = STATE(685),
    [sym_block_comment] = STATE(685),
    [ts_builtin_sym_end] = ACTIONS(2655),
    [sym_identifier] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_macro_rules_BANG] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_u8] = ACTIONS(2657),
    [anon_sym_i8] = ACTIONS(2657),
    [anon_sym_u16] = ACTIONS(2657),
    [anon_sym_i16] = ACTIONS(2657),
    [anon_sym_u32] = ACTIONS(2657),
    [anon_sym_i32] = ACTIONS(2657),
    [anon_sym_u64] = ACTIONS(2657),
    [anon_sym_i64] = ACTIONS(2657),
    [anon_sym_u128] = ACTIONS(2657),
    [anon_sym_i128] = ACTIONS(2657),
    [anon_sym_isize] = ACTIONS(2657),
    [anon_sym_usize] = ACTIONS(2657),
    [anon_sym_f32] = ACTIONS(2657),
    [anon_sym_f64] = ACTIONS(2657),
    [anon_sym_bool] = ACTIONS(2657),
    [anon_sym_str] = ACTIONS(2657),
    [anon_sym_char] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(2655),
    [anon_sym_DOT_DOT] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_POUND] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2657),
    [anon_sym_async] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_fn] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_impl] = ACTIONS(2657),
    [anon_sym_let] = ACTIONS(2657),
    [anon_sym_loop] = ACTIONS(2657),
    [anon_sym_match] = ACTIONS(2657),
    [anon_sym_mod] = ACTIONS(2657),
    [anon_sym_pub] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_trait] = ACTIONS(2657),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_unsafe] = ACTIONS(2657),
    [anon_sym_use] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym_yield] = ACTIONS(2657),
    [anon_sym_move] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [sym_integer_literal] = ACTIONS(2655),
    [aux_sym_string_literal_token1] = ACTIONS(2655),
    [sym_char_literal] = ACTIONS(2655),
    [anon_sym_true] = ACTIONS(2657),
    [anon_sym_false] = ACTIONS(2657),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2657),
    [sym_super] = ACTIONS(2657),
    [sym_crate] = ACTIONS(2657),
    [sym_metavariable] = ACTIONS(2655),
    [sym__raw_string_literal_start] = ACTIONS(2655),
    [sym_float_literal] = ACTIONS(2655),
  },
  [686] = {
    [sym_line_comment] = STATE(686),
    [sym_block_comment] = STATE(686),
    [ts_builtin_sym_end] = ACTIONS(2659),
    [sym_identifier] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym_macro_rules_BANG] = ACTIONS(2659),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_u8] = ACTIONS(2661),
    [anon_sym_i8] = ACTIONS(2661),
    [anon_sym_u16] = ACTIONS(2661),
    [anon_sym_i16] = ACTIONS(2661),
    [anon_sym_u32] = ACTIONS(2661),
    [anon_sym_i32] = ACTIONS(2661),
    [anon_sym_u64] = ACTIONS(2661),
    [anon_sym_i64] = ACTIONS(2661),
    [anon_sym_u128] = ACTIONS(2661),
    [anon_sym_i128] = ACTIONS(2661),
    [anon_sym_isize] = ACTIONS(2661),
    [anon_sym_usize] = ACTIONS(2661),
    [anon_sym_f32] = ACTIONS(2661),
    [anon_sym_f64] = ACTIONS(2661),
    [anon_sym_bool] = ACTIONS(2661),
    [anon_sym_str] = ACTIONS(2661),
    [anon_sym_char] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_DOT_DOT] = ACTIONS(2659),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_POUND] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2661),
    [anon_sym_async] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_fn] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_impl] = ACTIONS(2661),
    [anon_sym_let] = ACTIONS(2661),
    [anon_sym_loop] = ACTIONS(2661),
    [anon_sym_match] = ACTIONS(2661),
    [anon_sym_mod] = ACTIONS(2661),
    [anon_sym_pub] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_trait] = ACTIONS(2661),
    [anon_sym_type] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_unsafe] = ACTIONS(2661),
    [anon_sym_use] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym_yield] = ACTIONS(2661),
    [anon_sym_move] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [sym_integer_literal] = ACTIONS(2659),
    [aux_sym_string_literal_token1] = ACTIONS(2659),
    [sym_char_literal] = ACTIONS(2659),
    [anon_sym_true] = ACTIONS(2661),
    [anon_sym_false] = ACTIONS(2661),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2661),
    [sym_super] = ACTIONS(2661),
    [sym_crate] = ACTIONS(2661),
    [sym_metavariable] = ACTIONS(2659),
    [sym__raw_string_literal_start] = ACTIONS(2659),
    [sym_float_literal] = ACTIONS(2659),
  },
  [687] = {
    [sym_line_comment] = STATE(687),
    [sym_block_comment] = STATE(687),
    [ts_builtin_sym_end] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym_macro_rules_BANG] = ACTIONS(2663),
    [anon_sym_LPAREN] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2663),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2663),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_u8] = ACTIONS(2665),
    [anon_sym_i8] = ACTIONS(2665),
    [anon_sym_u16] = ACTIONS(2665),
    [anon_sym_i16] = ACTIONS(2665),
    [anon_sym_u32] = ACTIONS(2665),
    [anon_sym_i32] = ACTIONS(2665),
    [anon_sym_u64] = ACTIONS(2665),
    [anon_sym_i64] = ACTIONS(2665),
    [anon_sym_u128] = ACTIONS(2665),
    [anon_sym_i128] = ACTIONS(2665),
    [anon_sym_isize] = ACTIONS(2665),
    [anon_sym_usize] = ACTIONS(2665),
    [anon_sym_f32] = ACTIONS(2665),
    [anon_sym_f64] = ACTIONS(2665),
    [anon_sym_bool] = ACTIONS(2665),
    [anon_sym_str] = ACTIONS(2665),
    [anon_sym_char] = ACTIONS(2665),
    [anon_sym_DASH] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2663),
    [anon_sym_PIPE] = ACTIONS(2663),
    [anon_sym_LT] = ACTIONS(2663),
    [anon_sym_DOT_DOT] = ACTIONS(2663),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_POUND] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [anon_sym_async] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_fn] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_impl] = ACTIONS(2665),
    [anon_sym_let] = ACTIONS(2665),
    [anon_sym_loop] = ACTIONS(2665),
    [anon_sym_match] = ACTIONS(2665),
    [anon_sym_mod] = ACTIONS(2665),
    [anon_sym_pub] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_trait] = ACTIONS(2665),
    [anon_sym_type] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_unsafe] = ACTIONS(2665),
    [anon_sym_use] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym_yield] = ACTIONS(2665),
    [anon_sym_move] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [sym_integer_literal] = ACTIONS(2663),
    [aux_sym_string_literal_token1] = ACTIONS(2663),
    [sym_char_literal] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(2665),
    [anon_sym_false] = ACTIONS(2665),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2665),
    [sym_super] = ACTIONS(2665),
    [sym_crate] = ACTIONS(2665),
    [sym_metavariable] = ACTIONS(2663),
    [sym__raw_string_literal_start] = ACTIONS(2663),
    [sym_float_literal] = ACTIONS(2663),
  },
  [688] = {
    [sym_line_comment] = STATE(688),
    [sym_block_comment] = STATE(688),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_SEMI] = ACTIONS(1206),
    [anon_sym_macro_rules_BANG] = ACTIONS(1206),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(1206),
    [anon_sym_u8] = ACTIONS(1208),
    [anon_sym_i8] = ACTIONS(1208),
    [anon_sym_u16] = ACTIONS(1208),
    [anon_sym_i16] = ACTIONS(1208),
    [anon_sym_u32] = ACTIONS(1208),
    [anon_sym_i32] = ACTIONS(1208),
    [anon_sym_u64] = ACTIONS(1208),
    [anon_sym_i64] = ACTIONS(1208),
    [anon_sym_u128] = ACTIONS(1208),
    [anon_sym_i128] = ACTIONS(1208),
    [anon_sym_isize] = ACTIONS(1208),
    [anon_sym_usize] = ACTIONS(1208),
    [anon_sym_f32] = ACTIONS(1208),
    [anon_sym_f64] = ACTIONS(1208),
    [anon_sym_bool] = ACTIONS(1208),
    [anon_sym_str] = ACTIONS(1208),
    [anon_sym_char] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1206),
    [anon_sym_BANG] = ACTIONS(1206),
    [anon_sym_AMP] = ACTIONS(1206),
    [anon_sym_PIPE] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1206),
    [anon_sym_DOT_DOT] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(1206),
    [anon_sym_POUND] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1208),
    [anon_sym_async] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_const] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_default] = ACTIONS(1208),
    [anon_sym_enum] = ACTIONS(1208),
    [anon_sym_fn] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1208),
    [anon_sym_impl] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_loop] = ACTIONS(1208),
    [anon_sym_match] = ACTIONS(1208),
    [anon_sym_mod] = ACTIONS(1208),
    [anon_sym_pub] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_static] = ACTIONS(1208),
    [anon_sym_struct] = ACTIONS(1208),
    [anon_sym_trait] = ACTIONS(1208),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_union] = ACTIONS(1208),
    [anon_sym_unsafe] = ACTIONS(1208),
    [anon_sym_use] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_extern] = ACTIONS(1208),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_move] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [sym_integer_literal] = ACTIONS(1206),
    [aux_sym_string_literal_token1] = ACTIONS(1206),
    [sym_char_literal] = ACTIONS(1206),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1208),
    [sym_super] = ACTIONS(1208),
    [sym_crate] = ACTIONS(1208),
    [sym_metavariable] = ACTIONS(1206),
    [sym__raw_string_literal_start] = ACTIONS(1206),
    [sym_float_literal] = ACTIONS(1206),
  },
  [689] = {
    [sym_line_comment] = STATE(689),
    [sym_block_comment] = STATE(689),
    [ts_builtin_sym_end] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_macro_rules_BANG] = ACTIONS(2667),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_u8] = ACTIONS(2669),
    [anon_sym_i8] = ACTIONS(2669),
    [anon_sym_u16] = ACTIONS(2669),
    [anon_sym_i16] = ACTIONS(2669),
    [anon_sym_u32] = ACTIONS(2669),
    [anon_sym_i32] = ACTIONS(2669),
    [anon_sym_u64] = ACTIONS(2669),
    [anon_sym_i64] = ACTIONS(2669),
    [anon_sym_u128] = ACTIONS(2669),
    [anon_sym_i128] = ACTIONS(2669),
    [anon_sym_isize] = ACTIONS(2669),
    [anon_sym_usize] = ACTIONS(2669),
    [anon_sym_f32] = ACTIONS(2669),
    [anon_sym_f64] = ACTIONS(2669),
    [anon_sym_bool] = ACTIONS(2669),
    [anon_sym_str] = ACTIONS(2669),
    [anon_sym_char] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2667),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_POUND] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2669),
    [anon_sym_async] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_impl] = ACTIONS(2669),
    [anon_sym_let] = ACTIONS(2669),
    [anon_sym_loop] = ACTIONS(2669),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_mod] = ACTIONS(2669),
    [anon_sym_pub] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_trait] = ACTIONS(2669),
    [anon_sym_type] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_use] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym_yield] = ACTIONS(2669),
    [anon_sym_move] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [sym_integer_literal] = ACTIONS(2667),
    [aux_sym_string_literal_token1] = ACTIONS(2667),
    [sym_char_literal] = ACTIONS(2667),
    [anon_sym_true] = ACTIONS(2669),
    [anon_sym_false] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2669),
    [sym_super] = ACTIONS(2669),
    [sym_crate] = ACTIONS(2669),
    [sym_metavariable] = ACTIONS(2667),
    [sym__raw_string_literal_start] = ACTIONS(2667),
    [sym_float_literal] = ACTIONS(2667),
  },
  [690] = {
    [sym_line_comment] = STATE(690),
    [sym_block_comment] = STATE(690),
    [ts_builtin_sym_end] = ACTIONS(2671),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_macro_rules_BANG] = ACTIONS(2671),
    [anon_sym_LPAREN] = ACTIONS(2671),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_u8] = ACTIONS(2673),
    [anon_sym_i8] = ACTIONS(2673),
    [anon_sym_u16] = ACTIONS(2673),
    [anon_sym_i16] = ACTIONS(2673),
    [anon_sym_u32] = ACTIONS(2673),
    [anon_sym_i32] = ACTIONS(2673),
    [anon_sym_u64] = ACTIONS(2673),
    [anon_sym_i64] = ACTIONS(2673),
    [anon_sym_u128] = ACTIONS(2673),
    [anon_sym_i128] = ACTIONS(2673),
    [anon_sym_isize] = ACTIONS(2673),
    [anon_sym_usize] = ACTIONS(2673),
    [anon_sym_f32] = ACTIONS(2673),
    [anon_sym_f64] = ACTIONS(2673),
    [anon_sym_bool] = ACTIONS(2673),
    [anon_sym_str] = ACTIONS(2673),
    [anon_sym_char] = ACTIONS(2673),
    [anon_sym_DASH] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2671),
    [anon_sym_DOT_DOT] = ACTIONS(2671),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_POUND] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2673),
    [anon_sym_async] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_fn] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_impl] = ACTIONS(2673),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_loop] = ACTIONS(2673),
    [anon_sym_match] = ACTIONS(2673),
    [anon_sym_mod] = ACTIONS(2673),
    [anon_sym_pub] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_trait] = ACTIONS(2673),
    [anon_sym_type] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_unsafe] = ACTIONS(2673),
    [anon_sym_use] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym_yield] = ACTIONS(2673),
    [anon_sym_move] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [sym_integer_literal] = ACTIONS(2671),
    [aux_sym_string_literal_token1] = ACTIONS(2671),
    [sym_char_literal] = ACTIONS(2671),
    [anon_sym_true] = ACTIONS(2673),
    [anon_sym_false] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2673),
    [sym_super] = ACTIONS(2673),
    [sym_crate] = ACTIONS(2673),
    [sym_metavariable] = ACTIONS(2671),
    [sym__raw_string_literal_start] = ACTIONS(2671),
    [sym_float_literal] = ACTIONS(2671),
  },
  [691] = {
    [sym_line_comment] = STATE(691),
    [sym_block_comment] = STATE(691),
    [ts_builtin_sym_end] = ACTIONS(2675),
    [sym_identifier] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_macro_rules_BANG] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_RBRACE] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_u8] = ACTIONS(2677),
    [anon_sym_i8] = ACTIONS(2677),
    [anon_sym_u16] = ACTIONS(2677),
    [anon_sym_i16] = ACTIONS(2677),
    [anon_sym_u32] = ACTIONS(2677),
    [anon_sym_i32] = ACTIONS(2677),
    [anon_sym_u64] = ACTIONS(2677),
    [anon_sym_i64] = ACTIONS(2677),
    [anon_sym_u128] = ACTIONS(2677),
    [anon_sym_i128] = ACTIONS(2677),
    [anon_sym_isize] = ACTIONS(2677),
    [anon_sym_usize] = ACTIONS(2677),
    [anon_sym_f32] = ACTIONS(2677),
    [anon_sym_f64] = ACTIONS(2677),
    [anon_sym_bool] = ACTIONS(2677),
    [anon_sym_str] = ACTIONS(2677),
    [anon_sym_char] = ACTIONS(2677),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2675),
    [anon_sym_PIPE] = ACTIONS(2675),
    [anon_sym_LT] = ACTIONS(2675),
    [anon_sym_DOT_DOT] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_POUND] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_async] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_fn] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_impl] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_loop] = ACTIONS(2677),
    [anon_sym_match] = ACTIONS(2677),
    [anon_sym_mod] = ACTIONS(2677),
    [anon_sym_pub] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_trait] = ACTIONS(2677),
    [anon_sym_type] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_unsafe] = ACTIONS(2677),
    [anon_sym_use] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(2677),
    [anon_sym_move] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [sym_integer_literal] = ACTIONS(2675),
    [aux_sym_string_literal_token1] = ACTIONS(2675),
    [sym_char_literal] = ACTIONS(2675),
    [anon_sym_true] = ACTIONS(2677),
    [anon_sym_false] = ACTIONS(2677),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2677),
    [sym_super] = ACTIONS(2677),
    [sym_crate] = ACTIONS(2677),
    [sym_metavariable] = ACTIONS(2675),
    [sym__raw_string_literal_start] = ACTIONS(2675),
    [sym_float_literal] = ACTIONS(2675),
  },
  [692] = {
    [sym_line_comment] = STATE(692),
    [sym_block_comment] = STATE(692),
    [ts_builtin_sym_end] = ACTIONS(2679),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym_macro_rules_BANG] = ACTIONS(2679),
    [anon_sym_LPAREN] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_u8] = ACTIONS(2681),
    [anon_sym_i8] = ACTIONS(2681),
    [anon_sym_u16] = ACTIONS(2681),
    [anon_sym_i16] = ACTIONS(2681),
    [anon_sym_u32] = ACTIONS(2681),
    [anon_sym_i32] = ACTIONS(2681),
    [anon_sym_u64] = ACTIONS(2681),
    [anon_sym_i64] = ACTIONS(2681),
    [anon_sym_u128] = ACTIONS(2681),
    [anon_sym_i128] = ACTIONS(2681),
    [anon_sym_isize] = ACTIONS(2681),
    [anon_sym_usize] = ACTIONS(2681),
    [anon_sym_f32] = ACTIONS(2681),
    [anon_sym_f64] = ACTIONS(2681),
    [anon_sym_bool] = ACTIONS(2681),
    [anon_sym_str] = ACTIONS(2681),
    [anon_sym_char] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_PIPE] = ACTIONS(2679),
    [anon_sym_LT] = ACTIONS(2679),
    [anon_sym_DOT_DOT] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_POUND] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_async] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_fn] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_impl] = ACTIONS(2681),
    [anon_sym_let] = ACTIONS(2681),
    [anon_sym_loop] = ACTIONS(2681),
    [anon_sym_match] = ACTIONS(2681),
    [anon_sym_mod] = ACTIONS(2681),
    [anon_sym_pub] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_trait] = ACTIONS(2681),
    [anon_sym_type] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_unsafe] = ACTIONS(2681),
    [anon_sym_use] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2681),
    [anon_sym_move] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [sym_integer_literal] = ACTIONS(2679),
    [aux_sym_string_literal_token1] = ACTIONS(2679),
    [sym_char_literal] = ACTIONS(2679),
    [anon_sym_true] = ACTIONS(2681),
    [anon_sym_false] = ACTIONS(2681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2681),
    [sym_super] = ACTIONS(2681),
    [sym_crate] = ACTIONS(2681),
    [sym_metavariable] = ACTIONS(2679),
    [sym__raw_string_literal_start] = ACTIONS(2679),
    [sym_float_literal] = ACTIONS(2679),
  },
  [693] = {
    [sym_line_comment] = STATE(693),
    [sym_block_comment] = STATE(693),
    [ts_builtin_sym_end] = ACTIONS(2683),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym_macro_rules_BANG] = ACTIONS(2683),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_u8] = ACTIONS(2685),
    [anon_sym_i8] = ACTIONS(2685),
    [anon_sym_u16] = ACTIONS(2685),
    [anon_sym_i16] = ACTIONS(2685),
    [anon_sym_u32] = ACTIONS(2685),
    [anon_sym_i32] = ACTIONS(2685),
    [anon_sym_u64] = ACTIONS(2685),
    [anon_sym_i64] = ACTIONS(2685),
    [anon_sym_u128] = ACTIONS(2685),
    [anon_sym_i128] = ACTIONS(2685),
    [anon_sym_isize] = ACTIONS(2685),
    [anon_sym_usize] = ACTIONS(2685),
    [anon_sym_f32] = ACTIONS(2685),
    [anon_sym_f64] = ACTIONS(2685),
    [anon_sym_bool] = ACTIONS(2685),
    [anon_sym_str] = ACTIONS(2685),
    [anon_sym_char] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2683),
    [anon_sym_DOT_DOT] = ACTIONS(2683),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_POUND] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2685),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_break] = ACTIONS(2685),
    [anon_sym_const] = ACTIONS(2685),
    [anon_sym_continue] = ACTIONS(2685),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_enum] = ACTIONS(2685),
    [anon_sym_fn] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_impl] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_loop] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_mod] = ACTIONS(2685),
    [anon_sym_pub] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_struct] = ACTIONS(2685),
    [anon_sym_trait] = ACTIONS(2685),
    [anon_sym_type] = ACTIONS(2685),
    [anon_sym_union] = ACTIONS(2685),
    [anon_sym_unsafe] = ACTIONS(2685),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_extern] = ACTIONS(2685),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_move] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [sym_integer_literal] = ACTIONS(2683),
    [aux_sym_string_literal_token1] = ACTIONS(2683),
    [sym_char_literal] = ACTIONS(2683),
    [anon_sym_true] = ACTIONS(2685),
    [anon_sym_false] = ACTIONS(2685),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2685),
    [sym_super] = ACTIONS(2685),
    [sym_crate] = ACTIONS(2685),
    [sym_metavariable] = ACTIONS(2683),
    [sym__raw_string_literal_start] = ACTIONS(2683),
    [sym_float_literal] = ACTIONS(2683),
  },
  [694] = {
    [sym_line_comment] = STATE(694),
    [sym_block_comment] = STATE(694),
    [ts_builtin_sym_end] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2687),
    [anon_sym_macro_rules_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2687),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2687),
    [anon_sym_u8] = ACTIONS(2689),
    [anon_sym_i8] = ACTIONS(2689),
    [anon_sym_u16] = ACTIONS(2689),
    [anon_sym_i16] = ACTIONS(2689),
    [anon_sym_u32] = ACTIONS(2689),
    [anon_sym_i32] = ACTIONS(2689),
    [anon_sym_u64] = ACTIONS(2689),
    [anon_sym_i64] = ACTIONS(2689),
    [anon_sym_u128] = ACTIONS(2689),
    [anon_sym_i128] = ACTIONS(2689),
    [anon_sym_isize] = ACTIONS(2689),
    [anon_sym_usize] = ACTIONS(2689),
    [anon_sym_f32] = ACTIONS(2689),
    [anon_sym_f64] = ACTIONS(2689),
    [anon_sym_bool] = ACTIONS(2689),
    [anon_sym_str] = ACTIONS(2689),
    [anon_sym_char] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_BANG] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_POUND] = ACTIONS(2687),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_async] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_fn] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_impl] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_loop] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_mod] = ACTIONS(2689),
    [anon_sym_pub] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_trait] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [anon_sym_unsafe] = ACTIONS(2689),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_move] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [sym_integer_literal] = ACTIONS(2687),
    [aux_sym_string_literal_token1] = ACTIONS(2687),
    [sym_char_literal] = ACTIONS(2687),
    [anon_sym_true] = ACTIONS(2689),
    [anon_sym_false] = ACTIONS(2689),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2689),
    [sym_super] = ACTIONS(2689),
    [sym_crate] = ACTIONS(2689),
    [sym_metavariable] = ACTIONS(2687),
    [sym__raw_string_literal_start] = ACTIONS(2687),
    [sym_float_literal] = ACTIONS(2687),
  },
  [695] = {
    [sym_line_comment] = STATE(695),
    [sym_block_comment] = STATE(695),
    [ts_builtin_sym_end] = ACTIONS(2691),
    [sym_identifier] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym_macro_rules_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2691),
    [anon_sym_RBRACE] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_BANG] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_DOT_DOT] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_POUND] = ACTIONS(2691),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_async] = ACTIONS(2693),
    [anon_sym_break] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [anon_sym_continue] = ACTIONS(2693),
    [anon_sym_default] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [anon_sym_fn] = ACTIONS(2693),
    [anon_sym_for] = ACTIONS(2693),
    [anon_sym_if] = ACTIONS(2693),
    [anon_sym_impl] = ACTIONS(2693),
    [anon_sym_let] = ACTIONS(2693),
    [anon_sym_loop] = ACTIONS(2693),
    [anon_sym_match] = ACTIONS(2693),
    [anon_sym_mod] = ACTIONS(2693),
    [anon_sym_pub] = ACTIONS(2693),
    [anon_sym_return] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_struct] = ACTIONS(2693),
    [anon_sym_trait] = ACTIONS(2693),
    [anon_sym_type] = ACTIONS(2693),
    [anon_sym_union] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2693),
    [anon_sym_use] = ACTIONS(2693),
    [anon_sym_while] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2693),
    [anon_sym_yield] = ACTIONS(2693),
    [anon_sym_move] = ACTIONS(2693),
    [anon_sym_try] = ACTIONS(2693),
    [sym_integer_literal] = ACTIONS(2691),
    [aux_sym_string_literal_token1] = ACTIONS(2691),
    [sym_char_literal] = ACTIONS(2691),
    [anon_sym_true] = ACTIONS(2693),
    [anon_sym_false] = ACTIONS(2693),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2693),
    [sym_super] = ACTIONS(2693),
    [sym_crate] = ACTIONS(2693),
    [sym_metavariable] = ACTIONS(2691),
    [sym__raw_string_literal_start] = ACTIONS(2691),
    [sym_float_literal] = ACTIONS(2691),
  },
  [696] = {
    [sym_line_comment] = STATE(696),
    [sym_block_comment] = STATE(696),
    [ts_builtin_sym_end] = ACTIONS(2695),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2695),
    [anon_sym_macro_rules_BANG] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_RBRACE] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_u8] = ACTIONS(2697),
    [anon_sym_i8] = ACTIONS(2697),
    [anon_sym_u16] = ACTIONS(2697),
    [anon_sym_i16] = ACTIONS(2697),
    [anon_sym_u32] = ACTIONS(2697),
    [anon_sym_i32] = ACTIONS(2697),
    [anon_sym_u64] = ACTIONS(2697),
    [anon_sym_i64] = ACTIONS(2697),
    [anon_sym_u128] = ACTIONS(2697),
    [anon_sym_i128] = ACTIONS(2697),
    [anon_sym_isize] = ACTIONS(2697),
    [anon_sym_usize] = ACTIONS(2697),
    [anon_sym_f32] = ACTIONS(2697),
    [anon_sym_f64] = ACTIONS(2697),
    [anon_sym_bool] = ACTIONS(2697),
    [anon_sym_str] = ACTIONS(2697),
    [anon_sym_char] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_PIPE] = ACTIONS(2695),
    [anon_sym_LT] = ACTIONS(2695),
    [anon_sym_DOT_DOT] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2695),
    [anon_sym_POUND] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_async] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_default] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_fn] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_impl] = ACTIONS(2697),
    [anon_sym_let] = ACTIONS(2697),
    [anon_sym_loop] = ACTIONS(2697),
    [anon_sym_match] = ACTIONS(2697),
    [anon_sym_mod] = ACTIONS(2697),
    [anon_sym_pub] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_trait] = ACTIONS(2697),
    [anon_sym_type] = ACTIONS(2697),
    [anon_sym_union] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_use] = ACTIONS(2697),
    [anon_sym_while] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2697),
    [anon_sym_yield] = ACTIONS(2697),
    [anon_sym_move] = ACTIONS(2697),
    [anon_sym_try] = ACTIONS(2697),
    [sym_integer_literal] = ACTIONS(2695),
    [aux_sym_string_literal_token1] = ACTIONS(2695),
    [sym_char_literal] = ACTIONS(2695),
    [anon_sym_true] = ACTIONS(2697),
    [anon_sym_false] = ACTIONS(2697),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2697),
    [sym_super] = ACTIONS(2697),
    [sym_crate] = ACTIONS(2697),
    [sym_metavariable] = ACTIONS(2695),
    [sym__raw_string_literal_start] = ACTIONS(2695),
    [sym_float_literal] = ACTIONS(2695),
  },
  [697] = {
    [sym_line_comment] = STATE(697),
    [sym_block_comment] = STATE(697),
    [ts_builtin_sym_end] = ACTIONS(2699),
    [sym_identifier] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_macro_rules_BANG] = ACTIONS(2699),
    [anon_sym_LPAREN] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(2699),
    [anon_sym_RBRACE] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_u8] = ACTIONS(2701),
    [anon_sym_i8] = ACTIONS(2701),
    [anon_sym_u16] = ACTIONS(2701),
    [anon_sym_i16] = ACTIONS(2701),
    [anon_sym_u32] = ACTIONS(2701),
    [anon_sym_i32] = ACTIONS(2701),
    [anon_sym_u64] = ACTIONS(2701),
    [anon_sym_i64] = ACTIONS(2701),
    [anon_sym_u128] = ACTIONS(2701),
    [anon_sym_i128] = ACTIONS(2701),
    [anon_sym_isize] = ACTIONS(2701),
    [anon_sym_usize] = ACTIONS(2701),
    [anon_sym_f32] = ACTIONS(2701),
    [anon_sym_f64] = ACTIONS(2701),
    [anon_sym_bool] = ACTIONS(2701),
    [anon_sym_str] = ACTIONS(2701),
    [anon_sym_char] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2699),
    [anon_sym_POUND] = ACTIONS(2699),
    [anon_sym_SQUOTE] = ACTIONS(2701),
    [anon_sym_async] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_fn] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_impl] = ACTIONS(2701),
    [anon_sym_let] = ACTIONS(2701),
    [anon_sym_loop] = ACTIONS(2701),
    [anon_sym_match] = ACTIONS(2701),
    [anon_sym_mod] = ACTIONS(2701),
    [anon_sym_pub] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_trait] = ACTIONS(2701),
    [anon_sym_type] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_unsafe] = ACTIONS(2701),
    [anon_sym_use] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym_yield] = ACTIONS(2701),
    [anon_sym_move] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [sym_integer_literal] = ACTIONS(2699),
    [aux_sym_string_literal_token1] = ACTIONS(2699),
    [sym_char_literal] = ACTIONS(2699),
    [anon_sym_true] = ACTIONS(2701),
    [anon_sym_false] = ACTIONS(2701),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2701),
    [sym_super] = ACTIONS(2701),
    [sym_crate] = ACTIONS(2701),
    [sym_metavariable] = ACTIONS(2699),
    [sym__raw_string_literal_start] = ACTIONS(2699),
    [sym_float_literal] = ACTIONS(2699),
  },
  [698] = {
    [sym_line_comment] = STATE(698),
    [sym_block_comment] = STATE(698),
    [ts_builtin_sym_end] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_macro_rules_BANG] = ACTIONS(2703),
    [anon_sym_LPAREN] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_u8] = ACTIONS(2705),
    [anon_sym_i8] = ACTIONS(2705),
    [anon_sym_u16] = ACTIONS(2705),
    [anon_sym_i16] = ACTIONS(2705),
    [anon_sym_u32] = ACTIONS(2705),
    [anon_sym_i32] = ACTIONS(2705),
    [anon_sym_u64] = ACTIONS(2705),
    [anon_sym_i64] = ACTIONS(2705),
    [anon_sym_u128] = ACTIONS(2705),
    [anon_sym_i128] = ACTIONS(2705),
    [anon_sym_isize] = ACTIONS(2705),
    [anon_sym_usize] = ACTIONS(2705),
    [anon_sym_f32] = ACTIONS(2705),
    [anon_sym_f64] = ACTIONS(2705),
    [anon_sym_bool] = ACTIONS(2705),
    [anon_sym_str] = ACTIONS(2705),
    [anon_sym_char] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_PIPE] = ACTIONS(2703),
    [anon_sym_LT] = ACTIONS(2703),
    [anon_sym_DOT_DOT] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_POUND] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_async] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_fn] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_impl] = ACTIONS(2705),
    [anon_sym_let] = ACTIONS(2705),
    [anon_sym_loop] = ACTIONS(2705),
    [anon_sym_match] = ACTIONS(2705),
    [anon_sym_mod] = ACTIONS(2705),
    [anon_sym_pub] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_trait] = ACTIONS(2705),
    [anon_sym_type] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_unsafe] = ACTIONS(2705),
    [anon_sym_use] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym_yield] = ACTIONS(2705),
    [anon_sym_move] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [sym_integer_literal] = ACTIONS(2703),
    [aux_sym_string_literal_token1] = ACTIONS(2703),
    [sym_char_literal] = ACTIONS(2703),
    [anon_sym_true] = ACTIONS(2705),
    [anon_sym_false] = ACTIONS(2705),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2705),
    [sym_super] = ACTIONS(2705),
    [sym_crate] = ACTIONS(2705),
    [sym_metavariable] = ACTIONS(2703),
    [sym__raw_string_literal_start] = ACTIONS(2703),
    [sym_float_literal] = ACTIONS(2703),
  },
  [699] = {
    [sym_line_comment] = STATE(699),
    [sym_block_comment] = STATE(699),
    [ts_builtin_sym_end] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_macro_rules_BANG] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_u8] = ACTIONS(2709),
    [anon_sym_i8] = ACTIONS(2709),
    [anon_sym_u16] = ACTIONS(2709),
    [anon_sym_i16] = ACTIONS(2709),
    [anon_sym_u32] = ACTIONS(2709),
    [anon_sym_i32] = ACTIONS(2709),
    [anon_sym_u64] = ACTIONS(2709),
    [anon_sym_i64] = ACTIONS(2709),
    [anon_sym_u128] = ACTIONS(2709),
    [anon_sym_i128] = ACTIONS(2709),
    [anon_sym_isize] = ACTIONS(2709),
    [anon_sym_usize] = ACTIONS(2709),
    [anon_sym_f32] = ACTIONS(2709),
    [anon_sym_f64] = ACTIONS(2709),
    [anon_sym_bool] = ACTIONS(2709),
    [anon_sym_str] = ACTIONS(2709),
    [anon_sym_char] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_PIPE] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2707),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_POUND] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2709),
    [anon_sym_async] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_fn] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_impl] = ACTIONS(2709),
    [anon_sym_let] = ACTIONS(2709),
    [anon_sym_loop] = ACTIONS(2709),
    [anon_sym_match] = ACTIONS(2709),
    [anon_sym_mod] = ACTIONS(2709),
    [anon_sym_pub] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_trait] = ACTIONS(2709),
    [anon_sym_type] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_unsafe] = ACTIONS(2709),
    [anon_sym_use] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym_yield] = ACTIONS(2709),
    [anon_sym_move] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [sym_integer_literal] = ACTIONS(2707),
    [aux_sym_string_literal_token1] = ACTIONS(2707),
    [sym_char_literal] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(2709),
    [anon_sym_false] = ACTIONS(2709),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2709),
    [sym_super] = ACTIONS(2709),
    [sym_crate] = ACTIONS(2709),
    [sym_metavariable] = ACTIONS(2707),
    [sym__raw_string_literal_start] = ACTIONS(2707),
    [sym_float_literal] = ACTIONS(2707),
  },
  [700] = {
    [sym_line_comment] = STATE(700),
    [sym_block_comment] = STATE(700),
    [ts_builtin_sym_end] = ACTIONS(2711),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_macro_rules_BANG] = ACTIONS(2711),
    [anon_sym_LPAREN] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_RBRACE] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_u8] = ACTIONS(2713),
    [anon_sym_i8] = ACTIONS(2713),
    [anon_sym_u16] = ACTIONS(2713),
    [anon_sym_i16] = ACTIONS(2713),
    [anon_sym_u32] = ACTIONS(2713),
    [anon_sym_i32] = ACTIONS(2713),
    [anon_sym_u64] = ACTIONS(2713),
    [anon_sym_i64] = ACTIONS(2713),
    [anon_sym_u128] = ACTIONS(2713),
    [anon_sym_i128] = ACTIONS(2713),
    [anon_sym_isize] = ACTIONS(2713),
    [anon_sym_usize] = ACTIONS(2713),
    [anon_sym_f32] = ACTIONS(2713),
    [anon_sym_f64] = ACTIONS(2713),
    [anon_sym_bool] = ACTIONS(2713),
    [anon_sym_str] = ACTIONS(2713),
    [anon_sym_char] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_PIPE] = ACTIONS(2711),
    [anon_sym_LT] = ACTIONS(2711),
    [anon_sym_DOT_DOT] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_POUND] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2713),
    [anon_sym_async] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_fn] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_impl] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_loop] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_mod] = ACTIONS(2713),
    [anon_sym_pub] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_trait] = ACTIONS(2713),
    [anon_sym_type] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_unsafe] = ACTIONS(2713),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_move] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [sym_integer_literal] = ACTIONS(2711),
    [aux_sym_string_literal_token1] = ACTIONS(2711),
    [sym_char_literal] = ACTIONS(2711),
    [anon_sym_true] = ACTIONS(2713),
    [anon_sym_false] = ACTIONS(2713),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2713),
    [sym_super] = ACTIONS(2713),
    [sym_crate] = ACTIONS(2713),
    [sym_metavariable] = ACTIONS(2711),
    [sym__raw_string_literal_start] = ACTIONS(2711),
    [sym_float_literal] = ACTIONS(2711),
  },
  [701] = {
    [sym_line_comment] = STATE(701),
    [sym_block_comment] = STATE(701),
    [ts_builtin_sym_end] = ACTIONS(2715),
    [sym_identifier] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym_macro_rules_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_u8] = ACTIONS(2717),
    [anon_sym_i8] = ACTIONS(2717),
    [anon_sym_u16] = ACTIONS(2717),
    [anon_sym_i16] = ACTIONS(2717),
    [anon_sym_u32] = ACTIONS(2717),
    [anon_sym_i32] = ACTIONS(2717),
    [anon_sym_u64] = ACTIONS(2717),
    [anon_sym_i64] = ACTIONS(2717),
    [anon_sym_u128] = ACTIONS(2717),
    [anon_sym_i128] = ACTIONS(2717),
    [anon_sym_isize] = ACTIONS(2717),
    [anon_sym_usize] = ACTIONS(2717),
    [anon_sym_f32] = ACTIONS(2717),
    [anon_sym_f64] = ACTIONS(2717),
    [anon_sym_bool] = ACTIONS(2717),
    [anon_sym_str] = ACTIONS(2717),
    [anon_sym_char] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_DOT_DOT] = ACTIONS(2715),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_POUND] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2717),
    [anon_sym_async] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_fn] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_impl] = ACTIONS(2717),
    [anon_sym_let] = ACTIONS(2717),
    [anon_sym_loop] = ACTIONS(2717),
    [anon_sym_match] = ACTIONS(2717),
    [anon_sym_mod] = ACTIONS(2717),
    [anon_sym_pub] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_trait] = ACTIONS(2717),
    [anon_sym_type] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_unsafe] = ACTIONS(2717),
    [anon_sym_use] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym_yield] = ACTIONS(2717),
    [anon_sym_move] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [sym_integer_literal] = ACTIONS(2715),
    [aux_sym_string_literal_token1] = ACTIONS(2715),
    [sym_char_literal] = ACTIONS(2715),
    [anon_sym_true] = ACTIONS(2717),
    [anon_sym_false] = ACTIONS(2717),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2717),
    [sym_super] = ACTIONS(2717),
    [sym_crate] = ACTIONS(2717),
    [sym_metavariable] = ACTIONS(2715),
    [sym__raw_string_literal_start] = ACTIONS(2715),
    [sym_float_literal] = ACTIONS(2715),
  },
  [702] = {
    [sym_line_comment] = STATE(702),
    [sym_block_comment] = STATE(702),
    [ts_builtin_sym_end] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym_macro_rules_BANG] = ACTIONS(2719),
    [anon_sym_LPAREN] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_u8] = ACTIONS(2721),
    [anon_sym_i8] = ACTIONS(2721),
    [anon_sym_u16] = ACTIONS(2721),
    [anon_sym_i16] = ACTIONS(2721),
    [anon_sym_u32] = ACTIONS(2721),
    [anon_sym_i32] = ACTIONS(2721),
    [anon_sym_u64] = ACTIONS(2721),
    [anon_sym_i64] = ACTIONS(2721),
    [anon_sym_u128] = ACTIONS(2721),
    [anon_sym_i128] = ACTIONS(2721),
    [anon_sym_isize] = ACTIONS(2721),
    [anon_sym_usize] = ACTIONS(2721),
    [anon_sym_f32] = ACTIONS(2721),
    [anon_sym_f64] = ACTIONS(2721),
    [anon_sym_bool] = ACTIONS(2721),
    [anon_sym_str] = ACTIONS(2721),
    [anon_sym_char] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2719),
    [anon_sym_DOT_DOT] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_POUND] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2721),
    [anon_sym_async] = ACTIONS(2721),
    [anon_sym_break] = ACTIONS(2721),
    [anon_sym_const] = ACTIONS(2721),
    [anon_sym_continue] = ACTIONS(2721),
    [anon_sym_default] = ACTIONS(2721),
    [anon_sym_enum] = ACTIONS(2721),
    [anon_sym_fn] = ACTIONS(2721),
    [anon_sym_for] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2721),
    [anon_sym_impl] = ACTIONS(2721),
    [anon_sym_let] = ACTIONS(2721),
    [anon_sym_loop] = ACTIONS(2721),
    [anon_sym_match] = ACTIONS(2721),
    [anon_sym_mod] = ACTIONS(2721),
    [anon_sym_pub] = ACTIONS(2721),
    [anon_sym_return] = ACTIONS(2721),
    [anon_sym_static] = ACTIONS(2721),
    [anon_sym_struct] = ACTIONS(2721),
    [anon_sym_trait] = ACTIONS(2721),
    [anon_sym_type] = ACTIONS(2721),
    [anon_sym_union] = ACTIONS(2721),
    [anon_sym_unsafe] = ACTIONS(2721),
    [anon_sym_use] = ACTIONS(2721),
    [anon_sym_while] = ACTIONS(2721),
    [anon_sym_extern] = ACTIONS(2721),
    [anon_sym_yield] = ACTIONS(2721),
    [anon_sym_move] = ACTIONS(2721),
    [anon_sym_try] = ACTIONS(2721),
    [sym_integer_literal] = ACTIONS(2719),
    [aux_sym_string_literal_token1] = ACTIONS(2719),
    [sym_char_literal] = ACTIONS(2719),
    [anon_sym_true] = ACTIONS(2721),
    [anon_sym_false] = ACTIONS(2721),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2721),
    [sym_super] = ACTIONS(2721),
    [sym_crate] = ACTIONS(2721),
    [sym_metavariable] = ACTIONS(2719),
    [sym__raw_string_literal_start] = ACTIONS(2719),
    [sym_float_literal] = ACTIONS(2719),
  },
  [703] = {
    [sym_line_comment] = STATE(703),
    [sym_block_comment] = STATE(703),
    [ts_builtin_sym_end] = ACTIONS(2723),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2723),
    [anon_sym_macro_rules_BANG] = ACTIONS(2723),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_RBRACE] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2723),
    [anon_sym_u8] = ACTIONS(2725),
    [anon_sym_i8] = ACTIONS(2725),
    [anon_sym_u16] = ACTIONS(2725),
    [anon_sym_i16] = ACTIONS(2725),
    [anon_sym_u32] = ACTIONS(2725),
    [anon_sym_i32] = ACTIONS(2725),
    [anon_sym_u64] = ACTIONS(2725),
    [anon_sym_i64] = ACTIONS(2725),
    [anon_sym_u128] = ACTIONS(2725),
    [anon_sym_i128] = ACTIONS(2725),
    [anon_sym_isize] = ACTIONS(2725),
    [anon_sym_usize] = ACTIONS(2725),
    [anon_sym_f32] = ACTIONS(2725),
    [anon_sym_f64] = ACTIONS(2725),
    [anon_sym_bool] = ACTIONS(2725),
    [anon_sym_str] = ACTIONS(2725),
    [anon_sym_char] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_BANG] = ACTIONS(2723),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_LT] = ACTIONS(2723),
    [anon_sym_DOT_DOT] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2723),
    [anon_sym_POUND] = ACTIONS(2723),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_async] = ACTIONS(2725),
    [anon_sym_break] = ACTIONS(2725),
    [anon_sym_const] = ACTIONS(2725),
    [anon_sym_continue] = ACTIONS(2725),
    [anon_sym_default] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2725),
    [anon_sym_fn] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2725),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_impl] = ACTIONS(2725),
    [anon_sym_let] = ACTIONS(2725),
    [anon_sym_loop] = ACTIONS(2725),
    [anon_sym_match] = ACTIONS(2725),
    [anon_sym_mod] = ACTIONS(2725),
    [anon_sym_pub] = ACTIONS(2725),
    [anon_sym_return] = ACTIONS(2725),
    [anon_sym_static] = ACTIONS(2725),
    [anon_sym_struct] = ACTIONS(2725),
    [anon_sym_trait] = ACTIONS(2725),
    [anon_sym_type] = ACTIONS(2725),
    [anon_sym_union] = ACTIONS(2725),
    [anon_sym_unsafe] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_extern] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2725),
    [anon_sym_move] = ACTIONS(2725),
    [anon_sym_try] = ACTIONS(2725),
    [sym_integer_literal] = ACTIONS(2723),
    [aux_sym_string_literal_token1] = ACTIONS(2723),
    [sym_char_literal] = ACTIONS(2723),
    [anon_sym_true] = ACTIONS(2725),
    [anon_sym_false] = ACTIONS(2725),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2725),
    [sym_super] = ACTIONS(2725),
    [sym_crate] = ACTIONS(2725),
    [sym_metavariable] = ACTIONS(2723),
    [sym__raw_string_literal_start] = ACTIONS(2723),
    [sym_float_literal] = ACTIONS(2723),
  },
  [704] = {
    [sym_line_comment] = STATE(704),
    [sym_block_comment] = STATE(704),
    [ts_builtin_sym_end] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2727),
    [anon_sym_macro_rules_BANG] = ACTIONS(2727),
    [anon_sym_LPAREN] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2727),
    [anon_sym_RBRACE] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2727),
    [anon_sym_u8] = ACTIONS(2729),
    [anon_sym_i8] = ACTIONS(2729),
    [anon_sym_u16] = ACTIONS(2729),
    [anon_sym_i16] = ACTIONS(2729),
    [anon_sym_u32] = ACTIONS(2729),
    [anon_sym_i32] = ACTIONS(2729),
    [anon_sym_u64] = ACTIONS(2729),
    [anon_sym_i64] = ACTIONS(2729),
    [anon_sym_u128] = ACTIONS(2729),
    [anon_sym_i128] = ACTIONS(2729),
    [anon_sym_isize] = ACTIONS(2729),
    [anon_sym_usize] = ACTIONS(2729),
    [anon_sym_f32] = ACTIONS(2729),
    [anon_sym_f64] = ACTIONS(2729),
    [anon_sym_bool] = ACTIONS(2729),
    [anon_sym_str] = ACTIONS(2729),
    [anon_sym_char] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_PIPE] = ACTIONS(2727),
    [anon_sym_LT] = ACTIONS(2727),
    [anon_sym_DOT_DOT] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2727),
    [anon_sym_POUND] = ACTIONS(2727),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_async] = ACTIONS(2729),
    [anon_sym_break] = ACTIONS(2729),
    [anon_sym_const] = ACTIONS(2729),
    [anon_sym_continue] = ACTIONS(2729),
    [anon_sym_default] = ACTIONS(2729),
    [anon_sym_enum] = ACTIONS(2729),
    [anon_sym_fn] = ACTIONS(2729),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_impl] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_loop] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_mod] = ACTIONS(2729),
    [anon_sym_pub] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2729),
    [anon_sym_trait] = ACTIONS(2729),
    [anon_sym_type] = ACTIONS(2729),
    [anon_sym_union] = ACTIONS(2729),
    [anon_sym_unsafe] = ACTIONS(2729),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_extern] = ACTIONS(2729),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_move] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [sym_integer_literal] = ACTIONS(2727),
    [aux_sym_string_literal_token1] = ACTIONS(2727),
    [sym_char_literal] = ACTIONS(2727),
    [anon_sym_true] = ACTIONS(2729),
    [anon_sym_false] = ACTIONS(2729),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2729),
    [sym_super] = ACTIONS(2729),
    [sym_crate] = ACTIONS(2729),
    [sym_metavariable] = ACTIONS(2727),
    [sym__raw_string_literal_start] = ACTIONS(2727),
    [sym_float_literal] = ACTIONS(2727),
  },
  [705] = {
    [sym_line_comment] = STATE(705),
    [sym_block_comment] = STATE(705),
    [ts_builtin_sym_end] = ACTIONS(2731),
    [sym_identifier] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(2731),
    [anon_sym_macro_rules_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2731),
    [anon_sym_RBRACE] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2731),
    [anon_sym_u8] = ACTIONS(2733),
    [anon_sym_i8] = ACTIONS(2733),
    [anon_sym_u16] = ACTIONS(2733),
    [anon_sym_i16] = ACTIONS(2733),
    [anon_sym_u32] = ACTIONS(2733),
    [anon_sym_i32] = ACTIONS(2733),
    [anon_sym_u64] = ACTIONS(2733),
    [anon_sym_i64] = ACTIONS(2733),
    [anon_sym_u128] = ACTIONS(2733),
    [anon_sym_i128] = ACTIONS(2733),
    [anon_sym_isize] = ACTIONS(2733),
    [anon_sym_usize] = ACTIONS(2733),
    [anon_sym_f32] = ACTIONS(2733),
    [anon_sym_f64] = ACTIONS(2733),
    [anon_sym_bool] = ACTIONS(2733),
    [anon_sym_str] = ACTIONS(2733),
    [anon_sym_char] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_BANG] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_DOT_DOT] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_POUND] = ACTIONS(2731),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_async] = ACTIONS(2733),
    [anon_sym_break] = ACTIONS(2733),
    [anon_sym_const] = ACTIONS(2733),
    [anon_sym_continue] = ACTIONS(2733),
    [anon_sym_default] = ACTIONS(2733),
    [anon_sym_enum] = ACTIONS(2733),
    [anon_sym_fn] = ACTIONS(2733),
    [anon_sym_for] = ACTIONS(2733),
    [anon_sym_if] = ACTIONS(2733),
    [anon_sym_impl] = ACTIONS(2733),
    [anon_sym_let] = ACTIONS(2733),
    [anon_sym_loop] = ACTIONS(2733),
    [anon_sym_match] = ACTIONS(2733),
    [anon_sym_mod] = ACTIONS(2733),
    [anon_sym_pub] = ACTIONS(2733),
    [anon_sym_return] = ACTIONS(2733),
    [anon_sym_static] = ACTIONS(2733),
    [anon_sym_struct] = ACTIONS(2733),
    [anon_sym_trait] = ACTIONS(2733),
    [anon_sym_type] = ACTIONS(2733),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_unsafe] = ACTIONS(2733),
    [anon_sym_use] = ACTIONS(2733),
    [anon_sym_while] = ACTIONS(2733),
    [anon_sym_extern] = ACTIONS(2733),
    [anon_sym_yield] = ACTIONS(2733),
    [anon_sym_move] = ACTIONS(2733),
    [anon_sym_try] = ACTIONS(2733),
    [sym_integer_literal] = ACTIONS(2731),
    [aux_sym_string_literal_token1] = ACTIONS(2731),
    [sym_char_literal] = ACTIONS(2731),
    [anon_sym_true] = ACTIONS(2733),
    [anon_sym_false] = ACTIONS(2733),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2733),
    [sym_super] = ACTIONS(2733),
    [sym_crate] = ACTIONS(2733),
    [sym_metavariable] = ACTIONS(2731),
    [sym__raw_string_literal_start] = ACTIONS(2731),
    [sym_float_literal] = ACTIONS(2731),
  },
  [706] = {
    [sym_empty_statement] = STATE(1389),
    [sym_macro_definition] = STATE(1389),
    [sym_attribute_item] = STATE(1389),
    [sym_inner_attribute_item] = STATE(1389),
    [sym_mod_item] = STATE(1389),
    [sym_foreign_mod_item] = STATE(1389),
    [sym_struct_item] = STATE(1389),
    [sym_union_item] = STATE(1389),
    [sym_enum_item] = STATE(1389),
    [sym_extern_crate_declaration] = STATE(1389),
    [sym_const_item] = STATE(1389),
    [sym_static_item] = STATE(1389),
    [sym_type_item] = STATE(1389),
    [sym_function_item] = STATE(1389),
    [sym_function_signature_item] = STATE(1389),
    [sym_function_modifiers] = STATE(3601),
    [sym_impl_item] = STATE(1389),
    [sym_trait_item] = STATE(1389),
    [sym_associated_type] = STATE(1389),
    [sym_let_declaration] = STATE(1389),
    [sym_use_declaration] = STATE(1389),
    [sym_extern_modifier] = STATE(2140),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3312),
    [sym_generic_type_with_turbofish] = STATE(3351),
    [sym_macro_invocation] = STATE(1389),
    [sym_scoped_identifier] = STATE(3243),
    [sym_line_comment] = STATE(706),
    [sym_block_comment] = STATE(706),
    [aux_sym_declaration_list_repeat1] = STATE(528),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_macro_rules_BANG] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(2735),
    [anon_sym_u8] = ACTIONS(1928),
    [anon_sym_i8] = ACTIONS(1928),
    [anon_sym_u16] = ACTIONS(1928),
    [anon_sym_i16] = ACTIONS(1928),
    [anon_sym_u32] = ACTIONS(1928),
    [anon_sym_i32] = ACTIONS(1928),
    [anon_sym_u64] = ACTIONS(1928),
    [anon_sym_i64] = ACTIONS(1928),
    [anon_sym_u128] = ACTIONS(1928),
    [anon_sym_i128] = ACTIONS(1928),
    [anon_sym_isize] = ACTIONS(1928),
    [anon_sym_usize] = ACTIONS(1928),
    [anon_sym_f32] = ACTIONS(1928),
    [anon_sym_f64] = ACTIONS(1928),
    [anon_sym_bool] = ACTIONS(1928),
    [anon_sym_str] = ACTIONS(1928),
    [anon_sym_char] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1930),
    [anon_sym_POUND] = ACTIONS(1932),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_fn] = ACTIONS(1940),
    [anon_sym_impl] = ACTIONS(1942),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_mod] = ACTIONS(1946),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_trait] = ACTIONS(1952),
    [anon_sym_type] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1956),
    [anon_sym_unsafe] = ACTIONS(1958),
    [anon_sym_use] = ACTIONS(1960),
    [anon_sym_extern] = ACTIONS(1962),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1964),
    [sym_super] = ACTIONS(1964),
    [sym_crate] = ACTIONS(1966),
    [sym_metavariable] = ACTIONS(1968),
  },
  [707] = {
    [sym_line_comment] = STATE(707),
    [sym_block_comment] = STATE(707),
    [ts_builtin_sym_end] = ACTIONS(2737),
    [sym_identifier] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_macro_rules_BANG] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_u8] = ACTIONS(2739),
    [anon_sym_i8] = ACTIONS(2739),
    [anon_sym_u16] = ACTIONS(2739),
    [anon_sym_i16] = ACTIONS(2739),
    [anon_sym_u32] = ACTIONS(2739),
    [anon_sym_i32] = ACTIONS(2739),
    [anon_sym_u64] = ACTIONS(2739),
    [anon_sym_i64] = ACTIONS(2739),
    [anon_sym_u128] = ACTIONS(2739),
    [anon_sym_i128] = ACTIONS(2739),
    [anon_sym_isize] = ACTIONS(2739),
    [anon_sym_usize] = ACTIONS(2739),
    [anon_sym_f32] = ACTIONS(2739),
    [anon_sym_f64] = ACTIONS(2739),
    [anon_sym_bool] = ACTIONS(2739),
    [anon_sym_str] = ACTIONS(2739),
    [anon_sym_char] = ACTIONS(2739),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_PIPE] = ACTIONS(2737),
    [anon_sym_LT] = ACTIONS(2737),
    [anon_sym_DOT_DOT] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_POUND] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2739),
    [anon_sym_async] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_fn] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_impl] = ACTIONS(2739),
    [anon_sym_let] = ACTIONS(2739),
    [anon_sym_loop] = ACTIONS(2739),
    [anon_sym_match] = ACTIONS(2739),
    [anon_sym_mod] = ACTIONS(2739),
    [anon_sym_pub] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_trait] = ACTIONS(2739),
    [anon_sym_type] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_unsafe] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2739),
    [anon_sym_move] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [sym_integer_literal] = ACTIONS(2737),
    [aux_sym_string_literal_token1] = ACTIONS(2737),
    [sym_char_literal] = ACTIONS(2737),
    [anon_sym_true] = ACTIONS(2739),
    [anon_sym_false] = ACTIONS(2739),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2739),
    [sym_super] = ACTIONS(2739),
    [sym_crate] = ACTIONS(2739),
    [sym_metavariable] = ACTIONS(2737),
    [sym__raw_string_literal_start] = ACTIONS(2737),
    [sym_float_literal] = ACTIONS(2737),
  },
  [708] = {
    [sym_line_comment] = STATE(708),
    [sym_block_comment] = STATE(708),
    [ts_builtin_sym_end] = ACTIONS(2741),
    [sym_identifier] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym_macro_rules_BANG] = ACTIONS(2741),
    [anon_sym_LPAREN] = ACTIONS(2741),
    [anon_sym_LBRACK] = ACTIONS(2741),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_u8] = ACTIONS(2743),
    [anon_sym_i8] = ACTIONS(2743),
    [anon_sym_u16] = ACTIONS(2743),
    [anon_sym_i16] = ACTIONS(2743),
    [anon_sym_u32] = ACTIONS(2743),
    [anon_sym_i32] = ACTIONS(2743),
    [anon_sym_u64] = ACTIONS(2743),
    [anon_sym_i64] = ACTIONS(2743),
    [anon_sym_u128] = ACTIONS(2743),
    [anon_sym_i128] = ACTIONS(2743),
    [anon_sym_isize] = ACTIONS(2743),
    [anon_sym_usize] = ACTIONS(2743),
    [anon_sym_f32] = ACTIONS(2743),
    [anon_sym_f64] = ACTIONS(2743),
    [anon_sym_bool] = ACTIONS(2743),
    [anon_sym_str] = ACTIONS(2743),
    [anon_sym_char] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_POUND] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2743),
    [anon_sym_async] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_fn] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_impl] = ACTIONS(2743),
    [anon_sym_let] = ACTIONS(2743),
    [anon_sym_loop] = ACTIONS(2743),
    [anon_sym_match] = ACTIONS(2743),
    [anon_sym_mod] = ACTIONS(2743),
    [anon_sym_pub] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_trait] = ACTIONS(2743),
    [anon_sym_type] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_unsafe] = ACTIONS(2743),
    [anon_sym_use] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym_yield] = ACTIONS(2743),
    [anon_sym_move] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [sym_integer_literal] = ACTIONS(2741),
    [aux_sym_string_literal_token1] = ACTIONS(2741),
    [sym_char_literal] = ACTIONS(2741),
    [anon_sym_true] = ACTIONS(2743),
    [anon_sym_false] = ACTIONS(2743),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2743),
    [sym_super] = ACTIONS(2743),
    [sym_crate] = ACTIONS(2743),
    [sym_metavariable] = ACTIONS(2741),
    [sym__raw_string_literal_start] = ACTIONS(2741),
    [sym_float_literal] = ACTIONS(2741),
  },
  [709] = {
    [sym_line_comment] = STATE(709),
    [sym_block_comment] = STATE(709),
    [ts_builtin_sym_end] = ACTIONS(2745),
    [sym_identifier] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym_macro_rules_BANG] = ACTIONS(2745),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [anon_sym_LBRACK] = ACTIONS(2745),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_u8] = ACTIONS(2747),
    [anon_sym_i8] = ACTIONS(2747),
    [anon_sym_u16] = ACTIONS(2747),
    [anon_sym_i16] = ACTIONS(2747),
    [anon_sym_u32] = ACTIONS(2747),
    [anon_sym_i32] = ACTIONS(2747),
    [anon_sym_u64] = ACTIONS(2747),
    [anon_sym_i64] = ACTIONS(2747),
    [anon_sym_u128] = ACTIONS(2747),
    [anon_sym_i128] = ACTIONS(2747),
    [anon_sym_isize] = ACTIONS(2747),
    [anon_sym_usize] = ACTIONS(2747),
    [anon_sym_f32] = ACTIONS(2747),
    [anon_sym_f64] = ACTIONS(2747),
    [anon_sym_bool] = ACTIONS(2747),
    [anon_sym_str] = ACTIONS(2747),
    [anon_sym_char] = ACTIONS(2747),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2745),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_LT] = ACTIONS(2745),
    [anon_sym_DOT_DOT] = ACTIONS(2745),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_POUND] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2747),
    [anon_sym_async] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_fn] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_impl] = ACTIONS(2747),
    [anon_sym_let] = ACTIONS(2747),
    [anon_sym_loop] = ACTIONS(2747),
    [anon_sym_match] = ACTIONS(2747),
    [anon_sym_mod] = ACTIONS(2747),
    [anon_sym_pub] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_trait] = ACTIONS(2747),
    [anon_sym_type] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_unsafe] = ACTIONS(2747),
    [anon_sym_use] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym_yield] = ACTIONS(2747),
    [anon_sym_move] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [sym_integer_literal] = ACTIONS(2745),
    [aux_sym_string_literal_token1] = ACTIONS(2745),
    [sym_char_literal] = ACTIONS(2745),
    [anon_sym_true] = ACTIONS(2747),
    [anon_sym_false] = ACTIONS(2747),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2747),
    [sym_super] = ACTIONS(2747),
    [sym_crate] = ACTIONS(2747),
    [sym_metavariable] = ACTIONS(2745),
    [sym__raw_string_literal_start] = ACTIONS(2745),
    [sym_float_literal] = ACTIONS(2745),
  },
  [710] = {
    [sym_line_comment] = STATE(710),
    [sym_block_comment] = STATE(710),
    [ts_builtin_sym_end] = ACTIONS(2749),
    [sym_identifier] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym_macro_rules_BANG] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2749),
    [anon_sym_LBRACK] = ACTIONS(2749),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_u8] = ACTIONS(2751),
    [anon_sym_i8] = ACTIONS(2751),
    [anon_sym_u16] = ACTIONS(2751),
    [anon_sym_i16] = ACTIONS(2751),
    [anon_sym_u32] = ACTIONS(2751),
    [anon_sym_i32] = ACTIONS(2751),
    [anon_sym_u64] = ACTIONS(2751),
    [anon_sym_i64] = ACTIONS(2751),
    [anon_sym_u128] = ACTIONS(2751),
    [anon_sym_i128] = ACTIONS(2751),
    [anon_sym_isize] = ACTIONS(2751),
    [anon_sym_usize] = ACTIONS(2751),
    [anon_sym_f32] = ACTIONS(2751),
    [anon_sym_f64] = ACTIONS(2751),
    [anon_sym_bool] = ACTIONS(2751),
    [anon_sym_str] = ACTIONS(2751),
    [anon_sym_char] = ACTIONS(2751),
    [anon_sym_DASH] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_PIPE] = ACTIONS(2749),
    [anon_sym_LT] = ACTIONS(2749),
    [anon_sym_DOT_DOT] = ACTIONS(2749),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_POUND] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2751),
    [anon_sym_async] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_fn] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_impl] = ACTIONS(2751),
    [anon_sym_let] = ACTIONS(2751),
    [anon_sym_loop] = ACTIONS(2751),
    [anon_sym_match] = ACTIONS(2751),
    [anon_sym_mod] = ACTIONS(2751),
    [anon_sym_pub] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_trait] = ACTIONS(2751),
    [anon_sym_type] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_unsafe] = ACTIONS(2751),
    [anon_sym_use] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym_yield] = ACTIONS(2751),
    [anon_sym_move] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [sym_integer_literal] = ACTIONS(2749),
    [aux_sym_string_literal_token1] = ACTIONS(2749),
    [sym_char_literal] = ACTIONS(2749),
    [anon_sym_true] = ACTIONS(2751),
    [anon_sym_false] = ACTIONS(2751),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2751),
    [sym_super] = ACTIONS(2751),
    [sym_crate] = ACTIONS(2751),
    [sym_metavariable] = ACTIONS(2749),
    [sym__raw_string_literal_start] = ACTIONS(2749),
    [sym_float_literal] = ACTIONS(2749),
  },
  [711] = {
    [sym_line_comment] = STATE(711),
    [sym_block_comment] = STATE(711),
    [ts_builtin_sym_end] = ACTIONS(2753),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_macro_rules_BANG] = ACTIONS(2753),
    [anon_sym_LPAREN] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_u8] = ACTIONS(2755),
    [anon_sym_i8] = ACTIONS(2755),
    [anon_sym_u16] = ACTIONS(2755),
    [anon_sym_i16] = ACTIONS(2755),
    [anon_sym_u32] = ACTIONS(2755),
    [anon_sym_i32] = ACTIONS(2755),
    [anon_sym_u64] = ACTIONS(2755),
    [anon_sym_i64] = ACTIONS(2755),
    [anon_sym_u128] = ACTIONS(2755),
    [anon_sym_i128] = ACTIONS(2755),
    [anon_sym_isize] = ACTIONS(2755),
    [anon_sym_usize] = ACTIONS(2755),
    [anon_sym_f32] = ACTIONS(2755),
    [anon_sym_f64] = ACTIONS(2755),
    [anon_sym_bool] = ACTIONS(2755),
    [anon_sym_str] = ACTIONS(2755),
    [anon_sym_char] = ACTIONS(2755),
    [anon_sym_DASH] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2753),
    [anon_sym_PIPE] = ACTIONS(2753),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2753),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_POUND] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_async] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_fn] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_impl] = ACTIONS(2755),
    [anon_sym_let] = ACTIONS(2755),
    [anon_sym_loop] = ACTIONS(2755),
    [anon_sym_match] = ACTIONS(2755),
    [anon_sym_mod] = ACTIONS(2755),
    [anon_sym_pub] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_trait] = ACTIONS(2755),
    [anon_sym_type] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_unsafe] = ACTIONS(2755),
    [anon_sym_use] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2755),
    [anon_sym_move] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [sym_integer_literal] = ACTIONS(2753),
    [aux_sym_string_literal_token1] = ACTIONS(2753),
    [sym_char_literal] = ACTIONS(2753),
    [anon_sym_true] = ACTIONS(2755),
    [anon_sym_false] = ACTIONS(2755),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2755),
    [sym_super] = ACTIONS(2755),
    [sym_crate] = ACTIONS(2755),
    [sym_metavariable] = ACTIONS(2753),
    [sym__raw_string_literal_start] = ACTIONS(2753),
    [sym_float_literal] = ACTIONS(2753),
  },
  [712] = {
    [sym_line_comment] = STATE(712),
    [sym_block_comment] = STATE(712),
    [ts_builtin_sym_end] = ACTIONS(2757),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym_macro_rules_BANG] = ACTIONS(2757),
    [anon_sym_LPAREN] = ACTIONS(2757),
    [anon_sym_LBRACK] = ACTIONS(2757),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_RBRACE] = ACTIONS(2757),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_u8] = ACTIONS(2759),
    [anon_sym_i8] = ACTIONS(2759),
    [anon_sym_u16] = ACTIONS(2759),
    [anon_sym_i16] = ACTIONS(2759),
    [anon_sym_u32] = ACTIONS(2759),
    [anon_sym_i32] = ACTIONS(2759),
    [anon_sym_u64] = ACTIONS(2759),
    [anon_sym_i64] = ACTIONS(2759),
    [anon_sym_u128] = ACTIONS(2759),
    [anon_sym_i128] = ACTIONS(2759),
    [anon_sym_isize] = ACTIONS(2759),
    [anon_sym_usize] = ACTIONS(2759),
    [anon_sym_f32] = ACTIONS(2759),
    [anon_sym_f64] = ACTIONS(2759),
    [anon_sym_bool] = ACTIONS(2759),
    [anon_sym_str] = ACTIONS(2759),
    [anon_sym_char] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2757),
    [anon_sym_PIPE] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(2757),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_POUND] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2759),
    [anon_sym_async] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_fn] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_impl] = ACTIONS(2759),
    [anon_sym_let] = ACTIONS(2759),
    [anon_sym_loop] = ACTIONS(2759),
    [anon_sym_match] = ACTIONS(2759),
    [anon_sym_mod] = ACTIONS(2759),
    [anon_sym_pub] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_trait] = ACTIONS(2759),
    [anon_sym_type] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_unsafe] = ACTIONS(2759),
    [anon_sym_use] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym_yield] = ACTIONS(2759),
    [anon_sym_move] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [sym_integer_literal] = ACTIONS(2757),
    [aux_sym_string_literal_token1] = ACTIONS(2757),
    [sym_char_literal] = ACTIONS(2757),
    [anon_sym_true] = ACTIONS(2759),
    [anon_sym_false] = ACTIONS(2759),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2759),
    [sym_super] = ACTIONS(2759),
    [sym_crate] = ACTIONS(2759),
    [sym_metavariable] = ACTIONS(2757),
    [sym__raw_string_literal_start] = ACTIONS(2757),
    [sym_float_literal] = ACTIONS(2757),
  },
  [713] = {
    [sym_line_comment] = STATE(713),
    [sym_block_comment] = STATE(713),
    [ts_builtin_sym_end] = ACTIONS(2761),
    [sym_identifier] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym_macro_rules_BANG] = ACTIONS(2761),
    [anon_sym_LPAREN] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_RBRACE] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_u8] = ACTIONS(2763),
    [anon_sym_i8] = ACTIONS(2763),
    [anon_sym_u16] = ACTIONS(2763),
    [anon_sym_i16] = ACTIONS(2763),
    [anon_sym_u32] = ACTIONS(2763),
    [anon_sym_i32] = ACTIONS(2763),
    [anon_sym_u64] = ACTIONS(2763),
    [anon_sym_i64] = ACTIONS(2763),
    [anon_sym_u128] = ACTIONS(2763),
    [anon_sym_i128] = ACTIONS(2763),
    [anon_sym_isize] = ACTIONS(2763),
    [anon_sym_usize] = ACTIONS(2763),
    [anon_sym_f32] = ACTIONS(2763),
    [anon_sym_f64] = ACTIONS(2763),
    [anon_sym_bool] = ACTIONS(2763),
    [anon_sym_str] = ACTIONS(2763),
    [anon_sym_char] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_POUND] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_async] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_fn] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_impl] = ACTIONS(2763),
    [anon_sym_let] = ACTIONS(2763),
    [anon_sym_loop] = ACTIONS(2763),
    [anon_sym_match] = ACTIONS(2763),
    [anon_sym_mod] = ACTIONS(2763),
    [anon_sym_pub] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_trait] = ACTIONS(2763),
    [anon_sym_type] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_unsafe] = ACTIONS(2763),
    [anon_sym_use] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_move] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [sym_integer_literal] = ACTIONS(2761),
    [aux_sym_string_literal_token1] = ACTIONS(2761),
    [sym_char_literal] = ACTIONS(2761),
    [anon_sym_true] = ACTIONS(2763),
    [anon_sym_false] = ACTIONS(2763),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2763),
    [sym_super] = ACTIONS(2763),
    [sym_crate] = ACTIONS(2763),
    [sym_metavariable] = ACTIONS(2761),
    [sym__raw_string_literal_start] = ACTIONS(2761),
    [sym_float_literal] = ACTIONS(2761),
  },
  [714] = {
    [sym_line_comment] = STATE(714),
    [sym_block_comment] = STATE(714),
    [ts_builtin_sym_end] = ACTIONS(2765),
    [sym_identifier] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym_macro_rules_BANG] = ACTIONS(2765),
    [anon_sym_LPAREN] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2765),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_u8] = ACTIONS(2767),
    [anon_sym_i8] = ACTIONS(2767),
    [anon_sym_u16] = ACTIONS(2767),
    [anon_sym_i16] = ACTIONS(2767),
    [anon_sym_u32] = ACTIONS(2767),
    [anon_sym_i32] = ACTIONS(2767),
    [anon_sym_u64] = ACTIONS(2767),
    [anon_sym_i64] = ACTIONS(2767),
    [anon_sym_u128] = ACTIONS(2767),
    [anon_sym_i128] = ACTIONS(2767),
    [anon_sym_isize] = ACTIONS(2767),
    [anon_sym_usize] = ACTIONS(2767),
    [anon_sym_f32] = ACTIONS(2767),
    [anon_sym_f64] = ACTIONS(2767),
    [anon_sym_bool] = ACTIONS(2767),
    [anon_sym_str] = ACTIONS(2767),
    [anon_sym_char] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2765),
    [anon_sym_PIPE] = ACTIONS(2765),
    [anon_sym_LT] = ACTIONS(2765),
    [anon_sym_DOT_DOT] = ACTIONS(2765),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_POUND] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_async] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_fn] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_impl] = ACTIONS(2767),
    [anon_sym_let] = ACTIONS(2767),
    [anon_sym_loop] = ACTIONS(2767),
    [anon_sym_match] = ACTIONS(2767),
    [anon_sym_mod] = ACTIONS(2767),
    [anon_sym_pub] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_trait] = ACTIONS(2767),
    [anon_sym_type] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_unsafe] = ACTIONS(2767),
    [anon_sym_use] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym_yield] = ACTIONS(2767),
    [anon_sym_move] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [sym_integer_literal] = ACTIONS(2765),
    [aux_sym_string_literal_token1] = ACTIONS(2765),
    [sym_char_literal] = ACTIONS(2765),
    [anon_sym_true] = ACTIONS(2767),
    [anon_sym_false] = ACTIONS(2767),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2767),
    [sym_super] = ACTIONS(2767),
    [sym_crate] = ACTIONS(2767),
    [sym_metavariable] = ACTIONS(2765),
    [sym__raw_string_literal_start] = ACTIONS(2765),
    [sym_float_literal] = ACTIONS(2765),
  },
  [715] = {
    [sym_line_comment] = STATE(715),
    [sym_block_comment] = STATE(715),
    [ts_builtin_sym_end] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym_macro_rules_BANG] = ACTIONS(2769),
    [anon_sym_LPAREN] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_u8] = ACTIONS(2771),
    [anon_sym_i8] = ACTIONS(2771),
    [anon_sym_u16] = ACTIONS(2771),
    [anon_sym_i16] = ACTIONS(2771),
    [anon_sym_u32] = ACTIONS(2771),
    [anon_sym_i32] = ACTIONS(2771),
    [anon_sym_u64] = ACTIONS(2771),
    [anon_sym_i64] = ACTIONS(2771),
    [anon_sym_u128] = ACTIONS(2771),
    [anon_sym_i128] = ACTIONS(2771),
    [anon_sym_isize] = ACTIONS(2771),
    [anon_sym_usize] = ACTIONS(2771),
    [anon_sym_f32] = ACTIONS(2771),
    [anon_sym_f64] = ACTIONS(2771),
    [anon_sym_bool] = ACTIONS(2771),
    [anon_sym_str] = ACTIONS(2771),
    [anon_sym_char] = ACTIONS(2771),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_PIPE] = ACTIONS(2769),
    [anon_sym_LT] = ACTIONS(2769),
    [anon_sym_DOT_DOT] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_POUND] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_continue] = ACTIONS(2771),
    [anon_sym_default] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_fn] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_impl] = ACTIONS(2771),
    [anon_sym_let] = ACTIONS(2771),
    [anon_sym_loop] = ACTIONS(2771),
    [anon_sym_match] = ACTIONS(2771),
    [anon_sym_mod] = ACTIONS(2771),
    [anon_sym_pub] = ACTIONS(2771),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_trait] = ACTIONS(2771),
    [anon_sym_type] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [anon_sym_unsafe] = ACTIONS(2771),
    [anon_sym_use] = ACTIONS(2771),
    [anon_sym_while] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym_yield] = ACTIONS(2771),
    [anon_sym_move] = ACTIONS(2771),
    [anon_sym_try] = ACTIONS(2771),
    [sym_integer_literal] = ACTIONS(2769),
    [aux_sym_string_literal_token1] = ACTIONS(2769),
    [sym_char_literal] = ACTIONS(2769),
    [anon_sym_true] = ACTIONS(2771),
    [anon_sym_false] = ACTIONS(2771),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2771),
    [sym_super] = ACTIONS(2771),
    [sym_crate] = ACTIONS(2771),
    [sym_metavariable] = ACTIONS(2769),
    [sym__raw_string_literal_start] = ACTIONS(2769),
    [sym_float_literal] = ACTIONS(2769),
  },
  [716] = {
    [sym_line_comment] = STATE(716),
    [sym_block_comment] = STATE(716),
    [ts_builtin_sym_end] = ACTIONS(2773),
    [sym_identifier] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_macro_rules_BANG] = ACTIONS(2773),
    [anon_sym_LPAREN] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_u8] = ACTIONS(2775),
    [anon_sym_i8] = ACTIONS(2775),
    [anon_sym_u16] = ACTIONS(2775),
    [anon_sym_i16] = ACTIONS(2775),
    [anon_sym_u32] = ACTIONS(2775),
    [anon_sym_i32] = ACTIONS(2775),
    [anon_sym_u64] = ACTIONS(2775),
    [anon_sym_i64] = ACTIONS(2775),
    [anon_sym_u128] = ACTIONS(2775),
    [anon_sym_i128] = ACTIONS(2775),
    [anon_sym_isize] = ACTIONS(2775),
    [anon_sym_usize] = ACTIONS(2775),
    [anon_sym_f32] = ACTIONS(2775),
    [anon_sym_f64] = ACTIONS(2775),
    [anon_sym_bool] = ACTIONS(2775),
    [anon_sym_str] = ACTIONS(2775),
    [anon_sym_char] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_LT] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2773),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_POUND] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2775),
    [anon_sym_async] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2775),
    [anon_sym_const] = ACTIONS(2775),
    [anon_sym_continue] = ACTIONS(2775),
    [anon_sym_default] = ACTIONS(2775),
    [anon_sym_enum] = ACTIONS(2775),
    [anon_sym_fn] = ACTIONS(2775),
    [anon_sym_for] = ACTIONS(2775),
    [anon_sym_if] = ACTIONS(2775),
    [anon_sym_impl] = ACTIONS(2775),
    [anon_sym_let] = ACTIONS(2775),
    [anon_sym_loop] = ACTIONS(2775),
    [anon_sym_match] = ACTIONS(2775),
    [anon_sym_mod] = ACTIONS(2775),
    [anon_sym_pub] = ACTIONS(2775),
    [anon_sym_return] = ACTIONS(2775),
    [anon_sym_static] = ACTIONS(2775),
    [anon_sym_struct] = ACTIONS(2775),
    [anon_sym_trait] = ACTIONS(2775),
    [anon_sym_type] = ACTIONS(2775),
    [anon_sym_union] = ACTIONS(2775),
    [anon_sym_unsafe] = ACTIONS(2775),
    [anon_sym_use] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(2775),
    [anon_sym_extern] = ACTIONS(2775),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_move] = ACTIONS(2775),
    [anon_sym_try] = ACTIONS(2775),
    [sym_integer_literal] = ACTIONS(2773),
    [aux_sym_string_literal_token1] = ACTIONS(2773),
    [sym_char_literal] = ACTIONS(2773),
    [anon_sym_true] = ACTIONS(2775),
    [anon_sym_false] = ACTIONS(2775),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2775),
    [sym_super] = ACTIONS(2775),
    [sym_crate] = ACTIONS(2775),
    [sym_metavariable] = ACTIONS(2773),
    [sym__raw_string_literal_start] = ACTIONS(2773),
    [sym_float_literal] = ACTIONS(2773),
  },
  [717] = {
    [sym_line_comment] = STATE(717),
    [sym_block_comment] = STATE(717),
    [ts_builtin_sym_end] = ACTIONS(2777),
    [sym_identifier] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym_macro_rules_BANG] = ACTIONS(2777),
    [anon_sym_LPAREN] = ACTIONS(2777),
    [anon_sym_LBRACK] = ACTIONS(2777),
    [anon_sym_LBRACE] = ACTIONS(2777),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_u8] = ACTIONS(2779),
    [anon_sym_i8] = ACTIONS(2779),
    [anon_sym_u16] = ACTIONS(2779),
    [anon_sym_i16] = ACTIONS(2779),
    [anon_sym_u32] = ACTIONS(2779),
    [anon_sym_i32] = ACTIONS(2779),
    [anon_sym_u64] = ACTIONS(2779),
    [anon_sym_i64] = ACTIONS(2779),
    [anon_sym_u128] = ACTIONS(2779),
    [anon_sym_i128] = ACTIONS(2779),
    [anon_sym_isize] = ACTIONS(2779),
    [anon_sym_usize] = ACTIONS(2779),
    [anon_sym_f32] = ACTIONS(2779),
    [anon_sym_f64] = ACTIONS(2779),
    [anon_sym_bool] = ACTIONS(2779),
    [anon_sym_str] = ACTIONS(2779),
    [anon_sym_char] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2777),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_POUND] = ACTIONS(2777),
    [anon_sym_SQUOTE] = ACTIONS(2779),
    [anon_sym_async] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_default] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_fn] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_impl] = ACTIONS(2779),
    [anon_sym_let] = ACTIONS(2779),
    [anon_sym_loop] = ACTIONS(2779),
    [anon_sym_match] = ACTIONS(2779),
    [anon_sym_mod] = ACTIONS(2779),
    [anon_sym_pub] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_trait] = ACTIONS(2779),
    [anon_sym_type] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_unsafe] = ACTIONS(2779),
    [anon_sym_use] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym_yield] = ACTIONS(2779),
    [anon_sym_move] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [sym_integer_literal] = ACTIONS(2777),
    [aux_sym_string_literal_token1] = ACTIONS(2777),
    [sym_char_literal] = ACTIONS(2777),
    [anon_sym_true] = ACTIONS(2779),
    [anon_sym_false] = ACTIONS(2779),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2779),
    [sym_super] = ACTIONS(2779),
    [sym_crate] = ACTIONS(2779),
    [sym_metavariable] = ACTIONS(2777),
    [sym__raw_string_literal_start] = ACTIONS(2777),
    [sym_float_literal] = ACTIONS(2777),
  },
  [718] = {
    [sym_line_comment] = STATE(718),
    [sym_block_comment] = STATE(718),
    [ts_builtin_sym_end] = ACTIONS(2781),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_macro_rules_BANG] = ACTIONS(2781),
    [anon_sym_LPAREN] = ACTIONS(2781),
    [anon_sym_LBRACK] = ACTIONS(2781),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_u8] = ACTIONS(2783),
    [anon_sym_i8] = ACTIONS(2783),
    [anon_sym_u16] = ACTIONS(2783),
    [anon_sym_i16] = ACTIONS(2783),
    [anon_sym_u32] = ACTIONS(2783),
    [anon_sym_i32] = ACTIONS(2783),
    [anon_sym_u64] = ACTIONS(2783),
    [anon_sym_i64] = ACTIONS(2783),
    [anon_sym_u128] = ACTIONS(2783),
    [anon_sym_i128] = ACTIONS(2783),
    [anon_sym_isize] = ACTIONS(2783),
    [anon_sym_usize] = ACTIONS(2783),
    [anon_sym_f32] = ACTIONS(2783),
    [anon_sym_f64] = ACTIONS(2783),
    [anon_sym_bool] = ACTIONS(2783),
    [anon_sym_str] = ACTIONS(2783),
    [anon_sym_char] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_LT] = ACTIONS(2781),
    [anon_sym_DOT_DOT] = ACTIONS(2781),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_POUND] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2783),
    [anon_sym_async] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_fn] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_impl] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_loop] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_mod] = ACTIONS(2783),
    [anon_sym_pub] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_trait] = ACTIONS(2783),
    [anon_sym_type] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_unsafe] = ACTIONS(2783),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_move] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [sym_integer_literal] = ACTIONS(2781),
    [aux_sym_string_literal_token1] = ACTIONS(2781),
    [sym_char_literal] = ACTIONS(2781),
    [anon_sym_true] = ACTIONS(2783),
    [anon_sym_false] = ACTIONS(2783),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2783),
    [sym_super] = ACTIONS(2783),
    [sym_crate] = ACTIONS(2783),
    [sym_metavariable] = ACTIONS(2781),
    [sym__raw_string_literal_start] = ACTIONS(2781),
    [sym_float_literal] = ACTIONS(2781),
  },
  [719] = {
    [sym_line_comment] = STATE(719),
    [sym_block_comment] = STATE(719),
    [ts_builtin_sym_end] = ACTIONS(2785),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym_macro_rules_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2785),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_u8] = ACTIONS(2787),
    [anon_sym_i8] = ACTIONS(2787),
    [anon_sym_u16] = ACTIONS(2787),
    [anon_sym_i16] = ACTIONS(2787),
    [anon_sym_u32] = ACTIONS(2787),
    [anon_sym_i32] = ACTIONS(2787),
    [anon_sym_u64] = ACTIONS(2787),
    [anon_sym_i64] = ACTIONS(2787),
    [anon_sym_u128] = ACTIONS(2787),
    [anon_sym_i128] = ACTIONS(2787),
    [anon_sym_isize] = ACTIONS(2787),
    [anon_sym_usize] = ACTIONS(2787),
    [anon_sym_f32] = ACTIONS(2787),
    [anon_sym_f64] = ACTIONS(2787),
    [anon_sym_bool] = ACTIONS(2787),
    [anon_sym_str] = ACTIONS(2787),
    [anon_sym_char] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2785),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_POUND] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2787),
    [anon_sym_async] = ACTIONS(2787),
    [anon_sym_break] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_continue] = ACTIONS(2787),
    [anon_sym_default] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_fn] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_impl] = ACTIONS(2787),
    [anon_sym_let] = ACTIONS(2787),
    [anon_sym_loop] = ACTIONS(2787),
    [anon_sym_match] = ACTIONS(2787),
    [anon_sym_mod] = ACTIONS(2787),
    [anon_sym_pub] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_trait] = ACTIONS(2787),
    [anon_sym_type] = ACTIONS(2787),
    [anon_sym_union] = ACTIONS(2787),
    [anon_sym_unsafe] = ACTIONS(2787),
    [anon_sym_use] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [anon_sym_extern] = ACTIONS(2787),
    [anon_sym_yield] = ACTIONS(2787),
    [anon_sym_move] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [sym_integer_literal] = ACTIONS(2785),
    [aux_sym_string_literal_token1] = ACTIONS(2785),
    [sym_char_literal] = ACTIONS(2785),
    [anon_sym_true] = ACTIONS(2787),
    [anon_sym_false] = ACTIONS(2787),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2787),
    [sym_super] = ACTIONS(2787),
    [sym_crate] = ACTIONS(2787),
    [sym_metavariable] = ACTIONS(2785),
    [sym__raw_string_literal_start] = ACTIONS(2785),
    [sym_float_literal] = ACTIONS(2785),
  },
  [720] = {
    [sym_line_comment] = STATE(720),
    [sym_block_comment] = STATE(720),
    [ts_builtin_sym_end] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_macro_rules_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u8] = ACTIONS(2791),
    [anon_sym_i8] = ACTIONS(2791),
    [anon_sym_u16] = ACTIONS(2791),
    [anon_sym_i16] = ACTIONS(2791),
    [anon_sym_u32] = ACTIONS(2791),
    [anon_sym_i32] = ACTIONS(2791),
    [anon_sym_u64] = ACTIONS(2791),
    [anon_sym_i64] = ACTIONS(2791),
    [anon_sym_u128] = ACTIONS(2791),
    [anon_sym_i128] = ACTIONS(2791),
    [anon_sym_isize] = ACTIONS(2791),
    [anon_sym_usize] = ACTIONS(2791),
    [anon_sym_f32] = ACTIONS(2791),
    [anon_sym_f64] = ACTIONS(2791),
    [anon_sym_bool] = ACTIONS(2791),
    [anon_sym_str] = ACTIONS(2791),
    [anon_sym_char] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2789),
    [anon_sym_BANG] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_POUND] = ACTIONS(2789),
    [anon_sym_SQUOTE] = ACTIONS(2791),
    [anon_sym_async] = ACTIONS(2791),
    [anon_sym_break] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_continue] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_fn] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_impl] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_loop] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_mod] = ACTIONS(2791),
    [anon_sym_pub] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_trait] = ACTIONS(2791),
    [anon_sym_type] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [anon_sym_unsafe] = ACTIONS(2791),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_move] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [sym_integer_literal] = ACTIONS(2789),
    [aux_sym_string_literal_token1] = ACTIONS(2789),
    [sym_char_literal] = ACTIONS(2789),
    [anon_sym_true] = ACTIONS(2791),
    [anon_sym_false] = ACTIONS(2791),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2791),
    [sym_super] = ACTIONS(2791),
    [sym_crate] = ACTIONS(2791),
    [sym_metavariable] = ACTIONS(2789),
    [sym__raw_string_literal_start] = ACTIONS(2789),
    [sym_float_literal] = ACTIONS(2789),
  },
  [721] = {
    [sym_line_comment] = STATE(721),
    [sym_block_comment] = STATE(721),
    [ts_builtin_sym_end] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym_macro_rules_BANG] = ACTIONS(2793),
    [anon_sym_LPAREN] = ACTIONS(2793),
    [anon_sym_LBRACK] = ACTIONS(2793),
    [anon_sym_LBRACE] = ACTIONS(2793),
    [anon_sym_RBRACE] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(2793),
    [anon_sym_u8] = ACTIONS(2795),
    [anon_sym_i8] = ACTIONS(2795),
    [anon_sym_u16] = ACTIONS(2795),
    [anon_sym_i16] = ACTIONS(2795),
    [anon_sym_u32] = ACTIONS(2795),
    [anon_sym_i32] = ACTIONS(2795),
    [anon_sym_u64] = ACTIONS(2795),
    [anon_sym_i64] = ACTIONS(2795),
    [anon_sym_u128] = ACTIONS(2795),
    [anon_sym_i128] = ACTIONS(2795),
    [anon_sym_isize] = ACTIONS(2795),
    [anon_sym_usize] = ACTIONS(2795),
    [anon_sym_f32] = ACTIONS(2795),
    [anon_sym_f64] = ACTIONS(2795),
    [anon_sym_bool] = ACTIONS(2795),
    [anon_sym_str] = ACTIONS(2795),
    [anon_sym_char] = ACTIONS(2795),
    [anon_sym_DASH] = ACTIONS(2793),
    [anon_sym_BANG] = ACTIONS(2793),
    [anon_sym_AMP] = ACTIONS(2793),
    [anon_sym_PIPE] = ACTIONS(2793),
    [anon_sym_LT] = ACTIONS(2793),
    [anon_sym_DOT_DOT] = ACTIONS(2793),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_POUND] = ACTIONS(2793),
    [anon_sym_SQUOTE] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(2795),
    [anon_sym_break] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_continue] = ACTIONS(2795),
    [anon_sym_default] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2795),
    [anon_sym_fn] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_impl] = ACTIONS(2795),
    [anon_sym_let] = ACTIONS(2795),
    [anon_sym_loop] = ACTIONS(2795),
    [anon_sym_match] = ACTIONS(2795),
    [anon_sym_mod] = ACTIONS(2795),
    [anon_sym_pub] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_static] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_trait] = ACTIONS(2795),
    [anon_sym_type] = ACTIONS(2795),
    [anon_sym_union] = ACTIONS(2795),
    [anon_sym_unsafe] = ACTIONS(2795),
    [anon_sym_use] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [anon_sym_extern] = ACTIONS(2795),
    [anon_sym_yield] = ACTIONS(2795),
    [anon_sym_move] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [sym_integer_literal] = ACTIONS(2793),
    [aux_sym_string_literal_token1] = ACTIONS(2793),
    [sym_char_literal] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(2795),
    [anon_sym_false] = ACTIONS(2795),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2795),
    [sym_super] = ACTIONS(2795),
    [sym_crate] = ACTIONS(2795),
    [sym_metavariable] = ACTIONS(2793),
    [sym__raw_string_literal_start] = ACTIONS(2793),
    [sym_float_literal] = ACTIONS(2793),
  },
  [722] = {
    [sym_line_comment] = STATE(722),
    [sym_block_comment] = STATE(722),
    [ts_builtin_sym_end] = ACTIONS(2797),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2797),
    [anon_sym_macro_rules_BANG] = ACTIONS(2797),
    [anon_sym_LPAREN] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(2797),
    [anon_sym_RBRACE] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_u8] = ACTIONS(2799),
    [anon_sym_i8] = ACTIONS(2799),
    [anon_sym_u16] = ACTIONS(2799),
    [anon_sym_i16] = ACTIONS(2799),
    [anon_sym_u32] = ACTIONS(2799),
    [anon_sym_i32] = ACTIONS(2799),
    [anon_sym_u64] = ACTIONS(2799),
    [anon_sym_i64] = ACTIONS(2799),
    [anon_sym_u128] = ACTIONS(2799),
    [anon_sym_i128] = ACTIONS(2799),
    [anon_sym_isize] = ACTIONS(2799),
    [anon_sym_usize] = ACTIONS(2799),
    [anon_sym_f32] = ACTIONS(2799),
    [anon_sym_f64] = ACTIONS(2799),
    [anon_sym_bool] = ACTIONS(2799),
    [anon_sym_str] = ACTIONS(2799),
    [anon_sym_char] = ACTIONS(2799),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_BANG] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym_PIPE] = ACTIONS(2797),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_DOT_DOT] = ACTIONS(2797),
    [anon_sym_COLON_COLON] = ACTIONS(2797),
    [anon_sym_POUND] = ACTIONS(2797),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [anon_sym_async] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_fn] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_impl] = ACTIONS(2799),
    [anon_sym_let] = ACTIONS(2799),
    [anon_sym_loop] = ACTIONS(2799),
    [anon_sym_match] = ACTIONS(2799),
    [anon_sym_mod] = ACTIONS(2799),
    [anon_sym_pub] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_trait] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_unsafe] = ACTIONS(2799),
    [anon_sym_use] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym_yield] = ACTIONS(2799),
    [anon_sym_move] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [sym_integer_literal] = ACTIONS(2797),
    [aux_sym_string_literal_token1] = ACTIONS(2797),
    [sym_char_literal] = ACTIONS(2797),
    [anon_sym_true] = ACTIONS(2799),
    [anon_sym_false] = ACTIONS(2799),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2799),
    [sym_super] = ACTIONS(2799),
    [sym_crate] = ACTIONS(2799),
    [sym_metavariable] = ACTIONS(2797),
    [sym__raw_string_literal_start] = ACTIONS(2797),
    [sym_float_literal] = ACTIONS(2797),
  },
  [723] = {
    [sym_empty_statement] = STATE(1389),
    [sym_macro_definition] = STATE(1389),
    [sym_attribute_item] = STATE(1389),
    [sym_inner_attribute_item] = STATE(1389),
    [sym_mod_item] = STATE(1389),
    [sym_foreign_mod_item] = STATE(1389),
    [sym_struct_item] = STATE(1389),
    [sym_union_item] = STATE(1389),
    [sym_enum_item] = STATE(1389),
    [sym_extern_crate_declaration] = STATE(1389),
    [sym_const_item] = STATE(1389),
    [sym_static_item] = STATE(1389),
    [sym_type_item] = STATE(1389),
    [sym_function_item] = STATE(1389),
    [sym_function_signature_item] = STATE(1389),
    [sym_function_modifiers] = STATE(3601),
    [sym_impl_item] = STATE(1389),
    [sym_trait_item] = STATE(1389),
    [sym_associated_type] = STATE(1389),
    [sym_let_declaration] = STATE(1389),
    [sym_use_declaration] = STATE(1389),
    [sym_extern_modifier] = STATE(2140),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3312),
    [sym_generic_type_with_turbofish] = STATE(3351),
    [sym_macro_invocation] = STATE(1389),
    [sym_scoped_identifier] = STATE(3243),
    [sym_line_comment] = STATE(723),
    [sym_block_comment] = STATE(723),
    [aux_sym_declaration_list_repeat1] = STATE(628),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_macro_rules_BANG] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_u8] = ACTIONS(1928),
    [anon_sym_i8] = ACTIONS(1928),
    [anon_sym_u16] = ACTIONS(1928),
    [anon_sym_i16] = ACTIONS(1928),
    [anon_sym_u32] = ACTIONS(1928),
    [anon_sym_i32] = ACTIONS(1928),
    [anon_sym_u64] = ACTIONS(1928),
    [anon_sym_i64] = ACTIONS(1928),
    [anon_sym_u128] = ACTIONS(1928),
    [anon_sym_i128] = ACTIONS(1928),
    [anon_sym_isize] = ACTIONS(1928),
    [anon_sym_usize] = ACTIONS(1928),
    [anon_sym_f32] = ACTIONS(1928),
    [anon_sym_f64] = ACTIONS(1928),
    [anon_sym_bool] = ACTIONS(1928),
    [anon_sym_str] = ACTIONS(1928),
    [anon_sym_char] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1930),
    [anon_sym_POUND] = ACTIONS(1932),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_fn] = ACTIONS(1940),
    [anon_sym_impl] = ACTIONS(1942),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_mod] = ACTIONS(1946),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_trait] = ACTIONS(1952),
    [anon_sym_type] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1956),
    [anon_sym_unsafe] = ACTIONS(1958),
    [anon_sym_use] = ACTIONS(1960),
    [anon_sym_extern] = ACTIONS(1962),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1964),
    [sym_super] = ACTIONS(1964),
    [sym_crate] = ACTIONS(1966),
    [sym_metavariable] = ACTIONS(1968),
  },
  [724] = {
    [sym_line_comment] = STATE(724),
    [sym_block_comment] = STATE(724),
    [ts_builtin_sym_end] = ACTIONS(2803),
    [sym_identifier] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_macro_rules_BANG] = ACTIONS(2803),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_STAR] = ACTIONS(2803),
    [anon_sym_u8] = ACTIONS(2805),
    [anon_sym_i8] = ACTIONS(2805),
    [anon_sym_u16] = ACTIONS(2805),
    [anon_sym_i16] = ACTIONS(2805),
    [anon_sym_u32] = ACTIONS(2805),
    [anon_sym_i32] = ACTIONS(2805),
    [anon_sym_u64] = ACTIONS(2805),
    [anon_sym_i64] = ACTIONS(2805),
    [anon_sym_u128] = ACTIONS(2805),
    [anon_sym_i128] = ACTIONS(2805),
    [anon_sym_isize] = ACTIONS(2805),
    [anon_sym_usize] = ACTIONS(2805),
    [anon_sym_f32] = ACTIONS(2805),
    [anon_sym_f64] = ACTIONS(2805),
    [anon_sym_bool] = ACTIONS(2805),
    [anon_sym_str] = ACTIONS(2805),
    [anon_sym_char] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2803),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_AMP] = ACTIONS(2803),
    [anon_sym_PIPE] = ACTIONS(2803),
    [anon_sym_LT] = ACTIONS(2803),
    [anon_sym_DOT_DOT] = ACTIONS(2803),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_POUND] = ACTIONS(2803),
    [anon_sym_SQUOTE] = ACTIONS(2805),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_fn] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_impl] = ACTIONS(2805),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_loop] = ACTIONS(2805),
    [anon_sym_match] = ACTIONS(2805),
    [anon_sym_mod] = ACTIONS(2805),
    [anon_sym_pub] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_trait] = ACTIONS(2805),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_unsafe] = ACTIONS(2805),
    [anon_sym_use] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym_yield] = ACTIONS(2805),
    [anon_sym_move] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [sym_integer_literal] = ACTIONS(2803),
    [aux_sym_string_literal_token1] = ACTIONS(2803),
    [sym_char_literal] = ACTIONS(2803),
    [anon_sym_true] = ACTIONS(2805),
    [anon_sym_false] = ACTIONS(2805),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2805),
    [sym_super] = ACTIONS(2805),
    [sym_crate] = ACTIONS(2805),
    [sym_metavariable] = ACTIONS(2803),
    [sym__raw_string_literal_start] = ACTIONS(2803),
    [sym_float_literal] = ACTIONS(2803),
  },
  [725] = {
    [sym_line_comment] = STATE(725),
    [sym_block_comment] = STATE(725),
    [ts_builtin_sym_end] = ACTIONS(2807),
    [sym_identifier] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_macro_rules_BANG] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_u8] = ACTIONS(2809),
    [anon_sym_i8] = ACTIONS(2809),
    [anon_sym_u16] = ACTIONS(2809),
    [anon_sym_i16] = ACTIONS(2809),
    [anon_sym_u32] = ACTIONS(2809),
    [anon_sym_i32] = ACTIONS(2809),
    [anon_sym_u64] = ACTIONS(2809),
    [anon_sym_i64] = ACTIONS(2809),
    [anon_sym_u128] = ACTIONS(2809),
    [anon_sym_i128] = ACTIONS(2809),
    [anon_sym_isize] = ACTIONS(2809),
    [anon_sym_usize] = ACTIONS(2809),
    [anon_sym_f32] = ACTIONS(2809),
    [anon_sym_f64] = ACTIONS(2809),
    [anon_sym_bool] = ACTIONS(2809),
    [anon_sym_str] = ACTIONS(2809),
    [anon_sym_char] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_LT] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_POUND] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [anon_sym_async] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_fn] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_impl] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_loop] = ACTIONS(2809),
    [anon_sym_match] = ACTIONS(2809),
    [anon_sym_mod] = ACTIONS(2809),
    [anon_sym_pub] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_trait] = ACTIONS(2809),
    [anon_sym_type] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_unsafe] = ACTIONS(2809),
    [anon_sym_use] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym_yield] = ACTIONS(2809),
    [anon_sym_move] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [sym_integer_literal] = ACTIONS(2807),
    [aux_sym_string_literal_token1] = ACTIONS(2807),
    [sym_char_literal] = ACTIONS(2807),
    [anon_sym_true] = ACTIONS(2809),
    [anon_sym_false] = ACTIONS(2809),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2809),
    [sym_super] = ACTIONS(2809),
    [sym_crate] = ACTIONS(2809),
    [sym_metavariable] = ACTIONS(2807),
    [sym__raw_string_literal_start] = ACTIONS(2807),
    [sym_float_literal] = ACTIONS(2807),
  },
  [726] = {
    [sym_line_comment] = STATE(726),
    [sym_block_comment] = STATE(726),
    [ts_builtin_sym_end] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_macro_rules_BANG] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_u8] = ACTIONS(2813),
    [anon_sym_i8] = ACTIONS(2813),
    [anon_sym_u16] = ACTIONS(2813),
    [anon_sym_i16] = ACTIONS(2813),
    [anon_sym_u32] = ACTIONS(2813),
    [anon_sym_i32] = ACTIONS(2813),
    [anon_sym_u64] = ACTIONS(2813),
    [anon_sym_i64] = ACTIONS(2813),
    [anon_sym_u128] = ACTIONS(2813),
    [anon_sym_i128] = ACTIONS(2813),
    [anon_sym_isize] = ACTIONS(2813),
    [anon_sym_usize] = ACTIONS(2813),
    [anon_sym_f32] = ACTIONS(2813),
    [anon_sym_f64] = ACTIONS(2813),
    [anon_sym_bool] = ACTIONS(2813),
    [anon_sym_str] = ACTIONS(2813),
    [anon_sym_char] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym_PIPE] = ACTIONS(2811),
    [anon_sym_LT] = ACTIONS(2811),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_POUND] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2813),
    [anon_sym_async] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_fn] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_impl] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_loop] = ACTIONS(2813),
    [anon_sym_match] = ACTIONS(2813),
    [anon_sym_mod] = ACTIONS(2813),
    [anon_sym_pub] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_trait] = ACTIONS(2813),
    [anon_sym_type] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_unsafe] = ACTIONS(2813),
    [anon_sym_use] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2813),
    [anon_sym_move] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [sym_integer_literal] = ACTIONS(2811),
    [aux_sym_string_literal_token1] = ACTIONS(2811),
    [sym_char_literal] = ACTIONS(2811),
    [anon_sym_true] = ACTIONS(2813),
    [anon_sym_false] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2813),
    [sym_super] = ACTIONS(2813),
    [sym_crate] = ACTIONS(2813),
    [sym_metavariable] = ACTIONS(2811),
    [sym__raw_string_literal_start] = ACTIONS(2811),
    [sym_float_literal] = ACTIONS(2811),
  },
  [727] = {
    [sym_line_comment] = STATE(727),
    [sym_block_comment] = STATE(727),
    [ts_builtin_sym_end] = ACTIONS(2815),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_macro_rules_BANG] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_u8] = ACTIONS(2817),
    [anon_sym_i8] = ACTIONS(2817),
    [anon_sym_u16] = ACTIONS(2817),
    [anon_sym_i16] = ACTIONS(2817),
    [anon_sym_u32] = ACTIONS(2817),
    [anon_sym_i32] = ACTIONS(2817),
    [anon_sym_u64] = ACTIONS(2817),
    [anon_sym_i64] = ACTIONS(2817),
    [anon_sym_u128] = ACTIONS(2817),
    [anon_sym_i128] = ACTIONS(2817),
    [anon_sym_isize] = ACTIONS(2817),
    [anon_sym_usize] = ACTIONS(2817),
    [anon_sym_f32] = ACTIONS(2817),
    [anon_sym_f64] = ACTIONS(2817),
    [anon_sym_bool] = ACTIONS(2817),
    [anon_sym_str] = ACTIONS(2817),
    [anon_sym_char] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_PIPE] = ACTIONS(2815),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_POUND] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_async] = ACTIONS(2817),
    [anon_sym_break] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_continue] = ACTIONS(2817),
    [anon_sym_default] = ACTIONS(2817),
    [anon_sym_enum] = ACTIONS(2817),
    [anon_sym_fn] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_impl] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_loop] = ACTIONS(2817),
    [anon_sym_match] = ACTIONS(2817),
    [anon_sym_mod] = ACTIONS(2817),
    [anon_sym_pub] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_static] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_trait] = ACTIONS(2817),
    [anon_sym_type] = ACTIONS(2817),
    [anon_sym_union] = ACTIONS(2817),
    [anon_sym_unsafe] = ACTIONS(2817),
    [anon_sym_use] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [anon_sym_extern] = ACTIONS(2817),
    [anon_sym_yield] = ACTIONS(2817),
    [anon_sym_move] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [sym_integer_literal] = ACTIONS(2815),
    [aux_sym_string_literal_token1] = ACTIONS(2815),
    [sym_char_literal] = ACTIONS(2815),
    [anon_sym_true] = ACTIONS(2817),
    [anon_sym_false] = ACTIONS(2817),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2817),
    [sym_super] = ACTIONS(2817),
    [sym_crate] = ACTIONS(2817),
    [sym_metavariable] = ACTIONS(2815),
    [sym__raw_string_literal_start] = ACTIONS(2815),
    [sym_float_literal] = ACTIONS(2815),
  },
  [728] = {
    [sym_line_comment] = STATE(728),
    [sym_block_comment] = STATE(728),
    [ts_builtin_sym_end] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2821),
    [anon_sym_SEMI] = ACTIONS(2819),
    [anon_sym_macro_rules_BANG] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_u8] = ACTIONS(2821),
    [anon_sym_i8] = ACTIONS(2821),
    [anon_sym_u16] = ACTIONS(2821),
    [anon_sym_i16] = ACTIONS(2821),
    [anon_sym_u32] = ACTIONS(2821),
    [anon_sym_i32] = ACTIONS(2821),
    [anon_sym_u64] = ACTIONS(2821),
    [anon_sym_i64] = ACTIONS(2821),
    [anon_sym_u128] = ACTIONS(2821),
    [anon_sym_i128] = ACTIONS(2821),
    [anon_sym_isize] = ACTIONS(2821),
    [anon_sym_usize] = ACTIONS(2821),
    [anon_sym_f32] = ACTIONS(2821),
    [anon_sym_f64] = ACTIONS(2821),
    [anon_sym_bool] = ACTIONS(2821),
    [anon_sym_str] = ACTIONS(2821),
    [anon_sym_char] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_DOT_DOT] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2819),
    [anon_sym_POUND] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_break] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(2821),
    [anon_sym_continue] = ACTIONS(2821),
    [anon_sym_default] = ACTIONS(2821),
    [anon_sym_enum] = ACTIONS(2821),
    [anon_sym_fn] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2821),
    [anon_sym_if] = ACTIONS(2821),
    [anon_sym_impl] = ACTIONS(2821),
    [anon_sym_let] = ACTIONS(2821),
    [anon_sym_loop] = ACTIONS(2821),
    [anon_sym_match] = ACTIONS(2821),
    [anon_sym_mod] = ACTIONS(2821),
    [anon_sym_pub] = ACTIONS(2821),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_struct] = ACTIONS(2821),
    [anon_sym_trait] = ACTIONS(2821),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_union] = ACTIONS(2821),
    [anon_sym_unsafe] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2821),
    [anon_sym_while] = ACTIONS(2821),
    [anon_sym_extern] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2821),
    [anon_sym_move] = ACTIONS(2821),
    [anon_sym_try] = ACTIONS(2821),
    [sym_integer_literal] = ACTIONS(2819),
    [aux_sym_string_literal_token1] = ACTIONS(2819),
    [sym_char_literal] = ACTIONS(2819),
    [anon_sym_true] = ACTIONS(2821),
    [anon_sym_false] = ACTIONS(2821),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2821),
    [sym_super] = ACTIONS(2821),
    [sym_crate] = ACTIONS(2821),
    [sym_metavariable] = ACTIONS(2819),
    [sym__raw_string_literal_start] = ACTIONS(2819),
    [sym_float_literal] = ACTIONS(2819),
  },
  [729] = {
    [sym_line_comment] = STATE(729),
    [sym_block_comment] = STATE(729),
    [ts_builtin_sym_end] = ACTIONS(2823),
    [sym_identifier] = ACTIONS(2825),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_macro_rules_BANG] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_u8] = ACTIONS(2825),
    [anon_sym_i8] = ACTIONS(2825),
    [anon_sym_u16] = ACTIONS(2825),
    [anon_sym_i16] = ACTIONS(2825),
    [anon_sym_u32] = ACTIONS(2825),
    [anon_sym_i32] = ACTIONS(2825),
    [anon_sym_u64] = ACTIONS(2825),
    [anon_sym_i64] = ACTIONS(2825),
    [anon_sym_u128] = ACTIONS(2825),
    [anon_sym_i128] = ACTIONS(2825),
    [anon_sym_isize] = ACTIONS(2825),
    [anon_sym_usize] = ACTIONS(2825),
    [anon_sym_f32] = ACTIONS(2825),
    [anon_sym_f64] = ACTIONS(2825),
    [anon_sym_bool] = ACTIONS(2825),
    [anon_sym_str] = ACTIONS(2825),
    [anon_sym_char] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2823),
    [anon_sym_POUND] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2825),
    [anon_sym_async] = ACTIONS(2825),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_const] = ACTIONS(2825),
    [anon_sym_continue] = ACTIONS(2825),
    [anon_sym_default] = ACTIONS(2825),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_fn] = ACTIONS(2825),
    [anon_sym_for] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_impl] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2825),
    [anon_sym_loop] = ACTIONS(2825),
    [anon_sym_match] = ACTIONS(2825),
    [anon_sym_mod] = ACTIONS(2825),
    [anon_sym_pub] = ACTIONS(2825),
    [anon_sym_return] = ACTIONS(2825),
    [anon_sym_static] = ACTIONS(2825),
    [anon_sym_struct] = ACTIONS(2825),
    [anon_sym_trait] = ACTIONS(2825),
    [anon_sym_type] = ACTIONS(2825),
    [anon_sym_union] = ACTIONS(2825),
    [anon_sym_unsafe] = ACTIONS(2825),
    [anon_sym_use] = ACTIONS(2825),
    [anon_sym_while] = ACTIONS(2825),
    [anon_sym_extern] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2825),
    [anon_sym_move] = ACTIONS(2825),
    [anon_sym_try] = ACTIONS(2825),
    [sym_integer_literal] = ACTIONS(2823),
    [aux_sym_string_literal_token1] = ACTIONS(2823),
    [sym_char_literal] = ACTIONS(2823),
    [anon_sym_true] = ACTIONS(2825),
    [anon_sym_false] = ACTIONS(2825),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2825),
    [sym_super] = ACTIONS(2825),
    [sym_crate] = ACTIONS(2825),
    [sym_metavariable] = ACTIONS(2823),
    [sym__raw_string_literal_start] = ACTIONS(2823),
    [sym_float_literal] = ACTIONS(2823),
  },
  [730] = {
    [sym_line_comment] = STATE(730),
    [sym_block_comment] = STATE(730),
    [ts_builtin_sym_end] = ACTIONS(2827),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_SEMI] = ACTIONS(2827),
    [anon_sym_macro_rules_BANG] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_u8] = ACTIONS(2829),
    [anon_sym_i8] = ACTIONS(2829),
    [anon_sym_u16] = ACTIONS(2829),
    [anon_sym_i16] = ACTIONS(2829),
    [anon_sym_u32] = ACTIONS(2829),
    [anon_sym_i32] = ACTIONS(2829),
    [anon_sym_u64] = ACTIONS(2829),
    [anon_sym_i64] = ACTIONS(2829),
    [anon_sym_u128] = ACTIONS(2829),
    [anon_sym_i128] = ACTIONS(2829),
    [anon_sym_isize] = ACTIONS(2829),
    [anon_sym_usize] = ACTIONS(2829),
    [anon_sym_f32] = ACTIONS(2829),
    [anon_sym_f64] = ACTIONS(2829),
    [anon_sym_bool] = ACTIONS(2829),
    [anon_sym_str] = ACTIONS(2829),
    [anon_sym_char] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2827),
    [anon_sym_POUND] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_break] = ACTIONS(2829),
    [anon_sym_const] = ACTIONS(2829),
    [anon_sym_continue] = ACTIONS(2829),
    [anon_sym_default] = ACTIONS(2829),
    [anon_sym_enum] = ACTIONS(2829),
    [anon_sym_fn] = ACTIONS(2829),
    [anon_sym_for] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_impl] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_loop] = ACTIONS(2829),
    [anon_sym_match] = ACTIONS(2829),
    [anon_sym_mod] = ACTIONS(2829),
    [anon_sym_pub] = ACTIONS(2829),
    [anon_sym_return] = ACTIONS(2829),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_trait] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2829),
    [anon_sym_unsafe] = ACTIONS(2829),
    [anon_sym_use] = ACTIONS(2829),
    [anon_sym_while] = ACTIONS(2829),
    [anon_sym_extern] = ACTIONS(2829),
    [anon_sym_yield] = ACTIONS(2829),
    [anon_sym_move] = ACTIONS(2829),
    [anon_sym_try] = ACTIONS(2829),
    [sym_integer_literal] = ACTIONS(2827),
    [aux_sym_string_literal_token1] = ACTIONS(2827),
    [sym_char_literal] = ACTIONS(2827),
    [anon_sym_true] = ACTIONS(2829),
    [anon_sym_false] = ACTIONS(2829),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2829),
    [sym_super] = ACTIONS(2829),
    [sym_crate] = ACTIONS(2829),
    [sym_metavariable] = ACTIONS(2827),
    [sym__raw_string_literal_start] = ACTIONS(2827),
    [sym_float_literal] = ACTIONS(2827),
  },
  [731] = {
    [sym_line_comment] = STATE(731),
    [sym_block_comment] = STATE(731),
    [ts_builtin_sym_end] = ACTIONS(2831),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2831),
    [anon_sym_macro_rules_BANG] = ACTIONS(2831),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_STAR] = ACTIONS(2831),
    [anon_sym_u8] = ACTIONS(2833),
    [anon_sym_i8] = ACTIONS(2833),
    [anon_sym_u16] = ACTIONS(2833),
    [anon_sym_i16] = ACTIONS(2833),
    [anon_sym_u32] = ACTIONS(2833),
    [anon_sym_i32] = ACTIONS(2833),
    [anon_sym_u64] = ACTIONS(2833),
    [anon_sym_i64] = ACTIONS(2833),
    [anon_sym_u128] = ACTIONS(2833),
    [anon_sym_i128] = ACTIONS(2833),
    [anon_sym_isize] = ACTIONS(2833),
    [anon_sym_usize] = ACTIONS(2833),
    [anon_sym_f32] = ACTIONS(2833),
    [anon_sym_f64] = ACTIONS(2833),
    [anon_sym_bool] = ACTIONS(2833),
    [anon_sym_str] = ACTIONS(2833),
    [anon_sym_char] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_DOT_DOT] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_POUND] = ACTIONS(2831),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_default] = ACTIONS(2833),
    [anon_sym_enum] = ACTIONS(2833),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_impl] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_loop] = ACTIONS(2833),
    [anon_sym_match] = ACTIONS(2833),
    [anon_sym_mod] = ACTIONS(2833),
    [anon_sym_pub] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_trait] = ACTIONS(2833),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_union] = ACTIONS(2833),
    [anon_sym_unsafe] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [anon_sym_extern] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2833),
    [anon_sym_move] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [sym_integer_literal] = ACTIONS(2831),
    [aux_sym_string_literal_token1] = ACTIONS(2831),
    [sym_char_literal] = ACTIONS(2831),
    [anon_sym_true] = ACTIONS(2833),
    [anon_sym_false] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2833),
    [sym_super] = ACTIONS(2833),
    [sym_crate] = ACTIONS(2833),
    [sym_metavariable] = ACTIONS(2831),
    [sym__raw_string_literal_start] = ACTIONS(2831),
    [sym_float_literal] = ACTIONS(2831),
  },
  [732] = {
    [sym_line_comment] = STATE(732),
    [sym_block_comment] = STATE(732),
    [ts_builtin_sym_end] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_macro_rules_BANG] = ACTIONS(2835),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_u8] = ACTIONS(2837),
    [anon_sym_i8] = ACTIONS(2837),
    [anon_sym_u16] = ACTIONS(2837),
    [anon_sym_i16] = ACTIONS(2837),
    [anon_sym_u32] = ACTIONS(2837),
    [anon_sym_i32] = ACTIONS(2837),
    [anon_sym_u64] = ACTIONS(2837),
    [anon_sym_i64] = ACTIONS(2837),
    [anon_sym_u128] = ACTIONS(2837),
    [anon_sym_i128] = ACTIONS(2837),
    [anon_sym_isize] = ACTIONS(2837),
    [anon_sym_usize] = ACTIONS(2837),
    [anon_sym_f32] = ACTIONS(2837),
    [anon_sym_f64] = ACTIONS(2837),
    [anon_sym_bool] = ACTIONS(2837),
    [anon_sym_str] = ACTIONS(2837),
    [anon_sym_char] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_PIPE] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_DOT_DOT] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
    [anon_sym_POUND] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_default] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_impl] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_loop] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_mod] = ACTIONS(2837),
    [anon_sym_pub] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_trait] = ACTIONS(2837),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_union] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_extern] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2837),
    [anon_sym_move] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [sym_integer_literal] = ACTIONS(2835),
    [aux_sym_string_literal_token1] = ACTIONS(2835),
    [sym_char_literal] = ACTIONS(2835),
    [anon_sym_true] = ACTIONS(2837),
    [anon_sym_false] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2837),
    [sym_super] = ACTIONS(2837),
    [sym_crate] = ACTIONS(2837),
    [sym_metavariable] = ACTIONS(2835),
    [sym__raw_string_literal_start] = ACTIONS(2835),
    [sym_float_literal] = ACTIONS(2835),
  },
  [733] = {
    [sym_line_comment] = STATE(733),
    [sym_block_comment] = STATE(733),
    [ts_builtin_sym_end] = ACTIONS(2839),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2839),
    [anon_sym_macro_rules_BANG] = ACTIONS(2839),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_u8] = ACTIONS(2841),
    [anon_sym_i8] = ACTIONS(2841),
    [anon_sym_u16] = ACTIONS(2841),
    [anon_sym_i16] = ACTIONS(2841),
    [anon_sym_u32] = ACTIONS(2841),
    [anon_sym_i32] = ACTIONS(2841),
    [anon_sym_u64] = ACTIONS(2841),
    [anon_sym_i64] = ACTIONS(2841),
    [anon_sym_u128] = ACTIONS(2841),
    [anon_sym_i128] = ACTIONS(2841),
    [anon_sym_isize] = ACTIONS(2841),
    [anon_sym_usize] = ACTIONS(2841),
    [anon_sym_f32] = ACTIONS(2841),
    [anon_sym_f64] = ACTIONS(2841),
    [anon_sym_bool] = ACTIONS(2841),
    [anon_sym_str] = ACTIONS(2841),
    [anon_sym_char] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_BANG] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2839),
    [anon_sym_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_default] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_impl] = ACTIONS(2841),
    [anon_sym_let] = ACTIONS(2841),
    [anon_sym_loop] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_mod] = ACTIONS(2841),
    [anon_sym_pub] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_static] = ACTIONS(2841),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_trait] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_union] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2841),
    [anon_sym_while] = ACTIONS(2841),
    [anon_sym_extern] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2841),
    [anon_sym_move] = ACTIONS(2841),
    [anon_sym_try] = ACTIONS(2841),
    [sym_integer_literal] = ACTIONS(2839),
    [aux_sym_string_literal_token1] = ACTIONS(2839),
    [sym_char_literal] = ACTIONS(2839),
    [anon_sym_true] = ACTIONS(2841),
    [anon_sym_false] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2841),
    [sym_super] = ACTIONS(2841),
    [sym_crate] = ACTIONS(2841),
    [sym_metavariable] = ACTIONS(2839),
    [sym__raw_string_literal_start] = ACTIONS(2839),
    [sym_float_literal] = ACTIONS(2839),
  },
  [734] = {
    [sym_line_comment] = STATE(734),
    [sym_block_comment] = STATE(734),
    [ts_builtin_sym_end] = ACTIONS(2843),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(2843),
    [anon_sym_macro_rules_BANG] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2843),
    [anon_sym_u8] = ACTIONS(2845),
    [anon_sym_i8] = ACTIONS(2845),
    [anon_sym_u16] = ACTIONS(2845),
    [anon_sym_i16] = ACTIONS(2845),
    [anon_sym_u32] = ACTIONS(2845),
    [anon_sym_i32] = ACTIONS(2845),
    [anon_sym_u64] = ACTIONS(2845),
    [anon_sym_i64] = ACTIONS(2845),
    [anon_sym_u128] = ACTIONS(2845),
    [anon_sym_i128] = ACTIONS(2845),
    [anon_sym_isize] = ACTIONS(2845),
    [anon_sym_usize] = ACTIONS(2845),
    [anon_sym_f32] = ACTIONS(2845),
    [anon_sym_f64] = ACTIONS(2845),
    [anon_sym_bool] = ACTIONS(2845),
    [anon_sym_str] = ACTIONS(2845),
    [anon_sym_char] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_PIPE] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(2843),
    [anon_sym_DOT_DOT] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2843),
    [anon_sym_POUND] = ACTIONS(2843),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_async] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_default] = ACTIONS(2845),
    [anon_sym_enum] = ACTIONS(2845),
    [anon_sym_fn] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_impl] = ACTIONS(2845),
    [anon_sym_let] = ACTIONS(2845),
    [anon_sym_loop] = ACTIONS(2845),
    [anon_sym_match] = ACTIONS(2845),
    [anon_sym_mod] = ACTIONS(2845),
    [anon_sym_pub] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_static] = ACTIONS(2845),
    [anon_sym_struct] = ACTIONS(2845),
    [anon_sym_trait] = ACTIONS(2845),
    [anon_sym_type] = ACTIONS(2845),
    [anon_sym_union] = ACTIONS(2845),
    [anon_sym_unsafe] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2845),
    [anon_sym_while] = ACTIONS(2845),
    [anon_sym_extern] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2845),
    [anon_sym_move] = ACTIONS(2845),
    [anon_sym_try] = ACTIONS(2845),
    [sym_integer_literal] = ACTIONS(2843),
    [aux_sym_string_literal_token1] = ACTIONS(2843),
    [sym_char_literal] = ACTIONS(2843),
    [anon_sym_true] = ACTIONS(2845),
    [anon_sym_false] = ACTIONS(2845),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2845),
    [sym_super] = ACTIONS(2845),
    [sym_crate] = ACTIONS(2845),
    [sym_metavariable] = ACTIONS(2843),
    [sym__raw_string_literal_start] = ACTIONS(2843),
    [sym_float_literal] = ACTIONS(2843),
  },
  [735] = {
    [sym_line_comment] = STATE(735),
    [sym_block_comment] = STATE(735),
    [ts_builtin_sym_end] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_macro_rules_BANG] = ACTIONS(2847),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_STAR] = ACTIONS(2847),
    [anon_sym_u8] = ACTIONS(2849),
    [anon_sym_i8] = ACTIONS(2849),
    [anon_sym_u16] = ACTIONS(2849),
    [anon_sym_i16] = ACTIONS(2849),
    [anon_sym_u32] = ACTIONS(2849),
    [anon_sym_i32] = ACTIONS(2849),
    [anon_sym_u64] = ACTIONS(2849),
    [anon_sym_i64] = ACTIONS(2849),
    [anon_sym_u128] = ACTIONS(2849),
    [anon_sym_i128] = ACTIONS(2849),
    [anon_sym_isize] = ACTIONS(2849),
    [anon_sym_usize] = ACTIONS(2849),
    [anon_sym_f32] = ACTIONS(2849),
    [anon_sym_f64] = ACTIONS(2849),
    [anon_sym_bool] = ACTIONS(2849),
    [anon_sym_str] = ACTIONS(2849),
    [anon_sym_char] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_BANG] = ACTIONS(2847),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_PIPE] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2847),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2847),
    [anon_sym_POUND] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_default] = ACTIONS(2849),
    [anon_sym_enum] = ACTIONS(2849),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_impl] = ACTIONS(2849),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_loop] = ACTIONS(2849),
    [anon_sym_match] = ACTIONS(2849),
    [anon_sym_mod] = ACTIONS(2849),
    [anon_sym_pub] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_struct] = ACTIONS(2849),
    [anon_sym_trait] = ACTIONS(2849),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_union] = ACTIONS(2849),
    [anon_sym_unsafe] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2849),
    [anon_sym_while] = ACTIONS(2849),
    [anon_sym_extern] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2849),
    [anon_sym_move] = ACTIONS(2849),
    [anon_sym_try] = ACTIONS(2849),
    [sym_integer_literal] = ACTIONS(2847),
    [aux_sym_string_literal_token1] = ACTIONS(2847),
    [sym_char_literal] = ACTIONS(2847),
    [anon_sym_true] = ACTIONS(2849),
    [anon_sym_false] = ACTIONS(2849),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2849),
    [sym_super] = ACTIONS(2849),
    [sym_crate] = ACTIONS(2849),
    [sym_metavariable] = ACTIONS(2847),
    [sym__raw_string_literal_start] = ACTIONS(2847),
    [sym_float_literal] = ACTIONS(2847),
  },
  [736] = {
    [sym_line_comment] = STATE(736),
    [sym_block_comment] = STATE(736),
    [ts_builtin_sym_end] = ACTIONS(2851),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_macro_rules_BANG] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_STAR] = ACTIONS(2851),
    [anon_sym_u8] = ACTIONS(2853),
    [anon_sym_i8] = ACTIONS(2853),
    [anon_sym_u16] = ACTIONS(2853),
    [anon_sym_i16] = ACTIONS(2853),
    [anon_sym_u32] = ACTIONS(2853),
    [anon_sym_i32] = ACTIONS(2853),
    [anon_sym_u64] = ACTIONS(2853),
    [anon_sym_i64] = ACTIONS(2853),
    [anon_sym_u128] = ACTIONS(2853),
    [anon_sym_i128] = ACTIONS(2853),
    [anon_sym_isize] = ACTIONS(2853),
    [anon_sym_usize] = ACTIONS(2853),
    [anon_sym_f32] = ACTIONS(2853),
    [anon_sym_f64] = ACTIONS(2853),
    [anon_sym_bool] = ACTIONS(2853),
    [anon_sym_str] = ACTIONS(2853),
    [anon_sym_char] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_BANG] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2851),
    [anon_sym_POUND] = ACTIONS(2851),
    [anon_sym_SQUOTE] = ACTIONS(2853),
    [anon_sym_async] = ACTIONS(2853),
    [anon_sym_break] = ACTIONS(2853),
    [anon_sym_const] = ACTIONS(2853),
    [anon_sym_continue] = ACTIONS(2853),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_enum] = ACTIONS(2853),
    [anon_sym_fn] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_impl] = ACTIONS(2853),
    [anon_sym_let] = ACTIONS(2853),
    [anon_sym_loop] = ACTIONS(2853),
    [anon_sym_match] = ACTIONS(2853),
    [anon_sym_mod] = ACTIONS(2853),
    [anon_sym_pub] = ACTIONS(2853),
    [anon_sym_return] = ACTIONS(2853),
    [anon_sym_static] = ACTIONS(2853),
    [anon_sym_struct] = ACTIONS(2853),
    [anon_sym_trait] = ACTIONS(2853),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_union] = ACTIONS(2853),
    [anon_sym_unsafe] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [anon_sym_extern] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2853),
    [anon_sym_move] = ACTIONS(2853),
    [anon_sym_try] = ACTIONS(2853),
    [sym_integer_literal] = ACTIONS(2851),
    [aux_sym_string_literal_token1] = ACTIONS(2851),
    [sym_char_literal] = ACTIONS(2851),
    [anon_sym_true] = ACTIONS(2853),
    [anon_sym_false] = ACTIONS(2853),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2853),
    [sym_super] = ACTIONS(2853),
    [sym_crate] = ACTIONS(2853),
    [sym_metavariable] = ACTIONS(2851),
    [sym__raw_string_literal_start] = ACTIONS(2851),
    [sym_float_literal] = ACTIONS(2851),
  },
  [737] = {
    [sym_line_comment] = STATE(737),
    [sym_block_comment] = STATE(737),
    [ts_builtin_sym_end] = ACTIONS(2855),
    [sym_identifier] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2855),
    [anon_sym_macro_rules_BANG] = ACTIONS(2855),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_u8] = ACTIONS(2857),
    [anon_sym_i8] = ACTIONS(2857),
    [anon_sym_u16] = ACTIONS(2857),
    [anon_sym_i16] = ACTIONS(2857),
    [anon_sym_u32] = ACTIONS(2857),
    [anon_sym_i32] = ACTIONS(2857),
    [anon_sym_u64] = ACTIONS(2857),
    [anon_sym_i64] = ACTIONS(2857),
    [anon_sym_u128] = ACTIONS(2857),
    [anon_sym_i128] = ACTIONS(2857),
    [anon_sym_isize] = ACTIONS(2857),
    [anon_sym_usize] = ACTIONS(2857),
    [anon_sym_f32] = ACTIONS(2857),
    [anon_sym_f64] = ACTIONS(2857),
    [anon_sym_bool] = ACTIONS(2857),
    [anon_sym_str] = ACTIONS(2857),
    [anon_sym_char] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [anon_sym_POUND] = ACTIONS(2855),
    [anon_sym_SQUOTE] = ACTIONS(2857),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_break] = ACTIONS(2857),
    [anon_sym_const] = ACTIONS(2857),
    [anon_sym_continue] = ACTIONS(2857),
    [anon_sym_default] = ACTIONS(2857),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_fn] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_impl] = ACTIONS(2857),
    [anon_sym_let] = ACTIONS(2857),
    [anon_sym_loop] = ACTIONS(2857),
    [anon_sym_match] = ACTIONS(2857),
    [anon_sym_mod] = ACTIONS(2857),
    [anon_sym_pub] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_struct] = ACTIONS(2857),
    [anon_sym_trait] = ACTIONS(2857),
    [anon_sym_type] = ACTIONS(2857),
    [anon_sym_union] = ACTIONS(2857),
    [anon_sym_unsafe] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [anon_sym_extern] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2857),
    [anon_sym_move] = ACTIONS(2857),
    [anon_sym_try] = ACTIONS(2857),
    [sym_integer_literal] = ACTIONS(2855),
    [aux_sym_string_literal_token1] = ACTIONS(2855),
    [sym_char_literal] = ACTIONS(2855),
    [anon_sym_true] = ACTIONS(2857),
    [anon_sym_false] = ACTIONS(2857),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2857),
    [sym_super] = ACTIONS(2857),
    [sym_crate] = ACTIONS(2857),
    [sym_metavariable] = ACTIONS(2855),
    [sym__raw_string_literal_start] = ACTIONS(2855),
    [sym_float_literal] = ACTIONS(2855),
  },
  [738] = {
    [sym_line_comment] = STATE(738),
    [sym_block_comment] = STATE(738),
    [ts_builtin_sym_end] = ACTIONS(2859),
    [sym_identifier] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_macro_rules_BANG] = ACTIONS(2859),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_u8] = ACTIONS(2861),
    [anon_sym_i8] = ACTIONS(2861),
    [anon_sym_u16] = ACTIONS(2861),
    [anon_sym_i16] = ACTIONS(2861),
    [anon_sym_u32] = ACTIONS(2861),
    [anon_sym_i32] = ACTIONS(2861),
    [anon_sym_u64] = ACTIONS(2861),
    [anon_sym_i64] = ACTIONS(2861),
    [anon_sym_u128] = ACTIONS(2861),
    [anon_sym_i128] = ACTIONS(2861),
    [anon_sym_isize] = ACTIONS(2861),
    [anon_sym_usize] = ACTIONS(2861),
    [anon_sym_f32] = ACTIONS(2861),
    [anon_sym_f64] = ACTIONS(2861),
    [anon_sym_bool] = ACTIONS(2861),
    [anon_sym_str] = ACTIONS(2861),
    [anon_sym_char] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_PIPE] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2859),
    [anon_sym_DOT_DOT] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2859),
    [anon_sym_POUND] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2861),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [anon_sym_fn] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_impl] = ACTIONS(2861),
    [anon_sym_let] = ACTIONS(2861),
    [anon_sym_loop] = ACTIONS(2861),
    [anon_sym_match] = ACTIONS(2861),
    [anon_sym_mod] = ACTIONS(2861),
    [anon_sym_pub] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_trait] = ACTIONS(2861),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2861),
    [anon_sym_unsafe] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_extern] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2861),
    [anon_sym_move] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [sym_integer_literal] = ACTIONS(2859),
    [aux_sym_string_literal_token1] = ACTIONS(2859),
    [sym_char_literal] = ACTIONS(2859),
    [anon_sym_true] = ACTIONS(2861),
    [anon_sym_false] = ACTIONS(2861),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2861),
    [sym_super] = ACTIONS(2861),
    [sym_crate] = ACTIONS(2861),
    [sym_metavariable] = ACTIONS(2859),
    [sym__raw_string_literal_start] = ACTIONS(2859),
    [sym_float_literal] = ACTIONS(2859),
  },
  [739] = {
    [sym_line_comment] = STATE(739),
    [sym_block_comment] = STATE(739),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_macro_rules_BANG] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_STAR] = ACTIONS(2863),
    [anon_sym_u8] = ACTIONS(2865),
    [anon_sym_i8] = ACTIONS(2865),
    [anon_sym_u16] = ACTIONS(2865),
    [anon_sym_i16] = ACTIONS(2865),
    [anon_sym_u32] = ACTIONS(2865),
    [anon_sym_i32] = ACTIONS(2865),
    [anon_sym_u64] = ACTIONS(2865),
    [anon_sym_i64] = ACTIONS(2865),
    [anon_sym_u128] = ACTIONS(2865),
    [anon_sym_i128] = ACTIONS(2865),
    [anon_sym_isize] = ACTIONS(2865),
    [anon_sym_usize] = ACTIONS(2865),
    [anon_sym_f32] = ACTIONS(2865),
    [anon_sym_f64] = ACTIONS(2865),
    [anon_sym_bool] = ACTIONS(2865),
    [anon_sym_str] = ACTIONS(2865),
    [anon_sym_char] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_BANG] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2863),
    [anon_sym_DOT_DOT] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2863),
    [anon_sym_POUND] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_const] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_default] = ACTIONS(2865),
    [anon_sym_enum] = ACTIONS(2865),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_impl] = ACTIONS(2865),
    [anon_sym_let] = ACTIONS(2865),
    [anon_sym_loop] = ACTIONS(2865),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_mod] = ACTIONS(2865),
    [anon_sym_pub] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_static] = ACTIONS(2865),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_trait] = ACTIONS(2865),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_union] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2865),
    [anon_sym_while] = ACTIONS(2865),
    [anon_sym_extern] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_move] = ACTIONS(2865),
    [anon_sym_try] = ACTIONS(2865),
    [sym_integer_literal] = ACTIONS(2863),
    [aux_sym_string_literal_token1] = ACTIONS(2863),
    [sym_char_literal] = ACTIONS(2863),
    [anon_sym_true] = ACTIONS(2865),
    [anon_sym_false] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2865),
    [sym_super] = ACTIONS(2865),
    [sym_crate] = ACTIONS(2865),
    [sym_metavariable] = ACTIONS(2863),
    [sym__raw_string_literal_start] = ACTIONS(2863),
    [sym_float_literal] = ACTIONS(2863),
  },
  [740] = {
    [sym_line_comment] = STATE(740),
    [sym_block_comment] = STATE(740),
    [ts_builtin_sym_end] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_macro_rules_BANG] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_u8] = ACTIONS(2869),
    [anon_sym_i8] = ACTIONS(2869),
    [anon_sym_u16] = ACTIONS(2869),
    [anon_sym_i16] = ACTIONS(2869),
    [anon_sym_u32] = ACTIONS(2869),
    [anon_sym_i32] = ACTIONS(2869),
    [anon_sym_u64] = ACTIONS(2869),
    [anon_sym_i64] = ACTIONS(2869),
    [anon_sym_u128] = ACTIONS(2869),
    [anon_sym_i128] = ACTIONS(2869),
    [anon_sym_isize] = ACTIONS(2869),
    [anon_sym_usize] = ACTIONS(2869),
    [anon_sym_f32] = ACTIONS(2869),
    [anon_sym_f64] = ACTIONS(2869),
    [anon_sym_bool] = ACTIONS(2869),
    [anon_sym_str] = ACTIONS(2869),
    [anon_sym_char] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_DOT_DOT] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [anon_sym_POUND] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2869),
    [anon_sym_async] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_fn] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_impl] = ACTIONS(2869),
    [anon_sym_let] = ACTIONS(2869),
    [anon_sym_loop] = ACTIONS(2869),
    [anon_sym_match] = ACTIONS(2869),
    [anon_sym_mod] = ACTIONS(2869),
    [anon_sym_pub] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_trait] = ACTIONS(2869),
    [anon_sym_type] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_unsafe] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2869),
    [anon_sym_move] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [sym_integer_literal] = ACTIONS(2867),
    [aux_sym_string_literal_token1] = ACTIONS(2867),
    [sym_char_literal] = ACTIONS(2867),
    [anon_sym_true] = ACTIONS(2869),
    [anon_sym_false] = ACTIONS(2869),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2869),
    [sym_super] = ACTIONS(2869),
    [sym_crate] = ACTIONS(2869),
    [sym_metavariable] = ACTIONS(2867),
    [sym__raw_string_literal_start] = ACTIONS(2867),
    [sym_float_literal] = ACTIONS(2867),
  },
  [741] = {
    [sym_line_comment] = STATE(741),
    [sym_block_comment] = STATE(741),
    [ts_builtin_sym_end] = ACTIONS(2871),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_macro_rules_BANG] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_STAR] = ACTIONS(2871),
    [anon_sym_u8] = ACTIONS(2873),
    [anon_sym_i8] = ACTIONS(2873),
    [anon_sym_u16] = ACTIONS(2873),
    [anon_sym_i16] = ACTIONS(2873),
    [anon_sym_u32] = ACTIONS(2873),
    [anon_sym_i32] = ACTIONS(2873),
    [anon_sym_u64] = ACTIONS(2873),
    [anon_sym_i64] = ACTIONS(2873),
    [anon_sym_u128] = ACTIONS(2873),
    [anon_sym_i128] = ACTIONS(2873),
    [anon_sym_isize] = ACTIONS(2873),
    [anon_sym_usize] = ACTIONS(2873),
    [anon_sym_f32] = ACTIONS(2873),
    [anon_sym_f64] = ACTIONS(2873),
    [anon_sym_bool] = ACTIONS(2873),
    [anon_sym_str] = ACTIONS(2873),
    [anon_sym_char] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_BANG] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2871),
    [anon_sym_POUND] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2873),
    [anon_sym_break] = ACTIONS(2873),
    [anon_sym_const] = ACTIONS(2873),
    [anon_sym_continue] = ACTIONS(2873),
    [anon_sym_default] = ACTIONS(2873),
    [anon_sym_enum] = ACTIONS(2873),
    [anon_sym_fn] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_impl] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_loop] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_mod] = ACTIONS(2873),
    [anon_sym_pub] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_static] = ACTIONS(2873),
    [anon_sym_struct] = ACTIONS(2873),
    [anon_sym_trait] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_union] = ACTIONS(2873),
    [anon_sym_unsafe] = ACTIONS(2873),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_extern] = ACTIONS(2873),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_move] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [sym_integer_literal] = ACTIONS(2871),
    [aux_sym_string_literal_token1] = ACTIONS(2871),
    [sym_char_literal] = ACTIONS(2871),
    [anon_sym_true] = ACTIONS(2873),
    [anon_sym_false] = ACTIONS(2873),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2873),
    [sym_super] = ACTIONS(2873),
    [sym_crate] = ACTIONS(2873),
    [sym_metavariable] = ACTIONS(2871),
    [sym__raw_string_literal_start] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
  },
  [742] = {
    [sym_line_comment] = STATE(742),
    [sym_block_comment] = STATE(742),
    [ts_builtin_sym_end] = ACTIONS(2875),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_macro_rules_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_u8] = ACTIONS(2877),
    [anon_sym_i8] = ACTIONS(2877),
    [anon_sym_u16] = ACTIONS(2877),
    [anon_sym_i16] = ACTIONS(2877),
    [anon_sym_u32] = ACTIONS(2877),
    [anon_sym_i32] = ACTIONS(2877),
    [anon_sym_u64] = ACTIONS(2877),
    [anon_sym_i64] = ACTIONS(2877),
    [anon_sym_u128] = ACTIONS(2877),
    [anon_sym_i128] = ACTIONS(2877),
    [anon_sym_isize] = ACTIONS(2877),
    [anon_sym_usize] = ACTIONS(2877),
    [anon_sym_f32] = ACTIONS(2877),
    [anon_sym_f64] = ACTIONS(2877),
    [anon_sym_bool] = ACTIONS(2877),
    [anon_sym_str] = ACTIONS(2877),
    [anon_sym_char] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_POUND] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_async] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_impl] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_loop] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_mod] = ACTIONS(2877),
    [anon_sym_pub] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_trait] = ACTIONS(2877),
    [anon_sym_type] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [anon_sym_unsafe] = ACTIONS(2877),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_move] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [sym_integer_literal] = ACTIONS(2875),
    [aux_sym_string_literal_token1] = ACTIONS(2875),
    [sym_char_literal] = ACTIONS(2875),
    [anon_sym_true] = ACTIONS(2877),
    [anon_sym_false] = ACTIONS(2877),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2877),
    [sym_super] = ACTIONS(2877),
    [sym_crate] = ACTIONS(2877),
    [sym_metavariable] = ACTIONS(2875),
    [sym__raw_string_literal_start] = ACTIONS(2875),
    [sym_float_literal] = ACTIONS(2875),
  },
  [743] = {
    [sym_line_comment] = STATE(743),
    [sym_block_comment] = STATE(743),
    [ts_builtin_sym_end] = ACTIONS(2879),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_macro_rules_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_u8] = ACTIONS(2881),
    [anon_sym_i8] = ACTIONS(2881),
    [anon_sym_u16] = ACTIONS(2881),
    [anon_sym_i16] = ACTIONS(2881),
    [anon_sym_u32] = ACTIONS(2881),
    [anon_sym_i32] = ACTIONS(2881),
    [anon_sym_u64] = ACTIONS(2881),
    [anon_sym_i64] = ACTIONS(2881),
    [anon_sym_u128] = ACTIONS(2881),
    [anon_sym_i128] = ACTIONS(2881),
    [anon_sym_isize] = ACTIONS(2881),
    [anon_sym_usize] = ACTIONS(2881),
    [anon_sym_f32] = ACTIONS(2881),
    [anon_sym_f64] = ACTIONS(2881),
    [anon_sym_bool] = ACTIONS(2881),
    [anon_sym_str] = ACTIONS(2881),
    [anon_sym_char] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_break] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2881),
    [anon_sym_continue] = ACTIONS(2881),
    [anon_sym_default] = ACTIONS(2881),
    [anon_sym_enum] = ACTIONS(2881),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_impl] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_loop] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_mod] = ACTIONS(2881),
    [anon_sym_pub] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_static] = ACTIONS(2881),
    [anon_sym_struct] = ACTIONS(2881),
    [anon_sym_trait] = ACTIONS(2881),
    [anon_sym_type] = ACTIONS(2881),
    [anon_sym_union] = ACTIONS(2881),
    [anon_sym_unsafe] = ACTIONS(2881),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_extern] = ACTIONS(2881),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_move] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [sym_integer_literal] = ACTIONS(2879),
    [aux_sym_string_literal_token1] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [anon_sym_true] = ACTIONS(2881),
    [anon_sym_false] = ACTIONS(2881),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2881),
    [sym_super] = ACTIONS(2881),
    [sym_crate] = ACTIONS(2881),
    [sym_metavariable] = ACTIONS(2879),
    [sym__raw_string_literal_start] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
  },
  [744] = {
    [sym_line_comment] = STATE(744),
    [sym_block_comment] = STATE(744),
    [ts_builtin_sym_end] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_macro_rules_BANG] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2883),
    [anon_sym_u8] = ACTIONS(2885),
    [anon_sym_i8] = ACTIONS(2885),
    [anon_sym_u16] = ACTIONS(2885),
    [anon_sym_i16] = ACTIONS(2885),
    [anon_sym_u32] = ACTIONS(2885),
    [anon_sym_i32] = ACTIONS(2885),
    [anon_sym_u64] = ACTIONS(2885),
    [anon_sym_i64] = ACTIONS(2885),
    [anon_sym_u128] = ACTIONS(2885),
    [anon_sym_i128] = ACTIONS(2885),
    [anon_sym_isize] = ACTIONS(2885),
    [anon_sym_usize] = ACTIONS(2885),
    [anon_sym_f32] = ACTIONS(2885),
    [anon_sym_f64] = ACTIONS(2885),
    [anon_sym_bool] = ACTIONS(2885),
    [anon_sym_str] = ACTIONS(2885),
    [anon_sym_char] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2883),
    [anon_sym_POUND] = ACTIONS(2883),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_async] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_fn] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_impl] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_loop] = ACTIONS(2885),
    [anon_sym_match] = ACTIONS(2885),
    [anon_sym_mod] = ACTIONS(2885),
    [anon_sym_pub] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_trait] = ACTIONS(2885),
    [anon_sym_type] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_unsafe] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2885),
    [anon_sym_move] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [sym_integer_literal] = ACTIONS(2883),
    [aux_sym_string_literal_token1] = ACTIONS(2883),
    [sym_char_literal] = ACTIONS(2883),
    [anon_sym_true] = ACTIONS(2885),
    [anon_sym_false] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2885),
    [sym_super] = ACTIONS(2885),
    [sym_crate] = ACTIONS(2885),
    [sym_metavariable] = ACTIONS(2883),
    [sym__raw_string_literal_start] = ACTIONS(2883),
    [sym_float_literal] = ACTIONS(2883),
  },
  [745] = {
    [sym_line_comment] = STATE(745),
    [sym_block_comment] = STATE(745),
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_macro_rules_BANG] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_u8] = ACTIONS(2889),
    [anon_sym_i8] = ACTIONS(2889),
    [anon_sym_u16] = ACTIONS(2889),
    [anon_sym_i16] = ACTIONS(2889),
    [anon_sym_u32] = ACTIONS(2889),
    [anon_sym_i32] = ACTIONS(2889),
    [anon_sym_u64] = ACTIONS(2889),
    [anon_sym_i64] = ACTIONS(2889),
    [anon_sym_u128] = ACTIONS(2889),
    [anon_sym_i128] = ACTIONS(2889),
    [anon_sym_isize] = ACTIONS(2889),
    [anon_sym_usize] = ACTIONS(2889),
    [anon_sym_f32] = ACTIONS(2889),
    [anon_sym_f64] = ACTIONS(2889),
    [anon_sym_bool] = ACTIONS(2889),
    [anon_sym_str] = ACTIONS(2889),
    [anon_sym_char] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_PIPE] = ACTIONS(2887),
    [anon_sym_LT] = ACTIONS(2887),
    [anon_sym_DOT_DOT] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_POUND] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_async] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_fn] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_impl] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_loop] = ACTIONS(2889),
    [anon_sym_match] = ACTIONS(2889),
    [anon_sym_mod] = ACTIONS(2889),
    [anon_sym_pub] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_trait] = ACTIONS(2889),
    [anon_sym_type] = ACTIONS(2889),
    [anon_sym_union] = ACTIONS(2889),
    [anon_sym_unsafe] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_extern] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2889),
    [anon_sym_move] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [sym_integer_literal] = ACTIONS(2887),
    [aux_sym_string_literal_token1] = ACTIONS(2887),
    [sym_char_literal] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(2889),
    [anon_sym_false] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2889),
    [sym_super] = ACTIONS(2889),
    [sym_crate] = ACTIONS(2889),
    [sym_metavariable] = ACTIONS(2887),
    [sym__raw_string_literal_start] = ACTIONS(2887),
    [sym_float_literal] = ACTIONS(2887),
  },
  [746] = {
    [sym_line_comment] = STATE(746),
    [sym_block_comment] = STATE(746),
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_macro_rules_BANG] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_u8] = ACTIONS(2893),
    [anon_sym_i8] = ACTIONS(2893),
    [anon_sym_u16] = ACTIONS(2893),
    [anon_sym_i16] = ACTIONS(2893),
    [anon_sym_u32] = ACTIONS(2893),
    [anon_sym_i32] = ACTIONS(2893),
    [anon_sym_u64] = ACTIONS(2893),
    [anon_sym_i64] = ACTIONS(2893),
    [anon_sym_u128] = ACTIONS(2893),
    [anon_sym_i128] = ACTIONS(2893),
    [anon_sym_isize] = ACTIONS(2893),
    [anon_sym_usize] = ACTIONS(2893),
    [anon_sym_f32] = ACTIONS(2893),
    [anon_sym_f64] = ACTIONS(2893),
    [anon_sym_bool] = ACTIONS(2893),
    [anon_sym_str] = ACTIONS(2893),
    [anon_sym_char] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_DOT_DOT] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2891),
    [anon_sym_POUND] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_impl] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_loop] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_mod] = ACTIONS(2893),
    [anon_sym_pub] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_trait] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_move] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [sym_integer_literal] = ACTIONS(2891),
    [aux_sym_string_literal_token1] = ACTIONS(2891),
    [sym_char_literal] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(2893),
    [anon_sym_false] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_crate] = ACTIONS(2893),
    [sym_metavariable] = ACTIONS(2891),
    [sym__raw_string_literal_start] = ACTIONS(2891),
    [sym_float_literal] = ACTIONS(2891),
  },
  [747] = {
    [sym_line_comment] = STATE(747),
    [sym_block_comment] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_macro_rules_BANG] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_u8] = ACTIONS(2897),
    [anon_sym_i8] = ACTIONS(2897),
    [anon_sym_u16] = ACTIONS(2897),
    [anon_sym_i16] = ACTIONS(2897),
    [anon_sym_u32] = ACTIONS(2897),
    [anon_sym_i32] = ACTIONS(2897),
    [anon_sym_u64] = ACTIONS(2897),
    [anon_sym_i64] = ACTIONS(2897),
    [anon_sym_u128] = ACTIONS(2897),
    [anon_sym_i128] = ACTIONS(2897),
    [anon_sym_isize] = ACTIONS(2897),
    [anon_sym_usize] = ACTIONS(2897),
    [anon_sym_f32] = ACTIONS(2897),
    [anon_sym_f64] = ACTIONS(2897),
    [anon_sym_bool] = ACTIONS(2897),
    [anon_sym_str] = ACTIONS(2897),
    [anon_sym_char] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2895),
    [anon_sym_LT] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_POUND] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_fn] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_impl] = ACTIONS(2897),
    [anon_sym_let] = ACTIONS(2897),
    [anon_sym_loop] = ACTIONS(2897),
    [anon_sym_match] = ACTIONS(2897),
    [anon_sym_mod] = ACTIONS(2897),
    [anon_sym_pub] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_trait] = ACTIONS(2897),
    [anon_sym_type] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [anon_sym_unsafe] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2897),
    [anon_sym_move] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [sym_integer_literal] = ACTIONS(2895),
    [aux_sym_string_literal_token1] = ACTIONS(2895),
    [sym_char_literal] = ACTIONS(2895),
    [anon_sym_true] = ACTIONS(2897),
    [anon_sym_false] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2897),
    [sym_super] = ACTIONS(2897),
    [sym_crate] = ACTIONS(2897),
    [sym_metavariable] = ACTIONS(2895),
    [sym__raw_string_literal_start] = ACTIONS(2895),
    [sym_float_literal] = ACTIONS(2895),
  },
  [748] = {
    [sym_line_comment] = STATE(748),
    [sym_block_comment] = STATE(748),
    [ts_builtin_sym_end] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_macro_rules_BANG] = ACTIONS(2899),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_u8] = ACTIONS(2901),
    [anon_sym_i8] = ACTIONS(2901),
    [anon_sym_u16] = ACTIONS(2901),
    [anon_sym_i16] = ACTIONS(2901),
    [anon_sym_u32] = ACTIONS(2901),
    [anon_sym_i32] = ACTIONS(2901),
    [anon_sym_u64] = ACTIONS(2901),
    [anon_sym_i64] = ACTIONS(2901),
    [anon_sym_u128] = ACTIONS(2901),
    [anon_sym_i128] = ACTIONS(2901),
    [anon_sym_isize] = ACTIONS(2901),
    [anon_sym_usize] = ACTIONS(2901),
    [anon_sym_f32] = ACTIONS(2901),
    [anon_sym_f64] = ACTIONS(2901),
    [anon_sym_bool] = ACTIONS(2901),
    [anon_sym_str] = ACTIONS(2901),
    [anon_sym_char] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_DOT_DOT] = ACTIONS(2899),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_POUND] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2901),
    [anon_sym_async] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_fn] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_impl] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_loop] = ACTIONS(2901),
    [anon_sym_match] = ACTIONS(2901),
    [anon_sym_mod] = ACTIONS(2901),
    [anon_sym_pub] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_trait] = ACTIONS(2901),
    [anon_sym_type] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_unsafe] = ACTIONS(2901),
    [anon_sym_use] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym_yield] = ACTIONS(2901),
    [anon_sym_move] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [sym_integer_literal] = ACTIONS(2899),
    [aux_sym_string_literal_token1] = ACTIONS(2899),
    [sym_char_literal] = ACTIONS(2899),
    [anon_sym_true] = ACTIONS(2901),
    [anon_sym_false] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2901),
    [sym_super] = ACTIONS(2901),
    [sym_crate] = ACTIONS(2901),
    [sym_metavariable] = ACTIONS(2899),
    [sym__raw_string_literal_start] = ACTIONS(2899),
    [sym_float_literal] = ACTIONS(2899),
  },
  [749] = {
    [sym_line_comment] = STATE(749),
    [sym_block_comment] = STATE(749),
    [ts_builtin_sym_end] = ACTIONS(1236),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_macro_rules_BANG] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1238),
    [anon_sym_i8] = ACTIONS(1238),
    [anon_sym_u16] = ACTIONS(1238),
    [anon_sym_i16] = ACTIONS(1238),
    [anon_sym_u32] = ACTIONS(1238),
    [anon_sym_i32] = ACTIONS(1238),
    [anon_sym_u64] = ACTIONS(1238),
    [anon_sym_i64] = ACTIONS(1238),
    [anon_sym_u128] = ACTIONS(1238),
    [anon_sym_i128] = ACTIONS(1238),
    [anon_sym_isize] = ACTIONS(1238),
    [anon_sym_usize] = ACTIONS(1238),
    [anon_sym_f32] = ACTIONS(1238),
    [anon_sym_f64] = ACTIONS(1238),
    [anon_sym_bool] = ACTIONS(1238),
    [anon_sym_str] = ACTIONS(1238),
    [anon_sym_char] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_BANG] = ACTIONS(1236),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_PIPE] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1236),
    [anon_sym_DOT_DOT] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_async] = ACTIONS(1238),
    [anon_sym_break] = ACTIONS(1238),
    [anon_sym_const] = ACTIONS(1238),
    [anon_sym_continue] = ACTIONS(1238),
    [anon_sym_default] = ACTIONS(1238),
    [anon_sym_enum] = ACTIONS(1238),
    [anon_sym_fn] = ACTIONS(1238),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_if] = ACTIONS(1238),
    [anon_sym_impl] = ACTIONS(1238),
    [anon_sym_let] = ACTIONS(1238),
    [anon_sym_loop] = ACTIONS(1238),
    [anon_sym_match] = ACTIONS(1238),
    [anon_sym_mod] = ACTIONS(1238),
    [anon_sym_pub] = ACTIONS(1238),
    [anon_sym_return] = ACTIONS(1238),
    [anon_sym_static] = ACTIONS(1238),
    [anon_sym_struct] = ACTIONS(1238),
    [anon_sym_trait] = ACTIONS(1238),
    [anon_sym_type] = ACTIONS(1238),
    [anon_sym_union] = ACTIONS(1238),
    [anon_sym_unsafe] = ACTIONS(1238),
    [anon_sym_use] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(1238),
    [anon_sym_yield] = ACTIONS(1238),
    [anon_sym_move] = ACTIONS(1238),
    [anon_sym_try] = ACTIONS(1238),
    [sym_integer_literal] = ACTIONS(1236),
    [aux_sym_string_literal_token1] = ACTIONS(1236),
    [sym_char_literal] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1238),
    [anon_sym_false] = ACTIONS(1238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1238),
    [sym_super] = ACTIONS(1238),
    [sym_crate] = ACTIONS(1238),
    [sym_metavariable] = ACTIONS(1236),
    [sym__raw_string_literal_start] = ACTIONS(1236),
    [sym_float_literal] = ACTIONS(1236),
  },
  [750] = {
    [sym_line_comment] = STATE(750),
    [sym_block_comment] = STATE(750),
    [ts_builtin_sym_end] = ACTIONS(2903),
    [sym_identifier] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_macro_rules_BANG] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_u8] = ACTIONS(2905),
    [anon_sym_i8] = ACTIONS(2905),
    [anon_sym_u16] = ACTIONS(2905),
    [anon_sym_i16] = ACTIONS(2905),
    [anon_sym_u32] = ACTIONS(2905),
    [anon_sym_i32] = ACTIONS(2905),
    [anon_sym_u64] = ACTIONS(2905),
    [anon_sym_i64] = ACTIONS(2905),
    [anon_sym_u128] = ACTIONS(2905),
    [anon_sym_i128] = ACTIONS(2905),
    [anon_sym_isize] = ACTIONS(2905),
    [anon_sym_usize] = ACTIONS(2905),
    [anon_sym_f32] = ACTIONS(2905),
    [anon_sym_f64] = ACTIONS(2905),
    [anon_sym_bool] = ACTIONS(2905),
    [anon_sym_str] = ACTIONS(2905),
    [anon_sym_char] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_POUND] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2905),
    [anon_sym_async] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_fn] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_impl] = ACTIONS(2905),
    [anon_sym_let] = ACTIONS(2905),
    [anon_sym_loop] = ACTIONS(2905),
    [anon_sym_match] = ACTIONS(2905),
    [anon_sym_mod] = ACTIONS(2905),
    [anon_sym_pub] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_struct] = ACTIONS(2905),
    [anon_sym_trait] = ACTIONS(2905),
    [anon_sym_type] = ACTIONS(2905),
    [anon_sym_union] = ACTIONS(2905),
    [anon_sym_unsafe] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_extern] = ACTIONS(2905),
    [anon_sym_yield] = ACTIONS(2905),
    [anon_sym_move] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [sym_integer_literal] = ACTIONS(2903),
    [aux_sym_string_literal_token1] = ACTIONS(2903),
    [sym_char_literal] = ACTIONS(2903),
    [anon_sym_true] = ACTIONS(2905),
    [anon_sym_false] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2905),
    [sym_super] = ACTIONS(2905),
    [sym_crate] = ACTIONS(2905),
    [sym_metavariable] = ACTIONS(2903),
    [sym__raw_string_literal_start] = ACTIONS(2903),
    [sym_float_literal] = ACTIONS(2903),
  },
  [751] = {
    [sym_line_comment] = STATE(751),
    [sym_block_comment] = STATE(751),
    [ts_builtin_sym_end] = ACTIONS(2907),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_macro_rules_BANG] = ACTIONS(2907),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_u8] = ACTIONS(2909),
    [anon_sym_i8] = ACTIONS(2909),
    [anon_sym_u16] = ACTIONS(2909),
    [anon_sym_i16] = ACTIONS(2909),
    [anon_sym_u32] = ACTIONS(2909),
    [anon_sym_i32] = ACTIONS(2909),
    [anon_sym_u64] = ACTIONS(2909),
    [anon_sym_i64] = ACTIONS(2909),
    [anon_sym_u128] = ACTIONS(2909),
    [anon_sym_i128] = ACTIONS(2909),
    [anon_sym_isize] = ACTIONS(2909),
    [anon_sym_usize] = ACTIONS(2909),
    [anon_sym_f32] = ACTIONS(2909),
    [anon_sym_f64] = ACTIONS(2909),
    [anon_sym_bool] = ACTIONS(2909),
    [anon_sym_str] = ACTIONS(2909),
    [anon_sym_char] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_DOT_DOT] = ACTIONS(2907),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_POUND] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2909),
    [anon_sym_async] = ACTIONS(2909),
    [anon_sym_break] = ACTIONS(2909),
    [anon_sym_const] = ACTIONS(2909),
    [anon_sym_continue] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2909),
    [anon_sym_fn] = ACTIONS(2909),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_impl] = ACTIONS(2909),
    [anon_sym_let] = ACTIONS(2909),
    [anon_sym_loop] = ACTIONS(2909),
    [anon_sym_match] = ACTIONS(2909),
    [anon_sym_mod] = ACTIONS(2909),
    [anon_sym_pub] = ACTIONS(2909),
    [anon_sym_return] = ACTIONS(2909),
    [anon_sym_static] = ACTIONS(2909),
    [anon_sym_struct] = ACTIONS(2909),
    [anon_sym_trait] = ACTIONS(2909),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_union] = ACTIONS(2909),
    [anon_sym_unsafe] = ACTIONS(2909),
    [anon_sym_use] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_extern] = ACTIONS(2909),
    [anon_sym_yield] = ACTIONS(2909),
    [anon_sym_move] = ACTIONS(2909),
    [anon_sym_try] = ACTIONS(2909),
    [sym_integer_literal] = ACTIONS(2907),
    [aux_sym_string_literal_token1] = ACTIONS(2907),
    [sym_char_literal] = ACTIONS(2907),
    [anon_sym_true] = ACTIONS(2909),
    [anon_sym_false] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2909),
    [sym_super] = ACTIONS(2909),
    [sym_crate] = ACTIONS(2909),
    [sym_metavariable] = ACTIONS(2907),
    [sym__raw_string_literal_start] = ACTIONS(2907),
    [sym_float_literal] = ACTIONS(2907),
  },
  [752] = {
    [sym_line_comment] = STATE(752),
    [sym_block_comment] = STATE(752),
    [ts_builtin_sym_end] = ACTIONS(2911),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_macro_rules_BANG] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2911),
    [anon_sym_u8] = ACTIONS(2913),
    [anon_sym_i8] = ACTIONS(2913),
    [anon_sym_u16] = ACTIONS(2913),
    [anon_sym_i16] = ACTIONS(2913),
    [anon_sym_u32] = ACTIONS(2913),
    [anon_sym_i32] = ACTIONS(2913),
    [anon_sym_u64] = ACTIONS(2913),
    [anon_sym_i64] = ACTIONS(2913),
    [anon_sym_u128] = ACTIONS(2913),
    [anon_sym_i128] = ACTIONS(2913),
    [anon_sym_isize] = ACTIONS(2913),
    [anon_sym_usize] = ACTIONS(2913),
    [anon_sym_f32] = ACTIONS(2913),
    [anon_sym_f64] = ACTIONS(2913),
    [anon_sym_bool] = ACTIONS(2913),
    [anon_sym_str] = ACTIONS(2913),
    [anon_sym_char] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_BANG] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2911),
    [anon_sym_LT] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2911),
    [anon_sym_POUND] = ACTIONS(2911),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_async] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_const] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_default] = ACTIONS(2913),
    [anon_sym_enum] = ACTIONS(2913),
    [anon_sym_fn] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_impl] = ACTIONS(2913),
    [anon_sym_let] = ACTIONS(2913),
    [anon_sym_loop] = ACTIONS(2913),
    [anon_sym_match] = ACTIONS(2913),
    [anon_sym_mod] = ACTIONS(2913),
    [anon_sym_pub] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_static] = ACTIONS(2913),
    [anon_sym_struct] = ACTIONS(2913),
    [anon_sym_trait] = ACTIONS(2913),
    [anon_sym_type] = ACTIONS(2913),
    [anon_sym_union] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2913),
    [anon_sym_use] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_extern] = ACTIONS(2913),
    [anon_sym_yield] = ACTIONS(2913),
    [anon_sym_move] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [sym_integer_literal] = ACTIONS(2911),
    [aux_sym_string_literal_token1] = ACTIONS(2911),
    [sym_char_literal] = ACTIONS(2911),
    [anon_sym_true] = ACTIONS(2913),
    [anon_sym_false] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2913),
    [sym_super] = ACTIONS(2913),
    [sym_crate] = ACTIONS(2913),
    [sym_metavariable] = ACTIONS(2911),
    [sym__raw_string_literal_start] = ACTIONS(2911),
    [sym_float_literal] = ACTIONS(2911),
  },
  [753] = {
    [sym_line_comment] = STATE(753),
    [sym_block_comment] = STATE(753),
    [ts_builtin_sym_end] = ACTIONS(2915),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_macro_rules_BANG] = ACTIONS(2915),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_u8] = ACTIONS(2917),
    [anon_sym_i8] = ACTIONS(2917),
    [anon_sym_u16] = ACTIONS(2917),
    [anon_sym_i16] = ACTIONS(2917),
    [anon_sym_u32] = ACTIONS(2917),
    [anon_sym_i32] = ACTIONS(2917),
    [anon_sym_u64] = ACTIONS(2917),
    [anon_sym_i64] = ACTIONS(2917),
    [anon_sym_u128] = ACTIONS(2917),
    [anon_sym_i128] = ACTIONS(2917),
    [anon_sym_isize] = ACTIONS(2917),
    [anon_sym_usize] = ACTIONS(2917),
    [anon_sym_f32] = ACTIONS(2917),
    [anon_sym_f64] = ACTIONS(2917),
    [anon_sym_bool] = ACTIONS(2917),
    [anon_sym_str] = ACTIONS(2917),
    [anon_sym_char] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_BANG] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_DOT_DOT] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_POUND] = ACTIONS(2915),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_async] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2917),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_continue] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2917),
    [anon_sym_enum] = ACTIONS(2917),
    [anon_sym_fn] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_impl] = ACTIONS(2917),
    [anon_sym_let] = ACTIONS(2917),
    [anon_sym_loop] = ACTIONS(2917),
    [anon_sym_match] = ACTIONS(2917),
    [anon_sym_mod] = ACTIONS(2917),
    [anon_sym_pub] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2917),
    [anon_sym_static] = ACTIONS(2917),
    [anon_sym_struct] = ACTIONS(2917),
    [anon_sym_trait] = ACTIONS(2917),
    [anon_sym_type] = ACTIONS(2917),
    [anon_sym_union] = ACTIONS(2917),
    [anon_sym_unsafe] = ACTIONS(2917),
    [anon_sym_use] = ACTIONS(2917),
    [anon_sym_while] = ACTIONS(2917),
    [anon_sym_extern] = ACTIONS(2917),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_move] = ACTIONS(2917),
    [anon_sym_try] = ACTIONS(2917),
    [sym_integer_literal] = ACTIONS(2915),
    [aux_sym_string_literal_token1] = ACTIONS(2915),
    [sym_char_literal] = ACTIONS(2915),
    [anon_sym_true] = ACTIONS(2917),
    [anon_sym_false] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2917),
    [sym_super] = ACTIONS(2917),
    [sym_crate] = ACTIONS(2917),
    [sym_metavariable] = ACTIONS(2915),
    [sym__raw_string_literal_start] = ACTIONS(2915),
    [sym_float_literal] = ACTIONS(2915),
  },
  [754] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(2780),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2681),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(754),
    [sym_block_comment] = STATE(754),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [755] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(2778),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2684),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(755),
    [sym_block_comment] = STATE(755),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [756] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_pattern] = STATE(3399),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(756),
    [sym_block_comment] = STATE(756),
    [aux_sym_match_arm_repeat1] = STATE(1032),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [757] = {
    [sym_attribute_item] = STATE(1474),
    [sym_inner_attribute_item] = STATE(1474),
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_match_pattern] = STATE(3561),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(3025),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(757),
    [sym_block_comment] = STATE(757),
    [aux_sym_match_arm_repeat1] = STATE(1032),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [758] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(3155),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2911),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(758),
    [sym_block_comment] = STATE(758),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [759] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(3155),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2911),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(759),
    [sym_block_comment] = STATE(759),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [760] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(3155),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2911),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(760),
    [sym_block_comment] = STATE(760),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [761] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(3155),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2911),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(761),
    [sym_block_comment] = STATE(761),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [762] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(965),
    [sym__type] = STATE(2502),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(762),
    [sym_block_comment] = STATE(762),
    [aux_sym_enum_variant_list_repeat1] = STATE(778),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [763] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_const_parameter] = STATE(2733),
    [sym_constrained_type_parameter] = STATE(2728),
    [sym_optional_type_parameter] = STATE(2733),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2842),
    [sym_bracketed_type] = STATE(3333),
    [sym_qualified_type] = STATE(3464),
    [sym_lifetime] = STATE(2373),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(763),
    [sym_block_comment] = STATE(763),
    [aux_sym_enum_variant_list_repeat1] = STATE(2052),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(2973),
  },
  [764] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym_closure_expression] = STATE(3155),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2911),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(764),
    [sym_block_comment] = STATE(764),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [765] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(975),
    [sym__type] = STATE(2817),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(765),
    [sym_block_comment] = STATE(765),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [766] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(975),
    [sym__type] = STATE(2817),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(766),
    [sym_block_comment] = STATE(766),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [767] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(975),
    [sym__type] = STATE(2817),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(767),
    [sym_block_comment] = STATE(767),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [768] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(975),
    [sym__type] = STATE(2817),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(768),
    [sym_block_comment] = STATE(768),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [769] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(975),
    [sym__type] = STATE(2817),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(769),
    [sym_block_comment] = STATE(769),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [770] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(975),
    [sym__type] = STATE(2817),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(770),
    [sym_block_comment] = STATE(770),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [771] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(943),
    [sym__type] = STATE(2864),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(771),
    [sym_block_comment] = STATE(771),
    [aux_sym_enum_variant_list_repeat1] = STATE(1078),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [772] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2675),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(772),
    [sym_block_comment] = STATE(772),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2989),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [773] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(975),
    [sym__type] = STATE(2817),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(773),
    [sym_block_comment] = STATE(773),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [774] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2559),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(774),
    [sym_block_comment] = STATE(774),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [775] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2680),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(775),
    [sym_block_comment] = STATE(775),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2997),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [776] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2688),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(776),
    [sym_block_comment] = STATE(776),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [777] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2683),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(777),
    [sym_block_comment] = STATE(777),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(2999),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(3001),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [778] = {
    [sym_attribute_item] = STATE(1477),
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym_visibility_modifier] = STATE(897),
    [sym__type] = STATE(2649),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(778),
    [sym_block_comment] = STATE(778),
    [aux_sym_enum_variant_list_repeat1] = STATE(1078),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_pub] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2965),
    [sym_metavariable] = ACTIONS(1584),
  },
  [779] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(779),
    [sym_block_comment] = STATE(779),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [780] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(780),
    [sym_block_comment] = STATE(780),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(3007),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [781] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(781),
    [sym_block_comment] = STATE(781),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [782] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(782),
    [sym_block_comment] = STATE(782),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [783] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(783),
    [sym_block_comment] = STATE(783),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [784] = {
    [sym_parameter] = STATE(3160),
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2878),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(784),
    [sym_block_comment] = STATE(784),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(3015),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3017),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [785] = {
    [sym_parameter] = STATE(2846),
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2606),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(785),
    [sym_block_comment] = STATE(785),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(3015),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3017),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [786] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(786),
    [sym_block_comment] = STATE(786),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(3021),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [787] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(787),
    [sym_block_comment] = STATE(787),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(3023),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [788] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2570),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(788),
    [sym_block_comment] = STATE(788),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3025),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3027),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [789] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(789),
    [sym_block_comment] = STATE(789),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3029),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [790] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(790),
    [sym_block_comment] = STATE(790),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [791] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(791),
    [sym_block_comment] = STATE(791),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [792] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(792),
    [sym_block_comment] = STATE(792),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(3035),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [793] = {
    [sym_parameter] = STATE(2846),
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2408),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(793),
    [sym_block_comment] = STATE(793),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(3019),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(3015),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3017),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [794] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(794),
    [sym_block_comment] = STATE(794),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [795] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(795),
    [sym_block_comment] = STATE(795),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [796] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2905),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(796),
    [sym_block_comment] = STATE(796),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [797] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2397),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(797),
    [sym_block_comment] = STATE(797),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [798] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2086),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(798),
    [sym_block_comment] = STATE(798),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [799] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3049),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(799),
    [sym_block_comment] = STATE(799),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [800] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3087),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(800),
    [sym_block_comment] = STATE(800),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [801] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3050),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(801),
    [sym_block_comment] = STATE(801),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [802] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2089),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(802),
    [sym_block_comment] = STATE(802),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [803] = {
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(2954),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(803),
    [sym_block_comment] = STATE(803),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [804] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3270),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(804),
    [sym_block_comment] = STATE(804),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [805] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2097),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(805),
    [sym_block_comment] = STATE(805),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [806] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3287),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(806),
    [sym_block_comment] = STATE(806),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [807] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2749),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(807),
    [sym_block_comment] = STATE(807),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [808] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2102),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(808),
    [sym_block_comment] = STATE(808),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [809] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3051),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(809),
    [sym_block_comment] = STATE(809),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [810] = {
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(2952),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(810),
    [sym_block_comment] = STATE(810),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [811] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2433),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(811),
    [sym_block_comment] = STATE(811),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [812] = {
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(2950),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(812),
    [sym_block_comment] = STATE(812),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [813] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3105),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(813),
    [sym_block_comment] = STATE(813),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [814] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2459),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(814),
    [sym_block_comment] = STATE(814),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(3041),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [815] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3053),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(815),
    [sym_block_comment] = STATE(815),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [816] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2457),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(816),
    [sym_block_comment] = STATE(816),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(3043),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [817] = {
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(2972),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(817),
    [sym_block_comment] = STATE(817),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [818] = {
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(2961),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(818),
    [sym_block_comment] = STATE(818),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [819] = {
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(2949),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(819),
    [sym_block_comment] = STATE(819),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(3045),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [820] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2085),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(820),
    [sym_block_comment] = STATE(820),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(3047),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [821] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2094),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(821),
    [sym_block_comment] = STATE(821),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [822] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3161),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(822),
    [sym_block_comment] = STATE(822),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [823] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(823),
    [sym_block_comment] = STATE(823),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [824] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2849),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(824),
    [sym_block_comment] = STATE(824),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [825] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2087),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(825),
    [sym_block_comment] = STATE(825),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [826] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(2689),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(826),
    [sym_block_comment] = STATE(826),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3049),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [827] = {
    [sym_bracketed_type] = STATE(3531),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3136),
    [sym_macro_invocation] = STATE(2939),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(2744),
    [sym_const_block] = STATE(2939),
    [sym__pattern] = STATE(2964),
    [sym_tuple_pattern] = STATE(2939),
    [sym_slice_pattern] = STATE(2939),
    [sym_tuple_struct_pattern] = STATE(2939),
    [sym_struct_pattern] = STATE(2939),
    [sym_remaining_field_pattern] = STATE(2939),
    [sym_mut_pattern] = STATE(2939),
    [sym_range_pattern] = STATE(2939),
    [sym_ref_pattern] = STATE(2939),
    [sym_captured_pattern] = STATE(2939),
    [sym_reference_pattern] = STATE(2939),
    [sym_or_pattern] = STATE(2939),
    [sym__literal_pattern] = STATE(2366),
    [sym_negative_literal] = STATE(2355),
    [sym_string_literal] = STATE(2355),
    [sym_raw_string_literal] = STATE(2355),
    [sym_boolean_literal] = STATE(2355),
    [sym_line_comment] = STATE(827),
    [sym_block_comment] = STATE(827),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [828] = {
    [sym_bracketed_type] = STATE(3484),
    [sym_generic_type] = STATE(3487),
    [sym_generic_type_with_turbofish] = STATE(3219),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(1954),
    [sym_scoped_type_identifier] = STATE(2845),
    [sym_const_block] = STATE(2079),
    [sym__pattern] = STATE(3062),
    [sym_tuple_pattern] = STATE(2079),
    [sym_slice_pattern] = STATE(2079),
    [sym_tuple_struct_pattern] = STATE(2079),
    [sym_struct_pattern] = STATE(2079),
    [sym_remaining_field_pattern] = STATE(2079),
    [sym_mut_pattern] = STATE(2079),
    [sym_range_pattern] = STATE(2079),
    [sym_ref_pattern] = STATE(2079),
    [sym_captured_pattern] = STATE(2079),
    [sym_reference_pattern] = STATE(2079),
    [sym_or_pattern] = STATE(2079),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2009),
    [sym_string_literal] = STATE(2009),
    [sym_raw_string_literal] = STATE(2009),
    [sym_boolean_literal] = STATE(2009),
    [sym_line_comment] = STATE(828),
    [sym_block_comment] = STATE(828),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1312),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1318),
    [aux_sym_string_literal_token1] = ACTIONS(1320),
    [sym_char_literal] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1322),
    [anon_sym_false] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1318),
  },
  [829] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1639),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(829),
    [sym_block_comment] = STATE(829),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [sym_mutable_specifier] = ACTIONS(3081),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [830] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1995),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(830),
    [sym_block_comment] = STATE(830),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(3089),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3091),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [831] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1397),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(831),
    [sym_block_comment] = STATE(831),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [sym_mutable_specifier] = ACTIONS(3123),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [832] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(3035),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(832),
    [sym_block_comment] = STATE(832),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(3129),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [833] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1995),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(833),
    [sym_block_comment] = STATE(833),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(3131),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [834] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(3047),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(832),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(834),
    [sym_block_comment] = STATE(834),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(3133),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [835] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2886),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(835),
    [sym_block_comment] = STATE(835),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [836] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_type_parameters] = STATE(871),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2326),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(2328),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(2159),
    [sym_line_comment] = STATE(836),
    [sym_block_comment] = STATE(836),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [837] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2886),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(837),
    [sym_block_comment] = STATE(837),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3143),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [838] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2886),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(838),
    [sym_block_comment] = STATE(838),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [839] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_higher_ranked_trait_bound] = STATE(2214),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2217),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2218),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(839),
    [sym_block_comment] = STATE(839),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [840] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_higher_ranked_trait_bound] = STATE(2214),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2217),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2216),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(840),
    [sym_block_comment] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [841] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_type_parameters] = STATE(969),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2331),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(2317),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(2146),
    [sym_line_comment] = STATE(841),
    [sym_block_comment] = STATE(841),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3149),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3151),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [842] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2541),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(842),
    [sym_block_comment] = STATE(842),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3153),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [843] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2697),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(843),
    [sym_block_comment] = STATE(843),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3155),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [844] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_type_parameters] = STATE(941),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2352),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(2307),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(2136),
    [sym_line_comment] = STATE(844),
    [sym_block_comment] = STATE(844),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3159),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [845] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2886),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(845),
    [sym_block_comment] = STATE(845),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3161),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [846] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_higher_ranked_trait_bound] = STATE(2214),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2176),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2216),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(846),
    [sym_block_comment] = STATE(846),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [847] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1433),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(831),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(847),
    [sym_block_comment] = STATE(847),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [sym_mutable_specifier] = ACTIONS(3163),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [848] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1796),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(829),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(848),
    [sym_block_comment] = STATE(848),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [sym_mutable_specifier] = ACTIONS(3165),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [849] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2886),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(849),
    [sym_block_comment] = STATE(849),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [850] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2842),
    [sym_bracketed_type] = STATE(3333),
    [sym_qualified_type] = STATE(3464),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(850),
    [sym_block_comment] = STATE(850),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [851] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1992),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(833),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(851),
    [sym_block_comment] = STATE(851),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(3169),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [852] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_type_parameters] = STATE(901),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2386),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(2291),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(2145),
    [sym_line_comment] = STATE(852),
    [sym_block_comment] = STATE(852),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3173),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [853] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2886),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(853),
    [sym_block_comment] = STATE(853),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [854] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2694),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(854),
    [sym_block_comment] = STATE(854),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3177),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [855] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_higher_ranked_trait_bound] = STATE(2175),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2168),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(2167),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(855),
    [sym_block_comment] = STATE(855),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [856] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2568),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(856),
    [sym_block_comment] = STATE(856),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3179),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [857] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2543),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(857),
    [sym_block_comment] = STATE(857),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3181),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [858] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2951),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(858),
    [sym_block_comment] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [859] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1277),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(859),
    [sym_block_comment] = STATE(859),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [860] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2544),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(860),
    [sym_block_comment] = STATE(860),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [861] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2193),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(861),
    [sym_block_comment] = STATE(861),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [862] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2337),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(862),
    [sym_block_comment] = STATE(862),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [863] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2339),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(863),
    [sym_block_comment] = STATE(863),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [864] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2228),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(864),
    [sym_block_comment] = STATE(864),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [865] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2991),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(865),
    [sym_block_comment] = STATE(865),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [866] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2292),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(866),
    [sym_block_comment] = STATE(866),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [867] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2297),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(867),
    [sym_block_comment] = STATE(867),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [868] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2504),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(868),
    [sym_block_comment] = STATE(868),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [869] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2231),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(869),
    [sym_block_comment] = STATE(869),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [870] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2298),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(870),
    [sym_block_comment] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [871] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2375),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(2379),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(2149),
    [sym_line_comment] = STATE(871),
    [sym_block_comment] = STATE(871),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [872] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2543),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(872),
    [sym_block_comment] = STATE(872),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [873] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1979),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(873),
    [sym_block_comment] = STATE(873),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [874] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(3046),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(874),
    [sym_block_comment] = STATE(874),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [875] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(3035),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(875),
    [sym_block_comment] = STATE(875),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [876] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2299),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(876),
    [sym_block_comment] = STATE(876),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [877] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(3058),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(877),
    [sym_block_comment] = STATE(877),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [878] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2189),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(878),
    [sym_block_comment] = STATE(878),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [879] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2507),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(879),
    [sym_block_comment] = STATE(879),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [880] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2694),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(880),
    [sym_block_comment] = STATE(880),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [881] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2320),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(881),
    [sym_block_comment] = STATE(881),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [882] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1974),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(882),
    [sym_block_comment] = STATE(882),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3187),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [883] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2314),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(883),
    [sym_block_comment] = STATE(883),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [884] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2308),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(884),
    [sym_block_comment] = STATE(884),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [885] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2802),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(885),
    [sym_block_comment] = STATE(885),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [886] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2759),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(886),
    [sym_block_comment] = STATE(886),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [887] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1974),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(887),
    [sym_block_comment] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [888] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1639),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(888),
    [sym_block_comment] = STATE(888),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [889] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2387),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(889),
    [sym_block_comment] = STATE(889),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [890] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1983),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(890),
    [sym_block_comment] = STATE(890),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [891] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2897),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(891),
    [sym_block_comment] = STATE(891),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [892] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2203),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(892),
    [sym_block_comment] = STATE(892),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [893] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1996),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(893),
    [sym_block_comment] = STATE(893),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [894] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2826),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(894),
    [sym_block_comment] = STATE(894),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [895] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1643),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(895),
    [sym_block_comment] = STATE(895),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [896] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2886),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(896),
    [sym_block_comment] = STATE(896),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [897] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2633),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(897),
    [sym_block_comment] = STATE(897),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [898] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2706),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(898),
    [sym_block_comment] = STATE(898),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [899] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(3022),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(899),
    [sym_block_comment] = STATE(899),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [900] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1995),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(900),
    [sym_block_comment] = STATE(900),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [901] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2296),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(2294),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(2165),
    [sym_line_comment] = STATE(901),
    [sym_block_comment] = STATE(901),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [902] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2186),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(902),
    [sym_block_comment] = STATE(902),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [903] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2944),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(903),
    [sym_block_comment] = STATE(903),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [904] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2377),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(904),
    [sym_block_comment] = STATE(904),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [905] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1967),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(1993),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(905),
    [sym_block_comment] = STATE(905),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [906] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2210),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(906),
    [sym_block_comment] = STATE(906),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [907] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2551),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(907),
    [sym_block_comment] = STATE(907),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [908] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1718),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(908),
    [sym_block_comment] = STATE(908),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [909] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1660),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(909),
    [sym_block_comment] = STATE(909),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [910] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1966),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(910),
    [sym_block_comment] = STATE(910),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [911] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2458),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(911),
    [sym_block_comment] = STATE(911),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [912] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1994),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(912),
    [sym_block_comment] = STATE(912),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [913] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2351),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(913),
    [sym_block_comment] = STATE(913),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [914] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2813),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(914),
    [sym_block_comment] = STATE(914),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [915] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1686),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(915),
    [sym_block_comment] = STATE(915),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [916] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1984),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(916),
    [sym_block_comment] = STATE(916),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [917] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1398),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(917),
    [sym_block_comment] = STATE(917),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [918] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2756),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(918),
    [sym_block_comment] = STATE(918),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [919] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2827),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(919),
    [sym_block_comment] = STATE(919),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [920] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1397),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(920),
    [sym_block_comment] = STATE(920),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [921] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1669),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(921),
    [sym_block_comment] = STATE(921),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [922] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1673),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(922),
    [sym_block_comment] = STATE(922),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [923] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1326),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(923),
    [sym_block_comment] = STATE(923),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [924] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1684),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(924),
    [sym_block_comment] = STATE(924),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [925] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2374),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(925),
    [sym_block_comment] = STATE(925),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [926] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2336),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(926),
    [sym_block_comment] = STATE(926),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [927] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2342),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(927),
    [sym_block_comment] = STATE(927),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [928] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2558),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(928),
    [sym_block_comment] = STATE(928),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [929] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(929),
    [sym_block_comment] = STATE(929),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [930] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2481),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(930),
    [sym_block_comment] = STATE(930),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [931] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1726),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(931),
    [sym_block_comment] = STATE(931),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [932] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2594),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(932),
    [sym_block_comment] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [933] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2799),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(933),
    [sym_block_comment] = STATE(933),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [934] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1721),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(934),
    [sym_block_comment] = STATE(934),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [935] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1330),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(935),
    [sym_block_comment] = STATE(935),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [936] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2358),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(936),
    [sym_block_comment] = STATE(936),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [937] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2697),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(937),
    [sym_block_comment] = STATE(937),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [938] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(3021),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(938),
    [sym_block_comment] = STATE(938),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [939] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2388),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(939),
    [sym_block_comment] = STATE(939),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [940] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2311),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(940),
    [sym_block_comment] = STATE(940),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [941] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2385),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(2303),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(2133),
    [sym_line_comment] = STATE(941),
    [sym_block_comment] = STATE(941),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [942] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2400),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(942),
    [sym_block_comment] = STATE(942),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [943] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2909),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(943),
    [sym_block_comment] = STATE(943),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [944] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1312),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(944),
    [sym_block_comment] = STATE(944),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [945] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2178),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(945),
    [sym_block_comment] = STATE(945),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [946] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1374),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(946),
    [sym_block_comment] = STATE(946),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [947] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2501),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(947),
    [sym_block_comment] = STATE(947),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [948] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2310),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(948),
    [sym_block_comment] = STATE(948),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [949] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1418),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(949),
    [sym_block_comment] = STATE(949),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [950] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(3125),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(950),
    [sym_block_comment] = STATE(950),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [951] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2197),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(951),
    [sym_block_comment] = STATE(951),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [952] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1685),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(952),
    [sym_block_comment] = STATE(952),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [953] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2323),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(953),
    [sym_block_comment] = STATE(953),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [954] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(954),
    [sym_block_comment] = STATE(954),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [955] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2380),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(955),
    [sym_block_comment] = STATE(955),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [956] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1967),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(1993),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(956),
    [sym_block_comment] = STATE(956),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [957] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2568),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(957),
    [sym_block_comment] = STATE(957),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [958] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(3133),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(958),
    [sym_block_comment] = STATE(958),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [959] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2631),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(959),
    [sym_block_comment] = STATE(959),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [960] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1967),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(960),
    [sym_block_comment] = STATE(960),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [961] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2605),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(961),
    [sym_block_comment] = STATE(961),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [962] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2723),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(962),
    [sym_block_comment] = STATE(962),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [963] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2615),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(963),
    [sym_block_comment] = STATE(963),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [964] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2856),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(964),
    [sym_block_comment] = STATE(964),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [965] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2649),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(965),
    [sym_block_comment] = STATE(965),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [966] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1280),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(966),
    [sym_block_comment] = STATE(966),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [967] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1334),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(967),
    [sym_block_comment] = STATE(967),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [968] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1683),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(968),
    [sym_block_comment] = STATE(968),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [969] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2347),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(2309),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(2137),
    [sym_line_comment] = STATE(969),
    [sym_block_comment] = STATE(969),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3197),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [970] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2371),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(970),
    [sym_block_comment] = STATE(970),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [971] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2302),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(971),
    [sym_block_comment] = STATE(971),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [972] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1681),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(972),
    [sym_block_comment] = STATE(972),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [973] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2209),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(973),
    [sym_block_comment] = STATE(973),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [974] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2208),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(974),
    [sym_block_comment] = STATE(974),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [975] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2864),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(975),
    [sym_block_comment] = STATE(975),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [976] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2673),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(976),
    [sym_block_comment] = STATE(976),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [977] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2325),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(977),
    [sym_block_comment] = STATE(977),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [978] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2834),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(978),
    [sym_block_comment] = STATE(978),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [979] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2441),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(979),
    [sym_block_comment] = STATE(979),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [980] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2410),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(980),
    [sym_block_comment] = STATE(980),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [981] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1190),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(981),
    [sym_block_comment] = STATE(981),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [982] = {
    [sym_function_modifiers] = STATE(3480),
    [sym_removed_trait_bound] = STATE(1674),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1822),
    [sym_bracketed_type] = STATE(3537),
    [sym_lifetime] = STATE(3572),
    [sym_array_type] = STATE(1674),
    [sym_for_lifetimes] = STATE(1623),
    [sym_function_type] = STATE(1674),
    [sym_tuple_type] = STATE(1674),
    [sym_unit_type] = STATE(1674),
    [sym_generic_type] = STATE(1591),
    [sym_generic_type_with_turbofish] = STATE(3529),
    [sym_bounded_type] = STATE(1674),
    [sym_reference_type] = STATE(1674),
    [sym_pointer_type] = STATE(1674),
    [sym_never_type] = STATE(1674),
    [sym_abstract_type] = STATE(1674),
    [sym_dynamic_type] = STATE(1674),
    [sym_macro_invocation] = STATE(1674),
    [sym_scoped_identifier] = STATE(3130),
    [sym_scoped_type_identifier] = STATE(1516),
    [sym_line_comment] = STATE(982),
    [sym_block_comment] = STATE(982),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [983] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1273),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(983),
    [sym_block_comment] = STATE(983),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [984] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2224),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(984),
    [sym_block_comment] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [985] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2809),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(985),
    [sym_block_comment] = STATE(985),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [986] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1977),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(986),
    [sym_block_comment] = STATE(986),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [987] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2926),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(987),
    [sym_block_comment] = STATE(987),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [988] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2319),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(988),
    [sym_block_comment] = STATE(988),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [989] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1988),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(989),
    [sym_block_comment] = STATE(989),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [990] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1989),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(990),
    [sym_block_comment] = STATE(990),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [991] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2316),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(991),
    [sym_block_comment] = STATE(991),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [992] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2943),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(992),
    [sym_block_comment] = STATE(992),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [993] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2763),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(993),
    [sym_block_comment] = STATE(993),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [994] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2637),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(994),
    [sym_block_comment] = STATE(994),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [995] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2315),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(995),
    [sym_block_comment] = STATE(995),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [996] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1270),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(996),
    [sym_block_comment] = STATE(996),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [997] = {
    [sym_line_comment] = STATE(997),
    [sym_block_comment] = STATE(997),
    [sym_identifier] = ACTIONS(2743),
    [anon_sym_LPAREN] = ACTIONS(2741),
    [anon_sym_LBRACK] = ACTIONS(2741),
    [anon_sym_RBRACK] = ACTIONS(2741),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_u8] = ACTIONS(2743),
    [anon_sym_i8] = ACTIONS(2743),
    [anon_sym_u16] = ACTIONS(2743),
    [anon_sym_i16] = ACTIONS(2743),
    [anon_sym_u32] = ACTIONS(2743),
    [anon_sym_i32] = ACTIONS(2743),
    [anon_sym_u64] = ACTIONS(2743),
    [anon_sym_i64] = ACTIONS(2743),
    [anon_sym_u128] = ACTIONS(2743),
    [anon_sym_i128] = ACTIONS(2743),
    [anon_sym_isize] = ACTIONS(2743),
    [anon_sym_usize] = ACTIONS(2743),
    [anon_sym_f32] = ACTIONS(2743),
    [anon_sym_f64] = ACTIONS(2743),
    [anon_sym_bool] = ACTIONS(2743),
    [anon_sym_str] = ACTIONS(2743),
    [anon_sym_char] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym__] = ACTIONS(2743),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_COMMA] = ACTIONS(2741),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_POUND] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2743),
    [anon_sym_async] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_loop] = ACTIONS(2743),
    [anon_sym_match] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_unsafe] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_ref] = ACTIONS(2743),
    [sym_mutable_specifier] = ACTIONS(2743),
    [anon_sym_yield] = ACTIONS(2743),
    [anon_sym_move] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [sym_integer_literal] = ACTIONS(2741),
    [aux_sym_string_literal_token1] = ACTIONS(2741),
    [sym_char_literal] = ACTIONS(2741),
    [anon_sym_true] = ACTIONS(2743),
    [anon_sym_false] = ACTIONS(2743),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2743),
    [sym_super] = ACTIONS(2743),
    [sym_crate] = ACTIONS(2743),
    [sym_metavariable] = ACTIONS(2741),
    [sym__raw_string_literal_start] = ACTIONS(2741),
    [sym_float_literal] = ACTIONS(2741),
  },
  [998] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2313),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(998),
    [sym_block_comment] = STATE(998),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [999] = {
    [sym_function_modifiers] = STATE(3339),
    [sym_removed_trait_bound] = STATE(1351),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(1429),
    [sym_bracketed_type] = STATE(3522),
    [sym_lifetime] = STATE(3444),
    [sym_array_type] = STATE(1351),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1351),
    [sym_tuple_type] = STATE(1351),
    [sym_unit_type] = STATE(1351),
    [sym_generic_type] = STATE(1059),
    [sym_generic_type_with_turbofish] = STATE(3512),
    [sym_bounded_type] = STATE(1351),
    [sym_reference_type] = STATE(1351),
    [sym_pointer_type] = STATE(1351),
    [sym_never_type] = STATE(1351),
    [sym_abstract_type] = STATE(1351),
    [sym_dynamic_type] = STATE(1351),
    [sym_macro_invocation] = STATE(1351),
    [sym_scoped_identifier] = STATE(3269),
    [sym_scoped_type_identifier] = STATE(1024),
    [sym_line_comment] = STATE(999),
    [sym_block_comment] = STATE(999),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [1000] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2933),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(1000),
    [sym_block_comment] = STATE(1000),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [1001] = {
    [sym_function_modifiers] = STATE(3468),
    [sym_removed_trait_bound] = STATE(1976),
    [sym_extern_modifier] = STATE(2321),
    [sym__type] = STATE(2541),
    [sym_bracketed_type] = STATE(3333),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(1976),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1976),
    [sym_tuple_type] = STATE(1976),
    [sym_unit_type] = STATE(1976),
    [sym_generic_type] = STATE(1937),
    [sym_generic_type_with_turbofish] = STATE(3461),
    [sym_bounded_type] = STATE(1976),
    [sym_reference_type] = STATE(1976),
    [sym_pointer_type] = STATE(1976),
    [sym_never_type] = STATE(1976),
    [sym_abstract_type] = STATE(1976),
    [sym_dynamic_type] = STATE(1976),
    [sym_macro_invocation] = STATE(1976),
    [sym_scoped_identifier] = STATE(3146),
    [sym_scoped_type_identifier] = STATE(1918),
    [sym_line_comment] = STATE(1001),
    [sym_block_comment] = STATE(1001),
    [aux_sym_function_modifiers_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_QMARK] = ACTIONS(1270),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(1296),
    [anon_sym_const] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_impl] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_dyn] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [1002] = {
    [sym_attribute_item] = STATE(1003),
    [sym_line_comment] = STATE(1002),
    [sym_block_comment] = STATE(1002),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_RBRACK] = ACTIONS(758),
    [anon_sym_LBRACE] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_u8] = ACTIONS(3201),
    [anon_sym_i8] = ACTIONS(3201),
    [anon_sym_u16] = ACTIONS(3201),
    [anon_sym_i16] = ACTIONS(3201),
    [anon_sym_u32] = ACTIONS(3201),
    [anon_sym_i32] = ACTIONS(3201),
    [anon_sym_u64] = ACTIONS(3201),
    [anon_sym_i64] = ACTIONS(3201),
    [anon_sym_u128] = ACTIONS(3201),
    [anon_sym_i128] = ACTIONS(3201),
    [anon_sym_isize] = ACTIONS(3201),
    [anon_sym_usize] = ACTIONS(3201),
    [anon_sym_f32] = ACTIONS(3201),
    [anon_sym_f64] = ACTIONS(3201),
    [anon_sym_bool] = ACTIONS(3201),
    [anon_sym_str] = ACTIONS(3201),
    [anon_sym_char] = ACTIONS(3201),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_PIPE] = ACTIONS(758),
    [anon_sym_LT] = ACTIONS(758),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_COMMA] = ACTIONS(758),
    [anon_sym_COLON_COLON] = ACTIONS(758),
    [anon_sym_POUND] = ACTIONS(784),
    [anon_sym_SQUOTE] = ACTIONS(3201),
    [anon_sym_async] = ACTIONS(3201),
    [anon_sym_break] = ACTIONS(3201),
    [anon_sym_const] = ACTIONS(3201),
    [anon_sym_continue] = ACTIONS(3201),
    [anon_sym_default] = ACTIONS(3201),
    [anon_sym_for] = ACTIONS(3201),
    [anon_sym_if] = ACTIONS(3201),
    [anon_sym_loop] = ACTIONS(3201),
    [anon_sym_match] = ACTIONS(3201),
    [anon_sym_return] = ACTIONS(3201),
    [anon_sym_static] = ACTIONS(3201),
    [anon_sym_union] = ACTIONS(3201),
    [anon_sym_unsafe] = ACTIONS(3201),
    [anon_sym_while] = ACTIONS(3201),
    [anon_sym_yield] = ACTIONS(3201),
    [anon_sym_move] = ACTIONS(3201),
    [anon_sym_try] = ACTIONS(3201),
    [sym_integer_literal] = ACTIONS(758),
    [aux_sym_string_literal_token1] = ACTIONS(758),
    [sym_char_literal] = ACTIONS(758),
    [anon_sym_true] = ACTIONS(3201),
    [anon_sym_false] = ACTIONS(3201),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3201),
    [sym_super] = ACTIONS(3201),
    [sym_crate] = ACTIONS(3201),
    [sym_metavariable] = ACTIONS(758),
    [sym__raw_string_literal_start] = ACTIONS(758),
    [sym_float_literal] = ACTIONS(758),
  },
  [1003] = {
    [sym_line_comment] = STATE(1003),
    [sym_block_comment] = STATE(1003),
    [sym_identifier] = ACTIONS(3203),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_LBRACK] = ACTIONS(3205),
    [anon_sym_RBRACK] = ACTIONS(3205),
    [anon_sym_LBRACE] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(3203),
    [anon_sym_i8] = ACTIONS(3203),
    [anon_sym_u16] = ACTIONS(3203),
    [anon_sym_i16] = ACTIONS(3203),
    [anon_sym_u32] = ACTIONS(3203),
    [anon_sym_i32] = ACTIONS(3203),
    [anon_sym_u64] = ACTIONS(3203),
    [anon_sym_i64] = ACTIONS(3203),
    [anon_sym_u128] = ACTIONS(3203),
    [anon_sym_i128] = ACTIONS(3203),
    [anon_sym_isize] = ACTIONS(3203),
    [anon_sym_usize] = ACTIONS(3203),
    [anon_sym_f32] = ACTIONS(3203),
    [anon_sym_f64] = ACTIONS(3203),
    [anon_sym_bool] = ACTIONS(3203),
    [anon_sym_str] = ACTIONS(3203),
    [anon_sym_char] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_BANG] = ACTIONS(3205),
    [anon_sym_AMP] = ACTIONS(3205),
    [anon_sym_PIPE] = ACTIONS(3205),
    [anon_sym_LT] = ACTIONS(3205),
    [anon_sym_DOT_DOT] = ACTIONS(3205),
    [anon_sym_COMMA] = ACTIONS(3205),
    [anon_sym_COLON_COLON] = ACTIONS(3205),
    [anon_sym_POUND] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_async] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_loop] = ACTIONS(3203),
    [anon_sym_match] = ACTIONS(3203),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_union] = ACTIONS(3203),
    [anon_sym_unsafe] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_yield] = ACTIONS(3203),
    [anon_sym_move] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [sym_integer_literal] = ACTIONS(3205),
    [aux_sym_string_literal_token1] = ACTIONS(3205),
    [sym_char_literal] = ACTIONS(3205),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3203),
    [sym_super] = ACTIONS(3203),
    [sym_crate] = ACTIONS(3203),
    [sym_metavariable] = ACTIONS(3205),
    [sym__raw_string_literal_start] = ACTIONS(3205),
    [sym_float_literal] = ACTIONS(3205),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1556), 17,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(1554), 43,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_DASH,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [75] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3209), 17,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3207), 43,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_DASH,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [150] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1087), 18,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3211), 41,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [224] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2741), 17,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(2743), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_ref,
      anon_sym_dyn,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [294] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3215), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3213), 34,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_dyn,
      sym_mutable_specifier,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [363] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1274), 1,
      anon_sym_DASH,
    ACTIONS(1320), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1330), 1,
      sym__raw_string_literal_start,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3217), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      sym_metavariable,
    STATE(2041), 1,
      sym_scoped_identifier,
    STATE(2093), 1,
      sym__literal_pattern,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1322), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1318), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3221), 3,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
    ACTIONS(3225), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2009), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3219), 7,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
    ACTIONS(3223), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [462] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1274), 1,
      anon_sym_DASH,
    ACTIONS(1320), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1330), 1,
      sym__raw_string_literal_start,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3229), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      sym_metavariable,
    STATE(2057), 1,
      sym_scoped_identifier,
    STATE(2098), 1,
      sym__literal_pattern,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1322), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1318), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3233), 3,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
    ACTIONS(3237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2009), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3231), 7,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
    ACTIONS(3235), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [561] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3249), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1050), 1,
      sym_parameters,
    STATE(1072), 1,
      sym_type_arguments,
    STATE(1011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3245), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3241), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [638] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3257), 1,
      anon_sym_COLON_COLON,
    STATE(1050), 1,
      sym_parameters,
    STATE(1072), 1,
      sym_type_arguments,
    STATE(1012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3255), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3253), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [712] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3257), 1,
      anon_sym_COLON_COLON,
    STATE(1050), 1,
      sym_parameters,
    STATE(1072), 1,
      sym_type_arguments,
    STATE(1013), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [786] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3257), 1,
      anon_sym_COLON_COLON,
    STATE(1050), 1,
      sym_parameters,
    STATE(1072), 1,
      sym_type_arguments,
    STATE(1014), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3265), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3263), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [860] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1049), 1,
      sym_parameters,
    STATE(1070), 1,
      sym_type_arguments,
    STATE(1015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [931] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1003), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1001), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [994] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3275), 1,
      anon_sym_BANG,
    ACTIONS(3277), 1,
      anon_sym_COLON_COLON,
    STATE(1017), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1061] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1018), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(983), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(981), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1124] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1049), 1,
      sym_parameters,
    STATE(1070), 1,
      sym_type_arguments,
    STATE(1019), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3279), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1195] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1020), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1414), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1416), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1258] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1021), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1244), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1246), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1321] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1022), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1248), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1250), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1384] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_BANG,
    ACTIONS(3289), 1,
      anon_sym_COLON_COLON,
    STATE(1023), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1451] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1049), 1,
      sym_parameters,
    STATE(1070), 1,
      sym_type_arguments,
    STATE(1024), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1522] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1025), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1240), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1242), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1585] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 1,
      anon_sym_BANG,
    ACTIONS(3301), 1,
      anon_sym_COLON_COLON,
    STATE(1026), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1652] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1027), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1232), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1234), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1715] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_BANG,
    ACTIONS(3309), 1,
      anon_sym_COLON_COLON,
    STATE(1028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1782] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1236), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1238), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1845] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1030), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1206), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1208), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1908] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1049), 1,
      sym_parameters,
    STATE(1070), 1,
      sym_type_arguments,
    STATE(1031), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1979] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3319), 1,
      anon_sym_POUND,
    STATE(1474), 2,
      sym_attribute_item,
      sym_inner_attribute_item,
    STATE(1032), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_match_arm_repeat1,
    ACTIONS(3317), 14,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3315), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2045] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1033), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2107] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_COLON_COLON,
    STATE(1354), 1,
      sym_field_initializer_list,
    STATE(1034), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [2177] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1035), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1900), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1902), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2239] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1036), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2238), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2240), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2301] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3330), 1,
      anon_sym_BANG,
    ACTIONS(3332), 1,
      anon_sym_COLON_COLON,
    STATE(1037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
    ACTIONS(3328), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_as,
    ACTIONS(3326), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [2369] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1038), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2847), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2849), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2431] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1039), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3277), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2493] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3299), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3301), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2555] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1041), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2617] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1042), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2769), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2771), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2679] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1710), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1712), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2741] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3338), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3336), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2802] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1045), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3342), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3340), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2863] = 24,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3344), 1,
      sym_identifier,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_STAR,
    ACTIONS(3354), 1,
      anon_sym_AMP,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3358), 1,
      anon_sym_SQUOTE,
    ACTIONS(3362), 1,
      anon_sym_for,
    ACTIONS(3366), 1,
      sym_metavariable,
    STATE(2522), 1,
      sym_scoped_type_identifier,
    STATE(2671), 1,
      sym_where_predicate,
    STATE(2967), 1,
      sym_generic_type,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3476), 1,
      sym_bracketed_type,
    ACTIONS(3346), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3098), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3352), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2962] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3368), 1,
      anon_sym_LBRACE,
    STATE(1047), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3299), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3301), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [3025] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3370), 1,
      anon_sym_else,
    STATE(1352), 1,
      sym_else_clause,
    STATE(1048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1196), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1194), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
  [3090] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_DASH_GT,
    STATE(1049), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3374), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3372), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3153] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3382), 1,
      anon_sym_DASH_GT,
    STATE(1050), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3380), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3378), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3216] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3384), 1,
      anon_sym_COLON_COLON,
    STATE(1051), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3279] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3390), 1,
      anon_sym_DASH_GT,
    STATE(1052), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3388), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3386), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3342] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3392), 1,
      anon_sym_COLON_COLON,
    STATE(1053), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3405] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3103), 1,
      anon_sym_QMARK,
    ACTIONS(3115), 1,
      anon_sym_fn,
    ACTIONS(3394), 1,
      sym_identifier,
    ACTIONS(3396), 1,
      anon_sym_LPAREN,
    ACTIONS(3400), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3402), 1,
      anon_sym_default,
    ACTIONS(3404), 1,
      anon_sym_for,
    ACTIONS(3406), 1,
      anon_sym_union,
    ACTIONS(3410), 1,
      sym_metavariable,
    STATE(1031), 1,
      sym_scoped_type_identifier,
    STATE(1057), 1,
      sym_generic_type,
    STATE(1614), 1,
      sym_for_lifetimes,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(3339), 1,
      sym_function_modifiers,
    STATE(3490), 1,
      sym_scoped_identifier,
    STATE(3524), 1,
      sym_generic_type_with_turbofish,
    STATE(3534), 1,
      sym_bracketed_type,
    STATE(1054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3408), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1439), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3398), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3510] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3412), 1,
      anon_sym_COLON_COLON,
    STATE(1055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3573] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1056), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3416), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3414), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3634] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3384), 1,
      anon_sym_COLON_COLON,
    STATE(1057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3697] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3420), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3418), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3758] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3384), 1,
      anon_sym_COLON_COLON,
    STATE(1059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3821] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3424), 1,
      anon_sym_LPAREN,
    STATE(1340), 1,
      sym_arguments,
    STATE(1060), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3426), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3422), 29,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1061), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [3947] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3428), 1,
      anon_sym_COLON_COLON,
    STATE(1062), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4010] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1063), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3432), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3430), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4071] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1064), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3213), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3215), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4132] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3434), 1,
      anon_sym_LBRACE,
    STATE(1065), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3277), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [4195] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3440), 1,
      anon_sym_DASH_GT,
    STATE(1066), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3438), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3436), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4258] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1405), 1,
      sym_label,
    STATE(1067), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3444), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3442), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [4323] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1068), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3450), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3448), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4384] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1069), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3454), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3452), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4445] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1070), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3458), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3456), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4506] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    STATE(1071), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [4569] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1072), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3464), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3462), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4630] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1073), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3468), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3466), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4691] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1270), 1,
      anon_sym_QMARK,
    ACTIONS(1302), 1,
      anon_sym_fn,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3470), 1,
      sym_identifier,
    ACTIONS(3474), 1,
      anon_sym_default,
    ACTIONS(3476), 1,
      anon_sym_for,
    STATE(1587), 1,
      sym_for_lifetimes,
    STATE(1913), 1,
      sym_scoped_type_identifier,
    STATE(1940), 1,
      sym_generic_type,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3468), 1,
      sym_function_modifiers,
    STATE(3476), 1,
      sym_bracketed_type,
    STATE(1074), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1991), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3472), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4796] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1075), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3480), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3478), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4857] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1076), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3484), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3482), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4918] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1270), 1,
      anon_sym_QMARK,
    ACTIONS(1302), 1,
      anon_sym_fn,
    ACTIONS(1304), 1,
      anon_sym_for,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3474), 1,
      anon_sym_default,
    ACTIONS(3486), 1,
      sym_identifier,
    STATE(1587), 1,
      sym_for_lifetimes,
    STATE(1916), 1,
      sym_scoped_type_identifier,
    STATE(1949), 1,
      sym_generic_type,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3468), 1,
      sym_function_modifiers,
    STATE(3476), 1,
      sym_bracketed_type,
    STATE(1077), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1987), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3472), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5023] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3488), 1,
      anon_sym_POUND,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(1078), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_enum_variant_list_repeat1,
    ACTIONS(758), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_integer_literal,
      sym_metavariable,
    ACTIONS(3201), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [5088] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1079), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3493), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3491), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5149] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3499), 1,
      anon_sym_DASH_GT,
    STATE(1080), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3497), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3495), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5212] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(1081), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [5275] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3507), 1,
      anon_sym_DASH_GT,
    STATE(1082), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3505), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3503), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5338] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1304), 1,
      anon_sym_for,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3061), 1,
      anon_sym_QMARK,
    ACTIONS(3073), 1,
      anon_sym_fn,
    ACTIONS(3509), 1,
      sym_identifier,
    ACTIONS(3511), 1,
      anon_sym_LPAREN,
    ACTIONS(3515), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3517), 1,
      anon_sym_default,
    ACTIONS(3519), 1,
      anon_sym_union,
    ACTIONS(3523), 1,
      sym_metavariable,
    STATE(1532), 1,
      sym_scoped_type_identifier,
    STATE(1613), 1,
      sym_generic_type,
    STATE(1623), 1,
      sym_for_lifetimes,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(3480), 1,
      sym_function_modifiers,
    STATE(3515), 1,
      sym_scoped_identifier,
    STATE(3532), 1,
      sym_generic_type_with_turbofish,
    STATE(3538), 1,
      sym_bracketed_type,
    STATE(1083), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3521), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1666), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3513), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5443] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1084), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1546), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1548), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5504] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1085), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3527), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3525), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5565] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1304), 1,
      anon_sym_for,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3103), 1,
      anon_sym_QMARK,
    ACTIONS(3115), 1,
      anon_sym_fn,
    ACTIONS(3396), 1,
      anon_sym_LPAREN,
    ACTIONS(3400), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3402), 1,
      anon_sym_default,
    ACTIONS(3406), 1,
      anon_sym_union,
    ACTIONS(3410), 1,
      sym_metavariable,
    ACTIONS(3529), 1,
      sym_identifier,
    STATE(1019), 1,
      sym_scoped_type_identifier,
    STATE(1087), 1,
      sym_generic_type,
    STATE(1614), 1,
      sym_for_lifetimes,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(3339), 1,
      sym_function_modifiers,
    STATE(3490), 1,
      sym_scoped_identifier,
    STATE(3524), 1,
      sym_generic_type_with_turbofish,
    STATE(3534), 1,
      sym_bracketed_type,
    STATE(1086), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3408), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1275), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3398), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5670] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3384), 1,
      anon_sym_COLON_COLON,
    STATE(1087), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3279), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5733] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3061), 1,
      anon_sym_QMARK,
    ACTIONS(3073), 1,
      anon_sym_fn,
    ACTIONS(3511), 1,
      anon_sym_LPAREN,
    ACTIONS(3515), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3517), 1,
      anon_sym_default,
    ACTIONS(3519), 1,
      anon_sym_union,
    ACTIONS(3523), 1,
      sym_metavariable,
    ACTIONS(3531), 1,
      sym_identifier,
    ACTIONS(3533), 1,
      anon_sym_for,
    STATE(1524), 1,
      sym_scoped_type_identifier,
    STATE(1623), 1,
      sym_for_lifetimes,
    STATE(1631), 1,
      sym_generic_type,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(3480), 1,
      sym_function_modifiers,
    STATE(3515), 1,
      sym_scoped_identifier,
    STATE(3532), 1,
      sym_generic_type_with_turbofish,
    STATE(3538), 1,
      sym_bracketed_type,
    STATE(1088), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3521), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1779), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3513), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5838] = 24,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3344), 1,
      sym_identifier,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_STAR,
    ACTIONS(3354), 1,
      anon_sym_AMP,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3358), 1,
      anon_sym_SQUOTE,
    ACTIONS(3362), 1,
      anon_sym_for,
    ACTIONS(3366), 1,
      sym_metavariable,
    STATE(2522), 1,
      sym_scoped_type_identifier,
    STATE(2671), 1,
      sym_where_predicate,
    STATE(2967), 1,
      sym_generic_type,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3476), 1,
      sym_bracketed_type,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    ACTIONS(3535), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(1089), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3098), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3352), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5937] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3541), 1,
      anon_sym_DASH_GT,
    STATE(1090), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3539), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3537), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6000] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1091), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1666), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1668), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6060] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1092), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2793), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2795), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6120] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1093), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3545), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3543), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1094), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2741), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2743), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6240] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1095), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2222), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2224), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1096), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3549), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3547), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6360] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1097), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2062), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2064), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6420] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1098), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2436), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2438), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6480] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1099), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2058), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2060), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6540] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1100), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2206), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2208), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6600] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1101), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2424), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2426), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6660] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1102), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(903), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(905), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6720] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1103), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2198), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2200), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6780] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1104), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2054), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2056), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6840] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1105), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2274), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2276), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6900] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1106), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1440), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1438), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6960] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1107), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2166), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2168), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7020] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1108), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3553), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3551), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7080] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1109), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2270), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2272), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7140] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1110), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3557), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3555), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7200] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1111), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2158), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2160), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7260] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1112), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2266), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2268), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7320] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1113), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2262), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2264), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7380] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1114), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2154), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2156), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7440] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1115), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2254), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2256), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7500] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1116), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2278), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2280), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7560] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1117), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1444), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1442), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7620] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1118), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1242), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1240), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7680] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1119), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2380), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2382), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7740] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1120), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2350), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2352), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7800] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1121), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2144), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7860] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1122), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2346), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2348), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1123), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2342), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2344), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7980] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1124), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2334), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2336), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8040] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    STATE(1125), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3563), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3559), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8106] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1126), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1908), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1910), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8166] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1127), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2318), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2320), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8226] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1128), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2611), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2613), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8286] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1129), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2282), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2284), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8346] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1130), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2290), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2292), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8406] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1131), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2302), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2304), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8466] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1132), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2330), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2332), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8526] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1133), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2338), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2340), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8586] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1134), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2146), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2148), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8646] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1135), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2360), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2362), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8706] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1136), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2364), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2366), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8766] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1137), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2416), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2418), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8826] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1138), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2314), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2316), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1139), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1904), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1906), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8946] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1140), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2310), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2312), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9006] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1141), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2306), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2308), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9066] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1142), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2298), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2300), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9126] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1143), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1674), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1676), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9186] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1144), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1690), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1692), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9246] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1145), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2294), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2296), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9306] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1146), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2286), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2288), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9366] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1147), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2246), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2248), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9426] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1148), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2242), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2244), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9486] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1149), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2234), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2236), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9546] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1150), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2218), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2220), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9606] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1151), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2368), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2370), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9666] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1152), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2186), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2188), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9726] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1153), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2178), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2180), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9786] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1154), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2126), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2128), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9846] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1155), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2675), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2677), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9906] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1156), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2122), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2124), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9966] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1157), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2374), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10026] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1158), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2118), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2120), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10086] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1159), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2376), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2378), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10146] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1160), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2102), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2104), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10206] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1161), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2034), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2036), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10266] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1162), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2030), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2032), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10326] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1163), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1694), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1696), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10386] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1164), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2026), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2028), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10446] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1165), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2022), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2024), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10506] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1166), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3571), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3569), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10566] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1167), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1706), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1708), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10626] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1168), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1718), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1720), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10686] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1169), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1990), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1992), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10746] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1170), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2384), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2386), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10806] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1171), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2388), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2390), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10866] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1172), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1722), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1724), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10926] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1173), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1678), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1680), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10986] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1174), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1682), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1684), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11046] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1175), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1726), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1728), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11106] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1176), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1702), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1704), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11166] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1177), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2392), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2394), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11226] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1178), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2404), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2406), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11286] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1179), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2412), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2414), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11346] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1180), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2765), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2767), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11406] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1181), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2440), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2442), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11466] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1182), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2484), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2486), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11526] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1183), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1734), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1736), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11586] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1184), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2591), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2593), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11646] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1185), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2615), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2617), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11706] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1186), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1662), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1664), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11766] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1187), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1766), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1768), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11826] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1188), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2773), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2775), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1189), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1738), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1740), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11946] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1190), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3575), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3573), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12006] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1191), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2631), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2633), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12066] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1192), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2639), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2641), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12126] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1193), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1742), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1744), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12186] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1194), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2663), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2665), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12246] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1195), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1746), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1748), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12306] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1196), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2707), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2709), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12366] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1197), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1750), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1752), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12426] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1198), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2354), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2356), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12486] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1199), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1754), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1756), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12546] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1200), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1758), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1760), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12606] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1201), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1762), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1764), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12666] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1202), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3579), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3577), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12726] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1203), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2731), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2733), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12786] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1204), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1844), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1846), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12846] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1205), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2745), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2747), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12906] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1206), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2777), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2779), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12966] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1207), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2753), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2755), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13026] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1208), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2761), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2763), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13086] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1209), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1428), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1426), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13146] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1210), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1840), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1842), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13206] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1211), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1848), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1850), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13266] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1212), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3583), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3581), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13326] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1213), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2781), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2783), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13386] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1214), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3587), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3585), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13446] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1215), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1860), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1862), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13506] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1216), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3591), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3589), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13566] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1217), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1852), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1854), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13626] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1218), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1856), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1858), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13686] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1219), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1864), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1866), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13746] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1220), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1872), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1874), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13806] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1221), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1868), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1870), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13866] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1222), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3595), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3593), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13926] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1223), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1888), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1890), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13986] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1224), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1912), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1914), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14046] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1225), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3599), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3597), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14106] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1226), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3603), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3601), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14166] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1227), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1916), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1918), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14226] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1228), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1880), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1882), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14286] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1229), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2789), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2791), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14346] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1230), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1884), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1886), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14406] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1231), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2831), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2833), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14466] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1232), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1896), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1898), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14526] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1233), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1970), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1972), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14586] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1234), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1974), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1976), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14646] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1235), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2891), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2893), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14706] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1236), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2038), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2040), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14766] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1237), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2050), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2052), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14826] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1238), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2907), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2909), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1239), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2066), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2068), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14946] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1240), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2785), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2787), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15006] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1241), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2070), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2072), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15066] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1242), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1436), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1434), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15126] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1243), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3607), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3605), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15186] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1244), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3611), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3609), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15246] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1245), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2797), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2799), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15306] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1246), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1376), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1374), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15366] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1247), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2078), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2080), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15426] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1248), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2086), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2088), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15486] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1249), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3615), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3613), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15546] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1250), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2090), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2092), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15606] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1251), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1978), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1980), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15666] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1252), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2094), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2096), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15726] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1253), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2106), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2108), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15786] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1254), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1982), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1984), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15846] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1255), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3619), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3617), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15906] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1256), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1986), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1988), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15966] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1257), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2002), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2004), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16026] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1258), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2110), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2112), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16086] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1259), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2010), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2012), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16146] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1260), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2114), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2116), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16206] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1261), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2074), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2076), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16266] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1262), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2803), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2805), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16326] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1263), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1001), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1003), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [16386] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1264), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3623), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3621), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [16446] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1265), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2082), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2084), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16506] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1266), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2098), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2100), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16566] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3629), 1,
      anon_sym_RBRACE,
    STATE(1267), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3627), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3625), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16628] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3631), 1,
      anon_sym_COLON_COLON,
    STATE(1268), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [16692] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1269), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2130), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2132), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16752] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1270), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3635), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3633), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [16812] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1271), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2138), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2140), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16872] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1272), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2150), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2152), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16932] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1273), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3639), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3637), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [16992] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1274), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2162), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2164), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17052] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1275), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3279), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1276), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3643), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3641), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17172] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1277), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3647), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3645), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1278), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1730), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1732), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17292] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1279), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(933), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(935), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17352] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1280), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3651), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3649), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17412] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1281), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3655), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3653), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17472] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1282), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2444), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2446), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17532] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1283), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2819), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2821), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17592] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1284), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2460), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2462), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17652] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1285), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1432), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1430), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17712] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1286), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2464), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2466), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17772] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1287), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2468), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2470), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17832] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1288), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2476), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2478), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17892] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1289), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3659), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3657), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17952] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1290), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2170), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2172), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18012] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1291), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2174), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2176), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18072] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1292), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2480), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2482), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18132] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1293), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3663), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3661), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18192] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1294), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2190), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2192), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18252] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1295), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2194), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2196), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18312] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1296), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2827), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2829), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1297), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2488), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2490), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18432] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1298), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2202), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2204), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18492] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1299), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2210), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2212), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18552] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1300), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2496), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2498), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18612] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1301), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3667), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3665), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18672] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1302), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2500), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2502), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18732] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1303), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2226), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2228), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18792] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1304), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2595), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2597), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18852] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1305), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18912] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1306), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18972] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1307), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2835), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2837), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19032] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1308), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2839), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2841), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19092] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1309), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2599), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2601), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19152] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1310), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2623), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2625), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19212] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1311), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2230), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2232), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19272] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1312), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3671), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3669), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1313), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2627), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2629), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19392] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1314), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2647), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2649), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19452] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1315), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1208), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1206), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19512] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1316), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3675), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3673), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19572] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1317), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2653), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19632] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1318), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3679), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3677), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19692] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1319), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3683), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3681), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19752] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1320), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2655), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2657), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19812] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1321), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2659), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2661), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19872] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1322), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2667), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2669), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19932] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1323), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19992] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1324), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2671), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2673), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20052] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1325), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2679), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2681), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1326), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3687), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3685), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [20172] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1327), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2683), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2685), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1328), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2711), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2713), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20292] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1329), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3691), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3689), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [20352] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1330), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3695), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3693), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [20412] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1331), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2719), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2721), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20472] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1332), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2723), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2725), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20532] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1333), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2727), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2729), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20592] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1334), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3699), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3697), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [20652] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1335), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3703), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3701), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [20712] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1336), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2749), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2751), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20772] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1337), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(885), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(887), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [20832] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1338), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2134), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2136), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20892] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1339), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2851), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2853), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20952] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1340), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3707), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3705), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21012] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1341), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3711), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3709), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21072] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1342), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1368), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1366), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21132] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1343), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2867), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2869), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21192] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1344), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2879), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2881), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21252] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1345), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2883), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2885), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21312] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1346), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3715), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3713), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1347), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2895), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2897), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21432] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1348), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2899), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2901), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21492] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1349), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3717), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21552] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1350), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2322), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2324), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21612] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1351), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21672] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1352), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1396), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21732] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1353), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3723), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3721), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21792] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1354), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3727), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3725), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21852] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1355), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2326), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2328), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21912] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1356), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2887), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2889), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21972] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1357), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(937), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(939), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22032] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1358), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2875), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2877), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22092] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1359), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3731), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3729), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22152] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1360), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1364), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1362), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22212] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1361), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2863), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2865), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22272] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1362), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1246), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1244), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1363), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2859), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2861), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22392] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1364), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(945), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(947), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22452] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1365), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3735), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22512] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1366), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(981), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(983), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22572] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1367), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2855), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2857), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22632] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1368), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2871), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2873), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22692] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1369), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2396), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2398), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22752] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1370), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2400), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2402), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22812] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1371), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1258), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1256), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22872] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1372), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1254), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1252), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22932] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1373), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3739), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3737), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22992] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1374), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3739), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3737), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23052] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1375), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2408), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2410), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1376), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2420), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2422), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23172] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1377), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2428), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2430), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1378), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2432), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2434), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23292] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1379), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2448), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2450), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23352] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1380), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2452), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2454), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23412] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1381), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1372), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1370), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23472] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1382), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1420), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1418), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23532] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1383), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2911), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2913), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23592] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1384), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23652] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1385), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2915), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2917), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23712] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1386), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2456), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2458), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23772] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1387), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2472), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2474), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23832] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1388), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2715), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2717), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23892] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1389), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3743), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(3741), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23952] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1390), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2492), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2494), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24012] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1391), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3747), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3745), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24072] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2757), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2759), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24132] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1393), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2587), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2589), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24192] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1394), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1448), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1446), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24252] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1395), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3751), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3749), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24312] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1396), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3426), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3422), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1397), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3755), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3753), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24432] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1398), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3759), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3757), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24492] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1399), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3761), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24552] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1400), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3767), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3765), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24612] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1401), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3771), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3769), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24672] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1402), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2603), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2605), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24732] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1403), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3775), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3773), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24792] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3332), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3777), 1,
      anon_sym_BANG,
    STATE(1404), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3326), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [24856] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1405), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3781), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3779), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24916] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1406), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1238), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1236), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24976] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1407), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2607), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2609), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25036] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1408), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2214), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2216), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25096] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1409), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2619), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2621), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25156] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1410), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2182), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2184), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25216] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1411), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2903), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2905), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25276] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1412), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3783), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25336] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1413), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1234), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1232), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25396] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    STATE(1414), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3789), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 27,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_else,
  [25464] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1614), 1,
      anon_sym_DASH,
    ACTIONS(1638), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1646), 1,
      sym__raw_string_literal_start,
    ACTIONS(3221), 1,
      anon_sym_if,
    ACTIONS(3793), 1,
      sym_identifier,
    ACTIONS(3797), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3801), 1,
      sym_metavariable,
    STATE(2534), 1,
      sym_scoped_identifier,
    STATE(2959), 1,
      sym__literal_pattern,
    STATE(3472), 1,
      sym_bracketed_type,
    STATE(3485), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1640), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3219), 2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(1415), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1636), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3799), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2355), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3795), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [25556] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3807), 1,
      anon_sym_RBRACE,
    STATE(1416), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3805), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3803), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25618] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1417), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3811), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3809), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25678] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1418), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3815), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3813), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25738] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3819), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1419), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3817), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [25800] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1420), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3817), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25860] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1421), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3825), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3823), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1422), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3829), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3827), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25980] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1614), 1,
      anon_sym_DASH,
    ACTIONS(1638), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1646), 1,
      sym__raw_string_literal_start,
    ACTIONS(3233), 1,
      anon_sym_if,
    ACTIONS(3797), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3831), 1,
      sym_identifier,
    ACTIONS(3837), 1,
      sym_metavariable,
    STATE(2525), 1,
      sym_scoped_identifier,
    STATE(2968), 1,
      sym__literal_pattern,
    STATE(3472), 1,
      sym_bracketed_type,
    STATE(3485), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1640), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3231), 2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(1423), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1636), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3835), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2355), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3833), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [26072] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1424), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2825), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26132] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1425), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3841), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3839), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26192] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1426), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2815), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2817), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26252] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1427), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3845), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3843), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26312] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1428), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2635), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2637), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1429), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3849), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3847), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26432] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1430), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2811), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2813), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26492] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1431), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2643), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2645), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26552] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1432), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2018), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2020), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26612] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1433), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3853), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3851), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26672] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1434), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2687), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2689), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26732] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1435), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2014), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2016), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26792] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1436), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3857), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3855), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26852] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3859), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1437), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3817), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [26914] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1438), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1876), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1878), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26974] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1439), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27034] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1440), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27094] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1441), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3863), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3861), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27154] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    STATE(1442), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3867), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3865), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27220] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1443), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2807), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2809), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27280] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1444), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1416), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1414), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27340] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1445), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1360), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1358), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27400] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1446), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1836), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1838), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27460] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1447), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1714), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1716), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27520] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1448), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1698), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1700), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27580] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1449), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1686), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1688), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27640] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1450), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1670), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1672), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27700] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1451), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1892), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1894), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27760] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    STATE(1452), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3871), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3869), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27826] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1453), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3875), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3873), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1454), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3879), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3877), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27946] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1455), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1994), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1996), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28006] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1456), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1998), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2000), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28066] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1457), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1400), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1398), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28126] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1458), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2006), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2008), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28186] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1459), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2042), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2044), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28246] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1460), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2691), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2693), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28306] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1461), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2046), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2048), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28366] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1462), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28426] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1463), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2695), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2697), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28486] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1464), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2699), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2701), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28546] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1465), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2703), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2705), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28606] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1466), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2737), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2739), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28666] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1467), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3883), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28726] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1468), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1452), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1450), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28786] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1469), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2258), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2260), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28846] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1470), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1250), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1248), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28906] = 23,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3344), 1,
      sym_identifier,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_STAR,
    ACTIONS(3354), 1,
      anon_sym_AMP,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3358), 1,
      anon_sym_SQUOTE,
    ACTIONS(3362), 1,
      anon_sym_for,
    ACTIONS(3366), 1,
      sym_metavariable,
    STATE(2456), 1,
      sym_where_predicate,
    STATE(2522), 1,
      sym_scoped_type_identifier,
    STATE(2967), 1,
      sym_generic_type,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3476), 1,
      sym_bracketed_type,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1471), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3098), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3352), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29001] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1472), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3627), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3625), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29060] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3885), 1,
      anon_sym_COLON_COLON,
    STATE(1473), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [29121] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1474), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3889), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3887), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1475), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3805), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3803), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29239] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1476), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3893), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3891), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29298] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1477), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3205), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      sym_integer_literal,
      sym_metavariable,
    ACTIONS(3203), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29357] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1478), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2741), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      sym_integer_literal,
      sym_metavariable,
    ACTIONS(2743), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29416] = 23,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3344), 1,
      sym_identifier,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_STAR,
    ACTIONS(3354), 1,
      anon_sym_AMP,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3358), 1,
      anon_sym_SQUOTE,
    ACTIONS(3362), 1,
      anon_sym_for,
    ACTIONS(3366), 1,
      sym_metavariable,
    STATE(2522), 1,
      sym_scoped_type_identifier,
    STATE(2671), 1,
      sym_where_predicate,
    STATE(2967), 1,
      sym_generic_type,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3476), 1,
      sym_bracketed_type,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1479), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3098), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3352), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29511] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1480), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2098), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(2100), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29570] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3332), 1,
      anon_sym_COLON_COLON,
    STATE(1481), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3326), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [29631] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(3919), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1482), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3689), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29723] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1483), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [29801] = 25,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3115), 1,
      anon_sym_fn,
    ACTIONS(3400), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3402), 1,
      anon_sym_default,
    ACTIONS(3406), 1,
      anon_sym_union,
    ACTIONS(3410), 1,
      sym_metavariable,
    ACTIONS(3923), 1,
      sym_identifier,
    ACTIONS(3925), 1,
      anon_sym_for,
    STATE(1015), 1,
      sym_scoped_type_identifier,
    STATE(1051), 1,
      sym_generic_type,
    STATE(1614), 1,
      sym_for_lifetimes,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(3339), 1,
      sym_function_modifiers,
    STATE(3490), 1,
      sym_scoped_identifier,
    STATE(3524), 1,
      sym_generic_type_with_turbofish,
    STATE(3534), 1,
      sym_bracketed_type,
    STATE(1440), 2,
      sym_higher_ranked_trait_bound,
      sym_function_type,
    STATE(1484), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3408), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3398), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29899] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3919), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1485), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3927), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [29989] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3919), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3933), 1,
      anon_sym_EQ,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1486), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3931), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30079] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3919), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3937), 1,
      anon_sym_EQ,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1487), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3935), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30169] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3939), 1,
      anon_sym_BANG,
    STATE(1354), 1,
      sym_field_initializer_list,
    STATE(1488), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [30235] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3919), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1489), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30325] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1490), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(390), 19,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30411] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(3943), 1,
      anon_sym_BANG,
    ACTIONS(3945), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    STATE(1593), 1,
      sym_parameters,
    STATE(1599), 1,
      sym_type_arguments,
    STATE(1491), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3245), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3241), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [30481] = 25,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3073), 1,
      anon_sym_fn,
    ACTIONS(3515), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3517), 1,
      anon_sym_default,
    ACTIONS(3519), 1,
      anon_sym_union,
    ACTIONS(3523), 1,
      sym_metavariable,
    ACTIONS(3949), 1,
      sym_identifier,
    ACTIONS(3951), 1,
      anon_sym_for,
    STATE(1538), 1,
      sym_scoped_type_identifier,
    STATE(1623), 1,
      sym_for_lifetimes,
    STATE(1635), 1,
      sym_generic_type,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(3480), 1,
      sym_function_modifiers,
    STATE(3515), 1,
      sym_scoped_identifier,
    STATE(3532), 1,
      sym_generic_type_with_turbofish,
    STATE(3538), 1,
      sym_bracketed_type,
    STATE(1492), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1780), 2,
      sym_higher_ranked_trait_bound,
      sym_function_type,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3521), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3513), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30579] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    STATE(1493), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30647] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1494), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30721] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1495), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30793] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1496), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30869] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3789), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1497), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3787), 21,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30951] = 25,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1302), 1,
      anon_sym_fn,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3147), 1,
      anon_sym_for,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3474), 1,
      anon_sym_default,
    ACTIONS(3953), 1,
      sym_identifier,
    STATE(1587), 1,
      sym_for_lifetimes,
    STATE(1915), 1,
      sym_scoped_type_identifier,
    STATE(1948), 1,
      sym_generic_type,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3468), 1,
      sym_function_modifiers,
    STATE(3476), 1,
      sym_bracketed_type,
    STATE(1498), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1986), 2,
      sym_higher_ranked_trait_bound,
      sym_function_type,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3472), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [31049] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3789), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1499), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3787), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31133] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1500), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31203] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3919), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3957), 1,
      anon_sym_EQ,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1501), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3955), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31293] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3919), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3961), 1,
      anon_sym_EQ,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1502), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3959), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31383] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(3919), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1503), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3617), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31475] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(3919), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1504), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3661), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31567] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3965), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    STATE(1505), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3963), 19,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31653] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3943), 1,
      anon_sym_BANG,
    ACTIONS(3967), 1,
      anon_sym_LBRACE,
    ACTIONS(3969), 1,
      anon_sym_COLON_COLON,
    STATE(1748), 1,
      sym_field_initializer_list,
    STATE(1506), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31718] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3971), 1,
      anon_sym_COLON_COLON,
    STATE(1354), 1,
      sym_field_initializer_list,
    STATE(1507), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [31781] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    ACTIONS(3973), 1,
      anon_sym_COLON_COLON,
    STATE(1593), 1,
      sym_parameters,
    STATE(1599), 1,
      sym_type_arguments,
    STATE(1508), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3265), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3263), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31848] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    ACTIONS(3973), 1,
      anon_sym_COLON_COLON,
    STATE(1593), 1,
      sym_parameters,
    STATE(1599), 1,
      sym_type_arguments,
    STATE(1509), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31915] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1274), 1,
      anon_sym_DASH,
    ACTIONS(1320), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1330), 1,
      sym__raw_string_literal_start,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3217), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      sym_metavariable,
    STATE(2041), 1,
      sym_scoped_identifier,
    STATE(2093), 1,
      sym__literal_pattern,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1322), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1510), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1318), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3225), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2009), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3223), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32000] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1614), 1,
      anon_sym_DASH,
    ACTIONS(1638), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1646), 1,
      sym__raw_string_literal_start,
    ACTIONS(3793), 1,
      sym_identifier,
    ACTIONS(3797), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3801), 1,
      sym_metavariable,
    STATE(2534), 1,
      sym_scoped_identifier,
    STATE(2959), 1,
      sym__literal_pattern,
    STATE(3472), 1,
      sym_bracketed_type,
    STATE(3485), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1640), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1511), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1636), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3799), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2355), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3795), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32085] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1274), 1,
      anon_sym_DASH,
    ACTIONS(1320), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1330), 1,
      sym__raw_string_literal_start,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3229), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      sym_metavariable,
    STATE(2057), 1,
      sym_scoped_identifier,
    STATE(2098), 1,
      sym__literal_pattern,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1322), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1512), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1318), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2009), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3235), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32170] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    ACTIONS(3973), 1,
      anon_sym_COLON_COLON,
    STATE(1593), 1,
      sym_parameters,
    STATE(1599), 1,
      sym_type_arguments,
    STATE(1513), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3255), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3253), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32237] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3330), 1,
      anon_sym_BANG,
    ACTIONS(3332), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3975), 1,
      sym_identifier,
    STATE(1514), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_as,
    ACTIONS(3326), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [32300] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1614), 1,
      anon_sym_DASH,
    ACTIONS(1638), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1646), 1,
      sym__raw_string_literal_start,
    ACTIONS(3797), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3831), 1,
      sym_identifier,
    ACTIONS(3837), 1,
      sym_metavariable,
    STATE(2525), 1,
      sym_scoped_identifier,
    STATE(2968), 1,
      sym__literal_pattern,
    STATE(3472), 1,
      sym_bracketed_type,
    STATE(3485), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1640), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1515), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1636), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3835), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2355), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3833), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32385] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    STATE(1582), 1,
      sym_type_arguments,
    STATE(1589), 1,
      sym_parameters,
    STATE(1516), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32449] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3777), 1,
      anon_sym_BANG,
    ACTIONS(3977), 1,
      anon_sym_COLON_COLON,
    STATE(1517), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3326), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [32509] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3275), 1,
      anon_sym_BANG,
    ACTIONS(3277), 1,
      anon_sym_COLON_COLON,
    STATE(1518), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [32569] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3981), 1,
      anon_sym_LPAREN,
    STATE(1519), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3984), 9,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3979), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32627] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1520), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3545), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3543), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32683] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1521), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3715), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3713), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32739] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3434), 1,
      anon_sym_LBRACE,
    STATE(1522), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3277), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [32797] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    STATE(1523), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [32855] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    STATE(1582), 1,
      sym_type_arguments,
    STATE(1589), 1,
      sym_parameters,
    STATE(1524), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32919] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1525), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [32975] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3368), 1,
      anon_sym_LBRACE,
    STATE(1526), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3299), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3301), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [33033] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1527), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3277), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33089] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1528), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3988), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3986), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33145] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(1529), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [33203] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3990), 1,
      anon_sym_COLON_COLON,
    STATE(1530), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33263] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3992), 1,
      anon_sym_COLON_COLON,
    STATE(1531), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3984), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3979), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33321] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    STATE(1582), 1,
      sym_type_arguments,
    STATE(1589), 1,
      sym_parameters,
    STATE(1532), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3279), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33385] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1533), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33441] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1534), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3299), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3301), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33497] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1535), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3997), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3995), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33553] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3939), 1,
      anon_sym_BANG,
    STATE(1536), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33613] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_BANG,
    ACTIONS(3309), 1,
      anon_sym_COLON_COLON,
    STATE(1537), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [33673] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    STATE(1582), 1,
      sym_type_arguments,
    STATE(1589), 1,
      sym_parameters,
    STATE(1538), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33737] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 1,
      anon_sym_BANG,
    ACTIONS(3301), 1,
      anon_sym_COLON_COLON,
    STATE(1539), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [33797] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1540), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4001), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3999), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33853] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_BANG,
    ACTIONS(3289), 1,
      anon_sym_COLON_COLON,
    STATE(1541), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [33913] = 25,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(381), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1542), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34008] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1543), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34063] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1013), 1,
      anon_sym_RBRACK,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_SEMI,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    STATE(2832), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1544), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34158] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(1246), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1545), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34253] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1546), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3299), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3301), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34308] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1547), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3416), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3414), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34363] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3859), 1,
      anon_sym_COLON_COLON,
    STATE(1548), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3817), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [34420] = 25,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(396), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1549), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34515] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3859), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1550), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3817), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [34572] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4039), 1,
      anon_sym_else,
    STATE(1677), 1,
      sym_else_clause,
    STATE(1551), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1196), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1194), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [34631] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(466), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1552), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34726] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_RBRACK,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4041), 1,
      anon_sym_SEMI,
    ACTIONS(4043), 1,
      anon_sym_COMMA,
    STATE(2783), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1553), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34821] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1554), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3277), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34876] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4045), 1,
      anon_sym_SQUOTE,
    STATE(1737), 1,
      sym_label,
    STATE(1555), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3444), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3442), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [34935] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(465), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1556), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35030] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3819), 1,
      anon_sym_COLON_COLON,
    STATE(1557), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3817), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [35087] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3819), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1558), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3817), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [35144] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(1775), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1559), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35239] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1019), 1,
      anon_sym_RBRACK,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4047), 1,
      anon_sym_SEMI,
    ACTIONS(4049), 1,
      anon_sym_COMMA,
    STATE(2770), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1560), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35334] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4051), 1,
      anon_sym_COLON_COLON,
    STATE(1561), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [35391] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(953), 1,
      anon_sym_RBRACK,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4053), 1,
      anon_sym_SEMI,
    ACTIONS(4055), 1,
      anon_sym_COMMA,
    STATE(2784), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1562), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35486] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1405), 1,
      sym_label,
    STATE(1563), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3444), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3442), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [35543] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1564), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3450), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3448), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [35598] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1565), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3420), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3418), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [35653] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(1800), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1566), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35748] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3977), 1,
      anon_sym_COLON_COLON,
    STATE(1567), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3326), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [35805] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3943), 1,
      anon_sym_BANG,
    ACTIONS(4057), 1,
      anon_sym_COLON_COLON,
    STATE(1568), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [35864] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4059), 1,
      anon_sym_BANG,
    ACTIONS(4061), 1,
      anon_sym_COLON_COLON,
    STATE(1569), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3326), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [35923] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1570), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [35978] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(1117), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1571), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36073] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1572), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3484), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3482), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [36128] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(3789), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1573), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3787), 17,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [36206] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1574), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [36260] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4063), 1,
      anon_sym_DASH_GT,
    STATE(1575), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3539), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3537), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36316] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1576), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3454), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3452), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [36370] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1577), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3432), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3430), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [36424] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3933), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4067), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1578), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3931), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [36510] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1579), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1238), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1236), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36564] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1580), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [36638] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3961), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4067), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1581), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3959), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [36724] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1582), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3458), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3456), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [36778] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4069), 1,
      anon_sym_COLON_COLON,
    STATE(1583), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36834] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3957), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4067), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1584), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3955), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [36920] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1585), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [36986] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3789), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1586), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3787), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37066] = 22,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3474), 1,
      anon_sym_default,
    ACTIONS(4071), 1,
      sym_identifier,
    ACTIONS(4073), 1,
      anon_sym_fn,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(2709), 1,
      sym_scoped_type_identifier,
    STATE(3334), 1,
      sym_function_modifiers,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3476), 1,
      sym_bracketed_type,
    STATE(3487), 1,
      sym_generic_type,
    STATE(1587), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3472), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [37154] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1588), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1234), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1232), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [37208] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4075), 1,
      anon_sym_DASH_GT,
    STATE(1589), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3374), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3372), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [37264] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4077), 1,
      anon_sym_LPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(1590), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3426), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3422), 22,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [37322] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4079), 1,
      anon_sym_COLON_COLON,
    STATE(1591), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [37378] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4081), 1,
      anon_sym_COLON_COLON,
    STATE(1592), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [37434] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4083), 1,
      anon_sym_DASH_GT,
    STATE(1593), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3380), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3378), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [37490] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1594), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3493), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3491), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [37544] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_RPAREN,
    ACTIONS(4087), 1,
      anon_sym_COMMA,
    STATE(2957), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1595), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37636] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4067), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1596), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3689), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37724] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1597), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37796] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1598), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3480), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3478), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [37850] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1599), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3464), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3462), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [37904] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4067), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1600), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3617), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37992] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4061), 1,
      anon_sym_COLON_COLON,
    STATE(1601), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3326), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38048] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3965), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1602), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3963), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [38130] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1603), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3342), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3340), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [38184] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4089), 1,
      anon_sym_DASH_GT,
    STATE(1604), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3505), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3503), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38240] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4091), 1,
      anon_sym_COLON_COLON,
    STATE(1605), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38296] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4067), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1606), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3927), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [38382] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4093), 1,
      anon_sym_DASH_GT,
    STATE(1607), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3497), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3495), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38438] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4095), 1,
      anon_sym_COLON_COLON,
    STATE(1608), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38494] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1021), 1,
      anon_sym_RPAREN,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4097), 1,
      anon_sym_COMMA,
    STATE(2738), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1609), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38586] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1610), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3468), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3466), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [38640] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1611), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4099), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38728] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1612), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [38796] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4079), 1,
      anon_sym_COLON_COLON,
    STATE(1613), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3279), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38852] = 22,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3474), 1,
      anon_sym_default,
    ACTIONS(4101), 1,
      sym_identifier,
    ACTIONS(4103), 1,
      anon_sym_fn,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(2708), 1,
      sym_scoped_type_identifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3372), 1,
      sym_function_modifiers,
    STATE(3476), 1,
      sym_bracketed_type,
    STATE(3487), 1,
      sym_generic_type,
    STATE(1614), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3472), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [38940] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4067), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1615), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [39026] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1616), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [39096] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    STATE(1617), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [39160] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1618), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1208), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1206), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [39214] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3937), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4067), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1619), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3935), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [39300] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1620), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(390), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [39382] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4105), 1,
      anon_sym_DASH_GT,
    STATE(1621), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3388), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3386), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39438] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4107), 1,
      anon_sym_RPAREN,
    ACTIONS(4109), 1,
      anon_sym_COMMA,
    STATE(2867), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1622), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39530] = 22,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1310), 1,
      anon_sym_extern,
    ACTIONS(3356), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3474), 1,
      anon_sym_default,
    ACTIONS(4111), 1,
      sym_identifier,
    ACTIONS(4113), 1,
      anon_sym_fn,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(2545), 1,
      sym_scoped_type_identifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3362), 1,
      sym_scoped_identifier,
    STATE(3476), 1,
      sym_bracketed_type,
    STATE(3487), 1,
      sym_generic_type,
    STATE(3491), 1,
      sym_function_modifiers,
    STATE(1623), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3472), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [39618] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4115), 1,
      anon_sym_DASH_GT,
    STATE(1624), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3438), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3436), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39674] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1242), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1240), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [39728] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1626), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4117), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39816] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_RBRACK,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4119), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1627), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39908] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1007), 1,
      anon_sym_RBRACK,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4121), 1,
      anon_sym_COMMA,
    STATE(2913), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1628), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40000] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1025), 1,
      anon_sym_RPAREN,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4123), 1,
      anon_sym_COMMA,
    STATE(2956), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1629), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40092] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1630), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3338), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3336), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [40146] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4079), 1,
      anon_sym_COLON_COLON,
    STATE(1631), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40202] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1632), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3527), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3525), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [40256] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4065), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4067), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1633), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3661), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40344] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1634), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1246), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1244), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [40398] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4079), 1,
      anon_sym_COLON_COLON,
    STATE(1635), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40454] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(294), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1636), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40543] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(4127), 1,
      anon_sym_RBRACE,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1637), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40632] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    STATE(1638), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [40695] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1639), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3755), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3753), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40748] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1640), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3603), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3601), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40801] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1641), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3599), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3597), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40854] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1642), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3595), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3593), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40907] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1643), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3635), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3633), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40960] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1644), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4139), 3,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_SQUOTE,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41045] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1645), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3579), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3577), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41098] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4141), 1,
      anon_sym_SEMI,
    ACTIONS(4143), 1,
      anon_sym_else,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1646), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41187] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1647), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3667), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3665), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41240] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4145), 1,
      anon_sym_SEMI,
    ACTIONS(4147), 1,
      anon_sym_else,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1648), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41329] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1649), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3571), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3569), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41382] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(328), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1650), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41471] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1188), 1,
      anon_sym_RPAREN,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4149), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1651), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41560] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1073), 1,
      anon_sym_RPAREN,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4149), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1652), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41649] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4151), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1653), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41736] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4153), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1654), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41823] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1655), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3553), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3551), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41876] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(4155), 1,
      anon_sym_RBRACE,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1656), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41965] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1190), 1,
      anon_sym_RPAREN,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4149), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1657), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42054] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4149), 1,
      anon_sym_COMMA,
    ACTIONS(4157), 1,
      anon_sym_RPAREN,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1658), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42143] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4159), 1,
      anon_sym_SEMI,
    ACTIONS(4161), 1,
      anon_sym_else,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1659), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1660), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3639), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3637), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42285] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(280), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1661), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42374] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1662), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [42441] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(4167), 1,
      anon_sym_RBRACE,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1663), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42530] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4149), 1,
      anon_sym_COMMA,
    ACTIONS(4169), 1,
      anon_sym_RPAREN,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1664), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42619] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1665), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3711), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3709), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42672] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1666), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3279), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42725] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1667), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3747), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3745), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42778] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4171), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1668), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42865] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1669), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3671), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3669), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42918] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1670), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3751), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3749), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42971] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1671), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1360), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1358), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43024] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3617), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4193), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1672), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4183), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43111] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1673), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3647), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3645), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43164] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1674), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43217] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(286), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1675), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43306] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(318), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1676), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43395] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1677), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1396), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43448] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1678), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1368), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1366), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43501] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3617), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1679), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43588] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1680), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1432), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1430), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43641] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1681), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3699), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3697), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43694] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3661), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1682), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43781] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1683), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3695), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3693), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43834] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1684), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3651), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3649), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43887] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1685), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3687), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3685), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43940] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1686), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3575), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3573), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43993] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1687), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [44064] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1688), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3655), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3653), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44117] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1689), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3583), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3581), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44170] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1690), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3587), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3585), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44223] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1691), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3591), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3589), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44276] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1692), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [44345] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_EQ,
    ACTIONS(4219), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3617), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4221), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1693), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4211), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44432] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4223), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1694), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44519] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1695), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44572] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4225), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1696), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44659] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1697), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3607), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3605), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44712] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1698), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3611), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3609), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44765] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1699), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3426), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3422), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44818] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1700), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3615), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3613), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44871] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4227), 1,
      anon_sym_SEMI,
    ACTIONS(4229), 1,
      anon_sym_else,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1701), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44960] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1702), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3775), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3773), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45013] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_SEMI,
    ACTIONS(4233), 1,
      anon_sym_else,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1703), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45102] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(4235), 1,
      anon_sym_RBRACE,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1704), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45191] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1705), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45244] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1706), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3883), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45297] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(290), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1707), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45386] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    STATE(1708), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3871), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3869), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45445] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(278), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1709), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45534] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    STATE(1710), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3867), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3865), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45593] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_EQ,
    ACTIONS(4219), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3689), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4221), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1711), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4211), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45680] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1712), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3623), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3621), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45733] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3961), 1,
      anon_sym_EQ,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4193), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1713), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3959), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45818] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3957), 1,
      anon_sym_EQ,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4193), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1714), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3955), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45903] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1715), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [45976] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3965), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1716), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3963), 14,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [46057] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_SEMI,
    ACTIONS(4239), 1,
      anon_sym_else,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1717), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46146] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1718), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3849), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3847), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46199] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1719), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46252] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4241), 1,
      anon_sym_SEMI,
    ACTIONS(4243), 1,
      anon_sym_else,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1720), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46341] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1721), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3739), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3737), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46394] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(302), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1722), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46483] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1723), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3619), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3617), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46536] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(4245), 1,
      anon_sym_RBRACE,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1724), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46625] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_EQ,
    ACTIONS(4247), 1,
      anon_sym_LBRACE,
    ACTIONS(4249), 1,
      anon_sym_DOT_DOT,
    STATE(1457), 1,
      sym_match_block,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4251), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1725), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4211), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46714] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1726), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3759), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3757), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46767] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4253), 1,
      anon_sym_RBRACE,
    ACTIONS(4255), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1727), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46856] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(304), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1728), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46945] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1729), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(390), 14,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [47026] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1730), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3879), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3877), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47079] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1731), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3875), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3873), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47132] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1732), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3841), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3839), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47185] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1733), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(981), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(983), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47238] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4193), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1734), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47323] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(298), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1735), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47412] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1736), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4257), 3,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_SQUOTE,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47497] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1737), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3781), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3779), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47550] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1738), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1001), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1003), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47603] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1739), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1546), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1548), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47656] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1740), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(390), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [47737] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1741), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3739), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3737), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47790] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4193), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1742), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3927), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47875] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1743), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1364), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1362), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47928] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(306), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1744), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48017] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3933), 1,
      anon_sym_EQ,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4193), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1745), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3931), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48102] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(4259), 1,
      anon_sym_RBRACE,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1746), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48191] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1747), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3213), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3215), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48244] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1748), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3727), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3725), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48297] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(3789), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1749), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3787), 16,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [48374] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4219), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4221), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1750), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48459] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1751), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3659), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3657), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48512] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1752), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3707), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3705), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48565] = 18,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      sym_identifier,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4265), 1,
      anon_sym_RBRACE,
    ACTIONS(4267), 1,
      anon_sym_STAR,
    ACTIONS(4271), 1,
      anon_sym_COMMA,
    ACTIONS(4273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4277), 1,
      sym_metavariable,
    STATE(2449), 1,
      sym_scoped_identifier,
    STATE(2765), 1,
      sym__use_clause,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1753), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4275), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2811), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4269), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [48644] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1754), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1254), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1252), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48697] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1755), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3703), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3701), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48750] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1756), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1372), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1370), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48803] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(117), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1757), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48892] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_EQ,
    ACTIONS(4249), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_LBRACE,
    STATE(386), 1,
      sym_match_block,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4251), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1758), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4211), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48981] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1759), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1420), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1418), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49034] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_EQ,
    ACTIONS(4249), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4281), 1,
      anon_sym_LBRACE,
    STATE(463), 1,
      sym_match_block,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4251), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1760), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4211), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49123] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1761), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3857), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3855), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49176] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4283), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(1762), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49263] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3789), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1763), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3787), 15,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [49342] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1764), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3761), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49395] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4219), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4221), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1765), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3927), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49480] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1766), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3767), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3765), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49533] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1767), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3691), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3689), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49586] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(324), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1768), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49675] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1769), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49728] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3933), 1,
      anon_sym_EQ,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4219), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4221), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1770), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3931), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49813] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1771), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3643), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3641), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49866] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1772), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1400), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1398), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49919] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1773), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3735), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49972] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1774), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3723), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3721), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50025] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1775), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1376), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1374), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50078] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1776), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1436), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1434), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50131] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    STATE(1777), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3563), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3559), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50190] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(320), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1778), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50279] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1779), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1780), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50385] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4287), 1,
      anon_sym_RBRACE,
    ACTIONS(4289), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1781), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50474] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1782), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1416), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1414), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50527] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4291), 1,
      anon_sym_SEMI,
    ACTIONS(4293), 1,
      anon_sym_else,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1783), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50616] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3937), 1,
      anon_sym_EQ,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4193), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1784), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3935), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50701] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1785), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(937), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(939), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50754] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3661), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4193), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1786), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4183), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50841] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3937), 1,
      anon_sym_EQ,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4219), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4221), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1787), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3935), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50926] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4295), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1788), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51013] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1789), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1428), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1426), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51066] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(326), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1790), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51155] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(4297), 1,
      anon_sym_RBRACE,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1791), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51244] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(292), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1792), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51333] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1793), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1452), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1450), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51386] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1794), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1440), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1438), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51439] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3965), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1795), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3963), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [51520] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1796), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3853), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3851), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51573] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1797), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [51646] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1798), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1448), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1446), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51699] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4299), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1799), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51786] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1800), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1444), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1442), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51839] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1801), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(903), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(905), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51892] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1037), 1,
      anon_sym_RPAREN,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4149), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1802), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51981] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(330), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1803), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52070] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4301), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1804), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52157] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1805), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(885), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(887), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52210] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1806), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1258), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1256), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52263] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1807), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(945), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(947), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52316] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3689), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1808), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52403] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4303), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1809), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52490] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3689), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4193), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1810), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4183), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52577] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1811), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [52642] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1812), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(933), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(935), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52695] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1813), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3863), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3861), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52748] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1814), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1250), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1248), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52801] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3961), 1,
      anon_sym_EQ,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4219), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4221), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1815), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3959), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52886] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3957), 1,
      anon_sym_EQ,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4219), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4221), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1816), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3955), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52971] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1817), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3845), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3843), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53024] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1818), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [53089] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(296), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1819), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53178] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1820), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3817), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53231] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_EQ,
    ACTIONS(4219), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3661), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4221), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1821), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4211), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53318] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1822), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3815), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3813), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53371] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1823), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3811), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3809), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53424] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(314), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1824), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53513] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4305), 1,
      anon_sym_RPAREN,
    ACTIONS(4307), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1825), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53602] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    STATE(1826), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3789), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [53663] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1827), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3771), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3769), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53716] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1828), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3783), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53769] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(312), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1829), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53858] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4309), 1,
      anon_sym_RPAREN,
    ACTIONS(4311), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1830), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53947] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1831), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3663), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3661), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54000] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3789), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1832), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3787), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [54079] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1833), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1408), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54132] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4207), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_EQ,
    ACTIONS(4249), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4313), 1,
      anon_sym_LBRACE,
    STATE(1772), 1,
      sym_match_block,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4251), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1834), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4211), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54221] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    ACTIONS(3789), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4217), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1835), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3787), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [54298] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(332), 1,
      anon_sym_RBRACE,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1836), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54387] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1837), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [54458] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1838), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [54525] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(4201), 1,
      anon_sym_AMP,
    ACTIONS(4195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4209), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1839), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [54594] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    STATE(1840), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4197), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [54657] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1841), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3731), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3729), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54710] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4315), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1842), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54796] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4317), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1843), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54882] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4319), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1844), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54968] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4321), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1845), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55054] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4323), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1846), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55140] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4325), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1847), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55226] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4327), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1848), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55312] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4329), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1849), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55398] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4331), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1850), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55484] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4333), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1851), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55570] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      sym_identifier,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4267), 1,
      anon_sym_STAR,
    ACTIONS(4273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4277), 1,
      sym_metavariable,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    STATE(2449), 1,
      sym_scoped_identifier,
    STATE(3268), 1,
      sym__use_clause,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1852), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4275), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2811), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4269), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [55646] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4337), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1853), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55732] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4339), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1854), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55818] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4341), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1855), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55904] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4343), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1856), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55990] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4345), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1857), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56076] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1858), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56162] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4347), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1859), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56248] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4349), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1860), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56334] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4351), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4139), 2,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4353), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1861), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4183), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56418] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4355), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1862), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56504] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4357), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1863), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56590] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4359), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1864), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56676] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4361), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1865), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56762] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4363), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1866), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56848] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4351), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4257), 2,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
    ACTIONS(4353), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1867), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4183), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56932] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4149), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1868), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57018] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4365), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1869), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57104] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1870), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57190] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4129), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_QMARK,
    ACTIONS(4135), 1,
      anon_sym_DOT,
    ACTIONS(4137), 1,
      anon_sym_as,
    ACTIONS(4173), 1,
      anon_sym_CARET,
    ACTIONS(4175), 1,
      anon_sym_AMP,
    ACTIONS(4177), 1,
      anon_sym_PIPE,
    ACTIONS(4181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4283), 1,
      anon_sym_EQ_GT,
    ACTIONS(4351), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4165), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4353), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1871), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4131), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4187), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4183), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57276] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4371), 1,
      anon_sym_RBRACK,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1872), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57362] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4373), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1873), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57448] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      sym_identifier,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4267), 1,
      anon_sym_STAR,
    ACTIONS(4273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4277), 1,
      sym_metavariable,
    ACTIONS(4375), 1,
      anon_sym_RBRACE,
    STATE(2449), 1,
      sym_scoped_identifier,
    STATE(3268), 1,
      sym__use_clause,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1874), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4275), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2811), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4269), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57524] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3561), 1,
      anon_sym_LBRACK,
    ACTIONS(3565), 1,
      anon_sym_QMARK,
    ACTIONS(3567), 1,
      anon_sym_DOT,
    ACTIONS(3791), 1,
      anon_sym_as,
    ACTIONS(3899), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      anon_sym_AMP,
    ACTIONS(3903), 1,
      anon_sym_PIPE,
    ACTIONS(3905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4377), 1,
      anon_sym_SEMI,
    ACTIONS(3895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1875), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3897), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3911), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57610] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      sym_identifier,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4267), 1,
      anon_sym_STAR,
    ACTIONS(4273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4277), 1,
      sym_metavariable,
    STATE(2449), 1,
      sym_scoped_identifier,
    STATE(3330), 1,
      sym__use_clause,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1876), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4275), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2811), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4269), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57683] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      sym_identifier,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4267), 1,
      anon_sym_STAR,
    ACTIONS(4273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4277), 1,
      sym_metavariable,
    STATE(2449), 1,
      sym_scoped_identifier,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3434), 1,
      sym__use_clause,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1877), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4275), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2811), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4269), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57756] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      sym_identifier,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4267), 1,
      anon_sym_STAR,
    ACTIONS(4273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4277), 1,
      sym_metavariable,
    STATE(2449), 1,
      sym_scoped_identifier,
    STATE(3422), 1,
      sym__use_clause,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1878), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4275), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2811), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4269), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57829] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      sym_identifier,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4267), 1,
      anon_sym_STAR,
    ACTIONS(4273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4277), 1,
      sym_metavariable,
    STATE(2449), 1,
      sym_scoped_identifier,
    STATE(3382), 1,
      sym__use_clause,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1879), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4275), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2811), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4269), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57902] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      sym_identifier,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4267), 1,
      anon_sym_STAR,
    ACTIONS(4273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4277), 1,
      sym_metavariable,
    STATE(2449), 1,
      sym_scoped_identifier,
    STATE(3268), 1,
      sym__use_clause,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1880), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4275), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2811), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4269), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57975] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3711), 1,
      anon_sym_where,
    ACTIONS(4379), 1,
      sym_identifier,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    STATE(2776), 1,
      sym_scoped_type_identifier,
    STATE(3262), 1,
      sym_generic_type,
    STATE(3371), 1,
      sym_scoped_identifier,
    STATE(3482), 1,
      sym_generic_type_with_turbofish,
    STATE(3509), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1881), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58049] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3711), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4391), 1,
      sym_identifier,
    STATE(2863), 1,
      sym_scoped_type_identifier,
    STATE(3084), 1,
      sym_generic_type,
    STATE(3371), 1,
      sym_scoped_identifier,
    STATE(3482), 1,
      sym_generic_type_with_turbofish,
    STATE(3509), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1882), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58123] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3711), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4393), 1,
      sym_identifier,
    STATE(2998), 1,
      sym_scoped_type_identifier,
    STATE(3077), 1,
      sym_generic_type,
    STATE(3371), 1,
      sym_scoped_identifier,
    STATE(3482), 1,
      sym_generic_type_with_turbofish,
    STATE(3509), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1883), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58197] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3711), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4395), 1,
      sym_identifier,
    STATE(2906), 1,
      sym_scoped_type_identifier,
    STATE(3080), 1,
      sym_generic_type,
    STATE(3371), 1,
      sym_scoped_identifier,
    STATE(3482), 1,
      sym_generic_type_with_turbofish,
    STATE(3509), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1884), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58271] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3711), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4397), 1,
      sym_identifier,
    STATE(2946), 1,
      sym_scoped_type_identifier,
    STATE(3074), 1,
      sym_generic_type,
    STATE(3371), 1,
      sym_scoped_identifier,
    STATE(3482), 1,
      sym_generic_type_with_turbofish,
    STATE(3509), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1885), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58345] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3711), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4399), 1,
      sym_identifier,
    STATE(2732), 1,
      sym_scoped_type_identifier,
    STATE(3034), 1,
      sym_generic_type,
    STATE(3371), 1,
      sym_scoped_identifier,
    STATE(3482), 1,
      sym_generic_type_with_turbofish,
    STATE(3509), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1886), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58419] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3711), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4401), 1,
      sym_identifier,
    STATE(3030), 1,
      sym_scoped_type_identifier,
    STATE(3060), 1,
      sym_generic_type,
    STATE(3371), 1,
      sym_scoped_identifier,
    STATE(3482), 1,
      sym_generic_type_with_turbofish,
    STATE(3509), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1887), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58493] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3711), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4403), 1,
      sym_identifier,
    STATE(2982), 1,
      sym_scoped_type_identifier,
    STATE(3063), 1,
      sym_generic_type,
    STATE(3371), 1,
      sym_scoped_identifier,
    STATE(3482), 1,
      sym_generic_type_with_turbofish,
    STATE(3509), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1888), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58567] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1889), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4407), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(4405), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58613] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1890), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4411), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(4409), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58659] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1891), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4415), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(4413), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58705] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2250), 1,
      sym_scoped_identifier,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    STATE(3384), 1,
      sym_attribute,
    STATE(1892), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58766] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2250), 1,
      sym_scoped_identifier,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    STATE(3513), 1,
      sym_attribute,
    STATE(1893), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58827] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2250), 1,
      sym_scoped_identifier,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    STATE(3481), 1,
      sym_attribute,
    STATE(1894), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58888] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2250), 1,
      sym_scoped_identifier,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    STATE(3429), 1,
      sym_attribute,
    STATE(1895), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58949] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2250), 1,
      sym_scoped_identifier,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3346), 1,
      sym_attribute,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    STATE(1896), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59010] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2250), 1,
      sym_scoped_identifier,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_attribute,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    STATE(1897), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59071] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2250), 1,
      sym_scoped_identifier,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    STATE(3386), 1,
      sym_attribute,
    STATE(1898), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59132] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2250), 1,
      sym_scoped_identifier,
    STATE(3312), 1,
      sym_bracketed_type,
    STATE(3351), 1,
      sym_generic_type_with_turbofish,
    STATE(3505), 1,
      sym_attribute,
    STATE(1899), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59193] = 12,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4425), 1,
      sym_identifier,
    ACTIONS(4429), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      sym_metavariable,
    STATE(3036), 1,
      sym_scoped_identifier,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1900), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4431), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4427), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59251] = 12,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4435), 1,
      sym_identifier,
    ACTIONS(4441), 1,
      sym_metavariable,
    STATE(3201), 1,
      sym_scoped_identifier,
    STATE(3432), 1,
      sym_generic_type_with_turbofish,
    STATE(3562), 1,
      sym_bracketed_type,
    STATE(1901), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4439), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4437), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59309] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(945), 1,
      anon_sym_DOT_DOT,
    STATE(1902), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(947), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_in,
  [59345] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(1903), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59393] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(937), 1,
      anon_sym_DOT_DOT,
    STATE(1904), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(939), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_in,
  [59429] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3305), 1,
      anon_sym_COLON,
    ACTIONS(3309), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1905), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59466] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4455), 1,
      anon_sym_LBRACE,
    ACTIONS(4457), 1,
      anon_sym_COLON,
    ACTIONS(4459), 1,
      anon_sym_AT,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4465), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1906), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [59519] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3273), 1,
      anon_sym_COLON,
    ACTIONS(3277), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1907), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59556] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3265), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4467), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(1908), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3263), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59601] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3297), 1,
      anon_sym_COLON,
    ACTIONS(3301), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1909), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59638] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3261), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4467), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(1910), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3259), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59683] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4467), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(1911), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3253), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59728] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3285), 1,
      anon_sym_COLON,
    ACTIONS(3289), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1912), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59765] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(1913), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59805] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1914), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3309), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59841] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(1915), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59881] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(1916), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59921] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1917), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3289), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59957] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(1918), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59997] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3275), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1919), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3277), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60033] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1920), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3301), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60069] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3484), 1,
      anon_sym_COLON,
    STATE(1921), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3482), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60102] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1922), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60135] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3416), 1,
      anon_sym_COLON,
    STATE(1923), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3414), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60168] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1924), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 18,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [60199] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3275), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1925), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3277), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3420), 1,
      anon_sym_COLON,
    STATE(1926), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3418), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60265] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3450), 1,
      anon_sym_COLON,
    STATE(1927), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3448), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60298] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1928), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3309), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60331] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1929), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3301), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60364] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4479), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1930), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [60408] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    STATE(1931), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3456), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60440] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4483), 1,
      anon_sym_const,
    ACTIONS(4485), 1,
      anon_sym_enum,
    ACTIONS(4487), 1,
      anon_sym_fn,
    ACTIONS(4489), 1,
      anon_sym_mod,
    ACTIONS(4491), 1,
      anon_sym_static,
    ACTIONS(4493), 1,
      anon_sym_struct,
    ACTIONS(4495), 1,
      anon_sym_trait,
    ACTIONS(4497), 1,
      anon_sym_type,
    ACTIONS(4499), 1,
      anon_sym_union,
    ACTIONS(4501), 1,
      anon_sym_unsafe,
    ACTIONS(4503), 1,
      anon_sym_use,
    ACTIONS(4505), 1,
      anon_sym_extern,
    STATE(2174), 1,
      sym_extern_modifier,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(3409), 1,
      sym_function_modifiers,
    ACTIONS(4481), 2,
      anon_sym_async,
      anon_sym_default,
    STATE(1932), 2,
      sym_line_comment,
      sym_block_comment,
  [60500] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4507), 1,
      anon_sym_const,
    ACTIONS(4509), 1,
      anon_sym_enum,
    ACTIONS(4511), 1,
      anon_sym_fn,
    ACTIONS(4513), 1,
      anon_sym_mod,
    ACTIONS(4515), 1,
      anon_sym_static,
    ACTIONS(4517), 1,
      anon_sym_struct,
    ACTIONS(4519), 1,
      anon_sym_trait,
    ACTIONS(4521), 1,
      anon_sym_type,
    ACTIONS(4523), 1,
      anon_sym_union,
    ACTIONS(4525), 1,
      anon_sym_unsafe,
    ACTIONS(4527), 1,
      anon_sym_use,
    ACTIONS(4529), 1,
      anon_sym_extern,
    STATE(2171), 1,
      sym_extern_modifier,
    STATE(2220), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(3608), 1,
      sym_function_modifiers,
    ACTIONS(4481), 2,
      anon_sym_async,
      anon_sym_default,
    STATE(1933), 2,
      sym_line_comment,
      sym_block_comment,
  [60560] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1934), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [60606] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3464), 1,
      anon_sym_COLON,
    STATE(1935), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3462), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60638] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3480), 1,
      anon_sym_COLON,
    STATE(1936), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3478), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60670] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3293), 1,
      anon_sym_COLON,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    STATE(1937), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60703] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1938), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(983), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [60732] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4535), 1,
      anon_sym_DASH_GT,
    STATE(1939), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3436), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60763] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3313), 1,
      anon_sym_COLON,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    STATE(1940), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60796] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1941), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3525), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60825] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4537), 1,
      anon_sym_DASH_GT,
    STATE(1942), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3372), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60856] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4539), 1,
      anon_sym_DASH_GT,
    STATE(1943), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3386), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60887] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1944), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60916] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4455), 1,
      anon_sym_LBRACE,
    ACTIONS(4459), 1,
      anon_sym_AT,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4541), 1,
      anon_sym_LPAREN,
    ACTIONS(4543), 1,
      anon_sym_RBRACK,
    ACTIONS(4546), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    ACTIONS(3241), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4451), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1945), 2,
      sym_line_comment,
      sym_block_comment,
  [60969] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4548), 1,
      anon_sym_LPAREN,
    STATE(1946), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3979), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61000] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4550), 1,
      anon_sym_DASH_GT,
    STATE(1947), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3378), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61031] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3269), 1,
      anon_sym_COLON,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    STATE(1948), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61064] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3281), 1,
      anon_sym_COLON,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    STATE(1949), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61097] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1950), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3491), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61126] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3293), 1,
      anon_sym_COLON,
    ACTIONS(4552), 1,
      anon_sym_COLON_COLON,
    STATE(1951), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61159] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3293), 1,
      anon_sym_COLON,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    STATE(1952), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61192] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4451), 1,
      anon_sym_PIPE,
    ACTIONS(4455), 1,
      anon_sym_LBRACE,
    ACTIONS(4457), 1,
      anon_sym_COLON,
    ACTIONS(4459), 1,
      anon_sym_AT,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4556), 1,
      anon_sym_LPAREN,
    ACTIONS(4558), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1953), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [61245] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4457), 1,
      anon_sym_COLON,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1954), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [61286] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1955), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3466), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61315] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    STATE(1956), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3537), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61346] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1957), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61375] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4564), 1,
      anon_sym_DASH_GT,
    STATE(1958), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3495), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61406] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1959), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1248), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [61435] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1960), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1003), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [61464] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1961), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [61507] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3241), 1,
      anon_sym_PLUS,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4451), 1,
      anon_sym_PIPE,
    ACTIONS(4455), 1,
      anon_sym_LBRACE,
    ACTIONS(4457), 1,
      anon_sym_COLON,
    ACTIONS(4459), 1,
      anon_sym_AT,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4568), 1,
      anon_sym_LPAREN,
    ACTIONS(4570), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4543), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1962), 2,
      sym_line_comment,
      sym_block_comment,
  [61562] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4572), 1,
      anon_sym_DASH_GT,
    STATE(1963), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3503), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61593] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1964), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1414), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [61622] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1965), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3999), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61650] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1966), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3573), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61678] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1967), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3737), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61706] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1968), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3745), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61734] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1969), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3761), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61762] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1970), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3749), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61790] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1971), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3633), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61818] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1972), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3986), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61846] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1973), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3653), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61874] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1974), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3649), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61902] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3885), 1,
      anon_sym_COLON_COLON,
    STATE(1975), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3984), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [61932] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1976), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61960] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1977), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3685), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61988] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1978), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3995), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [62016] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1979), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3669), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62044] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1980), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3839), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62072] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1981), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    STATE(1982), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3984), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [62130] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1983), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3645), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62158] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1984), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3847), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62186] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4576), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1985), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [62230] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1986), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62258] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1987), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62286] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1988), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3693), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62314] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1989), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3697), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62342] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1990), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3765), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62370] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1991), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62398] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1992), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3851), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62426] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1993), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3737), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62454] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1994), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3637), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62482] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1995), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3753), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62510] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1996), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3757), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62538] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4578), 1,
      anon_sym_COLON,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4582), 1,
      anon_sym_GT,
    ACTIONS(4584), 1,
      anon_sym_COMMA,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2990), 1,
      sym_trait_bounds,
    STATE(2996), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3241), 2,
      anon_sym_PLUS,
      anon_sym_as,
    STATE(1997), 2,
      sym_line_comment,
      sym_block_comment,
  [62589] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(933), 1,
      anon_sym_DOT_DOT,
    STATE(1998), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(935), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62618] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(885), 1,
      anon_sym_DOT_DOT,
    STATE(1999), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(887), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62647] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4588), 1,
      anon_sym_pat,
    STATE(138), 1,
      sym_fragment_specifier,
    STATE(2000), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4586), 12,
      anon_sym_block,
      anon_sym_expr,
      anon_sym_ident,
      anon_sym_item,
      anon_sym_lifetime,
      anon_sym_literal,
      anon_sym_meta,
      anon_sym_path,
      anon_sym_stmt,
      anon_sym_tt,
      anon_sym_ty,
      anon_sym_vis,
  [62678] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2001), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62713] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4590), 1,
      anon_sym_LPAREN,
    ACTIONS(4592), 1,
      anon_sym_LBRACE,
    ACTIONS(4594), 1,
      anon_sym_BANG,
    ACTIONS(4596), 1,
      anon_sym_AT,
    ACTIONS(4598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4602), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    ACTIONS(4600), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2002), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [62757] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4604), 1,
      anon_sym_LPAREN,
    ACTIONS(3275), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2003), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3277), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62789] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4607), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3289), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [62821] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4610), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3309), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [62853] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62883] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4610), 1,
      anon_sym_LPAREN,
    ACTIONS(3307), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3309), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62915] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4615), 1,
      anon_sym_DOT_DOT,
    STATE(2008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4613), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62943] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4619), 1,
      anon_sym_DOT_DOT,
    STATE(2009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4617), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62971] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4621), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3301), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [63003] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4607), 1,
      anon_sym_LPAREN,
    ACTIONS(3287), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3289), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [63035] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3275), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4604), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3277), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [63067] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2013), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4610), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3309), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [63099] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3275), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4604), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2014), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3277), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [63131] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4621), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3301), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [63163] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4607), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3289), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [63195] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4621), 1,
      anon_sym_LPAREN,
    ACTIONS(3299), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2017), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3301), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [63227] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4626), 1,
      anon_sym_GT,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2018), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63272] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4632), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2019), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63317] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4634), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2020), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63362] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4636), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2021), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63407] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4638), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2022), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63452] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4640), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2023), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63497] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4642), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2024), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63542] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4644), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2025), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63587] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4646), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2026), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63632] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4648), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2027), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63677] = 10,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4495), 1,
      anon_sym_trait,
    ACTIONS(4650), 1,
      anon_sym_impl,
    STATE(380), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [63714] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4652), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2029), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63759] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4654), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2585), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2030), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63804] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4656), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2031), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63849] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4658), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2032), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63894] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4660), 1,
      anon_sym_GT,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2033), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63939] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4662), 1,
      sym_identifier,
    ACTIONS(4664), 1,
      sym_metavariable,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2395), 1,
      sym_lifetime,
    STATE(2635), 1,
      sym_constrained_type_parameter,
    STATE(2034), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2820), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63981] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2035), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1244), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64005] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4666), 1,
      anon_sym_EQ,
    STATE(1947), 1,
      sym_parameters,
    STATE(2306), 1,
      sym_type_arguments,
    STATE(2036), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 3,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
  [64045] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4670), 1,
      anon_sym_COLON,
    ACTIONS(4672), 1,
      anon_sym_COLON_COLON,
    STATE(2037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4668), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64073] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4674), 1,
      sym_identifier,
    ACTIONS(4676), 1,
      anon_sym_RBRACE,
    ACTIONS(4678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4680), 1,
      anon_sym_COMMA,
    ACTIONS(4682), 1,
      sym_integer_literal,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2393), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2038), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2743), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [64113] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2062), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2592), 1,
      sym_lifetime,
    STATE(2771), 1,
      sym_constrained_type_parameter,
    STATE(2039), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3182), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64155] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4670), 1,
      anon_sym_COLON,
    STATE(2040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4668), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64183] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4670), 1,
      anon_sym_COLON,
    ACTIONS(4684), 1,
      anon_sym_COLON_COLON,
    STATE(2041), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4668), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64211] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2042), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1232), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64235] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4686), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64273] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4688), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64311] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4690), 1,
      sym_identifier,
    ACTIONS(4692), 1,
      sym_metavariable,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2052), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2451), 1,
      sym_lifetime,
    STATE(2728), 1,
      sym_constrained_type_parameter,
    STATE(2045), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2733), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64353] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4696), 1,
      anon_sym_COLON,
    STATE(2046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4694), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64381] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1320), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4700), 1,
      sym_crate,
    STATE(2191), 1,
      sym_string_literal,
    STATE(2047), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4698), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64411] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3275), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3277), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [64439] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1320), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4702), 1,
      sym_crate,
    STATE(2191), 1,
      sym_string_literal,
    STATE(2049), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4698), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64469] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4704), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2050), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64507] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4706), 1,
      sym_identifier,
    ACTIONS(4708), 1,
      sym_metavariable,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2034), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2407), 1,
      sym_lifetime,
    STATE(2720), 1,
      sym_constrained_type_parameter,
    STATE(2051), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2742), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64549] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4710), 1,
      sym_identifier,
    ACTIONS(4712), 1,
      sym_metavariable,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2462), 1,
      sym_lifetime,
    STATE(2509), 1,
      sym_constrained_type_parameter,
    STATE(2052), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3002), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64591] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4674), 1,
      sym_identifier,
    ACTIONS(4678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4682), 1,
      sym_integer_literal,
    ACTIONS(4714), 1,
      anon_sym_RBRACE,
    ACTIONS(4716), 1,
      anon_sym_COMMA,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2393), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2053), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2779), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [64631] = 9,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4718), 1,
      anon_sym_move,
    STATE(377), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64665] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4720), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64703] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4722), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2056), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64741] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4684), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4696), 1,
      anon_sym_COLON,
    STATE(2057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4694), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64769] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4696), 1,
      anon_sym_COLON,
    STATE(2058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4694), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64797] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4724), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64835] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2060), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1240), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64859] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4728), 1,
      anon_sym_COLON,
    ACTIONS(4730), 1,
      anon_sym_COLON_COLON,
    STATE(2061), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4726), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64887] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4732), 1,
      sym_identifier,
    ACTIONS(4734), 1,
      sym_metavariable,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2657), 1,
      sym_lifetime,
    STATE(2801), 1,
      sym_constrained_type_parameter,
    STATE(2062), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3200), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64929] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1320), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4736), 1,
      sym_crate,
    STATE(2191), 1,
      sym_string_literal,
    STATE(2063), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4698), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64959] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2064), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3301), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [64987] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4738), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2065), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [65025] = 9,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4740), 1,
      sym_identifier,
    STATE(373), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2066), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4742), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65059] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4744), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2067), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [65097] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2068), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3309), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [65125] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1320), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4746), 1,
      sym_crate,
    STATE(2191), 1,
      sym_string_literal,
    STATE(2069), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4698), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65155] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4690), 1,
      sym_identifier,
    ACTIONS(4692), 1,
      sym_metavariable,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2052), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2370), 1,
      sym_lifetime,
    STATE(2728), 1,
      sym_constrained_type_parameter,
    STATE(2070), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2733), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [65197] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2071), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1236), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65221] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2072), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [65259] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2073), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1206), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65283] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4730), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4750), 1,
      anon_sym_COLON,
    STATE(2074), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4748), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65311] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2075), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [65339] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2076), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4752), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65362] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2077), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4754), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65385] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2078), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [65420] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2079), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65443] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2080), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4756), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65466] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4552), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    STATE(2081), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65497] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4457), 1,
      anon_sym_COLON,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4758), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2082), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [65532] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2083), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4760), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65555] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2084), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4762), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65578] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2085), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4764), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65601] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2086), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4766), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65624] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2087), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4768), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65647] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4772), 1,
      anon_sym_RBRACE,
    ACTIONS(4774), 1,
      anon_sym_COMMA,
    ACTIONS(4776), 1,
      sym_crate,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2223), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2945), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2088), 2,
      sym_line_comment,
      sym_block_comment,
  [65688] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2089), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4778), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65711] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    ACTIONS(4782), 1,
      anon_sym_RBRACE,
    ACTIONS(4784), 1,
      anon_sym_COMMA,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2181), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3015), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2090), 2,
      sym_line_comment,
      sym_block_comment,
  [65752] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4786), 1,
      anon_sym_BANG,
    ACTIONS(4788), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    ACTIONS(4790), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2091), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [65787] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2092), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4794), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65810] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2093), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4668), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65833] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2094), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4796), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65856] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2095), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4798), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65879] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2096), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4800), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65902] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2097), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4802), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65925] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2098), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4694), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65948] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2099), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4804), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65971] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2100), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4806), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65994] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2101), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4808), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66017] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2102), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4810), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66040] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1564), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym_block,
    STATE(3590), 1,
      sym_label,
    STATE(2103), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66071] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4812), 1,
      anon_sym_LBRACE,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2104), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 5,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [66104] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    ACTIONS(4095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4814), 1,
      anon_sym_BANG,
    STATE(1598), 1,
      sym_type_arguments,
    STATE(2105), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66135] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2106), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1256), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66158] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4674), 1,
      sym_identifier,
    ACTIONS(4678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4682), 1,
      sym_integer_literal,
    ACTIONS(4816), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2393), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2107), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3272), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66195] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4674), 1,
      sym_identifier,
    ACTIONS(4678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4682), 1,
      sym_integer_literal,
    ACTIONS(4818), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2393), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2108), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3272), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66232] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2109), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4820), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66255] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2110), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4822), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66278] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2111), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4824), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66301] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2112), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4826), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66324] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2113), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4828), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66347] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2114), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4830), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66370] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4674), 1,
      sym_identifier,
    ACTIONS(4678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4682), 1,
      sym_integer_literal,
    ACTIONS(4832), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2393), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2115), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3272), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66407] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4674), 1,
      sym_identifier,
    ACTIONS(4678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4682), 1,
      sym_integer_literal,
    ACTIONS(4834), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2393), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2116), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3272), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66444] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2117), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4836), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66467] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2118), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4838), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66490] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2119), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4840), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66513] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2120), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4842), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66536] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4844), 1,
      anon_sym_BANG,
    STATE(1075), 1,
      sym_type_arguments,
    STATE(2121), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66567] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2122), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4846), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66590] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4848), 1,
      anon_sym_RBRACE,
    ACTIONS(4850), 1,
      anon_sym_COMMA,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2185), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2807), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2123), 2,
      sym_line_comment,
      sym_block_comment,
  [66631] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    ACTIONS(4852), 1,
      anon_sym_RBRACE,
    ACTIONS(4854), 1,
      anon_sym_COMMA,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2187), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2837), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2124), 2,
      sym_line_comment,
      sym_block_comment,
  [66672] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2125), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4856), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66695] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2126), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4858), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66718] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2127), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4860), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66741] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4862), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2229), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3145), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2128), 2,
      sym_line_comment,
      sym_block_comment,
  [66779] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    ACTIONS(4864), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2179), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3167), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2129), 2,
      sym_line_comment,
      sym_block_comment,
  [66817] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    ACTIONS(4866), 1,
      anon_sym_COLON_COLON,
    STATE(1598), 1,
      sym_type_arguments,
    STATE(2130), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66845] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 1,
      anon_sym_DOT_DOT,
    STATE(2131), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3301), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [66869] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3275), 1,
      anon_sym_DOT_DOT,
    STATE(2132), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3277), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [66893] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4868), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2133), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [66925] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4870), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2229), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3145), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2134), 2,
      sym_line_comment,
      sym_block_comment,
  [66963] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2135), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [66995] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4872), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2136), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67027] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4874), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2137), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67059] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4876), 1,
      anon_sym_SEMI,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(712), 1,
      sym_declaration_list,
    STATE(2138), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67087] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    ACTIONS(4880), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2179), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3167), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2139), 2,
      sym_line_comment,
      sym_block_comment,
  [67125] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4882), 1,
      anon_sym_SEMI,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1392), 1,
      sym_declaration_list,
    STATE(2140), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67153] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4886), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2229), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3145), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2141), 2,
      sym_line_comment,
      sym_block_comment,
  [67191] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4888), 1,
      anon_sym_SEMI,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(660), 1,
      sym_field_declaration_list,
    STATE(2267), 1,
      sym_type_parameters,
    STATE(2965), 1,
      sym_ordered_field_declaration_list,
    STATE(3092), 1,
      sym_where_clause,
    STATE(2142), 2,
      sym_line_comment,
      sym_block_comment,
  [67229] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4898), 1,
      anon_sym_RBRACK,
    ACTIONS(3291), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4469), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2143), 2,
      sym_line_comment,
      sym_block_comment,
  [67261] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4674), 1,
      sym_identifier,
    ACTIONS(4678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4682), 1,
      sym_integer_literal,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2393), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2144), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3272), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [67295] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4901), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2145), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67327] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4903), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2146), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67359] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_DOT_DOT,
    STATE(2147), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [67383] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4905), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2148), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 3,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [67415] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4907), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2149), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67447] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4576), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2150), 2,
      sym_line_comment,
      sym_block_comment,
  [67483] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4911), 1,
      anon_sym_PLUS,
    STATE(2151), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_trait_bounds_repeat1,
    ACTIONS(4909), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67507] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4590), 1,
      anon_sym_LPAREN,
    ACTIONS(4594), 1,
      anon_sym_BANG,
    ACTIONS(4598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4914), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4600), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2152), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [67539] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4916), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2229), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3145), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2153), 2,
      sym_line_comment,
      sym_block_comment,
  [67577] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    ACTIONS(4918), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2179), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3167), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2154), 2,
      sym_line_comment,
      sym_block_comment,
  [67615] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    ACTIONS(4920), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2179), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3167), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2155), 2,
      sym_line_comment,
      sym_block_comment,
  [67653] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4924), 1,
      anon_sym_PLUS,
    STATE(2151), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2156), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4922), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67679] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4926), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    STATE(2157), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67707] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4928), 1,
      anon_sym_LPAREN,
    ACTIONS(4933), 1,
      anon_sym_LBRACK,
    ACTIONS(4936), 1,
      anon_sym_LBRACE,
    STATE(3331), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    ACTIONS(4931), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2158), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_macro_definition_repeat1,
  [67739] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4939), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2159), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67771] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4941), 1,
      anon_sym_SEMI,
    STATE(481), 1,
      sym_field_declaration_list,
    STATE(2245), 1,
      sym_type_parameters,
    STATE(2740), 1,
      sym_ordered_field_declaration_list,
    STATE(3305), 1,
      sym_where_clause,
    STATE(2160), 2,
      sym_line_comment,
      sym_block_comment,
  [67809] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4943), 1,
      anon_sym_SEMI,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1288), 1,
      sym_field_declaration_list,
    STATE(2242), 1,
      sym_type_parameters,
    STATE(2859), 1,
      sym_ordered_field_declaration_list,
    STATE(3180), 1,
      sym_where_clause,
    STATE(2161), 2,
      sym_line_comment,
      sym_block_comment,
  [67847] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2179), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3167), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2162), 2,
      sym_line_comment,
      sym_block_comment,
  [67885] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    ACTIONS(4949), 1,
      anon_sym_SEMI,
    STATE(1450), 1,
      sym_field_declaration_list,
    STATE(2269), 1,
      sym_type_parameters,
    STATE(2737), 1,
      sym_ordered_field_declaration_list,
    STATE(3311), 1,
      sym_where_clause,
    STATE(2163), 2,
      sym_line_comment,
      sym_block_comment,
  [67923] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    ACTIONS(4951), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2179), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3167), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2164), 2,
      sym_line_comment,
      sym_block_comment,
  [67961] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4953), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2165), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67993] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_DOT_DOT,
    STATE(2166), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3309), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [68017] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4957), 1,
      anon_sym_PLUS,
    STATE(2156), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2167), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4955), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68043] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4959), 1,
      anon_sym_PLUS,
    STATE(2156), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2168), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4955), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68069] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(4961), 1,
      anon_sym_COLON_COLON,
    STATE(1075), 1,
      sym_type_arguments,
    STATE(2169), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68097] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3291), 1,
      anon_sym_PLUS,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4898), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2170), 2,
      sym_line_comment,
      sym_block_comment,
  [68131] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4963), 1,
      anon_sym_SEMI,
    STATE(1432), 1,
      sym_declaration_list,
    STATE(2171), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68159] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4965), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2229), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3145), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2172), 2,
      sym_line_comment,
      sym_block_comment,
  [68197] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4967), 1,
      anon_sym_RBRACE,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2229), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3145), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2173), 2,
      sym_line_comment,
      sym_block_comment,
  [68235] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4969), 1,
      anon_sym_SEMI,
    STATE(541), 1,
      sym_declaration_list,
    STATE(2174), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68263] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4924), 1,
      anon_sym_PLUS,
    STATE(2156), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2175), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4955), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68289] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2176), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4909), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68310] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4971), 1,
      anon_sym_SEMI,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(4975), 1,
      anon_sym_EQ,
    ACTIONS(4977), 1,
      anon_sym_LT,
    STATE(2384), 1,
      sym_type_parameters,
    STATE(2758), 1,
      sym_trait_bounds,
    STATE(3338), 1,
      sym_where_clause,
    STATE(2177), 2,
      sym_line_comment,
      sym_block_comment,
  [68345] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4979), 1,
      anon_sym_SEMI,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    STATE(587), 1,
      sym_block,
    STATE(2490), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2178), 2,
      sym_line_comment,
      sym_block_comment,
  [68380] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(3082), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2179), 2,
      sym_line_comment,
      sym_block_comment,
  [68415] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4987), 1,
      anon_sym_RBRACE,
    ACTIONS(4989), 1,
      anon_sym_COMMA,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    STATE(2180), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2782), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [68448] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2796), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2181), 2,
      sym_line_comment,
      sym_block_comment,
  [68483] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(4995), 1,
      anon_sym_RBRACE,
    ACTIONS(4997), 1,
      anon_sym_COMMA,
    STATE(2182), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2786), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [68516] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2229), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3145), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2183), 2,
      sym_line_comment,
      sym_block_comment,
  [68551] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_fn,
    ACTIONS(5004), 1,
      anon_sym_extern,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(2184), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(4999), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [68578] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2908), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2185), 2,
      sym_line_comment,
      sym_block_comment,
  [68613] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5007), 1,
      anon_sym_SEMI,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    STATE(1181), 1,
      sym_block,
    STATE(2467), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2186), 2,
      sym_line_comment,
      sym_block_comment,
  [68648] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2930), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2187), 2,
      sym_line_comment,
      sym_block_comment,
  [68683] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5011), 1,
      anon_sym_SEMI,
    ACTIONS(5013), 1,
      anon_sym_DASH_GT,
    STATE(1143), 1,
      sym_block,
    STATE(2477), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2188), 2,
      sym_line_comment,
      sym_block_comment,
  [68718] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5015), 1,
      anon_sym_SEMI,
    STATE(1193), 1,
      sym_block,
    STATE(2478), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2189), 2,
      sym_line_comment,
      sym_block_comment,
  [68753] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5017), 1,
      anon_sym_SEMI,
    ACTIONS(5019), 1,
      anon_sym_DASH_GT,
    STATE(1356), 1,
      sym_block,
    STATE(2406), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2190), 2,
      sym_line_comment,
      sym_block_comment,
  [68788] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2191), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5021), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68809] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(4977), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_SEMI,
    ACTIONS(5025), 1,
      anon_sym_EQ,
    STATE(2350), 1,
      sym_type_parameters,
    STATE(2734), 1,
      sym_trait_bounds,
    STATE(3326), 1,
      sym_where_clause,
    STATE(2192), 2,
      sym_line_comment,
      sym_block_comment,
  [68844] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5027), 1,
      anon_sym_SEMI,
    STATE(1298), 1,
      sym_block,
    STATE(2390), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2193), 2,
      sym_line_comment,
      sym_block_comment,
  [68879] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5029), 1,
      anon_sym_SEMI,
    ACTIONS(5031), 1,
      anon_sym_DASH_GT,
    STATE(611), 1,
      sym_block,
    STATE(2418), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2194), 2,
      sym_line_comment,
      sym_block_comment,
  [68914] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5033), 1,
      anon_sym_SEMI,
    ACTIONS(5035), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_block,
    STATE(2487), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2195), 2,
      sym_line_comment,
      sym_block_comment,
  [68949] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5037), 1,
      anon_sym_SEMI,
    ACTIONS(5039), 1,
      anon_sym_DASH_GT,
    STATE(1409), 1,
      sym_block,
    STATE(2488), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2196), 2,
      sym_line_comment,
      sym_block_comment,
  [68984] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5041), 1,
      anon_sym_SEMI,
    STATE(651), 1,
      sym_block,
    STATE(2423), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2197), 2,
      sym_line_comment,
      sym_block_comment,
  [69019] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5043), 1,
      anon_sym_SEMI,
    ACTIONS(5045), 1,
      anon_sym_DASH_GT,
    STATE(639), 1,
      sym_block,
    STATE(2484), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2198), 2,
      sym_line_comment,
      sym_block_comment,
  [69054] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(4977), 1,
      anon_sym_LT,
    STATE(1449), 1,
      sym_declaration_list,
    STATE(2348), 1,
      sym_type_parameters,
    STATE(2730), 1,
      sym_trait_bounds,
    STATE(3310), 1,
      sym_where_clause,
    STATE(2199), 2,
      sym_line_comment,
      sym_block_comment,
  [69089] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(4977), 1,
      anon_sym_LT,
    STATE(1310), 1,
      sym_declaration_list,
    STATE(2381), 1,
      sym_type_parameters,
    STATE(2589), 1,
      sym_trait_bounds,
    STATE(3185), 1,
      sym_where_clause,
    STATE(2200), 2,
      sym_line_comment,
      sym_block_comment,
  [69124] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5047), 1,
      anon_sym_RBRACE,
    ACTIONS(5049), 1,
      anon_sym_COMMA,
    STATE(2201), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2875), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [69157] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5051), 1,
      anon_sym_RBRACE,
    ACTIONS(5053), 1,
      anon_sym_COMMA,
    STATE(2202), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2919), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [69190] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5055), 1,
      anon_sym_SEMI,
    STATE(1136), 1,
      sym_block,
    STATE(2476), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2203), 2,
      sym_line_comment,
      sym_block_comment,
  [69225] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(4977), 1,
      anon_sym_LT,
    STATE(485), 1,
      sym_declaration_list,
    STATE(2383), 1,
      sym_type_parameters,
    STATE(2699), 1,
      sym_trait_bounds,
    STATE(3304), 1,
      sym_where_clause,
    STATE(2204), 2,
      sym_line_comment,
      sym_block_comment,
  [69260] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1320), 1,
      aux_sym_string_literal_token1,
    STATE(2191), 1,
      sym_string_literal,
    STATE(2205), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4698), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69285] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      sym_crate,
    ACTIONS(4780), 1,
      sym_identifier,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2179), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3167), 1,
      sym_field_declaration,
    STATE(3581), 1,
      sym_visibility_modifier,
    STATE(2206), 2,
      sym_line_comment,
      sym_block_comment,
  [69320] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5057), 1,
      anon_sym_SEMI,
    ACTIONS(5059), 1,
      anon_sym_DASH_GT,
    STATE(676), 1,
      sym_block,
    STATE(2483), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2207), 2,
      sym_line_comment,
      sym_block_comment,
  [69355] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5061), 1,
      anon_sym_SEMI,
    STATE(1188), 1,
      sym_block,
    STATE(2450), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2208), 2,
      sym_line_comment,
      sym_block_comment,
  [69390] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5063), 1,
      anon_sym_SEMI,
    STATE(716), 1,
      sym_block,
    STATE(2445), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2209), 2,
      sym_line_comment,
      sym_block_comment,
  [69425] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5065), 1,
      anon_sym_SEMI,
    STATE(1205), 1,
      sym_block,
    STATE(2464), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2210), 2,
      sym_line_comment,
      sym_block_comment,
  [69460] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5067), 1,
      anon_sym_SEMI,
    ACTIONS(5069), 1,
      anon_sym_DASH_GT,
    STATE(533), 1,
      sym_block,
    STATE(2401), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2211), 2,
      sym_line_comment,
      sym_block_comment,
  [69495] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4451), 1,
      anon_sym_PIPE,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4457), 1,
      anon_sym_COLON,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5071), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2212), 2,
      sym_line_comment,
      sym_block_comment,
  [69528] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5073), 1,
      anon_sym_SEMI,
    ACTIONS(5075), 1,
      anon_sym_DASH_GT,
    STATE(745), 1,
      sym_block,
    STATE(2460), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2213), 2,
      sym_line_comment,
      sym_block_comment,
  [69563] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2214), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4909), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69584] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5077), 1,
      anon_sym_SEMI,
    ACTIONS(5079), 1,
      anon_sym_DASH_GT,
    STATE(1256), 1,
      sym_block,
    STATE(2391), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2215), 2,
      sym_line_comment,
      sym_block_comment,
  [69619] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2216), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4909), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69640] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2217), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4909), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69661] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2218), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4909), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69682] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(4977), 1,
      anon_sym_LT,
    STATE(677), 1,
      sym_declaration_list,
    STATE(2346), 1,
      sym_type_parameters,
    STATE(2513), 1,
      sym_trait_bounds,
    STATE(3078), 1,
      sym_where_clause,
    STATE(2219), 2,
      sym_line_comment,
      sym_block_comment,
  [69717] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5081), 1,
      anon_sym_fn,
    ACTIONS(5083), 1,
      anon_sym_extern,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2321), 1,
      sym_extern_modifier,
    STATE(2220), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4481), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [69746] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4730), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4786), 1,
      anon_sym_BANG,
    STATE(2221), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69771] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4519), 1,
      anon_sym_trait,
    ACTIONS(5085), 1,
      anon_sym_impl,
    STATE(2222), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69796] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2866), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2223), 2,
      sym_line_comment,
      sym_block_comment,
  [69831] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5087), 1,
      anon_sym_SEMI,
    STATE(499), 1,
      sym_block,
    STATE(2480), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2224), 2,
      sym_line_comment,
      sym_block_comment,
  [69866] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5089), 1,
      anon_sym_SEMI,
    ACTIONS(5091), 1,
      anon_sym_DASH_GT,
    STATE(1145), 1,
      sym_block,
    STATE(2486), 1,
      sym_where_clause,
    STATE(3597), 1,
      sym_label,
    STATE(2225), 2,
      sym_line_comment,
      sym_block_comment,
  [69901] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(4977), 1,
      anon_sym_LT,
    STATE(1120), 1,
      sym_declaration_list,
    STATE(2305), 1,
      sym_type_parameters,
    STATE(2542), 1,
      sym_trait_bounds,
    STATE(3065), 1,
      sym_where_clause,
    STATE(2226), 2,
      sym_line_comment,
      sym_block_comment,
  [69936] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(4977), 1,
      anon_sym_LT,
    STATE(626), 1,
      sym_declaration_list,
    STATE(2353), 1,
      sym_type_parameters,
    STATE(2717), 1,
      sym_trait_bounds,
    STATE(3300), 1,
      sym_where_clause,
    STATE(2227), 2,
      sym_line_comment,
      sym_block_comment,
  [69971] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5093), 1,
      anon_sym_SEMI,
    STATE(709), 1,
      sym_block,
    STATE(2416), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2228), 2,
      sym_line_comment,
      sym_block_comment,
  [70006] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym_identifier,
    ACTIONS(4776), 1,
      sym_crate,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(3097), 1,
      sym_enum_variant,
    STATE(3514), 1,
      sym_visibility_modifier,
    STATE(2229), 2,
      sym_line_comment,
      sym_block_comment,
  [70041] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5095), 1,
      anon_sym_SEMI,
    ACTIONS(5097), 1,
      anon_sym_DASH_GT,
    STATE(482), 1,
      sym_block,
    STATE(2415), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2230), 2,
      sym_line_comment,
      sym_block_comment,
  [70076] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5099), 1,
      anon_sym_SEMI,
    STATE(630), 1,
      sym_block,
    STATE(2424), 1,
      sym_where_clause,
    STATE(3594), 1,
      sym_label,
    STATE(2231), 2,
      sym_line_comment,
      sym_block_comment,
  [70111] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5105), 1,
      anon_sym_RBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    STATE(2275), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3224), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2232), 2,
      sym_line_comment,
      sym_block_comment,
  [70143] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5109), 1,
      anon_sym_RBRACE,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3165), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2233), 2,
      sym_line_comment,
      sym_block_comment,
  [70175] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5115), 1,
      anon_sym_RBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    ACTIONS(5119), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      sym_delim_token_tree,
    STATE(2234), 2,
      sym_line_comment,
      sym_block_comment,
  [70207] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5105), 1,
      anon_sym_RPAREN,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    STATE(2274), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3227), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2235), 2,
      sym_line_comment,
      sym_block_comment,
  [70239] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5121), 1,
      anon_sym_RPAREN,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3140), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2236), 2,
      sym_line_comment,
      sym_block_comment,
  [70271] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5121), 1,
      anon_sym_RBRACK,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3144), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2237), 2,
      sym_line_comment,
      sym_block_comment,
  [70303] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5123), 1,
      sym_identifier,
    STATE(2238), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4742), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70325] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5125), 1,
      anon_sym_RBRACE,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3147), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2239), 2,
      sym_line_comment,
      sym_block_comment,
  [70357] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5127), 1,
      anon_sym_RPAREN,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3151), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2240), 2,
      sym_line_comment,
      sym_block_comment,
  [70389] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5115), 1,
      anon_sym_RBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    ACTIONS(5119), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      sym_delim_token_tree,
    STATE(2241), 2,
      sym_line_comment,
      sym_block_comment,
  [70421] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    ACTIONS(5129), 1,
      anon_sym_SEMI,
    STATE(1124), 1,
      sym_field_declaration_list,
    STATE(2947), 1,
      sym_ordered_field_declaration_list,
    STATE(3114), 1,
      sym_where_clause,
    STATE(2242), 2,
      sym_line_comment,
      sym_block_comment,
  [70453] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4788), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4790), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2243), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [70479] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    ACTIONS(5133), 1,
      anon_sym_EQ,
    ACTIONS(5131), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2244), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2789), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [70507] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5135), 1,
      anon_sym_SEMI,
    STATE(702), 1,
      sym_field_declaration_list,
    STATE(3012), 1,
      sym_ordered_field_declaration_list,
    STATE(3055), 1,
      sym_where_clause,
    STATE(2245), 2,
      sym_line_comment,
      sym_block_comment,
  [70539] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5127), 1,
      anon_sym_RBRACK,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3152), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2246), 2,
      sym_line_comment,
      sym_block_comment,
  [70571] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5137), 1,
      anon_sym_RBRACE,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3154), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2247), 2,
      sym_line_comment,
      sym_block_comment,
  [70603] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5141), 1,
      anon_sym_COLON,
    ACTIONS(5143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5139), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2248), 2,
      sym_line_comment,
      sym_block_comment,
  [70631] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5145), 1,
      sym_identifier,
    STATE(2249), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4742), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70653] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4684), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5115), 1,
      anon_sym_RBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    ACTIONS(5119), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      sym_delim_token_tree,
    STATE(2250), 2,
      sym_line_comment,
      sym_block_comment,
  [70685] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5147), 1,
      anon_sym_RBRACE,
    STATE(2251), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3260), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70715] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5149), 1,
      anon_sym_RBRACK,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3183), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2252), 2,
      sym_line_comment,
      sym_block_comment,
  [70747] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5153), 1,
      anon_sym_STAR,
    STATE(2979), 1,
      sym_use_list,
    STATE(3164), 1,
      sym_type_arguments,
    ACTIONS(5151), 2,
      sym_identifier,
      sym_super,
    STATE(2253), 2,
      sym_line_comment,
      sym_block_comment,
  [70777] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5155), 1,
      anon_sym_RBRACE,
    STATE(2254), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3260), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70807] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5157), 1,
      anon_sym_RBRACE,
    STATE(2255), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3260), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70837] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5159), 1,
      anon_sym_RBRACE,
    STATE(2256), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3260), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70867] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5163), 1,
      anon_sym_COLON,
    ACTIONS(5165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5161), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2257), 2,
      sym_line_comment,
      sym_block_comment,
  [70895] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5153), 1,
      anon_sym_STAR,
    STATE(2979), 1,
      sym_use_list,
    STATE(3150), 1,
      sym_type_arguments,
    ACTIONS(5151), 2,
      sym_identifier,
      sym_super,
    STATE(2258), 2,
      sym_line_comment,
      sym_block_comment,
  [70925] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4730), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    ACTIONS(5167), 1,
      anon_sym_RBRACK,
    ACTIONS(5169), 1,
      anon_sym_EQ,
    STATE(3450), 1,
      sym_delim_token_tree,
    STATE(2259), 2,
      sym_line_comment,
      sym_block_comment,
  [70957] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5171), 1,
      sym_identifier,
    STATE(2260), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4742), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70979] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2261), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [71005] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5173), 1,
      anon_sym_RPAREN,
    STATE(2278), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3222), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2262), 2,
      sym_line_comment,
      sym_block_comment,
  [71037] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5173), 1,
      anon_sym_RBRACK,
    STATE(2252), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3221), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2263), 2,
      sym_line_comment,
      sym_block_comment,
  [71069] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5175), 1,
      anon_sym_RBRACE,
    STATE(2247), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3204), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2264), 2,
      sym_line_comment,
      sym_block_comment,
  [71101] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5177), 1,
      anon_sym_RBRACK,
    STATE(2246), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3205), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2265), 2,
      sym_line_comment,
      sym_block_comment,
  [71133] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5177), 1,
      anon_sym_RPAREN,
    STATE(2240), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3206), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2266), 2,
      sym_line_comment,
      sym_block_comment,
  [71165] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5179), 1,
      anon_sym_SEMI,
    STATE(622), 1,
      sym_field_declaration_list,
    STATE(2753), 1,
      sym_ordered_field_declaration_list,
    STATE(3236), 1,
      sym_where_clause,
    STATE(2267), 2,
      sym_line_comment,
      sym_block_comment,
  [71197] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5181), 1,
      anon_sym_RBRACE,
    STATE(2268), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3260), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71227] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_SEMI,
    STATE(1331), 1,
      sym_field_declaration_list,
    STATE(2839), 1,
      sym_ordered_field_declaration_list,
    STATE(3195), 1,
      sym_where_clause,
    STATE(2269), 2,
      sym_line_comment,
      sym_block_comment,
  [71259] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5185), 1,
      anon_sym_RBRACE,
    STATE(2270), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3260), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71289] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5187), 1,
      anon_sym_RBRACE,
    STATE(2239), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3209), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2271), 2,
      sym_line_comment,
      sym_block_comment,
  [71321] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5189), 1,
      anon_sym_RBRACK,
    STATE(2237), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3210), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2272), 2,
      sym_line_comment,
      sym_block_comment,
  [71353] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5189), 1,
      anon_sym_RPAREN,
    STATE(2236), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3214), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2273), 2,
      sym_line_comment,
      sym_block_comment,
  [71385] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5191), 1,
      anon_sym_RPAREN,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3196), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2274), 2,
      sym_line_comment,
      sym_block_comment,
  [71417] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5191), 1,
      anon_sym_RBRACK,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3189), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2275), 2,
      sym_line_comment,
      sym_block_comment,
  [71449] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5193), 1,
      anon_sym_RBRACE,
    STATE(2276), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3260), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71479] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    ACTIONS(5195), 1,
      anon_sym_RBRACE,
    STATE(2277), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3260), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71509] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5149), 1,
      anon_sym_RPAREN,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3187), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2278), 2,
      sym_line_comment,
      sym_block_comment,
  [71541] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5163), 1,
      anon_sym_COLON,
    ACTIONS(5197), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5161), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2279), 2,
      sym_line_comment,
      sym_block_comment,
  [71569] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5197), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2280), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [71595] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5199), 1,
      anon_sym_RBRACE,
    STATE(2282), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3274), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2281), 2,
      sym_line_comment,
      sym_block_comment,
  [71627] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5201), 1,
      anon_sym_RBRACE,
    STATE(2158), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3159), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2282), 2,
      sym_line_comment,
      sym_block_comment,
  [71659] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5203), 1,
      anon_sym_RBRACE,
    STATE(2233), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3279), 1,
      sym_macro_rule,
    STATE(3417), 1,
      sym_token_tree_pattern,
    STATE(2283), 2,
      sym_line_comment,
      sym_block_comment,
  [71691] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5205), 1,
      anon_sym_trait,
    STATE(2284), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [71713] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5207), 1,
      sym_identifier,
    STATE(2285), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4742), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [71735] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5209), 1,
      aux_sym_line_comment_token1,
    ACTIONS(5211), 1,
      aux_sym_line_comment_token3,
    ACTIONS(5213), 1,
      anon_sym_BANG2,
    ACTIONS(5215), 1,
      anon_sym_SLASH2,
    STATE(3525), 1,
      sym__outer_line_doc_comment_marker,
    STATE(3542), 1,
      sym__inner_line_doc_comment_marker,
    STATE(3545), 1,
      sym__line_doc_comment_marker,
    STATE(2286), 2,
      sym_line_comment,
      sym_block_comment,
  [71767] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5217), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2287), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PLUS,
  [71793] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5219), 1,
      anon_sym_trait,
    STATE(2288), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [71815] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_LPAREN,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    ACTIONS(5223), 1,
      anon_sym_EQ,
    ACTIONS(5221), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2289), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2853), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [71843] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5225), 1,
      anon_sym_GT,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    STATE(2999), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3291), 2,
      anon_sym_PLUS,
      anon_sym_as,
    STATE(2290), 2,
      sym_line_comment,
      sym_block_comment,
  [71870] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4901), 1,
      anon_sym_for,
    STATE(2291), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [71893] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5229), 1,
      anon_sym_SEMI,
    STATE(1228), 1,
      sym_declaration_list,
    STATE(3016), 1,
      sym_where_clause,
    STATE(2292), 2,
      sym_line_comment,
      sym_block_comment,
  [71922] = 9,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5231), 1,
      sym_identifier,
    ACTIONS(5233), 1,
      anon_sym_ref,
    ACTIONS(5235), 1,
      sym_mutable_specifier,
    ACTIONS(5237), 1,
      anon_sym_move,
    STATE(225), 1,
      sym_closure_parameters,
    STATE(2293), 2,
      sym_line_comment,
      sym_block_comment,
  [71951] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4953), 1,
      anon_sym_for,
    STATE(2294), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [71974] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(933), 1,
      anon_sym_DOT_DOT,
    STATE(2295), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(935), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [71995] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5239), 1,
      anon_sym_SEMI,
    STATE(581), 1,
      sym_declaration_list,
    STATE(2774), 1,
      sym_where_clause,
    STATE(2296), 2,
      sym_line_comment,
      sym_block_comment,
  [72024] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5241), 1,
      anon_sym_SEMI,
    STATE(1218), 1,
      sym_declaration_list,
    STATE(3017), 1,
      sym_where_clause,
    STATE(2297), 2,
      sym_line_comment,
      sym_block_comment,
  [72053] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5243), 1,
      anon_sym_SEMI,
    STATE(1211), 1,
      sym_declaration_list,
    STATE(3019), 1,
      sym_where_clause,
    STATE(2298), 2,
      sym_line_comment,
      sym_block_comment,
  [72082] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5245), 1,
      anon_sym_SEMI,
    STATE(1201), 1,
      sym_declaration_list,
    STATE(3020), 1,
      sym_where_clause,
    STATE(2299), 2,
      sym_line_comment,
      sym_block_comment,
  [72111] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4824), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2300), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [72132] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2301), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4931), 6,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [72151] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5247), 1,
      anon_sym_SEMI,
    STATE(1213), 1,
      sym_declaration_list,
    STATE(2980), 1,
      sym_where_clause,
    STATE(2302), 2,
      sym_line_comment,
      sym_block_comment,
  [72180] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4868), 1,
      anon_sym_for,
    STATE(2303), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72203] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4985), 1,
      sym_identifier,
    ACTIONS(4991), 1,
      anon_sym_ref,
    ACTIONS(4993), 1,
      sym_mutable_specifier,
    STATE(2304), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3260), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [72230] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(1375), 1,
      sym_declaration_list,
    STATE(2505), 1,
      sym_trait_bounds,
    STATE(3066), 1,
      sym_where_clause,
    STATE(2305), 2,
      sym_line_comment,
      sym_block_comment,
  [72259] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3464), 1,
      anon_sym_COLON,
    ACTIONS(5249), 1,
      anon_sym_EQ,
    STATE(2306), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3462), 4,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [72282] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4872), 1,
      anon_sym_for,
    STATE(2307), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72305] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5251), 1,
      anon_sym_SEMI,
    STATE(1245), 1,
      sym_declaration_list,
    STATE(2981), 1,
      sym_where_clause,
    STATE(2308), 2,
      sym_line_comment,
      sym_block_comment,
  [72334] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4874), 1,
      anon_sym_for,
    STATE(2309), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72357] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5253), 1,
      anon_sym_SEMI,
    STATE(1307), 1,
      sym_declaration_list,
    STATE(2986), 1,
      sym_where_clause,
    STATE(2310), 2,
      sym_line_comment,
      sym_block_comment,
  [72386] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5255), 1,
      anon_sym_SEMI,
    STATE(1339), 1,
      sym_declaration_list,
    STATE(2987), 1,
      sym_where_clause,
    STATE(2311), 2,
      sym_line_comment,
      sym_block_comment,
  [72415] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4798), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2312), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [72436] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5257), 1,
      anon_sym_SEMI,
    STATE(504), 1,
      sym_declaration_list,
    STATE(2881), 1,
      sym_where_clause,
    STATE(2313), 2,
      sym_line_comment,
      sym_block_comment,
  [72465] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5259), 1,
      anon_sym_SEMI,
    STATE(1130), 1,
      sym_declaration_list,
    STATE(3024), 1,
      sym_where_clause,
    STATE(2314), 2,
      sym_line_comment,
      sym_block_comment,
  [72494] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5261), 1,
      anon_sym_SEMI,
    STATE(510), 1,
      sym_declaration_list,
    STATE(2879), 1,
      sym_where_clause,
    STATE(2315), 2,
      sym_line_comment,
      sym_block_comment,
  [72523] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5263), 1,
      anon_sym_SEMI,
    STATE(512), 1,
      sym_declaration_list,
    STATE(2873), 1,
      sym_where_clause,
    STATE(2316), 2,
      sym_line_comment,
      sym_block_comment,
  [72552] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4903), 1,
      anon_sym_for,
    STATE(2317), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72575] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(937), 1,
      anon_sym_DOT_DOT,
    STATE(2318), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(939), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [72596] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5265), 1,
      anon_sym_SEMI,
    STATE(518), 1,
      sym_declaration_list,
    STATE(2871), 1,
      sym_where_clause,
    STATE(2319), 2,
      sym_line_comment,
      sym_block_comment,
  [72625] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5267), 1,
      anon_sym_SEMI,
    STATE(1116), 1,
      sym_declaration_list,
    STATE(3023), 1,
      sym_where_clause,
    STATE(2320), 2,
      sym_line_comment,
      sym_block_comment,
  [72654] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2321), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [72673] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5269), 1,
      anon_sym_LBRACE,
    STATE(601), 1,
      sym_enum_variant_list,
    STATE(2715), 1,
      sym_type_parameters,
    STATE(3267), 1,
      sym_where_clause,
    STATE(2322), 2,
      sym_line_comment,
      sym_block_comment,
  [72702] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5271), 1,
      anon_sym_SEMI,
    STATE(516), 1,
      sym_declaration_list,
    STATE(2819), 1,
      sym_where_clause,
    STATE(2323), 2,
      sym_line_comment,
      sym_block_comment,
  [72731] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5197), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5273), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2324), 2,
      sym_line_comment,
      sym_block_comment,
  [72756] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5275), 1,
      anon_sym_SEMI,
    STATE(529), 1,
      sym_declaration_list,
    STATE(2822), 1,
      sym_where_clause,
    STATE(2325), 2,
      sym_line_comment,
      sym_block_comment,
  [72785] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5277), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_declaration_list,
    STATE(2736), 1,
      sym_where_clause,
    STATE(2326), 2,
      sym_line_comment,
      sym_block_comment,
  [72814] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5279), 1,
      anon_sym_GT,
    ACTIONS(5281), 1,
      anon_sym_COMMA,
    STATE(2825), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2990), 1,
      sym_trait_bounds,
    STATE(2327), 2,
      sym_line_comment,
      sym_block_comment,
  [72843] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4939), 1,
      anon_sym_for,
    STATE(2328), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72866] = 8,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5283), 1,
      anon_sym_if,
    STATE(3457), 1,
      sym_label,
    STATE(394), 2,
      sym_if_expression,
      sym_block,
    STATE(2329), 2,
      sym_line_comment,
      sym_block_comment,
  [72893] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5285), 1,
      anon_sym_LBRACE,
    STATE(1469), 1,
      sym_enum_variant_list,
    STATE(2716), 1,
      sym_type_parameters,
    STATE(3265), 1,
      sym_where_clause,
    STATE(2330), 2,
      sym_line_comment,
      sym_block_comment,
  [72922] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5287), 1,
      anon_sym_SEMI,
    STATE(1459), 1,
      sym_declaration_list,
    STATE(2741), 1,
      sym_where_clause,
    STATE(2331), 2,
      sym_line_comment,
      sym_block_comment,
  [72951] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1447), 1,
      sym_field_declaration_list,
    STATE(2727), 1,
      sym_type_parameters,
    STATE(3309), 1,
      sym_where_clause,
    STATE(2332), 2,
      sym_line_comment,
      sym_block_comment,
  [72980] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(492), 1,
      sym_field_declaration_list,
    STATE(2495), 1,
      sym_type_parameters,
    STATE(3278), 1,
      sym_where_clause,
    STATE(2333), 2,
      sym_line_comment,
      sym_block_comment,
  [73009] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5197), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5139), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2334), 2,
      sym_line_comment,
      sym_block_comment,
  [73034] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4582), 1,
      anon_sym_GT,
    ACTIONS(4584), 1,
      anon_sym_COMMA,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(2990), 1,
      sym_trait_bounds,
    STATE(2996), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2335), 2,
      sym_line_comment,
      sym_block_comment,
  [73063] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5289), 1,
      anon_sym_SEMI,
    STATE(564), 1,
      sym_declaration_list,
    STATE(2861), 1,
      sym_where_clause,
    STATE(2336), 2,
      sym_line_comment,
      sym_block_comment,
  [73092] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5291), 1,
      anon_sym_SEMI,
    STATE(1269), 1,
      sym_declaration_list,
    STATE(3013), 1,
      sym_where_clause,
    STATE(2337), 2,
      sym_line_comment,
      sym_block_comment,
  [73121] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3340), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(4824), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5293), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2338), 2,
      sym_line_comment,
      sym_block_comment,
  [73144] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5296), 1,
      anon_sym_SEMI,
    STATE(1258), 1,
      sym_declaration_list,
    STATE(3014), 1,
      sym_where_clause,
    STATE(2339), 2,
      sym_line_comment,
      sym_block_comment,
  [73173] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    ACTIONS(5300), 1,
      anon_sym_GT,
    ACTIONS(5302), 1,
      anon_sym_COMMA,
    STATE(2920), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2923), 1,
      sym_trait_bounds,
    STATE(2340), 2,
      sym_line_comment,
      sym_block_comment,
  [73202] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5300), 1,
      anon_sym_GT,
    ACTIONS(5302), 1,
      anon_sym_COMMA,
    STATE(2920), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2923), 1,
      sym_trait_bounds,
    STATE(2341), 2,
      sym_line_comment,
      sym_block_comment,
  [73231] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5304), 1,
      anon_sym_SEMI,
    STATE(569), 1,
      sym_declaration_list,
    STATE(2858), 1,
      sym_where_clause,
    STATE(2342), 2,
      sym_line_comment,
      sym_block_comment,
  [73260] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5273), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2343), 2,
      sym_line_comment,
      sym_block_comment,
  [73285] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(945), 1,
      anon_sym_DOT_DOT,
    STATE(2344), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(947), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73306] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5293), 1,
      anon_sym_RBRACK,
    ACTIONS(4824), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2345), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [73329] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(598), 1,
      sym_declaration_list,
    STATE(2691), 1,
      sym_trait_bounds,
    STATE(3284), 1,
      sym_where_clause,
    STATE(2346), 2,
      sym_line_comment,
      sym_block_comment,
  [73358] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5306), 1,
      anon_sym_SEMI,
    STATE(1347), 1,
      sym_declaration_list,
    STATE(2824), 1,
      sym_where_clause,
    STATE(2347), 2,
      sym_line_comment,
      sym_block_comment,
  [73387] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(1325), 1,
      sym_declaration_list,
    STATE(2610), 1,
      sym_trait_bounds,
    STATE(3191), 1,
      sym_where_clause,
    STATE(2348), 2,
      sym_line_comment,
      sym_block_comment,
  [73416] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5308), 1,
      anon_sym_if,
    STATE(3598), 1,
      sym_label,
    STATE(461), 2,
      sym_if_expression,
      sym_block,
    STATE(2349), 2,
      sym_line_comment,
      sym_block_comment,
  [73443] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5310), 1,
      anon_sym_SEMI,
    ACTIONS(5312), 1,
      anon_sym_EQ,
    STATE(2847), 1,
      sym_trait_bounds,
    STATE(3431), 1,
      sym_where_clause,
    STATE(2350), 2,
      sym_line_comment,
      sym_block_comment,
  [73472] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5314), 1,
      anon_sym_SEMI,
    STATE(610), 1,
      sym_declaration_list,
    STATE(2925), 1,
      sym_where_clause,
    STATE(2351), 2,
      sym_line_comment,
      sym_block_comment,
  [73501] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5316), 1,
      anon_sym_SEMI,
    STATE(1313), 1,
      sym_declaration_list,
    STATE(2850), 1,
      sym_where_clause,
    STATE(2352), 2,
      sym_line_comment,
      sym_block_comment,
  [73530] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(643), 1,
      sym_declaration_list,
    STATE(2608), 1,
      sym_trait_bounds,
    STATE(3139), 1,
      sym_where_clause,
    STATE(2353), 2,
      sym_line_comment,
      sym_block_comment,
  [73559] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5318), 1,
      anon_sym_RBRACK,
    ACTIONS(4798), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2354), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [73582] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4619), 1,
      anon_sym_DOT_DOT,
    STATE(2355), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4617), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73603] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(885), 1,
      anon_sym_DOT_DOT,
    STATE(2356), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(887), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73624] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4615), 1,
      anon_sym_DOT_DOT,
    STATE(2357), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4613), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73645] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5321), 1,
      anon_sym_SEMI,
    STATE(607), 1,
      sym_declaration_list,
    STATE(2914), 1,
      sym_where_clause,
    STATE(2358), 2,
      sym_line_comment,
      sym_block_comment,
  [73674] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3336), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(4798), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5318), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2359), 2,
      sym_line_comment,
      sym_block_comment,
  [73697] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5285), 1,
      anon_sym_LBRACE,
    STATE(1302), 1,
      sym_enum_variant_list,
    STATE(2583), 1,
      sym_type_parameters,
    STATE(3181), 1,
      sym_where_clause,
    STATE(2360), 2,
      sym_line_comment,
      sym_block_comment,
  [73726] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5323), 1,
      anon_sym_GT,
    ACTIONS(5325), 1,
      anon_sym_COMMA,
    STATE(2900), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2902), 1,
      sym_trait_bounds,
    STATE(2361), 2,
      sym_line_comment,
      sym_block_comment,
  [73755] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    ACTIONS(5323), 1,
      anon_sym_GT,
    ACTIONS(5325), 1,
      anon_sym_COMMA,
    STATE(2900), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2902), 1,
      sym_trait_bounds,
    STATE(2362), 2,
      sym_line_comment,
      sym_block_comment,
  [73784] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1287), 1,
      sym_field_declaration_list,
    STATE(2578), 1,
      sym_type_parameters,
    STATE(3175), 1,
      sym_where_clause,
    STATE(2363), 2,
      sym_line_comment,
      sym_block_comment,
  [73813] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    ACTIONS(5327), 1,
      anon_sym_GT,
    ACTIONS(5329), 1,
      anon_sym_COMMA,
    STATE(2887), 1,
      sym_trait_bounds,
    STATE(2888), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2364), 2,
      sym_line_comment,
      sym_block_comment,
  [73842] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5327), 1,
      anon_sym_GT,
    ACTIONS(5329), 1,
      anon_sym_COMMA,
    STATE(2887), 1,
      sym_trait_bounds,
    STATE(2888), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2365), 2,
      sym_line_comment,
      sym_block_comment,
  [73871] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4600), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2366), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [73894] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5331), 1,
      anon_sym_GT,
    ACTIONS(5333), 1,
      anon_sym_COMMA,
    STATE(2816), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2990), 1,
      sym_trait_bounds,
    STATE(2367), 2,
      sym_line_comment,
      sym_block_comment,
  [73923] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5139), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2368), 2,
      sym_line_comment,
      sym_block_comment,
  [73948] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5335), 1,
      anon_sym_if,
    STATE(3547), 1,
      sym_label,
    STATE(1242), 2,
      sym_if_expression,
      sym_block,
    STATE(2369), 2,
      sym_line_comment,
      sym_block_comment,
  [73975] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5337), 1,
      anon_sym_GT,
    ACTIONS(5339), 1,
      anon_sym_COMMA,
    STATE(2870), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2999), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3000), 1,
      sym_trait_bounds,
    STATE(2370), 2,
      sym_line_comment,
      sym_block_comment,
  [74004] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5341), 1,
      anon_sym_SEMI,
    STATE(736), 1,
      sym_declaration_list,
    STATE(2806), 1,
      sym_where_clause,
    STATE(2371), 2,
      sym_line_comment,
      sym_block_comment,
  [74033] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5343), 1,
      anon_sym_if,
    STATE(3599), 1,
      sym_label,
    STATE(1776), 2,
      sym_if_expression,
      sym_block,
    STATE(2372), 2,
      sym_line_comment,
      sym_block_comment,
  [74060] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5225), 1,
      anon_sym_GT,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    STATE(2999), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3000), 1,
      sym_trait_bounds,
    STATE(2373), 2,
      sym_line_comment,
      sym_block_comment,
  [74089] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5345), 1,
      anon_sym_SEMI,
    STATE(718), 1,
      sym_declaration_list,
    STATE(2794), 1,
      sym_where_clause,
    STATE(2374), 2,
      sym_line_comment,
      sym_block_comment,
  [74118] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5347), 1,
      anon_sym_SEMI,
    STATE(747), 1,
      sym_declaration_list,
    STATE(3028), 1,
      sym_where_clause,
    STATE(2375), 2,
      sym_line_comment,
      sym_block_comment,
  [74147] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(658), 1,
      sym_field_declaration_list,
    STATE(2533), 1,
      sym_type_parameters,
    STATE(3172), 1,
      sym_where_clause,
    STATE(2376), 2,
      sym_line_comment,
      sym_block_comment,
  [74176] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5349), 1,
      anon_sym_SEMI,
    STATE(722), 1,
      sym_declaration_list,
    STATE(2797), 1,
      sym_where_clause,
    STATE(2377), 2,
      sym_line_comment,
      sym_block_comment,
  [74205] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5269), 1,
      anon_sym_LBRACE,
    STATE(666), 1,
      sym_enum_variant_list,
    STATE(2524), 1,
      sym_type_parameters,
    STATE(3090), 1,
      sym_where_clause,
    STATE(2378), 2,
      sym_line_comment,
      sym_block_comment,
  [74234] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4907), 1,
      anon_sym_for,
    STATE(2379), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [74257] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5351), 1,
      anon_sym_SEMI,
    STATE(732), 1,
      sym_declaration_list,
    STATE(2803), 1,
      sym_where_clause,
    STATE(2380), 2,
      sym_line_comment,
      sym_block_comment,
  [74286] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(1147), 1,
      sym_declaration_list,
    STATE(2549), 1,
      sym_trait_bounds,
    STATE(3127), 1,
      sym_where_clause,
    STATE(2381), 2,
      sym_line_comment,
      sym_block_comment,
  [74315] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5353), 1,
      anon_sym_GT,
    ACTIONS(5355), 1,
      anon_sym_COMMA,
    STATE(2916), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2990), 1,
      sym_trait_bounds,
    STATE(2382), 2,
      sym_line_comment,
      sym_block_comment,
  [74344] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(692), 1,
      sym_declaration_list,
    STATE(2503), 1,
      sym_trait_bounds,
    STATE(3044), 1,
      sym_where_clause,
    STATE(2383), 2,
      sym_line_comment,
      sym_block_comment,
  [74373] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5357), 1,
      anon_sym_SEMI,
    ACTIONS(5359), 1,
      anon_sym_EQ,
    STATE(3009), 1,
      sym_trait_bounds,
    STATE(3394), 1,
      sym_where_clause,
    STATE(2384), 2,
      sym_line_comment,
      sym_block_comment,
  [74402] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5361), 1,
      anon_sym_SEMI,
    STATE(1153), 1,
      sym_declaration_list,
    STATE(2936), 1,
      sym_where_clause,
    STATE(2385), 2,
      sym_line_comment,
      sym_block_comment,
  [74431] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5363), 1,
      anon_sym_SEMI,
    STATE(678), 1,
      sym_declaration_list,
    STATE(2997), 1,
      sym_where_clause,
    STATE(2386), 2,
      sym_line_comment,
      sym_block_comment,
  [74460] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5365), 1,
      anon_sym_SEMI,
    STATE(1233), 1,
      sym_declaration_list,
    STATE(2918), 1,
      sym_where_clause,
    STATE(2387), 2,
      sym_line_comment,
      sym_block_comment,
  [74489] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5367), 1,
      anon_sym_SEMI,
    STATE(1220), 1,
      sym_declaration_list,
    STATE(2921), 1,
      sym_where_clause,
    STATE(2388), 2,
      sym_line_comment,
      sym_block_comment,
  [74518] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5369), 1,
      anon_sym_RPAREN,
    ACTIONS(5371), 1,
      anon_sym_COLON,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5375), 1,
      anon_sym_COMMA,
    STATE(2898), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2389), 2,
      sym_line_comment,
      sym_block_comment,
  [74544] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5377), 1,
      anon_sym_SEMI,
    STATE(1097), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2390), 2,
      sym_line_comment,
      sym_block_comment,
  [74570] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5379), 1,
      anon_sym_SEMI,
    STATE(1180), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2391), 2,
      sym_line_comment,
      sym_block_comment,
  [74596] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(5153), 1,
      anon_sym_STAR,
    STATE(2979), 1,
      sym_use_list,
    ACTIONS(5151), 2,
      sym_identifier,
      sym_super,
    STATE(2392), 2,
      sym_line_comment,
      sym_block_comment,
  [74620] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2959), 1,
      anon_sym_POUND,
    ACTIONS(5381), 1,
      sym_identifier,
    ACTIONS(5383), 1,
      sym_integer_literal,
    STATE(1078), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1477), 1,
      sym_attribute_item,
    STATE(2393), 2,
      sym_line_comment,
      sym_block_comment,
  [74646] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5385), 1,
      anon_sym_RBRACK,
    ACTIONS(3291), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4451), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2394), 2,
      sym_line_comment,
      sym_block_comment,
  [74668] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4652), 1,
      anon_sym_GT,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5388), 1,
      anon_sym_COMMA,
    STATE(2917), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3000), 1,
      sym_trait_bounds,
    STATE(2395), 2,
      sym_line_comment,
      sym_block_comment,
  [74694] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4467), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1963), 1,
      sym_parameters,
    STATE(2396), 2,
      sym_line_comment,
      sym_block_comment,
  [74720] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(5390), 1,
      anon_sym_SEMI,
    ACTIONS(5392), 1,
      anon_sym_COLON,
    ACTIONS(5394), 1,
      anon_sym_EQ,
    ACTIONS(5396), 1,
      anon_sym_else,
    STATE(2397), 2,
      sym_line_comment,
      sym_block_comment,
  [74746] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(2990), 1,
      sym_trait_bounds,
    ACTIONS(5398), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2398), 2,
      sym_line_comment,
      sym_block_comment,
  [74770] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2399), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3683), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [74788] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    STATE(1243), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2400), 2,
      sym_line_comment,
      sym_block_comment,
  [74814] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5400), 1,
      anon_sym_SEMI,
    STATE(714), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2401), 2,
      sym_line_comment,
      sym_block_comment,
  [74840] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5402), 1,
      anon_sym_RBRACK,
    ACTIONS(3839), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4760), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2402), 2,
      sym_line_comment,
      sym_block_comment,
  [74862] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2403), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5405), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74880] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5407), 1,
      anon_sym_COMMA,
    STATE(2444), 1,
      aux_sym_where_clause_repeat1,
    STATE(2404), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3346), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
  [74902] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(5409), 1,
      anon_sym_COMMA,
    STATE(2762), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2405), 2,
      sym_line_comment,
      sym_block_comment,
  [74926] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5411), 1,
      anon_sym_SEMI,
    STATE(1251), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2406), 2,
      sym_line_comment,
      sym_block_comment,
  [74952] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5413), 1,
      anon_sym_GT,
    ACTIONS(5415), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3000), 1,
      sym_trait_bounds,
    STATE(2407), 2,
      sym_line_comment,
      sym_block_comment,
  [74978] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4766), 1,
      anon_sym_RPAREN,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(5419), 1,
      anon_sym_PIPE,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(2769), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2408), 2,
      sym_line_comment,
      sym_block_comment,
  [75004] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2409), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5423), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75022] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    STATE(1353), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2410), 2,
      sym_line_comment,
      sym_block_comment,
  [75048] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2411), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5425), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75066] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2412), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5427), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75084] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5429), 1,
      anon_sym_RPAREN,
    ACTIONS(5431), 1,
      anon_sym_COMMA,
    STATE(2901), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2413), 2,
      sym_line_comment,
      sym_block_comment,
  [75108] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5327), 1,
      anon_sym_GT,
    ACTIONS(5329), 1,
      anon_sym_COMMA,
    STATE(2887), 1,
      sym_trait_bounds,
    STATE(2888), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2414), 2,
      sym_line_comment,
      sym_block_comment,
  [75134] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5433), 1,
      anon_sym_SEMI,
    STATE(644), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2415), 2,
      sym_line_comment,
      sym_block_comment,
  [75160] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5435), 1,
      anon_sym_SEMI,
    STATE(751), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2416), 2,
      sym_line_comment,
      sym_block_comment,
  [75186] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5437), 1,
      anon_sym_move,
    STATE(472), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2417), 2,
      sym_line_comment,
      sym_block_comment,
  [75212] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5439), 1,
      anon_sym_SEMI,
    STATE(672), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2418), 2,
      sym_line_comment,
      sym_block_comment,
  [75238] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    STATE(1697), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2419), 2,
      sym_line_comment,
      sym_block_comment,
  [75264] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2420), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5441), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75282] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5323), 1,
      anon_sym_GT,
    ACTIONS(5325), 1,
      anon_sym_COMMA,
    STATE(2900), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2902), 1,
      sym_trait_bounds,
    STATE(2421), 2,
      sym_line_comment,
      sym_block_comment,
  [75308] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5141), 1,
      anon_sym_COLON,
    ACTIONS(5143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2422), 2,
      sym_line_comment,
      sym_block_comment,
  [75332] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5443), 1,
      anon_sym_SEMI,
    STATE(713), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2423), 2,
      sym_line_comment,
      sym_block_comment,
  [75358] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5445), 1,
      anon_sym_SEMI,
    STATE(627), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2424), 2,
      sym_line_comment,
      sym_block_comment,
  [75384] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2425), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5447), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75402] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5449), 1,
      anon_sym_RPAREN,
    ACTIONS(5452), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2426), 2,
      sym_line_comment,
      sym_block_comment,
  [75426] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2427), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5455), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75444] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3291), 1,
      anon_sym_PLUS,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5385), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2428), 2,
      sym_line_comment,
      sym_block_comment,
  [75466] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2429), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3675), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [75484] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2430), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3829), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [75502] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5457), 1,
      anon_sym_RPAREN,
    ACTIONS(5459), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2431), 2,
      sym_line_comment,
      sym_block_comment,
  [75526] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3839), 1,
      anon_sym_PLUS,
    ACTIONS(4760), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5402), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2432), 2,
      sym_line_comment,
      sym_block_comment,
  [75548] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(5461), 1,
      anon_sym_SEMI,
    ACTIONS(5463), 1,
      anon_sym_COLON,
    ACTIONS(5465), 1,
      anon_sym_EQ,
    ACTIONS(5467), 1,
      anon_sym_else,
    STATE(2433), 2,
      sym_line_comment,
      sym_block_comment,
  [75574] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4760), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2434), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3839), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [75594] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    STATE(3118), 1,
      sym_trait_bounds,
    ACTIONS(5469), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2435), 2,
      sym_line_comment,
      sym_block_comment,
  [75618] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2436), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [75638] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(3118), 1,
      sym_trait_bounds,
    ACTIONS(5469), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2437), 2,
      sym_line_comment,
      sym_block_comment,
  [75662] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4467), 1,
      anon_sym_COLON_COLON,
    STATE(1082), 1,
      sym_parameters,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2438), 2,
      sym_line_comment,
      sym_block_comment,
  [75688] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5471), 1,
      anon_sym_RPAREN,
    ACTIONS(5473), 1,
      anon_sym_COMMA,
    STATE(2915), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2439), 2,
      sym_line_comment,
      sym_block_comment,
  [75712] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2440), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5475), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75730] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    STATE(1655), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2441), 2,
      sym_line_comment,
      sym_block_comment,
  [75756] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    ACTIONS(5479), 1,
      anon_sym_STAR,
    STATE(2984), 1,
      sym_use_list,
    ACTIONS(5477), 2,
      sym_identifier,
      sym_super,
    STATE(2442), 2,
      sym_line_comment,
      sym_block_comment,
  [75780] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2443), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3679), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [75798] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5483), 1,
      anon_sym_COMMA,
    ACTIONS(5481), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2444), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_where_clause_repeat1,
  [75818] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5486), 1,
      anon_sym_SEMI,
    STATE(584), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2445), 2,
      sym_line_comment,
      sym_block_comment,
  [75844] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(2990), 1,
      sym_trait_bounds,
    ACTIONS(5488), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2446), 2,
      sym_line_comment,
      sym_block_comment,
  [75868] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5300), 1,
      anon_sym_GT,
    ACTIONS(5302), 1,
      anon_sym_COMMA,
    STATE(2920), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2923), 1,
      sym_trait_bounds,
    STATE(2447), 2,
      sym_line_comment,
      sym_block_comment,
  [75894] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4467), 1,
      anon_sym_COLON_COLON,
    STATE(1604), 1,
      sym_parameters,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2448), 2,
      sym_line_comment,
      sym_block_comment,
  [75920] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_as,
    STATE(2449), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5490), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [75942] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5496), 1,
      anon_sym_SEMI,
    STATE(1294), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2450), 2,
      sym_line_comment,
      sym_block_comment,
  [75968] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5225), 1,
      anon_sym_GT,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    STATE(2999), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3000), 1,
      sym_trait_bounds,
    STATE(2451), 2,
      sym_line_comment,
      sym_block_comment,
  [75994] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5494), 1,
      anon_sym_as,
    ACTIONS(5498), 1,
      anon_sym_COLON_COLON,
    STATE(2452), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5490), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [76016] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5494), 1,
      anon_sym_as,
    ACTIONS(5500), 1,
      anon_sym_COLON_COLON,
    STATE(2453), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5490), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [76038] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5504), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5506), 1,
      anon_sym_as,
    STATE(2454), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5502), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [76060] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4467), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4578), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2582), 1,
      sym_trait_bounds,
    STATE(2455), 2,
      sym_line_comment,
      sym_block_comment,
  [76086] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5510), 1,
      anon_sym_COMMA,
    STATE(2404), 1,
      aux_sym_where_clause_repeat1,
    STATE(2456), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5508), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
  [76108] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5512), 1,
      anon_sym_SEMI,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5516), 1,
      anon_sym_EQ,
    ACTIONS(5518), 1,
      anon_sym_else,
    STATE(2457), 2,
      sym_line_comment,
      sym_block_comment,
  [76134] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    STATE(1774), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2458), 2,
      sym_line_comment,
      sym_block_comment,
  [76160] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5520), 1,
      anon_sym_SEMI,
    ACTIONS(5522), 1,
      anon_sym_COLON,
    ACTIONS(5524), 1,
      anon_sym_EQ,
    ACTIONS(5526), 1,
      anon_sym_else,
    STATE(2459), 2,
      sym_line_comment,
      sym_block_comment,
  [76186] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5528), 1,
      anon_sym_SEMI,
    STATE(531), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2460), 2,
      sym_line_comment,
      sym_block_comment,
  [76212] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2461), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5530), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76230] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4646), 1,
      anon_sym_GT,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    ACTIONS(5532), 1,
      anon_sym_COMMA,
    STATE(2823), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3000), 1,
      sym_trait_bounds,
    STATE(2462), 2,
      sym_line_comment,
      sym_block_comment,
  [76256] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    ACTIONS(5534), 1,
      anon_sym_COMMA,
    STATE(2876), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2463), 2,
      sym_line_comment,
      sym_block_comment,
  [76280] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      anon_sym_SEMI,
    STATE(1238), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2464), 2,
      sym_line_comment,
      sym_block_comment,
  [76306] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2465), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5538), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76324] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2466), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3715), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76342] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_SEMI,
    STATE(1208), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2467), 2,
      sym_line_comment,
      sym_block_comment,
  [76368] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2468), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5542), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76386] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5163), 1,
      anon_sym_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2469), 2,
      sym_line_comment,
      sym_block_comment,
  [76410] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2470), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76428] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2471), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3545), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76446] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2472), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5544), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76464] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5546), 1,
      anon_sym_move,
    STATE(1360), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2473), 2,
      sym_line_comment,
      sym_block_comment,
  [76490] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2474), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3557), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76508] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2475), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3549), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76526] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5548), 1,
      anon_sym_SEMI,
    STATE(1198), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2476), 2,
      sym_line_comment,
      sym_block_comment,
  [76552] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5550), 1,
      anon_sym_SEMI,
    STATE(1179), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2477), 2,
      sym_line_comment,
      sym_block_comment,
  [76578] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5552), 1,
      anon_sym_SEMI,
    STATE(1157), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2478), 2,
      sym_line_comment,
      sym_block_comment,
  [76604] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2479), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3215), 5,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_as,
  [76622] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5554), 1,
      anon_sym_SEMI,
    STATE(632), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2480), 2,
      sym_line_comment,
      sym_block_comment,
  [76648] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    STATE(1108), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2481), 2,
      sym_line_comment,
      sym_block_comment,
  [76674] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2482), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3825), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76692] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5556), 1,
      anon_sym_SEMI,
    STATE(501), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2483), 2,
      sym_line_comment,
      sym_block_comment,
  [76718] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5558), 1,
      anon_sym_SEMI,
    STATE(525), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2484), 2,
      sym_line_comment,
      sym_block_comment,
  [76744] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5560), 1,
      anon_sym_move,
    STATE(1743), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2485), 2,
      sym_line_comment,
      sym_block_comment,
  [76770] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5562), 1,
      anon_sym_SEMI,
    STATE(1402), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2486), 2,
      sym_line_comment,
      sym_block_comment,
  [76796] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_SEMI,
    STATE(1126), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2487), 2,
      sym_line_comment,
      sym_block_comment,
  [76822] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    ACTIONS(5566), 1,
      anon_sym_SEMI,
    STATE(1197), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2488), 2,
      sym_line_comment,
      sym_block_comment,
  [76848] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    ACTIONS(5568), 1,
      anon_sym_COMMA,
    STATE(2974), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2489), 2,
      sym_line_comment,
      sym_block_comment,
  [76872] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(4981), 1,
      anon_sym_LBRACE,
    ACTIONS(5570), 1,
      anon_sym_SEMI,
    STATE(552), 1,
      sym_block,
    STATE(3594), 1,
      sym_label,
    STATE(2490), 2,
      sym_line_comment,
      sym_block_comment,
  [76898] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2491), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5572), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76916] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2492), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5574), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76934] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5576), 1,
      anon_sym_STAR_SLASH,
    ACTIONS(5578), 1,
      sym__outer_block_doc_comment_marker,
    ACTIONS(5580), 1,
      sym__inner_block_doc_comment_marker,
    ACTIONS(5582), 1,
      sym__block_comment_content,
    STATE(3113), 1,
      sym__block_doc_comment_marker,
    STATE(2493), 2,
      sym_line_comment,
      sym_block_comment,
  [76960] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4894), 1,
      anon_sym_LT,
    STATE(2198), 1,
      sym_parameters,
    STATE(3308), 1,
      sym_type_parameters,
    STATE(2494), 2,
      sym_line_comment,
      sym_block_comment,
  [76983] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(684), 1,
      sym_field_declaration_list,
    STATE(3073), 1,
      sym_where_clause,
    STATE(2495), 2,
      sym_line_comment,
      sym_block_comment,
  [77006] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5584), 1,
      anon_sym_DQUOTE,
    STATE(2529), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2496), 2,
      sym_line_comment,
      sym_block_comment,
  [77027] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(372), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2497), 2,
      sym_line_comment,
      sym_block_comment,
  [77050] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(467), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2498), 2,
      sym_line_comment,
      sym_block_comment,
  [77073] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(452), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2499), 2,
      sym_line_comment,
      sym_block_comment,
  [77096] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3406), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2500), 2,
      sym_line_comment,
      sym_block_comment,
  [77119] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5588), 1,
      anon_sym_SEMI,
    ACTIONS(5590), 1,
      anon_sym_EQ,
    ACTIONS(5592), 1,
      anon_sym_else,
    STATE(2501), 2,
      sym_line_comment,
      sym_block_comment,
  [77142] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5594), 1,
      anon_sym_RPAREN,
    ACTIONS(5596), 1,
      anon_sym_COMMA,
    STATE(2805), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2502), 2,
      sym_line_comment,
      sym_block_comment,
  [77165] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(543), 1,
      sym_declaration_list,
    STATE(3246), 1,
      sym_where_clause,
    STATE(2503), 2,
      sym_line_comment,
      sym_block_comment,
  [77188] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5598), 1,
      anon_sym_SEMI,
    STATE(3375), 1,
      sym_where_clause,
    STATE(2504), 2,
      sym_line_comment,
      sym_block_comment,
  [77211] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(1167), 1,
      sym_declaration_list,
    STATE(3039), 1,
      sym_where_clause,
    STATE(2505), 2,
      sym_line_comment,
      sym_block_comment,
  [77234] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1756), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2506), 2,
      sym_line_comment,
      sym_block_comment,
  [77257] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5600), 1,
      anon_sym_SEMI,
    STATE(3398), 1,
      sym_where_clause,
    STATE(2507), 2,
      sym_line_comment,
      sym_block_comment,
  [77280] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5604), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2508), 2,
      sym_line_comment,
      sym_block_comment,
  [77303] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4646), 1,
      anon_sym_GT,
    ACTIONS(5532), 1,
      anon_sym_COMMA,
    ACTIONS(5606), 1,
      anon_sym_EQ,
    STATE(2823), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2509), 2,
      sym_line_comment,
      sym_block_comment,
  [77326] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5608), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2510), 2,
      sym_line_comment,
      sym_block_comment,
  [77349] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5610), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2511), 2,
      sym_line_comment,
      sym_block_comment,
  [77372] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    ACTIONS(4095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4814), 1,
      anon_sym_BANG,
    STATE(1598), 1,
      sym_type_arguments,
    STATE(2512), 2,
      sym_line_comment,
      sym_block_comment,
  [77395] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(597), 1,
      sym_declaration_list,
    STATE(3266), 1,
      sym_where_clause,
    STATE(2513), 2,
      sym_line_comment,
      sym_block_comment,
  [77418] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(453), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2514), 2,
      sym_line_comment,
      sym_block_comment,
  [77441] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2515), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4257), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_SQUOTE,
  [77458] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5612), 1,
      anon_sym_LPAREN,
    ACTIONS(5614), 1,
      anon_sym_LBRACK,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    STATE(1959), 1,
      sym_delim_token_tree,
    STATE(2516), 2,
      sym_line_comment,
      sym_block_comment,
  [77481] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(390), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2517), 2,
      sym_line_comment,
      sym_block_comment,
  [77504] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3150), 1,
      sym_type_arguments,
    ACTIONS(5151), 2,
      sym_identifier,
      sym_super,
    STATE(2518), 2,
      sym_line_comment,
      sym_block_comment,
  [77525] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3164), 1,
      sym_type_arguments,
    ACTIONS(5151), 2,
      sym_identifier,
      sym_super,
    STATE(2519), 2,
      sym_line_comment,
      sym_block_comment,
  [77546] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5618), 1,
      anon_sym_DQUOTE,
    STATE(2653), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2520), 2,
      sym_line_comment,
      sym_block_comment,
  [77567] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(446), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2521), 2,
      sym_line_comment,
      sym_block_comment,
  [77590] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2577), 1,
      sym_trait_bounds,
    STATE(2522), 2,
      sym_line_comment,
      sym_block_comment,
  [77613] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(458), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2523), 2,
      sym_line_comment,
      sym_block_comment,
  [77636] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5269), 1,
      anon_sym_LBRACE,
    STATE(614), 1,
      sym_enum_variant_list,
    STATE(3281), 1,
      sym_where_clause,
    STATE(2524), 2,
      sym_line_comment,
      sym_block_comment,
  [77659] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5620), 1,
      anon_sym_COLON_COLON,
    STATE(2525), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4694), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77678] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 1,
      anon_sym_COLON_COLON,
    STATE(2526), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4694), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77697] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5624), 1,
      anon_sym_COLON_COLON,
    STATE(2527), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4694), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77716] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5626), 1,
      anon_sym_COLON_COLON,
    STATE(2528), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4726), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77735] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5628), 1,
      anon_sym_DQUOTE,
    STATE(2685), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2529), 2,
      sym_line_comment,
      sym_block_comment,
  [77756] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5612), 1,
      anon_sym_LPAREN,
    ACTIONS(5614), 1,
      anon_sym_LBRACK,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    STATE(1964), 1,
      sym_delim_token_tree,
    STATE(2530), 2,
      sym_line_comment,
      sym_block_comment,
  [77779] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    ACTIONS(5630), 1,
      sym_identifier,
    ACTIONS(5632), 1,
      sym_super,
    STATE(1550), 1,
      sym_type_arguments,
    STATE(2531), 2,
      sym_line_comment,
      sym_block_comment,
  [77802] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    ACTIONS(5630), 1,
      sym_identifier,
    ACTIONS(5632), 1,
      sym_super,
    STATE(1558), 1,
      sym_type_arguments,
    STATE(2532), 2,
      sym_line_comment,
      sym_block_comment,
  [77825] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(625), 1,
      sym_field_declaration_list,
    STATE(3297), 1,
      sym_where_clause,
    STATE(2533), 2,
      sym_line_comment,
      sym_block_comment,
  [77848] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5620), 1,
      anon_sym_COLON_COLON,
    STATE(2534), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4668), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77867] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 1,
      anon_sym_COLON_COLON,
    STATE(2535), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4668), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5624), 1,
      anon_sym_COLON_COLON,
    STATE(2536), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4668), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77905] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5626), 1,
      anon_sym_COLON_COLON,
    STATE(2537), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4748), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77924] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5634), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2538), 2,
      sym_line_comment,
      sym_block_comment,
  [77947] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5634), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2539), 2,
      sym_line_comment,
      sym_block_comment,
  [77970] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(395), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2540), 2,
      sym_line_comment,
      sym_block_comment,
  [77993] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5636), 1,
      anon_sym_RPAREN,
    ACTIONS(5638), 1,
      anon_sym_COMMA,
    STATE(2937), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2541), 2,
      sym_line_comment,
      sym_block_comment,
  [78016] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(1376), 1,
      sym_declaration_list,
    STATE(3067), 1,
      sym_where_clause,
    STATE(2542), 2,
      sym_line_comment,
      sym_block_comment,
  [78039] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    STATE(2543), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5640), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [78058] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5642), 1,
      anon_sym_SEMI,
    STATE(3579), 1,
      sym_where_clause,
    STATE(2544), 2,
      sym_line_comment,
      sym_block_comment,
  [78081] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1575), 1,
      sym_parameters,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2545), 2,
      sym_line_comment,
      sym_block_comment,
  [78104] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2546), 2,
      sym_line_comment,
      sym_block_comment,
  [78127] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5644), 1,
      anon_sym_LPAREN,
    ACTIONS(5646), 1,
      anon_sym_LBRACK,
    ACTIONS(5648), 1,
      anon_sym_LBRACE,
    STATE(2729), 1,
      sym_token_tree,
    STATE(2547), 2,
      sym_line_comment,
      sym_block_comment,
  [78150] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3150), 1,
      sym_type_arguments,
    ACTIONS(5650), 2,
      sym_identifier,
      sym_super,
    STATE(2548), 2,
      sym_line_comment,
      sym_block_comment,
  [78171] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(1434), 1,
      sym_declaration_list,
    STATE(3075), 1,
      sym_where_clause,
    STATE(2549), 2,
      sym_line_comment,
      sym_block_comment,
  [78194] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3164), 1,
      sym_type_arguments,
    ACTIONS(5650), 2,
      sym_identifier,
      sym_super,
    STATE(2550), 2,
      sym_line_comment,
      sym_block_comment,
  [78215] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5652), 1,
      anon_sym_SEMI,
    STATE(3575), 1,
      sym_where_clause,
    STATE(2551), 2,
      sym_line_comment,
      sym_block_comment,
  [78238] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5654), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2552), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5656), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [78257] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5471), 1,
      anon_sym_RPAREN,
    ACTIONS(5473), 1,
      anon_sym_COMMA,
    STATE(2915), 1,
      aux_sym_parameters_repeat1,
    STATE(2553), 2,
      sym_line_comment,
      sym_block_comment,
  [78280] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5658), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2554), 2,
      sym_line_comment,
      sym_block_comment,
  [78303] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5660), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2555), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5662), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [78322] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5457), 1,
      anon_sym_RPAREN,
    ACTIONS(5459), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym_parameters_repeat1,
    STATE(2556), 2,
      sym_line_comment,
      sym_block_comment,
  [78345] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(455), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2557), 2,
      sym_line_comment,
      sym_block_comment,
  [78368] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5664), 1,
      anon_sym_SEMI,
    ACTIONS(5666), 1,
      anon_sym_EQ,
    ACTIONS(5668), 1,
      anon_sym_else,
    STATE(2558), 2,
      sym_line_comment,
      sym_block_comment,
  [78391] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5670), 1,
      anon_sym_RPAREN,
    ACTIONS(5672), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2559), 2,
      sym_line_comment,
      sym_block_comment,
  [78414] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    STATE(2560), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5674), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [78433] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5676), 1,
      anon_sym_COMMA,
    ACTIONS(5674), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2561), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_slice_pattern_repeat1,
  [78452] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3576), 1,
      sym_block,
    STATE(2562), 2,
      sym_line_comment,
      sym_block_comment,
  [78475] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5568), 1,
      anon_sym_COMMA,
    STATE(2974), 1,
      aux_sym_parameters_repeat1,
    STATE(2563), 2,
      sym_line_comment,
      sym_block_comment,
  [78498] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2564), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(865), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [78515] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5679), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2565), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5681), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [78534] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2566), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3215), 4,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
  [78551] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5683), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2567), 2,
      sym_line_comment,
      sym_block_comment,
  [78574] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    STATE(2568), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5685), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [78593] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5534), 1,
      anon_sym_COMMA,
    STATE(2876), 1,
      aux_sym_parameters_repeat1,
    STATE(2569), 2,
      sym_line_comment,
      sym_block_comment,
  [78616] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5687), 1,
      anon_sym_COLON,
    STATE(2570), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4778), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [78635] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5409), 1,
      anon_sym_COMMA,
    STATE(2762), 1,
      aux_sym_parameters_repeat1,
    STATE(2571), 2,
      sym_line_comment,
      sym_block_comment,
  [78658] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1754), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2572), 2,
      sym_line_comment,
      sym_block_comment,
  [78681] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1106), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2573), 2,
      sym_line_comment,
      sym_block_comment,
  [78704] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2574), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(901), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [78721] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1759), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2575), 2,
      sym_line_comment,
      sym_block_comment,
  [78744] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5689), 1,
      anon_sym_DQUOTE,
    STATE(2599), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2576), 2,
      sym_line_comment,
      sym_block_comment,
  [78765] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2577), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5691), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [78782] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1122), 1,
      sym_field_declaration_list,
    STATE(3110), 1,
      sym_where_clause,
    STATE(2578), 2,
      sym_line_comment,
      sym_block_comment,
  [78805] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3574), 1,
      sym_block,
    STATE(2579), 2,
      sym_line_comment,
      sym_block_comment,
  [78828] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4724), 1,
      anon_sym_for,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2580), 2,
      sym_line_comment,
      sym_block_comment,
  [78851] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(473), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2581), 2,
      sym_line_comment,
      sym_block_comment,
  [78874] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2582), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5693), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [78891] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5285), 1,
      anon_sym_LBRACE,
    STATE(1141), 1,
      sym_enum_variant_list,
    STATE(3119), 1,
      sym_where_clause,
    STATE(2583), 2,
      sym_line_comment,
      sym_block_comment,
  [78914] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5695), 1,
      anon_sym_LBRACE,
    ACTIONS(5697), 1,
      anon_sym_for,
    ACTIONS(5699), 1,
      anon_sym_loop,
    ACTIONS(5701), 1,
      anon_sym_while,
    STATE(2584), 2,
      sym_line_comment,
      sym_block_comment,
  [78937] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(3000), 1,
      sym_trait_bounds,
    ACTIONS(5703), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2585), 2,
      sym_line_comment,
      sym_block_comment,
  [78958] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5217), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2586), 2,
      sym_line_comment,
      sym_block_comment,
  [78979] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1793), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2587), 2,
      sym_line_comment,
      sym_block_comment,
  [79002] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5706), 1,
      anon_sym_LPAREN,
    ACTIONS(5708), 1,
      anon_sym_LBRACK,
    ACTIONS(5710), 1,
      anon_sym_LBRACE,
    STATE(1022), 1,
      sym_delim_token_tree,
    STATE(2588), 2,
      sym_line_comment,
      sym_block_comment,
  [79025] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(1148), 1,
      sym_declaration_list,
    STATE(3131), 1,
      sym_where_clause,
    STATE(2589), 2,
      sym_line_comment,
      sym_block_comment,
  [79048] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5712), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2590), 2,
      sym_line_comment,
      sym_block_comment,
  [79067] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1551), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2591), 2,
      sym_line_comment,
      sym_block_comment,
  [79090] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(3000), 1,
      sym_trait_bounds,
    ACTIONS(5714), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2592), 2,
      sym_line_comment,
      sym_block_comment,
  [79111] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1371), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2593), 2,
      sym_line_comment,
      sym_block_comment,
  [79134] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    STATE(2594), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5716), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
  [79153] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1671), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2595), 2,
      sym_line_comment,
      sym_block_comment,
  [79176] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1381), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2596), 2,
      sym_line_comment,
      sym_block_comment,
  [79199] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5718), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2597), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5720), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [79218] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2598), 2,
      sym_line_comment,
      sym_block_comment,
  [79239] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5722), 1,
      anon_sym_DQUOTE,
    STATE(2685), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2599), 2,
      sym_line_comment,
      sym_block_comment,
  [79260] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1372), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2600), 2,
      sym_line_comment,
      sym_block_comment,
  [79283] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5724), 1,
      anon_sym_LBRACE,
    ACTIONS(5726), 1,
      anon_sym_for,
    ACTIONS(5728), 1,
      anon_sym_loop,
    ACTIONS(5730), 1,
      anon_sym_while,
    STATE(2601), 2,
      sym_line_comment,
      sym_block_comment,
  [79306] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1382), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2602), 2,
      sym_line_comment,
      sym_block_comment,
  [79329] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5732), 1,
      anon_sym_DQUOTE,
    STATE(2656), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2603), 2,
      sym_line_comment,
      sym_block_comment,
  [79350] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5706), 1,
      anon_sym_LPAREN,
    ACTIONS(5708), 1,
      anon_sym_LBRACK,
    ACTIONS(5710), 1,
      anon_sym_LBRACE,
    STATE(1020), 1,
      sym_delim_token_tree,
    STATE(2604), 2,
      sym_line_comment,
      sym_block_comment,
  [79373] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5734), 1,
      anon_sym_SEMI,
    STATE(3478), 1,
      sym_where_clause,
    STATE(2605), 2,
      sym_line_comment,
      sym_block_comment,
  [79396] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(5419), 1,
      anon_sym_PIPE,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(2769), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2606), 2,
      sym_line_comment,
      sym_block_comment,
  [79419] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5197), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2607), 2,
      sym_line_comment,
      sym_block_comment,
  [79440] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(490), 1,
      sym_declaration_list,
    STATE(3079), 1,
      sym_where_clause,
    STATE(2608), 2,
      sym_line_comment,
      sym_block_comment,
  [79463] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1564), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym_block,
    STATE(3590), 1,
      sym_label,
    STATE(2609), 2,
      sym_line_comment,
      sym_block_comment,
  [79486] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(1164), 1,
      sym_declaration_list,
    STATE(3138), 1,
      sym_where_clause,
    STATE(2610), 2,
      sym_line_comment,
      sym_block_comment,
  [79509] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(469), 1,
      sym_block,
    STATE(3598), 1,
      sym_label,
    STATE(2611), 2,
      sym_line_comment,
      sym_block_comment,
  [79532] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4552), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    STATE(2612), 2,
      sym_line_comment,
      sym_block_comment,
  [79555] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5369), 1,
      anon_sym_RPAREN,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5375), 1,
      anon_sym_COMMA,
    STATE(2898), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2613), 2,
      sym_line_comment,
      sym_block_comment,
  [79578] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3603), 1,
      sym_block,
    STATE(2614), 2,
      sym_line_comment,
      sym_block_comment,
  [79601] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5736), 1,
      anon_sym_SEMI,
    STATE(3570), 1,
      sym_where_clause,
    STATE(2615), 2,
      sym_line_comment,
      sym_block_comment,
  [79624] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3400), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2616), 2,
      sym_line_comment,
      sym_block_comment,
  [79647] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(399), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2617), 2,
      sym_line_comment,
      sym_block_comment,
  [79670] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5738), 1,
      anon_sym_LPAREN,
    ACTIONS(5740), 1,
      anon_sym_LBRACK,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(371), 1,
      sym_delim_token_tree,
    STATE(2618), 2,
      sym_line_comment,
      sym_block_comment,
  [79693] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5744), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2619), 2,
      sym_line_comment,
      sym_block_comment,
  [79716] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3612), 1,
      sym_block,
    STATE(2620), 2,
      sym_line_comment,
      sym_block_comment,
  [79739] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3552), 1,
      sym_block,
    STATE(2621), 2,
      sym_line_comment,
      sym_block_comment,
  [79762] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4894), 1,
      anon_sym_LT,
    STATE(2213), 1,
      sym_parameters,
    STATE(3280), 1,
      sym_type_parameters,
    STATE(2622), 2,
      sym_line_comment,
      sym_block_comment,
  [79785] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4598), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5746), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4600), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2623), 2,
      sym_line_comment,
      sym_block_comment,
  [79806] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5744), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2624), 2,
      sym_line_comment,
      sym_block_comment,
  [79829] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1680), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2625), 2,
      sym_line_comment,
      sym_block_comment,
  [79852] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5748), 1,
      anon_sym_COMMA,
    ACTIONS(4117), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2626), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_arguments_repeat1,
  [79871] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1794), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2627), 2,
      sym_line_comment,
      sym_block_comment,
  [79894] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(244), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2628), 2,
      sym_line_comment,
      sym_block_comment,
  [79917] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5751), 1,
      anon_sym_DQUOTE,
    STATE(2652), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2629), 2,
      sym_line_comment,
      sym_block_comment,
  [79938] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5753), 1,
      anon_sym_in,
    STATE(2630), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5755), 3,
      sym_self,
      sym_super,
      sym_crate,
  [79957] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5757), 1,
      anon_sym_SEMI,
    ACTIONS(5759), 1,
      anon_sym_EQ,
    ACTIONS(5761), 1,
      anon_sym_else,
    STATE(2631), 2,
      sym_line_comment,
      sym_block_comment,
  [79980] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4844), 1,
      anon_sym_BANG,
    STATE(1075), 1,
      sym_type_arguments,
    STATE(2632), 2,
      sym_line_comment,
      sym_block_comment,
  [80003] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5763), 1,
      anon_sym_RPAREN,
    ACTIONS(5765), 1,
      anon_sym_COMMA,
    STATE(2865), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2633), 2,
      sym_line_comment,
      sym_block_comment,
  [80026] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3569), 1,
      sym_block,
    STATE(2634), 2,
      sym_line_comment,
      sym_block_comment,
  [80049] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4652), 1,
      anon_sym_GT,
    ACTIONS(5388), 1,
      anon_sym_COMMA,
    ACTIONS(5606), 1,
      anon_sym_EQ,
    STATE(2917), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2635), 2,
      sym_line_comment,
      sym_block_comment,
  [80072] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1468), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2636), 2,
      sym_line_comment,
      sym_block_comment,
  [80095] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5767), 1,
      anon_sym_SEMI,
    ACTIONS(5769), 1,
      anon_sym_EQ,
    ACTIONS(5771), 1,
      anon_sym_else,
    STATE(2637), 2,
      sym_line_comment,
      sym_block_comment,
  [80118] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    STATE(1470), 1,
      sym_delim_token_tree,
    STATE(2638), 2,
      sym_line_comment,
      sym_block_comment,
  [80141] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1806), 1,
      sym_block,
    STATE(3599), 1,
      sym_label,
    STATE(2639), 2,
      sym_line_comment,
      sym_block_comment,
  [80164] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3568), 1,
      sym_block,
    STATE(2640), 2,
      sym_line_comment,
      sym_block_comment,
  [80187] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3426), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2641), 2,
      sym_line_comment,
      sym_block_comment,
  [80210] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1048), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2642), 2,
      sym_line_comment,
      sym_block_comment,
  [80233] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3433), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2643), 2,
      sym_line_comment,
      sym_block_comment,
  [80256] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4263), 1,
      anon_sym_LBRACE,
    STATE(2767), 1,
      sym_use_list,
    ACTIONS(5773), 2,
      sym_identifier,
      sym_super,
    STATE(2644), 2,
      sym_line_comment,
      sym_block_comment,
  [80277] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(393), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2645), 2,
      sym_line_comment,
      sym_block_comment,
  [80300] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5775), 1,
      anon_sym_LPAREN,
    ACTIONS(5777), 1,
      anon_sym_LBRACK,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    STATE(1814), 1,
      sym_delim_token_tree,
    STATE(2646), 2,
      sym_line_comment,
      sym_block_comment,
  [80323] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4894), 1,
      anon_sym_LT,
    STATE(2195), 1,
      sym_parameters,
    STATE(3163), 1,
      sym_type_parameters,
    STATE(2647), 2,
      sym_line_comment,
      sym_block_comment,
  [80346] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(376), 1,
      sym_block,
    STATE(3457), 1,
      sym_label,
    STATE(2648), 2,
      sym_line_comment,
      sym_block_comment,
  [80369] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5781), 1,
      anon_sym_RPAREN,
    ACTIONS(5783), 1,
      anon_sym_COMMA,
    STATE(2815), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2649), 2,
      sym_line_comment,
      sym_block_comment,
  [80392] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3559), 1,
      sym_block,
    STATE(2650), 2,
      sym_line_comment,
      sym_block_comment,
  [80415] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3557), 1,
      sym_block,
    STATE(2651), 2,
      sym_line_comment,
      sym_block_comment,
  [80438] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5785), 1,
      anon_sym_DQUOTE,
    STATE(2685), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2652), 2,
      sym_line_comment,
      sym_block_comment,
  [80459] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5787), 1,
      anon_sym_DQUOTE,
    STATE(2685), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2653), 2,
      sym_line_comment,
      sym_block_comment,
  [80480] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1445), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2654), 2,
      sym_line_comment,
      sym_block_comment,
  [80503] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5775), 1,
      anon_sym_LPAREN,
    ACTIONS(5777), 1,
      anon_sym_LBRACK,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    STATE(1782), 1,
      sym_delim_token_tree,
    STATE(2655), 2,
      sym_line_comment,
      sym_block_comment,
  [80526] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5789), 1,
      anon_sym_DQUOTE,
    STATE(2685), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2656), 2,
      sym_line_comment,
      sym_block_comment,
  [80547] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(3000), 1,
      sym_trait_bounds,
    ACTIONS(5791), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2657), 2,
      sym_line_comment,
      sym_block_comment,
  [80568] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    STATE(1444), 1,
      sym_delim_token_tree,
    STATE(2658), 2,
      sym_line_comment,
      sym_block_comment,
  [80591] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5793), 1,
      sym_identifier,
    STATE(1548), 1,
      sym_type_arguments,
    STATE(2659), 2,
      sym_line_comment,
      sym_block_comment,
  [80614] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5738), 1,
      anon_sym_LPAREN,
    ACTIONS(5740), 1,
      anon_sym_LBRACK,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(389), 1,
      sym_delim_token_tree,
    STATE(2660), 2,
      sym_line_comment,
      sym_block_comment,
  [80637] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2661), 2,
      sym_line_comment,
      sym_block_comment,
  [80660] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5797), 1,
      sym_identifier,
    STATE(1437), 1,
      sym_type_arguments,
    STATE(2662), 2,
      sym_line_comment,
      sym_block_comment,
  [80683] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3462), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2663), 2,
      sym_line_comment,
      sym_block_comment,
  [80706] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3150), 1,
      sym_type_arguments,
    ACTIONS(5799), 2,
      sym_identifier,
      sym_super,
    STATE(2664), 2,
      sym_line_comment,
      sym_block_comment,
  [80727] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3164), 1,
      sym_type_arguments,
    ACTIONS(5799), 2,
      sym_identifier,
      sym_super,
    STATE(2665), 2,
      sym_line_comment,
      sym_block_comment,
  [80748] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2666), 2,
      sym_line_comment,
      sym_block_comment,
  [80771] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4894), 1,
      anon_sym_LT,
    STATE(2194), 1,
      sym_parameters,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(2667), 2,
      sym_line_comment,
      sym_block_comment,
  [80794] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5793), 1,
      sym_identifier,
    STATE(1557), 1,
      sym_type_arguments,
    STATE(2668), 2,
      sym_line_comment,
      sym_block_comment,
  [80817] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5797), 1,
      sym_identifier,
    STATE(1419), 1,
      sym_type_arguments,
    STATE(2669), 2,
      sym_line_comment,
      sym_block_comment,
  [80840] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5429), 1,
      anon_sym_RPAREN,
    ACTIONS(5431), 1,
      anon_sym_COMMA,
    STATE(2901), 1,
      aux_sym_parameters_repeat1,
    STATE(2670), 2,
      sym_line_comment,
      sym_block_comment,
  [80863] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2671), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5481), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [80880] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5801), 1,
      anon_sym_DQUOTE,
    STATE(2674), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2672), 2,
      sym_line_comment,
      sym_block_comment,
  [80901] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5803), 1,
      anon_sym_SEMI,
    STATE(3364), 1,
      sym_where_clause,
    STATE(2673), 2,
      sym_line_comment,
      sym_block_comment,
  [80924] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5805), 1,
      anon_sym_DQUOTE,
    STATE(2685), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5586), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2674), 2,
      sym_line_comment,
      sym_block_comment,
  [80945] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5807), 1,
      anon_sym_RPAREN,
    ACTIONS(5809), 1,
      anon_sym_COMMA,
    STATE(2894), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2675), 2,
      sym_line_comment,
      sym_block_comment,
  [80968] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_for,
    ACTIONS(5815), 1,
      anon_sym_loop,
    ACTIONS(5817), 1,
      anon_sym_while,
    STATE(2676), 2,
      sym_line_comment,
      sym_block_comment,
  [80991] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5819), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2677), 2,
      sym_line_comment,
      sym_block_comment,
  [81014] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5819), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2678), 2,
      sym_line_comment,
      sym_block_comment,
  [81037] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4894), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_parameters,
    STATE(3198), 1,
      sym_type_parameters,
    STATE(2679), 2,
      sym_line_comment,
      sym_block_comment,
  [81060] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_RPAREN,
    ACTIONS(5823), 1,
      anon_sym_COMMA,
    STATE(2890), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2680), 2,
      sym_line_comment,
      sym_block_comment,
  [81083] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5825), 1,
      anon_sym_RPAREN,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    STATE(2773), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2681), 2,
      sym_line_comment,
      sym_block_comment,
  [81106] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5829), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2682), 2,
      sym_line_comment,
      sym_block_comment,
  [81129] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_RBRACK,
    ACTIONS(5833), 1,
      anon_sym_COMMA,
    STATE(2775), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2683), 2,
      sym_line_comment,
      sym_block_comment,
  [81152] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5835), 1,
      anon_sym_RPAREN,
    ACTIONS(5837), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2684), 2,
      sym_line_comment,
      sym_block_comment,
  [81175] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5839), 1,
      anon_sym_DQUOTE,
    ACTIONS(5841), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2685), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_string_literal_repeat1,
  [81194] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3407), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2686), 2,
      sym_line_comment,
      sym_block_comment,
  [81217] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5634), 1,
      sym_identifier,
    ACTIONS(5650), 1,
      sym_super,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2687), 2,
      sym_line_comment,
      sym_block_comment,
  [81240] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5844), 1,
      anon_sym_RBRACK,
    ACTIONS(5846), 1,
      anon_sym_COMMA,
    STATE(2836), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2688), 2,
      sym_line_comment,
      sym_block_comment,
  [81263] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5848), 1,
      anon_sym_COLON,
    STATE(2689), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4778), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [81282] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5744), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2690), 2,
      sym_line_comment,
      sym_block_comment,
  [81305] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(694), 1,
      sym_declaration_list,
    STATE(3149), 1,
      sym_where_clause,
    STATE(2691), 2,
      sym_line_comment,
      sym_block_comment,
  [81328] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5634), 1,
      sym_identifier,
    ACTIONS(5650), 1,
      sym_super,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2692), 2,
      sym_line_comment,
      sym_block_comment,
  [81351] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5744), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2693), 2,
      sym_line_comment,
      sym_block_comment,
  [81374] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5850), 1,
      anon_sym_RPAREN,
    ACTIONS(5852), 1,
      anon_sym_COMMA,
    STATE(2788), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2694), 2,
      sym_line_comment,
      sym_block_comment,
  [81397] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    ACTIONS(5009), 1,
      anon_sym_LBRACE,
    STATE(2922), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2695), 2,
      sym_line_comment,
      sym_block_comment,
  [81420] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5799), 1,
      sym_super,
    ACTIONS(5854), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2696), 2,
      sym_line_comment,
      sym_block_comment,
  [81443] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5856), 1,
      anon_sym_RPAREN,
    ACTIONS(5858), 1,
      anon_sym_COMMA,
    STATE(2924), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2697), 2,
      sym_line_comment,
      sym_block_comment,
  [81466] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5799), 1,
      sym_super,
    ACTIONS(5854), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2698), 2,
      sym_line_comment,
      sym_block_comment,
  [81489] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(693), 1,
      sym_declaration_list,
    STATE(3054), 1,
      sym_where_clause,
    STATE(2699), 2,
      sym_line_comment,
      sym_block_comment,
  [81512] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2700), 2,
      sym_line_comment,
      sym_block_comment,
  [81535] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(1285), 1,
      sym_block,
    STATE(3547), 1,
      sym_label,
    STATE(2701), 2,
      sym_line_comment,
      sym_block_comment,
  [81558] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4451), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5860), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2702), 2,
      sym_line_comment,
      sym_block_comment,
  [81577] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2703), 2,
      sym_line_comment,
      sym_block_comment,
  [81600] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5862), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2704), 2,
      sym_line_comment,
      sym_block_comment,
  [81623] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5864), 1,
      anon_sym_LBRACE,
    ACTIONS(5866), 1,
      anon_sym_for,
    ACTIONS(5868), 1,
      anon_sym_loop,
    ACTIONS(5870), 1,
      anon_sym_while,
    STATE(2705), 2,
      sym_line_comment,
      sym_block_comment,
  [81646] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5872), 1,
      anon_sym_SEMI,
    STATE(3313), 1,
      sym_where_clause,
    STATE(2706), 2,
      sym_line_comment,
      sym_block_comment,
  [81669] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5862), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2707), 2,
      sym_line_comment,
      sym_block_comment,
  [81692] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1090), 1,
      sym_parameters,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2708), 2,
      sym_line_comment,
      sym_block_comment,
  [81715] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(1956), 1,
      sym_parameters,
    STATE(2709), 2,
      sym_line_comment,
      sym_block_comment,
  [81738] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5874), 1,
      anon_sym_in,
    STATE(2710), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5876), 3,
      sym_self,
      sym_super,
      sym_crate,
  [81757] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4894), 1,
      anon_sym_LT,
    STATE(2190), 1,
      sym_parameters,
    STATE(3245), 1,
      sym_type_parameters,
    STATE(2711), 2,
      sym_line_comment,
      sym_block_comment,
  [81780] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5878), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2712), 2,
      sym_line_comment,
      sym_block_comment,
  [81803] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5878), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2713), 2,
      sym_line_comment,
      sym_block_comment,
  [81826] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2714), 2,
      sym_line_comment,
      sym_block_comment,
  [81849] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5269), 1,
      anon_sym_LBRACE,
    STATE(739), 1,
      sym_enum_variant_list,
    STATE(3086), 1,
      sym_where_clause,
    STATE(2715), 2,
      sym_line_comment,
      sym_block_comment,
  [81872] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5285), 1,
      anon_sym_LBRACE,
    STATE(1361), 1,
      sym_enum_variant_list,
    STATE(3226), 1,
      sym_where_clause,
    STATE(2716), 2,
      sym_line_comment,
      sym_block_comment,
  [81895] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(646), 1,
      sym_declaration_list,
    STATE(3142), 1,
      sym_where_clause,
    STATE(2717), 2,
      sym_line_comment,
      sym_block_comment,
  [81918] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2718), 2,
      sym_line_comment,
      sym_block_comment,
  [81941] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_type_arguments,
    STATE(2719), 2,
      sym_line_comment,
      sym_block_comment,
  [81964] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5413), 1,
      anon_sym_GT,
    ACTIONS(5415), 1,
      anon_sym_COMMA,
    ACTIONS(5606), 1,
      anon_sym_EQ,
    STATE(2818), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2720), 2,
      sym_line_comment,
      sym_block_comment,
  [81987] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(3118), 1,
      sym_trait_bounds,
    ACTIONS(5469), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2721), 2,
      sym_line_comment,
      sym_block_comment,
  [82008] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3150), 1,
      sym_type_arguments,
    STATE(2722), 2,
      sym_line_comment,
      sym_block_comment,
  [82031] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    STATE(2723), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5882), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
  [82050] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4463), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2724), 2,
      sym_line_comment,
      sym_block_comment,
  [82071] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4720), 1,
      anon_sym_for,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2725), 2,
      sym_line_comment,
      sym_block_comment,
  [82094] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3446), 1,
      anon_sym_SQUOTE,
    STATE(3547), 1,
      sym_label,
    STATE(3596), 1,
      sym_block,
    STATE(2726), 2,
      sym_line_comment,
      sym_block_comment,
  [82117] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1317), 1,
      sym_field_declaration_list,
    STATE(3186), 1,
      sym_where_clause,
    STATE(2727), 2,
      sym_line_comment,
      sym_block_comment,
  [82140] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5225), 1,
      anon_sym_GT,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5606), 1,
      anon_sym_EQ,
    STATE(2999), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2728), 2,
      sym_line_comment,
      sym_block_comment,
  [82163] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2729), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5884), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [82180] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(4896), 1,
      anon_sym_where,
    STATE(1327), 1,
      sym_declaration_list,
    STATE(3194), 1,
      sym_where_clause,
    STATE(2730), 2,
      sym_line_comment,
      sym_block_comment,
  [82203] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(5886), 1,
      anon_sym_COLON_COLON,
    STATE(1289), 1,
      sym_field_initializer_list,
    STATE(2731), 2,
      sym_line_comment,
      sym_block_comment,
  [82223] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4901), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2732), 2,
      sym_line_comment,
      sym_block_comment,
  [82243] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5225), 1,
      anon_sym_GT,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    STATE(2999), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2733), 2,
      sym_line_comment,
      sym_block_comment,
  [82263] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5888), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_where_clause,
    STATE(2734), 2,
      sym_line_comment,
      sym_block_comment,
  [82283] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5890), 1,
      anon_sym_LPAREN,
    ACTIONS(5892), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      anon_sym_LBRACE,
    STATE(2735), 2,
      sym_line_comment,
      sym_block_comment,
  [82303] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(5896), 1,
      anon_sym_SEMI,
    STATE(743), 1,
      sym_declaration_list,
    STATE(2736), 2,
      sym_line_comment,
      sym_block_comment,
  [82323] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5898), 1,
      anon_sym_SEMI,
    STATE(3424), 1,
      sym_where_clause,
    STATE(2737), 2,
      sym_line_comment,
      sym_block_comment,
  [82343] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1015), 1,
      anon_sym_RPAREN,
    ACTIONS(5900), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2738), 2,
      sym_line_comment,
      sym_block_comment,
  [82363] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5902), 1,
      anon_sym_LPAREN,
    ACTIONS(5904), 1,
      anon_sym_LBRACK,
    ACTIONS(5906), 1,
      anon_sym_LBRACE,
    STATE(2739), 2,
      sym_line_comment,
      sym_block_comment,
  [82383] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5908), 1,
      anon_sym_SEMI,
    STATE(3583), 1,
      sym_where_clause,
    STATE(2740), 2,
      sym_line_comment,
      sym_block_comment,
  [82403] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(5910), 1,
      anon_sym_SEMI,
    STATE(1344), 1,
      sym_declaration_list,
    STATE(2741), 2,
      sym_line_comment,
      sym_block_comment,
  [82423] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5413), 1,
      anon_sym_GT,
    ACTIONS(5415), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2742), 2,
      sym_line_comment,
      sym_block_comment,
  [82443] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5912), 1,
      anon_sym_RBRACE,
    ACTIONS(5914), 1,
      anon_sym_COMMA,
    STATE(2855), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2743), 2,
      sym_line_comment,
      sym_block_comment,
  [82463] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5916), 1,
      anon_sym_LBRACE,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2744), 2,
      sym_line_comment,
      sym_block_comment,
  [82483] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1594), 1,
      anon_sym_GT,
    ACTIONS(5918), 1,
      anon_sym_COMMA,
    STATE(2747), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2745), 2,
      sym_line_comment,
      sym_block_comment,
  [82503] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(5920), 1,
      anon_sym_SEMI,
    STATE(1297), 1,
      sym_declaration_list,
    STATE(2746), 2,
      sym_line_comment,
      sym_block_comment,
  [82523] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5469), 1,
      anon_sym_GT,
    ACTIONS(5922), 1,
      anon_sym_COMMA,
    STATE(2747), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_arguments_repeat1,
  [82541] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5927), 1,
      anon_sym_COLON,
    ACTIONS(5925), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2748), 2,
      sym_line_comment,
      sym_block_comment,
  [82559] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5929), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2749), 2,
      sym_line_comment,
      sym_block_comment,
  [82577] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5931), 1,
      anon_sym_RBRACE,
    ACTIONS(5933), 1,
      anon_sym_COMMA,
    STATE(2750), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_struct_pattern_repeat1,
  [82595] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5273), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2751), 2,
      sym_line_comment,
      sym_block_comment,
  [82613] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4926), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    STATE(2752), 2,
      sym_line_comment,
      sym_block_comment,
  [82633] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5936), 1,
      anon_sym_SEMI,
    STATE(3501), 1,
      sym_where_clause,
    STATE(2753), 2,
      sym_line_comment,
      sym_block_comment,
  [82653] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5938), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 1,
      sym_type_arguments,
    STATE(2754), 2,
      sym_line_comment,
      sym_block_comment,
  [82673] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5940), 1,
      sym_identifier,
    ACTIONS(5942), 1,
      anon_sym_await,
    ACTIONS(5944), 1,
      sym_integer_literal,
    STATE(2755), 2,
      sym_line_comment,
      sym_block_comment,
  [82693] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5946), 1,
      anon_sym_SEMI,
    ACTIONS(5948), 1,
      anon_sym_RBRACK,
    STATE(2756), 2,
      sym_line_comment,
      sym_block_comment,
  [82713] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5860), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2757), 2,
      sym_line_comment,
      sym_block_comment,
  [82731] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(5950), 1,
      anon_sym_SEMI,
    STATE(3586), 1,
      sym_where_clause,
    STATE(2758), 2,
      sym_line_comment,
      sym_block_comment,
  [82751] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5952), 1,
      anon_sym_SEMI,
    ACTIONS(5954), 1,
      anon_sym_EQ,
    STATE(2759), 2,
      sym_line_comment,
      sym_block_comment,
  [82771] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5860), 1,
      anon_sym_RPAREN,
    ACTIONS(5956), 1,
      anon_sym_COMMA,
    STATE(2760), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_parameters_repeat1,
  [82789] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5959), 1,
      anon_sym_RBRACE,
    ACTIONS(5961), 1,
      anon_sym_COMMA,
    STATE(2761), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_field_initializer_list_repeat1,
  [82807] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1462), 1,
      anon_sym_RPAREN,
    ACTIONS(5964), 1,
      anon_sym_COMMA,
    STATE(2760), 1,
      aux_sym_parameters_repeat1,
    STATE(2762), 2,
      sym_line_comment,
      sym_block_comment,
  [82827] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5966), 1,
      anon_sym_SEMI,
    ACTIONS(5968), 1,
      anon_sym_RBRACK,
    STATE(2763), 2,
      sym_line_comment,
      sym_block_comment,
  [82847] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2764), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5970), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82863] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5972), 1,
      anon_sym_RBRACE,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(2988), 1,
      aux_sym_use_list_repeat1,
    STATE(2765), 2,
      sym_line_comment,
      sym_block_comment,
  [82883] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5976), 1,
      anon_sym_RBRACE,
    ACTIONS(5978), 1,
      anon_sym_COMMA,
    STATE(2766), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_use_list_repeat1,
  [82901] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2767), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5981), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82917] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2768), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5983), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82933] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    STATE(2882), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2769), 2,
      sym_line_comment,
      sym_block_comment,
  [82953] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1023), 1,
      anon_sym_RBRACK,
    ACTIONS(4119), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2770), 2,
      sym_line_comment,
      sym_block_comment,
  [82973] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5606), 1,
      anon_sym_EQ,
    ACTIONS(5714), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2771), 2,
      sym_line_comment,
      sym_block_comment,
  [82991] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2961), 1,
      anon_sym_SQUOTE,
    ACTIONS(5987), 1,
      anon_sym_GT,
    STATE(3230), 1,
      sym_lifetime,
    STATE(2772), 2,
      sym_line_comment,
      sym_block_comment,
  [83011] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2947), 1,
      anon_sym_RPAREN,
    ACTIONS(5989), 1,
      anon_sym_COMMA,
    STATE(2910), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2773), 2,
      sym_line_comment,
      sym_block_comment,
  [83031] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(5991), 1,
      anon_sym_SEMI,
    STATE(697), 1,
      sym_declaration_list,
    STATE(2774), 2,
      sym_line_comment,
      sym_block_comment,
  [83051] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3007), 1,
      anon_sym_RBRACK,
    ACTIONS(5993), 1,
      anon_sym_COMMA,
    STATE(2561), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2775), 2,
      sym_line_comment,
      sym_block_comment,
  [83071] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5995), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2776), 2,
      sym_line_comment,
      sym_block_comment,
  [83091] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5999), 1,
      anon_sym_COLON,
    ACTIONS(5997), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2777), 2,
      sym_line_comment,
      sym_block_comment,
  [83109] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5835), 1,
      anon_sym_RPAREN,
    ACTIONS(5837), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2778), 2,
      sym_line_comment,
      sym_block_comment,
  [83129] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6001), 1,
      anon_sym_RBRACE,
    ACTIONS(6003), 1,
      anon_sym_COMMA,
    STATE(2975), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2779), 2,
      sym_line_comment,
      sym_block_comment,
  [83149] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5825), 1,
      anon_sym_RPAREN,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    STATE(2773), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2780), 2,
      sym_line_comment,
      sym_block_comment,
  [83169] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6005), 1,
      anon_sym_GT,
    ACTIONS(6007), 1,
      anon_sym_COMMA,
    STATE(2781), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_for_lifetimes_repeat1,
  [83187] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6010), 1,
      anon_sym_RBRACE,
    ACTIONS(6012), 1,
      anon_sym_COMMA,
    STATE(2892), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2782), 2,
      sym_line_comment,
      sym_block_comment,
  [83207] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1013), 1,
      anon_sym_RBRACK,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2783), 2,
      sym_line_comment,
      sym_block_comment,
  [83227] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1019), 1,
      anon_sym_RBRACK,
    ACTIONS(4049), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2784), 2,
      sym_line_comment,
      sym_block_comment,
  [83247] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6014), 1,
      anon_sym_RBRACE,
    ACTIONS(6016), 1,
      anon_sym_COMMA,
    STATE(2785), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_enum_variant_list_repeat2,
  [83265] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6019), 1,
      anon_sym_RBRACE,
    ACTIONS(6021), 1,
      anon_sym_COMMA,
    STATE(2896), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2786), 2,
      sym_line_comment,
      sym_block_comment,
  [83285] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6023), 1,
      sym_identifier,
    ACTIONS(6025), 1,
      anon_sym_ref,
    ACTIONS(6027), 1,
      sym_mutable_specifier,
    STATE(2787), 2,
      sym_line_comment,
      sym_block_comment,
  [83305] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3143), 1,
      anon_sym_RPAREN,
    ACTIONS(6029), 1,
      anon_sym_COMMA,
    STATE(2885), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2788), 2,
      sym_line_comment,
      sym_block_comment,
  [83325] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6033), 1,
      anon_sym_EQ,
    ACTIONS(6031), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2789), 2,
      sym_line_comment,
      sym_block_comment,
  [83343] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4965), 1,
      anon_sym_RBRACE,
    ACTIONS(6035), 1,
      anon_sym_COMMA,
    STATE(2785), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2790), 2,
      sym_line_comment,
      sym_block_comment,
  [83363] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4730), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4786), 1,
      anon_sym_BANG,
    ACTIONS(6037), 1,
      sym_identifier,
    STATE(2791), 2,
      sym_line_comment,
      sym_block_comment,
  [83383] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6039), 1,
      anon_sym_SEMI,
    STATE(663), 1,
      sym_declaration_list,
    STATE(2792), 2,
      sym_line_comment,
      sym_block_comment,
  [83403] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5429), 1,
      anon_sym_RPAREN,
    ACTIONS(5431), 1,
      anon_sym_COMMA,
    STATE(2901), 1,
      aux_sym_parameters_repeat1,
    STATE(2793), 2,
      sym_line_comment,
      sym_block_comment,
  [83423] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6041), 1,
      anon_sym_SEMI,
    STATE(579), 1,
      sym_declaration_list,
    STATE(2794), 2,
      sym_line_comment,
      sym_block_comment,
  [83443] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(6043), 1,
      anon_sym_EQ,
    STATE(3541), 1,
      sym_type_parameters,
    STATE(2795), 2,
      sym_line_comment,
      sym_block_comment,
  [83463] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4918), 1,
      anon_sym_RBRACE,
    ACTIONS(6045), 1,
      anon_sym_COMMA,
    STATE(2830), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2796), 2,
      sym_line_comment,
      sym_block_comment,
  [83483] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6047), 1,
      anon_sym_SEMI,
    STATE(574), 1,
      sym_declaration_list,
    STATE(2797), 2,
      sym_line_comment,
      sym_block_comment,
  [83503] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6049), 1,
      sym_identifier,
    ACTIONS(6051), 1,
      anon_sym_await,
    ACTIONS(6053), 1,
      sym_integer_literal,
    STATE(2798), 2,
      sym_line_comment,
      sym_block_comment,
  [83523] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6055), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2799), 2,
      sym_line_comment,
      sym_block_comment,
  [83541] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6059), 1,
      anon_sym_ref,
    ACTIONS(6061), 1,
      sym_mutable_specifier,
    STATE(2800), 2,
      sym_line_comment,
      sym_block_comment,
  [83561] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5606), 1,
      anon_sym_EQ,
    ACTIONS(5791), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2801), 2,
      sym_line_comment,
      sym_block_comment,
  [83579] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6063), 1,
      anon_sym_SEMI,
    ACTIONS(6065), 1,
      anon_sym_EQ,
    STATE(2802), 2,
      sym_line_comment,
      sym_block_comment,
  [83599] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6067), 1,
      anon_sym_SEMI,
    STATE(560), 1,
      sym_declaration_list,
    STATE(2803), 2,
      sym_line_comment,
      sym_block_comment,
  [83619] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4918), 1,
      anon_sym_RBRACE,
    ACTIONS(6045), 1,
      anon_sym_COMMA,
    STATE(2829), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2804), 2,
      sym_line_comment,
      sym_block_comment,
  [83639] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6069), 1,
      anon_sym_RPAREN,
    ACTIONS(6071), 1,
      anon_sym_COMMA,
    STATE(2821), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2805), 2,
      sym_line_comment,
      sym_block_comment,
  [83659] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6073), 1,
      anon_sym_SEMI,
    STATE(558), 1,
      sym_declaration_list,
    STATE(2806), 2,
      sym_line_comment,
      sym_block_comment,
  [83679] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6075), 1,
      anon_sym_RBRACE,
    ACTIONS(6077), 1,
      anon_sym_COMMA,
    STATE(2907), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2807), 2,
      sym_line_comment,
      sym_block_comment,
  [83699] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2808), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6079), 3,
      sym_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [83715] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6081), 1,
      anon_sym_SEMI,
    ACTIONS(6083), 1,
      anon_sym_EQ,
    STATE(2809), 2,
      sym_line_comment,
      sym_block_comment,
  [83735] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6085), 1,
      anon_sym_SEMI,
    STATE(1455), 1,
      sym_declaration_list,
    STATE(2810), 2,
      sym_line_comment,
      sym_block_comment,
  [83755] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2811), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5490), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [83771] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6087), 1,
      anon_sym_move,
    STATE(232), 1,
      sym_closure_parameters,
    STATE(2812), 2,
      sym_line_comment,
      sym_block_comment,
  [83791] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6089), 1,
      anon_sym_SEMI,
    ACTIONS(6091), 1,
      anon_sym_EQ,
    STATE(2813), 2,
      sym_line_comment,
      sym_block_comment,
  [83811] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2814), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6093), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [83827] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6095), 1,
      anon_sym_RPAREN,
    ACTIONS(6097), 1,
      anon_sym_COMMA,
    STATE(2821), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2815), 2,
      sym_line_comment,
      sym_block_comment,
  [83847] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4648), 1,
      anon_sym_GT,
    ACTIONS(6099), 1,
      anon_sym_COMMA,
    STATE(2835), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2816), 2,
      sym_line_comment,
      sym_block_comment,
  [83867] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6101), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2817), 2,
      sym_line_comment,
      sym_block_comment,
  [83885] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4652), 1,
      anon_sym_GT,
    ACTIONS(5388), 1,
      anon_sym_COMMA,
    STATE(2835), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2818), 2,
      sym_line_comment,
      sym_block_comment,
  [83905] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6103), 1,
      anon_sym_SEMI,
    STATE(737), 1,
      sym_declaration_list,
    STATE(2819), 2,
      sym_line_comment,
      sym_block_comment,
  [83925] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4652), 1,
      anon_sym_GT,
    ACTIONS(5388), 1,
      anon_sym_COMMA,
    STATE(2917), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2820), 2,
      sym_line_comment,
      sym_block_comment,
  [83945] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6105), 1,
      anon_sym_RPAREN,
    ACTIONS(6107), 1,
      anon_sym_COMMA,
    STATE(2821), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_ordered_field_declaration_list_repeat1,
  [83963] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6110), 1,
      anon_sym_SEMI,
    STATE(728), 1,
      sym_declaration_list,
    STATE(2822), 2,
      sym_line_comment,
      sym_block_comment,
  [83983] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4640), 1,
      anon_sym_GT,
    ACTIONS(6112), 1,
      anon_sym_COMMA,
    STATE(2835), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2823), 2,
      sym_line_comment,
      sym_block_comment,
  [84003] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6114), 1,
      anon_sym_SEMI,
    STATE(1224), 1,
      sym_declaration_list,
    STATE(2824), 2,
      sym_line_comment,
      sym_block_comment,
  [84023] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4656), 1,
      anon_sym_GT,
    ACTIONS(6116), 1,
      anon_sym_COMMA,
    STATE(2835), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2825), 2,
      sym_line_comment,
      sym_block_comment,
  [84043] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6118), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2826), 2,
      sym_line_comment,
      sym_block_comment,
  [84061] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6120), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2827), 2,
      sym_line_comment,
      sym_block_comment,
  [84079] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6122), 1,
      anon_sym_SEMI,
    STATE(535), 1,
      sym_declaration_list,
    STATE(2828), 2,
      sym_line_comment,
      sym_block_comment,
  [84099] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6124), 1,
      anon_sym_RBRACE,
    ACTIONS(6126), 1,
      anon_sym_COMMA,
    STATE(2829), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_field_declaration_list_repeat1,
  [84117] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4920), 1,
      anon_sym_RBRACE,
    ACTIONS(6129), 1,
      anon_sym_COMMA,
    STATE(2829), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2830), 2,
      sym_line_comment,
      sym_block_comment,
  [84137] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6133), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6131), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2831), 2,
      sym_line_comment,
      sym_block_comment,
  [84155] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1007), 1,
      anon_sym_RBRACK,
    ACTIONS(4121), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2832), 2,
      sym_line_comment,
      sym_block_comment,
  [84175] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2945), 1,
      anon_sym_RPAREN,
    ACTIONS(6135), 1,
      anon_sym_COMMA,
    STATE(2910), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2833), 2,
      sym_line_comment,
      sym_block_comment,
  [84195] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6137), 1,
      anon_sym_SEMI,
    ACTIONS(6139), 1,
      anon_sym_EQ,
    STATE(2834), 2,
      sym_line_comment,
      sym_block_comment,
  [84215] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5714), 1,
      anon_sym_GT,
    ACTIONS(6141), 1,
      anon_sym_COMMA,
    STATE(2835), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_parameters_repeat1,
  [84233] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3023), 1,
      anon_sym_RBRACK,
    ACTIONS(6144), 1,
      anon_sym_COMMA,
    STATE(2561), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2836), 2,
      sym_line_comment,
      sym_block_comment,
  [84253] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6146), 1,
      anon_sym_RBRACE,
    ACTIONS(6148), 1,
      anon_sym_COMMA,
    STATE(2929), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2837), 2,
      sym_line_comment,
      sym_block_comment,
  [84273] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    ACTIONS(4866), 1,
      anon_sym_COLON_COLON,
    STATE(1598), 1,
      sym_type_arguments,
    STATE(2838), 2,
      sym_line_comment,
      sym_block_comment,
  [84293] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(6150), 1,
      anon_sym_SEMI,
    STATE(3477), 1,
      sym_where_clause,
    STATE(2839), 2,
      sym_line_comment,
      sym_block_comment,
  [84313] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6133), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4283), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2840), 2,
      sym_line_comment,
      sym_block_comment,
  [84331] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2841), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6152), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [84347] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    ACTIONS(6154), 1,
      anon_sym_GT,
    ACTIONS(6156), 1,
      anon_sym_as,
    STATE(2842), 2,
      sym_line_comment,
      sym_block_comment,
  [84367] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6158), 1,
      anon_sym_move,
    STATE(219), 1,
      sym_closure_parameters,
    STATE(2843), 2,
      sym_line_comment,
      sym_block_comment,
  [84387] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3967), 1,
      anon_sym_LBRACE,
    ACTIONS(6160), 1,
      anon_sym_COLON_COLON,
    STATE(1751), 1,
      sym_field_initializer_list,
    STATE(2844), 2,
      sym_line_comment,
      sym_block_comment,
  [84407] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4812), 1,
      anon_sym_LBRACE,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2845), 2,
      sym_line_comment,
      sym_block_comment,
  [84427] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(6162), 1,
      anon_sym_PIPE,
    STATE(2769), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2846), 2,
      sym_line_comment,
      sym_block_comment,
  [84447] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(6164), 1,
      anon_sym_SEMI,
    STATE(3483), 1,
      sym_where_clause,
    STATE(2847), 2,
      sym_line_comment,
      sym_block_comment,
  [84467] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6166), 1,
      anon_sym_move,
    STATE(225), 1,
      sym_closure_parameters,
    STATE(2848), 2,
      sym_line_comment,
      sym_block_comment,
  [84487] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6168), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2849), 2,
      sym_line_comment,
      sym_block_comment,
  [84505] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6170), 1,
      anon_sym_SEMI,
    STATE(1150), 1,
      sym_declaration_list,
    STATE(2850), 2,
      sym_line_comment,
      sym_block_comment,
  [84525] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6172), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2851), 2,
      sym_line_comment,
      sym_block_comment,
  [84543] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6174), 1,
      anon_sym_LPAREN,
    ACTIONS(6176), 1,
      anon_sym_LBRACK,
    ACTIONS(6178), 1,
      anon_sym_LBRACE,
    STATE(2852), 2,
      sym_line_comment,
      sym_block_comment,
  [84563] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6182), 1,
      anon_sym_EQ,
    ACTIONS(6180), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2853), 2,
      sym_line_comment,
      sym_block_comment,
  [84581] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(5712), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2854), 2,
      sym_line_comment,
      sym_block_comment,
  [84599] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4832), 1,
      anon_sym_RBRACE,
    ACTIONS(6184), 1,
      anon_sym_COMMA,
    STATE(2761), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2855), 2,
      sym_line_comment,
      sym_block_comment,
  [84619] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6186), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2856), 2,
      sym_line_comment,
      sym_block_comment,
  [84637] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6188), 1,
      anon_sym_LPAREN,
    ACTIONS(6190), 1,
      anon_sym_LBRACK,
    ACTIONS(6192), 1,
      anon_sym_LBRACE,
    STATE(2857), 2,
      sym_line_comment,
      sym_block_comment,
  [84657] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6194), 1,
      anon_sym_SEMI,
    STATE(572), 1,
      sym_declaration_list,
    STATE(2858), 2,
      sym_line_comment,
      sym_block_comment,
  [84677] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(6196), 1,
      anon_sym_SEMI,
    STATE(3510), 1,
      sym_where_clause,
    STATE(2859), 2,
      sym_line_comment,
      sym_block_comment,
  [84697] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6198), 1,
      anon_sym_move,
    STATE(233), 1,
      sym_closure_parameters,
    STATE(2860), 2,
      sym_line_comment,
      sym_block_comment,
  [84717] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6200), 1,
      anon_sym_SEMI,
    STATE(576), 1,
      sym_declaration_list,
    STATE(2861), 2,
      sym_line_comment,
      sym_block_comment,
  [84737] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6202), 1,
      sym_identifier,
    ACTIONS(6204), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(2862), 2,
      sym_line_comment,
      sym_block_comment,
  [84755] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4872), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2863), 2,
      sym_line_comment,
      sym_block_comment,
  [84775] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6206), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2864), 2,
      sym_line_comment,
      sym_block_comment,
  [84793] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6208), 1,
      anon_sym_RPAREN,
    ACTIONS(6210), 1,
      anon_sym_COMMA,
    STATE(2821), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2865), 2,
      sym_line_comment,
      sym_block_comment,
  [84813] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4886), 1,
      anon_sym_RBRACE,
    ACTIONS(6212), 1,
      anon_sym_COMMA,
    STATE(2790), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2866), 2,
      sym_line_comment,
      sym_block_comment,
  [84833] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1025), 1,
      anon_sym_RPAREN,
    ACTIONS(4123), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2867), 2,
      sym_line_comment,
      sym_block_comment,
  [84853] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4886), 1,
      anon_sym_RBRACE,
    ACTIONS(6212), 1,
      anon_sym_COMMA,
    STATE(2785), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2868), 2,
      sym_line_comment,
      sym_block_comment,
  [84873] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(6214), 1,
      anon_sym_COLON_COLON,
    STATE(1289), 1,
      sym_field_initializer_list,
    STATE(2869), 2,
      sym_line_comment,
      sym_block_comment,
  [84893] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6216), 1,
      anon_sym_GT,
    ACTIONS(6218), 1,
      anon_sym_COMMA,
    STATE(2781), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2870), 2,
      sym_line_comment,
      sym_block_comment,
  [84913] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6220), 1,
      anon_sym_SEMI,
    STATE(602), 1,
      sym_declaration_list,
    STATE(2871), 2,
      sym_line_comment,
      sym_block_comment,
  [84933] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2961), 1,
      anon_sym_SQUOTE,
    ACTIONS(6216), 1,
      anon_sym_GT,
    STATE(3230), 1,
      sym_lifetime,
    STATE(2872), 2,
      sym_line_comment,
      sym_block_comment,
  [84953] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6222), 1,
      anon_sym_SEMI,
    STATE(604), 1,
      sym_declaration_list,
    STATE(2873), 2,
      sym_line_comment,
      sym_block_comment,
  [84973] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6226), 1,
      anon_sym_COLON,
    ACTIONS(6224), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2874), 2,
      sym_line_comment,
      sym_block_comment,
  [84991] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6228), 1,
      anon_sym_RBRACE,
    ACTIONS(6230), 1,
      anon_sym_COMMA,
    STATE(2893), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2875), 2,
      sym_line_comment,
      sym_block_comment,
  [85011] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(6232), 1,
      anon_sym_COMMA,
    STATE(2760), 1,
      aux_sym_parameters_repeat1,
    STATE(2876), 2,
      sym_line_comment,
      sym_block_comment,
  [85031] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1590), 1,
      anon_sym_GT,
    ACTIONS(6234), 1,
      anon_sym_COMMA,
    STATE(2747), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2877), 2,
      sym_line_comment,
      sym_block_comment,
  [85051] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(6236), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2878), 2,
      sym_line_comment,
      sym_block_comment,
  [85069] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6238), 1,
      anon_sym_SEMI,
    STATE(620), 1,
      sym_declaration_list,
    STATE(2879), 2,
      sym_line_comment,
      sym_block_comment,
  [85089] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(5409), 1,
      anon_sym_COMMA,
    STATE(2762), 1,
      aux_sym_parameters_repeat1,
    STATE(2880), 2,
      sym_line_comment,
      sym_block_comment,
  [85109] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6240), 1,
      anon_sym_SEMI,
    STATE(573), 1,
      sym_declaration_list,
    STATE(2881), 2,
      sym_line_comment,
      sym_block_comment,
  [85129] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6236), 1,
      anon_sym_PIPE,
    ACTIONS(6242), 1,
      anon_sym_COMMA,
    STATE(2882), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_closure_parameters_repeat1,
  [85147] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(989), 1,
      anon_sym_RBRACK,
    ACTIONS(6245), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2883), 2,
      sym_line_comment,
      sym_block_comment,
  [85167] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(5409), 1,
      anon_sym_COMMA,
    STATE(2760), 1,
      aux_sym_parameters_repeat1,
    STATE(2884), 2,
      sym_line_comment,
      sym_block_comment,
  [85187] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6247), 1,
      anon_sym_RPAREN,
    ACTIONS(6249), 1,
      anon_sym_COMMA,
    STATE(2885), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_tuple_type_repeat1,
  [85205] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6247), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2886), 2,
      sym_line_comment,
      sym_block_comment,
  [85223] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1600), 1,
      anon_sym_GT,
    ACTIONS(6252), 1,
      anon_sym_COMMA,
    STATE(2966), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2887), 2,
      sym_line_comment,
      sym_block_comment,
  [85243] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1600), 1,
      anon_sym_GT,
    ACTIONS(6252), 1,
      anon_sym_COMMA,
    STATE(2747), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2888), 2,
      sym_line_comment,
      sym_block_comment,
  [85263] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5147), 1,
      anon_sym_RBRACE,
    ACTIONS(6254), 1,
      anon_sym_COMMA,
    STATE(2750), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2889), 2,
      sym_line_comment,
      sym_block_comment,
  [85283] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3033), 1,
      anon_sym_RPAREN,
    ACTIONS(6256), 1,
      anon_sym_COMMA,
    STATE(2561), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2890), 2,
      sym_line_comment,
      sym_block_comment,
  [85303] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3031), 1,
      anon_sym_RPAREN,
    ACTIONS(6258), 1,
      anon_sym_COMMA,
    STATE(2561), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2891), 2,
      sym_line_comment,
      sym_block_comment,
  [85323] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5155), 1,
      anon_sym_RBRACE,
    ACTIONS(6260), 1,
      anon_sym_COMMA,
    STATE(2750), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2892), 2,
      sym_line_comment,
      sym_block_comment,
  [85343] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5157), 1,
      anon_sym_RBRACE,
    ACTIONS(6262), 1,
      anon_sym_COMMA,
    STATE(2750), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2893), 2,
      sym_line_comment,
      sym_block_comment,
  [85363] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3013), 1,
      anon_sym_RPAREN,
    ACTIONS(6264), 1,
      anon_sym_COMMA,
    STATE(2561), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2894), 2,
      sym_line_comment,
      sym_block_comment,
  [85383] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6268), 1,
      anon_sym_COLON,
    ACTIONS(6266), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2895), 2,
      sym_line_comment,
      sym_block_comment,
  [85401] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5159), 1,
      anon_sym_RBRACE,
    ACTIONS(6270), 1,
      anon_sym_COMMA,
    STATE(2750), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2896), 2,
      sym_line_comment,
      sym_block_comment,
  [85421] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6272), 1,
      anon_sym_SEMI,
    ACTIONS(6274), 1,
      anon_sym_EQ,
    STATE(2897), 2,
      sym_line_comment,
      sym_block_comment,
  [85441] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3011), 1,
      anon_sym_RPAREN,
    ACTIONS(6276), 1,
      anon_sym_COMMA,
    STATE(2561), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2898), 2,
      sym_line_comment,
      sym_block_comment,
  [85461] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4894), 1,
      anon_sym_LT,
    ACTIONS(6278), 1,
      anon_sym_EQ,
    STATE(3580), 1,
      sym_type_parameters,
    STATE(2899), 2,
      sym_line_comment,
      sym_block_comment,
  [85481] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1588), 1,
      anon_sym_GT,
    ACTIONS(6280), 1,
      anon_sym_COMMA,
    STATE(2747), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2900), 2,
      sym_line_comment,
      sym_block_comment,
  [85501] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    ACTIONS(5568), 1,
      anon_sym_COMMA,
    STATE(2760), 1,
      aux_sym_parameters_repeat1,
    STATE(2901), 2,
      sym_line_comment,
      sym_block_comment,
  [85521] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1588), 1,
      anon_sym_GT,
    ACTIONS(6280), 1,
      anon_sym_COMMA,
    STATE(2745), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2902), 2,
      sym_line_comment,
      sym_block_comment,
  [85541] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2903), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6282), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [85557] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    ACTIONS(5568), 1,
      anon_sym_COMMA,
    STATE(2974), 1,
      aux_sym_parameters_repeat1,
    STATE(2904), 2,
      sym_line_comment,
      sym_block_comment,
  [85577] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6284), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2905), 2,
      sym_line_comment,
      sym_block_comment,
  [85595] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(6286), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2906), 2,
      sym_line_comment,
      sym_block_comment,
  [85615] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4916), 1,
      anon_sym_RBRACE,
    ACTIONS(6288), 1,
      anon_sym_COMMA,
    STATE(2785), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2907), 2,
      sym_line_comment,
      sym_block_comment,
  [85635] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4916), 1,
      anon_sym_RBRACE,
    ACTIONS(6288), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2908), 2,
      sym_line_comment,
      sym_block_comment,
  [85655] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6290), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2909), 2,
      sym_line_comment,
      sym_block_comment,
  [85673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6292), 1,
      anon_sym_RPAREN,
    ACTIONS(6294), 1,
      anon_sym_COMMA,
    STATE(2910), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_tuple_pattern_repeat1,
  [85691] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6292), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2911), 2,
      sym_line_comment,
      sym_block_comment,
  [85709] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    ACTIONS(5534), 1,
      anon_sym_COMMA,
    STATE(2876), 1,
      aux_sym_parameters_repeat1,
    STATE(2912), 2,
      sym_line_comment,
      sym_block_comment,
  [85729] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1027), 1,
      anon_sym_RBRACK,
    ACTIONS(6297), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2913), 2,
      sym_line_comment,
      sym_block_comment,
  [85749] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6299), 1,
      anon_sym_SEMI,
    STATE(679), 1,
      sym_declaration_list,
    STATE(2914), 2,
      sym_line_comment,
      sym_block_comment,
  [85769] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    ACTIONS(5534), 1,
      anon_sym_COMMA,
    STATE(2760), 1,
      aux_sym_parameters_repeat1,
    STATE(2915), 2,
      sym_line_comment,
      sym_block_comment,
  [85789] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4636), 1,
      anon_sym_GT,
    ACTIONS(6301), 1,
      anon_sym_COMMA,
    STATE(2835), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2916), 2,
      sym_line_comment,
      sym_block_comment,
  [85809] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4642), 1,
      anon_sym_GT,
    ACTIONS(6303), 1,
      anon_sym_COMMA,
    STATE(2835), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2917), 2,
      sym_line_comment,
      sym_block_comment,
  [85829] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6305), 1,
      anon_sym_SEMI,
    STATE(1283), 1,
      sym_declaration_list,
    STATE(2918), 2,
      sym_line_comment,
      sym_block_comment,
  [85849] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6307), 1,
      anon_sym_RBRACE,
    ACTIONS(6309), 1,
      anon_sym_COMMA,
    STATE(2889), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2919), 2,
      sym_line_comment,
      sym_block_comment,
  [85869] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1586), 1,
      anon_sym_GT,
    ACTIONS(6311), 1,
      anon_sym_COMMA,
    STATE(2747), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2920), 2,
      sym_line_comment,
      sym_block_comment,
  [85889] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6313), 1,
      anon_sym_SEMI,
    STATE(1367), 1,
      sym_declaration_list,
    STATE(2921), 2,
      sym_line_comment,
      sym_block_comment,
  [85909] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2922), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1256), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [85925] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1586), 1,
      anon_sym_GT,
    ACTIONS(6311), 1,
      anon_sym_COMMA,
    STATE(2877), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2923), 2,
      sym_line_comment,
      sym_block_comment,
  [85945] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3145), 1,
      anon_sym_RPAREN,
    ACTIONS(6315), 1,
      anon_sym_COMMA,
    STATE(2885), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2924), 2,
      sym_line_comment,
      sym_block_comment,
  [85965] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6317), 1,
      anon_sym_SEMI,
    STATE(687), 1,
      sym_declaration_list,
    STATE(2925), 2,
      sym_line_comment,
      sym_block_comment,
  [85985] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6319), 1,
      anon_sym_SEMI,
    ACTIONS(6321), 1,
      anon_sym_EQ,
    STATE(2926), 2,
      sym_line_comment,
      sym_block_comment,
  [86005] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5457), 1,
      anon_sym_RPAREN,
    ACTIONS(5459), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym_parameters_repeat1,
    STATE(2927), 2,
      sym_line_comment,
      sym_block_comment,
  [86025] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2928), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6323), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [86041] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    ACTIONS(6325), 1,
      anon_sym_COMMA,
    STATE(2829), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2929), 2,
      sym_line_comment,
      sym_block_comment,
  [86061] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    ACTIONS(6325), 1,
      anon_sym_COMMA,
    STATE(2994), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2930), 2,
      sym_line_comment,
      sym_block_comment,
  [86081] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(6327), 1,
      sym_mutable_specifier,
    ACTIONS(6329), 1,
      sym_self,
    STATE(2931), 2,
      sym_line_comment,
      sym_block_comment,
  [86101] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6331), 1,
      anon_sym_GT,
    ACTIONS(6333), 1,
      anon_sym_COMMA,
    STATE(2870), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2932), 2,
      sym_line_comment,
      sym_block_comment,
  [86121] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6335), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2933), 2,
      sym_line_comment,
      sym_block_comment,
  [86139] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2934), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6337), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [86155] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5471), 1,
      anon_sym_RPAREN,
    ACTIONS(5473), 1,
      anon_sym_COMMA,
    STATE(2915), 1,
      aux_sym_parameters_repeat1,
    STATE(2935), 2,
      sym_line_comment,
      sym_block_comment,
  [86175] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6339), 1,
      anon_sym_SEMI,
    STATE(1464), 1,
      sym_declaration_list,
    STATE(2936), 2,
      sym_line_comment,
      sym_block_comment,
  [86195] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3161), 1,
      anon_sym_RPAREN,
    ACTIONS(6341), 1,
      anon_sym_COMMA,
    STATE(2885), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2937), 2,
      sym_line_comment,
      sym_block_comment,
  [86215] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2938), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(905), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
  [86231] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2939), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4451), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86247] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2940), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4756), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86263] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2941), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4760), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86279] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2942), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4762), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86295] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6343), 1,
      anon_sym_SEMI,
    ACTIONS(6345), 1,
      anon_sym_EQ,
    STATE(2943), 2,
      sym_line_comment,
      sym_block_comment,
  [86315] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6347), 1,
      anon_sym_SEMI,
    ACTIONS(6349), 1,
      anon_sym_EQ,
    STATE(2944), 2,
      sym_line_comment,
      sym_block_comment,
  [86335] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6351), 1,
      anon_sym_RBRACE,
    ACTIONS(6353), 1,
      anon_sym_COMMA,
    STATE(2868), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2945), 2,
      sym_line_comment,
      sym_block_comment,
  [86355] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(6355), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2946), 2,
      sym_line_comment,
      sym_block_comment,
  [86375] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(6357), 1,
      anon_sym_SEMI,
    STATE(3578), 1,
      sym_where_clause,
    STATE(2947), 2,
      sym_line_comment,
      sym_block_comment,
  [86395] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(4961), 1,
      anon_sym_COLON_COLON,
    STATE(1075), 1,
      sym_type_arguments,
    STATE(2948), 2,
      sym_line_comment,
      sym_block_comment,
  [86415] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2949), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4764), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86431] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2950), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4766), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86447] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6359), 1,
      anon_sym_SEMI,
    ACTIONS(6361), 1,
      anon_sym_RBRACK,
    STATE(2951), 2,
      sym_line_comment,
      sym_block_comment,
  [86467] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2952), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4768), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86483] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2953), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6363), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [86499] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2954), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4778), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86515] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2955), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4804), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86531] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(991), 1,
      anon_sym_RPAREN,
    ACTIONS(6365), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2956), 2,
      sym_line_comment,
      sym_block_comment,
  [86551] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1021), 1,
      anon_sym_RPAREN,
    ACTIONS(4097), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_arguments_repeat1,
    STATE(2957), 2,
      sym_line_comment,
      sym_block_comment,
  [86571] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2958), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4794), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86587] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2959), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4668), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86603] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2960), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6367), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [86619] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2961), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4796), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86635] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2962), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4798), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86651] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2963), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4800), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86667] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2964), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4802), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86683] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(6369), 1,
      anon_sym_SEMI,
    STATE(3335), 1,
      sym_where_clause,
    STATE(2965), 2,
      sym_line_comment,
      sym_block_comment,
  [86703] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1596), 1,
      anon_sym_GT,
    ACTIONS(6371), 1,
      anon_sym_COMMA,
    STATE(2747), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2966), 2,
      sym_line_comment,
      sym_block_comment,
  [86723] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4578), 1,
      anon_sym_COLON,
    STATE(2577), 1,
      sym_trait_bounds,
    STATE(2967), 2,
      sym_line_comment,
      sym_block_comment,
  [86743] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2968), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4694), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86759] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2969), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4806), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86775] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2970), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4808), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86791] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6375), 1,
      anon_sym_COLON,
    ACTIONS(6373), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2971), 2,
      sym_line_comment,
      sym_block_comment,
  [86809] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2972), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4810), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86825] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2973), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4822), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86841] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1468), 1,
      anon_sym_RPAREN,
    ACTIONS(6377), 1,
      anon_sym_COMMA,
    STATE(2760), 1,
      aux_sym_parameters_repeat1,
    STATE(2974), 2,
      sym_line_comment,
      sym_block_comment,
  [86861] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4816), 1,
      anon_sym_RBRACE,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    STATE(2761), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2975), 2,
      sym_line_comment,
      sym_block_comment,
  [86881] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2976), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4824), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86897] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4862), 1,
      anon_sym_RBRACE,
    ACTIONS(6381), 1,
      anon_sym_COMMA,
    STATE(2785), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2977), 2,
      sym_line_comment,
      sym_block_comment,
  [86917] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2978), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6383), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [86933] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2979), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6385), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [86949] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6387), 1,
      anon_sym_SEMI,
    STATE(1290), 1,
      sym_declaration_list,
    STATE(2980), 2,
      sym_line_comment,
      sym_block_comment,
  [86969] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6389), 1,
      anon_sym_SEMI,
    STATE(1272), 1,
      sym_declaration_list,
    STATE(2981), 2,
      sym_line_comment,
      sym_block_comment,
  [86989] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(6391), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2982), 2,
      sym_line_comment,
      sym_block_comment,
  [87009] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2983), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6393), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87025] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2984), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6395), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87041] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2985), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6397), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87057] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6399), 1,
      anon_sym_SEMI,
    STATE(1252), 1,
      sym_declaration_list,
    STATE(2986), 2,
      sym_line_comment,
      sym_block_comment,
  [87077] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6401), 1,
      anon_sym_SEMI,
    STATE(1248), 1,
      sym_declaration_list,
    STATE(2987), 2,
      sym_line_comment,
      sym_block_comment,
  [87097] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4375), 1,
      anon_sym_RBRACE,
    ACTIONS(6403), 1,
      anon_sym_COMMA,
    STATE(2766), 1,
      aux_sym_use_list_repeat1,
    STATE(2988), 2,
      sym_line_comment,
      sym_block_comment,
  [87117] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2989), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4826), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87133] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2990), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6405), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
  [87149] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6407), 1,
      anon_sym_SEMI,
    ACTIONS(6409), 1,
      anon_sym_EQ,
    STATE(2991), 2,
      sym_line_comment,
      sym_block_comment,
  [87169] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2992), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6411), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87185] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2993), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4828), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87201] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4951), 1,
      anon_sym_RBRACE,
    ACTIONS(6413), 1,
      anon_sym_COMMA,
    STATE(2829), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2994), 2,
      sym_line_comment,
      sym_block_comment,
  [87221] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2995), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4830), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87237] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4634), 1,
      anon_sym_GT,
    ACTIONS(6415), 1,
      anon_sym_COMMA,
    STATE(2835), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2996), 2,
      sym_line_comment,
      sym_block_comment,
  [87257] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6417), 1,
      anon_sym_SEMI,
    STATE(591), 1,
      sym_declaration_list,
    STATE(2997), 2,
      sym_line_comment,
      sym_block_comment,
  [87277] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(6419), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(2998), 2,
      sym_line_comment,
      sym_block_comment,
  [87297] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4646), 1,
      anon_sym_GT,
    ACTIONS(5532), 1,
      anon_sym_COMMA,
    STATE(2835), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2999), 2,
      sym_line_comment,
      sym_block_comment,
  [87317] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3000), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6421), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
  [87333] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3001), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4820), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87349] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4646), 1,
      anon_sym_GT,
    ACTIONS(5532), 1,
      anon_sym_COMMA,
    STATE(2823), 1,
      aux_sym_type_parameters_repeat1,
    STATE(3002), 2,
      sym_line_comment,
      sym_block_comment,
  [87369] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3003), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4840), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87385] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4846), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87401] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4752), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87417] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4838), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87433] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      anon_sym_move,
    STATE(217), 1,
      sym_closure_parameters,
    STATE(3007), 2,
      sym_line_comment,
      sym_block_comment,
  [87453] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4860), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87469] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(6425), 1,
      anon_sym_SEMI,
    STATE(3368), 1,
      sym_where_clause,
    STATE(3009), 2,
      sym_line_comment,
      sym_block_comment,
  [87489] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4836), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87505] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4754), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87521] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_where,
    ACTIONS(6427), 1,
      anon_sym_SEMI,
    STATE(3380), 1,
      sym_where_clause,
    STATE(3012), 2,
      sym_line_comment,
      sym_block_comment,
  [87541] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6429), 1,
      anon_sym_SEMI,
    STATE(1121), 1,
      sym_declaration_list,
    STATE(3013), 2,
      sym_line_comment,
      sym_block_comment,
  [87561] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6431), 1,
      anon_sym_SEMI,
    STATE(1111), 1,
      sym_declaration_list,
    STATE(3014), 2,
      sym_line_comment,
      sym_block_comment,
  [87581] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      anon_sym_RBRACE,
    ACTIONS(6435), 1,
      anon_sym_COMMA,
    STATE(2804), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(3015), 2,
      sym_line_comment,
      sym_block_comment,
  [87601] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6437), 1,
      anon_sym_SEMI,
    STATE(1113), 1,
      sym_declaration_list,
    STATE(3016), 2,
      sym_line_comment,
      sym_block_comment,
  [87621] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6439), 1,
      anon_sym_SEMI,
    STATE(1109), 1,
      sym_declaration_list,
    STATE(3017), 2,
      sym_line_comment,
      sym_block_comment,
  [87641] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3018), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4858), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87657] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6441), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_declaration_list,
    STATE(3019), 2,
      sym_line_comment,
      sym_block_comment,
  [87677] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6443), 1,
      anon_sym_SEMI,
    STATE(1134), 1,
      sym_declaration_list,
    STATE(3020), 2,
      sym_line_comment,
      sym_block_comment,
  [87697] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6445), 1,
      anon_sym_SEMI,
    ACTIONS(6447), 1,
      anon_sym_EQ,
    STATE(3021), 2,
      sym_line_comment,
      sym_block_comment,
  [87717] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6449), 1,
      anon_sym_SEMI,
    ACTIONS(6451), 1,
      anon_sym_EQ,
    STATE(3022), 2,
      sym_line_comment,
      sym_block_comment,
  [87737] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6453), 1,
      anon_sym_SEMI,
    STATE(1191), 1,
      sym_declaration_list,
    STATE(3023), 2,
      sym_line_comment,
      sym_block_comment,
  [87757] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    ACTIONS(6455), 1,
      anon_sym_SEMI,
    STATE(1194), 1,
      sym_declaration_list,
    STATE(3024), 2,
      sym_line_comment,
      sym_block_comment,
  [87777] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6457), 1,
      anon_sym_EQ_GT,
    ACTIONS(6459), 1,
      anon_sym_PIPE,
    ACTIONS(6461), 1,
      anon_sym_if,
    STATE(3025), 2,
      sym_line_comment,
      sym_block_comment,
  [87797] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3026), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4856), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87813] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3027), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4842), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [87829] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(6463), 1,
      anon_sym_SEMI,
    STATE(526), 1,
      sym_declaration_list,
    STATE(3028), 2,
      sym_line_comment,
      sym_block_comment,
  [87849] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4578), 1,
      anon_sym_COLON,
    ACTIONS(4926), 1,
      anon_sym_COLON_COLON,
    STATE(2577), 1,
      sym_trait_bounds,
    STATE(3029), 2,
      sym_line_comment,
      sym_block_comment,
  [87869] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(6465), 1,
      anon_sym_for,
    STATE(1931), 1,
      sym_type_arguments,
    STATE(3030), 2,
      sym_line_comment,
      sym_block_comment,
  [87889] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6467), 1,
      sym_identifier,
    ACTIONS(6469), 1,
      anon_sym_ref,
    ACTIONS(6471), 1,
      sym_mutable_specifier,
    STATE(3031), 2,
      sym_line_comment,
      sym_block_comment,
  [87909] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6473), 1,
      sym_identifier,
    ACTIONS(6475), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(3032), 2,
      sym_line_comment,
      sym_block_comment,
  [87927] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6477), 1,
      sym_identifier,
    ACTIONS(6479), 1,
      sym_super,
    STATE(3033), 2,
      sym_line_comment,
      sym_block_comment,
  [87944] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4901), 1,
      anon_sym_for,
    STATE(3034), 2,
      sym_line_comment,
      sym_block_comment,
  [87961] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3753), 1,
      anon_sym_COLON,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    STATE(3035), 2,
      sym_line_comment,
      sym_block_comment,
  [87978] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6481), 1,
      anon_sym_RPAREN,
    ACTIONS(6483), 1,
      anon_sym_COLON_COLON,
    STATE(3036), 2,
      sym_line_comment,
      sym_block_comment,
  [87995] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5773), 1,
      sym_super,
    ACTIONS(6485), 1,
      sym_identifier,
    STATE(3037), 2,
      sym_line_comment,
      sym_block_comment,
  [88012] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6487), 1,
      anon_sym_LBRACK,
    ACTIONS(6489), 1,
      anon_sym_BANG,
    STATE(3038), 2,
      sym_line_comment,
      sym_block_comment,
  [88029] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1177), 1,
      sym_declaration_list,
    STATE(3039), 2,
      sym_line_comment,
      sym_block_comment,
  [88046] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6481), 1,
      anon_sym_RPAREN,
    ACTIONS(6491), 1,
      anon_sym_COLON_COLON,
    STATE(3040), 2,
      sym_line_comment,
      sym_block_comment,
  [88063] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6481), 1,
      anon_sym_RPAREN,
    ACTIONS(6493), 1,
      anon_sym_COLON_COLON,
    STATE(3041), 2,
      sym_line_comment,
      sym_block_comment,
  [88080] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6495), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3042), 2,
      sym_line_comment,
      sym_block_comment,
  [88095] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6497), 1,
      anon_sym_RPAREN,
    ACTIONS(6499), 1,
      anon_sym_COLON_COLON,
    STATE(3043), 2,
      sym_line_comment,
      sym_block_comment,
  [88112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(542), 1,
      sym_declaration_list,
    STATE(3044), 2,
      sym_line_comment,
      sym_block_comment,
  [88129] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6501), 1,
      sym_identifier,
    ACTIONS(6503), 1,
      sym_mutable_specifier,
    STATE(3045), 2,
      sym_line_comment,
      sym_block_comment,
  [88146] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3757), 1,
      anon_sym_COLON,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    STATE(3046), 2,
      sym_line_comment,
      sym_block_comment,
  [88163] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3851), 1,
      anon_sym_COLON,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    STATE(3047), 2,
      sym_line_comment,
      sym_block_comment,
  [88180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6467), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      sym_mutable_specifier,
    STATE(3048), 2,
      sym_line_comment,
      sym_block_comment,
  [88197] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6505), 1,
      anon_sym_in,
    STATE(3049), 2,
      sym_line_comment,
      sym_block_comment,
  [88214] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6507), 1,
      anon_sym_in,
    STATE(3050), 2,
      sym_line_comment,
      sym_block_comment,
  [88231] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6509), 1,
      anon_sym_in,
    STATE(3051), 2,
      sym_line_comment,
      sym_block_comment,
  [88248] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5477), 1,
      sym_super,
    ACTIONS(6511), 1,
      sym_identifier,
    STATE(3052), 2,
      sym_line_comment,
      sym_block_comment,
  [88265] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6513), 1,
      anon_sym_in,
    STATE(3053), 2,
      sym_line_comment,
      sym_block_comment,
  [88282] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(534), 1,
      sym_declaration_list,
    STATE(3054), 2,
      sym_line_comment,
      sym_block_comment,
  [88299] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    STATE(483), 1,
      sym_field_declaration_list,
    STATE(3055), 2,
      sym_line_comment,
      sym_block_comment,
  [88316] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5477), 1,
      sym_super,
    ACTIONS(6515), 1,
      sym_identifier,
    STATE(3056), 2,
      sym_line_comment,
      sym_block_comment,
  [88333] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6517), 1,
      anon_sym_LBRACK,
    ACTIONS(6519), 1,
      anon_sym_BANG,
    STATE(3057), 2,
      sym_line_comment,
      sym_block_comment,
  [88350] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3573), 1,
      anon_sym_COLON,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    STATE(3058), 2,
      sym_line_comment,
      sym_block_comment,
  [88367] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(217), 1,
      sym_closure_parameters,
    STATE(3059), 2,
      sym_line_comment,
      sym_block_comment,
  [88384] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6465), 1,
      anon_sym_for,
    STATE(3060), 2,
      sym_line_comment,
      sym_block_comment,
  [88401] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5773), 2,
      sym_identifier,
      sym_super,
    STATE(3061), 2,
      sym_line_comment,
      sym_block_comment,
  [88416] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6521), 1,
      anon_sym_in,
    STATE(3062), 2,
      sym_line_comment,
      sym_block_comment,
  [88433] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6391), 1,
      anon_sym_for,
    STATE(3063), 2,
      sym_line_comment,
      sym_block_comment,
  [88450] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(225), 1,
      sym_closure_parameters,
    STATE(3064), 2,
      sym_line_comment,
      sym_block_comment,
  [88467] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1377), 1,
      sym_declaration_list,
    STATE(3065), 2,
      sym_line_comment,
      sym_block_comment,
  [88484] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1168), 1,
      sym_declaration_list,
    STATE(3066), 2,
      sym_line_comment,
      sym_block_comment,
  [88501] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1172), 1,
      sym_declaration_list,
    STATE(3067), 2,
      sym_line_comment,
      sym_block_comment,
  [88518] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5477), 2,
      sym_identifier,
      sym_super,
    STATE(3068), 2,
      sym_line_comment,
      sym_block_comment,
  [88533] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6523), 1,
      sym_identifier,
    ACTIONS(6525), 1,
      sym_super,
    STATE(3069), 2,
      sym_line_comment,
      sym_block_comment,
  [88550] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5773), 1,
      sym_super,
    ACTIONS(6527), 1,
      sym_identifier,
    STATE(3070), 2,
      sym_line_comment,
      sym_block_comment,
  [88567] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5477), 1,
      sym_super,
    ACTIONS(6529), 1,
      sym_identifier,
    STATE(3071), 2,
      sym_line_comment,
      sym_block_comment,
  [88584] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6531), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3072), 2,
      sym_line_comment,
      sym_block_comment,
  [88599] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_field_declaration_list,
    STATE(3073), 2,
      sym_line_comment,
      sym_block_comment,
  [88616] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6355), 1,
      anon_sym_for,
    STATE(3074), 2,
      sym_line_comment,
      sym_block_comment,
  [88633] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1200), 1,
      sym_declaration_list,
    STATE(3075), 2,
      sym_line_comment,
      sym_block_comment,
  [88650] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    STATE(1624), 1,
      sym_parameters,
    STATE(3076), 2,
      sym_line_comment,
      sym_block_comment,
  [88667] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6419), 1,
      anon_sym_for,
    STATE(3077), 2,
      sym_line_comment,
      sym_block_comment,
  [88684] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_declaration_list,
    STATE(3078), 2,
      sym_line_comment,
      sym_block_comment,
  [88701] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(638), 1,
      sym_declaration_list,
    STATE(3079), 2,
      sym_line_comment,
      sym_block_comment,
  [88718] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6286), 1,
      anon_sym_for,
    STATE(3080), 2,
      sym_line_comment,
      sym_block_comment,
  [88735] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6533), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3081), 2,
      sym_line_comment,
      sym_block_comment,
  [88750] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6535), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3082), 2,
      sym_line_comment,
      sym_block_comment,
  [88765] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    STATE(1289), 1,
      sym_field_initializer_list,
    STATE(3083), 2,
      sym_line_comment,
      sym_block_comment,
  [88782] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4872), 1,
      anon_sym_for,
    STATE(3084), 2,
      sym_line_comment,
      sym_block_comment,
  [88799] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6537), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3085), 2,
      sym_line_comment,
      sym_block_comment,
  [88814] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5269), 1,
      anon_sym_LBRACE,
    STATE(539), 1,
      sym_enum_variant_list,
    STATE(3086), 2,
      sym_line_comment,
      sym_block_comment,
  [88831] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6539), 1,
      anon_sym_in,
    STATE(3087), 2,
      sym_line_comment,
      sym_block_comment,
  [88848] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(220), 1,
      sym_closure_parameters,
    STATE(3088), 2,
      sym_line_comment,
      sym_block_comment,
  [88865] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2207), 1,
      sym_parameters,
    STATE(3089), 2,
      sym_line_comment,
      sym_block_comment,
  [88882] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5269), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_enum_variant_list,
    STATE(3090), 2,
      sym_line_comment,
      sym_block_comment,
  [88899] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6541), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3091), 2,
      sym_line_comment,
      sym_block_comment,
  [88914] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    STATE(616), 1,
      sym_field_declaration_list,
    STATE(3092), 2,
      sym_line_comment,
      sym_block_comment,
  [88931] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6543), 1,
      anon_sym_LBRACK,
    ACTIONS(6545), 1,
      anon_sym_BANG,
    STATE(3093), 2,
      sym_line_comment,
      sym_block_comment,
  [88948] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5630), 1,
      sym_identifier,
    ACTIONS(5632), 1,
      sym_super,
    STATE(3094), 2,
      sym_line_comment,
      sym_block_comment,
  [88965] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5799), 2,
      sym_identifier,
      sym_super,
    STATE(3095), 2,
      sym_line_comment,
      sym_block_comment,
  [88980] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6547), 1,
      sym_identifier,
    ACTIONS(6549), 1,
      sym_super,
    STATE(3096), 2,
      sym_line_comment,
      sym_block_comment,
  [88997] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6551), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3097), 2,
      sym_line_comment,
      sym_block_comment,
  [89012] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4973), 1,
      anon_sym_COLON,
    STATE(2577), 1,
      sym_trait_bounds,
    STATE(3098), 2,
      sym_line_comment,
      sym_block_comment,
  [89029] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      sym_identifier,
    ACTIONS(6553), 1,
      sym_super,
    STATE(3099), 2,
      sym_line_comment,
      sym_block_comment,
  [89046] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6555), 1,
      anon_sym_LPAREN,
    ACTIONS(6557), 1,
      anon_sym_COLON_COLON,
    STATE(3100), 2,
      sym_line_comment,
      sym_block_comment,
  [89063] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5634), 1,
      sym_identifier,
    STATE(3101), 2,
      sym_line_comment,
      sym_block_comment,
  [89080] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6559), 2,
      sym__block_comment_content,
      anon_sym_STAR_SLASH,
    STATE(3102), 2,
      sym_line_comment,
      sym_block_comment,
  [89095] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6561), 1,
      sym_identifier,
    ACTIONS(6563), 1,
      sym_super,
    STATE(3103), 2,
      sym_line_comment,
      sym_block_comment,
  [89112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6565), 1,
      anon_sym_SEMI,
    ACTIONS(6567), 1,
      anon_sym_as,
    STATE(3104), 2,
      sym_line_comment,
      sym_block_comment,
  [89129] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6569), 1,
      anon_sym_in,
    STATE(3105), 2,
      sym_line_comment,
      sym_block_comment,
  [89146] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6571), 2,
      sym__block_comment_content,
      anon_sym_STAR_SLASH,
    STATE(3106), 2,
      sym_line_comment,
      sym_block_comment,
  [89161] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4894), 1,
      anon_sym_LT,
    STATE(877), 1,
      sym_type_parameters,
    STATE(3107), 2,
      sym_line_comment,
      sym_block_comment,
  [89178] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6573), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3108), 2,
      sym_line_comment,
      sym_block_comment,
  [89193] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2961), 1,
      anon_sym_SQUOTE,
    STATE(3230), 1,
      sym_lifetime,
    STATE(3109), 2,
      sym_line_comment,
      sym_block_comment,
  [89210] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1378), 1,
      sym_field_declaration_list,
    STATE(3110), 2,
      sym_line_comment,
      sym_block_comment,
  [89227] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6575), 1,
      anon_sym_LT,
    STATE(915), 1,
      sym_type_parameters,
    STATE(3111), 2,
      sym_line_comment,
      sym_block_comment,
  [89244] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    STATE(1607), 1,
      sym_parameters,
    STATE(3112), 2,
      sym_line_comment,
      sym_block_comment,
  [89261] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6577), 1,
      anon_sym_STAR_SLASH,
    ACTIONS(6579), 1,
      sym__block_comment_content,
    STATE(3113), 2,
      sym_line_comment,
      sym_block_comment,
  [89278] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1380), 1,
      sym_field_declaration_list,
    STATE(3114), 2,
      sym_line_comment,
      sym_block_comment,
  [89295] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6555), 1,
      anon_sym_LPAREN,
    ACTIONS(6581), 1,
      anon_sym_COLON_COLON,
    STATE(3115), 2,
      sym_line_comment,
      sym_block_comment,
  [89312] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6583), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3116), 2,
      sym_line_comment,
      sym_block_comment,
  [89327] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5712), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3117), 2,
      sym_line_comment,
      sym_block_comment,
  [89342] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6585), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3118), 2,
      sym_line_comment,
      sym_block_comment,
  [89357] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5285), 1,
      anon_sym_LBRACE,
    STATE(1390), 1,
      sym_enum_variant_list,
    STATE(3119), 2,
      sym_line_comment,
      sym_block_comment,
  [89374] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6587), 2,
      sym_identifier,
      sym_super,
    STATE(3120), 2,
      sym_line_comment,
      sym_block_comment,
  [89389] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5773), 1,
      sym_super,
    ACTIONS(6589), 1,
      sym_identifier,
    STATE(3121), 2,
      sym_line_comment,
      sym_block_comment,
  [89406] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5477), 1,
      sym_super,
    ACTIONS(6591), 1,
      sym_identifier,
    STATE(3122), 2,
      sym_line_comment,
      sym_block_comment,
  [89423] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6593), 2,
      sym_float_literal,
      sym_integer_literal,
    STATE(3123), 2,
      sym_line_comment,
      sym_block_comment,
  [89438] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6595), 1,
      sym_identifier,
    ACTIONS(6597), 1,
      sym_super,
    STATE(3124), 2,
      sym_line_comment,
      sym_block_comment,
  [89455] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3649), 1,
      anon_sym_COLON,
    ACTIONS(5298), 1,
      anon_sym_PLUS,
    STATE(3125), 2,
      sym_line_comment,
      sym_block_comment,
  [89472] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6575), 1,
      anon_sym_LT,
    STATE(1083), 1,
      sym_type_parameters,
    STATE(3126), 2,
      sym_line_comment,
      sym_block_comment,
  [89489] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1460), 1,
      sym_declaration_list,
    STATE(3127), 2,
      sym_line_comment,
      sym_block_comment,
  [89506] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 2,
      sym_identifier,
      sym_super,
    STATE(3128), 2,
      sym_line_comment,
      sym_block_comment,
  [89521] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(1943), 1,
      sym_parameters,
    STATE(3129), 2,
      sym_line_comment,
      sym_block_comment,
  [89538] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6599), 1,
      anon_sym_BANG,
    ACTIONS(6601), 1,
      anon_sym_COLON_COLON,
    STATE(3130), 2,
      sym_line_comment,
      sym_block_comment,
  [89555] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1463), 1,
      sym_declaration_list,
    STATE(3131), 2,
      sym_line_comment,
      sym_block_comment,
  [89572] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3967), 1,
      anon_sym_LBRACE,
    STATE(1751), 1,
      sym_field_initializer_list,
    STATE(3132), 2,
      sym_line_comment,
      sym_block_comment,
  [89589] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_PLUS,
    ACTIONS(6603), 1,
      anon_sym_GT,
    STATE(3133), 2,
      sym_line_comment,
      sym_block_comment,
  [89606] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    STATE(1621), 1,
      sym_parameters,
    STATE(3134), 2,
      sym_line_comment,
      sym_block_comment,
  [89623] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6605), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3135), 2,
      sym_line_comment,
      sym_block_comment,
  [89638] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6607), 1,
      anon_sym_LPAREN,
    ACTIONS(6609), 1,
      anon_sym_COLON_COLON,
    STATE(3136), 2,
      sym_line_comment,
      sym_block_comment,
  [89655] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5371), 1,
      anon_sym_COLON,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    STATE(3137), 2,
      sym_line_comment,
      sym_block_comment,
  [89672] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1426), 1,
      sym_declaration_list,
    STATE(3138), 2,
      sym_line_comment,
      sym_block_comment,
  [89689] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      sym_declaration_list,
    STATE(3139), 2,
      sym_line_comment,
      sym_block_comment,
  [89706] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6613), 1,
      anon_sym_RPAREN,
    STATE(3140), 2,
      sym_line_comment,
      sym_block_comment,
  [89723] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(1939), 1,
      sym_parameters,
    STATE(3141), 2,
      sym_line_comment,
      sym_block_comment,
  [89740] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(494), 1,
      sym_declaration_list,
    STATE(3142), 2,
      sym_line_comment,
      sym_block_comment,
  [89757] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6615), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3143), 2,
      sym_line_comment,
      sym_block_comment,
  [89772] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6613), 1,
      anon_sym_RBRACK,
    STATE(3144), 2,
      sym_line_comment,
      sym_block_comment,
  [89789] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6014), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3145), 2,
      sym_line_comment,
      sym_block_comment,
  [89804] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(6617), 1,
      anon_sym_COLON_COLON,
    STATE(3146), 2,
      sym_line_comment,
      sym_block_comment,
  [89821] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6619), 1,
      anon_sym_RBRACE,
    STATE(3147), 2,
      sym_line_comment,
      sym_block_comment,
  [89838] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5477), 1,
      sym_super,
    ACTIONS(6621), 1,
      sym_identifier,
    STATE(3148), 2,
      sym_line_comment,
      sym_block_comment,
  [89855] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(503), 1,
      sym_declaration_list,
    STATE(3149), 2,
      sym_line_comment,
      sym_block_comment,
  [89872] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3819), 2,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
    STATE(3150), 2,
      sym_line_comment,
      sym_block_comment,
  [89887] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6623), 1,
      anon_sym_RPAREN,
    STATE(3151), 2,
      sym_line_comment,
      sym_block_comment,
  [89904] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6623), 1,
      anon_sym_RBRACK,
    STATE(3152), 2,
      sym_line_comment,
      sym_block_comment,
  [89921] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6625), 2,
      sym_float_literal,
      sym_integer_literal,
    STATE(3153), 2,
      sym_line_comment,
      sym_block_comment,
  [89936] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6627), 1,
      anon_sym_RBRACE,
    STATE(3154), 2,
      sym_line_comment,
      sym_block_comment,
  [89953] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6292), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3155), 2,
      sym_line_comment,
      sym_block_comment,
  [89968] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6527), 1,
      sym_identifier,
    ACTIONS(6597), 1,
      sym_super,
    STATE(3156), 2,
      sym_line_comment,
      sym_block_comment,
  [89985] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(219), 1,
      sym_closure_parameters,
    STATE(3157), 2,
      sym_line_comment,
      sym_block_comment,
  [90002] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6629), 2,
      sym_identifier,
      sym_super,
    STATE(3158), 2,
      sym_line_comment,
      sym_block_comment,
  [90017] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6631), 1,
      anon_sym_RBRACE,
    STATE(3159), 2,
      sym_line_comment,
      sym_block_comment,
  [90034] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6236), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(3160), 2,
      sym_line_comment,
      sym_block_comment,
  [90049] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6633), 1,
      anon_sym_in,
    STATE(3161), 2,
      sym_line_comment,
      sym_block_comment,
  [90066] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6635), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3162), 2,
      sym_line_comment,
      sym_block_comment,
  [90081] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2188), 1,
      sym_parameters,
    STATE(3163), 2,
      sym_line_comment,
      sym_block_comment,
  [90098] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3859), 2,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
    STATE(3164), 2,
      sym_line_comment,
      sym_block_comment,
  [90113] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6637), 1,
      anon_sym_RBRACE,
    STATE(3165), 2,
      sym_line_comment,
      sym_block_comment,
  [90130] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5477), 1,
      sym_super,
    ACTIONS(6639), 1,
      sym_identifier,
    STATE(3166), 2,
      sym_line_comment,
      sym_block_comment,
  [90147] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6124), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3167), 2,
      sym_line_comment,
      sym_block_comment,
  [90162] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    STATE(1066), 1,
      sym_parameters,
    STATE(3168), 2,
      sym_line_comment,
      sym_block_comment,
  [90179] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6061), 1,
      sym_mutable_specifier,
    STATE(3169), 2,
      sym_line_comment,
      sym_block_comment,
  [90196] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(233), 1,
      sym_closure_parameters,
    STATE(3170), 2,
      sym_line_comment,
      sym_block_comment,
  [90213] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5139), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3171), 2,
      sym_line_comment,
      sym_block_comment,
  [90228] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_field_declaration_list,
    STATE(3172), 2,
      sym_line_comment,
      sym_block_comment,
  [90245] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(218), 1,
      sym_closure_parameters,
    STATE(3173), 2,
      sym_line_comment,
      sym_block_comment,
  [90262] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6641), 1,
      anon_sym_SEMI,
    ACTIONS(6643), 1,
      anon_sym_as,
    STATE(3174), 2,
      sym_line_comment,
      sym_block_comment,
  [90279] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1123), 1,
      sym_field_declaration_list,
    STATE(3175), 2,
      sym_line_comment,
      sym_block_comment,
  [90296] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4283), 1,
      anon_sym_EQ_GT,
    ACTIONS(6645), 1,
      anon_sym_AMP_AMP,
    STATE(3176), 2,
      sym_line_comment,
      sym_block_comment,
  [90313] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6647), 1,
      sym_identifier,
    ACTIONS(6649), 1,
      sym_mutable_specifier,
    STATE(3177), 2,
      sym_line_comment,
      sym_block_comment,
  [90330] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5773), 1,
      sym_super,
    ACTIONS(6595), 1,
      sym_identifier,
    STATE(3178), 2,
      sym_line_comment,
      sym_block_comment,
  [90347] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6131), 1,
      anon_sym_EQ_GT,
    ACTIONS(6645), 1,
      anon_sym_AMP_AMP,
    STATE(3179), 2,
      sym_line_comment,
      sym_block_comment,
  [90364] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1138), 1,
      sym_field_declaration_list,
    STATE(3180), 2,
      sym_line_comment,
      sym_block_comment,
  [90381] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5285), 1,
      anon_sym_LBRACE,
    STATE(1142), 1,
      sym_enum_variant_list,
    STATE(3181), 2,
      sym_line_comment,
      sym_block_comment,
  [90398] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5714), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3182), 2,
      sym_line_comment,
      sym_block_comment,
  [90413] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6651), 1,
      anon_sym_RBRACK,
    STATE(3183), 2,
      sym_line_comment,
      sym_block_comment,
  [90430] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(242), 1,
      sym_closure_parameters,
    STATE(3184), 2,
      sym_line_comment,
      sym_block_comment,
  [90447] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1149), 1,
      sym_declaration_list,
    STATE(3185), 2,
      sym_line_comment,
      sym_block_comment,
  [90464] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1156), 1,
      sym_field_declaration_list,
    STATE(3186), 2,
      sym_line_comment,
      sym_block_comment,
  [90481] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6651), 1,
      anon_sym_RPAREN,
    STATE(3187), 2,
      sym_line_comment,
      sym_block_comment,
  [90498] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5632), 2,
      sym_identifier,
      sym_super,
    STATE(3188), 2,
      sym_line_comment,
      sym_block_comment,
  [90513] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6653), 1,
      anon_sym_RBRACK,
    STATE(3189), 2,
      sym_line_comment,
      sym_block_comment,
  [90530] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6655), 1,
      sym_identifier,
    STATE(3190), 2,
      sym_line_comment,
      sym_block_comment,
  [90547] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1165), 1,
      sym_declaration_list,
    STATE(3191), 2,
      sym_line_comment,
      sym_block_comment,
  [90564] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5744), 1,
      sym_identifier,
    STATE(3192), 2,
      sym_line_comment,
      sym_block_comment,
  [90581] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6563), 1,
      sym_super,
    ACTIONS(6657), 1,
      sym_identifier,
    STATE(3193), 2,
      sym_line_comment,
      sym_block_comment,
  [90598] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1169), 1,
      sym_declaration_list,
    STATE(3194), 2,
      sym_line_comment,
      sym_block_comment,
  [90615] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1173), 1,
      sym_field_declaration_list,
    STATE(3195), 2,
      sym_line_comment,
      sym_block_comment,
  [90632] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    ACTIONS(6653), 1,
      anon_sym_RPAREN,
    STATE(3196), 2,
      sym_line_comment,
      sym_block_comment,
  [90649] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(235), 1,
      sym_closure_parameters,
    STATE(3197), 2,
      sym_line_comment,
      sym_block_comment,
  [90666] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2196), 1,
      sym_parameters,
    STATE(3198), 2,
      sym_line_comment,
      sym_block_comment,
  [90683] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5793), 1,
      sym_identifier,
    STATE(3199), 2,
      sym_line_comment,
      sym_block_comment,
  [90700] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5791), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3200), 2,
      sym_line_comment,
      sym_block_comment,
  [90715] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6483), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6659), 1,
      anon_sym_RPAREN,
    STATE(3201), 2,
      sym_line_comment,
      sym_block_comment,
  [90732] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6491), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6659), 1,
      anon_sym_RPAREN,
    STATE(3202), 2,
      sym_line_comment,
      sym_block_comment,
  [90749] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6659), 1,
      anon_sym_RPAREN,
    STATE(3203), 2,
      sym_line_comment,
      sym_block_comment,
  [90766] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5137), 1,
      anon_sym_RBRACE,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3204), 2,
      sym_line_comment,
      sym_block_comment,
  [90783] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5127), 1,
      anon_sym_RBRACK,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3205), 2,
      sym_line_comment,
      sym_block_comment,
  [90800] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5127), 1,
      anon_sym_RPAREN,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3206), 2,
      sym_line_comment,
      sym_block_comment,
  [90817] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5650), 2,
      sym_identifier,
      sym_super,
    STATE(3207), 2,
      sym_line_comment,
      sym_block_comment,
  [90832] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5797), 1,
      sym_identifier,
    STATE(3208), 2,
      sym_line_comment,
      sym_block_comment,
  [90849] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5125), 1,
      anon_sym_RBRACE,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3209), 2,
      sym_line_comment,
      sym_block_comment,
  [90866] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5121), 1,
      anon_sym_RBRACK,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3210), 2,
      sym_line_comment,
      sym_block_comment,
  [90883] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6499), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6661), 1,
      anon_sym_RPAREN,
    STATE(3211), 2,
      sym_line_comment,
      sym_block_comment,
  [90900] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6563), 1,
      sym_super,
    ACTIONS(6663), 1,
      sym_identifier,
    STATE(3212), 2,
      sym_line_comment,
      sym_block_comment,
  [90917] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6665), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3213), 2,
      sym_line_comment,
      sym_block_comment,
  [90932] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5121), 1,
      anon_sym_RPAREN,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3214), 2,
      sym_line_comment,
      sym_block_comment,
  [90949] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3947), 1,
      anon_sym_LT2,
    STATE(1820), 1,
      sym_type_arguments,
    STATE(3215), 2,
      sym_line_comment,
      sym_block_comment,
  [90966] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(232), 1,
      sym_closure_parameters,
    STATE(3216), 2,
      sym_line_comment,
      sym_block_comment,
  [90983] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5151), 2,
      sym_identifier,
      sym_super,
    STATE(3217), 2,
      sym_line_comment,
      sym_block_comment,
  [90998] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6563), 1,
      sym_super,
    ACTIONS(6667), 1,
      sym_identifier,
    STATE(3218), 2,
      sym_line_comment,
      sym_block_comment,
  [91015] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6555), 1,
      anon_sym_LPAREN,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(3219), 2,
      sym_line_comment,
      sym_block_comment,
  [91032] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1420), 1,
      sym_type_arguments,
    STATE(3220), 2,
      sym_line_comment,
      sym_block_comment,
  [91049] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5149), 1,
      anon_sym_RBRACK,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3221), 2,
      sym_line_comment,
      sym_block_comment,
  [91066] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5149), 1,
      anon_sym_RPAREN,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3222), 2,
      sym_line_comment,
      sym_block_comment,
  [91083] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6597), 1,
      sym_super,
    ACTIONS(6671), 1,
      sym_identifier,
    STATE(3223), 2,
      sym_line_comment,
      sym_block_comment,
  [91100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5191), 1,
      anon_sym_RBRACK,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3224), 2,
      sym_line_comment,
      sym_block_comment,
  [91117] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(221), 1,
      sym_closure_parameters,
    STATE(3225), 2,
      sym_line_comment,
      sym_block_comment,
  [91134] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5285), 1,
      anon_sym_LBRACE,
    STATE(1259), 1,
      sym_enum_variant_list,
    STATE(3226), 2,
      sym_line_comment,
      sym_block_comment,
  [91151] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5191), 1,
      anon_sym_RPAREN,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3227), 2,
      sym_line_comment,
      sym_block_comment,
  [91168] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6529), 1,
      sym_identifier,
    ACTIONS(6553), 1,
      sym_super,
    STATE(3228), 2,
      sym_line_comment,
      sym_block_comment,
  [91185] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6629), 1,
      sym_super,
    ACTIONS(6673), 1,
      sym_identifier,
    STATE(3229), 2,
      sym_line_comment,
      sym_block_comment,
  [91202] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6005), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3230), 2,
      sym_line_comment,
      sym_block_comment,
  [91217] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(3231), 2,
      sym_line_comment,
      sym_block_comment,
  [91234] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6675), 1,
      sym_identifier,
    ACTIONS(6677), 1,
      sym_super,
    STATE(3232), 2,
      sym_line_comment,
      sym_block_comment,
  [91251] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5634), 1,
      sym_identifier,
    ACTIONS(5650), 1,
      sym_super,
    STATE(3233), 2,
      sym_line_comment,
      sym_block_comment,
  [91268] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6515), 1,
      sym_identifier,
    ACTIONS(6553), 1,
      sym_super,
    STATE(3234), 2,
      sym_line_comment,
      sym_block_comment,
  [91285] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6679), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3235), 2,
      sym_line_comment,
      sym_block_comment,
  [91300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    STATE(654), 1,
      sym_field_declaration_list,
    STATE(3236), 2,
      sym_line_comment,
      sym_block_comment,
  [91317] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6681), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3237), 2,
      sym_line_comment,
      sym_block_comment,
  [91332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6561), 1,
      sym_identifier,
    ACTIONS(6677), 1,
      sym_super,
    STATE(3238), 2,
      sym_line_comment,
      sym_block_comment,
  [91349] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    STATE(1052), 1,
      sym_parameters,
    STATE(3239), 2,
      sym_line_comment,
      sym_block_comment,
  [91366] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6683), 1,
      sym_identifier,
    ACTIONS(6685), 1,
      sym_mutable_specifier,
    STATE(3240), 2,
      sym_line_comment,
      sym_block_comment,
  [91383] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5744), 1,
      sym_identifier,
    STATE(3241), 2,
      sym_line_comment,
      sym_block_comment,
  [91400] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5273), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3242), 2,
      sym_line_comment,
      sym_block_comment,
  [91415] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4594), 1,
      anon_sym_BANG,
    ACTIONS(4684), 1,
      anon_sym_COLON_COLON,
    STATE(3243), 2,
      sym_line_comment,
      sym_block_comment,
  [91432] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4594), 1,
      anon_sym_BANG,
    ACTIONS(4672), 1,
      anon_sym_COLON_COLON,
    STATE(3244), 2,
      sym_line_comment,
      sym_block_comment,
  [91449] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2215), 1,
      sym_parameters,
    STATE(3245), 2,
      sym_line_comment,
      sym_block_comment,
  [91466] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(727), 1,
      sym_declaration_list,
    STATE(3246), 2,
      sym_line_comment,
      sym_block_comment,
  [91483] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6657), 1,
      sym_identifier,
    ACTIONS(6677), 1,
      sym_super,
    STATE(3247), 2,
      sym_line_comment,
      sym_block_comment,
  [91500] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6575), 1,
      anon_sym_LT,
    STATE(1086), 1,
      sym_type_parameters,
    STATE(3248), 2,
      sym_line_comment,
      sym_block_comment,
  [91517] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5860), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3249), 2,
      sym_line_comment,
      sym_block_comment,
  [91532] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6597), 1,
      sym_super,
    ACTIONS(6687), 1,
      sym_identifier,
    STATE(3250), 2,
      sym_line_comment,
      sym_block_comment,
  [91549] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2961), 1,
      anon_sym_SQUOTE,
    STATE(2932), 1,
      sym_lifetime,
    STATE(3251), 2,
      sym_line_comment,
      sym_block_comment,
  [91566] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    STATE(1080), 1,
      sym_parameters,
    STATE(3252), 2,
      sym_line_comment,
      sym_block_comment,
  [91583] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6689), 1,
      sym_identifier,
    STATE(3253), 2,
      sym_line_comment,
      sym_block_comment,
  [91600] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6575), 1,
      anon_sym_LT,
    STATE(910), 1,
      sym_type_parameters,
    STATE(3254), 2,
      sym_line_comment,
      sym_block_comment,
  [91617] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5819), 1,
      sym_identifier,
    STATE(3255), 2,
      sym_line_comment,
      sym_block_comment,
  [91634] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6677), 1,
      sym_super,
    ACTIONS(6691), 1,
      sym_identifier,
    STATE(3256), 2,
      sym_line_comment,
      sym_block_comment,
  [91651] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6693), 2,
      sym_identifier,
      sym_super,
    STATE(3257), 2,
      sym_line_comment,
      sym_block_comment,
  [91666] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(1958), 1,
      sym_parameters,
    STATE(3258), 2,
      sym_line_comment,
      sym_block_comment,
  [91683] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6575), 1,
      anon_sym_LT,
    STATE(1077), 1,
      sym_type_parameters,
    STATE(3259), 2,
      sym_line_comment,
      sym_block_comment,
  [91700] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5931), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3260), 2,
      sym_line_comment,
      sym_block_comment,
  [91715] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6597), 2,
      sym_identifier,
      sym_super,
    STATE(3261), 2,
      sym_line_comment,
      sym_block_comment,
  [91730] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5995), 1,
      anon_sym_for,
    STATE(3262), 2,
      sym_line_comment,
      sym_block_comment,
  [91747] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6695), 1,
      anon_sym_SEMI,
    ACTIONS(6697), 1,
      anon_sym_as,
    STATE(3263), 2,
      sym_line_comment,
      sym_block_comment,
  [91764] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6563), 2,
      sym_identifier,
      sym_super,
    STATE(3264), 2,
      sym_line_comment,
      sym_block_comment,
  [91779] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5285), 1,
      anon_sym_LBRACE,
    STATE(1363), 1,
      sym_enum_variant_list,
    STATE(3265), 2,
      sym_line_comment,
      sym_block_comment,
  [91796] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(696), 1,
      sym_declaration_list,
    STATE(3266), 2,
      sym_line_comment,
      sym_block_comment,
  [91813] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5269), 1,
      anon_sym_LBRACE,
    STATE(738), 1,
      sym_enum_variant_list,
    STATE(3267), 2,
      sym_line_comment,
      sym_block_comment,
  [91830] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5976), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3268), 2,
      sym_line_comment,
      sym_block_comment,
  [91845] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6699), 1,
      anon_sym_BANG,
    ACTIONS(6701), 1,
      anon_sym_COLON_COLON,
    STATE(3269), 2,
      sym_line_comment,
      sym_block_comment,
  [91862] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6703), 1,
      anon_sym_EQ,
    STATE(3270), 2,
      sym_line_comment,
      sym_block_comment,
  [91879] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6693), 1,
      sym_super,
    ACTIONS(6705), 1,
      sym_identifier,
    STATE(3271), 2,
      sym_line_comment,
      sym_block_comment,
  [91896] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5959), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3272), 2,
      sym_line_comment,
      sym_block_comment,
  [91911] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6707), 1,
      sym_identifier,
    STATE(3273), 2,
      sym_line_comment,
      sym_block_comment,
  [91928] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5201), 1,
      anon_sym_RBRACE,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3274), 2,
      sym_line_comment,
      sym_block_comment,
  [91945] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5799), 1,
      sym_super,
    ACTIONS(5854), 1,
      sym_identifier,
    STATE(3275), 2,
      sym_line_comment,
      sym_block_comment,
  [91962] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6587), 1,
      sym_super,
    ACTIONS(6709), 1,
      sym_identifier,
    STATE(3276), 2,
      sym_line_comment,
      sym_block_comment,
  [91979] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6711), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3277), 2,
      sym_line_comment,
      sym_block_comment,
  [91994] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    STATE(685), 1,
      sym_field_declaration_list,
    STATE(3278), 2,
      sym_line_comment,
      sym_block_comment,
  [92011] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5109), 1,
      anon_sym_RBRACE,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3279), 2,
      sym_line_comment,
      sym_block_comment,
  [92028] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2211), 1,
      sym_parameters,
    STATE(3280), 2,
      sym_line_comment,
      sym_block_comment,
  [92045] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5269), 1,
      anon_sym_LBRACE,
    STATE(664), 1,
      sym_enum_variant_list,
    STATE(3281), 2,
      sym_line_comment,
      sym_block_comment,
  [92062] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5773), 1,
      sym_super,
    ACTIONS(6671), 1,
      sym_identifier,
    STATE(3282), 2,
      sym_line_comment,
      sym_block_comment,
  [92079] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6639), 1,
      sym_identifier,
    STATE(3283), 2,
      sym_line_comment,
      sym_block_comment,
  [92096] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(695), 1,
      sym_declaration_list,
    STATE(3284), 2,
      sym_line_comment,
      sym_block_comment,
  [92113] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(3285), 2,
      sym_line_comment,
      sym_block_comment,
  [92130] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6563), 1,
      sym_super,
    ACTIONS(6675), 1,
      sym_identifier,
    STATE(3286), 2,
      sym_line_comment,
      sym_block_comment,
  [92147] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(6713), 1,
      anon_sym_EQ,
    STATE(3287), 2,
      sym_line_comment,
      sym_block_comment,
  [92164] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6597), 1,
      sym_super,
    ACTIONS(6715), 1,
      sym_identifier,
    STATE(3288), 2,
      sym_line_comment,
      sym_block_comment,
  [92181] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6555), 1,
      anon_sym_LPAREN,
    ACTIONS(6717), 1,
      anon_sym_COLON_COLON,
    STATE(3289), 2,
      sym_line_comment,
      sym_block_comment,
  [92198] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5862), 1,
      sym_identifier,
    STATE(3290), 2,
      sym_line_comment,
      sym_block_comment,
  [92215] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6677), 1,
      sym_super,
    ACTIONS(6719), 1,
      sym_identifier,
    STATE(3291), 2,
      sym_line_comment,
      sym_block_comment,
  [92232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6575), 1,
      anon_sym_LT,
    STATE(981), 1,
      sym_type_parameters,
    STATE(3292), 2,
      sym_line_comment,
      sym_block_comment,
  [92249] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6597), 1,
      sym_super,
    ACTIONS(6721), 1,
      sym_identifier,
    STATE(3293), 2,
      sym_line_comment,
      sym_block_comment,
  [92266] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5878), 1,
      sym_identifier,
    STATE(3294), 2,
      sym_line_comment,
      sym_block_comment,
  [92283] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6677), 1,
      sym_super,
    ACTIONS(6723), 1,
      sym_identifier,
    STATE(3295), 2,
      sym_line_comment,
      sym_block_comment,
  [92300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6597), 1,
      sym_super,
    ACTIONS(6725), 1,
      sym_identifier,
    STATE(3296), 2,
      sym_line_comment,
      sym_block_comment,
  [92317] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    STATE(649), 1,
      sym_field_declaration_list,
    STATE(3297), 2,
      sym_line_comment,
      sym_block_comment,
  [92334] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5650), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3298), 2,
      sym_line_comment,
      sym_block_comment,
  [92351] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6677), 1,
      sym_super,
    ACTIONS(6727), 1,
      sym_identifier,
    STATE(3299), 2,
      sym_line_comment,
      sym_block_comment,
  [92368] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(648), 1,
      sym_declaration_list,
    STATE(3300), 2,
      sym_line_comment,
      sym_block_comment,
  [92385] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5773), 1,
      sym_super,
    ACTIONS(6725), 1,
      sym_identifier,
    STATE(3301), 2,
      sym_line_comment,
      sym_block_comment,
  [92402] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5151), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3302), 2,
      sym_line_comment,
      sym_block_comment,
  [92419] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6563), 1,
      sym_super,
    ACTIONS(6727), 1,
      sym_identifier,
    STATE(3303), 2,
      sym_line_comment,
      sym_block_comment,
  [92436] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    STATE(700), 1,
      sym_declaration_list,
    STATE(3304), 2,
      sym_line_comment,
      sym_block_comment,
  [92453] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4892), 1,
      anon_sym_LBRACE,
    STATE(704), 1,
      sym_field_declaration_list,
    STATE(3305), 2,
      sym_line_comment,
      sym_block_comment,
  [92470] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6729), 1,
      anon_sym_SEMI,
    ACTIONS(6731), 1,
      anon_sym_as,
    STATE(3306), 2,
      sym_line_comment,
      sym_block_comment,
  [92487] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6677), 2,
      sym_identifier,
      sym_super,
    STATE(3307), 2,
      sym_line_comment,
      sym_block_comment,
  [92502] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2230), 1,
      sym_parameters,
    STATE(3308), 2,
      sym_line_comment,
      sym_block_comment,
  [92519] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1320), 1,
      sym_field_declaration_list,
    STATE(3309), 2,
      sym_line_comment,
      sym_block_comment,
  [92536] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4884), 1,
      anon_sym_LBRACE,
    STATE(1328), 1,
      sym_declaration_list,
    STATE(3310), 2,
      sym_line_comment,
      sym_block_comment,
  [92553] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4945), 1,
      anon_sym_LBRACE,
    STATE(1333), 1,
      sym_field_declaration_list,
    STATE(3311), 2,
      sym_line_comment,
      sym_block_comment,
  [92570] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    STATE(3312), 2,
      sym_line_comment,
      sym_block_comment,
  [92584] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6733), 1,
      anon_sym_SEMI,
    STATE(3313), 2,
      sym_line_comment,
      sym_block_comment,
  [92598] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6735), 1,
      sym_identifier,
    STATE(3314), 2,
      sym_line_comment,
      sym_block_comment,
  [92612] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6737), 1,
      sym_identifier,
    STATE(3315), 2,
      sym_line_comment,
      sym_block_comment,
  [92626] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6739), 1,
      sym_identifier,
    STATE(3316), 2,
      sym_line_comment,
      sym_block_comment,
  [92640] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6741), 1,
      sym_identifier,
    STATE(3317), 2,
      sym_line_comment,
      sym_block_comment,
  [92654] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6743), 1,
      sym_identifier,
    STATE(3318), 2,
      sym_line_comment,
      sym_block_comment,
  [92668] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6745), 1,
      anon_sym_RPAREN,
    STATE(3319), 2,
      sym_line_comment,
      sym_block_comment,
  [92682] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5912), 1,
      anon_sym_RBRACE,
    STATE(3320), 2,
      sym_line_comment,
      sym_block_comment,
  [92696] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6747), 1,
      sym_raw_string_literal_content,
    STATE(3321), 2,
      sym_line_comment,
      sym_block_comment,
  [92710] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6749), 1,
      sym_identifier,
    STATE(3322), 2,
      sym_line_comment,
      sym_block_comment,
  [92724] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4051), 1,
      anon_sym_COLON_COLON,
    STATE(3323), 2,
      sym_line_comment,
      sym_block_comment,
  [92738] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(943), 1,
      anon_sym_EQ_GT,
    STATE(3324), 2,
      sym_line_comment,
      sym_block_comment,
  [92752] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6751), 1,
      anon_sym_SEMI,
    STATE(3325), 2,
      sym_line_comment,
      sym_block_comment,
  [92766] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6753), 1,
      anon_sym_SEMI,
    STATE(3326), 2,
      sym_line_comment,
      sym_block_comment,
  [92780] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6755), 1,
      sym_identifier,
    STATE(3327), 2,
      sym_line_comment,
      sym_block_comment,
  [92794] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6757), 1,
      anon_sym_SEMI,
    STATE(3328), 2,
      sym_line_comment,
      sym_block_comment,
  [92808] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4107), 1,
      anon_sym_RPAREN,
    STATE(3329), 2,
      sym_line_comment,
      sym_block_comment,
  [92822] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6759), 1,
      anon_sym_SEMI,
    STATE(3330), 2,
      sym_line_comment,
      sym_block_comment,
  [92836] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3331), 2,
      sym_line_comment,
      sym_block_comment,
  [92850] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6761), 1,
      anon_sym_RPAREN,
    STATE(3332), 2,
      sym_line_comment,
      sym_block_comment,
  [92864] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    STATE(3333), 2,
      sym_line_comment,
      sym_block_comment,
  [92878] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6763), 1,
      anon_sym_fn,
    STATE(3334), 2,
      sym_line_comment,
      sym_block_comment,
  [92892] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6765), 1,
      anon_sym_SEMI,
    STATE(3335), 2,
      sym_line_comment,
      sym_block_comment,
  [92906] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6767), 1,
      anon_sym_COLON,
    STATE(3336), 2,
      sym_line_comment,
      sym_block_comment,
  [92920] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5109), 1,
      anon_sym_SEMI,
    STATE(3337), 2,
      sym_line_comment,
      sym_block_comment,
  [92934] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6769), 1,
      anon_sym_SEMI,
    STATE(3338), 2,
      sym_line_comment,
      sym_block_comment,
  [92948] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6771), 1,
      anon_sym_fn,
    STATE(3339), 2,
      sym_line_comment,
      sym_block_comment,
  [92962] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5201), 1,
      anon_sym_SEMI,
    STATE(3340), 2,
      sym_line_comment,
      sym_block_comment,
  [92976] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    STATE(3341), 2,
      sym_line_comment,
      sym_block_comment,
  [92990] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6775), 1,
      anon_sym_SEMI,
    STATE(3342), 2,
      sym_line_comment,
      sym_block_comment,
  [93004] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5972), 1,
      anon_sym_RBRACE,
    STATE(3343), 2,
      sym_line_comment,
      sym_block_comment,
  [93018] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    STATE(3344), 2,
      sym_line_comment,
      sym_block_comment,
  [93032] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    STATE(3345), 2,
      sym_line_comment,
      sym_block_comment,
  [93046] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6779), 1,
      anon_sym_RBRACK,
    STATE(3346), 2,
      sym_line_comment,
      sym_block_comment,
  [93060] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6781), 1,
      sym_identifier,
    STATE(3347), 2,
      sym_line_comment,
      sym_block_comment,
  [93074] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6001), 1,
      anon_sym_RBRACE,
    STATE(3348), 2,
      sym_line_comment,
      sym_block_comment,
  [93088] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6783), 1,
      anon_sym_RBRACK,
    STATE(3349), 2,
      sym_line_comment,
      sym_block_comment,
  [93102] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6785), 1,
      sym_identifier,
    STATE(3350), 2,
      sym_line_comment,
      sym_block_comment,
  [93116] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6787), 1,
      anon_sym_COLON_COLON,
    STATE(3351), 2,
      sym_line_comment,
      sym_block_comment,
  [93130] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6789), 1,
      sym_identifier,
    STATE(3352), 2,
      sym_line_comment,
      sym_block_comment,
  [93144] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    STATE(3353), 2,
      sym_line_comment,
      sym_block_comment,
  [93158] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6793), 1,
      sym_identifier,
    STATE(3354), 2,
      sym_line_comment,
      sym_block_comment,
  [93172] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6795), 1,
      sym_identifier,
    STATE(3355), 2,
      sym_line_comment,
      sym_block_comment,
  [93186] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6797), 1,
      sym_identifier,
    STATE(3356), 2,
      sym_line_comment,
      sym_block_comment,
  [93200] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6799), 1,
      anon_sym_COLON,
    STATE(3357), 2,
      sym_line_comment,
      sym_block_comment,
  [93214] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6801), 1,
      anon_sym_COLON_COLON,
    STATE(3358), 2,
      sym_line_comment,
      sym_block_comment,
  [93228] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5821), 1,
      anon_sym_RPAREN,
    STATE(3359), 2,
      sym_line_comment,
      sym_block_comment,
  [93242] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6010), 1,
      anon_sym_RBRACE,
    STATE(3360), 2,
      sym_line_comment,
      sym_block_comment,
  [93256] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5807), 1,
      anon_sym_RPAREN,
    STATE(3361), 2,
      sym_line_comment,
      sym_block_comment,
  [93270] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6803), 1,
      anon_sym_COLON_COLON,
    STATE(3362), 2,
      sym_line_comment,
      sym_block_comment,
  [93284] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6019), 1,
      anon_sym_RBRACE,
    STATE(3363), 2,
      sym_line_comment,
      sym_block_comment,
  [93298] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6805), 1,
      anon_sym_SEMI,
    STATE(3364), 2,
      sym_line_comment,
      sym_block_comment,
  [93312] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4926), 1,
      anon_sym_COLON_COLON,
    STATE(3365), 2,
      sym_line_comment,
      sym_block_comment,
  [93326] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6807), 1,
      sym_identifier,
    STATE(3366), 2,
      sym_line_comment,
      sym_block_comment,
  [93340] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5938), 1,
      anon_sym_COLON_COLON,
    STATE(3367), 2,
      sym_line_comment,
      sym_block_comment,
  [93354] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6809), 1,
      anon_sym_SEMI,
    STATE(3368), 2,
      sym_line_comment,
      sym_block_comment,
  [93368] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4961), 1,
      anon_sym_COLON_COLON,
    STATE(3369), 2,
      sym_line_comment,
      sym_block_comment,
  [93382] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4730), 1,
      anon_sym_COLON_COLON,
    STATE(3370), 2,
      sym_line_comment,
      sym_block_comment,
  [93396] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6811), 1,
      anon_sym_COLON_COLON,
    STATE(3371), 2,
      sym_line_comment,
      sym_block_comment,
  [93410] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6813), 1,
      anon_sym_fn,
    STATE(3372), 2,
      sym_line_comment,
      sym_block_comment,
  [93424] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6815), 1,
      anon_sym_RPAREN,
    STATE(3373), 2,
      sym_line_comment,
      sym_block_comment,
  [93438] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5864), 1,
      anon_sym_LBRACE,
    STATE(3374), 2,
      sym_line_comment,
      sym_block_comment,
  [93452] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6817), 1,
      anon_sym_SEMI,
    STATE(3375), 2,
      sym_line_comment,
      sym_block_comment,
  [93466] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6819), 1,
      sym_identifier,
    STATE(3376), 2,
      sym_line_comment,
      sym_block_comment,
  [93480] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6821), 1,
      sym__raw_string_literal_end,
    STATE(3377), 2,
      sym_line_comment,
      sym_block_comment,
  [93494] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5429), 1,
      anon_sym_RPAREN,
    STATE(3378), 2,
      sym_line_comment,
      sym_block_comment,
  [93508] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6823), 1,
      anon_sym_COLON,
    STATE(3379), 2,
      sym_line_comment,
      sym_block_comment,
  [93522] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6825), 1,
      anon_sym_SEMI,
    STATE(3380), 2,
      sym_line_comment,
      sym_block_comment,
  [93536] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6827), 1,
      sym_identifier,
    STATE(3381), 2,
      sym_line_comment,
      sym_block_comment,
  [93550] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6829), 1,
      anon_sym_SEMI,
    STATE(3382), 2,
      sym_line_comment,
      sym_block_comment,
  [93564] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6831), 1,
      sym_identifier,
    STATE(3383), 2,
      sym_line_comment,
      sym_block_comment,
  [93578] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6833), 1,
      anon_sym_RBRACK,
    STATE(3384), 2,
      sym_line_comment,
      sym_block_comment,
  [93592] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5844), 1,
      anon_sym_RBRACK,
    STATE(3385), 2,
      sym_line_comment,
      sym_block_comment,
  [93606] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6835), 1,
      anon_sym_RBRACK,
    STATE(3386), 2,
      sym_line_comment,
      sym_block_comment,
  [93620] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6837), 1,
      anon_sym_COLON,
    STATE(3387), 2,
      sym_line_comment,
      sym_block_comment,
  [93634] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5835), 1,
      anon_sym_RPAREN,
    STATE(3388), 2,
      sym_line_comment,
      sym_block_comment,
  [93648] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1013), 1,
      anon_sym_RBRACK,
    STATE(3389), 2,
      sym_line_comment,
      sym_block_comment,
  [93662] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5831), 1,
      anon_sym_RBRACK,
    STATE(3390), 2,
      sym_line_comment,
      sym_block_comment,
  [93676] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6839), 1,
      sym_identifier,
    STATE(3391), 2,
      sym_line_comment,
      sym_block_comment,
  [93690] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6841), 1,
      sym_identifier,
    STATE(3392), 2,
      sym_line_comment,
      sym_block_comment,
  [93704] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5825), 1,
      anon_sym_RPAREN,
    STATE(3393), 2,
      sym_line_comment,
      sym_block_comment,
  [93718] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6843), 1,
      anon_sym_SEMI,
    STATE(3394), 2,
      sym_line_comment,
      sym_block_comment,
  [93732] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4085), 1,
      anon_sym_RPAREN,
    STATE(3395), 2,
      sym_line_comment,
      sym_block_comment,
  [93746] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6845), 1,
      anon_sym_STAR_SLASH,
    STATE(3396), 2,
      sym_line_comment,
      sym_block_comment,
  [93760] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6075), 1,
      anon_sym_RBRACE,
    STATE(3397), 2,
      sym_line_comment,
      sym_block_comment,
  [93774] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6847), 1,
      anon_sym_SEMI,
    STATE(3398), 2,
      sym_line_comment,
      sym_block_comment,
  [93788] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6849), 1,
      anon_sym_EQ_GT,
    STATE(3399), 2,
      sym_line_comment,
      sym_block_comment,
  [93802] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6851), 1,
      anon_sym_SEMI,
    STATE(3400), 2,
      sym_line_comment,
      sym_block_comment,
  [93816] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6853), 1,
      anon_sym_RBRACE,
    STATE(3401), 2,
      sym_line_comment,
      sym_block_comment,
  [93830] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6855), 1,
      sym_identifier,
    STATE(3402), 2,
      sym_line_comment,
      sym_block_comment,
  [93844] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6857), 1,
      sym_identifier,
    STATE(3403), 2,
      sym_line_comment,
      sym_block_comment,
  [93858] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6859), 1,
      anon_sym_SEMI,
    STATE(3404), 2,
      sym_line_comment,
      sym_block_comment,
  [93872] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1019), 1,
      anon_sym_RBRACK,
    STATE(3405), 2,
      sym_line_comment,
      sym_block_comment,
  [93886] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6861), 1,
      anon_sym_SEMI,
    STATE(3406), 2,
      sym_line_comment,
      sym_block_comment,
  [93900] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6863), 1,
      anon_sym_SEMI,
    STATE(3407), 2,
      sym_line_comment,
      sym_block_comment,
  [93914] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6865), 1,
      sym__raw_string_literal_end,
    STATE(3408), 2,
      sym_line_comment,
      sym_block_comment,
  [93928] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6867), 1,
      anon_sym_fn,
    STATE(3409), 2,
      sym_line_comment,
      sym_block_comment,
  [93942] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6869), 1,
      sym_identifier,
    STATE(3410), 2,
      sym_line_comment,
      sym_block_comment,
  [93956] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6871), 1,
      sym_identifier,
    STATE(3411), 2,
      sym_line_comment,
      sym_block_comment,
  [93970] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6873), 1,
      sym_identifier,
    STATE(3412), 2,
      sym_line_comment,
      sym_block_comment,
  [93984] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6875), 1,
      anon_sym_RBRACE,
    STATE(3413), 2,
      sym_line_comment,
      sym_block_comment,
  [93998] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6877), 1,
      sym_identifier,
    STATE(3414), 2,
      sym_line_comment,
      sym_block_comment,
  [94012] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6879), 1,
      sym_identifier,
    STATE(3415), 2,
      sym_line_comment,
      sym_block_comment,
  [94026] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5125), 1,
      anon_sym_SEMI,
    STATE(3416), 2,
      sym_line_comment,
      sym_block_comment,
  [94040] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6881), 1,
      anon_sym_EQ_GT,
    STATE(3417), 2,
      sym_line_comment,
      sym_block_comment,
  [94054] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6883), 1,
      anon_sym_RBRACE,
    STATE(3418), 2,
      sym_line_comment,
      sym_block_comment,
  [94068] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6885), 1,
      anon_sym_RBRACE,
    STATE(3419), 2,
      sym_line_comment,
      sym_block_comment,
  [94082] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5137), 1,
      anon_sym_SEMI,
    STATE(3420), 2,
      sym_line_comment,
      sym_block_comment,
  [94096] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6146), 1,
      anon_sym_RBRACE,
    STATE(3421), 2,
      sym_line_comment,
      sym_block_comment,
  [94110] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6887), 1,
      anon_sym_SEMI,
    STATE(3422), 2,
      sym_line_comment,
      sym_block_comment,
  [94124] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6889), 1,
      sym_identifier,
    STATE(3423), 2,
      sym_line_comment,
      sym_block_comment,
  [94138] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6891), 1,
      anon_sym_SEMI,
    STATE(3424), 2,
      sym_line_comment,
      sym_block_comment,
  [94152] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6893), 1,
      sym_identifier,
    STATE(3425), 2,
      sym_line_comment,
      sym_block_comment,
  [94166] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6895), 1,
      anon_sym_SEMI,
    STATE(3426), 2,
      sym_line_comment,
      sym_block_comment,
  [94180] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6897), 1,
      sym_identifier,
    STATE(3427), 2,
      sym_line_comment,
      sym_block_comment,
  [94194] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5369), 1,
      anon_sym_RPAREN,
    STATE(3428), 2,
      sym_line_comment,
      sym_block_comment,
  [94208] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6899), 1,
      anon_sym_RBRACK,
    STATE(3429), 2,
      sym_line_comment,
      sym_block_comment,
  [94222] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6901), 1,
      anon_sym_SEMI,
    STATE(3430), 2,
      sym_line_comment,
      sym_block_comment,
  [94236] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6903), 1,
      anon_sym_SEMI,
    STATE(3431), 2,
      sym_line_comment,
      sym_block_comment,
  [94250] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6905), 1,
      anon_sym_COLON_COLON,
    STATE(3432), 2,
      sym_line_comment,
      sym_block_comment,
  [94264] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6907), 1,
      anon_sym_SEMI,
    STATE(3433), 2,
      sym_line_comment,
      sym_block_comment,
  [94278] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6909), 1,
      anon_sym_SEMI,
    STATE(3434), 2,
      sym_line_comment,
      sym_block_comment,
  [94292] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6911), 1,
      anon_sym_EQ_GT,
    STATE(3435), 2,
      sym_line_comment,
      sym_block_comment,
  [94306] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6913), 1,
      anon_sym_EQ_GT,
    STATE(3436), 2,
      sym_line_comment,
      sym_block_comment,
  [94320] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6915), 1,
      sym_identifier,
    STATE(3437), 2,
      sym_line_comment,
      sym_block_comment,
  [94334] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6228), 1,
      anon_sym_RBRACE,
    STATE(3438), 2,
      sym_line_comment,
      sym_block_comment,
  [94348] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6917), 1,
      sym_identifier,
    STATE(3439), 2,
      sym_line_comment,
      sym_block_comment,
  [94362] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6919), 1,
      anon_sym_COLON,
    STATE(3440), 2,
      sym_line_comment,
      sym_block_comment,
  [94376] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6921), 1,
      sym_identifier,
    STATE(3441), 2,
      sym_line_comment,
      sym_block_comment,
  [94390] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6923), 1,
      sym_identifier,
    STATE(3442), 2,
      sym_line_comment,
      sym_block_comment,
  [94404] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6925), 1,
      sym__raw_string_literal_end,
    STATE(3443), 2,
      sym_line_comment,
      sym_block_comment,
  [94418] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3099), 1,
      anon_sym_PLUS,
    STATE(3444), 2,
      sym_line_comment,
      sym_block_comment,
  [94432] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6927), 1,
      sym_self,
    STATE(3445), 2,
      sym_line_comment,
      sym_block_comment,
  [94446] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6929), 1,
      sym_identifier,
    STATE(3446), 2,
      sym_line_comment,
      sym_block_comment,
  [94460] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6931), 1,
      sym_identifier,
    STATE(3447), 2,
      sym_line_comment,
      sym_block_comment,
  [94474] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6933), 1,
      sym_identifier,
    STATE(3448), 2,
      sym_line_comment,
      sym_block_comment,
  [94488] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6637), 1,
      anon_sym_SEMI,
    STATE(3449), 2,
      sym_line_comment,
      sym_block_comment,
  [94502] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6935), 1,
      anon_sym_RBRACK,
    STATE(3450), 2,
      sym_line_comment,
      sym_block_comment,
  [94516] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6631), 1,
      anon_sym_SEMI,
    STATE(3451), 2,
      sym_line_comment,
      sym_block_comment,
  [94530] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6937), 1,
      anon_sym_RPAREN,
    STATE(3452), 2,
      sym_line_comment,
      sym_block_comment,
  [94544] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6939), 1,
      sym_identifier,
    STATE(3453), 2,
      sym_line_comment,
      sym_block_comment,
  [94558] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6941), 1,
      anon_sym_RBRACE,
    STATE(3454), 2,
      sym_line_comment,
      sym_block_comment,
  [94572] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5670), 1,
      anon_sym_RPAREN,
    STATE(3455), 2,
      sym_line_comment,
      sym_block_comment,
  [94586] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6943), 1,
      anon_sym_COLON,
    STATE(3456), 2,
      sym_line_comment,
      sym_block_comment,
  [94600] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6945), 1,
      anon_sym_COLON,
    STATE(3457), 2,
      sym_line_comment,
      sym_block_comment,
  [94614] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6307), 1,
      anon_sym_RBRACE,
    STATE(3458), 2,
      sym_line_comment,
      sym_block_comment,
  [94628] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6947), 1,
      anon_sym_LBRACK,
    STATE(3459), 2,
      sym_line_comment,
      sym_block_comment,
  [94642] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6627), 1,
      anon_sym_SEMI,
    STATE(3460), 2,
      sym_line_comment,
      sym_block_comment,
  [94656] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6949), 1,
      anon_sym_COLON_COLON,
    STATE(3461), 2,
      sym_line_comment,
      sym_block_comment,
  [94670] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6951), 1,
      anon_sym_SEMI,
    STATE(3462), 2,
      sym_line_comment,
      sym_block_comment,
  [94684] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    STATE(3463), 2,
      sym_line_comment,
      sym_block_comment,
  [94698] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6154), 1,
      anon_sym_GT,
    STATE(3464), 2,
      sym_line_comment,
      sym_block_comment,
  [94712] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6953), 1,
      anon_sym_COLON,
    STATE(3465), 2,
      sym_line_comment,
      sym_block_comment,
  [94726] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6955), 1,
      anon_sym_RBRACE,
    STATE(3466), 2,
      sym_line_comment,
      sym_block_comment,
  [94740] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6957), 1,
      sym_raw_string_literal_content,
    STATE(3467), 2,
      sym_line_comment,
      sym_block_comment,
  [94754] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6959), 1,
      anon_sym_fn,
    STATE(3468), 2,
      sym_line_comment,
      sym_block_comment,
  [94768] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(953), 1,
      anon_sym_RBRACK,
    STATE(3469), 2,
      sym_line_comment,
      sym_block_comment,
  [94782] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6961), 1,
      anon_sym_LT,
    STATE(3470), 2,
      sym_line_comment,
      sym_block_comment,
  [94796] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4081), 1,
      anon_sym_COLON_COLON,
    STATE(3471), 2,
      sym_line_comment,
      sym_block_comment,
  [94810] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 1,
      anon_sym_COLON_COLON,
    STATE(3472), 2,
      sym_line_comment,
      sym_block_comment,
  [94824] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5457), 1,
      anon_sym_RPAREN,
    STATE(3473), 2,
      sym_line_comment,
      sym_block_comment,
  [94838] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6963), 1,
      sym_identifier,
    STATE(3474), 2,
      sym_line_comment,
      sym_block_comment,
  [94852] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6965), 1,
      anon_sym_RBRACE,
    STATE(3475), 2,
      sym_line_comment,
      sym_block_comment,
  [94866] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6967), 1,
      anon_sym_COLON_COLON,
    STATE(3476), 2,
      sym_line_comment,
      sym_block_comment,
  [94880] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6969), 1,
      anon_sym_SEMI,
    STATE(3477), 2,
      sym_line_comment,
      sym_block_comment,
  [94894] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6971), 1,
      anon_sym_SEMI,
    STATE(3478), 2,
      sym_line_comment,
      sym_block_comment,
  [94908] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6973), 1,
      sym__raw_string_literal_end,
    STATE(3479), 2,
      sym_line_comment,
      sym_block_comment,
  [94922] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6975), 1,
      anon_sym_fn,
    STATE(3480), 2,
      sym_line_comment,
      sym_block_comment,
  [94936] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6977), 1,
      anon_sym_RBRACK,
    STATE(3481), 2,
      sym_line_comment,
      sym_block_comment,
  [94950] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6979), 1,
      anon_sym_COLON_COLON,
    STATE(3482), 2,
      sym_line_comment,
      sym_block_comment,
  [94964] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6981), 1,
      anon_sym_SEMI,
    STATE(3483), 2,
      sym_line_comment,
      sym_block_comment,
  [94978] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_COLON_COLON,
    STATE(3484), 2,
      sym_line_comment,
      sym_block_comment,
  [94992] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6983), 1,
      anon_sym_COLON_COLON,
    STATE(3485), 2,
      sym_line_comment,
      sym_block_comment,
  [95006] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6985), 1,
      anon_sym_SEMI,
    STATE(3486), 2,
      sym_line_comment,
      sym_block_comment,
  [95020] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    STATE(3487), 2,
      sym_line_comment,
      sym_block_comment,
  [95034] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4866), 1,
      anon_sym_COLON_COLON,
    STATE(3488), 2,
      sym_line_comment,
      sym_block_comment,
  [95048] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5471), 1,
      anon_sym_RPAREN,
    STATE(3489), 2,
      sym_line_comment,
      sym_block_comment,
  [95062] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6987), 1,
      anon_sym_COLON_COLON,
    STATE(3490), 2,
      sym_line_comment,
      sym_block_comment,
  [95076] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6989), 1,
      anon_sym_fn,
    STATE(3491), 2,
      sym_line_comment,
      sym_block_comment,
  [95090] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6991), 1,
      sym_raw_string_literal_content,
    STATE(3492), 2,
      sym_line_comment,
      sym_block_comment,
  [95104] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6993), 1,
      anon_sym_LBRACE,
    STATE(3493), 2,
      sym_line_comment,
      sym_block_comment,
  [95118] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6995), 1,
      anon_sym_COLON,
    STATE(3494), 2,
      sym_line_comment,
      sym_block_comment,
  [95132] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6997), 1,
      sym_identifier,
    STATE(3495), 2,
      sym_line_comment,
      sym_block_comment,
  [95146] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6999), 1,
      anon_sym_SEMI,
    STATE(3496), 2,
      sym_line_comment,
      sym_block_comment,
  [95160] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7001), 1,
      anon_sym_RBRACK,
    STATE(3497), 2,
      sym_line_comment,
      sym_block_comment,
  [95174] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6619), 1,
      anon_sym_SEMI,
    STATE(3498), 2,
      sym_line_comment,
      sym_block_comment,
  [95188] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(873), 1,
      anon_sym_RBRACK,
    STATE(3499), 2,
      sym_line_comment,
      sym_block_comment,
  [95202] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7003), 1,
      anon_sym_LPAREN,
    STATE(3500), 2,
      sym_line_comment,
      sym_block_comment,
  [95216] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7005), 1,
      anon_sym_SEMI,
    STATE(3501), 2,
      sym_line_comment,
      sym_block_comment,
  [95230] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7007), 1,
      sym_raw_string_literal_content,
    STATE(3502), 2,
      sym_line_comment,
      sym_block_comment,
  [95244] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7009), 1,
      anon_sym_LPAREN,
    STATE(3503), 2,
      sym_line_comment,
      sym_block_comment,
  [95258] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6517), 1,
      anon_sym_LBRACK,
    STATE(3504), 2,
      sym_line_comment,
      sym_block_comment,
  [95272] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7011), 1,
      anon_sym_RBRACK,
    STATE(3505), 2,
      sym_line_comment,
      sym_block_comment,
  [95286] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7013), 1,
      anon_sym_COLON_COLON,
    STATE(3506), 2,
      sym_line_comment,
      sym_block_comment,
  [95300] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6351), 1,
      anon_sym_RBRACE,
    STATE(3507), 2,
      sym_line_comment,
      sym_block_comment,
  [95314] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3984), 1,
      sym_identifier,
    STATE(3508), 2,
      sym_line_comment,
      sym_block_comment,
  [95328] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7015), 1,
      anon_sym_COLON_COLON,
    STATE(3509), 2,
      sym_line_comment,
      sym_block_comment,
  [95342] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7017), 1,
      anon_sym_SEMI,
    STATE(3510), 2,
      sym_line_comment,
      sym_block_comment,
  [95356] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7019), 1,
      sym__raw_string_literal_end,
    STATE(3511), 2,
      sym_line_comment,
      sym_block_comment,
  [95370] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7021), 1,
      anon_sym_COLON_COLON,
    STATE(3512), 2,
      sym_line_comment,
      sym_block_comment,
  [95384] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7023), 1,
      anon_sym_RBRACK,
    STATE(3513), 2,
      sym_line_comment,
      sym_block_comment,
  [95398] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7025), 1,
      sym_identifier,
    STATE(3514), 2,
      sym_line_comment,
      sym_block_comment,
  [95412] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7027), 1,
      anon_sym_COLON_COLON,
    STATE(3515), 2,
      sym_line_comment,
      sym_block_comment,
  [95426] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7029), 1,
      anon_sym_LBRACE,
    STATE(3516), 2,
      sym_line_comment,
      sym_block_comment,
  [95440] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7031), 1,
      sym_identifier,
    STATE(3517), 2,
      sym_line_comment,
      sym_block_comment,
  [95454] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7033), 1,
      anon_sym_STAR_SLASH,
    STATE(3518), 2,
      sym_line_comment,
      sym_block_comment,
  [95468] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7035), 1,
      sym_identifier,
    STATE(3519), 2,
      sym_line_comment,
      sym_block_comment,
  [95482] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(959), 1,
      anon_sym_EQ_GT,
    STATE(3520), 2,
      sym_line_comment,
      sym_block_comment,
  [95496] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7037), 1,
      sym_raw_string_literal_content,
    STATE(3521), 2,
      sym_line_comment,
      sym_block_comment,
  [95510] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3428), 1,
      anon_sym_COLON_COLON,
    STATE(3522), 2,
      sym_line_comment,
      sym_block_comment,
  [95524] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7039), 1,
      sym_identifier,
    STATE(3523), 2,
      sym_line_comment,
      sym_block_comment,
  [95538] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7041), 1,
      anon_sym_COLON_COLON,
    STATE(3524), 2,
      sym_line_comment,
      sym_block_comment,
  [95552] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7043), 1,
      sym__line_doc_content,
    STATE(3525), 2,
      sym_line_comment,
      sym_block_comment,
  [95566] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7045), 1,
      anon_sym_LBRACE,
    STATE(3526), 2,
      sym_line_comment,
      sym_block_comment,
  [95580] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7047), 1,
      sym_raw_string_literal_content,
    STATE(3527), 2,
      sym_line_comment,
      sym_block_comment,
  [95594] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5165), 1,
      anon_sym_COLON_COLON,
    STATE(3528), 2,
      sym_line_comment,
      sym_block_comment,
  [95608] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7049), 1,
      anon_sym_COLON_COLON,
    STATE(3529), 2,
      sym_line_comment,
      sym_block_comment,
  [95622] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5724), 1,
      anon_sym_LBRACE,
    STATE(3530), 2,
      sym_line_comment,
      sym_block_comment,
  [95636] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5746), 1,
      anon_sym_COLON_COLON,
    STATE(3531), 2,
      sym_line_comment,
      sym_block_comment,
  [95650] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7051), 1,
      anon_sym_COLON_COLON,
    STATE(3532), 2,
      sym_line_comment,
      sym_block_comment,
  [95664] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5695), 1,
      anon_sym_LBRACE,
    STATE(3533), 2,
      sym_line_comment,
      sym_block_comment,
  [95678] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7053), 1,
      anon_sym_COLON_COLON,
    STATE(3534), 2,
      sym_line_comment,
      sym_block_comment,
  [95692] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5197), 1,
      anon_sym_COLON_COLON,
    STATE(3535), 2,
      sym_line_comment,
      sym_block_comment,
  [95706] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5217), 1,
      anon_sym_COLON_COLON,
    STATE(3536), 2,
      sym_line_comment,
      sym_block_comment,
  [95720] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4091), 1,
      anon_sym_COLON_COLON,
    STATE(3537), 2,
      sym_line_comment,
      sym_block_comment,
  [95734] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7055), 1,
      anon_sym_COLON_COLON,
    STATE(3538), 2,
      sym_line_comment,
      sym_block_comment,
  [95748] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7057), 1,
      anon_sym_SEMI,
    STATE(3539), 2,
      sym_line_comment,
      sym_block_comment,
  [95762] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7059), 1,
      anon_sym_SEMI,
    STATE(3540), 2,
      sym_line_comment,
      sym_block_comment,
  [95776] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7061), 1,
      anon_sym_EQ,
    STATE(3541), 2,
      sym_line_comment,
      sym_block_comment,
  [95790] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7063), 1,
      sym__line_doc_content,
    STATE(3542), 2,
      sym_line_comment,
      sym_block_comment,
  [95804] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7065), 1,
      anon_sym_COLON,
    STATE(3543), 2,
      sym_line_comment,
      sym_block_comment,
  [95818] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7067), 1,
      anon_sym_LBRACK,
    STATE(3544), 2,
      sym_line_comment,
      sym_block_comment,
  [95832] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7069), 1,
      sym__line_doc_content,
    STATE(3545), 2,
      sym_line_comment,
      sym_block_comment,
  [95846] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7071), 1,
      anon_sym_LBRACK,
    STATE(3546), 2,
      sym_line_comment,
      sym_block_comment,
  [95860] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7073), 1,
      anon_sym_COLON,
    STATE(3547), 2,
      sym_line_comment,
      sym_block_comment,
  [95874] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7075), 1,
      anon_sym_COLON,
    STATE(3548), 2,
      sym_line_comment,
      sym_block_comment,
  [95888] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7077), 1,
      sym_identifier,
    STATE(3549), 2,
      sym_line_comment,
      sym_block_comment,
  [95902] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7079), 1,
      sym__line_doc_content,
    STATE(3550), 2,
      sym_line_comment,
      sym_block_comment,
  [95916] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7081), 1,
      sym__line_doc_content,
    STATE(3551), 2,
      sym_line_comment,
      sym_block_comment,
  [95930] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7083), 1,
      anon_sym_SEMI,
    STATE(3552), 2,
      sym_line_comment,
      sym_block_comment,
  [95944] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7085), 1,
      anon_sym_COLON,
    STATE(3553), 2,
      sym_line_comment,
      sym_block_comment,
  [95958] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7087), 1,
      anon_sym_COLON,
    STATE(3554), 2,
      sym_line_comment,
      sym_block_comment,
  [95972] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7089), 1,
      aux_sym_line_comment_token2,
    STATE(3555), 2,
      sym_line_comment,
      sym_block_comment,
  [95986] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7091), 1,
      anon_sym_COLON,
    STATE(3556), 2,
      sym_line_comment,
      sym_block_comment,
  [96000] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7093), 1,
      anon_sym_SEMI,
    STATE(3557), 2,
      sym_line_comment,
      sym_block_comment,
  [96014] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7095), 1,
      anon_sym_RPAREN,
    STATE(3558), 2,
      sym_line_comment,
      sym_block_comment,
  [96028] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7097), 1,
      anon_sym_SEMI,
    STATE(3559), 2,
      sym_line_comment,
      sym_block_comment,
  [96042] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7099), 1,
      sym_identifier,
    STATE(3560), 2,
      sym_line_comment,
      sym_block_comment,
  [96056] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7101), 1,
      anon_sym_EQ_GT,
    STATE(3561), 2,
      sym_line_comment,
      sym_block_comment,
  [96070] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6491), 1,
      anon_sym_COLON_COLON,
    STATE(3562), 2,
      sym_line_comment,
      sym_block_comment,
  [96084] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7103), 1,
      anon_sym_COLON,
    STATE(3563), 2,
      sym_line_comment,
      sym_block_comment,
  [96098] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4487), 1,
      anon_sym_fn,
    STATE(3564), 2,
      sym_line_comment,
      sym_block_comment,
  [96112] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7105), 1,
      ts_builtin_sym_end,
    STATE(3565), 2,
      sym_line_comment,
      sym_block_comment,
  [96126] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3885), 1,
      anon_sym_COLON_COLON,
    STATE(3566), 2,
      sym_line_comment,
      sym_block_comment,
  [96140] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7107), 1,
      anon_sym_COLON,
    STATE(3567), 2,
      sym_line_comment,
      sym_block_comment,
  [96154] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7109), 1,
      anon_sym_SEMI,
    STATE(3568), 2,
      sym_line_comment,
      sym_block_comment,
  [96168] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7111), 1,
      anon_sym_SEMI,
    STATE(3569), 2,
      sym_line_comment,
      sym_block_comment,
  [96182] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7113), 1,
      anon_sym_SEMI,
    STATE(3570), 2,
      sym_line_comment,
      sym_block_comment,
  [96196] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7115), 1,
      anon_sym_COLON,
    STATE(3571), 2,
      sym_line_comment,
      sym_block_comment,
  [96210] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3057), 1,
      anon_sym_PLUS,
    STATE(3572), 2,
      sym_line_comment,
      sym_block_comment,
  [96224] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7117), 1,
      anon_sym_COLON,
    STATE(3573), 2,
      sym_line_comment,
      sym_block_comment,
  [96238] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7119), 1,
      anon_sym_SEMI,
    STATE(3574), 2,
      sym_line_comment,
      sym_block_comment,
  [96252] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7121), 1,
      anon_sym_SEMI,
    STATE(3575), 2,
      sym_line_comment,
      sym_block_comment,
  [96266] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7123), 1,
      anon_sym_SEMI,
    STATE(3576), 2,
      sym_line_comment,
      sym_block_comment,
  [96280] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7125), 1,
      sym_identifier,
    STATE(3577), 2,
      sym_line_comment,
      sym_block_comment,
  [96294] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7127), 1,
      anon_sym_SEMI,
    STATE(3578), 2,
      sym_line_comment,
      sym_block_comment,
  [96308] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7129), 1,
      anon_sym_SEMI,
    STATE(3579), 2,
      sym_line_comment,
      sym_block_comment,
  [96322] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7131), 1,
      anon_sym_EQ,
    STATE(3580), 2,
      sym_line_comment,
      sym_block_comment,
  [96336] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7133), 1,
      sym_identifier,
    STATE(3581), 2,
      sym_line_comment,
      sym_block_comment,
  [96350] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7135), 1,
      sym__raw_string_literal_end,
    STATE(3582), 2,
      sym_line_comment,
      sym_block_comment,
  [96364] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7137), 1,
      anon_sym_SEMI,
    STATE(3583), 2,
      sym_line_comment,
      sym_block_comment,
  [96378] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7139), 1,
      anon_sym_RPAREN,
    STATE(3584), 2,
      sym_line_comment,
      sym_block_comment,
  [96392] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7141), 1,
      anon_sym_COLON,
    STATE(3585), 2,
      sym_line_comment,
      sym_block_comment,
  [96406] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7143), 1,
      anon_sym_SEMI,
    STATE(3586), 2,
      sym_line_comment,
      sym_block_comment,
  [96420] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7145), 1,
      anon_sym_COLON,
    STATE(3587), 2,
      sym_line_comment,
      sym_block_comment,
  [96434] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7147), 1,
      anon_sym_LBRACK,
    STATE(3588), 2,
      sym_line_comment,
      sym_block_comment,
  [96448] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7149), 1,
      anon_sym_LBRACK,
    STATE(3589), 2,
      sym_line_comment,
      sym_block_comment,
  [96462] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7151), 1,
      anon_sym_COLON,
    STATE(3590), 2,
      sym_line_comment,
      sym_block_comment,
  [96476] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7153), 1,
      sym_identifier,
    STATE(3591), 2,
      sym_line_comment,
      sym_block_comment,
  [96490] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6433), 1,
      anon_sym_RBRACE,
    STATE(3592), 2,
      sym_line_comment,
      sym_block_comment,
  [96504] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7155), 1,
      anon_sym_COLON,
    STATE(3593), 2,
      sym_line_comment,
      sym_block_comment,
  [96518] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7157), 1,
      anon_sym_COLON,
    STATE(3594), 2,
      sym_line_comment,
      sym_block_comment,
  [96532] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7159), 1,
      anon_sym_COLON,
    STATE(3595), 2,
      sym_line_comment,
      sym_block_comment,
  [96546] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7161), 1,
      anon_sym_SEMI,
    STATE(3596), 2,
      sym_line_comment,
      sym_block_comment,
  [96560] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7163), 1,
      anon_sym_COLON,
    STATE(3597), 2,
      sym_line_comment,
      sym_block_comment,
  [96574] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7165), 1,
      anon_sym_COLON,
    STATE(3598), 2,
      sym_line_comment,
      sym_block_comment,
  [96588] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7167), 1,
      anon_sym_COLON,
    STATE(3599), 2,
      sym_line_comment,
      sym_block_comment,
  [96602] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7169), 1,
      sym_identifier,
    STATE(3600), 2,
      sym_line_comment,
      sym_block_comment,
  [96616] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4511), 1,
      anon_sym_fn,
    STATE(3601), 2,
      sym_line_comment,
      sym_block_comment,
  [96630] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7171), 1,
      sym_identifier,
    STATE(3602), 2,
      sym_line_comment,
      sym_block_comment,
  [96644] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7173), 1,
      anon_sym_SEMI,
    STATE(3603), 2,
      sym_line_comment,
      sym_block_comment,
  [96658] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7175), 1,
      sym_identifier,
    STATE(3604), 2,
      sym_line_comment,
      sym_block_comment,
  [96672] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7177), 1,
      sym_identifier,
    STATE(3605), 2,
      sym_line_comment,
      sym_block_comment,
  [96686] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7179), 1,
      anon_sym_RBRACE,
    STATE(3606), 2,
      sym_line_comment,
      sym_block_comment,
  [96700] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7181), 1,
      sym_identifier,
    STATE(3607), 2,
      sym_line_comment,
      sym_block_comment,
  [96714] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7183), 1,
      anon_sym_fn,
    STATE(3608), 2,
      sym_line_comment,
      sym_block_comment,
  [96728] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7185), 1,
      sym_identifier,
    STATE(3609), 2,
      sym_line_comment,
      sym_block_comment,
  [96742] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7187), 1,
      sym_identifier,
    STATE(3610), 2,
      sym_line_comment,
      sym_block_comment,
  [96756] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7189), 1,
      anon_sym_EQ_GT,
    STATE(3611), 2,
      sym_line_comment,
      sym_block_comment,
  [96770] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7191), 1,
      anon_sym_SEMI,
    STATE(3612), 2,
      sym_line_comment,
      sym_block_comment,
  [96784] = 1,
    ACTIONS(7193), 1,
      ts_builtin_sym_end,
  [96788] = 1,
    ACTIONS(7195), 1,
      ts_builtin_sym_end,
  [96792] = 1,
    ACTIONS(7197), 1,
      ts_builtin_sym_end,
  [96796] = 1,
    ACTIONS(7199), 1,
      ts_builtin_sym_end,
  [96800] = 1,
    ACTIONS(7201), 1,
      ts_builtin_sym_end,
  [96804] = 1,
    ACTIONS(7203), 1,
      ts_builtin_sym_end,
  [96808] = 1,
    ACTIONS(7205), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1004)] = 0,
  [SMALL_STATE(1005)] = 75,
  [SMALL_STATE(1006)] = 150,
  [SMALL_STATE(1007)] = 224,
  [SMALL_STATE(1008)] = 294,
  [SMALL_STATE(1009)] = 363,
  [SMALL_STATE(1010)] = 462,
  [SMALL_STATE(1011)] = 561,
  [SMALL_STATE(1012)] = 638,
  [SMALL_STATE(1013)] = 712,
  [SMALL_STATE(1014)] = 786,
  [SMALL_STATE(1015)] = 860,
  [SMALL_STATE(1016)] = 931,
  [SMALL_STATE(1017)] = 994,
  [SMALL_STATE(1018)] = 1061,
  [SMALL_STATE(1019)] = 1124,
  [SMALL_STATE(1020)] = 1195,
  [SMALL_STATE(1021)] = 1258,
  [SMALL_STATE(1022)] = 1321,
  [SMALL_STATE(1023)] = 1384,
  [SMALL_STATE(1024)] = 1451,
  [SMALL_STATE(1025)] = 1522,
  [SMALL_STATE(1026)] = 1585,
  [SMALL_STATE(1027)] = 1652,
  [SMALL_STATE(1028)] = 1715,
  [SMALL_STATE(1029)] = 1782,
  [SMALL_STATE(1030)] = 1845,
  [SMALL_STATE(1031)] = 1908,
  [SMALL_STATE(1032)] = 1979,
  [SMALL_STATE(1033)] = 2045,
  [SMALL_STATE(1034)] = 2107,
  [SMALL_STATE(1035)] = 2177,
  [SMALL_STATE(1036)] = 2239,
  [SMALL_STATE(1037)] = 2301,
  [SMALL_STATE(1038)] = 2369,
  [SMALL_STATE(1039)] = 2431,
  [SMALL_STATE(1040)] = 2493,
  [SMALL_STATE(1041)] = 2555,
  [SMALL_STATE(1042)] = 2617,
  [SMALL_STATE(1043)] = 2679,
  [SMALL_STATE(1044)] = 2741,
  [SMALL_STATE(1045)] = 2802,
  [SMALL_STATE(1046)] = 2863,
  [SMALL_STATE(1047)] = 2962,
  [SMALL_STATE(1048)] = 3025,
  [SMALL_STATE(1049)] = 3090,
  [SMALL_STATE(1050)] = 3153,
  [SMALL_STATE(1051)] = 3216,
  [SMALL_STATE(1052)] = 3279,
  [SMALL_STATE(1053)] = 3342,
  [SMALL_STATE(1054)] = 3405,
  [SMALL_STATE(1055)] = 3510,
  [SMALL_STATE(1056)] = 3573,
  [SMALL_STATE(1057)] = 3634,
  [SMALL_STATE(1058)] = 3697,
  [SMALL_STATE(1059)] = 3758,
  [SMALL_STATE(1060)] = 3821,
  [SMALL_STATE(1061)] = 3886,
  [SMALL_STATE(1062)] = 3947,
  [SMALL_STATE(1063)] = 4010,
  [SMALL_STATE(1064)] = 4071,
  [SMALL_STATE(1065)] = 4132,
  [SMALL_STATE(1066)] = 4195,
  [SMALL_STATE(1067)] = 4258,
  [SMALL_STATE(1068)] = 4323,
  [SMALL_STATE(1069)] = 4384,
  [SMALL_STATE(1070)] = 4445,
  [SMALL_STATE(1071)] = 4506,
  [SMALL_STATE(1072)] = 4569,
  [SMALL_STATE(1073)] = 4630,
  [SMALL_STATE(1074)] = 4691,
  [SMALL_STATE(1075)] = 4796,
  [SMALL_STATE(1076)] = 4857,
  [SMALL_STATE(1077)] = 4918,
  [SMALL_STATE(1078)] = 5023,
  [SMALL_STATE(1079)] = 5088,
  [SMALL_STATE(1080)] = 5149,
  [SMALL_STATE(1081)] = 5212,
  [SMALL_STATE(1082)] = 5275,
  [SMALL_STATE(1083)] = 5338,
  [SMALL_STATE(1084)] = 5443,
  [SMALL_STATE(1085)] = 5504,
  [SMALL_STATE(1086)] = 5565,
  [SMALL_STATE(1087)] = 5670,
  [SMALL_STATE(1088)] = 5733,
  [SMALL_STATE(1089)] = 5838,
  [SMALL_STATE(1090)] = 5937,
  [SMALL_STATE(1091)] = 6000,
  [SMALL_STATE(1092)] = 6060,
  [SMALL_STATE(1093)] = 6120,
  [SMALL_STATE(1094)] = 6180,
  [SMALL_STATE(1095)] = 6240,
  [SMALL_STATE(1096)] = 6300,
  [SMALL_STATE(1097)] = 6360,
  [SMALL_STATE(1098)] = 6420,
  [SMALL_STATE(1099)] = 6480,
  [SMALL_STATE(1100)] = 6540,
  [SMALL_STATE(1101)] = 6600,
  [SMALL_STATE(1102)] = 6660,
  [SMALL_STATE(1103)] = 6720,
  [SMALL_STATE(1104)] = 6780,
  [SMALL_STATE(1105)] = 6840,
  [SMALL_STATE(1106)] = 6900,
  [SMALL_STATE(1107)] = 6960,
  [SMALL_STATE(1108)] = 7020,
  [SMALL_STATE(1109)] = 7080,
  [SMALL_STATE(1110)] = 7140,
  [SMALL_STATE(1111)] = 7200,
  [SMALL_STATE(1112)] = 7260,
  [SMALL_STATE(1113)] = 7320,
  [SMALL_STATE(1114)] = 7380,
  [SMALL_STATE(1115)] = 7440,
  [SMALL_STATE(1116)] = 7500,
  [SMALL_STATE(1117)] = 7560,
  [SMALL_STATE(1118)] = 7620,
  [SMALL_STATE(1119)] = 7680,
  [SMALL_STATE(1120)] = 7740,
  [SMALL_STATE(1121)] = 7800,
  [SMALL_STATE(1122)] = 7860,
  [SMALL_STATE(1123)] = 7920,
  [SMALL_STATE(1124)] = 7980,
  [SMALL_STATE(1125)] = 8040,
  [SMALL_STATE(1126)] = 8106,
  [SMALL_STATE(1127)] = 8166,
  [SMALL_STATE(1128)] = 8226,
  [SMALL_STATE(1129)] = 8286,
  [SMALL_STATE(1130)] = 8346,
  [SMALL_STATE(1131)] = 8406,
  [SMALL_STATE(1132)] = 8466,
  [SMALL_STATE(1133)] = 8526,
  [SMALL_STATE(1134)] = 8586,
  [SMALL_STATE(1135)] = 8646,
  [SMALL_STATE(1136)] = 8706,
  [SMALL_STATE(1137)] = 8766,
  [SMALL_STATE(1138)] = 8826,
  [SMALL_STATE(1139)] = 8886,
  [SMALL_STATE(1140)] = 8946,
  [SMALL_STATE(1141)] = 9006,
  [SMALL_STATE(1142)] = 9066,
  [SMALL_STATE(1143)] = 9126,
  [SMALL_STATE(1144)] = 9186,
  [SMALL_STATE(1145)] = 9246,
  [SMALL_STATE(1146)] = 9306,
  [SMALL_STATE(1147)] = 9366,
  [SMALL_STATE(1148)] = 9426,
  [SMALL_STATE(1149)] = 9486,
  [SMALL_STATE(1150)] = 9546,
  [SMALL_STATE(1151)] = 9606,
  [SMALL_STATE(1152)] = 9666,
  [SMALL_STATE(1153)] = 9726,
  [SMALL_STATE(1154)] = 9786,
  [SMALL_STATE(1155)] = 9846,
  [SMALL_STATE(1156)] = 9906,
  [SMALL_STATE(1157)] = 9966,
  [SMALL_STATE(1158)] = 10026,
  [SMALL_STATE(1159)] = 10086,
  [SMALL_STATE(1160)] = 10146,
  [SMALL_STATE(1161)] = 10206,
  [SMALL_STATE(1162)] = 10266,
  [SMALL_STATE(1163)] = 10326,
  [SMALL_STATE(1164)] = 10386,
  [SMALL_STATE(1165)] = 10446,
  [SMALL_STATE(1166)] = 10506,
  [SMALL_STATE(1167)] = 10566,
  [SMALL_STATE(1168)] = 10626,
  [SMALL_STATE(1169)] = 10686,
  [SMALL_STATE(1170)] = 10746,
  [SMALL_STATE(1171)] = 10806,
  [SMALL_STATE(1172)] = 10866,
  [SMALL_STATE(1173)] = 10926,
  [SMALL_STATE(1174)] = 10986,
  [SMALL_STATE(1175)] = 11046,
  [SMALL_STATE(1176)] = 11106,
  [SMALL_STATE(1177)] = 11166,
  [SMALL_STATE(1178)] = 11226,
  [SMALL_STATE(1179)] = 11286,
  [SMALL_STATE(1180)] = 11346,
  [SMALL_STATE(1181)] = 11406,
  [SMALL_STATE(1182)] = 11466,
  [SMALL_STATE(1183)] = 11526,
  [SMALL_STATE(1184)] = 11586,
  [SMALL_STATE(1185)] = 11646,
  [SMALL_STATE(1186)] = 11706,
  [SMALL_STATE(1187)] = 11766,
  [SMALL_STATE(1188)] = 11826,
  [SMALL_STATE(1189)] = 11886,
  [SMALL_STATE(1190)] = 11946,
  [SMALL_STATE(1191)] = 12006,
  [SMALL_STATE(1192)] = 12066,
  [SMALL_STATE(1193)] = 12126,
  [SMALL_STATE(1194)] = 12186,
  [SMALL_STATE(1195)] = 12246,
  [SMALL_STATE(1196)] = 12306,
  [SMALL_STATE(1197)] = 12366,
  [SMALL_STATE(1198)] = 12426,
  [SMALL_STATE(1199)] = 12486,
  [SMALL_STATE(1200)] = 12546,
  [SMALL_STATE(1201)] = 12606,
  [SMALL_STATE(1202)] = 12666,
  [SMALL_STATE(1203)] = 12726,
  [SMALL_STATE(1204)] = 12786,
  [SMALL_STATE(1205)] = 12846,
  [SMALL_STATE(1206)] = 12906,
  [SMALL_STATE(1207)] = 12966,
  [SMALL_STATE(1208)] = 13026,
  [SMALL_STATE(1209)] = 13086,
  [SMALL_STATE(1210)] = 13146,
  [SMALL_STATE(1211)] = 13206,
  [SMALL_STATE(1212)] = 13266,
  [SMALL_STATE(1213)] = 13326,
  [SMALL_STATE(1214)] = 13386,
  [SMALL_STATE(1215)] = 13446,
  [SMALL_STATE(1216)] = 13506,
  [SMALL_STATE(1217)] = 13566,
  [SMALL_STATE(1218)] = 13626,
  [SMALL_STATE(1219)] = 13686,
  [SMALL_STATE(1220)] = 13746,
  [SMALL_STATE(1221)] = 13806,
  [SMALL_STATE(1222)] = 13866,
  [SMALL_STATE(1223)] = 13926,
  [SMALL_STATE(1224)] = 13986,
  [SMALL_STATE(1225)] = 14046,
  [SMALL_STATE(1226)] = 14106,
  [SMALL_STATE(1227)] = 14166,
  [SMALL_STATE(1228)] = 14226,
  [SMALL_STATE(1229)] = 14286,
  [SMALL_STATE(1230)] = 14346,
  [SMALL_STATE(1231)] = 14406,
  [SMALL_STATE(1232)] = 14466,
  [SMALL_STATE(1233)] = 14526,
  [SMALL_STATE(1234)] = 14586,
  [SMALL_STATE(1235)] = 14646,
  [SMALL_STATE(1236)] = 14706,
  [SMALL_STATE(1237)] = 14766,
  [SMALL_STATE(1238)] = 14826,
  [SMALL_STATE(1239)] = 14886,
  [SMALL_STATE(1240)] = 14946,
  [SMALL_STATE(1241)] = 15006,
  [SMALL_STATE(1242)] = 15066,
  [SMALL_STATE(1243)] = 15126,
  [SMALL_STATE(1244)] = 15186,
  [SMALL_STATE(1245)] = 15246,
  [SMALL_STATE(1246)] = 15306,
  [SMALL_STATE(1247)] = 15366,
  [SMALL_STATE(1248)] = 15426,
  [SMALL_STATE(1249)] = 15486,
  [SMALL_STATE(1250)] = 15546,
  [SMALL_STATE(1251)] = 15606,
  [SMALL_STATE(1252)] = 15666,
  [SMALL_STATE(1253)] = 15726,
  [SMALL_STATE(1254)] = 15786,
  [SMALL_STATE(1255)] = 15846,
  [SMALL_STATE(1256)] = 15906,
  [SMALL_STATE(1257)] = 15966,
  [SMALL_STATE(1258)] = 16026,
  [SMALL_STATE(1259)] = 16086,
  [SMALL_STATE(1260)] = 16146,
  [SMALL_STATE(1261)] = 16206,
  [SMALL_STATE(1262)] = 16266,
  [SMALL_STATE(1263)] = 16326,
  [SMALL_STATE(1264)] = 16386,
  [SMALL_STATE(1265)] = 16446,
  [SMALL_STATE(1266)] = 16506,
  [SMALL_STATE(1267)] = 16566,
  [SMALL_STATE(1268)] = 16628,
  [SMALL_STATE(1269)] = 16692,
  [SMALL_STATE(1270)] = 16752,
  [SMALL_STATE(1271)] = 16812,
  [SMALL_STATE(1272)] = 16872,
  [SMALL_STATE(1273)] = 16932,
  [SMALL_STATE(1274)] = 16992,
  [SMALL_STATE(1275)] = 17052,
  [SMALL_STATE(1276)] = 17112,
  [SMALL_STATE(1277)] = 17172,
  [SMALL_STATE(1278)] = 17232,
  [SMALL_STATE(1279)] = 17292,
  [SMALL_STATE(1280)] = 17352,
  [SMALL_STATE(1281)] = 17412,
  [SMALL_STATE(1282)] = 17472,
  [SMALL_STATE(1283)] = 17532,
  [SMALL_STATE(1284)] = 17592,
  [SMALL_STATE(1285)] = 17652,
  [SMALL_STATE(1286)] = 17712,
  [SMALL_STATE(1287)] = 17772,
  [SMALL_STATE(1288)] = 17832,
  [SMALL_STATE(1289)] = 17892,
  [SMALL_STATE(1290)] = 17952,
  [SMALL_STATE(1291)] = 18012,
  [SMALL_STATE(1292)] = 18072,
  [SMALL_STATE(1293)] = 18132,
  [SMALL_STATE(1294)] = 18192,
  [SMALL_STATE(1295)] = 18252,
  [SMALL_STATE(1296)] = 18312,
  [SMALL_STATE(1297)] = 18372,
  [SMALL_STATE(1298)] = 18432,
  [SMALL_STATE(1299)] = 18492,
  [SMALL_STATE(1300)] = 18552,
  [SMALL_STATE(1301)] = 18612,
  [SMALL_STATE(1302)] = 18672,
  [SMALL_STATE(1303)] = 18732,
  [SMALL_STATE(1304)] = 18792,
  [SMALL_STATE(1305)] = 18852,
  [SMALL_STATE(1306)] = 18912,
  [SMALL_STATE(1307)] = 18972,
  [SMALL_STATE(1308)] = 19032,
  [SMALL_STATE(1309)] = 19092,
  [SMALL_STATE(1310)] = 19152,
  [SMALL_STATE(1311)] = 19212,
  [SMALL_STATE(1312)] = 19272,
  [SMALL_STATE(1313)] = 19332,
  [SMALL_STATE(1314)] = 19392,
  [SMALL_STATE(1315)] = 19452,
  [SMALL_STATE(1316)] = 19512,
  [SMALL_STATE(1317)] = 19572,
  [SMALL_STATE(1318)] = 19632,
  [SMALL_STATE(1319)] = 19692,
  [SMALL_STATE(1320)] = 19752,
  [SMALL_STATE(1321)] = 19812,
  [SMALL_STATE(1322)] = 19872,
  [SMALL_STATE(1323)] = 19932,
  [SMALL_STATE(1324)] = 19992,
  [SMALL_STATE(1325)] = 20052,
  [SMALL_STATE(1326)] = 20112,
  [SMALL_STATE(1327)] = 20172,
  [SMALL_STATE(1328)] = 20232,
  [SMALL_STATE(1329)] = 20292,
  [SMALL_STATE(1330)] = 20352,
  [SMALL_STATE(1331)] = 20412,
  [SMALL_STATE(1332)] = 20472,
  [SMALL_STATE(1333)] = 20532,
  [SMALL_STATE(1334)] = 20592,
  [SMALL_STATE(1335)] = 20652,
  [SMALL_STATE(1336)] = 20712,
  [SMALL_STATE(1337)] = 20772,
  [SMALL_STATE(1338)] = 20832,
  [SMALL_STATE(1339)] = 20892,
  [SMALL_STATE(1340)] = 20952,
  [SMALL_STATE(1341)] = 21012,
  [SMALL_STATE(1342)] = 21072,
  [SMALL_STATE(1343)] = 21132,
  [SMALL_STATE(1344)] = 21192,
  [SMALL_STATE(1345)] = 21252,
  [SMALL_STATE(1346)] = 21312,
  [SMALL_STATE(1347)] = 21372,
  [SMALL_STATE(1348)] = 21432,
  [SMALL_STATE(1349)] = 21492,
  [SMALL_STATE(1350)] = 21552,
  [SMALL_STATE(1351)] = 21612,
  [SMALL_STATE(1352)] = 21672,
  [SMALL_STATE(1353)] = 21732,
  [SMALL_STATE(1354)] = 21792,
  [SMALL_STATE(1355)] = 21852,
  [SMALL_STATE(1356)] = 21912,
  [SMALL_STATE(1357)] = 21972,
  [SMALL_STATE(1358)] = 22032,
  [SMALL_STATE(1359)] = 22092,
  [SMALL_STATE(1360)] = 22152,
  [SMALL_STATE(1361)] = 22212,
  [SMALL_STATE(1362)] = 22272,
  [SMALL_STATE(1363)] = 22332,
  [SMALL_STATE(1364)] = 22392,
  [SMALL_STATE(1365)] = 22452,
  [SMALL_STATE(1366)] = 22512,
  [SMALL_STATE(1367)] = 22572,
  [SMALL_STATE(1368)] = 22632,
  [SMALL_STATE(1369)] = 22692,
  [SMALL_STATE(1370)] = 22752,
  [SMALL_STATE(1371)] = 22812,
  [SMALL_STATE(1372)] = 22872,
  [SMALL_STATE(1373)] = 22932,
  [SMALL_STATE(1374)] = 22992,
  [SMALL_STATE(1375)] = 23052,
  [SMALL_STATE(1376)] = 23112,
  [SMALL_STATE(1377)] = 23172,
  [SMALL_STATE(1378)] = 23232,
  [SMALL_STATE(1379)] = 23292,
  [SMALL_STATE(1380)] = 23352,
  [SMALL_STATE(1381)] = 23412,
  [SMALL_STATE(1382)] = 23472,
  [SMALL_STATE(1383)] = 23532,
  [SMALL_STATE(1384)] = 23592,
  [SMALL_STATE(1385)] = 23652,
  [SMALL_STATE(1386)] = 23712,
  [SMALL_STATE(1387)] = 23772,
  [SMALL_STATE(1388)] = 23832,
  [SMALL_STATE(1389)] = 23892,
  [SMALL_STATE(1390)] = 23952,
  [SMALL_STATE(1391)] = 24012,
  [SMALL_STATE(1392)] = 24072,
  [SMALL_STATE(1393)] = 24132,
  [SMALL_STATE(1394)] = 24192,
  [SMALL_STATE(1395)] = 24252,
  [SMALL_STATE(1396)] = 24312,
  [SMALL_STATE(1397)] = 24372,
  [SMALL_STATE(1398)] = 24432,
  [SMALL_STATE(1399)] = 24492,
  [SMALL_STATE(1400)] = 24552,
  [SMALL_STATE(1401)] = 24612,
  [SMALL_STATE(1402)] = 24672,
  [SMALL_STATE(1403)] = 24732,
  [SMALL_STATE(1404)] = 24792,
  [SMALL_STATE(1405)] = 24856,
  [SMALL_STATE(1406)] = 24916,
  [SMALL_STATE(1407)] = 24976,
  [SMALL_STATE(1408)] = 25036,
  [SMALL_STATE(1409)] = 25096,
  [SMALL_STATE(1410)] = 25156,
  [SMALL_STATE(1411)] = 25216,
  [SMALL_STATE(1412)] = 25276,
  [SMALL_STATE(1413)] = 25336,
  [SMALL_STATE(1414)] = 25396,
  [SMALL_STATE(1415)] = 25464,
  [SMALL_STATE(1416)] = 25556,
  [SMALL_STATE(1417)] = 25618,
  [SMALL_STATE(1418)] = 25678,
  [SMALL_STATE(1419)] = 25738,
  [SMALL_STATE(1420)] = 25800,
  [SMALL_STATE(1421)] = 25860,
  [SMALL_STATE(1422)] = 25920,
  [SMALL_STATE(1423)] = 25980,
  [SMALL_STATE(1424)] = 26072,
  [SMALL_STATE(1425)] = 26132,
  [SMALL_STATE(1426)] = 26192,
  [SMALL_STATE(1427)] = 26252,
  [SMALL_STATE(1428)] = 26312,
  [SMALL_STATE(1429)] = 26372,
  [SMALL_STATE(1430)] = 26432,
  [SMALL_STATE(1431)] = 26492,
  [SMALL_STATE(1432)] = 26552,
  [SMALL_STATE(1433)] = 26612,
  [SMALL_STATE(1434)] = 26672,
  [SMALL_STATE(1435)] = 26732,
  [SMALL_STATE(1436)] = 26792,
  [SMALL_STATE(1437)] = 26852,
  [SMALL_STATE(1438)] = 26914,
  [SMALL_STATE(1439)] = 26974,
  [SMALL_STATE(1440)] = 27034,
  [SMALL_STATE(1441)] = 27094,
  [SMALL_STATE(1442)] = 27154,
  [SMALL_STATE(1443)] = 27220,
  [SMALL_STATE(1444)] = 27280,
  [SMALL_STATE(1445)] = 27340,
  [SMALL_STATE(1446)] = 27400,
  [SMALL_STATE(1447)] = 27460,
  [SMALL_STATE(1448)] = 27520,
  [SMALL_STATE(1449)] = 27580,
  [SMALL_STATE(1450)] = 27640,
  [SMALL_STATE(1451)] = 27700,
  [SMALL_STATE(1452)] = 27760,
  [SMALL_STATE(1453)] = 27826,
  [SMALL_STATE(1454)] = 27886,
  [SMALL_STATE(1455)] = 27946,
  [SMALL_STATE(1456)] = 28006,
  [SMALL_STATE(1457)] = 28066,
  [SMALL_STATE(1458)] = 28126,
  [SMALL_STATE(1459)] = 28186,
  [SMALL_STATE(1460)] = 28246,
  [SMALL_STATE(1461)] = 28306,
  [SMALL_STATE(1462)] = 28366,
  [SMALL_STATE(1463)] = 28426,
  [SMALL_STATE(1464)] = 28486,
  [SMALL_STATE(1465)] = 28546,
  [SMALL_STATE(1466)] = 28606,
  [SMALL_STATE(1467)] = 28666,
  [SMALL_STATE(1468)] = 28726,
  [SMALL_STATE(1469)] = 28786,
  [SMALL_STATE(1470)] = 28846,
  [SMALL_STATE(1471)] = 28906,
  [SMALL_STATE(1472)] = 29001,
  [SMALL_STATE(1473)] = 29060,
  [SMALL_STATE(1474)] = 29121,
  [SMALL_STATE(1475)] = 29180,
  [SMALL_STATE(1476)] = 29239,
  [SMALL_STATE(1477)] = 29298,
  [SMALL_STATE(1478)] = 29357,
  [SMALL_STATE(1479)] = 29416,
  [SMALL_STATE(1480)] = 29511,
  [SMALL_STATE(1481)] = 29570,
  [SMALL_STATE(1482)] = 29631,
  [SMALL_STATE(1483)] = 29723,
  [SMALL_STATE(1484)] = 29801,
  [SMALL_STATE(1485)] = 29899,
  [SMALL_STATE(1486)] = 29989,
  [SMALL_STATE(1487)] = 30079,
  [SMALL_STATE(1488)] = 30169,
  [SMALL_STATE(1489)] = 30235,
  [SMALL_STATE(1490)] = 30325,
  [SMALL_STATE(1491)] = 30411,
  [SMALL_STATE(1492)] = 30481,
  [SMALL_STATE(1493)] = 30579,
  [SMALL_STATE(1494)] = 30647,
  [SMALL_STATE(1495)] = 30721,
  [SMALL_STATE(1496)] = 30793,
  [SMALL_STATE(1497)] = 30869,
  [SMALL_STATE(1498)] = 30951,
  [SMALL_STATE(1499)] = 31049,
  [SMALL_STATE(1500)] = 31133,
  [SMALL_STATE(1501)] = 31203,
  [SMALL_STATE(1502)] = 31293,
  [SMALL_STATE(1503)] = 31383,
  [SMALL_STATE(1504)] = 31475,
  [SMALL_STATE(1505)] = 31567,
  [SMALL_STATE(1506)] = 31653,
  [SMALL_STATE(1507)] = 31718,
  [SMALL_STATE(1508)] = 31781,
  [SMALL_STATE(1509)] = 31848,
  [SMALL_STATE(1510)] = 31915,
  [SMALL_STATE(1511)] = 32000,
  [SMALL_STATE(1512)] = 32085,
  [SMALL_STATE(1513)] = 32170,
  [SMALL_STATE(1514)] = 32237,
  [SMALL_STATE(1515)] = 32300,
  [SMALL_STATE(1516)] = 32385,
  [SMALL_STATE(1517)] = 32449,
  [SMALL_STATE(1518)] = 32509,
  [SMALL_STATE(1519)] = 32569,
  [SMALL_STATE(1520)] = 32627,
  [SMALL_STATE(1521)] = 32683,
  [SMALL_STATE(1522)] = 32739,
  [SMALL_STATE(1523)] = 32797,
  [SMALL_STATE(1524)] = 32855,
  [SMALL_STATE(1525)] = 32919,
  [SMALL_STATE(1526)] = 32975,
  [SMALL_STATE(1527)] = 33033,
  [SMALL_STATE(1528)] = 33089,
  [SMALL_STATE(1529)] = 33145,
  [SMALL_STATE(1530)] = 33203,
  [SMALL_STATE(1531)] = 33263,
  [SMALL_STATE(1532)] = 33321,
  [SMALL_STATE(1533)] = 33385,
  [SMALL_STATE(1534)] = 33441,
  [SMALL_STATE(1535)] = 33497,
  [SMALL_STATE(1536)] = 33553,
  [SMALL_STATE(1537)] = 33613,
  [SMALL_STATE(1538)] = 33673,
  [SMALL_STATE(1539)] = 33737,
  [SMALL_STATE(1540)] = 33797,
  [SMALL_STATE(1541)] = 33853,
  [SMALL_STATE(1542)] = 33913,
  [SMALL_STATE(1543)] = 34008,
  [SMALL_STATE(1544)] = 34063,
  [SMALL_STATE(1545)] = 34158,
  [SMALL_STATE(1546)] = 34253,
  [SMALL_STATE(1547)] = 34308,
  [SMALL_STATE(1548)] = 34363,
  [SMALL_STATE(1549)] = 34420,
  [SMALL_STATE(1550)] = 34515,
  [SMALL_STATE(1551)] = 34572,
  [SMALL_STATE(1552)] = 34631,
  [SMALL_STATE(1553)] = 34726,
  [SMALL_STATE(1554)] = 34821,
  [SMALL_STATE(1555)] = 34876,
  [SMALL_STATE(1556)] = 34935,
  [SMALL_STATE(1557)] = 35030,
  [SMALL_STATE(1558)] = 35087,
  [SMALL_STATE(1559)] = 35144,
  [SMALL_STATE(1560)] = 35239,
  [SMALL_STATE(1561)] = 35334,
  [SMALL_STATE(1562)] = 35391,
  [SMALL_STATE(1563)] = 35486,
  [SMALL_STATE(1564)] = 35543,
  [SMALL_STATE(1565)] = 35598,
  [SMALL_STATE(1566)] = 35653,
  [SMALL_STATE(1567)] = 35748,
  [SMALL_STATE(1568)] = 35805,
  [SMALL_STATE(1569)] = 35864,
  [SMALL_STATE(1570)] = 35923,
  [SMALL_STATE(1571)] = 35978,
  [SMALL_STATE(1572)] = 36073,
  [SMALL_STATE(1573)] = 36128,
  [SMALL_STATE(1574)] = 36206,
  [SMALL_STATE(1575)] = 36260,
  [SMALL_STATE(1576)] = 36316,
  [SMALL_STATE(1577)] = 36370,
  [SMALL_STATE(1578)] = 36424,
  [SMALL_STATE(1579)] = 36510,
  [SMALL_STATE(1580)] = 36564,
  [SMALL_STATE(1581)] = 36638,
  [SMALL_STATE(1582)] = 36724,
  [SMALL_STATE(1583)] = 36778,
  [SMALL_STATE(1584)] = 36834,
  [SMALL_STATE(1585)] = 36920,
  [SMALL_STATE(1586)] = 36986,
  [SMALL_STATE(1587)] = 37066,
  [SMALL_STATE(1588)] = 37154,
  [SMALL_STATE(1589)] = 37208,
  [SMALL_STATE(1590)] = 37264,
  [SMALL_STATE(1591)] = 37322,
  [SMALL_STATE(1592)] = 37378,
  [SMALL_STATE(1593)] = 37434,
  [SMALL_STATE(1594)] = 37490,
  [SMALL_STATE(1595)] = 37544,
  [SMALL_STATE(1596)] = 37636,
  [SMALL_STATE(1597)] = 37724,
  [SMALL_STATE(1598)] = 37796,
  [SMALL_STATE(1599)] = 37850,
  [SMALL_STATE(1600)] = 37904,
  [SMALL_STATE(1601)] = 37992,
  [SMALL_STATE(1602)] = 38048,
  [SMALL_STATE(1603)] = 38130,
  [SMALL_STATE(1604)] = 38184,
  [SMALL_STATE(1605)] = 38240,
  [SMALL_STATE(1606)] = 38296,
  [SMALL_STATE(1607)] = 38382,
  [SMALL_STATE(1608)] = 38438,
  [SMALL_STATE(1609)] = 38494,
  [SMALL_STATE(1610)] = 38586,
  [SMALL_STATE(1611)] = 38640,
  [SMALL_STATE(1612)] = 38728,
  [SMALL_STATE(1613)] = 38796,
  [SMALL_STATE(1614)] = 38852,
  [SMALL_STATE(1615)] = 38940,
  [SMALL_STATE(1616)] = 39026,
  [SMALL_STATE(1617)] = 39096,
  [SMALL_STATE(1618)] = 39160,
  [SMALL_STATE(1619)] = 39214,
  [SMALL_STATE(1620)] = 39300,
  [SMALL_STATE(1621)] = 39382,
  [SMALL_STATE(1622)] = 39438,
  [SMALL_STATE(1623)] = 39530,
  [SMALL_STATE(1624)] = 39618,
  [SMALL_STATE(1625)] = 39674,
  [SMALL_STATE(1626)] = 39728,
  [SMALL_STATE(1627)] = 39816,
  [SMALL_STATE(1628)] = 39908,
  [SMALL_STATE(1629)] = 40000,
  [SMALL_STATE(1630)] = 40092,
  [SMALL_STATE(1631)] = 40146,
  [SMALL_STATE(1632)] = 40202,
  [SMALL_STATE(1633)] = 40256,
  [SMALL_STATE(1634)] = 40344,
  [SMALL_STATE(1635)] = 40398,
  [SMALL_STATE(1636)] = 40454,
  [SMALL_STATE(1637)] = 40543,
  [SMALL_STATE(1638)] = 40632,
  [SMALL_STATE(1639)] = 40695,
  [SMALL_STATE(1640)] = 40748,
  [SMALL_STATE(1641)] = 40801,
  [SMALL_STATE(1642)] = 40854,
  [SMALL_STATE(1643)] = 40907,
  [SMALL_STATE(1644)] = 40960,
  [SMALL_STATE(1645)] = 41045,
  [SMALL_STATE(1646)] = 41098,
  [SMALL_STATE(1647)] = 41187,
  [SMALL_STATE(1648)] = 41240,
  [SMALL_STATE(1649)] = 41329,
  [SMALL_STATE(1650)] = 41382,
  [SMALL_STATE(1651)] = 41471,
  [SMALL_STATE(1652)] = 41560,
  [SMALL_STATE(1653)] = 41649,
  [SMALL_STATE(1654)] = 41736,
  [SMALL_STATE(1655)] = 41823,
  [SMALL_STATE(1656)] = 41876,
  [SMALL_STATE(1657)] = 41965,
  [SMALL_STATE(1658)] = 42054,
  [SMALL_STATE(1659)] = 42143,
  [SMALL_STATE(1660)] = 42232,
  [SMALL_STATE(1661)] = 42285,
  [SMALL_STATE(1662)] = 42374,
  [SMALL_STATE(1663)] = 42441,
  [SMALL_STATE(1664)] = 42530,
  [SMALL_STATE(1665)] = 42619,
  [SMALL_STATE(1666)] = 42672,
  [SMALL_STATE(1667)] = 42725,
  [SMALL_STATE(1668)] = 42778,
  [SMALL_STATE(1669)] = 42865,
  [SMALL_STATE(1670)] = 42918,
  [SMALL_STATE(1671)] = 42971,
  [SMALL_STATE(1672)] = 43024,
  [SMALL_STATE(1673)] = 43111,
  [SMALL_STATE(1674)] = 43164,
  [SMALL_STATE(1675)] = 43217,
  [SMALL_STATE(1676)] = 43306,
  [SMALL_STATE(1677)] = 43395,
  [SMALL_STATE(1678)] = 43448,
  [SMALL_STATE(1679)] = 43501,
  [SMALL_STATE(1680)] = 43588,
  [SMALL_STATE(1681)] = 43641,
  [SMALL_STATE(1682)] = 43694,
  [SMALL_STATE(1683)] = 43781,
  [SMALL_STATE(1684)] = 43834,
  [SMALL_STATE(1685)] = 43887,
  [SMALL_STATE(1686)] = 43940,
  [SMALL_STATE(1687)] = 43993,
  [SMALL_STATE(1688)] = 44064,
  [SMALL_STATE(1689)] = 44117,
  [SMALL_STATE(1690)] = 44170,
  [SMALL_STATE(1691)] = 44223,
  [SMALL_STATE(1692)] = 44276,
  [SMALL_STATE(1693)] = 44345,
  [SMALL_STATE(1694)] = 44432,
  [SMALL_STATE(1695)] = 44519,
  [SMALL_STATE(1696)] = 44572,
  [SMALL_STATE(1697)] = 44659,
  [SMALL_STATE(1698)] = 44712,
  [SMALL_STATE(1699)] = 44765,
  [SMALL_STATE(1700)] = 44818,
  [SMALL_STATE(1701)] = 44871,
  [SMALL_STATE(1702)] = 44960,
  [SMALL_STATE(1703)] = 45013,
  [SMALL_STATE(1704)] = 45102,
  [SMALL_STATE(1705)] = 45191,
  [SMALL_STATE(1706)] = 45244,
  [SMALL_STATE(1707)] = 45297,
  [SMALL_STATE(1708)] = 45386,
  [SMALL_STATE(1709)] = 45445,
  [SMALL_STATE(1710)] = 45534,
  [SMALL_STATE(1711)] = 45593,
  [SMALL_STATE(1712)] = 45680,
  [SMALL_STATE(1713)] = 45733,
  [SMALL_STATE(1714)] = 45818,
  [SMALL_STATE(1715)] = 45903,
  [SMALL_STATE(1716)] = 45976,
  [SMALL_STATE(1717)] = 46057,
  [SMALL_STATE(1718)] = 46146,
  [SMALL_STATE(1719)] = 46199,
  [SMALL_STATE(1720)] = 46252,
  [SMALL_STATE(1721)] = 46341,
  [SMALL_STATE(1722)] = 46394,
  [SMALL_STATE(1723)] = 46483,
  [SMALL_STATE(1724)] = 46536,
  [SMALL_STATE(1725)] = 46625,
  [SMALL_STATE(1726)] = 46714,
  [SMALL_STATE(1727)] = 46767,
  [SMALL_STATE(1728)] = 46856,
  [SMALL_STATE(1729)] = 46945,
  [SMALL_STATE(1730)] = 47026,
  [SMALL_STATE(1731)] = 47079,
  [SMALL_STATE(1732)] = 47132,
  [SMALL_STATE(1733)] = 47185,
  [SMALL_STATE(1734)] = 47238,
  [SMALL_STATE(1735)] = 47323,
  [SMALL_STATE(1736)] = 47412,
  [SMALL_STATE(1737)] = 47497,
  [SMALL_STATE(1738)] = 47550,
  [SMALL_STATE(1739)] = 47603,
  [SMALL_STATE(1740)] = 47656,
  [SMALL_STATE(1741)] = 47737,
  [SMALL_STATE(1742)] = 47790,
  [SMALL_STATE(1743)] = 47875,
  [SMALL_STATE(1744)] = 47928,
  [SMALL_STATE(1745)] = 48017,
  [SMALL_STATE(1746)] = 48102,
  [SMALL_STATE(1747)] = 48191,
  [SMALL_STATE(1748)] = 48244,
  [SMALL_STATE(1749)] = 48297,
  [SMALL_STATE(1750)] = 48374,
  [SMALL_STATE(1751)] = 48459,
  [SMALL_STATE(1752)] = 48512,
  [SMALL_STATE(1753)] = 48565,
  [SMALL_STATE(1754)] = 48644,
  [SMALL_STATE(1755)] = 48697,
  [SMALL_STATE(1756)] = 48750,
  [SMALL_STATE(1757)] = 48803,
  [SMALL_STATE(1758)] = 48892,
  [SMALL_STATE(1759)] = 48981,
  [SMALL_STATE(1760)] = 49034,
  [SMALL_STATE(1761)] = 49123,
  [SMALL_STATE(1762)] = 49176,
  [SMALL_STATE(1763)] = 49263,
  [SMALL_STATE(1764)] = 49342,
  [SMALL_STATE(1765)] = 49395,
  [SMALL_STATE(1766)] = 49480,
  [SMALL_STATE(1767)] = 49533,
  [SMALL_STATE(1768)] = 49586,
  [SMALL_STATE(1769)] = 49675,
  [SMALL_STATE(1770)] = 49728,
  [SMALL_STATE(1771)] = 49813,
  [SMALL_STATE(1772)] = 49866,
  [SMALL_STATE(1773)] = 49919,
  [SMALL_STATE(1774)] = 49972,
  [SMALL_STATE(1775)] = 50025,
  [SMALL_STATE(1776)] = 50078,
  [SMALL_STATE(1777)] = 50131,
  [SMALL_STATE(1778)] = 50190,
  [SMALL_STATE(1779)] = 50279,
  [SMALL_STATE(1780)] = 50332,
  [SMALL_STATE(1781)] = 50385,
  [SMALL_STATE(1782)] = 50474,
  [SMALL_STATE(1783)] = 50527,
  [SMALL_STATE(1784)] = 50616,
  [SMALL_STATE(1785)] = 50701,
  [SMALL_STATE(1786)] = 50754,
  [SMALL_STATE(1787)] = 50841,
  [SMALL_STATE(1788)] = 50926,
  [SMALL_STATE(1789)] = 51013,
  [SMALL_STATE(1790)] = 51066,
  [SMALL_STATE(1791)] = 51155,
  [SMALL_STATE(1792)] = 51244,
  [SMALL_STATE(1793)] = 51333,
  [SMALL_STATE(1794)] = 51386,
  [SMALL_STATE(1795)] = 51439,
  [SMALL_STATE(1796)] = 51520,
  [SMALL_STATE(1797)] = 51573,
  [SMALL_STATE(1798)] = 51646,
  [SMALL_STATE(1799)] = 51699,
  [SMALL_STATE(1800)] = 51786,
  [SMALL_STATE(1801)] = 51839,
  [SMALL_STATE(1802)] = 51892,
  [SMALL_STATE(1803)] = 51981,
  [SMALL_STATE(1804)] = 52070,
  [SMALL_STATE(1805)] = 52157,
  [SMALL_STATE(1806)] = 52210,
  [SMALL_STATE(1807)] = 52263,
  [SMALL_STATE(1808)] = 52316,
  [SMALL_STATE(1809)] = 52403,
  [SMALL_STATE(1810)] = 52490,
  [SMALL_STATE(1811)] = 52577,
  [SMALL_STATE(1812)] = 52642,
  [SMALL_STATE(1813)] = 52695,
  [SMALL_STATE(1814)] = 52748,
  [SMALL_STATE(1815)] = 52801,
  [SMALL_STATE(1816)] = 52886,
  [SMALL_STATE(1817)] = 52971,
  [SMALL_STATE(1818)] = 53024,
  [SMALL_STATE(1819)] = 53089,
  [SMALL_STATE(1820)] = 53178,
  [SMALL_STATE(1821)] = 53231,
  [SMALL_STATE(1822)] = 53318,
  [SMALL_STATE(1823)] = 53371,
  [SMALL_STATE(1824)] = 53424,
  [SMALL_STATE(1825)] = 53513,
  [SMALL_STATE(1826)] = 53602,
  [SMALL_STATE(1827)] = 53663,
  [SMALL_STATE(1828)] = 53716,
  [SMALL_STATE(1829)] = 53769,
  [SMALL_STATE(1830)] = 53858,
  [SMALL_STATE(1831)] = 53947,
  [SMALL_STATE(1832)] = 54000,
  [SMALL_STATE(1833)] = 54079,
  [SMALL_STATE(1834)] = 54132,
  [SMALL_STATE(1835)] = 54221,
  [SMALL_STATE(1836)] = 54298,
  [SMALL_STATE(1837)] = 54387,
  [SMALL_STATE(1838)] = 54458,
  [SMALL_STATE(1839)] = 54525,
  [SMALL_STATE(1840)] = 54594,
  [SMALL_STATE(1841)] = 54657,
  [SMALL_STATE(1842)] = 54710,
  [SMALL_STATE(1843)] = 54796,
  [SMALL_STATE(1844)] = 54882,
  [SMALL_STATE(1845)] = 54968,
  [SMALL_STATE(1846)] = 55054,
  [SMALL_STATE(1847)] = 55140,
  [SMALL_STATE(1848)] = 55226,
  [SMALL_STATE(1849)] = 55312,
  [SMALL_STATE(1850)] = 55398,
  [SMALL_STATE(1851)] = 55484,
  [SMALL_STATE(1852)] = 55570,
  [SMALL_STATE(1853)] = 55646,
  [SMALL_STATE(1854)] = 55732,
  [SMALL_STATE(1855)] = 55818,
  [SMALL_STATE(1856)] = 55904,
  [SMALL_STATE(1857)] = 55990,
  [SMALL_STATE(1858)] = 56076,
  [SMALL_STATE(1859)] = 56162,
  [SMALL_STATE(1860)] = 56248,
  [SMALL_STATE(1861)] = 56334,
  [SMALL_STATE(1862)] = 56418,
  [SMALL_STATE(1863)] = 56504,
  [SMALL_STATE(1864)] = 56590,
  [SMALL_STATE(1865)] = 56676,
  [SMALL_STATE(1866)] = 56762,
  [SMALL_STATE(1867)] = 56848,
  [SMALL_STATE(1868)] = 56932,
  [SMALL_STATE(1869)] = 57018,
  [SMALL_STATE(1870)] = 57104,
  [SMALL_STATE(1871)] = 57190,
  [SMALL_STATE(1872)] = 57276,
  [SMALL_STATE(1873)] = 57362,
  [SMALL_STATE(1874)] = 57448,
  [SMALL_STATE(1875)] = 57524,
  [SMALL_STATE(1876)] = 57610,
  [SMALL_STATE(1877)] = 57683,
  [SMALL_STATE(1878)] = 57756,
  [SMALL_STATE(1879)] = 57829,
  [SMALL_STATE(1880)] = 57902,
  [SMALL_STATE(1881)] = 57975,
  [SMALL_STATE(1882)] = 58049,
  [SMALL_STATE(1883)] = 58123,
  [SMALL_STATE(1884)] = 58197,
  [SMALL_STATE(1885)] = 58271,
  [SMALL_STATE(1886)] = 58345,
  [SMALL_STATE(1887)] = 58419,
  [SMALL_STATE(1888)] = 58493,
  [SMALL_STATE(1889)] = 58567,
  [SMALL_STATE(1890)] = 58613,
  [SMALL_STATE(1891)] = 58659,
  [SMALL_STATE(1892)] = 58705,
  [SMALL_STATE(1893)] = 58766,
  [SMALL_STATE(1894)] = 58827,
  [SMALL_STATE(1895)] = 58888,
  [SMALL_STATE(1896)] = 58949,
  [SMALL_STATE(1897)] = 59010,
  [SMALL_STATE(1898)] = 59071,
  [SMALL_STATE(1899)] = 59132,
  [SMALL_STATE(1900)] = 59193,
  [SMALL_STATE(1901)] = 59251,
  [SMALL_STATE(1902)] = 59309,
  [SMALL_STATE(1903)] = 59345,
  [SMALL_STATE(1904)] = 59393,
  [SMALL_STATE(1905)] = 59429,
  [SMALL_STATE(1906)] = 59466,
  [SMALL_STATE(1907)] = 59519,
  [SMALL_STATE(1908)] = 59556,
  [SMALL_STATE(1909)] = 59601,
  [SMALL_STATE(1910)] = 59638,
  [SMALL_STATE(1911)] = 59683,
  [SMALL_STATE(1912)] = 59728,
  [SMALL_STATE(1913)] = 59765,
  [SMALL_STATE(1914)] = 59805,
  [SMALL_STATE(1915)] = 59841,
  [SMALL_STATE(1916)] = 59881,
  [SMALL_STATE(1917)] = 59921,
  [SMALL_STATE(1918)] = 59957,
  [SMALL_STATE(1919)] = 59997,
  [SMALL_STATE(1920)] = 60033,
  [SMALL_STATE(1921)] = 60069,
  [SMALL_STATE(1922)] = 60102,
  [SMALL_STATE(1923)] = 60135,
  [SMALL_STATE(1924)] = 60168,
  [SMALL_STATE(1925)] = 60199,
  [SMALL_STATE(1926)] = 60232,
  [SMALL_STATE(1927)] = 60265,
  [SMALL_STATE(1928)] = 60298,
  [SMALL_STATE(1929)] = 60331,
  [SMALL_STATE(1930)] = 60364,
  [SMALL_STATE(1931)] = 60408,
  [SMALL_STATE(1932)] = 60440,
  [SMALL_STATE(1933)] = 60500,
  [SMALL_STATE(1934)] = 60560,
  [SMALL_STATE(1935)] = 60606,
  [SMALL_STATE(1936)] = 60638,
  [SMALL_STATE(1937)] = 60670,
  [SMALL_STATE(1938)] = 60703,
  [SMALL_STATE(1939)] = 60732,
  [SMALL_STATE(1940)] = 60763,
  [SMALL_STATE(1941)] = 60796,
  [SMALL_STATE(1942)] = 60825,
  [SMALL_STATE(1943)] = 60856,
  [SMALL_STATE(1944)] = 60887,
  [SMALL_STATE(1945)] = 60916,
  [SMALL_STATE(1946)] = 60969,
  [SMALL_STATE(1947)] = 61000,
  [SMALL_STATE(1948)] = 61031,
  [SMALL_STATE(1949)] = 61064,
  [SMALL_STATE(1950)] = 61097,
  [SMALL_STATE(1951)] = 61126,
  [SMALL_STATE(1952)] = 61159,
  [SMALL_STATE(1953)] = 61192,
  [SMALL_STATE(1954)] = 61245,
  [SMALL_STATE(1955)] = 61286,
  [SMALL_STATE(1956)] = 61315,
  [SMALL_STATE(1957)] = 61346,
  [SMALL_STATE(1958)] = 61375,
  [SMALL_STATE(1959)] = 61406,
  [SMALL_STATE(1960)] = 61435,
  [SMALL_STATE(1961)] = 61464,
  [SMALL_STATE(1962)] = 61507,
  [SMALL_STATE(1963)] = 61562,
  [SMALL_STATE(1964)] = 61593,
  [SMALL_STATE(1965)] = 61622,
  [SMALL_STATE(1966)] = 61650,
  [SMALL_STATE(1967)] = 61678,
  [SMALL_STATE(1968)] = 61706,
  [SMALL_STATE(1969)] = 61734,
  [SMALL_STATE(1970)] = 61762,
  [SMALL_STATE(1971)] = 61790,
  [SMALL_STATE(1972)] = 61818,
  [SMALL_STATE(1973)] = 61846,
  [SMALL_STATE(1974)] = 61874,
  [SMALL_STATE(1975)] = 61902,
  [SMALL_STATE(1976)] = 61932,
  [SMALL_STATE(1977)] = 61960,
  [SMALL_STATE(1978)] = 61988,
  [SMALL_STATE(1979)] = 62016,
  [SMALL_STATE(1980)] = 62044,
  [SMALL_STATE(1981)] = 62072,
  [SMALL_STATE(1982)] = 62100,
  [SMALL_STATE(1983)] = 62130,
  [SMALL_STATE(1984)] = 62158,
  [SMALL_STATE(1985)] = 62186,
  [SMALL_STATE(1986)] = 62230,
  [SMALL_STATE(1987)] = 62258,
  [SMALL_STATE(1988)] = 62286,
  [SMALL_STATE(1989)] = 62314,
  [SMALL_STATE(1990)] = 62342,
  [SMALL_STATE(1991)] = 62370,
  [SMALL_STATE(1992)] = 62398,
  [SMALL_STATE(1993)] = 62426,
  [SMALL_STATE(1994)] = 62454,
  [SMALL_STATE(1995)] = 62482,
  [SMALL_STATE(1996)] = 62510,
  [SMALL_STATE(1997)] = 62538,
  [SMALL_STATE(1998)] = 62589,
  [SMALL_STATE(1999)] = 62618,
  [SMALL_STATE(2000)] = 62647,
  [SMALL_STATE(2001)] = 62678,
  [SMALL_STATE(2002)] = 62713,
  [SMALL_STATE(2003)] = 62757,
  [SMALL_STATE(2004)] = 62789,
  [SMALL_STATE(2005)] = 62821,
  [SMALL_STATE(2006)] = 62853,
  [SMALL_STATE(2007)] = 62883,
  [SMALL_STATE(2008)] = 62915,
  [SMALL_STATE(2009)] = 62943,
  [SMALL_STATE(2010)] = 62971,
  [SMALL_STATE(2011)] = 63003,
  [SMALL_STATE(2012)] = 63035,
  [SMALL_STATE(2013)] = 63067,
  [SMALL_STATE(2014)] = 63099,
  [SMALL_STATE(2015)] = 63131,
  [SMALL_STATE(2016)] = 63163,
  [SMALL_STATE(2017)] = 63195,
  [SMALL_STATE(2018)] = 63227,
  [SMALL_STATE(2019)] = 63272,
  [SMALL_STATE(2020)] = 63317,
  [SMALL_STATE(2021)] = 63362,
  [SMALL_STATE(2022)] = 63407,
  [SMALL_STATE(2023)] = 63452,
  [SMALL_STATE(2024)] = 63497,
  [SMALL_STATE(2025)] = 63542,
  [SMALL_STATE(2026)] = 63587,
  [SMALL_STATE(2027)] = 63632,
  [SMALL_STATE(2028)] = 63677,
  [SMALL_STATE(2029)] = 63714,
  [SMALL_STATE(2030)] = 63759,
  [SMALL_STATE(2031)] = 63804,
  [SMALL_STATE(2032)] = 63849,
  [SMALL_STATE(2033)] = 63894,
  [SMALL_STATE(2034)] = 63939,
  [SMALL_STATE(2035)] = 63981,
  [SMALL_STATE(2036)] = 64005,
  [SMALL_STATE(2037)] = 64045,
  [SMALL_STATE(2038)] = 64073,
  [SMALL_STATE(2039)] = 64113,
  [SMALL_STATE(2040)] = 64155,
  [SMALL_STATE(2041)] = 64183,
  [SMALL_STATE(2042)] = 64211,
  [SMALL_STATE(2043)] = 64235,
  [SMALL_STATE(2044)] = 64273,
  [SMALL_STATE(2045)] = 64311,
  [SMALL_STATE(2046)] = 64353,
  [SMALL_STATE(2047)] = 64381,
  [SMALL_STATE(2048)] = 64411,
  [SMALL_STATE(2049)] = 64439,
  [SMALL_STATE(2050)] = 64469,
  [SMALL_STATE(2051)] = 64507,
  [SMALL_STATE(2052)] = 64549,
  [SMALL_STATE(2053)] = 64591,
  [SMALL_STATE(2054)] = 64631,
  [SMALL_STATE(2055)] = 64665,
  [SMALL_STATE(2056)] = 64703,
  [SMALL_STATE(2057)] = 64741,
  [SMALL_STATE(2058)] = 64769,
  [SMALL_STATE(2059)] = 64797,
  [SMALL_STATE(2060)] = 64835,
  [SMALL_STATE(2061)] = 64859,
  [SMALL_STATE(2062)] = 64887,
  [SMALL_STATE(2063)] = 64929,
  [SMALL_STATE(2064)] = 64959,
  [SMALL_STATE(2065)] = 64987,
  [SMALL_STATE(2066)] = 65025,
  [SMALL_STATE(2067)] = 65059,
  [SMALL_STATE(2068)] = 65097,
  [SMALL_STATE(2069)] = 65125,
  [SMALL_STATE(2070)] = 65155,
  [SMALL_STATE(2071)] = 65197,
  [SMALL_STATE(2072)] = 65221,
  [SMALL_STATE(2073)] = 65259,
  [SMALL_STATE(2074)] = 65283,
  [SMALL_STATE(2075)] = 65311,
  [SMALL_STATE(2076)] = 65339,
  [SMALL_STATE(2077)] = 65362,
  [SMALL_STATE(2078)] = 65385,
  [SMALL_STATE(2079)] = 65420,
  [SMALL_STATE(2080)] = 65443,
  [SMALL_STATE(2081)] = 65466,
  [SMALL_STATE(2082)] = 65497,
  [SMALL_STATE(2083)] = 65532,
  [SMALL_STATE(2084)] = 65555,
  [SMALL_STATE(2085)] = 65578,
  [SMALL_STATE(2086)] = 65601,
  [SMALL_STATE(2087)] = 65624,
  [SMALL_STATE(2088)] = 65647,
  [SMALL_STATE(2089)] = 65688,
  [SMALL_STATE(2090)] = 65711,
  [SMALL_STATE(2091)] = 65752,
  [SMALL_STATE(2092)] = 65787,
  [SMALL_STATE(2093)] = 65810,
  [SMALL_STATE(2094)] = 65833,
  [SMALL_STATE(2095)] = 65856,
  [SMALL_STATE(2096)] = 65879,
  [SMALL_STATE(2097)] = 65902,
  [SMALL_STATE(2098)] = 65925,
  [SMALL_STATE(2099)] = 65948,
  [SMALL_STATE(2100)] = 65971,
  [SMALL_STATE(2101)] = 65994,
  [SMALL_STATE(2102)] = 66017,
  [SMALL_STATE(2103)] = 66040,
  [SMALL_STATE(2104)] = 66071,
  [SMALL_STATE(2105)] = 66104,
  [SMALL_STATE(2106)] = 66135,
  [SMALL_STATE(2107)] = 66158,
  [SMALL_STATE(2108)] = 66195,
  [SMALL_STATE(2109)] = 66232,
  [SMALL_STATE(2110)] = 66255,
  [SMALL_STATE(2111)] = 66278,
  [SMALL_STATE(2112)] = 66301,
  [SMALL_STATE(2113)] = 66324,
  [SMALL_STATE(2114)] = 66347,
  [SMALL_STATE(2115)] = 66370,
  [SMALL_STATE(2116)] = 66407,
  [SMALL_STATE(2117)] = 66444,
  [SMALL_STATE(2118)] = 66467,
  [SMALL_STATE(2119)] = 66490,
  [SMALL_STATE(2120)] = 66513,
  [SMALL_STATE(2121)] = 66536,
  [SMALL_STATE(2122)] = 66567,
  [SMALL_STATE(2123)] = 66590,
  [SMALL_STATE(2124)] = 66631,
  [SMALL_STATE(2125)] = 66672,
  [SMALL_STATE(2126)] = 66695,
  [SMALL_STATE(2127)] = 66718,
  [SMALL_STATE(2128)] = 66741,
  [SMALL_STATE(2129)] = 66779,
  [SMALL_STATE(2130)] = 66817,
  [SMALL_STATE(2131)] = 66845,
  [SMALL_STATE(2132)] = 66869,
  [SMALL_STATE(2133)] = 66893,
  [SMALL_STATE(2134)] = 66925,
  [SMALL_STATE(2135)] = 66963,
  [SMALL_STATE(2136)] = 66995,
  [SMALL_STATE(2137)] = 67027,
  [SMALL_STATE(2138)] = 67059,
  [SMALL_STATE(2139)] = 67087,
  [SMALL_STATE(2140)] = 67125,
  [SMALL_STATE(2141)] = 67153,
  [SMALL_STATE(2142)] = 67191,
  [SMALL_STATE(2143)] = 67229,
  [SMALL_STATE(2144)] = 67261,
  [SMALL_STATE(2145)] = 67295,
  [SMALL_STATE(2146)] = 67327,
  [SMALL_STATE(2147)] = 67359,
  [SMALL_STATE(2148)] = 67383,
  [SMALL_STATE(2149)] = 67415,
  [SMALL_STATE(2150)] = 67447,
  [SMALL_STATE(2151)] = 67483,
  [SMALL_STATE(2152)] = 67507,
  [SMALL_STATE(2153)] = 67539,
  [SMALL_STATE(2154)] = 67577,
  [SMALL_STATE(2155)] = 67615,
  [SMALL_STATE(2156)] = 67653,
  [SMALL_STATE(2157)] = 67679,
  [SMALL_STATE(2158)] = 67707,
  [SMALL_STATE(2159)] = 67739,
  [SMALL_STATE(2160)] = 67771,
  [SMALL_STATE(2161)] = 67809,
  [SMALL_STATE(2162)] = 67847,
  [SMALL_STATE(2163)] = 67885,
  [SMALL_STATE(2164)] = 67923,
  [SMALL_STATE(2165)] = 67961,
  [SMALL_STATE(2166)] = 67993,
  [SMALL_STATE(2167)] = 68017,
  [SMALL_STATE(2168)] = 68043,
  [SMALL_STATE(2169)] = 68069,
  [SMALL_STATE(2170)] = 68097,
  [SMALL_STATE(2171)] = 68131,
  [SMALL_STATE(2172)] = 68159,
  [SMALL_STATE(2173)] = 68197,
  [SMALL_STATE(2174)] = 68235,
  [SMALL_STATE(2175)] = 68263,
  [SMALL_STATE(2176)] = 68289,
  [SMALL_STATE(2177)] = 68310,
  [SMALL_STATE(2178)] = 68345,
  [SMALL_STATE(2179)] = 68380,
  [SMALL_STATE(2180)] = 68415,
  [SMALL_STATE(2181)] = 68448,
  [SMALL_STATE(2182)] = 68483,
  [SMALL_STATE(2183)] = 68516,
  [SMALL_STATE(2184)] = 68551,
  [SMALL_STATE(2185)] = 68578,
  [SMALL_STATE(2186)] = 68613,
  [SMALL_STATE(2187)] = 68648,
  [SMALL_STATE(2188)] = 68683,
  [SMALL_STATE(2189)] = 68718,
  [SMALL_STATE(2190)] = 68753,
  [SMALL_STATE(2191)] = 68788,
  [SMALL_STATE(2192)] = 68809,
  [SMALL_STATE(2193)] = 68844,
  [SMALL_STATE(2194)] = 68879,
  [SMALL_STATE(2195)] = 68914,
  [SMALL_STATE(2196)] = 68949,
  [SMALL_STATE(2197)] = 68984,
  [SMALL_STATE(2198)] = 69019,
  [SMALL_STATE(2199)] = 69054,
  [SMALL_STATE(2200)] = 69089,
  [SMALL_STATE(2201)] = 69124,
  [SMALL_STATE(2202)] = 69157,
  [SMALL_STATE(2203)] = 69190,
  [SMALL_STATE(2204)] = 69225,
  [SMALL_STATE(2205)] = 69260,
  [SMALL_STATE(2206)] = 69285,
  [SMALL_STATE(2207)] = 69320,
  [SMALL_STATE(2208)] = 69355,
  [SMALL_STATE(2209)] = 69390,
  [SMALL_STATE(2210)] = 69425,
  [SMALL_STATE(2211)] = 69460,
  [SMALL_STATE(2212)] = 69495,
  [SMALL_STATE(2213)] = 69528,
  [SMALL_STATE(2214)] = 69563,
  [SMALL_STATE(2215)] = 69584,
  [SMALL_STATE(2216)] = 69619,
  [SMALL_STATE(2217)] = 69640,
  [SMALL_STATE(2218)] = 69661,
  [SMALL_STATE(2219)] = 69682,
  [SMALL_STATE(2220)] = 69717,
  [SMALL_STATE(2221)] = 69746,
  [SMALL_STATE(2222)] = 69771,
  [SMALL_STATE(2223)] = 69796,
  [SMALL_STATE(2224)] = 69831,
  [SMALL_STATE(2225)] = 69866,
  [SMALL_STATE(2226)] = 69901,
  [SMALL_STATE(2227)] = 69936,
  [SMALL_STATE(2228)] = 69971,
  [SMALL_STATE(2229)] = 70006,
  [SMALL_STATE(2230)] = 70041,
  [SMALL_STATE(2231)] = 70076,
  [SMALL_STATE(2232)] = 70111,
  [SMALL_STATE(2233)] = 70143,
  [SMALL_STATE(2234)] = 70175,
  [SMALL_STATE(2235)] = 70207,
  [SMALL_STATE(2236)] = 70239,
  [SMALL_STATE(2237)] = 70271,
  [SMALL_STATE(2238)] = 70303,
  [SMALL_STATE(2239)] = 70325,
  [SMALL_STATE(2240)] = 70357,
  [SMALL_STATE(2241)] = 70389,
  [SMALL_STATE(2242)] = 70421,
  [SMALL_STATE(2243)] = 70453,
  [SMALL_STATE(2244)] = 70479,
  [SMALL_STATE(2245)] = 70507,
  [SMALL_STATE(2246)] = 70539,
  [SMALL_STATE(2247)] = 70571,
  [SMALL_STATE(2248)] = 70603,
  [SMALL_STATE(2249)] = 70631,
  [SMALL_STATE(2250)] = 70653,
  [SMALL_STATE(2251)] = 70685,
  [SMALL_STATE(2252)] = 70715,
  [SMALL_STATE(2253)] = 70747,
  [SMALL_STATE(2254)] = 70777,
  [SMALL_STATE(2255)] = 70807,
  [SMALL_STATE(2256)] = 70837,
  [SMALL_STATE(2257)] = 70867,
  [SMALL_STATE(2258)] = 70895,
  [SMALL_STATE(2259)] = 70925,
  [SMALL_STATE(2260)] = 70957,
  [SMALL_STATE(2261)] = 70979,
  [SMALL_STATE(2262)] = 71005,
  [SMALL_STATE(2263)] = 71037,
  [SMALL_STATE(2264)] = 71069,
  [SMALL_STATE(2265)] = 71101,
  [SMALL_STATE(2266)] = 71133,
  [SMALL_STATE(2267)] = 71165,
  [SMALL_STATE(2268)] = 71197,
  [SMALL_STATE(2269)] = 71227,
  [SMALL_STATE(2270)] = 71259,
  [SMALL_STATE(2271)] = 71289,
  [SMALL_STATE(2272)] = 71321,
  [SMALL_STATE(2273)] = 71353,
  [SMALL_STATE(2274)] = 71385,
  [SMALL_STATE(2275)] = 71417,
  [SMALL_STATE(2276)] = 71449,
  [SMALL_STATE(2277)] = 71479,
  [SMALL_STATE(2278)] = 71509,
  [SMALL_STATE(2279)] = 71541,
  [SMALL_STATE(2280)] = 71569,
  [SMALL_STATE(2281)] = 71595,
  [SMALL_STATE(2282)] = 71627,
  [SMALL_STATE(2283)] = 71659,
  [SMALL_STATE(2284)] = 71691,
  [SMALL_STATE(2285)] = 71713,
  [SMALL_STATE(2286)] = 71735,
  [SMALL_STATE(2287)] = 71767,
  [SMALL_STATE(2288)] = 71793,
  [SMALL_STATE(2289)] = 71815,
  [SMALL_STATE(2290)] = 71843,
  [SMALL_STATE(2291)] = 71870,
  [SMALL_STATE(2292)] = 71893,
  [SMALL_STATE(2293)] = 71922,
  [SMALL_STATE(2294)] = 71951,
  [SMALL_STATE(2295)] = 71974,
  [SMALL_STATE(2296)] = 71995,
  [SMALL_STATE(2297)] = 72024,
  [SMALL_STATE(2298)] = 72053,
  [SMALL_STATE(2299)] = 72082,
  [SMALL_STATE(2300)] = 72111,
  [SMALL_STATE(2301)] = 72132,
  [SMALL_STATE(2302)] = 72151,
  [SMALL_STATE(2303)] = 72180,
  [SMALL_STATE(2304)] = 72203,
  [SMALL_STATE(2305)] = 72230,
  [SMALL_STATE(2306)] = 72259,
  [SMALL_STATE(2307)] = 72282,
  [SMALL_STATE(2308)] = 72305,
  [SMALL_STATE(2309)] = 72334,
  [SMALL_STATE(2310)] = 72357,
  [SMALL_STATE(2311)] = 72386,
  [SMALL_STATE(2312)] = 72415,
  [SMALL_STATE(2313)] = 72436,
  [SMALL_STATE(2314)] = 72465,
  [SMALL_STATE(2315)] = 72494,
  [SMALL_STATE(2316)] = 72523,
  [SMALL_STATE(2317)] = 72552,
  [SMALL_STATE(2318)] = 72575,
  [SMALL_STATE(2319)] = 72596,
  [SMALL_STATE(2320)] = 72625,
  [SMALL_STATE(2321)] = 72654,
  [SMALL_STATE(2322)] = 72673,
  [SMALL_STATE(2323)] = 72702,
  [SMALL_STATE(2324)] = 72731,
  [SMALL_STATE(2325)] = 72756,
  [SMALL_STATE(2326)] = 72785,
  [SMALL_STATE(2327)] = 72814,
  [SMALL_STATE(2328)] = 72843,
  [SMALL_STATE(2329)] = 72866,
  [SMALL_STATE(2330)] = 72893,
  [SMALL_STATE(2331)] = 72922,
  [SMALL_STATE(2332)] = 72951,
  [SMALL_STATE(2333)] = 72980,
  [SMALL_STATE(2334)] = 73009,
  [SMALL_STATE(2335)] = 73034,
  [SMALL_STATE(2336)] = 73063,
  [SMALL_STATE(2337)] = 73092,
  [SMALL_STATE(2338)] = 73121,
  [SMALL_STATE(2339)] = 73144,
  [SMALL_STATE(2340)] = 73173,
  [SMALL_STATE(2341)] = 73202,
  [SMALL_STATE(2342)] = 73231,
  [SMALL_STATE(2343)] = 73260,
  [SMALL_STATE(2344)] = 73285,
  [SMALL_STATE(2345)] = 73306,
  [SMALL_STATE(2346)] = 73329,
  [SMALL_STATE(2347)] = 73358,
  [SMALL_STATE(2348)] = 73387,
  [SMALL_STATE(2349)] = 73416,
  [SMALL_STATE(2350)] = 73443,
  [SMALL_STATE(2351)] = 73472,
  [SMALL_STATE(2352)] = 73501,
  [SMALL_STATE(2353)] = 73530,
  [SMALL_STATE(2354)] = 73559,
  [SMALL_STATE(2355)] = 73582,
  [SMALL_STATE(2356)] = 73603,
  [SMALL_STATE(2357)] = 73624,
  [SMALL_STATE(2358)] = 73645,
  [SMALL_STATE(2359)] = 73674,
  [SMALL_STATE(2360)] = 73697,
  [SMALL_STATE(2361)] = 73726,
  [SMALL_STATE(2362)] = 73755,
  [SMALL_STATE(2363)] = 73784,
  [SMALL_STATE(2364)] = 73813,
  [SMALL_STATE(2365)] = 73842,
  [SMALL_STATE(2366)] = 73871,
  [SMALL_STATE(2367)] = 73894,
  [SMALL_STATE(2368)] = 73923,
  [SMALL_STATE(2369)] = 73948,
  [SMALL_STATE(2370)] = 73975,
  [SMALL_STATE(2371)] = 74004,
  [SMALL_STATE(2372)] = 74033,
  [SMALL_STATE(2373)] = 74060,
  [SMALL_STATE(2374)] = 74089,
  [SMALL_STATE(2375)] = 74118,
  [SMALL_STATE(2376)] = 74147,
  [SMALL_STATE(2377)] = 74176,
  [SMALL_STATE(2378)] = 74205,
  [SMALL_STATE(2379)] = 74234,
  [SMALL_STATE(2380)] = 74257,
  [SMALL_STATE(2381)] = 74286,
  [SMALL_STATE(2382)] = 74315,
  [SMALL_STATE(2383)] = 74344,
  [SMALL_STATE(2384)] = 74373,
  [SMALL_STATE(2385)] = 74402,
  [SMALL_STATE(2386)] = 74431,
  [SMALL_STATE(2387)] = 74460,
  [SMALL_STATE(2388)] = 74489,
  [SMALL_STATE(2389)] = 74518,
  [SMALL_STATE(2390)] = 74544,
  [SMALL_STATE(2391)] = 74570,
  [SMALL_STATE(2392)] = 74596,
  [SMALL_STATE(2393)] = 74620,
  [SMALL_STATE(2394)] = 74646,
  [SMALL_STATE(2395)] = 74668,
  [SMALL_STATE(2396)] = 74694,
  [SMALL_STATE(2397)] = 74720,
  [SMALL_STATE(2398)] = 74746,
  [SMALL_STATE(2399)] = 74770,
  [SMALL_STATE(2400)] = 74788,
  [SMALL_STATE(2401)] = 74814,
  [SMALL_STATE(2402)] = 74840,
  [SMALL_STATE(2403)] = 74862,
  [SMALL_STATE(2404)] = 74880,
  [SMALL_STATE(2405)] = 74902,
  [SMALL_STATE(2406)] = 74926,
  [SMALL_STATE(2407)] = 74952,
  [SMALL_STATE(2408)] = 74978,
  [SMALL_STATE(2409)] = 75004,
  [SMALL_STATE(2410)] = 75022,
  [SMALL_STATE(2411)] = 75048,
  [SMALL_STATE(2412)] = 75066,
  [SMALL_STATE(2413)] = 75084,
  [SMALL_STATE(2414)] = 75108,
  [SMALL_STATE(2415)] = 75134,
  [SMALL_STATE(2416)] = 75160,
  [SMALL_STATE(2417)] = 75186,
  [SMALL_STATE(2418)] = 75212,
  [SMALL_STATE(2419)] = 75238,
  [SMALL_STATE(2420)] = 75264,
  [SMALL_STATE(2421)] = 75282,
  [SMALL_STATE(2422)] = 75308,
  [SMALL_STATE(2423)] = 75332,
  [SMALL_STATE(2424)] = 75358,
  [SMALL_STATE(2425)] = 75384,
  [SMALL_STATE(2426)] = 75402,
  [SMALL_STATE(2427)] = 75426,
  [SMALL_STATE(2428)] = 75444,
  [SMALL_STATE(2429)] = 75466,
  [SMALL_STATE(2430)] = 75484,
  [SMALL_STATE(2431)] = 75502,
  [SMALL_STATE(2432)] = 75526,
  [SMALL_STATE(2433)] = 75548,
  [SMALL_STATE(2434)] = 75574,
  [SMALL_STATE(2435)] = 75594,
  [SMALL_STATE(2436)] = 75618,
  [SMALL_STATE(2437)] = 75638,
  [SMALL_STATE(2438)] = 75662,
  [SMALL_STATE(2439)] = 75688,
  [SMALL_STATE(2440)] = 75712,
  [SMALL_STATE(2441)] = 75730,
  [SMALL_STATE(2442)] = 75756,
  [SMALL_STATE(2443)] = 75780,
  [SMALL_STATE(2444)] = 75798,
  [SMALL_STATE(2445)] = 75818,
  [SMALL_STATE(2446)] = 75844,
  [SMALL_STATE(2447)] = 75868,
  [SMALL_STATE(2448)] = 75894,
  [SMALL_STATE(2449)] = 75920,
  [SMALL_STATE(2450)] = 75942,
  [SMALL_STATE(2451)] = 75968,
  [SMALL_STATE(2452)] = 75994,
  [SMALL_STATE(2453)] = 76016,
  [SMALL_STATE(2454)] = 76038,
  [SMALL_STATE(2455)] = 76060,
  [SMALL_STATE(2456)] = 76086,
  [SMALL_STATE(2457)] = 76108,
  [SMALL_STATE(2458)] = 76134,
  [SMALL_STATE(2459)] = 76160,
  [SMALL_STATE(2460)] = 76186,
  [SMALL_STATE(2461)] = 76212,
  [SMALL_STATE(2462)] = 76230,
  [SMALL_STATE(2463)] = 76256,
  [SMALL_STATE(2464)] = 76280,
  [SMALL_STATE(2465)] = 76306,
  [SMALL_STATE(2466)] = 76324,
  [SMALL_STATE(2467)] = 76342,
  [SMALL_STATE(2468)] = 76368,
  [SMALL_STATE(2469)] = 76386,
  [SMALL_STATE(2470)] = 76410,
  [SMALL_STATE(2471)] = 76428,
  [SMALL_STATE(2472)] = 76446,
  [SMALL_STATE(2473)] = 76464,
  [SMALL_STATE(2474)] = 76490,
  [SMALL_STATE(2475)] = 76508,
  [SMALL_STATE(2476)] = 76526,
  [SMALL_STATE(2477)] = 76552,
  [SMALL_STATE(2478)] = 76578,
  [SMALL_STATE(2479)] = 76604,
  [SMALL_STATE(2480)] = 76622,
  [SMALL_STATE(2481)] = 76648,
  [SMALL_STATE(2482)] = 76674,
  [SMALL_STATE(2483)] = 76692,
  [SMALL_STATE(2484)] = 76718,
  [SMALL_STATE(2485)] = 76744,
  [SMALL_STATE(2486)] = 76770,
  [SMALL_STATE(2487)] = 76796,
  [SMALL_STATE(2488)] = 76822,
  [SMALL_STATE(2489)] = 76848,
  [SMALL_STATE(2490)] = 76872,
  [SMALL_STATE(2491)] = 76898,
  [SMALL_STATE(2492)] = 76916,
  [SMALL_STATE(2493)] = 76934,
  [SMALL_STATE(2494)] = 76960,
  [SMALL_STATE(2495)] = 76983,
  [SMALL_STATE(2496)] = 77006,
  [SMALL_STATE(2497)] = 77027,
  [SMALL_STATE(2498)] = 77050,
  [SMALL_STATE(2499)] = 77073,
  [SMALL_STATE(2500)] = 77096,
  [SMALL_STATE(2501)] = 77119,
  [SMALL_STATE(2502)] = 77142,
  [SMALL_STATE(2503)] = 77165,
  [SMALL_STATE(2504)] = 77188,
  [SMALL_STATE(2505)] = 77211,
  [SMALL_STATE(2506)] = 77234,
  [SMALL_STATE(2507)] = 77257,
  [SMALL_STATE(2508)] = 77280,
  [SMALL_STATE(2509)] = 77303,
  [SMALL_STATE(2510)] = 77326,
  [SMALL_STATE(2511)] = 77349,
  [SMALL_STATE(2512)] = 77372,
  [SMALL_STATE(2513)] = 77395,
  [SMALL_STATE(2514)] = 77418,
  [SMALL_STATE(2515)] = 77441,
  [SMALL_STATE(2516)] = 77458,
  [SMALL_STATE(2517)] = 77481,
  [SMALL_STATE(2518)] = 77504,
  [SMALL_STATE(2519)] = 77525,
  [SMALL_STATE(2520)] = 77546,
  [SMALL_STATE(2521)] = 77567,
  [SMALL_STATE(2522)] = 77590,
  [SMALL_STATE(2523)] = 77613,
  [SMALL_STATE(2524)] = 77636,
  [SMALL_STATE(2525)] = 77659,
  [SMALL_STATE(2526)] = 77678,
  [SMALL_STATE(2527)] = 77697,
  [SMALL_STATE(2528)] = 77716,
  [SMALL_STATE(2529)] = 77735,
  [SMALL_STATE(2530)] = 77756,
  [SMALL_STATE(2531)] = 77779,
  [SMALL_STATE(2532)] = 77802,
  [SMALL_STATE(2533)] = 77825,
  [SMALL_STATE(2534)] = 77848,
  [SMALL_STATE(2535)] = 77867,
  [SMALL_STATE(2536)] = 77886,
  [SMALL_STATE(2537)] = 77905,
  [SMALL_STATE(2538)] = 77924,
  [SMALL_STATE(2539)] = 77947,
  [SMALL_STATE(2540)] = 77970,
  [SMALL_STATE(2541)] = 77993,
  [SMALL_STATE(2542)] = 78016,
  [SMALL_STATE(2543)] = 78039,
  [SMALL_STATE(2544)] = 78058,
  [SMALL_STATE(2545)] = 78081,
  [SMALL_STATE(2546)] = 78104,
  [SMALL_STATE(2547)] = 78127,
  [SMALL_STATE(2548)] = 78150,
  [SMALL_STATE(2549)] = 78171,
  [SMALL_STATE(2550)] = 78194,
  [SMALL_STATE(2551)] = 78215,
  [SMALL_STATE(2552)] = 78238,
  [SMALL_STATE(2553)] = 78257,
  [SMALL_STATE(2554)] = 78280,
  [SMALL_STATE(2555)] = 78303,
  [SMALL_STATE(2556)] = 78322,
  [SMALL_STATE(2557)] = 78345,
  [SMALL_STATE(2558)] = 78368,
  [SMALL_STATE(2559)] = 78391,
  [SMALL_STATE(2560)] = 78414,
  [SMALL_STATE(2561)] = 78433,
  [SMALL_STATE(2562)] = 78452,
  [SMALL_STATE(2563)] = 78475,
  [SMALL_STATE(2564)] = 78498,
  [SMALL_STATE(2565)] = 78515,
  [SMALL_STATE(2566)] = 78534,
  [SMALL_STATE(2567)] = 78551,
  [SMALL_STATE(2568)] = 78574,
  [SMALL_STATE(2569)] = 78593,
  [SMALL_STATE(2570)] = 78616,
  [SMALL_STATE(2571)] = 78635,
  [SMALL_STATE(2572)] = 78658,
  [SMALL_STATE(2573)] = 78681,
  [SMALL_STATE(2574)] = 78704,
  [SMALL_STATE(2575)] = 78721,
  [SMALL_STATE(2576)] = 78744,
  [SMALL_STATE(2577)] = 78765,
  [SMALL_STATE(2578)] = 78782,
  [SMALL_STATE(2579)] = 78805,
  [SMALL_STATE(2580)] = 78828,
  [SMALL_STATE(2581)] = 78851,
  [SMALL_STATE(2582)] = 78874,
  [SMALL_STATE(2583)] = 78891,
  [SMALL_STATE(2584)] = 78914,
  [SMALL_STATE(2585)] = 78937,
  [SMALL_STATE(2586)] = 78958,
  [SMALL_STATE(2587)] = 78979,
  [SMALL_STATE(2588)] = 79002,
  [SMALL_STATE(2589)] = 79025,
  [SMALL_STATE(2590)] = 79048,
  [SMALL_STATE(2591)] = 79067,
  [SMALL_STATE(2592)] = 79090,
  [SMALL_STATE(2593)] = 79111,
  [SMALL_STATE(2594)] = 79134,
  [SMALL_STATE(2595)] = 79153,
  [SMALL_STATE(2596)] = 79176,
  [SMALL_STATE(2597)] = 79199,
  [SMALL_STATE(2598)] = 79218,
  [SMALL_STATE(2599)] = 79239,
  [SMALL_STATE(2600)] = 79260,
  [SMALL_STATE(2601)] = 79283,
  [SMALL_STATE(2602)] = 79306,
  [SMALL_STATE(2603)] = 79329,
  [SMALL_STATE(2604)] = 79350,
  [SMALL_STATE(2605)] = 79373,
  [SMALL_STATE(2606)] = 79396,
  [SMALL_STATE(2607)] = 79419,
  [SMALL_STATE(2608)] = 79440,
  [SMALL_STATE(2609)] = 79463,
  [SMALL_STATE(2610)] = 79486,
  [SMALL_STATE(2611)] = 79509,
  [SMALL_STATE(2612)] = 79532,
  [SMALL_STATE(2613)] = 79555,
  [SMALL_STATE(2614)] = 79578,
  [SMALL_STATE(2615)] = 79601,
  [SMALL_STATE(2616)] = 79624,
  [SMALL_STATE(2617)] = 79647,
  [SMALL_STATE(2618)] = 79670,
  [SMALL_STATE(2619)] = 79693,
  [SMALL_STATE(2620)] = 79716,
  [SMALL_STATE(2621)] = 79739,
  [SMALL_STATE(2622)] = 79762,
  [SMALL_STATE(2623)] = 79785,
  [SMALL_STATE(2624)] = 79806,
  [SMALL_STATE(2625)] = 79829,
  [SMALL_STATE(2626)] = 79852,
  [SMALL_STATE(2627)] = 79871,
  [SMALL_STATE(2628)] = 79894,
  [SMALL_STATE(2629)] = 79917,
  [SMALL_STATE(2630)] = 79938,
  [SMALL_STATE(2631)] = 79957,
  [SMALL_STATE(2632)] = 79980,
  [SMALL_STATE(2633)] = 80003,
  [SMALL_STATE(2634)] = 80026,
  [SMALL_STATE(2635)] = 80049,
  [SMALL_STATE(2636)] = 80072,
  [SMALL_STATE(2637)] = 80095,
  [SMALL_STATE(2638)] = 80118,
  [SMALL_STATE(2639)] = 80141,
  [SMALL_STATE(2640)] = 80164,
  [SMALL_STATE(2641)] = 80187,
  [SMALL_STATE(2642)] = 80210,
  [SMALL_STATE(2643)] = 80233,
  [SMALL_STATE(2644)] = 80256,
  [SMALL_STATE(2645)] = 80277,
  [SMALL_STATE(2646)] = 80300,
  [SMALL_STATE(2647)] = 80323,
  [SMALL_STATE(2648)] = 80346,
  [SMALL_STATE(2649)] = 80369,
  [SMALL_STATE(2650)] = 80392,
  [SMALL_STATE(2651)] = 80415,
  [SMALL_STATE(2652)] = 80438,
  [SMALL_STATE(2653)] = 80459,
  [SMALL_STATE(2654)] = 80480,
  [SMALL_STATE(2655)] = 80503,
  [SMALL_STATE(2656)] = 80526,
  [SMALL_STATE(2657)] = 80547,
  [SMALL_STATE(2658)] = 80568,
  [SMALL_STATE(2659)] = 80591,
  [SMALL_STATE(2660)] = 80614,
  [SMALL_STATE(2661)] = 80637,
  [SMALL_STATE(2662)] = 80660,
  [SMALL_STATE(2663)] = 80683,
  [SMALL_STATE(2664)] = 80706,
  [SMALL_STATE(2665)] = 80727,
  [SMALL_STATE(2666)] = 80748,
  [SMALL_STATE(2667)] = 80771,
  [SMALL_STATE(2668)] = 80794,
  [SMALL_STATE(2669)] = 80817,
  [SMALL_STATE(2670)] = 80840,
  [SMALL_STATE(2671)] = 80863,
  [SMALL_STATE(2672)] = 80880,
  [SMALL_STATE(2673)] = 80901,
  [SMALL_STATE(2674)] = 80924,
  [SMALL_STATE(2675)] = 80945,
  [SMALL_STATE(2676)] = 80968,
  [SMALL_STATE(2677)] = 80991,
  [SMALL_STATE(2678)] = 81014,
  [SMALL_STATE(2679)] = 81037,
  [SMALL_STATE(2680)] = 81060,
  [SMALL_STATE(2681)] = 81083,
  [SMALL_STATE(2682)] = 81106,
  [SMALL_STATE(2683)] = 81129,
  [SMALL_STATE(2684)] = 81152,
  [SMALL_STATE(2685)] = 81175,
  [SMALL_STATE(2686)] = 81194,
  [SMALL_STATE(2687)] = 81217,
  [SMALL_STATE(2688)] = 81240,
  [SMALL_STATE(2689)] = 81263,
  [SMALL_STATE(2690)] = 81282,
  [SMALL_STATE(2691)] = 81305,
  [SMALL_STATE(2692)] = 81328,
  [SMALL_STATE(2693)] = 81351,
  [SMALL_STATE(2694)] = 81374,
  [SMALL_STATE(2695)] = 81397,
  [SMALL_STATE(2696)] = 81420,
  [SMALL_STATE(2697)] = 81443,
  [SMALL_STATE(2698)] = 81466,
  [SMALL_STATE(2699)] = 81489,
  [SMALL_STATE(2700)] = 81512,
  [SMALL_STATE(2701)] = 81535,
  [SMALL_STATE(2702)] = 81558,
  [SMALL_STATE(2703)] = 81577,
  [SMALL_STATE(2704)] = 81600,
  [SMALL_STATE(2705)] = 81623,
  [SMALL_STATE(2706)] = 81646,
  [SMALL_STATE(2707)] = 81669,
  [SMALL_STATE(2708)] = 81692,
  [SMALL_STATE(2709)] = 81715,
  [SMALL_STATE(2710)] = 81738,
  [SMALL_STATE(2711)] = 81757,
  [SMALL_STATE(2712)] = 81780,
  [SMALL_STATE(2713)] = 81803,
  [SMALL_STATE(2714)] = 81826,
  [SMALL_STATE(2715)] = 81849,
  [SMALL_STATE(2716)] = 81872,
  [SMALL_STATE(2717)] = 81895,
  [SMALL_STATE(2718)] = 81918,
  [SMALL_STATE(2719)] = 81941,
  [SMALL_STATE(2720)] = 81964,
  [SMALL_STATE(2721)] = 81987,
  [SMALL_STATE(2722)] = 82008,
  [SMALL_STATE(2723)] = 82031,
  [SMALL_STATE(2724)] = 82050,
  [SMALL_STATE(2725)] = 82071,
  [SMALL_STATE(2726)] = 82094,
  [SMALL_STATE(2727)] = 82117,
  [SMALL_STATE(2728)] = 82140,
  [SMALL_STATE(2729)] = 82163,
  [SMALL_STATE(2730)] = 82180,
  [SMALL_STATE(2731)] = 82203,
  [SMALL_STATE(2732)] = 82223,
  [SMALL_STATE(2733)] = 82243,
  [SMALL_STATE(2734)] = 82263,
  [SMALL_STATE(2735)] = 82283,
  [SMALL_STATE(2736)] = 82303,
  [SMALL_STATE(2737)] = 82323,
  [SMALL_STATE(2738)] = 82343,
  [SMALL_STATE(2739)] = 82363,
  [SMALL_STATE(2740)] = 82383,
  [SMALL_STATE(2741)] = 82403,
  [SMALL_STATE(2742)] = 82423,
  [SMALL_STATE(2743)] = 82443,
  [SMALL_STATE(2744)] = 82463,
  [SMALL_STATE(2745)] = 82483,
  [SMALL_STATE(2746)] = 82503,
  [SMALL_STATE(2747)] = 82523,
  [SMALL_STATE(2748)] = 82541,
  [SMALL_STATE(2749)] = 82559,
  [SMALL_STATE(2750)] = 82577,
  [SMALL_STATE(2751)] = 82595,
  [SMALL_STATE(2752)] = 82613,
  [SMALL_STATE(2753)] = 82633,
  [SMALL_STATE(2754)] = 82653,
  [SMALL_STATE(2755)] = 82673,
  [SMALL_STATE(2756)] = 82693,
  [SMALL_STATE(2757)] = 82713,
  [SMALL_STATE(2758)] = 82731,
  [SMALL_STATE(2759)] = 82751,
  [SMALL_STATE(2760)] = 82771,
  [SMALL_STATE(2761)] = 82789,
  [SMALL_STATE(2762)] = 82807,
  [SMALL_STATE(2763)] = 82827,
  [SMALL_STATE(2764)] = 82847,
  [SMALL_STATE(2765)] = 82863,
  [SMALL_STATE(2766)] = 82883,
  [SMALL_STATE(2767)] = 82901,
  [SMALL_STATE(2768)] = 82917,
  [SMALL_STATE(2769)] = 82933,
  [SMALL_STATE(2770)] = 82953,
  [SMALL_STATE(2771)] = 82973,
  [SMALL_STATE(2772)] = 82991,
  [SMALL_STATE(2773)] = 83011,
  [SMALL_STATE(2774)] = 83031,
  [SMALL_STATE(2775)] = 83051,
  [SMALL_STATE(2776)] = 83071,
  [SMALL_STATE(2777)] = 83091,
  [SMALL_STATE(2778)] = 83109,
  [SMALL_STATE(2779)] = 83129,
  [SMALL_STATE(2780)] = 83149,
  [SMALL_STATE(2781)] = 83169,
  [SMALL_STATE(2782)] = 83187,
  [SMALL_STATE(2783)] = 83207,
  [SMALL_STATE(2784)] = 83227,
  [SMALL_STATE(2785)] = 83247,
  [SMALL_STATE(2786)] = 83265,
  [SMALL_STATE(2787)] = 83285,
  [SMALL_STATE(2788)] = 83305,
  [SMALL_STATE(2789)] = 83325,
  [SMALL_STATE(2790)] = 83343,
  [SMALL_STATE(2791)] = 83363,
  [SMALL_STATE(2792)] = 83383,
  [SMALL_STATE(2793)] = 83403,
  [SMALL_STATE(2794)] = 83423,
  [SMALL_STATE(2795)] = 83443,
  [SMALL_STATE(2796)] = 83463,
  [SMALL_STATE(2797)] = 83483,
  [SMALL_STATE(2798)] = 83503,
  [SMALL_STATE(2799)] = 83523,
  [SMALL_STATE(2800)] = 83541,
  [SMALL_STATE(2801)] = 83561,
  [SMALL_STATE(2802)] = 83579,
  [SMALL_STATE(2803)] = 83599,
  [SMALL_STATE(2804)] = 83619,
  [SMALL_STATE(2805)] = 83639,
  [SMALL_STATE(2806)] = 83659,
  [SMALL_STATE(2807)] = 83679,
  [SMALL_STATE(2808)] = 83699,
  [SMALL_STATE(2809)] = 83715,
  [SMALL_STATE(2810)] = 83735,
  [SMALL_STATE(2811)] = 83755,
  [SMALL_STATE(2812)] = 83771,
  [SMALL_STATE(2813)] = 83791,
  [SMALL_STATE(2814)] = 83811,
  [SMALL_STATE(2815)] = 83827,
  [SMALL_STATE(2816)] = 83847,
  [SMALL_STATE(2817)] = 83867,
  [SMALL_STATE(2818)] = 83885,
  [SMALL_STATE(2819)] = 83905,
  [SMALL_STATE(2820)] = 83925,
  [SMALL_STATE(2821)] = 83945,
  [SMALL_STATE(2822)] = 83963,
  [SMALL_STATE(2823)] = 83983,
  [SMALL_STATE(2824)] = 84003,
  [SMALL_STATE(2825)] = 84023,
  [SMALL_STATE(2826)] = 84043,
  [SMALL_STATE(2827)] = 84061,
  [SMALL_STATE(2828)] = 84079,
  [SMALL_STATE(2829)] = 84099,
  [SMALL_STATE(2830)] = 84117,
  [SMALL_STATE(2831)] = 84137,
  [SMALL_STATE(2832)] = 84155,
  [SMALL_STATE(2833)] = 84175,
  [SMALL_STATE(2834)] = 84195,
  [SMALL_STATE(2835)] = 84215,
  [SMALL_STATE(2836)] = 84233,
  [SMALL_STATE(2837)] = 84253,
  [SMALL_STATE(2838)] = 84273,
  [SMALL_STATE(2839)] = 84293,
  [SMALL_STATE(2840)] = 84313,
  [SMALL_STATE(2841)] = 84331,
  [SMALL_STATE(2842)] = 84347,
  [SMALL_STATE(2843)] = 84367,
  [SMALL_STATE(2844)] = 84387,
  [SMALL_STATE(2845)] = 84407,
  [SMALL_STATE(2846)] = 84427,
  [SMALL_STATE(2847)] = 84447,
  [SMALL_STATE(2848)] = 84467,
  [SMALL_STATE(2849)] = 84487,
  [SMALL_STATE(2850)] = 84505,
  [SMALL_STATE(2851)] = 84525,
  [SMALL_STATE(2852)] = 84543,
  [SMALL_STATE(2853)] = 84563,
  [SMALL_STATE(2854)] = 84581,
  [SMALL_STATE(2855)] = 84599,
  [SMALL_STATE(2856)] = 84619,
  [SMALL_STATE(2857)] = 84637,
  [SMALL_STATE(2858)] = 84657,
  [SMALL_STATE(2859)] = 84677,
  [SMALL_STATE(2860)] = 84697,
  [SMALL_STATE(2861)] = 84717,
  [SMALL_STATE(2862)] = 84737,
  [SMALL_STATE(2863)] = 84755,
  [SMALL_STATE(2864)] = 84775,
  [SMALL_STATE(2865)] = 84793,
  [SMALL_STATE(2866)] = 84813,
  [SMALL_STATE(2867)] = 84833,
  [SMALL_STATE(2868)] = 84853,
  [SMALL_STATE(2869)] = 84873,
  [SMALL_STATE(2870)] = 84893,
  [SMALL_STATE(2871)] = 84913,
  [SMALL_STATE(2872)] = 84933,
  [SMALL_STATE(2873)] = 84953,
  [SMALL_STATE(2874)] = 84973,
  [SMALL_STATE(2875)] = 84991,
  [SMALL_STATE(2876)] = 85011,
  [SMALL_STATE(2877)] = 85031,
  [SMALL_STATE(2878)] = 85051,
  [SMALL_STATE(2879)] = 85069,
  [SMALL_STATE(2880)] = 85089,
  [SMALL_STATE(2881)] = 85109,
  [SMALL_STATE(2882)] = 85129,
  [SMALL_STATE(2883)] = 85147,
  [SMALL_STATE(2884)] = 85167,
  [SMALL_STATE(2885)] = 85187,
  [SMALL_STATE(2886)] = 85205,
  [SMALL_STATE(2887)] = 85223,
  [SMALL_STATE(2888)] = 85243,
  [SMALL_STATE(2889)] = 85263,
  [SMALL_STATE(2890)] = 85283,
  [SMALL_STATE(2891)] = 85303,
  [SMALL_STATE(2892)] = 85323,
  [SMALL_STATE(2893)] = 85343,
  [SMALL_STATE(2894)] = 85363,
  [SMALL_STATE(2895)] = 85383,
  [SMALL_STATE(2896)] = 85401,
  [SMALL_STATE(2897)] = 85421,
  [SMALL_STATE(2898)] = 85441,
  [SMALL_STATE(2899)] = 85461,
  [SMALL_STATE(2900)] = 85481,
  [SMALL_STATE(2901)] = 85501,
  [SMALL_STATE(2902)] = 85521,
  [SMALL_STATE(2903)] = 85541,
  [SMALL_STATE(2904)] = 85557,
  [SMALL_STATE(2905)] = 85577,
  [SMALL_STATE(2906)] = 85595,
  [SMALL_STATE(2907)] = 85615,
  [SMALL_STATE(2908)] = 85635,
  [SMALL_STATE(2909)] = 85655,
  [SMALL_STATE(2910)] = 85673,
  [SMALL_STATE(2911)] = 85691,
  [SMALL_STATE(2912)] = 85709,
  [SMALL_STATE(2913)] = 85729,
  [SMALL_STATE(2914)] = 85749,
  [SMALL_STATE(2915)] = 85769,
  [SMALL_STATE(2916)] = 85789,
  [SMALL_STATE(2917)] = 85809,
  [SMALL_STATE(2918)] = 85829,
  [SMALL_STATE(2919)] = 85849,
  [SMALL_STATE(2920)] = 85869,
  [SMALL_STATE(2921)] = 85889,
  [SMALL_STATE(2922)] = 85909,
  [SMALL_STATE(2923)] = 85925,
  [SMALL_STATE(2924)] = 85945,
  [SMALL_STATE(2925)] = 85965,
  [SMALL_STATE(2926)] = 85985,
  [SMALL_STATE(2927)] = 86005,
  [SMALL_STATE(2928)] = 86025,
  [SMALL_STATE(2929)] = 86041,
  [SMALL_STATE(2930)] = 86061,
  [SMALL_STATE(2931)] = 86081,
  [SMALL_STATE(2932)] = 86101,
  [SMALL_STATE(2933)] = 86121,
  [SMALL_STATE(2934)] = 86139,
  [SMALL_STATE(2935)] = 86155,
  [SMALL_STATE(2936)] = 86175,
  [SMALL_STATE(2937)] = 86195,
  [SMALL_STATE(2938)] = 86215,
  [SMALL_STATE(2939)] = 86231,
  [SMALL_STATE(2940)] = 86247,
  [SMALL_STATE(2941)] = 86263,
  [SMALL_STATE(2942)] = 86279,
  [SMALL_STATE(2943)] = 86295,
  [SMALL_STATE(2944)] = 86315,
  [SMALL_STATE(2945)] = 86335,
  [SMALL_STATE(2946)] = 86355,
  [SMALL_STATE(2947)] = 86375,
  [SMALL_STATE(2948)] = 86395,
  [SMALL_STATE(2949)] = 86415,
  [SMALL_STATE(2950)] = 86431,
  [SMALL_STATE(2951)] = 86447,
  [SMALL_STATE(2952)] = 86467,
  [SMALL_STATE(2953)] = 86483,
  [SMALL_STATE(2954)] = 86499,
  [SMALL_STATE(2955)] = 86515,
  [SMALL_STATE(2956)] = 86531,
  [SMALL_STATE(2957)] = 86551,
  [SMALL_STATE(2958)] = 86571,
  [SMALL_STATE(2959)] = 86587,
  [SMALL_STATE(2960)] = 86603,
  [SMALL_STATE(2961)] = 86619,
  [SMALL_STATE(2962)] = 86635,
  [SMALL_STATE(2963)] = 86651,
  [SMALL_STATE(2964)] = 86667,
  [SMALL_STATE(2965)] = 86683,
  [SMALL_STATE(2966)] = 86703,
  [SMALL_STATE(2967)] = 86723,
  [SMALL_STATE(2968)] = 86743,
  [SMALL_STATE(2969)] = 86759,
  [SMALL_STATE(2970)] = 86775,
  [SMALL_STATE(2971)] = 86791,
  [SMALL_STATE(2972)] = 86809,
  [SMALL_STATE(2973)] = 86825,
  [SMALL_STATE(2974)] = 86841,
  [SMALL_STATE(2975)] = 86861,
  [SMALL_STATE(2976)] = 86881,
  [SMALL_STATE(2977)] = 86897,
  [SMALL_STATE(2978)] = 86917,
  [SMALL_STATE(2979)] = 86933,
  [SMALL_STATE(2980)] = 86949,
  [SMALL_STATE(2981)] = 86969,
  [SMALL_STATE(2982)] = 86989,
  [SMALL_STATE(2983)] = 87009,
  [SMALL_STATE(2984)] = 87025,
  [SMALL_STATE(2985)] = 87041,
  [SMALL_STATE(2986)] = 87057,
  [SMALL_STATE(2987)] = 87077,
  [SMALL_STATE(2988)] = 87097,
  [SMALL_STATE(2989)] = 87117,
  [SMALL_STATE(2990)] = 87133,
  [SMALL_STATE(2991)] = 87149,
  [SMALL_STATE(2992)] = 87169,
  [SMALL_STATE(2993)] = 87185,
  [SMALL_STATE(2994)] = 87201,
  [SMALL_STATE(2995)] = 87221,
  [SMALL_STATE(2996)] = 87237,
  [SMALL_STATE(2997)] = 87257,
  [SMALL_STATE(2998)] = 87277,
  [SMALL_STATE(2999)] = 87297,
  [SMALL_STATE(3000)] = 87317,
  [SMALL_STATE(3001)] = 87333,
  [SMALL_STATE(3002)] = 87349,
  [SMALL_STATE(3003)] = 87369,
  [SMALL_STATE(3004)] = 87385,
  [SMALL_STATE(3005)] = 87401,
  [SMALL_STATE(3006)] = 87417,
  [SMALL_STATE(3007)] = 87433,
  [SMALL_STATE(3008)] = 87453,
  [SMALL_STATE(3009)] = 87469,
  [SMALL_STATE(3010)] = 87489,
  [SMALL_STATE(3011)] = 87505,
  [SMALL_STATE(3012)] = 87521,
  [SMALL_STATE(3013)] = 87541,
  [SMALL_STATE(3014)] = 87561,
  [SMALL_STATE(3015)] = 87581,
  [SMALL_STATE(3016)] = 87601,
  [SMALL_STATE(3017)] = 87621,
  [SMALL_STATE(3018)] = 87641,
  [SMALL_STATE(3019)] = 87657,
  [SMALL_STATE(3020)] = 87677,
  [SMALL_STATE(3021)] = 87697,
  [SMALL_STATE(3022)] = 87717,
  [SMALL_STATE(3023)] = 87737,
  [SMALL_STATE(3024)] = 87757,
  [SMALL_STATE(3025)] = 87777,
  [SMALL_STATE(3026)] = 87797,
  [SMALL_STATE(3027)] = 87813,
  [SMALL_STATE(3028)] = 87829,
  [SMALL_STATE(3029)] = 87849,
  [SMALL_STATE(3030)] = 87869,
  [SMALL_STATE(3031)] = 87889,
  [SMALL_STATE(3032)] = 87909,
  [SMALL_STATE(3033)] = 87927,
  [SMALL_STATE(3034)] = 87944,
  [SMALL_STATE(3035)] = 87961,
  [SMALL_STATE(3036)] = 87978,
  [SMALL_STATE(3037)] = 87995,
  [SMALL_STATE(3038)] = 88012,
  [SMALL_STATE(3039)] = 88029,
  [SMALL_STATE(3040)] = 88046,
  [SMALL_STATE(3041)] = 88063,
  [SMALL_STATE(3042)] = 88080,
  [SMALL_STATE(3043)] = 88095,
  [SMALL_STATE(3044)] = 88112,
  [SMALL_STATE(3045)] = 88129,
  [SMALL_STATE(3046)] = 88146,
  [SMALL_STATE(3047)] = 88163,
  [SMALL_STATE(3048)] = 88180,
  [SMALL_STATE(3049)] = 88197,
  [SMALL_STATE(3050)] = 88214,
  [SMALL_STATE(3051)] = 88231,
  [SMALL_STATE(3052)] = 88248,
  [SMALL_STATE(3053)] = 88265,
  [SMALL_STATE(3054)] = 88282,
  [SMALL_STATE(3055)] = 88299,
  [SMALL_STATE(3056)] = 88316,
  [SMALL_STATE(3057)] = 88333,
  [SMALL_STATE(3058)] = 88350,
  [SMALL_STATE(3059)] = 88367,
  [SMALL_STATE(3060)] = 88384,
  [SMALL_STATE(3061)] = 88401,
  [SMALL_STATE(3062)] = 88416,
  [SMALL_STATE(3063)] = 88433,
  [SMALL_STATE(3064)] = 88450,
  [SMALL_STATE(3065)] = 88467,
  [SMALL_STATE(3066)] = 88484,
  [SMALL_STATE(3067)] = 88501,
  [SMALL_STATE(3068)] = 88518,
  [SMALL_STATE(3069)] = 88533,
  [SMALL_STATE(3070)] = 88550,
  [SMALL_STATE(3071)] = 88567,
  [SMALL_STATE(3072)] = 88584,
  [SMALL_STATE(3073)] = 88599,
  [SMALL_STATE(3074)] = 88616,
  [SMALL_STATE(3075)] = 88633,
  [SMALL_STATE(3076)] = 88650,
  [SMALL_STATE(3077)] = 88667,
  [SMALL_STATE(3078)] = 88684,
  [SMALL_STATE(3079)] = 88701,
  [SMALL_STATE(3080)] = 88718,
  [SMALL_STATE(3081)] = 88735,
  [SMALL_STATE(3082)] = 88750,
  [SMALL_STATE(3083)] = 88765,
  [SMALL_STATE(3084)] = 88782,
  [SMALL_STATE(3085)] = 88799,
  [SMALL_STATE(3086)] = 88814,
  [SMALL_STATE(3087)] = 88831,
  [SMALL_STATE(3088)] = 88848,
  [SMALL_STATE(3089)] = 88865,
  [SMALL_STATE(3090)] = 88882,
  [SMALL_STATE(3091)] = 88899,
  [SMALL_STATE(3092)] = 88914,
  [SMALL_STATE(3093)] = 88931,
  [SMALL_STATE(3094)] = 88948,
  [SMALL_STATE(3095)] = 88965,
  [SMALL_STATE(3096)] = 88980,
  [SMALL_STATE(3097)] = 88997,
  [SMALL_STATE(3098)] = 89012,
  [SMALL_STATE(3099)] = 89029,
  [SMALL_STATE(3100)] = 89046,
  [SMALL_STATE(3101)] = 89063,
  [SMALL_STATE(3102)] = 89080,
  [SMALL_STATE(3103)] = 89095,
  [SMALL_STATE(3104)] = 89112,
  [SMALL_STATE(3105)] = 89129,
  [SMALL_STATE(3106)] = 89146,
  [SMALL_STATE(3107)] = 89161,
  [SMALL_STATE(3108)] = 89178,
  [SMALL_STATE(3109)] = 89193,
  [SMALL_STATE(3110)] = 89210,
  [SMALL_STATE(3111)] = 89227,
  [SMALL_STATE(3112)] = 89244,
  [SMALL_STATE(3113)] = 89261,
  [SMALL_STATE(3114)] = 89278,
  [SMALL_STATE(3115)] = 89295,
  [SMALL_STATE(3116)] = 89312,
  [SMALL_STATE(3117)] = 89327,
  [SMALL_STATE(3118)] = 89342,
  [SMALL_STATE(3119)] = 89357,
  [SMALL_STATE(3120)] = 89374,
  [SMALL_STATE(3121)] = 89389,
  [SMALL_STATE(3122)] = 89406,
  [SMALL_STATE(3123)] = 89423,
  [SMALL_STATE(3124)] = 89438,
  [SMALL_STATE(3125)] = 89455,
  [SMALL_STATE(3126)] = 89472,
  [SMALL_STATE(3127)] = 89489,
  [SMALL_STATE(3128)] = 89506,
  [SMALL_STATE(3129)] = 89521,
  [SMALL_STATE(3130)] = 89538,
  [SMALL_STATE(3131)] = 89555,
  [SMALL_STATE(3132)] = 89572,
  [SMALL_STATE(3133)] = 89589,
  [SMALL_STATE(3134)] = 89606,
  [SMALL_STATE(3135)] = 89623,
  [SMALL_STATE(3136)] = 89638,
  [SMALL_STATE(3137)] = 89655,
  [SMALL_STATE(3138)] = 89672,
  [SMALL_STATE(3139)] = 89689,
  [SMALL_STATE(3140)] = 89706,
  [SMALL_STATE(3141)] = 89723,
  [SMALL_STATE(3142)] = 89740,
  [SMALL_STATE(3143)] = 89757,
  [SMALL_STATE(3144)] = 89772,
  [SMALL_STATE(3145)] = 89789,
  [SMALL_STATE(3146)] = 89804,
  [SMALL_STATE(3147)] = 89821,
  [SMALL_STATE(3148)] = 89838,
  [SMALL_STATE(3149)] = 89855,
  [SMALL_STATE(3150)] = 89872,
  [SMALL_STATE(3151)] = 89887,
  [SMALL_STATE(3152)] = 89904,
  [SMALL_STATE(3153)] = 89921,
  [SMALL_STATE(3154)] = 89936,
  [SMALL_STATE(3155)] = 89953,
  [SMALL_STATE(3156)] = 89968,
  [SMALL_STATE(3157)] = 89985,
  [SMALL_STATE(3158)] = 90002,
  [SMALL_STATE(3159)] = 90017,
  [SMALL_STATE(3160)] = 90034,
  [SMALL_STATE(3161)] = 90049,
  [SMALL_STATE(3162)] = 90066,
  [SMALL_STATE(3163)] = 90081,
  [SMALL_STATE(3164)] = 90098,
  [SMALL_STATE(3165)] = 90113,
  [SMALL_STATE(3166)] = 90130,
  [SMALL_STATE(3167)] = 90147,
  [SMALL_STATE(3168)] = 90162,
  [SMALL_STATE(3169)] = 90179,
  [SMALL_STATE(3170)] = 90196,
  [SMALL_STATE(3171)] = 90213,
  [SMALL_STATE(3172)] = 90228,
  [SMALL_STATE(3173)] = 90245,
  [SMALL_STATE(3174)] = 90262,
  [SMALL_STATE(3175)] = 90279,
  [SMALL_STATE(3176)] = 90296,
  [SMALL_STATE(3177)] = 90313,
  [SMALL_STATE(3178)] = 90330,
  [SMALL_STATE(3179)] = 90347,
  [SMALL_STATE(3180)] = 90364,
  [SMALL_STATE(3181)] = 90381,
  [SMALL_STATE(3182)] = 90398,
  [SMALL_STATE(3183)] = 90413,
  [SMALL_STATE(3184)] = 90430,
  [SMALL_STATE(3185)] = 90447,
  [SMALL_STATE(3186)] = 90464,
  [SMALL_STATE(3187)] = 90481,
  [SMALL_STATE(3188)] = 90498,
  [SMALL_STATE(3189)] = 90513,
  [SMALL_STATE(3190)] = 90530,
  [SMALL_STATE(3191)] = 90547,
  [SMALL_STATE(3192)] = 90564,
  [SMALL_STATE(3193)] = 90581,
  [SMALL_STATE(3194)] = 90598,
  [SMALL_STATE(3195)] = 90615,
  [SMALL_STATE(3196)] = 90632,
  [SMALL_STATE(3197)] = 90649,
  [SMALL_STATE(3198)] = 90666,
  [SMALL_STATE(3199)] = 90683,
  [SMALL_STATE(3200)] = 90700,
  [SMALL_STATE(3201)] = 90715,
  [SMALL_STATE(3202)] = 90732,
  [SMALL_STATE(3203)] = 90749,
  [SMALL_STATE(3204)] = 90766,
  [SMALL_STATE(3205)] = 90783,
  [SMALL_STATE(3206)] = 90800,
  [SMALL_STATE(3207)] = 90817,
  [SMALL_STATE(3208)] = 90832,
  [SMALL_STATE(3209)] = 90849,
  [SMALL_STATE(3210)] = 90866,
  [SMALL_STATE(3211)] = 90883,
  [SMALL_STATE(3212)] = 90900,
  [SMALL_STATE(3213)] = 90917,
  [SMALL_STATE(3214)] = 90932,
  [SMALL_STATE(3215)] = 90949,
  [SMALL_STATE(3216)] = 90966,
  [SMALL_STATE(3217)] = 90983,
  [SMALL_STATE(3218)] = 90998,
  [SMALL_STATE(3219)] = 91015,
  [SMALL_STATE(3220)] = 91032,
  [SMALL_STATE(3221)] = 91049,
  [SMALL_STATE(3222)] = 91066,
  [SMALL_STATE(3223)] = 91083,
  [SMALL_STATE(3224)] = 91100,
  [SMALL_STATE(3225)] = 91117,
  [SMALL_STATE(3226)] = 91134,
  [SMALL_STATE(3227)] = 91151,
  [SMALL_STATE(3228)] = 91168,
  [SMALL_STATE(3229)] = 91185,
  [SMALL_STATE(3230)] = 91202,
  [SMALL_STATE(3231)] = 91217,
  [SMALL_STATE(3232)] = 91234,
  [SMALL_STATE(3233)] = 91251,
  [SMALL_STATE(3234)] = 91268,
  [SMALL_STATE(3235)] = 91285,
  [SMALL_STATE(3236)] = 91300,
  [SMALL_STATE(3237)] = 91317,
  [SMALL_STATE(3238)] = 91332,
  [SMALL_STATE(3239)] = 91349,
  [SMALL_STATE(3240)] = 91366,
  [SMALL_STATE(3241)] = 91383,
  [SMALL_STATE(3242)] = 91400,
  [SMALL_STATE(3243)] = 91415,
  [SMALL_STATE(3244)] = 91432,
  [SMALL_STATE(3245)] = 91449,
  [SMALL_STATE(3246)] = 91466,
  [SMALL_STATE(3247)] = 91483,
  [SMALL_STATE(3248)] = 91500,
  [SMALL_STATE(3249)] = 91517,
  [SMALL_STATE(3250)] = 91532,
  [SMALL_STATE(3251)] = 91549,
  [SMALL_STATE(3252)] = 91566,
  [SMALL_STATE(3253)] = 91583,
  [SMALL_STATE(3254)] = 91600,
  [SMALL_STATE(3255)] = 91617,
  [SMALL_STATE(3256)] = 91634,
  [SMALL_STATE(3257)] = 91651,
  [SMALL_STATE(3258)] = 91666,
  [SMALL_STATE(3259)] = 91683,
  [SMALL_STATE(3260)] = 91700,
  [SMALL_STATE(3261)] = 91715,
  [SMALL_STATE(3262)] = 91730,
  [SMALL_STATE(3263)] = 91747,
  [SMALL_STATE(3264)] = 91764,
  [SMALL_STATE(3265)] = 91779,
  [SMALL_STATE(3266)] = 91796,
  [SMALL_STATE(3267)] = 91813,
  [SMALL_STATE(3268)] = 91830,
  [SMALL_STATE(3269)] = 91845,
  [SMALL_STATE(3270)] = 91862,
  [SMALL_STATE(3271)] = 91879,
  [SMALL_STATE(3272)] = 91896,
  [SMALL_STATE(3273)] = 91911,
  [SMALL_STATE(3274)] = 91928,
  [SMALL_STATE(3275)] = 91945,
  [SMALL_STATE(3276)] = 91962,
  [SMALL_STATE(3277)] = 91979,
  [SMALL_STATE(3278)] = 91994,
  [SMALL_STATE(3279)] = 92011,
  [SMALL_STATE(3280)] = 92028,
  [SMALL_STATE(3281)] = 92045,
  [SMALL_STATE(3282)] = 92062,
  [SMALL_STATE(3283)] = 92079,
  [SMALL_STATE(3284)] = 92096,
  [SMALL_STATE(3285)] = 92113,
  [SMALL_STATE(3286)] = 92130,
  [SMALL_STATE(3287)] = 92147,
  [SMALL_STATE(3288)] = 92164,
  [SMALL_STATE(3289)] = 92181,
  [SMALL_STATE(3290)] = 92198,
  [SMALL_STATE(3291)] = 92215,
  [SMALL_STATE(3292)] = 92232,
  [SMALL_STATE(3293)] = 92249,
  [SMALL_STATE(3294)] = 92266,
  [SMALL_STATE(3295)] = 92283,
  [SMALL_STATE(3296)] = 92300,
  [SMALL_STATE(3297)] = 92317,
  [SMALL_STATE(3298)] = 92334,
  [SMALL_STATE(3299)] = 92351,
  [SMALL_STATE(3300)] = 92368,
  [SMALL_STATE(3301)] = 92385,
  [SMALL_STATE(3302)] = 92402,
  [SMALL_STATE(3303)] = 92419,
  [SMALL_STATE(3304)] = 92436,
  [SMALL_STATE(3305)] = 92453,
  [SMALL_STATE(3306)] = 92470,
  [SMALL_STATE(3307)] = 92487,
  [SMALL_STATE(3308)] = 92502,
  [SMALL_STATE(3309)] = 92519,
  [SMALL_STATE(3310)] = 92536,
  [SMALL_STATE(3311)] = 92553,
  [SMALL_STATE(3312)] = 92570,
  [SMALL_STATE(3313)] = 92584,
  [SMALL_STATE(3314)] = 92598,
  [SMALL_STATE(3315)] = 92612,
  [SMALL_STATE(3316)] = 92626,
  [SMALL_STATE(3317)] = 92640,
  [SMALL_STATE(3318)] = 92654,
  [SMALL_STATE(3319)] = 92668,
  [SMALL_STATE(3320)] = 92682,
  [SMALL_STATE(3321)] = 92696,
  [SMALL_STATE(3322)] = 92710,
  [SMALL_STATE(3323)] = 92724,
  [SMALL_STATE(3324)] = 92738,
  [SMALL_STATE(3325)] = 92752,
  [SMALL_STATE(3326)] = 92766,
  [SMALL_STATE(3327)] = 92780,
  [SMALL_STATE(3328)] = 92794,
  [SMALL_STATE(3329)] = 92808,
  [SMALL_STATE(3330)] = 92822,
  [SMALL_STATE(3331)] = 92836,
  [SMALL_STATE(3332)] = 92850,
  [SMALL_STATE(3333)] = 92864,
  [SMALL_STATE(3334)] = 92878,
  [SMALL_STATE(3335)] = 92892,
  [SMALL_STATE(3336)] = 92906,
  [SMALL_STATE(3337)] = 92920,
  [SMALL_STATE(3338)] = 92934,
  [SMALL_STATE(3339)] = 92948,
  [SMALL_STATE(3340)] = 92962,
  [SMALL_STATE(3341)] = 92976,
  [SMALL_STATE(3342)] = 92990,
  [SMALL_STATE(3343)] = 93004,
  [SMALL_STATE(3344)] = 93018,
  [SMALL_STATE(3345)] = 93032,
  [SMALL_STATE(3346)] = 93046,
  [SMALL_STATE(3347)] = 93060,
  [SMALL_STATE(3348)] = 93074,
  [SMALL_STATE(3349)] = 93088,
  [SMALL_STATE(3350)] = 93102,
  [SMALL_STATE(3351)] = 93116,
  [SMALL_STATE(3352)] = 93130,
  [SMALL_STATE(3353)] = 93144,
  [SMALL_STATE(3354)] = 93158,
  [SMALL_STATE(3355)] = 93172,
  [SMALL_STATE(3356)] = 93186,
  [SMALL_STATE(3357)] = 93200,
  [SMALL_STATE(3358)] = 93214,
  [SMALL_STATE(3359)] = 93228,
  [SMALL_STATE(3360)] = 93242,
  [SMALL_STATE(3361)] = 93256,
  [SMALL_STATE(3362)] = 93270,
  [SMALL_STATE(3363)] = 93284,
  [SMALL_STATE(3364)] = 93298,
  [SMALL_STATE(3365)] = 93312,
  [SMALL_STATE(3366)] = 93326,
  [SMALL_STATE(3367)] = 93340,
  [SMALL_STATE(3368)] = 93354,
  [SMALL_STATE(3369)] = 93368,
  [SMALL_STATE(3370)] = 93382,
  [SMALL_STATE(3371)] = 93396,
  [SMALL_STATE(3372)] = 93410,
  [SMALL_STATE(3373)] = 93424,
  [SMALL_STATE(3374)] = 93438,
  [SMALL_STATE(3375)] = 93452,
  [SMALL_STATE(3376)] = 93466,
  [SMALL_STATE(3377)] = 93480,
  [SMALL_STATE(3378)] = 93494,
  [SMALL_STATE(3379)] = 93508,
  [SMALL_STATE(3380)] = 93522,
  [SMALL_STATE(3381)] = 93536,
  [SMALL_STATE(3382)] = 93550,
  [SMALL_STATE(3383)] = 93564,
  [SMALL_STATE(3384)] = 93578,
  [SMALL_STATE(3385)] = 93592,
  [SMALL_STATE(3386)] = 93606,
  [SMALL_STATE(3387)] = 93620,
  [SMALL_STATE(3388)] = 93634,
  [SMALL_STATE(3389)] = 93648,
  [SMALL_STATE(3390)] = 93662,
  [SMALL_STATE(3391)] = 93676,
  [SMALL_STATE(3392)] = 93690,
  [SMALL_STATE(3393)] = 93704,
  [SMALL_STATE(3394)] = 93718,
  [SMALL_STATE(3395)] = 93732,
  [SMALL_STATE(3396)] = 93746,
  [SMALL_STATE(3397)] = 93760,
  [SMALL_STATE(3398)] = 93774,
  [SMALL_STATE(3399)] = 93788,
  [SMALL_STATE(3400)] = 93802,
  [SMALL_STATE(3401)] = 93816,
  [SMALL_STATE(3402)] = 93830,
  [SMALL_STATE(3403)] = 93844,
  [SMALL_STATE(3404)] = 93858,
  [SMALL_STATE(3405)] = 93872,
  [SMALL_STATE(3406)] = 93886,
  [SMALL_STATE(3407)] = 93900,
  [SMALL_STATE(3408)] = 93914,
  [SMALL_STATE(3409)] = 93928,
  [SMALL_STATE(3410)] = 93942,
  [SMALL_STATE(3411)] = 93956,
  [SMALL_STATE(3412)] = 93970,
  [SMALL_STATE(3413)] = 93984,
  [SMALL_STATE(3414)] = 93998,
  [SMALL_STATE(3415)] = 94012,
  [SMALL_STATE(3416)] = 94026,
  [SMALL_STATE(3417)] = 94040,
  [SMALL_STATE(3418)] = 94054,
  [SMALL_STATE(3419)] = 94068,
  [SMALL_STATE(3420)] = 94082,
  [SMALL_STATE(3421)] = 94096,
  [SMALL_STATE(3422)] = 94110,
  [SMALL_STATE(3423)] = 94124,
  [SMALL_STATE(3424)] = 94138,
  [SMALL_STATE(3425)] = 94152,
  [SMALL_STATE(3426)] = 94166,
  [SMALL_STATE(3427)] = 94180,
  [SMALL_STATE(3428)] = 94194,
  [SMALL_STATE(3429)] = 94208,
  [SMALL_STATE(3430)] = 94222,
  [SMALL_STATE(3431)] = 94236,
  [SMALL_STATE(3432)] = 94250,
  [SMALL_STATE(3433)] = 94264,
  [SMALL_STATE(3434)] = 94278,
  [SMALL_STATE(3435)] = 94292,
  [SMALL_STATE(3436)] = 94306,
  [SMALL_STATE(3437)] = 94320,
  [SMALL_STATE(3438)] = 94334,
  [SMALL_STATE(3439)] = 94348,
  [SMALL_STATE(3440)] = 94362,
  [SMALL_STATE(3441)] = 94376,
  [SMALL_STATE(3442)] = 94390,
  [SMALL_STATE(3443)] = 94404,
  [SMALL_STATE(3444)] = 94418,
  [SMALL_STATE(3445)] = 94432,
  [SMALL_STATE(3446)] = 94446,
  [SMALL_STATE(3447)] = 94460,
  [SMALL_STATE(3448)] = 94474,
  [SMALL_STATE(3449)] = 94488,
  [SMALL_STATE(3450)] = 94502,
  [SMALL_STATE(3451)] = 94516,
  [SMALL_STATE(3452)] = 94530,
  [SMALL_STATE(3453)] = 94544,
  [SMALL_STATE(3454)] = 94558,
  [SMALL_STATE(3455)] = 94572,
  [SMALL_STATE(3456)] = 94586,
  [SMALL_STATE(3457)] = 94600,
  [SMALL_STATE(3458)] = 94614,
  [SMALL_STATE(3459)] = 94628,
  [SMALL_STATE(3460)] = 94642,
  [SMALL_STATE(3461)] = 94656,
  [SMALL_STATE(3462)] = 94670,
  [SMALL_STATE(3463)] = 94684,
  [SMALL_STATE(3464)] = 94698,
  [SMALL_STATE(3465)] = 94712,
  [SMALL_STATE(3466)] = 94726,
  [SMALL_STATE(3467)] = 94740,
  [SMALL_STATE(3468)] = 94754,
  [SMALL_STATE(3469)] = 94768,
  [SMALL_STATE(3470)] = 94782,
  [SMALL_STATE(3471)] = 94796,
  [SMALL_STATE(3472)] = 94810,
  [SMALL_STATE(3473)] = 94824,
  [SMALL_STATE(3474)] = 94838,
  [SMALL_STATE(3475)] = 94852,
  [SMALL_STATE(3476)] = 94866,
  [SMALL_STATE(3477)] = 94880,
  [SMALL_STATE(3478)] = 94894,
  [SMALL_STATE(3479)] = 94908,
  [SMALL_STATE(3480)] = 94922,
  [SMALL_STATE(3481)] = 94936,
  [SMALL_STATE(3482)] = 94950,
  [SMALL_STATE(3483)] = 94964,
  [SMALL_STATE(3484)] = 94978,
  [SMALL_STATE(3485)] = 94992,
  [SMALL_STATE(3486)] = 95006,
  [SMALL_STATE(3487)] = 95020,
  [SMALL_STATE(3488)] = 95034,
  [SMALL_STATE(3489)] = 95048,
  [SMALL_STATE(3490)] = 95062,
  [SMALL_STATE(3491)] = 95076,
  [SMALL_STATE(3492)] = 95090,
  [SMALL_STATE(3493)] = 95104,
  [SMALL_STATE(3494)] = 95118,
  [SMALL_STATE(3495)] = 95132,
  [SMALL_STATE(3496)] = 95146,
  [SMALL_STATE(3497)] = 95160,
  [SMALL_STATE(3498)] = 95174,
  [SMALL_STATE(3499)] = 95188,
  [SMALL_STATE(3500)] = 95202,
  [SMALL_STATE(3501)] = 95216,
  [SMALL_STATE(3502)] = 95230,
  [SMALL_STATE(3503)] = 95244,
  [SMALL_STATE(3504)] = 95258,
  [SMALL_STATE(3505)] = 95272,
  [SMALL_STATE(3506)] = 95286,
  [SMALL_STATE(3507)] = 95300,
  [SMALL_STATE(3508)] = 95314,
  [SMALL_STATE(3509)] = 95328,
  [SMALL_STATE(3510)] = 95342,
  [SMALL_STATE(3511)] = 95356,
  [SMALL_STATE(3512)] = 95370,
  [SMALL_STATE(3513)] = 95384,
  [SMALL_STATE(3514)] = 95398,
  [SMALL_STATE(3515)] = 95412,
  [SMALL_STATE(3516)] = 95426,
  [SMALL_STATE(3517)] = 95440,
  [SMALL_STATE(3518)] = 95454,
  [SMALL_STATE(3519)] = 95468,
  [SMALL_STATE(3520)] = 95482,
  [SMALL_STATE(3521)] = 95496,
  [SMALL_STATE(3522)] = 95510,
  [SMALL_STATE(3523)] = 95524,
  [SMALL_STATE(3524)] = 95538,
  [SMALL_STATE(3525)] = 95552,
  [SMALL_STATE(3526)] = 95566,
  [SMALL_STATE(3527)] = 95580,
  [SMALL_STATE(3528)] = 95594,
  [SMALL_STATE(3529)] = 95608,
  [SMALL_STATE(3530)] = 95622,
  [SMALL_STATE(3531)] = 95636,
  [SMALL_STATE(3532)] = 95650,
  [SMALL_STATE(3533)] = 95664,
  [SMALL_STATE(3534)] = 95678,
  [SMALL_STATE(3535)] = 95692,
  [SMALL_STATE(3536)] = 95706,
  [SMALL_STATE(3537)] = 95720,
  [SMALL_STATE(3538)] = 95734,
  [SMALL_STATE(3539)] = 95748,
  [SMALL_STATE(3540)] = 95762,
  [SMALL_STATE(3541)] = 95776,
  [SMALL_STATE(3542)] = 95790,
  [SMALL_STATE(3543)] = 95804,
  [SMALL_STATE(3544)] = 95818,
  [SMALL_STATE(3545)] = 95832,
  [SMALL_STATE(3546)] = 95846,
  [SMALL_STATE(3547)] = 95860,
  [SMALL_STATE(3548)] = 95874,
  [SMALL_STATE(3549)] = 95888,
  [SMALL_STATE(3550)] = 95902,
  [SMALL_STATE(3551)] = 95916,
  [SMALL_STATE(3552)] = 95930,
  [SMALL_STATE(3553)] = 95944,
  [SMALL_STATE(3554)] = 95958,
  [SMALL_STATE(3555)] = 95972,
  [SMALL_STATE(3556)] = 95986,
  [SMALL_STATE(3557)] = 96000,
  [SMALL_STATE(3558)] = 96014,
  [SMALL_STATE(3559)] = 96028,
  [SMALL_STATE(3560)] = 96042,
  [SMALL_STATE(3561)] = 96056,
  [SMALL_STATE(3562)] = 96070,
  [SMALL_STATE(3563)] = 96084,
  [SMALL_STATE(3564)] = 96098,
  [SMALL_STATE(3565)] = 96112,
  [SMALL_STATE(3566)] = 96126,
  [SMALL_STATE(3567)] = 96140,
  [SMALL_STATE(3568)] = 96154,
  [SMALL_STATE(3569)] = 96168,
  [SMALL_STATE(3570)] = 96182,
  [SMALL_STATE(3571)] = 96196,
  [SMALL_STATE(3572)] = 96210,
  [SMALL_STATE(3573)] = 96224,
  [SMALL_STATE(3574)] = 96238,
  [SMALL_STATE(3575)] = 96252,
  [SMALL_STATE(3576)] = 96266,
  [SMALL_STATE(3577)] = 96280,
  [SMALL_STATE(3578)] = 96294,
  [SMALL_STATE(3579)] = 96308,
  [SMALL_STATE(3580)] = 96322,
  [SMALL_STATE(3581)] = 96336,
  [SMALL_STATE(3582)] = 96350,
  [SMALL_STATE(3583)] = 96364,
  [SMALL_STATE(3584)] = 96378,
  [SMALL_STATE(3585)] = 96392,
  [SMALL_STATE(3586)] = 96406,
  [SMALL_STATE(3587)] = 96420,
  [SMALL_STATE(3588)] = 96434,
  [SMALL_STATE(3589)] = 96448,
  [SMALL_STATE(3590)] = 96462,
  [SMALL_STATE(3591)] = 96476,
  [SMALL_STATE(3592)] = 96490,
  [SMALL_STATE(3593)] = 96504,
  [SMALL_STATE(3594)] = 96518,
  [SMALL_STATE(3595)] = 96532,
  [SMALL_STATE(3596)] = 96546,
  [SMALL_STATE(3597)] = 96560,
  [SMALL_STATE(3598)] = 96574,
  [SMALL_STATE(3599)] = 96588,
  [SMALL_STATE(3600)] = 96602,
  [SMALL_STATE(3601)] = 96616,
  [SMALL_STATE(3602)] = 96630,
  [SMALL_STATE(3603)] = 96644,
  [SMALL_STATE(3604)] = 96658,
  [SMALL_STATE(3605)] = 96672,
  [SMALL_STATE(3606)] = 96686,
  [SMALL_STATE(3607)] = 96700,
  [SMALL_STATE(3608)] = 96714,
  [SMALL_STATE(3609)] = 96728,
  [SMALL_STATE(3610)] = 96742,
  [SMALL_STATE(3611)] = 96756,
  [SMALL_STATE(3612)] = 96770,
  [SMALL_STATE(3613)] = 96784,
  [SMALL_STATE(3614)] = 96788,
  [SMALL_STATE(3615)] = 96792,
  [SMALL_STATE(3616)] = 96796,
  [SMALL_STATE(3617)] = 96800,
  [SMALL_STATE(3618)] = 96804,
  [SMALL_STATE(3619)] = 96808,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2493),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3402),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3517),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3609),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3605),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3600),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3566),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1488),
  [126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(496),
  [129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3032),
  [132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(175),
  [135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(143),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(10),
  [141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(261),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1481),
  [149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(246),
  [152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(785),
  [155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3037),
  [164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3038),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3402),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2054),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(38),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2066),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1067),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1037),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3517),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3042),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(822),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(203),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(836),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(814),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2497),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(303),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3609),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1946),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2293),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3605),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3602),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3600),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1514),
  [233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2028),
  [236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1877),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(174),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2063),
  [245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(41),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3064),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2517),
  [254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1102),
  [257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2520),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1337),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1473),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3566),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1975),
  [272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1473),
  [275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3492),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 2, 0, 0),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 2, 0, 0),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 1, 0, 0),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 1, 0, 0),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 1, 0, 0),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 1, 0, 0),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 1, 0, 0),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 2, 0, 0),
  [392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 2, 0, 0),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2485),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3591),
  [466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(141),
  [517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(167),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(79),
  [523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0),
  [525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(82),
  [528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(80),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(167),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3500),
  [537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(151),
  [540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2629),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(145),
  [546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(148),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3521),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3500),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(207),
  [587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(206),
  [590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(125),
  [593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0),
  [595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(106),
  [598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(206),
  [604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(207),
  [607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(200),
  [610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(2496),
  [613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(194),
  [616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(3467),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(165),
  [624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(167),
  [627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(128),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0),
  [632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(127),
  [635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(122),
  [638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(167),
  [641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(3503),
  [644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(151),
  [647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(2629),
  [650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(145),
  [653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(165),
  [656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(3521),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3503),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__token_pattern, 1, 0, 0),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__token_pattern, 1, 0, 0),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0),
  [737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0), SHIFT_REPEAT(167),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0),
  [742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0), SHIFT_REPEAT(167),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 1, 0, 0),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 1, 0, 0),
  [749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1034),
  [752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(175),
  [755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(143),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0),
  [760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3),
  [763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(261),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1481),
  [769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(246),
  [772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(785),
  [775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(850),
  [778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(39),
  [781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3037),
  [784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3504),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3402),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2473),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(38),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2593),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1067),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1404),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(800),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(184),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2600),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(298),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(36),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2848),
  [823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2596),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(201),
  [829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(41),
  [832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3064),
  [835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2602),
  [838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1102),
  [841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2520),
  [844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1337),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1473),
  [850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3566),
  [853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1473),
  [856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3492),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_binding_pattern, 3, 0, 197),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_binding_pattern, 3, 0, 197),
  [863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree, 3, 0, 0),
  [865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree, 3, 0, 0),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 6, 0, 0),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 6, 0, 0),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 5, 0, 0),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 5, 0, 0),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree, 2, 0, 0),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree, 2, 0, 0),
  [903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 4, 0, 0),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 4, 0, 0),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 1, 0, 0),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 1, 0, 0),
  [915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__non_delim_token, 1, 0, 0),
  [917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__non_delim_token, 1, 0, 0),
  [919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0), SHIFT_REPEAT(206),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0), SHIFT_REPEAT(206),
  [925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 6, 0, 0),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 6, 0, 0),
  [929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 4, 0, 0),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 4, 0, 0),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree_pattern, 3, 0, 0),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree_pattern, 3, 0, 0),
  [945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 5, 0, 0),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 5, 0, 0),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree_pattern, 2, 0, 0),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree_pattern, 2, 0, 0),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 1, 0, 0),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 1, 0, 0),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fragment_specifier, 1, 0, 0),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fragment_specifier, 1, 0, 0),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delim_token_tree, 2, 0, 0),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delim_token_tree, 2, 0, 0),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delim_token_tree, 3, 0, 0),
  [1003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delim_token_tree, 3, 0, 0),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [1029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 1, 0, 0),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 1, 0, 0),
  [1033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__delim_tokens, 1, 0, 0),
  [1035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delim_tokens, 1, 0, 0),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [1081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1034),
  [1084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(175),
  [1087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [1089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(143),
  [1092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3),
  [1095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(261),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1481),
  [1101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(246),
  [1104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(785),
  [1107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [1113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3037),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3402),
  [1119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2473),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(38),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2593),
  [1128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1067),
  [1131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1404),
  [1134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(800),
  [1137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(184),
  [1140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2600),
  [1143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(298),
  [1146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [1149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2848),
  [1152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2596),
  [1155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(201),
  [1158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(41),
  [1161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3064),
  [1164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2602),
  [1167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1102),
  [1170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2520),
  [1173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1337),
  [1176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1473),
  [1179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3566),
  [1182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1473),
  [1185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3492),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 3, 0, 30),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 3, 0, 30),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [1232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [1234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [1236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, 0, 0),
  [1238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4, 0, 0),
  [1240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 5, 0, 0),
  [1242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 5, 0, 0),
  [1244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 6, 0, 0),
  [1246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 6, 0, 0),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_invocation, 3, 0, 28),
  [1250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_invocation, 3, 0, 28),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_expression, 2, 0, 8),
  [1254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_expression, 2, 0, 8),
  [1256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_block, 2, 0, 8),
  [1258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_block, 2, 0, 8),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3470),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 3, 0, 38),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 3, 0, 38),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_block, 2, 0, 0),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_async_block, 2, 0, 0),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 2, 0, 0),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 2, 0, 0),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unsafe_block, 2, 0, 0),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unsafe_block, 2, 0, 0),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 5, 0, 115),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 5, 0, 115),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [1386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 75),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 75),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, 0, 33),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, 0, 33),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_except_range, 1, 0, 0),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_except_range, 1, 0, 0),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_invocation, 3, 0, 39),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_invocation, 3, 0, 39),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_block, 2, 0, 0),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_block, 2, 0, 0),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 0),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 0),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 3, 0, 0),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 3, 0, 0),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_expression, 4, 0, 98),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_expression, 4, 0, 98),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 5, 0, 145),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 5, 0, 145),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 7, 0, 241),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 7, 0, 241),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 4, 0, 0),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 4, 0, 0),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_block, 3, 0, 0),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_async_block, 3, 0, 0),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2860),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [1490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3170),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 2, 0, 0),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 2, 0, 0),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 2, 0, 0),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 2, 0, 0),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 3, 0, 0),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 3, 0, 0),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3427),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3333),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [1604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [1642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [1648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 3, 0, 172),
  [1650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 3, 0, 172),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, 0, 116),
  [1658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, 0, 116),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 157),
  [1664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 157),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 123),
  [1668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 123),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, 0, 29),
  [1672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, 0, 29),
  [1674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 239),
  [1676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 239),
  [1678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 111),
  [1680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 111),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 72),
  [1684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 72),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 3, 0, 29),
  [1688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 3, 0, 29),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 238),
  [1692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 238),
  [1694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 7, 0, 237),
  [1696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 7, 0, 237),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 3, 0, 7),
  [1700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 3, 0, 7),
  [1702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 29),
  [1704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 29),
  [1706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, 0, 236),
  [1708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, 0, 236),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [1712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 3, 0, 29),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 3, 0, 29),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, 0, 235),
  [1720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, 0, 235),
  [1722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, 0, 234),
  [1724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, 0, 234),
  [1726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, 0, 233),
  [1728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, 0, 233),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [1732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, 0, 191),
  [1736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, 0, 191),
  [1738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 7, 0, 137),
  [1740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 7, 0, 137),
  [1742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 232),
  [1744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 232),
  [1746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 231),
  [1748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 231),
  [1750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 230),
  [1752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 230),
  [1754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 188),
  [1756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 188),
  [1758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, 0, 229),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, 0, 229),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 228),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 228),
  [1766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 5, 0, 110),
  [1768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 5, 0, 110),
  [1770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2002),
  [1773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(754),
  [1776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(777),
  [1779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2243),
  [1782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3153),
  [1785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(819),
  [1788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(812),
  [1791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [1794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2939),
  [1797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2940),
  [1800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3271),
  [1803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3057),
  [1806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2695),
  [1809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2091),
  [1812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(810),
  [1815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(803),
  [1818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2355),
  [1821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2576),
  [1824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2356),
  [1827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2623),
  [1830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2623),
  [1833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3502),
  [1836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 3, 0, 37),
  [1838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_declaration, 3, 0, 37),
  [1840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, 0, 125),
  [1842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, 0, 125),
  [1844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 227),
  [1846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 227),
  [1848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 226),
  [1850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 226),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 225),
  [1854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 225),
  [1856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 224),
  [1858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 224),
  [1860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, 0, 116),
  [1862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, 0, 116),
  [1864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, 0, 100),
  [1866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, 0, 100),
  [1868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 223),
  [1870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 223),
  [1872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 124),
  [1874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 124),
  [1876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 222),
  [1882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 222),
  [1884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 221),
  [1886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 221),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 123),
  [1890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 123),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, 0, 7),
  [1894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, 0, 7),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, 0, 180),
  [1898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, 0, 180),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5, 0, 0),
  [1902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5, 0, 0),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 195),
  [1906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 195),
  [1908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 240),
  [1910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 240),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 122),
  [1914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 122),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 79),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 79),
  [1920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [1934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3327),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [1944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3318),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2791),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [1970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 121),
  [1972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 121),
  [1974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 120),
  [1976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 120),
  [1978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, 0, 114),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, 0, 114),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, 0, 73),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, 0, 73),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, 0, 113),
  [1988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, 0, 113),
  [1990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 128),
  [1992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 128),
  [1994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, 0, 34),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, 0, 34),
  [1998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, 0, 6),
  [2000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, 0, 6),
  [2002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, 0, 112),
  [2004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, 0, 112),
  [2006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 3, 0, 32),
  [2008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 3, 0, 32),
  [2010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, 0, 111),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, 0, 111),
  [2014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 3, 0, 0),
  [2016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 3, 0, 0),
  [2018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 3, 0, 44),
  [2020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 3, 0, 44),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 111),
  [2024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 111),
  [2026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 129),
  [2028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 129),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 5, 0, 130),
  [2032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 5, 0, 130),
  [2034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 5, 0, 86),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 5, 0, 86),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 7, 0, 201),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 7, 0, 201),
  [2042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 3, 0, 31),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 3, 0, 31),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 3, 0, 22),
  [2048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 3, 0, 22),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 7, 0, 218),
  [2052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 7, 0, 218),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 6, 0, 0),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 6, 0, 0),
  [2058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 204),
  [2060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 204),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 244),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 244),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, 0, 217),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, 0, 217),
  [2070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, 0, 216),
  [2072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, 0, 216),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 3, 0, 0),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 3, 0, 0),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, 0, 215),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, 0, 215),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 5, 0, 110),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 5, 0, 110),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 214),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 214),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 166),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 166),
  [2094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 213),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 213),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inner_attribute_item, 5, 0, 0),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inner_attribute_item, 5, 0, 0),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 5, 0, 84),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 5, 0, 84),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 164),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 164),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 212),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 212),
  [2114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 211),
  [2116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 211),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 5, 0, 131),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 5, 0, 131),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, 0, 111),
  [2124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, 0, 111),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 132),
  [2128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 132),
  [2130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 210),
  [2132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 210),
  [2134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 209),
  [2136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 209),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 209),
  [2140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 209),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 245),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 245),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 259),
  [2148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 259),
  [2150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 208),
  [2152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 208),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 211),
  [2156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 211),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 246),
  [2160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 246),
  [2162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 161),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 161),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, 0, 247),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, 0, 247),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 207),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 207),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 159),
  [2176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 159),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 133),
  [2180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 133),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, 0, 54),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, 0, 54),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 63),
  [2188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 63),
  [2190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 206),
  [2192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 206),
  [2194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 157),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 157),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, 0, 248),
  [2200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, 0, 248),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 205),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 205),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, 0, 249),
  [2208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, 0, 249),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 204),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 204),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, 0, 6),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, 0, 6),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 134),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 134),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 8, 0, 250),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 8, 0, 250),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 5, 0, 0),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 5, 0, 0),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 7, 0, 201),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 7, 0, 201),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 135),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 135),
  [2238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 6, 0, 0),
  [2240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 6, 0, 0),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 136),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 136),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 137),
  [2248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 137),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 221),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 221),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 3, 0, 29),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 3, 0, 29),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 252),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 252),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 223),
  [2268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 223),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 253),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 253),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 254),
  [2276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 254),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 255),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 255),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 256),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 256),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, 0, 140),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, 0, 140),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 257),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 257),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, 0, 141),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, 0, 141),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, 0, 135),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, 0, 135),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 225),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 225),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, 0, 137),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, 0, 137),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 88),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 88),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 135),
  [2316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 135),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 142),
  [2320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 142),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 7, 0, 6),
  [2324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 7, 0, 6),
  [2326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 7, 0, 54),
  [2328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 7, 0, 54),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 258),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 258),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 137),
  [2336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 137),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 227),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 227),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, 0, 135),
  [2344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, 0, 135),
  [2346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, 0, 137),
  [2348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, 0, 137),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 143),
  [2352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 143),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, 0, 272),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, 0, 272),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 260),
  [2362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 260),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 261),
  [2366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 261),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 231),
  [2370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 231),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 262),
  [2374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 262),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 8, 0, 250),
  [2378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 8, 0, 250),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 5, 0, 144),
  [2382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 5, 0, 144),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 8, 0, 263),
  [2386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 8, 0, 263),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 8, 0, 233),
  [2390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 8, 0, 233),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 8, 0, 264),
  [2394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 8, 0, 264),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 196),
  [2398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 196),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 195),
  [2402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 195),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 238),
  [2406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 238),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 194),
  [2410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 194),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 265),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 265),
  [2416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 266),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 266),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 193),
  [2422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 193),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 6, 0, 54),
  [2426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 6, 0, 54),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 192),
  [2430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 192),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 6, 0, 183),
  [2434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 6, 0, 183),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 6, 0, 6),
  [2438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 6, 0, 6),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 267),
  [2442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 267),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, 0, 6),
  [2446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, 0, 6),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, 0, 191),
  [2450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, 0, 191),
  [2452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, 0, 183),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, 0, 183),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, 0, 137),
  [2458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, 0, 137),
  [2460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, 0, 54),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, 0, 54),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 4, 0, 96),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_declaration, 4, 0, 96),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, 0, 88),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, 0, 88),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, 0, 88),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, 0, 88),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 88),
  [2478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 88),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 95),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 95),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 9, 0, 268),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 9, 0, 268),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 4, 0, 94),
  [2490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 4, 0, 94),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 6, 0, 183),
  [2494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 6, 0, 183),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 4, 0, 93),
  [2498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 4, 0, 93),
  [2500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, 0, 88),
  [2502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, 0, 88),
  [2504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3244),
  [2507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1278),
  [2510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2862),
  [2513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0),
  [2515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3370),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [2521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3261),
  [2524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3093),
  [2527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2321),
  [2530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2249),
  [2533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2221),
  [2536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3327),
  [2539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3091),
  [2542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(841),
  [2545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(816),
  [2548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3315),
  [2551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1946),
  [2554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2787),
  [2557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3316),
  [2560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3317),
  [2563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3318),
  [2566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2791),
  [2569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2222),
  [2572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1878),
  [2575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2047),
  [2578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3312),
  [2581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1982),
  [2584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3312),
  [2587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 6, 0, 174),
  [2589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 6, 0, 174),
  [2591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 9, 0, 269),
  [2593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 9, 0, 269),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 4, 0, 93),
  [2601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 4, 0, 93),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 190),
  [2605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 190),
  [2607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 140),
  [2609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 140),
  [2611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 4, 0, 0),
  [2613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 4, 0, 0),
  [2615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, 0, 254),
  [2617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, 0, 254),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 189),
  [2621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 189),
  [2623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 88),
  [2625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 88),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 87),
  [2629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 87),
  [2631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, 0, 270),
  [2633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, 0, 270),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 188),
  [2637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 188),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, 0, 256),
  [2641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, 0, 256),
  [2643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 6, 0, 185),
  [2645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 6, 0, 185),
  [2647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 63),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 63),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, 0, 72),
  [2653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, 0, 72),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, 0, 71),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, 0, 71),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 4, 0, 84),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 4, 0, 84),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, 0, 271),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, 0, 271),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 4, 0, 86),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 4, 0, 86),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 4, 0, 7),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 4, 0, 7),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 112),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 112),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 72),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 72),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 85),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 85),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 184),
  [2689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 184),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 183),
  [2693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 183),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 182),
  [2697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 182),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 181),
  [2701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 181),
  [2703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 132),
  [2705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 132),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, 0, 260),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, 0, 260),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 71),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 71),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 2, 0, 0),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 2, 0, 0),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 72),
  [2721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 72),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 84),
  [2725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 84),
  [2727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 71),
  [2729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 71),
  [2731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, 0, 273),
  [2733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, 0, 273),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 6, 0, 131),
  [2739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 6, 0, 131),
  [2741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_item, 4, 0, 0),
  [2743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_item, 4, 0, 0),
  [2745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, 0, 274),
  [2747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, 0, 274),
  [2749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 29),
  [2751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 29),
  [2753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, 0, 266),
  [2755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, 0, 266),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 2, 0, 8),
  [2759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 2, 0, 8),
  [2761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, 0, 275),
  [2763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, 0, 275),
  [2765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 156),
  [2767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 156),
  [2769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 158),
  [2775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 158),
  [2777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 159),
  [2779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 159),
  [2781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 160),
  [2783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 160),
  [2785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 161),
  [2787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 161),
  [2789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 10, 0, 276),
  [2791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 10, 0, 276),
  [2793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 2, 0, 0),
  [2795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 2, 0, 0),
  [2797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 162),
  [2799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 162),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 120),
  [2805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 120),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, 0, 180),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, 0, 180),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, 0, 130),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, 0, 130),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 179),
  [2817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 179),
  [2819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 163),
  [2821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 163),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, 0, 72),
  [2825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, 0, 72),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 164),
  [2829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 164),
  [2831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 10, 0, 277),
  [2833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 10, 0, 277),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 165),
  [2837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 165),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 166),
  [2841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 166),
  [2843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4, 0, 0),
  [2849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4, 0, 0),
  [2851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 167),
  [2853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 167),
  [2855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 168),
  [2857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 168),
  [2859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, 0, 71),
  [2861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, 0, 71),
  [2863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, 0, 72),
  [2865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, 0, 72),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 4, 0, 82),
  [2869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 4, 0, 82),
  [2871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, 0, 169),
  [2873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, 0, 169),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 4, 0, 73),
  [2877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 4, 0, 73),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 81),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 81),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 22),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 22),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 4, 0, 74),
  [2889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 4, 0, 74),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 10, 0, 273),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 10, 0, 273),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 80),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 80),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 79),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 79),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 6, 0, 174),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 6, 0, 174),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 10, 0, 278),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 10, 0, 278),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, 0, 170),
  [2913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, 0, 170),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, 0, 171),
  [2917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, 0, 171),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [2939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [2967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [2971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [3017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [3041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [3043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [3045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [3047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [3049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [3075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [3113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [3115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3168),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2632),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [3123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [3125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3254),
  [3149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [3165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [3201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0),
  [3203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 1, 0, 0),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 1, 0, 0),
  [3207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 4, 0, 0),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 4, 0, 0),
  [3211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [3213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lifetime, 2, 0, 0),
  [3215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lifetime, 2, 0, 0),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [3219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 2, 0, 1),
  [3221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 2, 0, 1),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [3229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 2, 0, 0),
  [3233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 2, 0, 0),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [3237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [3241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 5),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [3245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 5),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [3253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 4, 0, 104),
  [3255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 4, 0, 104),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [3259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 2, 0, 24),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 2, 0, 24),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_type, 2, 0, 24),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_type, 2, 0, 24),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_type, 2, 0, 25),
  [3269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_type, 2, 0, 25),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, 0, 41),
  [3273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, 0, 41),
  [3275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 40),
  [3277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 40),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 4, 0, 105),
  [3281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 4, 0, 105),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, 0, 17),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, 0, 17),
  [3287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 16),
  [3289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 16),
  [3291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 0),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 0),
  [3295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, 0, 46),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, 0, 46),
  [3299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 45),
  [3301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 45),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 2, 0, 7),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 2, 0, 7),
  [3307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 2, 0, 6),
  [3309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, 0, 6),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 2, 0, 25),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 2, 0, 25),
  [3315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_arm_repeat1, 2, 0, 0),
  [3317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_arm_repeat1, 2, 0, 0),
  [3319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arm_repeat1, 2, 0, 0), SHIFT_REPEAT(3057),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [3326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_except_range, 1, 0, 1),
  [3328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_except_range, 1, 0, 1),
  [3330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 1, 0, 0),
  [3336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [3338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [3340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [3342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [3346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 3, 0, 0),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3029),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3476),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [3368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, 0, 46),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, 0, 27),
  [3374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, 0, 27),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, 0, 26),
  [3380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, 0, 26),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [3386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 107),
  [3388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 107),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [3414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [3416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [3418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [3420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [3422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [3426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 49),
  [3432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 49),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, 0, 41),
  [3436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, 0, 23),
  [3438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, 0, 23),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 1, 0, 0),
  [3444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 1, 0, 0),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [3450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 50),
  [3454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 50),
  [3456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 21),
  [3458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 21),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, 0, 17),
  [3462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 20),
  [3464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 20),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 6, 0, 0),
  [3468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 6, 0, 0),
  [3470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3365),
  [3474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3259),
  [3478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 19),
  [3480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 19),
  [3482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 6, 0, 0),
  [3484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 6, 0, 0),
  [3486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [3488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3544),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5, 0, 0),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5, 0, 0),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 64),
  [3497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 64),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 2, 0, 7),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 66),
  [3505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 66),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [3513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [3519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [3521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3538),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 0),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 0),
  [3529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [3531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [3533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 4, 0, 0),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 67),
  [3539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 67),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [3547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 119),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 119),
  [3551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 5, 0, 127),
  [3553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 5, 0, 127),
  [3555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 76),
  [3557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 76),
  [3559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_expression, 3, 0, 18),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_expression, 3, 0, 18),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [3567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2755),
  [3569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 4, 0, 0),
  [3571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 4, 0, 0),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_higher_ranked_trait_bound, 3, 0, 79),
  [3575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_higher_ranked_trait_bound, 3, 0, 79),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [3579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 0),
  [3581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 5, 0, 0),
  [3583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 5, 0, 0),
  [3585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 5, 0, 99),
  [3587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 5, 0, 99),
  [3589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [3591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [3593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [3595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [3597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 6, 0, 146),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 6, 0, 146),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 6, 0, 0),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 6, 0, 0),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 4, 0, 97),
  [3607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 4, 0, 97),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 0),
  [3611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 0),
  [3613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [3615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [3617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 4, 0, 83),
  [3619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 4, 0, 83),
  [3621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [3623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [3625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 5, 0, 116),
  [3627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 5, 0, 116),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 5, 0, 116),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [3633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 108),
  [3635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 108),
  [3637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 106),
  [3639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 106),
  [3641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 103),
  [3647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 103),
  [3649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 4, 0, 102),
  [3651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 4, 0, 102),
  [3653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [3655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 2, 0, 11),
  [3659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 2, 0, 11),
  [3661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 3, 0, 35),
  [3663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 3, 0, 35),
  [3665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 6, 0, 0),
  [3667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 6, 0, 0),
  [3669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 6, 0, 200),
  [3671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 6, 0, 200),
  [3673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, 0, 76),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 76),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [3681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, 0, 119),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 119),
  [3685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 154),
  [3687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 154),
  [3689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 2, 0, 13),
  [3691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 2, 0, 13),
  [3693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 153),
  [3695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 153),
  [3697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 152),
  [3699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 152),
  [3701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 2, 0, 0),
  [3703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 2, 0, 0),
  [3705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 12),
  [3707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 12),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_never_type, 1, 0, 0),
  [3711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_never_type, 1, 0, 0),
  [3713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [3715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [3717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, 0, 76),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 76),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 6, 0, 175),
  [3723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 6, 0, 175),
  [3725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 2, 0, 10),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 2, 0, 10),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 3, 0, 0),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 3, 0, 0),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bounded_type, 3, 0, 0),
  [3739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bounded_type, 3, 0, 0),
  [3741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [3743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [3745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [3747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 150),
  [3751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 150),
  [3753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 3, 0, 63),
  [3755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 3, 0, 63),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 3, 0, 63),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 3, 0, 63),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 62),
  [3763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 62),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [3767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 5, 0, 0),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 5, 0, 0),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_expression, 2, 0, 0),
  [3775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit_expression, 2, 0, 0),
  [3777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [3779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 2, 0, 0),
  [3781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 2, 0, 0),
  [3783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [3785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [3787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 47),
  [3789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 47),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [3793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2537),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [3803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, 0, 172),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, 0, 172),
  [3807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, 0, 172),
  [3809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 3, 0, 0),
  [3811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 3, 0, 0),
  [3813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast_expression, 3, 0, 51),
  [3815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast_expression, 3, 0, 51),
  [3817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_function, 3, 0, 42),
  [3819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, 0, 52),
  [3821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_function, 3, 0, 42),
  [3823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 6, 0, 0),
  [3825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 6, 0, 0),
  [3827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 6, 0, 119),
  [3829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 6, 0, 119),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2527),
  [3833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2528),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [3839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_type, 2, 0, 0),
  [3841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit_type, 2, 0, 0),
  [3843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [3845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [3847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_removed_trait_bound, 2, 0, 0),
  [3849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_removed_trait_bound, 2, 0, 0),
  [3851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 2, 0, 22),
  [3853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 2, 0, 22),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5, 0, 0),
  [3857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5, 0, 0),
  [3859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, 0, 43),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 4, 0, 0),
  [3863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 4, 0, 0),
  [3865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_expression, 2, 0, 4),
  [3867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_expression, 2, 0, 4),
  [3869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 0),
  [3871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 0),
  [3873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 7, 0, 0),
  [3875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 7, 0, 0),
  [3877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 7, 0, 0),
  [3879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 7, 0, 0),
  [3881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 2, 0, 0),
  [3883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 2, 0, 0),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [3887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_arm_repeat1, 1, 0, 0),
  [3889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_arm_repeat1, 1, 0, 0),
  [3891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 1, 0, 0),
  [3893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 1, 0, 0),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [3925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [3927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 2, 0, 0),
  [3929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 2, 0, 0),
  [3931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2, 0, 0),
  [3933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2, 0, 0),
  [3935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 3, 0, 0),
  [3937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 3, 0, 0),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [3949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [3955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_assignment_expr, 3, 0, 47),
  [3957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_assignment_expr, 3, 0, 47),
  [3959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 48),
  [3961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 48),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 0),
  [3965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [3979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 1, 0, 0),
  [3981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_visibility_modifier, 1, 0, 0), SHIFT(2710),
  [3984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 1, 0, 0),
  [3986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 4, 0, 0),
  [3988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 4, 0, 0),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [3992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_visibility_modifier, 1, 0, 0), SHIFT(3233),
  [3995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 5, 0, 126),
  [3997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 5, 0, 126),
  [3999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 5, 0, 0),
  [4001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 5, 0, 0),
  [4003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [4005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [4065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [4071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3258),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [4099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 3, 0, 0),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3252),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [4117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2, 0, 0),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [4131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [4135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [4139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_condition, 4, 0, 116),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [4151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 138),
  [4153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 139),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [4163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [4165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [4171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_field_initializer, 2, 0, 0),
  [4173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [4177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [4185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [4201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [4219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 5, 0, 243),
  [4225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 3, 0, 155),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [4253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 3, 0, 172),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [4257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_chain, 3, 0, 0),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [4275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__condition, 1, 0, 0),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [4287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, 0, 116),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [4295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4, 0, 186),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [4299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 4, 0, 203),
  [4301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 4, 0, 202),
  [4303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4, 0, 187),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [4325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 18),
  [4327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 109),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [4351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [4381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2754),
  [4387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [4391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [4393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2554),
  [4399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [4401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2508),
  [4405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 6, 0, 0),
  [4407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 6, 0, 0),
  [4409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 5, 0, 0),
  [4411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 5, 0, 0),
  [4413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 4, 0, 0),
  [4415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 4, 0, 0),
  [4417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [4419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [4421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [4425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [4427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [4431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3040),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [4435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [4437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3211),
  [4439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3202),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [4451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [4457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 0),
  [4459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [4469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 1),
  [4471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 1),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [4475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1, 0, 5), REDUCE(sym__pattern, 1, 0, 0),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [4604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 40), REDUCE(sym_scoped_type_identifier, 3, 0, 41),
  [4607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 16), REDUCE(sym_scoped_type_identifier, 3, 0, 17),
  [4610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, 0, 6), REDUCE(sym_scoped_type_identifier, 2, 0, 7),
  [4613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negative_literal, 2, 0, 0),
  [4615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negative_literal, 2, 0, 0),
  [4617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal_pattern, 1, 0, 0),
  [4619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal_pattern, 1, 0, 0),
  [4621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 45), REDUCE(sym_scoped_type_identifier, 3, 0, 46),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [4668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, 0, 1),
  [4670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, 0, 1),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [4690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [4694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, 0, 0),
  [4696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, 0, 0),
  [4698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_modifier, 1, 0, 0),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [4726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, 0, 59),
  [4728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, 0, 59),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [4732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3456),
  [4742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_modifiers_repeat1, 1, 0, 0),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [4748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, 0, 55),
  [4750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, 0, 55),
  [4752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, 0, 57),
  [4754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, 0, 57),
  [4756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_remaining_field_pattern, 1, 0, 0),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [4760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [4762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 2, 0, 0),
  [4764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_pattern, 2, 0, 0),
  [4766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_pattern, 2, 0, 0),
  [4768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_pattern, 2, 0, 0),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [4778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mut_pattern, 2, 0, 0),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [4788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [4794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 3, 0, 0),
  [4796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_pattern, 3, 0, 0),
  [4798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 3, 0, 56),
  [4800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, 0, 57),
  [4802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_captured_pattern, 3, 0, 0),
  [4804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [4806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 3, 0, 61),
  [4808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, 0, 56),
  [4810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_pattern, 3, 0, 0),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [4820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 0),
  [4822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 4, 0, 0),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 4, 0, 56),
  [4826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, 0, 57),
  [4828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 4, 0, 61),
  [4830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, 0, 56),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [4836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 6, 0, 56),
  [4838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 5, 0, 61),
  [4840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 5, 0, 0),
  [4842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5, 0, 0),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [4846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 5, 0, 56),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [4856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, 0, 56),
  [4858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 6, 0, 61),
  [4860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, 0, 56),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1, 0, 0), REDUCE(sym__pattern, 1, 0, 1),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [4909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_trait_bounds_repeat1, 2, 0, 0),
  [4911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_trait_bounds_repeat1, 2, 0, 0), SHIFT_REPEAT(846),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [4922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_bounds, 3, 0, 0),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [4928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(81),
  [4931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2, 0, 0),
  [4933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(69),
  [4936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(83),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_bounds, 2, 0, 0),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [4991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [4993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [4999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2321),
  [5002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2, 0, 0),
  [5004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2205),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [5021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_modifier, 2, 0, 0),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [5081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_modifiers, 1, 0, 0),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [5115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 0),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [5123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3571),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [5131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 2, 0, 6),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [5139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 2, 0, 0),
  [5141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [5145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [5151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [5161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 1, 0, 0),
  [5163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [5167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 1),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [5171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3567),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [5207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [5211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3613),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [5215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [5221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 1, 0, 70),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [5233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3169),
  [5235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [5237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3173),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [5273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 3, 0, 0),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [5293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0), REDUCE(sym_tuple_struct_pattern, 4, 0, 56),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [5318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0), REDUCE(sym_tuple_struct_pattern, 3, 0, 56),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [5385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1, 0, 0), REDUCE(sym__pattern, 1, 0, 0),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [5398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 76),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [5402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_unit_type, 2, 0, 0), REDUCE(sym_tuple_pattern, 2, 0, 0),
  [5405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, 0, 102),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [5423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, 0, 176),
  [5425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 3, 0, 0),
  [5427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 3, 0, 22),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [5441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 7, 0, 251),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [5447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, 0, 251),
  [5449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0), SHIFT(1957),
  [5452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0), SHIFT(408),
  [5455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, 0, 102),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [5469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [5475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 2, 0, 0),
  [5477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0),
  [5483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1479),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 3, 0, 119),
  [5490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1, 0, 0),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [5502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1, 0, 1),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [5508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2, 0, 0),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [5530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, 0, 219),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, 0, 63),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, 0, 22),
  [5544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, 0, 176),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [5572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, 0, 63),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, 0, 219),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [5632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [5640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 60),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [5656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [5674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slice_pattern_repeat1, 2, 0, 0),
  [5676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slice_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(823),
  [5679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2928),
  [5681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [5685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 100),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [5691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_predicate, 2, 0, 78),
  [5693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_predicate, 2, 0, 77),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [5697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [5703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), REDUCE(aux_sym_for_lifetimes_repeat1, 2, 0, 0),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [5712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 3, 0, 0),
  [5714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0),
  [5716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_binding, 4, 0, 198),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [5720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [5748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(211),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [5753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [5757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [5759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [5761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [5763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [5765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [5773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [5791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 3, 0, 0),
  [5793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [5795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [5799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [5819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [5839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [5841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2808),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [5854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [5860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [5862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [5878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [5880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [5882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_binding, 3, 0, 147),
  [5884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_rule, 3, 0, 48),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [5922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(445),
  [5925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, 0, 148),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [5929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, 0, 149),
  [5931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2, 0, 0),
  [5933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2304),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [5940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [5956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(410),
  [5959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [5961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2144),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [5970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 2, 0, 0),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [5976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2, 0, 0),
  [5978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1880),
  [5981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 2, 0, 36),
  [5983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 4, 0, 0),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [5997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 1, 0, 0),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [6005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_lifetimes_repeat1, 2, 0, 0),
  [6007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_lifetimes_repeat1, 2, 0, 0), SHIFT_REPEAT(3109),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [6014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2, 0, 0),
  [6016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2, 0, 0), SHIFT_REPEAT(2183),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [6023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [6025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [6027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [6031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 3, 0, 34),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [6049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [6051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [6055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_parameter, 4, 0, 110),
  [6057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3465),
  [6059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [6061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [6079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [6093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 1, 0, 0),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [6101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, 0, 22),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [6105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, 0, 177),
  [6107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, 0, 177), SHIFT_REPEAT(773),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [6118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 178),
  [6120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, 0, 118),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [6124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0),
  [6126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2206),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [6131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__condition, 1, 0, 9),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [6141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(2039),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [6152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 5, 0, 0),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [6168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 4, 0, 199),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [6172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 4, 0, 0),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [6180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 2, 0, 11),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [6186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, 0, 117),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [6202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [6204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [6206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 3, 0, 63),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [6224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 1, 0, 58),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [6236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_closure_parameters_repeat1, 2, 0, 0),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [6242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_closure_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(784),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [6247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [6249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(896),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [6266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 2, 0, 101),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [6284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 5, 0, 242),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [6290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 4, 0, 102),
  [6292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0),
  [6294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(764),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [6335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 220),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [6367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 3, 0, 0),
  [6369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [6373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 2, 0, 0),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [6383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, 0, 92),
  [6385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, 0, 91),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [6393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, 0, 90),
  [6395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, 0, 89),
  [6397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 3, 0, 1),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [6405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 2, 0, 77),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [6411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 3, 0, 0),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [6421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 2, 0, 78),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [6443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [6457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 1, 0, 0),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [6467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [6471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3610),
  [6473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2852),
  [6475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [6477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [6479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [6485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [6491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [6497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [6499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [6501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3573),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [6511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [6519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [6523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [6525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [6527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [6529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [6535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 3, 0, 0),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [6547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [6549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [6551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 3, 0, 0),
  [6553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [6559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_doc_comment_marker, 1, 0, 3),
  [6561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [6563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [6571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_doc_comment_marker, 1, 0, 2),
  [6573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 2, 0, 0),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [6583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, 0, 32),
  [6585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 3, 0, 0),
  [6587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [6589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [6591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [6595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [6597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [6603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, 0, 65),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [6615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 1, 0, 0),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [6621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [6629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [6639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [6647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [6649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [6655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [6663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [6671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [6675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [6677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [6679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [6681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, 0, 151),
  [6683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3494),
  [6685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [6687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [6689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [6691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [6693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [6705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [6707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [6709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [6715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [6721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [6723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [6725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [6727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [6801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_type, 3, 0, 0),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [6911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 3, 0, 173),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [6935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 68),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [7001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 69),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [7017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [7043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__line_doc_comment_marker, 1, 0, 3),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [7063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__line_doc_comment_marker, 1, 0, 2),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [7079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__outer_line_doc_comment_marker, 1, 0, 0),
  [7081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inner_line_doc_comment_marker, 1, 0, 0),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [7089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3616),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [7105] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [7193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 2, 0, 0),
  [7195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 2, 0, 0),
  [7197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 4, 0, 53),
  [7199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 3, 0, 0),
  [7201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 3, 0, 14),
  [7203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 0),
  [7205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 15),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_string_content = 0,
  ts_external_token__raw_string_literal_start = 1,
  ts_external_token_raw_string_literal_content = 2,
  ts_external_token__raw_string_literal_end = 3,
  ts_external_token_float_literal = 4,
  ts_external_token__outer_block_doc_comment_marker = 5,
  ts_external_token__inner_block_doc_comment_marker = 6,
  ts_external_token__block_comment_content = 7,
  ts_external_token__line_doc_content = 8,
  ts_external_token__error_sentinel = 9,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_string_content] = sym_string_content,
  [ts_external_token__raw_string_literal_start] = sym__raw_string_literal_start,
  [ts_external_token_raw_string_literal_content] = sym_raw_string_literal_content,
  [ts_external_token__raw_string_literal_end] = sym__raw_string_literal_end,
  [ts_external_token_float_literal] = sym_float_literal,
  [ts_external_token__outer_block_doc_comment_marker] = sym__outer_block_doc_comment_marker,
  [ts_external_token__inner_block_doc_comment_marker] = sym__inner_block_doc_comment_marker,
  [ts_external_token__block_comment_content] = sym__block_comment_content,
  [ts_external_token__line_doc_content] = sym__line_doc_content,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[10][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_string_content] = true,
    [ts_external_token__raw_string_literal_start] = true,
    [ts_external_token_raw_string_literal_content] = true,
    [ts_external_token__raw_string_literal_end] = true,
    [ts_external_token_float_literal] = true,
    [ts_external_token__outer_block_doc_comment_marker] = true,
    [ts_external_token__inner_block_doc_comment_marker] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__line_doc_content] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token__raw_string_literal_start] = true,
    [ts_external_token_float_literal] = true,
  },
  [3] = {
    [ts_external_token__outer_block_doc_comment_marker] = true,
    [ts_external_token__inner_block_doc_comment_marker] = true,
    [ts_external_token__block_comment_content] = true,
  },
  [4] = {
    [ts_external_token_string_content] = true,
  },
  [5] = {
    [ts_external_token__block_comment_content] = true,
  },
  [6] = {
    [ts_external_token_float_literal] = true,
  },
  [7] = {
    [ts_external_token_raw_string_literal_content] = true,
  },
  [8] = {
    [ts_external_token__raw_string_literal_end] = true,
  },
  [9] = {
    [ts_external_token__line_doc_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_rust_external_scanner_create(void);
void tree_sitter_rust_external_scanner_destroy(void *);
bool tree_sitter_rust_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rust_external_scanner_serialize(void *, char *);
void tree_sitter_rust_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_rust(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_rust_external_scanner_create,
      tree_sitter_rust_external_scanner_destroy,
      tree_sitter_rust_external_scanner_scan,
      tree_sitter_rust_external_scanner_serialize,
      tree_sitter_rust_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
